var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var mathjax = {};

var version$1 = {};

Object.defineProperty(version$1, "__esModule", {
  value: true
});
version$1.VERSION = void 0;
version$1.VERSION = '3.2.2';

var HandlerList$1 = {};

var PrioritizedList$1 = {};

Object.defineProperty(PrioritizedList$1, "__esModule", {
  value: true
});
PrioritizedList$1.PrioritizedList = void 0;
var PrioritizedList = (function () {
  function PrioritizedList() {
    this.items = [];
    this.items = [];
  }
  PrioritizedList.prototype[Symbol.iterator] = function () {
    var i = 0;
    var items = this.items;
    return {
      next: function () {
        return {
          value: items[i++],
          done: i > items.length
        };
      }
    };
  };
  PrioritizedList.prototype.add = function (item, priority) {
    if (priority === void 0) {
      priority = PrioritizedList.DEFAULTPRIORITY;
    }
    var i = this.items.length;
    do {
      i--;
    } while (i >= 0 && priority < this.items[i].priority);
    this.items.splice(i + 1, 0, {
      item: item,
      priority: priority
    });
    return item;
  };
  PrioritizedList.prototype.remove = function (item) {
    var i = this.items.length;
    do {
      i--;
    } while (i >= 0 && this.items[i].item !== item);
    if (i >= 0) {
      this.items.splice(i, 1);
    }
  };
  PrioritizedList.DEFAULTPRIORITY = 5;
  return PrioritizedList;
})();
PrioritizedList$1.PrioritizedList = PrioritizedList;

var __extends$1W = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$Q = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(HandlerList$1, "__esModule", {
  value: true
});
HandlerList$1.HandlerList = void 0;
var PrioritizedList_js_1$1 = PrioritizedList$1;
var HandlerList = (function (_super) {
  __extends$1W(HandlerList, _super);
  function HandlerList() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  HandlerList.prototype.register = function (handler) {
    return this.add(handler, handler.priority);
  };
  HandlerList.prototype.unregister = function (handler) {
    this.remove(handler);
  };
  HandlerList.prototype.handlesDocument = function (document) {
    var e_1, _a;
    try {
      for (var _b = __values$Q(this), _c = _b.next(); !_c.done; _c = _b.next()) {
        var item = _c.value;
        var handler = item.item;
        if (handler.handlesDocument(document)) {
          return handler;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    throw new Error("Can't find handler for document");
  };
  HandlerList.prototype.document = function (document, options) {
    if (options === void 0) {
      options = null;
    }
    return this.handlesDocument(document).create(document, options);
  };
  return HandlerList;
})(PrioritizedList_js_1$1.PrioritizedList);
HandlerList$1.HandlerList = HandlerList;

var Retries = {};

Object.defineProperty(Retries, "__esModule", {
  value: true
});
Retries.retryAfter = Retries.handleRetriesFor = void 0;
function handleRetriesFor(code) {
  return new Promise(function run(ok, fail) {
    try {
      ok(code());
    } catch (err) {
      if (err.retry && err.retry instanceof Promise) {
        err.retry.then(function () {
          return run(ok, fail);
        }).catch(function (perr) {
          return fail(perr);
        });
      } else if (err.restart && err.restart.isCallback) {
        MathJax.Callback.After(function () {
          return run(ok, fail);
        }, err.restart);
      } else {
        fail(err);
      }
    }
  });
}
Retries.handleRetriesFor = handleRetriesFor;
function retryAfter(promise) {
  var err = new Error('MathJax retry');
  err.retry = promise;
  throw err;
}
Retries.retryAfter = retryAfter;

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.mathjax = void 0;
  var version_js_1 = version$1;
  var HandlerList_js_1 = HandlerList$1;
  var Retries_js_1 = Retries;
  exports.mathjax = {
    version: version_js_1.VERSION,
    handlers: new HandlerList_js_1.HandlerList(),
    document: function (document, options) {
      return exports.mathjax.handlers.document(document, options);
    },
    handleRetriesFor: Retries_js_1.handleRetriesFor,
    retryAfter: Retries_js_1.retryAfter,
    asyncLoad: null
  };
})(mathjax);
getDefaultExportFromCjs(mathjax);

var mathml = {};

var InputJax = {};

var Options = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.lookup = exports.separateOptions = exports.selectOptionsFromKeys = exports.selectOptions = exports.userOptions = exports.defaultOptions = exports.insert = exports.copy = exports.keys = exports.makeArray = exports.expandable = exports.Expandable = exports.OPTIONS = exports.REMOVE = exports.APPEND = exports.isObject = void 0;
  var OBJECT = ({}).constructor;
  function isObject(obj) {
    return typeof obj === 'object' && obj !== null && (obj.constructor === OBJECT || obj.constructor === Expandable);
  }
  exports.isObject = isObject;
  exports.APPEND = '[+]';
  exports.REMOVE = '[-]';
  exports.OPTIONS = {
    invalidOption: 'warn',
    optionError: function (message, _key) {
      if (exports.OPTIONS.invalidOption === 'fatal') {
        throw new Error(message);
      }
      console.warn('MathJax: ' + message);
    }
  };
  var Expandable = (function () {
    function Expandable() {}
    return Expandable;
  })();
  exports.Expandable = Expandable;
  function expandable(def) {
    return Object.assign(Object.create(Expandable.prototype), def);
  }
  exports.expandable = expandable;
  function makeArray(x) {
    return Array.isArray(x) ? x : [x];
  }
  exports.makeArray = makeArray;
  function keys(def) {
    if (!def) {
      return [];
    }
    return Object.keys(def).concat(Object.getOwnPropertySymbols(def));
  }
  exports.keys = keys;
  function copy(def) {
    var e_1, _a;
    var props = {};
    try {
      for (var _b = __values(keys(def)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var key = _c.value;
        var prop = Object.getOwnPropertyDescriptor(def, key);
        var value = prop.value;
        if (Array.isArray(value)) {
          prop.value = insert([], value, false);
        } else if (isObject(value)) {
          prop.value = copy(value);
        }
        if (prop.enumerable) {
          props[key] = prop;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return Object.defineProperties(def.constructor === Expandable ? expandable({}) : {}, props);
  }
  exports.copy = copy;
  function insert(dst, src, warn) {
    var e_2, _a;
    if (warn === void 0) {
      warn = true;
    }
    var _loop_1 = function (key) {
      if (warn && dst[key] === undefined && dst.constructor !== Expandable) {
        if (typeof key === 'symbol') {
          key = key.toString();
        }
        exports.OPTIONS.optionError(("Invalid option \"").concat(key, "\" (no default value)."), key);
        return "continue";
      }
      var sval = src[key], dval = dst[key];
      if (isObject(sval) && dval !== null && (typeof dval === 'object' || typeof dval === 'function')) {
        var ids = keys(sval);
        if (Array.isArray(dval) && (ids.length === 1 && (ids[0] === exports.APPEND || ids[0] === exports.REMOVE) && Array.isArray(sval[ids[0]]) || ids.length === 2 && ids.sort().join(',') === exports.APPEND + ',' + exports.REMOVE && Array.isArray(sval[exports.APPEND]) && Array.isArray(sval[exports.REMOVE]))) {
          if (sval[exports.REMOVE]) {
            dval = dst[key] = dval.filter(function (x) {
              return sval[exports.REMOVE].indexOf(x) < 0;
            });
          }
          if (sval[exports.APPEND]) {
            dst[key] = __spreadArray(__spreadArray([], __read(dval), false), __read(sval[exports.APPEND]), false);
          }
        } else {
          insert(dval, sval, warn);
        }
      } else if (Array.isArray(sval)) {
        dst[key] = [];
        insert(dst[key], sval, false);
      } else if (isObject(sval)) {
        dst[key] = copy(sval);
      } else {
        dst[key] = sval;
      }
    };
    try {
      for (var _b = __values(keys(src)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var key = _c.value;
        _loop_1(key);
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    return dst;
  }
  exports.insert = insert;
  function defaultOptions(options) {
    var defs = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      defs[_i - 1] = arguments[_i];
    }
    defs.forEach(function (def) {
      return insert(options, def, false);
    });
    return options;
  }
  exports.defaultOptions = defaultOptions;
  function userOptions(options) {
    var defs = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      defs[_i - 1] = arguments[_i];
    }
    defs.forEach(function (def) {
      return insert(options, def, true);
    });
    return options;
  }
  exports.userOptions = userOptions;
  function selectOptions(options) {
    var e_3, _a;
    var keys = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      keys[_i - 1] = arguments[_i];
    }
    var subset = {};
    try {
      for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
        var key = keys_1_1.value;
        if (options.hasOwnProperty(key)) {
          subset[key] = options[key];
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    return subset;
  }
  exports.selectOptions = selectOptions;
  function selectOptionsFromKeys(options, object) {
    return selectOptions.apply(void 0, __spreadArray([options], __read(Object.keys(object)), false));
  }
  exports.selectOptionsFromKeys = selectOptionsFromKeys;
  function separateOptions(options) {
    var e_4, _a, e_5, _b;
    var objects = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      objects[_i - 1] = arguments[_i];
    }
    var results = [];
    try {
      for (var objects_1 = __values(objects), objects_1_1 = objects_1.next(); !objects_1_1.done; objects_1_1 = objects_1.next()) {
        var object = objects_1_1.value;
        var exists = {}, missing = {};
        try {
          for (var _c = (e_5 = void 0, __values(Object.keys(options || ({})))), _d = _c.next(); !_d.done; _d = _c.next()) {
            var key = _d.value;
            (object[key] === undefined ? missing : exists)[key] = options[key];
          }
        } catch (e_5_1) {
          e_5 = {
            error: e_5_1
          };
        } finally {
          try {
            if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
          } finally {
            if (e_5) throw e_5.error;
          }
        }
        results.push(exists);
        options = missing;
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (objects_1_1 && !objects_1_1.done && (_a = objects_1.return)) _a.call(objects_1);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    results.unshift(options);
    return results;
  }
  exports.separateOptions = separateOptions;
  function lookup(name, lookup, def) {
    if (def === void 0) {
      def = null;
    }
    return lookup.hasOwnProperty(name) ? lookup[name] : def;
  }
  exports.lookup = lookup;
})(Options);
getDefaultExportFromCjs(Options);

var FunctionList$1 = {};

var __extends$1V = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$P = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$T = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$v = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(FunctionList$1, "__esModule", {
  value: true
});
FunctionList$1.FunctionList = void 0;
var PrioritizedList_js_1 = PrioritizedList$1;
var FunctionList = (function (_super) {
  __extends$1V(FunctionList, _super);
  function FunctionList() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  FunctionList.prototype.execute = function () {
    var e_1, _a;
    var data = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      data[_i] = arguments[_i];
    }
    try {
      for (var _b = __values$P(this), _c = _b.next(); !_c.done; _c = _b.next()) {
        var item = _c.value;
        var result = item.item.apply(item, __spreadArray$v([], __read$T(data), false));
        if (result === false) {
          return false;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return true;
  };
  FunctionList.prototype.asyncExecute = function () {
    var data = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      data[_i] = arguments[_i];
    }
    var i = -1;
    var items = this.items;
    return new Promise(function (ok, fail) {
      (function execute() {
        var _a;
        while (++i < items.length) {
          var result = (_a = items[i]).item.apply(_a, __spreadArray$v([], __read$T(data), false));
          if (result instanceof Promise) {
            result.then(execute).catch(function (err) {
              return fail(err);
            });
            return;
          }
          if (result === false) {
            ok(false);
            return;
          }
        }
        ok(true);
      })();
    });
  };
  return FunctionList;
})(PrioritizedList_js_1.PrioritizedList);
FunctionList$1.FunctionList = FunctionList;

Object.defineProperty(InputJax, "__esModule", {
  value: true
});
InputJax.AbstractInputJax = void 0;
var Options_js_1$d = Options;
var FunctionList_js_1$2 = FunctionList$1;
var AbstractInputJax = (function () {
  function AbstractInputJax(options) {
    if (options === void 0) {
      options = {};
    }
    this.adaptor = null;
    this.mmlFactory = null;
    var CLASS = this.constructor;
    this.options = (0, Options_js_1$d.userOptions)((0, Options_js_1$d.defaultOptions)({}, CLASS.OPTIONS), options);
    this.preFilters = new FunctionList_js_1$2.FunctionList();
    this.postFilters = new FunctionList_js_1$2.FunctionList();
  }
  Object.defineProperty(AbstractInputJax.prototype, "name", {
    get: function () {
      return this.constructor.NAME;
    },
    enumerable: false,
    configurable: true
  });
  AbstractInputJax.prototype.setAdaptor = function (adaptor) {
    this.adaptor = adaptor;
  };
  AbstractInputJax.prototype.setMmlFactory = function (mmlFactory) {
    this.mmlFactory = mmlFactory;
  };
  AbstractInputJax.prototype.initialize = function () {};
  AbstractInputJax.prototype.reset = function () {
    var _args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      _args[_i] = arguments[_i];
    }
  };
  Object.defineProperty(AbstractInputJax.prototype, "processStrings", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  AbstractInputJax.prototype.findMath = function (_node, _options) {
    return [];
  };
  AbstractInputJax.prototype.executeFilters = function (filters, math, document, data) {
    var args = {
      math: math,
      document: document,
      data: data
    };
    filters.execute(args);
    return args.data;
  };
  AbstractInputJax.NAME = 'generic';
  AbstractInputJax.OPTIONS = {};
  return AbstractInputJax;
})();
InputJax.AbstractInputJax = AbstractInputJax;

var FindMathML$1 = {};

var FindMath = {};

Object.defineProperty(FindMath, "__esModule", {
  value: true
});
FindMath.AbstractFindMath = void 0;
var Options_js_1$c = Options;
var AbstractFindMath = (function () {
  function AbstractFindMath(options) {
    var CLASS = this.constructor;
    this.options = (0, Options_js_1$c.userOptions)((0, Options_js_1$c.defaultOptions)({}, CLASS.OPTIONS), options);
  }
  AbstractFindMath.OPTIONS = {};
  return AbstractFindMath;
})();
FindMath.AbstractFindMath = AbstractFindMath;

var __extends$1U = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$O = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(FindMathML$1, "__esModule", {
  value: true
});
FindMathML$1.FindMathML = void 0;
var FindMath_js_1$1 = FindMath;
var NAMESPACE = 'http://www.w3.org/1998/Math/MathML';
var FindMathML = (function (_super) {
  __extends$1U(FindMathML, _super);
  function FindMathML() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  FindMathML.prototype.findMath = function (node) {
    var set = new Set();
    this.findMathNodes(node, set);
    this.findMathPrefixed(node, set);
    var html = this.adaptor.root(this.adaptor.document);
    if (this.adaptor.kind(html) === 'html' && set.size === 0) {
      this.findMathNS(node, set);
    }
    return this.processMath(set);
  };
  FindMathML.prototype.findMathNodes = function (node, set) {
    var e_1, _a;
    try {
      for (var _b = __values$O(this.adaptor.tags(node, 'math')), _c = _b.next(); !_c.done; _c = _b.next()) {
        var math = _c.value;
        set.add(math);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  FindMathML.prototype.findMathPrefixed = function (node, set) {
    var e_2, _a, e_3, _b;
    var html = this.adaptor.root(this.adaptor.document);
    try {
      for (var _c = __values$O(this.adaptor.allAttributes(html)), _d = _c.next(); !_d.done; _d = _c.next()) {
        var attr = _d.value;
        if (attr.name.substr(0, 6) === 'xmlns:' && attr.value === NAMESPACE) {
          var prefix = attr.name.substr(6);
          try {
            for (var _e = (e_3 = void 0, __values$O(this.adaptor.tags(node, prefix + ':math'))), _f = _e.next(); !_f.done; _f = _e.next()) {
              var math = _f.value;
              set.add(math);
            }
          } catch (e_3_1) {
            e_3 = {
              error: e_3_1
            };
          } finally {
            try {
              if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            } finally {
              if (e_3) throw e_3.error;
            }
          }
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  FindMathML.prototype.findMathNS = function (node, set) {
    var e_4, _a;
    try {
      for (var _b = __values$O(this.adaptor.tags(node, 'math', NAMESPACE)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var math = _c.value;
        set.add(math);
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
  };
  FindMathML.prototype.processMath = function (set) {
    var e_5, _a;
    var math = [];
    try {
      for (var _b = __values$O(Array.from(set)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var mml = _c.value;
        var display = this.adaptor.getAttribute(mml, 'display') === 'block' || this.adaptor.getAttribute(mml, 'mode') === 'display';
        var start = {
          node: mml,
          n: 0,
          delim: ''
        };
        var end = {
          node: mml,
          n: 0,
          delim: ''
        };
        math.push({
          math: this.adaptor.outerHTML(mml),
          start: start,
          end: end,
          display: display
        });
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
    return math;
  };
  FindMathML.OPTIONS = {};
  return FindMathML;
})(FindMath_js_1$1.AbstractFindMath);
FindMathML$1.FindMathML = FindMathML;

var MathMLCompile$1 = {};

var MmlNode = {};

var Attributes = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.Attributes = exports.INHERIT = void 0;
  exports.INHERIT = '_inherit_';
  var Attributes = (function () {
    function Attributes(defaults, global) {
      this.global = global;
      this.defaults = Object.create(global);
      this.inherited = Object.create(this.defaults);
      this.attributes = Object.create(this.inherited);
      Object.assign(this.defaults, defaults);
    }
    Attributes.prototype.set = function (name, value) {
      this.attributes[name] = value;
    };
    Attributes.prototype.setList = function (list) {
      Object.assign(this.attributes, list);
    };
    Attributes.prototype.get = function (name) {
      var value = this.attributes[name];
      if (value === exports.INHERIT) {
        value = this.global[name];
      }
      return value;
    };
    Attributes.prototype.getExplicit = function (name) {
      if (!this.attributes.hasOwnProperty(name)) {
        return undefined;
      }
      return this.attributes[name];
    };
    Attributes.prototype.getList = function () {
      var e_1, _a;
      var names = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        names[_i] = arguments[_i];
      }
      var values = {};
      try {
        for (var names_1 = __values(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
          var name_1 = names_1_1.value;
          values[name_1] = this.get(name_1);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (names_1_1 && !names_1_1.done && (_a = names_1.return)) _a.call(names_1);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return values;
    };
    Attributes.prototype.setInherited = function (name, value) {
      this.inherited[name] = value;
    };
    Attributes.prototype.getInherited = function (name) {
      return this.inherited[name];
    };
    Attributes.prototype.getDefault = function (name) {
      return this.defaults[name];
    };
    Attributes.prototype.isSet = function (name) {
      return this.attributes.hasOwnProperty(name) || this.inherited.hasOwnProperty(name);
    };
    Attributes.prototype.hasDefault = function (name) {
      return (name in this.defaults);
    };
    Attributes.prototype.getExplicitNames = function () {
      return Object.keys(this.attributes);
    };
    Attributes.prototype.getInheritedNames = function () {
      return Object.keys(this.inherited);
    };
    Attributes.prototype.getDefaultNames = function () {
      return Object.keys(this.defaults);
    };
    Attributes.prototype.getGlobalNames = function () {
      return Object.keys(this.global);
    };
    Attributes.prototype.getAllAttributes = function () {
      return this.attributes;
    };
    Attributes.prototype.getAllInherited = function () {
      return this.inherited;
    };
    Attributes.prototype.getAllDefaults = function () {
      return this.defaults;
    };
    Attributes.prototype.getAllGlobals = function () {
      return this.global;
    };
    return Attributes;
  })();
  exports.Attributes = Attributes;
})(Attributes);
getDefaultExportFromCjs(Attributes);

var Node$1 = {};

var __extends$1T = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$G = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$G = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$G.apply(this, arguments);
});
var __values$N = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(Node$1, "__esModule", {
  value: true
});
Node$1.AbstractEmptyNode = Node$1.AbstractNode = void 0;
var AbstractNode = (function () {
  function AbstractNode(factory, properties, children) {
    var e_1, _a;
    if (properties === void 0) {
      properties = {};
    }
    if (children === void 0) {
      children = [];
    }
    this.factory = factory;
    this.parent = null;
    this.properties = {};
    this.childNodes = [];
    try {
      for (var _b = __values$N(Object.keys(properties)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_1 = _c.value;
        this.setProperty(name_1, properties[name_1]);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    if (children.length) {
      this.setChildren(children);
    }
  }
  Object.defineProperty(AbstractNode.prototype, "kind", {
    get: function () {
      return 'unknown';
    },
    enumerable: false,
    configurable: true
  });
  AbstractNode.prototype.setProperty = function (name, value) {
    this.properties[name] = value;
  };
  AbstractNode.prototype.getProperty = function (name) {
    return this.properties[name];
  };
  AbstractNode.prototype.getPropertyNames = function () {
    return Object.keys(this.properties);
  };
  AbstractNode.prototype.getAllProperties = function () {
    return this.properties;
  };
  AbstractNode.prototype.removeProperty = function () {
    var e_2, _a;
    var names = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      names[_i] = arguments[_i];
    }
    try {
      for (var names_1 = __values$N(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
        var name_2 = names_1_1.value;
        delete this.properties[name_2];
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (names_1_1 && !names_1_1.done && (_a = names_1.return)) _a.call(names_1);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  AbstractNode.prototype.isKind = function (kind) {
    return this.factory.nodeIsKind(this, kind);
  };
  AbstractNode.prototype.setChildren = function (children) {
    var e_3, _a;
    this.childNodes = [];
    try {
      for (var children_1 = __values$N(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
        var child = children_1_1.value;
        this.appendChild(child);
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
  };
  AbstractNode.prototype.appendChild = function (child) {
    this.childNodes.push(child);
    child.parent = this;
    return child;
  };
  AbstractNode.prototype.replaceChild = function (newChild, oldChild) {
    var i = this.childIndex(oldChild);
    if (i !== null) {
      this.childNodes[i] = newChild;
      newChild.parent = this;
      oldChild.parent = null;
    }
    return newChild;
  };
  AbstractNode.prototype.removeChild = function (child) {
    var i = this.childIndex(child);
    if (i !== null) {
      this.childNodes.splice(i, 1);
      child.parent = null;
    }
    return child;
  };
  AbstractNode.prototype.childIndex = function (node) {
    var i = this.childNodes.indexOf(node);
    return i === -1 ? null : i;
  };
  AbstractNode.prototype.copy = function () {
    var e_4, _a;
    var node = this.factory.create(this.kind);
    node.properties = __assign$G({}, this.properties);
    try {
      for (var _b = __values$N(this.childNodes || []), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (child) {
          node.appendChild(child.copy());
        }
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    return node;
  };
  AbstractNode.prototype.findNodes = function (kind) {
    var nodes = [];
    this.walkTree(function (node) {
      if (node.isKind(kind)) {
        nodes.push(node);
      }
    });
    return nodes;
  };
  AbstractNode.prototype.walkTree = function (func, data) {
    var e_5, _a;
    func(this, data);
    try {
      for (var _b = __values$N(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (child) {
          child.walkTree(func, data);
        }
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
    return data;
  };
  AbstractNode.prototype.toString = function () {
    return this.kind + '(' + this.childNodes.join(',') + ')';
  };
  return AbstractNode;
})();
Node$1.AbstractNode = AbstractNode;
var AbstractEmptyNode = (function (_super) {
  __extends$1T(AbstractEmptyNode, _super);
  function AbstractEmptyNode() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  AbstractEmptyNode.prototype.setChildren = function (_children) {};
  AbstractEmptyNode.prototype.appendChild = function (child) {
    return child;
  };
  AbstractEmptyNode.prototype.replaceChild = function (_newChild, oldChild) {
    return oldChild;
  };
  AbstractEmptyNode.prototype.childIndex = function (_node) {
    return null;
  };
  AbstractEmptyNode.prototype.walkTree = function (func, data) {
    func(this, data);
    return data;
  };
  AbstractEmptyNode.prototype.toString = function () {
    return this.kind;
  };
  return AbstractEmptyNode;
})(AbstractNode);
Node$1.AbstractEmptyNode = AbstractEmptyNode;

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __assign = commonjsGlobal && commonjsGlobal.__assign || (function () {
    __assign = Object.assign || (function (t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    });
    return __assign.apply(this, arguments);
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.XMLNode = exports.TextNode = exports.AbstractMmlEmptyNode = exports.AbstractMmlBaseNode = exports.AbstractMmlLayoutNode = exports.AbstractMmlTokenNode = exports.AbstractMmlNode = exports.indentAttributes = exports.TEXCLASSNAMES = exports.TEXCLASS = void 0;
  var Attributes_js_1 = Attributes;
  var Node_js_1 = Node$1;
  exports.TEXCLASS = {
    ORD: 0,
    OP: 1,
    BIN: 2,
    REL: 3,
    OPEN: 4,
    CLOSE: 5,
    PUNCT: 6,
    INNER: 7,
    VCENTER: 8,
    NONE: -1
  };
  exports.TEXCLASSNAMES = ['ORD', 'OP', 'BIN', 'REL', 'OPEN', 'CLOSE', 'PUNCT', 'INNER', 'VCENTER'];
  var TEXSPACELENGTH = ['', 'thinmathspace', 'mediummathspace', 'thickmathspace'];
  var TEXSPACE = [[0, -1, 2, 3, 0, 0, 0, 1], [-1, -1, 0, 3, 0, 0, 0, 1], [2, 2, 0, 0, 2, 0, 0, 2], [3, 3, 0, 0, 3, 0, 0, 3], [0, 0, 0, 0, 0, 0, 0, 0], [0, -1, 2, 3, 0, 0, 0, 1], [1, 1, 0, 1, 1, 1, 1, 1], [1, -1, 2, 3, 1, 0, 1, 1]];
  exports.indentAttributes = ['indentalign', 'indentalignfirst', 'indentshift', 'indentshiftfirst'];
  var AbstractMmlNode = (function (_super) {
    __extends(AbstractMmlNode, _super);
    function AbstractMmlNode(factory, attributes, children) {
      if (attributes === void 0) {
        attributes = {};
      }
      if (children === void 0) {
        children = [];
      }
      var _this = _super.call(this, factory) || this;
      _this.prevClass = null;
      _this.prevLevel = null;
      _this.texclass = null;
      if (_this.arity < 0) {
        _this.childNodes = [factory.create('inferredMrow')];
        _this.childNodes[0].parent = _this;
      }
      _this.setChildren(children);
      _this.attributes = new Attributes_js_1.Attributes(factory.getNodeClass(_this.kind).defaults, factory.getNodeClass('math').defaults);
      _this.attributes.setList(attributes);
      return _this;
    }
    AbstractMmlNode.prototype.copy = function (keepIds) {
      var e_1, _a, e_2, _b;
      if (keepIds === void 0) {
        keepIds = false;
      }
      var node = this.factory.create(this.kind);
      node.properties = __assign({}, this.properties);
      if (this.attributes) {
        var attributes = this.attributes.getAllAttributes();
        try {
          for (var _c = __values(Object.keys(attributes)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var name_1 = _d.value;
            if (name_1 !== 'id' || keepIds) {
              node.attributes.set(name_1, attributes[name_1]);
            }
          }
        } catch (e_1_1) {
          e_1 = {
            error: e_1_1
          };
        } finally {
          try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
          } finally {
            if (e_1) throw e_1.error;
          }
        }
      }
      if (this.childNodes && this.childNodes.length) {
        var children = this.childNodes;
        if (children.length === 1 && children[0].isInferred) {
          children = children[0].childNodes;
        }
        try {
          for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
            var child = children_1_1.value;
            if (child) {
              node.appendChild(child.copy());
            } else {
              node.childNodes.push(null);
            }
          }
        } catch (e_2_1) {
          e_2 = {
            error: e_2_1
          };
        } finally {
          try {
            if (children_1_1 && !children_1_1.done && (_b = children_1.return)) _b.call(children_1);
          } finally {
            if (e_2) throw e_2.error;
          }
        }
      }
      return node;
    };
    Object.defineProperty(AbstractMmlNode.prototype, "texClass", {
      get: function () {
        return this.texclass;
      },
      set: function (texClass) {
        this.texclass = texClass;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "isToken", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "isEmbellished", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "isSpacelike", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "linebreakContainer", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "hasNewLine", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "arity", {
      get: function () {
        return Infinity;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "isInferred", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "Parent", {
      get: function () {
        var parent = this.parent;
        while (parent && parent.notParent) {
          parent = parent.Parent;
        }
        return parent;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlNode.prototype, "notParent", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlNode.prototype.setChildren = function (children) {
      if (this.arity < 0) {
        return this.childNodes[0].setChildren(children);
      }
      return _super.prototype.setChildren.call(this, children);
    };
    AbstractMmlNode.prototype.appendChild = function (child) {
      var e_3, _a;
      var _this = this;
      if (this.arity < 0) {
        this.childNodes[0].appendChild(child);
        return child;
      }
      if (child.isInferred) {
        if (this.arity === Infinity) {
          child.childNodes.forEach(function (node) {
            return _super.prototype.appendChild.call(_this, node);
          });
          return child;
        }
        var original = child;
        child = this.factory.create('mrow');
        child.setChildren(original.childNodes);
        child.attributes = original.attributes;
        try {
          for (var _b = __values(original.getPropertyNames()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var name_2 = _c.value;
            child.setProperty(name_2, original.getProperty(name_2));
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
      }
      return _super.prototype.appendChild.call(this, child);
    };
    AbstractMmlNode.prototype.replaceChild = function (newChild, oldChild) {
      if (this.arity < 0) {
        this.childNodes[0].replaceChild(newChild, oldChild);
        return newChild;
      }
      return _super.prototype.replaceChild.call(this, newChild, oldChild);
    };
    AbstractMmlNode.prototype.core = function () {
      return this;
    };
    AbstractMmlNode.prototype.coreMO = function () {
      return this;
    };
    AbstractMmlNode.prototype.coreIndex = function () {
      return 0;
    };
    AbstractMmlNode.prototype.childPosition = function () {
      var e_4, _a;
      var child = this;
      var parent = child.parent;
      while (parent && parent.notParent) {
        child = parent;
        parent = parent.parent;
      }
      if (parent) {
        var i = 0;
        try {
          for (var _b = __values(parent.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
            var node = _c.value;
            if (node === child) {
              return i;
            }
            i++;
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
      }
      return null;
    };
    AbstractMmlNode.prototype.setTeXclass = function (prev) {
      this.getPrevClass(prev);
      return this.texClass != null ? this : prev;
    };
    AbstractMmlNode.prototype.updateTeXclass = function (core) {
      if (core) {
        this.prevClass = core.prevClass;
        this.prevLevel = core.prevLevel;
        core.prevClass = core.prevLevel = null;
        this.texClass = core.texClass;
      }
    };
    AbstractMmlNode.prototype.getPrevClass = function (prev) {
      if (prev) {
        this.prevClass = prev.texClass;
        this.prevLevel = prev.attributes.get('scriptlevel');
      }
    };
    AbstractMmlNode.prototype.texSpacing = function () {
      var prevClass = this.prevClass != null ? this.prevClass : exports.TEXCLASS.NONE;
      var texClass = this.texClass || exports.TEXCLASS.ORD;
      if (prevClass === exports.TEXCLASS.NONE || texClass === exports.TEXCLASS.NONE) {
        return '';
      }
      if (prevClass === exports.TEXCLASS.VCENTER) {
        prevClass = exports.TEXCLASS.ORD;
      }
      if (texClass === exports.TEXCLASS.VCENTER) {
        texClass = exports.TEXCLASS.ORD;
      }
      var space = TEXSPACE[prevClass][texClass];
      if ((this.prevLevel > 0 || this.attributes.get('scriptlevel') > 0) && space >= 0) {
        return '';
      }
      return TEXSPACELENGTH[Math.abs(space)];
    };
    AbstractMmlNode.prototype.hasSpacingAttributes = function () {
      return this.isEmbellished && this.coreMO().hasSpacingAttributes();
    };
    AbstractMmlNode.prototype.setInheritedAttributes = function (attributes, display, level, prime) {
      var e_5, _a;
      if (attributes === void 0) {
        attributes = {};
      }
      if (display === void 0) {
        display = false;
      }
      if (level === void 0) {
        level = 0;
      }
      if (prime === void 0) {
        prime = false;
      }
      var defaults = this.attributes.getAllDefaults();
      try {
        for (var _b = __values(Object.keys(attributes)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          if (defaults.hasOwnProperty(key) || AbstractMmlNode.alwaysInherit.hasOwnProperty(key)) {
            var _d = __read(attributes[key], 2), node = _d[0], value = _d[1];
            var noinherit = (AbstractMmlNode.noInherit[node] || ({}))[this.kind] || ({});
            if (!noinherit[key]) {
              this.attributes.setInherited(key, value);
            }
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      var displaystyle = this.attributes.getExplicit('displaystyle');
      if (displaystyle === undefined) {
        this.attributes.setInherited('displaystyle', display);
      }
      var scriptlevel = this.attributes.getExplicit('scriptlevel');
      if (scriptlevel === undefined) {
        this.attributes.setInherited('scriptlevel', level);
      }
      if (prime) {
        this.setProperty('texprimestyle', prime);
      }
      var arity = this.arity;
      if (arity >= 0 && arity !== Infinity && (arity === 1 && this.childNodes.length === 0 || arity !== 1 && this.childNodes.length !== arity)) {
        if (arity < this.childNodes.length) {
          this.childNodes = this.childNodes.slice(0, arity);
        } else {
          while (this.childNodes.length < arity) {
            this.appendChild(this.factory.create('mrow'));
          }
        }
      }
      this.setChildInheritedAttributes(attributes, display, level, prime);
    };
    AbstractMmlNode.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
      var e_6, _a;
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          child.setInheritedAttributes(attributes, display, level, prime);
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
    };
    AbstractMmlNode.prototype.addInheritedAttributes = function (current, attributes) {
      var e_7, _a;
      var updated = __assign({}, current);
      try {
        for (var _b = __values(Object.keys(attributes)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var name_3 = _c.value;
          if (name_3 !== 'displaystyle' && name_3 !== 'scriptlevel' && name_3 !== 'style') {
            updated[name_3] = [this.kind, attributes[name_3]];
          }
        }
      } catch (e_7_1) {
        e_7 = {
          error: e_7_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_7) throw e_7.error;
        }
      }
      return updated;
    };
    AbstractMmlNode.prototype.inheritAttributesFrom = function (node) {
      var attributes = node.attributes;
      var display = attributes.get('displaystyle');
      var scriptlevel = attributes.get('scriptlevel');
      var defaults = !attributes.isSet('mathsize') ? {} : {
        mathsize: ['math', attributes.get('mathsize')]
      };
      var prime = node.getProperty('texprimestyle') || false;
      this.setInheritedAttributes(defaults, display, scriptlevel, prime);
    };
    AbstractMmlNode.prototype.verifyTree = function (options) {
      if (options === void 0) {
        options = null;
      }
      if (options === null) {
        return;
      }
      this.verifyAttributes(options);
      var arity = this.arity;
      if (options['checkArity']) {
        if (arity >= 0 && arity !== Infinity && (arity === 1 && this.childNodes.length === 0 || arity !== 1 && this.childNodes.length !== arity)) {
          this.mError('Wrong number of children for "' + this.kind + '" node', options, true);
        }
      }
      this.verifyChildren(options);
    };
    AbstractMmlNode.prototype.verifyAttributes = function (options) {
      var e_8, _a;
      if (options['checkAttributes']) {
        var attributes = this.attributes;
        var bad = [];
        try {
          for (var _b = __values(attributes.getExplicitNames()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var name_4 = _c.value;
            if (name_4.substr(0, 5) !== 'data-' && attributes.getDefault(name_4) === undefined && !name_4.match(/^(?:class|style|id|(?:xlink:)?href)$/)) {
              bad.push(name_4);
            }
          }
        } catch (e_8_1) {
          e_8 = {
            error: e_8_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_8) throw e_8.error;
          }
        }
        if (bad.length) {
          this.mError('Unknown attributes for ' + this.kind + ' node: ' + bad.join(', '), options);
        }
      }
    };
    AbstractMmlNode.prototype.verifyChildren = function (options) {
      var e_9, _a;
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          child.verifyTree(options);
        }
      } catch (e_9_1) {
        e_9 = {
          error: e_9_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_9) throw e_9.error;
        }
      }
    };
    AbstractMmlNode.prototype.mError = function (message, options, short) {
      if (short === void 0) {
        short = false;
      }
      if (this.parent && this.parent.isKind('merror')) {
        return null;
      }
      var merror = this.factory.create('merror');
      merror.attributes.set('data-mjx-message', message);
      if (options['fullErrors'] || short) {
        var mtext = this.factory.create('mtext');
        var text = this.factory.create('text');
        text.setText(options['fullErrors'] ? message : this.kind);
        mtext.appendChild(text);
        merror.appendChild(mtext);
        this.parent.replaceChild(merror, this);
      } else {
        this.parent.replaceChild(merror, this);
        merror.appendChild(this);
      }
      return merror;
    };
    AbstractMmlNode.defaults = {
      mathbackground: Attributes_js_1.INHERIT,
      mathcolor: Attributes_js_1.INHERIT,
      mathsize: Attributes_js_1.INHERIT,
      dir: Attributes_js_1.INHERIT
    };
    AbstractMmlNode.noInherit = {
      mstyle: {
        mpadded: {
          width: true,
          height: true,
          depth: true,
          lspace: true,
          voffset: true
        },
        mtable: {
          width: true,
          height: true,
          depth: true,
          align: true
        }
      },
      maligngroup: {
        mrow: {
          groupalign: true
        },
        mtable: {
          groupalign: true
        }
      }
    };
    AbstractMmlNode.alwaysInherit = {
      scriptminsize: true,
      scriptsizemultiplier: true
    };
    AbstractMmlNode.verifyDefaults = {
      checkArity: true,
      checkAttributes: false,
      fullErrors: false,
      fixMmultiscripts: true,
      fixMtables: true
    };
    return AbstractMmlNode;
  })(Node_js_1.AbstractNode);
  exports.AbstractMmlNode = AbstractMmlNode;
  var AbstractMmlTokenNode = (function (_super) {
    __extends(AbstractMmlTokenNode, _super);
    function AbstractMmlTokenNode() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AbstractMmlTokenNode.prototype, "isToken", {
      get: function () {
        return true;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlTokenNode.prototype.getText = function () {
      var e_10, _a;
      var text = '';
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child instanceof TextNode) {
            text += child.getText();
          }
        }
      } catch (e_10_1) {
        e_10 = {
          error: e_10_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_10) throw e_10.error;
        }
      }
      return text;
    };
    AbstractMmlTokenNode.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
      var e_11, _a;
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child instanceof AbstractMmlNode) {
            child.setInheritedAttributes(attributes, display, level, prime);
          }
        }
      } catch (e_11_1) {
        e_11 = {
          error: e_11_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_11) throw e_11.error;
        }
      }
    };
    AbstractMmlTokenNode.prototype.walkTree = function (func, data) {
      var e_12, _a;
      func(this, data);
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child instanceof AbstractMmlNode) {
            child.walkTree(func, data);
          }
        }
      } catch (e_12_1) {
        e_12 = {
          error: e_12_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_12) throw e_12.error;
        }
      }
      return data;
    };
    AbstractMmlTokenNode.defaults = __assign(__assign({}, AbstractMmlNode.defaults), {
      mathvariant: 'normal',
      mathsize: Attributes_js_1.INHERIT
    });
    return AbstractMmlTokenNode;
  })(AbstractMmlNode);
  exports.AbstractMmlTokenNode = AbstractMmlTokenNode;
  var AbstractMmlLayoutNode = (function (_super) {
    __extends(AbstractMmlLayoutNode, _super);
    function AbstractMmlLayoutNode() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AbstractMmlLayoutNode.prototype, "isSpacelike", {
      get: function () {
        return this.childNodes[0].isSpacelike;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlLayoutNode.prototype, "isEmbellished", {
      get: function () {
        return this.childNodes[0].isEmbellished;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlLayoutNode.prototype, "arity", {
      get: function () {
        return -1;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlLayoutNode.prototype.core = function () {
      return this.childNodes[0];
    };
    AbstractMmlLayoutNode.prototype.coreMO = function () {
      return this.childNodes[0].coreMO();
    };
    AbstractMmlLayoutNode.prototype.setTeXclass = function (prev) {
      prev = this.childNodes[0].setTeXclass(prev);
      this.updateTeXclass(this.childNodes[0]);
      return prev;
    };
    AbstractMmlLayoutNode.defaults = AbstractMmlNode.defaults;
    return AbstractMmlLayoutNode;
  })(AbstractMmlNode);
  exports.AbstractMmlLayoutNode = AbstractMmlLayoutNode;
  var AbstractMmlBaseNode = (function (_super) {
    __extends(AbstractMmlBaseNode, _super);
    function AbstractMmlBaseNode() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AbstractMmlBaseNode.prototype, "isEmbellished", {
      get: function () {
        return this.childNodes[0].isEmbellished;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlBaseNode.prototype.core = function () {
      return this.childNodes[0];
    };
    AbstractMmlBaseNode.prototype.coreMO = function () {
      return this.childNodes[0].coreMO();
    };
    AbstractMmlBaseNode.prototype.setTeXclass = function (prev) {
      var e_13, _a;
      this.getPrevClass(prev);
      this.texClass = exports.TEXCLASS.ORD;
      var base = this.childNodes[0];
      if (base) {
        if (this.isEmbellished || base.isKind('mi')) {
          prev = base.setTeXclass(prev);
          this.updateTeXclass(this.core());
        } else {
          base.setTeXclass(null);
          prev = this;
        }
      } else {
        prev = this;
      }
      try {
        for (var _b = __values(this.childNodes.slice(1)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child) {
            child.setTeXclass(null);
          }
        }
      } catch (e_13_1) {
        e_13 = {
          error: e_13_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_13) throw e_13.error;
        }
      }
      return prev;
    };
    AbstractMmlBaseNode.defaults = AbstractMmlNode.defaults;
    return AbstractMmlBaseNode;
  })(AbstractMmlNode);
  exports.AbstractMmlBaseNode = AbstractMmlBaseNode;
  var AbstractMmlEmptyNode = (function (_super) {
    __extends(AbstractMmlEmptyNode, _super);
    function AbstractMmlEmptyNode() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "isToken", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "isEmbellished", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "isSpacelike", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "linebreakContainer", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "hasNewLine", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "arity", {
      get: function () {
        return 0;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "isInferred", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "notParent", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "Parent", {
      get: function () {
        return this.parent;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "texClass", {
      get: function () {
        return exports.TEXCLASS.NONE;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "prevClass", {
      get: function () {
        return exports.TEXCLASS.NONE;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "prevLevel", {
      get: function () {
        return 0;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlEmptyNode.prototype.hasSpacingAttributes = function () {
      return false;
    };
    Object.defineProperty(AbstractMmlEmptyNode.prototype, "attributes", {
      get: function () {
        return null;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMmlEmptyNode.prototype.core = function () {
      return this;
    };
    AbstractMmlEmptyNode.prototype.coreMO = function () {
      return this;
    };
    AbstractMmlEmptyNode.prototype.coreIndex = function () {
      return 0;
    };
    AbstractMmlEmptyNode.prototype.childPosition = function () {
      return 0;
    };
    AbstractMmlEmptyNode.prototype.setTeXclass = function (prev) {
      return prev;
    };
    AbstractMmlEmptyNode.prototype.texSpacing = function () {
      return '';
    };
    AbstractMmlEmptyNode.prototype.setInheritedAttributes = function (_attributes, _display, _level, _prime) {};
    AbstractMmlEmptyNode.prototype.inheritAttributesFrom = function (_node) {};
    AbstractMmlEmptyNode.prototype.verifyTree = function (_options) {};
    AbstractMmlEmptyNode.prototype.mError = function (_message, _options, _short) {
      return null;
    };
    return AbstractMmlEmptyNode;
  })(Node_js_1.AbstractEmptyNode);
  exports.AbstractMmlEmptyNode = AbstractMmlEmptyNode;
  var TextNode = (function (_super) {
    __extends(TextNode, _super);
    function TextNode() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.text = '';
      return _this;
    }
    Object.defineProperty(TextNode.prototype, "kind", {
      get: function () {
        return 'text';
      },
      enumerable: false,
      configurable: true
    });
    TextNode.prototype.getText = function () {
      return this.text;
    };
    TextNode.prototype.setText = function (text) {
      this.text = text;
      return this;
    };
    TextNode.prototype.copy = function () {
      return this.factory.create(this.kind).setText(this.getText());
    };
    TextNode.prototype.toString = function () {
      return this.text;
    };
    return TextNode;
  })(AbstractMmlEmptyNode);
  exports.TextNode = TextNode;
  var XMLNode = (function (_super) {
    __extends(XMLNode, _super);
    function XMLNode() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.xml = null;
      _this.adaptor = null;
      return _this;
    }
    Object.defineProperty(XMLNode.prototype, "kind", {
      get: function () {
        return 'XML';
      },
      enumerable: false,
      configurable: true
    });
    XMLNode.prototype.getXML = function () {
      return this.xml;
    };
    XMLNode.prototype.setXML = function (xml, adaptor) {
      if (adaptor === void 0) {
        adaptor = null;
      }
      this.xml = xml;
      this.adaptor = adaptor;
      return this;
    };
    XMLNode.prototype.getSerializedXML = function () {
      return this.adaptor.serializeXML(this.xml);
    };
    XMLNode.prototype.copy = function () {
      return this.factory.create(this.kind).setXML(this.adaptor.clone(this.xml));
    };
    XMLNode.prototype.toString = function () {
      return 'XML data';
    };
    return XMLNode;
  })(AbstractMmlEmptyNode);
  exports.XMLNode = XMLNode;
})(MmlNode);
getDefaultExportFromCjs(MmlNode);

var Entities$1 = {};

var AsyncLoad = {};

Object.defineProperty(AsyncLoad, "__esModule", {
  value: true
});
AsyncLoad.asyncLoad = void 0;
var mathjax_js_1$1 = mathjax;
function asyncLoad(name) {
  if (!mathjax_js_1$1.mathjax.asyncLoad) {
    return Promise.reject(("Can't load '").concat(name, "': No asyncLoad method specified"));
  }
  return new Promise(function (ok, fail) {
    var result = mathjax_js_1$1.mathjax.asyncLoad(name);
    if (result instanceof Promise) {
      result.then(function (value) {
        return ok(value);
      }).catch(function (err) {
        return fail(err);
      });
    } else {
      ok(result);
    }
  });
}
AsyncLoad.asyncLoad = asyncLoad;

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.numeric = exports.translate = exports.remove = exports.add = exports.entities = exports.options = void 0;
  var Retries_js_1 = Retries;
  var AsyncLoad_js_1 = AsyncLoad;
  exports.options = {
    loadMissingEntities: true
  };
  exports.entities = {
    ApplyFunction: '\u2061',
    Backslash: '\u2216',
    Because: '\u2235',
    Breve: '\u02D8',
    Cap: '\u22D2',
    CenterDot: '\u00B7',
    CircleDot: '\u2299',
    CircleMinus: '\u2296',
    CirclePlus: '\u2295',
    CircleTimes: '\u2297',
    Congruent: '\u2261',
    ContourIntegral: '\u222E',
    Coproduct: '\u2210',
    Cross: '\u2A2F',
    Cup: '\u22D3',
    CupCap: '\u224D',
    Dagger: '\u2021',
    Del: '\u2207',
    Delta: '\u0394',
    Diamond: '\u22C4',
    DifferentialD: '\u2146',
    DotEqual: '\u2250',
    DoubleDot: '\u00A8',
    DoubleRightTee: '\u22A8',
    DoubleVerticalBar: '\u2225',
    DownArrow: '\u2193',
    DownLeftVector: '\u21BD',
    DownRightVector: '\u21C1',
    DownTee: '\u22A4',
    Downarrow: '\u21D3',
    Element: '\u2208',
    EqualTilde: '\u2242',
    Equilibrium: '\u21CC',
    Exists: '\u2203',
    ExponentialE: '\u2147',
    FilledVerySmallSquare: '\u25AA',
    ForAll: '\u2200',
    Gamma: '\u0393',
    Gg: '\u22D9',
    GreaterEqual: '\u2265',
    GreaterEqualLess: '\u22DB',
    GreaterFullEqual: '\u2267',
    GreaterLess: '\u2277',
    GreaterSlantEqual: '\u2A7E',
    GreaterTilde: '\u2273',
    Hacek: '\u02C7',
    Hat: '\u005E',
    HumpDownHump: '\u224E',
    HumpEqual: '\u224F',
    Im: '\u2111',
    ImaginaryI: '\u2148',
    Integral: '\u222B',
    Intersection: '\u22C2',
    InvisibleComma: '\u2063',
    InvisibleTimes: '\u2062',
    Lambda: '\u039B',
    Larr: '\u219E',
    LeftAngleBracket: '\u27E8',
    LeftArrow: '\u2190',
    LeftArrowRightArrow: '\u21C6',
    LeftCeiling: '\u2308',
    LeftDownVector: '\u21C3',
    LeftFloor: '\u230A',
    LeftRightArrow: '\u2194',
    LeftTee: '\u22A3',
    LeftTriangle: '\u22B2',
    LeftTriangleEqual: '\u22B4',
    LeftUpVector: '\u21BF',
    LeftVector: '\u21BC',
    Leftarrow: '\u21D0',
    Leftrightarrow: '\u21D4',
    LessEqualGreater: '\u22DA',
    LessFullEqual: '\u2266',
    LessGreater: '\u2276',
    LessSlantEqual: '\u2A7D',
    LessTilde: '\u2272',
    Ll: '\u22D8',
    Lleftarrow: '\u21DA',
    LongLeftArrow: '\u27F5',
    LongLeftRightArrow: '\u27F7',
    LongRightArrow: '\u27F6',
    Longleftarrow: '\u27F8',
    Longleftrightarrow: '\u27FA',
    Longrightarrow: '\u27F9',
    Lsh: '\u21B0',
    MinusPlus: '\u2213',
    NestedGreaterGreater: '\u226B',
    NestedLessLess: '\u226A',
    NotDoubleVerticalBar: '\u2226',
    NotElement: '\u2209',
    NotEqual: '\u2260',
    NotExists: '\u2204',
    NotGreater: '\u226F',
    NotGreaterEqual: '\u2271',
    NotLeftTriangle: '\u22EA',
    NotLeftTriangleEqual: '\u22EC',
    NotLess: '\u226E',
    NotLessEqual: '\u2270',
    NotPrecedes: '\u2280',
    NotPrecedesSlantEqual: '\u22E0',
    NotRightTriangle: '\u22EB',
    NotRightTriangleEqual: '\u22ED',
    NotSubsetEqual: '\u2288',
    NotSucceeds: '\u2281',
    NotSucceedsSlantEqual: '\u22E1',
    NotSupersetEqual: '\u2289',
    NotTilde: '\u2241',
    NotVerticalBar: '\u2224',
    Omega: '\u03A9',
    OverBar: '\u203E',
    OverBrace: '\u23DE',
    PartialD: '\u2202',
    Phi: '\u03A6',
    Pi: '\u03A0',
    PlusMinus: '\u00B1',
    Precedes: '\u227A',
    PrecedesEqual: '\u2AAF',
    PrecedesSlantEqual: '\u227C',
    PrecedesTilde: '\u227E',
    Product: '\u220F',
    Proportional: '\u221D',
    Psi: '\u03A8',
    Rarr: '\u21A0',
    Re: '\u211C',
    ReverseEquilibrium: '\u21CB',
    RightAngleBracket: '\u27E9',
    RightArrow: '\u2192',
    RightArrowLeftArrow: '\u21C4',
    RightCeiling: '\u2309',
    RightDownVector: '\u21C2',
    RightFloor: '\u230B',
    RightTee: '\u22A2',
    RightTeeArrow: '\u21A6',
    RightTriangle: '\u22B3',
    RightTriangleEqual: '\u22B5',
    RightUpVector: '\u21BE',
    RightVector: '\u21C0',
    Rightarrow: '\u21D2',
    Rrightarrow: '\u21DB',
    Rsh: '\u21B1',
    Sigma: '\u03A3',
    SmallCircle: '\u2218',
    Sqrt: '\u221A',
    Square: '\u25A1',
    SquareIntersection: '\u2293',
    SquareSubset: '\u228F',
    SquareSubsetEqual: '\u2291',
    SquareSuperset: '\u2290',
    SquareSupersetEqual: '\u2292',
    SquareUnion: '\u2294',
    Star: '\u22C6',
    Subset: '\u22D0',
    SubsetEqual: '\u2286',
    Succeeds: '\u227B',
    SucceedsEqual: '\u2AB0',
    SucceedsSlantEqual: '\u227D',
    SucceedsTilde: '\u227F',
    SuchThat: '\u220B',
    Sum: '\u2211',
    Superset: '\u2283',
    SupersetEqual: '\u2287',
    Supset: '\u22D1',
    Therefore: '\u2234',
    Theta: '\u0398',
    Tilde: '\u223C',
    TildeEqual: '\u2243',
    TildeFullEqual: '\u2245',
    TildeTilde: '\u2248',
    UnderBar: '\u005F',
    UnderBrace: '\u23DF',
    Union: '\u22C3',
    UnionPlus: '\u228E',
    UpArrow: '\u2191',
    UpDownArrow: '\u2195',
    UpTee: '\u22A5',
    Uparrow: '\u21D1',
    Updownarrow: '\u21D5',
    Upsilon: '\u03A5',
    Vdash: '\u22A9',
    Vee: '\u22C1',
    VerticalBar: '\u2223',
    VerticalTilde: '\u2240',
    Vvdash: '\u22AA',
    Wedge: '\u22C0',
    Xi: '\u039E',
    amp: '\u0026',
    acute: '\u00B4',
    aleph: '\u2135',
    alpha: '\u03B1',
    amalg: '\u2A3F',
    and: '\u2227',
    ang: '\u2220',
    angmsd: '\u2221',
    angsph: '\u2222',
    ape: '\u224A',
    backprime: '\u2035',
    backsim: '\u223D',
    backsimeq: '\u22CD',
    beta: '\u03B2',
    beth: '\u2136',
    between: '\u226C',
    bigcirc: '\u25EF',
    bigodot: '\u2A00',
    bigoplus: '\u2A01',
    bigotimes: '\u2A02',
    bigsqcup: '\u2A06',
    bigstar: '\u2605',
    bigtriangledown: '\u25BD',
    bigtriangleup: '\u25B3',
    biguplus: '\u2A04',
    blacklozenge: '\u29EB',
    blacktriangle: '\u25B4',
    blacktriangledown: '\u25BE',
    blacktriangleleft: '\u25C2',
    bowtie: '\u22C8',
    boxdl: '\u2510',
    boxdr: '\u250C',
    boxminus: '\u229F',
    boxplus: '\u229E',
    boxtimes: '\u22A0',
    boxul: '\u2518',
    boxur: '\u2514',
    bsol: '\u005C',
    bull: '\u2022',
    cap: '\u2229',
    check: '\u2713',
    chi: '\u03C7',
    circ: '\u02C6',
    circeq: '\u2257',
    circlearrowleft: '\u21BA',
    circlearrowright: '\u21BB',
    circledR: '\u00AE',
    circledS: '\u24C8',
    circledast: '\u229B',
    circledcirc: '\u229A',
    circleddash: '\u229D',
    clubs: '\u2663',
    colon: '\u003A',
    comp: '\u2201',
    ctdot: '\u22EF',
    cuepr: '\u22DE',
    cuesc: '\u22DF',
    cularr: '\u21B6',
    cup: '\u222A',
    curarr: '\u21B7',
    curlyvee: '\u22CE',
    curlywedge: '\u22CF',
    dagger: '\u2020',
    daleth: '\u2138',
    ddarr: '\u21CA',
    deg: '\u00B0',
    delta: '\u03B4',
    digamma: '\u03DD',
    div: '\u00F7',
    divideontimes: '\u22C7',
    dot: '\u02D9',
    doteqdot: '\u2251',
    dotplus: '\u2214',
    dotsquare: '\u22A1',
    dtdot: '\u22F1',
    ecir: '\u2256',
    efDot: '\u2252',
    egs: '\u2A96',
    ell: '\u2113',
    els: '\u2A95',
    empty: '\u2205',
    epsi: '\u03B5',
    epsiv: '\u03F5',
    erDot: '\u2253',
    eta: '\u03B7',
    eth: '\u00F0',
    flat: '\u266D',
    fork: '\u22D4',
    frown: '\u2322',
    gEl: '\u2A8C',
    gamma: '\u03B3',
    gap: '\u2A86',
    gimel: '\u2137',
    gnE: '\u2269',
    gnap: '\u2A8A',
    gne: '\u2A88',
    gnsim: '\u22E7',
    gt: '\u003E',
    gtdot: '\u22D7',
    harrw: '\u21AD',
    hbar: '\u210F',
    hellip: '\u2026',
    hookleftarrow: '\u21A9',
    hookrightarrow: '\u21AA',
    imath: '\u0131',
    infin: '\u221E',
    intcal: '\u22BA',
    iota: '\u03B9',
    jmath: '\u0237',
    kappa: '\u03BA',
    kappav: '\u03F0',
    lEg: '\u2A8B',
    lambda: '\u03BB',
    lap: '\u2A85',
    larrlp: '\u21AB',
    larrtl: '\u21A2',
    lbrace: '\u007B',
    lbrack: '\u005B',
    le: '\u2264',
    leftleftarrows: '\u21C7',
    leftthreetimes: '\u22CB',
    lessdot: '\u22D6',
    lmoust: '\u23B0',
    lnE: '\u2268',
    lnap: '\u2A89',
    lne: '\u2A87',
    lnsim: '\u22E6',
    longmapsto: '\u27FC',
    looparrowright: '\u21AC',
    lowast: '\u2217',
    loz: '\u25CA',
    lt: '\u003C',
    ltimes: '\u22C9',
    ltri: '\u25C3',
    macr: '\u00AF',
    malt: '\u2720',
    mho: '\u2127',
    mu: '\u03BC',
    multimap: '\u22B8',
    nLeftarrow: '\u21CD',
    nLeftrightarrow: '\u21CE',
    nRightarrow: '\u21CF',
    nVDash: '\u22AF',
    nVdash: '\u22AE',
    natur: '\u266E',
    nearr: '\u2197',
    nharr: '\u21AE',
    nlarr: '\u219A',
    not: '\u00AC',
    nrarr: '\u219B',
    nu: '\u03BD',
    nvDash: '\u22AD',
    nvdash: '\u22AC',
    nwarr: '\u2196',
    omega: '\u03C9',
    omicron: '\u03BF',
    or: '\u2228',
    osol: '\u2298',
    period: '\u002E',
    phi: '\u03C6',
    phiv: '\u03D5',
    pi: '\u03C0',
    piv: '\u03D6',
    prap: '\u2AB7',
    precnapprox: '\u2AB9',
    precneqq: '\u2AB5',
    precnsim: '\u22E8',
    prime: '\u2032',
    psi: '\u03C8',
    quot: '\u0022',
    rarrtl: '\u21A3',
    rbrace: '\u007D',
    rbrack: '\u005D',
    rho: '\u03C1',
    rhov: '\u03F1',
    rightrightarrows: '\u21C9',
    rightthreetimes: '\u22CC',
    ring: '\u02DA',
    rmoust: '\u23B1',
    rtimes: '\u22CA',
    rtri: '\u25B9',
    scap: '\u2AB8',
    scnE: '\u2AB6',
    scnap: '\u2ABA',
    scnsim: '\u22E9',
    sdot: '\u22C5',
    searr: '\u2198',
    sect: '\u00A7',
    sharp: '\u266F',
    sigma: '\u03C3',
    sigmav: '\u03C2',
    simne: '\u2246',
    smile: '\u2323',
    spades: '\u2660',
    sub: '\u2282',
    subE: '\u2AC5',
    subnE: '\u2ACB',
    subne: '\u228A',
    supE: '\u2AC6',
    supnE: '\u2ACC',
    supne: '\u228B',
    swarr: '\u2199',
    tau: '\u03C4',
    theta: '\u03B8',
    thetav: '\u03D1',
    tilde: '\u02DC',
    times: '\u00D7',
    triangle: '\u25B5',
    triangleq: '\u225C',
    upsi: '\u03C5',
    upuparrows: '\u21C8',
    veebar: '\u22BB',
    vellip: '\u22EE',
    weierp: '\u2118',
    xi: '\u03BE',
    yen: '\u00A5',
    zeta: '\u03B6',
    zigrarr: '\u21DD',
    nbsp: '\u00A0',
    rsquo: '\u2019',
    lsquo: '\u2018'
  };
  var loaded = {};
  function add(additions, file) {
    Object.assign(exports.entities, additions);
    loaded[file] = true;
  }
  exports.add = add;
  function remove(entity) {
    delete exports.entities[entity];
  }
  exports.remove = remove;
  function translate(text) {
    return text.replace(/&([a-z][a-z0-9]*|#(?:[0-9]+|x[0-9a-f]+));/ig, replace);
  }
  exports.translate = translate;
  function replace(match, entity) {
    if (entity.charAt(0) === '#') {
      return numeric(entity.slice(1));
    }
    if (exports.entities[entity]) {
      return exports.entities[entity];
    }
    if (exports.options['loadMissingEntities']) {
      var file = entity.match(/^[a-zA-Z](fr|scr|opf)$/) ? RegExp.$1 : entity.charAt(0).toLowerCase();
      if (!loaded[file]) {
        loaded[file] = true;
        (0, Retries_js_1.retryAfter)((0, AsyncLoad_js_1.asyncLoad)('./util/entities/' + file + '.js'));
      }
    }
    return match;
  }
  function numeric(entity) {
    var n = entity.charAt(0) === 'x' ? parseInt(entity.slice(1), 16) : parseInt(entity);
    return String.fromCodePoint(n);
  }
  exports.numeric = numeric;
})(Entities$1);
getDefaultExportFromCjs(Entities$1);

var __assign$F = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$F = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$F.apply(this, arguments);
});
var __createBinding$e = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$e = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$e = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$e(result, mod, k);
  __setModuleDefault$e(result, mod);
  return result;
});
var __values$M = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(MathMLCompile$1, "__esModule", {
  value: true
});
MathMLCompile$1.MathMLCompile = void 0;
var MmlNode_js_1$P = MmlNode;
var Options_js_1$b = Options;
var Entities = __importStar$e(Entities$1);
var MathMLCompile = (function () {
  function MathMLCompile(options) {
    if (options === void 0) {
      options = {};
    }
    var Class = this.constructor;
    this.options = (0, Options_js_1$b.userOptions)((0, Options_js_1$b.defaultOptions)({}, Class.OPTIONS), options);
  }
  MathMLCompile.prototype.setMmlFactory = function (mmlFactory) {
    this.factory = mmlFactory;
  };
  MathMLCompile.prototype.compile = function (node) {
    var mml = this.makeNode(node);
    mml.verifyTree(this.options['verify']);
    mml.setInheritedAttributes({}, false, 0, false);
    mml.walkTree(this.markMrows);
    return mml;
  };
  MathMLCompile.prototype.makeNode = function (node) {
    var e_1, _a;
    var adaptor = this.adaptor;
    var limits = false;
    var kind = adaptor.kind(node).replace(/^.*:/, '');
    var texClass = adaptor.getAttribute(node, 'data-mjx-texclass') || '';
    if (texClass) {
      texClass = this.filterAttribute('data-mjx-texclass', texClass) || '';
    }
    var type = texClass && kind === 'mrow' ? 'TeXAtom' : kind;
    try {
      for (var _b = __values$M(this.filterClassList(adaptor.allClasses(node))), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_1 = _c.value;
        if (name_1.match(/^MJX-TeXAtom-/) && kind === 'mrow') {
          texClass = name_1.substr(12);
          type = 'TeXAtom';
        } else if (name_1 === 'MJX-fixedlimits') {
          limits = true;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    this.factory.getNodeClass(type) || this.error('Unknown node type "' + type + '"');
    var mml = this.factory.create(type);
    if (type === 'TeXAtom' && texClass === 'OP' && !limits) {
      mml.setProperty('movesupsub', true);
      mml.attributes.setInherited('movablelimits', true);
    }
    if (texClass) {
      mml.texClass = MmlNode_js_1$P.TEXCLASS[texClass];
      mml.setProperty('texClass', mml.texClass);
    }
    this.addAttributes(mml, node);
    this.checkClass(mml, node);
    this.addChildren(mml, node);
    return mml;
  };
  MathMLCompile.prototype.addAttributes = function (mml, node) {
    var e_2, _a;
    var ignoreVariant = false;
    try {
      for (var _b = __values$M(this.adaptor.allAttributes(node)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var attr = _c.value;
        var name_2 = attr.name;
        var value = this.filterAttribute(name_2, attr.value);
        if (value === null || name_2 === 'xmlns') {
          continue;
        }
        if (name_2.substr(0, 9) === 'data-mjx-') {
          switch (name_2.substr(9)) {
            case 'alternate':
              mml.setProperty('variantForm', true);
              break;
            case 'variant':
              mml.attributes.set('mathvariant', value);
              ignoreVariant = true;
              break;
            case 'smallmatrix':
              mml.setProperty('scriptlevel', 1);
              mml.setProperty('useHeight', false);
              break;
            case 'accent':
              mml.setProperty('mathaccent', value === 'true');
              break;
            case 'auto-op':
              mml.setProperty('autoOP', value === 'true');
              break;
            case 'script-align':
              mml.setProperty('scriptalign', value);
              break;
          }
        } else if (name_2 !== 'class') {
          var val = value.toLowerCase();
          if (val === 'true' || val === 'false') {
            mml.attributes.set(name_2, val === 'true');
          } else if (!ignoreVariant || name_2 !== 'mathvariant') {
            mml.attributes.set(name_2, value);
          }
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  MathMLCompile.prototype.filterAttribute = function (_name, value) {
    return value;
  };
  MathMLCompile.prototype.filterClassList = function (list) {
    return list;
  };
  MathMLCompile.prototype.addChildren = function (mml, node) {
    var e_3, _a;
    if (mml.arity === 0) {
      return;
    }
    var adaptor = this.adaptor;
    try {
      for (var _b = __values$M(adaptor.childNodes(node)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        var name_3 = adaptor.kind(child);
        if (name_3 === '#comment') {
          continue;
        }
        if (name_3 === '#text') {
          this.addText(mml, child);
        } else if (mml.isKind('annotation-xml')) {
          mml.appendChild(this.factory.create('XML').setXML(child, adaptor));
        } else {
          var childMml = mml.appendChild(this.makeNode(child));
          if (childMml.arity === 0 && adaptor.childNodes(child).length) {
            if (this.options['fixMisplacedChildren']) {
              this.addChildren(mml, child);
            } else {
              childMml.mError('There should not be children for ' + childMml.kind + ' nodes', this.options['verify'], true);
            }
          }
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
  };
  MathMLCompile.prototype.addText = function (mml, child) {
    var text = this.adaptor.value(child);
    if ((mml.isToken || mml.getProperty('isChars')) && mml.arity) {
      if (mml.isToken) {
        text = Entities.translate(text);
        text = this.trimSpace(text);
      }
      mml.appendChild(this.factory.create('text').setText(text));
    } else if (text.match(/\S/)) {
      this.error('Unexpected text node "' + text + '"');
    }
  };
  MathMLCompile.prototype.checkClass = function (mml, node) {
    var e_4, _a;
    var classList = [];
    try {
      for (var _b = __values$M(this.filterClassList(this.adaptor.allClasses(node))), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_4 = _c.value;
        if (name_4.substr(0, 4) === 'MJX-') {
          if (name_4 === 'MJX-variant') {
            mml.setProperty('variantForm', true);
          } else if (name_4.substr(0, 11) !== 'MJX-TeXAtom') {
            mml.attributes.set('mathvariant', this.fixCalligraphic(name_4.substr(3)));
          }
        } else {
          classList.push(name_4);
        }
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    if (classList.length) {
      mml.attributes.set('class', classList.join(' '));
    }
  };
  MathMLCompile.prototype.fixCalligraphic = function (variant) {
    return variant.replace(/caligraphic/, 'calligraphic');
  };
  MathMLCompile.prototype.markMrows = function (mml) {
    if (mml.isKind('mrow') && !mml.isInferred && mml.childNodes.length >= 2) {
      var first = mml.childNodes[0];
      var last = mml.childNodes[mml.childNodes.length - 1];
      if (first.isKind('mo') && first.attributes.get('fence') && first.attributes.get('stretchy') && last.isKind('mo') && last.attributes.get('fence') && last.attributes.get('stretchy')) {
        if (first.childNodes.length) {
          mml.setProperty('open', first.getText());
        }
        if (last.childNodes.length) {
          mml.setProperty('close', last.getText());
        }
      }
    }
  };
  MathMLCompile.prototype.trimSpace = function (text) {
    return text.replace(/[\t\n\r]/g, ' ').replace(/^ +/, '').replace(/ +$/, '').replace(/  +/g, ' ');
  };
  MathMLCompile.prototype.error = function (message) {
    throw new Error(message);
  };
  MathMLCompile.OPTIONS = {
    MmlFactory: null,
    fixMisplacedChildren: true,
    verify: __assign$F({}, MmlNode_js_1$P.AbstractMmlNode.verifyDefaults),
    translateEntities: true
  };
  return MathMLCompile;
})();
MathMLCompile$1.MathMLCompile = MathMLCompile;

var __extends$1S = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$S = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(mathml, "__esModule", {
  value: true
});
var MathML_1 = mathml.MathML = void 0;
var InputJax_js_1$1 = InputJax;
var Options_js_1$a = Options;
var FunctionList_js_1$1 = FunctionList$1;
var FindMathML_js_1 = FindMathML$1;
var MathMLCompile_js_1 = MathMLCompile$1;
var MathML = (function (_super) {
  __extends$1S(MathML, _super);
  function MathML(options) {
    if (options === void 0) {
      options = {};
    }
    var _this = this;
    var _a = __read$S((0, Options_js_1$a.separateOptions)(options, FindMathML_js_1.FindMathML.OPTIONS, MathMLCompile_js_1.MathMLCompile.OPTIONS), 3), mml = _a[0], find = _a[1], compile = _a[2];
    _this = _super.call(this, mml) || this;
    _this.findMathML = _this.options['FindMathML'] || new FindMathML_js_1.FindMathML(find);
    _this.mathml = _this.options['MathMLCompile'] || new MathMLCompile_js_1.MathMLCompile(compile);
    _this.mmlFilters = new FunctionList_js_1$1.FunctionList();
    return _this;
  }
  MathML.prototype.setAdaptor = function (adaptor) {
    _super.prototype.setAdaptor.call(this, adaptor);
    this.findMathML.adaptor = adaptor;
    this.mathml.adaptor = adaptor;
  };
  MathML.prototype.setMmlFactory = function (mmlFactory) {
    _super.prototype.setMmlFactory.call(this, mmlFactory);
    this.mathml.setMmlFactory(mmlFactory);
  };
  Object.defineProperty(MathML.prototype, "processStrings", {
    get: function () {
      return false;
    },
    enumerable: false,
    configurable: true
  });
  MathML.prototype.compile = function (math, document) {
    var mml = math.start.node;
    if (!mml || !math.end.node || this.options['forceReparse'] || this.adaptor.kind(mml) === '#text') {
      var mathml = this.executeFilters(this.preFilters, math, document, (math.math || '<math></math>').trim());
      var doc = this.checkForErrors(this.adaptor.parse(mathml, 'text/' + this.options['parseAs']));
      var body = this.adaptor.body(doc);
      if (this.adaptor.childNodes(body).length !== 1) {
        this.error('MathML must consist of a single element');
      }
      mml = this.adaptor.remove(this.adaptor.firstChild(body));
      if (this.adaptor.kind(mml).replace(/^[a-z]+:/, '') !== 'math') {
        this.error('MathML must be formed by a <math> element, not <' + this.adaptor.kind(mml) + '>');
      }
    }
    mml = this.executeFilters(this.mmlFilters, math, document, mml);
    return this.executeFilters(this.postFilters, math, document, this.mathml.compile(mml));
  };
  MathML.prototype.checkForErrors = function (doc) {
    var err = this.adaptor.tags(this.adaptor.body(doc), 'parsererror')[0];
    if (err) {
      if (this.adaptor.textContent(err) === '') {
        this.error('Error processing MathML');
      }
      this.options['parseError'].call(this, err);
    }
    return doc;
  };
  MathML.prototype.error = function (message) {
    throw new Error(message);
  };
  MathML.prototype.findMath = function (node) {
    return this.findMathML.findMath(node);
  };
  MathML.NAME = 'MathML';
  MathML.OPTIONS = (0, Options_js_1$a.defaultOptions)({
    parseAs: 'html',
    forceReparse: false,
    FindMathML: null,
    MathMLCompile: null,
    parseError: function (node) {
      this.error(this.adaptor.textContent(node).replace(/\n.*/g, ''));
    }
  }, InputJax_js_1$1.AbstractInputJax.OPTIONS);
  return MathML;
})(InputJax_js_1$1.AbstractInputJax);
MathML_1 = mathml.MathML = MathML;

var tex$2 = {};

var FindTeX$1 = {};

var string = {};

var __read$R = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$u = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(string, "__esModule", {
  value: true
});
string.split = string.isPercent = string.unicodeString = string.unicodeChars = string.quotePattern = string.sortLength = void 0;
function sortLength(a, b) {
  return a.length !== b.length ? b.length - a.length : a === b ? 0 : a < b ? -1 : 1;
}
string.sortLength = sortLength;
function quotePattern(text) {
  return text.replace(/([\^$(){}+*?\-|\[\]\:\\])/g, '\\$1');
}
string.quotePattern = quotePattern;
function unicodeChars(text) {
  return Array.from(text).map(function (c) {
    return c.codePointAt(0);
  });
}
string.unicodeChars = unicodeChars;
function unicodeString(data) {
  return String.fromCodePoint.apply(String, __spreadArray$u([], __read$R(data), false));
}
string.unicodeString = unicodeString;
function isPercent(x) {
  return !!x.match(/%\s*$/);
}
string.isPercent = isPercent;
function split$1(x) {
  return x.trim().split(/\s+/);
}
string.split = split$1;

var MathItem = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.newState = exports.STATE = exports.AbstractMathItem = exports.protoItem = void 0;
  function protoItem(open, math, close, n, start, end, display) {
    if (display === void 0) {
      display = null;
    }
    var item = {
      open: open,
      math: math,
      close: close,
      n: n,
      start: {
        n: start
      },
      end: {
        n: end
      },
      display: display
    };
    return item;
  }
  exports.protoItem = protoItem;
  var AbstractMathItem = (function () {
    function AbstractMathItem(math, jax, display, start, end) {
      if (display === void 0) {
        display = true;
      }
      if (start === void 0) {
        start = {
          i: 0,
          n: 0,
          delim: ''
        };
      }
      if (end === void 0) {
        end = {
          i: 0,
          n: 0,
          delim: ''
        };
      }
      this.root = null;
      this.typesetRoot = null;
      this.metrics = {};
      this.inputData = {};
      this.outputData = {};
      this._state = exports.STATE.UNPROCESSED;
      this.math = math;
      this.inputJax = jax;
      this.display = display;
      this.start = start;
      this.end = end;
      this.root = null;
      this.typesetRoot = null;
      this.metrics = {};
      this.inputData = {};
      this.outputData = {};
    }
    Object.defineProperty(AbstractMathItem.prototype, "isEscaped", {
      get: function () {
        return this.display === null;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMathItem.prototype.render = function (document) {
      document.renderActions.renderMath(this, document);
    };
    AbstractMathItem.prototype.rerender = function (document, start) {
      if (start === void 0) {
        start = exports.STATE.RERENDER;
      }
      if (this.state() >= start) {
        this.state(start - 1);
      }
      document.renderActions.renderMath(this, document, start);
    };
    AbstractMathItem.prototype.convert = function (document, end) {
      if (end === void 0) {
        end = exports.STATE.LAST;
      }
      document.renderActions.renderConvert(this, document, end);
    };
    AbstractMathItem.prototype.compile = function (document) {
      if (this.state() < exports.STATE.COMPILED) {
        this.root = this.inputJax.compile(this, document);
        this.state(exports.STATE.COMPILED);
      }
    };
    AbstractMathItem.prototype.typeset = function (document) {
      if (this.state() < exports.STATE.TYPESET) {
        this.typesetRoot = document.outputJax[this.isEscaped ? 'escaped' : 'typeset'](this, document);
        this.state(exports.STATE.TYPESET);
      }
    };
    AbstractMathItem.prototype.updateDocument = function (_document) {};
    AbstractMathItem.prototype.removeFromDocument = function (_restore) {
    };
    AbstractMathItem.prototype.setMetrics = function (em, ex, cwidth, lwidth, scale) {
      this.metrics = {
        em: em,
        ex: ex,
        containerWidth: cwidth,
        lineWidth: lwidth,
        scale: scale
      };
    };
    AbstractMathItem.prototype.state = function (state, restore) {
      if (state === void 0) {
        state = null;
      }
      if (restore === void 0) {
        restore = false;
      }
      if (state != null) {
        if (state < exports.STATE.INSERTED && this._state >= exports.STATE.INSERTED) {
          this.removeFromDocument(restore);
        }
        if (state < exports.STATE.TYPESET && this._state >= exports.STATE.TYPESET) {
          this.outputData = {};
        }
        if (state < exports.STATE.COMPILED && this._state >= exports.STATE.COMPILED) {
          this.inputData = {};
        }
        this._state = state;
      }
      return this._state;
    };
    AbstractMathItem.prototype.reset = function (restore) {
      if (restore === void 0) {
        restore = false;
      }
      this.state(exports.STATE.UNPROCESSED, restore);
    };
    return AbstractMathItem;
  })();
  exports.AbstractMathItem = AbstractMathItem;
  exports.STATE = {
    UNPROCESSED: 0,
    FINDMATH: 10,
    COMPILED: 20,
    CONVERT: 100,
    METRICS: 110,
    RERENDER: 125,
    TYPESET: 150,
    INSERTED: 200,
    LAST: 10000
  };
  function newState(name, state) {
    if ((name in exports.STATE)) {
      throw Error('State ' + name + ' already exists');
    }
    exports.STATE[name] = state;
  }
  exports.newState = newState;
})(MathItem);
getDefaultExportFromCjs(MathItem);

var __extends$1R = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$Q = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(FindTeX$1, "__esModule", {
  value: true
});
FindTeX$1.FindTeX = void 0;
var FindMath_js_1 = FindMath;
var string_js_1$a = string;
var MathItem_js_1$3 = MathItem;
var FindTeX = (function (_super) {
  __extends$1R(FindTeX, _super);
  function FindTeX(options) {
    var _this = _super.call(this, options) || this;
    _this.getPatterns();
    return _this;
  }
  FindTeX.prototype.getPatterns = function () {
    var _this = this;
    var options = this.options;
    var starts = [], parts = [], subparts = [];
    this.end = {};
    this.env = this.sub = 0;
    var i = 1;
    options['inlineMath'].forEach(function (delims) {
      return _this.addPattern(starts, delims, false);
    });
    options['displayMath'].forEach(function (delims) {
      return _this.addPattern(starts, delims, true);
    });
    if (starts.length) {
      parts.push(starts.sort(string_js_1$a.sortLength).join('|'));
    }
    if (options['processEnvironments']) {
      parts.push('\\\\begin\\s*\\{([^}]*)\\}');
      this.env = i;
      i++;
    }
    if (options['processEscapes']) {
      subparts.push('\\\\([\\\\$])');
    }
    if (options['processRefs']) {
      subparts.push('(\\\\(?:eq)?ref\\s*\\{[^}]*\\})');
    }
    if (subparts.length) {
      parts.push('(' + subparts.join('|') + ')');
      this.sub = i;
    }
    this.start = new RegExp(parts.join('|'), 'g');
    this.hasPatterns = parts.length > 0;
  };
  FindTeX.prototype.addPattern = function (starts, delims, display) {
    var _a = __read$Q(delims, 2), open = _a[0], close = _a[1];
    starts.push((0, string_js_1$a.quotePattern)(open));
    this.end[open] = [close, display, this.endPattern(close)];
  };
  FindTeX.prototype.endPattern = function (end, endp) {
    return new RegExp((endp || (0, string_js_1$a.quotePattern)(end)) + '|\\\\(?:[a-zA-Z]|.)|[{}]', 'g');
  };
  FindTeX.prototype.findEnd = function (text, n, start, end) {
    var _a = __read$Q(end, 3), close = _a[0], display = _a[1], pattern = _a[2];
    var i = pattern.lastIndex = start.index + start[0].length;
    var match, braces = 0;
    while (match = pattern.exec(text)) {
      if ((match[1] || match[0]) === close && braces === 0) {
        return (0, MathItem_js_1$3.protoItem)(start[0], text.substr(i, match.index - i), match[0], n, start.index, match.index + match[0].length, display);
      } else if (match[0] === '{') {
        braces++;
      } else if (match[0] === '}' && braces) {
        braces--;
      }
    }
    return null;
  };
  FindTeX.prototype.findMathInString = function (math, n, text) {
    var start, match;
    this.start.lastIndex = 0;
    while (start = this.start.exec(text)) {
      if (start[this.env] !== undefined && this.env) {
        var end = '\\\\end\\s*(\\{' + (0, string_js_1$a.quotePattern)(start[this.env]) + '\\})';
        match = this.findEnd(text, n, start, ['{' + start[this.env] + '}', true, this.endPattern(null, end)]);
        if (match) {
          match.math = match.open + match.math + match.close;
          match.open = match.close = '';
        }
      } else if (start[this.sub] !== undefined && this.sub) {
        var math_1 = start[this.sub];
        var end = start.index + start[this.sub].length;
        if (math_1.length === 2) {
          match = (0, MathItem_js_1$3.protoItem)('', math_1.substr(1), '', n, start.index, end);
        } else {
          match = (0, MathItem_js_1$3.protoItem)('', math_1, '', n, start.index, end, false);
        }
      } else {
        match = this.findEnd(text, n, start, this.end[start[0]]);
      }
      if (match) {
        math.push(match);
        this.start.lastIndex = match.end.n;
      }
    }
  };
  FindTeX.prototype.findMath = function (strings) {
    var math = [];
    if (this.hasPatterns) {
      for (var i = 0, m = strings.length; i < m; i++) {
        this.findMathInString(math, i, strings[i]);
      }
    }
    return math;
  };
  FindTeX.OPTIONS = {
    inlineMath: [['\\(', '\\)']],
    displayMath: [['$$', '$$'], ['\\[', '\\]']],
    processEscapes: true,
    processEnvironments: true,
    processRefs: true
  };
  return FindTeX;
})(FindMath_js_1.AbstractFindMath);
FindTeX$1.FindTeX = FindTeX;

var FilterUtil$1 = {};

var NodeUtil$1 = {};

var mo$3 = {};

var OperatorDictionary = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.OPTABLE = exports.MMLSPACING = exports.getRange = exports.RANGES = exports.MO = exports.OPDEF = void 0;
  var MmlNode_js_1 = MmlNode;
  function OPDEF(lspace, rspace, texClass, properties) {
    if (texClass === void 0) {
      texClass = MmlNode_js_1.TEXCLASS.BIN;
    }
    if (properties === void 0) {
      properties = null;
    }
    return [lspace, rspace, texClass, properties];
  }
  exports.OPDEF = OPDEF;
  exports.MO = {
    ORD: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.ORD),
    ORD11: OPDEF(1, 1, MmlNode_js_1.TEXCLASS.ORD),
    ORD21: OPDEF(2, 1, MmlNode_js_1.TEXCLASS.ORD),
    ORD02: OPDEF(0, 2, MmlNode_js_1.TEXCLASS.ORD),
    ORD55: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.ORD),
    NONE: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.NONE),
    OP: OPDEF(1, 2, MmlNode_js_1.TEXCLASS.OP, {
      largeop: true,
      movablelimits: true,
      symmetric: true
    }),
    OPFIXED: OPDEF(1, 2, MmlNode_js_1.TEXCLASS.OP, {
      largeop: true,
      movablelimits: true
    }),
    INTEGRAL: OPDEF(0, 1, MmlNode_js_1.TEXCLASS.OP, {
      largeop: true,
      symmetric: true
    }),
    INTEGRAL2: OPDEF(1, 2, MmlNode_js_1.TEXCLASS.OP, {
      largeop: true,
      symmetric: true
    }),
    BIN3: OPDEF(3, 3, MmlNode_js_1.TEXCLASS.BIN),
    BIN4: OPDEF(4, 4, MmlNode_js_1.TEXCLASS.BIN),
    BIN01: OPDEF(0, 1, MmlNode_js_1.TEXCLASS.BIN),
    BIN5: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.BIN),
    TALLBIN: OPDEF(4, 4, MmlNode_js_1.TEXCLASS.BIN, {
      stretchy: true
    }),
    BINOP: OPDEF(4, 4, MmlNode_js_1.TEXCLASS.BIN, {
      largeop: true,
      movablelimits: true
    }),
    REL: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.REL),
    REL1: OPDEF(1, 1, MmlNode_js_1.TEXCLASS.REL, {
      stretchy: true
    }),
    REL4: OPDEF(4, 4, MmlNode_js_1.TEXCLASS.REL),
    RELSTRETCH: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.REL, {
      stretchy: true
    }),
    RELACCENT: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.REL, {
      accent: true
    }),
    WIDEREL: OPDEF(5, 5, MmlNode_js_1.TEXCLASS.REL, {
      accent: true,
      stretchy: true
    }),
    OPEN: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.OPEN, {
      fence: true,
      stretchy: true,
      symmetric: true
    }),
    CLOSE: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.CLOSE, {
      fence: true,
      stretchy: true,
      symmetric: true
    }),
    INNER: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.INNER),
    PUNCT: OPDEF(0, 3, MmlNode_js_1.TEXCLASS.PUNCT),
    ACCENT: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.ORD, {
      accent: true
    }),
    WIDEACCENT: OPDEF(0, 0, MmlNode_js_1.TEXCLASS.ORD, {
      accent: true,
      stretchy: true
    })
  };
  exports.RANGES = [[0x0020, 0x007F, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x00A0, 0x00BF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x00C0, 0x024F, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x02B0, 0x036F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x0370, 0x1A20, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x1AB0, 0x1AFF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x1B00, 0x1DBF, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x1DC0, 0x1DFF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x1E00, 0x1FFF, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x2000, 0x206F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2070, 0x209F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2100, 0x214F, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x2150, 0x218F, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x2190, 0x21FF, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x2200, 0x22FF, MmlNode_js_1.TEXCLASS.BIN, 'mo'], [0x2300, 0x23FF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2460, 0x24FF, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x2500, 0x27EF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x27F0, 0x27FF, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x2800, 0x28FF, MmlNode_js_1.TEXCLASS.ORD, 'mtext'], [0x2900, 0x297F, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x2980, 0x29FF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2A00, 0x2AFF, MmlNode_js_1.TEXCLASS.BIN, 'mo'], [0x2B00, 0x2B2F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2B30, 0x2B4F, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x2B50, 0x2BFF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2C00, 0x2DE0, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x2E00, 0x2E7F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x2E80, 0x2FDF, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normal'], [0x2FF0, 0x303F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x3040, 0xA49F, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normal'], [0xA4D0, 0xA82F, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0xA830, 0xA83F, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0xA840, 0xD7FF, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0xF900, 0xFAFF, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normal'], [0xFB00, 0xFDFF, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0xFE00, 0xFE6F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0xFE70, 0x100FF, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x10100, 0x1018F, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x10190, 0x123FF, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normal'], [0x12400, 0x1247F, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x12480, 0x1BC9F, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normal'], [0x1BCA0, 0x1D25F, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x1D360, 0x1D37F, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x1D400, 0x1D7CD, MmlNode_js_1.TEXCLASS.ORD, 'mi'], [0x1D7CE, 0x1D7FF, MmlNode_js_1.TEXCLASS.ORD, 'mn'], [0x1DF00, 0x1F7FF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x1F800, 0x1F8FF, MmlNode_js_1.TEXCLASS.REL, 'mo'], [0x1F900, 0x1F9FF, MmlNode_js_1.TEXCLASS.ORD, 'mo'], [0x20000, 0x2FA1F, MmlNode_js_1.TEXCLASS.ORD, 'mi', 'normnal']];
  function getRange(text) {
    var e_1, _a;
    var n = text.codePointAt(0);
    try {
      for (var RANGES_1 = __values(exports.RANGES), RANGES_1_1 = RANGES_1.next(); !RANGES_1_1.done; RANGES_1_1 = RANGES_1.next()) {
        var range = RANGES_1_1.value;
        if (n <= range[1]) {
          if (n >= range[0]) {
            return range;
          }
          break;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (RANGES_1_1 && !RANGES_1_1.done && (_a = RANGES_1.return)) _a.call(RANGES_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return null;
  }
  exports.getRange = getRange;
  exports.MMLSPACING = [[0, 0], [1, 2], [3, 3], [4, 4], [0, 0], [0, 0], [0, 3]];
  exports.OPTABLE = {
    prefix: {
      '(': exports.MO.OPEN,
      '+': exports.MO.BIN01,
      '-': exports.MO.BIN01,
      '[': exports.MO.OPEN,
      '{': exports.MO.OPEN,
      '|': exports.MO.OPEN,
      '||': [0, 0, MmlNode_js_1.TEXCLASS.BIN, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '|||': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '\u00AC': exports.MO.ORD21,
      '\u00B1': exports.MO.BIN01,
      '\u2016': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true
      }],
      '\u2018': [0, 0, MmlNode_js_1.TEXCLASS.OPEN, {
        fence: true
      }],
      '\u201C': [0, 0, MmlNode_js_1.TEXCLASS.OPEN, {
        fence: true
      }],
      '\u2145': exports.MO.ORD21,
      '\u2146': OPDEF(2, 0, MmlNode_js_1.TEXCLASS.ORD),
      '\u2200': exports.MO.ORD21,
      '\u2202': exports.MO.ORD21,
      '\u2203': exports.MO.ORD21,
      '\u2204': exports.MO.ORD21,
      '\u2207': exports.MO.ORD21,
      '\u220F': exports.MO.OP,
      '\u2210': exports.MO.OP,
      '\u2211': exports.MO.OP,
      '\u2212': exports.MO.BIN01,
      '\u2213': exports.MO.BIN01,
      '\u221A': [1, 1, MmlNode_js_1.TEXCLASS.ORD, {
        stretchy: true
      }],
      '\u221B': exports.MO.ORD11,
      '\u221C': exports.MO.ORD11,
      '\u2220': exports.MO.ORD,
      '\u2221': exports.MO.ORD,
      '\u2222': exports.MO.ORD,
      '\u222B': exports.MO.INTEGRAL,
      '\u222C': exports.MO.INTEGRAL,
      '\u222D': exports.MO.INTEGRAL,
      '\u222E': exports.MO.INTEGRAL,
      '\u222F': exports.MO.INTEGRAL,
      '\u2230': exports.MO.INTEGRAL,
      '\u2231': exports.MO.INTEGRAL,
      '\u2232': exports.MO.INTEGRAL,
      '\u2233': exports.MO.INTEGRAL,
      '\u22C0': exports.MO.OP,
      '\u22C1': exports.MO.OP,
      '\u22C2': exports.MO.OP,
      '\u22C3': exports.MO.OP,
      '\u2308': exports.MO.OPEN,
      '\u230A': exports.MO.OPEN,
      '\u2329': exports.MO.OPEN,
      '\u2772': exports.MO.OPEN,
      '\u27E6': exports.MO.OPEN,
      '\u27E8': exports.MO.OPEN,
      '\u27EA': exports.MO.OPEN,
      '\u27EC': exports.MO.OPEN,
      '\u27EE': exports.MO.OPEN,
      '\u2980': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true
      }],
      '\u2983': exports.MO.OPEN,
      '\u2985': exports.MO.OPEN,
      '\u2987': exports.MO.OPEN,
      '\u2989': exports.MO.OPEN,
      '\u298B': exports.MO.OPEN,
      '\u298D': exports.MO.OPEN,
      '\u298F': exports.MO.OPEN,
      '\u2991': exports.MO.OPEN,
      '\u2993': exports.MO.OPEN,
      '\u2995': exports.MO.OPEN,
      '\u2997': exports.MO.OPEN,
      '\u29FC': exports.MO.OPEN,
      '\u2A00': exports.MO.OP,
      '\u2A01': exports.MO.OP,
      '\u2A02': exports.MO.OP,
      '\u2A03': exports.MO.OP,
      '\u2A04': exports.MO.OP,
      '\u2A05': exports.MO.OP,
      '\u2A06': exports.MO.OP,
      '\u2A07': exports.MO.OP,
      '\u2A08': exports.MO.OP,
      '\u2A09': exports.MO.OP,
      '\u2A0A': exports.MO.OP,
      '\u2A0B': exports.MO.INTEGRAL2,
      '\u2A0C': exports.MO.INTEGRAL,
      '\u2A0D': exports.MO.INTEGRAL2,
      '\u2A0E': exports.MO.INTEGRAL2,
      '\u2A0F': exports.MO.INTEGRAL2,
      '\u2A10': exports.MO.OP,
      '\u2A11': exports.MO.OP,
      '\u2A12': exports.MO.OP,
      '\u2A13': exports.MO.OP,
      '\u2A14': exports.MO.OP,
      '\u2A15': exports.MO.INTEGRAL2,
      '\u2A16': exports.MO.INTEGRAL2,
      '\u2A17': exports.MO.INTEGRAL2,
      '\u2A18': exports.MO.INTEGRAL2,
      '\u2A19': exports.MO.INTEGRAL2,
      '\u2A1A': exports.MO.INTEGRAL2,
      '\u2A1B': exports.MO.INTEGRAL2,
      '\u2A1C': exports.MO.INTEGRAL2,
      '\u2AFC': exports.MO.OP,
      '\u2AFF': exports.MO.OP
    },
    postfix: {
      '!!': OPDEF(1, 0),
      '!': [1, 0, MmlNode_js_1.TEXCLASS.CLOSE, null],
      '"': exports.MO.ACCENT,
      '&': exports.MO.ORD,
      ')': exports.MO.CLOSE,
      '++': OPDEF(0, 0),
      '--': OPDEF(0, 0),
      '..': OPDEF(0, 0),
      '...': exports.MO.ORD,
      '\'': exports.MO.ACCENT,
      ']': exports.MO.CLOSE,
      '^': exports.MO.WIDEACCENT,
      '_': exports.MO.WIDEACCENT,
      '`': exports.MO.ACCENT,
      '|': exports.MO.CLOSE,
      '}': exports.MO.CLOSE,
      '~': exports.MO.WIDEACCENT,
      '||': [0, 0, MmlNode_js_1.TEXCLASS.BIN, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '|||': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '\u00A8': exports.MO.ACCENT,
      '\u00AA': exports.MO.ACCENT,
      '\u00AF': exports.MO.WIDEACCENT,
      '\u00B0': exports.MO.ORD,
      '\u00B2': exports.MO.ACCENT,
      '\u00B3': exports.MO.ACCENT,
      '\u00B4': exports.MO.ACCENT,
      '\u00B8': exports.MO.ACCENT,
      '\u00B9': exports.MO.ACCENT,
      '\u00BA': exports.MO.ACCENT,
      '\u02C6': exports.MO.WIDEACCENT,
      '\u02C7': exports.MO.WIDEACCENT,
      '\u02C9': exports.MO.WIDEACCENT,
      '\u02CA': exports.MO.ACCENT,
      '\u02CB': exports.MO.ACCENT,
      '\u02CD': exports.MO.WIDEACCENT,
      '\u02D8': exports.MO.ACCENT,
      '\u02D9': exports.MO.ACCENT,
      '\u02DA': exports.MO.ACCENT,
      '\u02DC': exports.MO.WIDEACCENT,
      '\u02DD': exports.MO.ACCENT,
      '\u02F7': exports.MO.WIDEACCENT,
      '\u0302': exports.MO.WIDEACCENT,
      '\u0311': exports.MO.ACCENT,
      '\u03F6': exports.MO.REL,
      '\u2016': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true
      }],
      '\u2019': [0, 0, MmlNode_js_1.TEXCLASS.CLOSE, {
        fence: true
      }],
      '\u201A': exports.MO.ACCENT,
      '\u201B': exports.MO.ACCENT,
      '\u201D': [0, 0, MmlNode_js_1.TEXCLASS.CLOSE, {
        fence: true
      }],
      '\u201E': exports.MO.ACCENT,
      '\u201F': exports.MO.ACCENT,
      '\u2032': exports.MO.ORD,
      '\u2033': exports.MO.ACCENT,
      '\u2034': exports.MO.ACCENT,
      '\u2035': exports.MO.ACCENT,
      '\u2036': exports.MO.ACCENT,
      '\u2037': exports.MO.ACCENT,
      '\u203E': exports.MO.WIDEACCENT,
      '\u2057': exports.MO.ACCENT,
      '\u20DB': exports.MO.ACCENT,
      '\u20DC': exports.MO.ACCENT,
      '\u2309': exports.MO.CLOSE,
      '\u230B': exports.MO.CLOSE,
      '\u232A': exports.MO.CLOSE,
      '\u23B4': exports.MO.WIDEACCENT,
      '\u23B5': exports.MO.WIDEACCENT,
      '\u23DC': exports.MO.WIDEACCENT,
      '\u23DD': exports.MO.WIDEACCENT,
      '\u23DE': exports.MO.WIDEACCENT,
      '\u23DF': exports.MO.WIDEACCENT,
      '\u23E0': exports.MO.WIDEACCENT,
      '\u23E1': exports.MO.WIDEACCENT,
      '\u25A0': exports.MO.BIN3,
      '\u25A1': exports.MO.BIN3,
      '\u25AA': exports.MO.BIN3,
      '\u25AB': exports.MO.BIN3,
      '\u25AD': exports.MO.BIN3,
      '\u25AE': exports.MO.BIN3,
      '\u25AF': exports.MO.BIN3,
      '\u25B0': exports.MO.BIN3,
      '\u25B1': exports.MO.BIN3,
      '\u25B2': exports.MO.BIN4,
      '\u25B4': exports.MO.BIN4,
      '\u25B6': exports.MO.BIN4,
      '\u25B7': exports.MO.BIN4,
      '\u25B8': exports.MO.BIN4,
      '\u25BC': exports.MO.BIN4,
      '\u25BE': exports.MO.BIN4,
      '\u25C0': exports.MO.BIN4,
      '\u25C1': exports.MO.BIN4,
      '\u25C2': exports.MO.BIN4,
      '\u25C4': exports.MO.BIN4,
      '\u25C5': exports.MO.BIN4,
      '\u25C6': exports.MO.BIN4,
      '\u25C7': exports.MO.BIN4,
      '\u25C8': exports.MO.BIN4,
      '\u25C9': exports.MO.BIN4,
      '\u25CC': exports.MO.BIN4,
      '\u25CD': exports.MO.BIN4,
      '\u25CE': exports.MO.BIN4,
      '\u25CF': exports.MO.BIN4,
      '\u25D6': exports.MO.BIN4,
      '\u25D7': exports.MO.BIN4,
      '\u25E6': exports.MO.BIN4,
      '\u266D': exports.MO.ORD02,
      '\u266E': exports.MO.ORD02,
      '\u266F': exports.MO.ORD02,
      '\u2773': exports.MO.CLOSE,
      '\u27E7': exports.MO.CLOSE,
      '\u27E9': exports.MO.CLOSE,
      '\u27EB': exports.MO.CLOSE,
      '\u27ED': exports.MO.CLOSE,
      '\u27EF': exports.MO.CLOSE,
      '\u2980': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true
      }],
      '\u2984': exports.MO.CLOSE,
      '\u2986': exports.MO.CLOSE,
      '\u2988': exports.MO.CLOSE,
      '\u298A': exports.MO.CLOSE,
      '\u298C': exports.MO.CLOSE,
      '\u298E': exports.MO.CLOSE,
      '\u2990': exports.MO.CLOSE,
      '\u2992': exports.MO.CLOSE,
      '\u2994': exports.MO.CLOSE,
      '\u2996': exports.MO.CLOSE,
      '\u2998': exports.MO.CLOSE,
      '\u29FD': exports.MO.CLOSE
    },
    infix: {
      '!=': exports.MO.BIN4,
      '#': exports.MO.ORD,
      '$': exports.MO.ORD,
      '%': [3, 3, MmlNode_js_1.TEXCLASS.ORD, null],
      '&&': exports.MO.BIN4,
      '': exports.MO.ORD,
      '*': exports.MO.BIN3,
      '**': OPDEF(1, 1),
      '*=': exports.MO.BIN4,
      '+': exports.MO.BIN4,
      '+=': exports.MO.BIN4,
      ',': [0, 3, MmlNode_js_1.TEXCLASS.PUNCT, {
        linebreakstyle: 'after',
        separator: true
      }],
      '-': exports.MO.BIN4,
      '-=': exports.MO.BIN4,
      '->': exports.MO.BIN5,
      '.': [0, 3, MmlNode_js_1.TEXCLASS.PUNCT, {
        separator: true
      }],
      '/': exports.MO.ORD11,
      '//': OPDEF(1, 1),
      '/=': exports.MO.BIN4,
      ':': [1, 2, MmlNode_js_1.TEXCLASS.REL, null],
      ':=': exports.MO.BIN4,
      ';': [0, 3, MmlNode_js_1.TEXCLASS.PUNCT, {
        linebreakstyle: 'after',
        separator: true
      }],
      '<': exports.MO.REL,
      '<=': exports.MO.BIN5,
      '<>': OPDEF(1, 1),
      '=': exports.MO.REL,
      '==': exports.MO.BIN4,
      '>': exports.MO.REL,
      '>=': exports.MO.BIN5,
      '?': [1, 1, MmlNode_js_1.TEXCLASS.CLOSE, null],
      '@': exports.MO.ORD11,
      '\\': exports.MO.ORD,
      '^': exports.MO.ORD11,
      '_': exports.MO.ORD11,
      '|': [2, 2, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '||': [2, 2, MmlNode_js_1.TEXCLASS.BIN, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '|||': [2, 2, MmlNode_js_1.TEXCLASS.ORD, {
        fence: true,
        stretchy: true,
        symmetric: true
      }],
      '\u00B1': exports.MO.BIN4,
      '\u00B7': exports.MO.BIN4,
      '\u00D7': exports.MO.BIN4,
      '\u00F7': exports.MO.BIN4,
      '\u02B9': exports.MO.ORD,
      '\u0300': exports.MO.ACCENT,
      '\u0301': exports.MO.ACCENT,
      '\u0303': exports.MO.WIDEACCENT,
      '\u0304': exports.MO.ACCENT,
      '\u0306': exports.MO.ACCENT,
      '\u0307': exports.MO.ACCENT,
      '\u0308': exports.MO.ACCENT,
      '\u030C': exports.MO.ACCENT,
      '\u0332': exports.MO.WIDEACCENT,
      '\u0338': exports.MO.REL4,
      '\u2015': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        stretchy: true
      }],
      '\u2017': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        stretchy: true
      }],
      '\u2020': exports.MO.BIN3,
      '\u2021': exports.MO.BIN3,
      '\u2022': exports.MO.BIN4,
      '\u2026': exports.MO.INNER,
      '\u2043': exports.MO.BIN4,
      '\u2044': exports.MO.TALLBIN,
      '\u2061': exports.MO.NONE,
      '\u2062': exports.MO.NONE,
      '\u2063': [0, 0, MmlNode_js_1.TEXCLASS.NONE, {
        linebreakstyle: 'after',
        separator: true
      }],
      '\u2064': exports.MO.NONE,
      '\u20D7': exports.MO.ACCENT,
      '\u2111': exports.MO.ORD,
      '\u2113': exports.MO.ORD,
      '\u2118': exports.MO.ORD,
      '\u211C': exports.MO.ORD,
      '\u2190': exports.MO.WIDEREL,
      '\u2191': exports.MO.RELSTRETCH,
      '\u2192': exports.MO.WIDEREL,
      '\u2193': exports.MO.RELSTRETCH,
      '\u2194': exports.MO.WIDEREL,
      '\u2195': exports.MO.RELSTRETCH,
      '\u2196': exports.MO.RELSTRETCH,
      '\u2197': exports.MO.RELSTRETCH,
      '\u2198': exports.MO.RELSTRETCH,
      '\u2199': exports.MO.RELSTRETCH,
      '\u219A': exports.MO.RELACCENT,
      '\u219B': exports.MO.RELACCENT,
      '\u219C': exports.MO.WIDEREL,
      '\u219D': exports.MO.WIDEREL,
      '\u219E': exports.MO.WIDEREL,
      '\u219F': exports.MO.WIDEREL,
      '\u21A0': exports.MO.WIDEREL,
      '\u21A1': exports.MO.RELSTRETCH,
      '\u21A2': exports.MO.WIDEREL,
      '\u21A3': exports.MO.WIDEREL,
      '\u21A4': exports.MO.WIDEREL,
      '\u21A5': exports.MO.RELSTRETCH,
      '\u21A6': exports.MO.WIDEREL,
      '\u21A7': exports.MO.RELSTRETCH,
      '\u21A8': exports.MO.RELSTRETCH,
      '\u21A9': exports.MO.WIDEREL,
      '\u21AA': exports.MO.WIDEREL,
      '\u21AB': exports.MO.WIDEREL,
      '\u21AC': exports.MO.WIDEREL,
      '\u21AD': exports.MO.WIDEREL,
      '\u21AE': exports.MO.RELACCENT,
      '\u21AF': exports.MO.RELSTRETCH,
      '\u21B0': exports.MO.RELSTRETCH,
      '\u21B1': exports.MO.RELSTRETCH,
      '\u21B2': exports.MO.RELSTRETCH,
      '\u21B3': exports.MO.RELSTRETCH,
      '\u21B4': exports.MO.RELSTRETCH,
      '\u21B5': exports.MO.RELSTRETCH,
      '\u21B6': exports.MO.RELACCENT,
      '\u21B7': exports.MO.RELACCENT,
      '\u21B8': exports.MO.REL,
      '\u21B9': exports.MO.WIDEREL,
      '\u21BA': exports.MO.REL,
      '\u21BB': exports.MO.REL,
      '\u21BC': exports.MO.WIDEREL,
      '\u21BD': exports.MO.WIDEREL,
      '\u21BE': exports.MO.RELSTRETCH,
      '\u21BF': exports.MO.RELSTRETCH,
      '\u21C0': exports.MO.WIDEREL,
      '\u21C1': exports.MO.WIDEREL,
      '\u21C2': exports.MO.RELSTRETCH,
      '\u21C3': exports.MO.RELSTRETCH,
      '\u21C4': exports.MO.WIDEREL,
      '\u21C5': exports.MO.RELSTRETCH,
      '\u21C6': exports.MO.WIDEREL,
      '\u21C7': exports.MO.WIDEREL,
      '\u21C8': exports.MO.RELSTRETCH,
      '\u21C9': exports.MO.WIDEREL,
      '\u21CA': exports.MO.RELSTRETCH,
      '\u21CB': exports.MO.WIDEREL,
      '\u21CC': exports.MO.WIDEREL,
      '\u21CD': exports.MO.RELACCENT,
      '\u21CE': exports.MO.RELACCENT,
      '\u21CF': exports.MO.RELACCENT,
      '\u21D0': exports.MO.WIDEREL,
      '\u21D1': exports.MO.RELSTRETCH,
      '\u21D2': exports.MO.WIDEREL,
      '\u21D3': exports.MO.RELSTRETCH,
      '\u21D4': exports.MO.WIDEREL,
      '\u21D5': exports.MO.RELSTRETCH,
      '\u21D6': exports.MO.RELSTRETCH,
      '\u21D7': exports.MO.RELSTRETCH,
      '\u21D8': exports.MO.RELSTRETCH,
      '\u21D9': exports.MO.RELSTRETCH,
      '\u21DA': exports.MO.WIDEREL,
      '\u21DB': exports.MO.WIDEREL,
      '\u21DC': exports.MO.WIDEREL,
      '\u21DD': exports.MO.WIDEREL,
      '\u21DE': exports.MO.REL,
      '\u21DF': exports.MO.REL,
      '\u21E0': exports.MO.WIDEREL,
      '\u21E1': exports.MO.RELSTRETCH,
      '\u21E2': exports.MO.WIDEREL,
      '\u21E3': exports.MO.RELSTRETCH,
      '\u21E4': exports.MO.WIDEREL,
      '\u21E5': exports.MO.WIDEREL,
      '\u21E6': exports.MO.WIDEREL,
      '\u21E7': exports.MO.RELSTRETCH,
      '\u21E8': exports.MO.WIDEREL,
      '\u21E9': exports.MO.RELSTRETCH,
      '\u21EA': exports.MO.RELSTRETCH,
      '\u21EB': exports.MO.RELSTRETCH,
      '\u21EC': exports.MO.RELSTRETCH,
      '\u21ED': exports.MO.RELSTRETCH,
      '\u21EE': exports.MO.RELSTRETCH,
      '\u21EF': exports.MO.RELSTRETCH,
      '\u21F0': exports.MO.WIDEREL,
      '\u21F1': exports.MO.REL,
      '\u21F2': exports.MO.REL,
      '\u21F3': exports.MO.RELSTRETCH,
      '\u21F4': exports.MO.RELACCENT,
      '\u21F5': exports.MO.RELSTRETCH,
      '\u21F6': exports.MO.WIDEREL,
      '\u21F7': exports.MO.RELACCENT,
      '\u21F8': exports.MO.RELACCENT,
      '\u21F9': exports.MO.RELACCENT,
      '\u21FA': exports.MO.RELACCENT,
      '\u21FB': exports.MO.RELACCENT,
      '\u21FC': exports.MO.RELACCENT,
      '\u21FD': exports.MO.WIDEREL,
      '\u21FE': exports.MO.WIDEREL,
      '\u21FF': exports.MO.WIDEREL,
      '\u2201': OPDEF(1, 2, MmlNode_js_1.TEXCLASS.ORD),
      '\u2205': exports.MO.ORD,
      '\u2206': exports.MO.BIN3,
      '\u2208': exports.MO.REL,
      '\u2209': exports.MO.REL,
      '\u220A': exports.MO.REL,
      '\u220B': exports.MO.REL,
      '\u220C': exports.MO.REL,
      '\u220D': exports.MO.REL,
      '\u220E': exports.MO.BIN3,
      '\u2212': exports.MO.BIN4,
      '\u2213': exports.MO.BIN4,
      '\u2214': exports.MO.BIN4,
      '\u2215': exports.MO.TALLBIN,
      '\u2216': exports.MO.BIN4,
      '\u2217': exports.MO.BIN4,
      '\u2218': exports.MO.BIN4,
      '\u2219': exports.MO.BIN4,
      '\u221D': exports.MO.REL,
      '\u221E': exports.MO.ORD,
      '\u221F': exports.MO.REL,
      '\u2223': exports.MO.REL,
      '\u2224': exports.MO.REL,
      '\u2225': exports.MO.REL,
      '\u2226': exports.MO.REL,
      '\u2227': exports.MO.BIN4,
      '\u2228': exports.MO.BIN4,
      '\u2229': exports.MO.BIN4,
      '\u222A': exports.MO.BIN4,
      '\u2234': exports.MO.REL,
      '\u2235': exports.MO.REL,
      '\u2236': exports.MO.REL,
      '\u2237': exports.MO.REL,
      '\u2238': exports.MO.BIN4,
      '\u2239': exports.MO.REL,
      '\u223A': exports.MO.BIN4,
      '\u223B': exports.MO.REL,
      '\u223C': exports.MO.REL,
      '\u223D': exports.MO.REL,
      '\u223D\u0331': exports.MO.BIN3,
      '\u223E': exports.MO.REL,
      '\u223F': exports.MO.BIN3,
      '\u2240': exports.MO.BIN4,
      '\u2241': exports.MO.REL,
      '\u2242': exports.MO.REL,
      '\u2242\u0338': exports.MO.REL,
      '\u2243': exports.MO.REL,
      '\u2244': exports.MO.REL,
      '\u2245': exports.MO.REL,
      '\u2246': exports.MO.REL,
      '\u2247': exports.MO.REL,
      '\u2248': exports.MO.REL,
      '\u2249': exports.MO.REL,
      '\u224A': exports.MO.REL,
      '\u224B': exports.MO.REL,
      '\u224C': exports.MO.REL,
      '\u224D': exports.MO.REL,
      '\u224E': exports.MO.REL,
      '\u224E\u0338': exports.MO.REL,
      '\u224F': exports.MO.REL,
      '\u224F\u0338': exports.MO.REL,
      '\u2250': exports.MO.REL,
      '\u2251': exports.MO.REL,
      '\u2252': exports.MO.REL,
      '\u2253': exports.MO.REL,
      '\u2254': exports.MO.REL,
      '\u2255': exports.MO.REL,
      '\u2256': exports.MO.REL,
      '\u2257': exports.MO.REL,
      '\u2258': exports.MO.REL,
      '\u2259': exports.MO.REL,
      '\u225A': exports.MO.REL,
      '\u225B': exports.MO.REL,
      '\u225C': exports.MO.REL,
      '\u225D': exports.MO.REL,
      '\u225E': exports.MO.REL,
      '\u225F': exports.MO.REL,
      '\u2260': exports.MO.REL,
      '\u2261': exports.MO.REL,
      '\u2262': exports.MO.REL,
      '\u2263': exports.MO.REL,
      '\u2264': exports.MO.REL,
      '\u2265': exports.MO.REL,
      '\u2266': exports.MO.REL,
      '\u2266\u0338': exports.MO.REL,
      '\u2267': exports.MO.REL,
      '\u2268': exports.MO.REL,
      '\u2269': exports.MO.REL,
      '\u226A': exports.MO.REL,
      '\u226A\u0338': exports.MO.REL,
      '\u226B': exports.MO.REL,
      '\u226B\u0338': exports.MO.REL,
      '\u226C': exports.MO.REL,
      '\u226D': exports.MO.REL,
      '\u226E': exports.MO.REL,
      '\u226F': exports.MO.REL,
      '\u2270': exports.MO.REL,
      '\u2271': exports.MO.REL,
      '\u2272': exports.MO.REL,
      '\u2273': exports.MO.REL,
      '\u2274': exports.MO.REL,
      '\u2275': exports.MO.REL,
      '\u2276': exports.MO.REL,
      '\u2277': exports.MO.REL,
      '\u2278': exports.MO.REL,
      '\u2279': exports.MO.REL,
      '\u227A': exports.MO.REL,
      '\u227B': exports.MO.REL,
      '\u227C': exports.MO.REL,
      '\u227D': exports.MO.REL,
      '\u227E': exports.MO.REL,
      '\u227F': exports.MO.REL,
      '\u227F\u0338': exports.MO.REL,
      '\u2280': exports.MO.REL,
      '\u2281': exports.MO.REL,
      '\u2282': exports.MO.REL,
      '\u2282\u20D2': exports.MO.REL,
      '\u2283': exports.MO.REL,
      '\u2283\u20D2': exports.MO.REL,
      '\u2284': exports.MO.REL,
      '\u2285': exports.MO.REL,
      '\u2286': exports.MO.REL,
      '\u2287': exports.MO.REL,
      '\u2288': exports.MO.REL,
      '\u2289': exports.MO.REL,
      '\u228A': exports.MO.REL,
      '\u228B': exports.MO.REL,
      '\u228C': exports.MO.BIN4,
      '\u228D': exports.MO.BIN4,
      '\u228E': exports.MO.BIN4,
      '\u228F': exports.MO.REL,
      '\u228F\u0338': exports.MO.REL,
      '\u2290': exports.MO.REL,
      '\u2290\u0338': exports.MO.REL,
      '\u2291': exports.MO.REL,
      '\u2292': exports.MO.REL,
      '\u2293': exports.MO.BIN4,
      '\u2294': exports.MO.BIN4,
      '\u2295': exports.MO.BIN4,
      '\u2296': exports.MO.BIN4,
      '\u2297': exports.MO.BIN4,
      '\u2298': exports.MO.BIN4,
      '\u2299': exports.MO.BIN4,
      '\u229A': exports.MO.BIN4,
      '\u229B': exports.MO.BIN4,
      '\u229C': exports.MO.BIN4,
      '\u229D': exports.MO.BIN4,
      '\u229E': exports.MO.BIN4,
      '\u229F': exports.MO.BIN4,
      '\u22A0': exports.MO.BIN4,
      '\u22A1': exports.MO.BIN4,
      '\u22A2': exports.MO.REL,
      '\u22A3': exports.MO.REL,
      '\u22A4': exports.MO.ORD55,
      '\u22A5': exports.MO.REL,
      '\u22A6': exports.MO.REL,
      '\u22A7': exports.MO.REL,
      '\u22A8': exports.MO.REL,
      '\u22A9': exports.MO.REL,
      '\u22AA': exports.MO.REL,
      '\u22AB': exports.MO.REL,
      '\u22AC': exports.MO.REL,
      '\u22AD': exports.MO.REL,
      '\u22AE': exports.MO.REL,
      '\u22AF': exports.MO.REL,
      '\u22B0': exports.MO.REL,
      '\u22B1': exports.MO.REL,
      '\u22B2': exports.MO.REL,
      '\u22B3': exports.MO.REL,
      '\u22B4': exports.MO.REL,
      '\u22B5': exports.MO.REL,
      '\u22B6': exports.MO.REL,
      '\u22B7': exports.MO.REL,
      '\u22B8': exports.MO.REL,
      '\u22B9': exports.MO.REL,
      '\u22BA': exports.MO.BIN4,
      '\u22BB': exports.MO.BIN4,
      '\u22BC': exports.MO.BIN4,
      '\u22BD': exports.MO.BIN4,
      '\u22BE': exports.MO.BIN3,
      '\u22BF': exports.MO.BIN3,
      '\u22C4': exports.MO.BIN4,
      '\u22C5': exports.MO.BIN4,
      '\u22C6': exports.MO.BIN4,
      '\u22C7': exports.MO.BIN4,
      '\u22C8': exports.MO.REL,
      '\u22C9': exports.MO.BIN4,
      '\u22CA': exports.MO.BIN4,
      '\u22CB': exports.MO.BIN4,
      '\u22CC': exports.MO.BIN4,
      '\u22CD': exports.MO.REL,
      '\u22CE': exports.MO.BIN4,
      '\u22CF': exports.MO.BIN4,
      '\u22D0': exports.MO.REL,
      '\u22D1': exports.MO.REL,
      '\u22D2': exports.MO.BIN4,
      '\u22D3': exports.MO.BIN4,
      '\u22D4': exports.MO.REL,
      '\u22D5': exports.MO.REL,
      '\u22D6': exports.MO.REL,
      '\u22D7': exports.MO.REL,
      '\u22D8': exports.MO.REL,
      '\u22D9': exports.MO.REL,
      '\u22DA': exports.MO.REL,
      '\u22DB': exports.MO.REL,
      '\u22DC': exports.MO.REL,
      '\u22DD': exports.MO.REL,
      '\u22DE': exports.MO.REL,
      '\u22DF': exports.MO.REL,
      '\u22E0': exports.MO.REL,
      '\u22E1': exports.MO.REL,
      '\u22E2': exports.MO.REL,
      '\u22E3': exports.MO.REL,
      '\u22E4': exports.MO.REL,
      '\u22E5': exports.MO.REL,
      '\u22E6': exports.MO.REL,
      '\u22E7': exports.MO.REL,
      '\u22E8': exports.MO.REL,
      '\u22E9': exports.MO.REL,
      '\u22EA': exports.MO.REL,
      '\u22EB': exports.MO.REL,
      '\u22EC': exports.MO.REL,
      '\u22ED': exports.MO.REL,
      '\u22EE': exports.MO.ORD55,
      '\u22EF': exports.MO.INNER,
      '\u22F0': exports.MO.REL,
      '\u22F1': [5, 5, MmlNode_js_1.TEXCLASS.INNER, null],
      '\u22F2': exports.MO.REL,
      '\u22F3': exports.MO.REL,
      '\u22F4': exports.MO.REL,
      '\u22F5': exports.MO.REL,
      '\u22F6': exports.MO.REL,
      '\u22F7': exports.MO.REL,
      '\u22F8': exports.MO.REL,
      '\u22F9': exports.MO.REL,
      '\u22FA': exports.MO.REL,
      '\u22FB': exports.MO.REL,
      '\u22FC': exports.MO.REL,
      '\u22FD': exports.MO.REL,
      '\u22FE': exports.MO.REL,
      '\u22FF': exports.MO.REL,
      '\u2305': exports.MO.BIN3,
      '\u2306': exports.MO.BIN3,
      '\u2322': exports.MO.REL4,
      '\u2323': exports.MO.REL4,
      '\u2329': exports.MO.OPEN,
      '\u232A': exports.MO.CLOSE,
      '\u23AA': exports.MO.ORD,
      '\u23AF': [0, 0, MmlNode_js_1.TEXCLASS.ORD, {
        stretchy: true
      }],
      '\u23B0': exports.MO.OPEN,
      '\u23B1': exports.MO.CLOSE,
      '\u2500': exports.MO.ORD,
      '\u25B3': exports.MO.BIN4,
      '\u25B5': exports.MO.BIN4,
      '\u25B9': exports.MO.BIN4,
      '\u25BD': exports.MO.BIN4,
      '\u25BF': exports.MO.BIN4,
      '\u25C3': exports.MO.BIN4,
      '\u25EF': exports.MO.BIN3,
      '\u2660': exports.MO.ORD,
      '\u2661': exports.MO.ORD,
      '\u2662': exports.MO.ORD,
      '\u2663': exports.MO.ORD,
      '\u2758': exports.MO.REL,
      '\u27F0': exports.MO.RELSTRETCH,
      '\u27F1': exports.MO.RELSTRETCH,
      '\u27F5': exports.MO.WIDEREL,
      '\u27F6': exports.MO.WIDEREL,
      '\u27F7': exports.MO.WIDEREL,
      '\u27F8': exports.MO.WIDEREL,
      '\u27F9': exports.MO.WIDEREL,
      '\u27FA': exports.MO.WIDEREL,
      '\u27FB': exports.MO.WIDEREL,
      '\u27FC': exports.MO.WIDEREL,
      '\u27FD': exports.MO.WIDEREL,
      '\u27FE': exports.MO.WIDEREL,
      '\u27FF': exports.MO.WIDEREL,
      '\u2900': exports.MO.RELACCENT,
      '\u2901': exports.MO.RELACCENT,
      '\u2902': exports.MO.RELACCENT,
      '\u2903': exports.MO.RELACCENT,
      '\u2904': exports.MO.RELACCENT,
      '\u2905': exports.MO.RELACCENT,
      '\u2906': exports.MO.RELACCENT,
      '\u2907': exports.MO.RELACCENT,
      '\u2908': exports.MO.REL,
      '\u2909': exports.MO.REL,
      '\u290A': exports.MO.RELSTRETCH,
      '\u290B': exports.MO.RELSTRETCH,
      '\u290C': exports.MO.WIDEREL,
      '\u290D': exports.MO.WIDEREL,
      '\u290E': exports.MO.WIDEREL,
      '\u290F': exports.MO.WIDEREL,
      '\u2910': exports.MO.WIDEREL,
      '\u2911': exports.MO.RELACCENT,
      '\u2912': exports.MO.RELSTRETCH,
      '\u2913': exports.MO.RELSTRETCH,
      '\u2914': exports.MO.RELACCENT,
      '\u2915': exports.MO.RELACCENT,
      '\u2916': exports.MO.RELACCENT,
      '\u2917': exports.MO.RELACCENT,
      '\u2918': exports.MO.RELACCENT,
      '\u2919': exports.MO.RELACCENT,
      '\u291A': exports.MO.RELACCENT,
      '\u291B': exports.MO.RELACCENT,
      '\u291C': exports.MO.RELACCENT,
      '\u291D': exports.MO.RELACCENT,
      '\u291E': exports.MO.RELACCENT,
      '\u291F': exports.MO.RELACCENT,
      '\u2920': exports.MO.RELACCENT,
      '\u2921': exports.MO.RELSTRETCH,
      '\u2922': exports.MO.RELSTRETCH,
      '\u2923': exports.MO.REL,
      '\u2924': exports.MO.REL,
      '\u2925': exports.MO.REL,
      '\u2926': exports.MO.REL,
      '\u2927': exports.MO.REL,
      '\u2928': exports.MO.REL,
      '\u2929': exports.MO.REL,
      '\u292A': exports.MO.REL,
      '\u292B': exports.MO.REL,
      '\u292C': exports.MO.REL,
      '\u292D': exports.MO.REL,
      '\u292E': exports.MO.REL,
      '\u292F': exports.MO.REL,
      '\u2930': exports.MO.REL,
      '\u2931': exports.MO.REL,
      '\u2932': exports.MO.REL,
      '\u2933': exports.MO.RELACCENT,
      '\u2934': exports.MO.REL,
      '\u2935': exports.MO.REL,
      '\u2936': exports.MO.REL,
      '\u2937': exports.MO.REL,
      '\u2938': exports.MO.REL,
      '\u2939': exports.MO.REL,
      '\u293A': exports.MO.RELACCENT,
      '\u293B': exports.MO.RELACCENT,
      '\u293C': exports.MO.RELACCENT,
      '\u293D': exports.MO.RELACCENT,
      '\u293E': exports.MO.REL,
      '\u293F': exports.MO.REL,
      '\u2940': exports.MO.REL,
      '\u2941': exports.MO.REL,
      '\u2942': exports.MO.RELACCENT,
      '\u2943': exports.MO.RELACCENT,
      '\u2944': exports.MO.RELACCENT,
      '\u2945': exports.MO.RELACCENT,
      '\u2946': exports.MO.RELACCENT,
      '\u2947': exports.MO.RELACCENT,
      '\u2948': exports.MO.RELACCENT,
      '\u2949': exports.MO.REL,
      '\u294A': exports.MO.RELACCENT,
      '\u294B': exports.MO.RELACCENT,
      '\u294C': exports.MO.REL,
      '\u294D': exports.MO.REL,
      '\u294E': exports.MO.WIDEREL,
      '\u294F': exports.MO.RELSTRETCH,
      '\u2950': exports.MO.WIDEREL,
      '\u2951': exports.MO.RELSTRETCH,
      '\u2952': exports.MO.WIDEREL,
      '\u2953': exports.MO.WIDEREL,
      '\u2954': exports.MO.RELSTRETCH,
      '\u2955': exports.MO.RELSTRETCH,
      '\u2956': exports.MO.RELSTRETCH,
      '\u2957': exports.MO.RELSTRETCH,
      '\u2958': exports.MO.RELSTRETCH,
      '\u2959': exports.MO.RELSTRETCH,
      '\u295A': exports.MO.WIDEREL,
      '\u295B': exports.MO.WIDEREL,
      '\u295C': exports.MO.RELSTRETCH,
      '\u295D': exports.MO.RELSTRETCH,
      '\u295E': exports.MO.WIDEREL,
      '\u295F': exports.MO.WIDEREL,
      '\u2960': exports.MO.RELSTRETCH,
      '\u2961': exports.MO.RELSTRETCH,
      '\u2962': exports.MO.RELACCENT,
      '\u2963': exports.MO.REL,
      '\u2964': exports.MO.RELACCENT,
      '\u2965': exports.MO.REL,
      '\u2966': exports.MO.RELACCENT,
      '\u2967': exports.MO.RELACCENT,
      '\u2968': exports.MO.RELACCENT,
      '\u2969': exports.MO.RELACCENT,
      '\u296A': exports.MO.RELACCENT,
      '\u296B': exports.MO.RELACCENT,
      '\u296C': exports.MO.RELACCENT,
      '\u296D': exports.MO.RELACCENT,
      '\u296E': exports.MO.RELSTRETCH,
      '\u296F': exports.MO.RELSTRETCH,
      '\u2970': exports.MO.RELACCENT,
      '\u2971': exports.MO.RELACCENT,
      '\u2972': exports.MO.RELACCENT,
      '\u2973': exports.MO.RELACCENT,
      '\u2974': exports.MO.RELACCENT,
      '\u2975': exports.MO.RELACCENT,
      '\u2976': exports.MO.RELACCENT,
      '\u2977': exports.MO.RELACCENT,
      '\u2978': exports.MO.RELACCENT,
      '\u2979': exports.MO.RELACCENT,
      '\u297A': exports.MO.RELACCENT,
      '\u297B': exports.MO.RELACCENT,
      '\u297C': exports.MO.RELACCENT,
      '\u297D': exports.MO.RELACCENT,
      '\u297E': exports.MO.REL,
      '\u297F': exports.MO.REL,
      '\u2981': exports.MO.BIN3,
      '\u2982': exports.MO.BIN3,
      '\u2999': exports.MO.BIN3,
      '\u299A': exports.MO.BIN3,
      '\u299B': exports.MO.BIN3,
      '\u299C': exports.MO.BIN3,
      '\u299D': exports.MO.BIN3,
      '\u299E': exports.MO.BIN3,
      '\u299F': exports.MO.BIN3,
      '\u29A0': exports.MO.BIN3,
      '\u29A1': exports.MO.BIN3,
      '\u29A2': exports.MO.BIN3,
      '\u29A3': exports.MO.BIN3,
      '\u29A4': exports.MO.BIN3,
      '\u29A5': exports.MO.BIN3,
      '\u29A6': exports.MO.BIN3,
      '\u29A7': exports.MO.BIN3,
      '\u29A8': exports.MO.BIN3,
      '\u29A9': exports.MO.BIN3,
      '\u29AA': exports.MO.BIN3,
      '\u29AB': exports.MO.BIN3,
      '\u29AC': exports.MO.BIN3,
      '\u29AD': exports.MO.BIN3,
      '\u29AE': exports.MO.BIN3,
      '\u29AF': exports.MO.BIN3,
      '\u29B0': exports.MO.BIN3,
      '\u29B1': exports.MO.BIN3,
      '\u29B2': exports.MO.BIN3,
      '\u29B3': exports.MO.BIN3,
      '\u29B4': exports.MO.BIN3,
      '\u29B5': exports.MO.BIN3,
      '\u29B6': exports.MO.BIN4,
      '\u29B7': exports.MO.BIN4,
      '\u29B8': exports.MO.BIN4,
      '\u29B9': exports.MO.BIN4,
      '\u29BA': exports.MO.BIN4,
      '\u29BB': exports.MO.BIN4,
      '\u29BC': exports.MO.BIN4,
      '\u29BD': exports.MO.BIN4,
      '\u29BE': exports.MO.BIN4,
      '\u29BF': exports.MO.BIN4,
      '\u29C0': exports.MO.REL,
      '\u29C1': exports.MO.REL,
      '\u29C2': exports.MO.BIN3,
      '\u29C3': exports.MO.BIN3,
      '\u29C4': exports.MO.BIN4,
      '\u29C5': exports.MO.BIN4,
      '\u29C6': exports.MO.BIN4,
      '\u29C7': exports.MO.BIN4,
      '\u29C8': exports.MO.BIN4,
      '\u29C9': exports.MO.BIN3,
      '\u29CA': exports.MO.BIN3,
      '\u29CB': exports.MO.BIN3,
      '\u29CC': exports.MO.BIN3,
      '\u29CD': exports.MO.BIN3,
      '\u29CE': exports.MO.REL,
      '\u29CF': exports.MO.REL,
      '\u29CF\u0338': exports.MO.REL,
      '\u29D0': exports.MO.REL,
      '\u29D0\u0338': exports.MO.REL,
      '\u29D1': exports.MO.REL,
      '\u29D2': exports.MO.REL,
      '\u29D3': exports.MO.REL,
      '\u29D4': exports.MO.REL,
      '\u29D5': exports.MO.REL,
      '\u29D6': exports.MO.BIN4,
      '\u29D7': exports.MO.BIN4,
      '\u29D8': exports.MO.BIN3,
      '\u29D9': exports.MO.BIN3,
      '\u29DB': exports.MO.BIN3,
      '\u29DC': exports.MO.BIN3,
      '\u29DD': exports.MO.BIN3,
      '\u29DE': exports.MO.REL,
      '\u29DF': exports.MO.BIN3,
      '\u29E0': exports.MO.BIN3,
      '\u29E1': exports.MO.REL,
      '\u29E2': exports.MO.BIN4,
      '\u29E3': exports.MO.REL,
      '\u29E4': exports.MO.REL,
      '\u29E5': exports.MO.REL,
      '\u29E6': exports.MO.REL,
      '\u29E7': exports.MO.BIN3,
      '\u29E8': exports.MO.BIN3,
      '\u29E9': exports.MO.BIN3,
      '\u29EA': exports.MO.BIN3,
      '\u29EB': exports.MO.BIN3,
      '\u29EC': exports.MO.BIN3,
      '\u29ED': exports.MO.BIN3,
      '\u29EE': exports.MO.BIN3,
      '\u29EF': exports.MO.BIN3,
      '\u29F0': exports.MO.BIN3,
      '\u29F1': exports.MO.BIN3,
      '\u29F2': exports.MO.BIN3,
      '\u29F3': exports.MO.BIN3,
      '\u29F4': exports.MO.REL,
      '\u29F5': exports.MO.BIN4,
      '\u29F6': exports.MO.BIN4,
      '\u29F7': exports.MO.BIN4,
      '\u29F8': exports.MO.BIN3,
      '\u29F9': exports.MO.BIN3,
      '\u29FA': exports.MO.BIN3,
      '\u29FB': exports.MO.BIN3,
      '\u29FE': exports.MO.BIN4,
      '\u29FF': exports.MO.BIN4,
      '\u2A1D': exports.MO.BIN3,
      '\u2A1E': exports.MO.BIN3,
      '\u2A1F': exports.MO.BIN3,
      '\u2A20': exports.MO.BIN3,
      '\u2A21': exports.MO.BIN3,
      '\u2A22': exports.MO.BIN4,
      '\u2A23': exports.MO.BIN4,
      '\u2A24': exports.MO.BIN4,
      '\u2A25': exports.MO.BIN4,
      '\u2A26': exports.MO.BIN4,
      '\u2A27': exports.MO.BIN4,
      '\u2A28': exports.MO.BIN4,
      '\u2A29': exports.MO.BIN4,
      '\u2A2A': exports.MO.BIN4,
      '\u2A2B': exports.MO.BIN4,
      '\u2A2C': exports.MO.BIN4,
      '\u2A2D': exports.MO.BIN4,
      '\u2A2E': exports.MO.BIN4,
      '\u2A2F': exports.MO.BIN4,
      '\u2A30': exports.MO.BIN4,
      '\u2A31': exports.MO.BIN4,
      '\u2A32': exports.MO.BIN4,
      '\u2A33': exports.MO.BIN4,
      '\u2A34': exports.MO.BIN4,
      '\u2A35': exports.MO.BIN4,
      '\u2A36': exports.MO.BIN4,
      '\u2A37': exports.MO.BIN4,
      '\u2A38': exports.MO.BIN4,
      '\u2A39': exports.MO.BIN4,
      '\u2A3A': exports.MO.BIN4,
      '\u2A3B': exports.MO.BIN4,
      '\u2A3C': exports.MO.BIN4,
      '\u2A3D': exports.MO.BIN4,
      '\u2A3E': exports.MO.BIN4,
      '\u2A3F': exports.MO.BIN4,
      '\u2A40': exports.MO.BIN4,
      '\u2A41': exports.MO.BIN4,
      '\u2A42': exports.MO.BIN4,
      '\u2A43': exports.MO.BIN4,
      '\u2A44': exports.MO.BIN4,
      '\u2A45': exports.MO.BIN4,
      '\u2A46': exports.MO.BIN4,
      '\u2A47': exports.MO.BIN4,
      '\u2A48': exports.MO.BIN4,
      '\u2A49': exports.MO.BIN4,
      '\u2A4A': exports.MO.BIN4,
      '\u2A4B': exports.MO.BIN4,
      '\u2A4C': exports.MO.BIN4,
      '\u2A4D': exports.MO.BIN4,
      '\u2A4E': exports.MO.BIN4,
      '\u2A4F': exports.MO.BIN4,
      '\u2A50': exports.MO.BIN4,
      '\u2A51': exports.MO.BIN4,
      '\u2A52': exports.MO.BIN4,
      '\u2A53': exports.MO.BIN4,
      '\u2A54': exports.MO.BIN4,
      '\u2A55': exports.MO.BIN4,
      '\u2A56': exports.MO.BIN4,
      '\u2A57': exports.MO.BIN4,
      '\u2A58': exports.MO.BIN4,
      '\u2A59': exports.MO.REL,
      '\u2A5A': exports.MO.BIN4,
      '\u2A5B': exports.MO.BIN4,
      '\u2A5C': exports.MO.BIN4,
      '\u2A5D': exports.MO.BIN4,
      '\u2A5E': exports.MO.BIN4,
      '\u2A5F': exports.MO.BIN4,
      '\u2A60': exports.MO.BIN4,
      '\u2A61': exports.MO.BIN4,
      '\u2A62': exports.MO.BIN4,
      '\u2A63': exports.MO.BIN4,
      '\u2A64': exports.MO.BIN4,
      '\u2A65': exports.MO.BIN4,
      '\u2A66': exports.MO.REL,
      '\u2A67': exports.MO.REL,
      '\u2A68': exports.MO.REL,
      '\u2A69': exports.MO.REL,
      '\u2A6A': exports.MO.REL,
      '\u2A6B': exports.MO.REL,
      '\u2A6C': exports.MO.REL,
      '\u2A6D': exports.MO.REL,
      '\u2A6E': exports.MO.REL,
      '\u2A6F': exports.MO.REL,
      '\u2A70': exports.MO.REL,
      '\u2A71': exports.MO.BIN4,
      '\u2A72': exports.MO.BIN4,
      '\u2A73': exports.MO.REL,
      '\u2A74': exports.MO.REL,
      '\u2A75': exports.MO.REL,
      '\u2A76': exports.MO.REL,
      '\u2A77': exports.MO.REL,
      '\u2A78': exports.MO.REL,
      '\u2A79': exports.MO.REL,
      '\u2A7A': exports.MO.REL,
      '\u2A7B': exports.MO.REL,
      '\u2A7C': exports.MO.REL,
      '\u2A7D': exports.MO.REL,
      '\u2A7D\u0338': exports.MO.REL,
      '\u2A7E': exports.MO.REL,
      '\u2A7E\u0338': exports.MO.REL,
      '\u2A7F': exports.MO.REL,
      '\u2A80': exports.MO.REL,
      '\u2A81': exports.MO.REL,
      '\u2A82': exports.MO.REL,
      '\u2A83': exports.MO.REL,
      '\u2A84': exports.MO.REL,
      '\u2A85': exports.MO.REL,
      '\u2A86': exports.MO.REL,
      '\u2A87': exports.MO.REL,
      '\u2A88': exports.MO.REL,
      '\u2A89': exports.MO.REL,
      '\u2A8A': exports.MO.REL,
      '\u2A8B': exports.MO.REL,
      '\u2A8C': exports.MO.REL,
      '\u2A8D': exports.MO.REL,
      '\u2A8E': exports.MO.REL,
      '\u2A8F': exports.MO.REL,
      '\u2A90': exports.MO.REL,
      '\u2A91': exports.MO.REL,
      '\u2A92': exports.MO.REL,
      '\u2A93': exports.MO.REL,
      '\u2A94': exports.MO.REL,
      '\u2A95': exports.MO.REL,
      '\u2A96': exports.MO.REL,
      '\u2A97': exports.MO.REL,
      '\u2A98': exports.MO.REL,
      '\u2A99': exports.MO.REL,
      '\u2A9A': exports.MO.REL,
      '\u2A9B': exports.MO.REL,
      '\u2A9C': exports.MO.REL,
      '\u2A9D': exports.MO.REL,
      '\u2A9E': exports.MO.REL,
      '\u2A9F': exports.MO.REL,
      '\u2AA0': exports.MO.REL,
      '\u2AA1': exports.MO.REL,
      '\u2AA1\u0338': exports.MO.REL,
      '\u2AA2': exports.MO.REL,
      '\u2AA2\u0338': exports.MO.REL,
      '\u2AA3': exports.MO.REL,
      '\u2AA4': exports.MO.REL,
      '\u2AA5': exports.MO.REL,
      '\u2AA6': exports.MO.REL,
      '\u2AA7': exports.MO.REL,
      '\u2AA8': exports.MO.REL,
      '\u2AA9': exports.MO.REL,
      '\u2AAA': exports.MO.REL,
      '\u2AAB': exports.MO.REL,
      '\u2AAC': exports.MO.REL,
      '\u2AAD': exports.MO.REL,
      '\u2AAE': exports.MO.REL,
      '\u2AAF': exports.MO.REL,
      '\u2AAF\u0338': exports.MO.REL,
      '\u2AB0': exports.MO.REL,
      '\u2AB0\u0338': exports.MO.REL,
      '\u2AB1': exports.MO.REL,
      '\u2AB2': exports.MO.REL,
      '\u2AB3': exports.MO.REL,
      '\u2AB4': exports.MO.REL,
      '\u2AB5': exports.MO.REL,
      '\u2AB6': exports.MO.REL,
      '\u2AB7': exports.MO.REL,
      '\u2AB8': exports.MO.REL,
      '\u2AB9': exports.MO.REL,
      '\u2ABA': exports.MO.REL,
      '\u2ABB': exports.MO.REL,
      '\u2ABC': exports.MO.REL,
      '\u2ABD': exports.MO.REL,
      '\u2ABE': exports.MO.REL,
      '\u2ABF': exports.MO.REL,
      '\u2AC0': exports.MO.REL,
      '\u2AC1': exports.MO.REL,
      '\u2AC2': exports.MO.REL,
      '\u2AC3': exports.MO.REL,
      '\u2AC4': exports.MO.REL,
      '\u2AC5': exports.MO.REL,
      '\u2AC6': exports.MO.REL,
      '\u2AC7': exports.MO.REL,
      '\u2AC8': exports.MO.REL,
      '\u2AC9': exports.MO.REL,
      '\u2ACA': exports.MO.REL,
      '\u2ACB': exports.MO.REL,
      '\u2ACC': exports.MO.REL,
      '\u2ACD': exports.MO.REL,
      '\u2ACE': exports.MO.REL,
      '\u2ACF': exports.MO.REL,
      '\u2AD0': exports.MO.REL,
      '\u2AD1': exports.MO.REL,
      '\u2AD2': exports.MO.REL,
      '\u2AD3': exports.MO.REL,
      '\u2AD4': exports.MO.REL,
      '\u2AD5': exports.MO.REL,
      '\u2AD6': exports.MO.REL,
      '\u2AD7': exports.MO.REL,
      '\u2AD8': exports.MO.REL,
      '\u2AD9': exports.MO.REL,
      '\u2ADA': exports.MO.REL,
      '\u2ADB': exports.MO.REL,
      '\u2ADD': exports.MO.REL,
      '\u2ADD\u0338': exports.MO.REL,
      '\u2ADE': exports.MO.REL,
      '\u2ADF': exports.MO.REL,
      '\u2AE0': exports.MO.REL,
      '\u2AE1': exports.MO.REL,
      '\u2AE2': exports.MO.REL,
      '\u2AE3': exports.MO.REL,
      '\u2AE4': exports.MO.REL,
      '\u2AE5': exports.MO.REL,
      '\u2AE6': exports.MO.REL,
      '\u2AE7': exports.MO.REL,
      '\u2AE8': exports.MO.REL,
      '\u2AE9': exports.MO.REL,
      '\u2AEA': exports.MO.REL,
      '\u2AEB': exports.MO.REL,
      '\u2AEC': exports.MO.REL,
      '\u2AED': exports.MO.REL,
      '\u2AEE': exports.MO.REL,
      '\u2AEF': exports.MO.REL,
      '\u2AF0': exports.MO.REL,
      '\u2AF1': exports.MO.REL,
      '\u2AF2': exports.MO.REL,
      '\u2AF3': exports.MO.REL,
      '\u2AF4': exports.MO.BIN4,
      '\u2AF5': exports.MO.BIN4,
      '\u2AF6': exports.MO.BIN4,
      '\u2AF7': exports.MO.REL,
      '\u2AF8': exports.MO.REL,
      '\u2AF9': exports.MO.REL,
      '\u2AFA': exports.MO.REL,
      '\u2AFB': exports.MO.BIN4,
      '\u2AFD': exports.MO.BIN4,
      '\u2AFE': exports.MO.BIN3,
      '\u2B45': exports.MO.RELSTRETCH,
      '\u2B46': exports.MO.RELSTRETCH,
      '\u3008': exports.MO.OPEN,
      '\u3009': exports.MO.CLOSE,
      '\uFE37': exports.MO.WIDEACCENT,
      '\uFE38': exports.MO.WIDEACCENT
    }
  };
  exports.OPTABLE.infix['^'] = exports.MO.WIDEREL;
  exports.OPTABLE.infix['_'] = exports.MO.WIDEREL;
  exports.OPTABLE.infix['\u2ADC'] = exports.MO.REL;
})(OperatorDictionary);
getDefaultExportFromCjs(OperatorDictionary);

var __extends$1Q = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$E = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$E = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$E.apply(this, arguments);
});
var __read$P = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$L = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mo$3, "__esModule", {
  value: true
});
mo$3.MmlMo = void 0;
var MmlNode_js_1$O = MmlNode;
var OperatorDictionary_js_1$1 = OperatorDictionary;
var string_js_1$9 = string;
var MmlMo = (function (_super) {
  __extends$1Q(MmlMo, _super);
  function MmlMo() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._texClass = null;
    _this.lspace = 5 / 18;
    _this.rspace = 5 / 18;
    return _this;
  }
  Object.defineProperty(MmlMo.prototype, "texClass", {
    get: function () {
      if (this._texClass === null) {
        var mo = this.getText();
        var _a = __read$P(this.handleExplicitForm(this.getForms()), 3), form1 = _a[0], form2 = _a[1], form3 = _a[2];
        var OPTABLE_1 = this.constructor.OPTABLE;
        var def = OPTABLE_1[form1][mo] || OPTABLE_1[form2][mo] || OPTABLE_1[form3][mo];
        return def ? def[2] : MmlNode_js_1$O.TEXCLASS.REL;
      }
      return this._texClass;
    },
    set: function (value) {
      this._texClass = value;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMo.prototype, "kind", {
    get: function () {
      return 'mo';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMo.prototype, "isEmbellished", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMo.prototype, "hasNewLine", {
    get: function () {
      return this.attributes.get('linebreak') === 'newline';
    },
    enumerable: false,
    configurable: true
  });
  MmlMo.prototype.coreParent = function () {
    var embellished = this;
    var parent = this;
    var math = this.factory.getNodeClass('math');
    while (parent && parent.isEmbellished && parent.coreMO() === this && !(parent instanceof math)) {
      embellished = parent;
      parent = parent.parent;
    }
    return embellished;
  };
  MmlMo.prototype.coreText = function (parent) {
    if (!parent) {
      return '';
    }
    if (parent.isEmbellished) {
      return parent.coreMO().getText();
    }
    while (((parent.isKind('mrow') || parent.isKind('TeXAtom') && parent.texClass !== MmlNode_js_1$O.TEXCLASS.VCENTER || parent.isKind('mstyle') || parent.isKind('mphantom')) && parent.childNodes.length === 1 || parent.isKind('munderover')) && parent.childNodes[0]) {
      parent = parent.childNodes[0];
    }
    return parent.isToken ? parent.getText() : '';
  };
  MmlMo.prototype.hasSpacingAttributes = function () {
    return this.attributes.isSet('lspace') || this.attributes.isSet('rspace');
  };
  Object.defineProperty(MmlMo.prototype, "isAccent", {
    get: function () {
      var accent = false;
      var node = this.coreParent().parent;
      if (node) {
        var key = node.isKind('mover') ? node.childNodes[node.over].coreMO() ? 'accent' : '' : node.isKind('munder') ? node.childNodes[node.under].coreMO() ? 'accentunder' : '' : node.isKind('munderover') ? this === node.childNodes[node.over].coreMO() ? 'accent' : this === node.childNodes[node.under].coreMO() ? 'accentunder' : '' : '';
        if (key) {
          var value = node.attributes.getExplicit(key);
          accent = value !== undefined ? accent : this.attributes.get('accent');
        }
      }
      return accent;
    },
    enumerable: false,
    configurable: true
  });
  MmlMo.prototype.setTeXclass = function (prev) {
    var _a = this.attributes.getList('form', 'fence'), form = _a.form, fence = _a.fence;
    if (this.getProperty('texClass') === undefined && (this.attributes.isSet('lspace') || this.attributes.isSet('rspace'))) {
      return null;
    }
    if (fence && this.texClass === MmlNode_js_1$O.TEXCLASS.REL) {
      if (form === 'prefix') {
        this.texClass = MmlNode_js_1$O.TEXCLASS.OPEN;
      }
      if (form === 'postfix') {
        this.texClass = MmlNode_js_1$O.TEXCLASS.CLOSE;
      }
    }
    return this.adjustTeXclass(prev);
  };
  MmlMo.prototype.adjustTeXclass = function (prev) {
    var texClass = this.texClass;
    var prevClass = this.prevClass;
    if (texClass === MmlNode_js_1$O.TEXCLASS.NONE) {
      return prev;
    }
    if (prev) {
      if (prev.getProperty('autoOP') && (texClass === MmlNode_js_1$O.TEXCLASS.BIN || texClass === MmlNode_js_1$O.TEXCLASS.REL)) {
        prevClass = prev.texClass = MmlNode_js_1$O.TEXCLASS.ORD;
      }
      prevClass = this.prevClass = prev.texClass || MmlNode_js_1$O.TEXCLASS.ORD;
      this.prevLevel = this.attributes.getInherited('scriptlevel');
    } else {
      prevClass = this.prevClass = MmlNode_js_1$O.TEXCLASS.NONE;
    }
    if (texClass === MmlNode_js_1$O.TEXCLASS.BIN && (prevClass === MmlNode_js_1$O.TEXCLASS.NONE || prevClass === MmlNode_js_1$O.TEXCLASS.BIN || prevClass === MmlNode_js_1$O.TEXCLASS.OP || prevClass === MmlNode_js_1$O.TEXCLASS.REL || prevClass === MmlNode_js_1$O.TEXCLASS.OPEN || prevClass === MmlNode_js_1$O.TEXCLASS.PUNCT)) {
      this.texClass = MmlNode_js_1$O.TEXCLASS.ORD;
    } else if (prevClass === MmlNode_js_1$O.TEXCLASS.BIN && (texClass === MmlNode_js_1$O.TEXCLASS.REL || texClass === MmlNode_js_1$O.TEXCLASS.CLOSE || texClass === MmlNode_js_1$O.TEXCLASS.PUNCT)) {
      prev.texClass = this.prevClass = MmlNode_js_1$O.TEXCLASS.ORD;
    } else if (texClass === MmlNode_js_1$O.TEXCLASS.BIN) {
      var child = this;
      var parent_1 = this.parent;
      while (parent_1 && parent_1.parent && parent_1.isEmbellished && (parent_1.childNodes.length === 1 || !parent_1.isKind('mrow') && parent_1.core() === child)) {
        child = parent_1;
        parent_1 = parent_1.parent;
      }
      if (parent_1.childNodes[parent_1.childNodes.length - 1] === child) {
        this.texClass = MmlNode_js_1$O.TEXCLASS.ORD;
      }
    }
    return this;
  };
  MmlMo.prototype.setInheritedAttributes = function (attributes, display, level, prime) {
    if (attributes === void 0) {
      attributes = {};
    }
    if (display === void 0) {
      display = false;
    }
    if (level === void 0) {
      level = 0;
    }
    if (prime === void 0) {
      prime = false;
    }
    _super.prototype.setInheritedAttributes.call(this, attributes, display, level, prime);
    var mo = this.getText();
    this.checkOperatorTable(mo);
    this.checkPseudoScripts(mo);
    this.checkPrimes(mo);
    this.checkMathAccent(mo);
  };
  MmlMo.prototype.checkOperatorTable = function (mo) {
    var e_1, _a;
    var _b = __read$P(this.handleExplicitForm(this.getForms()), 3), form1 = _b[0], form2 = _b[1], form3 = _b[2];
    this.attributes.setInherited('form', form1);
    var OPTABLE = this.constructor.OPTABLE;
    var def = OPTABLE[form1][mo] || OPTABLE[form2][mo] || OPTABLE[form3][mo];
    if (def) {
      if (this.getProperty('texClass') === undefined) {
        this.texClass = def[2];
      }
      try {
        for (var _c = __values$L(Object.keys(def[3] || ({}))), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_1 = _d.value;
          this.attributes.setInherited(name_1, def[3][name_1]);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      this.lspace = (def[0] + 1) / 18;
      this.rspace = (def[1] + 1) / 18;
    } else {
      var range = (0, OperatorDictionary_js_1$1.getRange)(mo);
      if (range) {
        if (this.getProperty('texClass') === undefined) {
          this.texClass = range[2];
        }
        var spacing = this.constructor.MMLSPACING[range[2]];
        this.lspace = (spacing[0] + 1) / 18;
        this.rspace = (spacing[1] + 1) / 18;
      }
    }
  };
  MmlMo.prototype.getForms = function () {
    var core = this;
    var parent = this.parent;
    var Parent = this.Parent;
    while (Parent && Parent.isEmbellished) {
      core = parent;
      parent = Parent.parent;
      Parent = Parent.Parent;
    }
    if (parent && parent.isKind('mrow') && parent.nonSpaceLength() !== 1) {
      if (parent.firstNonSpace() === core) {
        return ['prefix', 'infix', 'postfix'];
      }
      if (parent.lastNonSpace() === core) {
        return ['postfix', 'infix', 'prefix'];
      }
    }
    return ['infix', 'prefix', 'postfix'];
  };
  MmlMo.prototype.handleExplicitForm = function (forms) {
    if (this.attributes.isSet('form')) {
      var form_1 = this.attributes.get('form');
      forms = [form_1].concat(forms.filter(function (name) {
        return name !== form_1;
      }));
    }
    return forms;
  };
  MmlMo.prototype.checkPseudoScripts = function (mo) {
    var PSEUDOSCRIPTS = this.constructor.pseudoScripts;
    if (!mo.match(PSEUDOSCRIPTS)) return;
    var parent = this.coreParent().Parent;
    var isPseudo = !parent || !(parent.isKind('msubsup') && !parent.isKind('msub'));
    this.setProperty('pseudoscript', isPseudo);
    if (isPseudo) {
      this.attributes.setInherited('lspace', 0);
      this.attributes.setInherited('rspace', 0);
    }
  };
  MmlMo.prototype.checkPrimes = function (mo) {
    var PRIMES = this.constructor.primes;
    if (!mo.match(PRIMES)) return;
    var REMAP = this.constructor.remapPrimes;
    var primes = (0, string_js_1$9.unicodeString)((0, string_js_1$9.unicodeChars)(mo).map(function (c) {
      return REMAP[c];
    }));
    this.setProperty('primes', primes);
  };
  MmlMo.prototype.checkMathAccent = function (mo) {
    var parent = this.Parent;
    if (this.getProperty('mathaccent') !== undefined || !parent || !parent.isKind('munderover')) return;
    var base = parent.childNodes[0];
    if (base.isEmbellished && base.coreMO() === this) return;
    var MATHACCENT = this.constructor.mathaccents;
    if (mo.match(MATHACCENT)) {
      this.setProperty('mathaccent', true);
    }
  };
  MmlMo.defaults = __assign$E(__assign$E({}, MmlNode_js_1$O.AbstractMmlTokenNode.defaults), {
    form: 'infix',
    fence: false,
    separator: false,
    lspace: 'thickmathspace',
    rspace: 'thickmathspace',
    stretchy: false,
    symmetric: false,
    maxsize: 'infinity',
    minsize: '0em',
    largeop: false,
    movablelimits: false,
    accent: false,
    linebreak: 'auto',
    lineleading: '1ex',
    linebreakstyle: 'before',
    indentalign: 'auto',
    indentshift: '0',
    indenttarget: '',
    indentalignfirst: 'indentalign',
    indentshiftfirst: 'indentshift',
    indentalignlast: 'indentalign',
    indentshiftlast: 'indentshift'
  });
  MmlMo.MMLSPACING = OperatorDictionary_js_1$1.MMLSPACING;
  MmlMo.OPTABLE = OperatorDictionary_js_1$1.OPTABLE;
  MmlMo.pseudoScripts = new RegExp(['^["\'*`', '\u00AA', '\u00B0', '\u00B2-\u00B4', '\u00B9', '\u00BA', '\u2018-\u201F', '\u2032-\u2037\u2057', '\u2070\u2071', '\u2074-\u207F', '\u2080-\u208E', ']+$'].join(''));
  MmlMo.primes = new RegExp(['^["\'`', '\u2018-\u201F', ']+$'].join(''));
  MmlMo.remapPrimes = {
    0x0022: 0x2033,
    0x0027: 0x2032,
    0x0060: 0x2035,
    0x2018: 0x2035,
    0x2019: 0x2032,
    0x201A: 0x2032,
    0x201B: 0x2035,
    0x201C: 0x2036,
    0x201D: 0x2033,
    0x201E: 0x2033,
    0x201F: 0x2036
  };
  MmlMo.mathaccents = new RegExp(['^[', '\u00B4\u0301\u02CA', '\u0060\u0300\u02CB', '\u00A8\u0308', '\u007E\u0303\u02DC', '\u00AF\u0304\u02C9', '\u02D8\u0306', '\u02C7\u030C', '\u005E\u0302\u02C6', '\u2192\u20D7', '\u02D9\u0307', '\u02DA\u030A', '\u20DB', '\u20DC', ']$'].join(''));
  return MmlMo;
})(MmlNode_js_1$O.AbstractMmlTokenNode);
mo$3.MmlMo = MmlMo;

var __values$K = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$O = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$t = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(NodeUtil$1, "__esModule", {
  value: true
});
var MmlNode_js_1$N = MmlNode;
var mo_js_1$4 = mo$3;
var NodeUtil;
(function (NodeUtil) {
  var attrs = new Map([['autoOP', true], ['fnOP', true], ['movesupsub', true], ['subsupOK', true], ['texprimestyle', true], ['useHeight', true], ['variantForm', true], ['withDelims', true], ['mathaccent', true], ['open', true], ['close', true]]);
  function createEntity(code) {
    return String.fromCodePoint(parseInt(code, 16));
  }
  NodeUtil.createEntity = createEntity;
  function getChildren(node) {
    return node.childNodes;
  }
  NodeUtil.getChildren = getChildren;
  function getText(node) {
    return node.getText();
  }
  NodeUtil.getText = getText;
  function appendChildren(node, children) {
    var e_1, _a;
    try {
      for (var children_1 = __values$K(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
        var child = children_1_1.value;
        node.appendChild(child);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  }
  NodeUtil.appendChildren = appendChildren;
  function setAttribute(node, attribute, value) {
    node.attributes.set(attribute, value);
  }
  NodeUtil.setAttribute = setAttribute;
  function setProperty(node, property, value) {
    node.setProperty(property, value);
  }
  NodeUtil.setProperty = setProperty;
  function setProperties(node, properties) {
    var e_2, _a;
    try {
      for (var _b = __values$K(Object.keys(properties)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_1 = _c.value;
        var value = properties[name_1];
        if (name_1 === 'texClass') {
          node.texClass = value;
          node.setProperty(name_1, value);
        } else if (name_1 === 'movablelimits') {
          node.setProperty('movablelimits', value);
          if (node.isKind('mo') || node.isKind('mstyle')) {
            node.attributes.set('movablelimits', value);
          }
        } else if (name_1 === 'inferred') {} else if (attrs.has(name_1)) {
          node.setProperty(name_1, value);
        } else {
          node.attributes.set(name_1, value);
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  }
  NodeUtil.setProperties = setProperties;
  function getProperty(node, property) {
    return node.getProperty(property);
  }
  NodeUtil.getProperty = getProperty;
  function getAttribute(node, attr) {
    return node.attributes.get(attr);
  }
  NodeUtil.getAttribute = getAttribute;
  function removeProperties(node) {
    var properties = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      properties[_i - 1] = arguments[_i];
    }
    node.removeProperty.apply(node, __spreadArray$t([], __read$O(properties), false));
  }
  NodeUtil.removeProperties = removeProperties;
  function getChildAt(node, position) {
    return node.childNodes[position];
  }
  NodeUtil.getChildAt = getChildAt;
  function setChild(node, position, child) {
    var children = node.childNodes;
    children[position] = child;
    if (child) {
      child.parent = node;
    }
  }
  NodeUtil.setChild = setChild;
  function copyChildren(oldNode, newNode) {
    var children = oldNode.childNodes;
    for (var i = 0; i < children.length; i++) {
      setChild(newNode, i, children[i]);
    }
  }
  NodeUtil.copyChildren = copyChildren;
  function copyAttributes(oldNode, newNode) {
    newNode.attributes = oldNode.attributes;
    setProperties(newNode, oldNode.getAllProperties());
  }
  NodeUtil.copyAttributes = copyAttributes;
  function isType(node, kind) {
    return node.isKind(kind);
  }
  NodeUtil.isType = isType;
  function isEmbellished(node) {
    return node.isEmbellished;
  }
  NodeUtil.isEmbellished = isEmbellished;
  function getTexClass(node) {
    return node.texClass;
  }
  NodeUtil.getTexClass = getTexClass;
  function getCoreMO(node) {
    return node.coreMO();
  }
  NodeUtil.getCoreMO = getCoreMO;
  function isNode(item) {
    return item instanceof MmlNode_js_1$N.AbstractMmlNode || item instanceof MmlNode_js_1$N.AbstractMmlEmptyNode;
  }
  NodeUtil.isNode = isNode;
  function isInferred(node) {
    return node.isInferred;
  }
  NodeUtil.isInferred = isInferred;
  function getForm(node) {
    var e_3, _a;
    if (!isType(node, 'mo')) {
      return null;
    }
    var mo = node;
    var forms = mo.getForms();
    try {
      for (var forms_1 = __values$K(forms), forms_1_1 = forms_1.next(); !forms_1_1.done; forms_1_1 = forms_1.next()) {
        var form = forms_1_1.value;
        var symbol = mo_js_1$4.MmlMo.OPTABLE[form][mo.getText()];
        if (symbol) {
          return symbol;
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (forms_1_1 && !forms_1_1.done && (_a = forms_1.return)) _a.call(forms_1);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    return null;
  }
  NodeUtil.getForm = getForm;
})(NodeUtil || (NodeUtil = {}));
NodeUtil$1.default = NodeUtil;

var __values$J = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$K = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(FilterUtil$1, "__esModule", {
  value: true
});
var MmlNode_js_1$M = MmlNode;
var NodeUtil_js_1$h = __importDefault$K(NodeUtil$1);
var FilterUtil;
(function (FilterUtil) {
  FilterUtil.cleanStretchy = function (arg) {
    var e_1, _a;
    var options = arg.data;
    try {
      for (var _b = __values$J(options.getList('fixStretchy')), _c = _b.next(); !_c.done; _c = _b.next()) {
        var mo = _c.value;
        if (NodeUtil_js_1$h.default.getProperty(mo, 'fixStretchy')) {
          var symbol = NodeUtil_js_1$h.default.getForm(mo);
          if (symbol && symbol[3] && symbol[3]['stretchy']) {
            NodeUtil_js_1$h.default.setAttribute(mo, 'stretchy', false);
          }
          var parent_1 = mo.parent;
          if (!NodeUtil_js_1$h.default.getTexClass(mo) && (!symbol || !symbol[2])) {
            var texAtom = options.nodeFactory.create('node', 'TeXAtom', [mo]);
            parent_1.replaceChild(texAtom, mo);
            texAtom.inheritAttributesFrom(mo);
          }
          NodeUtil_js_1$h.default.removeProperties(mo, 'fixStretchy');
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  FilterUtil.cleanAttributes = function (arg) {
    var node = arg.data.root;
    node.walkTree(function (mml, _d) {
      var e_2, _a;
      var attribs = mml.attributes;
      if (!attribs) {
        return;
      }
      var keep = new Set((attribs.get('mjx-keep-attrs') || '').split(/ /));
      delete attribs.getAllAttributes()['mjx-keep-attrs'];
      try {
        for (var _b = __values$J(attribs.getExplicitNames()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          if (!keep.has(key) && attribs.attributes[key] === mml.attributes.getInherited(key)) {
            delete attribs.attributes[key];
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }, {});
  };
  FilterUtil.combineRelations = function (arg) {
    var e_3, _a, e_4, _b;
    var remove = [];
    try {
      for (var _c = __values$J(arg.data.getList('mo')), _e = _c.next(); !_e.done; _e = _c.next()) {
        var mo = _e.value;
        if (mo.getProperty('relationsCombined') || !mo.parent || mo.parent && !NodeUtil_js_1$h.default.isType(mo.parent, 'mrow') || NodeUtil_js_1$h.default.getTexClass(mo) !== MmlNode_js_1$M.TEXCLASS.REL) {
          continue;
        }
        var mml = mo.parent;
        var m2 = void 0;
        var children = mml.childNodes;
        var next = children.indexOf(mo) + 1;
        var variantForm = NodeUtil_js_1$h.default.getProperty(mo, 'variantForm');
        while (next < children.length && (m2 = children[next]) && NodeUtil_js_1$h.default.isType(m2, 'mo') && NodeUtil_js_1$h.default.getTexClass(m2) === MmlNode_js_1$M.TEXCLASS.REL) {
          if (variantForm === NodeUtil_js_1$h.default.getProperty(m2, 'variantForm') && _compareExplicit(mo, m2)) {
            NodeUtil_js_1$h.default.appendChildren(mo, NodeUtil_js_1$h.default.getChildren(m2));
            _copyExplicit(['stretchy', 'rspace'], mo, m2);
            try {
              for (var _f = (e_4 = void 0, __values$J(m2.getPropertyNames())), _g = _f.next(); !_g.done; _g = _f.next()) {
                var name_1 = _g.value;
                mo.setProperty(name_1, m2.getProperty(name_1));
              }
            } catch (e_4_1) {
              e_4 = {
                error: e_4_1
              };
            } finally {
              try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
              } finally {
                if (e_4) throw e_4.error;
              }
            }
            children.splice(next, 1);
            remove.push(m2);
            m2.parent = null;
            m2.setProperty('relationsCombined', true);
          } else {
            if (mo.attributes.getExplicit('rspace') == null) {
              NodeUtil_js_1$h.default.setAttribute(mo, 'rspace', '0pt');
            }
            if (m2.attributes.getExplicit('lspace') == null) {
              NodeUtil_js_1$h.default.setAttribute(m2, 'lspace', '0pt');
            }
            break;
          }
        }
        mo.attributes.setInherited('form', mo.getForms()[0]);
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_e && !_e.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    arg.data.removeFromList('mo', remove);
  };
  var _copyExplicit = function (attrs, node1, node2) {
    var attr1 = node1.attributes;
    var attr2 = node2.attributes;
    attrs.forEach(function (x) {
      var attr = attr2.getExplicit(x);
      if (attr != null) {
        attr1.set(x, attr);
      }
    });
  };
  var _compareExplicit = function (node1, node2) {
    var e_5, _a;
    var filter = function (attr, space) {
      var exp = attr.getExplicitNames();
      return exp.filter(function (x) {
        return x !== space && (x !== 'stretchy' || attr.getExplicit('stretchy'));
      });
    };
    var attr1 = node1.attributes;
    var attr2 = node2.attributes;
    var exp1 = filter(attr1, 'lspace');
    var exp2 = filter(attr2, 'rspace');
    if (exp1.length !== exp2.length) {
      return false;
    }
    try {
      for (var exp1_1 = __values$J(exp1), exp1_1_1 = exp1_1.next(); !exp1_1_1.done; exp1_1_1 = exp1_1.next()) {
        var name_2 = exp1_1_1.value;
        if (attr1.getExplicit(name_2) !== attr2.getExplicit(name_2)) {
          return false;
        }
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (exp1_1_1 && !exp1_1_1.done && (_a = exp1_1.return)) _a.call(exp1_1);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
    return true;
  };
  var _cleanSubSup = function (options, low, up) {
    var e_6, _a;
    var remove = [];
    try {
      for (var _b = __values$J(options.getList('m' + low + up)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var mml = _c.value;
        var children = mml.childNodes;
        if (children[mml[low]] && children[mml[up]]) {
          continue;
        }
        var parent_2 = mml.parent;
        var newNode = children[mml[low]] ? options.nodeFactory.create('node', 'm' + low, [children[mml.base], children[mml[low]]]) : options.nodeFactory.create('node', 'm' + up, [children[mml.base], children[mml[up]]]);
        NodeUtil_js_1$h.default.copyAttributes(mml, newNode);
        if (parent_2) {
          parent_2.replaceChild(newNode, mml);
        } else {
          options.root = newNode;
        }
        remove.push(mml);
      }
    } catch (e_6_1) {
      e_6 = {
        error: e_6_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_6) throw e_6.error;
      }
    }
    options.removeFromList('m' + low + up, remove);
  };
  FilterUtil.cleanSubSup = function (arg) {
    var options = arg.data;
    if (options.error) {
      return;
    }
    _cleanSubSup(options, 'sub', 'sup');
    _cleanSubSup(options, 'under', 'over');
  };
  var _moveLimits = function (options, underover, subsup) {
    var e_7, _a;
    var remove = [];
    try {
      for (var _b = __values$J(options.getList(underover)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var mml = _c.value;
        if (mml.attributes.get('displaystyle')) {
          continue;
        }
        var base = mml.childNodes[mml.base];
        var mo = base.coreMO();
        if (base.getProperty('movablelimits') && !mo.attributes.getExplicit('movablelimits')) {
          var node = options.nodeFactory.create('node', subsup, mml.childNodes);
          NodeUtil_js_1$h.default.copyAttributes(mml, node);
          if (mml.parent) {
            mml.parent.replaceChild(node, mml);
          } else {
            options.root = node;
          }
          remove.push(mml);
        }
      }
    } catch (e_7_1) {
      e_7 = {
        error: e_7_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_7) throw e_7.error;
      }
    }
    options.removeFromList(underover, remove);
  };
  FilterUtil.moveLimits = function (arg) {
    var options = arg.data;
    _moveLimits(options, 'munderover', 'msubsup');
    _moveLimits(options, 'munder', 'msub');
    _moveLimits(options, 'mover', 'msup');
  };
  FilterUtil.setInherited = function (arg) {
    arg.data.root.setInheritedAttributes({}, arg.math['display'], 0, false);
  };
})(FilterUtil || (FilterUtil = {}));
FilterUtil$1.default = FilterUtil;

var TexParser$1 = {};

var ParseUtil$1 = {};

var TexError$1 = {};

Object.defineProperty(TexError$1, "__esModule", {
  value: true
});
var TexError = (function () {
  function TexError(id, message) {
    var rest = [];
    for (var _i = 2; _i < arguments.length; _i++) {
      rest[_i - 2] = arguments[_i];
    }
    this.id = id;
    this.message = TexError.processString(message, rest);
  }
  TexError.processString = function (str, args) {
    var parts = str.split(TexError.pattern);
    for (var i = 1, m = parts.length; i < m; i += 2) {
      var c = parts[i].charAt(0);
      if (c >= '0' && c <= '9') {
        parts[i] = args[parseInt(parts[i], 10) - 1];
        if (typeof parts[i] === 'number') {
          parts[i] = parts[i].toString();
        }
      } else if (c === '{') {
        c = parts[i].substr(1);
        if (c >= '0' && c <= '9') {
          parts[i] = args[parseInt(parts[i].substr(1, parts[i].length - 2), 10) - 1];
          if (typeof parts[i] === 'number') {
            parts[i] = parts[i].toString();
          }
        } else {
          var match = parts[i].match(/^\{([a-z]+):%(\d+)\|(.*)\}$/);
          if (match) {
            parts[i] = '%' + parts[i];
          }
        }
      }
      if (parts[i] == null) {
        parts[i] = '???';
      }
    }
    return parts.join('');
  };
  TexError.pattern = /%(\d+|\{\d+\}|\{[a-z]+:\%\d+(?:\|(?:%\{\d+\}|%.|[^\}])*)+\}|.)/g;
  return TexError;
})();
TexError$1.default = TexError;

var __read$N = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$I = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$J = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(ParseUtil$1, "__esModule", {
  value: true
});
var MmlNode_js_1$L = MmlNode;
var NodeUtil_js_1$g = __importDefault$J(NodeUtil$1);
var TexParser_js_1$a = __importDefault$J(TexParser$1);
var TexError_js_1$k = __importDefault$J(TexError$1);
var Entities_js_1$2 = Entities$1;
var ParseUtil;
(function (ParseUtil) {
  var emPerInch = 7.2;
  var pxPerInch = 72;
  var UNIT_CASES = {
    'em': function (m) {
      return m;
    },
    'ex': function (m) {
      return m * .43;
    },
    'pt': function (m) {
      return m / 10;
    },
    'pc': function (m) {
      return m * 1.2;
    },
    'px': function (m) {
      return m * emPerInch / pxPerInch;
    },
    'in': function (m) {
      return m * emPerInch;
    },
    'cm': function (m) {
      return m * emPerInch / 2.54;
    },
    'mm': function (m) {
      return m * emPerInch / 25.4;
    },
    'mu': function (m) {
      return m / 18;
    }
  };
  var num = '([-+]?([.,]\\d+|\\d+([.,]\\d*)?))';
  var unit = '(pt|em|ex|mu|px|mm|cm|in|pc)';
  var dimenEnd = RegExp('^\\s*' + num + '\\s*' + unit + '\\s*$');
  var dimenRest = RegExp('^\\s*' + num + '\\s*' + unit + ' ?');
  function matchDimen(dim, rest) {
    if (rest === void 0) {
      rest = false;
    }
    var match = dim.match(rest ? dimenRest : dimenEnd);
    return match ? muReplace([match[1].replace(/,/, '.'), match[4], match[0].length]) : [null, null, 0];
  }
  ParseUtil.matchDimen = matchDimen;
  function muReplace(_a) {
    var _b = __read$N(_a, 3), value = _b[0], unit = _b[1], length = _b[2];
    if (unit !== 'mu') {
      return [value, unit, length];
    }
    var em = Em(UNIT_CASES[unit](parseFloat(value || '1')));
    return [em.slice(0, -2), 'em', length];
  }
  function dimen2em(dim) {
    var _a = __read$N(matchDimen(dim), 2), value = _a[0], unit = _a[1];
    var m = parseFloat(value || '1');
    var func = UNIT_CASES[unit];
    return func ? func(m) : 0;
  }
  ParseUtil.dimen2em = dimen2em;
  function Em(m) {
    if (Math.abs(m) < .0006) {
      return '0em';
    }
    return m.toFixed(3).replace(/\.?0+$/, '') + 'em';
  }
  ParseUtil.Em = Em;
  function cols() {
    var W = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      W[_i] = arguments[_i];
    }
    return W.map(function (n) {
      return Em(n);
    }).join(' ');
  }
  ParseUtil.cols = cols;
  function fenced(configuration, open, mml, close, big, color) {
    if (big === void 0) {
      big = '';
    }
    if (color === void 0) {
      color = '';
    }
    var nf = configuration.nodeFactory;
    var mrow = nf.create('node', 'mrow', [], {
      open: open,
      close: close,
      texClass: MmlNode_js_1$L.TEXCLASS.INNER
    });
    var mo;
    if (big) {
      mo = new TexParser_js_1$a.default('\\' + big + 'l' + open, configuration.parser.stack.env, configuration).mml();
    } else {
      var openNode = nf.create('text', open);
      mo = nf.create('node', 'mo', [], {
        fence: true,
        stretchy: true,
        symmetric: true,
        texClass: MmlNode_js_1$L.TEXCLASS.OPEN
      }, openNode);
    }
    NodeUtil_js_1$g.default.appendChildren(mrow, [mo, mml]);
    if (big) {
      mo = new TexParser_js_1$a.default('\\' + big + 'r' + close, configuration.parser.stack.env, configuration).mml();
    } else {
      var closeNode = nf.create('text', close);
      mo = nf.create('node', 'mo', [], {
        fence: true,
        stretchy: true,
        symmetric: true,
        texClass: MmlNode_js_1$L.TEXCLASS.CLOSE
      }, closeNode);
    }
    color && mo.attributes.set('mathcolor', color);
    NodeUtil_js_1$g.default.appendChildren(mrow, [mo]);
    return mrow;
  }
  ParseUtil.fenced = fenced;
  function fixedFence(configuration, open, mml, close) {
    var mrow = configuration.nodeFactory.create('node', 'mrow', [], {
      open: open,
      close: close,
      texClass: MmlNode_js_1$L.TEXCLASS.ORD
    });
    if (open) {
      NodeUtil_js_1$g.default.appendChildren(mrow, [mathPalette(configuration, open, 'l')]);
    }
    if (NodeUtil_js_1$g.default.isType(mml, 'mrow')) {
      NodeUtil_js_1$g.default.appendChildren(mrow, NodeUtil_js_1$g.default.getChildren(mml));
    } else {
      NodeUtil_js_1$g.default.appendChildren(mrow, [mml]);
    }
    if (close) {
      NodeUtil_js_1$g.default.appendChildren(mrow, [mathPalette(configuration, close, 'r')]);
    }
    return mrow;
  }
  ParseUtil.fixedFence = fixedFence;
  function mathPalette(configuration, fence, side) {
    if (fence === '{' || fence === '}') {
      fence = '\\' + fence;
    }
    var D = '{\\bigg' + side + ' ' + fence + '}';
    var T = '{\\big' + side + ' ' + fence + '}';
    return new TexParser_js_1$a.default('\\mathchoice' + D + T + T + T, {}, configuration).mml();
  }
  ParseUtil.mathPalette = mathPalette;
  function fixInitialMO(configuration, nodes) {
    for (var i = 0, m = nodes.length; i < m; i++) {
      var child = nodes[i];
      if (child && (!NodeUtil_js_1$g.default.isType(child, 'mspace') && (!NodeUtil_js_1$g.default.isType(child, 'TeXAtom') || NodeUtil_js_1$g.default.getChildren(child)[0] && NodeUtil_js_1$g.default.getChildren(NodeUtil_js_1$g.default.getChildren(child)[0]).length))) {
        if (NodeUtil_js_1$g.default.isEmbellished(child) || NodeUtil_js_1$g.default.isType(child, 'TeXAtom') && NodeUtil_js_1$g.default.getTexClass(child) === MmlNode_js_1$L.TEXCLASS.REL) {
          var mi = configuration.nodeFactory.create('node', 'mi');
          nodes.unshift(mi);
        }
        break;
      }
    }
  }
  ParseUtil.fixInitialMO = fixInitialMO;
  function internalMath(parser, text, level, font) {
    if (parser.configuration.options.internalMath) {
      return parser.configuration.options.internalMath(parser, text, level, font);
    }
    var mathvariant = font || parser.stack.env.font;
    var def = mathvariant ? {
      mathvariant: mathvariant
    } : {};
    var mml = [], i = 0, k = 0, c, node, match = '', braces = 0;
    if (text.match(/\\?[${}\\]|\\\(|\\(eq)?ref\s*\{/)) {
      while (i < text.length) {
        c = text.charAt(i++);
        if (c === '$') {
          if (match === '$' && braces === 0) {
            node = parser.create('node', 'TeXAtom', [new TexParser_js_1$a.default(text.slice(k, i - 1), {}, parser.configuration).mml()]);
            mml.push(node);
            match = '';
            k = i;
          } else if (match === '') {
            if (k < i - 1) {
              mml.push(internalText(parser, text.slice(k, i - 1), def));
            }
            match = '$';
            k = i;
          }
        } else if (c === '{' && match !== '') {
          braces++;
        } else if (c === '}') {
          if (match === '}' && braces === 0) {
            var atom = new TexParser_js_1$a.default(text.slice(k, i), {}, parser.configuration).mml();
            node = parser.create('node', 'TeXAtom', [atom], def);
            mml.push(node);
            match = '';
            k = i;
          } else if (match !== '') {
            if (braces) {
              braces--;
            }
          }
        } else if (c === '\\') {
          if (match === '' && text.substr(i).match(/^(eq)?ref\s*\{/)) {
            var len = RegExp['$&'].length;
            if (k < i - 1) {
              mml.push(internalText(parser, text.slice(k, i - 1), def));
            }
            match = '}';
            k = i - 1;
            i += len;
          } else {
            c = text.charAt(i++);
            if (c === '(' && match === '') {
              if (k < i - 2) {
                mml.push(internalText(parser, text.slice(k, i - 2), def));
              }
              match = ')';
              k = i;
            } else if (c === ')' && match === ')' && braces === 0) {
              node = parser.create('node', 'TeXAtom', [new TexParser_js_1$a.default(text.slice(k, i - 2), {}, parser.configuration).mml()]);
              mml.push(node);
              match = '';
              k = i;
            } else if (c.match(/[${}\\]/) && match === '') {
              i--;
              text = text.substr(0, i - 1) + text.substr(i);
            }
          }
        }
      }
      if (match !== '') {
        throw new TexError_js_1$k.default('MathNotTerminated', 'Math not terminated in text box');
      }
    }
    if (k < text.length) {
      mml.push(internalText(parser, text.slice(k), def));
    }
    if (level != null) {
      mml = [parser.create('node', 'mstyle', mml, {
        displaystyle: false,
        scriptlevel: level
      })];
    } else if (mml.length > 1) {
      mml = [parser.create('node', 'mrow', mml)];
    }
    return mml;
  }
  ParseUtil.internalMath = internalMath;
  function internalText(parser, text, def) {
    text = text.replace(/^\s+/, Entities_js_1$2.entities.nbsp).replace(/\s+$/, Entities_js_1$2.entities.nbsp);
    var textNode = parser.create('text', text);
    return parser.create('node', 'mtext', [], def, textNode);
  }
  ParseUtil.internalText = internalText;
  function underOver(parser, base, script, pos, stack) {
    ParseUtil.checkMovableLimits(base);
    if (NodeUtil_js_1$g.default.isType(base, 'munderover') && NodeUtil_js_1$g.default.isEmbellished(base)) {
      NodeUtil_js_1$g.default.setProperties(NodeUtil_js_1$g.default.getCoreMO(base), {
        lspace: 0,
        rspace: 0
      });
      var mo = parser.create('node', 'mo', [], {
        rspace: 0
      });
      base = parser.create('node', 'mrow', [mo, base]);
    }
    var mml = parser.create('node', 'munderover', [base]);
    NodeUtil_js_1$g.default.setChild(mml, pos === 'over' ? mml.over : mml.under, script);
    var node = mml;
    if (stack) {
      node = parser.create('node', 'TeXAtom', [mml], {
        texClass: MmlNode_js_1$L.TEXCLASS.OP,
        movesupsub: true
      });
    }
    NodeUtil_js_1$g.default.setProperty(node, 'subsupOK', true);
    return node;
  }
  ParseUtil.underOver = underOver;
  function checkMovableLimits(base) {
    var symbol = NodeUtil_js_1$g.default.isType(base, 'mo') ? NodeUtil_js_1$g.default.getForm(base) : null;
    if (NodeUtil_js_1$g.default.getProperty(base, 'movablelimits') || symbol && symbol[3] && symbol[3].movablelimits) {
      NodeUtil_js_1$g.default.setProperties(base, {
        movablelimits: false
      });
    }
  }
  ParseUtil.checkMovableLimits = checkMovableLimits;
  function trimSpaces(text) {
    if (typeof text !== 'string') {
      return text;
    }
    var TEXT = text.trim();
    if (TEXT.match(/\\$/) && text.match(/ $/)) {
      TEXT += ' ';
    }
    return TEXT;
  }
  ParseUtil.trimSpaces = trimSpaces;
  function setArrayAlign(array, align) {
    align = ParseUtil.trimSpaces(align || '');
    if (align === 't') {
      array.arraydef.align = 'baseline 1';
    } else if (align === 'b') {
      array.arraydef.align = 'baseline -1';
    } else if (align === 'c') {
      array.arraydef.align = 'axis';
    } else if (align) {
      array.arraydef.align = align;
    }
    return array;
  }
  ParseUtil.setArrayAlign = setArrayAlign;
  function substituteArgs(parser, args, str) {
    var text = '';
    var newstring = '';
    var i = 0;
    while (i < str.length) {
      var c = str.charAt(i++);
      if (c === '\\') {
        text += c + str.charAt(i++);
      } else if (c === '#') {
        c = str.charAt(i++);
        if (c === '#') {
          text += c;
        } else {
          if (!c.match(/[1-9]/) || parseInt(c, 10) > args.length) {
            throw new TexError_js_1$k.default('IllegalMacroParam', 'Illegal macro parameter reference');
          }
          newstring = addArgs(parser, addArgs(parser, newstring, text), args[parseInt(c, 10) - 1]);
          text = '';
        }
      } else {
        text += c;
      }
    }
    return addArgs(parser, newstring, text);
  }
  ParseUtil.substituteArgs = substituteArgs;
  function addArgs(parser, s1, s2) {
    if (s2.match(/^[a-z]/i) && s1.match(/(^|[^\\])(\\\\)*\\[a-z]+$/i)) {
      s1 += ' ';
    }
    if (s1.length + s2.length > parser.configuration.options['maxBuffer']) {
      throw new TexError_js_1$k.default('MaxBufferSize', 'MathJax internal buffer size exceeded; is there a' + ' recursive macro call?');
    }
    return s1 + s2;
  }
  ParseUtil.addArgs = addArgs;
  function checkMaxMacros(parser, isMacro) {
    if (isMacro === void 0) {
      isMacro = true;
    }
    if (++parser.macroCount <= parser.configuration.options['maxMacros']) {
      return;
    }
    if (isMacro) {
      throw new TexError_js_1$k.default('MaxMacroSub1', 'MathJax maximum macro substitution count exceeded; ' + 'is here a recursive macro call?');
    } else {
      throw new TexError_js_1$k.default('MaxMacroSub2', 'MathJax maximum substitution count exceeded; ' + 'is there a recursive latex environment?');
    }
  }
  ParseUtil.checkMaxMacros = checkMaxMacros;
  function checkEqnEnv(parser) {
    if (parser.stack.global.eqnenv) {
      throw new TexError_js_1$k.default('ErroneousNestingEq', 'Erroneous nesting of equation structures');
    }
    parser.stack.global.eqnenv = true;
  }
  ParseUtil.checkEqnEnv = checkEqnEnv;
  function copyNode(node, parser) {
    var tree = node.copy();
    var options = parser.configuration;
    tree.walkTree(function (n) {
      var e_1, _a;
      options.addNode(n.kind, n);
      var lists = (n.getProperty('in-lists') || '').split(/,/);
      try {
        for (var lists_1 = __values$I(lists), lists_1_1 = lists_1.next(); !lists_1_1.done; lists_1_1 = lists_1.next()) {
          var list = lists_1_1.value;
          list && options.addNode(list, n);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (lists_1_1 && !lists_1_1.done && (_a = lists_1.return)) _a.call(lists_1);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    });
    return tree;
  }
  ParseUtil.copyNode = copyNode;
  function MmlFilterAttribute(_parser, _name, value) {
    return value;
  }
  ParseUtil.MmlFilterAttribute = MmlFilterAttribute;
  function getFontDef(parser) {
    var font = parser.stack.env['font'];
    return font ? {
      mathvariant: font
    } : {};
  }
  ParseUtil.getFontDef = getFontDef;
  function keyvalOptions(attrib, allowed, error) {
    var e_2, _a;
    if (allowed === void 0) {
      allowed = null;
    }
    if (error === void 0) {
      error = false;
    }
    var def = readKeyval(attrib);
    if (allowed) {
      try {
        for (var _b = __values$I(Object.keys(def)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          if (!allowed.hasOwnProperty(key)) {
            if (error) {
              throw new TexError_js_1$k.default('InvalidOption', 'Invalid option: %1', key);
            }
            delete def[key];
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }
    return def;
  }
  ParseUtil.keyvalOptions = keyvalOptions;
  function readKeyval(text) {
    var _a, _b;
    var options = {};
    var rest = text;
    var end, key, val;
    while (rest) {
      (_a = __read$N(readValue(rest, ['=', ',']), 3), key = _a[0], end = _a[1], rest = _a[2]);
      if (end === '=') {
        (_b = __read$N(readValue(rest, [',']), 3), val = _b[0], end = _b[1], rest = _b[2]);
        val = val === 'false' || val === 'true' ? JSON.parse(val) : val;
        options[key] = val;
      } else if (key) {
        options[key] = true;
      }
    }
    return options;
  }
  function removeBraces(text, count) {
    while (count > 0) {
      text = text.trim().slice(1, -1);
      count--;
    }
    return text.trim();
  }
  function readValue(text, end) {
    var length = text.length;
    var braces = 0;
    var value = '';
    var index = 0;
    var start = 0;
    var startCount = true;
    var stopCount = false;
    while (index < length) {
      var c = text[index++];
      switch (c) {
        case ' ':
          break;
        case '{':
          if (startCount) {
            start++;
          } else {
            stopCount = false;
            if (start > braces) {
              start = braces;
            }
          }
          braces++;
          break;
        case '}':
          if (braces) {
            braces--;
          }
          if (startCount || stopCount) {
            start--;
            stopCount = true;
          }
          startCount = false;
          break;
        default:
          if (!braces && end.indexOf(c) !== -1) {
            return [stopCount ? 'true' : removeBraces(value, start), c, text.slice(index)];
          }
          startCount = false;
          stopCount = false;
      }
      value += c;
    }
    if (braces) {
      throw new TexError_js_1$k.default('ExtraOpenMissingClose', 'Extra open brace or missing close brace');
    }
    return [stopCount ? 'true' : removeBraces(value, start), '', text.slice(index)];
  }
})(ParseUtil || (ParseUtil = {}));
ParseUtil$1.default = ParseUtil;

var Stack$1 = {};

var __values$H = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$M = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$s = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$I = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(Stack$1, "__esModule", {
  value: true
});
var NodeUtil_js_1$f = __importDefault$I(NodeUtil$1);
var Stack = (function () {
  function Stack(_factory, _env, inner) {
    this._factory = _factory;
    this._env = _env;
    this.global = {};
    this.stack = [];
    this.global = {
      isInner: inner
    };
    this.stack = [this._factory.create('start', this.global)];
    if (_env) {
      this.stack[0].env = _env;
    }
    this.env = this.stack[0].env;
  }
  Object.defineProperty(Stack.prototype, "env", {
    get: function () {
      return this._env;
    },
    set: function (env) {
      this._env = env;
    },
    enumerable: false,
    configurable: true
  });
  Stack.prototype.Push = function () {
    var e_1, _a;
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    try {
      for (var args_1 = __values$H(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
        var node = args_1_1.value;
        if (!node) {
          continue;
        }
        var item = NodeUtil_js_1$f.default.isNode(node) ? this._factory.create('mml', node) : node;
        item.global = this.global;
        var _b = __read$M(this.stack.length ? this.Top().checkItem(item) : [null, true], 2), top_1 = _b[0], success = _b[1];
        if (!success) {
          continue;
        }
        if (top_1) {
          this.Pop();
          this.Push.apply(this, __spreadArray$s([], __read$M(top_1), false));
          continue;
        }
        this.stack.push(item);
        if (item.env) {
          if (item.copyEnv) {
            Object.assign(item.env, this.env);
          }
          this.env = item.env;
        } else {
          item.env = this.env;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  Stack.prototype.Pop = function () {
    var item = this.stack.pop();
    if (!item.isOpen) {
      delete item.env;
    }
    this.env = this.stack.length ? this.Top().env : {};
    return item;
  };
  Stack.prototype.Top = function (n) {
    if (n === void 0) {
      n = 1;
    }
    return this.stack.length < n ? null : this.stack[this.stack.length - n];
  };
  Stack.prototype.Prev = function (noPop) {
    var top = this.Top();
    return noPop ? top.First : top.Pop();
  };
  Stack.prototype.toString = function () {
    return 'stack[\n  ' + this.stack.join('\n  ') + '\n]';
  };
  return Stack;
})();
Stack$1.default = Stack;

var __values$G = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$L = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$r = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$H = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(TexParser$1, "__esModule", {
  value: true
});
var ParseUtil_js_1$f = __importDefault$H(ParseUtil$1);
var Stack_js_1$1 = __importDefault$H(Stack$1);
var TexError_js_1$j = __importDefault$H(TexError$1);
var MmlNode_js_1$K = MmlNode;
var TexParser = (function () {
  function TexParser(_string, env, configuration) {
    var e_1, _a;
    this._string = _string;
    this.configuration = configuration;
    this.macroCount = 0;
    this.i = 0;
    this.currentCS = '';
    var inner = env.hasOwnProperty('isInner');
    var isInner = env['isInner'];
    delete env['isInner'];
    var ENV;
    if (env) {
      ENV = {};
      try {
        for (var _b = __values$G(Object.keys(env)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var id = _c.value;
          ENV[id] = env[id];
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    }
    this.configuration.pushParser(this);
    this.stack = new Stack_js_1$1.default(this.itemFactory, ENV, inner ? isInner : true);
    this.Parse();
    this.Push(this.itemFactory.create('stop'));
  }
  Object.defineProperty(TexParser.prototype, "options", {
    get: function () {
      return this.configuration.options;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TexParser.prototype, "itemFactory", {
    get: function () {
      return this.configuration.itemFactory;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TexParser.prototype, "tags", {
    get: function () {
      return this.configuration.tags;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TexParser.prototype, "string", {
    get: function () {
      return this._string;
    },
    set: function (str) {
      this._string = str;
    },
    enumerable: false,
    configurable: true
  });
  TexParser.prototype.parse = function (kind, input) {
    return this.configuration.handlers.get(kind).parse(input);
  };
  TexParser.prototype.lookup = function (kind, symbol) {
    return this.configuration.handlers.get(kind).lookup(symbol);
  };
  TexParser.prototype.contains = function (kind, symbol) {
    return this.configuration.handlers.get(kind).contains(symbol);
  };
  TexParser.prototype.toString = function () {
    var e_2, _a;
    var str = '';
    try {
      for (var _b = __values$G(Array.from(this.configuration.handlers.keys())), _c = _b.next(); !_c.done; _c = _b.next()) {
        var config = _c.value;
        str += config + ': ' + this.configuration.handlers.get(config) + '\n';
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    return str;
  };
  TexParser.prototype.Parse = function () {
    var c;
    while (this.i < this.string.length) {
      c = this.getCodePoint();
      this.i += c.length;
      this.parse('character', [this, c]);
    }
  };
  TexParser.prototype.Push = function (arg) {
    if (arg instanceof MmlNode_js_1$K.AbstractMmlNode && arg.isInferred) {
      this.PushAll(arg.childNodes);
    } else {
      this.stack.Push(arg);
    }
  };
  TexParser.prototype.PushAll = function (args) {
    var e_3, _a;
    try {
      for (var args_1 = __values$G(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
        var arg = args_1_1.value;
        this.stack.Push(arg);
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
  };
  TexParser.prototype.mml = function () {
    if (!this.stack.Top().isKind('mml')) {
      return null;
    }
    var node = this.stack.Top().First;
    this.configuration.popParser();
    return node;
  };
  TexParser.prototype.convertDelimiter = function (c) {
    var symbol = this.lookup('delimiter', c);
    return symbol ? symbol.char : null;
  };
  TexParser.prototype.getCodePoint = function () {
    var code = this.string.codePointAt(this.i);
    return code === undefined ? '' : String.fromCodePoint(code);
  };
  TexParser.prototype.nextIsSpace = function () {
    return !!this.string.charAt(this.i).match(/\s/);
  };
  TexParser.prototype.GetNext = function () {
    while (this.nextIsSpace()) {
      this.i++;
    }
    return this.getCodePoint();
  };
  TexParser.prototype.GetCS = function () {
    var CS = this.string.slice(this.i).match(/^(([a-z]+) ?|[\uD800-\uDBFF].|.)/i);
    if (CS) {
      this.i += CS[0].length;
      return CS[2] || CS[1];
    } else {
      this.i++;
      return ' ';
    }
  };
  TexParser.prototype.GetArgument = function (_name, noneOK) {
    switch (this.GetNext()) {
      case '':
        if (!noneOK) {
          throw new TexError_js_1$j.default('MissingArgFor', 'Missing argument for %1', this.currentCS);
        }
        return null;
      case '}':
        if (!noneOK) {
          throw new TexError_js_1$j.default('ExtraCloseMissingOpen', 'Extra close brace or missing open brace');
        }
        return null;
      case '\\':
        this.i++;
        return '\\' + this.GetCS();
      case '{':
        var j = ++this.i, parens = 1;
        while (this.i < this.string.length) {
          switch (this.string.charAt(this.i++)) {
            case '\\':
              this.i++;
              break;
            case '{':
              parens++;
              break;
            case '}':
              if (--parens === 0) {
                return this.string.slice(j, this.i - 1);
              }
              break;
          }
        }
        throw new TexError_js_1$j.default('MissingCloseBrace', 'Missing close brace');
    }
    var c = this.getCodePoint();
    this.i += c.length;
    return c;
  };
  TexParser.prototype.GetBrackets = function (_name, def) {
    if (this.GetNext() !== '[') {
      return def;
    }
    var j = ++this.i, parens = 0;
    while (this.i < this.string.length) {
      switch (this.string.charAt(this.i++)) {
        case '{':
          parens++;
          break;
        case '\\':
          this.i++;
          break;
        case '}':
          if (parens-- <= 0) {
            throw new TexError_js_1$j.default('ExtraCloseLooking', 'Extra close brace while looking for %1', '\']\'');
          }
          break;
        case ']':
          if (parens === 0) {
            return this.string.slice(j, this.i - 1);
          }
          break;
      }
    }
    throw new TexError_js_1$j.default('MissingCloseBracket', 'Could not find closing \']\' for argument to %1', this.currentCS);
  };
  TexParser.prototype.GetDelimiter = function (name, braceOK) {
    var c = this.GetNext();
    this.i += c.length;
    if (this.i <= this.string.length) {
      if (c === '\\') {
        c += this.GetCS();
      } else if (c === '{' && braceOK) {
        this.i--;
        c = this.GetArgument(name).trim();
      }
      if (this.contains('delimiter', c)) {
        return this.convertDelimiter(c);
      }
    }
    throw new TexError_js_1$j.default('MissingOrUnrecognizedDelim', 'Missing or unrecognized delimiter for %1', this.currentCS);
  };
  TexParser.prototype.GetDimen = function (name) {
    if (this.GetNext() === '{') {
      var dimen = this.GetArgument(name);
      var _a = __read$L(ParseUtil_js_1$f.default.matchDimen(dimen), 2), value = _a[0], unit = _a[1];
      if (value) {
        return value + unit;
      }
    } else {
      var dimen = this.string.slice(this.i);
      var _b = __read$L(ParseUtil_js_1$f.default.matchDimen(dimen, true), 3), value = _b[0], unit = _b[1], length_1 = _b[2];
      if (value) {
        this.i += length_1;
        return value + unit;
      }
    }
    throw new TexError_js_1$j.default('MissingDimOrUnits', 'Missing dimension or its units for %1', this.currentCS);
  };
  TexParser.prototype.GetUpTo = function (_name, token) {
    while (this.nextIsSpace()) {
      this.i++;
    }
    var j = this.i;
    var parens = 0;
    while (this.i < this.string.length) {
      var k = this.i;
      var c = this.GetNext();
      this.i += c.length;
      switch (c) {
        case '\\':
          c += this.GetCS();
          break;
        case '{':
          parens++;
          break;
        case '}':
          if (parens === 0) {
            throw new TexError_js_1$j.default('ExtraCloseLooking', 'Extra close brace while looking for %1', token);
          }
          parens--;
          break;
      }
      if (parens === 0 && c === token) {
        return this.string.slice(j, k);
      }
    }
    throw new TexError_js_1$j.default('TokenNotFoundForCommand', 'Could not find %1 for %2', token, this.currentCS);
  };
  TexParser.prototype.ParseArg = function (name) {
    return new TexParser(this.GetArgument(name), this.stack.env, this.configuration).mml();
  };
  TexParser.prototype.ParseUpTo = function (name, token) {
    return new TexParser(this.GetUpTo(name, token), this.stack.env, this.configuration).mml();
  };
  TexParser.prototype.GetDelimiterArg = function (name) {
    var c = ParseUtil_js_1$f.default.trimSpaces(this.GetArgument(name));
    if (c === '') {
      return null;
    }
    if (this.contains('delimiter', c)) {
      return c;
    }
    throw new TexError_js_1$j.default('MissingOrUnrecognizedDelim', 'Missing or unrecognized delimiter for %1', this.currentCS);
  };
  TexParser.prototype.GetStar = function () {
    var star = this.GetNext() === '*';
    if (star) {
      this.i++;
    }
    return star;
  };
  TexParser.prototype.create = function (kind) {
    var _a;
    var rest = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      rest[_i - 1] = arguments[_i];
    }
    return (_a = this.configuration.nodeFactory).create.apply(_a, __spreadArray$r([kind], __read$L(rest), false));
  };
  return TexParser;
})();
TexParser$1.default = TexParser;

var ParseOptions$1 = {};

var StackItemFactory$1 = {};

var StackItem = {};

var __extends$1P = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$K = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$q = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$F = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$G = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(StackItem, "__esModule", {
  value: true
});
StackItem.BaseItem = StackItem.MmlStack = void 0;
var TexError_js_1$i = __importDefault$G(TexError$1);
var MmlStack = (function () {
  function MmlStack(_nodes) {
    this._nodes = _nodes;
  }
  Object.defineProperty(MmlStack.prototype, "nodes", {
    get: function () {
      return this._nodes;
    },
    enumerable: false,
    configurable: true
  });
  MmlStack.prototype.Push = function () {
    var _a;
    var nodes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      nodes[_i] = arguments[_i];
    }
    (_a = this._nodes).push.apply(_a, __spreadArray$q([], __read$K(nodes), false));
  };
  MmlStack.prototype.Pop = function () {
    return this._nodes.pop();
  };
  Object.defineProperty(MmlStack.prototype, "First", {
    get: function () {
      return this._nodes[this.Size() - 1];
    },
    set: function (node) {
      this._nodes[this.Size() - 1] = node;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlStack.prototype, "Last", {
    get: function () {
      return this._nodes[0];
    },
    set: function (node) {
      this._nodes[0] = node;
    },
    enumerable: false,
    configurable: true
  });
  MmlStack.prototype.Peek = function (n) {
    if (n == null) {
      n = 1;
    }
    return this._nodes.slice(this.Size() - n);
  };
  MmlStack.prototype.Size = function () {
    return this._nodes.length;
  };
  MmlStack.prototype.Clear = function () {
    this._nodes = [];
  };
  MmlStack.prototype.toMml = function (inferred, forceRow) {
    if (inferred === void 0) {
      inferred = true;
    }
    if (this._nodes.length === 1 && !forceRow) {
      return this.First;
    }
    return this.create('node', inferred ? 'inferredMrow' : 'mrow', this._nodes, {});
  };
  MmlStack.prototype.create = function (kind) {
    var _a;
    var rest = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      rest[_i - 1] = arguments[_i];
    }
    return (_a = this.factory.configuration.nodeFactory).create.apply(_a, __spreadArray$q([kind], __read$K(rest), false));
  };
  return MmlStack;
})();
StackItem.MmlStack = MmlStack;
var BaseItem = (function (_super) {
  __extends$1P(BaseItem, _super);
  function BaseItem(factory) {
    var nodes = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      nodes[_i - 1] = arguments[_i];
    }
    var _this = _super.call(this, nodes) || this;
    _this.factory = factory;
    _this.global = {};
    _this._properties = {};
    if (_this.isOpen) {
      _this._env = {};
    }
    return _this;
  }
  Object.defineProperty(BaseItem.prototype, "kind", {
    get: function () {
      return 'base';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BaseItem.prototype, "env", {
    get: function () {
      return this._env;
    },
    set: function (value) {
      this._env = value;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BaseItem.prototype, "copyEnv", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  BaseItem.prototype.getProperty = function (key) {
    return this._properties[key];
  };
  BaseItem.prototype.setProperty = function (key, value) {
    this._properties[key] = value;
    return this;
  };
  Object.defineProperty(BaseItem.prototype, "isOpen", {
    get: function () {
      return false;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BaseItem.prototype, "isClose", {
    get: function () {
      return false;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BaseItem.prototype, "isFinal", {
    get: function () {
      return false;
    },
    enumerable: false,
    configurable: true
  });
  BaseItem.prototype.isKind = function (kind) {
    return kind === this.kind;
  };
  BaseItem.prototype.checkItem = function (item) {
    if (item.isKind('over') && this.isOpen) {
      item.setProperty('num', this.toMml(false));
      this.Clear();
    }
    if (item.isKind('cell') && this.isOpen) {
      if (item.getProperty('linebreak')) {
        return BaseItem.fail;
      }
      throw new TexError_js_1$i.default('Misplaced', 'Misplaced %1', item.getName());
    }
    if (item.isClose && this.getErrors(item.kind)) {
      var _a = __read$K(this.getErrors(item.kind), 2), id = _a[0], message = _a[1];
      throw new TexError_js_1$i.default(id, message, item.getName());
    }
    if (!item.isFinal) {
      return BaseItem.success;
    }
    this.Push(item.First);
    return BaseItem.fail;
  };
  BaseItem.prototype.clearEnv = function () {
    var e_1, _a;
    try {
      for (var _b = __values$F(Object.keys(this.env)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var id = _c.value;
        delete this.env[id];
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  BaseItem.prototype.setProperties = function (def) {
    Object.assign(this._properties, def);
    return this;
  };
  BaseItem.prototype.getName = function () {
    return this.getProperty('name');
  };
  BaseItem.prototype.toString = function () {
    return this.kind + '[' + this.nodes.join('; ') + ']';
  };
  BaseItem.prototype.getErrors = function (kind) {
    var CLASS = this.constructor;
    return (CLASS.errors || ({}))[kind] || BaseItem.errors[kind];
  };
  BaseItem.fail = [null, false];
  BaseItem.success = [null, true];
  BaseItem.errors = {
    end: ['MissingBeginExtraEnd', 'Missing \\begin{%1} or extra \\end{%1}'],
    close: ['ExtraCloseMissingOpen', 'Extra close brace or missing open brace'],
    right: ['MissingLeftExtraRight', 'Missing \\left or extra \\right'],
    middle: ['ExtraMiddle', 'Extra \\middle']
  };
  return BaseItem;
})(MmlStack);
StackItem.BaseItem = BaseItem;

var Factory = {};

var __values$E = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$J = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$p = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(Factory, "__esModule", {
  value: true
});
Factory.AbstractFactory = void 0;
var AbstractFactory = (function () {
  function AbstractFactory(nodes) {
    var e_1, _a;
    if (nodes === void 0) {
      nodes = null;
    }
    this.defaultKind = 'unknown';
    this.nodeMap = new Map();
    this.node = {};
    if (nodes === null) {
      nodes = this.constructor.defaultNodes;
    }
    try {
      for (var _b = __values$E(Object.keys(nodes)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var kind = _c.value;
        this.setNodeClass(kind, nodes[kind]);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  }
  AbstractFactory.prototype.create = function (kind) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    return (this.node[kind] || this.node[this.defaultKind]).apply(void 0, __spreadArray$p([], __read$J(args), false));
  };
  AbstractFactory.prototype.setNodeClass = function (kind, nodeClass) {
    this.nodeMap.set(kind, nodeClass);
    var THIS = this;
    var KIND = this.nodeMap.get(kind);
    this.node[kind] = function () {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return new (KIND.bind.apply(KIND, __spreadArray$p([void 0, THIS], __read$J(args), false)))();
    };
  };
  AbstractFactory.prototype.getNodeClass = function (kind) {
    return this.nodeMap.get(kind);
  };
  AbstractFactory.prototype.deleteNodeClass = function (kind) {
    this.nodeMap.delete(kind);
    delete this.node[kind];
  };
  AbstractFactory.prototype.nodeIsKind = function (node, kind) {
    return node instanceof this.getNodeClass(kind);
  };
  AbstractFactory.prototype.getKinds = function () {
    return Array.from(this.nodeMap.keys());
  };
  AbstractFactory.defaultNodes = {};
  return AbstractFactory;
})();
Factory.AbstractFactory = AbstractFactory;

var __extends$1O = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var _a$b;
Object.defineProperty(StackItemFactory$1, "__esModule", {
  value: true
});
var StackItem_js_1$5 = StackItem;
var Factory_js_1$2 = Factory;
var DummyItem = (function (_super) {
  __extends$1O(DummyItem, _super);
  function DummyItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return DummyItem;
})(StackItem_js_1$5.BaseItem);
var StackItemFactory = (function (_super) {
  __extends$1O(StackItemFactory, _super);
  function StackItemFactory() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.defaultKind = 'dummy';
    _this.configuration = null;
    return _this;
  }
  StackItemFactory.DefaultStackItems = (_a$b = {}, _a$b[DummyItem.prototype.kind] = DummyItem, _a$b);
  return StackItemFactory;
})(Factory_js_1$2.AbstractFactory);
StackItemFactory$1.default = StackItemFactory;

var NodeFactory$2 = {};

var __read$I = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$o = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$F = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(NodeFactory$2, "__esModule", {
  value: true
});
NodeFactory$2.NodeFactory = void 0;
var NodeUtil_js_1$e = __importDefault$F(NodeUtil$1);
var NodeFactory$1 = (function () {
  function NodeFactory() {
    this.mmlFactory = null;
    this.factory = {
      'node': NodeFactory.createNode,
      'token': NodeFactory.createToken,
      'text': NodeFactory.createText,
      'error': NodeFactory.createError
    };
  }
  NodeFactory.createNode = function (factory, kind, children, def, text) {
    if (children === void 0) {
      children = [];
    }
    if (def === void 0) {
      def = {};
    }
    var node = factory.mmlFactory.create(kind);
    node.setChildren(children);
    if (text) {
      node.appendChild(text);
    }
    NodeUtil_js_1$e.default.setProperties(node, def);
    return node;
  };
  NodeFactory.createToken = function (factory, kind, def, text) {
    if (def === void 0) {
      def = {};
    }
    if (text === void 0) {
      text = '';
    }
    var textNode = factory.create('text', text);
    return factory.create('node', kind, [], def, textNode);
  };
  NodeFactory.createText = function (factory, text) {
    if (text == null) {
      return null;
    }
    return factory.mmlFactory.create('text').setText(text);
  };
  NodeFactory.createError = function (factory, message) {
    var text = factory.create('text', message);
    var mtext = factory.create('node', 'mtext', [], {}, text);
    var error = factory.create('node', 'merror', [mtext], {
      'data-mjx-error': message
    });
    return error;
  };
  NodeFactory.prototype.setMmlFactory = function (mmlFactory) {
    this.mmlFactory = mmlFactory;
  };
  NodeFactory.prototype.set = function (kind, func) {
    this.factory[kind] = func;
  };
  NodeFactory.prototype.setCreators = function (maps) {
    for (var kind in maps) {
      this.set(kind, maps[kind]);
    }
  };
  NodeFactory.prototype.create = function (kind) {
    var rest = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      rest[_i - 1] = arguments[_i];
    }
    var func = this.factory[kind] || this.factory['node'];
    var node = func.apply(void 0, __spreadArray$o([this, rest[0]], __read$I(rest.slice(1)), false));
    if (kind === 'node') {
      this.configuration.addNode(rest[0], node);
    }
    return node;
  };
  NodeFactory.prototype.get = function (kind) {
    return this.factory[kind];
  };
  return NodeFactory;
})();
NodeFactory$2.NodeFactory = NodeFactory$1;

var __read$H = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$n = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$D = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$E = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(ParseOptions$1, "__esModule", {
  value: true
});
var StackItemFactory_js_1 = __importDefault$E(StackItemFactory$1);
var NodeFactory_js_1$2 = NodeFactory$2;
var NodeUtil_js_1$d = __importDefault$E(NodeUtil$1);
var Options_js_1$9 = Options;
var ParseOptions = (function () {
  function ParseOptions(configuration, options) {
    if (options === void 0) {
      options = [];
    }
    this.options = {};
    this.packageData = new Map();
    this.parsers = [];
    this.root = null;
    this.nodeLists = {};
    this.error = false;
    this.handlers = configuration.handlers;
    this.nodeFactory = new NodeFactory_js_1$2.NodeFactory();
    this.nodeFactory.configuration = this;
    this.nodeFactory.setCreators(configuration.nodes);
    this.itemFactory = new StackItemFactory_js_1.default(configuration.items);
    this.itemFactory.configuration = this;
    Options_js_1$9.defaultOptions.apply(void 0, __spreadArray$n([this.options], __read$H(options), false));
    (0, Options_js_1$9.defaultOptions)(this.options, configuration.options);
  }
  ParseOptions.prototype.pushParser = function (parser) {
    this.parsers.unshift(parser);
  };
  ParseOptions.prototype.popParser = function () {
    this.parsers.shift();
  };
  Object.defineProperty(ParseOptions.prototype, "parser", {
    get: function () {
      return this.parsers[0];
    },
    enumerable: false,
    configurable: true
  });
  ParseOptions.prototype.clear = function () {
    this.parsers = [];
    this.root = null;
    this.nodeLists = {};
    this.error = false;
    this.tags.resetTag();
  };
  ParseOptions.prototype.addNode = function (property, node) {
    var list = this.nodeLists[property];
    if (!list) {
      list = this.nodeLists[property] = [];
    }
    list.push(node);
    if (node.kind !== property) {
      var inlists = NodeUtil_js_1$d.default.getProperty(node, 'in-lists') || '';
      var lists = (inlists ? inlists.split(/,/) : []).concat(property).join(',');
      NodeUtil_js_1$d.default.setProperty(node, 'in-lists', lists);
    }
  };
  ParseOptions.prototype.getList = function (property) {
    var e_1, _a;
    var list = this.nodeLists[property] || [];
    var result = [];
    try {
      for (var list_1 = __values$D(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
        var node = list_1_1.value;
        if (this.inTree(node)) {
          result.push(node);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (list_1_1 && !list_1_1.done && (_a = list_1.return)) _a.call(list_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    this.nodeLists[property] = result;
    return result;
  };
  ParseOptions.prototype.removeFromList = function (property, nodes) {
    var e_2, _a;
    var list = this.nodeLists[property] || [];
    try {
      for (var nodes_1 = __values$D(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
        var node = nodes_1_1.value;
        var i = list.indexOf(node);
        if (i >= 0) {
          list.splice(i, 1);
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  ParseOptions.prototype.inTree = function (node) {
    while (node && node !== this.root) {
      node = node.parent;
    }
    return !!node;
  };
  return ParseOptions;
})();
ParseOptions$1.default = ParseOptions;

var Tags = {};

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TagsFactory = exports.AllTags = exports.NoTags = exports.AbstractTags = exports.TagInfo = exports.Label = void 0;
  var TexParser_js_1 = __importDefault(TexParser$1);
  var Label = (function () {
    function Label(tag, id) {
      if (tag === void 0) {
        tag = '???';
      }
      if (id === void 0) {
        id = '';
      }
      this.tag = tag;
      this.id = id;
    }
    return Label;
  })();
  exports.Label = Label;
  var TagInfo = (function () {
    function TagInfo(env, taggable, defaultTags, tag, tagId, tagFormat, noTag, labelId) {
      if (env === void 0) {
        env = '';
      }
      if (taggable === void 0) {
        taggable = false;
      }
      if (defaultTags === void 0) {
        defaultTags = false;
      }
      if (tag === void 0) {
        tag = null;
      }
      if (tagId === void 0) {
        tagId = '';
      }
      if (tagFormat === void 0) {
        tagFormat = '';
      }
      if (noTag === void 0) {
        noTag = false;
      }
      if (labelId === void 0) {
        labelId = '';
      }
      this.env = env;
      this.taggable = taggable;
      this.defaultTags = defaultTags;
      this.tag = tag;
      this.tagId = tagId;
      this.tagFormat = tagFormat;
      this.noTag = noTag;
      this.labelId = labelId;
    }
    return TagInfo;
  })();
  exports.TagInfo = TagInfo;
  var AbstractTags = (function () {
    function AbstractTags() {
      this.counter = 0;
      this.allCounter = 0;
      this.configuration = null;
      this.ids = {};
      this.allIds = {};
      this.labels = {};
      this.allLabels = {};
      this.redo = false;
      this.refUpdate = false;
      this.currentTag = new TagInfo();
      this.history = [];
      this.stack = [];
      this.enTag = function (node, tag) {
        var nf = this.configuration.nodeFactory;
        var cell = nf.create('node', 'mtd', [node]);
        var row = nf.create('node', 'mlabeledtr', [tag, cell]);
        var table = nf.create('node', 'mtable', [row], {
          side: this.configuration.options['tagSide'],
          minlabelspacing: this.configuration.options['tagIndent'],
          displaystyle: true
        });
        return table;
      };
    }
    AbstractTags.prototype.start = function (env, taggable, defaultTags) {
      if (this.currentTag) {
        this.stack.push(this.currentTag);
      }
      this.currentTag = new TagInfo(env, taggable, defaultTags);
    };
    Object.defineProperty(AbstractTags.prototype, "env", {
      get: function () {
        return this.currentTag.env;
      },
      enumerable: false,
      configurable: true
    });
    AbstractTags.prototype.end = function () {
      this.history.push(this.currentTag);
      this.currentTag = this.stack.pop();
    };
    AbstractTags.prototype.tag = function (tag, noFormat) {
      this.currentTag.tag = tag;
      this.currentTag.tagFormat = noFormat ? tag : this.formatTag(tag);
      this.currentTag.noTag = false;
    };
    AbstractTags.prototype.notag = function () {
      this.tag('', true);
      this.currentTag.noTag = true;
    };
    Object.defineProperty(AbstractTags.prototype, "noTag", {
      get: function () {
        return this.currentTag.noTag;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(AbstractTags.prototype, "label", {
      get: function () {
        return this.currentTag.labelId;
      },
      set: function (label) {
        this.currentTag.labelId = label;
      },
      enumerable: false,
      configurable: true
    });
    AbstractTags.prototype.formatUrl = function (id, base) {
      return base + '#' + encodeURIComponent(id);
    };
    AbstractTags.prototype.formatTag = function (tag) {
      return '(' + tag + ')';
    };
    AbstractTags.prototype.formatId = function (id) {
      return 'mjx-eqn:' + id.replace(/\s/g, '_');
    };
    AbstractTags.prototype.formatNumber = function (n) {
      return n.toString();
    };
    AbstractTags.prototype.autoTag = function () {
      if (this.currentTag.tag == null) {
        this.counter++;
        this.tag(this.formatNumber(this.counter), false);
      }
    };
    AbstractTags.prototype.clearTag = function () {
      this.label = '';
      this.tag(null, true);
      this.currentTag.tagId = '';
    };
    AbstractTags.prototype.getTag = function (force) {
      if (force === void 0) {
        force = false;
      }
      if (force) {
        this.autoTag();
        return this.makeTag();
      }
      var ct = this.currentTag;
      if (ct.taggable && !ct.noTag) {
        if (ct.defaultTags) {
          this.autoTag();
        }
        if (ct.tag) {
          return this.makeTag();
        }
      }
      return null;
    };
    AbstractTags.prototype.resetTag = function () {
      this.history = [];
      this.redo = false;
      this.refUpdate = false;
      this.clearTag();
    };
    AbstractTags.prototype.reset = function (offset) {
      if (offset === void 0) {
        offset = 0;
      }
      this.resetTag();
      this.counter = this.allCounter = offset;
      this.allLabels = {};
      this.allIds = {};
    };
    AbstractTags.prototype.startEquation = function (math) {
      this.history = [];
      this.stack = [];
      this.clearTag();
      this.currentTag = new TagInfo('', undefined, undefined);
      this.labels = {};
      this.ids = {};
      this.counter = this.allCounter;
      this.redo = false;
      var recompile = math.inputData.recompile;
      if (recompile) {
        this.refUpdate = true;
        this.counter = recompile.counter;
      }
    };
    AbstractTags.prototype.finishEquation = function (math) {
      if (this.redo) {
        math.inputData.recompile = {
          state: math.state(),
          counter: this.allCounter
        };
      }
      if (!this.refUpdate) {
        this.allCounter = this.counter;
      }
      Object.assign(this.allIds, this.ids);
      Object.assign(this.allLabels, this.labels);
    };
    AbstractTags.prototype.finalize = function (node, env) {
      if (!env.display || this.currentTag.env || this.currentTag.tag == null) {
        return node;
      }
      var tag = this.makeTag();
      var table = this.enTag(node, tag);
      return table;
    };
    AbstractTags.prototype.makeId = function () {
      this.currentTag.tagId = this.formatId(this.configuration.options['useLabelIds'] ? this.label || this.currentTag.tag : this.currentTag.tag);
    };
    AbstractTags.prototype.makeTag = function () {
      this.makeId();
      if (this.label) {
        this.labels[this.label] = new Label(this.currentTag.tag, this.currentTag.tagId);
      }
      var mml = new TexParser_js_1.default('\\text{' + this.currentTag.tagFormat + '}', {}, this.configuration).mml();
      return this.configuration.nodeFactory.create('node', 'mtd', [mml], {
        id: this.currentTag.tagId
      });
    };
    return AbstractTags;
  })();
  exports.AbstractTags = AbstractTags;
  var NoTags = (function (_super) {
    __extends(NoTags, _super);
    function NoTags() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    NoTags.prototype.autoTag = function () {};
    NoTags.prototype.getTag = function () {
      return !this.currentTag.tag ? null : _super.prototype.getTag.call(this);
    };
    return NoTags;
  })(AbstractTags);
  exports.NoTags = NoTags;
  var AllTags = (function (_super) {
    __extends(AllTags, _super);
    function AllTags() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    AllTags.prototype.finalize = function (node, env) {
      if (!env.display || this.history.find(function (x) {
        return x.taggable;
      })) {
        return node;
      }
      var tag = this.getTag(true);
      return this.enTag(node, tag);
    };
    return AllTags;
  })(AbstractTags);
  exports.AllTags = AllTags;
  (function (TagsFactory) {
    var tagsMapping = new Map([['none', NoTags], ['all', AllTags]]);
    var defaultTags = 'none';
    TagsFactory.OPTIONS = {
      tags: defaultTags,
      tagSide: 'right',
      tagIndent: '0.8em',
      useLabelIds: true,
      ignoreDuplicateLabels: false
    };
    TagsFactory.add = function (name, constr) {
      tagsMapping.set(name, constr);
    };
    TagsFactory.addTags = function (tags) {
      var e_1, _a;
      try {
        for (var _b = __values(Object.keys(tags)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          TagsFactory.add(key, tags[key]);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    };
    TagsFactory.create = function (name) {
      var constr = tagsMapping.get(name) || tagsMapping.get(defaultTags);
      if (!constr) {
        throw Error('Unknown tags class');
      }
      return new constr();
    };
    TagsFactory.setDefault = function (name) {
      defaultTags = name;
    };
    TagsFactory.getDefault = function () {
      return TagsFactory.create(defaultTags);
    };
  })(exports.TagsFactory || (exports.TagsFactory = {}));
})(Tags);
getDefaultExportFromCjs(Tags);

var Configuration = {};

var MapHandler = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SubHandlers = exports.SubHandler = exports.MapHandler = void 0;
  var PrioritizedList_js_1 = PrioritizedList$1;
  var FunctionList_js_1 = FunctionList$1;
  var MapHandler;
  (function (MapHandler) {
    var maps = new Map();
    MapHandler.register = function (map) {
      maps.set(map.name, map);
    };
    MapHandler.getMap = function (name) {
      return maps.get(name);
    };
  })(MapHandler = exports.MapHandler || (exports.MapHandler = {}));
  var SubHandler = (function () {
    function SubHandler() {
      this._configuration = new PrioritizedList_js_1.PrioritizedList();
      this._fallback = new FunctionList_js_1.FunctionList();
    }
    SubHandler.prototype.add = function (maps, fallback, priority) {
      var e_1, _a;
      if (priority === void 0) {
        priority = PrioritizedList_js_1.PrioritizedList.DEFAULTPRIORITY;
      }
      try {
        for (var _b = __values(maps.slice().reverse()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var name_1 = _c.value;
          var map = MapHandler.getMap(name_1);
          if (!map) {
            this.warn('Configuration ' + name_1 + ' not found! Omitted.');
            return;
          }
          this._configuration.add(map, priority);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      if (fallback) {
        this._fallback.add(fallback, priority);
      }
    };
    SubHandler.prototype.parse = function (input) {
      var e_2, _a;
      try {
        for (var _b = __values(this._configuration), _c = _b.next(); !_c.done; _c = _b.next()) {
          var map = _c.value.item;
          var result = map.parse(input);
          if (result) {
            return result;
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      var _d = __read(input, 2), env = _d[0], symbol = _d[1];
      Array.from(this._fallback)[0].item(env, symbol);
    };
    SubHandler.prototype.lookup = function (symbol) {
      var map = this.applicable(symbol);
      return map ? map.lookup(symbol) : null;
    };
    SubHandler.prototype.contains = function (symbol) {
      return this.applicable(symbol) ? true : false;
    };
    SubHandler.prototype.toString = function () {
      var e_3, _a;
      var names = [];
      try {
        for (var _b = __values(this._configuration), _c = _b.next(); !_c.done; _c = _b.next()) {
          var map = _c.value.item;
          names.push(map.name);
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      return names.join(', ');
    };
    SubHandler.prototype.applicable = function (symbol) {
      var e_4, _a;
      try {
        for (var _b = __values(this._configuration), _c = _b.next(); !_c.done; _c = _b.next()) {
          var map = _c.value.item;
          if (map.contains(symbol)) {
            return map;
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
      return null;
    };
    SubHandler.prototype.retrieve = function (name) {
      var e_5, _a;
      try {
        for (var _b = __values(this._configuration), _c = _b.next(); !_c.done; _c = _b.next()) {
          var map = _c.value.item;
          if (map.name === name) {
            return map;
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      return null;
    };
    SubHandler.prototype.warn = function (message) {
      console.log('TexParser Warning: ' + message);
    };
    return SubHandler;
  })();
  exports.SubHandler = SubHandler;
  var SubHandlers = (function () {
    function SubHandlers() {
      this.map = new Map();
    }
    SubHandlers.prototype.add = function (handlers, fallbacks, priority) {
      var e_6, _a;
      if (priority === void 0) {
        priority = PrioritizedList_js_1.PrioritizedList.DEFAULTPRIORITY;
      }
      try {
        for (var _b = __values(Object.keys(handlers)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          var name_2 = key;
          var subHandler = this.get(name_2);
          if (!subHandler) {
            subHandler = new SubHandler();
            this.set(name_2, subHandler);
          }
          subHandler.add(handlers[name_2], fallbacks[name_2], priority);
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
    };
    SubHandlers.prototype.set = function (name, subHandler) {
      this.map.set(name, subHandler);
    };
    SubHandlers.prototype.get = function (name) {
      return this.map.get(name);
    };
    SubHandlers.prototype.retrieve = function (name) {
      var e_7, _a;
      try {
        for (var _b = __values(this.map.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var handler = _c.value;
          var map = handler.retrieve(name);
          if (map) {
            return map;
          }
        }
      } catch (e_7_1) {
        e_7 = {
          error: e_7_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_7) throw e_7.error;
        }
      }
      return null;
    };
    SubHandlers.prototype.keys = function () {
      return this.map.keys();
    };
    return SubHandlers;
  })();
  exports.SubHandlers = SubHandlers;
})(MapHandler);
getDefaultExportFromCjs(MapHandler);

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ParserConfiguration = exports.ConfigurationHandler = exports.Configuration = void 0;
  var Options_js_1 = Options;
  var MapHandler_js_1 = MapHandler;
  var FunctionList_js_1 = FunctionList$1;
  var PrioritizedList_js_1 = PrioritizedList$1;
  var Tags_js_1 = Tags;
  var Configuration = (function () {
    function Configuration(name, handler, fallback, items, tags, options, nodes, preprocessors, postprocessors, initMethod, configMethod, priority, parser) {
      if (handler === void 0) {
        handler = {};
      }
      if (fallback === void 0) {
        fallback = {};
      }
      if (items === void 0) {
        items = {};
      }
      if (tags === void 0) {
        tags = {};
      }
      if (options === void 0) {
        options = {};
      }
      if (nodes === void 0) {
        nodes = {};
      }
      if (preprocessors === void 0) {
        preprocessors = [];
      }
      if (postprocessors === void 0) {
        postprocessors = [];
      }
      if (initMethod === void 0) {
        initMethod = null;
      }
      if (configMethod === void 0) {
        configMethod = null;
      }
      this.name = name;
      this.handler = handler;
      this.fallback = fallback;
      this.items = items;
      this.tags = tags;
      this.options = options;
      this.nodes = nodes;
      this.preprocessors = preprocessors;
      this.postprocessors = postprocessors;
      this.initMethod = initMethod;
      this.configMethod = configMethod;
      this.priority = priority;
      this.parser = parser;
      this.handler = Object.assign({
        character: [],
        delimiter: [],
        macro: [],
        environment: []
      }, handler);
    }
    Configuration.makeProcessor = function (func, priority) {
      return Array.isArray(func) ? func : [func, priority];
    };
    Configuration._create = function (name, config) {
      var _this = this;
      if (config === void 0) {
        config = {};
      }
      var priority = config.priority || PrioritizedList_js_1.PrioritizedList.DEFAULTPRIORITY;
      var init = config.init ? this.makeProcessor(config.init, priority) : null;
      var conf = config.config ? this.makeProcessor(config.config, priority) : null;
      var preprocessors = (config.preprocessors || []).map(function (pre) {
        return _this.makeProcessor(pre, priority);
      });
      var postprocessors = (config.postprocessors || []).map(function (post) {
        return _this.makeProcessor(post, priority);
      });
      var parser = config.parser || 'tex';
      return new Configuration(name, config.handler || ({}), config.fallback || ({}), config.items || ({}), config.tags || ({}), config.options || ({}), config.nodes || ({}), preprocessors, postprocessors, init, conf, priority, parser);
    };
    Configuration.create = function (name, config) {
      if (config === void 0) {
        config = {};
      }
      var configuration = Configuration._create(name, config);
      ConfigurationHandler.set(name, configuration);
      return configuration;
    };
    Configuration.local = function (config) {
      if (config === void 0) {
        config = {};
      }
      return Configuration._create('', config);
    };
    Object.defineProperty(Configuration.prototype, "init", {
      get: function () {
        return this.initMethod ? this.initMethod[0] : null;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(Configuration.prototype, "config", {
      get: function () {
        return this.configMethod ? this.configMethod[0] : null;
      },
      enumerable: false,
      configurable: true
    });
    return Configuration;
  })();
  exports.Configuration = Configuration;
  var ConfigurationHandler;
  (function (ConfigurationHandler) {
    var maps = new Map();
    ConfigurationHandler.set = function (name, map) {
      maps.set(name, map);
    };
    ConfigurationHandler.get = function (name) {
      return maps.get(name);
    };
    ConfigurationHandler.keys = function () {
      return maps.keys();
    };
  })(ConfigurationHandler = exports.ConfigurationHandler || (exports.ConfigurationHandler = {}));
  var ParserConfiguration = (function () {
    function ParserConfiguration(packages, parsers) {
      var e_1, _a, e_2, _b;
      if (parsers === void 0) {
        parsers = ['tex'];
      }
      this.initMethod = new FunctionList_js_1.FunctionList();
      this.configMethod = new FunctionList_js_1.FunctionList();
      this.configurations = new PrioritizedList_js_1.PrioritizedList();
      this.parsers = [];
      this.handlers = new MapHandler_js_1.SubHandlers();
      this.items = {};
      this.tags = {};
      this.options = {};
      this.nodes = {};
      this.parsers = parsers;
      try {
        for (var _c = __values(packages.slice().reverse()), _d = _c.next(); !_d.done; _d = _c.next()) {
          var pkg = _d.value;
          this.addPackage(pkg);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      try {
        for (var _e = __values(this.configurations), _f = _e.next(); !_f.done; _f = _e.next()) {
          var _g = _f.value, config = _g.item, priority = _g.priority;
          this.append(config, priority);
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }
    ParserConfiguration.prototype.init = function () {
      this.initMethod.execute(this);
    };
    ParserConfiguration.prototype.config = function (jax) {
      var e_3, _a;
      this.configMethod.execute(this, jax);
      try {
        for (var _b = __values(this.configurations), _c = _b.next(); !_c.done; _c = _b.next()) {
          var config = _c.value;
          this.addFilters(jax, config.item);
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
    };
    ParserConfiguration.prototype.addPackage = function (pkg) {
      var name = typeof pkg === 'string' ? pkg : pkg[0];
      var conf = this.getPackage(name);
      conf && this.configurations.add(conf, typeof pkg === 'string' ? conf.priority : pkg[1]);
    };
    ParserConfiguration.prototype.add = function (name, jax, options) {
      var e_4, _a;
      if (options === void 0) {
        options = {};
      }
      var config = this.getPackage(name);
      this.append(config);
      this.configurations.add(config, config.priority);
      this.init();
      var parser = jax.parseOptions;
      parser.nodeFactory.setCreators(config.nodes);
      try {
        for (var _b = __values(Object.keys(config.items)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var kind = _c.value;
          parser.itemFactory.setNodeClass(kind, config.items[kind]);
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
      Tags_js_1.TagsFactory.addTags(config.tags);
      (0, Options_js_1.defaultOptions)(parser.options, config.options);
      (0, Options_js_1.userOptions)(parser.options, options);
      this.addFilters(jax, config);
      if (config.config) {
        config.config(this, jax);
      }
    };
    ParserConfiguration.prototype.getPackage = function (name) {
      var config = ConfigurationHandler.get(name);
      if (config && this.parsers.indexOf(config.parser) < 0) {
        throw Error(("Package ").concat(name, " doesn't target the proper parser"));
      }
      return config;
    };
    ParserConfiguration.prototype.append = function (config, priority) {
      priority = priority || config.priority;
      if (config.initMethod) {
        this.initMethod.add(config.initMethod[0], config.initMethod[1]);
      }
      if (config.configMethod) {
        this.configMethod.add(config.configMethod[0], config.configMethod[1]);
      }
      this.handlers.add(config.handler, config.fallback, priority);
      Object.assign(this.items, config.items);
      Object.assign(this.tags, config.tags);
      (0, Options_js_1.defaultOptions)(this.options, config.options);
      Object.assign(this.nodes, config.nodes);
    };
    ParserConfiguration.prototype.addFilters = function (jax, config) {
      var e_5, _a, e_6, _b;
      try {
        for (var _c = __values(config.preprocessors), _d = _c.next(); !_d.done; _d = _c.next()) {
          var _e = __read(_d.value, 2), pre = _e[0], priority = _e[1];
          jax.preFilters.add(pre, priority);
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      try {
        for (var _f = __values(config.postprocessors), _g = _f.next(); !_g.done; _g = _f.next()) {
          var _h = __read(_g.value, 2), post = _h[0], priority = _h[1];
          jax.postFilters.add(post, priority);
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
    };
    return ParserConfiguration;
  })();
  exports.ParserConfiguration = ParserConfiguration;
})(Configuration);
getDefaultExportFromCjs(Configuration);

var BaseConfiguration = {};

var SymbolMap = {};

var _Symbol = {};

Object.defineProperty(_Symbol, "__esModule", {
  value: true
});
_Symbol.Macro = _Symbol.Symbol = void 0;
var Symbol$1 = (function () {
  function Symbol(_symbol, _char, _attributes) {
    this._symbol = _symbol;
    this._char = _char;
    this._attributes = _attributes;
  }
  Object.defineProperty(Symbol.prototype, "symbol", {
    get: function () {
      return this._symbol;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Symbol.prototype, "char", {
    get: function () {
      return this._char;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Symbol.prototype, "attributes", {
    get: function () {
      return this._attributes;
    },
    enumerable: false,
    configurable: true
  });
  return Symbol;
})();
_Symbol.Symbol = Symbol$1;
var Macro = (function () {
  function Macro(_symbol, _func, _args) {
    if (_args === void 0) {
      _args = [];
    }
    this._symbol = _symbol;
    this._func = _func;
    this._args = _args;
  }
  Object.defineProperty(Macro.prototype, "symbol", {
    get: function () {
      return this._symbol;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Macro.prototype, "func", {
    get: function () {
      return this._func;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Macro.prototype, "args", {
    get: function () {
      return this._args;
    },
    enumerable: false,
    configurable: true
  });
  return Macro;
})();
_Symbol.Macro = Macro;

var __extends$1N = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$G = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$C = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __spreadArray$m = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(SymbolMap, "__esModule", {
  value: true
});
SymbolMap.EnvironmentMap = SymbolMap.CommandMap = SymbolMap.MacroMap = SymbolMap.DelimiterMap = SymbolMap.CharacterMap = SymbolMap.AbstractParseMap = SymbolMap.RegExpMap = SymbolMap.AbstractSymbolMap = SymbolMap.parseResult = void 0;
var Symbol_js_1$3 = _Symbol;
var MapHandler_js_1$2 = MapHandler;
function parseResult(result) {
  return result === void 0 ? true : result;
}
SymbolMap.parseResult = parseResult;
var AbstractSymbolMap = (function () {
  function AbstractSymbolMap(_name, _parser) {
    this._name = _name;
    this._parser = _parser;
    MapHandler_js_1$2.MapHandler.register(this);
  }
  Object.defineProperty(AbstractSymbolMap.prototype, "name", {
    get: function () {
      return this._name;
    },
    enumerable: false,
    configurable: true
  });
  AbstractSymbolMap.prototype.parserFor = function (symbol) {
    return this.contains(symbol) ? this.parser : null;
  };
  AbstractSymbolMap.prototype.parse = function (_a) {
    var _b = __read$G(_a, 2), env = _b[0], symbol = _b[1];
    var parser = this.parserFor(symbol);
    var mapped = this.lookup(symbol);
    return parser && mapped ? parseResult(parser(env, mapped)) : null;
  };
  Object.defineProperty(AbstractSymbolMap.prototype, "parser", {
    get: function () {
      return this._parser;
    },
    set: function (parser) {
      this._parser = parser;
    },
    enumerable: false,
    configurable: true
  });
  return AbstractSymbolMap;
})();
SymbolMap.AbstractSymbolMap = AbstractSymbolMap;
var RegExpMap = (function (_super) {
  __extends$1N(RegExpMap, _super);
  function RegExpMap(name, parser, _regExp) {
    var _this = _super.call(this, name, parser) || this;
    _this._regExp = _regExp;
    return _this;
  }
  RegExpMap.prototype.contains = function (symbol) {
    return this._regExp.test(symbol);
  };
  RegExpMap.prototype.lookup = function (symbol) {
    return this.contains(symbol) ? symbol : null;
  };
  return RegExpMap;
})(AbstractSymbolMap);
SymbolMap.RegExpMap = RegExpMap;
var AbstractParseMap = (function (_super) {
  __extends$1N(AbstractParseMap, _super);
  function AbstractParseMap() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.map = new Map();
    return _this;
  }
  AbstractParseMap.prototype.lookup = function (symbol) {
    return this.map.get(symbol);
  };
  AbstractParseMap.prototype.contains = function (symbol) {
    return this.map.has(symbol);
  };
  AbstractParseMap.prototype.add = function (symbol, object) {
    this.map.set(symbol, object);
  };
  AbstractParseMap.prototype.remove = function (symbol) {
    this.map.delete(symbol);
  };
  return AbstractParseMap;
})(AbstractSymbolMap);
SymbolMap.AbstractParseMap = AbstractParseMap;
var CharacterMap = (function (_super) {
  __extends$1N(CharacterMap, _super);
  function CharacterMap(name, parser, json) {
    var e_1, _a;
    var _this = _super.call(this, name, parser) || this;
    try {
      for (var _b = __values$C(Object.keys(json)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var key = _c.value;
        var value = json[key];
        var _d = __read$G(typeof value === 'string' ? [value, null] : value, 2), char = _d[0], attrs = _d[1];
        var character = new Symbol_js_1$3.Symbol(key, char, attrs);
        _this.add(key, character);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return _this;
  }
  return CharacterMap;
})(AbstractParseMap);
SymbolMap.CharacterMap = CharacterMap;
var DelimiterMap = (function (_super) {
  __extends$1N(DelimiterMap, _super);
  function DelimiterMap() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DelimiterMap.prototype.parse = function (_a) {
    var _b = __read$G(_a, 2), env = _b[0], symbol = _b[1];
    return _super.prototype.parse.call(this, [env, '\\' + symbol]);
  };
  return DelimiterMap;
})(CharacterMap);
SymbolMap.DelimiterMap = DelimiterMap;
var MacroMap = (function (_super) {
  __extends$1N(MacroMap, _super);
  function MacroMap(name, json, functionMap) {
    var e_2, _a;
    var _this = _super.call(this, name, null) || this;
    try {
      for (var _b = __values$C(Object.keys(json)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var key = _c.value;
        var value = json[key];
        var _d = __read$G(typeof value === 'string' ? [value] : value), func = _d[0], attrs = _d.slice(1);
        var character = new Symbol_js_1$3.Macro(key, functionMap[func], attrs);
        _this.add(key, character);
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    return _this;
  }
  MacroMap.prototype.parserFor = function (symbol) {
    var macro = this.lookup(symbol);
    return macro ? macro.func : null;
  };
  MacroMap.prototype.parse = function (_a) {
    var _b = __read$G(_a, 2), env = _b[0], symbol = _b[1];
    var macro = this.lookup(symbol);
    var parser = this.parserFor(symbol);
    if (!macro || !parser) {
      return null;
    }
    return parseResult(parser.apply(void 0, __spreadArray$m([env, macro.symbol], __read$G(macro.args), false)));
  };
  return MacroMap;
})(AbstractParseMap);
SymbolMap.MacroMap = MacroMap;
var CommandMap = (function (_super) {
  __extends$1N(CommandMap, _super);
  function CommandMap() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CommandMap.prototype.parse = function (_a) {
    var _b = __read$G(_a, 2), env = _b[0], symbol = _b[1];
    var macro = this.lookup(symbol);
    var parser = this.parserFor(symbol);
    if (!macro || !parser) {
      return null;
    }
    var saveCommand = env.currentCS;
    env.currentCS = '\\' + symbol;
    var result = parser.apply(void 0, __spreadArray$m([env, '\\' + macro.symbol], __read$G(macro.args), false));
    env.currentCS = saveCommand;
    return parseResult(result);
  };
  return CommandMap;
})(MacroMap);
SymbolMap.CommandMap = CommandMap;
var EnvironmentMap = (function (_super) {
  __extends$1N(EnvironmentMap, _super);
  function EnvironmentMap(name, parser, json, functionMap) {
    var _this = _super.call(this, name, json, functionMap) || this;
    _this.parser = parser;
    return _this;
  }
  EnvironmentMap.prototype.parse = function (_a) {
    var _b = __read$G(_a, 2), env = _b[0], symbol = _b[1];
    var macro = this.lookup(symbol);
    var envParser = this.parserFor(symbol);
    if (!macro || !envParser) {
      return null;
    }
    return parseResult(this.parser(env, macro.symbol, envParser, macro.args));
  };
  return EnvironmentMap;
})(MacroMap);
SymbolMap.EnvironmentMap = EnvironmentMap;

var BaseItems = {};

var __extends$1M = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$F = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$l = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$D = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BaseItems, "__esModule", {
  value: true
});
BaseItems.EquationItem = BaseItems.EqnArrayItem = BaseItems.ArrayItem = BaseItems.DotsItem = BaseItems.NonscriptItem = BaseItems.NotItem = BaseItems.FnItem = BaseItems.MmlItem = BaseItems.CellItem = BaseItems.PositionItem = BaseItems.StyleItem = BaseItems.EndItem = BaseItems.BeginItem = BaseItems.RightItem = BaseItems.Middle = BaseItems.LeftItem = BaseItems.OverItem = BaseItems.SubsupItem = BaseItems.PrimeItem = BaseItems.CloseItem = BaseItems.OpenItem = BaseItems.StopItem = BaseItems.StartItem = void 0;
var MapHandler_js_1$1 = MapHandler;
var Entities_js_1$1 = Entities$1;
var MmlNode_js_1$J = MmlNode;
var TexError_js_1$h = __importDefault$D(TexError$1);
var ParseUtil_js_1$e = __importDefault$D(ParseUtil$1);
var NodeUtil_js_1$c = __importDefault$D(NodeUtil$1);
var StackItem_js_1$4 = StackItem;
var StartItem = (function (_super) {
  __extends$1M(StartItem, _super);
  function StartItem(factory, global) {
    var _this = _super.call(this, factory) || this;
    _this.global = global;
    return _this;
  }
  Object.defineProperty(StartItem.prototype, "kind", {
    get: function () {
      return 'start';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(StartItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  StartItem.prototype.checkItem = function (item) {
    if (item.isKind('stop')) {
      var node = this.toMml();
      if (!this.global.isInner) {
        node = this.factory.configuration.tags.finalize(node, this.env);
      }
      return [[this.factory.create('mml', node)], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  return StartItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.StartItem = StartItem;
var StopItem = (function (_super) {
  __extends$1M(StopItem, _super);
  function StopItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(StopItem.prototype, "kind", {
    get: function () {
      return 'stop';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(StopItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return StopItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.StopItem = StopItem;
var OpenItem = (function (_super) {
  __extends$1M(OpenItem, _super);
  function OpenItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(OpenItem.prototype, "kind", {
    get: function () {
      return 'open';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(OpenItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  OpenItem.prototype.checkItem = function (item) {
    if (item.isKind('close')) {
      var mml = this.toMml();
      var node = this.create('node', 'TeXAtom', [mml]);
      return [[this.factory.create('mml', node)], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  OpenItem.errors = Object.assign(Object.create(StackItem_js_1$4.BaseItem.errors), {
    'stop': ['ExtraOpenMissingClose', 'Extra open brace or missing close brace']
  });
  return OpenItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.OpenItem = OpenItem;
var CloseItem = (function (_super) {
  __extends$1M(CloseItem, _super);
  function CloseItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(CloseItem.prototype, "kind", {
    get: function () {
      return 'close';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(CloseItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return CloseItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.CloseItem = CloseItem;
var PrimeItem = (function (_super) {
  __extends$1M(PrimeItem, _super);
  function PrimeItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(PrimeItem.prototype, "kind", {
    get: function () {
      return 'prime';
    },
    enumerable: false,
    configurable: true
  });
  PrimeItem.prototype.checkItem = function (item) {
    var _a = __read$F(this.Peek(2), 2), top0 = _a[0], top1 = _a[1];
    if (!NodeUtil_js_1$c.default.isType(top0, 'msubsup') || NodeUtil_js_1$c.default.isType(top0, 'msup')) {
      var node = this.create('node', 'msup', [top0, top1]);
      return [[node, item], true];
    }
    NodeUtil_js_1$c.default.setChild(top0, top0.sup, top1);
    return [[top0, item], true];
  };
  return PrimeItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.PrimeItem = PrimeItem;
var SubsupItem = (function (_super) {
  __extends$1M(SubsupItem, _super);
  function SubsupItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(SubsupItem.prototype, "kind", {
    get: function () {
      return 'subsup';
    },
    enumerable: false,
    configurable: true
  });
  SubsupItem.prototype.checkItem = function (item) {
    if (item.isKind('open') || item.isKind('left')) {
      return StackItem_js_1$4.BaseItem.success;
    }
    var top = this.First;
    var position = this.getProperty('position');
    if (item.isKind('mml')) {
      if (this.getProperty('primes')) {
        if (position !== 2) {
          NodeUtil_js_1$c.default.setChild(top, 2, this.getProperty('primes'));
        } else {
          NodeUtil_js_1$c.default.setProperty(this.getProperty('primes'), 'variantForm', true);
          var node = this.create('node', 'mrow', [this.getProperty('primes'), item.First]);
          item.First = node;
        }
      }
      NodeUtil_js_1$c.default.setChild(top, position, item.First);
      if (this.getProperty('movesupsub') != null) {
        NodeUtil_js_1$c.default.setProperty(top, 'movesupsub', this.getProperty('movesupsub'));
      }
      var result = this.factory.create('mml', top);
      return [[result], true];
    }
    if (_super.prototype.checkItem.call(this, item)[1]) {
      var error = this.getErrors(['', 'sub', 'sup'][position]);
      throw new (TexError_js_1$h.default.bind.apply(TexError_js_1$h.default, __spreadArray$l([void 0, error[0], error[1]], __read$F(error.splice(2)), false)))();
    }
    return null;
  };
  SubsupItem.errors = Object.assign(Object.create(StackItem_js_1$4.BaseItem.errors), {
    'stop': ['MissingScript', 'Missing superscript or subscript argument'],
    'sup': ['MissingOpenForSup', 'Missing open brace for superscript'],
    'sub': ['MissingOpenForSub', 'Missing open brace for subscript']
  });
  return SubsupItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.SubsupItem = SubsupItem;
var OverItem = (function (_super) {
  __extends$1M(OverItem, _super);
  function OverItem(factory) {
    var _this = _super.call(this, factory) || this;
    _this.setProperty('name', '\\over');
    return _this;
  }
  Object.defineProperty(OverItem.prototype, "kind", {
    get: function () {
      return 'over';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(OverItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  OverItem.prototype.checkItem = function (item) {
    if (item.isKind('over')) {
      throw new TexError_js_1$h.default('AmbiguousUseOf', 'Ambiguous use of %1', item.getName());
    }
    if (item.isClose) {
      var mml = this.create('node', 'mfrac', [this.getProperty('num'), this.toMml(false)]);
      if (this.getProperty('thickness') != null) {
        NodeUtil_js_1$c.default.setAttribute(mml, 'linethickness', this.getProperty('thickness'));
      }
      if (this.getProperty('open') || this.getProperty('close')) {
        NodeUtil_js_1$c.default.setProperty(mml, 'withDelims', true);
        mml = ParseUtil_js_1$e.default.fixedFence(this.factory.configuration, this.getProperty('open'), mml, this.getProperty('close'));
      }
      return [[this.factory.create('mml', mml), item], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  OverItem.prototype.toString = function () {
    return 'over[' + this.getProperty('num') + ' / ' + this.nodes.join('; ') + ']';
  };
  return OverItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.OverItem = OverItem;
var LeftItem = (function (_super) {
  __extends$1M(LeftItem, _super);
  function LeftItem(factory, delim) {
    var _this = _super.call(this, factory) || this;
    _this.setProperty('delim', delim);
    return _this;
  }
  Object.defineProperty(LeftItem.prototype, "kind", {
    get: function () {
      return 'left';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(LeftItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  LeftItem.prototype.checkItem = function (item) {
    if (item.isKind('right')) {
      return [[this.factory.create('mml', ParseUtil_js_1$e.default.fenced(this.factory.configuration, this.getProperty('delim'), this.toMml(), item.getProperty('delim'), '', item.getProperty('color')))], true];
    }
    if (item.isKind('middle')) {
      var def = {
        stretchy: true
      };
      if (item.getProperty('color')) {
        def.mathcolor = item.getProperty('color');
      }
      this.Push(this.create('node', 'TeXAtom', [], {
        texClass: MmlNode_js_1$J.TEXCLASS.CLOSE
      }), this.create('token', 'mo', def, item.getProperty('delim')), this.create('node', 'TeXAtom', [], {
        texClass: MmlNode_js_1$J.TEXCLASS.OPEN
      }));
      this.env = {};
      return [[this], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  LeftItem.errors = Object.assign(Object.create(StackItem_js_1$4.BaseItem.errors), {
    'stop': ['ExtraLeftMissingRight', 'Extra \\left or missing \\right']
  });
  return LeftItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.LeftItem = LeftItem;
var Middle = (function (_super) {
  __extends$1M(Middle, _super);
  function Middle(factory, delim, color) {
    var _this = _super.call(this, factory) || this;
    _this.setProperty('delim', delim);
    color && _this.setProperty('color', color);
    return _this;
  }
  Object.defineProperty(Middle.prototype, "kind", {
    get: function () {
      return 'middle';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Middle.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return Middle;
})(StackItem_js_1$4.BaseItem);
BaseItems.Middle = Middle;
var RightItem = (function (_super) {
  __extends$1M(RightItem, _super);
  function RightItem(factory, delim, color) {
    var _this = _super.call(this, factory) || this;
    _this.setProperty('delim', delim);
    color && _this.setProperty('color', color);
    return _this;
  }
  Object.defineProperty(RightItem.prototype, "kind", {
    get: function () {
      return 'right';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(RightItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return RightItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.RightItem = RightItem;
var BeginItem = (function (_super) {
  __extends$1M(BeginItem, _super);
  function BeginItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(BeginItem.prototype, "kind", {
    get: function () {
      return 'begin';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BeginItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  BeginItem.prototype.checkItem = function (item) {
    if (item.isKind('end')) {
      if (item.getName() !== this.getName()) {
        throw new TexError_js_1$h.default('EnvBadEnd', '\\begin{%1} ended with \\end{%2}', this.getName(), item.getName());
      }
      if (!this.getProperty('end')) {
        return [[this.factory.create('mml', this.toMml())], true];
      }
      return StackItem_js_1$4.BaseItem.fail;
    }
    if (item.isKind('stop')) {
      throw new TexError_js_1$h.default('EnvMissingEnd', 'Missing \\end{%1}', this.getName());
    }
    return _super.prototype.checkItem.call(this, item);
  };
  return BeginItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.BeginItem = BeginItem;
var EndItem = (function (_super) {
  __extends$1M(EndItem, _super);
  function EndItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(EndItem.prototype, "kind", {
    get: function () {
      return 'end';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(EndItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return EndItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.EndItem = EndItem;
var StyleItem = (function (_super) {
  __extends$1M(StyleItem, _super);
  function StyleItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(StyleItem.prototype, "kind", {
    get: function () {
      return 'style';
    },
    enumerable: false,
    configurable: true
  });
  StyleItem.prototype.checkItem = function (item) {
    if (!item.isClose) {
      return _super.prototype.checkItem.call(this, item);
    }
    var mml = this.create('node', 'mstyle', this.nodes, this.getProperty('styles'));
    return [[this.factory.create('mml', mml), item], true];
  };
  return StyleItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.StyleItem = StyleItem;
var PositionItem = (function (_super) {
  __extends$1M(PositionItem, _super);
  function PositionItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(PositionItem.prototype, "kind", {
    get: function () {
      return 'position';
    },
    enumerable: false,
    configurable: true
  });
  PositionItem.prototype.checkItem = function (item) {
    if (item.isClose) {
      throw new TexError_js_1$h.default('MissingBoxFor', 'Missing box for %1', this.getName());
    }
    if (item.isFinal) {
      var mml = item.toMml();
      switch (this.getProperty('move')) {
        case 'vertical':
          mml = this.create('node', 'mpadded', [mml], {
            height: this.getProperty('dh'),
            depth: this.getProperty('dd'),
            voffset: this.getProperty('dh')
          });
          return [[this.factory.create('mml', mml)], true];
        case 'horizontal':
          return [[this.factory.create('mml', this.getProperty('left')), item, this.factory.create('mml', this.getProperty('right'))], true];
      }
    }
    return _super.prototype.checkItem.call(this, item);
  };
  return PositionItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.PositionItem = PositionItem;
var CellItem = (function (_super) {
  __extends$1M(CellItem, _super);
  function CellItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(CellItem.prototype, "kind", {
    get: function () {
      return 'cell';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(CellItem.prototype, "isClose", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  return CellItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.CellItem = CellItem;
var MmlItem = (function (_super) {
  __extends$1M(MmlItem, _super);
  function MmlItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlItem.prototype, "isFinal", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlItem.prototype, "kind", {
    get: function () {
      return 'mml';
    },
    enumerable: false,
    configurable: true
  });
  return MmlItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.MmlItem = MmlItem;
var FnItem = (function (_super) {
  __extends$1M(FnItem, _super);
  function FnItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(FnItem.prototype, "kind", {
    get: function () {
      return 'fn';
    },
    enumerable: false,
    configurable: true
  });
  FnItem.prototype.checkItem = function (item) {
    var top = this.First;
    if (top) {
      if (item.isOpen) {
        return StackItem_js_1$4.BaseItem.success;
      }
      if (!item.isKind('fn')) {
        var mml = item.First;
        if (!item.isKind('mml') || !mml) {
          return [[top, item], true];
        }
        if (NodeUtil_js_1$c.default.isType(mml, 'mstyle') && mml.childNodes.length && NodeUtil_js_1$c.default.isType(mml.childNodes[0].childNodes[0], 'mspace') || NodeUtil_js_1$c.default.isType(mml, 'mspace')) {
          return [[top, item], true];
        }
        if (NodeUtil_js_1$c.default.isEmbellished(mml)) {
          mml = NodeUtil_js_1$c.default.getCoreMO(mml);
        }
        var form = NodeUtil_js_1$c.default.getForm(mml);
        if (form != null && [0, 0, 1, 1, 0, 1, 1, 0, 0, 0][form[2]]) {
          return [[top, item], true];
        }
      }
      var node = this.create('token', 'mo', {
        texClass: MmlNode_js_1$J.TEXCLASS.NONE
      }, Entities_js_1$1.entities.ApplyFunction);
      return [[top, node, item], true];
    }
    return _super.prototype.checkItem.apply(this, arguments);
  };
  return FnItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.FnItem = FnItem;
var NotItem = (function (_super) {
  __extends$1M(NotItem, _super);
  function NotItem() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.remap = MapHandler_js_1$1.MapHandler.getMap('not_remap');
    return _this;
  }
  Object.defineProperty(NotItem.prototype, "kind", {
    get: function () {
      return 'not';
    },
    enumerable: false,
    configurable: true
  });
  NotItem.prototype.checkItem = function (item) {
    var mml;
    var c;
    var textNode;
    if (item.isKind('open') || item.isKind('left')) {
      return StackItem_js_1$4.BaseItem.success;
    }
    if (item.isKind('mml') && (NodeUtil_js_1$c.default.isType(item.First, 'mo') || NodeUtil_js_1$c.default.isType(item.First, 'mi') || NodeUtil_js_1$c.default.isType(item.First, 'mtext'))) {
      mml = item.First;
      c = NodeUtil_js_1$c.default.getText(mml);
      if (c.length === 1 && !NodeUtil_js_1$c.default.getProperty(mml, 'movesupsub') && NodeUtil_js_1$c.default.getChildren(mml).length === 1) {
        if (this.remap.contains(c)) {
          textNode = this.create('text', this.remap.lookup(c).char);
          NodeUtil_js_1$c.default.setChild(mml, 0, textNode);
        } else {
          textNode = this.create('text', '\u0338');
          NodeUtil_js_1$c.default.appendChildren(mml, [textNode]);
        }
        return [[item], true];
      }
    }
    textNode = this.create('text', '\u29F8');
    var mtextNode = this.create('node', 'mtext', [], {}, textNode);
    var paddedNode = this.create('node', 'mpadded', [mtextNode], {
      width: 0
    });
    mml = this.create('node', 'TeXAtom', [paddedNode], {
      texClass: MmlNode_js_1$J.TEXCLASS.REL
    });
    return [[mml, item], true];
  };
  return NotItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.NotItem = NotItem;
var NonscriptItem = (function (_super) {
  __extends$1M(NonscriptItem, _super);
  function NonscriptItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(NonscriptItem.prototype, "kind", {
    get: function () {
      return 'nonscript';
    },
    enumerable: false,
    configurable: true
  });
  NonscriptItem.prototype.checkItem = function (item) {
    if (item.isKind('mml') && item.Size() === 1) {
      var mml = item.First;
      if (mml.isKind('mstyle') && mml.notParent) {
        mml = NodeUtil_js_1$c.default.getChildren(NodeUtil_js_1$c.default.getChildren(mml)[0])[0];
      }
      if (mml.isKind('mspace')) {
        if (mml !== item.First) {
          var mrow = this.create('node', 'mrow', [item.Pop()]);
          item.Push(mrow);
        }
        this.factory.configuration.addNode('nonscript', item.First);
      }
    }
    return [[item], true];
  };
  return NonscriptItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.NonscriptItem = NonscriptItem;
var DotsItem = (function (_super) {
  __extends$1M(DotsItem, _super);
  function DotsItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(DotsItem.prototype, "kind", {
    get: function () {
      return 'dots';
    },
    enumerable: false,
    configurable: true
  });
  DotsItem.prototype.checkItem = function (item) {
    if (item.isKind('open') || item.isKind('left')) {
      return StackItem_js_1$4.BaseItem.success;
    }
    var dots = this.getProperty('ldots');
    var top = item.First;
    if (item.isKind('mml') && NodeUtil_js_1$c.default.isEmbellished(top)) {
      var tclass = NodeUtil_js_1$c.default.getTexClass(NodeUtil_js_1$c.default.getCoreMO(top));
      if (tclass === MmlNode_js_1$J.TEXCLASS.BIN || tclass === MmlNode_js_1$J.TEXCLASS.REL) {
        dots = this.getProperty('cdots');
      }
    }
    return [[dots, item], true];
  };
  return DotsItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.DotsItem = DotsItem;
var ArrayItem = (function (_super) {
  __extends$1M(ArrayItem, _super);
  function ArrayItem() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.table = [];
    _this.row = [];
    _this.frame = [];
    _this.hfill = [];
    _this.arraydef = {};
    _this.dashed = false;
    return _this;
  }
  Object.defineProperty(ArrayItem.prototype, "kind", {
    get: function () {
      return 'array';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(ArrayItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(ArrayItem.prototype, "copyEnv", {
    get: function () {
      return false;
    },
    enumerable: false,
    configurable: true
  });
  ArrayItem.prototype.checkItem = function (item) {
    if (item.isClose && !item.isKind('over')) {
      if (item.getProperty('isEntry')) {
        this.EndEntry();
        this.clearEnv();
        return StackItem_js_1$4.BaseItem.fail;
      }
      if (item.getProperty('isCR')) {
        this.EndEntry();
        this.EndRow();
        this.clearEnv();
        return StackItem_js_1$4.BaseItem.fail;
      }
      this.EndTable();
      this.clearEnv();
      var newItem = this.factory.create('mml', this.createMml());
      if (this.getProperty('requireClose')) {
        if (item.isKind('close')) {
          return [[newItem], true];
        }
        throw new TexError_js_1$h.default('MissingCloseBrace', 'Missing close brace');
      }
      return [[newItem, item], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  ArrayItem.prototype.createMml = function () {
    var scriptlevel = this.arraydef['scriptlevel'];
    delete this.arraydef['scriptlevel'];
    var mml = this.create('node', 'mtable', this.table, this.arraydef);
    if (scriptlevel) {
      mml.setProperty('scriptlevel', scriptlevel);
    }
    if (this.frame.length === 4) {
      NodeUtil_js_1$c.default.setAttribute(mml, 'frame', this.dashed ? 'dashed' : 'solid');
    } else if (this.frame.length) {
      if (this.arraydef['rowlines']) {
        this.arraydef['rowlines'] = this.arraydef['rowlines'].replace(/none( none)+$/, 'none');
      }
      NodeUtil_js_1$c.default.setAttribute(mml, 'frame', '');
      mml = this.create('node', 'menclose', [mml], {
        notation: this.frame.join(' ')
      });
      if ((this.arraydef['columnlines'] || 'none') !== 'none' || (this.arraydef['rowlines'] || 'none') !== 'none') {
        NodeUtil_js_1$c.default.setAttribute(mml, 'data-padding', 0);
      }
    }
    if (this.getProperty('open') || this.getProperty('close')) {
      mml = ParseUtil_js_1$e.default.fenced(this.factory.configuration, this.getProperty('open'), mml, this.getProperty('close'));
    }
    return mml;
  };
  ArrayItem.prototype.EndEntry = function () {
    var mtd = this.create('node', 'mtd', this.nodes);
    if (this.hfill.length) {
      if (this.hfill[0] === 0) {
        NodeUtil_js_1$c.default.setAttribute(mtd, 'columnalign', 'right');
      }
      if (this.hfill[this.hfill.length - 1] === this.Size()) {
        NodeUtil_js_1$c.default.setAttribute(mtd, 'columnalign', NodeUtil_js_1$c.default.getAttribute(mtd, 'columnalign') ? 'center' : 'left');
      }
    }
    this.row.push(mtd);
    this.Clear();
    this.hfill = [];
  };
  ArrayItem.prototype.EndRow = function () {
    var node;
    if (this.getProperty('isNumbered') && this.row.length === 3) {
      this.row.unshift(this.row.pop());
      node = this.create('node', 'mlabeledtr', this.row);
    } else {
      node = this.create('node', 'mtr', this.row);
    }
    this.table.push(node);
    this.row = [];
  };
  ArrayItem.prototype.EndTable = function () {
    if (this.Size() || this.row.length) {
      this.EndEntry();
      this.EndRow();
    }
    this.checkLines();
  };
  ArrayItem.prototype.checkLines = function () {
    if (this.arraydef['rowlines']) {
      var lines = this.arraydef['rowlines'].split(/ /);
      if (lines.length === this.table.length) {
        this.frame.push('bottom');
        lines.pop();
        this.arraydef['rowlines'] = lines.join(' ');
      } else if (lines.length < this.table.length - 1) {
        this.arraydef['rowlines'] += ' none';
      }
    }
    if (this.getProperty('rowspacing')) {
      var rows = this.arraydef['rowspacing'].split(/ /);
      while (rows.length < this.table.length) {
        rows.push(this.getProperty('rowspacing') + 'em');
      }
      this.arraydef['rowspacing'] = rows.join(' ');
    }
  };
  ArrayItem.prototype.addRowSpacing = function (spacing) {
    if (this.arraydef['rowspacing']) {
      var rows = this.arraydef['rowspacing'].split(/ /);
      if (!this.getProperty('rowspacing')) {
        var dimem = ParseUtil_js_1$e.default.dimen2em(rows[0]);
        this.setProperty('rowspacing', dimem);
      }
      var rowspacing = this.getProperty('rowspacing');
      while (rows.length < this.table.length) {
        rows.push(ParseUtil_js_1$e.default.Em(rowspacing));
      }
      rows[this.table.length - 1] = ParseUtil_js_1$e.default.Em(Math.max(0, rowspacing + ParseUtil_js_1$e.default.dimen2em(spacing)));
      this.arraydef['rowspacing'] = rows.join(' ');
    }
  };
  return ArrayItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.ArrayItem = ArrayItem;
var EqnArrayItem = (function (_super) {
  __extends$1M(EqnArrayItem, _super);
  function EqnArrayItem(factory) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    var _this = _super.call(this, factory) || this;
    _this.maxrow = 0;
    _this.factory.configuration.tags.start(args[0], args[2], args[1]);
    return _this;
  }
  Object.defineProperty(EqnArrayItem.prototype, "kind", {
    get: function () {
      return 'eqnarray';
    },
    enumerable: false,
    configurable: true
  });
  EqnArrayItem.prototype.EndEntry = function () {
    if (this.row.length) {
      ParseUtil_js_1$e.default.fixInitialMO(this.factory.configuration, this.nodes);
    }
    var node = this.create('node', 'mtd', this.nodes);
    this.row.push(node);
    this.Clear();
  };
  EqnArrayItem.prototype.EndRow = function () {
    if (this.row.length > this.maxrow) {
      this.maxrow = this.row.length;
    }
    var mtr = 'mtr';
    var tag = this.factory.configuration.tags.getTag();
    if (tag) {
      this.row = [tag].concat(this.row);
      mtr = 'mlabeledtr';
    }
    this.factory.configuration.tags.clearTag();
    var node = this.create('node', mtr, this.row);
    this.table.push(node);
    this.row = [];
  };
  EqnArrayItem.prototype.EndTable = function () {
    _super.prototype.EndTable.call(this);
    this.factory.configuration.tags.end();
    this.extendArray('columnalign', this.maxrow);
    this.extendArray('columnwidth', this.maxrow);
    this.extendArray('columnspacing', this.maxrow - 1);
  };
  EqnArrayItem.prototype.extendArray = function (name, max) {
    if (!this.arraydef[name]) return;
    var repeat = this.arraydef[name].split(/ /);
    var columns = __spreadArray$l([], __read$F(repeat), false);
    if (columns.length > 1) {
      while (columns.length < max) {
        columns.push.apply(columns, __spreadArray$l([], __read$F(repeat), false));
      }
      this.arraydef[name] = columns.slice(0, max).join(' ');
    }
  };
  return EqnArrayItem;
})(ArrayItem);
BaseItems.EqnArrayItem = EqnArrayItem;
var EquationItem = (function (_super) {
  __extends$1M(EquationItem, _super);
  function EquationItem(factory) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    var _this = _super.call(this, factory) || this;
    _this.factory.configuration.tags.start('equation', true, args[0]);
    return _this;
  }
  Object.defineProperty(EquationItem.prototype, "kind", {
    get: function () {
      return 'equation';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(EquationItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  EquationItem.prototype.checkItem = function (item) {
    if (item.isKind('end')) {
      var mml = this.toMml();
      var tag = this.factory.configuration.tags.getTag();
      this.factory.configuration.tags.end();
      return [[tag ? this.factory.configuration.tags.enTag(mml, tag) : mml, item], true];
    }
    if (item.isKind('stop')) {
      throw new TexError_js_1$h.default('EnvMissingEnd', 'Missing \\end{%1}', this.getName());
    }
    return _super.prototype.checkItem.call(this, item);
  };
  return EquationItem;
})(StackItem_js_1$4.BaseItem);
BaseItems.EquationItem = EquationItem;

var BaseMappings = {};

var TexConstants = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.TexConstant = void 0;
  (function (TexConstant) {
    TexConstant.Variant = {
      NORMAL: 'normal',
      BOLD: 'bold',
      ITALIC: 'italic',
      BOLDITALIC: 'bold-italic',
      DOUBLESTRUCK: 'double-struck',
      FRAKTUR: 'fraktur',
      BOLDFRAKTUR: 'bold-fraktur',
      SCRIPT: 'script',
      BOLDSCRIPT: 'bold-script',
      SANSSERIF: 'sans-serif',
      BOLDSANSSERIF: 'bold-sans-serif',
      SANSSERIFITALIC: 'sans-serif-italic',
      SANSSERIFBOLDITALIC: 'sans-serif-bold-italic',
      MONOSPACE: 'monospace',
      INITIAL: 'inital',
      TAILED: 'tailed',
      LOOPED: 'looped',
      STRETCHED: 'stretched',
      CALLIGRAPHIC: '-tex-calligraphic',
      BOLDCALLIGRAPHIC: '-tex-bold-calligraphic',
      OLDSTYLE: '-tex-oldstyle',
      BOLDOLDSTYLE: '-tex-bold-oldstyle',
      MATHITALIC: '-tex-mathit'
    };
    TexConstant.Form = {
      PREFIX: 'prefix',
      INFIX: 'infix',
      POSTFIX: 'postfix'
    };
    TexConstant.LineBreak = {
      AUTO: 'auto',
      NEWLINE: 'newline',
      NOBREAK: 'nobreak',
      GOODBREAK: 'goodbreak',
      BADBREAK: 'badbreak'
    };
    TexConstant.LineBreakStyle = {
      BEFORE: 'before',
      AFTER: 'after',
      DUPLICATE: 'duplicate',
      INFIXLINBREAKSTYLE: 'infixlinebreakstyle'
    };
    TexConstant.IndentAlign = {
      LEFT: 'left',
      CENTER: 'center',
      RIGHT: 'right',
      AUTO: 'auto',
      ID: 'id',
      INDENTALIGN: 'indentalign'
    };
    TexConstant.IndentShift = {
      INDENTSHIFT: 'indentshift'
    };
    TexConstant.LineThickness = {
      THIN: 'thin',
      MEDIUM: 'medium',
      THICK: 'thick'
    };
    TexConstant.Notation = {
      LONGDIV: 'longdiv',
      ACTUARIAL: 'actuarial',
      PHASORANGLE: 'phasorangle',
      RADICAL: 'radical',
      BOX: 'box',
      ROUNDEDBOX: 'roundedbox',
      CIRCLE: 'circle',
      LEFT: 'left',
      RIGHT: 'right',
      TOP: 'top',
      BOTTOM: 'bottom',
      UPDIAGONALSTRIKE: 'updiagonalstrike',
      DOWNDIAGONALSTRIKE: 'downdiagonalstrike',
      VERTICALSTRIKE: 'verticalstrike',
      HORIZONTALSTRIKE: 'horizontalstrike',
      NORTHEASTARROW: 'northeastarrow',
      MADRUWB: 'madruwb',
      UPDIAGONALARROW: 'updiagonalarrow'
    };
    TexConstant.Align = {
      TOP: 'top',
      BOTTOM: 'bottom',
      CENTER: 'center',
      BASELINE: 'baseline',
      AXIS: 'axis',
      LEFT: 'left',
      RIGHT: 'right'
    };
    TexConstant.Lines = {
      NONE: 'none',
      SOLID: 'solid',
      DASHED: 'dashed'
    };
    TexConstant.Side = {
      LEFT: 'left',
      RIGHT: 'right',
      LEFTOVERLAP: 'leftoverlap',
      RIGHTOVERLAP: 'rightoverlap'
    };
    TexConstant.Width = {
      AUTO: 'auto',
      FIT: 'fit'
    };
    TexConstant.Actiontype = {
      TOGGLE: 'toggle',
      STATUSLINE: 'statusline',
      TOOLTIP: 'tooltip',
      INPUT: 'input'
    };
    TexConstant.Overflow = {
      LINBREAK: 'linebreak',
      SCROLL: 'scroll',
      ELIDE: 'elide',
      TRUNCATE: 'truncate',
      SCALE: 'scale'
    };
    TexConstant.Unit = {
      EM: 'em',
      EX: 'ex',
      PX: 'px',
      IN: 'in',
      CM: 'cm',
      MM: 'mm',
      PT: 'pt',
      PC: 'pc'
    };
  })(exports.TexConstant || (exports.TexConstant = {}));
})(TexConstants);
getDefaultExportFromCjs(TexConstants);

var BaseMethods$1 = {};

var lengths = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.px = exports.emRounded = exports.em = exports.percent = exports.length2em = exports.MATHSPACE = exports.RELUNITS = exports.UNITS = exports.BIGDIMEN = void 0;
  exports.BIGDIMEN = 1000000;
  exports.UNITS = {
    px: 1,
    'in': 96,
    cm: 96 / 2.54,
    mm: 96 / 25.4
  };
  exports.RELUNITS = {
    em: 1,
    ex: .431,
    pt: 1 / 10,
    pc: 12 / 10,
    mu: 1 / 18
  };
  exports.MATHSPACE = {
    veryverythinmathspace: 1 / 18,
    verythinmathspace: 2 / 18,
    thinmathspace: 3 / 18,
    mediummathspace: 4 / 18,
    thickmathspace: 5 / 18,
    verythickmathspace: 6 / 18,
    veryverythickmathspace: 7 / 18,
    negativeveryverythinmathspace: -1 / 18,
    negativeverythinmathspace: -2 / 18,
    negativethinmathspace: -3 / 18,
    negativemediummathspace: -4 / 18,
    negativethickmathspace: -5 / 18,
    negativeverythickmathspace: -6 / 18,
    negativeveryverythickmathspace: -7 / 18,
    thin: .04,
    medium: .06,
    thick: .1,
    normal: 1,
    big: 2,
    small: 1 / Math.sqrt(2),
    infinity: exports.BIGDIMEN
  };
  function length2em(length, size, scale, em) {
    if (size === void 0) {
      size = 0;
    }
    if (scale === void 0) {
      scale = 1;
    }
    if (em === void 0) {
      em = 16;
    }
    if (typeof length !== 'string') {
      length = String(length);
    }
    if (length === '' || length == null) {
      return size;
    }
    if (exports.MATHSPACE[length]) {
      return exports.MATHSPACE[length];
    }
    var match = length.match(/^\s*([-+]?(?:\.\d+|\d+(?:\.\d*)?))?(pt|em|ex|mu|px|pc|in|mm|cm|%)?/);
    if (!match) {
      return size;
    }
    var m = parseFloat(match[1] || '1'), unit = match[2];
    if (exports.UNITS.hasOwnProperty(unit)) {
      return m * exports.UNITS[unit] / em / scale;
    }
    if (exports.RELUNITS.hasOwnProperty(unit)) {
      return m * exports.RELUNITS[unit];
    }
    if (unit === '%') {
      return m / 100 * size;
    }
    return m * size;
  }
  exports.length2em = length2em;
  function percent(m) {
    return (100 * m).toFixed(1).replace(/\.?0+$/, '') + '%';
  }
  exports.percent = percent;
  function em(m) {
    if (Math.abs(m) < .001) return '0';
    return m.toFixed(3).replace(/\.?0+$/, '') + 'em';
  }
  exports.em = em;
  function emRounded(m, em) {
    if (em === void 0) {
      em = 16;
    }
    m = (Math.round(m * em) + .05) / em;
    if (Math.abs(m) < .001) return '0em';
    return m.toFixed(3).replace(/\.?0+$/, '') + 'em';
  }
  exports.emRounded = emRounded;
  function px(m, M, em) {
    if (M === void 0) {
      M = -exports.BIGDIMEN;
    }
    if (em === void 0) {
      em = 16;
    }
    m *= em;
    if (M && m < M) m = M;
    if (Math.abs(m) < .1) return '0';
    return m.toFixed(1).replace(/\.0$/, '') + 'px';
  }
  exports.px = px;
})(lengths);
getDefaultExportFromCjs(lengths);

var __assign$D = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$D = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$D.apply(this, arguments);
});
var __createBinding$d = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$d = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$d = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$d(result, mod, k);
  __setModuleDefault$d(result, mod);
  return result;
});
var __read$E = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __importDefault$C = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BaseMethods$1, "__esModule", {
  value: true
});
var sitem = __importStar$d(BaseItems);
var NodeUtil_js_1$b = __importDefault$C(NodeUtil$1);
var TexError_js_1$g = __importDefault$C(TexError$1);
var TexParser_js_1$9 = __importDefault$C(TexParser$1);
var TexConstants_js_1$b = TexConstants;
var ParseUtil_js_1$d = __importDefault$C(ParseUtil$1);
var MmlNode_js_1$I = MmlNode;
var Tags_js_1$6 = Tags;
var lengths_js_1$6 = lengths;
var Entities_js_1 = Entities$1;
var Options_js_1$8 = Options;
var BaseMethods = {};
var P_HEIGHT = 1.2 / .85;
var MmlTokenAllow = {
  fontfamily: 1,
  fontsize: 1,
  fontweight: 1,
  fontstyle: 1,
  color: 1,
  background: 1,
  id: 1,
  'class': 1,
  href: 1,
  style: 1
};
BaseMethods.Open = function (parser, _c) {
  parser.Push(parser.itemFactory.create('open'));
};
BaseMethods.Close = function (parser, _c) {
  parser.Push(parser.itemFactory.create('close'));
};
BaseMethods.Tilde = function (parser, _c) {
  parser.Push(parser.create('token', 'mtext', {}, Entities_js_1.entities.nbsp));
};
BaseMethods.Space = function (_parser, _c) {};
BaseMethods.Superscript = function (parser, _c) {
  var _a;
  if (parser.GetNext().match(/\d/)) {
    parser.string = parser.string.substr(0, parser.i + 1) + ' ' + parser.string.substr(parser.i + 1);
  }
  var primes;
  var base;
  var top = parser.stack.Top();
  if (top.isKind('prime')) {
    (_a = __read$E(top.Peek(2), 2), base = _a[0], primes = _a[1]);
    parser.stack.Pop();
  } else {
    base = parser.stack.Prev();
    if (!base) {
      base = parser.create('token', 'mi', {}, '');
    }
  }
  var movesupsub = NodeUtil_js_1$b.default.getProperty(base, 'movesupsub');
  var position = NodeUtil_js_1$b.default.isType(base, 'msubsup') ? base.sup : base.over;
  if (NodeUtil_js_1$b.default.isType(base, 'msubsup') && !NodeUtil_js_1$b.default.isType(base, 'msup') && NodeUtil_js_1$b.default.getChildAt(base, base.sup) || NodeUtil_js_1$b.default.isType(base, 'munderover') && !NodeUtil_js_1$b.default.isType(base, 'mover') && NodeUtil_js_1$b.default.getChildAt(base, base.over) && !NodeUtil_js_1$b.default.getProperty(base, 'subsupOK')) {
    throw new TexError_js_1$g.default('DoubleExponent', 'Double exponent: use braces to clarify');
  }
  if (!NodeUtil_js_1$b.default.isType(base, 'msubsup') || NodeUtil_js_1$b.default.isType(base, 'msup')) {
    if (movesupsub) {
      if (!NodeUtil_js_1$b.default.isType(base, 'munderover') || NodeUtil_js_1$b.default.isType(base, 'mover') || NodeUtil_js_1$b.default.getChildAt(base, base.over)) {
        base = parser.create('node', 'munderover', [base], {
          movesupsub: true
        });
      }
      position = base.over;
    } else {
      base = parser.create('node', 'msubsup', [base]);
      position = base.sup;
    }
  }
  parser.Push(parser.itemFactory.create('subsup', base).setProperties({
    position: position,
    primes: primes,
    movesupsub: movesupsub
  }));
};
BaseMethods.Subscript = function (parser, _c) {
  var _a;
  if (parser.GetNext().match(/\d/)) {
    parser.string = parser.string.substr(0, parser.i + 1) + ' ' + parser.string.substr(parser.i + 1);
  }
  var primes, base;
  var top = parser.stack.Top();
  if (top.isKind('prime')) {
    (_a = __read$E(top.Peek(2), 2), base = _a[0], primes = _a[1]);
    parser.stack.Pop();
  } else {
    base = parser.stack.Prev();
    if (!base) {
      base = parser.create('token', 'mi', {}, '');
    }
  }
  var movesupsub = NodeUtil_js_1$b.default.getProperty(base, 'movesupsub');
  var position = NodeUtil_js_1$b.default.isType(base, 'msubsup') ? base.sub : base.under;
  if (NodeUtil_js_1$b.default.isType(base, 'msubsup') && !NodeUtil_js_1$b.default.isType(base, 'msup') && NodeUtil_js_1$b.default.getChildAt(base, base.sub) || NodeUtil_js_1$b.default.isType(base, 'munderover') && !NodeUtil_js_1$b.default.isType(base, 'mover') && NodeUtil_js_1$b.default.getChildAt(base, base.under) && !NodeUtil_js_1$b.default.getProperty(base, 'subsupOK')) {
    throw new TexError_js_1$g.default('DoubleSubscripts', 'Double subscripts: use braces to clarify');
  }
  if (!NodeUtil_js_1$b.default.isType(base, 'msubsup') || NodeUtil_js_1$b.default.isType(base, 'msup')) {
    if (movesupsub) {
      if (!NodeUtil_js_1$b.default.isType(base, 'munderover') || NodeUtil_js_1$b.default.isType(base, 'mover') || NodeUtil_js_1$b.default.getChildAt(base, base.under)) {
        base = parser.create('node', 'munderover', [base], {
          movesupsub: true
        });
      }
      position = base.under;
    } else {
      base = parser.create('node', 'msubsup', [base]);
      position = base.sub;
    }
  }
  parser.Push(parser.itemFactory.create('subsup', base).setProperties({
    position: position,
    primes: primes,
    movesupsub: movesupsub
  }));
};
BaseMethods.Prime = function (parser, c) {
  var base = parser.stack.Prev();
  if (!base) {
    base = parser.create('node', 'mi');
  }
  if (NodeUtil_js_1$b.default.isType(base, 'msubsup') && !NodeUtil_js_1$b.default.isType(base, 'msup') && NodeUtil_js_1$b.default.getChildAt(base, base.sup)) {
    throw new TexError_js_1$g.default('DoubleExponentPrime', 'Prime causes double exponent: use braces to clarify');
  }
  var sup = '';
  parser.i--;
  do {
    sup += Entities_js_1.entities.prime;
    (parser.i++, c = parser.GetNext());
  } while (c === '\'' || c === Entities_js_1.entities.rsquo);
  sup = ['', '\u2032', '\u2033', '\u2034', '\u2057'][sup.length] || sup;
  var node = parser.create('token', 'mo', {
    variantForm: true
  }, sup);
  parser.Push(parser.itemFactory.create('prime', base, node));
};
BaseMethods.Comment = function (parser, _c) {
  while (parser.i < parser.string.length && parser.string.charAt(parser.i) !== '\n') {
    parser.i++;
  }
};
BaseMethods.Hash = function (_parser, _c) {
  throw new TexError_js_1$g.default('CantUseHash1', 'You can\'t use \'macro parameter character #\' in math mode');
};
BaseMethods.MathFont = function (parser, name, variant) {
  var text = parser.GetArgument(name);
  var mml = new TexParser_js_1$9.default(text, __assign$D(__assign$D({}, parser.stack.env), {
    font: variant,
    multiLetterIdentifiers: /^[a-zA-Z]+/,
    noAutoOP: true
  }), parser.configuration).mml();
  parser.Push(parser.create('node', 'TeXAtom', [mml]));
};
BaseMethods.SetFont = function (parser, _name, font) {
  parser.stack.env['font'] = font;
};
BaseMethods.SetStyle = function (parser, _name, texStyle, style, level) {
  parser.stack.env['style'] = texStyle;
  parser.stack.env['level'] = level;
  parser.Push(parser.itemFactory.create('style').setProperty('styles', {
    displaystyle: style,
    scriptlevel: level
  }));
};
BaseMethods.SetSize = function (parser, _name, size) {
  parser.stack.env['size'] = size;
  parser.Push(parser.itemFactory.create('style').setProperty('styles', {
    mathsize: (0, lengths_js_1$6.em)(size)
  }));
};
BaseMethods.Spacer = function (parser, _name, space) {
  var node = parser.create('node', 'mspace', [], {
    width: (0, lengths_js_1$6.em)(space)
  });
  var style = parser.create('node', 'mstyle', [node], {
    scriptlevel: 0
  });
  parser.Push(style);
};
BaseMethods.LeftRight = function (parser, name) {
  var first = name.substr(1);
  parser.Push(parser.itemFactory.create(first, parser.GetDelimiter(name), parser.stack.env.color));
};
BaseMethods.NamedFn = function (parser, name, id) {
  if (!id) {
    id = name.substr(1);
  }
  var mml = parser.create('token', 'mi', {
    texClass: MmlNode_js_1$I.TEXCLASS.OP
  }, id);
  parser.Push(parser.itemFactory.create('fn', mml));
};
BaseMethods.NamedOp = function (parser, name, id) {
  if (!id) {
    id = name.substr(1);
  }
  id = id.replace(/&thinsp;/, '\u2006');
  var mml = parser.create('token', 'mo', {
    movablelimits: true,
    movesupsub: true,
    form: TexConstants_js_1$b.TexConstant.Form.PREFIX,
    texClass: MmlNode_js_1$I.TEXCLASS.OP
  }, id);
  parser.Push(mml);
};
BaseMethods.Limits = function (parser, _name, limits) {
  var op = parser.stack.Prev(true);
  if (!op || NodeUtil_js_1$b.default.getTexClass(NodeUtil_js_1$b.default.getCoreMO(op)) !== MmlNode_js_1$I.TEXCLASS.OP && NodeUtil_js_1$b.default.getProperty(op, 'movesupsub') == null) {
    throw new TexError_js_1$g.default('MisplacedLimits', '%1 is allowed only on operators', parser.currentCS);
  }
  var top = parser.stack.Top();
  var node;
  if (NodeUtil_js_1$b.default.isType(op, 'munderover') && !limits) {
    node = parser.create('node', 'msubsup');
    NodeUtil_js_1$b.default.copyChildren(op, node);
    op = top.Last = node;
  } else if (NodeUtil_js_1$b.default.isType(op, 'msubsup') && limits) {
    node = parser.create('node', 'munderover');
    NodeUtil_js_1$b.default.copyChildren(op, node);
    op = top.Last = node;
  }
  NodeUtil_js_1$b.default.setProperty(op, 'movesupsub', limits ? true : false);
  NodeUtil_js_1$b.default.setProperties(NodeUtil_js_1$b.default.getCoreMO(op), {
    'movablelimits': false
  });
  if (NodeUtil_js_1$b.default.getAttribute(op, 'movablelimits') || NodeUtil_js_1$b.default.getProperty(op, 'movablelimits')) {
    NodeUtil_js_1$b.default.setProperties(op, {
      'movablelimits': false
    });
  }
};
BaseMethods.Over = function (parser, name, open, close) {
  var mml = parser.itemFactory.create('over').setProperty('name', parser.currentCS);
  if (open || close) {
    mml.setProperty('open', open);
    mml.setProperty('close', close);
  } else if (name.match(/withdelims$/)) {
    mml.setProperty('open', parser.GetDelimiter(name));
    mml.setProperty('close', parser.GetDelimiter(name));
  }
  if (name.match(/^\\above/)) {
    mml.setProperty('thickness', parser.GetDimen(name));
  } else if (name.match(/^\\atop/) || open || close) {
    mml.setProperty('thickness', 0);
  }
  parser.Push(mml);
};
BaseMethods.Frac = function (parser, name) {
  var num = parser.ParseArg(name);
  var den = parser.ParseArg(name);
  var node = parser.create('node', 'mfrac', [num, den]);
  parser.Push(node);
};
BaseMethods.Sqrt = function (parser, name) {
  var n = parser.GetBrackets(name);
  var arg = parser.GetArgument(name);
  if (arg === '\\frac') {
    arg += '{' + parser.GetArgument(arg) + '}{' + parser.GetArgument(arg) + '}';
  }
  var mml = new TexParser_js_1$9.default(arg, parser.stack.env, parser.configuration).mml();
  if (!n) {
    mml = parser.create('node', 'msqrt', [mml]);
  } else {
    mml = parser.create('node', 'mroot', [mml, parseRoot(parser, n)]);
  }
  parser.Push(mml);
};
function parseRoot(parser, n) {
  var env = parser.stack.env;
  var inRoot = env['inRoot'];
  env['inRoot'] = true;
  var newParser = new TexParser_js_1$9.default(n, env, parser.configuration);
  var node = newParser.mml();
  var global = newParser.stack.global;
  if (global['leftRoot'] || global['upRoot']) {
    var def = {};
    if (global['leftRoot']) {
      def['width'] = global['leftRoot'];
    }
    if (global['upRoot']) {
      def['voffset'] = global['upRoot'];
      def['height'] = global['upRoot'];
    }
    node = parser.create('node', 'mpadded', [node], def);
  }
  env['inRoot'] = inRoot;
  return node;
}
BaseMethods.Root = function (parser, name) {
  var n = parser.GetUpTo(name, '\\of');
  var arg = parser.ParseArg(name);
  var node = parser.create('node', 'mroot', [arg, parseRoot(parser, n)]);
  parser.Push(node);
};
BaseMethods.MoveRoot = function (parser, name, id) {
  if (!parser.stack.env['inRoot']) {
    throw new TexError_js_1$g.default('MisplacedMoveRoot', '%1 can appear only within a root', parser.currentCS);
  }
  if (parser.stack.global[id]) {
    throw new TexError_js_1$g.default('MultipleMoveRoot', 'Multiple use of %1', parser.currentCS);
  }
  var n = parser.GetArgument(name);
  if (!n.match(/-?[0-9]+/)) {
    throw new TexError_js_1$g.default('IntegerArg', 'The argument to %1 must be an integer', parser.currentCS);
  }
  n = parseInt(n, 10) / 15 + 'em';
  if (n.substr(0, 1) !== '-') {
    n = '+' + n;
  }
  parser.stack.global[id] = n;
};
BaseMethods.Accent = function (parser, name, accent, stretchy) {
  var c = parser.ParseArg(name);
  var def = __assign$D(__assign$D({}, ParseUtil_js_1$d.default.getFontDef(parser)), {
    accent: true,
    mathaccent: true
  });
  var entity = NodeUtil_js_1$b.default.createEntity(accent);
  var moNode = parser.create('token', 'mo', def, entity);
  var mml = moNode;
  NodeUtil_js_1$b.default.setAttribute(mml, 'stretchy', stretchy ? true : false);
  var mo = NodeUtil_js_1$b.default.isEmbellished(c) ? NodeUtil_js_1$b.default.getCoreMO(c) : c;
  if (NodeUtil_js_1$b.default.isType(mo, 'mo') || NodeUtil_js_1$b.default.getProperty(mo, 'movablelimits')) {
    NodeUtil_js_1$b.default.setProperties(mo, {
      'movablelimits': false
    });
  }
  var muoNode = parser.create('node', 'munderover');
  NodeUtil_js_1$b.default.setChild(muoNode, 0, c);
  NodeUtil_js_1$b.default.setChild(muoNode, 1, null);
  NodeUtil_js_1$b.default.setChild(muoNode, 2, mml);
  var texAtom = parser.create('node', 'TeXAtom', [muoNode]);
  parser.Push(texAtom);
};
BaseMethods.UnderOver = function (parser, name, c, stack) {
  var entity = NodeUtil_js_1$b.default.createEntity(c);
  var mo = parser.create('token', 'mo', {
    stretchy: true,
    accent: true
  }, entity);
  var pos = name.charAt(1) === 'o' ? 'over' : 'under';
  var base = parser.ParseArg(name);
  parser.Push(ParseUtil_js_1$d.default.underOver(parser, base, mo, pos, stack));
};
BaseMethods.Overset = function (parser, name) {
  var top = parser.ParseArg(name);
  var base = parser.ParseArg(name);
  ParseUtil_js_1$d.default.checkMovableLimits(base);
  if (top.isKind('mo')) {
    NodeUtil_js_1$b.default.setAttribute(top, 'accent', false);
  }
  var node = parser.create('node', 'mover', [base, top]);
  parser.Push(node);
};
BaseMethods.Underset = function (parser, name) {
  var bot = parser.ParseArg(name);
  var base = parser.ParseArg(name);
  ParseUtil_js_1$d.default.checkMovableLimits(base);
  if (bot.isKind('mo')) {
    NodeUtil_js_1$b.default.setAttribute(bot, 'accent', false);
  }
  var node = parser.create('node', 'munder', [base, bot], {
    accentunder: false
  });
  parser.Push(node);
};
BaseMethods.Overunderset = function (parser, name) {
  var top = parser.ParseArg(name);
  var bot = parser.ParseArg(name);
  var base = parser.ParseArg(name);
  ParseUtil_js_1$d.default.checkMovableLimits(base);
  if (top.isKind('mo')) {
    NodeUtil_js_1$b.default.setAttribute(top, 'accent', false);
  }
  if (bot.isKind('mo')) {
    NodeUtil_js_1$b.default.setAttribute(bot, 'accent', false);
  }
  var node = parser.create('node', 'munderover', [base, bot, top], {
    accent: false,
    accentunder: false
  });
  parser.Push(node);
};
BaseMethods.TeXAtom = function (parser, name, mclass) {
  var def = {
    texClass: mclass
  };
  var mml;
  var node;
  var parsed;
  if (mclass === MmlNode_js_1$I.TEXCLASS.OP) {
    def['movesupsub'] = def['movablelimits'] = true;
    var arg = parser.GetArgument(name);
    var match = arg.match(/^\s*\\rm\s+([a-zA-Z0-9 ]+)$/);
    if (match) {
      def['mathvariant'] = TexConstants_js_1$b.TexConstant.Variant.NORMAL;
      node = parser.create('token', 'mi', def, match[1]);
    } else {
      parsed = new TexParser_js_1$9.default(arg, parser.stack.env, parser.configuration).mml();
      node = parser.create('node', 'TeXAtom', [parsed], def);
    }
    mml = parser.itemFactory.create('fn', node);
  } else {
    parsed = parser.ParseArg(name);
    mml = parser.create('node', 'TeXAtom', [parsed], def);
  }
  parser.Push(mml);
};
BaseMethods.MmlToken = function (parser, name) {
  var kind = parser.GetArgument(name);
  var attr = parser.GetBrackets(name, '').replace(/^\s+/, '');
  var text = parser.GetArgument(name);
  var def = {};
  var keep = [];
  var node;
  try {
    node = parser.create('node', kind);
  } catch (e) {
    node = null;
  }
  if (!node || !node.isToken) {
    throw new TexError_js_1$g.default('NotMathMLToken', '%1 is not a token element', kind);
  }
  while (attr !== '') {
    var match = attr.match(/^([a-z]+)\s*=\s*('[^']*'|"[^"]*"|[^ ,]*)\s*,?\s*/i);
    if (!match) {
      throw new TexError_js_1$g.default('InvalidMathMLAttr', 'Invalid MathML attribute: %1', attr);
    }
    if (!node.attributes.hasDefault(match[1]) && !MmlTokenAllow[match[1]]) {
      throw new TexError_js_1$g.default('UnknownAttrForElement', '%1 is not a recognized attribute for %2', match[1], kind);
    }
    var value = ParseUtil_js_1$d.default.MmlFilterAttribute(parser, match[1], match[2].replace(/^(['"])(.*)\1$/, '$2'));
    if (value) {
      if (value.toLowerCase() === 'true') {
        value = true;
      } else if (value.toLowerCase() === 'false') {
        value = false;
      }
      def[match[1]] = value;
      keep.push(match[1]);
    }
    attr = attr.substr(match[0].length);
  }
  if (keep.length) {
    def['mjx-keep-attrs'] = keep.join(' ');
  }
  var textNode = parser.create('text', text);
  node.appendChild(textNode);
  NodeUtil_js_1$b.default.setProperties(node, def);
  parser.Push(node);
};
BaseMethods.Strut = function (parser, _name) {
  var row = parser.create('node', 'mrow');
  var padded = parser.create('node', 'mpadded', [row], {
    height: '8.6pt',
    depth: '3pt',
    width: 0
  });
  parser.Push(padded);
};
BaseMethods.Phantom = function (parser, name, v, h) {
  var box = parser.create('node', 'mphantom', [parser.ParseArg(name)]);
  if (v || h) {
    box = parser.create('node', 'mpadded', [box]);
    if (h) {
      NodeUtil_js_1$b.default.setAttribute(box, 'height', 0);
      NodeUtil_js_1$b.default.setAttribute(box, 'depth', 0);
    }
    if (v) {
      NodeUtil_js_1$b.default.setAttribute(box, 'width', 0);
    }
  }
  var atom = parser.create('node', 'TeXAtom', [box]);
  parser.Push(atom);
};
BaseMethods.Smash = function (parser, name) {
  var bt = ParseUtil_js_1$d.default.trimSpaces(parser.GetBrackets(name, ''));
  var smash = parser.create('node', 'mpadded', [parser.ParseArg(name)]);
  switch (bt) {
    case 'b':
      NodeUtil_js_1$b.default.setAttribute(smash, 'depth', 0);
      break;
    case 't':
      NodeUtil_js_1$b.default.setAttribute(smash, 'height', 0);
      break;
    default:
      NodeUtil_js_1$b.default.setAttribute(smash, 'height', 0);
      NodeUtil_js_1$b.default.setAttribute(smash, 'depth', 0);
  }
  var atom = parser.create('node', 'TeXAtom', [smash]);
  parser.Push(atom);
};
BaseMethods.Lap = function (parser, name) {
  var mml = parser.create('node', 'mpadded', [parser.ParseArg(name)], {
    width: 0
  });
  if (name === '\\llap') {
    NodeUtil_js_1$b.default.setAttribute(mml, 'lspace', '-1width');
  }
  var atom = parser.create('node', 'TeXAtom', [mml]);
  parser.Push(atom);
};
BaseMethods.RaiseLower = function (parser, name) {
  var h = parser.GetDimen(name);
  var item = parser.itemFactory.create('position').setProperties({
    name: parser.currentCS,
    move: 'vertical'
  });
  if (h.charAt(0) === '-') {
    h = h.slice(1);
    name = name.substr(1) === 'raise' ? '\\lower' : '\\raise';
  }
  if (name === '\\lower') {
    item.setProperty('dh', '-' + h);
    item.setProperty('dd', '+' + h);
  } else {
    item.setProperty('dh', '+' + h);
    item.setProperty('dd', '-' + h);
  }
  parser.Push(item);
};
BaseMethods.MoveLeftRight = function (parser, name) {
  var h = parser.GetDimen(name);
  var nh = h.charAt(0) === '-' ? h.slice(1) : '-' + h;
  if (name === '\\moveleft') {
    var tmp = h;
    h = nh;
    nh = tmp;
  }
  parser.Push(parser.itemFactory.create('position').setProperties({
    name: parser.currentCS,
    move: 'horizontal',
    left: parser.create('node', 'mspace', [], {
      width: h
    }),
    right: parser.create('node', 'mspace', [], {
      width: nh
    })
  }));
};
BaseMethods.Hskip = function (parser, name) {
  var node = parser.create('node', 'mspace', [], {
    width: parser.GetDimen(name)
  });
  parser.Push(node);
};
BaseMethods.Nonscript = function (parser, _name) {
  parser.Push(parser.itemFactory.create('nonscript'));
};
BaseMethods.Rule = function (parser, name, style) {
  var w = parser.GetDimen(name), h = parser.GetDimen(name), d = parser.GetDimen(name);
  var def = {
    width: w,
    height: h,
    depth: d
  };
  if (style !== 'blank') {
    def['mathbackground'] = parser.stack.env['color'] || 'black';
  }
  var node = parser.create('node', 'mspace', [], def);
  parser.Push(node);
};
BaseMethods.rule = function (parser, name) {
  var v = parser.GetBrackets(name), w = parser.GetDimen(name), h = parser.GetDimen(name);
  var mml = parser.create('node', 'mspace', [], {
    width: w,
    height: h,
    mathbackground: parser.stack.env['color'] || 'black'
  });
  if (v) {
    mml = parser.create('node', 'mpadded', [mml], {
      voffset: v
    });
    if (v.match(/^\-/)) {
      NodeUtil_js_1$b.default.setAttribute(mml, 'height', v);
      NodeUtil_js_1$b.default.setAttribute(mml, 'depth', '+' + v.substr(1));
    } else {
      NodeUtil_js_1$b.default.setAttribute(mml, 'height', '+' + v);
    }
  }
  parser.Push(mml);
};
BaseMethods.MakeBig = function (parser, name, mclass, size) {
  size *= P_HEIGHT;
  var sizeStr = String(size).replace(/(\.\d\d\d).+/, '$1') + 'em';
  var delim = parser.GetDelimiter(name, true);
  var mo = parser.create('token', 'mo', {
    minsize: sizeStr,
    maxsize: sizeStr,
    fence: true,
    stretchy: true,
    symmetric: true
  }, delim);
  var node = parser.create('node', 'TeXAtom', [mo], {
    texClass: mclass
  });
  parser.Push(node);
};
BaseMethods.BuildRel = function (parser, name) {
  var top = parser.ParseUpTo(name, '\\over');
  var bot = parser.ParseArg(name);
  var node = parser.create('node', 'munderover');
  NodeUtil_js_1$b.default.setChild(node, 0, bot);
  NodeUtil_js_1$b.default.setChild(node, 1, null);
  NodeUtil_js_1$b.default.setChild(node, 2, top);
  var atom = parser.create('node', 'TeXAtom', [node], {
    texClass: MmlNode_js_1$I.TEXCLASS.REL
  });
  parser.Push(atom);
};
BaseMethods.HBox = function (parser, name, style, font) {
  parser.PushAll(ParseUtil_js_1$d.default.internalMath(parser, parser.GetArgument(name), style, font));
};
BaseMethods.FBox = function (parser, name) {
  var internal = ParseUtil_js_1$d.default.internalMath(parser, parser.GetArgument(name));
  var node = parser.create('node', 'menclose', internal, {
    notation: 'box'
  });
  parser.Push(node);
};
BaseMethods.FrameBox = function (parser, name) {
  var width = parser.GetBrackets(name);
  var pos = parser.GetBrackets(name) || 'c';
  var mml = ParseUtil_js_1$d.default.internalMath(parser, parser.GetArgument(name));
  if (width) {
    mml = [parser.create('node', 'mpadded', mml, {
      width: width,
      'data-align': (0, Options_js_1$8.lookup)(pos, {
        l: 'left',
        r: 'right'
      }, 'center')
    })];
  }
  var node = parser.create('node', 'TeXAtom', [parser.create('node', 'menclose', mml, {
    notation: 'box'
  })], {
    texClass: MmlNode_js_1$I.TEXCLASS.ORD
  });
  parser.Push(node);
};
BaseMethods.Not = function (parser, _name) {
  parser.Push(parser.itemFactory.create('not'));
};
BaseMethods.Dots = function (parser, _name) {
  var ldotsEntity = NodeUtil_js_1$b.default.createEntity('2026');
  var cdotsEntity = NodeUtil_js_1$b.default.createEntity('22EF');
  var ldots = parser.create('token', 'mo', {
    stretchy: false
  }, ldotsEntity);
  var cdots = parser.create('token', 'mo', {
    stretchy: false
  }, cdotsEntity);
  parser.Push(parser.itemFactory.create('dots').setProperties({
    ldots: ldots,
    cdots: cdots
  }));
};
BaseMethods.Matrix = function (parser, _name, open, close, align, spacing, vspacing, style, cases, numbered) {
  var c = parser.GetNext();
  if (c === '') {
    throw new TexError_js_1$g.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
  }
  if (c === '{') {
    parser.i++;
  } else {
    parser.string = c + '}' + parser.string.slice(parser.i + 1);
    parser.i = 0;
  }
  var array = parser.itemFactory.create('array').setProperty('requireClose', true);
  array.arraydef = {
    rowspacing: vspacing || '4pt',
    columnspacing: spacing || '1em'
  };
  if (cases) {
    array.setProperty('isCases', true);
  }
  if (numbered) {
    array.setProperty('isNumbered', true);
    array.arraydef.side = numbered;
  }
  if (open || close) {
    array.setProperty('open', open);
    array.setProperty('close', close);
  }
  if (style === 'D') {
    array.arraydef.displaystyle = true;
  }
  if (align != null) {
    array.arraydef.columnalign = align;
  }
  parser.Push(array);
};
BaseMethods.Entry = function (parser, name) {
  parser.Push(parser.itemFactory.create('cell').setProperties({
    isEntry: true,
    name: name
  }));
  var top = parser.stack.Top();
  var env = top.getProperty('casesEnv');
  var cases = top.getProperty('isCases');
  if (!cases && !env) return;
  var str = parser.string;
  var braces = 0, close = -1, i = parser.i, m = str.length;
  var end = env ? new RegExp(("^\\\\end\\s*\\{").concat(env.replace(/\*/, '\\*'), "\\}")) : null;
  while (i < m) {
    var c = str.charAt(i);
    if (c === '{') {
      braces++;
      i++;
    } else if (c === '}') {
      if (braces === 0) {
        m = 0;
      } else {
        braces--;
        if (braces === 0 && close < 0) {
          close = i - parser.i;
        }
        i++;
      }
    } else if (c === '&' && braces === 0) {
      throw new TexError_js_1$g.default('ExtraAlignTab', 'Extra alignment tab in \\cases text');
    } else if (c === '\\') {
      var rest = str.substr(i);
      if (rest.match(/^((\\cr)[^a-zA-Z]|\\\\)/) || end && rest.match(end)) {
        m = 0;
      } else {
        i += 2;
      }
    } else {
      i++;
    }
  }
  var text = str.substr(parser.i, i - parser.i);
  if (!text.match(/^\s*\\text[^a-zA-Z]/) || close !== text.replace(/\s+$/, '').length - 1) {
    var internal = ParseUtil_js_1$d.default.internalMath(parser, ParseUtil_js_1$d.default.trimSpaces(text), 0);
    parser.PushAll(internal);
    parser.i = i;
  }
};
BaseMethods.Cr = function (parser, name) {
  parser.Push(parser.itemFactory.create('cell').setProperties({
    isCR: true,
    name: name
  }));
};
BaseMethods.CrLaTeX = function (parser, name, nobrackets) {
  if (nobrackets === void 0) {
    nobrackets = false;
  }
  var n;
  if (!nobrackets) {
    if (parser.string.charAt(parser.i) === '*') {
      parser.i++;
    }
    if (parser.string.charAt(parser.i) === '[') {
      var dim = parser.GetBrackets(name, '');
      var _a = __read$E(ParseUtil_js_1$d.default.matchDimen(dim), 2), value = _a[0], unit = _a[1];
      if (dim && !value) {
        throw new TexError_js_1$g.default('BracketMustBeDimension', 'Bracket argument to %1 must be a dimension', parser.currentCS);
      }
      n = value + unit;
    }
  }
  parser.Push(parser.itemFactory.create('cell').setProperties({
    isCR: true,
    name: name,
    linebreak: true
  }));
  var top = parser.stack.Top();
  var node;
  if (top instanceof sitem.ArrayItem) {
    if (n) {
      top.addRowSpacing(n);
    }
  } else {
    if (n) {
      node = parser.create('node', 'mspace', [], {
        depth: n
      });
      parser.Push(node);
    }
    node = parser.create('node', 'mspace', [], {
      linebreak: TexConstants_js_1$b.TexConstant.LineBreak.NEWLINE
    });
    parser.Push(node);
  }
};
BaseMethods.HLine = function (parser, _name, style) {
  if (style == null) {
    style = 'solid';
  }
  var top = parser.stack.Top();
  if (!(top instanceof sitem.ArrayItem) || top.Size()) {
    throw new TexError_js_1$g.default('Misplaced', 'Misplaced %1', parser.currentCS);
  }
  if (!top.table.length) {
    top.frame.push('top');
  } else {
    var lines = top.arraydef['rowlines'] ? top.arraydef['rowlines'].split(/ /) : [];
    while (lines.length < top.table.length) {
      lines.push('none');
    }
    lines[top.table.length - 1] = style;
    top.arraydef['rowlines'] = lines.join(' ');
  }
};
BaseMethods.HFill = function (parser, _name) {
  var top = parser.stack.Top();
  if (top instanceof sitem.ArrayItem) {
    top.hfill.push(top.Size());
  } else {
    throw new TexError_js_1$g.default('UnsupportedHFill', 'Unsupported use of %1', parser.currentCS);
  }
};
BaseMethods.BeginEnd = function (parser, name) {
  var env = parser.GetArgument(name);
  if (env.match(/\\/i)) {
    throw new TexError_js_1$g.default('InvalidEnv', 'Invalid environment name \'%1\'', env);
  }
  var macro = parser.configuration.handlers.get('environment').lookup(env);
  if (macro && name === '\\end') {
    if (!macro.args[0]) {
      var mml = parser.itemFactory.create('end').setProperty('name', env);
      parser.Push(mml);
      return;
    }
    parser.stack.env['closing'] = env;
  }
  ParseUtil_js_1$d.default.checkMaxMacros(parser, false);
  parser.parse('environment', [parser, env]);
};
BaseMethods.Array = function (parser, begin, open, close, align, spacing, vspacing, style, raggedHeight) {
  if (!align) {
    align = parser.GetArgument('\\begin{' + begin.getName() + '}');
  }
  var lines = ('c' + align).replace(/[^clr|:]/g, '').replace(/[^|:]([|:])+/g, '$1');
  align = align.replace(/[^clr]/g, '').split('').join(' ');
  align = align.replace(/l/g, 'left').replace(/r/g, 'right').replace(/c/g, 'center');
  var array = parser.itemFactory.create('array');
  array.arraydef = {
    columnalign: align,
    columnspacing: spacing || '1em',
    rowspacing: vspacing || '4pt'
  };
  if (lines.match(/[|:]/)) {
    if (lines.charAt(0).match(/[|:]/)) {
      array.frame.push('left');
      array.dashed = lines.charAt(0) === ':';
    }
    if (lines.charAt(lines.length - 1).match(/[|:]/)) {
      array.frame.push('right');
    }
    lines = lines.substr(1, lines.length - 2);
    array.arraydef.columnlines = lines.split('').join(' ').replace(/[^|: ]/g, 'none').replace(/\|/g, 'solid').replace(/:/g, 'dashed');
  }
  if (open) {
    array.setProperty('open', parser.convertDelimiter(open));
  }
  if (close) {
    array.setProperty('close', parser.convertDelimiter(close));
  }
  if ((style || '').charAt(1) === '\'') {
    array.arraydef['data-cramped'] = true;
    style = style.charAt(0);
  }
  if (style === 'D') {
    array.arraydef['displaystyle'] = true;
  } else if (style) {
    array.arraydef['displaystyle'] = false;
  }
  if (style === 'S') {
    array.arraydef['scriptlevel'] = 1;
  }
  if (raggedHeight) {
    array.arraydef['useHeight'] = false;
  }
  parser.Push(begin);
  return array;
};
BaseMethods.AlignedArray = function (parser, begin) {
  var align = parser.GetBrackets('\\begin{' + begin.getName() + '}');
  var item = BaseMethods.Array(parser, begin);
  return ParseUtil_js_1$d.default.setArrayAlign(item, align);
};
BaseMethods.Equation = function (parser, begin, numbered) {
  parser.Push(begin);
  ParseUtil_js_1$d.default.checkEqnEnv(parser);
  return parser.itemFactory.create('equation', numbered).setProperty('name', begin.getName());
};
BaseMethods.EqnArray = function (parser, begin, numbered, taggable, align, spacing) {
  parser.Push(begin);
  if (taggable) {
    ParseUtil_js_1$d.default.checkEqnEnv(parser);
  }
  align = align.replace(/[^clr]/g, '').split('').join(' ');
  align = align.replace(/l/g, 'left').replace(/r/g, 'right').replace(/c/g, 'center');
  var newItem = parser.itemFactory.create('eqnarray', begin.getName(), numbered, taggable, parser.stack.global);
  newItem.arraydef = {
    displaystyle: true,
    columnalign: align,
    columnspacing: spacing || '1em',
    rowspacing: '3pt',
    side: parser.options['tagSide'],
    minlabelspacing: parser.options['tagIndent']
  };
  return newItem;
};
BaseMethods.HandleNoTag = function (parser, _name) {
  parser.tags.notag();
};
BaseMethods.HandleLabel = function (parser, name) {
  var label = parser.GetArgument(name);
  if (label === '') {
    return;
  }
  if (!parser.tags.refUpdate) {
    if (parser.tags.label) {
      throw new TexError_js_1$g.default('MultipleCommand', 'Multiple %1', parser.currentCS);
    }
    parser.tags.label = label;
    if ((parser.tags.allLabels[label] || parser.tags.labels[label]) && !parser.options['ignoreDuplicateLabels']) {
      throw new TexError_js_1$g.default('MultipleLabel', 'Label \'%1\' multiply defined', label);
    }
    parser.tags.labels[label] = new Tags_js_1$6.Label();
  }
};
BaseMethods.HandleRef = function (parser, name, eqref) {
  var label = parser.GetArgument(name);
  var ref = parser.tags.allLabels[label] || parser.tags.labels[label];
  if (!ref) {
    if (!parser.tags.refUpdate) {
      parser.tags.redo = true;
    }
    ref = new Tags_js_1$6.Label();
  }
  var tag = ref.tag;
  if (eqref) {
    tag = parser.tags.formatTag(tag);
  }
  var node = parser.create('node', 'mrow', ParseUtil_js_1$d.default.internalMath(parser, tag), {
    href: parser.tags.formatUrl(ref.id, parser.options.baseURL),
    'class': 'MathJax_ref'
  });
  parser.Push(node);
};
BaseMethods.Macro = function (parser, name, macro, argcount, def) {
  if (argcount) {
    var args = [];
    if (def != null) {
      var optional = parser.GetBrackets(name);
      args.push(optional == null ? def : optional);
    }
    for (var i = args.length; i < argcount; i++) {
      args.push(parser.GetArgument(name));
    }
    macro = ParseUtil_js_1$d.default.substituteArgs(parser, args, macro);
  }
  parser.string = ParseUtil_js_1$d.default.addArgs(parser, macro, parser.string.slice(parser.i));
  parser.i = 0;
  ParseUtil_js_1$d.default.checkMaxMacros(parser);
};
BaseMethods.MathChoice = function (parser, name) {
  var D = parser.ParseArg(name);
  var T = parser.ParseArg(name);
  var S = parser.ParseArg(name);
  var SS = parser.ParseArg(name);
  parser.Push(parser.create('node', 'MathChoice', [D, T, S, SS]));
};
BaseMethods$1.default = BaseMethods;

var ParseMethods$1 = {};

var __read$D = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$k = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$B = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(ParseMethods$1, "__esModule", {
  value: true
});
var NodeUtil_js_1$a = __importDefault$B(NodeUtil$1);
var TexConstants_js_1$a = TexConstants;
var ParseUtil_js_1$c = __importDefault$B(ParseUtil$1);
var ParseMethods;
(function (ParseMethods) {
  function variable(parser, c) {
    var def = ParseUtil_js_1$c.default.getFontDef(parser);
    var env = parser.stack.env;
    if (env.multiLetterIdentifiers && env.font !== '') {
      c = parser.string.substr(parser.i - 1).match(env.multiLetterIdentifiers)[0];
      parser.i += c.length - 1;
      if (def.mathvariant === TexConstants_js_1$a.TexConstant.Variant.NORMAL && env.noAutoOP && c.length > 1) {
        def.autoOP = false;
      }
    }
    var node = parser.create('token', 'mi', def, c);
    parser.Push(node);
  }
  ParseMethods.variable = variable;
  function digit(parser, c) {
    var mml;
    var pattern = parser.configuration.options['digits'];
    var n = parser.string.slice(parser.i - 1).match(pattern);
    var def = ParseUtil_js_1$c.default.getFontDef(parser);
    if (n) {
      mml = parser.create('token', 'mn', def, n[0].replace(/[{}]/g, ''));
      parser.i += n[0].length - 1;
    } else {
      mml = parser.create('token', 'mo', def, c);
    }
    parser.Push(mml);
  }
  ParseMethods.digit = digit;
  function controlSequence(parser, _c) {
    var name = parser.GetCS();
    parser.parse('macro', [parser, name]);
  }
  ParseMethods.controlSequence = controlSequence;
  function mathchar0mi(parser, mchar) {
    var def = mchar.attributes || ({
      mathvariant: TexConstants_js_1$a.TexConstant.Variant.ITALIC
    });
    var node = parser.create('token', 'mi', def, mchar.char);
    parser.Push(node);
  }
  ParseMethods.mathchar0mi = mathchar0mi;
  function mathchar0mo(parser, mchar) {
    var def = mchar.attributes || ({});
    def['stretchy'] = false;
    var node = parser.create('token', 'mo', def, mchar.char);
    NodeUtil_js_1$a.default.setProperty(node, 'fixStretchy', true);
    parser.configuration.addNode('fixStretchy', node);
    parser.Push(node);
  }
  ParseMethods.mathchar0mo = mathchar0mo;
  function mathchar7(parser, mchar) {
    var def = mchar.attributes || ({
      mathvariant: TexConstants_js_1$a.TexConstant.Variant.NORMAL
    });
    if (parser.stack.env['font']) {
      def['mathvariant'] = parser.stack.env['font'];
    }
    var node = parser.create('token', 'mi', def, mchar.char);
    parser.Push(node);
  }
  ParseMethods.mathchar7 = mathchar7;
  function delimiter(parser, delim) {
    var def = delim.attributes || ({});
    def = Object.assign({
      fence: false,
      stretchy: false
    }, def);
    var node = parser.create('token', 'mo', def, delim.char);
    parser.Push(node);
  }
  ParseMethods.delimiter = delimiter;
  function environment(parser, env, func, args) {
    var end = args[0];
    var mml = parser.itemFactory.create('begin').setProperties({
      name: env,
      end: end
    });
    mml = func.apply(void 0, __spreadArray$k([parser, mml], __read$D(args.slice(1)), false));
    parser.Push(mml);
  }
  ParseMethods.environment = environment;
})(ParseMethods || (ParseMethods = {}));
ParseMethods$1.default = ParseMethods;

var __createBinding$c = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$c = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$c = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$c(result, mod, k);
  __setModuleDefault$c(result, mod);
  return result;
});
var __importDefault$A = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BaseMappings, "__esModule", {
  value: true
});
var sm$4 = __importStar$c(SymbolMap);
var TexConstants_js_1$9 = TexConstants;
var BaseMethods_js_1$6 = __importDefault$A(BaseMethods$1);
var ParseMethods_js_1$7 = __importDefault$A(ParseMethods$1);
var ParseUtil_js_1$b = __importDefault$A(ParseUtil$1);
var MmlNode_js_1$H = MmlNode;
var lengths_js_1$5 = lengths;
new sm$4.RegExpMap('letter', ParseMethods_js_1$7.default.variable, /[a-z]/i);
new sm$4.RegExpMap('digit', ParseMethods_js_1$7.default.digit, /[0-9.,]/);
new sm$4.RegExpMap('command', ParseMethods_js_1$7.default.controlSequence, /^\\/);
new sm$4.MacroMap('special', {
  '{': 'Open',
  '}': 'Close',
  '~': 'Tilde',
  '^': 'Superscript',
  '_': 'Subscript',
  ' ': 'Space',
  '\t': 'Space',
  '\r': 'Space',
  '\n': 'Space',
  '\'': 'Prime',
  '%': 'Comment',
  '&': 'Entry',
  '#': 'Hash',
  '\u00A0': 'Space',
  '\u2019': 'Prime'
}, BaseMethods_js_1$6.default);
new sm$4.CharacterMap('mathchar0mi', ParseMethods_js_1$7.default.mathchar0mi, {
  alpha: '\u03B1',
  beta: '\u03B2',
  gamma: '\u03B3',
  delta: '\u03B4',
  epsilon: '\u03F5',
  zeta: '\u03B6',
  eta: '\u03B7',
  theta: '\u03B8',
  iota: '\u03B9',
  kappa: '\u03BA',
  lambda: '\u03BB',
  mu: '\u03BC',
  nu: '\u03BD',
  xi: '\u03BE',
  omicron: '\u03BF',
  pi: '\u03C0',
  rho: '\u03C1',
  sigma: '\u03C3',
  tau: '\u03C4',
  upsilon: '\u03C5',
  phi: '\u03D5',
  chi: '\u03C7',
  psi: '\u03C8',
  omega: '\u03C9',
  varepsilon: '\u03B5',
  vartheta: '\u03D1',
  varpi: '\u03D6',
  varrho: '\u03F1',
  varsigma: '\u03C2',
  varphi: '\u03C6',
  S: ['\u00A7', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  aleph: ['\u2135', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  hbar: ['\u210F', {
    variantForm: true
  }],
  imath: '\u0131',
  jmath: '\u0237',
  ell: '\u2113',
  wp: ['\u2118', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  Re: ['\u211C', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  Im: ['\u2111', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  partial: ['\u2202', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.ITALIC
  }],
  infty: ['\u221E', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  prime: ['\u2032', {
    variantForm: true
  }],
  emptyset: ['\u2205', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  nabla: ['\u2207', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  top: ['\u22A4', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  bot: ['\u22A5', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  angle: ['\u2220', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  triangle: ['\u25B3', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  backslash: ['\u2216', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  forall: ['\u2200', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  exists: ['\u2203', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  neg: ['\u00AC', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  lnot: ['\u00AC', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  flat: ['\u266D', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  natural: ['\u266E', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  sharp: ['\u266F', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  clubsuit: ['\u2663', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  diamondsuit: ['\u2662', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  heartsuit: ['\u2661', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }],
  spadesuit: ['\u2660', {
    mathvariant: TexConstants_js_1$9.TexConstant.Variant.NORMAL
  }]
});
new sm$4.CharacterMap('mathchar0mo', ParseMethods_js_1$7.default.mathchar0mo, {
  surd: '\u221A',
  coprod: ['\u2210', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigvee: ['\u22C1', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigwedge: ['\u22C0', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  biguplus: ['\u2A04', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigcap: ['\u22C2', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigcup: ['\u22C3', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  'int': ['\u222B', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP
  }],
  intop: ['\u222B', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true,
    movablelimits: true
  }],
  iint: ['\u222C', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP
  }],
  iiint: ['\u222D', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP
  }],
  prod: ['\u220F', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  sum: ['\u2211', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigotimes: ['\u2A02', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigoplus: ['\u2A01', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  bigodot: ['\u2A00', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  oint: ['\u222E', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP
  }],
  bigsqcup: ['\u2A06', {
    texClass: MmlNode_js_1$H.TEXCLASS.OP,
    movesupsub: true
  }],
  smallint: ['\u222B', {
    largeop: false
  }],
  triangleleft: '\u25C3',
  triangleright: '\u25B9',
  bigtriangleup: '\u25B3',
  bigtriangledown: '\u25BD',
  wedge: '\u2227',
  land: '\u2227',
  vee: '\u2228',
  lor: '\u2228',
  cap: '\u2229',
  cup: '\u222A',
  ddagger: '\u2021',
  dagger: '\u2020',
  sqcap: '\u2293',
  sqcup: '\u2294',
  uplus: '\u228E',
  amalg: '\u2A3F',
  diamond: '\u22C4',
  bullet: '\u2219',
  wr: '\u2240',
  div: '\u00F7',
  divsymbol: '\u00F7',
  odot: ['\u2299', {
    largeop: false
  }],
  oslash: ['\u2298', {
    largeop: false
  }],
  otimes: ['\u2297', {
    largeop: false
  }],
  ominus: ['\u2296', {
    largeop: false
  }],
  oplus: ['\u2295', {
    largeop: false
  }],
  mp: '\u2213',
  pm: '\u00B1',
  circ: '\u2218',
  bigcirc: '\u25EF',
  setminus: '\u2216',
  cdot: '\u22C5',
  ast: '\u2217',
  times: '\u00D7',
  star: '\u22C6',
  propto: '\u221D',
  sqsubseteq: '\u2291',
  sqsupseteq: '\u2292',
  parallel: '\u2225',
  mid: '\u2223',
  dashv: '\u22A3',
  vdash: '\u22A2',
  leq: '\u2264',
  le: '\u2264',
  geq: '\u2265',
  ge: '\u2265',
  lt: '\u003C',
  gt: '\u003E',
  succ: '\u227B',
  prec: '\u227A',
  approx: '\u2248',
  succeq: '\u2AB0',
  preceq: '\u2AAF',
  supset: '\u2283',
  subset: '\u2282',
  supseteq: '\u2287',
  subseteq: '\u2286',
  'in': '\u2208',
  ni: '\u220B',
  notin: '\u2209',
  owns: '\u220B',
  gg: '\u226B',
  ll: '\u226A',
  sim: '\u223C',
  simeq: '\u2243',
  perp: '\u22A5',
  equiv: '\u2261',
  asymp: '\u224D',
  smile: '\u2323',
  frown: '\u2322',
  ne: '\u2260',
  neq: '\u2260',
  cong: '\u2245',
  doteq: '\u2250',
  bowtie: '\u22C8',
  models: '\u22A8',
  notChar: '\u29F8',
  Leftrightarrow: '\u21D4',
  Leftarrow: '\u21D0',
  Rightarrow: '\u21D2',
  leftrightarrow: '\u2194',
  leftarrow: '\u2190',
  gets: '\u2190',
  rightarrow: '\u2192',
  to: ['\u2192', {
    accent: false
  }],
  mapsto: '\u21A6',
  leftharpoonup: '\u21BC',
  leftharpoondown: '\u21BD',
  rightharpoonup: '\u21C0',
  rightharpoondown: '\u21C1',
  nearrow: '\u2197',
  searrow: '\u2198',
  nwarrow: '\u2196',
  swarrow: '\u2199',
  rightleftharpoons: '\u21CC',
  hookrightarrow: '\u21AA',
  hookleftarrow: '\u21A9',
  longleftarrow: '\u27F5',
  Longleftarrow: '\u27F8',
  longrightarrow: '\u27F6',
  Longrightarrow: '\u27F9',
  Longleftrightarrow: '\u27FA',
  longleftrightarrow: '\u27F7',
  longmapsto: '\u27FC',
  ldots: '\u2026',
  cdots: '\u22EF',
  vdots: '\u22EE',
  ddots: '\u22F1',
  dotsc: '\u2026',
  dotsb: '\u22EF',
  dotsm: '\u22EF',
  dotsi: '\u22EF',
  dotso: '\u2026',
  ldotp: ['\u002E', {
    texClass: MmlNode_js_1$H.TEXCLASS.PUNCT
  }],
  cdotp: ['\u22C5', {
    texClass: MmlNode_js_1$H.TEXCLASS.PUNCT
  }],
  colon: ['\u003A', {
    texClass: MmlNode_js_1$H.TEXCLASS.PUNCT
  }]
});
new sm$4.CharacterMap('mathchar7', ParseMethods_js_1$7.default.mathchar7, {
  Gamma: '\u0393',
  Delta: '\u0394',
  Theta: '\u0398',
  Lambda: '\u039B',
  Xi: '\u039E',
  Pi: '\u03A0',
  Sigma: '\u03A3',
  Upsilon: '\u03A5',
  Phi: '\u03A6',
  Psi: '\u03A8',
  Omega: '\u03A9',
  '_': '\u005F',
  '#': '\u0023',
  '$': '\u0024',
  '%': '\u0025',
  '&': '\u0026',
  And: '\u0026'
});
new sm$4.DelimiterMap('delimiter', ParseMethods_js_1$7.default.delimiter, {
  '(': '(',
  ')': ')',
  '[': '[',
  ']': ']',
  '<': '\u27E8',
  '>': '\u27E9',
  '\\lt': '\u27E8',
  '\\gt': '\u27E9',
  '/': '/',
  '|': ['|', {
    texClass: MmlNode_js_1$H.TEXCLASS.ORD
  }],
  '.': '',
  '\\\\': '\\',
  '\\lmoustache': '\u23B0',
  '\\rmoustache': '\u23B1',
  '\\lgroup': '\u27EE',
  '\\rgroup': '\u27EF',
  '\\arrowvert': '\u23D0',
  '\\Arrowvert': '\u2016',
  '\\bracevert': '\u23AA',
  '\\Vert': ['\u2016', {
    texClass: MmlNode_js_1$H.TEXCLASS.ORD
  }],
  '\\|': ['\u2016', {
    texClass: MmlNode_js_1$H.TEXCLASS.ORD
  }],
  '\\vert': ['|', {
    texClass: MmlNode_js_1$H.TEXCLASS.ORD
  }],
  '\\uparrow': '\u2191',
  '\\downarrow': '\u2193',
  '\\updownarrow': '\u2195',
  '\\Uparrow': '\u21D1',
  '\\Downarrow': '\u21D3',
  '\\Updownarrow': '\u21D5',
  '\\backslash': '\\',
  '\\rangle': '\u27E9',
  '\\langle': '\u27E8',
  '\\rbrace': '}',
  '\\lbrace': '{',
  '\\}': '}',
  '\\{': '{',
  '\\rceil': '\u2309',
  '\\lceil': '\u2308',
  '\\rfloor': '\u230B',
  '\\lfloor': '\u230A',
  '\\lbrack': '[',
  '\\rbrack': ']'
});
new sm$4.CommandMap('macros', {
  displaystyle: ['SetStyle', 'D', true, 0],
  textstyle: ['SetStyle', 'T', false, 0],
  scriptstyle: ['SetStyle', 'S', false, 1],
  scriptscriptstyle: ['SetStyle', 'SS', false, 2],
  rm: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  mit: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.ITALIC],
  oldstyle: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.OLDSTYLE],
  cal: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.CALLIGRAPHIC],
  it: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.MATHITALIC],
  bf: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.BOLD],
  bbFont: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.DOUBLESTRUCK],
  scr: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.SCRIPT],
  frak: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.FRAKTUR],
  sf: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  tt: ['SetFont', TexConstants_js_1$9.TexConstant.Variant.MONOSPACE],
  mathrm: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  mathup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  mathnormal: ['MathFont', ''],
  mathbf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLD],
  mathbfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLD],
  mathit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.MATHITALIC],
  mathbfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDITALIC],
  mathbb: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.DOUBLESTRUCK],
  Bbb: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.DOUBLESTRUCK],
  mathfrak: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.FRAKTUR],
  mathbffrak: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDFRAKTUR],
  mathscr: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SCRIPT],
  mathbfscr: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSCRIPT],
  mathsf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  mathsfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  mathbfsf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSANSSERIF],
  mathbfsfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSANSSERIF],
  mathsfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIFITALIC],
  mathbfsfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIFBOLDITALIC],
  mathtt: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.MONOSPACE],
  mathcal: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.CALLIGRAPHIC],
  mathbfcal: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDCALLIGRAPHIC],
  symrm: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  symup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  symnormal: ['MathFont', ''],
  symbf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLD],
  symbfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLD],
  symit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.ITALIC],
  symbfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDITALIC],
  symbb: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.DOUBLESTRUCK],
  symfrak: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.FRAKTUR],
  symbffrak: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDFRAKTUR],
  symscr: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SCRIPT],
  symbfscr: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSCRIPT],
  symsf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  symsfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  symbfsf: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSANSSERIF],
  symbfsfup: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDSANSSERIF],
  symsfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIFITALIC],
  symbfsfit: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.SANSSERIFBOLDITALIC],
  symtt: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.MONOSPACE],
  symcal: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.CALLIGRAPHIC],
  symbfcal: ['MathFont', TexConstants_js_1$9.TexConstant.Variant.BOLDCALLIGRAPHIC],
  textrm: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  textup: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.NORMAL],
  textnormal: ['HBox'],
  textit: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.ITALIC],
  textbf: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.BOLD],
  textsf: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.SANSSERIF],
  texttt: ['HBox', null, TexConstants_js_1$9.TexConstant.Variant.MONOSPACE],
  tiny: ['SetSize', 0.5],
  Tiny: ['SetSize', 0.6],
  scriptsize: ['SetSize', 0.7],
  small: ['SetSize', 0.85],
  normalsize: ['SetSize', 1.0],
  large: ['SetSize', 1.2],
  Large: ['SetSize', 1.44],
  LARGE: ['SetSize', 1.73],
  huge: ['SetSize', 2.07],
  Huge: ['SetSize', 2.49],
  arcsin: 'NamedFn',
  arccos: 'NamedFn',
  arctan: 'NamedFn',
  arg: 'NamedFn',
  cos: 'NamedFn',
  cosh: 'NamedFn',
  cot: 'NamedFn',
  coth: 'NamedFn',
  csc: 'NamedFn',
  deg: 'NamedFn',
  det: 'NamedOp',
  dim: 'NamedFn',
  exp: 'NamedFn',
  gcd: 'NamedOp',
  hom: 'NamedFn',
  inf: 'NamedOp',
  ker: 'NamedFn',
  lg: 'NamedFn',
  lim: 'NamedOp',
  liminf: ['NamedOp', 'lim&thinsp;inf'],
  limsup: ['NamedOp', 'lim&thinsp;sup'],
  ln: 'NamedFn',
  log: 'NamedFn',
  max: 'NamedOp',
  min: 'NamedOp',
  Pr: 'NamedOp',
  sec: 'NamedFn',
  sin: 'NamedFn',
  sinh: 'NamedFn',
  sup: 'NamedOp',
  tan: 'NamedFn',
  tanh: 'NamedFn',
  limits: ['Limits', 1],
  nolimits: ['Limits', 0],
  overline: ['UnderOver', '2015'],
  underline: ['UnderOver', '2015'],
  overbrace: ['UnderOver', '23DE', 1],
  underbrace: ['UnderOver', '23DF', 1],
  overparen: ['UnderOver', '23DC'],
  underparen: ['UnderOver', '23DD'],
  overrightarrow: ['UnderOver', '2192'],
  underrightarrow: ['UnderOver', '2192'],
  overleftarrow: ['UnderOver', '2190'],
  underleftarrow: ['UnderOver', '2190'],
  overleftrightarrow: ['UnderOver', '2194'],
  underleftrightarrow: ['UnderOver', '2194'],
  overset: 'Overset',
  underset: 'Underset',
  overunderset: 'Overunderset',
  stackrel: ['Macro', '\\mathrel{\\mathop{#2}\\limits^{#1}}', 2],
  stackbin: ['Macro', '\\mathbin{\\mathop{#2}\\limits^{#1}}', 2],
  over: 'Over',
  overwithdelims: 'Over',
  atop: 'Over',
  atopwithdelims: 'Over',
  above: 'Over',
  abovewithdelims: 'Over',
  brace: ['Over', '{', '}'],
  brack: ['Over', '[', ']'],
  choose: ['Over', '(', ')'],
  frac: 'Frac',
  sqrt: 'Sqrt',
  root: 'Root',
  uproot: ['MoveRoot', 'upRoot'],
  leftroot: ['MoveRoot', 'leftRoot'],
  left: 'LeftRight',
  right: 'LeftRight',
  middle: 'LeftRight',
  llap: 'Lap',
  rlap: 'Lap',
  raise: 'RaiseLower',
  lower: 'RaiseLower',
  moveleft: 'MoveLeftRight',
  moveright: 'MoveLeftRight',
  ',': ['Spacer', lengths_js_1$5.MATHSPACE.thinmathspace],
  ':': ['Spacer', lengths_js_1$5.MATHSPACE.mediummathspace],
  '>': ['Spacer', lengths_js_1$5.MATHSPACE.mediummathspace],
  ';': ['Spacer', lengths_js_1$5.MATHSPACE.thickmathspace],
  '!': ['Spacer', lengths_js_1$5.MATHSPACE.negativethinmathspace],
  enspace: ['Spacer', .5],
  quad: ['Spacer', 1],
  qquad: ['Spacer', 2],
  thinspace: ['Spacer', lengths_js_1$5.MATHSPACE.thinmathspace],
  negthinspace: ['Spacer', lengths_js_1$5.MATHSPACE.negativethinmathspace],
  hskip: 'Hskip',
  hspace: 'Hskip',
  kern: 'Hskip',
  mskip: 'Hskip',
  mspace: 'Hskip',
  mkern: 'Hskip',
  rule: 'rule',
  Rule: ['Rule'],
  Space: ['Rule', 'blank'],
  nonscript: 'Nonscript',
  big: ['MakeBig', MmlNode_js_1$H.TEXCLASS.ORD, 0.85],
  Big: ['MakeBig', MmlNode_js_1$H.TEXCLASS.ORD, 1.15],
  bigg: ['MakeBig', MmlNode_js_1$H.TEXCLASS.ORD, 1.45],
  Bigg: ['MakeBig', MmlNode_js_1$H.TEXCLASS.ORD, 1.75],
  bigl: ['MakeBig', MmlNode_js_1$H.TEXCLASS.OPEN, 0.85],
  Bigl: ['MakeBig', MmlNode_js_1$H.TEXCLASS.OPEN, 1.15],
  biggl: ['MakeBig', MmlNode_js_1$H.TEXCLASS.OPEN, 1.45],
  Biggl: ['MakeBig', MmlNode_js_1$H.TEXCLASS.OPEN, 1.75],
  bigr: ['MakeBig', MmlNode_js_1$H.TEXCLASS.CLOSE, 0.85],
  Bigr: ['MakeBig', MmlNode_js_1$H.TEXCLASS.CLOSE, 1.15],
  biggr: ['MakeBig', MmlNode_js_1$H.TEXCLASS.CLOSE, 1.45],
  Biggr: ['MakeBig', MmlNode_js_1$H.TEXCLASS.CLOSE, 1.75],
  bigm: ['MakeBig', MmlNode_js_1$H.TEXCLASS.REL, 0.85],
  Bigm: ['MakeBig', MmlNode_js_1$H.TEXCLASS.REL, 1.15],
  biggm: ['MakeBig', MmlNode_js_1$H.TEXCLASS.REL, 1.45],
  Biggm: ['MakeBig', MmlNode_js_1$H.TEXCLASS.REL, 1.75],
  mathord: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.ORD],
  mathop: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.OP],
  mathopen: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.OPEN],
  mathclose: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.CLOSE],
  mathbin: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.BIN],
  mathrel: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.REL],
  mathpunct: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.PUNCT],
  mathinner: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.INNER],
  vcenter: ['TeXAtom', MmlNode_js_1$H.TEXCLASS.VCENTER],
  buildrel: 'BuildRel',
  hbox: ['HBox', 0],
  text: 'HBox',
  mbox: ['HBox', 0],
  fbox: 'FBox',
  boxed: ['Macro', '\\fbox{$\\displaystyle{#1}$}', 1],
  framebox: 'FrameBox',
  strut: 'Strut',
  mathstrut: ['Macro', '\\vphantom{(}'],
  phantom: 'Phantom',
  vphantom: ['Phantom', 1, 0],
  hphantom: ['Phantom', 0, 1],
  smash: 'Smash',
  acute: ['Accent', '00B4'],
  grave: ['Accent', '0060'],
  ddot: ['Accent', '00A8'],
  tilde: ['Accent', '007E'],
  bar: ['Accent', '00AF'],
  breve: ['Accent', '02D8'],
  check: ['Accent', '02C7'],
  hat: ['Accent', '005E'],
  vec: ['Accent', '2192'],
  dot: ['Accent', '02D9'],
  widetilde: ['Accent', '007E', 1],
  widehat: ['Accent', '005E', 1],
  matrix: 'Matrix',
  array: 'Matrix',
  pmatrix: ['Matrix', '(', ')'],
  cases: ['Matrix', '{', '', 'left left', null, '.1em', null, true],
  eqalign: ['Matrix', null, null, 'right left', (0, lengths_js_1$5.em)(lengths_js_1$5.MATHSPACE.thickmathspace), '.5em', 'D'],
  displaylines: ['Matrix', null, null, 'center', null, '.5em', 'D'],
  cr: 'Cr',
  '\\': 'CrLaTeX',
  newline: ['CrLaTeX', true],
  hline: ['HLine', 'solid'],
  hdashline: ['HLine', 'dashed'],
  eqalignno: ['Matrix', null, null, 'right left', (0, lengths_js_1$5.em)(lengths_js_1$5.MATHSPACE.thickmathspace), '.5em', 'D', null, 'right'],
  leqalignno: ['Matrix', null, null, 'right left', (0, lengths_js_1$5.em)(lengths_js_1$5.MATHSPACE.thickmathspace), '.5em', 'D', null, 'left'],
  hfill: 'HFill',
  hfil: 'HFill',
  hfilll: 'HFill',
  bmod: ['Macro', '\\mmlToken{mo}[lspace="thickmathspace"' + ' rspace="thickmathspace"]{mod}'],
  pmod: ['Macro', '\\pod{\\mmlToken{mi}{mod}\\kern 6mu #1}', 1],
  mod: ['Macro', '\\mathchoice{\\kern18mu}{\\kern12mu}' + '{\\kern12mu}{\\kern12mu}\\mmlToken{mi}{mod}\\,\\,#1', 1],
  pod: ['Macro', '\\mathchoice{\\kern18mu}{\\kern8mu}' + '{\\kern8mu}{\\kern8mu}(#1)', 1],
  iff: ['Macro', '\\;\\Longleftrightarrow\\;'],
  skew: ['Macro', '{{#2{#3\\mkern#1mu}\\mkern-#1mu}{}}', 3],
  pmb: ['Macro', '\\rlap{#1}\\kern1px{#1}', 1],
  TeX: ['Macro', 'T\\kern-.14em\\lower.5ex{E}\\kern-.115em X'],
  LaTeX: ['Macro', 'L\\kern-.325em\\raise.21em' + '{\\scriptstyle{A}}\\kern-.17em\\TeX'],
  ' ': ['Macro', '\\text{ }'],
  not: 'Not',
  dots: 'Dots',
  space: 'Tilde',
  '\u00A0': 'Tilde',
  begin: 'BeginEnd',
  end: 'BeginEnd',
  label: 'HandleLabel',
  ref: 'HandleRef',
  nonumber: 'HandleNoTag',
  mathchoice: 'MathChoice',
  mmlToken: 'MmlToken'
}, BaseMethods_js_1$6.default);
new sm$4.EnvironmentMap('environment', ParseMethods_js_1$7.default.environment, {
  array: ['AlignedArray'],
  equation: ['Equation', null, true],
  eqnarray: ['EqnArray', null, true, true, 'rcl', ParseUtil_js_1$b.default.cols(0, lengths_js_1$5.MATHSPACE.thickmathspace), '.5em']
}, BaseMethods_js_1$6.default);
new sm$4.CharacterMap('not_remap', null, {
  '\u2190': '\u219A',
  '\u2192': '\u219B',
  '\u2194': '\u21AE',
  '\u21D0': '\u21CD',
  '\u21D2': '\u21CF',
  '\u21D4': '\u21CE',
  '\u2208': '\u2209',
  '\u220B': '\u220C',
  '\u2223': '\u2224',
  '\u2225': '\u2226',
  '\u223C': '\u2241',
  '\u007E': '\u2241',
  '\u2243': '\u2244',
  '\u2245': '\u2247',
  '\u2248': '\u2249',
  '\u224D': '\u226D',
  '\u003D': '\u2260',
  '\u2261': '\u2262',
  '\u003C': '\u226E',
  '\u003E': '\u226F',
  '\u2264': '\u2270',
  '\u2265': '\u2271',
  '\u2272': '\u2274',
  '\u2273': '\u2275',
  '\u2276': '\u2278',
  '\u2277': '\u2279',
  '\u227A': '\u2280',
  '\u227B': '\u2281',
  '\u2282': '\u2284',
  '\u2283': '\u2285',
  '\u2286': '\u2288',
  '\u2287': '\u2289',
  '\u22A2': '\u22AC',
  '\u22A8': '\u22AD',
  '\u22A9': '\u22AE',
  '\u22AB': '\u22AF',
  '\u227C': '\u22E0',
  '\u227D': '\u22E1',
  '\u2291': '\u22E2',
  '\u2292': '\u22E3',
  '\u22B2': '\u22EA',
  '\u22B3': '\u22EB',
  '\u22B4': '\u22EC',
  '\u22B5': '\u22ED',
  '\u2203': '\u2204'
});

var __extends$1L = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __createBinding$b = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$b = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$b = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$b(result, mod, k);
  __setModuleDefault$b(result, mod);
  return result;
});
var __values$B = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$z = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
var _a$a;
Object.defineProperty(BaseConfiguration, "__esModule", {
  value: true
});
BaseConfiguration.BaseConfiguration = BaseConfiguration.BaseTags = BaseConfiguration.Other = void 0;
var Configuration_js_1$k = Configuration;
var MapHandler_js_1 = MapHandler;
var TexError_js_1$f = __importDefault$z(TexError$1);
var NodeUtil_js_1$9 = __importDefault$z(NodeUtil$1);
var SymbolMap_js_1$g = SymbolMap;
var bitem = __importStar$b(BaseItems);
var Tags_js_1$5 = Tags;
var OperatorDictionary_js_1 = OperatorDictionary;
new SymbolMap_js_1$g.CharacterMap('remap', null, {
  '-': '\u2212',
  '*': '\u2217',
  '`': '\u2018'
});
function Other(parser, char) {
  var font = parser.stack.env['font'];
  var def = font ? {
    mathvariant: parser.stack.env['font']
  } : {};
  var remap = MapHandler_js_1.MapHandler.getMap('remap').lookup(char);
  var range = (0, OperatorDictionary_js_1.getRange)(char);
  var type = range ? range[3] : 'mo';
  var mo = parser.create('token', type, def, remap ? remap.char : char);
  range[4] && mo.attributes.set('mathvariant', range[4]);
  if (type === 'mo') {
    NodeUtil_js_1$9.default.setProperty(mo, 'fixStretchy', true);
    parser.configuration.addNode('fixStretchy', mo);
  }
  parser.Push(mo);
}
BaseConfiguration.Other = Other;
function csUndefined(_parser, name) {
  throw new TexError_js_1$f.default('UndefinedControlSequence', 'Undefined control sequence %1', '\\' + name);
}
function envUndefined(_parser, env) {
  throw new TexError_js_1$f.default('UnknownEnv', 'Unknown environment \'%1\'', env);
}
function filterNonscript(_a) {
  var e_1, _b;
  var data = _a.data;
  try {
    for (var _c = __values$B(data.getList('nonscript')), _d = _c.next(); !_d.done; _d = _c.next()) {
      var mml = _d.value;
      if (mml.attributes.get('scriptlevel') > 0) {
        var parent_1 = mml.parent;
        parent_1.childNodes.splice(parent_1.childIndex(mml), 1);
        data.removeFromList(mml.kind, [mml]);
        if (mml.isKind('mrow')) {
          var mstyle = mml.childNodes[0];
          data.removeFromList('mstyle', [mstyle]);
          data.removeFromList('mspace', mstyle.childNodes[0].childNodes);
        }
      } else if (mml.isKind('mrow')) {
        mml.parent.replaceChild(mml.childNodes[0], mml);
        data.removeFromList('mrow', [mml]);
      }
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
}
var BaseTags = (function (_super) {
  __extends$1L(BaseTags, _super);
  function BaseTags() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return BaseTags;
})(Tags_js_1$5.AbstractTags);
BaseConfiguration.BaseTags = BaseTags;
BaseConfiguration.BaseConfiguration = Configuration_js_1$k.Configuration.create('base', {
  handler: {
    character: ['command', 'special', 'letter', 'digit'],
    delimiter: ['delimiter'],
    macro: ['delimiter', 'macros', 'mathchar0mi', 'mathchar0mo', 'mathchar7'],
    environment: ['environment']
  },
  fallback: {
    character: Other,
    macro: csUndefined,
    environment: envUndefined
  },
  items: (_a$a = {}, _a$a[bitem.StartItem.prototype.kind] = bitem.StartItem, _a$a[bitem.StopItem.prototype.kind] = bitem.StopItem, _a$a[bitem.OpenItem.prototype.kind] = bitem.OpenItem, _a$a[bitem.CloseItem.prototype.kind] = bitem.CloseItem, _a$a[bitem.PrimeItem.prototype.kind] = bitem.PrimeItem, _a$a[bitem.SubsupItem.prototype.kind] = bitem.SubsupItem, _a$a[bitem.OverItem.prototype.kind] = bitem.OverItem, _a$a[bitem.LeftItem.prototype.kind] = bitem.LeftItem, _a$a[bitem.Middle.prototype.kind] = bitem.Middle, _a$a[bitem.RightItem.prototype.kind] = bitem.RightItem, _a$a[bitem.BeginItem.prototype.kind] = bitem.BeginItem, _a$a[bitem.EndItem.prototype.kind] = bitem.EndItem, _a$a[bitem.StyleItem.prototype.kind] = bitem.StyleItem, _a$a[bitem.PositionItem.prototype.kind] = bitem.PositionItem, _a$a[bitem.CellItem.prototype.kind] = bitem.CellItem, _a$a[bitem.MmlItem.prototype.kind] = bitem.MmlItem, _a$a[bitem.FnItem.prototype.kind] = bitem.FnItem, _a$a[bitem.NotItem.prototype.kind] = bitem.NotItem, _a$a[bitem.NonscriptItem.prototype.kind] = bitem.NonscriptItem, _a$a[bitem.DotsItem.prototype.kind] = bitem.DotsItem, _a$a[bitem.ArrayItem.prototype.kind] = bitem.ArrayItem, _a$a[bitem.EqnArrayItem.prototype.kind] = bitem.EqnArrayItem, _a$a[bitem.EquationItem.prototype.kind] = bitem.EquationItem, _a$a),
  options: {
    maxMacros: 1000,
    baseURL: typeof document === 'undefined' || document.getElementsByTagName('base').length === 0 ? '' : String(document.location).replace(/#.*$/, '')
  },
  tags: {
    base: BaseTags
  },
  postprocessors: [[filterNonscript, -4]]
});

var __extends$1K = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$C = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$C = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$C.apply(this, arguments);
});
var __read$C = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __importDefault$y = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(tex$2, "__esModule", {
  value: true
});
var TeX_1 = tex$2.TeX = void 0;
var InputJax_js_1 = InputJax;
var Options_js_1$7 = Options;
var FindTeX_js_1 = FindTeX$1;
var FilterUtil_js_1 = __importDefault$y(FilterUtil$1);
var NodeUtil_js_1$8 = __importDefault$y(NodeUtil$1);
var TexParser_js_1$8 = __importDefault$y(TexParser$1);
var TexError_js_1$e = __importDefault$y(TexError$1);
var ParseOptions_js_1$1 = __importDefault$y(ParseOptions$1);
var Tags_js_1$4 = Tags;
var Configuration_js_1$j = Configuration;
var TeX = (function (_super) {
  __extends$1K(TeX, _super);
  function TeX(options) {
    if (options === void 0) {
      options = {};
    }
    var _this = this;
    var _a = __read$C((0, Options_js_1$7.separateOptions)(options, TeX.OPTIONS, FindTeX_js_1.FindTeX.OPTIONS), 3), rest = _a[0], tex = _a[1], find = _a[2];
    _this = _super.call(this, tex) || this;
    _this.findTeX = _this.options['FindTeX'] || new FindTeX_js_1.FindTeX(find);
    var packages = _this.options.packages;
    var configuration = _this.configuration = TeX.configure(packages);
    var parseOptions = _this._parseOptions = new ParseOptions_js_1$1.default(configuration, [_this.options, Tags_js_1$4.TagsFactory.OPTIONS]);
    (0, Options_js_1$7.userOptions)(parseOptions.options, rest);
    configuration.config(_this);
    TeX.tags(parseOptions, configuration);
    _this.postFilters.add(FilterUtil_js_1.default.cleanSubSup, -6);
    _this.postFilters.add(FilterUtil_js_1.default.setInherited, -5);
    _this.postFilters.add(FilterUtil_js_1.default.moveLimits, -4);
    _this.postFilters.add(FilterUtil_js_1.default.cleanStretchy, -3);
    _this.postFilters.add(FilterUtil_js_1.default.cleanAttributes, -2);
    _this.postFilters.add(FilterUtil_js_1.default.combineRelations, -1);
    return _this;
  }
  TeX.configure = function (packages) {
    var configuration = new Configuration_js_1$j.ParserConfiguration(packages, ['tex']);
    configuration.init();
    return configuration;
  };
  TeX.tags = function (options, configuration) {
    Tags_js_1$4.TagsFactory.addTags(configuration.tags);
    Tags_js_1$4.TagsFactory.setDefault(options.options.tags);
    options.tags = Tags_js_1$4.TagsFactory.getDefault();
    options.tags.configuration = options;
  };
  TeX.prototype.setMmlFactory = function (mmlFactory) {
    _super.prototype.setMmlFactory.call(this, mmlFactory);
    this._parseOptions.nodeFactory.setMmlFactory(mmlFactory);
  };
  Object.defineProperty(TeX.prototype, "parseOptions", {
    get: function () {
      return this._parseOptions;
    },
    enumerable: false,
    configurable: true
  });
  TeX.prototype.reset = function (tag) {
    if (tag === void 0) {
      tag = 0;
    }
    this.parseOptions.tags.reset(tag);
  };
  TeX.prototype.compile = function (math, document) {
    this.parseOptions.clear();
    this.executeFilters(this.preFilters, math, document, this.parseOptions);
    var display = math.display;
    this.latex = math.math;
    var node;
    this.parseOptions.tags.startEquation(math);
    var globalEnv;
    try {
      var parser = new TexParser_js_1$8.default(this.latex, {
        display: display,
        isInner: false
      }, this.parseOptions);
      node = parser.mml();
      globalEnv = parser.stack.global;
    } catch (err) {
      if (!(err instanceof TexError_js_1$e.default)) {
        throw err;
      }
      this.parseOptions.error = true;
      node = this.options.formatError(this, err);
    }
    node = this.parseOptions.nodeFactory.create('node', 'math', [node]);
    if (globalEnv === null || globalEnv === void 0 ? void 0 : globalEnv.indentalign) {
      NodeUtil_js_1$8.default.setAttribute(node, 'indentalign', globalEnv.indentalign);
    }
    if (display) {
      NodeUtil_js_1$8.default.setAttribute(node, 'display', 'block');
    }
    this.parseOptions.tags.finishEquation(math);
    this.parseOptions.root = node;
    this.executeFilters(this.postFilters, math, document, this.parseOptions);
    this.mathNode = this.parseOptions.root;
    return this.mathNode;
  };
  TeX.prototype.findMath = function (strings) {
    return this.findTeX.findMath(strings);
  };
  TeX.prototype.formatError = function (err) {
    var message = err.message.replace(/\n.*/, '');
    return this.parseOptions.nodeFactory.create('error', message, err.id, this.latex);
  };
  TeX.NAME = 'TeX';
  TeX.OPTIONS = __assign$C(__assign$C({}, InputJax_js_1.AbstractInputJax.OPTIONS), {
    FindTeX: null,
    packages: ['base'],
    digits: /^(?:[0-9]+(?:\{,\}[0-9]{3})*(?:\.[0-9]*)?|\.[0-9]+)/,
    maxBuffer: 5 * 1024,
    formatError: function (jax, err) {
      return jax.formatError(err);
    }
  });
  return TeX;
})(InputJax_js_1.AbstractInputJax);
TeX_1 = tex$2.TeX = TeX;

var chtml = {};

var OutputJax$1 = {};

var OutputJax = {};

Object.defineProperty(OutputJax, "__esModule", {
  value: true
});
OutputJax.AbstractOutputJax = void 0;
var Options_js_1$6 = Options;
var FunctionList_js_1 = FunctionList$1;
var AbstractOutputJax = (function () {
  function AbstractOutputJax(options) {
    if (options === void 0) {
      options = {};
    }
    this.adaptor = null;
    var CLASS = this.constructor;
    this.options = (0, Options_js_1$6.userOptions)((0, Options_js_1$6.defaultOptions)({}, CLASS.OPTIONS), options);
    this.postFilters = new FunctionList_js_1.FunctionList();
  }
  Object.defineProperty(AbstractOutputJax.prototype, "name", {
    get: function () {
      return this.constructor.NAME;
    },
    enumerable: false,
    configurable: true
  });
  AbstractOutputJax.prototype.setAdaptor = function (adaptor) {
    this.adaptor = adaptor;
  };
  AbstractOutputJax.prototype.initialize = function () {};
  AbstractOutputJax.prototype.reset = function () {
    var _args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      _args[_i] = arguments[_i];
    }
  };
  AbstractOutputJax.prototype.getMetrics = function (_document) {};
  AbstractOutputJax.prototype.styleSheet = function (_document) {
    return null;
  };
  AbstractOutputJax.prototype.pageElements = function (_document) {
    return null;
  };
  AbstractOutputJax.prototype.executeFilters = function (filters, math, document, data) {
    var args = {
      math: math,
      document: document,
      data: data
    };
    filters.execute(args);
    return args.data;
  };
  AbstractOutputJax.NAME = 'generic';
  AbstractOutputJax.OPTIONS = {};
  return AbstractOutputJax;
})();
OutputJax.AbstractOutputJax = AbstractOutputJax;

var Styles$1 = {};

var __values$A = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$B = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$j = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(Styles$1, "__esModule", {
  value: true
});
Styles$1.Styles = void 0;
var TRBL = ['top', 'right', 'bottom', 'left'];
var WSC = ['width', 'style', 'color'];
function splitSpaces(text) {
  var parts = text.split(/((?:'[^']*'|"[^"]*"|,[\s\n]|[^\s\n])*)/g);
  var split = [];
  while (parts.length > 1) {
    parts.shift();
    split.push(parts.shift());
  }
  return split;
}
function splitTRBL(name) {
  var e_1, _a;
  var parts = splitSpaces(this.styles[name]);
  if (parts.length === 0) {
    parts.push('');
  }
  if (parts.length === 1) {
    parts.push(parts[0]);
  }
  if (parts.length === 2) {
    parts.push(parts[0]);
  }
  if (parts.length === 3) {
    parts.push(parts[1]);
  }
  try {
    for (var _b = __values$A(Styles.connect[name].children), _c = _b.next(); !_c.done; _c = _b.next()) {
      var child = _c.value;
      this.setStyle(this.childName(name, child), parts.shift());
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
}
function combineTRBL(name) {
  var e_2, _a;
  var children = Styles.connect[name].children;
  var parts = [];
  try {
    for (var children_1 = __values$A(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
      var child = children_1_1.value;
      var part = this.styles[name + '-' + child];
      if (!part) {
        delete this.styles[name];
        return;
      }
      parts.push(part);
    }
  } catch (e_2_1) {
    e_2 = {
      error: e_2_1
    };
  } finally {
    try {
      if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
    } finally {
      if (e_2) throw e_2.error;
    }
  }
  if (parts[3] === parts[1]) {
    parts.pop();
    if (parts[2] === parts[0]) {
      parts.pop();
      if (parts[1] === parts[0]) {
        parts.pop();
      }
    }
  }
  this.styles[name] = parts.join(' ');
}
function splitSame(name) {
  var e_3, _a;
  try {
    for (var _b = __values$A(Styles.connect[name].children), _c = _b.next(); !_c.done; _c = _b.next()) {
      var child = _c.value;
      this.setStyle(this.childName(name, child), this.styles[name]);
    }
  } catch (e_3_1) {
    e_3 = {
      error: e_3_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_3) throw e_3.error;
    }
  }
}
function combineSame(name) {
  var e_4, _a;
  var children = __spreadArray$j([], __read$B(Styles.connect[name].children), false);
  var value = this.styles[this.childName(name, children.shift())];
  try {
    for (var children_2 = __values$A(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
      var child = children_2_1.value;
      if (this.styles[this.childName(name, child)] !== value) {
        delete this.styles[name];
        return;
      }
    }
  } catch (e_4_1) {
    e_4 = {
      error: e_4_1
    };
  } finally {
    try {
      if (children_2_1 && !children_2_1.done && (_a = children_2.return)) _a.call(children_2);
    } finally {
      if (e_4) throw e_4.error;
    }
  }
  this.styles[name] = value;
}
var BORDER = {
  width: /^(?:[\d.]+(?:[a-z]+)|thin|medium|thick|inherit|initial|unset)$/,
  style: /^(?:none|hidden|dotted|dashed|solid|double|groove|ridge|inset|outset|inherit|initial|unset)$/
};
function splitWSC(name) {
  var e_5, _a, e_6, _b;
  var parts = {
    width: '',
    style: '',
    color: ''
  };
  try {
    for (var _c = __values$A(splitSpaces(this.styles[name])), _d = _c.next(); !_d.done; _d = _c.next()) {
      var part = _d.value;
      if (part.match(BORDER.width) && parts.width === '') {
        parts.width = part;
      } else if (part.match(BORDER.style) && parts.style === '') {
        parts.style = part;
      } else {
        parts.color = part;
      }
    }
  } catch (e_5_1) {
    e_5 = {
      error: e_5_1
    };
  } finally {
    try {
      if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
    } finally {
      if (e_5) throw e_5.error;
    }
  }
  try {
    for (var _e = __values$A(Styles.connect[name].children), _f = _e.next(); !_f.done; _f = _e.next()) {
      var child = _f.value;
      this.setStyle(this.childName(name, child), parts[child]);
    }
  } catch (e_6_1) {
    e_6 = {
      error: e_6_1
    };
  } finally {
    try {
      if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
    } finally {
      if (e_6) throw e_6.error;
    }
  }
}
function combineWSC(name) {
  var e_7, _a;
  var parts = [];
  try {
    for (var _b = __values$A(Styles.connect[name].children), _c = _b.next(); !_c.done; _c = _b.next()) {
      var child = _c.value;
      var value = this.styles[this.childName(name, child)];
      if (value) {
        parts.push(value);
      }
    }
  } catch (e_7_1) {
    e_7 = {
      error: e_7_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_7) throw e_7.error;
    }
  }
  if (parts.length) {
    this.styles[name] = parts.join(' ');
  } else {
    delete this.styles[name];
  }
}
var FONT = {
  style: /^(?:normal|italic|oblique|inherit|initial|unset)$/,
  variant: new RegExp('^(?:' + ['normal|none', 'inherit|initial|unset', 'common-ligatures|no-common-ligatures', 'discretionary-ligatures|no-discretionary-ligatures', 'historical-ligatures|no-historical-ligatures', 'contextual|no-contextual', '(?:stylistic|character-variant|swash|ornaments|annotation)\\([^)]*\\)', 'small-caps|all-small-caps|petite-caps|all-petite-caps|unicase|titling-caps', 'lining-nums|oldstyle-nums|proportional-nums|tabular-nums', 'diagonal-fractions|stacked-fractions', 'ordinal|slashed-zero', 'jis78|jis83|jis90|jis04|simplified|traditional', 'full-width|proportional-width', 'ruby'].join('|') + ')$'),
  weight: /^(?:normal|bold|bolder|lighter|[1-9]00|inherit|initial|unset)$/,
  stretch: new RegExp('^(?:' + ['normal', '(?:(?:ultra|extra|semi)-)?condensed', '(?:(?:semi|extra|ulta)-)?expanded', 'inherit|initial|unset'].join('|') + ')$'),
  size: new RegExp('^(?:' + ['xx-small|x-small|small|medium|large|x-large|xx-large|larger|smaller', '[\d.]+%|[\d.]+[a-z]+', 'inherit|initial|unset'].join('|') + ')' + '(?:\/(?:normal|[\d.\+](?:%|[a-z]+)?))?$')
};
function splitFont(name) {
  var e_8, _a, e_9, _b;
  var parts = splitSpaces(this.styles[name]);
  var value = {
    style: '',
    variant: [],
    weight: '',
    stretch: '',
    size: '',
    family: '',
    'line-height': ''
  };
  try {
    for (var parts_1 = __values$A(parts), parts_1_1 = parts_1.next(); !parts_1_1.done; parts_1_1 = parts_1.next()) {
      var part = parts_1_1.value;
      value.family = part;
      try {
        for (var _c = (e_9 = void 0, __values$A(Object.keys(FONT))), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_1 = _d.value;
          if ((Array.isArray(value[name_1]) || value[name_1] === '') && part.match(FONT[name_1])) {
            if (name_1 === 'size') {
              var _e = __read$B(part.split(/\//), 2), size = _e[0], height = _e[1];
              value[name_1] = size;
              if (height) {
                value['line-height'] = height;
              }
            } else if (value.size === '') {
              if (Array.isArray(value[name_1])) {
                value[name_1].push(part);
              } else {
                value[name_1] = part;
              }
            }
          }
        }
      } catch (e_9_1) {
        e_9 = {
          error: e_9_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        } finally {
          if (e_9) throw e_9.error;
        }
      }
    }
  } catch (e_8_1) {
    e_8 = {
      error: e_8_1
    };
  } finally {
    try {
      if (parts_1_1 && !parts_1_1.done && (_a = parts_1.return)) _a.call(parts_1);
    } finally {
      if (e_8) throw e_8.error;
    }
  }
  saveFontParts(name, value);
  delete this.styles[name];
}
function saveFontParts(name, value) {
  var e_10, _a;
  try {
    for (var _b = __values$A(Styles.connect[name].children), _c = _b.next(); !_c.done; _c = _b.next()) {
      var child = _c.value;
      var cname = this.childName(name, child);
      if (Array.isArray(value[child])) {
        var values = value[child];
        if (values.length) {
          this.styles[cname] = values.join(' ');
        }
      } else if (value[child] !== '') {
        this.styles[cname] = value[child];
      }
    }
  } catch (e_10_1) {
    e_10 = {
      error: e_10_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_10) throw e_10.error;
    }
  }
}
function combineFont(_name) {}
var Styles = (function () {
  function Styles(cssText) {
    if (cssText === void 0) {
      cssText = '';
    }
    this.parse(cssText);
  }
  Object.defineProperty(Styles.prototype, "cssText", {
    get: function () {
      var e_11, _a;
      var styles = [];
      try {
        for (var _b = __values$A(Object.keys(this.styles)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var name_2 = _c.value;
          var parent_1 = this.parentName(name_2);
          if (!this.styles[parent_1]) {
            styles.push(name_2 + ': ' + this.styles[name_2] + ';');
          }
        }
      } catch (e_11_1) {
        e_11 = {
          error: e_11_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_11) throw e_11.error;
        }
      }
      return styles.join(' ');
    },
    enumerable: false,
    configurable: true
  });
  Styles.prototype.set = function (name, value) {
    name = this.normalizeName(name);
    this.setStyle(name, value);
    if (Styles.connect[name] && !Styles.connect[name].combine) {
      this.combineChildren(name);
      delete this.styles[name];
    }
    while (name.match(/-/)) {
      name = this.parentName(name);
      if (!Styles.connect[name]) break;
      Styles.connect[name].combine.call(this, name);
    }
  };
  Styles.prototype.get = function (name) {
    name = this.normalizeName(name);
    return this.styles.hasOwnProperty(name) ? this.styles[name] : '';
  };
  Styles.prototype.setStyle = function (name, value) {
    this.styles[name] = value;
    if (Styles.connect[name] && Styles.connect[name].children) {
      Styles.connect[name].split.call(this, name);
    }
    if (value === '') {
      delete this.styles[name];
    }
  };
  Styles.prototype.combineChildren = function (name) {
    var e_12, _a;
    var parent = this.parentName(name);
    try {
      for (var _b = __values$A(Styles.connect[name].children), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        var cname = this.childName(parent, child);
        Styles.connect[cname].combine.call(this, cname);
      }
    } catch (e_12_1) {
      e_12 = {
        error: e_12_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_12) throw e_12.error;
      }
    }
  };
  Styles.prototype.parentName = function (name) {
    var parent = name.replace(/-[^-]*$/, '');
    return name === parent ? '' : parent;
  };
  Styles.prototype.childName = function (name, child) {
    if (child.match(/-/)) {
      return child;
    }
    if (Styles.connect[name] && !Styles.connect[name].combine) {
      child += name.replace(/.*-/, '-');
      name = this.parentName(name);
    }
    return name + '-' + child;
  };
  Styles.prototype.normalizeName = function (name) {
    return name.replace(/[A-Z]/g, function (c) {
      return '-' + c.toLowerCase();
    });
  };
  Styles.prototype.parse = function (cssText) {
    if (cssText === void 0) {
      cssText = '';
    }
    var PATTERN = this.constructor.pattern;
    this.styles = {};
    var parts = cssText.replace(PATTERN.comment, '').split(PATTERN.style);
    while (parts.length > 1) {
      var _a = __read$B(parts.splice(0, 3), 3), space = _a[0], name_3 = _a[1], value = _a[2];
      if (space.match(/[^\s\n]/)) return;
      this.set(name_3, value);
    }
  };
  Styles.pattern = {
    style: /([-a-z]+)[\s\n]*:[\s\n]*((?:'[^']*'|"[^"]*"|\n|.)*?)[\s\n]*(?:;|$)/g,
    comment: /\/\*[^]*?\*\//g
  };
  Styles.connect = {
    padding: {
      children: TRBL,
      split: splitTRBL,
      combine: combineTRBL
    },
    border: {
      children: TRBL,
      split: splitSame,
      combine: combineSame
    },
    'border-top': {
      children: WSC,
      split: splitWSC,
      combine: combineWSC
    },
    'border-right': {
      children: WSC,
      split: splitWSC,
      combine: combineWSC
    },
    'border-bottom': {
      children: WSC,
      split: splitWSC,
      combine: combineWSC
    },
    'border-left': {
      children: WSC,
      split: splitWSC,
      combine: combineWSC
    },
    'border-width': {
      children: TRBL,
      split: splitTRBL,
      combine: null
    },
    'border-style': {
      children: TRBL,
      split: splitTRBL,
      combine: null
    },
    'border-color': {
      children: TRBL,
      split: splitTRBL,
      combine: null
    },
    font: {
      children: ['style', 'variant', 'weight', 'stretch', 'line-height', 'size', 'family'],
      split: splitFont,
      combine: combineFont
    }
  };
  return Styles;
})();
Styles$1.Styles = Styles;

var StyleList = {};

var __values$z = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(StyleList, "__esModule", {
  value: true
});
StyleList.CssStyles = void 0;
var CssStyles = (function () {
  function CssStyles(styles) {
    if (styles === void 0) {
      styles = null;
    }
    this.styles = {};
    this.addStyles(styles);
  }
  Object.defineProperty(CssStyles.prototype, "cssText", {
    get: function () {
      return this.getStyleString();
    },
    enumerable: false,
    configurable: true
  });
  CssStyles.prototype.addStyles = function (styles) {
    var e_1, _a;
    if (!styles) return;
    try {
      for (var _b = __values$z(Object.keys(styles)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var style = _c.value;
        if (!this.styles[style]) {
          this.styles[style] = {};
        }
        Object.assign(this.styles[style], styles[style]);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  CssStyles.prototype.removeStyles = function () {
    var e_2, _a;
    var selectors = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      selectors[_i] = arguments[_i];
    }
    try {
      for (var selectors_1 = __values$z(selectors), selectors_1_1 = selectors_1.next(); !selectors_1_1.done; selectors_1_1 = selectors_1.next()) {
        var selector = selectors_1_1.value;
        delete this.styles[selector];
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (selectors_1_1 && !selectors_1_1.done && (_a = selectors_1.return)) _a.call(selectors_1);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  CssStyles.prototype.clear = function () {
    this.styles = {};
  };
  CssStyles.prototype.getStyleString = function () {
    return this.getStyleRules().join('\n\n');
  };
  CssStyles.prototype.getStyleRules = function () {
    var e_3, _a;
    var selectors = Object.keys(this.styles);
    var defs = new Array(selectors.length);
    var i = 0;
    try {
      for (var selectors_2 = __values$z(selectors), selectors_2_1 = selectors_2.next(); !selectors_2_1.done; selectors_2_1 = selectors_2.next()) {
        var selector = selectors_2_1.value;
        defs[i++] = selector + ' {\n' + this.getStyleDefString(this.styles[selector]) + '\n}';
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (selectors_2_1 && !selectors_2_1.done && (_a = selectors_2.return)) _a.call(selectors_2);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    return defs;
  };
  CssStyles.prototype.getStyleDefString = function (styles) {
    var e_4, _a;
    var properties = Object.keys(styles);
    var values = new Array(properties.length);
    var i = 0;
    try {
      for (var properties_1 = __values$z(properties), properties_1_1 = properties_1.next(); !properties_1_1.done; properties_1_1 = properties_1.next()) {
        var property = properties_1_1.value;
        values[i++] = '  ' + property + ': ' + styles[property] + ';';
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (properties_1_1 && !properties_1_1.done && (_a = properties_1.return)) _a.call(properties_1);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    return values.join('\n');
  };
  return CssStyles;
})();
StyleList.CssStyles = CssStyles;

var __extends$1J = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$B = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$B = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$B.apply(this, arguments);
});
var __read$A = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$y = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(OutputJax$1, "__esModule", {
  value: true
});
OutputJax$1.CommonOutputJax = void 0;
var OutputJax_js_1$1 = OutputJax;
var MathItem_js_1$2 = MathItem;
var Options_js_1$5 = Options;
var lengths_js_1$4 = lengths;
var Styles_js_1$1 = Styles$1;
var StyleList_js_1$1 = StyleList;
var CommonOutputJax = (function (_super) {
  __extends$1J(CommonOutputJax, _super);
  function CommonOutputJax(options, defaultFactory, defaultFont) {
    if (options === void 0) {
      options = null;
    }
    if (defaultFactory === void 0) {
      defaultFactory = null;
    }
    if (defaultFont === void 0) {
      defaultFont = null;
    }
    var _this = this;
    var _a = __read$A((0, Options_js_1$5.separateOptions)(options, defaultFont.OPTIONS), 2), jaxOptions = _a[0], fontOptions = _a[1];
    _this = _super.call(this, jaxOptions) || this;
    _this.factory = _this.options.wrapperFactory || new defaultFactory();
    _this.factory.jax = _this;
    _this.cssStyles = _this.options.cssStyles || new StyleList_js_1$1.CssStyles();
    _this.font = _this.options.font || new defaultFont(fontOptions);
    _this.unknownCache = new Map();
    return _this;
  }
  CommonOutputJax.prototype.typeset = function (math, html) {
    this.setDocument(html);
    var node = this.createNode();
    this.toDOM(math, node, html);
    return node;
  };
  CommonOutputJax.prototype.createNode = function () {
    var jax = this.constructor.NAME;
    return this.html('mjx-container', {
      'class': 'MathJax',
      jax: jax
    });
  };
  CommonOutputJax.prototype.setScale = function (node) {
    var scale = this.math.metrics.scale * this.options.scale;
    if (scale !== 1) {
      this.adaptor.setStyle(node, 'fontSize', (0, lengths_js_1$4.percent)(scale));
    }
  };
  CommonOutputJax.prototype.toDOM = function (math, node, html) {
    if (html === void 0) {
      html = null;
    }
    this.setDocument(html);
    this.math = math;
    this.pxPerEm = math.metrics.ex / this.font.params.x_height;
    math.root.setTeXclass(null);
    this.setScale(node);
    this.nodeMap = new Map();
    this.container = node;
    this.processMath(math.root, node);
    this.nodeMap = null;
    this.executeFilters(this.postFilters, math, html, node);
  };
  CommonOutputJax.prototype.getBBox = function (math, html) {
    this.setDocument(html);
    this.math = math;
    math.root.setTeXclass(null);
    this.nodeMap = new Map();
    var bbox = this.factory.wrap(math.root).getOuterBBox();
    this.nodeMap = null;
    return bbox;
  };
  CommonOutputJax.prototype.getMetrics = function (html) {
    var e_1, _a;
    this.setDocument(html);
    var adaptor = this.adaptor;
    var maps = this.getMetricMaps(html);
    try {
      for (var _b = __values$y(html.math), _c = _b.next(); !_c.done; _c = _b.next()) {
        var math = _c.value;
        var parent_1 = adaptor.parent(math.start.node);
        if (math.state() < MathItem_js_1$2.STATE.METRICS && parent_1) {
          var map = maps[math.display ? 1 : 0];
          var _d = map.get(parent_1), em = _d.em, ex = _d.ex, containerWidth = _d.containerWidth, lineWidth = _d.lineWidth, scale = _d.scale, family = _d.family;
          math.setMetrics(em, ex, containerWidth, lineWidth, scale);
          if (this.options.mtextInheritFont) {
            math.outputData.mtextFamily = family;
          }
          if (this.options.merrorInheritFont) {
            math.outputData.merrorFamily = family;
          }
          math.state(MathItem_js_1$2.STATE.METRICS);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  CommonOutputJax.prototype.getMetricsFor = function (node, display) {
    var getFamily = this.options.mtextInheritFont || this.options.merrorInheritFont;
    var test = this.getTestElement(node, display);
    var metrics = this.measureMetrics(test, getFamily);
    this.adaptor.remove(test);
    return metrics;
  };
  CommonOutputJax.prototype.getMetricMaps = function (html) {
    var e_2, _a, e_3, _b, e_4, _c, e_5, _d, e_6, _e;
    var adaptor = this.adaptor;
    var domMaps = [new Map(), new Map()];
    try {
      for (var _f = __values$y(html.math), _g = _f.next(); !_g.done; _g = _f.next()) {
        var math = _g.value;
        var node = adaptor.parent(math.start.node);
        if (node && math.state() < MathItem_js_1$2.STATE.METRICS) {
          var map = domMaps[math.display ? 1 : 0];
          if (!map.has(node)) {
            map.set(node, this.getTestElement(node, math.display));
          }
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_g && !_g.done && (_a = _f.return)) _a.call(_f);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    var getFamily = this.options.mtextInheritFont || this.options.merrorInheritFont;
    var maps = [new Map(), new Map()];
    try {
      for (var _h = __values$y(maps.keys()), _j = _h.next(); !_j.done; _j = _h.next()) {
        var i = _j.value;
        try {
          for (var _k = (e_4 = void 0, __values$y(domMaps[i].keys())), _l = _k.next(); !_l.done; _l = _k.next()) {
            var node = _l.value;
            maps[i].set(node, this.measureMetrics(domMaps[i].get(node), getFamily));
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_l && !_l.done && (_c = _k.return)) _c.call(_k);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_j && !_j.done && (_b = _h.return)) _b.call(_h);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    try {
      for (var _m = __values$y(maps.keys()), _o = _m.next(); !_o.done; _o = _m.next()) {
        var i = _o.value;
        try {
          for (var _p = (e_6 = void 0, __values$y(domMaps[i].values())), _q = _p.next(); !_q.done; _q = _p.next()) {
            var node = _q.value;
            adaptor.remove(node);
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (_q && !_q.done && (_e = _p.return)) _e.call(_p);
          } finally {
            if (e_6) throw e_6.error;
          }
        }
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (_o && !_o.done && (_d = _m.return)) _d.call(_m);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
    return maps;
  };
  CommonOutputJax.prototype.getTestElement = function (node, display) {
    var adaptor = this.adaptor;
    if (!this.testInline) {
      this.testInline = this.html('mjx-test', {
        style: {
          display: 'inline-block',
          width: '100%',
          'font-style': 'normal',
          'font-weight': 'normal',
          'font-size': '100%',
          'font-size-adjust': 'none',
          'text-indent': 0,
          'text-transform': 'none',
          'letter-spacing': 'normal',
          'word-spacing': 'normal',
          overflow: 'hidden',
          height: '1px',
          'margin-right': '-1px'
        }
      }, [this.html('mjx-left-box', {
        style: {
          display: 'inline-block',
          width: 0,
          'float': 'left'
        }
      }), this.html('mjx-ex-box', {
        style: {
          position: 'absolute',
          overflow: 'hidden',
          width: '1px',
          height: '60ex'
        }
      }), this.html('mjx-right-box', {
        style: {
          display: 'inline-block',
          width: 0,
          'float': 'right'
        }
      })]);
      this.testDisplay = adaptor.clone(this.testInline);
      adaptor.setStyle(this.testDisplay, 'display', 'table');
      adaptor.setStyle(this.testDisplay, 'margin-right', '');
      adaptor.setStyle(adaptor.firstChild(this.testDisplay), 'display', 'none');
      var right = adaptor.lastChild(this.testDisplay);
      adaptor.setStyle(right, 'display', 'table-cell');
      adaptor.setStyle(right, 'width', '10000em');
      adaptor.setStyle(right, 'float', '');
    }
    return adaptor.append(node, adaptor.clone(display ? this.testDisplay : this.testInline));
  };
  CommonOutputJax.prototype.measureMetrics = function (node, getFamily) {
    var adaptor = this.adaptor;
    var family = getFamily ? adaptor.fontFamily(node) : '';
    var em = adaptor.fontSize(node);
    var _a = __read$A(adaptor.nodeSize(adaptor.childNode(node, 1)), 2), w = _a[0], h = _a[1];
    var ex = w ? h / 60 : em * this.options.exFactor;
    var containerWidth = !w ? 1000000 : adaptor.getStyle(node, 'display') === 'table' ? adaptor.nodeSize(adaptor.lastChild(node))[0] - 1 : adaptor.nodeBBox(adaptor.lastChild(node)).left - adaptor.nodeBBox(adaptor.firstChild(node)).left - 2;
    var scale = Math.max(this.options.minScale, this.options.matchFontHeight ? ex / this.font.params.x_height / em : 1);
    var lineWidth = 1000000;
    return {
      em: em,
      ex: ex,
      containerWidth: containerWidth,
      lineWidth: lineWidth,
      scale: scale,
      family: family
    };
  };
  CommonOutputJax.prototype.styleSheet = function (html) {
    var e_7, _a;
    this.setDocument(html);
    this.cssStyles.clear();
    this.cssStyles.addStyles(this.constructor.commonStyles);
    if (('getStyles' in html)) {
      try {
        for (var _b = __values$y(html.getStyles()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var styles = _c.value;
          this.cssStyles.addStyles(styles);
        }
      } catch (e_7_1) {
        e_7 = {
          error: e_7_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_7) throw e_7.error;
        }
      }
    }
    this.addWrapperStyles(this.cssStyles);
    this.addFontStyles(this.cssStyles);
    var sheet = this.html('style', {
      id: 'MJX-styles'
    }, [this.text('\n' + this.cssStyles.cssText + '\n')]);
    return sheet;
  };
  CommonOutputJax.prototype.addFontStyles = function (styles) {
    styles.addStyles(this.font.styles);
  };
  CommonOutputJax.prototype.addWrapperStyles = function (styles) {
    var e_8, _a;
    try {
      for (var _b = __values$y(this.factory.getKinds()), _c = _b.next(); !_c.done; _c = _b.next()) {
        var kind = _c.value;
        this.addClassStyles(this.factory.getNodeClass(kind), styles);
      }
    } catch (e_8_1) {
      e_8 = {
        error: e_8_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_8) throw e_8.error;
      }
    }
  };
  CommonOutputJax.prototype.addClassStyles = function (CLASS, styles) {
    styles.addStyles(CLASS.styles);
  };
  CommonOutputJax.prototype.setDocument = function (html) {
    if (html) {
      this.document = html;
      this.adaptor.document = html.document;
    }
  };
  CommonOutputJax.prototype.html = function (type, def, content, ns) {
    if (def === void 0) {
      def = {};
    }
    if (content === void 0) {
      content = [];
    }
    return this.adaptor.node(type, def, content, ns);
  };
  CommonOutputJax.prototype.text = function (text) {
    return this.adaptor.text(text);
  };
  CommonOutputJax.prototype.fixed = function (m, n) {
    if (n === void 0) {
      n = 3;
    }
    if (Math.abs(m) < .0006) {
      return '0';
    }
    return m.toFixed(n).replace(/\.?0+$/, '');
  };
  CommonOutputJax.prototype.measureText = function (text, variant, font) {
    if (font === void 0) {
      font = ['', false, false];
    }
    var node = this.unknownText(text, variant);
    if (variant === '-explicitFont') {
      var styles = this.cssFontStyles(font);
      this.adaptor.setAttributes(node, {
        style: styles
      });
    }
    return this.measureTextNodeWithCache(node, text, variant, font);
  };
  CommonOutputJax.prototype.measureTextNodeWithCache = function (text, chars, variant, font) {
    if (font === void 0) {
      font = ['', false, false];
    }
    if (variant === '-explicitFont') {
      variant = [font[0], font[1] ? 'T' : 'F', font[2] ? 'T' : 'F', ''].join('-');
    }
    if (!this.unknownCache.has(variant)) {
      this.unknownCache.set(variant, new Map());
    }
    var map = this.unknownCache.get(variant);
    var cached = map.get(chars);
    if (cached) return cached;
    var bbox = this.measureTextNode(text);
    map.set(chars, bbox);
    return bbox;
  };
  CommonOutputJax.prototype.measureXMLnode = function (xml) {
    var adaptor = this.adaptor;
    var content = this.html('mjx-xml-block', {
      style: {
        display: 'inline-block'
      }
    }, [adaptor.clone(xml)]);
    var base = this.html('mjx-baseline', {
      style: {
        display: 'inline-block',
        width: 0,
        height: 0
      }
    });
    var style = {
      position: 'absolute',
      display: 'inline-block',
      'font-family': 'initial',
      'line-height': 'normal'
    };
    var node = this.html('mjx-measure-xml', {
      style: style
    }, [base, content]);
    adaptor.append(adaptor.parent(this.math.start.node), this.container);
    adaptor.append(this.container, node);
    var em = this.math.metrics.em * this.math.metrics.scale;
    var _a = adaptor.nodeBBox(content), left = _a.left, right = _a.right, bottom = _a.bottom, top = _a.top;
    var w = (right - left) / em;
    var h = (adaptor.nodeBBox(base).top - top) / em;
    var d = (bottom - top) / em - h;
    adaptor.remove(this.container);
    adaptor.remove(node);
    return {
      w: w,
      h: h,
      d: d
    };
  };
  CommonOutputJax.prototype.cssFontStyles = function (font, styles) {
    if (styles === void 0) {
      styles = {};
    }
    var _a = __read$A(font, 3), family = _a[0], italic = _a[1], bold = _a[2];
    styles['font-family'] = this.font.getFamily(family);
    if (italic) styles['font-style'] = 'italic';
    if (bold) styles['font-weight'] = 'bold';
    return styles;
  };
  CommonOutputJax.prototype.getFontData = function (styles) {
    if (!styles) {
      styles = new Styles_js_1$1.Styles();
    }
    return [this.font.getFamily(styles.get('font-family')), styles.get('font-style') === 'italic', styles.get('font-weight') === 'bold'];
  };
  CommonOutputJax.NAME = 'Common';
  CommonOutputJax.OPTIONS = __assign$B(__assign$B({}, OutputJax_js_1$1.AbstractOutputJax.OPTIONS), {
    scale: 1,
    minScale: .5,
    mtextInheritFont: false,
    merrorInheritFont: false,
    mtextFont: '',
    merrorFont: 'serif',
    mathmlSpacing: false,
    skipAttributes: {},
    exFactor: .5,
    displayAlign: 'center',
    displayIndent: '0',
    wrapperFactory: null,
    font: null,
    cssStyles: null
  });
  CommonOutputJax.commonStyles = {};
  return CommonOutputJax;
})(OutputJax_js_1$1.AbstractOutputJax);
OutputJax$1.CommonOutputJax = CommonOutputJax;

var WrapperFactory$2 = {};

var WrapperFactory$1 = {};

var WrapperFactory = {};

var __extends$1I = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$z = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$i = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(WrapperFactory, "__esModule", {
  value: true
});
WrapperFactory.AbstractWrapperFactory = void 0;
var Factory_js_1$1 = Factory;
var AbstractWrapperFactory = (function (_super) {
  __extends$1I(AbstractWrapperFactory, _super);
  function AbstractWrapperFactory() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  AbstractWrapperFactory.prototype.wrap = function (node) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    return this.create.apply(this, __spreadArray$i([node.kind, node], __read$z(args), false));
  };
  return AbstractWrapperFactory;
})(Factory_js_1$1.AbstractFactory);
WrapperFactory.AbstractWrapperFactory = AbstractWrapperFactory;

var __extends$1H = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(WrapperFactory$1, "__esModule", {
  value: true
});
WrapperFactory$1.CommonWrapperFactory = void 0;
var WrapperFactory_js_1$2 = WrapperFactory;
var CommonWrapperFactory = (function (_super) {
  __extends$1H(CommonWrapperFactory, _super);
  function CommonWrapperFactory() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.jax = null;
    return _this;
  }
  Object.defineProperty(CommonWrapperFactory.prototype, "Wrappers", {
    get: function () {
      return this.node;
    },
    enumerable: false,
    configurable: true
  });
  CommonWrapperFactory.defaultNodes = {};
  return CommonWrapperFactory;
})(WrapperFactory_js_1$2.AbstractWrapperFactory);
WrapperFactory$1.CommonWrapperFactory = CommonWrapperFactory;

var Wrappers = {};

var Wrapper$3 = {};

var Wrapper$2 = {};

var Wrapper$1 = {};

Object.defineProperty(Wrapper$1, "__esModule", {
  value: true
});
Wrapper$1.AbstractWrapper = void 0;
var AbstractWrapper = (function () {
  function AbstractWrapper(factory, node) {
    this.factory = factory;
    this.node = node;
  }
  Object.defineProperty(AbstractWrapper.prototype, "kind", {
    get: function () {
      return this.node.kind;
    },
    enumerable: false,
    configurable: true
  });
  AbstractWrapper.prototype.wrap = function (node) {
    return this.factory.wrap(node);
  };
  return AbstractWrapper;
})();
Wrapper$1.AbstractWrapper = AbstractWrapper;

var BBox$1 = {};

Object.defineProperty(BBox$1, "__esModule", {
  value: true
});
BBox$1.BBox = void 0;
var lengths_js_1$3 = lengths;
var BBox = (function () {
  function BBox(def) {
    if (def === void 0) {
      def = {
        w: 0,
        h: -lengths_js_1$3.BIGDIMEN,
        d: -lengths_js_1$3.BIGDIMEN
      };
    }
    this.w = def.w || 0;
    this.h = ('h' in def) ? def.h : -lengths_js_1$3.BIGDIMEN;
    this.d = ('d' in def) ? def.d : -lengths_js_1$3.BIGDIMEN;
    this.L = this.R = this.ic = this.sk = this.dx = 0;
    this.scale = this.rscale = 1;
    this.pwidth = '';
  }
  BBox.zero = function () {
    return new BBox({
      h: 0,
      d: 0,
      w: 0
    });
  };
  BBox.empty = function () {
    return new BBox();
  };
  BBox.prototype.empty = function () {
    this.w = 0;
    this.h = this.d = -lengths_js_1$3.BIGDIMEN;
    return this;
  };
  BBox.prototype.clean = function () {
    if (this.w === -lengths_js_1$3.BIGDIMEN) this.w = 0;
    if (this.h === -lengths_js_1$3.BIGDIMEN) this.h = 0;
    if (this.d === -lengths_js_1$3.BIGDIMEN) this.d = 0;
  };
  BBox.prototype.rescale = function (scale) {
    this.w *= scale;
    this.h *= scale;
    this.d *= scale;
  };
  BBox.prototype.combine = function (cbox, x, y) {
    if (x === void 0) {
      x = 0;
    }
    if (y === void 0) {
      y = 0;
    }
    var rscale = cbox.rscale;
    var w = x + rscale * (cbox.w + cbox.L + cbox.R);
    var h = y + rscale * cbox.h;
    var d = rscale * cbox.d - y;
    if (w > this.w) this.w = w;
    if (h > this.h) this.h = h;
    if (d > this.d) this.d = d;
  };
  BBox.prototype.append = function (cbox) {
    var scale = cbox.rscale;
    this.w += scale * (cbox.w + cbox.L + cbox.R);
    if (scale * cbox.h > this.h) {
      this.h = scale * cbox.h;
    }
    if (scale * cbox.d > this.d) {
      this.d = scale * cbox.d;
    }
  };
  BBox.prototype.updateFrom = function (cbox) {
    this.h = cbox.h;
    this.d = cbox.d;
    this.w = cbox.w;
    if (cbox.pwidth) {
      this.pwidth = cbox.pwidth;
    }
  };
  BBox.fullWidth = '100%';
  BBox.StyleAdjust = [['borderTopWidth', 'h'], ['borderRightWidth', 'w'], ['borderBottomWidth', 'd'], ['borderLeftWidth', 'w', 0], ['paddingTop', 'h'], ['paddingRight', 'w'], ['paddingBottom', 'd'], ['paddingLeft', 'w', 0]];
  return BBox;
})();
BBox$1.BBox = BBox;

var FontData$2 = {};

var __assign$A = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$A = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$A.apply(this, arguments);
});
var __read$y = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$h = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$x = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(FontData$2, "__esModule", {
  value: true
});
FontData$2.FontData = FontData$2.NOSTRETCH = FontData$2.H = FontData$2.V = void 0;
var Options_js_1$4 = Options;
FontData$2.V = 1;
FontData$2.H = 2;
FontData$2.NOSTRETCH = {
  dir: 0
};
var FontData$1 = (function () {
  function FontData(options) {
    var e_1, _a, e_2, _b;
    if (options === void 0) {
      options = null;
    }
    this.variant = {};
    this.delimiters = {};
    this.cssFontMap = {};
    this.remapChars = {};
    this.skewIcFactor = .75;
    var CLASS = this.constructor;
    this.options = (0, Options_js_1$4.userOptions)((0, Options_js_1$4.defaultOptions)({}, CLASS.OPTIONS), options);
    this.params = __assign$A({}, CLASS.defaultParams);
    this.sizeVariants = __spreadArray$h([], __read$y(CLASS.defaultSizeVariants), false);
    this.stretchVariants = __spreadArray$h([], __read$y(CLASS.defaultStretchVariants), false);
    this.cssFontMap = __assign$A({}, CLASS.defaultCssFonts);
    try {
      for (var _c = __values$x(Object.keys(this.cssFontMap)), _d = _c.next(); !_d.done; _d = _c.next()) {
        var name_1 = _d.value;
        if (this.cssFontMap[name_1][0] === 'unknown') {
          this.cssFontMap[name_1][0] = this.options.unknownFamily;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    this.cssFamilyPrefix = CLASS.defaultCssFamilyPrefix;
    this.createVariants(CLASS.defaultVariants);
    this.defineDelimiters(CLASS.defaultDelimiters);
    try {
      for (var _e = __values$x(Object.keys(CLASS.defaultChars)), _f = _e.next(); !_f.done; _f = _e.next()) {
        var name_2 = _f.value;
        this.defineChars(name_2, CLASS.defaultChars[name_2]);
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    this.defineRemap('accent', CLASS.defaultAccentMap);
    this.defineRemap('mo', CLASS.defaultMoMap);
    this.defineRemap('mn', CLASS.defaultMnMap);
  }
  FontData.charOptions = function (font, n) {
    var char = font[n];
    if (char.length === 3) {
      char[3] = {};
    }
    return char[3];
  };
  Object.defineProperty(FontData.prototype, "styles", {
    get: function () {
      return this._styles;
    },
    set: function (style) {
      this._styles = style;
    },
    enumerable: false,
    configurable: true
  });
  FontData.prototype.createVariant = function (name, inherit, link) {
    if (inherit === void 0) {
      inherit = null;
    }
    if (link === void 0) {
      link = null;
    }
    var variant = {
      linked: [],
      chars: inherit ? Object.create(this.variant[inherit].chars) : {}
    };
    if (link && this.variant[link]) {
      Object.assign(variant.chars, this.variant[link].chars);
      this.variant[link].linked.push(variant.chars);
      variant.chars = Object.create(variant.chars);
    }
    this.remapSmpChars(variant.chars, name);
    this.variant[name] = variant;
  };
  FontData.prototype.remapSmpChars = function (chars, name) {
    var e_3, _a, e_4, _b;
    var CLASS = this.constructor;
    if (CLASS.VariantSmp[name]) {
      var SmpRemap = CLASS.SmpRemap;
      var SmpGreek = [null, null, CLASS.SmpRemapGreekU, CLASS.SmpRemapGreekL];
      try {
        for (var _c = __values$x(CLASS.SmpRanges), _d = _c.next(); !_d.done; _d = _c.next()) {
          var _e = __read$y(_d.value, 3), i = _e[0], lo = _e[1], hi = _e[2];
          var base = CLASS.VariantSmp[name][i];
          if (!base) continue;
          for (var n = lo; n <= hi; n++) {
            if (n === 0x3A2) continue;
            var smp = base + n - lo;
            chars[n] = this.smpChar(SmpRemap[smp] || smp);
          }
          if (SmpGreek[i]) {
            try {
              for (var _f = (e_4 = void 0, __values$x(Object.keys(SmpGreek[i]).map(function (x) {
                return parseInt(x);
              }))), _g = _f.next(); !_g.done; _g = _f.next()) {
                var n = _g.value;
                chars[n] = this.smpChar(base + SmpGreek[i][n]);
              }
            } catch (e_4_1) {
              e_4 = {
                error: e_4_1
              };
            } finally {
              try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
              } finally {
                if (e_4) throw e_4.error;
              }
            }
          }
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
    }
    if (name === 'bold') {
      chars[0x3DC] = this.smpChar(0x1D7CA);
      chars[0x3DD] = this.smpChar(0x1D7CB);
    }
  };
  FontData.prototype.smpChar = function (n) {
    return [, , , {
      smp: n
    }];
  };
  FontData.prototype.createVariants = function (variants) {
    var e_5, _a;
    try {
      for (var variants_1 = __values$x(variants), variants_1_1 = variants_1.next(); !variants_1_1.done; variants_1_1 = variants_1.next()) {
        var variant = variants_1_1.value;
        this.createVariant(variant[0], variant[1], variant[2]);
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (variants_1_1 && !variants_1_1.done && (_a = variants_1.return)) _a.call(variants_1);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
  };
  FontData.prototype.defineChars = function (name, chars) {
    var e_6, _a;
    var variant = this.variant[name];
    Object.assign(variant.chars, chars);
    try {
      for (var _b = __values$x(variant.linked), _c = _b.next(); !_c.done; _c = _b.next()) {
        var link = _c.value;
        Object.assign(link, chars);
      }
    } catch (e_6_1) {
      e_6 = {
        error: e_6_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_6) throw e_6.error;
      }
    }
  };
  FontData.prototype.defineDelimiters = function (delims) {
    Object.assign(this.delimiters, delims);
  };
  FontData.prototype.defineRemap = function (name, remap) {
    if (!this.remapChars.hasOwnProperty(name)) {
      this.remapChars[name] = {};
    }
    Object.assign(this.remapChars[name], remap);
  };
  FontData.prototype.getDelimiter = function (n) {
    return this.delimiters[n];
  };
  FontData.prototype.getSizeVariant = function (n, i) {
    if (this.delimiters[n].variants) {
      i = this.delimiters[n].variants[i];
    }
    return this.sizeVariants[i];
  };
  FontData.prototype.getStretchVariant = function (n, i) {
    return this.stretchVariants[this.delimiters[n].stretchv ? this.delimiters[n].stretchv[i] : 0];
  };
  FontData.prototype.getChar = function (name, n) {
    return this.variant[name].chars[n];
  };
  FontData.prototype.getVariant = function (name) {
    return this.variant[name];
  };
  FontData.prototype.getCssFont = function (variant) {
    return this.cssFontMap[variant] || ['serif', false, false];
  };
  FontData.prototype.getFamily = function (family) {
    return this.cssFamilyPrefix ? this.cssFamilyPrefix + ', ' + family : family;
  };
  FontData.prototype.getRemappedChar = function (name, c) {
    var map = this.remapChars[name] || ({});
    return map[c];
  };
  FontData.OPTIONS = {
    unknownFamily: 'serif'
  };
  FontData.JAX = 'common';
  FontData.NAME = '';
  FontData.defaultVariants = [['normal'], ['bold', 'normal'], ['italic', 'normal'], ['bold-italic', 'italic', 'bold'], ['double-struck', 'bold'], ['fraktur', 'normal'], ['bold-fraktur', 'bold', 'fraktur'], ['script', 'italic'], ['bold-script', 'bold-italic', 'script'], ['sans-serif', 'normal'], ['bold-sans-serif', 'bold', 'sans-serif'], ['sans-serif-italic', 'italic', 'sans-serif'], ['sans-serif-bold-italic', 'bold-italic', 'bold-sans-serif'], ['monospace', 'normal']];
  FontData.defaultCssFonts = {
    normal: ['unknown', false, false],
    bold: ['unknown', false, true],
    italic: ['unknown', true, false],
    'bold-italic': ['unknown', true, true],
    'double-struck': ['unknown', false, true],
    fraktur: ['unknown', false, false],
    'bold-fraktur': ['unknown', false, true],
    script: ['cursive', false, false],
    'bold-script': ['cursive', false, true],
    'sans-serif': ['sans-serif', false, false],
    'bold-sans-serif': ['sans-serif', false, true],
    'sans-serif-italic': ['sans-serif', true, false],
    'sans-serif-bold-italic': ['sans-serif', true, true],
    monospace: ['monospace', false, false]
  };
  FontData.defaultCssFamilyPrefix = '';
  FontData.VariantSmp = {
    bold: [0x1D400, 0x1D41A, 0x1D6A8, 0x1D6C2, 0x1D7CE],
    italic: [0x1D434, 0x1D44E, 0x1D6E2, 0x1D6FC],
    'bold-italic': [0x1D468, 0x1D482, 0x1D71C, 0x1D736],
    script: [0x1D49C, 0x1D4B6],
    'bold-script': [0x1D4D0, 0x1D4EA],
    fraktur: [0x1D504, 0x1D51E],
    'double-struck': [0x1D538, 0x1D552, , , 0x1D7D8],
    'bold-fraktur': [0x1D56C, 0x1D586],
    'sans-serif': [0x1D5A0, 0x1D5BA, , , 0x1D7E2],
    'bold-sans-serif': [0x1D5D4, 0x1D5EE, 0x1D756, 0x1D770, 0x1D7EC],
    'sans-serif-italic': [0x1D608, 0x1D622],
    'sans-serif-bold-italic': [0x1D63C, 0x1D656, 0x1D790, 0x1D7AA],
    'monospace': [0x1D670, 0x1D68A, , , 0x1D7F6]
  };
  FontData.SmpRanges = [[0, 0x41, 0x5A], [1, 0x61, 0x7A], [2, 0x391, 0x3A9], [3, 0x3B1, 0x3C9], [4, 0x30, 0x39]];
  FontData.SmpRemap = {
    0x1D455: 0x210E,
    0x1D49D: 0x212C,
    0x1D4A0: 0x2130,
    0x1D4A1: 0x2131,
    0x1D4A3: 0x210B,
    0x1D4A4: 0x2110,
    0x1D4A7: 0x2112,
    0x1D4A8: 0x2133,
    0x1D4AD: 0x211B,
    0x1D4BA: 0x212F,
    0x1D4BC: 0x210A,
    0x1D4C4: 0x2134,
    0x1D506: 0x212D,
    0x1D50B: 0x210C,
    0x1D50C: 0x2111,
    0x1D515: 0x211C,
    0x1D51D: 0x2128,
    0x1D53A: 0x2102,
    0x1D53F: 0x210D,
    0x1D545: 0x2115,
    0x1D547: 0x2119,
    0x1D548: 0x211A,
    0x1D549: 0x211D,
    0x1D551: 0x2124
  };
  FontData.SmpRemapGreekU = {
    0x2207: 0x19,
    0x03F4: 0x11
  };
  FontData.SmpRemapGreekL = {
    0x3D1: 0x1B,
    0x3D5: 0x1D,
    0x3D6: 0x1F,
    0x3F0: 0x1C,
    0x3F1: 0x1E,
    0x3F5: 0x1A,
    0x2202: 0x19
  };
  FontData.defaultAccentMap = {
    0x0300: '\u02CB',
    0x0301: '\u02CA',
    0x0302: '\u02C6',
    0x0303: '\u02DC',
    0x0304: '\u02C9',
    0x0306: '\u02D8',
    0x0307: '\u02D9',
    0x0308: '\u00A8',
    0x030A: '\u02DA',
    0x030C: '\u02C7',
    0x2192: '\u20D7',
    0x2032: '\'',
    0x2033: '\'\'',
    0x2034: '\'\'\'',
    0x2035: '`',
    0x2036: '``',
    0x2037: '```',
    0x2057: '\'\'\'\'',
    0x20D0: '\u21BC',
    0x20D1: '\u21C0',
    0x20D6: '\u2190',
    0x20E1: '\u2194',
    0x20F0: '*',
    0x20DB: '...',
    0x20DC: '....',
    0x20EC: '\u21C1',
    0x20ED: '\u21BD',
    0x20EE: '\u2190',
    0x20EF: '\u2192'
  };
  FontData.defaultMoMap = {
    0x002D: '\u2212'
  };
  FontData.defaultMnMap = {
    0x002D: '\u2212'
  };
  FontData.defaultParams = {
    x_height: .442,
    quad: 1,
    num1: .676,
    num2: .394,
    num3: .444,
    denom1: .686,
    denom2: .345,
    sup1: .413,
    sup2: .363,
    sup3: .289,
    sub1: .15,
    sub2: .247,
    sup_drop: .386,
    sub_drop: .05,
    delim1: 2.39,
    delim2: 1.0,
    axis_height: .25,
    rule_thickness: .06,
    big_op_spacing1: .111,
    big_op_spacing2: .167,
    big_op_spacing3: .2,
    big_op_spacing4: .6,
    big_op_spacing5: .1,
    surd_height: .075,
    scriptspace: .05,
    nulldelimiterspace: .12,
    delimiterfactor: 901,
    delimitershortfall: .3,
    min_rule_thickness: 1.25,
    separation_factor: 1.75,
    extra_ic: .033
  };
  FontData.defaultDelimiters = {};
  FontData.defaultChars = {};
  FontData.defaultSizeVariants = [];
  FontData.defaultStretchVariants = [];
  return FontData;
})();
FontData$2.FontData = FontData$1;

var __extends$1G = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __createBinding$a = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$a = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$a = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$a(result, mod, k);
  __setModuleDefault$a(result, mod);
  return result;
});
var __values$w = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$x = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$g = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(Wrapper$2, "__esModule", {
  value: true
});
Wrapper$2.CommonWrapper = void 0;
var Wrapper_js_1$n = Wrapper$1;
var MmlNode_js_1$G = MmlNode;
var string_js_1$8 = string;
var LENGTHS$1 = __importStar$a(lengths);
var Styles_js_1 = Styles$1;
var BBox_js_1$5 = BBox$1;
var FontData_js_1$j = FontData$2;
var SMALLSIZE = 2 / 18;
function MathMLSpace(script, size) {
  return script ? size < SMALLSIZE ? 0 : SMALLSIZE : size;
}
var CommonWrapper = (function (_super) {
  __extends$1G(CommonWrapper, _super);
  function CommonWrapper(factory, node, parent) {
    if (parent === void 0) {
      parent = null;
    }
    var _this = _super.call(this, factory, node) || this;
    _this.parent = null;
    _this.removedStyles = null;
    _this.styles = null;
    _this.variant = '';
    _this.bboxComputed = false;
    _this.stretch = FontData_js_1$j.NOSTRETCH;
    _this.font = null;
    _this.parent = parent;
    _this.font = factory.jax.font;
    _this.bbox = BBox_js_1$5.BBox.zero();
    _this.getStyles();
    _this.getVariant();
    _this.getScale();
    _this.getSpace();
    _this.childNodes = node.childNodes.map(function (child) {
      var wrapped = _this.wrap(child);
      if (wrapped.bbox.pwidth && (node.notParent || node.isKind('math'))) {
        _this.bbox.pwidth = BBox_js_1$5.BBox.fullWidth;
      }
      return wrapped;
    });
    return _this;
  }
  Object.defineProperty(CommonWrapper.prototype, "jax", {
    get: function () {
      return this.factory.jax;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(CommonWrapper.prototype, "adaptor", {
    get: function () {
      return this.factory.jax.adaptor;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(CommonWrapper.prototype, "metrics", {
    get: function () {
      return this.factory.jax.math.metrics;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(CommonWrapper.prototype, "fixesPWidth", {
    get: function () {
      return !this.node.notParent && !this.node.isToken;
    },
    enumerable: false,
    configurable: true
  });
  CommonWrapper.prototype.wrap = function (node, parent) {
    if (parent === void 0) {
      parent = null;
    }
    var wrapped = this.factory.wrap(node, parent || this);
    if (parent) {
      parent.childNodes.push(wrapped);
    }
    this.jax.nodeMap.set(node, wrapped);
    return wrapped;
  };
  CommonWrapper.prototype.getBBox = function (save) {
    if (save === void 0) {
      save = true;
    }
    if (this.bboxComputed) {
      return this.bbox;
    }
    var bbox = save ? this.bbox : BBox_js_1$5.BBox.zero();
    this.computeBBox(bbox);
    this.bboxComputed = save;
    return bbox;
  };
  CommonWrapper.prototype.getOuterBBox = function (save) {
    var e_1, _a;
    if (save === void 0) {
      save = true;
    }
    var bbox = this.getBBox(save);
    if (!this.styles) return bbox;
    var obox = new BBox_js_1$5.BBox();
    Object.assign(obox, bbox);
    try {
      for (var _b = __values$w(BBox_js_1$5.BBox.StyleAdjust), _c = _b.next(); !_c.done; _c = _b.next()) {
        var _d = __read$x(_c.value, 2), name_1 = _d[0], side = _d[1];
        var x = this.styles.get(name_1);
        if (x) {
          obox[side] += this.length2em(x, 1, obox.rscale);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return obox;
  };
  CommonWrapper.prototype.computeBBox = function (bbox, recompute) {
    var e_2, _a;
    if (recompute === void 0) {
      recompute = false;
    }
    bbox.empty();
    try {
      for (var _b = __values$w(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        bbox.append(child.getOuterBBox());
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    bbox.clean();
    if (this.fixesPWidth && this.setChildPWidths(recompute)) {
      this.computeBBox(bbox, true);
    }
  };
  CommonWrapper.prototype.setChildPWidths = function (recompute, w, clear) {
    var e_3, _a;
    if (w === void 0) {
      w = null;
    }
    if (clear === void 0) {
      clear = true;
    }
    if (recompute) {
      return false;
    }
    if (clear) {
      this.bbox.pwidth = '';
    }
    var changed = false;
    try {
      for (var _b = __values$w(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        var cbox = child.getOuterBBox();
        if (cbox.pwidth && child.setChildPWidths(recompute, w === null ? cbox.w : w, clear)) {
          changed = true;
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    return changed;
  };
  CommonWrapper.prototype.invalidateBBox = function () {
    if (this.bboxComputed) {
      this.bboxComputed = false;
      if (this.parent) {
        this.parent.invalidateBBox();
      }
    }
  };
  CommonWrapper.prototype.copySkewIC = function (bbox) {
    var first = this.childNodes[0];
    if (first === null || first === void 0 ? void 0 : first.bbox.sk) {
      bbox.sk = first.bbox.sk;
    }
    if (first === null || first === void 0 ? void 0 : first.bbox.dx) {
      bbox.dx = first.bbox.dx;
    }
    var last = this.childNodes[this.childNodes.length - 1];
    if (last === null || last === void 0 ? void 0 : last.bbox.ic) {
      bbox.ic = last.bbox.ic;
      bbox.w += bbox.ic;
    }
  };
  CommonWrapper.prototype.getStyles = function () {
    var styleString = this.node.attributes.getExplicit('style');
    if (!styleString) return;
    var style = this.styles = new Styles_js_1.Styles(styleString);
    for (var i = 0, m = CommonWrapper.removeStyles.length; i < m; i++) {
      var id = CommonWrapper.removeStyles[i];
      if (style.get(id)) {
        if (!this.removedStyles) this.removedStyles = {};
        this.removedStyles[id] = style.get(id);
        style.set(id, '');
      }
    }
  };
  CommonWrapper.prototype.getVariant = function () {
    if (!this.node.isToken) return;
    var attributes = this.node.attributes;
    var variant = attributes.get('mathvariant');
    if (!attributes.getExplicit('mathvariant')) {
      var values = attributes.getList('fontfamily', 'fontweight', 'fontstyle');
      if (this.removedStyles) {
        var style = this.removedStyles;
        if (style.fontFamily) values.family = style.fontFamily;
        if (style.fontWeight) values.weight = style.fontWeight;
        if (style.fontStyle) values.style = style.fontStyle;
      }
      if (values.fontfamily) values.family = values.fontfamily;
      if (values.fontweight) values.weight = values.fontweight;
      if (values.fontstyle) values.style = values.fontstyle;
      if (values.weight && values.weight.match(/^\d+$/)) {
        values.weight = parseInt(values.weight) > 600 ? 'bold' : 'normal';
      }
      if (values.family) {
        variant = this.explicitVariant(values.family, values.weight, values.style);
      } else {
        if (this.node.getProperty('variantForm')) variant = '-tex-variant';
        variant = (CommonWrapper.BOLDVARIANTS[values.weight] || ({}))[variant] || variant;
        variant = (CommonWrapper.ITALICVARIANTS[values.style] || ({}))[variant] || variant;
      }
    }
    this.variant = variant;
  };
  CommonWrapper.prototype.explicitVariant = function (fontFamily, fontWeight, fontStyle) {
    var style = this.styles;
    if (!style) style = this.styles = new Styles_js_1.Styles();
    style.set('fontFamily', fontFamily);
    if (fontWeight) style.set('fontWeight', fontWeight);
    if (fontStyle) style.set('fontStyle', fontStyle);
    return '-explicitFont';
  };
  CommonWrapper.prototype.getScale = function () {
    var scale = 1, parent = this.parent;
    var pscale = parent ? parent.bbox.scale : 1;
    var attributes = this.node.attributes;
    var scriptlevel = Math.min(attributes.get('scriptlevel'), 2);
    var fontsize = attributes.get('fontsize');
    var mathsize = this.node.isToken || this.node.isKind('mstyle') ? attributes.get('mathsize') : attributes.getInherited('mathsize');
    if (scriptlevel !== 0) {
      scale = Math.pow(attributes.get('scriptsizemultiplier'), scriptlevel);
      var scriptminsize = this.length2em(attributes.get('scriptminsize'), .8, 1);
      if (scale < scriptminsize) scale = scriptminsize;
    }
    if (this.removedStyles && this.removedStyles.fontSize && !fontsize) {
      fontsize = this.removedStyles.fontSize;
    }
    if (fontsize && !attributes.getExplicit('mathsize')) {
      mathsize = fontsize;
    }
    if (mathsize !== '1') {
      scale *= this.length2em(mathsize, 1, 1);
    }
    this.bbox.scale = scale;
    this.bbox.rscale = scale / pscale;
  };
  CommonWrapper.prototype.getSpace = function () {
    var isTop = this.isTopEmbellished();
    var hasSpacing = this.node.hasSpacingAttributes();
    if (this.jax.options.mathmlSpacing || hasSpacing) {
      isTop && this.getMathMLSpacing();
    } else {
      this.getTeXSpacing(isTop, hasSpacing);
    }
  };
  CommonWrapper.prototype.getMathMLSpacing = function () {
    var node = this.node.coreMO();
    var child = node.coreParent();
    var parent = child.parent;
    if (!parent || !parent.isKind('mrow') || parent.childNodes.length === 1) return;
    var attributes = node.attributes;
    var isScript = attributes.get('scriptlevel') > 0;
    this.bbox.L = attributes.isSet('lspace') ? Math.max(0, this.length2em(attributes.get('lspace'))) : MathMLSpace(isScript, node.lspace);
    this.bbox.R = attributes.isSet('rspace') ? Math.max(0, this.length2em(attributes.get('rspace'))) : MathMLSpace(isScript, node.rspace);
    var n = parent.childIndex(child);
    if (n === 0) return;
    var prev = parent.childNodes[n - 1];
    if (!prev.isEmbellished) return;
    var bbox = this.jax.nodeMap.get(prev).getBBox();
    if (bbox.R) {
      this.bbox.L = Math.max(0, this.bbox.L - bbox.R);
    }
  };
  CommonWrapper.prototype.getTeXSpacing = function (isTop, hasSpacing) {
    if (!hasSpacing) {
      var space = this.node.texSpacing();
      if (space) {
        this.bbox.L = this.length2em(space);
      }
    }
    if (isTop || hasSpacing) {
      var attributes = this.node.coreMO().attributes;
      if (attributes.isSet('lspace')) {
        this.bbox.L = Math.max(0, this.length2em(attributes.get('lspace')));
      }
      if (attributes.isSet('rspace')) {
        this.bbox.R = Math.max(0, this.length2em(attributes.get('rspace')));
      }
    }
  };
  CommonWrapper.prototype.isTopEmbellished = function () {
    return this.node.isEmbellished && !(this.node.parent && this.node.parent.isEmbellished);
  };
  CommonWrapper.prototype.core = function () {
    return this.jax.nodeMap.get(this.node.core());
  };
  CommonWrapper.prototype.coreMO = function () {
    return this.jax.nodeMap.get(this.node.coreMO());
  };
  CommonWrapper.prototype.getText = function () {
    var e_4, _a;
    var text = '';
    if (this.node.isToken) {
      try {
        for (var _b = __values$w(this.node.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child instanceof MmlNode_js_1$G.TextNode) {
            text += child.getText();
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
    }
    return text;
  };
  CommonWrapper.prototype.canStretch = function (direction) {
    this.stretch = FontData_js_1$j.NOSTRETCH;
    if (this.node.isEmbellished) {
      var core = this.core();
      if (core && core.node !== this.node) {
        if (core.canStretch(direction)) {
          this.stretch = core.stretch;
        }
      }
    }
    return this.stretch.dir !== 0;
  };
  CommonWrapper.prototype.getAlignShift = function () {
    var _a;
    var _b = (_a = this.node.attributes).getList.apply(_a, __spreadArray$g([], __read$x(MmlNode_js_1$G.indentAttributes), false)), indentalign = _b.indentalign, indentshift = _b.indentshift, indentalignfirst = _b.indentalignfirst, indentshiftfirst = _b.indentshiftfirst;
    if (indentalignfirst !== 'indentalign') {
      indentalign = indentalignfirst;
    }
    if (indentalign === 'auto') {
      indentalign = this.jax.options.displayAlign;
    }
    if (indentshiftfirst !== 'indentshift') {
      indentshift = indentshiftfirst;
    }
    if (indentshift === 'auto') {
      indentshift = this.jax.options.displayIndent;
      if (indentalign === 'right' && !indentshift.match(/^\s*0[a-z]*\s*$/)) {
        indentshift = ('-' + indentshift.trim()).replace(/^--/, '');
      }
    }
    var shift = this.length2em(indentshift, this.metrics.containerWidth);
    return [indentalign, shift];
  };
  CommonWrapper.prototype.getAlignX = function (W, bbox, align) {
    return align === 'right' ? W - (bbox.w + bbox.R) * bbox.rscale : align === 'left' ? bbox.L * bbox.rscale : (W - bbox.w * bbox.rscale) / 2;
  };
  CommonWrapper.prototype.getAlignY = function (H, D, h, d, align) {
    return align === 'top' ? H - h : align === 'bottom' ? d - D : align === 'center' ? (H - h - (D - d)) / 2 : 0;
  };
  CommonWrapper.prototype.getWrapWidth = function (i) {
    return this.childNodes[i].getBBox().w;
  };
  CommonWrapper.prototype.getChildAlign = function (_i) {
    return 'left';
  };
  CommonWrapper.prototype.percent = function (m) {
    return LENGTHS$1.percent(m);
  };
  CommonWrapper.prototype.em = function (m) {
    return LENGTHS$1.em(m);
  };
  CommonWrapper.prototype.px = function (m, M) {
    if (M === void 0) {
      M = -LENGTHS$1.BIGDIMEN;
    }
    return LENGTHS$1.px(m, M, this.metrics.em);
  };
  CommonWrapper.prototype.length2em = function (length, size, scale) {
    if (size === void 0) {
      size = 1;
    }
    if (scale === void 0) {
      scale = null;
    }
    if (scale === null) {
      scale = this.bbox.scale;
    }
    return LENGTHS$1.length2em(length, size, scale, this.jax.pxPerEm);
  };
  CommonWrapper.prototype.unicodeChars = function (text, name) {
    if (name === void 0) {
      name = this.variant;
    }
    var chars = (0, string_js_1$8.unicodeChars)(text);
    var variant = this.font.getVariant(name);
    if (variant && variant.chars) {
      var map_1 = variant.chars;
      chars = chars.map(function (n) {
        return ((map_1[n] || [])[3] || ({})).smp || n;
      });
    }
    return chars;
  };
  CommonWrapper.prototype.remapChars = function (chars) {
    return chars;
  };
  CommonWrapper.prototype.mmlText = function (text) {
    return this.node.factory.create('text').setText(text);
  };
  CommonWrapper.prototype.mmlNode = function (kind, properties, children) {
    if (properties === void 0) {
      properties = {};
    }
    if (children === void 0) {
      children = [];
    }
    return this.node.factory.create(kind, properties, children);
  };
  CommonWrapper.prototype.createMo = function (text) {
    var mmlFactory = this.node.factory;
    var textNode = mmlFactory.create('text').setText(text);
    var mml = mmlFactory.create('mo', {
      stretchy: true
    }, [textNode]);
    mml.inheritAttributesFrom(this.node);
    var node = this.wrap(mml);
    node.parent = this;
    return node;
  };
  CommonWrapper.prototype.getVariantChar = function (variant, n) {
    var char = this.font.getChar(variant, n) || [0, 0, 0, {
      unknown: true
    }];
    if (char.length === 3) {
      char[3] = {};
    }
    return char;
  };
  CommonWrapper.kind = 'unknown';
  CommonWrapper.styles = {};
  CommonWrapper.removeStyles = ['fontSize', 'fontFamily', 'fontWeight', 'fontStyle', 'fontVariant', 'font'];
  CommonWrapper.skipAttributes = {
    fontfamily: true,
    fontsize: true,
    fontweight: true,
    fontstyle: true,
    color: true,
    background: true,
    'class': true,
    href: true,
    style: true,
    xmlns: true
  };
  CommonWrapper.BOLDVARIANTS = {
    bold: {
      normal: 'bold',
      italic: 'bold-italic',
      fraktur: 'bold-fraktur',
      script: 'bold-script',
      'sans-serif': 'bold-sans-serif',
      'sans-serif-italic': 'sans-serif-bold-italic'
    },
    normal: {
      bold: 'normal',
      'bold-italic': 'italic',
      'bold-fraktur': 'fraktur',
      'bold-script': 'script',
      'bold-sans-serif': 'sans-serif',
      'sans-serif-bold-italic': 'sans-serif-italic'
    }
  };
  CommonWrapper.ITALICVARIANTS = {
    italic: {
      normal: 'italic',
      bold: 'bold-italic',
      'sans-serif': 'sans-serif-italic',
      'bold-sans-serif': 'sans-serif-bold-italic'
    },
    normal: {
      italic: 'normal',
      'bold-italic': 'bold',
      'sans-serif-italic': 'sans-serif',
      'sans-serif-bold-italic': 'bold-sans-serif'
    }
  };
  return CommonWrapper;
})(Wrapper_js_1$n.AbstractWrapper);
Wrapper$2.CommonWrapper = CommonWrapper;

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = {
        enumerable: true,
        get: function () {
          return m[k];
        }
      };
    }
    Object.defineProperty(o, k2, desc);
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __setModuleDefault = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
    Object.defineProperty(o, "default", {
      enumerable: true,
      value: v
    });
  } : function (o, v) {
    o["default"] = v;
  });
  var __importStar = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var _a;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CHTMLWrapper = exports.SPACE = exports.FONTSIZE = void 0;
  var LENGTHS = __importStar(lengths);
  var Wrapper_js_1 = Wrapper$2;
  var BBox_js_1 = BBox$1;
  exports.FONTSIZE = {
    '70.7%': 's',
    '70%': 's',
    '50%': 'ss',
    '60%': 'Tn',
    '85%': 'sm',
    '120%': 'lg',
    '144%': 'Lg',
    '173%': 'LG',
    '207%': 'hg',
    '249%': 'HG'
  };
  exports.SPACE = (_a = {}, _a[LENGTHS.em(2 / 18)] = '1', _a[LENGTHS.em(3 / 18)] = '2', _a[LENGTHS.em(4 / 18)] = '3', _a[LENGTHS.em(5 / 18)] = '4', _a[LENGTHS.em(6 / 18)] = '5', _a);
  var CHTMLWrapper = (function (_super) {
    __extends(CHTMLWrapper, _super);
    function CHTMLWrapper() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.chtml = null;
      return _this;
    }
    CHTMLWrapper.prototype.toCHTML = function (parent) {
      var e_1, _a;
      var chtml = this.standardCHTMLnode(parent);
      try {
        for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          child.toCHTML(chtml);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    };
    CHTMLWrapper.prototype.standardCHTMLnode = function (parent) {
      this.markUsed();
      var chtml = this.createCHTMLnode(parent);
      this.handleStyles();
      this.handleVariant();
      this.handleScale();
      this.handleColor();
      this.handleSpace();
      this.handleAttributes();
      this.handlePWidth();
      return chtml;
    };
    CHTMLWrapper.prototype.markUsed = function () {
      this.jax.wrapperUsage.add(this.kind);
    };
    CHTMLWrapper.prototype.createCHTMLnode = function (parent) {
      var href = this.node.attributes.get('href');
      if (href) {
        parent = this.adaptor.append(parent, this.html('a', {
          href: href
        }));
      }
      this.chtml = this.adaptor.append(parent, this.html('mjx-' + this.node.kind));
      return this.chtml;
    };
    CHTMLWrapper.prototype.handleStyles = function () {
      if (!this.styles) return;
      var styles = this.styles.cssText;
      if (styles) {
        this.adaptor.setAttribute(this.chtml, 'style', styles);
        var family = this.styles.get('font-family');
        if (family) {
          this.adaptor.setStyle(this.chtml, 'font-family', 'MJXZERO, ' + family);
        }
      }
    };
    CHTMLWrapper.prototype.handleVariant = function () {
      if (this.node.isToken && this.variant !== '-explicitFont') {
        this.adaptor.setAttribute(this.chtml, 'class', (this.font.getVariant(this.variant) || this.font.getVariant('normal')).classes);
      }
    };
    CHTMLWrapper.prototype.handleScale = function () {
      this.setScale(this.chtml, this.bbox.rscale);
    };
    CHTMLWrapper.prototype.setScale = function (chtml, rscale) {
      var scale = Math.abs(rscale - 1) < .001 ? 1 : rscale;
      if (chtml && scale !== 1) {
        var size = this.percent(scale);
        if (exports.FONTSIZE[size]) {
          this.adaptor.setAttribute(chtml, 'size', exports.FONTSIZE[size]);
        } else {
          this.adaptor.setStyle(chtml, 'fontSize', size);
        }
      }
      return chtml;
    };
    CHTMLWrapper.prototype.handleSpace = function () {
      var e_2, _a;
      try {
        for (var _b = __values([[this.bbox.L, 'space', 'marginLeft'], [this.bbox.R, 'rspace', 'marginRight']]), _c = _b.next(); !_c.done; _c = _b.next()) {
          var data = _c.value;
          var _d = __read(data, 3), dimen = _d[0], name_1 = _d[1], margin = _d[2];
          if (dimen) {
            var space = this.em(dimen);
            if (exports.SPACE[space]) {
              this.adaptor.setAttribute(this.chtml, name_1, exports.SPACE[space]);
            } else {
              this.adaptor.setStyle(this.chtml, margin, space);
            }
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    };
    CHTMLWrapper.prototype.handleColor = function () {
      var attributes = this.node.attributes;
      var mathcolor = attributes.getExplicit('mathcolor');
      var color = attributes.getExplicit('color');
      var mathbackground = attributes.getExplicit('mathbackground');
      var background = attributes.getExplicit('background');
      if (mathcolor || color) {
        this.adaptor.setStyle(this.chtml, 'color', mathcolor || color);
      }
      if (mathbackground || background) {
        this.adaptor.setStyle(this.chtml, 'backgroundColor', mathbackground || background);
      }
    };
    CHTMLWrapper.prototype.handleAttributes = function () {
      var e_3, _a, e_4, _b;
      var attributes = this.node.attributes;
      var defaults = attributes.getAllDefaults();
      var skip = CHTMLWrapper.skipAttributes;
      try {
        for (var _c = __values(attributes.getExplicitNames()), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_2 = _d.value;
          if (skip[name_2] === false || !((name_2 in defaults)) && !skip[name_2] && !this.adaptor.hasAttribute(this.chtml, name_2)) {
            this.adaptor.setAttribute(this.chtml, name_2, attributes.getExplicit(name_2));
          }
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      if (attributes.get('class')) {
        var names = attributes.get('class').trim().split(/ +/);
        try {
          for (var names_1 = __values(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
            var name_3 = names_1_1.value;
            this.adaptor.addClass(this.chtml, name_3);
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (names_1_1 && !names_1_1.done && (_b = names_1.return)) _b.call(names_1);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
      }
    };
    CHTMLWrapper.prototype.handlePWidth = function () {
      if (this.bbox.pwidth) {
        if (this.bbox.pwidth === BBox_js_1.BBox.fullWidth) {
          this.adaptor.setAttribute(this.chtml, 'width', 'full');
        } else {
          this.adaptor.setStyle(this.chtml, 'width', this.bbox.pwidth);
        }
      }
    };
    CHTMLWrapper.prototype.setIndent = function (chtml, align, shift) {
      var adaptor = this.adaptor;
      if (align === 'center' || align === 'left') {
        var L = this.getBBox().L;
        adaptor.setStyle(chtml, 'margin-left', this.em(shift + L));
      }
      if (align === 'center' || align === 'right') {
        var R = this.getBBox().R;
        adaptor.setStyle(chtml, 'margin-right', this.em(-shift + R));
      }
    };
    CHTMLWrapper.prototype.drawBBox = function () {
      var _a = this.getBBox(), w = _a.w, h = _a.h, d = _a.d, R = _a.R;
      var box = this.html('mjx-box', {
        style: {
          opacity: .25,
          'margin-left': this.em(-w - R)
        }
      }, [this.html('mjx-box', {
        style: {
          height: this.em(h),
          width: this.em(w),
          'background-color': 'red'
        }
      }), this.html('mjx-box', {
        style: {
          height: this.em(d),
          width: this.em(w),
          'margin-left': this.em(-w),
          'vertical-align': this.em(-d),
          'background-color': 'green'
        }
      })]);
      var node = this.chtml || this.parent.chtml;
      var size = this.adaptor.getAttribute(node, 'size');
      if (size) {
        this.adaptor.setAttribute(box, 'size', size);
      }
      var fontsize = this.adaptor.getStyle(node, 'fontSize');
      if (fontsize) {
        this.adaptor.setStyle(box, 'fontSize', fontsize);
      }
      this.adaptor.append(this.adaptor.parent(node), box);
      this.adaptor.setStyle(node, 'backgroundColor', '#FFEE00');
    };
    CHTMLWrapper.prototype.html = function (type, def, content) {
      if (def === void 0) {
        def = {};
      }
      if (content === void 0) {
        content = [];
      }
      return this.jax.html(type, def, content);
    };
    CHTMLWrapper.prototype.text = function (text) {
      return this.jax.text(text);
    };
    CHTMLWrapper.prototype.char = function (n) {
      return this.font.charSelector(n).substr(1);
    };
    CHTMLWrapper.kind = 'unknown';
    CHTMLWrapper.autoStyle = true;
    return CHTMLWrapper;
  })(Wrapper_js_1.CommonWrapper);
  exports.CHTMLWrapper = CHTMLWrapper;
})(Wrapper$3);
getDefaultExportFromCjs(Wrapper$3);

var math$3 = {};

var math$2 = {};

var __extends$1F = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(math$2, "__esModule", {
  value: true
});
math$2.CommonMathMixin = void 0;
function CommonMathMixin(Base) {
  return (function (_super) {
    __extends$1F(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.getWrapWidth = function (_i) {
      return this.parent ? this.getBBox().w : this.metrics.containerWidth / this.jax.pxPerEm;
    };
    return class_1;
  })(Base);
}
math$2.CommonMathMixin = CommonMathMixin;

var math$1 = {};

var __extends$1E = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$z = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$z = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$z.apply(this, arguments);
});
Object.defineProperty(math$1, "__esModule", {
  value: true
});
math$1.MmlMath = void 0;
var MmlNode_js_1$F = MmlNode;
var MmlMath = (function (_super) {
  __extends$1E(MmlMath, _super);
  function MmlMath() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMath.prototype, "kind", {
    get: function () {
      return 'math';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMath.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMath.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    if (this.attributes.get('mode') === 'display') {
      this.attributes.setInherited('display', 'block');
    }
    attributes = this.addInheritedAttributes(attributes, this.attributes.getAllAttributes());
    display = !!this.attributes.get('displaystyle') || !this.attributes.get('displaystyle') && this.attributes.get('display') === 'block';
    this.attributes.setInherited('displaystyle', display);
    level = this.attributes.get('scriptlevel') || this.constructor.defaults['scriptlevel'];
    _super.prototype.setChildInheritedAttributes.call(this, attributes, display, level, prime);
  };
  MmlMath.defaults = __assign$z(__assign$z({}, MmlNode_js_1$F.AbstractMmlLayoutNode.defaults), {
    mathvariant: 'normal',
    mathsize: 'normal',
    mathcolor: '',
    mathbackground: 'transparent',
    dir: 'ltr',
    scriptlevel: 0,
    displaystyle: false,
    display: 'inline',
    maxwidth: '',
    overflow: 'linebreak',
    altimg: '',
    'altimg-width': '',
    'altimg-height': '',
    'altimg-valign': '',
    alttext: '',
    cdgroup: '',
    scriptsizemultiplier: 1 / Math.sqrt(2),
    scriptminsize: '8px',
    infixlinebreakstyle: 'before',
    lineleading: '1ex',
    linebreakmultchar: '\u2062',
    indentshift: 'auto',
    indentalign: 'auto',
    indenttarget: '',
    indentalignfirst: 'indentalign',
    indentshiftfirst: 'indentshift',
    indentalignlast: 'indentalign',
    indentshiftlast: 'indentshift'
  });
  return MmlMath;
})(MmlNode_js_1$F.AbstractMmlLayoutNode);
math$1.MmlMath = MmlMath;

var __extends$1D = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$w = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(math$3, "__esModule", {
  value: true
});
math$3.CHTMLmath = void 0;
var Wrapper_js_1$m = Wrapper$3;
var math_js_1$2 = math$2;
var math_js_2 = math$1;
var BBox_js_1$4 = BBox$1;
var CHTMLmath = (function (_super) {
  __extends$1D(CHTMLmath, _super);
  function CHTMLmath() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmath.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
    var chtml = this.chtml;
    var adaptor = this.adaptor;
    var display = this.node.attributes.get('display') === 'block';
    if (display) {
      adaptor.setAttribute(chtml, 'display', 'true');
      adaptor.setAttribute(parent, 'display', 'true');
      this.handleDisplay(parent);
    } else {
      this.handleInline(parent);
    }
    adaptor.addClass(chtml, 'MJX-TEX');
  };
  CHTMLmath.prototype.handleDisplay = function (parent) {
    var adaptor = this.adaptor;
    var _a = __read$w(this.getAlignShift(), 2), align = _a[0], shift = _a[1];
    if (align !== 'center') {
      adaptor.setAttribute(parent, 'justify', align);
    }
    if (this.bbox.pwidth === BBox_js_1$4.BBox.fullWidth) {
      adaptor.setAttribute(parent, 'width', 'full');
      if (this.jax.table) {
        var _b = this.jax.table.getOuterBBox(), L = _b.L, w = _b.w, R = _b.R;
        if (align === 'right') {
          R = Math.max(R || -shift, -shift);
        } else if (align === 'left') {
          L = Math.max(L || shift, shift);
        } else if (align === 'center') {
          w += 2 * Math.abs(shift);
        }
        var W = this.em(Math.max(0, L + w + R));
        adaptor.setStyle(parent, 'min-width', W);
        adaptor.setStyle(this.jax.table.chtml, 'min-width', W);
      }
    } else {
      this.setIndent(this.chtml, align, shift);
    }
  };
  CHTMLmath.prototype.handleInline = function (parent) {
    var adaptor = this.adaptor;
    var margin = adaptor.getStyle(this.chtml, 'margin-right');
    if (margin) {
      adaptor.setStyle(this.chtml, 'margin-right', '');
      adaptor.setStyle(parent, 'margin-right', margin);
      adaptor.setStyle(parent, 'width', '0');
    }
  };
  CHTMLmath.prototype.setChildPWidths = function (recompute, w, clear) {
    if (w === void 0) {
      w = null;
    }
    if (clear === void 0) {
      clear = true;
    }
    return this.parent ? _super.prototype.setChildPWidths.call(this, recompute, w, clear) : false;
  };
  CHTMLmath.kind = math_js_2.MmlMath.prototype.kind;
  CHTMLmath.styles = {
    'mjx-math': {
      'line-height': 0,
      'text-align': 'left',
      'text-indent': 0,
      'font-style': 'normal',
      'font-weight': 'normal',
      'font-size': '100%',
      'font-size-adjust': 'none',
      'letter-spacing': 'normal',
      'border-collapse': 'collapse',
      'word-wrap': 'normal',
      'word-spacing': 'normal',
      'white-space': 'nowrap',
      'direction': 'ltr',
      'padding': '1px 0'
    },
    'mjx-container[jax="CHTML"][display="true"]': {
      display: 'block',
      'text-align': 'center',
      margin: '1em 0'
    },
    'mjx-container[jax="CHTML"][display="true"][width="full"]': {
      display: 'flex'
    },
    'mjx-container[jax="CHTML"][display="true"] mjx-math': {
      padding: 0
    },
    'mjx-container[jax="CHTML"][justify="left"]': {
      'text-align': 'left'
    },
    'mjx-container[jax="CHTML"][justify="right"]': {
      'text-align': 'right'
    }
  };
  return CHTMLmath;
})((0, math_js_1$2.CommonMathMixin)(Wrapper_js_1$m.CHTMLWrapper));
math$3.CHTMLmath = CHTMLmath;

var mi$3 = {};

var mi$2 = {};

var __extends$1C = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mi$2, "__esModule", {
  value: true
});
mi$2.CommonMiMixin = void 0;
function CommonMiMixin(Base) {
  return (function (_super) {
    __extends$1C(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      _super.prototype.computeBBox.call(this, bbox);
      this.copySkewIC(bbox);
    };
    return class_1;
  })(Base);
}
mi$2.CommonMiMixin = CommonMiMixin;

var mi$1 = {};

var __extends$1B = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$y = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$y = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$y.apply(this, arguments);
});
Object.defineProperty(mi$1, "__esModule", {
  value: true
});
mi$1.MmlMi = void 0;
var MmlNode_js_1$E = MmlNode;
var MmlMi = (function (_super) {
  __extends$1B(MmlMi, _super);
  function MmlMi() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$E.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMi.prototype, "kind", {
    get: function () {
      return 'mi';
    },
    enumerable: false,
    configurable: true
  });
  MmlMi.prototype.setInheritedAttributes = function (attributes, display, level, prime) {
    if (attributes === void 0) {
      attributes = {};
    }
    if (display === void 0) {
      display = false;
    }
    if (level === void 0) {
      level = 0;
    }
    if (prime === void 0) {
      prime = false;
    }
    _super.prototype.setInheritedAttributes.call(this, attributes, display, level, prime);
    var text = this.getText();
    if (text.match(MmlMi.singleCharacter) && !attributes.mathvariant) {
      this.attributes.setInherited('mathvariant', 'italic');
    }
  };
  MmlMi.prototype.setTeXclass = function (prev) {
    this.getPrevClass(prev);
    var name = this.getText();
    if (name.length > 1 && name.match(MmlMi.operatorName) && this.attributes.get('mathvariant') === 'normal' && this.getProperty('autoOP') === undefined && this.getProperty('texClass') === undefined) {
      this.texClass = MmlNode_js_1$E.TEXCLASS.OP;
      this.setProperty('autoOP', true);
    }
    return this;
  };
  MmlMi.defaults = __assign$y({}, MmlNode_js_1$E.AbstractMmlTokenNode.defaults);
  MmlMi.operatorName = /^[a-z][a-z0-9]*$/i;
  MmlMi.singleCharacter = /^[\uD800-\uDBFF]?.[\u0300-\u036F\u1AB0-\u1ABE\u1DC0-\u1DFF\u20D0-\u20EF]*$/;
  return MmlMi;
})(MmlNode_js_1$E.AbstractMmlTokenNode);
mi$1.MmlMi = MmlMi;

var __extends$1A = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mi$3, "__esModule", {
  value: true
});
mi$3.CHTMLmi = void 0;
var Wrapper_js_1$l = Wrapper$3;
var mi_js_1$2 = mi$2;
var mi_js_2 = mi$1;
var CHTMLmi = (function (_super) {
  __extends$1A(CHTMLmi, _super);
  function CHTMLmi() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmi.kind = mi_js_2.MmlMi.prototype.kind;
  return CHTMLmi;
})((0, mi_js_1$2.CommonMiMixin)(Wrapper_js_1$l.CHTMLWrapper));
mi$3.CHTMLmi = CHTMLmi;

var mo$2 = {};

var mo$1 = {};

var __extends$1z = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$x = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$x = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$x.apply(this, arguments);
});
var __read$v = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$f = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$v = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var _a$9;
Object.defineProperty(mo$1, "__esModule", {
  value: true
});
mo$1.CommonMoMixin = mo$1.DirectionVH = void 0;
var BBox_js_1$3 = BBox$1;
var string_js_1$7 = string;
var FontData_js_1$i = FontData$2;
mo$1.DirectionVH = (_a$9 = {}, _a$9[1] = 'v', _a$9[2] = 'h', _a$9);
function CommonMoMixin(Base) {
  return (function (_super) {
    __extends$1z(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$f([], __read$v(args), false)) || this;
      _this.size = null;
      _this.isAccent = _this.node.isAccent;
      return _this;
    }
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      this.protoBBox(bbox);
      if (this.node.attributes.get('symmetric') && this.stretch.dir !== 2) {
        var d = this.getCenterOffset(bbox);
        bbox.h += d;
        bbox.d -= d;
      }
      if (this.node.getProperty('mathaccent') && (this.stretch.dir === 0 || this.size >= 0)) {
        bbox.w = 0;
      }
    };
    class_1.prototype.protoBBox = function (bbox) {
      var stretchy = this.stretch.dir !== 0;
      if (stretchy && this.size === null) {
        this.getStretchedVariant([0]);
      }
      if (stretchy && this.size < 0) return;
      _super.prototype.computeBBox.call(this, bbox);
      this.copySkewIC(bbox);
    };
    class_1.prototype.getAccentOffset = function () {
      var bbox = BBox_js_1$3.BBox.empty();
      this.protoBBox(bbox);
      return -bbox.w / 2;
    };
    class_1.prototype.getCenterOffset = function (bbox) {
      if (bbox === void 0) {
        bbox = null;
      }
      if (!bbox) {
        bbox = BBox_js_1$3.BBox.empty();
        _super.prototype.computeBBox.call(this, bbox);
      }
      return (bbox.h + bbox.d) / 2 + this.font.params.axis_height - bbox.h;
    };
    class_1.prototype.getVariant = function () {
      if (this.node.attributes.get('largeop')) {
        this.variant = this.node.attributes.get('displaystyle') ? '-largeop' : '-smallop';
        return;
      }
      if (!this.node.attributes.getExplicit('mathvariant') && this.node.getProperty('pseudoscript') === false) {
        this.variant = '-tex-variant';
        return;
      }
      _super.prototype.getVariant.call(this);
    };
    class_1.prototype.canStretch = function (direction) {
      if (this.stretch.dir !== 0) {
        return this.stretch.dir === direction;
      }
      var attributes = this.node.attributes;
      if (!attributes.get('stretchy')) return false;
      var c = this.getText();
      if (Array.from(c).length !== 1) return false;
      var delim = this.font.getDelimiter(c.codePointAt(0));
      this.stretch = delim && delim.dir === direction ? delim : FontData_js_1$i.NOSTRETCH;
      return this.stretch.dir !== 0;
    };
    class_1.prototype.getStretchedVariant = function (WH, exact) {
      var e_1, _a;
      if (exact === void 0) {
        exact = false;
      }
      if (this.stretch.dir !== 0) {
        var D = this.getWH(WH);
        var min = this.getSize('minsize', 0);
        var max = this.getSize('maxsize', Infinity);
        var mathaccent = this.node.getProperty('mathaccent');
        D = Math.max(min, Math.min(max, D));
        var df = this.font.params.delimiterfactor / 1000;
        var ds = this.font.params.delimitershortfall;
        var m = min || exact ? D : mathaccent ? Math.min(D / df, D + ds) : Math.max(D * df, D - ds);
        var delim = this.stretch;
        var c = delim.c || this.getText().codePointAt(0);
        var i = 0;
        if (delim.sizes) {
          try {
            for (var _b = __values$v(delim.sizes), _c = _b.next(); !_c.done; _c = _b.next()) {
              var d = _c.value;
              if (d >= m) {
                if (mathaccent && i) {
                  i--;
                }
                this.variant = this.font.getSizeVariant(c, i);
                this.size = i;
                if (delim.schar && delim.schar[i]) {
                  this.stretch = __assign$x(__assign$x({}, this.stretch), {
                    c: delim.schar[i]
                  });
                }
                return;
              }
              i++;
            }
          } catch (e_1_1) {
            e_1 = {
              error: e_1_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            } finally {
              if (e_1) throw e_1.error;
            }
          }
        }
        if (delim.stretch) {
          this.size = -1;
          this.invalidateBBox();
          this.getStretchBBox(WH, this.checkExtendedHeight(D, delim), delim);
        } else {
          this.variant = this.font.getSizeVariant(c, i - 1);
          this.size = i - 1;
        }
      }
    };
    class_1.prototype.getSize = function (name, value) {
      var attributes = this.node.attributes;
      if (attributes.isSet(name)) {
        value = this.length2em(attributes.get(name), 1, 1);
      }
      return value;
    };
    class_1.prototype.getWH = function (WH) {
      if (WH.length === 0) return 0;
      if (WH.length === 1) return WH[0];
      var _a = __read$v(WH, 2), H = _a[0], D = _a[1];
      var a = this.font.params.axis_height;
      return this.node.attributes.get('symmetric') ? 2 * Math.max(H - a, D + a) : H + D;
    };
    class_1.prototype.getStretchBBox = function (WHD, D, C) {
      var _a;
      if (C.hasOwnProperty('min') && C.min > D) {
        D = C.min;
      }
      var _b = __read$v(C.HDW, 3), h = _b[0], d = _b[1], w = _b[2];
      if (this.stretch.dir === 1) {
        (_a = __read$v(this.getBaseline(WHD, D, C), 2), h = _a[0], d = _a[1]);
      } else {
        w = D;
      }
      this.bbox.h = h;
      this.bbox.d = d;
      this.bbox.w = w;
    };
    class_1.prototype.getBaseline = function (WHD, HD, C) {
      var hasWHD = WHD.length === 2 && WHD[0] + WHD[1] === HD;
      var symmetric = this.node.attributes.get('symmetric');
      var _a = __read$v(hasWHD ? WHD : [HD, 0], 2), H = _a[0], D = _a[1];
      var _b = __read$v([H + D, 0], 2), h = _b[0], d = _b[1];
      if (symmetric) {
        var a = this.font.params.axis_height;
        if (hasWHD) {
          h = 2 * Math.max(H - a, D + a);
        }
        d = h / 2 - a;
      } else if (hasWHD) {
        d = D;
      } else {
        var _c = __read$v(C.HDW || [.75, .25], 2), ch = _c[0], cd = _c[1];
        d = cd * (h / (ch + cd));
      }
      return [h - d, d];
    };
    class_1.prototype.checkExtendedHeight = function (D, C) {
      if (C.fullExt) {
        var _a = __read$v(C.fullExt, 2), extSize = _a[0], endSize = _a[1];
        var n = Math.ceil(Math.max(0, D - endSize) / extSize);
        D = endSize + n * extSize;
      }
      return D;
    };
    class_1.prototype.remapChars = function (chars) {
      var primes = this.node.getProperty('primes');
      if (primes) {
        return (0, string_js_1$7.unicodeChars)(primes);
      }
      if (chars.length === 1) {
        var parent_1 = this.node.coreParent().parent;
        var isAccent = this.isAccent && !parent_1.isKind('mrow');
        var map = isAccent ? 'accent' : 'mo';
        var text = this.font.getRemappedChar(map, chars[0]);
        if (text) {
          chars = this.unicodeChars(text, this.variant);
        }
      }
      return chars;
    };
    return class_1;
  })(Base);
}
mo$1.CommonMoMixin = CommonMoMixin;

var __extends$1y = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$u = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mo$2, "__esModule", {
  value: true
});
mo$2.CHTMLmo = void 0;
var Wrapper_js_1$k = Wrapper$3;
var mo_js_1$3 = mo$1;
var mo_js_2 = mo$3;
var CHTMLmo = (function (_super) {
  __extends$1y(CHTMLmo, _super);
  function CHTMLmo() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmo.prototype.toCHTML = function (parent) {
    var e_1, _a;
    var attributes = this.node.attributes;
    var symmetric = attributes.get('symmetric') && this.stretch.dir !== 2;
    var stretchy = this.stretch.dir !== 0;
    if (stretchy && this.size === null) {
      this.getStretchedVariant([]);
    }
    var chtml = this.standardCHTMLnode(parent);
    if (stretchy && this.size < 0) {
      this.stretchHTML(chtml);
    } else {
      if (symmetric || attributes.get('largeop')) {
        var u = this.em(this.getCenterOffset());
        if (u !== '0') {
          this.adaptor.setStyle(chtml, 'verticalAlign', u);
        }
      }
      if (this.node.getProperty('mathaccent')) {
        this.adaptor.setStyle(chtml, 'width', '0');
        this.adaptor.setStyle(chtml, 'margin-left', this.em(this.getAccentOffset()));
      }
      try {
        for (var _b = __values$u(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          child.toCHTML(chtml);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    }
  };
  CHTMLmo.prototype.stretchHTML = function (chtml) {
    var c = this.getText().codePointAt(0);
    this.font.delimUsage.add(c);
    this.childNodes[0].markUsed();
    var delim = this.stretch;
    var stretch = delim.stretch;
    var content = [];
    if (stretch[0]) {
      content.push(this.html('mjx-beg', {}, [this.html('mjx-c')]));
    }
    content.push(this.html('mjx-ext', {}, [this.html('mjx-c')]));
    if (stretch.length === 4) {
      content.push(this.html('mjx-mid', {}, [this.html('mjx-c')]), this.html('mjx-ext', {}, [this.html('mjx-c')]));
    }
    if (stretch[2]) {
      content.push(this.html('mjx-end', {}, [this.html('mjx-c')]));
    }
    var styles = {};
    var _a = this.bbox, h = _a.h, d = _a.d, w = _a.w;
    if (delim.dir === 1) {
      content.push(this.html('mjx-mark'));
      styles.height = this.em(h + d);
      styles.verticalAlign = this.em(-d);
    } else {
      styles.width = this.em(w);
    }
    var dir = mo_js_1$3.DirectionVH[delim.dir];
    var properties = {
      class: this.char(delim.c || c),
      style: styles
    };
    var html = this.html('mjx-stretchy-' + dir, properties, content);
    this.adaptor.append(chtml, html);
  };
  CHTMLmo.kind = mo_js_2.MmlMo.prototype.kind;
  CHTMLmo.styles = {
    'mjx-stretchy-h': {
      display: 'inline-table',
      width: '100%'
    },
    'mjx-stretchy-h > *': {
      display: 'table-cell',
      width: 0
    },
    'mjx-stretchy-h > * > mjx-c': {
      display: 'inline-block',
      transform: 'scalex(1.0000001)'
    },
    'mjx-stretchy-h > * > mjx-c::before': {
      display: 'inline-block',
      width: 'initial'
    },
    'mjx-stretchy-h > mjx-ext': {
      '/* IE */ overflow': 'hidden',
      '/* others */ overflow': 'clip visible',
      width: '100%'
    },
    'mjx-stretchy-h > mjx-ext > mjx-c::before': {
      transform: 'scalex(500)'
    },
    'mjx-stretchy-h > mjx-ext > mjx-c': {
      width: 0
    },
    'mjx-stretchy-h > mjx-beg > mjx-c': {
      'margin-right': '-.1em'
    },
    'mjx-stretchy-h > mjx-end > mjx-c': {
      'margin-left': '-.1em'
    },
    'mjx-stretchy-v': {
      display: 'inline-block'
    },
    'mjx-stretchy-v > *': {
      display: 'block'
    },
    'mjx-stretchy-v > mjx-beg': {
      height: 0
    },
    'mjx-stretchy-v > mjx-end > mjx-c': {
      display: 'block'
    },
    'mjx-stretchy-v > * > mjx-c': {
      transform: 'scaley(1.0000001)',
      'transform-origin': 'left center',
      overflow: 'hidden'
    },
    'mjx-stretchy-v > mjx-ext': {
      display: 'block',
      height: '100%',
      'box-sizing': 'border-box',
      border: '0px solid transparent',
      '/* IE */ overflow': 'hidden',
      '/* others */ overflow': 'visible clip'
    },
    'mjx-stretchy-v > mjx-ext > mjx-c::before': {
      width: 'initial',
      'box-sizing': 'border-box'
    },
    'mjx-stretchy-v > mjx-ext > mjx-c': {
      transform: 'scaleY(500) translateY(.075em)',
      overflow: 'visible'
    },
    'mjx-mark': {
      display: 'inline-block',
      height: '0px'
    }
  };
  return CHTMLmo;
})((0, mo_js_1$3.CommonMoMixin)(Wrapper_js_1$k.CHTMLWrapper));
mo$2.CHTMLmo = CHTMLmo;

var mn$3 = {};

var mn$2 = {};

var __extends$1x = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mn$2, "__esModule", {
  value: true
});
mn$2.CommonMnMixin = void 0;
function CommonMnMixin(Base) {
  return (function (_super) {
    __extends$1x(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.remapChars = function (chars) {
      if (chars.length) {
        var text = this.font.getRemappedChar('mn', chars[0]);
        if (text) {
          var c = this.unicodeChars(text, this.variant);
          if (c.length === 1) {
            chars[0] = c[0];
          } else {
            chars = c.concat(chars.slice(1));
          }
        }
      }
      return chars;
    };
    return class_1;
  })(Base);
}
mn$2.CommonMnMixin = CommonMnMixin;

var mn$1 = {};

var __extends$1w = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$w = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$w = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$w.apply(this, arguments);
});
Object.defineProperty(mn$1, "__esModule", {
  value: true
});
mn$1.MmlMn = void 0;
var MmlNode_js_1$D = MmlNode;
var MmlMn = (function (_super) {
  __extends$1w(MmlMn, _super);
  function MmlMn() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$D.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMn.prototype, "kind", {
    get: function () {
      return 'mn';
    },
    enumerable: false,
    configurable: true
  });
  MmlMn.defaults = __assign$w({}, MmlNode_js_1$D.AbstractMmlTokenNode.defaults);
  return MmlMn;
})(MmlNode_js_1$D.AbstractMmlTokenNode);
mn$1.MmlMn = MmlMn;

var __extends$1v = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mn$3, "__esModule", {
  value: true
});
mn$3.CHTMLmn = void 0;
var Wrapper_js_1$j = Wrapper$3;
var mn_js_1$2 = mn$2;
var mn_js_2 = mn$1;
var CHTMLmn = (function (_super) {
  __extends$1v(CHTMLmn, _super);
  function CHTMLmn() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmn.kind = mn_js_2.MmlMn.prototype.kind;
  return CHTMLmn;
})((0, mn_js_1$2.CommonMnMixin)(Wrapper_js_1$j.CHTMLWrapper));
mn$3.CHTMLmn = CHTMLmn;

var ms$3 = {};

var ms$2 = {};

var __extends$1u = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$u = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$e = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(ms$2, "__esModule", {
  value: true
});
ms$2.CommonMsMixin = void 0;
function CommonMsMixin(Base) {
  return (function (_super) {
    __extends$1u(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$e([], __read$u(args), false)) || this;
      var attributes = _this.node.attributes;
      var quotes = attributes.getList('lquote', 'rquote');
      if (_this.variant !== 'monospace') {
        if (!attributes.isSet('lquote') && quotes.lquote === '"') quotes.lquote = '\u201C';
        if (!attributes.isSet('rquote') && quotes.rquote === '"') quotes.rquote = '\u201D';
      }
      _this.childNodes.unshift(_this.createText(quotes.lquote));
      _this.childNodes.push(_this.createText(quotes.rquote));
      return _this;
    }
    class_1.prototype.createText = function (text) {
      var node = this.wrap(this.mmlText(text));
      node.parent = this;
      return node;
    };
    return class_1;
  })(Base);
}
ms$2.CommonMsMixin = CommonMsMixin;

var ms$1 = {};

var __extends$1t = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$v = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$v = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$v.apply(this, arguments);
});
Object.defineProperty(ms$1, "__esModule", {
  value: true
});
ms$1.MmlMs = void 0;
var MmlNode_js_1$C = MmlNode;
var MmlMs = (function (_super) {
  __extends$1t(MmlMs, _super);
  function MmlMs() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$C.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMs.prototype, "kind", {
    get: function () {
      return 'ms';
    },
    enumerable: false,
    configurable: true
  });
  MmlMs.defaults = __assign$v(__assign$v({}, MmlNode_js_1$C.AbstractMmlTokenNode.defaults), {
    lquote: '"',
    rquote: '"'
  });
  return MmlMs;
})(MmlNode_js_1$C.AbstractMmlTokenNode);
ms$1.MmlMs = MmlMs;

var __extends$1s = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(ms$3, "__esModule", {
  value: true
});
ms$3.CHTMLms = void 0;
var Wrapper_js_1$i = Wrapper$3;
var ms_js_1$2 = ms$2;
var ms_js_2 = ms$1;
var CHTMLms = (function (_super) {
  __extends$1s(CHTMLms, _super);
  function CHTMLms() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLms.kind = ms_js_2.MmlMs.prototype.kind;
  return CHTMLms;
})((0, ms_js_1$2.CommonMsMixin)(Wrapper_js_1$i.CHTMLWrapper));
ms$3.CHTMLms = CHTMLms;

var mtext$3 = {};

var mtext$2 = {};

var __extends$1r = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mtext$2, "__esModule", {
  value: true
});
mtext$2.CommonMtextMixin = void 0;
function CommonMtextMixin(Base) {
  var _a;
  return (_a = (function (_super) {
    __extends$1r(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.getVariant = function () {
      var options = this.jax.options;
      var data = this.jax.math.outputData;
      var merror = (!!data.merrorFamily || !!options.merrorFont) && this.node.Parent.isKind('merror');
      if (!!data.mtextFamily || !!options.mtextFont || merror) {
        var variant = this.node.attributes.get('mathvariant');
        var font = this.constructor.INHERITFONTS[variant] || this.jax.font.getCssFont(variant);
        var family = font[0] || (merror ? data.merrorFamily || options.merrorFont : data.mtextFamily || options.mtextFont);
        this.variant = this.explicitVariant(family, font[2] ? 'bold' : '', font[1] ? 'italic' : '');
        return;
      }
      _super.prototype.getVariant.call(this);
    };
    return class_1;
  })(Base), _a.INHERITFONTS = {
    normal: ['', false, false],
    bold: ['', false, true],
    italic: ['', true, false],
    'bold-italic': ['', true, true]
  }, _a);
}
mtext$2.CommonMtextMixin = CommonMtextMixin;

var mtext$1 = {};

var __extends$1q = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$u = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$u = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$u.apply(this, arguments);
});
Object.defineProperty(mtext$1, "__esModule", {
  value: true
});
mtext$1.MmlMtext = void 0;
var MmlNode_js_1$B = MmlNode;
var MmlMtext = (function (_super) {
  __extends$1q(MmlMtext, _super);
  function MmlMtext() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$B.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMtext.prototype, "kind", {
    get: function () {
      return 'mtext';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMtext.prototype, "isSpacelike", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMtext.defaults = __assign$u({}, MmlNode_js_1$B.AbstractMmlTokenNode.defaults);
  return MmlMtext;
})(MmlNode_js_1$B.AbstractMmlTokenNode);
mtext$1.MmlMtext = MmlMtext;

var __extends$1p = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mtext$3, "__esModule", {
  value: true
});
mtext$3.CHTMLmtext = void 0;
var Wrapper_js_1$h = Wrapper$3;
var mtext_js_1$2 = mtext$2;
var mtext_js_2 = mtext$1;
var CHTMLmtext = (function (_super) {
  __extends$1p(CHTMLmtext, _super);
  function CHTMLmtext() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmtext.kind = mtext_js_2.MmlMtext.prototype.kind;
  return CHTMLmtext;
})((0, mtext_js_1$2.CommonMtextMixin)(Wrapper_js_1$h.CHTMLWrapper));
mtext$3.CHTMLmtext = CHTMLmtext;

var mspace$2 = {};

var mspace$1 = {};

var __extends$1o = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mspace$1, "__esModule", {
  value: true
});
mspace$1.CommonMspaceMixin = void 0;
function CommonMspaceMixin(Base) {
  return (function (_super) {
    __extends$1o(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      var attributes = this.node.attributes;
      bbox.w = this.length2em(attributes.get('width'), 0);
      bbox.h = this.length2em(attributes.get('height'), 0);
      bbox.d = this.length2em(attributes.get('depth'), 0);
    };
    class_1.prototype.handleVariant = function () {};
    return class_1;
  })(Base);
}
mspace$1.CommonMspaceMixin = CommonMspaceMixin;

var mspace = {};

var __extends$1n = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$t = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$t = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$t.apply(this, arguments);
});
Object.defineProperty(mspace, "__esModule", {
  value: true
});
mspace.MmlMspace = void 0;
var MmlNode_js_1$A = MmlNode;
var MmlMspace = (function (_super) {
  __extends$1n(MmlMspace, _super);
  function MmlMspace() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$A.TEXCLASS.NONE;
    return _this;
  }
  MmlMspace.prototype.setTeXclass = function (prev) {
    return prev;
  };
  Object.defineProperty(MmlMspace.prototype, "kind", {
    get: function () {
      return 'mspace';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMspace.prototype, "arity", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMspace.prototype, "isSpacelike", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMspace.prototype, "hasNewline", {
    get: function () {
      var attributes = this.attributes;
      return attributes.getExplicit('width') == null && attributes.getExplicit('height') == null && attributes.getExplicit('depth') == null && attributes.get('linebreak') === 'newline';
    },
    enumerable: false,
    configurable: true
  });
  MmlMspace.defaults = __assign$t(__assign$t({}, MmlNode_js_1$A.AbstractMmlTokenNode.defaults), {
    width: '0em',
    height: '0ex',
    depth: '0ex',
    linebreak: 'auto'
  });
  return MmlMspace;
})(MmlNode_js_1$A.AbstractMmlTokenNode);
mspace.MmlMspace = MmlMspace;

var __extends$1m = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mspace$2, "__esModule", {
  value: true
});
var CHTMLmspace_1 = mspace$2.CHTMLmspace = void 0;
var Wrapper_js_1$g = Wrapper$3;
var mspace_js_1$2 = mspace$1;
var mspace_js_2 = mspace;
var CHTMLmspace = (function (_super) {
  __extends$1m(CHTMLmspace, _super);
  function CHTMLmspace() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmspace.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    var _a = this.getBBox(), w = _a.w, h = _a.h, d = _a.d;
    if (w < 0) {
      this.adaptor.setStyle(chtml, 'marginRight', this.em(w));
      w = 0;
    }
    if (w) {
      this.adaptor.setStyle(chtml, 'width', this.em(w));
    }
    h = Math.max(0, h + d);
    if (h) {
      this.adaptor.setStyle(chtml, 'height', this.em(Math.max(0, h)));
    }
    if (d) {
      this.adaptor.setStyle(chtml, 'verticalAlign', this.em(-d));
    }
  };
  CHTMLmspace.kind = mspace_js_2.MmlMspace.prototype.kind;
  return CHTMLmspace;
})((0, mspace_js_1$2.CommonMspaceMixin)(Wrapper_js_1$g.CHTMLWrapper));
CHTMLmspace_1 = mspace$2.CHTMLmspace = CHTMLmspace;

var mpadded$2 = {};

var mpadded$1 = {};

var __extends$1l = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$t = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(mpadded$1, "__esModule", {
  value: true
});
mpadded$1.CommonMpaddedMixin = void 0;
function CommonMpaddedMixin(Base) {
  return (function (_super) {
    __extends$1l(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.getDimens = function () {
      var values = this.node.attributes.getList('width', 'height', 'depth', 'lspace', 'voffset');
      var bbox = this.childNodes[0].getBBox();
      var w = bbox.w, h = bbox.h, d = bbox.d;
      var W = w, H = h, D = d, x = 0, y = 0, dx = 0;
      if (values.width !== '') w = this.dimen(values.width, bbox, 'w', 0);
      if (values.height !== '') h = this.dimen(values.height, bbox, 'h', 0);
      if (values.depth !== '') d = this.dimen(values.depth, bbox, 'd', 0);
      if (values.voffset !== '') y = this.dimen(values.voffset, bbox);
      if (values.lspace !== '') x = this.dimen(values.lspace, bbox);
      var align = this.node.attributes.get('data-align');
      if (align) {
        dx = this.getAlignX(w, bbox, align);
      }
      return [H, D, W, h - H, d - D, w - W, x, y, dx];
    };
    class_1.prototype.dimen = function (length, bbox, d, m) {
      if (d === void 0) {
        d = '';
      }
      if (m === void 0) {
        m = null;
      }
      length = String(length);
      var match = length.match(/width|height|depth/);
      var size = match ? bbox[match[0].charAt(0)] : d ? bbox[d] : 0;
      var dimen = this.length2em(length, size) || 0;
      if (length.match(/^[-+]/) && d) {
        dimen += size;
      }
      if (m != null) {
        dimen = Math.max(m, dimen);
      }
      return dimen;
    };
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      var _a = __read$t(this.getDimens(), 6), H = _a[0], D = _a[1], W = _a[2], dh = _a[3], dd = _a[4], dw = _a[5];
      bbox.w = W + dw;
      bbox.h = H + dh;
      bbox.d = D + dd;
      this.setChildPWidths(recompute, bbox.w);
    };
    class_1.prototype.getWrapWidth = function (_i) {
      return this.getBBox().w;
    };
    class_1.prototype.getChildAlign = function (_i) {
      return this.node.attributes.get('data-align') || 'left';
    };
    return class_1;
  })(Base);
}
mpadded$1.CommonMpaddedMixin = CommonMpaddedMixin;

var mpadded = {};

var __extends$1k = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$s = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$s = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$s.apply(this, arguments);
});
Object.defineProperty(mpadded, "__esModule", {
  value: true
});
mpadded.MmlMpadded = void 0;
var MmlNode_js_1$z = MmlNode;
var MmlMpadded = (function (_super) {
  __extends$1k(MmlMpadded, _super);
  function MmlMpadded() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMpadded.prototype, "kind", {
    get: function () {
      return 'mpadded';
    },
    enumerable: false,
    configurable: true
  });
  MmlMpadded.defaults = __assign$s(__assign$s({}, MmlNode_js_1$z.AbstractMmlLayoutNode.defaults), {
    width: '',
    height: '',
    depth: '',
    lspace: 0,
    voffset: 0
  });
  return MmlMpadded;
})(MmlNode_js_1$z.AbstractMmlLayoutNode);
mpadded.MmlMpadded = MmlMpadded;

var __extends$1j = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$s = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$t = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mpadded$2, "__esModule", {
  value: true
});
mpadded$2.CHTMLmpadded = void 0;
var Wrapper_js_1$f = Wrapper$3;
var mpadded_js_1$2 = mpadded$1;
var mpadded_js_2 = mpadded;
var CHTMLmpadded = (function (_super) {
  __extends$1j(CHTMLmpadded, _super);
  function CHTMLmpadded() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmpadded.prototype.toCHTML = function (parent) {
    var e_1, _a;
    var chtml = this.standardCHTMLnode(parent);
    var content = [];
    var style = {};
    var _b = __read$s(this.getDimens(), 9), W = _b[2], dh = _b[3], dd = _b[4], dw = _b[5], x = _b[6], y = _b[7], dx = _b[8];
    if (dw) {
      style.width = this.em(W + dw);
    }
    if (dh || dd) {
      style.margin = this.em(dh) + ' 0 ' + this.em(dd);
    }
    if (x + dx || y) {
      style.position = 'relative';
      var rbox = this.html('mjx-rbox', {
        style: {
          left: this.em(x + dx),
          top: this.em(-y),
          'max-width': style.width
        }
      });
      if (x + dx && this.childNodes[0].getBBox().pwidth) {
        this.adaptor.setAttribute(rbox, 'width', 'full');
        this.adaptor.setStyle(rbox, 'left', this.em(x));
      }
      content.push(rbox);
    }
    chtml = this.adaptor.append(chtml, this.html('mjx-block', {
      style: style
    }, content));
    try {
      for (var _c = __values$t(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var child = _d.value;
        child.toCHTML(content[0] || chtml);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  CHTMLmpadded.kind = mpadded_js_2.MmlMpadded.prototype.kind;
  CHTMLmpadded.styles = {
    'mjx-mpadded': {
      display: 'inline-block'
    },
    'mjx-rbox': {
      display: 'inline-block',
      position: 'relative'
    }
  };
  return CHTMLmpadded;
})((0, mpadded_js_1$2.CommonMpaddedMixin)(Wrapper_js_1$f.CHTMLWrapper));
mpadded$2.CHTMLmpadded = CHTMLmpadded;

var menclose$3 = {};

var menclose$2 = {};

var Notation$4 = {};

(function (exports) {
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CommonArrow = exports.CommonDiagonalArrow = exports.CommonDiagonalStrike = exports.CommonBorder2 = exports.CommonBorder = exports.arrowBBox = exports.diagonalArrowDef = exports.arrowDef = exports.arrowBBoxW = exports.arrowBBoxHD = exports.arrowHead = exports.fullBorder = exports.fullPadding = exports.fullBBox = exports.sideNames = exports.sideIndex = exports.SOLID = exports.PADDING = exports.THICKNESS = exports.ARROWY = exports.ARROWDX = exports.ARROWX = void 0;
  (exports.ARROWX = 4, exports.ARROWDX = 1, exports.ARROWY = 2);
  exports.THICKNESS = .067;
  exports.PADDING = .2;
  exports.SOLID = exports.THICKNESS + 'em solid';
  exports.sideIndex = {
    top: 0,
    right: 1,
    bottom: 2,
    left: 3
  };
  exports.sideNames = Object.keys(exports.sideIndex);
  exports.fullBBox = function (node) {
    return new Array(4).fill(node.thickness + node.padding);
  };
  exports.fullPadding = function (node) {
    return new Array(4).fill(node.padding);
  };
  exports.fullBorder = function (node) {
    return new Array(4).fill(node.thickness);
  };
  var arrowHead = function (node) {
    return Math.max(node.padding, node.thickness * (node.arrowhead.x + node.arrowhead.dx + 1));
  };
  exports.arrowHead = arrowHead;
  var arrowBBoxHD = function (node, TRBL) {
    if (node.childNodes[0]) {
      var _a = node.childNodes[0].getBBox(), h = _a.h, d = _a.d;
      TRBL[0] = TRBL[2] = Math.max(0, node.thickness * node.arrowhead.y - (h + d) / 2);
    }
    return TRBL;
  };
  exports.arrowBBoxHD = arrowBBoxHD;
  var arrowBBoxW = function (node, TRBL) {
    if (node.childNodes[0]) {
      var w = node.childNodes[0].getBBox().w;
      TRBL[1] = TRBL[3] = Math.max(0, node.thickness * node.arrowhead.y - w / 2);
    }
    return TRBL;
  };
  exports.arrowBBoxW = arrowBBoxW;
  exports.arrowDef = {
    up: [-Math.PI / 2, false, true, 'verticalstrike'],
    down: [Math.PI / 2, false, true, 'verticakstrike'],
    right: [0, false, false, 'horizontalstrike'],
    left: [Math.PI, false, false, 'horizontalstrike'],
    updown: [Math.PI / 2, true, true, 'verticalstrike uparrow downarrow'],
    leftright: [0, true, false, 'horizontalstrike leftarrow rightarrow']
  };
  exports.diagonalArrowDef = {
    updiagonal: [-1, 0, false, 'updiagonalstrike northeastarrow'],
    northeast: [-1, 0, false, 'updiagonalstrike updiagonalarrow'],
    southeast: [1, 0, false, 'downdiagonalstrike'],
    northwest: [1, Math.PI, false, 'downdiagonalstrike'],
    southwest: [-1, Math.PI, false, 'updiagonalstrike'],
    northeastsouthwest: [-1, 0, true, 'updiagonalstrike northeastarrow updiagonalarrow southwestarrow'],
    northwestsoutheast: [1, 0, true, 'downdiagonalstrike northwestarrow southeastarrow']
  };
  exports.arrowBBox = {
    up: function (node) {
      return (0, exports.arrowBBoxW)(node, [(0, exports.arrowHead)(node), 0, node.padding, 0]);
    },
    down: function (node) {
      return (0, exports.arrowBBoxW)(node, [node.padding, 0, (0, exports.arrowHead)(node), 0]);
    },
    right: function (node) {
      return (0, exports.arrowBBoxHD)(node, [0, (0, exports.arrowHead)(node), 0, node.padding]);
    },
    left: function (node) {
      return (0, exports.arrowBBoxHD)(node, [0, node.padding, 0, (0, exports.arrowHead)(node)]);
    },
    updown: function (node) {
      return (0, exports.arrowBBoxW)(node, [(0, exports.arrowHead)(node), 0, (0, exports.arrowHead)(node), 0]);
    },
    leftright: function (node) {
      return (0, exports.arrowBBoxHD)(node, [0, (0, exports.arrowHead)(node), 0, (0, exports.arrowHead)(node)]);
    }
  };
  var CommonBorder = function (render) {
    return function (side) {
      var i = exports.sideIndex[side];
      return [side, {
        renderer: render,
        bbox: function (node) {
          var bbox = [0, 0, 0, 0];
          bbox[i] = node.thickness + node.padding;
          return bbox;
        },
        border: function (node) {
          var bbox = [0, 0, 0, 0];
          bbox[i] = node.thickness;
          return bbox;
        }
      }];
    };
  };
  exports.CommonBorder = CommonBorder;
  var CommonBorder2 = function (render) {
    return function (name, side1, side2) {
      var i1 = exports.sideIndex[side1];
      var i2 = exports.sideIndex[side2];
      return [name, {
        renderer: render,
        bbox: function (node) {
          var t = node.thickness + node.padding;
          var bbox = [0, 0, 0, 0];
          bbox[i1] = bbox[i2] = t;
          return bbox;
        },
        border: function (node) {
          var bbox = [0, 0, 0, 0];
          bbox[i1] = bbox[i2] = node.thickness;
          return bbox;
        },
        remove: side1 + ' ' + side2
      }];
    };
  };
  exports.CommonBorder2 = CommonBorder2;
  var CommonDiagonalStrike = function (render) {
    return function (name) {
      var cname = 'mjx-' + name.charAt(0) + 'strike';
      return [name + 'diagonalstrike', {
        renderer: render(cname),
        bbox: exports.fullBBox
      }];
    };
  };
  exports.CommonDiagonalStrike = CommonDiagonalStrike;
  var CommonDiagonalArrow = function (render) {
    return function (name) {
      var _a = __read(exports.diagonalArrowDef[name], 4), c = _a[0], pi = _a[1], double = _a[2], remove = _a[3];
      return [name + 'arrow', {
        renderer: function (node, _child) {
          var _a = __read(node.arrowAW(), 2), a = _a[0], W = _a[1];
          var arrow = node.arrow(W, c * (a - pi), double);
          render(node, arrow);
        },
        bbox: function (node) {
          var _a = node.arrowData(), a = _a.a, x = _a.x, y = _a.y;
          var _b = __read([node.arrowhead.x, node.arrowhead.y, node.arrowhead.dx], 3), ax = _b[0], ay = _b[1], adx = _b[2];
          var _c = __read(node.getArgMod(ax + adx, ay), 2), b = _c[0], ar = _c[1];
          var dy = y + (b > a ? node.thickness * ar * Math.sin(b - a) : 0);
          var dx = x + (b > Math.PI / 2 - a ? node.thickness * ar * Math.sin(b + a - Math.PI / 2) : 0);
          return [dy, dx, dy, dx];
        },
        remove: remove
      }];
    };
  };
  exports.CommonDiagonalArrow = CommonDiagonalArrow;
  var CommonArrow = function (render) {
    return function (name) {
      var _a = __read(exports.arrowDef[name], 4), angle = _a[0], double = _a[1], isVertical = _a[2], remove = _a[3];
      return [name + 'arrow', {
        renderer: function (node, _child) {
          var _a = node.getBBox(), w = _a.w, h = _a.h, d = _a.d;
          var _b = __read(isVertical ? [h + d, 'X'] : [w, 'Y'], 2), W = _b[0], offset = _b[1];
          var dd = node.getOffset(offset);
          var arrow = node.arrow(W, angle, double, offset, dd);
          render(node, arrow);
        },
        bbox: exports.arrowBBox[name],
        remove: remove
      }];
    };
  };
  exports.CommonArrow = CommonArrow;
})(Notation$4);
getDefaultExportFromCjs(Notation$4);

var __extends$1i = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __createBinding$9 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$9 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$9 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$9(result, mod, k);
  __setModuleDefault$9(result, mod);
  return result;
});
var __read$r = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$d = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$s = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(menclose$2, "__esModule", {
  value: true
});
menclose$2.CommonMencloseMixin = void 0;
var Notation$3 = __importStar$9(Notation$4);
var string_js_1$6 = string;
function CommonMencloseMixin(Base) {
  return (function (_super) {
    __extends$1i(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$d([], __read$r(args), false)) || this;
      _this.notations = {};
      _this.renderChild = null;
      _this.msqrt = null;
      _this.padding = Notation$3.PADDING;
      _this.thickness = Notation$3.THICKNESS;
      _this.arrowhead = {
        x: Notation$3.ARROWX,
        y: Notation$3.ARROWY,
        dx: Notation$3.ARROWDX
      };
      _this.TRBL = [0, 0, 0, 0];
      _this.getParameters();
      _this.getNotations();
      _this.removeRedundantNotations();
      _this.initializeNotations();
      _this.TRBL = _this.getBBoxExtenders();
      return _this;
    }
    class_1.prototype.getParameters = function () {
      var attributes = this.node.attributes;
      var padding = attributes.get('data-padding');
      if (padding !== undefined) {
        this.padding = this.length2em(padding, Notation$3.PADDING);
      }
      var thickness = attributes.get('data-thickness');
      if (thickness !== undefined) {
        this.thickness = this.length2em(thickness, Notation$3.THICKNESS);
      }
      var arrowhead = attributes.get('data-arrowhead');
      if (arrowhead !== undefined) {
        var _b = __read$r((0, string_js_1$6.split)(arrowhead), 3), x = _b[0], y = _b[1], dx = _b[2];
        this.arrowhead = {
          x: x ? parseFloat(x) : Notation$3.ARROWX,
          y: y ? parseFloat(y) : Notation$3.ARROWY,
          dx: dx ? parseFloat(dx) : Notation$3.ARROWDX
        };
      }
    };
    class_1.prototype.getNotations = function () {
      var e_1, _b;
      var Notations = this.constructor.notations;
      try {
        for (var _c = __values$s((0, string_js_1$6.split)(this.node.attributes.get('notation'))), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_1 = _d.value;
          var notation = Notations.get(name_1);
          if (notation) {
            this.notations[name_1] = notation;
            if (notation.renderChild) {
              this.renderChild = notation.renderer;
            }
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    };
    class_1.prototype.removeRedundantNotations = function () {
      var e_2, _b, e_3, _c;
      try {
        for (var _d = __values$s(Object.keys(this.notations)), _e = _d.next(); !_e.done; _e = _d.next()) {
          var name_2 = _e.value;
          if (this.notations[name_2]) {
            var remove = this.notations[name_2].remove || '';
            try {
              for (var _f = (e_3 = void 0, __values$s(remove.split(/ /))), _g = _f.next(); !_g.done; _g = _f.next()) {
                var notation = _g.value;
                delete this.notations[notation];
              }
            } catch (e_3_1) {
              e_3 = {
                error: e_3_1
              };
            } finally {
              try {
                if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
              } finally {
                if (e_3) throw e_3.error;
              }
            }
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    };
    class_1.prototype.initializeNotations = function () {
      var e_4, _b;
      try {
        for (var _c = __values$s(Object.keys(this.notations)), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_3 = _d.value;
          var init = this.notations[name_3].init;
          init && init(this);
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
    };
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      var _b = __read$r(this.TRBL, 4), T = _b[0], R = _b[1], B = _b[2], L = _b[3];
      var child = this.childNodes[0].getBBox();
      bbox.combine(child, L, 0);
      bbox.h += T;
      bbox.d += B;
      bbox.w += R;
      this.setChildPWidths(recompute);
    };
    class_1.prototype.getBBoxExtenders = function () {
      var e_5, _b;
      var TRBL = [0, 0, 0, 0];
      try {
        for (var _c = __values$s(Object.keys(this.notations)), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_4 = _d.value;
          this.maximizeEntries(TRBL, this.notations[name_4].bbox(this));
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      return TRBL;
    };
    class_1.prototype.getPadding = function () {
      var e_6, _b;
      var _this = this;
      var BTRBL = [0, 0, 0, 0];
      try {
        for (var _c = __values$s(Object.keys(this.notations)), _d = _c.next(); !_d.done; _d = _c.next()) {
          var name_5 = _d.value;
          var border = this.notations[name_5].border;
          if (border) {
            this.maximizeEntries(BTRBL, border(this));
          }
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
      return [0, 1, 2, 3].map(function (i) {
        return _this.TRBL[i] - BTRBL[i];
      });
    };
    class_1.prototype.maximizeEntries = function (X, Y) {
      for (var i = 0; i < X.length; i++) {
        if (X[i] < Y[i]) {
          X[i] = Y[i];
        }
      }
    };
    class_1.prototype.getOffset = function (direction) {
      var _b = __read$r(this.TRBL, 4), T = _b[0], R = _b[1], B = _b[2], L = _b[3];
      var d = (direction === 'X' ? R - L : B - T) / 2;
      return Math.abs(d) > .001 ? d : 0;
    };
    class_1.prototype.getArgMod = function (w, h) {
      return [Math.atan2(h, w), Math.sqrt(w * w + h * h)];
    };
    class_1.prototype.arrow = function (_w, _a, _double, _offset, _dist) {
      return null;
    };
    class_1.prototype.arrowData = function () {
      var _b = __read$r([this.padding, this.thickness], 2), p = _b[0], t = _b[1];
      var r = t * (this.arrowhead.x + Math.max(1, this.arrowhead.dx));
      var _c = this.childNodes[0].getBBox(), h = _c.h, d = _c.d, w = _c.w;
      var H = h + d;
      var R = Math.sqrt(H * H + w * w);
      var x = Math.max(p, r * w / R);
      var y = Math.max(p, r * H / R);
      var _d = __read$r(this.getArgMod(w + 2 * x, H + 2 * y), 2), a = _d[0], W = _d[1];
      return {
        a: a,
        W: W,
        x: x,
        y: y
      };
    };
    class_1.prototype.arrowAW = function () {
      var _b = this.childNodes[0].getBBox(), h = _b.h, d = _b.d, w = _b.w;
      var _c = __read$r(this.TRBL, 4), T = _c[0], R = _c[1], B = _c[2], L = _c[3];
      return this.getArgMod(L + w + R, T + h + d + B);
    };
    class_1.prototype.createMsqrt = function (child) {
      var mmlFactory = this.node.factory;
      var mml = mmlFactory.create('msqrt');
      mml.inheritAttributesFrom(this.node);
      mml.childNodes[0] = child.node;
      var node = this.wrap(mml);
      node.parent = this;
      return node;
    };
    class_1.prototype.sqrtTRBL = function () {
      var bbox = this.msqrt.getBBox();
      var cbox = this.msqrt.childNodes[0].getBBox();
      return [bbox.h - cbox.h, 0, bbox.d - cbox.d, bbox.w - cbox.w];
    };
    return class_1;
  })(Base);
}
menclose$2.CommonMencloseMixin = CommonMencloseMixin;

var Notation$2 = {};

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = {
        enumerable: true,
        get: function () {
          return m[k];
        }
      };
    }
    Object.defineProperty(o, k2, desc);
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __setModuleDefault = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
    Object.defineProperty(o, "default", {
      enumerable: true,
      value: v
    });
  } : function (o, v) {
    o["default"] = v;
  });
  var __importStar = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.Arrow = exports.DiagonalArrow = exports.DiagonalStrike = exports.Border2 = exports.Border = exports.RenderElement = void 0;
  var Notation = __importStar(Notation$4);
  __exportStar(Notation$4, exports);
  var RenderElement = function (name, offset) {
    if (offset === void 0) {
      offset = '';
    }
    return function (node, _child) {
      var shape = node.adjustBorder(node.html('mjx-' + name));
      if (offset) {
        var d = node.getOffset(offset);
        if (node.thickness !== Notation.THICKNESS || d) {
          var transform = ("translate").concat(offset, "(").concat(node.em(node.thickness / 2 - d), ")");
          node.adaptor.setStyle(shape, 'transform', transform);
        }
      }
      node.adaptor.append(node.chtml, shape);
    };
  };
  exports.RenderElement = RenderElement;
  var Border = function (side) {
    return Notation.CommonBorder(function (node, child) {
      node.adaptor.setStyle(child, 'border-' + side, node.em(node.thickness) + ' solid');
    })(side);
  };
  exports.Border = Border;
  var Border2 = function (name, side1, side2) {
    return Notation.CommonBorder2(function (node, child) {
      var border = node.em(node.thickness) + ' solid';
      node.adaptor.setStyle(child, 'border-' + side1, border);
      node.adaptor.setStyle(child, 'border-' + side2, border);
    })(name, side1, side2);
  };
  exports.Border2 = Border2;
  var DiagonalStrike = function (name, neg) {
    return Notation.CommonDiagonalStrike(function (cname) {
      return function (node, _child) {
        var _a = node.getBBox(), w = _a.w, h = _a.h, d = _a.d;
        var _b = __read(node.getArgMod(w, h + d), 2), a = _b[0], W = _b[1];
        var t = neg * node.thickness / 2;
        var strike = node.adjustBorder(node.html(cname, {
          style: {
            width: node.em(W),
            transform: 'rotate(' + node.fixed(-neg * a) + 'rad) translateY(' + t + 'em)'
          }
        }));
        node.adaptor.append(node.chtml, strike);
      };
    })(name);
  };
  exports.DiagonalStrike = DiagonalStrike;
  var DiagonalArrow = function (name) {
    return Notation.CommonDiagonalArrow(function (node, arrow) {
      node.adaptor.append(node.chtml, arrow);
    })(name);
  };
  exports.DiagonalArrow = DiagonalArrow;
  var Arrow = function (name) {
    return Notation.CommonArrow(function (node, arrow) {
      node.adaptor.append(node.chtml, arrow);
    })(name);
  };
  exports.Arrow = Arrow;
})(Notation$2);
getDefaultExportFromCjs(Notation$2);

var menclose$1 = {};

var __extends$1h = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$r = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$r = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$r.apply(this, arguments);
});
Object.defineProperty(menclose$1, "__esModule", {
  value: true
});
menclose$1.MmlMenclose = void 0;
var MmlNode_js_1$y = MmlNode;
var MmlMenclose = (function (_super) {
  __extends$1h(MmlMenclose, _super);
  function MmlMenclose() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$y.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMenclose.prototype, "kind", {
    get: function () {
      return 'menclose';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMenclose.prototype, "arity", {
    get: function () {
      return -1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMenclose.prototype, "linebreakContininer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMenclose.prototype.setTeXclass = function (prev) {
    prev = this.childNodes[0].setTeXclass(prev);
    this.updateTeXclass(this.childNodes[0]);
    return prev;
  };
  MmlMenclose.defaults = __assign$r(__assign$r({}, MmlNode_js_1$y.AbstractMmlNode.defaults), {
    notation: 'longdiv'
  });
  return MmlMenclose;
})(MmlNode_js_1$y.AbstractMmlNode);
menclose$1.MmlMenclose = MmlMenclose;

var __extends$1g = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __createBinding$8 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$8 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$8 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$8(result, mod, k);
  __setModuleDefault$8(result, mod);
  return result;
});
var __values$r = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$q = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(menclose$3, "__esModule", {
  value: true
});
menclose$3.CHTMLmenclose = void 0;
var Wrapper_js_1$e = Wrapper$3;
var menclose_js_1$2 = menclose$2;
var Notation$1 = __importStar$8(Notation$2);
var menclose_js_2 = menclose$1;
var lengths_js_1$2 = lengths;
function Angle(x, y) {
  return Math.atan2(x, y).toFixed(3).replace(/\.?0+$/, '');
}
var ANGLE = Angle(Notation$1.ARROWDX, Notation$1.ARROWY);
var CHTMLmenclose = (function (_super) {
  __extends$1g(CHTMLmenclose, _super);
  function CHTMLmenclose() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmenclose.prototype.toCHTML = function (parent) {
    var e_1, _a, e_2, _b;
    var adaptor = this.adaptor;
    var chtml = this.standardCHTMLnode(parent);
    var block = adaptor.append(chtml, this.html('mjx-box'));
    if (this.renderChild) {
      this.renderChild(this, block);
    } else {
      this.childNodes[0].toCHTML(block);
    }
    try {
      for (var _c = __values$r(Object.keys(this.notations)), _d = _c.next(); !_d.done; _d = _c.next()) {
        var name_1 = _d.value;
        var notation = this.notations[name_1];
        !notation.renderChild && notation.renderer(this, block);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    var pbox = this.getPadding();
    try {
      for (var _e = __values$r(Notation$1.sideNames), _f = _e.next(); !_f.done; _f = _e.next()) {
        var name_2 = _f.value;
        var i = Notation$1.sideIndex[name_2];
        pbox[i] > 0 && adaptor.setStyle(block, 'padding-' + name_2, this.em(pbox[i]));
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  CHTMLmenclose.prototype.arrow = function (w, a, double, offset, dist) {
    if (offset === void 0) {
      offset = '';
    }
    if (dist === void 0) {
      dist = 0;
    }
    var W = this.getBBox().w;
    var style = {
      width: this.em(w)
    };
    if (W !== w) {
      style.left = this.em((W - w) / 2);
    }
    if (a) {
      style.transform = 'rotate(' + this.fixed(a) + 'rad)';
    }
    var arrow = this.html('mjx-arrow', {
      style: style
    }, [this.html('mjx-aline'), this.html('mjx-rthead'), this.html('mjx-rbhead')]);
    if (double) {
      this.adaptor.append(arrow, this.html('mjx-lthead'));
      this.adaptor.append(arrow, this.html('mjx-lbhead'));
      this.adaptor.setAttribute(arrow, 'double', 'true');
    }
    this.adjustArrow(arrow, double);
    this.moveArrow(arrow, offset, dist);
    return arrow;
  };
  CHTMLmenclose.prototype.adjustArrow = function (arrow, double) {
    var _this = this;
    var t = this.thickness;
    var head = this.arrowhead;
    if (head.x === Notation$1.ARROWX && head.y === Notation$1.ARROWY && head.dx === Notation$1.ARROWDX && t === Notation$1.THICKNESS) return;
    var _a = __read$q([t * head.x, t * head.y].map(function (x) {
      return _this.em(x);
    }), 2), x = _a[0], y = _a[1];
    var a = Angle(head.dx, head.y);
    var _b = __read$q(this.adaptor.childNodes(arrow), 5), line = _b[0], rthead = _b[1], rbhead = _b[2], lthead = _b[3], lbhead = _b[4];
    this.adjustHead(rthead, [y, '0', '1px', x], a);
    this.adjustHead(rbhead, ['1px', '0', y, x], '-' + a);
    this.adjustHead(lthead, [y, x, '1px', '0'], '-' + a);
    this.adjustHead(lbhead, ['1px', x, y, '0'], a);
    this.adjustLine(line, t, head.x, double);
  };
  CHTMLmenclose.prototype.adjustHead = function (head, border, a) {
    if (head) {
      this.adaptor.setStyle(head, 'border-width', border.join(' '));
      this.adaptor.setStyle(head, 'transform', 'skewX(' + a + 'rad)');
    }
  };
  CHTMLmenclose.prototype.adjustLine = function (line, t, x, double) {
    this.adaptor.setStyle(line, 'borderTop', this.em(t) + ' solid');
    this.adaptor.setStyle(line, 'top', this.em(-t / 2));
    this.adaptor.setStyle(line, 'right', this.em(t * (x - 1)));
    if (double) {
      this.adaptor.setStyle(line, 'left', this.em(t * (x - 1)));
    }
  };
  CHTMLmenclose.prototype.moveArrow = function (arrow, offset, d) {
    if (!d) return;
    var transform = this.adaptor.getStyle(arrow, 'transform');
    this.adaptor.setStyle(arrow, 'transform', ("translate").concat(offset, "(").concat(this.em(-d), ")").concat(transform ? ' ' + transform : ''));
  };
  CHTMLmenclose.prototype.adjustBorder = function (node) {
    if (this.thickness !== Notation$1.THICKNESS) {
      this.adaptor.setStyle(node, 'borderWidth', this.em(this.thickness));
    }
    return node;
  };
  CHTMLmenclose.prototype.adjustThickness = function (shape) {
    if (this.thickness !== Notation$1.THICKNESS) {
      this.adaptor.setStyle(shape, 'strokeWidth', this.fixed(this.thickness));
    }
    return shape;
  };
  CHTMLmenclose.prototype.fixed = function (m, n) {
    if (n === void 0) {
      n = 3;
    }
    if (Math.abs(m) < .0006) {
      return '0';
    }
    return m.toFixed(n).replace(/\.?0+$/, '');
  };
  CHTMLmenclose.prototype.em = function (m) {
    return _super.prototype.em.call(this, m);
  };
  CHTMLmenclose.kind = menclose_js_2.MmlMenclose.prototype.kind;
  CHTMLmenclose.styles = {
    'mjx-menclose': {
      position: 'relative'
    },
    'mjx-menclose > mjx-dstrike': {
      display: 'inline-block',
      left: 0,
      top: 0,
      position: 'absolute',
      'border-top': Notation$1.SOLID,
      'transform-origin': 'top left'
    },
    'mjx-menclose > mjx-ustrike': {
      display: 'inline-block',
      left: 0,
      bottom: 0,
      position: 'absolute',
      'border-top': Notation$1.SOLID,
      'transform-origin': 'bottom left'
    },
    'mjx-menclose > mjx-hstrike': {
      'border-top': Notation$1.SOLID,
      position: 'absolute',
      left: 0,
      right: 0,
      bottom: '50%',
      transform: 'translateY(' + (0, lengths_js_1$2.em)(Notation$1.THICKNESS / 2) + ')'
    },
    'mjx-menclose > mjx-vstrike': {
      'border-left': Notation$1.SOLID,
      position: 'absolute',
      top: 0,
      bottom: 0,
      right: '50%',
      transform: 'translateX(' + (0, lengths_js_1$2.em)(Notation$1.THICKNESS / 2) + ')'
    },
    'mjx-menclose > mjx-rbox': {
      position: 'absolute',
      top: 0,
      bottom: 0,
      right: 0,
      left: 0,
      'border': Notation$1.SOLID,
      'border-radius': (0, lengths_js_1$2.em)(Notation$1.THICKNESS + Notation$1.PADDING)
    },
    'mjx-menclose > mjx-cbox': {
      position: 'absolute',
      top: 0,
      bottom: 0,
      right: 0,
      left: 0,
      'border': Notation$1.SOLID,
      'border-radius': '50%'
    },
    'mjx-menclose > mjx-arrow': {
      position: 'absolute',
      left: 0,
      bottom: '50%',
      height: 0,
      width: 0
    },
    'mjx-menclose > mjx-arrow > *': {
      display: 'block',
      position: 'absolute',
      'transform-origin': 'bottom',
      'border-left': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWX) + ' solid',
      'border-right': 0,
      'box-sizing': 'border-box'
    },
    'mjx-menclose > mjx-arrow > mjx-aline': {
      left: 0,
      top: (0, lengths_js_1$2.em)(-Notation$1.THICKNESS / 2),
      right: (0, lengths_js_1$2.em)(Notation$1.THICKNESS * (Notation$1.ARROWX - 1)),
      height: 0,
      'border-top': (0, lengths_js_1$2.em)(Notation$1.THICKNESS) + ' solid',
      'border-left': 0
    },
    'mjx-menclose > mjx-arrow[double] > mjx-aline': {
      left: (0, lengths_js_1$2.em)(Notation$1.THICKNESS * (Notation$1.ARROWX - 1)),
      height: 0
    },
    'mjx-menclose > mjx-arrow > mjx-rthead': {
      transform: 'skewX(' + ANGLE + 'rad)',
      right: 0,
      bottom: '-1px',
      'border-bottom': '1px solid transparent',
      'border-top': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWY) + ' solid transparent'
    },
    'mjx-menclose > mjx-arrow > mjx-rbhead': {
      transform: 'skewX(-' + ANGLE + 'rad)',
      'transform-origin': 'top',
      right: 0,
      top: '-1px',
      'border-top': '1px solid transparent',
      'border-bottom': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWY) + ' solid transparent'
    },
    'mjx-menclose > mjx-arrow > mjx-lthead': {
      transform: 'skewX(-' + ANGLE + 'rad)',
      left: 0,
      bottom: '-1px',
      'border-left': 0,
      'border-right': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWX) + ' solid',
      'border-bottom': '1px solid transparent',
      'border-top': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWY) + ' solid transparent'
    },
    'mjx-menclose > mjx-arrow > mjx-lbhead': {
      transform: 'skewX(' + ANGLE + 'rad)',
      'transform-origin': 'top',
      left: 0,
      top: '-1px',
      'border-left': 0,
      'border-right': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWX) + ' solid',
      'border-top': '1px solid transparent',
      'border-bottom': (0, lengths_js_1$2.em)(Notation$1.THICKNESS * Notation$1.ARROWY) + ' solid transparent'
    },
    'mjx-menclose > dbox': {
      position: 'absolute',
      top: 0,
      bottom: 0,
      left: (0, lengths_js_1$2.em)(-1.5 * Notation$1.PADDING),
      width: (0, lengths_js_1$2.em)(3 * Notation$1.PADDING),
      border: (0, lengths_js_1$2.em)(Notation$1.THICKNESS) + ' solid',
      'border-radius': '50%',
      'clip-path': 'inset(0 0 0 ' + (0, lengths_js_1$2.em)(1.5 * Notation$1.PADDING) + ')',
      'box-sizing': 'border-box'
    }
  };
  CHTMLmenclose.notations = new Map([Notation$1.Border('top'), Notation$1.Border('right'), Notation$1.Border('bottom'), Notation$1.Border('left'), Notation$1.Border2('actuarial', 'top', 'right'), Notation$1.Border2('madruwb', 'bottom', 'right'), Notation$1.DiagonalStrike('up', 1), Notation$1.DiagonalStrike('down', -1), ['horizontalstrike', {
    renderer: Notation$1.RenderElement('hstrike', 'Y'),
    bbox: function (node) {
      return [0, node.padding, 0, node.padding];
    }
  }], ['verticalstrike', {
    renderer: Notation$1.RenderElement('vstrike', 'X'),
    bbox: function (node) {
      return [node.padding, 0, node.padding, 0];
    }
  }], ['box', {
    renderer: function (node, child) {
      node.adaptor.setStyle(child, 'border', node.em(node.thickness) + ' solid');
    },
    bbox: Notation$1.fullBBox,
    border: Notation$1.fullBorder,
    remove: 'left right top bottom'
  }], ['roundedbox', {
    renderer: Notation$1.RenderElement('rbox'),
    bbox: Notation$1.fullBBox
  }], ['circle', {
    renderer: Notation$1.RenderElement('cbox'),
    bbox: Notation$1.fullBBox
  }], ['phasorangle', {
    renderer: function (node, child) {
      var _a = node.getBBox(), h = _a.h, d = _a.d;
      var _b = __read$q(node.getArgMod(1.75 * node.padding, h + d), 2), a = _b[0], W = _b[1];
      var t = node.thickness * Math.sin(a) * .9;
      node.adaptor.setStyle(child, 'border-bottom', node.em(node.thickness) + ' solid');
      var strike = node.adjustBorder(node.html('mjx-ustrike', {
        style: {
          width: node.em(W),
          transform: 'translateX(' + node.em(t) + ') rotate(' + node.fixed(-a) + 'rad)'
        }
      }));
      node.adaptor.append(node.chtml, strike);
    },
    bbox: function (node) {
      var p = node.padding / 2;
      var t = node.thickness;
      return [2 * p, p, p + t, 3 * p + t];
    },
    border: function (node) {
      return [0, 0, node.thickness, 0];
    },
    remove: 'bottom'
  }], Notation$1.Arrow('up'), Notation$1.Arrow('down'), Notation$1.Arrow('left'), Notation$1.Arrow('right'), Notation$1.Arrow('updown'), Notation$1.Arrow('leftright'), Notation$1.DiagonalArrow('updiagonal'), Notation$1.DiagonalArrow('northeast'), Notation$1.DiagonalArrow('southeast'), Notation$1.DiagonalArrow('northwest'), Notation$1.DiagonalArrow('southwest'), Notation$1.DiagonalArrow('northeastsouthwest'), Notation$1.DiagonalArrow('northwestsoutheast'), ['longdiv', {
    renderer: function (node, child) {
      var adaptor = node.adaptor;
      adaptor.setStyle(child, 'border-top', node.em(node.thickness) + ' solid');
      var arc = adaptor.append(node.chtml, node.html('dbox'));
      var t = node.thickness;
      var p = node.padding;
      if (t !== Notation$1.THICKNESS) {
        adaptor.setStyle(arc, 'border-width', node.em(t));
      }
      if (p !== Notation$1.PADDING) {
        adaptor.setStyle(arc, 'left', node.em(-1.5 * p));
        adaptor.setStyle(arc, 'width', node.em(3 * p));
        adaptor.setStyle(arc, 'clip-path', 'inset(0 0 0 ' + node.em(1.5 * p) + ')');
      }
    },
    bbox: function (node) {
      var p = node.padding;
      var t = node.thickness;
      return [p + t, p, p, 2 * p + t / 2];
    }
  }], ['radical', {
    renderer: function (node, child) {
      node.msqrt.toCHTML(child);
      var TRBL = node.sqrtTRBL();
      node.adaptor.setStyle(node.msqrt.chtml, 'margin', TRBL.map(function (x) {
        return node.em(-x);
      }).join(' '));
    },
    init: function (node) {
      node.msqrt = node.createMsqrt(node.childNodes[0]);
    },
    bbox: function (node) {
      return node.sqrtTRBL();
    },
    renderChild: true
  }]]);
  return CHTMLmenclose;
})((0, menclose_js_1$2.CommonMencloseMixin)(Wrapper_js_1$e.CHTMLWrapper));
menclose$3.CHTMLmenclose = CHTMLmenclose;

var mrow$2 = {};

var mrow$1 = {};

var __extends$1f = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$p = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$c = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$q = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mrow$1, "__esModule", {
  value: true
});
mrow$1.CommonInferredMrowMixin = mrow$1.CommonMrowMixin = void 0;
var BBox_js_1$2 = BBox$1;
function CommonMrowMixin(Base) {
  return (function (_super) {
    __extends$1f(class_1, _super);
    function class_1() {
      var e_1, _a;
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$c([], __read$p(args), false)) || this;
      _this.stretchChildren();
      try {
        for (var _b = __values$q(_this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child.bbox.pwidth) {
            _this.bbox.pwidth = BBox_js_1$2.BBox.fullWidth;
            break;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return _this;
    }
    Object.defineProperty(class_1.prototype, "fixesPWidth", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.stretchChildren = function () {
      var e_2, _a, e_3, _b, e_4, _c;
      var stretchy = [];
      try {
        for (var _d = __values$q(this.childNodes), _e = _d.next(); !_e.done; _e = _d.next()) {
          var child = _e.value;
          if (child.canStretch(1)) {
            stretchy.push(child);
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      var count = stretchy.length;
      var nodeCount = this.childNodes.length;
      if (count && nodeCount > 1) {
        var H = 0, D = 0;
        var all = count > 1 && count === nodeCount;
        try {
          for (var _f = __values$q(this.childNodes), _g = _f.next(); !_g.done; _g = _f.next()) {
            var child = _g.value;
            var noStretch = child.stretch.dir === 0;
            if (all || noStretch) {
              var _h = child.getOuterBBox(noStretch), h = _h.h, d = _h.d, rscale = _h.rscale;
              h *= rscale;
              d *= rscale;
              if (h > H) H = h;
              if (d > D) D = d;
            }
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
        try {
          for (var stretchy_1 = __values$q(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
            var child = stretchy_1_1.value;
            child.coreMO().getStretchedVariant([H, D]);
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (stretchy_1_1 && !stretchy_1_1.done && (_c = stretchy_1.return)) _c.call(stretchy_1);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
      }
    };
    return class_1;
  })(Base);
}
mrow$1.CommonMrowMixin = CommonMrowMixin;
function CommonInferredMrowMixin(Base) {
  return (function (_super) {
    __extends$1f(class_2, _super);
    function class_2() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_2.prototype.getScale = function () {
      this.bbox.scale = this.parent.bbox.scale;
      this.bbox.rscale = 1;
    };
    return class_2;
  })(Base);
}
mrow$1.CommonInferredMrowMixin = CommonInferredMrowMixin;

var mrow = {};

var __extends$1e = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$q = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$q = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$q.apply(this, arguments);
});
var __values$p = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mrow, "__esModule", {
  value: true
});
mrow.MmlInferredMrow = mrow.MmlMrow = void 0;
var MmlNode_js_1$x = MmlNode;
var MmlMrow = (function (_super) {
  __extends$1e(MmlMrow, _super);
  function MmlMrow() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._core = null;
    return _this;
  }
  Object.defineProperty(MmlMrow.prototype, "kind", {
    get: function () {
      return 'mrow';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMrow.prototype, "isSpacelike", {
    get: function () {
      var e_1, _a;
      try {
        for (var _b = __values$p(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (!child.isSpacelike) {
            return false;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMrow.prototype, "isEmbellished", {
    get: function () {
      var e_2, _a;
      var embellished = false;
      var i = 0;
      try {
        for (var _b = __values$p(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          if (child) {
            if (child.isEmbellished) {
              if (embellished) {
                return false;
              }
              embellished = true;
              this._core = i;
            } else if (!child.isSpacelike) {
              return false;
            }
          }
          i++;
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      return embellished;
    },
    enumerable: false,
    configurable: true
  });
  MmlMrow.prototype.core = function () {
    if (!this.isEmbellished || this._core == null) {
      return this;
    }
    return this.childNodes[this._core];
  };
  MmlMrow.prototype.coreMO = function () {
    if (!this.isEmbellished || this._core == null) {
      return this;
    }
    return this.childNodes[this._core].coreMO();
  };
  MmlMrow.prototype.nonSpaceLength = function () {
    var e_3, _a;
    var n = 0;
    try {
      for (var _b = __values$p(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (child && !child.isSpacelike) {
          n++;
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    return n;
  };
  MmlMrow.prototype.firstNonSpace = function () {
    var e_4, _a;
    try {
      for (var _b = __values$p(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (child && !child.isSpacelike) {
          return child;
        }
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    return null;
  };
  MmlMrow.prototype.lastNonSpace = function () {
    var i = this.childNodes.length;
    while (--i >= 0) {
      var child = this.childNodes[i];
      if (child && !child.isSpacelike) {
        return child;
      }
    }
    return null;
  };
  MmlMrow.prototype.setTeXclass = function (prev) {
    var e_5, _a, e_6, _b;
    if (this.getProperty('open') != null || this.getProperty('close') != null) {
      this.getPrevClass(prev);
      prev = null;
      try {
        for (var _c = __values$p(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
          var child = _d.value;
          prev = child.setTeXclass(prev);
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      if (this.texClass == null) {
        this.texClass = MmlNode_js_1$x.TEXCLASS.INNER;
      }
    } else {
      try {
        for (var _e = __values$p(this.childNodes), _f = _e.next(); !_f.done; _f = _e.next()) {
          var child = _f.value;
          prev = child.setTeXclass(prev);
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
      if (this.childNodes[0]) {
        this.updateTeXclass(this.childNodes[0]);
      }
    }
    return prev;
  };
  MmlMrow.defaults = __assign$q({}, MmlNode_js_1$x.AbstractMmlNode.defaults);
  return MmlMrow;
})(MmlNode_js_1$x.AbstractMmlNode);
mrow.MmlMrow = MmlMrow;
var MmlInferredMrow = (function (_super) {
  __extends$1e(MmlInferredMrow, _super);
  function MmlInferredMrow() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlInferredMrow.prototype, "kind", {
    get: function () {
      return 'inferredMrow';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlInferredMrow.prototype, "isInferred", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlInferredMrow.prototype, "notParent", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlInferredMrow.prototype.toString = function () {
    return '[' + this.childNodes.join(',') + ']';
  };
  MmlInferredMrow.defaults = MmlMrow.defaults;
  return MmlInferredMrow;
})(MmlMrow);
mrow.MmlInferredMrow = MmlInferredMrow;

var __extends$1d = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$o = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mrow$2, "__esModule", {
  value: true
});
mrow$2.CHTMLinferredMrow = mrow$2.CHTMLmrow = void 0;
var Wrapper_js_1$d = Wrapper$3;
var mrow_js_1$2 = mrow$1;
var mrow_js_2 = mrow$1;
var mrow_js_3 = mrow;
var CHTMLmrow = (function (_super) {
  __extends$1d(CHTMLmrow, _super);
  function CHTMLmrow() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmrow.prototype.toCHTML = function (parent) {
    var e_1, _a;
    var chtml = this.node.isInferred ? this.chtml = parent : this.standardCHTMLnode(parent);
    var hasNegative = false;
    try {
      for (var _b = __values$o(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        child.toCHTML(chtml);
        if (child.bbox.w < 0) {
          hasNegative = true;
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    if (hasNegative) {
      var w = this.getBBox().w;
      if (w) {
        this.adaptor.setStyle(chtml, 'width', this.em(Math.max(0, w)));
        if (w < 0) {
          this.adaptor.setStyle(chtml, 'marginRight', this.em(w));
        }
      }
    }
  };
  CHTMLmrow.kind = mrow_js_3.MmlMrow.prototype.kind;
  return CHTMLmrow;
})((0, mrow_js_1$2.CommonMrowMixin)(Wrapper_js_1$d.CHTMLWrapper));
mrow$2.CHTMLmrow = CHTMLmrow;
var CHTMLinferredMrow = (function (_super) {
  __extends$1d(CHTMLinferredMrow, _super);
  function CHTMLinferredMrow() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLinferredMrow.kind = mrow_js_3.MmlInferredMrow.prototype.kind;
  return CHTMLinferredMrow;
})((0, mrow_js_2.CommonInferredMrowMixin)(CHTMLmrow));
mrow$2.CHTMLinferredMrow = CHTMLinferredMrow;

var mfenced$3 = {};

var mfenced$2 = {};

var __extends$1c = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$o = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$b = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$n = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mfenced$2, "__esModule", {
  value: true
});
mfenced$2.CommonMfencedMixin = void 0;
function CommonMfencedMixin(Base) {
  return (function (_super) {
    __extends$1c(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$b([], __read$o(args), false)) || this;
      _this.mrow = null;
      _this.createMrow();
      _this.addMrowChildren();
      return _this;
    }
    class_1.prototype.createMrow = function () {
      var mmlFactory = this.node.factory;
      var mrow = mmlFactory.create('inferredMrow');
      mrow.inheritAttributesFrom(this.node);
      this.mrow = this.wrap(mrow);
      this.mrow.parent = this;
    };
    class_1.prototype.addMrowChildren = function () {
      var e_1, _a;
      var mfenced = this.node;
      var mrow = this.mrow;
      this.addMo(mfenced.open);
      if (this.childNodes.length) {
        mrow.childNodes.push(this.childNodes[0]);
      }
      var i = 0;
      try {
        for (var _b = __values$n(this.childNodes.slice(1)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          this.addMo(mfenced.separators[i++]);
          mrow.childNodes.push(child);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      this.addMo(mfenced.close);
      mrow.stretchChildren();
    };
    class_1.prototype.addMo = function (node) {
      if (!node) return;
      var mo = this.wrap(node);
      this.mrow.childNodes.push(mo);
      mo.parent = this.mrow;
    };
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      bbox.updateFrom(this.mrow.getOuterBBox());
      this.setChildPWidths(recompute);
    };
    return class_1;
  })(Base);
}
mfenced$2.CommonMfencedMixin = CommonMfencedMixin;

var mfenced$1 = {};

var __extends$1b = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$p = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$p = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$p.apply(this, arguments);
});
var __values$m = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mfenced$1, "__esModule", {
  value: true
});
mfenced$1.MmlMfenced = void 0;
var MmlNode_js_1$w = MmlNode;
var MmlMfenced = (function (_super) {
  __extends$1b(MmlMfenced, _super);
  function MmlMfenced() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$w.TEXCLASS.INNER;
    _this.separators = [];
    _this.open = null;
    _this.close = null;
    return _this;
  }
  Object.defineProperty(MmlMfenced.prototype, "kind", {
    get: function () {
      return 'mfenced';
    },
    enumerable: false,
    configurable: true
  });
  MmlMfenced.prototype.setTeXclass = function (prev) {
    this.getPrevClass(prev);
    if (this.open) {
      prev = this.open.setTeXclass(prev);
    }
    if (this.childNodes[0]) {
      prev = this.childNodes[0].setTeXclass(prev);
    }
    for (var i = 1, m = this.childNodes.length; i < m; i++) {
      if (this.separators[i - 1]) {
        prev = this.separators[i - 1].setTeXclass(prev);
      }
      if (this.childNodes[i]) {
        prev = this.childNodes[i].setTeXclass(prev);
      }
    }
    if (this.close) {
      prev = this.close.setTeXclass(prev);
    }
    this.updateTeXclass(this.open);
    return prev;
  };
  MmlMfenced.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    var e_1, _a;
    this.addFakeNodes();
    try {
      for (var _b = __values$m([this.open, this.close].concat(this.separators)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (child) {
          child.setInheritedAttributes(attributes, display, level, prime);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    _super.prototype.setChildInheritedAttributes.call(this, attributes, display, level, prime);
  };
  MmlMfenced.prototype.addFakeNodes = function () {
    var e_2, _a;
    var _b = this.attributes.getList('open', 'close', 'separators'), open = _b.open, close = _b.close, separators = _b.separators;
    open = open.replace(/[ \t\n\r]/g, '');
    close = close.replace(/[ \t\n\r]/g, '');
    separators = separators.replace(/[ \t\n\r]/g, '');
    if (open) {
      this.open = this.fakeNode(open, {
        fence: true,
        form: 'prefix'
      }, MmlNode_js_1$w.TEXCLASS.OPEN);
    }
    if (separators) {
      while (separators.length < this.childNodes.length - 1) {
        separators += separators.charAt(separators.length - 1);
      }
      var i = 0;
      try {
        for (var _c = __values$m(this.childNodes.slice(1)), _d = _c.next(); !_d.done; _d = _c.next()) {
          var child = _d.value;
          if (child) {
            this.separators.push(this.fakeNode(separators.charAt(i++)));
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }
    if (close) {
      this.close = this.fakeNode(close, {
        fence: true,
        form: 'postfix'
      }, MmlNode_js_1$w.TEXCLASS.CLOSE);
    }
  };
  MmlMfenced.prototype.fakeNode = function (c, properties, texClass) {
    if (properties === void 0) {
      properties = {};
    }
    if (texClass === void 0) {
      texClass = null;
    }
    var text = this.factory.create('text').setText(c);
    var node = this.factory.create('mo', properties, [text]);
    node.texClass = texClass;
    node.parent = this;
    return node;
  };
  MmlMfenced.defaults = __assign$p(__assign$p({}, MmlNode_js_1$w.AbstractMmlNode.defaults), {
    open: '(',
    close: ')',
    separators: ','
  });
  return MmlMfenced;
})(MmlNode_js_1$w.AbstractMmlNode);
mfenced$1.MmlMfenced = MmlMfenced;

var __extends$1a = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mfenced$3, "__esModule", {
  value: true
});
mfenced$3.CHTMLmfenced = void 0;
var Wrapper_js_1$c = Wrapper$3;
var mfenced_js_1$2 = mfenced$2;
var mfenced_js_2 = mfenced$1;
var CHTMLmfenced = (function (_super) {
  __extends$1a(CHTMLmfenced, _super);
  function CHTMLmfenced() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmfenced.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    this.mrow.toCHTML(chtml);
  };
  CHTMLmfenced.kind = mfenced_js_2.MmlMfenced.prototype.kind;
  return CHTMLmfenced;
})((0, mfenced_js_1$2.CommonMfencedMixin)(Wrapper_js_1$c.CHTMLWrapper));
mfenced$3.CHTMLmfenced = CHTMLmfenced;

var mfrac$3 = {};

var mfrac$2 = {};

var __extends$19 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$n = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$a = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(mfrac$2, "__esModule", {
  value: true
});
mfrac$2.CommonMfracMixin = void 0;
function CommonMfracMixin(Base) {
  return (function (_super) {
    __extends$19(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$a([], __read$n(args), false)) || this;
      _this.bevel = null;
      _this.pad = _this.node.getProperty('withDelims') ? 0 : _this.font.params.nulldelimiterspace;
      if (_this.node.attributes.get('bevelled')) {
        var H = _this.getBevelData(_this.isDisplay()).H;
        var bevel = _this.bevel = _this.createMo('/');
        bevel.node.attributes.set('symmetric', true);
        bevel.canStretch(1);
        bevel.getStretchedVariant([H], true);
      }
      return _this;
    }
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      bbox.empty();
      var _a = this.node.attributes.getList('linethickness', 'bevelled'), linethickness = _a.linethickness, bevelled = _a.bevelled;
      var display = this.isDisplay();
      var w = null;
      if (bevelled) {
        this.getBevelledBBox(bbox, display);
      } else {
        var thickness = this.length2em(String(linethickness), .06);
        w = -2 * this.pad;
        if (thickness === 0) {
          this.getAtopBBox(bbox, display);
        } else {
          this.getFractionBBox(bbox, display, thickness);
          w -= .2;
        }
        w += bbox.w;
      }
      bbox.clean();
      this.setChildPWidths(recompute, w);
    };
    class_1.prototype.getFractionBBox = function (bbox, display, t) {
      var nbox = this.childNodes[0].getOuterBBox();
      var dbox = this.childNodes[1].getOuterBBox();
      var tex = this.font.params;
      var a = tex.axis_height;
      var _a = this.getTUV(display, t), T = _a.T, u = _a.u, v = _a.v;
      bbox.combine(nbox, 0, a + T + Math.max(nbox.d * nbox.rscale, u));
      bbox.combine(dbox, 0, a - T - Math.max(dbox.h * dbox.rscale, v));
      bbox.w += 2 * this.pad + .2;
    };
    class_1.prototype.getTUV = function (display, t) {
      var tex = this.font.params;
      var a = tex.axis_height;
      var T = (display ? 3.5 : 1.5) * t;
      return {
        T: (display ? 3.5 : 1.5) * t,
        u: (display ? tex.num1 : tex.num2) - a - T,
        v: (display ? tex.denom1 : tex.denom2) + a - T
      };
    };
    class_1.prototype.getAtopBBox = function (bbox, display) {
      var _a = this.getUVQ(display), u = _a.u, v = _a.v, nbox = _a.nbox, dbox = _a.dbox;
      bbox.combine(nbox, 0, u);
      bbox.combine(dbox, 0, -v);
      bbox.w += 2 * this.pad;
    };
    class_1.prototype.getUVQ = function (display) {
      var nbox = this.childNodes[0].getOuterBBox();
      var dbox = this.childNodes[1].getOuterBBox();
      var tex = this.font.params;
      var _a = __read$n(display ? [tex.num1, tex.denom1] : [tex.num3, tex.denom2], 2), u = _a[0], v = _a[1];
      var p = (display ? 7 : 3) * tex.rule_thickness;
      var q = u - nbox.d * nbox.scale - (dbox.h * dbox.scale - v);
      if (q < p) {
        u += (p - q) / 2;
        v += (p - q) / 2;
        q = p;
      }
      return {
        u: u,
        v: v,
        q: q,
        nbox: nbox,
        dbox: dbox
      };
    };
    class_1.prototype.getBevelledBBox = function (bbox, display) {
      var _a = this.getBevelData(display), u = _a.u, v = _a.v, delta = _a.delta, nbox = _a.nbox, dbox = _a.dbox;
      var lbox = this.bevel.getOuterBBox();
      bbox.combine(nbox, 0, u);
      bbox.combine(lbox, bbox.w - delta / 2, 0);
      bbox.combine(dbox, bbox.w - delta / 2, v);
    };
    class_1.prototype.getBevelData = function (display) {
      var nbox = this.childNodes[0].getOuterBBox();
      var dbox = this.childNodes[1].getOuterBBox();
      var delta = display ? .4 : .15;
      var H = Math.max(nbox.scale * (nbox.h + nbox.d), dbox.scale * (dbox.h + dbox.d)) + 2 * delta;
      var a = this.font.params.axis_height;
      var u = nbox.scale * (nbox.d - nbox.h) / 2 + a + delta;
      var v = dbox.scale * (dbox.d - dbox.h) / 2 + a - delta;
      return {
        H: H,
        delta: delta,
        u: u,
        v: v,
        nbox: nbox,
        dbox: dbox
      };
    };
    class_1.prototype.canStretch = function (_direction) {
      return false;
    };
    class_1.prototype.isDisplay = function () {
      var _a = this.node.attributes.getList('displaystyle', 'scriptlevel'), displaystyle = _a.displaystyle, scriptlevel = _a.scriptlevel;
      return displaystyle && scriptlevel === 0;
    };
    class_1.prototype.getWrapWidth = function (i) {
      var attributes = this.node.attributes;
      if (attributes.get('bevelled')) {
        return this.childNodes[i].getOuterBBox().w;
      }
      var w = this.getBBox().w;
      var thickness = this.length2em(attributes.get('linethickness'));
      return w - (thickness ? .2 : 0) - 2 * this.pad;
    };
    class_1.prototype.getChildAlign = function (i) {
      var attributes = this.node.attributes;
      return attributes.get('bevelled') ? 'left' : attributes.get(['numalign', 'denomalign'][i]);
    };
    return class_1;
  })(Base);
}
mfrac$2.CommonMfracMixin = CommonMfracMixin;

var mfrac$1 = {};

var __extends$18 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$o = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$o = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$o.apply(this, arguments);
});
var __values$l = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mfrac$1, "__esModule", {
  value: true
});
mfrac$1.MmlMfrac = void 0;
var MmlNode_js_1$v = MmlNode;
var MmlMfrac = (function (_super) {
  __extends$18(MmlMfrac, _super);
  function MmlMfrac() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMfrac.prototype, "kind", {
    get: function () {
      return 'mfrac';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMfrac.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMfrac.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMfrac.prototype.setTeXclass = function (prev) {
    var e_1, _a;
    this.getPrevClass(prev);
    try {
      for (var _b = __values$l(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        child.setTeXclass(null);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return this;
  };
  MmlMfrac.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    if (!display || level > 0) {
      level++;
    }
    this.childNodes[0].setInheritedAttributes(attributes, false, level, prime);
    this.childNodes[1].setInheritedAttributes(attributes, false, level, true);
  };
  MmlMfrac.defaults = __assign$o(__assign$o({}, MmlNode_js_1$v.AbstractMmlBaseNode.defaults), {
    linethickness: 'medium',
    numalign: 'center',
    denomalign: 'center',
    bevelled: false
  });
  return MmlMfrac;
})(MmlNode_js_1$v.AbstractMmlBaseNode);
mfrac$1.MmlMfrac = MmlMfrac;

var __extends$17 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$n = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$n = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$n.apply(this, arguments);
});
Object.defineProperty(mfrac$3, "__esModule", {
  value: true
});
mfrac$3.CHTMLmfrac = void 0;
var Wrapper_js_1$b = Wrapper$3;
var mfrac_js_1$2 = mfrac$2;
var mfrac_js_2 = mfrac$1;
var CHTMLmfrac = (function (_super) {
  __extends$17(CHTMLmfrac, _super);
  function CHTMLmfrac() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmfrac.prototype.toCHTML = function (parent) {
    this.standardCHTMLnode(parent);
    var _a = this.node.attributes.getList('linethickness', 'bevelled'), linethickness = _a.linethickness, bevelled = _a.bevelled;
    var display = this.isDisplay();
    if (bevelled) {
      this.makeBevelled(display);
    } else {
      var thickness = this.length2em(String(linethickness), .06);
      if (thickness === 0) {
        this.makeAtop(display);
      } else {
        this.makeFraction(display, thickness);
      }
    }
  };
  CHTMLmfrac.prototype.makeFraction = function (display, t) {
    var _a = this.node.attributes.getList('numalign', 'denomalign'), numalign = _a.numalign, denomalign = _a.denomalign;
    var withDelims = this.node.getProperty('withDelims');
    var attr = display ? {
      type: 'd'
    } : {};
    var fattr = withDelims ? __assign$n(__assign$n({}, attr), {
      delims: 'true'
    }) : __assign$n({}, attr);
    var nattr = numalign !== 'center' ? {
      align: numalign
    } : {};
    var dattr = denomalign !== 'center' ? {
      align: denomalign
    } : {};
    var dsattr = __assign$n({}, attr), nsattr = __assign$n({}, attr);
    var tex = this.font.params;
    if (t !== .06) {
      var a = tex.axis_height;
      var tEm = this.em(t);
      var _b = this.getTUV(display, t), T = _b.T, u = _b.u, v = _b.v;
      var m = (display ? this.em(3 * t) : tEm) + ' -.1em';
      attr.style = {
        height: tEm,
        'border-top': tEm + ' solid',
        margin: m
      };
      var nh = this.em(Math.max(0, u));
      nsattr.style = {
        height: nh,
        'vertical-align': '-' + nh
      };
      dsattr.style = {
        height: this.em(Math.max(0, v))
      };
      fattr.style = {
        'vertical-align': this.em(a - T)
      };
    }
    var num, den;
    this.adaptor.append(this.chtml, this.html('mjx-frac', fattr, [num = this.html('mjx-num', nattr, [this.html('mjx-nstrut', nsattr)]), this.html('mjx-dbox', {}, [this.html('mjx-dtable', {}, [this.html('mjx-line', attr), this.html('mjx-row', {}, [den = this.html('mjx-den', dattr, [this.html('mjx-dstrut', dsattr)])])])])]));
    this.childNodes[0].toCHTML(num);
    this.childNodes[1].toCHTML(den);
  };
  CHTMLmfrac.prototype.makeAtop = function (display) {
    var _a = this.node.attributes.getList('numalign', 'denomalign'), numalign = _a.numalign, denomalign = _a.denomalign;
    var withDelims = this.node.getProperty('withDelims');
    var attr = display ? {
      type: 'd',
      atop: true
    } : {
      atop: true
    };
    var fattr = withDelims ? __assign$n(__assign$n({}, attr), {
      delims: true
    }) : __assign$n({}, attr);
    var nattr = numalign !== 'center' ? {
      align: numalign
    } : {};
    var dattr = denomalign !== 'center' ? {
      align: denomalign
    } : {};
    var _b = this.getUVQ(display), v = _b.v, q = _b.q;
    nattr.style = {
      'padding-bottom': this.em(q)
    };
    fattr.style = {
      'vertical-align': this.em(-v)
    };
    var num, den;
    this.adaptor.append(this.chtml, this.html('mjx-frac', fattr, [num = this.html('mjx-num', nattr), den = this.html('mjx-den', dattr)]));
    this.childNodes[0].toCHTML(num);
    this.childNodes[1].toCHTML(den);
  };
  CHTMLmfrac.prototype.makeBevelled = function (display) {
    var adaptor = this.adaptor;
    adaptor.setAttribute(this.chtml, 'bevelled', 'ture');
    var num = adaptor.append(this.chtml, this.html('mjx-num'));
    this.childNodes[0].toCHTML(num);
    this.bevel.toCHTML(this.chtml);
    var den = adaptor.append(this.chtml, this.html('mjx-den'));
    this.childNodes[1].toCHTML(den);
    var _a = this.getBevelData(display), u = _a.u, v = _a.v, delta = _a.delta, nbox = _a.nbox, dbox = _a.dbox;
    if (u) {
      adaptor.setStyle(num, 'verticalAlign', this.em(u / nbox.scale));
    }
    if (v) {
      adaptor.setStyle(den, 'verticalAlign', this.em(v / dbox.scale));
    }
    var dx = this.em(-delta / 2);
    adaptor.setStyle(this.bevel.chtml, 'marginLeft', dx);
    adaptor.setStyle(this.bevel.chtml, 'marginRight', dx);
  };
  CHTMLmfrac.kind = mfrac_js_2.MmlMfrac.prototype.kind;
  CHTMLmfrac.styles = {
    'mjx-frac': {
      display: 'inline-block',
      'vertical-align': '0.17em',
      padding: '0 .22em'
    },
    'mjx-frac[type="d"]': {
      'vertical-align': '.04em'
    },
    'mjx-frac[delims]': {
      padding: '0 .1em'
    },
    'mjx-frac[atop]': {
      padding: '0 .12em'
    },
    'mjx-frac[atop][delims]': {
      padding: '0'
    },
    'mjx-dtable': {
      display: 'inline-table',
      width: '100%'
    },
    'mjx-dtable > *': {
      'font-size': '2000%'
    },
    'mjx-dbox': {
      display: 'block',
      'font-size': '5%'
    },
    'mjx-num': {
      display: 'block',
      'text-align': 'center'
    },
    'mjx-den': {
      display: 'block',
      'text-align': 'center'
    },
    'mjx-mfrac[bevelled] > mjx-num': {
      display: 'inline-block'
    },
    'mjx-mfrac[bevelled] > mjx-den': {
      display: 'inline-block'
    },
    'mjx-den[align="right"], mjx-num[align="right"]': {
      'text-align': 'right'
    },
    'mjx-den[align="left"], mjx-num[align="left"]': {
      'text-align': 'left'
    },
    'mjx-nstrut': {
      display: 'inline-block',
      height: '.054em',
      width: 0,
      'vertical-align': '-.054em'
    },
    'mjx-nstrut[type="d"]': {
      height: '.217em',
      'vertical-align': '-.217em'
    },
    'mjx-dstrut': {
      display: 'inline-block',
      height: '.505em',
      width: 0
    },
    'mjx-dstrut[type="d"]': {
      height: '.726em'
    },
    'mjx-line': {
      display: 'block',
      'box-sizing': 'border-box',
      'min-height': '1px',
      height: '.06em',
      'border-top': '.06em solid',
      margin: '.06em -.1em',
      overflow: 'hidden'
    },
    'mjx-line[type="d"]': {
      margin: '.18em -.1em'
    }
  };
  return CHTMLmfrac;
})((0, mfrac_js_1$2.CommonMfracMixin)(Wrapper_js_1$b.CHTMLWrapper));
mfrac$3.CHTMLmfrac = CHTMLmfrac;

var msqrt$3 = {};

var msqrt$2 = {};

var __extends$16 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$m = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$9 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(msqrt$2, "__esModule", {
  value: true
});
msqrt$2.CommonMsqrtMixin = void 0;
var BBox_js_1$1 = BBox$1;
function CommonMsqrtMixin(Base) {
  return (function (_super) {
    __extends$16(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$9([], __read$m(args), false)) || this;
      var surd = _this.createMo('\u221A');
      surd.canStretch(1);
      var _a = _this.childNodes[_this.base].getOuterBBox(), h = _a.h, d = _a.d;
      var t = _this.font.params.rule_thickness;
      var p = _this.node.attributes.get('displaystyle') ? _this.font.params.x_height : t;
      _this.surdH = h + d + 2 * t + p / 4;
      surd.getStretchedVariant([_this.surdH - d, d], true);
      return _this;
    }
    Object.defineProperty(class_1.prototype, "base", {
      get: function () {
        return 0;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "surd", {
      get: function () {
        return 1;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "root", {
      get: function () {
        return null;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.createMo = function (text) {
      var node = _super.prototype.createMo.call(this, text);
      this.childNodes.push(node);
      return node;
    };
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      var surdbox = this.childNodes[this.surd].getBBox();
      var basebox = new BBox_js_1$1.BBox(this.childNodes[this.base].getOuterBBox());
      var q = this.getPQ(surdbox)[1];
      var t = this.font.params.rule_thickness;
      var H = basebox.h + q + t;
      var _a = __read$m(this.getRootDimens(surdbox, H), 1), x = _a[0];
      bbox.h = H + t;
      this.combineRootBBox(bbox, surdbox, H);
      bbox.combine(surdbox, x, H - surdbox.h);
      bbox.combine(basebox, x + surdbox.w, 0);
      bbox.clean();
      this.setChildPWidths(recompute);
    };
    class_1.prototype.combineRootBBox = function (_bbox, _sbox, _H) {};
    class_1.prototype.getPQ = function (sbox) {
      var t = this.font.params.rule_thickness;
      var p = this.node.attributes.get('displaystyle') ? this.font.params.x_height : t;
      var q = sbox.h + sbox.d > this.surdH ? (sbox.h + sbox.d - (this.surdH - 2 * t - p / 2)) / 2 : t + p / 4;
      return [p, q];
    };
    class_1.prototype.getRootDimens = function (_sbox, _H) {
      return [0, 0, 0, 0];
    };
    return class_1;
  })(Base);
}
msqrt$2.CommonMsqrtMixin = CommonMsqrtMixin;

var msqrt$1 = {};

var __extends$15 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$m = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$m = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$m.apply(this, arguments);
});
Object.defineProperty(msqrt$1, "__esModule", {
  value: true
});
msqrt$1.MmlMsqrt = void 0;
var MmlNode_js_1$u = MmlNode;
var MmlMsqrt = (function (_super) {
  __extends$15(MmlMsqrt, _super);
  function MmlMsqrt() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$u.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMsqrt.prototype, "kind", {
    get: function () {
      return 'msqrt';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsqrt.prototype, "arity", {
    get: function () {
      return -1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsqrt.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMsqrt.prototype.setTeXclass = function (prev) {
    this.getPrevClass(prev);
    this.childNodes[0].setTeXclass(null);
    return this;
  };
  MmlMsqrt.prototype.setChildInheritedAttributes = function (attributes, display, level, _prime) {
    this.childNodes[0].setInheritedAttributes(attributes, display, level, true);
  };
  MmlMsqrt.defaults = __assign$m({}, MmlNode_js_1$u.AbstractMmlNode.defaults);
  return MmlMsqrt;
})(MmlNode_js_1$u.AbstractMmlNode);
msqrt$1.MmlMsqrt = MmlMsqrt;

var __extends$14 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$l = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(msqrt$3, "__esModule", {
  value: true
});
msqrt$3.CHTMLmsqrt = void 0;
var Wrapper_js_1$a = Wrapper$3;
var msqrt_js_1$3 = msqrt$2;
var msqrt_js_2 = msqrt$1;
var CHTMLmsqrt = (function (_super) {
  __extends$14(CHTMLmsqrt, _super);
  function CHTMLmsqrt() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmsqrt.prototype.toCHTML = function (parent) {
    var surd = this.childNodes[this.surd];
    var base = this.childNodes[this.base];
    var sbox = surd.getBBox();
    var bbox = base.getOuterBBox();
    var _a = __read$l(this.getPQ(sbox), 2), q = _a[1];
    var t = this.font.params.rule_thickness;
    var H = bbox.h + q + t;
    var CHTML = this.standardCHTMLnode(parent);
    var SURD, BASE, ROOT, root;
    if (this.root != null) {
      ROOT = this.adaptor.append(CHTML, this.html('mjx-root'));
      root = this.childNodes[this.root];
    }
    var SQRT = this.adaptor.append(CHTML, this.html('mjx-sqrt', {}, [SURD = this.html('mjx-surd'), BASE = this.html('mjx-box', {
      style: {
        paddingTop: this.em(q)
      }
    })]));
    this.addRoot(ROOT, root, sbox, H);
    surd.toCHTML(SURD);
    base.toCHTML(BASE);
    if (surd.size < 0) {
      this.adaptor.addClass(SQRT, 'mjx-tall');
    }
  };
  CHTMLmsqrt.prototype.addRoot = function (_ROOT, _root, _sbox, _H) {};
  CHTMLmsqrt.kind = msqrt_js_2.MmlMsqrt.prototype.kind;
  CHTMLmsqrt.styles = {
    'mjx-root': {
      display: 'inline-block',
      'white-space': 'nowrap'
    },
    'mjx-surd': {
      display: 'inline-block',
      'vertical-align': 'top'
    },
    'mjx-sqrt': {
      display: 'inline-block',
      'padding-top': '.07em'
    },
    'mjx-sqrt > mjx-box': {
      'border-top': '.07em solid'
    },
    'mjx-sqrt.mjx-tall > mjx-box': {
      'padding-left': '.3em',
      'margin-left': '-.3em'
    }
  };
  return CHTMLmsqrt;
})((0, msqrt_js_1$3.CommonMsqrtMixin)(Wrapper_js_1$a.CHTMLWrapper));
msqrt$3.CHTMLmsqrt = CHTMLmsqrt;

var mroot$3 = {};

var mroot$2 = {};

var __extends$13 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mroot$2, "__esModule", {
  value: true
});
mroot$2.CommonMrootMixin = void 0;
function CommonMrootMixin(Base) {
  return (function (_super) {
    __extends$13(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_1.prototype, "surd", {
      get: function () {
        return 2;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "root", {
      get: function () {
        return 1;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.combineRootBBox = function (BBOX, sbox, H) {
      var bbox = this.childNodes[this.root].getOuterBBox();
      var h = this.getRootDimens(sbox, H)[1];
      BBOX.combine(bbox, 0, h);
    };
    class_1.prototype.getRootDimens = function (sbox, H) {
      var surd = this.childNodes[this.surd];
      var bbox = this.childNodes[this.root].getOuterBBox();
      var offset = (surd.size < 0 ? .5 : .6) * sbox.w;
      var w = bbox.w, rscale = bbox.rscale;
      var W = Math.max(w, offset / rscale);
      var dx = Math.max(0, W - w);
      var h = this.rootHeight(bbox, sbox, surd.size, H);
      var x = W * rscale - offset;
      return [x, h, dx];
    };
    class_1.prototype.rootHeight = function (rbox, sbox, size, H) {
      var h = sbox.h + sbox.d;
      var b = (size < 0 ? 1.9 : .55 * h) - (h - H);
      return b + Math.max(0, rbox.d * rbox.rscale);
    };
    return class_1;
  })(Base);
}
mroot$2.CommonMrootMixin = CommonMrootMixin;

var mroot$1 = {};

var __extends$12 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$l = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$l = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$l.apply(this, arguments);
});
Object.defineProperty(mroot$1, "__esModule", {
  value: true
});
mroot$1.MmlMroot = void 0;
var MmlNode_js_1$t = MmlNode;
var MmlMroot = (function (_super) {
  __extends$12(MmlMroot, _super);
  function MmlMroot() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$t.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMroot.prototype, "kind", {
    get: function () {
      return 'mroot';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMroot.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMroot.prototype.setTeXclass = function (prev) {
    this.getPrevClass(prev);
    this.childNodes[0].setTeXclass(null);
    this.childNodes[1].setTeXclass(null);
    return this;
  };
  MmlMroot.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    this.childNodes[0].setInheritedAttributes(attributes, display, level, true);
    this.childNodes[1].setInheritedAttributes(attributes, false, level + 2, prime);
  };
  MmlMroot.defaults = __assign$l({}, MmlNode_js_1$t.AbstractMmlNode.defaults);
  return MmlMroot;
})(MmlNode_js_1$t.AbstractMmlNode);
mroot$1.MmlMroot = MmlMroot;

var __extends$11 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$k = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(mroot$3, "__esModule", {
  value: true
});
mroot$3.CHTMLmroot = void 0;
var msqrt_js_1$2 = msqrt$3;
var mroot_js_1$2 = mroot$2;
var mroot_js_2 = mroot$1;
var CHTMLmroot = (function (_super) {
  __extends$11(CHTMLmroot, _super);
  function CHTMLmroot() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmroot.prototype.addRoot = function (ROOT, root, sbox, H) {
    root.toCHTML(ROOT);
    var _a = __read$k(this.getRootDimens(sbox, H), 3), x = _a[0], h = _a[1], dx = _a[2];
    this.adaptor.setStyle(ROOT, 'verticalAlign', this.em(h));
    this.adaptor.setStyle(ROOT, 'width', this.em(x));
    if (dx) {
      this.adaptor.setStyle(this.adaptor.firstChild(ROOT), 'paddingLeft', this.em(dx));
    }
  };
  CHTMLmroot.kind = mroot_js_2.MmlMroot.prototype.kind;
  return CHTMLmroot;
})((0, mroot_js_1$2.CommonMrootMixin)(msqrt_js_1$2.CHTMLmsqrt));
mroot$3.CHTMLmroot = CHTMLmroot;

var msubsup$3 = {};

var scriptbase$1 = {};

var scriptbase = {};

var __extends$10 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$j = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$8 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$k = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(scriptbase, "__esModule", {
  value: true
});
scriptbase.CommonScriptbaseMixin = void 0;
var MmlNode_js_1$s = MmlNode;
function CommonScriptbaseMixin(Base) {
  var _a;
  return (_a = (function (_super) {
    __extends$10(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$8([], __read$j(args), false)) || this;
      _this.baseScale = 1;
      _this.baseIc = 0;
      _this.baseRemoveIc = false;
      _this.baseIsChar = false;
      _this.baseHasAccentOver = null;
      _this.baseHasAccentUnder = null;
      _this.isLineAbove = false;
      _this.isLineBelow = false;
      _this.isMathAccent = false;
      var core = _this.baseCore = _this.getBaseCore();
      if (!core) return _this;
      _this.setBaseAccentsFor(core);
      _this.baseScale = _this.getBaseScale();
      _this.baseIc = _this.getBaseIc();
      _this.baseIsChar = _this.isCharBase();
      _this.isMathAccent = _this.baseIsChar && (_this.scriptChild && !!_this.scriptChild.coreMO().node.getProperty('mathaccent'));
      _this.checkLineAccents();
      _this.baseRemoveIc = !_this.isLineAbove && !_this.isLineBelow && (!_this.constructor.useIC || _this.isMathAccent);
      return _this;
    }
    Object.defineProperty(class_1.prototype, "baseChild", {
      get: function () {
        return this.childNodes[this.node.base];
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "scriptChild", {
      get: function () {
        return this.childNodes[1];
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.getBaseCore = function () {
      var core = this.getSemanticBase() || this.childNodes[0];
      while (core && (core.childNodes.length === 1 && (core.node.isKind('mrow') || core.node.isKind('TeXAtom') && core.node.texClass !== MmlNode_js_1$s.TEXCLASS.VCENTER || core.node.isKind('mstyle') || core.node.isKind('mpadded') || core.node.isKind('mphantom') || core.node.isKind('semantics')) || core.node.isKind('munderover') && core.isMathAccent)) {
        this.setBaseAccentsFor(core);
        core = core.childNodes[0];
      }
      if (!core) {
        this.baseHasAccentOver = this.baseHasAccentUnder = false;
      }
      return core || this.childNodes[0];
    };
    class_1.prototype.setBaseAccentsFor = function (core) {
      if (core.node.isKind('munderover')) {
        if (this.baseHasAccentOver === null) {
          this.baseHasAccentOver = !!core.node.attributes.get('accent');
        }
        if (this.baseHasAccentUnder === null) {
          this.baseHasAccentUnder = !!core.node.attributes.get('accentunder');
        }
      }
    };
    class_1.prototype.getSemanticBase = function () {
      var fence = this.node.attributes.getExplicit('data-semantic-fencepointer');
      return this.getBaseFence(this.baseChild, fence);
    };
    class_1.prototype.getBaseFence = function (fence, id) {
      var e_1, _a;
      if (!fence || !fence.node.attributes || !id) {
        return null;
      }
      if (fence.node.attributes.getExplicit('data-semantic-id') === id) {
        return fence;
      }
      try {
        for (var _b = __values$k(fence.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          var result = this.getBaseFence(child, id);
          if (result) {
            return result;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return null;
    };
    class_1.prototype.getBaseScale = function () {
      var child = this.baseCore;
      var scale = 1;
      while (child && child !== this) {
        var bbox = child.getOuterBBox();
        scale *= bbox.rscale;
        child = child.parent;
      }
      return scale;
    };
    class_1.prototype.getBaseIc = function () {
      return this.baseCore.getOuterBBox().ic * this.baseScale;
    };
    class_1.prototype.getAdjustedIc = function () {
      var bbox = this.baseCore.getOuterBBox();
      return (bbox.ic ? 1.05 * bbox.ic + .05 : 0) * this.baseScale;
    };
    class_1.prototype.isCharBase = function () {
      var base = this.baseCore;
      return (base.node.isKind('mo') && base.size === null || base.node.isKind('mi') || base.node.isKind('mn')) && base.bbox.rscale === 1 && Array.from(base.getText()).length === 1;
    };
    class_1.prototype.checkLineAccents = function () {
      if (!this.node.isKind('munderover')) return;
      if (this.node.isKind('mover')) {
        this.isLineAbove = this.isLineAccent(this.scriptChild);
      } else if (this.node.isKind('munder')) {
        this.isLineBelow = this.isLineAccent(this.scriptChild);
      } else {
        var mml = this;
        this.isLineAbove = this.isLineAccent(mml.overChild);
        this.isLineBelow = this.isLineAccent(mml.underChild);
      }
    };
    class_1.prototype.isLineAccent = function (script) {
      var node = script.coreMO().node;
      return node.isToken && node.getText() === '\u2015';
    };
    class_1.prototype.getBaseWidth = function () {
      var bbox = this.baseChild.getOuterBBox();
      return bbox.w * bbox.rscale - (this.baseRemoveIc ? this.baseIc : 0) + this.font.params.extra_ic;
    };
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      var w = this.getBaseWidth();
      var _a = __read$j(this.getOffset(), 2), x = _a[0], y = _a[1];
      bbox.append(this.baseChild.getOuterBBox());
      bbox.combine(this.scriptChild.getOuterBBox(), w + x, y);
      bbox.w += this.font.params.scriptspace;
      bbox.clean();
      this.setChildPWidths(recompute);
    };
    class_1.prototype.getOffset = function () {
      return [0, 0];
    };
    class_1.prototype.baseCharZero = function (n) {
      var largeop = !!this.baseCore.node.attributes.get('largeop');
      var scale = this.baseScale;
      return this.baseIsChar && !largeop && scale === 1 ? 0 : n;
    };
    class_1.prototype.getV = function () {
      var bbox = this.baseCore.getOuterBBox();
      var sbox = this.scriptChild.getOuterBBox();
      var tex = this.font.params;
      var subscriptshift = this.length2em(this.node.attributes.get('subscriptshift'), tex.sub1);
      return Math.max(this.baseCharZero(bbox.d * this.baseScale + tex.sub_drop * sbox.rscale), subscriptshift, sbox.h * sbox.rscale - 4 / 5 * tex.x_height);
    };
    class_1.prototype.getU = function () {
      var bbox = this.baseCore.getOuterBBox();
      var sbox = this.scriptChild.getOuterBBox();
      var tex = this.font.params;
      var attr = this.node.attributes.getList('displaystyle', 'superscriptshift');
      var prime = this.node.getProperty('texprimestyle');
      var p = prime ? tex.sup3 : attr.displaystyle ? tex.sup1 : tex.sup2;
      var superscriptshift = this.length2em(attr.superscriptshift, p);
      return Math.max(this.baseCharZero(bbox.h * this.baseScale - tex.sup_drop * sbox.rscale), superscriptshift, sbox.d * sbox.rscale + 1 / 4 * tex.x_height);
    };
    class_1.prototype.hasMovableLimits = function () {
      var display = this.node.attributes.get('displaystyle');
      var mo = this.baseChild.coreMO().node;
      return !display && !!mo.attributes.get('movablelimits');
    };
    class_1.prototype.getOverKU = function (basebox, overbox) {
      var accent = this.node.attributes.get('accent');
      var tex = this.font.params;
      var d = overbox.d * overbox.rscale;
      var t = tex.rule_thickness * tex.separation_factor;
      var delta = this.baseHasAccentOver ? t : 0;
      var T = this.isLineAbove ? 3 * tex.rule_thickness : t;
      var k = (accent ? T : Math.max(tex.big_op_spacing1, tex.big_op_spacing3 - Math.max(0, d))) - delta;
      return [k, basebox.h * basebox.rscale + k + d];
    };
    class_1.prototype.getUnderKV = function (basebox, underbox) {
      var accent = this.node.attributes.get('accentunder');
      var tex = this.font.params;
      var h = underbox.h * underbox.rscale;
      var t = tex.rule_thickness * tex.separation_factor;
      var delta = this.baseHasAccentUnder ? t : 0;
      var T = this.isLineBelow ? 3 * tex.rule_thickness : t;
      var k = (accent ? T : Math.max(tex.big_op_spacing2, tex.big_op_spacing4 - h)) - delta;
      return [k, -(basebox.d * basebox.rscale + k + h)];
    };
    class_1.prototype.getDeltaW = function (boxes, delta) {
      var e_2, _a, e_3, _b;
      if (delta === void 0) {
        delta = [0, 0, 0];
      }
      var align = this.node.attributes.get('align');
      var widths = boxes.map(function (box) {
        return box.w * box.rscale;
      });
      widths[0] -= this.baseRemoveIc && !this.baseCore.node.attributes.get('largeop') ? this.baseIc : 0;
      var w = Math.max.apply(Math, __spreadArray$8([], __read$j(widths), false));
      var dw = [];
      var m = 0;
      try {
        for (var _c = __values$k(widths.keys()), _d = _c.next(); !_d.done; _d = _c.next()) {
          var i = _d.value;
          dw[i] = (align === 'center' ? (w - widths[i]) / 2 : align === 'right' ? w - widths[i] : 0) + delta[i];
          if (dw[i] < m) {
            m = -dw[i];
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      if (m) {
        try {
          for (var _e = __values$k(dw.keys()), _f = _e.next(); !_f.done; _f = _e.next()) {
            var i = _f.value;
            dw[i] += m;
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
      }
      [1, 2].map(function (i) {
        return dw[i] += boxes[i] ? boxes[i].dx * boxes[0].scale : 0;
      });
      return dw;
    };
    class_1.prototype.getDelta = function (noskew) {
      if (noskew === void 0) {
        noskew = false;
      }
      var accent = this.node.attributes.get('accent');
      var _a = this.baseCore.getOuterBBox(), sk = _a.sk, ic = _a.ic;
      return ((accent && !noskew ? sk : 0) + this.font.skewIcFactor * ic) * this.baseScale;
    };
    class_1.prototype.stretchChildren = function () {
      var e_4, _a, e_5, _b, e_6, _c;
      var stretchy = [];
      try {
        for (var _d = __values$k(this.childNodes), _e = _d.next(); !_e.done; _e = _d.next()) {
          var child = _e.value;
          if (child.canStretch(2)) {
            stretchy.push(child);
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
      var count = stretchy.length;
      var nodeCount = this.childNodes.length;
      if (count && nodeCount > 1) {
        var W = 0;
        var all = count > 1 && count === nodeCount;
        try {
          for (var _f = __values$k(this.childNodes), _g = _f.next(); !_g.done; _g = _f.next()) {
            var child = _g.value;
            var noStretch = child.stretch.dir === 0;
            if (all || noStretch) {
              var _h = child.getOuterBBox(noStretch), w = _h.w, rscale = _h.rscale;
              if (w * rscale > W) W = w * rscale;
            }
          }
        } catch (e_5_1) {
          e_5 = {
            error: e_5_1
          };
        } finally {
          try {
            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
          } finally {
            if (e_5) throw e_5.error;
          }
        }
        try {
          for (var stretchy_1 = __values$k(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
            var child = stretchy_1_1.value;
            child.coreMO().getStretchedVariant([W / child.bbox.rscale]);
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (stretchy_1_1 && !stretchy_1_1.done && (_c = stretchy_1.return)) _c.call(stretchy_1);
          } finally {
            if (e_6) throw e_6.error;
          }
        }
      }
    };
    return class_1;
  })(Base), _a.useIC = true, _a);
}
scriptbase.CommonScriptbaseMixin = CommonScriptbaseMixin;

var __extends$$ = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$i = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$j = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(scriptbase$1, "__esModule", {
  value: true
});
scriptbase$1.CHTMLscriptbase = void 0;
var Wrapper_js_1$9 = Wrapper$3;
var scriptbase_js_1$1 = scriptbase;
var CHTMLscriptbase = (function (_super) {
  __extends$$(CHTMLscriptbase, _super);
  function CHTMLscriptbase() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLscriptbase.prototype.toCHTML = function (parent) {
    this.chtml = this.standardCHTMLnode(parent);
    var _a = __read$i(this.getOffset(), 2), x = _a[0], v = _a[1];
    var dx = x - (this.baseRemoveIc ? this.baseIc : 0);
    var style = {
      'vertical-align': this.em(v)
    };
    if (dx) {
      style['margin-left'] = this.em(dx);
    }
    this.baseChild.toCHTML(this.chtml);
    this.scriptChild.toCHTML(this.adaptor.append(this.chtml, this.html('mjx-script', {
      style: style
    })));
  };
  CHTMLscriptbase.prototype.setDeltaW = function (nodes, dx) {
    for (var i = 0; i < dx.length; i++) {
      if (dx[i]) {
        this.adaptor.setStyle(nodes[i], 'paddingLeft', this.em(dx[i]));
      }
    }
  };
  CHTMLscriptbase.prototype.adjustOverDepth = function (over, overbox) {
    if (overbox.d >= 0) return;
    this.adaptor.setStyle(over, 'marginBottom', this.em(overbox.d * overbox.rscale));
  };
  CHTMLscriptbase.prototype.adjustUnderDepth = function (under, underbox) {
    var e_1, _a;
    if (underbox.d >= 0) return;
    var adaptor = this.adaptor;
    var v = this.em(underbox.d);
    var box = this.html('mjx-box', {
      style: {
        'margin-bottom': v,
        'vertical-align': v
      }
    });
    try {
      for (var _b = __values$j(adaptor.childNodes(adaptor.firstChild(under))), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        adaptor.append(box, child);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    adaptor.append(adaptor.firstChild(under), box);
  };
  CHTMLscriptbase.prototype.adjustBaseHeight = function (base, basebox) {
    if (this.node.attributes.get('accent')) {
      var minH = this.font.params.x_height * basebox.scale;
      if (basebox.h < minH) {
        this.adaptor.setStyle(base, 'paddingTop', this.em(minH - basebox.h));
        basebox.h = minH;
      }
    }
  };
  CHTMLscriptbase.kind = 'scriptbase';
  return CHTMLscriptbase;
})((0, scriptbase_js_1$1.CommonScriptbaseMixin)(Wrapper_js_1$9.CHTMLWrapper));
scriptbase$1.CHTMLscriptbase = CHTMLscriptbase;

var msubsup$2 = {};

var __extends$_ = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$h = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(msubsup$2, "__esModule", {
  value: true
});
msubsup$2.CommonMsubsupMixin = msubsup$2.CommonMsupMixin = msubsup$2.CommonMsubMixin = void 0;
function CommonMsubMixin(Base) {
  var _a;
  return (_a = (function (_super) {
    __extends$_(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_1.prototype, "scriptChild", {
      get: function () {
        return this.childNodes[this.node.sub];
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.getOffset = function () {
      return [0, -this.getV()];
    };
    return class_1;
  })(Base), _a.useIC = false, _a);
}
msubsup$2.CommonMsubMixin = CommonMsubMixin;
function CommonMsupMixin(Base) {
  return (function (_super) {
    __extends$_(class_2, _super);
    function class_2() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_2.prototype, "scriptChild", {
      get: function () {
        return this.childNodes[this.node.sup];
      },
      enumerable: false,
      configurable: true
    });
    class_2.prototype.getOffset = function () {
      var x = this.getAdjustedIc() - (this.baseRemoveIc ? 0 : this.baseIc);
      return [x, this.getU()];
    };
    return class_2;
  })(Base);
}
msubsup$2.CommonMsupMixin = CommonMsupMixin;
function CommonMsubsupMixin(Base) {
  var _a;
  return (_a = (function (_super) {
    __extends$_(class_3, _super);
    function class_3() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.UVQ = null;
      return _this;
    }
    Object.defineProperty(class_3.prototype, "subChild", {
      get: function () {
        return this.childNodes[this.node.sub];
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_3.prototype, "supChild", {
      get: function () {
        return this.childNodes[this.node.sup];
      },
      enumerable: false,
      configurable: true
    });
    class_3.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      var basebox = this.baseChild.getOuterBBox();
      var _a = __read$h([this.subChild.getOuterBBox(), this.supChild.getOuterBBox()], 2), subbox = _a[0], supbox = _a[1];
      bbox.empty();
      bbox.append(basebox);
      var w = this.getBaseWidth();
      var x = this.getAdjustedIc();
      var _b = __read$h(this.getUVQ(), 2), u = _b[0], v = _b[1];
      bbox.combine(subbox, w, v);
      bbox.combine(supbox, w + x, u);
      bbox.w += this.font.params.scriptspace;
      bbox.clean();
      this.setChildPWidths(recompute);
    };
    class_3.prototype.getUVQ = function (subbox, supbox) {
      if (subbox === void 0) {
        subbox = this.subChild.getOuterBBox();
      }
      if (supbox === void 0) {
        supbox = this.supChild.getOuterBBox();
      }
      var basebox = this.baseCore.getOuterBBox();
      if (this.UVQ) return this.UVQ;
      var tex = this.font.params;
      var t = 3 * tex.rule_thickness;
      var subscriptshift = this.length2em(this.node.attributes.get('subscriptshift'), tex.sub2);
      var drop = this.baseCharZero(basebox.d * this.baseScale + tex.sub_drop * subbox.rscale);
      var _a = __read$h([this.getU(), Math.max(drop, subscriptshift)], 2), u = _a[0], v = _a[1];
      var q = u - supbox.d * supbox.rscale - (subbox.h * subbox.rscale - v);
      if (q < t) {
        v += t - q;
        var p = 4 / 5 * tex.x_height - (u - supbox.d * supbox.rscale);
        if (p > 0) {
          u += p;
          v -= p;
        }
      }
      u = Math.max(this.length2em(this.node.attributes.get('superscriptshift'), u), u);
      v = Math.max(this.length2em(this.node.attributes.get('subscriptshift'), v), v);
      q = u - supbox.d * supbox.rscale - (subbox.h * subbox.rscale - v);
      this.UVQ = [u, -v, q];
      return this.UVQ;
    };
    return class_3;
  })(Base), _a.useIC = false, _a);
}
msubsup$2.CommonMsubsupMixin = CommonMsubsupMixin;

var msubsup$1 = {};

var __extends$Z = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$k = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$k = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$k.apply(this, arguments);
});
Object.defineProperty(msubsup$1, "__esModule", {
  value: true
});
msubsup$1.MmlMsup = msubsup$1.MmlMsub = msubsup$1.MmlMsubsup = void 0;
var MmlNode_js_1$r = MmlNode;
var MmlMsubsup = (function (_super) {
  __extends$Z(MmlMsubsup, _super);
  function MmlMsubsup() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMsubsup.prototype, "kind", {
    get: function () {
      return 'msubsup';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsubsup.prototype, "arity", {
    get: function () {
      return 3;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsubsup.prototype, "base", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsubsup.prototype, "sub", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsubsup.prototype, "sup", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMsubsup.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    var nodes = this.childNodes;
    nodes[0].setInheritedAttributes(attributes, display, level, prime);
    nodes[1].setInheritedAttributes(attributes, false, level + 1, prime || this.sub === 1);
    if (!nodes[2]) {
      return;
    }
    nodes[2].setInheritedAttributes(attributes, false, level + 1, prime || this.sub === 2);
  };
  MmlMsubsup.defaults = __assign$k(__assign$k({}, MmlNode_js_1$r.AbstractMmlBaseNode.defaults), {
    subscriptshift: '',
    superscriptshift: ''
  });
  return MmlMsubsup;
})(MmlNode_js_1$r.AbstractMmlBaseNode);
msubsup$1.MmlMsubsup = MmlMsubsup;
var MmlMsub = (function (_super) {
  __extends$Z(MmlMsub, _super);
  function MmlMsub() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMsub.prototype, "kind", {
    get: function () {
      return 'msub';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsub.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMsub.defaults = __assign$k({}, MmlMsubsup.defaults);
  return MmlMsub;
})(MmlMsubsup);
msubsup$1.MmlMsub = MmlMsub;
var MmlMsup = (function (_super) {
  __extends$Z(MmlMsup, _super);
  function MmlMsup() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMsup.prototype, "kind", {
    get: function () {
      return 'msup';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsup.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsup.prototype, "sup", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMsup.prototype, "sub", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMsup.defaults = __assign$k({}, MmlMsubsup.defaults);
  return MmlMsup;
})(MmlMsubsup);
msubsup$1.MmlMsup = MmlMsup;

var __extends$Y = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$g = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(msubsup$3, "__esModule", {
  value: true
});
msubsup$3.CHTMLmsubsup = msubsup$3.CHTMLmsup = msubsup$3.CHTMLmsub = void 0;
var scriptbase_js_1 = scriptbase$1;
var msubsup_js_1$5 = msubsup$2;
var msubsup_js_2 = msubsup$2;
var msubsup_js_3 = msubsup$2;
var msubsup_js_4 = msubsup$1;
var CHTMLmsub = (function (_super) {
  __extends$Y(CHTMLmsub, _super);
  function CHTMLmsub() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmsub.kind = msubsup_js_4.MmlMsub.prototype.kind;
  return CHTMLmsub;
})((0, msubsup_js_1$5.CommonMsubMixin)(scriptbase_js_1.CHTMLscriptbase));
msubsup$3.CHTMLmsub = CHTMLmsub;
var CHTMLmsup = (function (_super) {
  __extends$Y(CHTMLmsup, _super);
  function CHTMLmsup() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmsup.kind = msubsup_js_4.MmlMsup.prototype.kind;
  return CHTMLmsup;
})((0, msubsup_js_2.CommonMsupMixin)(scriptbase_js_1.CHTMLscriptbase));
msubsup$3.CHTMLmsup = CHTMLmsup;
var CHTMLmsubsup = (function (_super) {
  __extends$Y(CHTMLmsubsup, _super);
  function CHTMLmsubsup() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmsubsup.prototype.toCHTML = function (parent) {
    var adaptor = this.adaptor;
    var chtml = this.standardCHTMLnode(parent);
    var _a = __read$g([this.baseChild, this.supChild, this.subChild], 3), base = _a[0], sup = _a[1], sub = _a[2];
    var _b = __read$g(this.getUVQ(), 3), v = _b[1], q = _b[2];
    var style = {
      'vertical-align': this.em(v)
    };
    base.toCHTML(chtml);
    var stack = adaptor.append(chtml, this.html('mjx-script', {
      style: style
    }));
    sup.toCHTML(stack);
    adaptor.append(stack, this.html('mjx-spacer', {
      style: {
        'margin-top': this.em(q)
      }
    }));
    sub.toCHTML(stack);
    var ic = this.getAdjustedIc();
    if (ic) {
      adaptor.setStyle(sup.chtml, 'marginLeft', this.em(ic / sup.bbox.rscale));
    }
    if (this.baseRemoveIc) {
      adaptor.setStyle(stack, 'marginLeft', this.em(-this.baseIc));
    }
  };
  CHTMLmsubsup.kind = msubsup_js_4.MmlMsubsup.prototype.kind;
  CHTMLmsubsup.styles = {
    'mjx-script': {
      display: 'inline-block',
      'padding-right': '.05em',
      'padding-left': '.033em'
    },
    'mjx-script > mjx-spacer': {
      display: 'block'
    }
  };
  return CHTMLmsubsup;
})((0, msubsup_js_3.CommonMsubsupMixin)(scriptbase_js_1.CHTMLscriptbase));
msubsup$3.CHTMLmsubsup = CHTMLmsubsup;

var munderover$3 = {};

var munderover$2 = {};

var __extends$X = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$f = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$7 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(munderover$2, "__esModule", {
  value: true
});
munderover$2.CommonMunderoverMixin = munderover$2.CommonMoverMixin = munderover$2.CommonMunderMixin = void 0;
function CommonMunderMixin(Base) {
  return (function (_super) {
    __extends$X(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$7([], __read$f(args), false)) || this;
      _this.stretchChildren();
      return _this;
    }
    Object.defineProperty(class_1.prototype, "scriptChild", {
      get: function () {
        return this.childNodes[this.node.under];
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      if (this.hasMovableLimits()) {
        _super.prototype.computeBBox.call(this, bbox, recompute);
        return;
      }
      bbox.empty();
      var basebox = this.baseChild.getOuterBBox();
      var underbox = this.scriptChild.getOuterBBox();
      var v = this.getUnderKV(basebox, underbox)[1];
      var delta = this.isLineBelow ? 0 : this.getDelta(true);
      var _a = __read$f(this.getDeltaW([basebox, underbox], [0, -delta]), 2), bw = _a[0], uw = _a[1];
      bbox.combine(basebox, bw, 0);
      bbox.combine(underbox, uw, v);
      bbox.d += this.font.params.big_op_spacing5;
      bbox.clean();
      this.setChildPWidths(recompute);
    };
    return class_1;
  })(Base);
}
munderover$2.CommonMunderMixin = CommonMunderMixin;
function CommonMoverMixin(Base) {
  return (function (_super) {
    __extends$X(class_2, _super);
    function class_2() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$7([], __read$f(args), false)) || this;
      _this.stretchChildren();
      return _this;
    }
    Object.defineProperty(class_2.prototype, "scriptChild", {
      get: function () {
        return this.childNodes[this.node.over];
      },
      enumerable: false,
      configurable: true
    });
    class_2.prototype.computeBBox = function (bbox) {
      if (this.hasMovableLimits()) {
        _super.prototype.computeBBox.call(this, bbox);
        return;
      }
      bbox.empty();
      var basebox = this.baseChild.getOuterBBox();
      var overbox = this.scriptChild.getOuterBBox();
      if (this.node.attributes.get('accent')) {
        basebox.h = Math.max(basebox.h, this.font.params.x_height * basebox.scale);
      }
      var u = this.getOverKU(basebox, overbox)[1];
      var delta = this.isLineAbove ? 0 : this.getDelta();
      var _a = __read$f(this.getDeltaW([basebox, overbox], [0, delta]), 2), bw = _a[0], ow = _a[1];
      bbox.combine(basebox, bw, 0);
      bbox.combine(overbox, ow, u);
      bbox.h += this.font.params.big_op_spacing5;
      bbox.clean();
    };
    return class_2;
  })(Base);
}
munderover$2.CommonMoverMixin = CommonMoverMixin;
function CommonMunderoverMixin(Base) {
  return (function (_super) {
    __extends$X(class_3, _super);
    function class_3() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$7([], __read$f(args), false)) || this;
      _this.stretchChildren();
      return _this;
    }
    Object.defineProperty(class_3.prototype, "underChild", {
      get: function () {
        return this.childNodes[this.node.under];
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_3.prototype, "overChild", {
      get: function () {
        return this.childNodes[this.node.over];
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_3.prototype, "subChild", {
      get: function () {
        return this.underChild;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_3.prototype, "supChild", {
      get: function () {
        return this.overChild;
      },
      enumerable: false,
      configurable: true
    });
    class_3.prototype.computeBBox = function (bbox) {
      if (this.hasMovableLimits()) {
        _super.prototype.computeBBox.call(this, bbox);
        return;
      }
      bbox.empty();
      var overbox = this.overChild.getOuterBBox();
      var basebox = this.baseChild.getOuterBBox();
      var underbox = this.underChild.getOuterBBox();
      if (this.node.attributes.get('accent')) {
        basebox.h = Math.max(basebox.h, this.font.params.x_height * basebox.scale);
      }
      var u = this.getOverKU(basebox, overbox)[1];
      var v = this.getUnderKV(basebox, underbox)[1];
      var delta = this.getDelta();
      var _a = __read$f(this.getDeltaW([basebox, underbox, overbox], [0, this.isLineBelow ? 0 : -delta, this.isLineAbove ? 0 : delta]), 3), bw = _a[0], uw = _a[1], ow = _a[2];
      bbox.combine(basebox, bw, 0);
      bbox.combine(overbox, ow, u);
      bbox.combine(underbox, uw, v);
      var z = this.font.params.big_op_spacing5;
      bbox.h += z;
      bbox.d += z;
      bbox.clean();
    };
    return class_3;
  })(Base);
}
munderover$2.CommonMunderoverMixin = CommonMunderoverMixin;

var munderover$1 = {};

var __extends$W = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$j = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$j = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$j.apply(this, arguments);
});
Object.defineProperty(munderover$1, "__esModule", {
  value: true
});
munderover$1.MmlMover = munderover$1.MmlMunder = munderover$1.MmlMunderover = void 0;
var MmlNode_js_1$q = MmlNode;
var MmlMunderover = (function (_super) {
  __extends$W(MmlMunderover, _super);
  function MmlMunderover() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMunderover.prototype, "kind", {
    get: function () {
      return 'munderover';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunderover.prototype, "arity", {
    get: function () {
      return 3;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunderover.prototype, "base", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunderover.prototype, "under", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunderover.prototype, "over", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunderover.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMunderover.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    var nodes = this.childNodes;
    nodes[0].setInheritedAttributes(attributes, display, level, prime || !!nodes[this.over]);
    var force = !!(!display && nodes[0].coreMO().attributes.get('movablelimits'));
    var ACCENTS = this.constructor.ACCENTS;
    nodes[1].setInheritedAttributes(attributes, false, this.getScriptlevel(ACCENTS[1], force, level), prime || this.under === 1);
    this.setInheritedAccent(1, ACCENTS[1], display, level, prime, force);
    if (!nodes[2]) {
      return;
    }
    nodes[2].setInheritedAttributes(attributes, false, this.getScriptlevel(ACCENTS[2], force, level), prime || this.under === 2);
    this.setInheritedAccent(2, ACCENTS[2], display, level, prime, force);
  };
  MmlMunderover.prototype.getScriptlevel = function (accent, force, level) {
    if (force || !this.attributes.get(accent)) {
      level++;
    }
    return level;
  };
  MmlMunderover.prototype.setInheritedAccent = function (n, accent, display, level, prime, force) {
    var node = this.childNodes[n];
    if (this.attributes.getExplicit(accent) == null && node.isEmbellished) {
      var value = node.coreMO().attributes.get('accent');
      this.attributes.setInherited(accent, value);
      if (value !== this.attributes.getDefault(accent)) {
        node.setInheritedAttributes({}, display, this.getScriptlevel(accent, force, level), prime);
      }
    }
  };
  MmlMunderover.defaults = __assign$j(__assign$j({}, MmlNode_js_1$q.AbstractMmlBaseNode.defaults), {
    accent: false,
    accentunder: false,
    align: 'center'
  });
  MmlMunderover.ACCENTS = ['', 'accentunder', 'accent'];
  return MmlMunderover;
})(MmlNode_js_1$q.AbstractMmlBaseNode);
munderover$1.MmlMunderover = MmlMunderover;
var MmlMunder = (function (_super) {
  __extends$W(MmlMunder, _super);
  function MmlMunder() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMunder.prototype, "kind", {
    get: function () {
      return 'munder';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMunder.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMunder.defaults = __assign$j({}, MmlMunderover.defaults);
  return MmlMunder;
})(MmlMunderover);
munderover$1.MmlMunder = MmlMunder;
var MmlMover = (function (_super) {
  __extends$W(MmlMover, _super);
  function MmlMover() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMover.prototype, "kind", {
    get: function () {
      return 'mover';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMover.prototype, "arity", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMover.prototype, "over", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMover.prototype, "under", {
    get: function () {
      return 2;
    },
    enumerable: false,
    configurable: true
  });
  MmlMover.defaults = __assign$j({}, MmlMunderover.defaults);
  MmlMover.ACCENTS = ['', 'accent', 'accentunder'];
  return MmlMover;
})(MmlMunderover);
munderover$1.MmlMover = MmlMover;

var __extends$V = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(munderover$3, "__esModule", {
  value: true
});
munderover$3.CHTMLmunderover = munderover$3.CHTMLmover = munderover$3.CHTMLmunder = void 0;
var msubsup_js_1$4 = msubsup$3;
var munderover_js_1$2 = munderover$2;
var munderover_js_2 = munderover$2;
var munderover_js_3 = munderover$2;
var munderover_js_4 = munderover$1;
var CHTMLmunder = (function (_super) {
  __extends$V(CHTMLmunder, _super);
  function CHTMLmunder() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmunder.prototype.toCHTML = function (parent) {
    if (this.hasMovableLimits()) {
      _super.prototype.toCHTML.call(this, parent);
      this.adaptor.setAttribute(this.chtml, 'limits', 'false');
      return;
    }
    this.chtml = this.standardCHTMLnode(parent);
    var base = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-row')), this.html('mjx-base'));
    var under = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-row')), this.html('mjx-under'));
    this.baseChild.toCHTML(base);
    this.scriptChild.toCHTML(under);
    var basebox = this.baseChild.getOuterBBox();
    var underbox = this.scriptChild.getOuterBBox();
    var k = this.getUnderKV(basebox, underbox)[0];
    var delta = this.isLineBelow ? 0 : this.getDelta(true);
    this.adaptor.setStyle(under, 'paddingTop', this.em(k));
    this.setDeltaW([base, under], this.getDeltaW([basebox, underbox], [0, -delta]));
    this.adjustUnderDepth(under, underbox);
  };
  CHTMLmunder.kind = munderover_js_4.MmlMunder.prototype.kind;
  CHTMLmunder.styles = {
    'mjx-over': {
      'text-align': 'left'
    },
    'mjx-munder:not([limits="false"])': {
      display: 'inline-table'
    },
    'mjx-munder > mjx-row': {
      'text-align': 'left'
    },
    'mjx-under': {
      'padding-bottom': '.1em'
    }
  };
  return CHTMLmunder;
})((0, munderover_js_1$2.CommonMunderMixin)(msubsup_js_1$4.CHTMLmsub));
munderover$3.CHTMLmunder = CHTMLmunder;
var CHTMLmover = (function (_super) {
  __extends$V(CHTMLmover, _super);
  function CHTMLmover() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmover.prototype.toCHTML = function (parent) {
    if (this.hasMovableLimits()) {
      _super.prototype.toCHTML.call(this, parent);
      this.adaptor.setAttribute(this.chtml, 'limits', 'false');
      return;
    }
    this.chtml = this.standardCHTMLnode(parent);
    var over = this.adaptor.append(this.chtml, this.html('mjx-over'));
    var base = this.adaptor.append(this.chtml, this.html('mjx-base'));
    this.scriptChild.toCHTML(over);
    this.baseChild.toCHTML(base);
    var overbox = this.scriptChild.getOuterBBox();
    var basebox = this.baseChild.getOuterBBox();
    this.adjustBaseHeight(base, basebox);
    var k = this.getOverKU(basebox, overbox)[0];
    var delta = this.isLineAbove ? 0 : this.getDelta();
    this.adaptor.setStyle(over, 'paddingBottom', this.em(k));
    this.setDeltaW([base, over], this.getDeltaW([basebox, overbox], [0, delta]));
    this.adjustOverDepth(over, overbox);
  };
  CHTMLmover.kind = munderover_js_4.MmlMover.prototype.kind;
  CHTMLmover.styles = {
    'mjx-mover:not([limits="false"])': {
      'padding-top': '.1em'
    },
    'mjx-mover:not([limits="false"]) > *': {
      display: 'block',
      'text-align': 'left'
    }
  };
  return CHTMLmover;
})((0, munderover_js_2.CommonMoverMixin)(msubsup_js_1$4.CHTMLmsup));
munderover$3.CHTMLmover = CHTMLmover;
var CHTMLmunderover = (function (_super) {
  __extends$V(CHTMLmunderover, _super);
  function CHTMLmunderover() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmunderover.prototype.toCHTML = function (parent) {
    if (this.hasMovableLimits()) {
      _super.prototype.toCHTML.call(this, parent);
      this.adaptor.setAttribute(this.chtml, 'limits', 'false');
      return;
    }
    this.chtml = this.standardCHTMLnode(parent);
    var over = this.adaptor.append(this.chtml, this.html('mjx-over'));
    var table = this.adaptor.append(this.adaptor.append(this.chtml, this.html('mjx-box')), this.html('mjx-munder'));
    var base = this.adaptor.append(this.adaptor.append(table, this.html('mjx-row')), this.html('mjx-base'));
    var under = this.adaptor.append(this.adaptor.append(table, this.html('mjx-row')), this.html('mjx-under'));
    this.overChild.toCHTML(over);
    this.baseChild.toCHTML(base);
    this.underChild.toCHTML(under);
    var overbox = this.overChild.getOuterBBox();
    var basebox = this.baseChild.getOuterBBox();
    var underbox = this.underChild.getOuterBBox();
    this.adjustBaseHeight(base, basebox);
    var ok = this.getOverKU(basebox, overbox)[0];
    var uk = this.getUnderKV(basebox, underbox)[0];
    var delta = this.getDelta();
    this.adaptor.setStyle(over, 'paddingBottom', this.em(ok));
    this.adaptor.setStyle(under, 'paddingTop', this.em(uk));
    this.setDeltaW([base, under, over], this.getDeltaW([basebox, underbox, overbox], [0, this.isLineBelow ? 0 : -delta, this.isLineAbove ? 0 : delta]));
    this.adjustOverDepth(over, overbox);
    this.adjustUnderDepth(under, underbox);
  };
  CHTMLmunderover.prototype.markUsed = function () {
    _super.prototype.markUsed.call(this);
    this.jax.wrapperUsage.add(msubsup_js_1$4.CHTMLmsubsup.kind);
  };
  CHTMLmunderover.kind = munderover_js_4.MmlMunderover.prototype.kind;
  CHTMLmunderover.styles = {
    'mjx-munderover:not([limits="false"])': {
      'padding-top': '.1em'
    },
    'mjx-munderover:not([limits="false"]) > *': {
      display: 'block'
    }
  };
  return CHTMLmunderover;
})((0, munderover_js_3.CommonMunderoverMixin)(msubsup_js_1$4.CHTMLmsubsup));
munderover$3.CHTMLmunderover = CHTMLmunderover;

var mmultiscripts$3 = {};

var mmultiscripts$2 = {};

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CommonMmultiscriptsMixin = exports.ScriptNames = exports.NextScript = void 0;
  var BBox_js_1 = BBox$1;
  exports.NextScript = {
    base: 'subList',
    subList: 'supList',
    supList: 'subList',
    psubList: 'psupList',
    psupList: 'psubList'
  };
  exports.ScriptNames = ['sup', 'sup', 'psup', 'psub'];
  function CommonMmultiscriptsMixin(Base) {
    return (function (_super) {
      __extends(class_1, _super);
      function class_1() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
        }
        var _this = _super.apply(this, __spreadArray([], __read(args), false)) || this;
        _this.scriptData = null;
        _this.firstPrescript = 0;
        _this.getScriptData();
        return _this;
      }
      class_1.prototype.combinePrePost = function (pre, post) {
        var bbox = new BBox_js_1.BBox(pre);
        bbox.combine(post, 0, 0);
        return bbox;
      };
      class_1.prototype.computeBBox = function (bbox, recompute) {
        if (recompute === void 0) {
          recompute = false;
        }
        var scriptspace = this.font.params.scriptspace;
        var data = this.scriptData;
        var sub = this.combinePrePost(data.sub, data.psub);
        var sup = this.combinePrePost(data.sup, data.psup);
        var _a = __read(this.getUVQ(sub, sup), 2), u = _a[0], v = _a[1];
        bbox.empty();
        if (data.numPrescripts) {
          bbox.combine(data.psup, scriptspace, u);
          bbox.combine(data.psub, scriptspace, v);
        }
        bbox.append(data.base);
        if (data.numScripts) {
          var w = bbox.w;
          bbox.combine(data.sup, w, u);
          bbox.combine(data.sub, w, v);
          bbox.w += scriptspace;
        }
        bbox.clean();
        this.setChildPWidths(recompute);
      };
      class_1.prototype.getScriptData = function () {
        var data = this.scriptData = {
          base: null,
          sub: BBox_js_1.BBox.empty(),
          sup: BBox_js_1.BBox.empty(),
          psub: BBox_js_1.BBox.empty(),
          psup: BBox_js_1.BBox.empty(),
          numPrescripts: 0,
          numScripts: 0
        };
        var lists = this.getScriptBBoxLists();
        this.combineBBoxLists(data.sub, data.sup, lists.subList, lists.supList);
        this.combineBBoxLists(data.psub, data.psup, lists.psubList, lists.psupList);
        data.base = lists.base[0];
        data.numPrescripts = lists.psubList.length;
        data.numScripts = lists.subList.length;
      };
      class_1.prototype.getScriptBBoxLists = function () {
        var e_1, _a;
        var lists = {
          base: [],
          subList: [],
          supList: [],
          psubList: [],
          psupList: []
        };
        var script = 'base';
        try {
          for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
            var child = _c.value;
            if (child.node.isKind('mprescripts')) {
              script = 'psubList';
            } else {
              lists[script].push(child.getOuterBBox());
              script = exports.NextScript[script];
            }
          }
        } catch (e_1_1) {
          e_1 = {
            error: e_1_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_1) throw e_1.error;
          }
        }
        this.firstPrescript = lists.subList.length + lists.supList.length + 2;
        this.padLists(lists.subList, lists.supList);
        this.padLists(lists.psubList, lists.psupList);
        return lists;
      };
      class_1.prototype.padLists = function (list1, list2) {
        if (list1.length > list2.length) {
          list2.push(BBox_js_1.BBox.empty());
        }
      };
      class_1.prototype.combineBBoxLists = function (bbox1, bbox2, list1, list2) {
        for (var i = 0; i < list1.length; i++) {
          var _a = __read(this.getScaledWHD(list1[i]), 3), w1 = _a[0], h1 = _a[1], d1 = _a[2];
          var _b = __read(this.getScaledWHD(list2[i]), 3), w2 = _b[0], h2 = _b[1], d2 = _b[2];
          var w = Math.max(w1, w2);
          bbox1.w += w;
          bbox2.w += w;
          if (h1 > bbox1.h) bbox1.h = h1;
          if (d1 > bbox1.d) bbox1.d = d1;
          if (h2 > bbox2.h) bbox2.h = h2;
          if (d2 > bbox2.d) bbox2.d = d2;
        }
      };
      class_1.prototype.getScaledWHD = function (bbox) {
        var w = bbox.w, h = bbox.h, d = bbox.d, rscale = bbox.rscale;
        return [w * rscale, h * rscale, d * rscale];
      };
      class_1.prototype.getUVQ = function (subbox, supbox) {
        var _a;
        if (!this.UVQ) {
          var _b = __read([0, 0, 0], 3), u = _b[0], v = _b[1], q = _b[2];
          if (subbox.h === 0 && subbox.d === 0) {
            u = this.getU();
          } else if (supbox.h === 0 && supbox.d === 0) {
            u = -this.getV();
          } else {
            (_a = __read(_super.prototype.getUVQ.call(this, subbox, supbox), 3), u = _a[0], v = _a[1], q = _a[2]);
          }
          this.UVQ = [u, v, q];
        }
        return this.UVQ;
      };
      return class_1;
    })(Base);
  }
  exports.CommonMmultiscriptsMixin = CommonMmultiscriptsMixin;
})(mmultiscripts$2);
getDefaultExportFromCjs(mmultiscripts$2);

var mmultiscripts$1 = {};

var __extends$U = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$i = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$i = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$i.apply(this, arguments);
});
Object.defineProperty(mmultiscripts$1, "__esModule", {
  value: true
});
mmultiscripts$1.MmlNone = mmultiscripts$1.MmlMprescripts = mmultiscripts$1.MmlMmultiscripts = void 0;
var MmlNode_js_1$p = MmlNode;
var msubsup_js_1$3 = msubsup$1;
var MmlMmultiscripts = (function (_super) {
  __extends$U(MmlMmultiscripts, _super);
  function MmlMmultiscripts() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMmultiscripts.prototype, "kind", {
    get: function () {
      return 'mmultiscripts';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMmultiscripts.prototype, "arity", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  MmlMmultiscripts.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    this.childNodes[0].setInheritedAttributes(attributes, display, level, prime);
    var prescripts = false;
    for (var i = 1, n = 0; i < this.childNodes.length; i++) {
      var child = this.childNodes[i];
      if (child.isKind('mprescripts')) {
        if (!prescripts) {
          prescripts = true;
          if (i % 2 === 0) {
            var mrow = this.factory.create('mrow');
            this.childNodes.splice(i, 0, mrow);
            mrow.parent = this;
            i++;
          }
        }
      } else {
        var primestyle = prime || n % 2 === 0;
        child.setInheritedAttributes(attributes, false, level + 1, primestyle);
        n++;
      }
    }
    if (this.childNodes.length % 2 === (prescripts ? 1 : 0)) {
      this.appendChild(this.factory.create('mrow'));
      this.childNodes[this.childNodes.length - 1].setInheritedAttributes(attributes, false, level + 1, prime);
    }
  };
  MmlMmultiscripts.prototype.verifyChildren = function (options) {
    var prescripts = false;
    var fix = options['fixMmultiscripts'];
    for (var i = 0; i < this.childNodes.length; i++) {
      var child = this.childNodes[i];
      if (child.isKind('mprescripts')) {
        if (prescripts) {
          child.mError(child.kind + ' can only appear once in ' + this.kind, options, true);
        } else {
          prescripts = true;
          if (i % 2 === 0 && !fix) {
            this.mError('There must be an equal number of prescripts of each type', options);
          }
        }
      }
    }
    if (this.childNodes.length % 2 === (prescripts ? 1 : 0) && !fix) {
      this.mError('There must be an equal number of scripts of each type', options);
    }
    _super.prototype.verifyChildren.call(this, options);
  };
  MmlMmultiscripts.defaults = __assign$i({}, msubsup_js_1$3.MmlMsubsup.defaults);
  return MmlMmultiscripts;
})(msubsup_js_1$3.MmlMsubsup);
mmultiscripts$1.MmlMmultiscripts = MmlMmultiscripts;
var MmlMprescripts = (function (_super) {
  __extends$U(MmlMprescripts, _super);
  function MmlMprescripts() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMprescripts.prototype, "kind", {
    get: function () {
      return 'mprescripts';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMprescripts.prototype, "arity", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  MmlMprescripts.prototype.verifyTree = function (options) {
    _super.prototype.verifyTree.call(this, options);
    if (this.parent && !this.parent.isKind('mmultiscripts')) {
      this.mError(this.kind + ' must be a child of mmultiscripts', options, true);
    }
  };
  MmlMprescripts.defaults = __assign$i({}, MmlNode_js_1$p.AbstractMmlNode.defaults);
  return MmlMprescripts;
})(MmlNode_js_1$p.AbstractMmlNode);
mmultiscripts$1.MmlMprescripts = MmlMprescripts;
var MmlNone$1 = (function (_super) {
  __extends$U(MmlNone, _super);
  function MmlNone() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlNone.prototype, "kind", {
    get: function () {
      return 'none';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlNone.prototype, "arity", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  MmlNone.prototype.verifyTree = function (options) {
    _super.prototype.verifyTree.call(this, options);
    if (this.parent && !this.parent.isKind('mmultiscripts')) {
      this.mError(this.kind + ' must be a child of mmultiscripts', options, true);
    }
  };
  MmlNone.defaults = __assign$i({}, MmlNode_js_1$p.AbstractMmlNode.defaults);
  return MmlNone;
})(MmlNode_js_1$p.AbstractMmlNode);
mmultiscripts$1.MmlNone = MmlNone$1;

var __extends$T = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$e = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(mmultiscripts$3, "__esModule", {
  value: true
});
mmultiscripts$3.CHTMLmmultiscripts = void 0;
var msubsup_js_1$2 = msubsup$3;
var mmultiscripts_js_1$2 = mmultiscripts$2;
var mmultiscripts_js_2 = mmultiscripts$1;
var string_js_1$5 = string;
var CHTMLmmultiscripts = (function (_super) {
  __extends$T(CHTMLmmultiscripts, _super);
  function CHTMLmmultiscripts() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmmultiscripts.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    var data = this.scriptData;
    var scriptalign = this.node.getProperty('scriptalign') || 'right left';
    var _a = __read$e((0, string_js_1$5.split)(scriptalign + ' ' + scriptalign), 2), preAlign = _a[0], postAlign = _a[1];
    var sub = this.combinePrePost(data.sub, data.psub);
    var sup = this.combinePrePost(data.sup, data.psup);
    var _b = __read$e(this.getUVQ(sub, sup), 2), u = _b[0], v = _b[1];
    if (data.numPrescripts) {
      var scripts = this.addScripts(u, -v, true, data.psub, data.psup, this.firstPrescript, data.numPrescripts);
      preAlign !== 'right' && this.adaptor.setAttribute(scripts, 'script-align', preAlign);
    }
    this.childNodes[0].toCHTML(chtml);
    if (data.numScripts) {
      var scripts = this.addScripts(u, -v, false, data.sub, data.sup, 1, data.numScripts);
      postAlign !== 'left' && this.adaptor.setAttribute(scripts, 'script-align', postAlign);
    }
  };
  CHTMLmmultiscripts.prototype.addScripts = function (u, v, isPre, sub, sup, i, n) {
    var adaptor = this.adaptor;
    var q = u - sup.d + (v - sub.h);
    var U = u < 0 && v === 0 ? sub.h + u : u;
    var rowdef = q > 0 ? {
      style: {
        height: this.em(q)
      }
    } : {};
    var tabledef = U ? {
      style: {
        'vertical-align': this.em(U)
      }
    } : {};
    var supRow = this.html('mjx-row');
    var sepRow = this.html('mjx-row', rowdef);
    var subRow = this.html('mjx-row');
    var name = 'mjx-' + (isPre ? 'pre' : '') + 'scripts';
    var m = i + 2 * n;
    while (i < m) {
      this.childNodes[i++].toCHTML(adaptor.append(subRow, this.html('mjx-cell')));
      this.childNodes[i++].toCHTML(adaptor.append(supRow, this.html('mjx-cell')));
    }
    return adaptor.append(this.chtml, this.html(name, tabledef, [supRow, sepRow, subRow]));
  };
  CHTMLmmultiscripts.kind = mmultiscripts_js_2.MmlMmultiscripts.prototype.kind;
  CHTMLmmultiscripts.styles = {
    'mjx-prescripts': {
      display: 'inline-table',
      'padding-left': '.05em'
    },
    'mjx-scripts': {
      display: 'inline-table',
      'padding-right': '.05em'
    },
    'mjx-prescripts > mjx-row > mjx-cell': {
      'text-align': 'right'
    },
    '[script-align="left"] > mjx-row > mjx-cell': {
      'text-align': 'left'
    },
    '[script-align="center"] > mjx-row > mjx-cell': {
      'text-align': 'center'
    },
    '[script-align="right"] > mjx-row > mjx-cell': {
      'text-align': 'right'
    }
  };
  return CHTMLmmultiscripts;
})((0, mmultiscripts_js_1$2.CommonMmultiscriptsMixin)(msubsup_js_1$2.CHTMLmsubsup));
mmultiscripts$3.CHTMLmmultiscripts = CHTMLmmultiscripts;

var mtable$3 = {};

var mtable$2 = {};

var numeric = {};

Object.defineProperty(numeric, "__esModule", {
  value: true
});
numeric.max = numeric.sum = void 0;
function sum(A) {
  return A.reduce(function (a, b) {
    return a + b;
  }, 0);
}
numeric.sum = sum;
function max(A) {
  return A.reduce(function (a, b) {
    return Math.max(a, b);
  }, 0);
}
numeric.max = max;

var __extends$S = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$d = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$6 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __values$i = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mtable$2, "__esModule", {
  value: true
});
mtable$2.CommonMtableMixin = void 0;
var BBox_js_1 = BBox$1;
var string_js_1$4 = string;
var numeric_js_1 = numeric;
function CommonMtableMixin(Base) {
  return (function (_super) {
    __extends$S(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$6([], __read$d(args), false)) || this;
      _this.numCols = 0;
      _this.numRows = 0;
      _this.data = null;
      _this.pwidthCells = [];
      _this.pWidth = 0;
      _this.numCols = (0, numeric_js_1.max)(_this.tableRows.map(function (row) {
        return row.numCells;
      }));
      _this.numRows = _this.childNodes.length;
      _this.hasLabels = _this.childNodes.reduce(function (value, row) {
        return value || row.node.isKind('mlabeledtr');
      }, false);
      _this.findContainer();
      _this.isTop = !_this.container || _this.container.node.isKind('math') && !_this.container.parent;
      if (_this.isTop) {
        _this.jax.table = _this;
      }
      _this.getPercentageWidth();
      var attributes = _this.node.attributes;
      _this.frame = attributes.get('frame') !== 'none';
      _this.fLine = _this.frame && attributes.get('frame') ? .07 : 0;
      _this.fSpace = _this.frame ? _this.convertLengths(_this.getAttributeArray('framespacing')) : [0, 0];
      _this.cSpace = _this.convertLengths(_this.getColumnAttributes('columnspacing'));
      _this.rSpace = _this.convertLengths(_this.getRowAttributes('rowspacing'));
      _this.cLines = _this.getColumnAttributes('columnlines').map(function (x) {
        return x === 'none' ? 0 : .07;
      });
      _this.rLines = _this.getRowAttributes('rowlines').map(function (x) {
        return x === 'none' ? 0 : .07;
      });
      _this.cWidths = _this.getColumnWidths();
      _this.stretchRows();
      _this.stretchColumns();
      return _this;
    }
    Object.defineProperty(class_1.prototype, "tableRows", {
      get: function () {
        return this.childNodes;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.findContainer = function () {
      var node = this;
      var parent = node.parent;
      while (parent && (parent.node.notParent || parent.node.isKind('mrow'))) {
        node = parent;
        parent = parent.parent;
      }
      this.container = parent;
      this.containerI = node.node.childPosition();
    };
    class_1.prototype.getPercentageWidth = function () {
      if (this.hasLabels) {
        this.bbox.pwidth = BBox_js_1.BBox.fullWidth;
      } else {
        var width = this.node.attributes.get('width');
        if ((0, string_js_1$4.isPercent)(width)) {
          this.bbox.pwidth = width;
        }
      }
    };
    class_1.prototype.stretchRows = function () {
      var equal = this.node.attributes.get('equalrows');
      var HD = equal ? this.getEqualRowHeight() : 0;
      var _a = equal ? this.getTableData() : {
        H: [0],
        D: [0]
      }, H = _a.H, D = _a.D;
      var rows = this.tableRows;
      for (var i = 0; i < this.numRows; i++) {
        var hd = equal ? [(HD + H[i] - D[i]) / 2, (HD - H[i] + D[i]) / 2] : null;
        rows[i].stretchChildren(hd);
      }
    };
    class_1.prototype.stretchColumns = function () {
      for (var i = 0; i < this.numCols; i++) {
        var width = typeof this.cWidths[i] === 'number' ? this.cWidths[i] : null;
        this.stretchColumn(i, width);
      }
    };
    class_1.prototype.stretchColumn = function (i, W) {
      var e_1, _a, e_2, _b, e_3, _c;
      var stretchy = [];
      try {
        for (var _d = __values$i(this.tableRows), _e = _d.next(); !_e.done; _e = _d.next()) {
          var row = _e.value;
          var cell = row.getChild(i);
          if (cell) {
            var child = cell.childNodes[0];
            if (child.stretch.dir === 0 && child.canStretch(2)) {
              stretchy.push(child);
            }
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      var count = stretchy.length;
      var nodeCount = this.childNodes.length;
      if (count && nodeCount > 1) {
        if (W === null) {
          W = 0;
          var all = count > 1 && count === nodeCount;
          try {
            for (var _f = __values$i(this.tableRows), _g = _f.next(); !_g.done; _g = _f.next()) {
              var row = _g.value;
              var cell = row.getChild(i);
              if (cell) {
                var child = cell.childNodes[0];
                var noStretch = child.stretch.dir === 0;
                if (all || noStretch) {
                  var w = child.getBBox(noStretch).w;
                  if (w > W) {
                    W = w;
                  }
                }
              }
            }
          } catch (e_2_1) {
            e_2 = {
              error: e_2_1
            };
          } finally {
            try {
              if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
            } finally {
              if (e_2) throw e_2.error;
            }
          }
        }
        try {
          for (var stretchy_1 = __values$i(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
            var child = stretchy_1_1.value;
            child.coreMO().getStretchedVariant([W]);
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (stretchy_1_1 && !stretchy_1_1.done && (_c = stretchy_1.return)) _c.call(stretchy_1);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
      }
    };
    class_1.prototype.getTableData = function () {
      if (this.data) {
        return this.data;
      }
      var H = new Array(this.numRows).fill(0);
      var D = new Array(this.numRows).fill(0);
      var W = new Array(this.numCols).fill(0);
      var NH = new Array(this.numRows);
      var ND = new Array(this.numRows);
      var LW = [0];
      var rows = this.tableRows;
      for (var j = 0; j < rows.length; j++) {
        var M = 0;
        var row = rows[j];
        var align = row.node.attributes.get('rowalign');
        for (var i = 0; i < row.numCells; i++) {
          var cell = row.getChild(i);
          M = this.updateHDW(cell, i, j, align, H, D, W, M);
          this.recordPWidthCell(cell, i);
        }
        NH[j] = H[j];
        ND[j] = D[j];
        if (row.labeled) {
          M = this.updateHDW(row.childNodes[0], 0, j, align, H, D, LW, M);
        }
        this.extendHD(j, H, D, M);
        this.extendHD(j, NH, ND, M);
      }
      var L = LW[0];
      this.data = {
        H: H,
        D: D,
        W: W,
        NH: NH,
        ND: ND,
        L: L
      };
      return this.data;
    };
    class_1.prototype.updateHDW = function (cell, i, j, align, H, D, W, M) {
      var _a = cell.getBBox(), h = _a.h, d = _a.d, w = _a.w;
      var scale = cell.parent.bbox.rscale;
      if (cell.parent.bbox.rscale !== 1) {
        h *= scale;
        d *= scale;
        w *= scale;
      }
      if (this.node.getProperty('useHeight')) {
        if (h < .75) h = .75;
        if (d < .25) d = .25;
      }
      var m = 0;
      align = cell.node.attributes.get('rowalign') || align;
      if (align !== 'baseline' && align !== 'axis') {
        m = h + d;
        h = d = 0;
      }
      if (h > H[j]) H[j] = h;
      if (d > D[j]) D[j] = d;
      if (m > M) M = m;
      if (W && w > W[i]) W[i] = w;
      return M;
    };
    class_1.prototype.extendHD = function (i, H, D, M) {
      var d = (M - (H[i] + D[i])) / 2;
      if (d < .00001) return;
      H[i] += d;
      D[i] += d;
    };
    class_1.prototype.recordPWidthCell = function (cell, i) {
      if (cell.childNodes[0] && cell.childNodes[0].getBBox().pwidth) {
        this.pwidthCells.push([cell, i]);
      }
    };
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      var _a = this.getTableData(), H = _a.H, D = _a.D;
      var height, width;
      if (this.node.attributes.get('equalrows')) {
        var HD = this.getEqualRowHeight();
        height = (0, numeric_js_1.sum)([].concat(this.rLines, this.rSpace)) + HD * this.numRows;
      } else {
        height = (0, numeric_js_1.sum)(H.concat(D, this.rLines, this.rSpace));
      }
      height += 2 * (this.fLine + this.fSpace[1]);
      var CW = this.getComputedWidths();
      width = (0, numeric_js_1.sum)(CW.concat(this.cLines, this.cSpace)) + 2 * (this.fLine + this.fSpace[0]);
      var w = this.node.attributes.get('width');
      if (w !== 'auto') {
        width = Math.max(this.length2em(w, 0) + 2 * this.fLine, width);
      }
      var _b = __read$d(this.getBBoxHD(height), 2), h = _b[0], d = _b[1];
      bbox.h = h;
      bbox.d = d;
      bbox.w = width;
      var _c = __read$d(this.getBBoxLR(), 2), L = _c[0], R = _c[1];
      bbox.L = L;
      bbox.R = R;
      if (!(0, string_js_1$4.isPercent)(w)) {
        this.setColumnPWidths();
      }
    };
    class_1.prototype.setChildPWidths = function (_recompute, cwidth, _clear) {
      var width = this.node.attributes.get('width');
      if (!(0, string_js_1$4.isPercent)(width)) return false;
      if (!this.hasLabels) {
        this.bbox.pwidth = '';
        this.container.bbox.pwidth = '';
      }
      var _a = this.bbox, w = _a.w, L = _a.L, R = _a.R;
      var labelInWidth = this.node.attributes.get('data-width-includes-label');
      var W = Math.max(w, this.length2em(width, Math.max(cwidth, L + w + R))) - (labelInWidth ? L + R : 0);
      var cols = this.node.attributes.get('equalcolumns') ? Array(this.numCols).fill(this.percent(1 / Math.max(1, this.numCols))) : this.getColumnAttributes('columnwidth', 0);
      this.cWidths = this.getColumnWidthsFixed(cols, W);
      var CW = this.getComputedWidths();
      this.pWidth = (0, numeric_js_1.sum)(CW.concat(this.cLines, this.cSpace)) + 2 * (this.fLine + this.fSpace[0]);
      if (this.isTop) {
        this.bbox.w = this.pWidth;
      }
      this.setColumnPWidths();
      if (this.pWidth !== w) {
        this.parent.invalidateBBox();
      }
      return this.pWidth !== w;
    };
    class_1.prototype.setColumnPWidths = function () {
      var e_4, _a;
      var W = this.cWidths;
      try {
        for (var _b = __values$i(this.pwidthCells), _c = _b.next(); !_c.done; _c = _b.next()) {
          var _d = __read$d(_c.value, 2), cell = _d[0], i = _d[1];
          if (cell.setChildPWidths(false, W[i])) {
            cell.invalidateBBox();
            cell.getBBox();
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
    };
    class_1.prototype.getBBoxHD = function (height) {
      var _a = __read$d(this.getAlignmentRow(), 2), align = _a[0], row = _a[1];
      if (row === null) {
        var a = this.font.params.axis_height;
        var h2 = height / 2;
        var HD = {
          top: [0, height],
          center: [h2, h2],
          bottom: [height, 0],
          baseline: [h2, h2],
          axis: [h2 + a, h2 - a]
        };
        return HD[align] || [h2, h2];
      } else {
        var y = this.getVerticalPosition(row, align);
        return [y, height - y];
      }
    };
    class_1.prototype.getBBoxLR = function () {
      if (this.hasLabels) {
        var attributes = this.node.attributes;
        var side = attributes.get('side');
        var _a = __read$d(this.getPadAlignShift(side), 2), pad = _a[0], align = _a[1];
        var labels = this.hasLabels && !!attributes.get('data-width-includes-label');
        if (labels && this.frame && this.fSpace[0]) {
          pad -= this.fSpace[0];
        }
        return align === 'center' && !labels ? [pad, pad] : side === 'left' ? [pad, 0] : [0, pad];
      }
      return [0, 0];
    };
    class_1.prototype.getPadAlignShift = function (side) {
      var L = this.getTableData().L;
      var sep = this.length2em(this.node.attributes.get('minlabelspacing'));
      var pad = L + sep;
      var _a = __read$d(this.styles == null ? ['', ''] : [this.styles.get('padding-left'), this.styles.get('padding-right')], 2), lpad = _a[0], rpad = _a[1];
      if (lpad || rpad) {
        pad = Math.max(pad, this.length2em(lpad || '0'), this.length2em(rpad || '0'));
      }
      var _b = __read$d(this.getAlignShift(), 2), align = _b[0], shift = _b[1];
      if (align === side) {
        shift = side === 'left' ? Math.max(pad, shift) - pad : Math.min(-pad, shift) + pad;
      }
      return [pad, align, shift];
    };
    class_1.prototype.getAlignShift = function () {
      return this.isTop ? _super.prototype.getAlignShift.call(this) : [this.container.getChildAlign(this.containerI), 0];
    };
    class_1.prototype.getWidth = function () {
      return this.pWidth || this.getBBox().w;
    };
    class_1.prototype.getEqualRowHeight = function () {
      var _a = this.getTableData(), H = _a.H, D = _a.D;
      var HD = Array.from(H.keys()).map(function (i) {
        return H[i] + D[i];
      });
      return Math.max.apply(Math, HD);
    };
    class_1.prototype.getComputedWidths = function () {
      var _this = this;
      var W = this.getTableData().W;
      var CW = Array.from(W.keys()).map(function (i) {
        return typeof _this.cWidths[i] === 'number' ? _this.cWidths[i] : W[i];
      });
      if (this.node.attributes.get('equalcolumns')) {
        CW = Array(CW.length).fill((0, numeric_js_1.max)(CW));
      }
      return CW;
    };
    class_1.prototype.getColumnWidths = function () {
      var width = this.node.attributes.get('width');
      if (this.node.attributes.get('equalcolumns')) {
        return this.getEqualColumns(width);
      }
      var swidths = this.getColumnAttributes('columnwidth', 0);
      if (width === 'auto') {
        return this.getColumnWidthsAuto(swidths);
      }
      if ((0, string_js_1$4.isPercent)(width)) {
        return this.getColumnWidthsPercent(swidths);
      }
      return this.getColumnWidthsFixed(swidths, this.length2em(width));
    };
    class_1.prototype.getEqualColumns = function (width) {
      var n = Math.max(1, this.numCols);
      var cwidth;
      if (width === 'auto') {
        var W = this.getTableData().W;
        cwidth = (0, numeric_js_1.max)(W);
      } else if ((0, string_js_1$4.isPercent)(width)) {
        cwidth = this.percent(1 / n);
      } else {
        var w = (0, numeric_js_1.sum)([].concat(this.cLines, this.cSpace)) + 2 * this.fSpace[0];
        cwidth = Math.max(0, this.length2em(width) - w) / n;
      }
      return Array(this.numCols).fill(cwidth);
    };
    class_1.prototype.getColumnWidthsAuto = function (swidths) {
      var _this = this;
      return swidths.map(function (x) {
        if (x === 'auto' || x === 'fit') return null;
        if ((0, string_js_1$4.isPercent)(x)) return x;
        return _this.length2em(x);
      });
    };
    class_1.prototype.getColumnWidthsPercent = function (swidths) {
      var _this = this;
      var hasFit = swidths.indexOf('fit') >= 0;
      var W = (hasFit ? this.getTableData() : {
        W: null
      }).W;
      return Array.from(swidths.keys()).map(function (i) {
        var x = swidths[i];
        if (x === 'fit') return null;
        if (x === 'auto') return hasFit ? W[i] : null;
        if ((0, string_js_1$4.isPercent)(x)) return x;
        return _this.length2em(x);
      });
    };
    class_1.prototype.getColumnWidthsFixed = function (swidths, width) {
      var _this = this;
      var indices = Array.from(swidths.keys());
      var fit = indices.filter(function (i) {
        return swidths[i] === 'fit';
      });
      var auto = indices.filter(function (i) {
        return swidths[i] === 'auto';
      });
      var n = fit.length || auto.length;
      var W = (n ? this.getTableData() : {
        W: null
      }).W;
      var cwidth = width - (0, numeric_js_1.sum)([].concat(this.cLines, this.cSpace)) - 2 * this.fSpace[0];
      var dw = cwidth;
      indices.forEach(function (i) {
        var x = swidths[i];
        dw -= x === 'fit' || x === 'auto' ? W[i] : _this.length2em(x, cwidth);
      });
      var fw = n && dw > 0 ? dw / n : 0;
      return indices.map(function (i) {
        var x = swidths[i];
        if (x === 'fit') return W[i] + fw;
        if (x === 'auto') return W[i] + (fit.length === 0 ? fw : 0);
        return _this.length2em(x, cwidth);
      });
    };
    class_1.prototype.getVerticalPosition = function (i, align) {
      var equal = this.node.attributes.get('equalrows');
      var _a = this.getTableData(), H = _a.H, D = _a.D;
      var HD = equal ? this.getEqualRowHeight() : 0;
      var space = this.getRowHalfSpacing();
      var y = this.fLine;
      for (var j = 0; j < i; j++) {
        y += space[j] + (equal ? HD : H[j] + D[j]) + space[j + 1] + this.rLines[j];
      }
      var _b = __read$d(equal ? [(HD + H[i] - D[i]) / 2, (HD - H[i] + D[i]) / 2] : [H[i], D[i]], 2), h = _b[0], d = _b[1];
      var offset = {
        top: 0,
        center: space[i] + (h + d) / 2,
        bottom: space[i] + h + d + space[i + 1],
        baseline: space[i] + h,
        axis: space[i] + h - .25
      };
      y += offset[align] || 0;
      return y;
    };
    class_1.prototype.getEmHalfSpacing = function (fspace, space, scale) {
      if (scale === void 0) {
        scale = 1;
      }
      var fspaceEm = this.em(fspace * scale);
      var spaceEm = this.addEm(space, 2 / scale);
      spaceEm.unshift(fspaceEm);
      spaceEm.push(fspaceEm);
      return spaceEm;
    };
    class_1.prototype.getRowHalfSpacing = function () {
      var space = this.rSpace.map(function (x) {
        return x / 2;
      });
      space.unshift(this.fSpace[1]);
      space.push(this.fSpace[1]);
      return space;
    };
    class_1.prototype.getColumnHalfSpacing = function () {
      var space = this.cSpace.map(function (x) {
        return x / 2;
      });
      space.unshift(this.fSpace[0]);
      space.push(this.fSpace[0]);
      return space;
    };
    class_1.prototype.getAlignmentRow = function () {
      var _a = __read$d((0, string_js_1$4.split)(this.node.attributes.get('align')), 2), align = _a[0], row = _a[1];
      if (row == null) return [align, null];
      var i = parseInt(row);
      if (i < 0) i += this.numRows + 1;
      return [align, i < 1 || i > this.numRows ? null : i - 1];
    };
    class_1.prototype.getColumnAttributes = function (name, i) {
      if (i === void 0) {
        i = 1;
      }
      var n = this.numCols - i;
      var columns = this.getAttributeArray(name);
      if (columns.length === 0) return null;
      while (columns.length < n) {
        columns.push(columns[columns.length - 1]);
      }
      if (columns.length > n) {
        columns.splice(n);
      }
      return columns;
    };
    class_1.prototype.getRowAttributes = function (name, i) {
      if (i === void 0) {
        i = 1;
      }
      var n = this.numRows - i;
      var rows = this.getAttributeArray(name);
      if (rows.length === 0) return null;
      while (rows.length < n) {
        rows.push(rows[rows.length - 1]);
      }
      if (rows.length > n) {
        rows.splice(n);
      }
      return rows;
    };
    class_1.prototype.getAttributeArray = function (name) {
      var value = this.node.attributes.get(name);
      if (!value) return [this.node.attributes.getDefault(name)];
      return (0, string_js_1$4.split)(value);
    };
    class_1.prototype.addEm = function (list, n) {
      var _this = this;
      if (n === void 0) {
        n = 1;
      }
      if (!list) return null;
      return list.map(function (x) {
        return _this.em(x / n);
      });
    };
    class_1.prototype.convertLengths = function (list) {
      var _this = this;
      if (!list) return null;
      return list.map(function (x) {
        return _this.length2em(x);
      });
    };
    return class_1;
  })(Base);
}
mtable$2.CommonMtableMixin = CommonMtableMixin;

var mtable$1 = {};

var __extends$R = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$h = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$h = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$h.apply(this, arguments);
});
var __values$h = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mtable$1, "__esModule", {
  value: true
});
mtable$1.MmlMtable = void 0;
var MmlNode_js_1$o = MmlNode;
var string_js_1$3 = string;
var MmlMtable = (function (_super) {
  __extends$R(MmlMtable, _super);
  function MmlMtable() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.properties = {
      useHeight: true
    };
    _this.texclass = MmlNode_js_1$o.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMtable.prototype, "kind", {
    get: function () {
      return 'mtable';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMtable.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMtable.prototype.setInheritedAttributes = function (attributes, display, level, prime) {
    var e_1, _a;
    try {
      for (var indentAttributes_1 = __values$h(MmlNode_js_1$o.indentAttributes), indentAttributes_1_1 = indentAttributes_1.next(); !indentAttributes_1_1.done; indentAttributes_1_1 = indentAttributes_1.next()) {
        var name_1 = indentAttributes_1_1.value;
        if (attributes[name_1]) {
          this.attributes.setInherited(name_1, attributes[name_1][1]);
        }
        if (this.attributes.getExplicit(name_1) !== undefined) {
          delete this.attributes.getAllAttributes()[name_1];
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (indentAttributes_1_1 && !indentAttributes_1_1.done && (_a = indentAttributes_1.return)) _a.call(indentAttributes_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    _super.prototype.setInheritedAttributes.call(this, attributes, display, level, prime);
  };
  MmlMtable.prototype.setChildInheritedAttributes = function (attributes, display, level, _prime) {
    var e_2, _a, e_3, _b;
    try {
      for (var _c = __values$h(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var child = _d.value;
        if (!child.isKind('mtr')) {
          this.replaceChild(this.factory.create('mtr'), child).appendChild(child);
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
    level = this.getProperty('scriptlevel') || level;
    display = !!(this.attributes.getExplicit('displaystyle') || this.attributes.getDefault('displaystyle'));
    attributes = this.addInheritedAttributes(attributes, {
      columnalign: this.attributes.get('columnalign'),
      rowalign: 'center'
    });
    var cramped = this.attributes.getExplicit('data-cramped');
    var ralign = (0, string_js_1$3.split)(this.attributes.get('rowalign'));
    try {
      for (var _e = __values$h(this.childNodes), _f = _e.next(); !_f.done; _f = _e.next()) {
        var child = _f.value;
        attributes.rowalign[1] = ralign.shift() || attributes.rowalign[1];
        child.setInheritedAttributes(attributes, display, level, !!cramped);
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
  };
  MmlMtable.prototype.verifyChildren = function (options) {
    var mtr = null;
    var factory = this.factory;
    for (var i = 0; i < this.childNodes.length; i++) {
      var child = this.childNodes[i];
      if (child.isKind('mtr')) {
        mtr = null;
      } else {
        var isMtd = child.isKind('mtd');
        if (mtr) {
          this.removeChild(child);
          i--;
        } else {
          mtr = this.replaceChild(factory.create('mtr'), child);
        }
        mtr.appendChild(isMtd ? child : factory.create('mtd', {}, [child]));
        if (!options['fixMtables']) {
          child.parent.removeChild(child);
          child.parent = this;
          isMtd && mtr.appendChild(factory.create('mtd'));
          var merror = child.mError('Children of ' + this.kind + ' must be mtr or mlabeledtr', options, isMtd);
          mtr.childNodes[mtr.childNodes.length - 1].appendChild(merror);
        }
      }
    }
    _super.prototype.verifyChildren.call(this, options);
  };
  MmlMtable.prototype.setTeXclass = function (prev) {
    var e_4, _a;
    this.getPrevClass(prev);
    try {
      for (var _b = __values$h(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        child.setTeXclass(null);
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    return this;
  };
  MmlMtable.defaults = __assign$h(__assign$h({}, MmlNode_js_1$o.AbstractMmlNode.defaults), {
    align: 'axis',
    rowalign: 'baseline',
    columnalign: 'center',
    groupalign: '{left}',
    alignmentscope: true,
    columnwidth: 'auto',
    width: 'auto',
    rowspacing: '1ex',
    columnspacing: '.8em',
    rowlines: 'none',
    columnlines: 'none',
    frame: 'none',
    framespacing: '0.4em 0.5ex',
    equalrows: false,
    equalcolumns: false,
    displaystyle: false,
    side: 'right',
    minlabelspacing: '0.8em'
  });
  return MmlMtable;
})(MmlNode_js_1$o.AbstractMmlNode);
mtable$1.MmlMtable = MmlMtable;

var __extends$Q = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$g = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$c = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(mtable$3, "__esModule", {
  value: true
});
mtable$3.CHTMLmtable = void 0;
var Wrapper_js_1$8 = Wrapper$3;
var mtable_js_1$2 = mtable$2;
var mtable_js_2 = mtable$1;
var string_js_1$2 = string;
var CHTMLmtable = (function (_super) {
  __extends$Q(CHTMLmtable, _super);
  function CHTMLmtable(factory, node, parent) {
    if (parent === void 0) {
      parent = null;
    }
    var _this = _super.call(this, factory, node, parent) || this;
    _this.itable = _this.html('mjx-itable');
    _this.labels = _this.html('mjx-itable');
    return _this;
  }
  CHTMLmtable.prototype.getAlignShift = function () {
    var data = _super.prototype.getAlignShift.call(this);
    if (!this.isTop) {
      data[1] = 0;
    }
    return data;
  };
  CHTMLmtable.prototype.toCHTML = function (parent) {
    var e_1, _a;
    var chtml = this.standardCHTMLnode(parent);
    this.adaptor.append(chtml, this.html('mjx-table', {}, [this.itable]));
    try {
      for (var _b = __values$g(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        child.toCHTML(this.itable);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    this.padRows();
    this.handleColumnSpacing();
    this.handleColumnLines();
    this.handleColumnWidths();
    this.handleRowSpacing();
    this.handleRowLines();
    this.handleRowHeights();
    this.handleFrame();
    this.handleWidth();
    this.handleLabels();
    this.handleAlign();
    this.handleJustify();
    this.shiftColor();
  };
  CHTMLmtable.prototype.shiftColor = function () {
    var adaptor = this.adaptor;
    var color = adaptor.getStyle(this.chtml, 'backgroundColor');
    if (color) {
      adaptor.setStyle(this.chtml, 'backgroundColor', '');
      adaptor.setStyle(this.itable, 'backgroundColor', color);
    }
  };
  CHTMLmtable.prototype.padRows = function () {
    var e_2, _a;
    var adaptor = this.adaptor;
    try {
      for (var _b = __values$g(adaptor.childNodes(this.itable)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var row = _c.value;
        while (adaptor.childNodes(row).length < this.numCols) {
          adaptor.append(row, this.html('mjx-mtd', {
            'extra': true
          }));
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  CHTMLmtable.prototype.handleColumnSpacing = function () {
    var e_3, _a, e_4, _b;
    var scale = this.childNodes[0] ? 1 / this.childNodes[0].getBBox().rscale : 1;
    var spacing = this.getEmHalfSpacing(this.fSpace[0], this.cSpace, scale);
    var frame = this.frame;
    try {
      for (var _c = __values$g(this.tableRows), _d = _c.next(); !_d.done; _d = _c.next()) {
        var row = _d.value;
        var i = 0;
        try {
          for (var _e = (e_4 = void 0, __values$g(row.tableCells)), _f = _e.next(); !_f.done; _f = _e.next()) {
            var cell = _f.value;
            var lspace = spacing[i++];
            var rspace = spacing[i];
            var styleNode = cell ? cell.chtml : this.adaptor.childNodes(row.chtml)[i];
            if (i > 1 && lspace !== '0.4em' || frame && i === 1) {
              this.adaptor.setStyle(styleNode, 'paddingLeft', lspace);
            }
            if (i < this.numCols && rspace !== '0.4em' || frame && i === this.numCols) {
              this.adaptor.setStyle(styleNode, 'paddingRight', rspace);
            }
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
  };
  CHTMLmtable.prototype.handleColumnLines = function () {
    var e_5, _a, e_6, _b;
    if (this.node.attributes.get('columnlines') === 'none') return;
    var lines = this.getColumnAttributes('columnlines');
    try {
      for (var _c = __values$g(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var row = _d.value;
        var i = 0;
        try {
          for (var _e = (e_6 = void 0, __values$g(this.adaptor.childNodes(row.chtml).slice(1))), _f = _e.next(); !_f.done; _f = _e.next()) {
            var cell = _f.value;
            var line = lines[i++];
            if (line === 'none') continue;
            this.adaptor.setStyle(cell, 'borderLeft', '.07em ' + line);
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_6) throw e_6.error;
          }
        }
      }
    } catch (e_5_1) {
      e_5 = {
        error: e_5_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_5) throw e_5.error;
      }
    }
  };
  CHTMLmtable.prototype.handleColumnWidths = function () {
    var e_7, _a, e_8, _b;
    try {
      for (var _c = __values$g(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var row = _d.value;
        var i = 0;
        try {
          for (var _e = (e_8 = void 0, __values$g(this.adaptor.childNodes(row.chtml))), _f = _e.next(); !_f.done; _f = _e.next()) {
            var cell = _f.value;
            var w = this.cWidths[i++];
            if (w !== null) {
              var width = typeof w === 'number' ? this.em(w) : w;
              this.adaptor.setStyle(cell, 'width', width);
              this.adaptor.setStyle(cell, 'maxWidth', width);
              this.adaptor.setStyle(cell, 'minWidth', width);
            }
          }
        } catch (e_8_1) {
          e_8 = {
            error: e_8_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_8) throw e_8.error;
          }
        }
      }
    } catch (e_7_1) {
      e_7 = {
        error: e_7_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_7) throw e_7.error;
      }
    }
  };
  CHTMLmtable.prototype.handleRowSpacing = function () {
    var e_9, _a, e_10, _b;
    var scale = this.childNodes[0] ? 1 / this.childNodes[0].getBBox().rscale : 1;
    var spacing = this.getEmHalfSpacing(this.fSpace[1], this.rSpace, scale);
    var frame = this.frame;
    var i = 0;
    try {
      for (var _c = __values$g(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var row = _d.value;
        var tspace = spacing[i++];
        var bspace = spacing[i];
        try {
          for (var _e = (e_10 = void 0, __values$g(row.childNodes)), _f = _e.next(); !_f.done; _f = _e.next()) {
            var cell = _f.value;
            if (i > 1 && tspace !== '0.215em' || frame && i === 1) {
              this.adaptor.setStyle(cell.chtml, 'paddingTop', tspace);
            }
            if (i < this.numRows && bspace !== '0.215em' || frame && i === this.numRows) {
              this.adaptor.setStyle(cell.chtml, 'paddingBottom', bspace);
            }
          }
        } catch (e_10_1) {
          e_10 = {
            error: e_10_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_10) throw e_10.error;
          }
        }
      }
    } catch (e_9_1) {
      e_9 = {
        error: e_9_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_9) throw e_9.error;
      }
    }
  };
  CHTMLmtable.prototype.handleRowLines = function () {
    var e_11, _a, e_12, _b;
    if (this.node.attributes.get('rowlines') === 'none') return;
    var lines = this.getRowAttributes('rowlines');
    var i = 0;
    try {
      for (var _c = __values$g(this.childNodes.slice(1)), _d = _c.next(); !_d.done; _d = _c.next()) {
        var row = _d.value;
        var line = lines[i++];
        if (line === 'none') continue;
        try {
          for (var _e = (e_12 = void 0, __values$g(this.adaptor.childNodes(row.chtml))), _f = _e.next(); !_f.done; _f = _e.next()) {
            var cell = _f.value;
            this.adaptor.setStyle(cell, 'borderTop', '.07em ' + line);
          }
        } catch (e_12_1) {
          e_12 = {
            error: e_12_1
          };
        } finally {
          try {
            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
          } finally {
            if (e_12) throw e_12.error;
          }
        }
      }
    } catch (e_11_1) {
      e_11 = {
        error: e_11_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_11) throw e_11.error;
      }
    }
  };
  CHTMLmtable.prototype.handleRowHeights = function () {
    if (this.node.attributes.get('equalrows')) {
      this.handleEqualRows();
    }
  };
  CHTMLmtable.prototype.handleEqualRows = function () {
    var space = this.getRowHalfSpacing();
    var _a = this.getTableData(), H = _a.H, D = _a.D, NH = _a.NH, ND = _a.ND;
    var HD = this.getEqualRowHeight();
    for (var i = 0; i < this.numRows; i++) {
      var row = this.childNodes[i];
      this.setRowHeight(row, HD + space[i] + space[i + 1] + this.rLines[i]);
      if (HD !== NH[i] + ND[i]) {
        this.setRowBaseline(row, HD, (HD - H[i] + D[i]) / 2);
      }
    }
  };
  CHTMLmtable.prototype.setRowHeight = function (row, HD) {
    this.adaptor.setStyle(row.chtml, 'height', this.em(HD));
  };
  CHTMLmtable.prototype.setRowBaseline = function (row, HD, D) {
    var e_13, _a;
    var ralign = row.node.attributes.get('rowalign');
    try {
      for (var _b = __values$g(row.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var cell = _c.value;
        if (this.setCellBaseline(cell, ralign, HD, D)) break;
      }
    } catch (e_13_1) {
      e_13 = {
        error: e_13_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_13) throw e_13.error;
      }
    }
  };
  CHTMLmtable.prototype.setCellBaseline = function (cell, ralign, HD, D) {
    var calign = cell.node.attributes.get('rowalign');
    if (calign === 'baseline' || calign === 'axis') {
      var adaptor = this.adaptor;
      var child = adaptor.lastChild(cell.chtml);
      adaptor.setStyle(child, 'height', this.em(HD));
      adaptor.setStyle(child, 'verticalAlign', this.em(-D));
      var row = cell.parent;
      if ((!row.node.isKind('mlabeledtr') || cell !== row.childNodes[0]) && (ralign === 'baseline' || ralign === 'axis')) {
        return true;
      }
    }
    return false;
  };
  CHTMLmtable.prototype.handleFrame = function () {
    if (this.frame && this.fLine) {
      this.adaptor.setStyle(this.itable, 'border', '.07em ' + this.node.attributes.get('frame'));
    }
  };
  CHTMLmtable.prototype.handleWidth = function () {
    var adaptor = this.adaptor;
    var _a = this.getBBox(), w = _a.w, L = _a.L, R = _a.R;
    adaptor.setStyle(this.chtml, 'minWidth', this.em(L + w + R));
    var W = this.node.attributes.get('width');
    if ((0, string_js_1$2.isPercent)(W)) {
      adaptor.setStyle(this.chtml, 'width', '');
      adaptor.setAttribute(this.chtml, 'width', 'full');
    } else if (!this.hasLabels) {
      if (W === 'auto') return;
      W = this.em(this.length2em(W) + 2 * this.fLine);
    }
    var table = adaptor.firstChild(this.chtml);
    adaptor.setStyle(table, 'width', W);
    adaptor.setStyle(table, 'minWidth', this.em(w));
    if (L || R) {
      adaptor.setStyle(this.chtml, 'margin', '');
      var style = this.node.attributes.get('data-width-includes-label') ? 'padding' : 'margin';
      if (L === R) {
        adaptor.setStyle(table, style, '0 ' + this.em(R));
      } else {
        adaptor.setStyle(table, style, '0 ' + this.em(R) + ' 0 ' + this.em(L));
      }
    }
    adaptor.setAttribute(this.itable, 'width', 'full');
  };
  CHTMLmtable.prototype.handleAlign = function () {
    var _a = __read$c(this.getAlignmentRow(), 2), align = _a[0], row = _a[1];
    if (row === null) {
      if (align !== 'axis') {
        this.adaptor.setAttribute(this.chtml, 'align', align);
      }
    } else {
      var y = this.getVerticalPosition(row, align);
      this.adaptor.setAttribute(this.chtml, 'align', 'top');
      this.adaptor.setStyle(this.chtml, 'verticalAlign', this.em(y));
    }
  };
  CHTMLmtable.prototype.handleJustify = function () {
    var align = this.getAlignShift()[0];
    if (align !== 'center') {
      this.adaptor.setAttribute(this.chtml, 'justify', align);
    }
  };
  CHTMLmtable.prototype.handleLabels = function () {
    if (!this.hasLabels) return;
    var labels = this.labels;
    var attributes = this.node.attributes;
    var adaptor = this.adaptor;
    var side = attributes.get('side');
    adaptor.setAttribute(this.chtml, 'side', side);
    adaptor.setAttribute(labels, 'align', side);
    adaptor.setStyle(labels, side, '0');
    var _a = __read$c(this.addLabelPadding(side), 2), align = _a[0], shift = _a[1];
    if (shift) {
      var table = adaptor.firstChild(this.chtml);
      this.setIndent(table, align, shift);
    }
    this.updateRowHeights();
    this.addLabelSpacing();
  };
  CHTMLmtable.prototype.addLabelPadding = function (side) {
    var _a = __read$c(this.getPadAlignShift(side), 3), align = _a[1], shift = _a[2];
    var styles = {};
    if (side === 'right' && !this.node.attributes.get('data-width-includes-label')) {
      var W = this.node.attributes.get('width');
      var _b = this.getBBox(), w = _b.w, L = _b.L, R = _b.R;
      styles.style = {
        width: (0, string_js_1$2.isPercent)(W) ? 'calc(' + W + ' + ' + this.em(L + R) + ')' : this.em(L + w + R)
      };
    }
    this.adaptor.append(this.chtml, this.html('mjx-labels', styles, [this.labels]));
    return [align, shift];
  };
  CHTMLmtable.prototype.updateRowHeights = function () {
    var _a = this.getTableData(), H = _a.H, D = _a.D, NH = _a.NH, ND = _a.ND;
    var space = this.getRowHalfSpacing();
    for (var i = 0; i < this.numRows; i++) {
      var row = this.childNodes[i];
      this.setRowHeight(row, H[i] + D[i] + space[i] + space[i + 1] + this.rLines[i]);
      if (H[i] !== NH[i] || D[i] !== ND[i]) {
        this.setRowBaseline(row, H[i] + D[i], D[i]);
      } else if (row.node.isKind('mlabeledtr')) {
        this.setCellBaseline(row.childNodes[0], '', H[i] + D[i], D[i]);
      }
    }
  };
  CHTMLmtable.prototype.addLabelSpacing = function () {
    var adaptor = this.adaptor;
    var equal = this.node.attributes.get('equalrows');
    var _a = this.getTableData(), H = _a.H, D = _a.D;
    var HD = equal ? this.getEqualRowHeight() : 0;
    var space = this.getRowHalfSpacing();
    var h = this.fLine;
    var current = adaptor.firstChild(this.labels);
    for (var i = 0; i < this.numRows; i++) {
      var row = this.childNodes[i];
      if (row.node.isKind('mlabeledtr')) {
        h && adaptor.insert(this.html('mjx-mtr', {
          style: {
            height: this.em(h)
          }
        }), current);
        adaptor.setStyle(current, 'height', this.em((equal ? HD : H[i] + D[i]) + space[i] + space[i + 1]));
        current = adaptor.next(current);
        h = this.rLines[i];
      } else {
        h += space[i] + (equal ? HD : H[i] + D[i]) + space[i + 1] + this.rLines[i];
      }
    }
  };
  CHTMLmtable.kind = mtable_js_2.MmlMtable.prototype.kind;
  CHTMLmtable.styles = {
    'mjx-mtable': {
      'vertical-align': '.25em',
      'text-align': 'center',
      'position': 'relative',
      'box-sizing': 'border-box',
      'border-spacing': 0,
      'border-collapse': 'collapse'
    },
    'mjx-mstyle[size="s"] mjx-mtable': {
      'vertical-align': '.354em'
    },
    'mjx-labels': {
      position: 'absolute',
      left: 0,
      top: 0
    },
    'mjx-table': {
      'display': 'inline-block',
      'vertical-align': '-.5ex',
      'box-sizing': 'border-box'
    },
    'mjx-table > mjx-itable': {
      'vertical-align': 'middle',
      'text-align': 'left',
      'box-sizing': 'border-box'
    },
    'mjx-labels > mjx-itable': {
      position: 'absolute',
      top: 0
    },
    'mjx-mtable[justify="left"]': {
      'text-align': 'left'
    },
    'mjx-mtable[justify="right"]': {
      'text-align': 'right'
    },
    'mjx-mtable[justify="left"][side="left"]': {
      'padding-right': '0 ! important'
    },
    'mjx-mtable[justify="left"][side="right"]': {
      'padding-left': '0 ! important'
    },
    'mjx-mtable[justify="right"][side="left"]': {
      'padding-right': '0 ! important'
    },
    'mjx-mtable[justify="right"][side="right"]': {
      'padding-left': '0 ! important'
    },
    'mjx-mtable[align]': {
      'vertical-align': 'baseline'
    },
    'mjx-mtable[align="top"] > mjx-table': {
      'vertical-align': 'top'
    },
    'mjx-mtable[align="bottom"] > mjx-table': {
      'vertical-align': 'bottom'
    },
    'mjx-mtable[side="right"] mjx-labels': {
      'min-width': '100%'
    }
  };
  return CHTMLmtable;
})((0, mtable_js_1$2.CommonMtableMixin)(Wrapper_js_1$8.CHTMLWrapper));
mtable$3.CHTMLmtable = CHTMLmtable;

var mtr$3 = {};

var mtr$2 = {};

var __extends$P = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$f = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mtr$2, "__esModule", {
  value: true
});
mtr$2.CommonMlabeledtrMixin = mtr$2.CommonMtrMixin = void 0;
function CommonMtrMixin(Base) {
  return (function (_super) {
    __extends$P(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_1.prototype, "fixesPWidth", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "numCells", {
      get: function () {
        return this.childNodes.length;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "labeled", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_1.prototype, "tableCells", {
      get: function () {
        return this.childNodes;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.getChild = function (i) {
      return this.childNodes[i];
    };
    class_1.prototype.getChildBBoxes = function () {
      return this.childNodes.map(function (cell) {
        return cell.getBBox();
      });
    };
    class_1.prototype.stretchChildren = function (HD) {
      var e_1, _a, e_2, _b, e_3, _c;
      if (HD === void 0) {
        HD = null;
      }
      var stretchy = [];
      var children = this.labeled ? this.childNodes.slice(1) : this.childNodes;
      try {
        for (var children_1 = __values$f(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
          var mtd = children_1_1.value;
          var child = mtd.childNodes[0];
          if (child.canStretch(1)) {
            stretchy.push(child);
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      var count = stretchy.length;
      var nodeCount = this.childNodes.length;
      if (count && nodeCount > 1) {
        if (HD === null) {
          var H = 0, D = 0;
          var all = count > 1 && count === nodeCount;
          try {
            for (var children_2 = __values$f(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
              var mtd = children_2_1.value;
              var child = mtd.childNodes[0];
              var noStretch = child.stretch.dir === 0;
              if (all || noStretch) {
                var _d = child.getBBox(noStretch), h = _d.h, d = _d.d;
                if (h > H) {
                  H = h;
                }
                if (d > D) {
                  D = d;
                }
              }
            }
          } catch (e_2_1) {
            e_2 = {
              error: e_2_1
            };
          } finally {
            try {
              if (children_2_1 && !children_2_1.done && (_b = children_2.return)) _b.call(children_2);
            } finally {
              if (e_2) throw e_2.error;
            }
          }
          HD = [H, D];
        }
        try {
          for (var stretchy_1 = __values$f(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
            var child = stretchy_1_1.value;
            child.coreMO().getStretchedVariant(HD);
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (stretchy_1_1 && !stretchy_1_1.done && (_c = stretchy_1.return)) _c.call(stretchy_1);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
      }
    };
    return class_1;
  })(Base);
}
mtr$2.CommonMtrMixin = CommonMtrMixin;
function CommonMlabeledtrMixin(Base) {
  return (function (_super) {
    __extends$P(class_2, _super);
    function class_2() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_2.prototype, "numCells", {
      get: function () {
        return Math.max(0, this.childNodes.length - 1);
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_2.prototype, "labeled", {
      get: function () {
        return true;
      },
      enumerable: false,
      configurable: true
    });
    Object.defineProperty(class_2.prototype, "tableCells", {
      get: function () {
        return this.childNodes.slice(1);
      },
      enumerable: false,
      configurable: true
    });
    class_2.prototype.getChild = function (i) {
      return this.childNodes[i + 1];
    };
    class_2.prototype.getChildBBoxes = function () {
      return this.childNodes.slice(1).map(function (cell) {
        return cell.getBBox();
      });
    };
    return class_2;
  })(Base);
}
mtr$2.CommonMlabeledtrMixin = CommonMlabeledtrMixin;

var mtr$1 = {};

var __extends$O = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$g = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$g = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$g.apply(this, arguments);
});
var __values$e = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(mtr$1, "__esModule", {
  value: true
});
mtr$1.MmlMlabeledtr = mtr$1.MmlMtr = void 0;
var MmlNode_js_1$n = MmlNode;
var Attributes_js_1$3 = Attributes;
var string_js_1$1 = string;
var MmlMtr = (function (_super) {
  __extends$O(MmlMtr, _super);
  function MmlMtr() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMtr.prototype, "kind", {
    get: function () {
      return 'mtr';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMtr.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMtr.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    var e_1, _a, e_2, _b;
    try {
      for (var _c = __values$e(this.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
        var child = _d.value;
        if (!child.isKind('mtd')) {
          this.replaceChild(this.factory.create('mtd'), child).appendChild(child);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    var calign = (0, string_js_1$1.split)(this.attributes.get('columnalign'));
    if (this.arity === 1) {
      calign.unshift(this.parent.attributes.get('side'));
    }
    attributes = this.addInheritedAttributes(attributes, {
      rowalign: this.attributes.get('rowalign'),
      columnalign: 'center'
    });
    try {
      for (var _e = __values$e(this.childNodes), _f = _e.next(); !_f.done; _f = _e.next()) {
        var child = _f.value;
        attributes.columnalign[1] = calign.shift() || attributes.columnalign[1];
        child.setInheritedAttributes(attributes, display, level, prime);
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  MmlMtr.prototype.verifyChildren = function (options) {
    var e_3, _a;
    if (this.parent && !this.parent.isKind('mtable')) {
      this.mError(this.kind + ' can only be a child of an mtable', options, true);
      return;
    }
    try {
      for (var _b = __values$e(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        if (!child.isKind('mtd')) {
          var mtd = this.replaceChild(this.factory.create('mtd'), child);
          mtd.appendChild(child);
          if (!options['fixMtables']) {
            child.mError('Children of ' + this.kind + ' must be mtd', options);
          }
        }
      }
    } catch (e_3_1) {
      e_3 = {
        error: e_3_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_3) throw e_3.error;
      }
    }
    _super.prototype.verifyChildren.call(this, options);
  };
  MmlMtr.prototype.setTeXclass = function (prev) {
    var e_4, _a;
    this.getPrevClass(prev);
    try {
      for (var _b = __values$e(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
        var child = _c.value;
        child.setTeXclass(null);
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
    return this;
  };
  MmlMtr.defaults = __assign$g(__assign$g({}, MmlNode_js_1$n.AbstractMmlNode.defaults), {
    rowalign: Attributes_js_1$3.INHERIT,
    columnalign: Attributes_js_1$3.INHERIT,
    groupalign: Attributes_js_1$3.INHERIT
  });
  return MmlMtr;
})(MmlNode_js_1$n.AbstractMmlNode);
mtr$1.MmlMtr = MmlMtr;
var MmlMlabeledtr = (function (_super) {
  __extends$O(MmlMlabeledtr, _super);
  function MmlMlabeledtr() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMlabeledtr.prototype, "kind", {
    get: function () {
      return 'mlabeledtr';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMlabeledtr.prototype, "arity", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  return MmlMlabeledtr;
})(MmlMtr);
mtr$1.MmlMlabeledtr = MmlMlabeledtr;

var __extends$N = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mtr$3, "__esModule", {
  value: true
});
mtr$3.CHTMLmlabeledtr = mtr$3.CHTMLmtr = void 0;
var Wrapper_js_1$7 = Wrapper$3;
var mtr_js_1$2 = mtr$2;
var mtr_js_2 = mtr$2;
var mtr_js_3 = mtr$1;
var CHTMLmtr = (function (_super) {
  __extends$N(CHTMLmtr, _super);
  function CHTMLmtr() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmtr.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
    var align = this.node.attributes.get('rowalign');
    if (align !== 'baseline') {
      this.adaptor.setAttribute(this.chtml, 'rowalign', align);
    }
  };
  CHTMLmtr.kind = mtr_js_3.MmlMtr.prototype.kind;
  CHTMLmtr.styles = {
    'mjx-mtr': {
      display: 'table-row'
    },
    'mjx-mtr[rowalign="top"] > mjx-mtd': {
      'vertical-align': 'top'
    },
    'mjx-mtr[rowalign="center"] > mjx-mtd': {
      'vertical-align': 'middle'
    },
    'mjx-mtr[rowalign="bottom"] > mjx-mtd': {
      'vertical-align': 'bottom'
    },
    'mjx-mtr[rowalign="baseline"] > mjx-mtd': {
      'vertical-align': 'baseline'
    },
    'mjx-mtr[rowalign="axis"] > mjx-mtd': {
      'vertical-align': '.25em'
    }
  };
  return CHTMLmtr;
})((0, mtr_js_1$2.CommonMtrMixin)(Wrapper_js_1$7.CHTMLWrapper));
mtr$3.CHTMLmtr = CHTMLmtr;
var CHTMLmlabeledtr = (function (_super) {
  __extends$N(CHTMLmlabeledtr, _super);
  function CHTMLmlabeledtr() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmlabeledtr.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
    var child = this.adaptor.firstChild(this.chtml);
    if (child) {
      this.adaptor.remove(child);
      var align = this.node.attributes.get('rowalign');
      var attr = align !== 'baseline' && align !== 'axis' ? {
        rowalign: align
      } : {};
      var row = this.html('mjx-mtr', attr, [child]);
      this.adaptor.append(this.parent.labels, row);
    }
  };
  CHTMLmlabeledtr.prototype.markUsed = function () {
    _super.prototype.markUsed.call(this);
    this.jax.wrapperUsage.add(CHTMLmtr.kind);
  };
  CHTMLmlabeledtr.kind = mtr_js_3.MmlMlabeledtr.prototype.kind;
  CHTMLmlabeledtr.styles = {
    'mjx-mlabeledtr': {
      display: 'table-row'
    },
    'mjx-mlabeledtr[rowalign="top"] > mjx-mtd': {
      'vertical-align': 'top'
    },
    'mjx-mlabeledtr[rowalign="center"] > mjx-mtd': {
      'vertical-align': 'middle'
    },
    'mjx-mlabeledtr[rowalign="bottom"] > mjx-mtd': {
      'vertical-align': 'bottom'
    },
    'mjx-mlabeledtr[rowalign="baseline"] > mjx-mtd': {
      'vertical-align': 'baseline'
    },
    'mjx-mlabeledtr[rowalign="axis"] > mjx-mtd': {
      'vertical-align': '.25em'
    }
  };
  return CHTMLmlabeledtr;
})((0, mtr_js_2.CommonMlabeledtrMixin)(CHTMLmtr));
mtr$3.CHTMLmlabeledtr = CHTMLmlabeledtr;

var mtd$2 = {};

var mtd$1 = {};

var __extends$M = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mtd$1, "__esModule", {
  value: true
});
mtd$1.CommonMtdMixin = void 0;
function CommonMtdMixin(Base) {
  return (function (_super) {
    __extends$M(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(class_1.prototype, "fixesPWidth", {
      get: function () {
        return false;
      },
      enumerable: false,
      configurable: true
    });
    class_1.prototype.invalidateBBox = function () {
      this.bboxComputed = false;
    };
    class_1.prototype.getWrapWidth = function (_j) {
      var table = this.parent.parent;
      var row = this.parent;
      var i = this.node.childPosition() - (row.labeled ? 1 : 0);
      return typeof table.cWidths[i] === 'number' ? table.cWidths[i] : table.getTableData().W[i];
    };
    class_1.prototype.getChildAlign = function (_i) {
      return this.node.attributes.get('columnalign');
    };
    return class_1;
  })(Base);
}
mtd$1.CommonMtdMixin = CommonMtdMixin;

var mtd = {};

var __extends$L = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$f = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$f = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$f.apply(this, arguments);
});
Object.defineProperty(mtd, "__esModule", {
  value: true
});
mtd.MmlMtd = void 0;
var MmlNode_js_1$m = MmlNode;
var Attributes_js_1$2 = Attributes;
var MmlMtd = (function (_super) {
  __extends$L(MmlMtd, _super);
  function MmlMtd() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMtd.prototype, "kind", {
    get: function () {
      return 'mtd';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMtd.prototype, "arity", {
    get: function () {
      return -1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMtd.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMtd.prototype.verifyChildren = function (options) {
    if (this.parent && !this.parent.isKind('mtr')) {
      this.mError(this.kind + ' can only be a child of an mtr or mlabeledtr', options, true);
      return;
    }
    _super.prototype.verifyChildren.call(this, options);
  };
  MmlMtd.prototype.setTeXclass = function (prev) {
    this.getPrevClass(prev);
    this.childNodes[0].setTeXclass(null);
    return this;
  };
  MmlMtd.defaults = __assign$f(__assign$f({}, MmlNode_js_1$m.AbstractMmlBaseNode.defaults), {
    rowspan: 1,
    columnspan: 1,
    rowalign: Attributes_js_1$2.INHERIT,
    columnalign: Attributes_js_1$2.INHERIT,
    groupalign: Attributes_js_1$2.INHERIT
  });
  return MmlMtd;
})(MmlNode_js_1$m.AbstractMmlBaseNode);
mtd.MmlMtd = MmlMtd;

var __extends$K = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mtd$2, "__esModule", {
  value: true
});
mtd$2.CHTMLmtd = void 0;
var Wrapper_js_1$6 = Wrapper$3;
var mtd_js_1$2 = mtd$1;
var mtd_js_2 = mtd;
var CHTMLmtd = (function (_super) {
  __extends$K(CHTMLmtd, _super);
  function CHTMLmtd() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmtd.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
    var ralign = this.node.attributes.get('rowalign');
    var calign = this.node.attributes.get('columnalign');
    var palign = this.parent.node.attributes.get('rowalign');
    if (ralign !== palign) {
      this.adaptor.setAttribute(this.chtml, 'rowalign', ralign);
    }
    if (calign !== 'center' && (this.parent.kind !== 'mlabeledtr' || this !== this.parent.childNodes[0] || calign !== this.parent.parent.node.attributes.get('side'))) {
      this.adaptor.setStyle(this.chtml, 'textAlign', calign);
    }
    if (this.parent.parent.node.getProperty('useHeight')) {
      this.adaptor.append(this.chtml, this.html('mjx-tstrut'));
    }
  };
  CHTMLmtd.kind = mtd_js_2.MmlMtd.prototype.kind;
  CHTMLmtd.styles = {
    'mjx-mtd': {
      display: 'table-cell',
      'text-align': 'center',
      'padding': '.215em .4em'
    },
    'mjx-mtd:first-child': {
      'padding-left': 0
    },
    'mjx-mtd:last-child': {
      'padding-right': 0
    },
    'mjx-mtable > * > mjx-itable > *:first-child > mjx-mtd': {
      'padding-top': 0
    },
    'mjx-mtable > * > mjx-itable > *:last-child > mjx-mtd': {
      'padding-bottom': 0
    },
    'mjx-tstrut': {
      display: 'inline-block',
      height: '1em',
      'vertical-align': '-.25em'
    },
    'mjx-labels[align="left"] > mjx-mtr > mjx-mtd': {
      'text-align': 'left'
    },
    'mjx-labels[align="right"] > mjx-mtr > mjx-mtd': {
      'text-align': 'right'
    },
    'mjx-mtd[extra]': {
      padding: 0
    },
    'mjx-mtd[rowalign="top"]': {
      'vertical-align': 'top'
    },
    'mjx-mtd[rowalign="center"]': {
      'vertical-align': 'middle'
    },
    'mjx-mtd[rowalign="bottom"]': {
      'vertical-align': 'bottom'
    },
    'mjx-mtd[rowalign="baseline"]': {
      'vertical-align': 'baseline'
    },
    'mjx-mtd[rowalign="axis"]': {
      'vertical-align': '.25em'
    }
  };
  return CHTMLmtd;
})((0, mtd_js_1$2.CommonMtdMixin)(Wrapper_js_1$6.CHTMLWrapper));
mtd$2.CHTMLmtd = CHTMLmtd;

var maction$3 = {};

var maction$2 = {};

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CommonMactionMixin = exports.TooltipData = void 0;
  var string_js_1 = string;
  exports.TooltipData = {
    dx: '.2em',
    dy: '.1em',
    postDelay: 600,
    clearDelay: 100,
    hoverTimer: new Map(),
    clearTimer: new Map(),
    stopTimers: function (node, data) {
      if (data.clearTimer.has(node)) {
        clearTimeout(data.clearTimer.get(node));
        data.clearTimer.delete(node);
      }
      if (data.hoverTimer.has(node)) {
        clearTimeout(data.hoverTimer.get(node));
        data.hoverTimer.delete(node);
      }
    }
  };
  function CommonMactionMixin(Base) {
    return (function (_super) {
      __extends(class_1, _super);
      function class_1() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
        }
        var _this = _super.apply(this, __spreadArray([], __read(args), false)) || this;
        var actions = _this.constructor.actions;
        var action = _this.node.attributes.get('actiontype');
        var _a = __read(actions.get(action) || [function (_node, _data) {}, {}], 2), handler = _a[0], data = _a[1];
        _this.action = handler;
        _this.data = data;
        _this.getParameters();
        return _this;
      }
      Object.defineProperty(class_1.prototype, "selected", {
        get: function () {
          var selection = this.node.attributes.get('selection');
          var i = Math.max(1, Math.min(this.childNodes.length, selection)) - 1;
          return this.childNodes[i] || this.wrap(this.node.selected);
        },
        enumerable: false,
        configurable: true
      });
      class_1.prototype.getParameters = function () {
        var offsets = this.node.attributes.get('data-offsets');
        var _a = __read((0, string_js_1.split)(offsets || ''), 2), dx = _a[0], dy = _a[1];
        this.dx = this.length2em(dx || exports.TooltipData.dx);
        this.dy = this.length2em(dy || exports.TooltipData.dy);
      };
      class_1.prototype.computeBBox = function (bbox, recompute) {
        if (recompute === void 0) {
          recompute = false;
        }
        bbox.updateFrom(this.selected.getOuterBBox());
        this.selected.setChildPWidths(recompute);
      };
      return class_1;
    })(Base);
  }
  exports.CommonMactionMixin = CommonMactionMixin;
})(maction$2);
getDefaultExportFromCjs(maction$2);

var maction$1 = {};

var __extends$J = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$e = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$e = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$e.apply(this, arguments);
});
Object.defineProperty(maction$1, "__esModule", {
  value: true
});
maction$1.MmlMaction = void 0;
var MmlNode_js_1$l = MmlNode;
var MmlMaction = (function (_super) {
  __extends$J(MmlMaction, _super);
  function MmlMaction() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMaction.prototype, "kind", {
    get: function () {
      return 'maction';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMaction.prototype, "arity", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMaction.prototype, "selected", {
    get: function () {
      var selection = this.attributes.get('selection');
      var i = Math.max(1, Math.min(this.childNodes.length, selection)) - 1;
      return this.childNodes[i] || this.factory.create('mrow');
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMaction.prototype, "isEmbellished", {
    get: function () {
      return this.selected.isEmbellished;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMaction.prototype, "isSpacelike", {
    get: function () {
      return this.selected.isSpacelike;
    },
    enumerable: false,
    configurable: true
  });
  MmlMaction.prototype.core = function () {
    return this.selected.core();
  };
  MmlMaction.prototype.coreMO = function () {
    return this.selected.coreMO();
  };
  MmlMaction.prototype.verifyAttributes = function (options) {
    _super.prototype.verifyAttributes.call(this, options);
    if (this.attributes.get('actiontype') !== 'toggle' && this.attributes.getExplicit('selection') !== undefined) {
      var attributes = this.attributes.getAllAttributes();
      delete attributes.selection;
    }
  };
  MmlMaction.prototype.setTeXclass = function (prev) {
    if (this.attributes.get('actiontype') === 'tooltip' && this.childNodes[1]) {
      this.childNodes[1].setTeXclass(null);
    }
    var selected = this.selected;
    prev = selected.setTeXclass(prev);
    this.updateTeXclass(selected);
    return prev;
  };
  MmlMaction.prototype.nextToggleSelection = function () {
    var selection = Math.max(1, this.attributes.get('selection') + 1);
    if (selection > this.childNodes.length) {
      selection = 1;
    }
    this.attributes.set('selection', selection);
  };
  MmlMaction.defaults = __assign$e(__assign$e({}, MmlNode_js_1$l.AbstractMmlNode.defaults), {
    actiontype: 'toggle',
    selection: 1
  });
  return MmlMaction;
})(MmlNode_js_1$l.AbstractMmlNode);
maction$1.MmlMaction = MmlMaction;

var __extends$I = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(maction$3, "__esModule", {
  value: true
});
maction$3.CHTMLmaction = void 0;
var Wrapper_js_1$5 = Wrapper$3;
var maction_js_1$2 = maction$2;
var maction_js_2 = maction$2;
var maction_js_3 = maction$1;
var CHTMLmaction = (function (_super) {
  __extends$I(CHTMLmaction, _super);
  function CHTMLmaction() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmaction.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    var child = this.selected;
    child.toCHTML(chtml);
    this.action(this, this.data);
  };
  CHTMLmaction.prototype.setEventHandler = function (type, handler) {
    this.chtml.addEventListener(type, handler);
  };
  CHTMLmaction.kind = maction_js_3.MmlMaction.prototype.kind;
  CHTMLmaction.styles = {
    'mjx-maction': {
      position: 'relative'
    },
    'mjx-maction > mjx-tool': {
      display: 'none',
      position: 'absolute',
      bottom: 0,
      right: 0,
      width: 0,
      height: 0,
      'z-index': 500
    },
    'mjx-tool > mjx-tip': {
      display: 'inline-block',
      padding: '.2em',
      border: '1px solid #888',
      'font-size': '70%',
      'background-color': '#F8F8F8',
      color: 'black',
      'box-shadow': '2px 2px 5px #AAAAAA'
    },
    'mjx-maction[toggle]': {
      cursor: 'pointer'
    },
    'mjx-status': {
      display: 'block',
      position: 'fixed',
      left: '1em',
      bottom: '1em',
      'min-width': '25%',
      padding: '.2em .4em',
      border: '1px solid #888',
      'font-size': '90%',
      'background-color': '#F8F8F8',
      color: 'black'
    }
  };
  CHTMLmaction.actions = new Map([['toggle', [function (node, _data) {
    node.adaptor.setAttribute(node.chtml, 'toggle', node.node.attributes.get('selection'));
    var math = node.factory.jax.math;
    var document = node.factory.jax.document;
    var mml = node.node;
    node.setEventHandler('click', function (event) {
      if (!math.end.node) {
        math.start.node = math.end.node = math.typesetRoot;
        math.start.n = math.end.n = 0;
      }
      mml.nextToggleSelection();
      math.rerender(document);
      event.stopPropagation();
    });
  }, {}]], ['tooltip', [function (node, data) {
    var tip = node.childNodes[1];
    if (!tip) return;
    if (tip.node.isKind('mtext')) {
      var text = tip.node.getText();
      node.adaptor.setAttribute(node.chtml, 'title', text);
    } else {
      var adaptor_1 = node.adaptor;
      var tool_1 = adaptor_1.append(node.chtml, node.html('mjx-tool', {
        style: {
          bottom: node.em(-node.dy),
          right: node.em(-node.dx)
        }
      }, [node.html('mjx-tip')]));
      tip.toCHTML(adaptor_1.firstChild(tool_1));
      node.setEventHandler('mouseover', function (event) {
        data.stopTimers(node, data);
        var timeout = setTimeout(function () {
          return adaptor_1.setStyle(tool_1, 'display', 'block');
        }, data.postDelay);
        data.hoverTimer.set(node, timeout);
        event.stopPropagation();
      });
      node.setEventHandler('mouseout', function (event) {
        data.stopTimers(node, data);
        var timeout = setTimeout(function () {
          return adaptor_1.setStyle(tool_1, 'display', '');
        }, data.clearDelay);
        data.clearTimer.set(node, timeout);
        event.stopPropagation();
      });
    }
  }, maction_js_2.TooltipData]], ['statusline', [function (node, data) {
    var tip = node.childNodes[1];
    if (!tip) return;
    if (tip.node.isKind('mtext')) {
      var adaptor_2 = node.adaptor;
      var text_1 = tip.node.getText();
      adaptor_2.setAttribute(node.chtml, 'statusline', text_1);
      node.setEventHandler('mouseover', function (event) {
        if (data.status === null) {
          var body = adaptor_2.body(adaptor_2.document);
          data.status = adaptor_2.append(body, node.html('mjx-status', {}, [node.text(text_1)]));
        }
        event.stopPropagation();
      });
      node.setEventHandler('mouseout', function (event) {
        if (data.status) {
          adaptor_2.remove(data.status);
          data.status = null;
        }
        event.stopPropagation();
      });
    }
  }, {
    status: null
  }]]]);
  return CHTMLmaction;
})((0, maction_js_1$2.CommonMactionMixin)(Wrapper_js_1$5.CHTMLWrapper));
maction$3.CHTMLmaction = CHTMLmaction;

var mglyph$2 = {};

var mglyph$1 = {};

var __extends$H = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __read$b = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$5 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(mglyph$1, "__esModule", {
  value: true
});
mglyph$1.CommonMglyphMixin = void 0;
function CommonMglyphMixin(Base) {
  return (function (_super) {
    __extends$H(class_1, _super);
    function class_1() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      var _this = _super.apply(this, __spreadArray$5([], __read$b(args), false)) || this;
      _this.getParameters();
      return _this;
    }
    class_1.prototype.getParameters = function () {
      var _a = this.node.attributes.getList('width', 'height', 'valign', 'src', 'index'), width = _a.width, height = _a.height, valign = _a.valign, src = _a.src, index = _a.index;
      if (src) {
        this.width = width === 'auto' ? 1 : this.length2em(width);
        this.height = height === 'auto' ? 1 : this.length2em(height);
        this.valign = this.length2em(valign || '0');
      } else {
        var text = String.fromCodePoint(parseInt(index));
        var mmlFactory = this.node.factory;
        this.charWrapper = this.wrap(mmlFactory.create('text').setText(text));
        this.charWrapper.parent = this;
      }
    };
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      if (this.charWrapper) {
        bbox.updateFrom(this.charWrapper.getBBox());
      } else {
        bbox.w = this.width;
        bbox.h = this.height + this.valign;
        bbox.d = -this.valign;
      }
    };
    return class_1;
  })(Base);
}
mglyph$1.CommonMglyphMixin = CommonMglyphMixin;

var mglyph = {};

var __extends$G = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$d = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$d = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$d.apply(this, arguments);
});
Object.defineProperty(mglyph, "__esModule", {
  value: true
});
mglyph.MmlMglyph = void 0;
var MmlNode_js_1$k = MmlNode;
var MmlMglyph = (function (_super) {
  __extends$G(MmlMglyph, _super);
  function MmlMglyph() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$k.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMglyph.prototype, "kind", {
    get: function () {
      return 'mglyph';
    },
    enumerable: false,
    configurable: true
  });
  MmlMglyph.prototype.verifyAttributes = function (options) {
    var _a = this.attributes.getList('src', 'fontfamily', 'index'), src = _a.src, fontfamily = _a.fontfamily, index = _a.index;
    if (src === '' && (fontfamily === '' || index === '')) {
      this.mError('mglyph must have either src or fontfamily and index attributes', options, true);
    } else {
      _super.prototype.verifyAttributes.call(this, options);
    }
  };
  MmlMglyph.defaults = __assign$d(__assign$d({}, MmlNode_js_1$k.AbstractMmlTokenNode.defaults), {
    alt: '',
    src: '',
    index: '',
    width: 'auto',
    height: 'auto',
    valign: '0em'
  });
  return MmlMglyph;
})(MmlNode_js_1$k.AbstractMmlTokenNode);
mglyph.MmlMglyph = MmlMglyph;

var __extends$F = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(mglyph$2, "__esModule", {
  value: true
});
mglyph$2.CHTMLmglyph = void 0;
var Wrapper_js_1$4 = Wrapper$3;
var mglyph_js_1$2 = mglyph$1;
var mglyph_js_2 = mglyph;
var CHTMLmglyph = (function (_super) {
  __extends$F(CHTMLmglyph, _super);
  function CHTMLmglyph() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLmglyph.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    if (this.charWrapper) {
      this.charWrapper.toCHTML(chtml);
      return;
    }
    var _a = this.node.attributes.getList('src', 'alt'), src = _a.src, alt = _a.alt;
    var styles = {
      width: this.em(this.width),
      height: this.em(this.height)
    };
    if (this.valign) {
      styles.verticalAlign = this.em(this.valign);
    }
    var img = this.html('img', {
      src: src,
      style: styles,
      alt: alt,
      title: alt
    });
    this.adaptor.append(chtml, img);
  };
  CHTMLmglyph.kind = mglyph_js_2.MmlMglyph.prototype.kind;
  CHTMLmglyph.styles = {
    'mjx-mglyph > img': {
      display: 'inline-block',
      border: 0,
      padding: 0
    }
  };
  return CHTMLmglyph;
})((0, mglyph_js_1$2.CommonMglyphMixin)(Wrapper_js_1$4.CHTMLWrapper));
mglyph$2.CHTMLmglyph = CHTMLmglyph;

var semantics$2 = {};

var semantics$1 = {};

var __extends$E = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(semantics$1, "__esModule", {
  value: true
});
semantics$1.CommonSemanticsMixin = void 0;
function CommonSemanticsMixin(Base) {
  return (function (_super) {
    __extends$E(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      if (this.childNodes.length) {
        var _a = this.childNodes[0].getBBox(), w = _a.w, h = _a.h, d = _a.d;
        bbox.w = w;
        bbox.h = h;
        bbox.d = d;
      }
    };
    return class_1;
  })(Base);
}
semantics$1.CommonSemanticsMixin = CommonSemanticsMixin;

var semantics = {};

var __extends$D = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$c = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$c = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$c.apply(this, arguments);
});
Object.defineProperty(semantics, "__esModule", {
  value: true
});
semantics.MmlAnnotation = semantics.MmlAnnotationXML = semantics.MmlSemantics = void 0;
var MmlNode_js_1$j = MmlNode;
var MmlSemantics = (function (_super) {
  __extends$D(MmlSemantics, _super);
  function MmlSemantics() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlSemantics.prototype, "kind", {
    get: function () {
      return 'semantics';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlSemantics.prototype, "arity", {
    get: function () {
      return 1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlSemantics.prototype, "notParent", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlSemantics.defaults = __assign$c(__assign$c({}, MmlNode_js_1$j.AbstractMmlBaseNode.defaults), {
    definitionUrl: null,
    encoding: null
  });
  return MmlSemantics;
})(MmlNode_js_1$j.AbstractMmlBaseNode);
semantics.MmlSemantics = MmlSemantics;
var MmlAnnotationXML = (function (_super) {
  __extends$D(MmlAnnotationXML, _super);
  function MmlAnnotationXML() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlAnnotationXML.prototype, "kind", {
    get: function () {
      return 'annotation-xml';
    },
    enumerable: false,
    configurable: true
  });
  MmlAnnotationXML.prototype.setChildInheritedAttributes = function () {};
  MmlAnnotationXML.defaults = __assign$c(__assign$c({}, MmlNode_js_1$j.AbstractMmlNode.defaults), {
    definitionUrl: null,
    encoding: null,
    cd: 'mathmlkeys',
    name: '',
    src: null
  });
  return MmlAnnotationXML;
})(MmlNode_js_1$j.AbstractMmlNode);
semantics.MmlAnnotationXML = MmlAnnotationXML;
var MmlAnnotation = (function (_super) {
  __extends$D(MmlAnnotation, _super);
  function MmlAnnotation() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.properties = {
      isChars: true
    };
    return _this;
  }
  Object.defineProperty(MmlAnnotation.prototype, "kind", {
    get: function () {
      return 'annotation';
    },
    enumerable: false,
    configurable: true
  });
  MmlAnnotation.defaults = __assign$c({}, MmlAnnotationXML.defaults);
  return MmlAnnotation;
})(MmlAnnotationXML);
semantics.MmlAnnotation = MmlAnnotation;

var __extends$C = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(semantics$2, "__esModule", {
  value: true
});
semantics$2.CHTMLxml = semantics$2.CHTMLannotationXML = semantics$2.CHTMLannotation = semantics$2.CHTMLsemantics = void 0;
var Wrapper_js_1$3 = Wrapper$3;
var semantics_js_1$2 = semantics$1;
var semantics_js_2 = semantics;
var MmlNode_js_1$i = MmlNode;
var CHTMLsemantics = (function (_super) {
  __extends$C(CHTMLsemantics, _super);
  function CHTMLsemantics() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLsemantics.prototype.toCHTML = function (parent) {
    var chtml = this.standardCHTMLnode(parent);
    if (this.childNodes.length) {
      this.childNodes[0].toCHTML(chtml);
    }
  };
  CHTMLsemantics.kind = semantics_js_2.MmlSemantics.prototype.kind;
  return CHTMLsemantics;
})((0, semantics_js_1$2.CommonSemanticsMixin)(Wrapper_js_1$3.CHTMLWrapper));
semantics$2.CHTMLsemantics = CHTMLsemantics;
var CHTMLannotation = (function (_super) {
  __extends$C(CHTMLannotation, _super);
  function CHTMLannotation() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLannotation.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
  };
  CHTMLannotation.prototype.computeBBox = function () {
    return this.bbox;
  };
  CHTMLannotation.kind = semantics_js_2.MmlAnnotation.prototype.kind;
  return CHTMLannotation;
})(Wrapper_js_1$3.CHTMLWrapper);
semantics$2.CHTMLannotation = CHTMLannotation;
var CHTMLannotationXML = (function (_super) {
  __extends$C(CHTMLannotationXML, _super);
  function CHTMLannotationXML() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLannotationXML.kind = semantics_js_2.MmlAnnotationXML.prototype.kind;
  CHTMLannotationXML.styles = {
    'mjx-annotation-xml': {
      'font-family': 'initial',
      'line-height': 'normal'
    }
  };
  return CHTMLannotationXML;
})(Wrapper_js_1$3.CHTMLWrapper);
semantics$2.CHTMLannotationXML = CHTMLannotationXML;
var CHTMLxml = (function (_super) {
  __extends$C(CHTMLxml, _super);
  function CHTMLxml() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLxml.prototype.toCHTML = function (parent) {
    this.chtml = this.adaptor.append(parent, this.adaptor.clone(this.node.getXML()));
  };
  CHTMLxml.prototype.computeBBox = function (bbox, _recompute) {
    var _a = this.jax.measureXMLnode(this.node.getXML()), w = _a.w, h = _a.h, d = _a.d;
    bbox.w = w;
    bbox.h = h;
    bbox.d = d;
  };
  CHTMLxml.prototype.getStyles = function () {};
  CHTMLxml.prototype.getScale = function () {};
  CHTMLxml.prototype.getVariant = function () {};
  CHTMLxml.kind = MmlNode_js_1$i.XMLNode.prototype.kind;
  CHTMLxml.autoStyle = false;
  return CHTMLxml;
})(Wrapper_js_1$3.CHTMLWrapper);
semantics$2.CHTMLxml = CHTMLxml;

var TeXAtom$3 = {};

var TeXAtom$2 = {};

var __extends$B = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(TeXAtom$2, "__esModule", {
  value: true
});
TeXAtom$2.CommonTeXAtomMixin = void 0;
var MmlNode_js_1$h = MmlNode;
function CommonTeXAtomMixin(Base) {
  return (function (_super) {
    __extends$B(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.computeBBox = function (bbox, recompute) {
      if (recompute === void 0) {
        recompute = false;
      }
      _super.prototype.computeBBox.call(this, bbox, recompute);
      if (this.childNodes[0] && this.childNodes[0].bbox.ic) {
        bbox.ic = this.childNodes[0].bbox.ic;
      }
      if (this.node.texClass === MmlNode_js_1$h.TEXCLASS.VCENTER) {
        var h = bbox.h, d = bbox.d;
        var a = this.font.params.axis_height;
        var dh = (h + d) / 2 + a - h;
        bbox.h += dh;
        bbox.d -= dh;
      }
    };
    return class_1;
  })(Base);
}
TeXAtom$2.CommonTeXAtomMixin = CommonTeXAtomMixin;

var TeXAtom$1 = {};

var __extends$A = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$b = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$b = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$b.apply(this, arguments);
});
Object.defineProperty(TeXAtom$1, "__esModule", {
  value: true
});
TeXAtom$1.TeXAtom = void 0;
var MmlNode_js_1$g = MmlNode;
var mo_js_1$2 = mo$3;
var TeXAtom = (function (_super) {
  __extends$A(TeXAtom, _super);
  function TeXAtom(factory, attributes, children) {
    var _this = _super.call(this, factory, attributes, children) || this;
    _this.texclass = MmlNode_js_1$g.TEXCLASS.ORD;
    _this.setProperty('texClass', _this.texClass);
    return _this;
  }
  Object.defineProperty(TeXAtom.prototype, "kind", {
    get: function () {
      return 'TeXAtom';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TeXAtom.prototype, "arity", {
    get: function () {
      return -1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TeXAtom.prototype, "notParent", {
    get: function () {
      return this.childNodes[0] && this.childNodes[0].childNodes.length === 1;
    },
    enumerable: false,
    configurable: true
  });
  TeXAtom.prototype.setTeXclass = function (prev) {
    this.childNodes[0].setTeXclass(null);
    return this.adjustTeXclass(prev);
  };
  TeXAtom.prototype.adjustTeXclass = function (prev) {
    return prev;
  };
  TeXAtom.defaults = __assign$b({}, MmlNode_js_1$g.AbstractMmlBaseNode.defaults);
  return TeXAtom;
})(MmlNode_js_1$g.AbstractMmlBaseNode);
TeXAtom$1.TeXAtom = TeXAtom;
TeXAtom.prototype.adjustTeXclass = mo_js_1$2.MmlMo.prototype.adjustTeXclass;

var __extends$z = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(TeXAtom$3, "__esModule", {
  value: true
});
TeXAtom$3.CHTMLTeXAtom = void 0;
var Wrapper_js_1$2 = Wrapper$3;
var TeXAtom_js_1$2 = TeXAtom$2;
var TeXAtom_js_2 = TeXAtom$1;
var MmlNode_js_1$f = MmlNode;
var CHTMLTeXAtom = (function (_super) {
  __extends$z(CHTMLTeXAtom, _super);
  function CHTMLTeXAtom() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLTeXAtom.prototype.toCHTML = function (parent) {
    _super.prototype.toCHTML.call(this, parent);
    this.adaptor.setAttribute(this.chtml, 'texclass', MmlNode_js_1$f.TEXCLASSNAMES[this.node.texClass]);
    if (this.node.texClass === MmlNode_js_1$f.TEXCLASS.VCENTER) {
      var bbox = this.childNodes[0].getBBox();
      var h = bbox.h, d = bbox.d;
      var a = this.font.params.axis_height;
      var dh = (h + d) / 2 + a - h;
      this.adaptor.setStyle(this.chtml, 'verticalAlign', this.em(dh));
    }
  };
  CHTMLTeXAtom.kind = TeXAtom_js_2.TeXAtom.prototype.kind;
  return CHTMLTeXAtom;
})((0, TeXAtom_js_1$2.CommonTeXAtomMixin)(Wrapper_js_1$2.CHTMLWrapper));
TeXAtom$3.CHTMLTeXAtom = CHTMLTeXAtom;

var TextNode$1 = {};

var TextNode = {};

var __extends$y = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$d = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$a = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(TextNode, "__esModule", {
  value: true
});
TextNode.CommonTextNodeMixin = void 0;
function CommonTextNodeMixin(Base) {
  return (function (_super) {
    __extends$y(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.computeBBox = function (bbox, _recompute) {
      var e_1, _a;
      var variant = this.parent.variant;
      var text = this.node.getText();
      if (variant === '-explicitFont') {
        var font = this.jax.getFontData(this.parent.styles);
        var _b = this.jax.measureText(text, variant, font), w = _b.w, h = _b.h, d = _b.d;
        bbox.h = h;
        bbox.d = d;
        bbox.w = w;
      } else {
        var chars = this.remappedText(text, variant);
        bbox.empty();
        try {
          for (var chars_1 = __values$d(chars), chars_1_1 = chars_1.next(); !chars_1_1.done; chars_1_1 = chars_1.next()) {
            var char = chars_1_1.value;
            var _c = __read$a(this.getVariantChar(variant, char), 4), h = _c[0], d = _c[1], w = _c[2], data = _c[3];
            if (data.unknown) {
              var cbox = this.jax.measureText(String.fromCodePoint(char), variant);
              w = cbox.w;
              h = cbox.h;
              d = cbox.d;
            }
            bbox.w += w;
            if (h > bbox.h) bbox.h = h;
            if (d > bbox.d) bbox.d = d;
            bbox.ic = data.ic || 0;
            bbox.sk = data.sk || 0;
            bbox.dx = data.dx || 0;
          }
        } catch (e_1_1) {
          e_1 = {
            error: e_1_1
          };
        } finally {
          try {
            if (chars_1_1 && !chars_1_1.done && (_a = chars_1.return)) _a.call(chars_1);
          } finally {
            if (e_1) throw e_1.error;
          }
        }
        if (chars.length > 1) {
          bbox.sk = 0;
        }
        bbox.clean();
      }
    };
    class_1.prototype.remappedText = function (text, variant) {
      var c = this.parent.stretch.c;
      return c ? [c] : this.parent.remapChars(this.unicodeChars(text, variant));
    };
    class_1.prototype.getStyles = function () {};
    class_1.prototype.getVariant = function () {};
    class_1.prototype.getScale = function () {};
    class_1.prototype.getSpace = function () {};
    return class_1;
  })(Base);
}
TextNode.CommonTextNodeMixin = CommonTextNodeMixin;

var __extends$x = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$c = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(TextNode$1, "__esModule", {
  value: true
});
TextNode$1.CHTMLTextNode = void 0;
var MmlNode_js_1$e = MmlNode;
var Wrapper_js_1$1 = Wrapper$3;
var TextNode_js_1$1 = TextNode;
var CHTMLTextNode = (function (_super) {
  __extends$x(CHTMLTextNode, _super);
  function CHTMLTextNode() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLTextNode.prototype.toCHTML = function (parent) {
    var e_1, _a;
    this.markUsed();
    var adaptor = this.adaptor;
    var variant = this.parent.variant;
    var text = this.node.getText();
    if (text.length === 0) return;
    if (variant === '-explicitFont') {
      adaptor.append(parent, this.jax.unknownText(text, variant, this.getBBox().w));
    } else {
      var chars = this.remappedText(text, variant);
      try {
        for (var chars_1 = __values$c(chars), chars_1_1 = chars_1.next(); !chars_1_1.done; chars_1_1 = chars_1.next()) {
          var n = chars_1_1.value;
          var data = this.getVariantChar(variant, n)[3];
          var font = data.f ? ' TEX-' + data.f : '';
          var node = data.unknown ? this.jax.unknownText(String.fromCodePoint(n), variant) : this.html('mjx-c', {
            class: this.char(n) + font
          });
          adaptor.append(parent, node);
          !data.unknown && this.font.charUsage.add([variant, n]);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (chars_1_1 && !chars_1_1.done && (_a = chars_1.return)) _a.call(chars_1);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    }
  };
  CHTMLTextNode.kind = MmlNode_js_1$e.TextNode.prototype.kind;
  CHTMLTextNode.autoStyle = false;
  CHTMLTextNode.styles = {
    'mjx-c': {
      display: 'inline-block'
    },
    'mjx-utext': {
      display: 'inline-block',
      padding: '.75em 0 .2em 0'
    }
  };
  return CHTMLTextNode;
})((0, TextNode_js_1$1.CommonTextNodeMixin)(Wrapper_js_1$1.CHTMLWrapper));
TextNode$1.CHTMLTextNode = CHTMLTextNode;

var _a$8;
Object.defineProperty(Wrappers, "__esModule", {
  value: true
});
Wrappers.CHTMLWrappers = void 0;
var Wrapper_js_1 = Wrapper$3;
var math_js_1$1 = math$3;
var mi_js_1$1 = mi$3;
var mo_js_1$1 = mo$2;
var mn_js_1$1 = mn$3;
var ms_js_1$1 = ms$3;
var mtext_js_1$1 = mtext$3;
var mspace_js_1$1 = mspace$2;
var mpadded_js_1$1 = mpadded$2;
var menclose_js_1$1 = menclose$3;
var mrow_js_1$1 = mrow$2;
var mfenced_js_1$1 = mfenced$3;
var mfrac_js_1$1 = mfrac$3;
var msqrt_js_1$1 = msqrt$3;
var mroot_js_1$1 = mroot$3;
var msubsup_js_1$1 = msubsup$3;
var munderover_js_1$1 = munderover$3;
var mmultiscripts_js_1$1 = mmultiscripts$3;
var mtable_js_1$1 = mtable$3;
var mtr_js_1$1 = mtr$3;
var mtd_js_1$1 = mtd$2;
var maction_js_1$1 = maction$3;
var mglyph_js_1$1 = mglyph$2;
var semantics_js_1$1 = semantics$2;
var TeXAtom_js_1$1 = TeXAtom$3;
var TextNode_js_1 = TextNode$1;
Wrappers.CHTMLWrappers = (_a$8 = {}, _a$8[math_js_1$1.CHTMLmath.kind] = math_js_1$1.CHTMLmath, _a$8[mrow_js_1$1.CHTMLmrow.kind] = mrow_js_1$1.CHTMLmrow, _a$8[mrow_js_1$1.CHTMLinferredMrow.kind] = mrow_js_1$1.CHTMLinferredMrow, _a$8[mi_js_1$1.CHTMLmi.kind] = mi_js_1$1.CHTMLmi, _a$8[mo_js_1$1.CHTMLmo.kind] = mo_js_1$1.CHTMLmo, _a$8[mn_js_1$1.CHTMLmn.kind] = mn_js_1$1.CHTMLmn, _a$8[ms_js_1$1.CHTMLms.kind] = ms_js_1$1.CHTMLms, _a$8[mtext_js_1$1.CHTMLmtext.kind] = mtext_js_1$1.CHTMLmtext, _a$8[mspace_js_1$1.CHTMLmspace.kind] = mspace_js_1$1.CHTMLmspace, _a$8[mpadded_js_1$1.CHTMLmpadded.kind] = mpadded_js_1$1.CHTMLmpadded, _a$8[menclose_js_1$1.CHTMLmenclose.kind] = menclose_js_1$1.CHTMLmenclose, _a$8[mfrac_js_1$1.CHTMLmfrac.kind] = mfrac_js_1$1.CHTMLmfrac, _a$8[msqrt_js_1$1.CHTMLmsqrt.kind] = msqrt_js_1$1.CHTMLmsqrt, _a$8[mroot_js_1$1.CHTMLmroot.kind] = mroot_js_1$1.CHTMLmroot, _a$8[msubsup_js_1$1.CHTMLmsub.kind] = msubsup_js_1$1.CHTMLmsub, _a$8[msubsup_js_1$1.CHTMLmsup.kind] = msubsup_js_1$1.CHTMLmsup, _a$8[msubsup_js_1$1.CHTMLmsubsup.kind] = msubsup_js_1$1.CHTMLmsubsup, _a$8[munderover_js_1$1.CHTMLmunder.kind] = munderover_js_1$1.CHTMLmunder, _a$8[munderover_js_1$1.CHTMLmover.kind] = munderover_js_1$1.CHTMLmover, _a$8[munderover_js_1$1.CHTMLmunderover.kind] = munderover_js_1$1.CHTMLmunderover, _a$8[mmultiscripts_js_1$1.CHTMLmmultiscripts.kind] = mmultiscripts_js_1$1.CHTMLmmultiscripts, _a$8[mfenced_js_1$1.CHTMLmfenced.kind] = mfenced_js_1$1.CHTMLmfenced, _a$8[mtable_js_1$1.CHTMLmtable.kind] = mtable_js_1$1.CHTMLmtable, _a$8[mtr_js_1$1.CHTMLmtr.kind] = mtr_js_1$1.CHTMLmtr, _a$8[mtr_js_1$1.CHTMLmlabeledtr.kind] = mtr_js_1$1.CHTMLmlabeledtr, _a$8[mtd_js_1$1.CHTMLmtd.kind] = mtd_js_1$1.CHTMLmtd, _a$8[maction_js_1$1.CHTMLmaction.kind] = maction_js_1$1.CHTMLmaction, _a$8[mglyph_js_1$1.CHTMLmglyph.kind] = mglyph_js_1$1.CHTMLmglyph, _a$8[semantics_js_1$1.CHTMLsemantics.kind] = semantics_js_1$1.CHTMLsemantics, _a$8[semantics_js_1$1.CHTMLannotation.kind] = semantics_js_1$1.CHTMLannotation, _a$8[semantics_js_1$1.CHTMLannotationXML.kind] = semantics_js_1$1.CHTMLannotationXML, _a$8[semantics_js_1$1.CHTMLxml.kind] = semantics_js_1$1.CHTMLxml, _a$8[TeXAtom_js_1$1.CHTMLTeXAtom.kind] = TeXAtom_js_1$1.CHTMLTeXAtom, _a$8[TextNode_js_1.CHTMLTextNode.kind] = TextNode_js_1.CHTMLTextNode, _a$8[Wrapper_js_1.CHTMLWrapper.kind] = Wrapper_js_1.CHTMLWrapper, _a$8);

var __extends$w = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(WrapperFactory$2, "__esModule", {
  value: true
});
var CHTMLWrapperFactory_1 = WrapperFactory$2.CHTMLWrapperFactory = void 0;
var WrapperFactory_js_1$1 = WrapperFactory$1;
var Wrappers_js_1 = Wrappers;
var CHTMLWrapperFactory = (function (_super) {
  __extends$w(CHTMLWrapperFactory, _super);
  function CHTMLWrapperFactory() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CHTMLWrapperFactory.defaultNodes = Wrappers_js_1.CHTMLWrappers;
  return CHTMLWrapperFactory;
})(WrapperFactory_js_1$1.CommonWrapperFactory);
CHTMLWrapperFactory_1 = WrapperFactory$2.CHTMLWrapperFactory = CHTMLWrapperFactory;

var Usage$1 = {};

Object.defineProperty(Usage$1, "__esModule", {
  value: true
});
Usage$1.Usage = void 0;
var Usage = (function () {
  function Usage() {
    this.used = new Set();
    this.needsUpdate = [];
  }
  Usage.prototype.add = function (item) {
    var name = JSON.stringify(item);
    if (!this.used.has(name)) {
      this.needsUpdate.push(item);
    }
    this.used.add(name);
  };
  Usage.prototype.has = function (item) {
    return this.used.has(JSON.stringify(item));
  };
  Usage.prototype.clear = function () {
    this.used.clear();
    this.needsUpdate = [];
  };
  Usage.prototype.update = function () {
    var update = this.needsUpdate;
    this.needsUpdate = [];
    return update;
  };
  return Usage;
})();
Usage$1.Usage = Usage;

var tex$1 = {};

var FontData = {};

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __assign = commonjsGlobal && commonjsGlobal.__assign || (function () {
    __assign = Object.assign || (function (t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    });
    return __assign.apply(this, arguments);
  });
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = {
        enumerable: true,
        get: function () {
          return m[k];
        }
      };
    }
    Object.defineProperty(o, k2, desc);
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.AddCSS = exports.CHTMLFontData = void 0;
  var FontData_js_1 = FontData$2;
  var Usage_js_1 = Usage$1;
  var lengths_js_1 = lengths;
  __exportStar(FontData$2, exports);
  var CHTMLFontData = (function (_super) {
    __extends(CHTMLFontData, _super);
    function CHTMLFontData() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.charUsage = new Usage_js_1.Usage();
      _this.delimUsage = new Usage_js_1.Usage();
      return _this;
    }
    CHTMLFontData.charOptions = function (font, n) {
      return _super.charOptions.call(this, font, n);
    };
    CHTMLFontData.prototype.adaptiveCSS = function (adapt) {
      this.options.adaptiveCSS = adapt;
    };
    CHTMLFontData.prototype.clearCache = function () {
      if (this.options.adaptiveCSS) {
        this.charUsage.clear();
        this.delimUsage.clear();
      }
    };
    CHTMLFontData.prototype.createVariant = function (name, inherit, link) {
      if (inherit === void 0) {
        inherit = null;
      }
      if (link === void 0) {
        link = null;
      }
      _super.prototype.createVariant.call(this, name, inherit, link);
      var CLASS = this.constructor;
      this.variant[name].classes = CLASS.defaultVariantClasses[name];
      this.variant[name].letter = CLASS.defaultVariantLetters[name];
    };
    CHTMLFontData.prototype.defineChars = function (name, chars) {
      var e_1, _a;
      _super.prototype.defineChars.call(this, name, chars);
      var letter = this.variant[name].letter;
      try {
        for (var _b = __values(Object.keys(chars)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var n = _c.value;
          var options = CHTMLFontData.charOptions(chars, parseInt(n));
          if (options.f === undefined) {
            options.f = letter;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    };
    Object.defineProperty(CHTMLFontData.prototype, "styles", {
      get: function () {
        var CLASS = this.constructor;
        var styles = __assign({}, CLASS.defaultStyles);
        this.addFontURLs(styles, CLASS.defaultFonts, this.options.fontURL);
        if (this.options.adaptiveCSS) {
          this.updateStyles(styles);
        } else {
          this.allStyles(styles);
        }
        return styles;
      },
      enumerable: false,
      configurable: true
    });
    CHTMLFontData.prototype.updateStyles = function (styles) {
      var e_2, _a, e_3, _b;
      try {
        for (var _c = __values(this.delimUsage.update()), _d = _c.next(); !_d.done; _d = _c.next()) {
          var N = _d.value;
          this.addDelimiterStyles(styles, N, this.delimiters[N]);
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      try {
        for (var _e = __values(this.charUsage.update()), _f = _e.next(); !_f.done; _f = _e.next()) {
          var _g = __read(_f.value, 2), name_1 = _g[0], N = _g[1];
          var variant = this.variant[name_1];
          this.addCharStyles(styles, variant.letter, N, variant.chars[N]);
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      return styles;
    };
    CHTMLFontData.prototype.allStyles = function (styles) {
      var e_4, _a, e_5, _b, e_6, _c;
      try {
        for (var _d = __values(Object.keys(this.delimiters)), _e = _d.next(); !_e.done; _e = _d.next()) {
          var n = _e.value;
          var N = parseInt(n);
          this.addDelimiterStyles(styles, N, this.delimiters[N]);
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
      try {
        for (var _f = __values(Object.keys(this.variant)), _g = _f.next(); !_g.done; _g = _f.next()) {
          var name_2 = _g.value;
          var variant = this.variant[name_2];
          var vletter = variant.letter;
          try {
            for (var _h = (e_6 = void 0, __values(Object.keys(variant.chars))), _j = _h.next(); !_j.done; _j = _h.next()) {
              var n = _j.value;
              var N = parseInt(n);
              var char = variant.chars[N];
              if ((char[3] || ({})).smp) continue;
              if (char.length < 4) {
                char[3] = {};
              }
              this.addCharStyles(styles, vletter, N, char);
            }
          } catch (e_6_1) {
            e_6 = {
              error: e_6_1
            };
          } finally {
            try {
              if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
            } finally {
              if (e_6) throw e_6.error;
            }
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
    };
    CHTMLFontData.prototype.addFontURLs = function (styles, fonts, url) {
      var e_7, _a;
      try {
        for (var _b = __values(Object.keys(fonts)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var name_3 = _c.value;
          var font = __assign({}, fonts[name_3]);
          font.src = font.src.replace(/%%URL%%/, url);
          styles[name_3] = font;
        }
      } catch (e_7_1) {
        e_7 = {
          error: e_7_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_7) throw e_7.error;
        }
      }
    };
    CHTMLFontData.prototype.addDelimiterStyles = function (styles, n, data) {
      var c = this.charSelector(n);
      if (data.c && data.c !== n) {
        c = this.charSelector(data.c);
        styles['.mjx-stretched mjx-c' + c + '::before'] = {
          content: this.charContent(data.c)
        };
      }
      if (!data.stretch) return;
      if (data.dir === 1) {
        this.addDelimiterVStyles(styles, c, data);
      } else {
        this.addDelimiterHStyles(styles, c, data);
      }
    };
    CHTMLFontData.prototype.addDelimiterVStyles = function (styles, c, data) {
      var HDW = data.HDW;
      var _a = __read(data.stretch, 4), beg = _a[0], ext = _a[1], end = _a[2], mid = _a[3];
      var Hb = this.addDelimiterVPart(styles, c, 'beg', beg, HDW);
      this.addDelimiterVPart(styles, c, 'ext', ext, HDW);
      var He = this.addDelimiterVPart(styles, c, 'end', end, HDW);
      var css = {};
      if (mid) {
        var Hm = this.addDelimiterVPart(styles, c, 'mid', mid, HDW);
        css.height = '50%';
        styles['mjx-stretchy-v' + c + ' > mjx-mid'] = {
          'margin-top': this.em(-Hm / 2),
          'margin-bottom': this.em(-Hm / 2)
        };
      }
      if (Hb) {
        css['border-top-width'] = this.em0(Hb - .03);
      }
      if (He) {
        css['border-bottom-width'] = this.em0(He - .03);
        styles['mjx-stretchy-v' + c + ' > mjx-end'] = {
          'margin-top': this.em(-He)
        };
      }
      if (Object.keys(css).length) {
        styles['mjx-stretchy-v' + c + ' > mjx-ext'] = css;
      }
    };
    CHTMLFontData.prototype.addDelimiterVPart = function (styles, c, part, n, HDW) {
      if (!n) return 0;
      var data = this.getDelimiterData(n);
      var dw = (HDW[2] - data[2]) / 2;
      var css = {
        content: this.charContent(n)
      };
      if (part !== 'ext') {
        css.padding = this.padding(data, dw);
      } else {
        css.width = this.em0(HDW[2]);
        if (dw) {
          css['padding-left'] = this.em0(dw);
        }
      }
      styles['mjx-stretchy-v' + c + ' mjx-' + part + ' mjx-c::before'] = css;
      return data[0] + data[1];
    };
    CHTMLFontData.prototype.addDelimiterHStyles = function (styles, c, data) {
      var _a = __read(data.stretch, 4), beg = _a[0], ext = _a[1], end = _a[2], mid = _a[3];
      var HDW = data.HDW;
      this.addDelimiterHPart(styles, c, 'beg', beg, HDW);
      this.addDelimiterHPart(styles, c, 'ext', ext, HDW);
      this.addDelimiterHPart(styles, c, 'end', end, HDW);
      if (mid) {
        this.addDelimiterHPart(styles, c, 'mid', mid, HDW);
        styles['mjx-stretchy-h' + c + ' > mjx-ext'] = {
          width: '50%'
        };
      }
    };
    CHTMLFontData.prototype.addDelimiterHPart = function (styles, c, part, n, HDW) {
      if (!n) return;
      var data = this.getDelimiterData(n);
      var options = data[3];
      var css = {
        content: options && options.c ? '"' + options.c + '"' : this.charContent(n)
      };
      css.padding = this.padding(HDW, 0, -HDW[2]);
      styles['mjx-stretchy-h' + c + ' mjx-' + part + ' mjx-c::before'] = css;
    };
    CHTMLFontData.prototype.addCharStyles = function (styles, vletter, n, data) {
      var options = data[3];
      var letter = options.f !== undefined ? options.f : vletter;
      var selector = 'mjx-c' + this.charSelector(n) + (letter ? '.TEX-' + letter : '');
      styles[selector + '::before'] = {
        padding: this.padding(data, 0, options.ic || 0),
        content: options.c != null ? '"' + options.c + '"' : this.charContent(n)
      };
    };
    CHTMLFontData.prototype.getDelimiterData = function (n) {
      return this.getChar('-smallop', n);
    };
    CHTMLFontData.prototype.em = function (n) {
      return (0, lengths_js_1.em)(n);
    };
    CHTMLFontData.prototype.em0 = function (n) {
      return (0, lengths_js_1.em)(Math.max(0, n));
    };
    CHTMLFontData.prototype.padding = function (_a, dw, ic) {
      var _b = __read(_a, 3), h = _b[0], d = _b[1], w = _b[2];
      if (dw === void 0) {
        dw = 0;
      }
      if (ic === void 0) {
        ic = 0;
      }
      return [h, w + ic, d, dw].map(this.em0).join(' ');
    };
    CHTMLFontData.prototype.charContent = function (n) {
      return '"' + (n >= 0x20 && n <= 0x7E && n !== 0x22 && n !== 0x27 && n !== 0x5C ? String.fromCharCode(n) : '\\' + n.toString(16).toUpperCase()) + '"';
    };
    CHTMLFontData.prototype.charSelector = function (n) {
      return '.mjx-c' + n.toString(16).toUpperCase();
    };
    CHTMLFontData.OPTIONS = __assign(__assign({}, FontData_js_1.FontData.OPTIONS), {
      fontURL: 'js/output/chtml/fonts/tex-woff-v2'
    });
    CHTMLFontData.JAX = 'CHTML';
    CHTMLFontData.defaultVariantClasses = {};
    CHTMLFontData.defaultVariantLetters = {};
    CHTMLFontData.defaultStyles = {
      'mjx-c::before': {
        display: 'block',
        width: 0
      }
    };
    CHTMLFontData.defaultFonts = {
      '@font-face /* 0 */': {
        'font-family': 'MJXZERO',
        src: 'url("%%URL%%/MathJax_Zero.woff") format("woff")'
      }
    };
    return CHTMLFontData;
  })(FontData_js_1.FontData);
  exports.CHTMLFontData = CHTMLFontData;
  function AddCSS(font, options) {
    var e_8, _a;
    try {
      for (var _b = __values(Object.keys(options)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var c = _c.value;
        var n = parseInt(c);
        Object.assign(FontData_js_1.FontData.charOptions(font, n), options[n]);
      }
    } catch (e_8_1) {
      e_8 = {
        error: e_8_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_8) throw e_8.error;
      }
    }
    return font;
  }
  exports.AddCSS = AddCSS;
})(FontData);
getDefaultExportFromCjs(FontData);

var tex = {};

var __extends$v = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$a = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$a = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$a.apply(this, arguments);
});
var __read$9 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$4 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(tex, "__esModule", {
  value: true
});
tex.CommonTeXFontMixin = void 0;
function CommonTeXFontMixin(Base) {
  var _a;
  return (_a = (function (_super) {
    __extends$v(class_1, _super);
    function class_1() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    class_1.prototype.getDelimiterData = function (n) {
      return this.getChar('-smallop', n) || this.getChar('-size4', n);
    };
    return class_1;
  })(Base), _a.NAME = 'TeX', _a.defaultVariants = __spreadArray$4(__spreadArray$4([], __read$9(Base.defaultVariants), false), [['-smallop', 'normal'], ['-largeop', 'normal'], ['-size3', 'normal'], ['-size4', 'normal'], ['-tex-calligraphic', 'italic'], ['-tex-bold-calligraphic', 'bold-italic'], ['-tex-oldstyle', 'normal'], ['-tex-bold-oldstyle', 'bold'], ['-tex-mathit', 'italic'], ['-tex-variant', 'normal']], false), _a.defaultCssFonts = __assign$a(__assign$a({}, Base.defaultCssFonts), {
    '-smallop': ['serif', false, false],
    '-largeop': ['serif', false, false],
    '-size3': ['serif', false, false],
    '-size4': ['serif', false, false],
    '-tex-calligraphic': ['cursive', true, false],
    '-tex-bold-calligraphic': ['cursive', true, true],
    '-tex-oldstyle': ['serif', false, false],
    '-tex-bold-oldstyle': ['serif', false, true],
    '-tex-mathit': ['serif', true, false]
  }), _a.defaultSizeVariants = ['normal', '-smallop', '-largeop', '-size3', '-size4', '-tex-variant'], _a.defaultStretchVariants = ['-size4'], _a);
}
tex.CommonTeXFontMixin = CommonTeXFontMixin;

var boldItalic$1 = {};

var boldItalic = {};

Object.defineProperty(boldItalic, "__esModule", {
  value: true
});
boldItalic.boldItalic = void 0;
boldItalic.boldItalic = {
  0x2F: [.711, .21, .894],
  0x131: [.452, .008, .394, {
    sk: .0319
  }],
  0x237: [.451, .201, .439, {
    sk: .0958
  }],
  0x2044: [.711, .21, .894],
  0x2206: [.711, 0, .958, {
    sk: .192
  }],
  0x29F8: [.711, .21, .894]
};

Object.defineProperty(boldItalic$1, "__esModule", {
  value: true
});
boldItalic$1.boldItalic = void 0;
var FontData_js_1$h = FontData;
var bold_italic_js_1$1 = boldItalic;
boldItalic$1.boldItalic = (0, FontData_js_1$h.AddCSS)(bold_italic_js_1$1.boldItalic, {
  0x131: {
    f: 'B'
  },
  0x237: {
    f: 'B'
  },
  0x2044: {
    c: '/'
  },
  0x2206: {
    c: '\\394'
  },
  0x29F8: {
    c: '/'
  }
});

var bold$1 = {};

var bold = {};

Object.defineProperty(bold, "__esModule", {
  value: true
});
bold.bold = void 0;
bold.bold = {
  0x21: [.705, 0, .35],
  0x22: [.694, -0.329, .603],
  0x23: [.694, .193, .958],
  0x24: [.75, .056, .575],
  0x25: [.75, .056, .958],
  0x26: [.705, .011, .894],
  0x27: [.694, -0.329, .319],
  0x28: [.75, .249, .447],
  0x29: [.75, .249, .447],
  0x2A: [.75, -0.306, .575],
  0x2B: [.633, .131, .894],
  0x2C: [.171, .194, .319],
  0x2D: [.278, -0.166, .383],
  0x2E: [.171, 0, .319],
  0x2F: [.75, .25, .575],
  0x3A: [.444, 0, .319],
  0x3B: [.444, .194, .319],
  0x3C: [.587, .085, .894],
  0x3D: [.393, -0.109, .894],
  0x3E: [.587, .085, .894],
  0x3F: [.7, 0, .543],
  0x40: [.699, .006, .894],
  0x5B: [.75, .25, .319],
  0x5C: [.75, .25, .575],
  0x5D: [.75, .25, .319],
  0x5E: [.694, -0.52, .575],
  0x5F: [-0.01, .061, .575],
  0x60: [.706, -0.503, .575],
  0x7B: [.75, .25, .575],
  0x7C: [.75, .249, .319],
  0x7D: [.75, .25, .575],
  0x7E: [.344, -0.202, .575],
  0xA8: [.695, -0.535, .575],
  0xAC: [.371, -0.061, .767],
  0xAF: [.607, -0.54, .575],
  0xB0: [.702, -0.536, .575],
  0xB1: [.728, .035, .894],
  0xB4: [.706, -0.503, .575],
  0xB7: [.336, -0.166, .319],
  0xD7: [.53, .028, .894],
  0xF7: [.597, .096, .894],
  0x131: [.442, 0, .278, {
    sk: .0278
  }],
  0x237: [.442, .205, .306, {
    sk: .0833
  }],
  0x2B9: [.563, -0.033, .344],
  0x2C6: [.694, -0.52, .575],
  0x2C7: [.66, -0.515, .575],
  0x2C9: [.607, -0.54, .575],
  0x2CA: [.706, -0.503, .575],
  0x2CB: [.706, -0.503, .575],
  0x2D8: [.694, -0.5, .575],
  0x2D9: [.695, -0.525, .575],
  0x2DA: [.702, -0.536, .575],
  0x2DC: [.694, -0.552, .575],
  0x300: [.706, -0.503, 0],
  0x301: [.706, -0.503, 0],
  0x302: [.694, -0.52, 0],
  0x303: [.694, -0.552, 0],
  0x304: [.607, -0.54, 0],
  0x306: [.694, -0.5, 0],
  0x307: [.695, -0.525, 0],
  0x308: [.695, -0.535, 0],
  0x30A: [.702, -0.536, 0],
  0x30B: [.714, -0.511, 0],
  0x30C: [.66, -0.515, 0],
  0x338: [.711, .21, 0],
  0x2002: [0, 0, .5],
  0x2003: [0, 0, .999],
  0x2004: [0, 0, .333],
  0x2005: [0, 0, .25],
  0x2006: [0, 0, .167],
  0x2009: [0, 0, .167],
  0x200A: [0, 0, .083],
  0x2013: [.3, -0.249, .575],
  0x2014: [.3, -0.249, 1.15],
  0x2015: [.3, -0.249, 1.15],
  0x2016: [.75, .248, .575],
  0x2017: [-0.01, .061, .575],
  0x2018: [.694, -0.329, .319],
  0x2019: [.694, -0.329, .319],
  0x201C: [.694, -0.329, .603],
  0x201D: [.694, -0.329, .603],
  0x2020: [.702, .211, .511],
  0x2021: [.702, .202, .511],
  0x2022: [.474, -0.028, .575],
  0x2026: [.171, 0, 1.295],
  0x2032: [.563, -0.033, .344],
  0x2033: [.563, 0, .688],
  0x2034: [.563, 0, 1.032],
  0x203E: [.607, -0.54, .575],
  0x2044: [.75, .25, .575],
  0x2057: [.563, 0, 1.376],
  0x20D7: [.723, -0.513, .575],
  0x210F: [.694, .008, .668, {
    sk: -0.0319
  }],
  0x2113: [.702, .019, .474, {
    sk: .128
  }],
  0x2118: [.461, .21, .74],
  0x2135: [.694, 0, .703],
  0x2190: [.518, .017, 1.15],
  0x2191: [.694, .193, .575],
  0x2192: [.518, .017, 1.15],
  0x2193: [.694, .194, .575],
  0x2194: [.518, .017, 1.15],
  0x2195: [.767, .267, .575],
  0x2196: [.724, .194, 1.15],
  0x2197: [.724, .193, 1.15],
  0x2198: [.694, .224, 1.15],
  0x2199: [.694, .224, 1.15],
  0x219A: [.711, .21, 1.15],
  0x219B: [.711, .21, 1.15],
  0x21A6: [.518, .017, 1.15],
  0x21A9: [.518, .017, 1.282],
  0x21AA: [.518, .017, 1.282],
  0x21AE: [.711, .21, 1.15],
  0x21BC: [.518, -0.22, 1.15],
  0x21BD: [.281, .017, 1.15],
  0x21C0: [.518, -0.22, 1.15],
  0x21C1: [.281, .017, 1.15],
  0x21CC: [.718, .017, 1.15],
  0x21CD: [.711, .21, 1.15],
  0x21CE: [.711, .21, 1.15],
  0x21CF: [.711, .21, 1.15],
  0x21D0: [.547, .046, 1.15],
  0x21D1: [.694, .193, .703],
  0x21D2: [.547, .046, 1.15],
  0x21D3: [.694, .194, .703],
  0x21D4: [.547, .046, 1.15],
  0x21D5: [.767, .267, .703],
  0x2200: [.694, .016, .639],
  0x2203: [.694, 0, .639],
  0x2204: [.711, .21, .639],
  0x2205: [.767, .073, .575],
  0x2206: [.698, 0, .958],
  0x2208: [.587, .086, .767],
  0x2209: [.711, .21, .767],
  0x220B: [.587, .086, .767],
  0x220C: [.711, .21, .767],
  0x2212: [.281, -0.221, .894],
  0x2213: [.537, .227, .894],
  0x2215: [.75, .25, .575],
  0x2216: [.75, .25, .575],
  0x2217: [.472, -0.028, .575],
  0x2218: [.474, -0.028, .575],
  0x2219: [.474, -0.028, .575],
  0x221A: [.82, .18, .958, {
    ic: .03
  }],
  0x221D: [.451, .008, .894],
  0x221E: [.452, .008, 1.15],
  0x2220: [.714, 0, .722],
  0x2223: [.75, .249, .319],
  0x2224: [.75, .249, .319],
  0x2225: [.75, .248, .575],
  0x2226: [.75, .248, .575],
  0x2227: [.604, .017, .767],
  0x2228: [.604, .016, .767],
  0x2229: [.603, .016, .767],
  0x222A: [.604, .016, .767],
  0x222B: [.711, .211, .569, {
    ic: .063
  }],
  0x223C: [.391, -0.109, .894],
  0x2240: [.583, .082, .319],
  0x2241: [.711, .21, .894],
  0x2243: [.502, 0, .894],
  0x2244: [.711, .21, .894],
  0x2245: [.638, .027, .894],
  0x2247: [.711, .21, .894],
  0x2248: [.524, -0.032, .894],
  0x2249: [.711, .21, .894],
  0x224D: [.533, .032, .894],
  0x2250: [.721, -0.109, .894],
  0x2260: [.711, .21, .894],
  0x2261: [.505, 0, .894],
  0x2262: [.711, .21, .894],
  0x2264: [.697, .199, .894],
  0x2265: [.697, .199, .894],
  0x226A: [.617, .116, 1.15],
  0x226B: [.618, .116, 1.15],
  0x226D: [.711, .21, .894],
  0x226E: [.711, .21, .894],
  0x226F: [.711, .21, .894],
  0x2270: [.711, .21, .894],
  0x2271: [.711, .21, .894],
  0x227A: [.585, .086, .894],
  0x227B: [.586, .086, .894],
  0x2280: [.711, .21, .894],
  0x2281: [.711, .21, .894],
  0x2282: [.587, .085, .894],
  0x2283: [.587, .086, .894],
  0x2284: [.711, .21, .894],
  0x2285: [.711, .21, .894],
  0x2286: [.697, .199, .894],
  0x2287: [.697, .199, .894],
  0x2288: [.711, .21, .894],
  0x2289: [.711, .21, .894],
  0x228E: [.604, .016, .767],
  0x2291: [.697, .199, .894],
  0x2292: [.697, .199, .894],
  0x2293: [.604, 0, .767],
  0x2294: [.604, 0, .767],
  0x2295: [.632, .132, .894],
  0x2296: [.632, .132, .894],
  0x2297: [.632, .132, .894],
  0x2298: [.632, .132, .894],
  0x2299: [.632, .132, .894],
  0x22A2: [.693, 0, .703],
  0x22A3: [.693, 0, .703],
  0x22A4: [.694, 0, .894],
  0x22A5: [.693, 0, .894],
  0x22A8: [.75, .249, .974],
  0x22AC: [.711, .21, .703],
  0x22AD: [.75, .249, .974],
  0x22C4: [.523, .021, .575],
  0x22C5: [.336, -0.166, .319],
  0x22C6: [.502, 0, .575],
  0x22C8: [.54, .039, 1],
  0x22E2: [.711, .21, .894],
  0x22E3: [.711, .21, .894],
  0x22EE: [.951, .029, .319],
  0x22EF: [.336, -0.166, 1.295],
  0x22F1: [.871, -0.101, 1.323],
  0x2308: [.75, .248, .511],
  0x2309: [.75, .248, .511],
  0x230A: [.749, .248, .511],
  0x230B: [.749, .248, .511],
  0x2322: [.405, -0.108, 1.15],
  0x2323: [.392, -0.126, 1.15],
  0x2329: [.75, .249, .447],
  0x232A: [.75, .249, .447],
  0x25B3: [.711, 0, 1.022],
  0x25B5: [.711, 0, 1.022],
  0x25B9: [.54, .039, .575],
  0x25BD: [.5, .21, 1.022],
  0x25BF: [.5, .21, 1.022],
  0x25C3: [.539, .038, .575],
  0x25EF: [.711, .211, 1.15],
  0x2660: [.719, .129, .894],
  0x2661: [.711, .024, .894],
  0x2662: [.719, .154, .894],
  0x2663: [.719, .129, .894],
  0x266D: [.75, .017, .447],
  0x266E: [.741, .223, .447],
  0x266F: [.724, .224, .447],
  0x2758: [.75, .249, .319],
  0x27E8: [.75, .249, .447],
  0x27E9: [.75, .249, .447],
  0x27F5: [.518, .017, 1.805],
  0x27F6: [.518, .017, 1.833],
  0x27F7: [.518, .017, 2.126],
  0x27F8: [.547, .046, 1.868],
  0x27F9: [.547, .046, 1.87],
  0x27FA: [.547, .046, 2.126],
  0x27FC: [.518, .017, 1.833],
  0x29F8: [.711, .21, .894],
  0x2A2F: [.53, .028, .894],
  0x2A3F: [.686, 0, .9],
  0x2AAF: [.696, .199, .894],
  0x2AB0: [.697, .199, .894],
  0x3008: [.75, .249, .447],
  0x3009: [.75, .249, .447]
};

Object.defineProperty(bold$1, "__esModule", {
  value: true
});
bold$1.bold = void 0;
var FontData_js_1$g = FontData;
var bold_js_1$1 = bold;
bold$1.bold = (0, FontData_js_1$g.AddCSS)(bold_js_1$1.bold, {
  0xB7: {
    c: '\\22C5'
  },
  0x131: {
    f: ''
  },
  0x237: {
    f: ''
  },
  0x2B9: {
    c: '\\2032'
  },
  0x2002: {
    c: ''
  },
  0x2003: {
    c: ''
  },
  0x2004: {
    c: ''
  },
  0x2005: {
    c: ''
  },
  0x2006: {
    c: ''
  },
  0x2009: {
    c: ''
  },
  0x200A: {
    c: ''
  },
  0x2015: {
    c: '\\2014'
  },
  0x2016: {
    c: '\\2225'
  },
  0x2017: {
    c: '_'
  },
  0x2022: {
    c: '\\2219'
  },
  0x2033: {
    c: '\\2032\\2032'
  },
  0x2034: {
    c: '\\2032\\2032\\2032'
  },
  0x203E: {
    c: '\\2C9'
  },
  0x2044: {
    c: '/'
  },
  0x2057: {
    c: '\\2032\\2032\\2032\\2032'
  },
  0x20D7: {
    c: '\\2192',
    f: 'VB'
  },
  0x219A: {
    c: '\\2190\\338'
  },
  0x219B: {
    c: '\\2192\\338'
  },
  0x21AE: {
    c: '\\2194\\338'
  },
  0x21CD: {
    c: '\\21D0\\338'
  },
  0x21CE: {
    c: '\\21D4\\338'
  },
  0x21CF: {
    c: '\\21D2\\338'
  },
  0x2204: {
    c: '\\2203\\338'
  },
  0x2206: {
    c: '\\394'
  },
  0x220C: {
    c: '\\220B\\338'
  },
  0x2224: {
    c: '\\2223\\338'
  },
  0x2226: {
    c: '\\2225\\338'
  },
  0x2241: {
    c: '\\223C\\338'
  },
  0x2244: {
    c: '\\2243\\338'
  },
  0x2247: {
    c: '\\2245\\338'
  },
  0x2249: {
    c: '\\2248\\338'
  },
  0x2262: {
    c: '\\2261\\338'
  },
  0x226D: {
    c: '\\224D\\338'
  },
  0x226E: {
    c: '<\\338'
  },
  0x226F: {
    c: '>\\338'
  },
  0x2270: {
    c: '\\2264\\338'
  },
  0x2271: {
    c: '\\2265\\338'
  },
  0x2280: {
    c: '\\227A\\338'
  },
  0x2281: {
    c: '\\227B\\338'
  },
  0x2284: {
    c: '\\2282\\338'
  },
  0x2285: {
    c: '\\2283\\338'
  },
  0x2288: {
    c: '\\2286\\338'
  },
  0x2289: {
    c: '\\2287\\338'
  },
  0x22AC: {
    c: '\\22A2\\338'
  },
  0x22AD: {
    c: '\\22A8\\338'
  },
  0x22E2: {
    c: '\\2291\\338'
  },
  0x22E3: {
    c: '\\2292\\338'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x25B5: {
    c: '\\25B3'
  },
  0x25BF: {
    c: '\\25BD'
  },
  0x2758: {
    c: '\\2223'
  },
  0x29F8: {
    c: '/',
    f: 'BI'
  },
  0x2A2F: {
    c: '\\D7'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  }
});

var doubleStruck$1 = {};

var doubleStruck = {};

Object.defineProperty(doubleStruck, "__esModule", {
  value: true
});
doubleStruck.doubleStruck = void 0;
doubleStruck.doubleStruck = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.doubleStruck = void 0;
  var double_struck_js_1 = doubleStruck;
  Object.defineProperty(exports, "doubleStruck", {
    enumerable: true,
    get: function () {
      return double_struck_js_1.doubleStruck;
    }
  });
})(doubleStruck$1);
getDefaultExportFromCjs(doubleStruck$1);

var frakturBold$1 = {};

var frakturBold = {};

Object.defineProperty(frakturBold, "__esModule", {
  value: true
});
frakturBold.frakturBold = void 0;
frakturBold.frakturBold = {
  0x21: [.689, .012, .349],
  0x22: [.695, -0.432, .254],
  0x26: [.696, .016, .871],
  0x27: [.695, -0.436, .25],
  0x28: [.737, .186, .459],
  0x29: [.735, .187, .459],
  0x2A: [.692, -0.449, .328],
  0x2B: [.598, .082, .893],
  0x2C: [.107, .191, .328],
  0x2D: [.275, -0.236, .893],
  0x2E: [.102, .015, .328],
  0x2F: [.721, .182, .593],
  0x30: [.501, .012, .593],
  0x31: [.489, 0, .593],
  0x32: [.491, 0, .593],
  0x33: [.487, .193, .593],
  0x34: [.495, .196, .593],
  0x35: [.481, .19, .593],
  0x36: [.704, .012, .593],
  0x37: [.479, .197, .593],
  0x38: [.714, .005, .593],
  0x39: [.487, .195, .593],
  0x3A: [.457, .012, .255],
  0x3B: [.458, .19, .255],
  0x3D: [.343, -0.168, .582],
  0x3F: [.697, .014, .428],
  0x5B: [.74, .13, .257],
  0x5D: [.738, .132, .257],
  0x5E: [.734, -0.452, .59],
  0x2018: [.708, -0.411, .254],
  0x2019: [.692, -0.394, .254],
  0x2044: [.721, .182, .593],
  0xE301: [.63, .027, .587],
  0xE302: [.693, .212, .394, {
    ic: .014
  }],
  0xE303: [.681, .219, .387],
  0xE304: [.473, .212, .593],
  0xE305: [.684, .027, .393],
  0xE308: [.679, .22, .981],
  0xE309: [.717, .137, .727]
};

Object.defineProperty(frakturBold$1, "__esModule", {
  value: true
});
frakturBold$1.frakturBold = void 0;
var FontData_js_1$f = FontData;
var fraktur_bold_js_1$1 = frakturBold;
frakturBold$1.frakturBold = (0, FontData_js_1$f.AddCSS)(fraktur_bold_js_1$1.frakturBold, {
  0x2044: {
    c: '/'
  }
});

var fraktur$1 = {};

var fraktur = {};

Object.defineProperty(fraktur, "__esModule", {
  value: true
});
fraktur.fraktur = void 0;
fraktur.fraktur = {
  0x21: [.689, .012, .296],
  0x22: [.695, -0.432, .215],
  0x26: [.698, .011, .738],
  0x27: [.695, -0.436, .212],
  0x28: [.737, .186, .389],
  0x29: [.735, .187, .389],
  0x2A: [.692, -0.449, .278],
  0x2B: [.598, .082, .756],
  0x2C: [.107, .191, .278],
  0x2D: [.275, -0.236, .756],
  0x2E: [.102, .015, .278],
  0x2F: [.721, .182, .502],
  0x30: [.492, .013, .502],
  0x31: [.468, 0, .502],
  0x32: [.474, 0, .502],
  0x33: [.473, .182, .502],
  0x34: [.476, .191, .502],
  0x35: [.458, .184, .502],
  0x36: [.7, .013, .502],
  0x37: [.468, .181, .502],
  0x38: [.705, .01, .502],
  0x39: [.469, .182, .502],
  0x3A: [.457, .012, .216],
  0x3B: [.458, .189, .216],
  0x3D: [.368, -0.132, .756],
  0x3F: [.693, .011, .362],
  0x5B: [.74, .13, .278],
  0x5D: [.738, .131, .278],
  0x5E: [.734, -0.452, .5],
  0x2018: [.708, -0.41, .215],
  0x2019: [.692, -0.395, .215],
  0x2044: [.721, .182, .502],
  0xE300: [.683, .032, .497],
  0xE301: [.616, .03, .498],
  0xE302: [.68, .215, .333],
  0xE303: [.679, .224, .329],
  0xE304: [.471, .214, .503],
  0xE305: [.686, .02, .333],
  0xE306: [.577, .021, .334, {
    ic: .013
  }],
  0xE307: [.475, .022, .501, {
    ic: .013
  }]
};

Object.defineProperty(fraktur$1, "__esModule", {
  value: true
});
fraktur$1.fraktur = void 0;
var FontData_js_1$e = FontData;
var fraktur_js_1$1 = fraktur;
fraktur$1.fraktur = (0, FontData_js_1$e.AddCSS)(fraktur_js_1$1.fraktur, {
  0x2044: {
    c: '/'
  }
});

var italic$1 = {};

var italic = {};

Object.defineProperty(italic, "__esModule", {
  value: true
});
italic.italic = void 0;
italic.italic = {
  0x21: [.716, 0, .307, {
    ic: .073
  }],
  0x22: [.694, -0.379, .514, {
    ic: .024
  }],
  0x23: [.694, .194, .818, {
    ic: .01
  }],
  0x25: [.75, .056, .818, {
    ic: .029
  }],
  0x26: [.716, .022, .767, {
    ic: .035
  }],
  0x27: [.694, -0.379, .307, {
    ic: .07
  }],
  0x28: [.75, .25, .409, {
    ic: .108
  }],
  0x29: [.75, .25, .409],
  0x2A: [.75, -0.32, .511, {
    ic: .073
  }],
  0x2B: [.557, .057, .767],
  0x2C: [.121, .194, .307],
  0x2D: [.251, -0.18, .358],
  0x2E: [.121, 0, .307],
  0x2F: [.716, .215, .778],
  0x30: [.665, .021, .511, {
    ic: .051
  }],
  0x31: [.666, 0, .511],
  0x32: [.666, .022, .511, {
    ic: .04
  }],
  0x33: [.666, .022, .511, {
    ic: .051
  }],
  0x34: [.666, .194, .511],
  0x35: [.666, .022, .511, {
    ic: .056
  }],
  0x36: [.665, .022, .511, {
    ic: .054
  }],
  0x37: [.666, .022, .511, {
    ic: .123
  }],
  0x38: [.666, .021, .511, {
    ic: .042
  }],
  0x39: [.666, .022, .511, {
    ic: .042
  }],
  0x3A: [.431, 0, .307],
  0x3B: [.431, .194, .307],
  0x3D: [.367, -0.133, .767],
  0x3F: [.716, 0, .511, {
    ic: .04
  }],
  0x40: [.705, .011, .767, {
    ic: .022
  }],
  0x5B: [.75, .25, .307, {
    ic: .139
  }],
  0x5D: [.75, .25, .307, {
    ic: .052
  }],
  0x5E: [.694, -0.527, .511, {
    ic: .017
  }],
  0x5F: [-0.025, .062, .511, {
    ic: .043
  }],
  0x7E: [.318, -0.208, .511, {
    ic: .06
  }],
  0x131: [.441, .01, .307, {
    ic: .033
  }],
  0x237: [.442, .204, .332],
  0x300: [.697, -0.5, 0],
  0x301: [.697, -0.5, 0, {
    ic: .039
  }],
  0x302: [.694, -0.527, 0, {
    ic: .017
  }],
  0x303: [.668, -0.558, 0, {
    ic: .06
  }],
  0x304: [.589, -0.544, 0, {
    ic: .054
  }],
  0x306: [.694, -0.515, 0, {
    ic: .062
  }],
  0x307: [.669, -0.548, 0],
  0x308: [.669, -0.554, 0, {
    ic: .045
  }],
  0x30A: [.716, -0.542, 0],
  0x30B: [.697, -0.503, 0, {
    ic: .065
  }],
  0x30C: [.638, -0.502, 0, {
    ic: .029
  }],
  0x3DD: [.605, .085, .778],
  0x2013: [.285, -0.248, .511, {
    ic: .043
  }],
  0x2014: [.285, -0.248, 1.022, {
    ic: .016
  }],
  0x2015: [.285, -0.248, 1.022, {
    ic: .016
  }],
  0x2017: [-0.025, .062, .511, {
    ic: .043
  }],
  0x2018: [.694, -0.379, .307, {
    ic: .055
  }],
  0x2019: [.694, -0.379, .307, {
    ic: .07
  }],
  0x201C: [.694, -0.379, .514, {
    ic: .092
  }],
  0x201D: [.694, -0.379, .514, {
    ic: .024
  }],
  0x2044: [.716, .215, .778],
  0x210F: [.695, .013, .54, {
    ic: .022
  }],
  0x2206: [.716, 0, .833, {
    sk: .167
  }],
  0x29F8: [.716, .215, .778]
};

Object.defineProperty(italic$1, "__esModule", {
  value: true
});
italic$1.italic = void 0;
var FontData_js_1$d = FontData;
var italic_js_1$1 = italic;
italic$1.italic = (0, FontData_js_1$d.AddCSS)(italic_js_1$1.italic, {
  0x2F: {
    f: 'I'
  },
  0x3DD: {
    c: '\\E008',
    f: 'A'
  },
  0x2015: {
    c: '\\2014'
  },
  0x2017: {
    c: '_'
  },
  0x2044: {
    c: '/',
    f: 'I'
  },
  0x2206: {
    c: '\\394',
    f: 'I'
  },
  0x29F8: {
    c: '/',
    f: 'I'
  }
});

var largeop$1 = {};

var largeop = {};

Object.defineProperty(largeop, "__esModule", {
  value: true
});
largeop.largeop = void 0;
largeop.largeop = {
  0x28: [1.15, .649, .597],
  0x29: [1.15, .649, .597],
  0x2F: [1.15, .649, .811],
  0x5B: [1.15, .649, .472],
  0x5C: [1.15, .649, .811],
  0x5D: [1.15, .649, .472],
  0x7B: [1.15, .649, .667],
  0x7D: [1.15, .649, .667],
  0x2C6: [.772, -0.565, 1],
  0x2DC: [.75, -0.611, 1],
  0x302: [.772, -0.565, 0],
  0x303: [.75, -0.611, 0],
  0x2016: [.602, 0, .778],
  0x2044: [1.15, .649, .811],
  0x2191: [.6, 0, .667],
  0x2193: [.6, 0, .667],
  0x21D1: [.599, 0, .778],
  0x21D3: [.6, 0, .778],
  0x220F: [.95, .45, 1.278],
  0x2210: [.95, .45, 1.278],
  0x2211: [.95, .45, 1.444],
  0x221A: [1.15, .65, 1, {
    ic: .02
  }],
  0x2223: [.627, .015, .333],
  0x2225: [.627, .015, .556],
  0x222B: [1.36, .862, .556, {
    ic: .388
  }],
  0x222C: [1.36, .862, 1.084, {
    ic: .388
  }],
  0x222D: [1.36, .862, 1.592, {
    ic: .388
  }],
  0x222E: [1.36, .862, .556, {
    ic: .388
  }],
  0x22C0: [.95, .45, 1.111],
  0x22C1: [.95, .45, 1.111],
  0x22C2: [.949, .45, 1.111],
  0x22C3: [.95, .449, 1.111],
  0x2308: [1.15, .649, .528],
  0x2309: [1.15, .649, .528],
  0x230A: [1.15, .649, .528],
  0x230B: [1.15, .649, .528],
  0x2329: [1.15, .649, .611],
  0x232A: [1.15, .649, .611],
  0x23D0: [.602, 0, .667],
  0x2758: [.627, .015, .333],
  0x27E8: [1.15, .649, .611],
  0x27E9: [1.15, .649, .611],
  0x2A00: [.949, .449, 1.511],
  0x2A01: [.949, .449, 1.511],
  0x2A02: [.949, .449, 1.511],
  0x2A04: [.95, .449, 1.111],
  0x2A06: [.95, .45, 1.111],
  0x2A0C: [1.36, .862, 2.168, {
    ic: .388
  }],
  0x3008: [1.15, .649, .611],
  0x3009: [1.15, .649, .611]
};

Object.defineProperty(largeop$1, "__esModule", {
  value: true
});
largeop$1.largeop = void 0;
var FontData_js_1$c = FontData;
var largeop_js_1$1 = largeop;
largeop$1.largeop = (0, FontData_js_1$c.AddCSS)(largeop_js_1$1.largeop, {
  0x2016: {
    f: 'S1'
  },
  0x2044: {
    c: '/'
  },
  0x2191: {
    f: 'S1'
  },
  0x2193: {
    f: 'S1'
  },
  0x21D1: {
    f: 'S1'
  },
  0x21D3: {
    f: 'S1'
  },
  0x2223: {
    f: 'S1'
  },
  0x2225: {
    f: 'S1'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x23D0: {
    f: 'S1'
  },
  0x2758: {
    c: '\\2223',
    f: 'S1'
  },
  0x2A0C: {
    c: '\\222C\\222C'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  }
});

var monospace$1 = {};

var monospace = {};

Object.defineProperty(monospace, "__esModule", {
  value: true
});
monospace.monospace = void 0;
monospace.monospace = {
  0x20: [0, 0, .525],
  0x21: [.622, 0, .525],
  0x22: [.623, -0.333, .525],
  0x23: [.611, 0, .525],
  0x24: [.694, .082, .525],
  0x25: [.694, .083, .525],
  0x26: [.622, .011, .525],
  0x27: [.611, -0.287, .525],
  0x28: [.694, .082, .525],
  0x29: [.694, .082, .525],
  0x2A: [.52, -0.09, .525],
  0x2B: [.531, -0.081, .525],
  0x2C: [.14, .139, .525],
  0x2D: [.341, -0.271, .525],
  0x2E: [.14, 0, .525],
  0x2F: [.694, .083, .525],
  0x3A: [.431, 0, .525],
  0x3B: [.431, .139, .525],
  0x3C: [.557, -0.055, .525],
  0x3D: [.417, -0.195, .525],
  0x3E: [.557, -0.055, .525],
  0x3F: [.617, 0, .525],
  0x40: [.617, .006, .525],
  0x5B: [.694, .082, .525],
  0x5C: [.694, .083, .525],
  0x5D: [.694, .082, .525],
  0x5E: [.611, -0.46, .525],
  0x5F: [-0.025, .095, .525],
  0x60: [.681, -0.357, .525],
  0x7B: [.694, .083, .525],
  0x7C: [.694, .082, .525],
  0x7D: [.694, .083, .525],
  0x7E: [.611, -0.466, .525],
  0x7F: [.612, -0.519, .525],
  0xA0: [0, 0, .525],
  0x131: [.431, 0, .525],
  0x237: [.431, .228, .525],
  0x2B9: [.623, -0.334, .525],
  0x300: [.611, -0.485, 0],
  0x301: [.611, -0.485, 0],
  0x302: [.611, -0.46, 0],
  0x303: [.611, -0.466, 0],
  0x304: [.577, -0.5, 0],
  0x306: [.611, -0.504, 0],
  0x308: [.612, -0.519, 0],
  0x30A: [.619, -0.499, 0],
  0x30C: [.577, -0.449, 0],
  0x391: [.623, 0, .525],
  0x392: [.611, 0, .525],
  0x393: [.611, 0, .525],
  0x394: [.623, 0, .525],
  0x395: [.611, 0, .525],
  0x396: [.611, 0, .525],
  0x397: [.611, 0, .525],
  0x398: [.621, .01, .525],
  0x399: [.611, 0, .525],
  0x39A: [.611, 0, .525],
  0x39B: [.623, 0, .525],
  0x39C: [.611, 0, .525],
  0x39D: [.611, 0, .525],
  0x39E: [.611, 0, .525],
  0x39F: [.621, .01, .525],
  0x3A0: [.611, 0, .525],
  0x3A1: [.611, 0, .525],
  0x3A3: [.611, 0, .525],
  0x3A4: [.611, 0, .525],
  0x3A5: [.622, 0, .525],
  0x3A6: [.611, 0, .525],
  0x3A7: [.611, 0, .525],
  0x3A8: [.611, 0, .525],
  0x3A9: [.622, 0, .525],
  0x2017: [-0.025, .095, .525],
  0x2032: [.623, -0.334, .525],
  0x2033: [.623, 0, 1.05],
  0x2034: [.623, 0, 1.575],
  0x2044: [.694, .083, .525],
  0x2057: [.623, 0, 2.1],
  0x2206: [.623, 0, .525]
};

Object.defineProperty(monospace$1, "__esModule", {
  value: true
});
monospace$1.monospace = void 0;
var FontData_js_1$b = FontData;
var monospace_js_1$1 = monospace;
monospace$1.monospace = (0, FontData_js_1$b.AddCSS)(monospace_js_1$1.monospace, {
  0x2B9: {
    c: '\\2032'
  },
  0x391: {
    c: 'A'
  },
  0x392: {
    c: 'B'
  },
  0x395: {
    c: 'E'
  },
  0x396: {
    c: 'Z'
  },
  0x397: {
    c: 'H'
  },
  0x399: {
    c: 'I'
  },
  0x39A: {
    c: 'K'
  },
  0x39C: {
    c: 'M'
  },
  0x39D: {
    c: 'N'
  },
  0x39F: {
    c: 'O'
  },
  0x3A1: {
    c: 'P'
  },
  0x3A4: {
    c: 'T'
  },
  0x3A7: {
    c: 'X'
  },
  0x2017: {
    c: '_'
  },
  0x2033: {
    c: '\\2032\\2032'
  },
  0x2034: {
    c: '\\2032\\2032\\2032'
  },
  0x2044: {
    c: '/'
  },
  0x2057: {
    c: '\\2032\\2032\\2032\\2032'
  },
  0x2206: {
    c: '\\394'
  }
});

var normal$1 = {};

var normal = {};

Object.defineProperty(normal, "__esModule", {
  value: true
});
normal.normal = void 0;
normal.normal = {
  0x20: [0, 0, .25],
  0x21: [.716, 0, .278],
  0x22: [.694, -0.379, .5],
  0x23: [.694, .194, .833],
  0x24: [.75, .056, .5],
  0x25: [.75, .056, .833],
  0x26: [.716, .022, .778],
  0x27: [.694, -0.379, .278],
  0x28: [.75, .25, .389],
  0x29: [.75, .25, .389],
  0x2A: [.75, -0.32, .5],
  0x2B: [.583, .082, .778],
  0x2C: [.121, .194, .278],
  0x2D: [.252, -0.179, .333],
  0x2E: [.12, 0, .278],
  0x2F: [.75, .25, .5],
  0x30: [.666, .022, .5],
  0x31: [.666, 0, .5],
  0x32: [.666, 0, .5],
  0x33: [.665, .022, .5],
  0x34: [.677, 0, .5],
  0x35: [.666, .022, .5],
  0x36: [.666, .022, .5],
  0x37: [.676, .022, .5],
  0x38: [.666, .022, .5],
  0x39: [.666, .022, .5],
  0x3A: [.43, 0, .278],
  0x3B: [.43, .194, .278],
  0x3C: [.54, .04, .778],
  0x3D: [.583, .082, .778],
  0x3E: [.54, .04, .778],
  0x3F: [.705, 0, .472],
  0x40: [.705, .011, .778],
  0x41: [.716, 0, .75],
  0x42: [.683, 0, .708],
  0x43: [.705, .021, .722],
  0x44: [.683, 0, .764],
  0x45: [.68, 0, .681],
  0x46: [.68, 0, .653],
  0x47: [.705, .022, .785],
  0x48: [.683, 0, .75],
  0x49: [.683, 0, .361],
  0x4A: [.683, .022, .514],
  0x4B: [.683, 0, .778],
  0x4C: [.683, 0, .625],
  0x4D: [.683, 0, .917],
  0x4E: [.683, 0, .75],
  0x4F: [.705, .022, .778],
  0x50: [.683, 0, .681],
  0x51: [.705, .193, .778],
  0x52: [.683, .022, .736],
  0x53: [.705, .022, .556],
  0x54: [.677, 0, .722],
  0x55: [.683, .022, .75],
  0x56: [.683, .022, .75],
  0x57: [.683, .022, 1.028],
  0x58: [.683, 0, .75],
  0x59: [.683, 0, .75],
  0x5A: [.683, 0, .611],
  0x5B: [.75, .25, .278],
  0x5C: [.75, .25, .5],
  0x5D: [.75, .25, .278],
  0x5E: [.694, -0.531, .5],
  0x5F: [-0.025, .062, .5],
  0x60: [.699, -0.505, .5],
  0x61: [.448, .011, .5],
  0x62: [.694, .011, .556],
  0x63: [.448, .011, .444],
  0x64: [.694, .011, .556],
  0x65: [.448, .011, .444],
  0x66: [.705, 0, .306, {
    ic: .066
  }],
  0x67: [.453, .206, .5],
  0x68: [.694, 0, .556],
  0x69: [.669, 0, .278],
  0x6A: [.669, .205, .306],
  0x6B: [.694, 0, .528],
  0x6C: [.694, 0, .278],
  0x6D: [.442, 0, .833],
  0x6E: [.442, 0, .556],
  0x6F: [.448, .01, .5],
  0x70: [.442, .194, .556],
  0x71: [.442, .194, .528],
  0x72: [.442, 0, .392],
  0x73: [.448, .011, .394],
  0x74: [.615, .01, .389],
  0x75: [.442, .011, .556],
  0x76: [.431, .011, .528],
  0x77: [.431, .011, .722],
  0x78: [.431, 0, .528],
  0x79: [.431, .204, .528],
  0x7A: [.431, 0, .444],
  0x7B: [.75, .25, .5],
  0x7C: [.75, .249, .278],
  0x7D: [.75, .25, .5],
  0x7E: [.318, -0.215, .5],
  0xA0: [0, 0, .25],
  0xA3: [.714, .011, .769],
  0xA5: [.683, 0, .75],
  0xA8: [.669, -0.554, .5],
  0xAC: [.356, -0.089, .667],
  0xAE: [.709, .175, .947],
  0xAF: [.59, -0.544, .5],
  0xB0: [.715, -0.542, .5],
  0xB1: [.666, 0, .778],
  0xB4: [.699, -0.505, .5],
  0xB7: [.31, -0.19, .278],
  0xD7: [.491, -0.009, .778],
  0xF0: [.749, .021, .556],
  0xF7: [.537, .036, .778],
  0x131: [.442, 0, .278, {
    sk: .0278
  }],
  0x237: [.442, .205, .306, {
    sk: .0833
  }],
  0x2B9: [.56, -0.043, .275],
  0x2C6: [.694, -0.531, .5],
  0x2C7: [.644, -0.513, .5],
  0x2C9: [.59, -0.544, .5],
  0x2CA: [.699, -0.505, .5],
  0x2CB: [.699, -0.505, .5],
  0x2D8: [.694, -0.515, .5],
  0x2D9: [.669, -0.549, .5],
  0x2DA: [.715, -0.542, .5],
  0x2DC: [.668, -0.565, .5],
  0x300: [.699, -0.505, 0],
  0x301: [.699, -0.505, 0],
  0x302: [.694, -0.531, 0],
  0x303: [.668, -0.565, 0],
  0x304: [.59, -0.544, 0],
  0x306: [.694, -0.515, 0],
  0x307: [.669, -0.549, 0],
  0x308: [.669, -0.554, 0],
  0x30A: [.715, -0.542, 0],
  0x30B: [.701, -0.51, 0],
  0x30C: [.644, -0.513, 0],
  0x338: [.716, .215, 0],
  0x391: [.716, 0, .75],
  0x392: [.683, 0, .708],
  0x393: [.68, 0, .625],
  0x394: [.716, 0, .833],
  0x395: [.68, 0, .681],
  0x396: [.683, 0, .611],
  0x397: [.683, 0, .75],
  0x398: [.705, .022, .778],
  0x399: [.683, 0, .361],
  0x39A: [.683, 0, .778],
  0x39B: [.716, 0, .694],
  0x39C: [.683, 0, .917],
  0x39D: [.683, 0, .75],
  0x39E: [.677, 0, .667],
  0x39F: [.705, .022, .778],
  0x3A0: [.68, 0, .75],
  0x3A1: [.683, 0, .681],
  0x3A3: [.683, 0, .722],
  0x3A4: [.677, 0, .722],
  0x3A5: [.705, 0, .778],
  0x3A6: [.683, 0, .722],
  0x3A7: [.683, 0, .75],
  0x3A8: [.683, 0, .778],
  0x3A9: [.704, 0, .722],
  0x2000: [0, 0, .5],
  0x2001: [0, 0, 1],
  0x2002: [0, 0, .5],
  0x2003: [0, 0, 1],
  0x2004: [0, 0, .333],
  0x2005: [0, 0, .25],
  0x2006: [0, 0, .167],
  0x2009: [0, 0, .167],
  0x200A: [0, 0, .1],
  0x200B: [0, 0, 0],
  0x200C: [0, 0, 0],
  0x2013: [.285, -0.248, .5],
  0x2014: [.285, -0.248, 1],
  0x2015: [.285, -0.248, 1],
  0x2016: [.75, .25, .5],
  0x2017: [-0.025, .062, .5],
  0x2018: [.694, -0.379, .278],
  0x2019: [.694, -0.379, .278],
  0x201C: [.694, -0.379, .5],
  0x201D: [.694, -0.379, .5],
  0x2020: [.705, .216, .444],
  0x2021: [.705, .205, .444],
  0x2022: [.444, -0.055, .5],
  0x2026: [.12, 0, 1.172],
  0x2032: [.56, -0.043, .275],
  0x2033: [.56, 0, .55],
  0x2034: [.56, 0, .825],
  0x2035: [.56, -0.043, .275],
  0x2036: [.56, 0, .55],
  0x2037: [.56, 0, .825],
  0x203E: [.59, -0.544, .5],
  0x2044: [.75, .25, .5],
  0x2057: [.56, 0, 1.1],
  0x2060: [0, 0, 0],
  0x2061: [0, 0, 0],
  0x2062: [0, 0, 0],
  0x2063: [0, 0, 0],
  0x2064: [0, 0, 0],
  0x20D7: [.714, -0.516, .5],
  0x2102: [.702, .019, .722],
  0x210B: [.717, .036, .969, {
    ic: .272,
    sk: .333
  }],
  0x210C: [.666, .133, .72],
  0x210D: [.683, 0, .778],
  0x210E: [.694, .011, .576, {
    sk: -0.0278
  }],
  0x210F: [.695, .013, .54, {
    ic: .022
  }],
  0x2110: [.717, .017, .809, {
    ic: .137,
    sk: .333
  }],
  0x2111: [.686, .026, .554],
  0x2112: [.717, .017, .874, {
    ic: .161,
    sk: .306
  }],
  0x2113: [.705, .02, .417, {
    sk: .111
  }],
  0x2115: [.683, .02, .722],
  0x2118: [.453, .216, .636, {
    sk: .111
  }],
  0x2119: [.683, 0, .611],
  0x211A: [.701, .181, .778],
  0x211B: [.717, .017, .85, {
    ic: .037,
    sk: .194
  }],
  0x211C: [.686, .026, .828],
  0x211D: [.683, 0, .722],
  0x2124: [.683, 0, .667],
  0x2126: [.704, 0, .722],
  0x2127: [.684, .022, .722],
  0x2128: [.729, .139, .602],
  0x212C: [.708, .028, .908, {
    ic: .02,
    sk: .194
  }],
  0x212D: [.685, .024, .613],
  0x2130: [.707, .008, .562, {
    ic: .156,
    sk: .139
  }],
  0x2131: [.735, .036, .895, {
    ic: .095,
    sk: .222
  }],
  0x2132: [.695, 0, .556],
  0x2133: [.721, .05, 1.08, {
    ic: .136,
    sk: .444
  }],
  0x2135: [.694, 0, .611],
  0x2136: [.763, .021, .667, {
    ic: .02
  }],
  0x2137: [.764, .043, .444],
  0x2138: [.764, .043, .667],
  0x2141: [.705, .023, .639],
  0x2190: [.511, .011, 1],
  0x2191: [.694, .193, .5],
  0x2192: [.511, .011, 1],
  0x2193: [.694, .194, .5],
  0x2194: [.511, .011, 1],
  0x2195: [.772, .272, .5],
  0x2196: [.72, .195, 1],
  0x2197: [.72, .195, 1],
  0x2198: [.695, .22, 1],
  0x2199: [.695, .22, 1],
  0x219A: [.437, -0.06, 1],
  0x219B: [.437, -0.06, 1],
  0x219E: [.417, -0.083, 1],
  0x21A0: [.417, -0.083, 1],
  0x21A2: [.417, -0.083, 1.111],
  0x21A3: [.417, -0.083, 1.111],
  0x21A6: [.511, .011, 1],
  0x21A9: [.511, .011, 1.126],
  0x21AA: [.511, .011, 1.126],
  0x21AB: [.575, .041, 1],
  0x21AC: [.575, .041, 1],
  0x21AD: [.417, -0.083, 1.389],
  0x21AE: [.437, -0.06, 1],
  0x21B0: [.722, 0, .5],
  0x21B1: [.722, 0, .5],
  0x21B6: [.461, 0, 1],
  0x21B7: [.46, 0, 1],
  0x21BA: [.65, .083, .778],
  0x21BB: [.65, .083, .778],
  0x21BC: [.511, -0.23, 1],
  0x21BD: [.27, .011, 1],
  0x21BE: [.694, .194, .417],
  0x21BF: [.694, .194, .417],
  0x21C0: [.511, -0.23, 1],
  0x21C1: [.27, .011, 1],
  0x21C2: [.694, .194, .417],
  0x21C3: [.694, .194, .417],
  0x21C4: [.667, 0, 1],
  0x21C6: [.667, 0, 1],
  0x21C7: [.583, .083, 1],
  0x21C8: [.694, .193, .833],
  0x21C9: [.583, .083, 1],
  0x21CA: [.694, .194, .833],
  0x21CB: [.514, .014, 1],
  0x21CC: [.671, .011, 1],
  0x21CD: [.534, .035, 1],
  0x21CE: [.534, .037, 1],
  0x21CF: [.534, .035, 1],
  0x21D0: [.525, .024, 1],
  0x21D1: [.694, .194, .611],
  0x21D2: [.525, .024, 1],
  0x21D3: [.694, .194, .611],
  0x21D4: [.526, .025, 1],
  0x21D5: [.772, .272, .611],
  0x21DA: [.611, .111, 1],
  0x21DB: [.611, .111, 1],
  0x21DD: [.417, -0.083, 1],
  0x21E0: [.437, -0.064, 1.334],
  0x21E2: [.437, -0.064, 1.334],
  0x2200: [.694, .022, .556],
  0x2201: [.846, .021, .5],
  0x2202: [.715, .022, .531, {
    ic: .035,
    sk: .0833
  }],
  0x2203: [.694, 0, .556],
  0x2204: [.716, .215, .556],
  0x2205: [.772, .078, .5],
  0x2206: [.716, 0, .833],
  0x2207: [.683, .033, .833],
  0x2208: [.54, .04, .667],
  0x2209: [.716, .215, .667],
  0x220B: [.54, .04, .667],
  0x220C: [.716, .215, .667],
  0x220D: [.44, 0, .429, {
    ic: .027
  }],
  0x220F: [.75, .25, .944],
  0x2210: [.75, .25, .944],
  0x2211: [.75, .25, 1.056],
  0x2212: [.583, .082, .778],
  0x2213: [.5, .166, .778],
  0x2214: [.766, .093, .778],
  0x2215: [.75, .25, .5],
  0x2216: [.75, .25, .5],
  0x2217: [.465, -0.035, .5],
  0x2218: [.444, -0.055, .5],
  0x2219: [.444, -0.055, .5],
  0x221A: [.8, .2, .833, {
    ic: .02
  }],
  0x221D: [.442, .011, .778],
  0x221E: [.442, .011, 1],
  0x2220: [.694, 0, .722],
  0x2221: [.714, .02, .722],
  0x2222: [.551, .051, .722],
  0x2223: [.75, .249, .278],
  0x2224: [.75, .252, .278, {
    ic: .019
  }],
  0x2225: [.75, .25, .5],
  0x2226: [.75, .25, .5, {
    ic: .018
  }],
  0x2227: [.598, .022, .667],
  0x2228: [.598, .022, .667],
  0x2229: [.598, .022, .667],
  0x222A: [.598, .022, .667],
  0x222B: [.716, .216, .417, {
    ic: .055
  }],
  0x222C: [.805, .306, .819, {
    ic: .138
  }],
  0x222D: [.805, .306, 1.166, {
    ic: .138
  }],
  0x222E: [.805, .306, .472, {
    ic: .138
  }],
  0x2234: [.471, .082, .667],
  0x2235: [.471, .082, .667],
  0x223C: [.367, -0.133, .778],
  0x223D: [.367, -0.133, .778],
  0x2240: [.583, .083, .278],
  0x2241: [.467, -0.032, .778],
  0x2242: [.463, -0.034, .778],
  0x2243: [.464, -0.036, .778],
  0x2244: [.716, .215, .778],
  0x2245: [.589, -0.022, .778],
  0x2247: [.652, .155, .778],
  0x2248: [.483, -0.055, .778],
  0x2249: [.716, .215, .778],
  0x224A: [.579, .039, .778],
  0x224D: [.484, -0.016, .778],
  0x224E: [.492, -0.008, .778],
  0x224F: [.492, -0.133, .778],
  0x2250: [.67, -0.133, .778],
  0x2251: [.609, .108, .778],
  0x2252: [.601, .101, .778],
  0x2253: [.601, .102, .778],
  0x2256: [.367, -0.133, .778],
  0x2257: [.721, -0.133, .778],
  0x225C: [.859, -0.133, .778],
  0x2260: [.716, .215, .778],
  0x2261: [.464, -0.036, .778],
  0x2262: [.716, .215, .778],
  0x2264: [.636, .138, .778],
  0x2265: [.636, .138, .778],
  0x2266: [.753, .175, .778],
  0x2267: [.753, .175, .778],
  0x2268: [.752, .286, .778],
  0x2269: [.752, .286, .778],
  0x226A: [.568, .067, 1],
  0x226B: [.567, .067, 1],
  0x226C: [.75, .25, .5],
  0x226D: [.716, .215, .778],
  0x226E: [.708, .209, .778],
  0x226F: [.708, .209, .778],
  0x2270: [.801, .303, .778],
  0x2271: [.801, .303, .778],
  0x2272: [.732, .228, .778],
  0x2273: [.732, .228, .778],
  0x2274: [.732, .228, .778],
  0x2275: [.732, .228, .778],
  0x2276: [.681, .253, .778],
  0x2277: [.681, .253, .778],
  0x2278: [.716, .253, .778],
  0x2279: [.716, .253, .778],
  0x227A: [.539, .041, .778],
  0x227B: [.539, .041, .778],
  0x227C: [.58, .153, .778],
  0x227D: [.58, .154, .778],
  0x227E: [.732, .228, .778],
  0x227F: [.732, .228, .778],
  0x2280: [.705, .208, .778],
  0x2281: [.705, .208, .778],
  0x2282: [.54, .04, .778],
  0x2283: [.54, .04, .778],
  0x2284: [.716, .215, .778],
  0x2285: [.716, .215, .778],
  0x2286: [.636, .138, .778],
  0x2287: [.636, .138, .778],
  0x2288: [.801, .303, .778],
  0x2289: [.801, .303, .778],
  0x228A: [.635, .241, .778],
  0x228B: [.635, .241, .778],
  0x228E: [.598, .022, .667],
  0x228F: [.539, .041, .778],
  0x2290: [.539, .041, .778],
  0x2291: [.636, .138, .778],
  0x2292: [.636, .138, .778],
  0x2293: [.598, 0, .667],
  0x2294: [.598, 0, .667],
  0x2295: [.583, .083, .778],
  0x2296: [.583, .083, .778],
  0x2297: [.583, .083, .778],
  0x2298: [.583, .083, .778],
  0x2299: [.583, .083, .778],
  0x229A: [.582, .082, .778],
  0x229B: [.582, .082, .778],
  0x229D: [.582, .082, .778],
  0x229E: [.689, 0, .778],
  0x229F: [.689, 0, .778],
  0x22A0: [.689, 0, .778],
  0x22A1: [.689, 0, .778],
  0x22A2: [.694, 0, .611],
  0x22A3: [.694, 0, .611],
  0x22A4: [.668, 0, .778],
  0x22A5: [.668, 0, .778],
  0x22A8: [.75, .249, .867],
  0x22A9: [.694, 0, .722],
  0x22AA: [.694, 0, .889],
  0x22AC: [.695, 0, .611],
  0x22AD: [.695, 0, .611],
  0x22AE: [.695, 0, .722],
  0x22AF: [.695, 0, .722],
  0x22B2: [.539, .041, .778],
  0x22B3: [.539, .041, .778],
  0x22B4: [.636, .138, .778],
  0x22B5: [.636, .138, .778],
  0x22B8: [.408, -0.092, 1.111],
  0x22BA: [.431, .212, .556],
  0x22BB: [.716, 0, .611],
  0x22BC: [.716, 0, .611],
  0x22C0: [.75, .249, .833],
  0x22C1: [.75, .249, .833],
  0x22C2: [.75, .249, .833],
  0x22C3: [.75, .249, .833],
  0x22C4: [.488, -0.012, .5],
  0x22C5: [.31, -0.19, .278],
  0x22C6: [.486, -0.016, .5],
  0x22C7: [.545, .044, .778],
  0x22C8: [.505, .005, .9],
  0x22C9: [.492, -0.008, .778],
  0x22CA: [.492, -0.008, .778],
  0x22CB: [.694, .022, .778],
  0x22CC: [.694, .022, .778],
  0x22CD: [.464, -0.036, .778],
  0x22CE: [.578, .021, .76],
  0x22CF: [.578, .022, .76],
  0x22D0: [.54, .04, .778],
  0x22D1: [.54, .04, .778],
  0x22D2: [.598, .022, .667],
  0x22D3: [.598, .022, .667],
  0x22D4: [.736, .022, .667],
  0x22D6: [.541, .041, .778],
  0x22D7: [.541, .041, .778],
  0x22D8: [.568, .067, 1.333],
  0x22D9: [.568, .067, 1.333],
  0x22DA: [.886, .386, .778],
  0x22DB: [.886, .386, .778],
  0x22DE: [.734, 0, .778],
  0x22DF: [.734, 0, .778],
  0x22E0: [.801, .303, .778],
  0x22E1: [.801, .303, .778],
  0x22E2: [.716, .215, .778],
  0x22E3: [.716, .215, .778],
  0x22E6: [.73, .359, .778],
  0x22E7: [.73, .359, .778],
  0x22E8: [.73, .359, .778],
  0x22E9: [.73, .359, .778],
  0x22EA: [.706, .208, .778],
  0x22EB: [.706, .208, .778],
  0x22EC: [.802, .303, .778],
  0x22ED: [.801, .303, .778],
  0x22EE: [1.3, .03, .278],
  0x22EF: [.31, -0.19, 1.172],
  0x22F1: [1.52, -0.1, 1.282],
  0x2305: [.716, 0, .611],
  0x2306: [.813, .097, .611],
  0x2308: [.75, .25, .444],
  0x2309: [.75, .25, .444],
  0x230A: [.75, .25, .444],
  0x230B: [.75, .25, .444],
  0x231C: [.694, -0.306, .5],
  0x231D: [.694, -0.306, .5],
  0x231E: [.366, .022, .5],
  0x231F: [.366, .022, .5],
  0x2322: [.388, -0.122, 1],
  0x2323: [.378, -0.134, 1],
  0x2329: [.75, .25, .389],
  0x232A: [.75, .25, .389],
  0x23B0: [.744, .244, .412],
  0x23B1: [.744, .244, .412],
  0x23D0: [.602, 0, .667],
  0x24C8: [.709, .175, .902],
  0x250C: [.694, -0.306, .5],
  0x2510: [.694, -0.306, .5],
  0x2514: [.366, .022, .5],
  0x2518: [.366, .022, .5],
  0x2571: [.694, .195, .889],
  0x2572: [.694, .195, .889],
  0x25A0: [.689, 0, .778],
  0x25A1: [.689, 0, .778],
  0x25AA: [.689, 0, .778],
  0x25B2: [.575, .02, .722],
  0x25B3: [.716, 0, .889],
  0x25B4: [.575, .02, .722],
  0x25B5: [.716, 0, .889],
  0x25B6: [.539, .041, .778],
  0x25B8: [.539, .041, .778],
  0x25B9: [.505, .005, .5],
  0x25BC: [.576, .019, .722],
  0x25BD: [.5, .215, .889],
  0x25BE: [.576, .019, .722],
  0x25BF: [.5, .215, .889],
  0x25C0: [.539, .041, .778],
  0x25C2: [.539, .041, .778],
  0x25C3: [.505, .005, .5],
  0x25CA: [.716, .132, .667],
  0x25EF: [.715, .215, 1],
  0x25FB: [.689, 0, .778],
  0x25FC: [.689, 0, .778],
  0x2605: [.694, .111, .944],
  0x2660: [.727, .13, .778],
  0x2661: [.716, .033, .778],
  0x2662: [.727, .162, .778],
  0x2663: [.726, .13, .778],
  0x266D: [.75, .022, .389],
  0x266E: [.734, .223, .389],
  0x266F: [.723, .223, .389],
  0x2713: [.706, .034, .833],
  0x2720: [.716, .022, .833],
  0x2758: [.75, .249, .278],
  0x27E8: [.75, .25, .389],
  0x27E9: [.75, .25, .389],
  0x27EE: [.744, .244, .412],
  0x27EF: [.744, .244, .412],
  0x27F5: [.511, .011, 1.609],
  0x27F6: [.511, .011, 1.638],
  0x27F7: [.511, .011, 1.859],
  0x27F8: [.525, .024, 1.609],
  0x27F9: [.525, .024, 1.638],
  0x27FA: [.525, .024, 1.858],
  0x27FC: [.511, .011, 1.638],
  0x29EB: [.716, .132, .667],
  0x29F8: [.716, .215, .778],
  0x2A00: [.75, .25, 1.111],
  0x2A01: [.75, .25, 1.111],
  0x2A02: [.75, .25, 1.111],
  0x2A04: [.75, .249, .833],
  0x2A06: [.75, .249, .833],
  0x2A0C: [.805, .306, 1.638, {
    ic: .138
  }],
  0x2A2F: [.491, -0.009, .778],
  0x2A3F: [.683, 0, .75],
  0x2A5E: [.813, .097, .611],
  0x2A7D: [.636, .138, .778],
  0x2A7E: [.636, .138, .778],
  0x2A85: [.762, .29, .778],
  0x2A86: [.762, .29, .778],
  0x2A87: [.635, .241, .778],
  0x2A88: [.635, .241, .778],
  0x2A89: [.761, .387, .778],
  0x2A8A: [.761, .387, .778],
  0x2A8B: [1.003, .463, .778],
  0x2A8C: [1.003, .463, .778],
  0x2A95: [.636, .138, .778],
  0x2A96: [.636, .138, .778],
  0x2AAF: [.636, .138, .778],
  0x2AB0: [.636, .138, .778],
  0x2AB5: [.752, .286, .778],
  0x2AB6: [.752, .286, .778],
  0x2AB7: [.761, .294, .778],
  0x2AB8: [.761, .294, .778],
  0x2AB9: [.761, .337, .778],
  0x2ABA: [.761, .337, .778],
  0x2AC5: [.753, .215, .778],
  0x2AC6: [.753, .215, .778],
  0x2ACB: [.783, .385, .778],
  0x2ACC: [.783, .385, .778],
  0x3008: [.75, .25, .389],
  0x3009: [.75, .25, .389],
  0xE006: [.43, .023, .222, {
    ic: .018
  }],
  0xE007: [.431, .024, .389, {
    ic: .018
  }],
  0xE008: [.605, .085, .778],
  0xE009: [.434, .006, .667, {
    ic: .067
  }],
  0xE00C: [.752, .284, .778],
  0xE00D: [.752, .284, .778],
  0xE00E: [.919, .421, .778],
  0xE00F: [.801, .303, .778],
  0xE010: [.801, .303, .778],
  0xE011: [.919, .421, .778],
  0xE016: [.828, .33, .778],
  0xE017: [.752, .332, .778],
  0xE018: [.828, .33, .778],
  0xE019: [.752, .333, .778],
  0xE01A: [.634, .255, .778],
  0xE01B: [.634, .254, .778],
  0x1D400: [.698, 0, .869],
  0x1D401: [.686, 0, .818],
  0x1D402: [.697, .011, .831],
  0x1D403: [.686, 0, .882],
  0x1D404: [.68, 0, .756],
  0x1D405: [.68, 0, .724],
  0x1D406: [.697, .01, .904],
  0x1D407: [.686, 0, .9],
  0x1D408: [.686, 0, .436],
  0x1D409: [.686, .011, .594],
  0x1D40A: [.686, 0, .901],
  0x1D40B: [.686, 0, .692],
  0x1D40C: [.686, 0, 1.092],
  0x1D40D: [.686, 0, .9],
  0x1D40E: [.696, .01, .864],
  0x1D40F: [.686, 0, .786],
  0x1D410: [.696, .193, .864],
  0x1D411: [.686, .011, .862],
  0x1D412: [.697, .011, .639],
  0x1D413: [.675, 0, .8],
  0x1D414: [.686, .011, .885],
  0x1D415: [.686, .007, .869],
  0x1D416: [.686, .007, 1.189],
  0x1D417: [.686, 0, .869],
  0x1D418: [.686, 0, .869],
  0x1D419: [.686, 0, .703],
  0x1D41A: [.453, .006, .559],
  0x1D41B: [.694, .006, .639],
  0x1D41C: [.453, .006, .511],
  0x1D41D: [.694, .006, .639],
  0x1D41E: [.452, .006, .527],
  0x1D41F: [.7, 0, .351, {
    ic: .101
  }],
  0x1D420: [.455, .201, .575],
  0x1D421: [.694, 0, .639],
  0x1D422: [.695, 0, .319],
  0x1D423: [.695, .2, .351],
  0x1D424: [.694, 0, .607],
  0x1D425: [.694, 0, .319],
  0x1D426: [.45, 0, .958],
  0x1D427: [.45, 0, .639],
  0x1D428: [.452, .005, .575],
  0x1D429: [.45, .194, .639],
  0x1D42A: [.45, .194, .607],
  0x1D42B: [.45, 0, .474],
  0x1D42C: [.453, .006, .454],
  0x1D42D: [.635, .005, .447],
  0x1D42E: [.45, .006, .639],
  0x1D42F: [.444, 0, .607],
  0x1D430: [.444, 0, .831],
  0x1D431: [.444, 0, .607],
  0x1D432: [.444, .2, .607],
  0x1D433: [.444, 0, .511],
  0x1D434: [.716, 0, .75, {
    sk: .139
  }],
  0x1D435: [.683, 0, .759, {
    sk: .0833
  }],
  0x1D436: [.705, .022, .715, {
    ic: .045,
    sk: .0833
  }],
  0x1D437: [.683, 0, .828, {
    sk: .0556
  }],
  0x1D438: [.68, 0, .738, {
    ic: .026,
    sk: .0833
  }],
  0x1D439: [.68, 0, .643, {
    ic: .106,
    sk: .0833
  }],
  0x1D43A: [.705, .022, .786, {
    sk: .0833
  }],
  0x1D43B: [.683, 0, .831, {
    ic: .057,
    sk: .0556
  }],
  0x1D43C: [.683, 0, .44, {
    ic: .064,
    sk: .111
  }],
  0x1D43D: [.683, .022, .555, {
    ic: .078,
    sk: .167
  }],
  0x1D43E: [.683, 0, .849, {
    ic: .04,
    sk: .0556
  }],
  0x1D43F: [.683, 0, .681, {
    sk: .0278
  }],
  0x1D440: [.683, 0, .97, {
    ic: .081,
    sk: .0833
  }],
  0x1D441: [.683, 0, .803, {
    ic: .085,
    sk: .0833
  }],
  0x1D442: [.704, .022, .763, {
    sk: .0833
  }],
  0x1D443: [.683, 0, .642, {
    ic: .109,
    sk: .0833
  }],
  0x1D444: [.704, .194, .791, {
    sk: .0833
  }],
  0x1D445: [.683, .021, .759, {
    sk: .0833
  }],
  0x1D446: [.705, .022, .613, {
    ic: .032,
    sk: .0833
  }],
  0x1D447: [.677, 0, .584, {
    ic: .12,
    sk: .0833
  }],
  0x1D448: [.683, .022, .683, {
    ic: .084,
    sk: .0278
  }],
  0x1D449: [.683, .022, .583, {
    ic: .186
  }],
  0x1D44A: [.683, .022, .944, {
    ic: .104
  }],
  0x1D44B: [.683, 0, .828, {
    ic: .024,
    sk: .0833
  }],
  0x1D44C: [.683, 0, .581, {
    ic: .182
  }],
  0x1D44D: [.683, 0, .683, {
    ic: .04,
    sk: .0833
  }],
  0x1D44E: [.441, .01, .529],
  0x1D44F: [.694, .011, .429],
  0x1D450: [.442, .011, .433, {
    sk: .0556
  }],
  0x1D451: [.694, .01, .52, {
    sk: .167
  }],
  0x1D452: [.442, .011, .466, {
    sk: .0556
  }],
  0x1D453: [.705, .205, .49, {
    ic: .06,
    sk: .167
  }],
  0x1D454: [.442, .205, .477, {
    sk: .0278
  }],
  0x1D456: [.661, .011, .345],
  0x1D457: [.661, .204, .412],
  0x1D458: [.694, .011, .521],
  0x1D459: [.694, .011, .298, {
    sk: .0833
  }],
  0x1D45A: [.442, .011, .878],
  0x1D45B: [.442, .011, .6],
  0x1D45C: [.441, .011, .485, {
    sk: .0556
  }],
  0x1D45D: [.442, .194, .503, {
    sk: .0833
  }],
  0x1D45E: [.442, .194, .446, {
    ic: .014,
    sk: .0833
  }],
  0x1D45F: [.442, .011, .451, {
    sk: .0556
  }],
  0x1D460: [.442, .01, .469, {
    sk: .0556
  }],
  0x1D461: [.626, .011, .361, {
    sk: .0833
  }],
  0x1D462: [.442, .011, .572, {
    sk: .0278
  }],
  0x1D463: [.443, .011, .485, {
    sk: .0278
  }],
  0x1D464: [.443, .011, .716, {
    sk: .0833
  }],
  0x1D465: [.442, .011, .572, {
    sk: .0278
  }],
  0x1D466: [.442, .205, .49, {
    sk: .0556
  }],
  0x1D467: [.442, .011, .465, {
    sk: .0556
  }],
  0x1D468: [.711, 0, .869, {
    sk: .16
  }],
  0x1D469: [.686, 0, .866, {
    sk: .0958
  }],
  0x1D46A: [.703, .017, .817, {
    ic: .038,
    sk: .0958
  }],
  0x1D46B: [.686, 0, .938, {
    sk: .0639
  }],
  0x1D46C: [.68, 0, .81, {
    ic: .015,
    sk: .0958
  }],
  0x1D46D: [.68, 0, .689, {
    ic: .12,
    sk: .0958
  }],
  0x1D46E: [.703, .016, .887, {
    sk: .0958
  }],
  0x1D46F: [.686, 0, .982, {
    ic: .045,
    sk: .0639
  }],
  0x1D470: [.686, 0, .511, {
    ic: .062,
    sk: .128
  }],
  0x1D471: [.686, .017, .631, {
    ic: .063,
    sk: .192
  }],
  0x1D472: [.686, 0, .971, {
    ic: .032,
    sk: .0639
  }],
  0x1D473: [.686, 0, .756, {
    sk: .0319
  }],
  0x1D474: [.686, 0, 1.142, {
    ic: .077,
    sk: .0958
  }],
  0x1D475: [.686, 0, .95, {
    ic: .077,
    sk: .0958
  }],
  0x1D476: [.703, .017, .837, {
    sk: .0958
  }],
  0x1D477: [.686, 0, .723, {
    ic: .124,
    sk: .0958
  }],
  0x1D478: [.703, .194, .869, {
    sk: .0958
  }],
  0x1D479: [.686, .017, .872, {
    sk: .0958
  }],
  0x1D47A: [.703, .017, .693, {
    ic: .021,
    sk: .0958
  }],
  0x1D47B: [.675, 0, .637, {
    ic: .135,
    sk: .0958
  }],
  0x1D47C: [.686, .016, .8, {
    ic: .077,
    sk: .0319
  }],
  0x1D47D: [.686, .016, .678, {
    ic: .208
  }],
  0x1D47E: [.686, .017, 1.093, {
    ic: .114
  }],
  0x1D47F: [.686, 0, .947, {
    sk: .0958
  }],
  0x1D480: [.686, 0, .675, {
    ic: .201
  }],
  0x1D481: [.686, 0, .773, {
    ic: .032,
    sk: .0958
  }],
  0x1D482: [.452, .008, .633],
  0x1D483: [.694, .008, .521],
  0x1D484: [.451, .008, .513, {
    sk: .0639
  }],
  0x1D485: [.694, .008, .61, {
    sk: .192
  }],
  0x1D486: [.452, .008, .554, {
    sk: .0639
  }],
  0x1D487: [.701, .201, .568, {
    ic: .056,
    sk: .192
  }],
  0x1D488: [.452, .202, .545, {
    sk: .0319
  }],
  0x1D489: [.694, .008, .668, {
    sk: -0.0319
  }],
  0x1D48A: [.694, .008, .405],
  0x1D48B: [.694, .202, .471],
  0x1D48C: [.694, .008, .604],
  0x1D48D: [.694, .008, .348, {
    sk: .0958
  }],
  0x1D48E: [.452, .008, 1.032],
  0x1D48F: [.452, .008, .713],
  0x1D490: [.452, .008, .585, {
    sk: .0639
  }],
  0x1D491: [.452, .194, .601, {
    sk: .0958
  }],
  0x1D492: [.452, .194, .542, {
    sk: .0958
  }],
  0x1D493: [.452, .008, .529, {
    sk: .0639
  }],
  0x1D494: [.451, .008, .531, {
    sk: .0639
  }],
  0x1D495: [.643, .007, .415, {
    sk: .0958
  }],
  0x1D496: [.452, .008, .681, {
    sk: .0319
  }],
  0x1D497: [.453, .008, .567, {
    sk: .0319
  }],
  0x1D498: [.453, .008, .831, {
    sk: .0958
  }],
  0x1D499: [.452, .008, .659, {
    sk: .0319
  }],
  0x1D49A: [.452, .202, .59, {
    sk: .0639
  }],
  0x1D49B: [.452, .008, .555, {
    sk: .0639
  }],
  0x1D49C: [.717, .008, .803, {
    ic: .213,
    sk: .389
  }],
  0x1D49E: [.728, .026, .666, {
    ic: .153,
    sk: .278
  }],
  0x1D49F: [.708, .031, .774, {
    ic: .081,
    sk: .111
  }],
  0x1D4A2: [.717, .037, .61, {
    ic: .128,
    sk: .25
  }],
  0x1D4A5: [.717, .314, 1.052, {
    ic: .081,
    sk: .417
  }],
  0x1D4A6: [.717, .037, .914, {
    ic: .29,
    sk: .361
  }],
  0x1D4A9: [.726, .036, .902, {
    ic: .306,
    sk: .389
  }],
  0x1D4AA: [.707, .008, .738, {
    ic: .067,
    sk: .167
  }],
  0x1D4AB: [.716, .037, 1.013, {
    ic: .018,
    sk: .222
  }],
  0x1D4AC: [.717, .017, .883, {
    sk: .278
  }],
  0x1D4AE: [.708, .036, .868, {
    ic: .148,
    sk: .333
  }],
  0x1D4AF: [.735, .037, .747, {
    ic: .249,
    sk: .222
  }],
  0x1D4B0: [.717, .017, .8, {
    ic: .16,
    sk: .25
  }],
  0x1D4B1: [.717, .017, .622, {
    ic: .228,
    sk: .222
  }],
  0x1D4B2: [.717, .017, .805, {
    ic: .221,
    sk: .25
  }],
  0x1D4B3: [.717, .017, .944, {
    ic: .187,
    sk: .278
  }],
  0x1D4B4: [.716, .017, .71, {
    ic: .249,
    sk: .194
  }],
  0x1D4B5: [.717, .016, .821, {
    ic: .211,
    sk: .306
  }],
  0x1D504: [.696, .026, .718],
  0x1D505: [.691, .027, .884],
  0x1D507: [.685, .027, .832],
  0x1D508: [.685, .024, .663],
  0x1D509: [.686, .153, .611],
  0x1D50A: [.69, .026, .785],
  0x1D50D: [.686, .139, .552],
  0x1D50E: [.68, .027, .668, {
    ic: .014
  }],
  0x1D50F: [.686, .026, .666],
  0x1D510: [.692, .027, 1.05],
  0x1D511: [.686, .025, .832],
  0x1D512: [.729, .027, .827],
  0x1D513: [.692, .218, .828],
  0x1D514: [.729, .069, .827],
  0x1D516: [.692, .027, .829],
  0x1D517: [.701, .027, .669],
  0x1D518: [.697, .027, .646, {
    ic: .019
  }],
  0x1D519: [.686, .026, .831],
  0x1D51A: [.686, .027, 1.046],
  0x1D51B: [.688, .027, .719],
  0x1D51C: [.686, .218, .833],
  0x1D51E: [.47, .035, .5],
  0x1D51F: [.685, .031, .513],
  0x1D520: [.466, .029, .389],
  0x1D521: [.609, .033, .499],
  0x1D522: [.467, .03, .401],
  0x1D523: [.681, .221, .326],
  0x1D524: [.47, .209, .504],
  0x1D525: [.688, .205, .521],
  0x1D526: [.673, .02, .279],
  0x1D527: [.672, .208, .281],
  0x1D528: [.689, .025, .389],
  0x1D529: [.685, .02, .28],
  0x1D52A: [.475, .026, .767],
  0x1D52B: [.475, .022, .527],
  0x1D52C: [.48, .028, .489],
  0x1D52D: [.541, .212, .5],
  0x1D52E: [.479, .219, .489],
  0x1D52F: [.474, .021, .389],
  0x1D530: [.478, .029, .443],
  0x1D531: [.64, .02, .333, {
    ic: .015
  }],
  0x1D532: [.474, .023, .517],
  0x1D533: [.53, .028, .512],
  0x1D534: [.532, .028, .774],
  0x1D535: [.472, .188, .389],
  0x1D536: [.528, .218, .499],
  0x1D537: [.471, .214, .391],
  0x1D538: [.701, 0, .722],
  0x1D539: [.683, 0, .667],
  0x1D53B: [.683, 0, .722],
  0x1D53C: [.683, 0, .667],
  0x1D53D: [.683, 0, .611],
  0x1D53E: [.702, .019, .778],
  0x1D540: [.683, 0, .389],
  0x1D541: [.683, .077, .5],
  0x1D542: [.683, 0, .778],
  0x1D543: [.683, 0, .667],
  0x1D544: [.683, 0, .944],
  0x1D546: [.701, .019, .778],
  0x1D54A: [.702, .012, .556],
  0x1D54B: [.683, 0, .667],
  0x1D54C: [.683, .019, .722],
  0x1D54D: [.683, .02, .722],
  0x1D54E: [.683, .019, 1],
  0x1D54F: [.683, 0, .722],
  0x1D550: [.683, 0, .722],
  0x1D56C: [.686, .031, .847],
  0x1D56D: [.684, .031, 1.044],
  0x1D56E: [.676, .032, .723],
  0x1D56F: [.683, .029, .982],
  0x1D570: [.686, .029, .783],
  0x1D571: [.684, .146, .722],
  0x1D572: [.687, .029, .927],
  0x1D573: [.683, .126, .851],
  0x1D574: [.681, .025, .655],
  0x1D575: [.68, .141, .652],
  0x1D576: [.681, .026, .789, {
    ic: .017
  }],
  0x1D577: [.683, .028, .786],
  0x1D578: [.683, .032, 1.239],
  0x1D579: [.679, .03, .983],
  0x1D57A: [.726, .03, .976],
  0x1D57B: [.688, .223, .977],
  0x1D57C: [.726, .083, .976],
  0x1D57D: [.688, .028, .978],
  0x1D57E: [.685, .031, .978],
  0x1D57F: [.686, .03, .79, {
    ic: .012
  }],
  0x1D580: [.688, .039, .851, {
    ic: .02
  }],
  0x1D581: [.685, .029, .982],
  0x1D582: [.683, .03, 1.235],
  0x1D583: [.681, .035, .849],
  0x1D584: [.688, .214, .984],
  0x1D585: [.677, .148, .711],
  0x1D586: [.472, .032, .603],
  0x1D587: [.69, .032, .59],
  0x1D588: [.473, .026, .464],
  0x1D589: [.632, .028, .589],
  0x1D58A: [.471, .027, .472],
  0x1D58B: [.687, .222, .388],
  0x1D58C: [.472, .208, .595],
  0x1D58D: [.687, .207, .615],
  0x1D58E: [.686, .025, .331],
  0x1D58F: [.682, .203, .332],
  0x1D590: [.682, .025, .464],
  0x1D591: [.681, .024, .337],
  0x1D592: [.476, .031, .921],
  0x1D593: [.473, .028, .654],
  0x1D594: [.482, .034, .609],
  0x1D595: [.557, .207, .604],
  0x1D596: [.485, .211, .596],
  0x1D597: [.472, .026, .46],
  0x1D598: [.479, .034, .523],
  0x1D599: [.648, .027, .393, {
    ic: .014
  }],
  0x1D59A: [.472, .032, .589, {
    ic: .014
  }],
  0x1D59B: [.546, .027, .604],
  0x1D59C: [.549, .032, .918],
  0x1D59D: [.471, .188, .459],
  0x1D59E: [.557, .221, .589],
  0x1D59F: [.471, .214, .461],
  0x1D5A0: [.694, 0, .667],
  0x1D5A1: [.694, 0, .667],
  0x1D5A2: [.705, .011, .639],
  0x1D5A3: [.694, 0, .722],
  0x1D5A4: [.691, 0, .597],
  0x1D5A5: [.691, 0, .569],
  0x1D5A6: [.704, .011, .667],
  0x1D5A7: [.694, 0, .708],
  0x1D5A8: [.694, 0, .278],
  0x1D5A9: [.694, .022, .472],
  0x1D5AA: [.694, 0, .694],
  0x1D5AB: [.694, 0, .542],
  0x1D5AC: [.694, 0, .875],
  0x1D5AD: [.694, 0, .708],
  0x1D5AE: [.715, .022, .736],
  0x1D5AF: [.694, 0, .639],
  0x1D5B0: [.715, .125, .736],
  0x1D5B1: [.694, 0, .646],
  0x1D5B2: [.716, .022, .556],
  0x1D5B3: [.688, 0, .681],
  0x1D5B4: [.694, .022, .688],
  0x1D5B5: [.694, 0, .667],
  0x1D5B6: [.694, 0, .944],
  0x1D5B7: [.694, 0, .667],
  0x1D5B8: [.694, 0, .667],
  0x1D5B9: [.694, 0, .611],
  0x1D5BA: [.46, .01, .481],
  0x1D5BB: [.694, .011, .517],
  0x1D5BC: [.46, .01, .444],
  0x1D5BD: [.694, .01, .517],
  0x1D5BE: [.461, .01, .444],
  0x1D5BF: [.705, 0, .306, {
    ic: .041
  }],
  0x1D5C0: [.455, .206, .5],
  0x1D5C1: [.694, 0, .517],
  0x1D5C2: [.68, 0, .239],
  0x1D5C3: [.68, .205, .267],
  0x1D5C4: [.694, 0, .489],
  0x1D5C5: [.694, 0, .239],
  0x1D5C6: [.455, 0, .794],
  0x1D5C7: [.455, 0, .517],
  0x1D5C8: [.46, .01, .5],
  0x1D5C9: [.455, .194, .517],
  0x1D5CA: [.455, .194, .517],
  0x1D5CB: [.455, 0, .342],
  0x1D5CC: [.46, .01, .383],
  0x1D5CD: [.571, .01, .361],
  0x1D5CE: [.444, .01, .517],
  0x1D5CF: [.444, 0, .461],
  0x1D5D0: [.444, 0, .683],
  0x1D5D1: [.444, 0, .461],
  0x1D5D2: [.444, .204, .461],
  0x1D5D3: [.444, 0, .435],
  0x1D5D4: [.694, 0, .733],
  0x1D5D5: [.694, 0, .733],
  0x1D5D6: [.704, .011, .703],
  0x1D5D7: [.694, 0, .794],
  0x1D5D8: [.691, 0, .642],
  0x1D5D9: [.691, 0, .611],
  0x1D5DA: [.705, .011, .733],
  0x1D5DB: [.694, 0, .794],
  0x1D5DC: [.694, 0, .331],
  0x1D5DD: [.694, .022, .519],
  0x1D5DE: [.694, 0, .764],
  0x1D5DF: [.694, 0, .581],
  0x1D5E0: [.694, 0, .978],
  0x1D5E1: [.694, 0, .794],
  0x1D5E2: [.716, .022, .794],
  0x1D5E3: [.694, 0, .703],
  0x1D5E4: [.716, .106, .794],
  0x1D5E5: [.694, 0, .703],
  0x1D5E6: [.716, .022, .611],
  0x1D5E7: [.688, 0, .733],
  0x1D5E8: [.694, .022, .764],
  0x1D5E9: [.694, 0, .733],
  0x1D5EA: [.694, 0, 1.039],
  0x1D5EB: [.694, 0, .733],
  0x1D5EC: [.694, 0, .733],
  0x1D5ED: [.694, 0, .672],
  0x1D5EE: [.475, .011, .525],
  0x1D5EF: [.694, .01, .561],
  0x1D5F0: [.475, .011, .489],
  0x1D5F1: [.694, .011, .561],
  0x1D5F2: [.474, .01, .511],
  0x1D5F3: [.705, 0, .336, {
    ic: .045
  }],
  0x1D5F4: [.469, .206, .55],
  0x1D5F5: [.694, 0, .561],
  0x1D5F6: [.695, 0, .256],
  0x1D5F7: [.695, .205, .286],
  0x1D5F8: [.694, 0, .531],
  0x1D5F9: [.694, 0, .256],
  0x1D5FA: [.469, 0, .867],
  0x1D5FB: [.468, 0, .561],
  0x1D5FC: [.474, .011, .55],
  0x1D5FD: [.469, .194, .561],
  0x1D5FE: [.469, .194, .561],
  0x1D5FF: [.469, 0, .372],
  0x1D600: [.474, .01, .422],
  0x1D601: [.589, .01, .404],
  0x1D602: [.458, .011, .561],
  0x1D603: [.458, 0, .5],
  0x1D604: [.458, 0, .744],
  0x1D605: [.458, 0, .5],
  0x1D606: [.458, .205, .5],
  0x1D607: [.458, 0, .476],
  0x1D608: [.694, 0, .667],
  0x1D609: [.694, 0, .667, {
    ic: .029
  }],
  0x1D60A: [.705, .01, .639, {
    ic: .08
  }],
  0x1D60B: [.694, 0, .722, {
    ic: .025
  }],
  0x1D60C: [.691, 0, .597, {
    ic: .091
  }],
  0x1D60D: [.691, 0, .569, {
    ic: .104
  }],
  0x1D60E: [.705, .011, .667, {
    ic: .063
  }],
  0x1D60F: [.694, 0, .708, {
    ic: .06
  }],
  0x1D610: [.694, 0, .278, {
    ic: .06
  }],
  0x1D611: [.694, .022, .472, {
    ic: .063
  }],
  0x1D612: [.694, 0, .694, {
    ic: .091
  }],
  0x1D613: [.694, 0, .542],
  0x1D614: [.694, 0, .875, {
    ic: .054
  }],
  0x1D615: [.694, 0, .708, {
    ic: .058
  }],
  0x1D616: [.716, .022, .736, {
    ic: .027
  }],
  0x1D617: [.694, 0, .639, {
    ic: .051
  }],
  0x1D618: [.716, .125, .736, {
    ic: .027
  }],
  0x1D619: [.694, 0, .646, {
    ic: .052
  }],
  0x1D61A: [.716, .022, .556, {
    ic: .053
  }],
  0x1D61B: [.688, 0, .681, {
    ic: .109
  }],
  0x1D61C: [.694, .022, .688, {
    ic: .059
  }],
  0x1D61D: [.694, 0, .667, {
    ic: .132
  }],
  0x1D61E: [.694, 0, .944, {
    ic: .132
  }],
  0x1D61F: [.694, 0, .667, {
    ic: .091
  }],
  0x1D620: [.694, 0, .667, {
    ic: .143
  }],
  0x1D621: [.694, 0, .611, {
    ic: .091
  }],
  0x1D622: [.461, .01, .481],
  0x1D623: [.694, .011, .517, {
    ic: .022
  }],
  0x1D624: [.46, .011, .444, {
    ic: .055
  }],
  0x1D625: [.694, .01, .517, {
    ic: .071
  }],
  0x1D626: [.46, .011, .444, {
    ic: .028
  }],
  0x1D627: [.705, 0, .306, {
    ic: .188
  }],
  0x1D628: [.455, .206, .5, {
    ic: .068
  }],
  0x1D629: [.694, 0, .517],
  0x1D62A: [.68, 0, .239, {
    ic: .076
  }],
  0x1D62B: [.68, .204, .267, {
    ic: .069
  }],
  0x1D62C: [.694, 0, .489, {
    ic: .054
  }],
  0x1D62D: [.694, 0, .239, {
    ic: .072
  }],
  0x1D62E: [.455, 0, .794],
  0x1D62F: [.454, 0, .517],
  0x1D630: [.461, .011, .5, {
    ic: .023
  }],
  0x1D631: [.455, .194, .517, {
    ic: .021
  }],
  0x1D632: [.455, .194, .517, {
    ic: .021
  }],
  0x1D633: [.455, 0, .342, {
    ic: .082
  }],
  0x1D634: [.461, .011, .383, {
    ic: .053
  }],
  0x1D635: [.571, .011, .361, {
    ic: .049
  }],
  0x1D636: [.444, .01, .517, {
    ic: .02
  }],
  0x1D637: [.444, 0, .461, {
    ic: .079
  }],
  0x1D638: [.444, 0, .683, {
    ic: .079
  }],
  0x1D639: [.444, 0, .461, {
    ic: .076
  }],
  0x1D63A: [.444, .205, .461, {
    ic: .079
  }],
  0x1D63B: [.444, 0, .435, {
    ic: .059
  }],
  0x1D670: [.623, 0, .525],
  0x1D671: [.611, 0, .525],
  0x1D672: [.622, .011, .525],
  0x1D673: [.611, 0, .525],
  0x1D674: [.611, 0, .525],
  0x1D675: [.611, 0, .525],
  0x1D676: [.622, .011, .525],
  0x1D677: [.611, 0, .525],
  0x1D678: [.611, 0, .525],
  0x1D679: [.611, .011, .525],
  0x1D67A: [.611, 0, .525],
  0x1D67B: [.611, 0, .525],
  0x1D67C: [.611, 0, .525],
  0x1D67D: [.611, 0, .525],
  0x1D67E: [.621, .01, .525],
  0x1D67F: [.611, 0, .525],
  0x1D680: [.621, .138, .525],
  0x1D681: [.611, .011, .525],
  0x1D682: [.622, .011, .525],
  0x1D683: [.611, 0, .525],
  0x1D684: [.611, .011, .525],
  0x1D685: [.611, .007, .525],
  0x1D686: [.611, .007, .525],
  0x1D687: [.611, 0, .525],
  0x1D688: [.611, 0, .525],
  0x1D689: [.611, 0, .525],
  0x1D68A: [.439, .006, .525],
  0x1D68B: [.611, .006, .525],
  0x1D68C: [.44, .006, .525],
  0x1D68D: [.611, .006, .525],
  0x1D68E: [.44, .006, .525],
  0x1D68F: [.617, 0, .525],
  0x1D690: [.442, .229, .525],
  0x1D691: [.611, 0, .525],
  0x1D692: [.612, 0, .525],
  0x1D693: [.612, .228, .525],
  0x1D694: [.611, 0, .525],
  0x1D695: [.611, 0, .525],
  0x1D696: [.436, 0, .525, {
    ic: .011
  }],
  0x1D697: [.436, 0, .525],
  0x1D698: [.44, .006, .525],
  0x1D699: [.437, .221, .525],
  0x1D69A: [.437, .221, .525, {
    ic: .02
  }],
  0x1D69B: [.437, 0, .525],
  0x1D69C: [.44, .006, .525],
  0x1D69D: [.554, .006, .525],
  0x1D69E: [.431, .005, .525],
  0x1D69F: [.431, 0, .525],
  0x1D6A0: [.431, 0, .525],
  0x1D6A1: [.431, 0, .525],
  0x1D6A2: [.431, .228, .525],
  0x1D6A3: [.431, 0, .525],
  0x1D6A8: [.698, 0, .869],
  0x1D6A9: [.686, 0, .818],
  0x1D6AA: [.68, 0, .692],
  0x1D6AB: [.698, 0, .958],
  0x1D6AC: [.68, 0, .756],
  0x1D6AD: [.686, 0, .703],
  0x1D6AE: [.686, 0, .9],
  0x1D6AF: [.696, .01, .894],
  0x1D6B0: [.686, 0, .436],
  0x1D6B1: [.686, 0, .901],
  0x1D6B2: [.698, 0, .806],
  0x1D6B3: [.686, 0, 1.092],
  0x1D6B4: [.686, 0, .9],
  0x1D6B5: [.675, 0, .767],
  0x1D6B6: [.696, .01, .864],
  0x1D6B7: [.68, 0, .9],
  0x1D6B8: [.686, 0, .786],
  0x1D6BA: [.686, 0, .831],
  0x1D6BB: [.675, 0, .8],
  0x1D6BC: [.697, 0, .894],
  0x1D6BD: [.686, 0, .831],
  0x1D6BE: [.686, 0, .869],
  0x1D6BF: [.686, 0, .894],
  0x1D6C0: [.696, 0, .831],
  0x1D6C1: [.686, .024, .958],
  0x1D6E2: [.716, 0, .75, {
    sk: .139
  }],
  0x1D6E3: [.683, 0, .759, {
    sk: .0833
  }],
  0x1D6E4: [.68, 0, .615, {
    ic: .106,
    sk: .0833
  }],
  0x1D6E5: [.716, 0, .833, {
    sk: .167
  }],
  0x1D6E6: [.68, 0, .738, {
    ic: .026,
    sk: .0833
  }],
  0x1D6E7: [.683, 0, .683, {
    ic: .04,
    sk: .0833
  }],
  0x1D6E8: [.683, 0, .831, {
    ic: .057,
    sk: .0556
  }],
  0x1D6E9: [.704, .022, .763, {
    sk: .0833
  }],
  0x1D6EA: [.683, 0, .44, {
    ic: .064,
    sk: .111
  }],
  0x1D6EB: [.683, 0, .849, {
    ic: .04,
    sk: .0556
  }],
  0x1D6EC: [.716, 0, .694, {
    sk: .167
  }],
  0x1D6ED: [.683, 0, .97, {
    ic: .081,
    sk: .0833
  }],
  0x1D6EE: [.683, 0, .803, {
    ic: .085,
    sk: .0833
  }],
  0x1D6EF: [.677, 0, .742, {
    ic: .035,
    sk: .0833
  }],
  0x1D6F0: [.704, .022, .763, {
    sk: .0833
  }],
  0x1D6F1: [.68, 0, .831, {
    ic: .056,
    sk: .0556
  }],
  0x1D6F2: [.683, 0, .642, {
    ic: .109,
    sk: .0833
  }],
  0x1D6F4: [.683, 0, .78, {
    ic: .026,
    sk: .0833
  }],
  0x1D6F5: [.677, 0, .584, {
    ic: .12,
    sk: .0833
  }],
  0x1D6F6: [.705, 0, .583, {
    ic: .117,
    sk: .0556
  }],
  0x1D6F7: [.683, 0, .667, {
    sk: .0833
  }],
  0x1D6F8: [.683, 0, .828, {
    ic: .024,
    sk: .0833
  }],
  0x1D6F9: [.683, 0, .612, {
    ic: .08,
    sk: .0556
  }],
  0x1D6FA: [.704, 0, .772, {
    ic: .014,
    sk: .0833
  }],
  0x1D6FC: [.442, .011, .64, {
    sk: .0278
  }],
  0x1D6FD: [.705, .194, .566, {
    sk: .0833
  }],
  0x1D6FE: [.441, .216, .518, {
    ic: .025
  }],
  0x1D6FF: [.717, .01, .444, {
    sk: .0556
  }],
  0x1D700: [.452, .022, .466, {
    sk: .0833
  }],
  0x1D701: [.704, .204, .438, {
    ic: .033,
    sk: .0833
  }],
  0x1D702: [.442, .216, .497, {
    sk: .0556
  }],
  0x1D703: [.705, .01, .469, {
    sk: .0833
  }],
  0x1D704: [.442, .01, .354, {
    sk: .0556
  }],
  0x1D705: [.442, .011, .576],
  0x1D706: [.694, .012, .583],
  0x1D707: [.442, .216, .603, {
    sk: .0278
  }],
  0x1D708: [.442, 0, .494, {
    ic: .036,
    sk: .0278
  }],
  0x1D709: [.704, .205, .438, {
    sk: .111
  }],
  0x1D70A: [.441, .011, .485, {
    sk: .0556
  }],
  0x1D70B: [.431, .011, .57],
  0x1D70C: [.442, .216, .517, {
    sk: .0833
  }],
  0x1D70D: [.442, .107, .363, {
    ic: .042,
    sk: .0833
  }],
  0x1D70E: [.431, .011, .571],
  0x1D70F: [.431, .013, .437, {
    ic: .08,
    sk: .0278
  }],
  0x1D710: [.443, .01, .54, {
    sk: .0278
  }],
  0x1D711: [.442, .218, .654, {
    sk: .0833
  }],
  0x1D712: [.442, .204, .626, {
    sk: .0556
  }],
  0x1D713: [.694, .205, .651, {
    sk: .111
  }],
  0x1D714: [.443, .011, .622],
  0x1D715: [.715, .022, .531, {
    ic: .035,
    sk: .0833
  }],
  0x1D716: [.431, .011, .406, {
    sk: .0556
  }],
  0x1D717: [.705, .011, .591, {
    sk: .0833
  }],
  0x1D718: [.434, .006, .667, {
    ic: .067
  }],
  0x1D719: [.694, .205, .596, {
    sk: .0833
  }],
  0x1D71A: [.442, .194, .517, {
    sk: .0833
  }],
  0x1D71B: [.431, .01, .828],
  0x1D71C: [.711, 0, .869, {
    sk: .16
  }],
  0x1D71D: [.686, 0, .866, {
    sk: .0958
  }],
  0x1D71E: [.68, 0, .657, {
    ic: .12,
    sk: .0958
  }],
  0x1D71F: [.711, 0, .958, {
    sk: .192
  }],
  0x1D720: [.68, 0, .81, {
    ic: .015,
    sk: .0958
  }],
  0x1D721: [.686, 0, .773, {
    ic: .032,
    sk: .0958
  }],
  0x1D722: [.686, 0, .982, {
    ic: .045,
    sk: .0639
  }],
  0x1D723: [.702, .017, .867, {
    sk: .0958
  }],
  0x1D724: [.686, 0, .511, {
    ic: .062,
    sk: .128
  }],
  0x1D725: [.686, 0, .971, {
    ic: .032,
    sk: .0639
  }],
  0x1D726: [.711, 0, .806, {
    sk: .192
  }],
  0x1D727: [.686, 0, 1.142, {
    ic: .077,
    sk: .0958
  }],
  0x1D728: [.686, 0, .95, {
    ic: .077,
    sk: .0958
  }],
  0x1D729: [.675, 0, .841, {
    ic: .026,
    sk: .0958
  }],
  0x1D72A: [.703, .017, .837, {
    sk: .0958
  }],
  0x1D72B: [.68, 0, .982, {
    ic: .044,
    sk: .0639
  }],
  0x1D72C: [.686, 0, .723, {
    ic: .124,
    sk: .0958
  }],
  0x1D72E: [.686, 0, .885, {
    ic: .017,
    sk: .0958
  }],
  0x1D72F: [.675, 0, .637, {
    ic: .135,
    sk: .0958
  }],
  0x1D730: [.703, 0, .671, {
    ic: .131,
    sk: .0639
  }],
  0x1D731: [.686, 0, .767, {
    sk: .0958
  }],
  0x1D732: [.686, 0, .947, {
    sk: .0958
  }],
  0x1D733: [.686, 0, .714, {
    ic: .076,
    sk: .0639
  }],
  0x1D734: [.703, 0, .879, {
    sk: .0958
  }],
  0x1D736: [.452, .008, .761, {
    sk: .0319
  }],
  0x1D737: [.701, .194, .66, {
    sk: .0958
  }],
  0x1D738: [.451, .211, .59, {
    ic: .027
  }],
  0x1D739: [.725, .008, .522, {
    sk: .0639
  }],
  0x1D73A: [.461, .017, .529, {
    sk: .0958
  }],
  0x1D73B: [.711, .202, .508, {
    ic: .013,
    sk: .0958
  }],
  0x1D73C: [.452, .211, .6, {
    sk: .0639
  }],
  0x1D73D: [.702, .008, .562, {
    sk: .0958
  }],
  0x1D73E: [.452, .008, .412, {
    sk: .0639
  }],
  0x1D73F: [.452, .008, .668],
  0x1D740: [.694, .013, .671],
  0x1D741: [.452, .211, .708, {
    sk: .0319
  }],
  0x1D742: [.452, 0, .577, {
    ic: .031,
    sk: .0319
  }],
  0x1D743: [.711, .201, .508, {
    sk: .128
  }],
  0x1D744: [.452, .008, .585, {
    sk: .0639
  }],
  0x1D745: [.444, .008, .682],
  0x1D746: [.451, .211, .612, {
    sk: .0958
  }],
  0x1D747: [.451, .105, .424, {
    ic: .033,
    sk: .0958
  }],
  0x1D748: [.444, .008, .686],
  0x1D749: [.444, .013, .521, {
    ic: .089,
    sk: .0319
  }],
  0x1D74A: [.453, .008, .631, {
    sk: .0319
  }],
  0x1D74B: [.452, .216, .747, {
    sk: .0958
  }],
  0x1D74C: [.452, .201, .718, {
    sk: .0639
  }],
  0x1D74D: [.694, .202, .758, {
    sk: .128
  }],
  0x1D74E: [.453, .008, .718],
  0x1D74F: [.71, .017, .628, {
    ic: .029,
    sk: .0958
  }],
  0x1D750: [.444, .007, .483, {
    sk: .0639
  }],
  0x1D751: [.701, .008, .692, {
    sk: .0958
  }],
  0x1D752: [.434, .006, .667, {
    ic: .067
  }],
  0x1D753: [.694, .202, .712, {
    sk: .0958
  }],
  0x1D754: [.451, .194, .612, {
    sk: .0958
  }],
  0x1D755: [.444, .008, .975],
  0x1D756: [.694, 0, .733],
  0x1D757: [.694, 0, .733],
  0x1D758: [.691, 0, .581],
  0x1D759: [.694, 0, .917],
  0x1D75A: [.691, 0, .642],
  0x1D75B: [.694, 0, .672],
  0x1D75C: [.694, 0, .794],
  0x1D75D: [.716, .022, .856],
  0x1D75E: [.694, 0, .331],
  0x1D75F: [.694, 0, .764],
  0x1D760: [.694, 0, .672],
  0x1D761: [.694, 0, .978],
  0x1D762: [.694, 0, .794],
  0x1D763: [.688, 0, .733],
  0x1D764: [.716, .022, .794],
  0x1D765: [.691, 0, .794],
  0x1D766: [.694, 0, .703],
  0x1D768: [.694, 0, .794],
  0x1D769: [.688, 0, .733],
  0x1D76A: [.715, 0, .856],
  0x1D76B: [.694, 0, .794],
  0x1D76C: [.694, 0, .733],
  0x1D76D: [.694, 0, .856],
  0x1D76E: [.716, 0, .794],
  0x1D7CE: [.654, .01, .575],
  0x1D7CF: [.655, 0, .575],
  0x1D7D0: [.654, 0, .575],
  0x1D7D1: [.655, .011, .575],
  0x1D7D2: [.656, 0, .575],
  0x1D7D3: [.655, .011, .575],
  0x1D7D4: [.655, .011, .575],
  0x1D7D5: [.676, .011, .575],
  0x1D7D6: [.654, .011, .575],
  0x1D7D7: [.654, .011, .575],
  0x1D7E2: [.678, .022, .5],
  0x1D7E3: [.678, 0, .5],
  0x1D7E4: [.677, 0, .5],
  0x1D7E5: [.678, .022, .5],
  0x1D7E6: [.656, 0, .5],
  0x1D7E7: [.656, .021, .5],
  0x1D7E8: [.677, .022, .5],
  0x1D7E9: [.656, .011, .5],
  0x1D7EA: [.678, .022, .5],
  0x1D7EB: [.677, .022, .5],
  0x1D7EC: [.715, .022, .55],
  0x1D7ED: [.716, 0, .55],
  0x1D7EE: [.716, 0, .55],
  0x1D7EF: [.716, .022, .55],
  0x1D7F0: [.694, 0, .55],
  0x1D7F1: [.694, .022, .55],
  0x1D7F2: [.716, .022, .55],
  0x1D7F3: [.695, .011, .55],
  0x1D7F4: [.715, .022, .55],
  0x1D7F5: [.716, .022, .55],
  0x1D7F6: [.621, .01, .525],
  0x1D7F7: [.622, 0, .525],
  0x1D7F8: [.622, 0, .525],
  0x1D7F9: [.622, .011, .525],
  0x1D7FA: [.624, 0, .525],
  0x1D7FB: [.611, .01, .525],
  0x1D7FC: [.622, .011, .525],
  0x1D7FD: [.627, .01, .525],
  0x1D7FE: [.621, .01, .525],
  0x1D7FF: [.622, .011, .525]
};

Object.defineProperty(normal$1, "__esModule", {
  value: true
});
normal$1.normal = void 0;
var FontData_js_1$a = FontData;
var normal_js_1$1 = normal;
normal$1.normal = (0, FontData_js_1$a.AddCSS)(normal_js_1$1.normal, {
  0xA3: {
    f: 'MI'
  },
  0xA5: {
    f: 'A'
  },
  0xAE: {
    f: 'A'
  },
  0xB7: {
    c: '\\22C5'
  },
  0xF0: {
    f: 'A'
  },
  0x2B9: {
    c: '\\2032'
  },
  0x391: {
    c: 'A'
  },
  0x392: {
    c: 'B'
  },
  0x395: {
    c: 'E'
  },
  0x396: {
    c: 'Z'
  },
  0x397: {
    c: 'H'
  },
  0x399: {
    c: 'I'
  },
  0x39A: {
    c: 'K'
  },
  0x39C: {
    c: 'M'
  },
  0x39D: {
    c: 'N'
  },
  0x39F: {
    c: 'O'
  },
  0x3A1: {
    c: 'P'
  },
  0x3A4: {
    c: 'T'
  },
  0x3A7: {
    c: 'X'
  },
  0x2000: {
    c: ''
  },
  0x2001: {
    c: ''
  },
  0x2002: {
    c: ''
  },
  0x2003: {
    c: ''
  },
  0x2004: {
    c: ''
  },
  0x2005: {
    c: ''
  },
  0x2006: {
    c: ''
  },
  0x2009: {
    c: ''
  },
  0x200A: {
    c: ''
  },
  0x200B: {
    c: ''
  },
  0x200C: {
    c: ''
  },
  0x2015: {
    c: '\\2014'
  },
  0x2016: {
    c: '\\2225'
  },
  0x2017: {
    c: '_'
  },
  0x2022: {
    c: '\\2219'
  },
  0x2033: {
    c: '\\2032\\2032'
  },
  0x2034: {
    c: '\\2032\\2032\\2032'
  },
  0x2035: {
    f: 'A'
  },
  0x2036: {
    c: '\\2035\\2035',
    f: 'A'
  },
  0x2037: {
    c: '\\2035\\2035\\2035',
    f: 'A'
  },
  0x203E: {
    c: '\\2C9'
  },
  0x2044: {
    c: '/'
  },
  0x2057: {
    c: '\\2032\\2032\\2032\\2032'
  },
  0x2060: {
    c: ''
  },
  0x2061: {
    c: ''
  },
  0x2062: {
    c: ''
  },
  0x2063: {
    c: ''
  },
  0x2064: {
    c: ''
  },
  0x20D7: {
    c: '\\2192',
    f: 'V'
  },
  0x2102: {
    c: 'C',
    f: 'A'
  },
  0x210B: {
    c: 'H',
    f: 'SC'
  },
  0x210C: {
    c: 'H',
    f: 'FR'
  },
  0x210D: {
    c: 'H',
    f: 'A'
  },
  0x210E: {
    c: 'h',
    f: 'I'
  },
  0x210F: {
    f: 'A'
  },
  0x2110: {
    c: 'I',
    f: 'SC'
  },
  0x2111: {
    c: 'I',
    f: 'FR'
  },
  0x2112: {
    c: 'L',
    f: 'SC'
  },
  0x2115: {
    c: 'N',
    f: 'A'
  },
  0x2119: {
    c: 'P',
    f: 'A'
  },
  0x211A: {
    c: 'Q',
    f: 'A'
  },
  0x211B: {
    c: 'R',
    f: 'SC'
  },
  0x211C: {
    c: 'R',
    f: 'FR'
  },
  0x211D: {
    c: 'R',
    f: 'A'
  },
  0x2124: {
    c: 'Z',
    f: 'A'
  },
  0x2126: {
    c: '\\3A9'
  },
  0x2127: {
    f: 'A'
  },
  0x2128: {
    c: 'Z',
    f: 'FR'
  },
  0x212C: {
    c: 'B',
    f: 'SC'
  },
  0x212D: {
    c: 'C',
    f: 'FR'
  },
  0x2130: {
    c: 'E',
    f: 'SC'
  },
  0x2131: {
    c: 'F',
    f: 'SC'
  },
  0x2132: {
    f: 'A'
  },
  0x2133: {
    c: 'M',
    f: 'SC'
  },
  0x2136: {
    f: 'A'
  },
  0x2137: {
    f: 'A'
  },
  0x2138: {
    f: 'A'
  },
  0x2141: {
    f: 'A'
  },
  0x219A: {
    f: 'A'
  },
  0x219B: {
    f: 'A'
  },
  0x219E: {
    f: 'A'
  },
  0x21A0: {
    f: 'A'
  },
  0x21A2: {
    f: 'A'
  },
  0x21A3: {
    f: 'A'
  },
  0x21AB: {
    f: 'A'
  },
  0x21AC: {
    f: 'A'
  },
  0x21AD: {
    f: 'A'
  },
  0x21AE: {
    f: 'A'
  },
  0x21B0: {
    f: 'A'
  },
  0x21B1: {
    f: 'A'
  },
  0x21B6: {
    f: 'A'
  },
  0x21B7: {
    f: 'A'
  },
  0x21BA: {
    f: 'A'
  },
  0x21BB: {
    f: 'A'
  },
  0x21BE: {
    f: 'A'
  },
  0x21BF: {
    f: 'A'
  },
  0x21C2: {
    f: 'A'
  },
  0x21C3: {
    f: 'A'
  },
  0x21C4: {
    f: 'A'
  },
  0x21C6: {
    f: 'A'
  },
  0x21C7: {
    f: 'A'
  },
  0x21C8: {
    f: 'A'
  },
  0x21C9: {
    f: 'A'
  },
  0x21CA: {
    f: 'A'
  },
  0x21CB: {
    f: 'A'
  },
  0x21CD: {
    f: 'A'
  },
  0x21CE: {
    f: 'A'
  },
  0x21CF: {
    f: 'A'
  },
  0x21DA: {
    f: 'A'
  },
  0x21DB: {
    f: 'A'
  },
  0x21DD: {
    f: 'A'
  },
  0x21E0: {
    f: 'A'
  },
  0x21E2: {
    f: 'A'
  },
  0x2201: {
    f: 'A'
  },
  0x2204: {
    c: '\\2203\\338'
  },
  0x2206: {
    c: '\\394'
  },
  0x220C: {
    c: '\\220B\\338'
  },
  0x220D: {
    f: 'A'
  },
  0x220F: {
    f: 'S1'
  },
  0x2210: {
    f: 'S1'
  },
  0x2211: {
    f: 'S1'
  },
  0x2214: {
    f: 'A'
  },
  0x2221: {
    f: 'A'
  },
  0x2222: {
    f: 'A'
  },
  0x2224: {
    f: 'A'
  },
  0x2226: {
    f: 'A'
  },
  0x222C: {
    f: 'S1'
  },
  0x222D: {
    f: 'S1'
  },
  0x222E: {
    f: 'S1'
  },
  0x2234: {
    f: 'A'
  },
  0x2235: {
    f: 'A'
  },
  0x223D: {
    f: 'A'
  },
  0x2241: {
    f: 'A'
  },
  0x2242: {
    f: 'A'
  },
  0x2244: {
    c: '\\2243\\338'
  },
  0x2247: {
    c: '\\2246',
    f: 'A'
  },
  0x2249: {
    c: '\\2248\\338'
  },
  0x224A: {
    f: 'A'
  },
  0x224E: {
    f: 'A'
  },
  0x224F: {
    f: 'A'
  },
  0x2251: {
    f: 'A'
  },
  0x2252: {
    f: 'A'
  },
  0x2253: {
    f: 'A'
  },
  0x2256: {
    f: 'A'
  },
  0x2257: {
    f: 'A'
  },
  0x225C: {
    f: 'A'
  },
  0x2262: {
    c: '\\2261\\338'
  },
  0x2266: {
    f: 'A'
  },
  0x2267: {
    f: 'A'
  },
  0x2268: {
    f: 'A'
  },
  0x2269: {
    f: 'A'
  },
  0x226C: {
    f: 'A'
  },
  0x226D: {
    c: '\\224D\\338'
  },
  0x226E: {
    f: 'A'
  },
  0x226F: {
    f: 'A'
  },
  0x2270: {
    f: 'A'
  },
  0x2271: {
    f: 'A'
  },
  0x2272: {
    f: 'A'
  },
  0x2273: {
    f: 'A'
  },
  0x2274: {
    c: '\\2272\\338'
  },
  0x2275: {
    c: '\\2273\\338'
  },
  0x2276: {
    f: 'A'
  },
  0x2277: {
    f: 'A'
  },
  0x2278: {
    c: '\\2276\\338'
  },
  0x2279: {
    c: '\\2277\\338'
  },
  0x227C: {
    f: 'A'
  },
  0x227D: {
    f: 'A'
  },
  0x227E: {
    f: 'A'
  },
  0x227F: {
    f: 'A'
  },
  0x2280: {
    f: 'A'
  },
  0x2281: {
    f: 'A'
  },
  0x2284: {
    c: '\\2282\\338'
  },
  0x2285: {
    c: '\\2283\\338'
  },
  0x2288: {
    f: 'A'
  },
  0x2289: {
    f: 'A'
  },
  0x228A: {
    f: 'A'
  },
  0x228B: {
    f: 'A'
  },
  0x228F: {
    f: 'A'
  },
  0x2290: {
    f: 'A'
  },
  0x229A: {
    f: 'A'
  },
  0x229B: {
    f: 'A'
  },
  0x229D: {
    f: 'A'
  },
  0x229E: {
    f: 'A'
  },
  0x229F: {
    f: 'A'
  },
  0x22A0: {
    f: 'A'
  },
  0x22A1: {
    f: 'A'
  },
  0x22A9: {
    f: 'A'
  },
  0x22AA: {
    f: 'A'
  },
  0x22AC: {
    f: 'A'
  },
  0x22AD: {
    f: 'A'
  },
  0x22AE: {
    f: 'A'
  },
  0x22AF: {
    f: 'A'
  },
  0x22B2: {
    f: 'A'
  },
  0x22B3: {
    f: 'A'
  },
  0x22B4: {
    f: 'A'
  },
  0x22B5: {
    f: 'A'
  },
  0x22B8: {
    f: 'A'
  },
  0x22BA: {
    f: 'A'
  },
  0x22BB: {
    f: 'A'
  },
  0x22BC: {
    f: 'A'
  },
  0x22C0: {
    f: 'S1'
  },
  0x22C1: {
    f: 'S1'
  },
  0x22C2: {
    f: 'S1'
  },
  0x22C3: {
    f: 'S1'
  },
  0x22C7: {
    f: 'A'
  },
  0x22C9: {
    f: 'A'
  },
  0x22CA: {
    f: 'A'
  },
  0x22CB: {
    f: 'A'
  },
  0x22CC: {
    f: 'A'
  },
  0x22CD: {
    f: 'A'
  },
  0x22CE: {
    f: 'A'
  },
  0x22CF: {
    f: 'A'
  },
  0x22D0: {
    f: 'A'
  },
  0x22D1: {
    f: 'A'
  },
  0x22D2: {
    f: 'A'
  },
  0x22D3: {
    f: 'A'
  },
  0x22D4: {
    f: 'A'
  },
  0x22D6: {
    f: 'A'
  },
  0x22D7: {
    f: 'A'
  },
  0x22D8: {
    f: 'A'
  },
  0x22D9: {
    f: 'A'
  },
  0x22DA: {
    f: 'A'
  },
  0x22DB: {
    f: 'A'
  },
  0x22DE: {
    f: 'A'
  },
  0x22DF: {
    f: 'A'
  },
  0x22E0: {
    f: 'A'
  },
  0x22E1: {
    f: 'A'
  },
  0x22E2: {
    c: '\\2291\\338'
  },
  0x22E3: {
    c: '\\2292\\338'
  },
  0x22E6: {
    f: 'A'
  },
  0x22E7: {
    f: 'A'
  },
  0x22E8: {
    f: 'A'
  },
  0x22E9: {
    f: 'A'
  },
  0x22EA: {
    f: 'A'
  },
  0x22EB: {
    f: 'A'
  },
  0x22EC: {
    f: 'A'
  },
  0x22ED: {
    f: 'A'
  },
  0x2305: {
    c: '\\22BC',
    f: 'A'
  },
  0x2306: {
    c: '\\2A5E',
    f: 'A'
  },
  0x231C: {
    c: '\\250C',
    f: 'A'
  },
  0x231D: {
    c: '\\2510',
    f: 'A'
  },
  0x231E: {
    c: '\\2514',
    f: 'A'
  },
  0x231F: {
    c: '\\2518',
    f: 'A'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x23D0: {
    f: 'S1'
  },
  0x24C8: {
    f: 'A'
  },
  0x250C: {
    f: 'A'
  },
  0x2510: {
    f: 'A'
  },
  0x2514: {
    f: 'A'
  },
  0x2518: {
    f: 'A'
  },
  0x2571: {
    f: 'A'
  },
  0x2572: {
    f: 'A'
  },
  0x25A0: {
    f: 'A'
  },
  0x25A1: {
    f: 'A'
  },
  0x25AA: {
    c: '\\25A0',
    f: 'A'
  },
  0x25B2: {
    f: 'A'
  },
  0x25B4: {
    c: '\\25B2',
    f: 'A'
  },
  0x25B5: {
    c: '\\25B3'
  },
  0x25B6: {
    f: 'A'
  },
  0x25B8: {
    c: '\\25B6',
    f: 'A'
  },
  0x25BC: {
    f: 'A'
  },
  0x25BE: {
    c: '\\25BC',
    f: 'A'
  },
  0x25BF: {
    c: '\\25BD'
  },
  0x25C0: {
    f: 'A'
  },
  0x25C2: {
    c: '\\25C0',
    f: 'A'
  },
  0x25CA: {
    f: 'A'
  },
  0x25FB: {
    c: '\\25A1',
    f: 'A'
  },
  0x25FC: {
    c: '\\25A0',
    f: 'A'
  },
  0x2605: {
    f: 'A'
  },
  0x2713: {
    f: 'A'
  },
  0x2720: {
    f: 'A'
  },
  0x2758: {
    c: '\\2223'
  },
  0x29EB: {
    f: 'A'
  },
  0x29F8: {
    c: '/',
    f: 'I'
  },
  0x2A00: {
    f: 'S1'
  },
  0x2A01: {
    f: 'S1'
  },
  0x2A02: {
    f: 'S1'
  },
  0x2A04: {
    f: 'S1'
  },
  0x2A06: {
    f: 'S1'
  },
  0x2A0C: {
    c: '\\222C\\222C',
    f: 'S1'
  },
  0x2A2F: {
    c: '\\D7'
  },
  0x2A5E: {
    f: 'A'
  },
  0x2A7D: {
    f: 'A'
  },
  0x2A7E: {
    f: 'A'
  },
  0x2A85: {
    f: 'A'
  },
  0x2A86: {
    f: 'A'
  },
  0x2A87: {
    f: 'A'
  },
  0x2A88: {
    f: 'A'
  },
  0x2A89: {
    f: 'A'
  },
  0x2A8A: {
    f: 'A'
  },
  0x2A8B: {
    f: 'A'
  },
  0x2A8C: {
    f: 'A'
  },
  0x2A95: {
    f: 'A'
  },
  0x2A96: {
    f: 'A'
  },
  0x2AB5: {
    f: 'A'
  },
  0x2AB6: {
    f: 'A'
  },
  0x2AB7: {
    f: 'A'
  },
  0x2AB8: {
    f: 'A'
  },
  0x2AB9: {
    f: 'A'
  },
  0x2ABA: {
    f: 'A'
  },
  0x2AC5: {
    f: 'A'
  },
  0x2AC6: {
    f: 'A'
  },
  0x2ACB: {
    f: 'A'
  },
  0x2ACC: {
    f: 'A'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  },
  0xE006: {
    f: 'A'
  },
  0xE007: {
    f: 'A'
  },
  0xE008: {
    f: 'A'
  },
  0xE009: {
    f: 'A'
  },
  0xE00C: {
    f: 'A'
  },
  0xE00D: {
    f: 'A'
  },
  0xE00E: {
    f: 'A'
  },
  0xE00F: {
    f: 'A'
  },
  0xE010: {
    f: 'A'
  },
  0xE011: {
    f: 'A'
  },
  0xE016: {
    f: 'A'
  },
  0xE017: {
    f: 'A'
  },
  0xE018: {
    f: 'A'
  },
  0xE019: {
    f: 'A'
  },
  0xE01A: {
    f: 'A'
  },
  0xE01B: {
    f: 'A'
  },
  0x1D400: {
    c: 'A',
    f: 'B'
  },
  0x1D401: {
    c: 'B',
    f: 'B'
  },
  0x1D402: {
    c: 'C',
    f: 'B'
  },
  0x1D403: {
    c: 'D',
    f: 'B'
  },
  0x1D404: {
    c: 'E',
    f: 'B'
  },
  0x1D405: {
    c: 'F',
    f: 'B'
  },
  0x1D406: {
    c: 'G',
    f: 'B'
  },
  0x1D407: {
    c: 'H',
    f: 'B'
  },
  0x1D408: {
    c: 'I',
    f: 'B'
  },
  0x1D409: {
    c: 'J',
    f: 'B'
  },
  0x1D40A: {
    c: 'K',
    f: 'B'
  },
  0x1D40B: {
    c: 'L',
    f: 'B'
  },
  0x1D40C: {
    c: 'M',
    f: 'B'
  },
  0x1D40D: {
    c: 'N',
    f: 'B'
  },
  0x1D40E: {
    c: 'O',
    f: 'B'
  },
  0x1D40F: {
    c: 'P',
    f: 'B'
  },
  0x1D410: {
    c: 'Q',
    f: 'B'
  },
  0x1D411: {
    c: 'R',
    f: 'B'
  },
  0x1D412: {
    c: 'S',
    f: 'B'
  },
  0x1D413: {
    c: 'T',
    f: 'B'
  },
  0x1D414: {
    c: 'U',
    f: 'B'
  },
  0x1D415: {
    c: 'V',
    f: 'B'
  },
  0x1D416: {
    c: 'W',
    f: 'B'
  },
  0x1D417: {
    c: 'X',
    f: 'B'
  },
  0x1D418: {
    c: 'Y',
    f: 'B'
  },
  0x1D419: {
    c: 'Z',
    f: 'B'
  },
  0x1D41A: {
    c: 'a',
    f: 'B'
  },
  0x1D41B: {
    c: 'b',
    f: 'B'
  },
  0x1D41C: {
    c: 'c',
    f: 'B'
  },
  0x1D41D: {
    c: 'd',
    f: 'B'
  },
  0x1D41E: {
    c: 'e',
    f: 'B'
  },
  0x1D41F: {
    c: 'f',
    f: 'B'
  },
  0x1D420: {
    c: 'g',
    f: 'B'
  },
  0x1D421: {
    c: 'h',
    f: 'B'
  },
  0x1D422: {
    c: 'i',
    f: 'B'
  },
  0x1D423: {
    c: 'j',
    f: 'B'
  },
  0x1D424: {
    c: 'k',
    f: 'B'
  },
  0x1D425: {
    c: 'l',
    f: 'B'
  },
  0x1D426: {
    c: 'm',
    f: 'B'
  },
  0x1D427: {
    c: 'n',
    f: 'B'
  },
  0x1D428: {
    c: 'o',
    f: 'B'
  },
  0x1D429: {
    c: 'p',
    f: 'B'
  },
  0x1D42A: {
    c: 'q',
    f: 'B'
  },
  0x1D42B: {
    c: 'r',
    f: 'B'
  },
  0x1D42C: {
    c: 's',
    f: 'B'
  },
  0x1D42D: {
    c: 't',
    f: 'B'
  },
  0x1D42E: {
    c: 'u',
    f: 'B'
  },
  0x1D42F: {
    c: 'v',
    f: 'B'
  },
  0x1D430: {
    c: 'w',
    f: 'B'
  },
  0x1D431: {
    c: 'x',
    f: 'B'
  },
  0x1D432: {
    c: 'y',
    f: 'B'
  },
  0x1D433: {
    c: 'z',
    f: 'B'
  },
  0x1D434: {
    c: 'A',
    f: 'I'
  },
  0x1D435: {
    c: 'B',
    f: 'I'
  },
  0x1D436: {
    c: 'C',
    f: 'I'
  },
  0x1D437: {
    c: 'D',
    f: 'I'
  },
  0x1D438: {
    c: 'E',
    f: 'I'
  },
  0x1D439: {
    c: 'F',
    f: 'I'
  },
  0x1D43A: {
    c: 'G',
    f: 'I'
  },
  0x1D43B: {
    c: 'H',
    f: 'I'
  },
  0x1D43C: {
    c: 'I',
    f: 'I'
  },
  0x1D43D: {
    c: 'J',
    f: 'I'
  },
  0x1D43E: {
    c: 'K',
    f: 'I'
  },
  0x1D43F: {
    c: 'L',
    f: 'I'
  },
  0x1D440: {
    c: 'M',
    f: 'I'
  },
  0x1D441: {
    c: 'N',
    f: 'I'
  },
  0x1D442: {
    c: 'O',
    f: 'I'
  },
  0x1D443: {
    c: 'P',
    f: 'I'
  },
  0x1D444: {
    c: 'Q',
    f: 'I'
  },
  0x1D445: {
    c: 'R',
    f: 'I'
  },
  0x1D446: {
    c: 'S',
    f: 'I'
  },
  0x1D447: {
    c: 'T',
    f: 'I'
  },
  0x1D448: {
    c: 'U',
    f: 'I'
  },
  0x1D449: {
    c: 'V',
    f: 'I'
  },
  0x1D44A: {
    c: 'W',
    f: 'I'
  },
  0x1D44B: {
    c: 'X',
    f: 'I'
  },
  0x1D44C: {
    c: 'Y',
    f: 'I'
  },
  0x1D44D: {
    c: 'Z',
    f: 'I'
  },
  0x1D44E: {
    c: 'a',
    f: 'I'
  },
  0x1D44F: {
    c: 'b',
    f: 'I'
  },
  0x1D450: {
    c: 'c',
    f: 'I'
  },
  0x1D451: {
    c: 'd',
    f: 'I'
  },
  0x1D452: {
    c: 'e',
    f: 'I'
  },
  0x1D453: {
    c: 'f',
    f: 'I'
  },
  0x1D454: {
    c: 'g',
    f: 'I'
  },
  0x1D456: {
    c: 'i',
    f: 'I'
  },
  0x1D457: {
    c: 'j',
    f: 'I'
  },
  0x1D458: {
    c: 'k',
    f: 'I'
  },
  0x1D459: {
    c: 'l',
    f: 'I'
  },
  0x1D45A: {
    c: 'm',
    f: 'I'
  },
  0x1D45B: {
    c: 'n',
    f: 'I'
  },
  0x1D45C: {
    c: 'o',
    f: 'I'
  },
  0x1D45D: {
    c: 'p',
    f: 'I'
  },
  0x1D45E: {
    c: 'q',
    f: 'I'
  },
  0x1D45F: {
    c: 'r',
    f: 'I'
  },
  0x1D460: {
    c: 's',
    f: 'I'
  },
  0x1D461: {
    c: 't',
    f: 'I'
  },
  0x1D462: {
    c: 'u',
    f: 'I'
  },
  0x1D463: {
    c: 'v',
    f: 'I'
  },
  0x1D464: {
    c: 'w',
    f: 'I'
  },
  0x1D465: {
    c: 'x',
    f: 'I'
  },
  0x1D466: {
    c: 'y',
    f: 'I'
  },
  0x1D467: {
    c: 'z',
    f: 'I'
  },
  0x1D468: {
    c: 'A',
    f: 'BI'
  },
  0x1D469: {
    c: 'B',
    f: 'BI'
  },
  0x1D46A: {
    c: 'C',
    f: 'BI'
  },
  0x1D46B: {
    c: 'D',
    f: 'BI'
  },
  0x1D46C: {
    c: 'E',
    f: 'BI'
  },
  0x1D46D: {
    c: 'F',
    f: 'BI'
  },
  0x1D46E: {
    c: 'G',
    f: 'BI'
  },
  0x1D46F: {
    c: 'H',
    f: 'BI'
  },
  0x1D470: {
    c: 'I',
    f: 'BI'
  },
  0x1D471: {
    c: 'J',
    f: 'BI'
  },
  0x1D472: {
    c: 'K',
    f: 'BI'
  },
  0x1D473: {
    c: 'L',
    f: 'BI'
  },
  0x1D474: {
    c: 'M',
    f: 'BI'
  },
  0x1D475: {
    c: 'N',
    f: 'BI'
  },
  0x1D476: {
    c: 'O',
    f: 'BI'
  },
  0x1D477: {
    c: 'P',
    f: 'BI'
  },
  0x1D478: {
    c: 'Q',
    f: 'BI'
  },
  0x1D479: {
    c: 'R',
    f: 'BI'
  },
  0x1D47A: {
    c: 'S',
    f: 'BI'
  },
  0x1D47B: {
    c: 'T',
    f: 'BI'
  },
  0x1D47C: {
    c: 'U',
    f: 'BI'
  },
  0x1D47D: {
    c: 'V',
    f: 'BI'
  },
  0x1D47E: {
    c: 'W',
    f: 'BI'
  },
  0x1D47F: {
    c: 'X',
    f: 'BI'
  },
  0x1D480: {
    c: 'Y',
    f: 'BI'
  },
  0x1D481: {
    c: 'Z',
    f: 'BI'
  },
  0x1D482: {
    c: 'a',
    f: 'BI'
  },
  0x1D483: {
    c: 'b',
    f: 'BI'
  },
  0x1D484: {
    c: 'c',
    f: 'BI'
  },
  0x1D485: {
    c: 'd',
    f: 'BI'
  },
  0x1D486: {
    c: 'e',
    f: 'BI'
  },
  0x1D487: {
    c: 'f',
    f: 'BI'
  },
  0x1D488: {
    c: 'g',
    f: 'BI'
  },
  0x1D489: {
    c: 'h',
    f: 'BI'
  },
  0x1D48A: {
    c: 'i',
    f: 'BI'
  },
  0x1D48B: {
    c: 'j',
    f: 'BI'
  },
  0x1D48C: {
    c: 'k',
    f: 'BI'
  },
  0x1D48D: {
    c: 'l',
    f: 'BI'
  },
  0x1D48E: {
    c: 'm',
    f: 'BI'
  },
  0x1D48F: {
    c: 'n',
    f: 'BI'
  },
  0x1D490: {
    c: 'o',
    f: 'BI'
  },
  0x1D491: {
    c: 'p',
    f: 'BI'
  },
  0x1D492: {
    c: 'q',
    f: 'BI'
  },
  0x1D493: {
    c: 'r',
    f: 'BI'
  },
  0x1D494: {
    c: 's',
    f: 'BI'
  },
  0x1D495: {
    c: 't',
    f: 'BI'
  },
  0x1D496: {
    c: 'u',
    f: 'BI'
  },
  0x1D497: {
    c: 'v',
    f: 'BI'
  },
  0x1D498: {
    c: 'w',
    f: 'BI'
  },
  0x1D499: {
    c: 'x',
    f: 'BI'
  },
  0x1D49A: {
    c: 'y',
    f: 'BI'
  },
  0x1D49B: {
    c: 'z',
    f: 'BI'
  },
  0x1D49C: {
    c: 'A',
    f: 'SC'
  },
  0x1D49E: {
    c: 'C',
    f: 'SC'
  },
  0x1D49F: {
    c: 'D',
    f: 'SC'
  },
  0x1D4A2: {
    c: 'G',
    f: 'SC'
  },
  0x1D4A5: {
    c: 'J',
    f: 'SC'
  },
  0x1D4A6: {
    c: 'K',
    f: 'SC'
  },
  0x1D4A9: {
    c: 'N',
    f: 'SC'
  },
  0x1D4AA: {
    c: 'O',
    f: 'SC'
  },
  0x1D4AB: {
    c: 'P',
    f: 'SC'
  },
  0x1D4AC: {
    c: 'Q',
    f: 'SC'
  },
  0x1D4AE: {
    c: 'S',
    f: 'SC'
  },
  0x1D4AF: {
    c: 'T',
    f: 'SC'
  },
  0x1D4B0: {
    c: 'U',
    f: 'SC'
  },
  0x1D4B1: {
    c: 'V',
    f: 'SC'
  },
  0x1D4B2: {
    c: 'W',
    f: 'SC'
  },
  0x1D4B3: {
    c: 'X',
    f: 'SC'
  },
  0x1D4B4: {
    c: 'Y',
    f: 'SC'
  },
  0x1D4B5: {
    c: 'Z',
    f: 'SC'
  },
  0x1D504: {
    c: 'A',
    f: 'FR'
  },
  0x1D505: {
    c: 'B',
    f: 'FR'
  },
  0x1D507: {
    c: 'D',
    f: 'FR'
  },
  0x1D508: {
    c: 'E',
    f: 'FR'
  },
  0x1D509: {
    c: 'F',
    f: 'FR'
  },
  0x1D50A: {
    c: 'G',
    f: 'FR'
  },
  0x1D50D: {
    c: 'J',
    f: 'FR'
  },
  0x1D50E: {
    c: 'K',
    f: 'FR'
  },
  0x1D50F: {
    c: 'L',
    f: 'FR'
  },
  0x1D510: {
    c: 'M',
    f: 'FR'
  },
  0x1D511: {
    c: 'N',
    f: 'FR'
  },
  0x1D512: {
    c: 'O',
    f: 'FR'
  },
  0x1D513: {
    c: 'P',
    f: 'FR'
  },
  0x1D514: {
    c: 'Q',
    f: 'FR'
  },
  0x1D516: {
    c: 'S',
    f: 'FR'
  },
  0x1D517: {
    c: 'T',
    f: 'FR'
  },
  0x1D518: {
    c: 'U',
    f: 'FR'
  },
  0x1D519: {
    c: 'V',
    f: 'FR'
  },
  0x1D51A: {
    c: 'W',
    f: 'FR'
  },
  0x1D51B: {
    c: 'X',
    f: 'FR'
  },
  0x1D51C: {
    c: 'Y',
    f: 'FR'
  },
  0x1D51E: {
    c: 'a',
    f: 'FR'
  },
  0x1D51F: {
    c: 'b',
    f: 'FR'
  },
  0x1D520: {
    c: 'c',
    f: 'FR'
  },
  0x1D521: {
    c: 'd',
    f: 'FR'
  },
  0x1D522: {
    c: 'e',
    f: 'FR'
  },
  0x1D523: {
    c: 'f',
    f: 'FR'
  },
  0x1D524: {
    c: 'g',
    f: 'FR'
  },
  0x1D525: {
    c: 'h',
    f: 'FR'
  },
  0x1D526: {
    c: 'i',
    f: 'FR'
  },
  0x1D527: {
    c: 'j',
    f: 'FR'
  },
  0x1D528: {
    c: 'k',
    f: 'FR'
  },
  0x1D529: {
    c: 'l',
    f: 'FR'
  },
  0x1D52A: {
    c: 'm',
    f: 'FR'
  },
  0x1D52B: {
    c: 'n',
    f: 'FR'
  },
  0x1D52C: {
    c: 'o',
    f: 'FR'
  },
  0x1D52D: {
    c: 'p',
    f: 'FR'
  },
  0x1D52E: {
    c: 'q',
    f: 'FR'
  },
  0x1D52F: {
    c: 'r',
    f: 'FR'
  },
  0x1D530: {
    c: 's',
    f: 'FR'
  },
  0x1D531: {
    c: 't',
    f: 'FR'
  },
  0x1D532: {
    c: 'u',
    f: 'FR'
  },
  0x1D533: {
    c: 'v',
    f: 'FR'
  },
  0x1D534: {
    c: 'w',
    f: 'FR'
  },
  0x1D535: {
    c: 'x',
    f: 'FR'
  },
  0x1D536: {
    c: 'y',
    f: 'FR'
  },
  0x1D537: {
    c: 'z',
    f: 'FR'
  },
  0x1D538: {
    c: 'A',
    f: 'A'
  },
  0x1D539: {
    c: 'B',
    f: 'A'
  },
  0x1D53B: {
    c: 'D',
    f: 'A'
  },
  0x1D53C: {
    c: 'E',
    f: 'A'
  },
  0x1D53D: {
    c: 'F',
    f: 'A'
  },
  0x1D53E: {
    c: 'G',
    f: 'A'
  },
  0x1D540: {
    c: 'I',
    f: 'A'
  },
  0x1D541: {
    c: 'J',
    f: 'A'
  },
  0x1D542: {
    c: 'K',
    f: 'A'
  },
  0x1D543: {
    c: 'L',
    f: 'A'
  },
  0x1D544: {
    c: 'M',
    f: 'A'
  },
  0x1D546: {
    c: 'O',
    f: 'A'
  },
  0x1D54A: {
    c: 'S',
    f: 'A'
  },
  0x1D54B: {
    c: 'T',
    f: 'A'
  },
  0x1D54C: {
    c: 'U',
    f: 'A'
  },
  0x1D54D: {
    c: 'V',
    f: 'A'
  },
  0x1D54E: {
    c: 'W',
    f: 'A'
  },
  0x1D54F: {
    c: 'X',
    f: 'A'
  },
  0x1D550: {
    c: 'Y',
    f: 'A'
  },
  0x1D56C: {
    c: 'A',
    f: 'FRB'
  },
  0x1D56D: {
    c: 'B',
    f: 'FRB'
  },
  0x1D56E: {
    c: 'C',
    f: 'FRB'
  },
  0x1D56F: {
    c: 'D',
    f: 'FRB'
  },
  0x1D570: {
    c: 'E',
    f: 'FRB'
  },
  0x1D571: {
    c: 'F',
    f: 'FRB'
  },
  0x1D572: {
    c: 'G',
    f: 'FRB'
  },
  0x1D573: {
    c: 'H',
    f: 'FRB'
  },
  0x1D574: {
    c: 'I',
    f: 'FRB'
  },
  0x1D575: {
    c: 'J',
    f: 'FRB'
  },
  0x1D576: {
    c: 'K',
    f: 'FRB'
  },
  0x1D577: {
    c: 'L',
    f: 'FRB'
  },
  0x1D578: {
    c: 'M',
    f: 'FRB'
  },
  0x1D579: {
    c: 'N',
    f: 'FRB'
  },
  0x1D57A: {
    c: 'O',
    f: 'FRB'
  },
  0x1D57B: {
    c: 'P',
    f: 'FRB'
  },
  0x1D57C: {
    c: 'Q',
    f: 'FRB'
  },
  0x1D57D: {
    c: 'R',
    f: 'FRB'
  },
  0x1D57E: {
    c: 'S',
    f: 'FRB'
  },
  0x1D57F: {
    c: 'T',
    f: 'FRB'
  },
  0x1D580: {
    c: 'U',
    f: 'FRB'
  },
  0x1D581: {
    c: 'V',
    f: 'FRB'
  },
  0x1D582: {
    c: 'W',
    f: 'FRB'
  },
  0x1D583: {
    c: 'X',
    f: 'FRB'
  },
  0x1D584: {
    c: 'Y',
    f: 'FRB'
  },
  0x1D585: {
    c: 'Z',
    f: 'FRB'
  },
  0x1D586: {
    c: 'a',
    f: 'FRB'
  },
  0x1D587: {
    c: 'b',
    f: 'FRB'
  },
  0x1D588: {
    c: 'c',
    f: 'FRB'
  },
  0x1D589: {
    c: 'd',
    f: 'FRB'
  },
  0x1D58A: {
    c: 'e',
    f: 'FRB'
  },
  0x1D58B: {
    c: 'f',
    f: 'FRB'
  },
  0x1D58C: {
    c: 'g',
    f: 'FRB'
  },
  0x1D58D: {
    c: 'h',
    f: 'FRB'
  },
  0x1D58E: {
    c: 'i',
    f: 'FRB'
  },
  0x1D58F: {
    c: 'j',
    f: 'FRB'
  },
  0x1D590: {
    c: 'k',
    f: 'FRB'
  },
  0x1D591: {
    c: 'l',
    f: 'FRB'
  },
  0x1D592: {
    c: 'm',
    f: 'FRB'
  },
  0x1D593: {
    c: 'n',
    f: 'FRB'
  },
  0x1D594: {
    c: 'o',
    f: 'FRB'
  },
  0x1D595: {
    c: 'p',
    f: 'FRB'
  },
  0x1D596: {
    c: 'q',
    f: 'FRB'
  },
  0x1D597: {
    c: 'r',
    f: 'FRB'
  },
  0x1D598: {
    c: 's',
    f: 'FRB'
  },
  0x1D599: {
    c: 't',
    f: 'FRB'
  },
  0x1D59A: {
    c: 'u',
    f: 'FRB'
  },
  0x1D59B: {
    c: 'v',
    f: 'FRB'
  },
  0x1D59C: {
    c: 'w',
    f: 'FRB'
  },
  0x1D59D: {
    c: 'x',
    f: 'FRB'
  },
  0x1D59E: {
    c: 'y',
    f: 'FRB'
  },
  0x1D59F: {
    c: 'z',
    f: 'FRB'
  },
  0x1D5A0: {
    c: 'A',
    f: 'SS'
  },
  0x1D5A1: {
    c: 'B',
    f: 'SS'
  },
  0x1D5A2: {
    c: 'C',
    f: 'SS'
  },
  0x1D5A3: {
    c: 'D',
    f: 'SS'
  },
  0x1D5A4: {
    c: 'E',
    f: 'SS'
  },
  0x1D5A5: {
    c: 'F',
    f: 'SS'
  },
  0x1D5A6: {
    c: 'G',
    f: 'SS'
  },
  0x1D5A7: {
    c: 'H',
    f: 'SS'
  },
  0x1D5A8: {
    c: 'I',
    f: 'SS'
  },
  0x1D5A9: {
    c: 'J',
    f: 'SS'
  },
  0x1D5AA: {
    c: 'K',
    f: 'SS'
  },
  0x1D5AB: {
    c: 'L',
    f: 'SS'
  },
  0x1D5AC: {
    c: 'M',
    f: 'SS'
  },
  0x1D5AD: {
    c: 'N',
    f: 'SS'
  },
  0x1D5AE: {
    c: 'O',
    f: 'SS'
  },
  0x1D5AF: {
    c: 'P',
    f: 'SS'
  },
  0x1D5B0: {
    c: 'Q',
    f: 'SS'
  },
  0x1D5B1: {
    c: 'R',
    f: 'SS'
  },
  0x1D5B2: {
    c: 'S',
    f: 'SS'
  },
  0x1D5B3: {
    c: 'T',
    f: 'SS'
  },
  0x1D5B4: {
    c: 'U',
    f: 'SS'
  },
  0x1D5B5: {
    c: 'V',
    f: 'SS'
  },
  0x1D5B6: {
    c: 'W',
    f: 'SS'
  },
  0x1D5B7: {
    c: 'X',
    f: 'SS'
  },
  0x1D5B8: {
    c: 'Y',
    f: 'SS'
  },
  0x1D5B9: {
    c: 'Z',
    f: 'SS'
  },
  0x1D5BA: {
    c: 'a',
    f: 'SS'
  },
  0x1D5BB: {
    c: 'b',
    f: 'SS'
  },
  0x1D5BC: {
    c: 'c',
    f: 'SS'
  },
  0x1D5BD: {
    c: 'd',
    f: 'SS'
  },
  0x1D5BE: {
    c: 'e',
    f: 'SS'
  },
  0x1D5BF: {
    c: 'f',
    f: 'SS'
  },
  0x1D5C0: {
    c: 'g',
    f: 'SS'
  },
  0x1D5C1: {
    c: 'h',
    f: 'SS'
  },
  0x1D5C2: {
    c: 'i',
    f: 'SS'
  },
  0x1D5C3: {
    c: 'j',
    f: 'SS'
  },
  0x1D5C4: {
    c: 'k',
    f: 'SS'
  },
  0x1D5C5: {
    c: 'l',
    f: 'SS'
  },
  0x1D5C6: {
    c: 'm',
    f: 'SS'
  },
  0x1D5C7: {
    c: 'n',
    f: 'SS'
  },
  0x1D5C8: {
    c: 'o',
    f: 'SS'
  },
  0x1D5C9: {
    c: 'p',
    f: 'SS'
  },
  0x1D5CA: {
    c: 'q',
    f: 'SS'
  },
  0x1D5CB: {
    c: 'r',
    f: 'SS'
  },
  0x1D5CC: {
    c: 's',
    f: 'SS'
  },
  0x1D5CD: {
    c: 't',
    f: 'SS'
  },
  0x1D5CE: {
    c: 'u',
    f: 'SS'
  },
  0x1D5CF: {
    c: 'v',
    f: 'SS'
  },
  0x1D5D0: {
    c: 'w',
    f: 'SS'
  },
  0x1D5D1: {
    c: 'x',
    f: 'SS'
  },
  0x1D5D2: {
    c: 'y',
    f: 'SS'
  },
  0x1D5D3: {
    c: 'z',
    f: 'SS'
  },
  0x1D5D4: {
    c: 'A',
    f: 'SSB'
  },
  0x1D5D5: {
    c: 'B',
    f: 'SSB'
  },
  0x1D5D6: {
    c: 'C',
    f: 'SSB'
  },
  0x1D5D7: {
    c: 'D',
    f: 'SSB'
  },
  0x1D5D8: {
    c: 'E',
    f: 'SSB'
  },
  0x1D5D9: {
    c: 'F',
    f: 'SSB'
  },
  0x1D5DA: {
    c: 'G',
    f: 'SSB'
  },
  0x1D5DB: {
    c: 'H',
    f: 'SSB'
  },
  0x1D5DC: {
    c: 'I',
    f: 'SSB'
  },
  0x1D5DD: {
    c: 'J',
    f: 'SSB'
  },
  0x1D5DE: {
    c: 'K',
    f: 'SSB'
  },
  0x1D5DF: {
    c: 'L',
    f: 'SSB'
  },
  0x1D5E0: {
    c: 'M',
    f: 'SSB'
  },
  0x1D5E1: {
    c: 'N',
    f: 'SSB'
  },
  0x1D5E2: {
    c: 'O',
    f: 'SSB'
  },
  0x1D5E3: {
    c: 'P',
    f: 'SSB'
  },
  0x1D5E4: {
    c: 'Q',
    f: 'SSB'
  },
  0x1D5E5: {
    c: 'R',
    f: 'SSB'
  },
  0x1D5E6: {
    c: 'S',
    f: 'SSB'
  },
  0x1D5E7: {
    c: 'T',
    f: 'SSB'
  },
  0x1D5E8: {
    c: 'U',
    f: 'SSB'
  },
  0x1D5E9: {
    c: 'V',
    f: 'SSB'
  },
  0x1D5EA: {
    c: 'W',
    f: 'SSB'
  },
  0x1D5EB: {
    c: 'X',
    f: 'SSB'
  },
  0x1D5EC: {
    c: 'Y',
    f: 'SSB'
  },
  0x1D5ED: {
    c: 'Z',
    f: 'SSB'
  },
  0x1D5EE: {
    c: 'a',
    f: 'SSB'
  },
  0x1D5EF: {
    c: 'b',
    f: 'SSB'
  },
  0x1D5F0: {
    c: 'c',
    f: 'SSB'
  },
  0x1D5F1: {
    c: 'd',
    f: 'SSB'
  },
  0x1D5F2: {
    c: 'e',
    f: 'SSB'
  },
  0x1D5F3: {
    c: 'f',
    f: 'SSB'
  },
  0x1D5F4: {
    c: 'g',
    f: 'SSB'
  },
  0x1D5F5: {
    c: 'h',
    f: 'SSB'
  },
  0x1D5F6: {
    c: 'i',
    f: 'SSB'
  },
  0x1D5F7: {
    c: 'j',
    f: 'SSB'
  },
  0x1D5F8: {
    c: 'k',
    f: 'SSB'
  },
  0x1D5F9: {
    c: 'l',
    f: 'SSB'
  },
  0x1D5FA: {
    c: 'm',
    f: 'SSB'
  },
  0x1D5FB: {
    c: 'n',
    f: 'SSB'
  },
  0x1D5FC: {
    c: 'o',
    f: 'SSB'
  },
  0x1D5FD: {
    c: 'p',
    f: 'SSB'
  },
  0x1D5FE: {
    c: 'q',
    f: 'SSB'
  },
  0x1D5FF: {
    c: 'r',
    f: 'SSB'
  },
  0x1D600: {
    c: 's',
    f: 'SSB'
  },
  0x1D601: {
    c: 't',
    f: 'SSB'
  },
  0x1D602: {
    c: 'u',
    f: 'SSB'
  },
  0x1D603: {
    c: 'v',
    f: 'SSB'
  },
  0x1D604: {
    c: 'w',
    f: 'SSB'
  },
  0x1D605: {
    c: 'x',
    f: 'SSB'
  },
  0x1D606: {
    c: 'y',
    f: 'SSB'
  },
  0x1D607: {
    c: 'z',
    f: 'SSB'
  },
  0x1D608: {
    c: 'A',
    f: 'SSI'
  },
  0x1D609: {
    c: 'B',
    f: 'SSI'
  },
  0x1D60A: {
    c: 'C',
    f: 'SSI'
  },
  0x1D60B: {
    c: 'D',
    f: 'SSI'
  },
  0x1D60C: {
    c: 'E',
    f: 'SSI'
  },
  0x1D60D: {
    c: 'F',
    f: 'SSI'
  },
  0x1D60E: {
    c: 'G',
    f: 'SSI'
  },
  0x1D60F: {
    c: 'H',
    f: 'SSI'
  },
  0x1D610: {
    c: 'I',
    f: 'SSI'
  },
  0x1D611: {
    c: 'J',
    f: 'SSI'
  },
  0x1D612: {
    c: 'K',
    f: 'SSI'
  },
  0x1D613: {
    c: 'L',
    f: 'SSI'
  },
  0x1D614: {
    c: 'M',
    f: 'SSI'
  },
  0x1D615: {
    c: 'N',
    f: 'SSI'
  },
  0x1D616: {
    c: 'O',
    f: 'SSI'
  },
  0x1D617: {
    c: 'P',
    f: 'SSI'
  },
  0x1D618: {
    c: 'Q',
    f: 'SSI'
  },
  0x1D619: {
    c: 'R',
    f: 'SSI'
  },
  0x1D61A: {
    c: 'S',
    f: 'SSI'
  },
  0x1D61B: {
    c: 'T',
    f: 'SSI'
  },
  0x1D61C: {
    c: 'U',
    f: 'SSI'
  },
  0x1D61D: {
    c: 'V',
    f: 'SSI'
  },
  0x1D61E: {
    c: 'W',
    f: 'SSI'
  },
  0x1D61F: {
    c: 'X',
    f: 'SSI'
  },
  0x1D620: {
    c: 'Y',
    f: 'SSI'
  },
  0x1D621: {
    c: 'Z',
    f: 'SSI'
  },
  0x1D622: {
    c: 'a',
    f: 'SSI'
  },
  0x1D623: {
    c: 'b',
    f: 'SSI'
  },
  0x1D624: {
    c: 'c',
    f: 'SSI'
  },
  0x1D625: {
    c: 'd',
    f: 'SSI'
  },
  0x1D626: {
    c: 'e',
    f: 'SSI'
  },
  0x1D627: {
    c: 'f',
    f: 'SSI'
  },
  0x1D628: {
    c: 'g',
    f: 'SSI'
  },
  0x1D629: {
    c: 'h',
    f: 'SSI'
  },
  0x1D62A: {
    c: 'i',
    f: 'SSI'
  },
  0x1D62B: {
    c: 'j',
    f: 'SSI'
  },
  0x1D62C: {
    c: 'k',
    f: 'SSI'
  },
  0x1D62D: {
    c: 'l',
    f: 'SSI'
  },
  0x1D62E: {
    c: 'm',
    f: 'SSI'
  },
  0x1D62F: {
    c: 'n',
    f: 'SSI'
  },
  0x1D630: {
    c: 'o',
    f: 'SSI'
  },
  0x1D631: {
    c: 'p',
    f: 'SSI'
  },
  0x1D632: {
    c: 'q',
    f: 'SSI'
  },
  0x1D633: {
    c: 'r',
    f: 'SSI'
  },
  0x1D634: {
    c: 's',
    f: 'SSI'
  },
  0x1D635: {
    c: 't',
    f: 'SSI'
  },
  0x1D636: {
    c: 'u',
    f: 'SSI'
  },
  0x1D637: {
    c: 'v',
    f: 'SSI'
  },
  0x1D638: {
    c: 'w',
    f: 'SSI'
  },
  0x1D639: {
    c: 'x',
    f: 'SSI'
  },
  0x1D63A: {
    c: 'y',
    f: 'SSI'
  },
  0x1D63B: {
    c: 'z',
    f: 'SSI'
  },
  0x1D670: {
    c: 'A',
    f: 'T'
  },
  0x1D671: {
    c: 'B',
    f: 'T'
  },
  0x1D672: {
    c: 'C',
    f: 'T'
  },
  0x1D673: {
    c: 'D',
    f: 'T'
  },
  0x1D674: {
    c: 'E',
    f: 'T'
  },
  0x1D675: {
    c: 'F',
    f: 'T'
  },
  0x1D676: {
    c: 'G',
    f: 'T'
  },
  0x1D677: {
    c: 'H',
    f: 'T'
  },
  0x1D678: {
    c: 'I',
    f: 'T'
  },
  0x1D679: {
    c: 'J',
    f: 'T'
  },
  0x1D67A: {
    c: 'K',
    f: 'T'
  },
  0x1D67B: {
    c: 'L',
    f: 'T'
  },
  0x1D67C: {
    c: 'M',
    f: 'T'
  },
  0x1D67D: {
    c: 'N',
    f: 'T'
  },
  0x1D67E: {
    c: 'O',
    f: 'T'
  },
  0x1D67F: {
    c: 'P',
    f: 'T'
  },
  0x1D680: {
    c: 'Q',
    f: 'T'
  },
  0x1D681: {
    c: 'R',
    f: 'T'
  },
  0x1D682: {
    c: 'S',
    f: 'T'
  },
  0x1D683: {
    c: 'T',
    f: 'T'
  },
  0x1D684: {
    c: 'U',
    f: 'T'
  },
  0x1D685: {
    c: 'V',
    f: 'T'
  },
  0x1D686: {
    c: 'W',
    f: 'T'
  },
  0x1D687: {
    c: 'X',
    f: 'T'
  },
  0x1D688: {
    c: 'Y',
    f: 'T'
  },
  0x1D689: {
    c: 'Z',
    f: 'T'
  },
  0x1D68A: {
    c: 'a',
    f: 'T'
  },
  0x1D68B: {
    c: 'b',
    f: 'T'
  },
  0x1D68C: {
    c: 'c',
    f: 'T'
  },
  0x1D68D: {
    c: 'd',
    f: 'T'
  },
  0x1D68E: {
    c: 'e',
    f: 'T'
  },
  0x1D68F: {
    c: 'f',
    f: 'T'
  },
  0x1D690: {
    c: 'g',
    f: 'T'
  },
  0x1D691: {
    c: 'h',
    f: 'T'
  },
  0x1D692: {
    c: 'i',
    f: 'T'
  },
  0x1D693: {
    c: 'j',
    f: 'T'
  },
  0x1D694: {
    c: 'k',
    f: 'T'
  },
  0x1D695: {
    c: 'l',
    f: 'T'
  },
  0x1D696: {
    c: 'm',
    f: 'T'
  },
  0x1D697: {
    c: 'n',
    f: 'T'
  },
  0x1D698: {
    c: 'o',
    f: 'T'
  },
  0x1D699: {
    c: 'p',
    f: 'T'
  },
  0x1D69A: {
    c: 'q',
    f: 'T'
  },
  0x1D69B: {
    c: 'r',
    f: 'T'
  },
  0x1D69C: {
    c: 's',
    f: 'T'
  },
  0x1D69D: {
    c: 't',
    f: 'T'
  },
  0x1D69E: {
    c: 'u',
    f: 'T'
  },
  0x1D69F: {
    c: 'v',
    f: 'T'
  },
  0x1D6A0: {
    c: 'w',
    f: 'T'
  },
  0x1D6A1: {
    c: 'x',
    f: 'T'
  },
  0x1D6A2: {
    c: 'y',
    f: 'T'
  },
  0x1D6A3: {
    c: 'z',
    f: 'T'
  },
  0x1D6A8: {
    c: 'A',
    f: 'B'
  },
  0x1D6A9: {
    c: 'B',
    f: 'B'
  },
  0x1D6AA: {
    c: '\\393',
    f: 'B'
  },
  0x1D6AB: {
    c: '\\394',
    f: 'B'
  },
  0x1D6AC: {
    c: 'E',
    f: 'B'
  },
  0x1D6AD: {
    c: 'Z',
    f: 'B'
  },
  0x1D6AE: {
    c: 'H',
    f: 'B'
  },
  0x1D6AF: {
    c: '\\398',
    f: 'B'
  },
  0x1D6B0: {
    c: 'I',
    f: 'B'
  },
  0x1D6B1: {
    c: 'K',
    f: 'B'
  },
  0x1D6B2: {
    c: '\\39B',
    f: 'B'
  },
  0x1D6B3: {
    c: 'M',
    f: 'B'
  },
  0x1D6B4: {
    c: 'N',
    f: 'B'
  },
  0x1D6B5: {
    c: '\\39E',
    f: 'B'
  },
  0x1D6B6: {
    c: 'O',
    f: 'B'
  },
  0x1D6B7: {
    c: '\\3A0',
    f: 'B'
  },
  0x1D6B8: {
    c: 'P',
    f: 'B'
  },
  0x1D6BA: {
    c: '\\3A3',
    f: 'B'
  },
  0x1D6BB: {
    c: 'T',
    f: 'B'
  },
  0x1D6BC: {
    c: '\\3A5',
    f: 'B'
  },
  0x1D6BD: {
    c: '\\3A6',
    f: 'B'
  },
  0x1D6BE: {
    c: 'X',
    f: 'B'
  },
  0x1D6BF: {
    c: '\\3A8',
    f: 'B'
  },
  0x1D6C0: {
    c: '\\3A9',
    f: 'B'
  },
  0x1D6C1: {
    c: '\\2207',
    f: 'B'
  },
  0x1D6E2: {
    c: 'A',
    f: 'I'
  },
  0x1D6E3: {
    c: 'B',
    f: 'I'
  },
  0x1D6E4: {
    c: '\\393',
    f: 'I'
  },
  0x1D6E5: {
    c: '\\394',
    f: 'I'
  },
  0x1D6E6: {
    c: 'E',
    f: 'I'
  },
  0x1D6E7: {
    c: 'Z',
    f: 'I'
  },
  0x1D6E8: {
    c: 'H',
    f: 'I'
  },
  0x1D6E9: {
    c: '\\398',
    f: 'I'
  },
  0x1D6EA: {
    c: 'I',
    f: 'I'
  },
  0x1D6EB: {
    c: 'K',
    f: 'I'
  },
  0x1D6EC: {
    c: '\\39B',
    f: 'I'
  },
  0x1D6ED: {
    c: 'M',
    f: 'I'
  },
  0x1D6EE: {
    c: 'N',
    f: 'I'
  },
  0x1D6EF: {
    c: '\\39E',
    f: 'I'
  },
  0x1D6F0: {
    c: 'O',
    f: 'I'
  },
  0x1D6F1: {
    c: '\\3A0',
    f: 'I'
  },
  0x1D6F2: {
    c: 'P',
    f: 'I'
  },
  0x1D6F4: {
    c: '\\3A3',
    f: 'I'
  },
  0x1D6F5: {
    c: 'T',
    f: 'I'
  },
  0x1D6F6: {
    c: '\\3A5',
    f: 'I'
  },
  0x1D6F7: {
    c: '\\3A6',
    f: 'I'
  },
  0x1D6F8: {
    c: 'X',
    f: 'I'
  },
  0x1D6F9: {
    c: '\\3A8',
    f: 'I'
  },
  0x1D6FA: {
    c: '\\3A9',
    f: 'I'
  },
  0x1D6FC: {
    c: '\\3B1',
    f: 'I'
  },
  0x1D6FD: {
    c: '\\3B2',
    f: 'I'
  },
  0x1D6FE: {
    c: '\\3B3',
    f: 'I'
  },
  0x1D6FF: {
    c: '\\3B4',
    f: 'I'
  },
  0x1D700: {
    c: '\\3B5',
    f: 'I'
  },
  0x1D701: {
    c: '\\3B6',
    f: 'I'
  },
  0x1D702: {
    c: '\\3B7',
    f: 'I'
  },
  0x1D703: {
    c: '\\3B8',
    f: 'I'
  },
  0x1D704: {
    c: '\\3B9',
    f: 'I'
  },
  0x1D705: {
    c: '\\3BA',
    f: 'I'
  },
  0x1D706: {
    c: '\\3BB',
    f: 'I'
  },
  0x1D707: {
    c: '\\3BC',
    f: 'I'
  },
  0x1D708: {
    c: '\\3BD',
    f: 'I'
  },
  0x1D709: {
    c: '\\3BE',
    f: 'I'
  },
  0x1D70A: {
    c: '\\3BF',
    f: 'I'
  },
  0x1D70B: {
    c: '\\3C0',
    f: 'I'
  },
  0x1D70C: {
    c: '\\3C1',
    f: 'I'
  },
  0x1D70D: {
    c: '\\3C2',
    f: 'I'
  },
  0x1D70E: {
    c: '\\3C3',
    f: 'I'
  },
  0x1D70F: {
    c: '\\3C4',
    f: 'I'
  },
  0x1D710: {
    c: '\\3C5',
    f: 'I'
  },
  0x1D711: {
    c: '\\3C6',
    f: 'I'
  },
  0x1D712: {
    c: '\\3C7',
    f: 'I'
  },
  0x1D713: {
    c: '\\3C8',
    f: 'I'
  },
  0x1D714: {
    c: '\\3C9',
    f: 'I'
  },
  0x1D715: {
    c: '\\2202'
  },
  0x1D716: {
    c: '\\3F5',
    f: 'I'
  },
  0x1D717: {
    c: '\\3D1',
    f: 'I'
  },
  0x1D718: {
    c: '\\E009',
    f: 'A'
  },
  0x1D719: {
    c: '\\3D5',
    f: 'I'
  },
  0x1D71A: {
    c: '\\3F1',
    f: 'I'
  },
  0x1D71B: {
    c: '\\3D6',
    f: 'I'
  },
  0x1D71C: {
    c: 'A',
    f: 'BI'
  },
  0x1D71D: {
    c: 'B',
    f: 'BI'
  },
  0x1D71E: {
    c: '\\393',
    f: 'BI'
  },
  0x1D71F: {
    c: '\\394',
    f: 'BI'
  },
  0x1D720: {
    c: 'E',
    f: 'BI'
  },
  0x1D721: {
    c: 'Z',
    f: 'BI'
  },
  0x1D722: {
    c: 'H',
    f: 'BI'
  },
  0x1D723: {
    c: '\\398',
    f: 'BI'
  },
  0x1D724: {
    c: 'I',
    f: 'BI'
  },
  0x1D725: {
    c: 'K',
    f: 'BI'
  },
  0x1D726: {
    c: '\\39B',
    f: 'BI'
  },
  0x1D727: {
    c: 'M',
    f: 'BI'
  },
  0x1D728: {
    c: 'N',
    f: 'BI'
  },
  0x1D729: {
    c: '\\39E',
    f: 'BI'
  },
  0x1D72A: {
    c: 'O',
    f: 'BI'
  },
  0x1D72B: {
    c: '\\3A0',
    f: 'BI'
  },
  0x1D72C: {
    c: 'P',
    f: 'BI'
  },
  0x1D72E: {
    c: '\\3A3',
    f: 'BI'
  },
  0x1D72F: {
    c: 'T',
    f: 'BI'
  },
  0x1D730: {
    c: '\\3A5',
    f: 'BI'
  },
  0x1D731: {
    c: '\\3A6',
    f: 'BI'
  },
  0x1D732: {
    c: 'X',
    f: 'BI'
  },
  0x1D733: {
    c: '\\3A8',
    f: 'BI'
  },
  0x1D734: {
    c: '\\3A9',
    f: 'BI'
  },
  0x1D736: {
    c: '\\3B1',
    f: 'BI'
  },
  0x1D737: {
    c: '\\3B2',
    f: 'BI'
  },
  0x1D738: {
    c: '\\3B3',
    f: 'BI'
  },
  0x1D739: {
    c: '\\3B4',
    f: 'BI'
  },
  0x1D73A: {
    c: '\\3B5',
    f: 'BI'
  },
  0x1D73B: {
    c: '\\3B6',
    f: 'BI'
  },
  0x1D73C: {
    c: '\\3B7',
    f: 'BI'
  },
  0x1D73D: {
    c: '\\3B8',
    f: 'BI'
  },
  0x1D73E: {
    c: '\\3B9',
    f: 'BI'
  },
  0x1D73F: {
    c: '\\3BA',
    f: 'BI'
  },
  0x1D740: {
    c: '\\3BB',
    f: 'BI'
  },
  0x1D741: {
    c: '\\3BC',
    f: 'BI'
  },
  0x1D742: {
    c: '\\3BD',
    f: 'BI'
  },
  0x1D743: {
    c: '\\3BE',
    f: 'BI'
  },
  0x1D744: {
    c: '\\3BF',
    f: 'BI'
  },
  0x1D745: {
    c: '\\3C0',
    f: 'BI'
  },
  0x1D746: {
    c: '\\3C1',
    f: 'BI'
  },
  0x1D747: {
    c: '\\3C2',
    f: 'BI'
  },
  0x1D748: {
    c: '\\3C3',
    f: 'BI'
  },
  0x1D749: {
    c: '\\3C4',
    f: 'BI'
  },
  0x1D74A: {
    c: '\\3C5',
    f: 'BI'
  },
  0x1D74B: {
    c: '\\3C6',
    f: 'BI'
  },
  0x1D74C: {
    c: '\\3C7',
    f: 'BI'
  },
  0x1D74D: {
    c: '\\3C8',
    f: 'BI'
  },
  0x1D74E: {
    c: '\\3C9',
    f: 'BI'
  },
  0x1D74F: {
    c: '\\2202',
    f: 'B'
  },
  0x1D750: {
    c: '\\3F5',
    f: 'BI'
  },
  0x1D751: {
    c: '\\3D1',
    f: 'BI'
  },
  0x1D752: {
    c: '\\E009',
    f: 'A'
  },
  0x1D753: {
    c: '\\3D5',
    f: 'BI'
  },
  0x1D754: {
    c: '\\3F1',
    f: 'BI'
  },
  0x1D755: {
    c: '\\3D6',
    f: 'BI'
  },
  0x1D756: {
    c: 'A',
    f: 'SSB'
  },
  0x1D757: {
    c: 'B',
    f: 'SSB'
  },
  0x1D758: {
    c: '\\393',
    f: 'SSB'
  },
  0x1D759: {
    c: '\\394',
    f: 'SSB'
  },
  0x1D75A: {
    c: 'E',
    f: 'SSB'
  },
  0x1D75B: {
    c: 'Z',
    f: 'SSB'
  },
  0x1D75C: {
    c: 'H',
    f: 'SSB'
  },
  0x1D75D: {
    c: '\\398',
    f: 'SSB'
  },
  0x1D75E: {
    c: 'I',
    f: 'SSB'
  },
  0x1D75F: {
    c: 'K',
    f: 'SSB'
  },
  0x1D760: {
    c: '\\39B',
    f: 'SSB'
  },
  0x1D761: {
    c: 'M',
    f: 'SSB'
  },
  0x1D762: {
    c: 'N',
    f: 'SSB'
  },
  0x1D763: {
    c: '\\39E',
    f: 'SSB'
  },
  0x1D764: {
    c: 'O',
    f: 'SSB'
  },
  0x1D765: {
    c: '\\3A0',
    f: 'SSB'
  },
  0x1D766: {
    c: 'P',
    f: 'SSB'
  },
  0x1D768: {
    c: '\\3A3',
    f: 'SSB'
  },
  0x1D769: {
    c: 'T',
    f: 'SSB'
  },
  0x1D76A: {
    c: '\\3A5',
    f: 'SSB'
  },
  0x1D76B: {
    c: '\\3A6',
    f: 'SSB'
  },
  0x1D76C: {
    c: 'X',
    f: 'SSB'
  },
  0x1D76D: {
    c: '\\3A8',
    f: 'SSB'
  },
  0x1D76E: {
    c: '\\3A9',
    f: 'SSB'
  },
  0x1D7CE: {
    c: '0',
    f: 'B'
  },
  0x1D7CF: {
    c: '1',
    f: 'B'
  },
  0x1D7D0: {
    c: '2',
    f: 'B'
  },
  0x1D7D1: {
    c: '3',
    f: 'B'
  },
  0x1D7D2: {
    c: '4',
    f: 'B'
  },
  0x1D7D3: {
    c: '5',
    f: 'B'
  },
  0x1D7D4: {
    c: '6',
    f: 'B'
  },
  0x1D7D5: {
    c: '7',
    f: 'B'
  },
  0x1D7D6: {
    c: '8',
    f: 'B'
  },
  0x1D7D7: {
    c: '9',
    f: 'B'
  },
  0x1D7E2: {
    c: '0',
    f: 'SS'
  },
  0x1D7E3: {
    c: '1',
    f: 'SS'
  },
  0x1D7E4: {
    c: '2',
    f: 'SS'
  },
  0x1D7E5: {
    c: '3',
    f: 'SS'
  },
  0x1D7E6: {
    c: '4',
    f: 'SS'
  },
  0x1D7E7: {
    c: '5',
    f: 'SS'
  },
  0x1D7E8: {
    c: '6',
    f: 'SS'
  },
  0x1D7E9: {
    c: '7',
    f: 'SS'
  },
  0x1D7EA: {
    c: '8',
    f: 'SS'
  },
  0x1D7EB: {
    c: '9',
    f: 'SS'
  },
  0x1D7EC: {
    c: '0',
    f: 'SSB'
  },
  0x1D7ED: {
    c: '1',
    f: 'SSB'
  },
  0x1D7EE: {
    c: '2',
    f: 'SSB'
  },
  0x1D7EF: {
    c: '3',
    f: 'SSB'
  },
  0x1D7F0: {
    c: '4',
    f: 'SSB'
  },
  0x1D7F1: {
    c: '5',
    f: 'SSB'
  },
  0x1D7F2: {
    c: '6',
    f: 'SSB'
  },
  0x1D7F3: {
    c: '7',
    f: 'SSB'
  },
  0x1D7F4: {
    c: '8',
    f: 'SSB'
  },
  0x1D7F5: {
    c: '9',
    f: 'SSB'
  },
  0x1D7F6: {
    c: '0',
    f: 'T'
  },
  0x1D7F7: {
    c: '1',
    f: 'T'
  },
  0x1D7F8: {
    c: '2',
    f: 'T'
  },
  0x1D7F9: {
    c: '3',
    f: 'T'
  },
  0x1D7FA: {
    c: '4',
    f: 'T'
  },
  0x1D7FB: {
    c: '5',
    f: 'T'
  },
  0x1D7FC: {
    c: '6',
    f: 'T'
  },
  0x1D7FD: {
    c: '7',
    f: 'T'
  },
  0x1D7FE: {
    c: '8',
    f: 'T'
  },
  0x1D7FF: {
    c: '9',
    f: 'T'
  }
});

var sansSerifBoldItalic$1 = {};

var sansSerifBoldItalic = {};

Object.defineProperty(sansSerifBoldItalic, "__esModule", {
  value: true
});
sansSerifBoldItalic.sansSerifBoldItalic = void 0;
sansSerifBoldItalic.sansSerifBoldItalic = {
  0x131: [.458, 0, .256],
  0x237: [.458, .205, .286]
};

Object.defineProperty(sansSerifBoldItalic$1, "__esModule", {
  value: true
});
sansSerifBoldItalic$1.sansSerifBoldItalic = void 0;
var FontData_js_1$9 = FontData;
var sans_serif_bold_italic_js_1$1 = sansSerifBoldItalic;
sansSerifBoldItalic$1.sansSerifBoldItalic = (0, FontData_js_1$9.AddCSS)(sans_serif_bold_italic_js_1$1.sansSerifBoldItalic, {
  0x131: {
    f: 'SSB'
  },
  0x237: {
    f: 'SSB'
  }
});

var sansSerifBold$1 = {};

var sansSerifBold = {};

Object.defineProperty(sansSerifBold, "__esModule", {
  value: true
});
sansSerifBold.sansSerifBold = void 0;
sansSerifBold.sansSerifBold = {
  0x21: [.694, 0, .367],
  0x22: [.694, -0.442, .558],
  0x23: [.694, .193, .917],
  0x24: [.75, .056, .55],
  0x25: [.75, .056, 1.029],
  0x26: [.716, .022, .831],
  0x27: [.694, -0.442, .306],
  0x28: [.75, .249, .428],
  0x29: [.75, .25, .428],
  0x2A: [.75, -0.293, .55],
  0x2B: [.617, .116, .856],
  0x2C: [.146, .106, .306],
  0x2D: [.273, -0.186, .367],
  0x2E: [.146, 0, .306],
  0x2F: [.75, .249, .55],
  0x3A: [.458, 0, .306],
  0x3B: [.458, .106, .306],
  0x3D: [.407, -0.094, .856],
  0x3F: [.705, 0, .519],
  0x40: [.704, .011, .733],
  0x5B: [.75, .25, .343],
  0x5D: [.75, .25, .343],
  0x5E: [.694, -0.537, .55],
  0x5F: [-0.023, .11, .55],
  0x7E: [.344, -0.198, .55],
  0x131: [.458, 0, .256],
  0x237: [.458, .205, .286],
  0x300: [.694, -0.537, 0],
  0x301: [.694, -0.537, 0],
  0x302: [.694, -0.537, 0],
  0x303: [.694, -0.548, 0],
  0x304: [.66, -0.56, 0],
  0x306: [.694, -0.552, 0],
  0x307: [.695, -0.596, 0],
  0x308: [.695, -0.595, 0],
  0x30A: [.694, -0.538, 0],
  0x30B: [.694, -0.537, 0],
  0x30C: [.657, -0.5, 0],
  0x2013: [.327, -0.24, .55],
  0x2014: [.327, -0.24, 1.1],
  0x2015: [.327, -0.24, 1.1],
  0x2017: [-0.023, .11, .55],
  0x2018: [.694, -0.443, .306],
  0x2019: [.694, -0.442, .306],
  0x201C: [.694, -0.443, .558],
  0x201D: [.694, -0.442, .558],
  0x2044: [.75, .249, .55],
  0x2206: [.694, 0, .917]
};

Object.defineProperty(sansSerifBold$1, "__esModule", {
  value: true
});
sansSerifBold$1.sansSerifBold = void 0;
var FontData_js_1$8 = FontData;
var sans_serif_bold_js_1$1 = sansSerifBold;
sansSerifBold$1.sansSerifBold = (0, FontData_js_1$8.AddCSS)(sans_serif_bold_js_1$1.sansSerifBold, {
  0x2015: {
    c: '\\2014'
  },
  0x2017: {
    c: '_'
  },
  0x2044: {
    c: '/'
  },
  0x2206: {
    c: '\\394'
  }
});

var sansSerifItalic$1 = {};

var sansSerifItalic = {};

Object.defineProperty(sansSerifItalic, "__esModule", {
  value: true
});
sansSerifItalic.sansSerifItalic = void 0;
sansSerifItalic.sansSerifItalic = {
  0x21: [.694, 0, .319, {
    ic: .036
  }],
  0x22: [.694, -0.471, .5],
  0x23: [.694, .194, .833, {
    ic: .018
  }],
  0x24: [.75, .056, .5, {
    ic: .065
  }],
  0x25: [.75, .056, .833],
  0x26: [.716, .022, .758],
  0x27: [.694, -0.471, .278, {
    ic: .057
  }],
  0x28: [.75, .25, .389, {
    ic: .102
  }],
  0x29: [.75, .25, .389],
  0x2A: [.75, -0.306, .5, {
    ic: .068
  }],
  0x2B: [.583, .083, .778],
  0x2C: [.098, .125, .278],
  0x2D: [.259, -0.186, .333],
  0x2E: [.098, 0, .278],
  0x2F: [.75, .25, .5, {
    ic: .1
  }],
  0x30: [.678, .022, .5, {
    ic: .049
  }],
  0x31: [.678, 0, .5],
  0x32: [.678, 0, .5, {
    ic: .051
  }],
  0x33: [.678, .022, .5, {
    ic: .044
  }],
  0x34: [.656, 0, .5, {
    ic: .021
  }],
  0x35: [.656, .022, .5, {
    ic: .055
  }],
  0x36: [.678, .022, .5, {
    ic: .048
  }],
  0x37: [.656, .011, .5, {
    ic: .096
  }],
  0x38: [.678, .022, .5, {
    ic: .054
  }],
  0x39: [.677, .022, .5, {
    ic: .045
  }],
  0x3A: [.444, 0, .278],
  0x3B: [.444, .125, .278],
  0x3D: [.37, -0.13, .778, {
    ic: .018
  }],
  0x3F: [.704, 0, .472, {
    ic: .064
  }],
  0x40: [.705, .01, .667, {
    ic: .04
  }],
  0x5B: [.75, .25, .289, {
    ic: .136
  }],
  0x5D: [.75, .25, .289, {
    ic: .064
  }],
  0x5E: [.694, -0.527, .5, {
    ic: .033
  }],
  0x5F: [-0.038, .114, .5, {
    ic: .065
  }],
  0x7E: [.327, -0.193, .5, {
    ic: .06
  }],
  0x131: [.444, 0, .239, {
    ic: .019
  }],
  0x237: [.444, .204, .267, {
    ic: .019
  }],
  0x300: [.694, -0.527, 0],
  0x301: [.694, -0.527, 0, {
    ic: .063
  }],
  0x302: [.694, -0.527, 0, {
    ic: .033
  }],
  0x303: [.677, -0.543, 0, {
    ic: .06
  }],
  0x304: [.631, -0.552, 0, {
    ic: .064
  }],
  0x306: [.694, -0.508, 0, {
    ic: .073
  }],
  0x307: [.68, -0.576, 0],
  0x308: [.68, -0.582, 0, {
    ic: .04
  }],
  0x30A: [.693, -0.527, 0],
  0x30B: [.694, -0.527, 0, {
    ic: .063
  }],
  0x30C: [.654, -0.487, 0, {
    ic: .06
  }],
  0x391: [.694, 0, .667],
  0x392: [.694, 0, .667, {
    ic: .029
  }],
  0x393: [.691, 0, .542, {
    ic: .104
  }],
  0x394: [.694, 0, .833],
  0x395: [.691, 0, .597, {
    ic: .091
  }],
  0x396: [.694, 0, .611, {
    ic: .091
  }],
  0x397: [.694, 0, .708, {
    ic: .06
  }],
  0x398: [.715, .022, .778, {
    ic: .026
  }],
  0x399: [.694, 0, .278, {
    ic: .06
  }],
  0x39A: [.694, 0, .694, {
    ic: .091
  }],
  0x39B: [.694, 0, .611],
  0x39C: [.694, 0, .875, {
    ic: .054
  }],
  0x39D: [.694, 0, .708, {
    ic: .058
  }],
  0x39E: [.688, 0, .667, {
    ic: .098
  }],
  0x39F: [.716, .022, .736, {
    ic: .027
  }],
  0x3A0: [.691, 0, .708, {
    ic: .06
  }],
  0x3A1: [.694, 0, .639, {
    ic: .051
  }],
  0x3A3: [.694, 0, .722, {
    ic: .091
  }],
  0x3A4: [.688, 0, .681, {
    ic: .109
  }],
  0x3A5: [.716, 0, .778, {
    ic: .065
  }],
  0x3A6: [.694, 0, .722, {
    ic: .021
  }],
  0x3A7: [.694, 0, .667, {
    ic: .091
  }],
  0x3A8: [.694, 0, .778, {
    ic: .076
  }],
  0x3A9: [.716, 0, .722, {
    ic: .047
  }],
  0x2013: [.312, -0.236, .5, {
    ic: .065
  }],
  0x2014: [.312, -0.236, 1, {
    ic: .065
  }],
  0x2015: [.312, -0.236, 1, {
    ic: .065
  }],
  0x2017: [-0.038, .114, .5, {
    ic: .065
  }],
  0x2018: [.694, -0.471, .278, {
    ic: .058
  }],
  0x2019: [.694, -0.471, .278, {
    ic: .057
  }],
  0x201C: [.694, -0.471, .5, {
    ic: .114
  }],
  0x201D: [.694, -0.471, .5],
  0x2044: [.75, .25, .5, {
    ic: .1
  }],
  0x2206: [.694, 0, .833]
};

Object.defineProperty(sansSerifItalic$1, "__esModule", {
  value: true
});
sansSerifItalic$1.sansSerifItalic = void 0;
var FontData_js_1$7 = FontData;
var sans_serif_italic_js_1$1 = sansSerifItalic;
sansSerifItalic$1.sansSerifItalic = (0, FontData_js_1$7.AddCSS)(sans_serif_italic_js_1$1.sansSerifItalic, {
  0x391: {
    c: 'A'
  },
  0x392: {
    c: 'B'
  },
  0x395: {
    c: 'E'
  },
  0x396: {
    c: 'Z'
  },
  0x397: {
    c: 'H'
  },
  0x399: {
    c: 'I'
  },
  0x39A: {
    c: 'K'
  },
  0x39C: {
    c: 'M'
  },
  0x39D: {
    c: 'N'
  },
  0x39F: {
    c: 'O'
  },
  0x3A1: {
    c: 'P'
  },
  0x3A4: {
    c: 'T'
  },
  0x3A7: {
    c: 'X'
  },
  0x2015: {
    c: '\\2014'
  },
  0x2017: {
    c: '_'
  },
  0x2044: {
    c: '/'
  },
  0x2206: {
    c: '\\394'
  }
});

var sansSerif$1 = {};

var sansSerif = {};

Object.defineProperty(sansSerif, "__esModule", {
  value: true
});
sansSerif.sansSerif = void 0;
sansSerif.sansSerif = {
  0x21: [.694, 0, .319],
  0x22: [.694, -0.471, .5],
  0x23: [.694, .194, .833],
  0x24: [.75, .056, .5],
  0x25: [.75, .056, .833],
  0x26: [.716, .022, .758],
  0x27: [.694, -0.471, .278],
  0x28: [.75, .25, .389],
  0x29: [.75, .25, .389],
  0x2A: [.75, -0.306, .5],
  0x2B: [.583, .082, .778],
  0x2C: [.098, .125, .278],
  0x2D: [.259, -0.186, .333],
  0x2E: [.098, 0, .278],
  0x2F: [.75, .25, .5],
  0x3A: [.444, 0, .278],
  0x3B: [.444, .125, .278],
  0x3D: [.37, -0.13, .778],
  0x3F: [.704, 0, .472],
  0x40: [.704, .011, .667],
  0x5B: [.75, .25, .289],
  0x5D: [.75, .25, .289],
  0x5E: [.694, -0.527, .5],
  0x5F: [-0.038, .114, .5],
  0x7E: [.327, -0.193, .5],
  0x131: [.444, 0, .239],
  0x237: [.444, .205, .267],
  0x300: [.694, -0.527, 0],
  0x301: [.694, -0.527, 0],
  0x302: [.694, -0.527, 0],
  0x303: [.677, -0.543, 0],
  0x304: [.631, -0.552, 0],
  0x306: [.694, -0.508, 0],
  0x307: [.68, -0.576, 0],
  0x308: [.68, -0.582, 0],
  0x30A: [.694, -0.527, 0],
  0x30B: [.694, -0.527, 0],
  0x30C: [.654, -0.487, 0],
  0x391: [.694, 0, .667],
  0x392: [.694, 0, .667],
  0x393: [.691, 0, .542],
  0x394: [.694, 0, .833],
  0x395: [.691, 0, .597],
  0x396: [.694, 0, .611],
  0x397: [.694, 0, .708],
  0x398: [.716, .021, .778],
  0x399: [.694, 0, .278],
  0x39A: [.694, 0, .694],
  0x39B: [.694, 0, .611],
  0x39C: [.694, 0, .875],
  0x39D: [.694, 0, .708],
  0x39E: [.688, 0, .667],
  0x39F: [.715, .022, .736],
  0x3A0: [.691, 0, .708],
  0x3A1: [.694, 0, .639],
  0x3A3: [.694, 0, .722],
  0x3A4: [.688, 0, .681],
  0x3A5: [.716, 0, .778],
  0x3A6: [.694, 0, .722],
  0x3A7: [.694, 0, .667],
  0x3A8: [.694, 0, .778],
  0x3A9: [.716, 0, .722],
  0x2013: [.312, -0.236, .5],
  0x2014: [.312, -0.236, 1],
  0x2015: [.312, -0.236, 1],
  0x2017: [-0.038, .114, .5],
  0x2018: [.694, -0.471, .278],
  0x2019: [.694, -0.471, .278],
  0x201C: [.694, -0.471, .5],
  0x201D: [.694, -0.471, .5],
  0x2044: [.75, .25, .5],
  0x2206: [.694, 0, .833]
};

Object.defineProperty(sansSerif$1, "__esModule", {
  value: true
});
sansSerif$1.sansSerif = void 0;
var FontData_js_1$6 = FontData;
var sans_serif_js_1$1 = sansSerif;
sansSerif$1.sansSerif = (0, FontData_js_1$6.AddCSS)(sans_serif_js_1$1.sansSerif, {
  0x391: {
    c: 'A'
  },
  0x392: {
    c: 'B'
  },
  0x395: {
    c: 'E'
  },
  0x396: {
    c: 'Z'
  },
  0x397: {
    c: 'H'
  },
  0x399: {
    c: 'I'
  },
  0x39A: {
    c: 'K'
  },
  0x39C: {
    c: 'M'
  },
  0x39D: {
    c: 'N'
  },
  0x39F: {
    c: 'O'
  },
  0x3A1: {
    c: 'P'
  },
  0x3A4: {
    c: 'T'
  },
  0x3A7: {
    c: 'X'
  },
  0x2015: {
    c: '\\2014'
  },
  0x2017: {
    c: '_'
  },
  0x2044: {
    c: '/'
  },
  0x2206: {
    c: '\\394'
  }
});

var scriptBold$1 = {};

var scriptBold = {};

Object.defineProperty(scriptBold, "__esModule", {
  value: true
});
scriptBold.scriptBold = void 0;
scriptBold.scriptBold = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.scriptBold = void 0;
  var script_bold_js_1 = scriptBold;
  Object.defineProperty(exports, "scriptBold", {
    enumerable: true,
    get: function () {
      return script_bold_js_1.scriptBold;
    }
  });
})(scriptBold$1);
getDefaultExportFromCjs(scriptBold$1);

var script$1 = {};

var script = {};

Object.defineProperty(script, "__esModule", {
  value: true
});
script.script = void 0;
script.script = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.script = void 0;
  var script_js_1 = script;
  Object.defineProperty(exports, "script", {
    enumerable: true,
    get: function () {
      return script_js_1.script;
    }
  });
})(script$1);
getDefaultExportFromCjs(script$1);

var smallop$1 = {};

var smallop = {};

Object.defineProperty(smallop, "__esModule", {
  value: true
});
smallop.smallop = void 0;
smallop.smallop = {
  0x28: [.85, .349, .458],
  0x29: [.85, .349, .458],
  0x2F: [.85, .349, .578],
  0x5B: [.85, .349, .417],
  0x5C: [.85, .349, .578],
  0x5D: [.85, .349, .417],
  0x7B: [.85, .349, .583],
  0x7D: [.85, .349, .583],
  0x2C6: [.744, -0.551, .556],
  0x2DC: [.722, -0.597, .556],
  0x302: [.744, -0.551, 0],
  0x303: [.722, -0.597, 0],
  0x2016: [.602, 0, .778],
  0x2044: [.85, .349, .578],
  0x2191: [.6, 0, .667],
  0x2193: [.6, 0, .667],
  0x21D1: [.599, 0, .778],
  0x21D3: [.6, 0, .778],
  0x220F: [.75, .25, .944],
  0x2210: [.75, .25, .944],
  0x2211: [.75, .25, 1.056],
  0x221A: [.85, .35, 1, {
    ic: .02
  }],
  0x2223: [.627, .015, .333],
  0x2225: [.627, .015, .556],
  0x222B: [.805, .306, .472, {
    ic: .138
  }],
  0x222C: [.805, .306, .819, {
    ic: .138
  }],
  0x222D: [.805, .306, 1.166, {
    ic: .138
  }],
  0x222E: [.805, .306, .472, {
    ic: .138
  }],
  0x22C0: [.75, .249, .833],
  0x22C1: [.75, .249, .833],
  0x22C2: [.75, .249, .833],
  0x22C3: [.75, .249, .833],
  0x2308: [.85, .349, .472],
  0x2309: [.85, .349, .472],
  0x230A: [.85, .349, .472],
  0x230B: [.85, .349, .472],
  0x2329: [.85, .35, .472],
  0x232A: [.85, .35, .472],
  0x23D0: [.602, 0, .667],
  0x2758: [.627, .015, .333],
  0x27E8: [.85, .35, .472],
  0x27E9: [.85, .35, .472],
  0x2A00: [.75, .25, 1.111],
  0x2A01: [.75, .25, 1.111],
  0x2A02: [.75, .25, 1.111],
  0x2A04: [.75, .249, .833],
  0x2A06: [.75, .249, .833],
  0x2A0C: [.805, .306, 1.638, {
    ic: .138
  }],
  0x3008: [.85, .35, .472],
  0x3009: [.85, .35, .472]
};

Object.defineProperty(smallop$1, "__esModule", {
  value: true
});
smallop$1.smallop = void 0;
var FontData_js_1$5 = FontData;
var smallop_js_1$1 = smallop;
smallop$1.smallop = (0, FontData_js_1$5.AddCSS)(smallop_js_1$1.smallop, {
  0x2044: {
    c: '/'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x2758: {
    c: '\\2223'
  },
  0x2A0C: {
    c: '\\222C\\222C'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  }
});

var texCalligraphicBold$1 = {};

var texCalligraphicBold = {};

Object.defineProperty(texCalligraphicBold, "__esModule", {
  value: true
});
texCalligraphicBold.texCalligraphicBold = void 0;
texCalligraphicBold.texCalligraphicBold = {
  0x41: [.751, .049, .921, {
    ic: .068,
    sk: .224
  }],
  0x42: [.705, .017, .748, {
    sk: .16
  }],
  0x43: [.703, .02, .613, {
    sk: .16
  }],
  0x44: [.686, 0, .892, {
    sk: .0958
  }],
  0x45: [.703, .016, .607, {
    ic: .02,
    sk: .128
  }],
  0x46: [.686, .03, .814, {
    ic: .116,
    sk: .128
  }],
  0x47: [.703, .113, .682, {
    sk: .128
  }],
  0x48: [.686, .048, .987, {
    sk: .128
  }],
  0x49: [.686, 0, .642, {
    ic: .104,
    sk: .0319
  }],
  0x4A: [.686, .114, .779, {
    ic: .158,
    sk: .192
  }],
  0x4B: [.703, .017, .871, {
    sk: .0639
  }],
  0x4C: [.703, .017, .788, {
    sk: .16
  }],
  0x4D: [.703, .049, 1.378, {
    sk: .16
  }],
  0x4E: [.84, .049, .937, {
    ic: .168,
    sk: .0958
  }],
  0x4F: [.703, .017, .906, {
    sk: .128
  }],
  0x50: [.686, .067, .81, {
    ic: .036,
    sk: .0958
  }],
  0x51: [.703, .146, .939, {
    sk: .128
  }],
  0x52: [.686, .017, .99, {
    sk: .0958
  }],
  0x53: [.703, .016, .696, {
    ic: .025,
    sk: .16
  }],
  0x54: [.72, .069, .644, {
    ic: .303,
    sk: .0319
  }],
  0x55: [.686, .024, .715, {
    ic: .056,
    sk: .0958
  }],
  0x56: [.686, .077, .737, {
    ic: .037,
    sk: .0319
  }],
  0x57: [.686, .077, 1.169, {
    ic: .037,
    sk: .0958
  }],
  0x58: [.686, 0, .817, {
    ic: .089,
    sk: .16
  }],
  0x59: [.686, .164, .759, {
    ic: .038,
    sk: .0958
  }],
  0x5A: [.686, 0, .818, {
    ic: .035,
    sk: .16
  }],
  0x131: [.452, .008, .394, {
    sk: .0319
  }],
  0x237: [.451, .201, .439, {
    sk: .0958
  }]
};

Object.defineProperty(texCalligraphicBold$1, "__esModule", {
  value: true
});
texCalligraphicBold$1.texCalligraphicBold = void 0;
var FontData_js_1$4 = FontData;
var tex_calligraphic_bold_js_1$1 = texCalligraphicBold;
texCalligraphicBold$1.texCalligraphicBold = (0, FontData_js_1$4.AddCSS)(tex_calligraphic_bold_js_1$1.texCalligraphicBold, {
  0x131: {
    f: 'B'
  },
  0x237: {
    f: 'B'
  }
});

var texCalligraphic$1 = {};

var texCalligraphic = {};

Object.defineProperty(texCalligraphic, "__esModule", {
  value: true
});
texCalligraphic.texCalligraphic = void 0;
texCalligraphic.texCalligraphic = {
  0x41: [.728, .05, .798, {
    ic: .021,
    sk: .194
  }],
  0x42: [.705, .022, .657, {
    sk: .139
  }],
  0x43: [.705, .025, .527, {
    sk: .139
  }],
  0x44: [.683, 0, .771, {
    sk: .0833
  }],
  0x45: [.705, .022, .528, {
    ic: .036,
    sk: .111
  }],
  0x46: [.683, .032, .719, {
    ic: .11,
    sk: .111
  }],
  0x47: [.704, .119, .595, {
    sk: .111
  }],
  0x48: [.683, .048, .845, {
    sk: .111
  }],
  0x49: [.683, 0, .545, {
    ic: .097,
    sk: .0278
  }],
  0x4A: [.683, .119, .678, {
    ic: .161,
    sk: .167
  }],
  0x4B: [.705, .022, .762, {
    sk: .0556
  }],
  0x4C: [.705, .022, .69, {
    sk: .139
  }],
  0x4D: [.705, .05, 1.201, {
    sk: .139
  }],
  0x4E: [.789, .05, .82, {
    ic: .159,
    sk: .0833
  }],
  0x4F: [.705, .022, .796, {
    sk: .111
  }],
  0x50: [.683, .057, .696, {
    ic: .037,
    sk: .0833
  }],
  0x51: [.705, .131, .817, {
    sk: .111
  }],
  0x52: [.682, .022, .848, {
    sk: .0833
  }],
  0x53: [.705, .022, .606, {
    ic: .036,
    sk: .139
  }],
  0x54: [.717, .068, .545, {
    ic: .288,
    sk: .0278
  }],
  0x55: [.683, .028, .626, {
    ic: .061,
    sk: .0833
  }],
  0x56: [.683, .052, .613, {
    ic: .045,
    sk: .0278
  }],
  0x57: [.683, .053, .988, {
    ic: .046,
    sk: .0833
  }],
  0x58: [.683, 0, .713, {
    ic: .094,
    sk: .139
  }],
  0x59: [.683, .143, .668, {
    ic: .046,
    sk: .0833
  }],
  0x5A: [.683, 0, .725, {
    ic: .042,
    sk: .139
  }]
};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.texCalligraphic = void 0;
  var tex_calligraphic_js_1 = texCalligraphic;
  Object.defineProperty(exports, "texCalligraphic", {
    enumerable: true,
    get: function () {
      return tex_calligraphic_js_1.texCalligraphic;
    }
  });
})(texCalligraphic$1);
getDefaultExportFromCjs(texCalligraphic$1);

var texMathit$1 = {};

var texMathit = {};

Object.defineProperty(texMathit, "__esModule", {
  value: true
});
texMathit.texMathit = void 0;
texMathit.texMathit = {
  0x41: [.716, 0, .743],
  0x42: [.683, 0, .704],
  0x43: [.705, .021, .716],
  0x44: [.683, 0, .755],
  0x45: [.68, 0, .678],
  0x46: [.68, 0, .653],
  0x47: [.705, .022, .774],
  0x48: [.683, 0, .743],
  0x49: [.683, 0, .386],
  0x4A: [.683, .021, .525],
  0x4B: [.683, 0, .769],
  0x4C: [.683, 0, .627],
  0x4D: [.683, 0, .897],
  0x4E: [.683, 0, .743],
  0x4F: [.704, .022, .767],
  0x50: [.683, 0, .678],
  0x51: [.704, .194, .767],
  0x52: [.683, .022, .729],
  0x53: [.705, .022, .562],
  0x54: [.677, 0, .716],
  0x55: [.683, .022, .743],
  0x56: [.683, .022, .743],
  0x57: [.683, .022, .999],
  0x58: [.683, 0, .743],
  0x59: [.683, 0, .743],
  0x5A: [.683, 0, .613],
  0x61: [.442, .011, .511],
  0x62: [.694, .011, .46],
  0x63: [.441, .01, .46],
  0x64: [.694, .011, .511],
  0x65: [.442, .01, .46],
  0x66: [.705, .204, .307],
  0x67: [.442, .205, .46],
  0x68: [.694, .011, .511],
  0x69: [.656, .01, .307],
  0x6A: [.656, .204, .307],
  0x6B: [.694, .011, .46],
  0x6C: [.694, .011, .256],
  0x6D: [.442, .011, .818],
  0x6E: [.442, .011, .562],
  0x6F: [.442, .011, .511],
  0x70: [.442, .194, .511],
  0x71: [.442, .194, .46],
  0x72: [.442, .011, .422],
  0x73: [.442, .011, .409],
  0x74: [.626, .011, .332],
  0x75: [.441, .011, .537],
  0x76: [.443, .01, .46],
  0x77: [.443, .011, .664],
  0x78: [.442, .011, .464],
  0x79: [.441, .205, .486],
  0x7A: [.442, .011, .409]
};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.texMathit = void 0;
  var tex_mathit_js_1 = texMathit;
  Object.defineProperty(exports, "texMathit", {
    enumerable: true,
    get: function () {
      return tex_mathit_js_1.texMathit;
    }
  });
})(texMathit$1);
getDefaultExportFromCjs(texMathit$1);

var texOldstyleBold$1 = {};

var texOldstyleBold = {};

Object.defineProperty(texOldstyleBold, "__esModule", {
  value: true
});
texOldstyleBold.texOldstyleBold = void 0;
texOldstyleBold.texOldstyleBold = {
  0x30: [.46, .017, .575],
  0x31: [.461, 0, .575],
  0x32: [.46, 0, .575],
  0x33: [.461, .211, .575],
  0x34: [.469, .194, .575],
  0x35: [.461, .211, .575],
  0x36: [.66, .017, .575],
  0x37: [.476, .211, .575],
  0x38: [.661, .017, .575],
  0x39: [.461, .21, .575],
  0x41: [.751, .049, .921, {
    ic: .068,
    sk: .224
  }],
  0x42: [.705, .017, .748, {
    sk: .16
  }],
  0x43: [.703, .02, .613, {
    sk: .16
  }],
  0x44: [.686, 0, .892, {
    sk: .0958
  }],
  0x45: [.703, .016, .607, {
    ic: .02,
    sk: .128
  }],
  0x46: [.686, .03, .814, {
    ic: .116,
    sk: .128
  }],
  0x47: [.703, .113, .682, {
    sk: .128
  }],
  0x48: [.686, .048, .987, {
    sk: .128
  }],
  0x49: [.686, 0, .642, {
    ic: .104,
    sk: .0319
  }],
  0x4A: [.686, .114, .779, {
    ic: .158,
    sk: .192
  }],
  0x4B: [.703, .017, .871, {
    sk: .0639
  }],
  0x4C: [.703, .017, .788, {
    sk: .16
  }],
  0x4D: [.703, .049, 1.378, {
    sk: .16
  }],
  0x4E: [.84, .049, .937, {
    ic: .168,
    sk: .0958
  }],
  0x4F: [.703, .017, .906, {
    sk: .128
  }],
  0x50: [.686, .067, .81, {
    ic: .036,
    sk: .0958
  }],
  0x51: [.703, .146, .939, {
    sk: .128
  }],
  0x52: [.686, .017, .99, {
    sk: .0958
  }],
  0x53: [.703, .016, .696, {
    ic: .025,
    sk: .16
  }],
  0x54: [.72, .069, .644, {
    ic: .303,
    sk: .0319
  }],
  0x55: [.686, .024, .715, {
    ic: .056,
    sk: .0958
  }],
  0x56: [.686, .077, .737, {
    ic: .037,
    sk: .0319
  }],
  0x57: [.686, .077, 1.169, {
    ic: .037,
    sk: .0958
  }],
  0x58: [.686, 0, .817, {
    ic: .089,
    sk: .16
  }],
  0x59: [.686, .164, .759, {
    ic: .038,
    sk: .0958
  }],
  0x5A: [.686, 0, .818, {
    ic: .035,
    sk: .16
  }]
};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.texOldstyleBold = void 0;
  var tex_oldstyle_bold_js_1 = texOldstyleBold;
  Object.defineProperty(exports, "texOldstyleBold", {
    enumerable: true,
    get: function () {
      return tex_oldstyle_bold_js_1.texOldstyleBold;
    }
  });
})(texOldstyleBold$1);
getDefaultExportFromCjs(texOldstyleBold$1);

var texOldstyle$1 = {};

var texOldstyle = {};

Object.defineProperty(texOldstyle, "__esModule", {
  value: true
});
texOldstyle.texOldstyle = void 0;
texOldstyle.texOldstyle = {
  0x30: [.452, .022, .5],
  0x31: [.453, 0, .5],
  0x32: [.453, 0, .5],
  0x33: [.452, .216, .5],
  0x34: [.464, .194, .5],
  0x35: [.453, .216, .5],
  0x36: [.665, .022, .5],
  0x37: [.463, .216, .5],
  0x38: [.666, .021, .5],
  0x39: [.453, .216, .5],
  0x41: [.728, .05, .798, {
    ic: .021,
    sk: .194
  }],
  0x42: [.705, .022, .657, {
    sk: .139
  }],
  0x43: [.705, .025, .527, {
    sk: .139
  }],
  0x44: [.683, 0, .771, {
    sk: .0833
  }],
  0x45: [.705, .022, .528, {
    ic: .036,
    sk: .111
  }],
  0x46: [.683, .032, .719, {
    ic: .11,
    sk: .111
  }],
  0x47: [.704, .119, .595, {
    sk: .111
  }],
  0x48: [.683, .048, .845, {
    sk: .111
  }],
  0x49: [.683, 0, .545, {
    ic: .097,
    sk: .0278
  }],
  0x4A: [.683, .119, .678, {
    ic: .161,
    sk: .167
  }],
  0x4B: [.705, .022, .762, {
    sk: .0556
  }],
  0x4C: [.705, .022, .69, {
    sk: .139
  }],
  0x4D: [.705, .05, 1.201, {
    sk: .139
  }],
  0x4E: [.789, .05, .82, {
    ic: .159,
    sk: .0833
  }],
  0x4F: [.705, .022, .796, {
    sk: .111
  }],
  0x50: [.683, .057, .696, {
    ic: .037,
    sk: .0833
  }],
  0x51: [.705, .131, .817, {
    sk: .111
  }],
  0x52: [.682, .022, .848, {
    sk: .0833
  }],
  0x53: [.705, .022, .606, {
    ic: .036,
    sk: .139
  }],
  0x54: [.717, .068, .545, {
    ic: .288,
    sk: .0278
  }],
  0x55: [.683, .028, .626, {
    ic: .061,
    sk: .0833
  }],
  0x56: [.683, .052, .613, {
    ic: .045,
    sk: .0278
  }],
  0x57: [.683, .053, .988, {
    ic: .046,
    sk: .0833
  }],
  0x58: [.683, 0, .713, {
    ic: .094,
    sk: .139
  }],
  0x59: [.683, .143, .668, {
    ic: .046,
    sk: .0833
  }],
  0x5A: [.683, 0, .725, {
    ic: .042,
    sk: .139
  }]
};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.texOldstyle = void 0;
  var tex_oldstyle_js_1 = texOldstyle;
  Object.defineProperty(exports, "texOldstyle", {
    enumerable: true,
    get: function () {
      return tex_oldstyle_js_1.texOldstyle;
    }
  });
})(texOldstyle$1);
getDefaultExportFromCjs(texOldstyle$1);

var texSize3$1 = {};

var texSize3 = {};

Object.defineProperty(texSize3, "__esModule", {
  value: true
});
texSize3.texSize3 = void 0;
texSize3.texSize3 = {
  0x28: [1.45, .949, .736],
  0x29: [1.45, .949, .736],
  0x2F: [1.45, .949, 1.044],
  0x5B: [1.45, .949, .528],
  0x5C: [1.45, .949, 1.044],
  0x5D: [1.45, .949, .528],
  0x7B: [1.45, .949, .75],
  0x7D: [1.45, .949, .75],
  0x2C6: [.772, -0.564, 1.444],
  0x2DC: [.749, -0.61, 1.444],
  0x302: [.772, -0.564, 0],
  0x303: [.749, -0.61, 0],
  0x2044: [1.45, .949, 1.044],
  0x221A: [1.45, .95, 1, {
    ic: .02
  }],
  0x2308: [1.45, .949, .583],
  0x2309: [1.45, .949, .583],
  0x230A: [1.45, .949, .583],
  0x230B: [1.45, .949, .583],
  0x2329: [1.45, .95, .75],
  0x232A: [1.45, .949, .75],
  0x27E8: [1.45, .95, .75],
  0x27E9: [1.45, .949, .75],
  0x3008: [1.45, .95, .75],
  0x3009: [1.45, .949, .75]
};

Object.defineProperty(texSize3$1, "__esModule", {
  value: true
});
texSize3$1.texSize3 = void 0;
var FontData_js_1$3 = FontData;
var tex_size3_js_1$1 = texSize3;
texSize3$1.texSize3 = (0, FontData_js_1$3.AddCSS)(tex_size3_js_1$1.texSize3, {
  0x2044: {
    c: '/'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  }
});

var texSize4$1 = {};

var texSize4 = {};

Object.defineProperty(texSize4, "__esModule", {
  value: true
});
texSize4.texSize4 = void 0;
texSize4.texSize4 = {
  0x28: [1.75, 1.249, .792],
  0x29: [1.75, 1.249, .792],
  0x2F: [1.75, 1.249, 1.278],
  0x5B: [1.75, 1.249, .583],
  0x5C: [1.75, 1.249, 1.278],
  0x5D: [1.75, 1.249, .583],
  0x7B: [1.75, 1.249, .806],
  0x7D: [1.75, 1.249, .806],
  0x2C6: [.845, -0.561, 1.889, {
    ic: .013
  }],
  0x2DC: [.823, -0.583, 1.889],
  0x302: [.845, -0.561, 0, {
    ic: .013
  }],
  0x303: [.823, -0.583, 0],
  0x2044: [1.75, 1.249, 1.278],
  0x221A: [1.75, 1.25, 1, {
    ic: .02
  }],
  0x2308: [1.75, 1.249, .639],
  0x2309: [1.75, 1.249, .639],
  0x230A: [1.75, 1.249, .639],
  0x230B: [1.75, 1.249, .639],
  0x2329: [1.75, 1.248, .806],
  0x232A: [1.75, 1.248, .806],
  0x239B: [1.154, .655, .875],
  0x239C: [.61, .01, .875],
  0x239D: [1.165, .644, .875],
  0x239E: [1.154, .655, .875],
  0x239F: [.61, .01, .875],
  0x23A0: [1.165, .644, .875],
  0x23A1: [1.154, .645, .667],
  0x23A2: [.602, 0, .667],
  0x23A3: [1.155, .644, .667],
  0x23A4: [1.154, .645, .667],
  0x23A5: [.602, 0, .667],
  0x23A6: [1.155, .644, .667],
  0x23A7: [.899, .01, .889],
  0x23A8: [1.16, .66, .889],
  0x23A9: [.01, .899, .889],
  0x23AA: [.29, .015, .889],
  0x23AB: [.899, .01, .889],
  0x23AC: [1.16, .66, .889],
  0x23AD: [.01, .899, .889],
  0x23B7: [.935, .885, 1.056],
  0x27E8: [1.75, 1.248, .806],
  0x27E9: [1.75, 1.248, .806],
  0x3008: [1.75, 1.248, .806],
  0x3009: [1.75, 1.248, .806],
  0xE000: [.625, .014, 1.056],
  0xE001: [.605, .014, 1.056, {
    ic: .02
  }],
  0xE150: [.12, .213, .45, {
    ic: .01
  }],
  0xE151: [.12, .213, .45, {
    ic: .024
  }],
  0xE152: [.333, 0, .45, {
    ic: .01
  }],
  0xE153: [.333, 0, .45, {
    ic: .024
  }],
  0xE154: [.32, .2, .4, {
    ic: .01
  }],
  0xE155: [.333, 0, .9, {
    ic: .01
  }],
  0xE156: [.12, .213, .9, {
    ic: .01
  }]
};

Object.defineProperty(texSize4$1, "__esModule", {
  value: true
});
texSize4$1.texSize4 = void 0;
var FontData_js_1$2 = FontData;
var tex_size4_js_1$1 = texSize4;
texSize4$1.texSize4 = (0, FontData_js_1$2.AddCSS)(tex_size4_js_1$1.texSize4, {
  0x2044: {
    c: '/'
  },
  0x2329: {
    c: '\\27E8'
  },
  0x232A: {
    c: '\\27E9'
  },
  0x3008: {
    c: '\\27E8'
  },
  0x3009: {
    c: '\\27E9'
  },
  0xE155: {
    c: '\\E153\\E152'
  },
  0xE156: {
    c: '\\E151\\E150'
  }
});

var texVariant$1 = {};

var texVariant = {};

Object.defineProperty(texVariant, "__esModule", {
  value: true
});
texVariant.texVariant = void 0;
texVariant.texVariant = {
  0x2C6: [.845, -0.561, 2.333, {
    ic: .013
  }],
  0x2DC: [.899, -0.628, 2.333],
  0x302: [.845, -0.561, 0, {
    ic: .013
  }],
  0x303: [.899, -0.628, 0],
  0x3F0: [.434, .006, .667, {
    ic: .067
  }],
  0x210F: [.695, .013, .54, {
    ic: .022
  }],
  0x2190: [.437, -0.064, .5],
  0x2192: [.437, -0.064, .5],
  0x21CC: [.514, .014, 1],
  0x2204: [.86, .166, .556],
  0x2205: [.587, 0, .778],
  0x2212: [.27, -0.23, .5],
  0x2216: [.43, .023, .778],
  0x221D: [.472, -0.028, .778],
  0x2223: [.43, .023, .222],
  0x2224: [.43, .023, .222, {
    ic: .018
  }],
  0x2225: [.431, .023, .389],
  0x2226: [.431, .024, .389, {
    ic: .018
  }],
  0x223C: [.365, -0.132, .778],
  0x2248: [.481, -0.05, .778],
  0x2268: [.752, .284, .778],
  0x2269: [.752, .284, .778],
  0x2270: [.919, .421, .778],
  0x2271: [.919, .421, .778],
  0x2288: [.828, .33, .778],
  0x2289: [.828, .33, .778],
  0x228A: [.634, .255, .778],
  0x228B: [.634, .254, .778],
  0x22A8: [.694, 0, .611],
  0x22C5: [.189, 0, .278],
  0x2322: [.378, -0.122, .778],
  0x2323: [.378, -0.143, .778],
  0x25B3: [.575, .02, .722],
  0x25BD: [.576, .019, .722],
  0x2A87: [.801, .303, .778],
  0x2A88: [.801, .303, .778],
  0x2ACB: [.752, .332, .778],
  0x2ACC: [.752, .333, .778]
};

Object.defineProperty(texVariant$1, "__esModule", {
  value: true
});
texVariant$1.texVariant = void 0;
var FontData_js_1$1 = FontData;
var tex_variant_js_1$1 = texVariant;
texVariant$1.texVariant = (0, FontData_js_1$1.AddCSS)(tex_variant_js_1$1.texVariant, {
  0x3F0: {
    c: '\\E009'
  },
  0x210F: {
    f: ''
  },
  0x2224: {
    c: '\\E006'
  },
  0x2226: {
    c: '\\E007'
  },
  0x2268: {
    c: '\\E00C'
  },
  0x2269: {
    c: '\\E00D'
  },
  0x2270: {
    c: '\\E011'
  },
  0x2271: {
    c: '\\E00E'
  },
  0x2288: {
    c: '\\E016'
  },
  0x2289: {
    c: '\\E018'
  },
  0x228A: {
    c: '\\E01A'
  },
  0x228B: {
    c: '\\E01B'
  },
  0x2A87: {
    c: '\\E010'
  },
  0x2A88: {
    c: '\\E00F'
  },
  0x2ACB: {
    c: '\\E017'
  },
  0x2ACC: {
    c: '\\E019'
  }
});

var delimiters = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.delimiters = exports.VSIZES = exports.HDW3 = exports.HDW2 = exports.HDW1 = void 0;
  var FontData_js_1 = FontData$2;
  exports.HDW1 = [.75, .25, .875];
  exports.HDW2 = [.85, .349, .667];
  exports.HDW3 = [.583, .082, .5];
  exports.VSIZES = [1, 1.2, 1.8, 2.4, 3];
  var DELIM2F = {
    c: 0x2F,
    dir: FontData_js_1.V,
    sizes: exports.VSIZES
  };
  var DELIMAF = {
    c: 0xAF,
    dir: FontData_js_1.H,
    sizes: [.5],
    stretch: [0, 0xAF],
    HDW: [.59, -0.544, .5]
  };
  var DELIM2C6 = {
    c: 0x2C6,
    dir: FontData_js_1.H,
    sizes: [.5, .556, 1, 1.444, 1.889]
  };
  var DELIM2DC = {
    c: 0x2DC,
    dir: FontData_js_1.H,
    sizes: [.5, .556, 1, 1.444, 1.889]
  };
  var DELIM2013 = {
    c: 0x2013,
    dir: FontData_js_1.H,
    sizes: [.5],
    stretch: [0, 0x2013],
    HDW: [.285, -0.248, .5]
  };
  var DELIM2190 = {
    c: 0x2190,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0x2190, 0x2212],
    HDW: exports.HDW3
  };
  var DELIM2192 = {
    c: 0x2192,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0, 0x2212, 0x2192],
    HDW: exports.HDW3
  };
  var DELIM2194 = {
    c: 0x2194,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0x2190, 0x2212, 0x2192],
    HDW: exports.HDW3
  };
  var DELIM21A4 = {
    c: 0x21A4,
    dir: FontData_js_1.H,
    stretch: [0x2190, 0x2212, 0x2223],
    HDW: exports.HDW3,
    min: 1.278
  };
  var DELIM21A6 = {
    c: 0x21A6,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0x2223, 0x2212, 0x2192],
    HDW: exports.HDW3
  };
  var DELIM21D0 = {
    c: 0x21D0,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0x21D0, 0x3D],
    HDW: exports.HDW3
  };
  var DELIM21D2 = {
    c: 0x21D2,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0, 0x3D, 0x21D2],
    HDW: exports.HDW3
  };
  var DELIM21D4 = {
    c: 0x21D4,
    dir: FontData_js_1.H,
    sizes: [1],
    stretch: [0x21D0, 0x3D, 0x21D2],
    HDW: exports.HDW3
  };
  var DELIM2212 = {
    c: 0x2212,
    dir: FontData_js_1.H,
    sizes: [.778],
    stretch: [0, 0x2212],
    HDW: exports.HDW3
  };
  var DELIM2223 = {
    c: 0x2223,
    dir: FontData_js_1.V,
    sizes: [1],
    stretch: [0, 0x2223],
    HDW: [.627, .015, .333]
  };
  var DELIM23DC = {
    c: 0x23DC,
    dir: FontData_js_1.H,
    sizes: [.778, 1],
    schar: [0x2322, 0x2322],
    variants: [5, 0],
    stretch: [0xE150, 0xE154, 0xE151],
    HDW: [.32, .2, .5]
  };
  var DELIM23DD = {
    c: 0x23DD,
    dir: FontData_js_1.H,
    sizes: [.778, 1],
    schar: [0x2323, 0x2323],
    variants: [5, 0],
    stretch: [0xE152, 0xE154, 0xE153],
    HDW: [.32, .2, .5]
  };
  var DELIM23DE = {
    c: 0x23DE,
    dir: FontData_js_1.H,
    stretch: [0xE150, 0xE154, 0xE151, 0xE155],
    HDW: [.32, .2, .5],
    min: 1.8
  };
  var DELIM23DF = {
    c: 0x23DF,
    dir: FontData_js_1.H,
    stretch: [0xE152, 0xE154, 0xE153, 0xE156],
    HDW: [.32, .2, .5],
    min: 1.8
  };
  var DELIM27E8 = {
    c: 0x27E8,
    dir: FontData_js_1.V,
    sizes: exports.VSIZES
  };
  var DELIM27E9 = {
    c: 0x27E9,
    dir: FontData_js_1.V,
    sizes: exports.VSIZES
  };
  var DELIM2906 = {
    c: 0x2906,
    dir: FontData_js_1.H,
    stretch: [0x21D0, 0x3D, 0x2223],
    HDW: exports.HDW3,
    min: 1.278
  };
  var DELIM2907 = {
    c: 0x2907,
    dir: FontData_js_1.H,
    stretch: [0x22A8, 0x3D, 0x21D2],
    HDW: exports.HDW3,
    min: 1.278
  };
  exports.delimiters = {
    0x28: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x239B, 0x239C, 0x239D],
      HDW: [.85, .349, .875]
    },
    0x29: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x239E, 0x239F, 0x23A0],
      HDW: [.85, .349, .875]
    },
    0x2D: DELIM2212,
    0x2F: DELIM2F,
    0x3D: {
      dir: FontData_js_1.H,
      sizes: [.778],
      stretch: [0, 0x3D],
      HDW: exports.HDW3
    },
    0x5B: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23A1, 0x23A2, 0x23A3],
      HDW: exports.HDW2
    },
    0x5C: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES
    },
    0x5D: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23A4, 0x23A5, 0x23A6],
      HDW: exports.HDW2
    },
    0x5E: DELIM2C6,
    0x5F: DELIM2013,
    0x7B: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23A7, 0x23AA, 0x23A9, 0x23A8],
      HDW: [.85, .349, .889]
    },
    0x7C: {
      dir: FontData_js_1.V,
      sizes: [1],
      stretch: [0, 0x2223],
      HDW: [.75, .25, .333]
    },
    0x7D: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23AB, 0x23AA, 0x23AD, 0x23AC],
      HDW: [.85, .349, .889]
    },
    0x7E: DELIM2DC,
    0xAF: DELIMAF,
    0x2C6: DELIM2C6,
    0x2C9: DELIMAF,
    0x2DC: DELIM2DC,
    0x302: DELIM2C6,
    0x303: DELIM2DC,
    0x332: DELIM2013,
    0x2013: DELIM2013,
    0x2014: DELIM2013,
    0x2015: DELIM2013,
    0x2016: {
      dir: FontData_js_1.V,
      sizes: [.602, 1],
      schar: [0, 0x2225],
      variants: [1, 0],
      stretch: [0, 0x2225],
      HDW: [.602, 0, .556]
    },
    0x2017: DELIM2013,
    0x203E: DELIMAF,
    0x20D7: DELIM2192,
    0x2190: DELIM2190,
    0x2191: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0x2191, 0x23D0],
      HDW: [.6, 0, .667]
    },
    0x2192: DELIM2192,
    0x2193: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0, 0x23D0, 0x2193],
      HDW: [.6, 0, .667]
    },
    0x2194: DELIM2194,
    0x2195: {
      dir: FontData_js_1.V,
      sizes: [1.044],
      stretch: [0x2191, 0x23D0, 0x2193],
      HDW: exports.HDW1
    },
    0x219E: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0x219E, 0x2212],
      HDW: exports.HDW3
    },
    0x21A0: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0, 0x2212, 0x21A0],
      HDW: exports.HDW3
    },
    0x21A4: DELIM21A4,
    0x21A5: {
      dir: FontData_js_1.V,
      stretch: [0x2191, 0x23D0, 0x22A5],
      HDW: exports.HDW1,
      min: 1.555
    },
    0x21A6: DELIM21A6,
    0x21A7: {
      dir: FontData_js_1.V,
      stretch: [0x22A4, 0x23D0, 0x2193],
      HDW: exports.HDW1,
      min: 1.555
    },
    0x21B0: {
      dir: FontData_js_1.V,
      sizes: [.722],
      stretch: [0x21B0, 0x23D0],
      HDW: exports.HDW1
    },
    0x21B1: {
      dir: FontData_js_1.V,
      sizes: [.722],
      stretch: [0x21B1, 0x23D0],
      HDW: exports.HDW1
    },
    0x21BC: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0x21BC, 0x2212],
      HDW: exports.HDW3
    },
    0x21BD: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0x21BD, 0x2212],
      HDW: exports.HDW3
    },
    0x21BE: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0x21BE, 0x23D0],
      HDW: exports.HDW1
    },
    0x21BF: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0x21BF, 0x23D0],
      HDW: exports.HDW1
    },
    0x21C0: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0, 0x2212, 0x21C0],
      HDW: exports.HDW3
    },
    0x21C1: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0, 0x2212, 0x21C1],
      HDW: exports.HDW3
    },
    0x21C2: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0, 0x23D0, 0x21C2],
      HDW: exports.HDW1
    },
    0x21C3: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0, 0x23D0, 0x21C3],
      HDW: exports.HDW1
    },
    0x21D0: DELIM21D0,
    0x21D1: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0x21D1, 0x2016],
      HDW: [.599, 0, .778]
    },
    0x21D2: DELIM21D2,
    0x21D3: {
      dir: FontData_js_1.V,
      sizes: [.888],
      stretch: [0, 0x2016, 0x21D3],
      HDW: [.6, 0, .778]
    },
    0x21D4: DELIM21D4,
    0x21D5: {
      dir: FontData_js_1.V,
      sizes: [1.044],
      stretch: [0x21D1, 0x2016, 0x21D3],
      HDW: [.75, .25, .778]
    },
    0x21DA: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0x21DA, 0x2261],
      HDW: [.464, -0.036, .5]
    },
    0x21DB: {
      dir: FontData_js_1.H,
      sizes: [1],
      stretch: [0, 0x2261, 0x21DB],
      HDW: [.464, -0.036, .5]
    },
    0x2212: DELIM2212,
    0x2215: DELIM2F,
    0x221A: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0xE001, 0xE000, 0x23B7],
      fullExt: [.65, 2.3],
      HDW: [.85, .35, 1.056]
    },
    0x2223: DELIM2223,
    0x2225: {
      dir: FontData_js_1.V,
      sizes: [1],
      stretch: [0, 0x2225],
      HDW: [.627, .015, .556]
    },
    0x2308: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23A1, 0x23A2],
      HDW: exports.HDW2
    },
    0x2309: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0x23A4, 0x23A5],
      HDW: exports.HDW2
    },
    0x230A: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0, 0x23A2, 0x23A3],
      HDW: exports.HDW2
    },
    0x230B: {
      dir: FontData_js_1.V,
      sizes: exports.VSIZES,
      stretch: [0, 0x23A5, 0x23A6],
      HDW: exports.HDW2
    },
    0x2312: DELIM23DC,
    0x2322: DELIM23DC,
    0x2323: DELIM23DD,
    0x2329: DELIM27E8,
    0x232A: DELIM27E9,
    0x23AA: {
      dir: FontData_js_1.V,
      sizes: [.32],
      stretch: [0x23AA, 0x23AA, 0x23AA],
      HDW: [.29, .015, .889]
    },
    0x23AF: DELIM2013,
    0x23B0: {
      dir: FontData_js_1.V,
      sizes: [.989],
      stretch: [0x23A7, 0x23AA, 0x23AD],
      HDW: [.75, .25, .889]
    },
    0x23B1: {
      dir: FontData_js_1.V,
      sizes: [.989],
      stretch: [0x23AB, 0x23AA, 0x23A9],
      HDW: [.75, .25, .889]
    },
    0x23B4: {
      dir: FontData_js_1.H,
      stretch: [0x250C, 0x2212, 0x2510],
      HDW: exports.HDW3,
      min: 1
    },
    0x23B5: {
      dir: FontData_js_1.H,
      stretch: [0x2514, 0x2212, 0x2518],
      HDW: exports.HDW3,
      min: 1
    },
    0x23D0: {
      dir: FontData_js_1.V,
      sizes: [.602, 1],
      schar: [0, 0x2223],
      variants: [1, 0],
      stretch: [0, 0x2223],
      HDW: [.602, 0, .333]
    },
    0x23DC: DELIM23DC,
    0x23DD: DELIM23DD,
    0x23DE: DELIM23DE,
    0x23DF: DELIM23DF,
    0x23E0: {
      dir: FontData_js_1.H,
      stretch: [0x2CA, 0x2C9, 0x2CB],
      HDW: [.59, -0.544, .5],
      min: 1
    },
    0x23E1: {
      dir: FontData_js_1.H,
      stretch: [0x2CB, 0x2C9, 0x2CA],
      HDW: [.59, -0.544, .5],
      min: 1
    },
    0x2500: DELIM2013,
    0x2758: DELIM2223,
    0x27E8: DELIM27E8,
    0x27E9: DELIM27E9,
    0x27EE: {
      dir: FontData_js_1.V,
      sizes: [.989],
      stretch: [0x23A7, 0x23AA, 0x23A9],
      HDW: [.75, .25, .889]
    },
    0x27EF: {
      dir: FontData_js_1.V,
      sizes: [.989],
      stretch: [0x23AB, 0x23AA, 0x23AD],
      HDW: [.75, .25, .889]
    },
    0x27F5: DELIM2190,
    0x27F6: DELIM2192,
    0x27F7: DELIM2194,
    0x27F8: DELIM21D0,
    0x27F9: DELIM21D2,
    0x27FA: DELIM21D4,
    0x27FB: DELIM21A4,
    0x27FC: DELIM21A6,
    0x27FD: DELIM2906,
    0x27FE: DELIM2907,
    0x2906: DELIM2906,
    0x2907: DELIM2907,
    0x294E: {
      dir: FontData_js_1.H,
      stretch: [0x21BC, 0x2212, 0x21C0],
      HDW: exports.HDW3,
      min: 2
    },
    0x294F: {
      dir: FontData_js_1.V,
      stretch: [0x21BE, 0x23D0, 0x21C2],
      HDW: exports.HDW1,
      min: 1.776
    },
    0x2950: {
      dir: FontData_js_1.H,
      stretch: [0x21BD, 0x2212, 0x21C1],
      HDW: exports.HDW3,
      min: 2
    },
    0x2951: {
      dir: FontData_js_1.V,
      stretch: [0x21BF, 0x23D0, 0x21C3],
      HDW: exports.HDW1,
      min: .5
    },
    0x295A: {
      dir: FontData_js_1.H,
      stretch: [0x21BC, 0x2212, 0x2223],
      HDW: exports.HDW3,
      min: 1.278
    },
    0x295B: {
      dir: FontData_js_1.H,
      stretch: [0x2223, 0x2212, 0x21C0],
      HDW: exports.HDW3,
      min: 1.278
    },
    0x295C: {
      dir: FontData_js_1.V,
      stretch: [0x21BE, 0x23D0, 0x22A5],
      HDW: exports.HDW1,
      min: 1.556
    },
    0x295D: {
      dir: FontData_js_1.V,
      stretch: [0x22A4, 0x23D0, 0x21C2],
      HDW: exports.HDW1,
      min: 1.556
    },
    0x295E: {
      dir: FontData_js_1.H,
      stretch: [0x21BD, 0x2212, 0x2223],
      HDW: exports.HDW3,
      min: 1.278
    },
    0x295F: {
      dir: FontData_js_1.H,
      stretch: [0x2223, 0x2212, 0x21C1],
      HDW: exports.HDW3,
      min: 1.278
    },
    0x2960: {
      dir: FontData_js_1.V,
      stretch: [0x21BF, 0x23D0, 0x22A5],
      HDW: exports.HDW1,
      min: 1.776
    },
    0x2961: {
      dir: FontData_js_1.V,
      stretch: [0x22A4, 0x23D0, 0x21C3],
      HDW: exports.HDW1,
      min: 1.776
    },
    0x3008: DELIM27E8,
    0x3009: DELIM27E9,
    0xFE37: DELIM23DE,
    0xFE38: DELIM23DF
  };
})(delimiters);
getDefaultExportFromCjs(delimiters);

var __extends$u = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$9 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$9 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$9.apply(this, arguments);
});
Object.defineProperty(tex$1, "__esModule", {
  value: true
});
tex$1.TeXFont = void 0;
var FontData_js_1 = FontData;
var tex_js_1$1 = tex;
var bold_italic_js_1 = boldItalic$1;
var bold_js_1 = bold$1;
var double_struck_js_1 = doubleStruck$1;
var fraktur_bold_js_1 = frakturBold$1;
var fraktur_js_1 = fraktur$1;
var italic_js_1 = italic$1;
var largeop_js_1 = largeop$1;
var monospace_js_1 = monospace$1;
var normal_js_1 = normal$1;
var sans_serif_bold_italic_js_1 = sansSerifBoldItalic$1;
var sans_serif_bold_js_1 = sansSerifBold$1;
var sans_serif_italic_js_1 = sansSerifItalic$1;
var sans_serif_js_1 = sansSerif$1;
var script_bold_js_1 = scriptBold$1;
var script_js_1 = script$1;
var smallop_js_1 = smallop$1;
var tex_calligraphic_bold_js_1 = texCalligraphicBold$1;
var tex_calligraphic_js_1 = texCalligraphic$1;
var tex_mathit_js_1 = texMathit$1;
var tex_oldstyle_bold_js_1 = texOldstyleBold$1;
var tex_oldstyle_js_1 = texOldstyle$1;
var tex_size3_js_1 = texSize3$1;
var tex_size4_js_1 = texSize4$1;
var tex_variant_js_1 = texVariant$1;
var delimiters_js_1 = delimiters;
var TeXFont = (function (_super) {
  __extends$u(TeXFont, _super);
  function TeXFont() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TeXFont.defaultCssFamilyPrefix = 'MJXZERO';
  TeXFont.defaultVariantClasses = {
    'normal': 'mjx-n',
    'bold': 'mjx-b',
    'italic': 'mjx-i',
    'bold-italic': 'mjx-b mjx-i',
    'double-struck': 'mjx-ds mjx-b',
    'fraktur': 'mjx-fr',
    'bold-fraktur': 'mjx-fr mjx-b',
    'script': 'mjx-sc mjx-i',
    'bold-script': 'mjx-sc mjx-b mjx-i',
    'sans-serif': 'mjx-ss',
    'bold-sans-serif': 'mjx-ss mjx-b',
    'sans-serif-italic': 'mjx-ss mjx-i',
    'sans-serif-bold-italic': 'mjx-ss mjx-b mjx-i',
    'monospace': 'mjx-ty',
    '-smallop': 'mjx-sop',
    '-largeop': 'mjx-lop',
    '-size3': 'mjx-s3',
    '-size4': 'mjx-s4',
    '-tex-calligraphic': 'mjx-cal mjx-i',
    '-tex-bold-calligraphic': 'mjx-cal mjx-b',
    '-tex-mathit': 'mjx-mit mjx-i',
    '-tex-oldstyle': 'mjx-os',
    '-tex-bold-oldstyle': 'mjx-os mjx-b',
    '-tex-variant': 'mjx-var'
  };
  TeXFont.defaultVariantLetters = {
    'normal': '',
    'bold': 'B',
    'italic': 'MI',
    'bold-italic': 'BI',
    'double-struck': 'A',
    'fraktur': 'FR',
    'bold-fraktur': 'FRB',
    'script': 'SC',
    'bold-script': 'SCB',
    'sans-serif': 'SS',
    'bold-sans-serif': 'SSB',
    'sans-serif-italic': 'SSI',
    'sans-serif-bold-italic': 'SSBI',
    'monospace': 'T',
    '-smallop': 'S1',
    '-largeop': 'S2',
    '-size3': 'S3',
    '-size4': 'S4',
    '-tex-calligraphic': 'C',
    '-tex-bold-calligraphic': 'CB',
    '-tex-mathit': 'MI',
    '-tex-oldstyle': 'C',
    '-tex-bold-oldstyle': 'CB',
    '-tex-variant': 'A'
  };
  TeXFont.defaultDelimiters = delimiters_js_1.delimiters;
  TeXFont.defaultChars = {
    'normal': normal_js_1.normal,
    'bold': bold_js_1.bold,
    'italic': italic_js_1.italic,
    'bold-italic': bold_italic_js_1.boldItalic,
    'double-struck': double_struck_js_1.doubleStruck,
    'fraktur': fraktur_js_1.fraktur,
    'bold-fraktur': fraktur_bold_js_1.frakturBold,
    'script': script_js_1.script,
    'bold-script': script_bold_js_1.scriptBold,
    'sans-serif': sans_serif_js_1.sansSerif,
    'bold-sans-serif': sans_serif_bold_js_1.sansSerifBold,
    'sans-serif-italic': sans_serif_italic_js_1.sansSerifItalic,
    'sans-serif-bold-italic': sans_serif_bold_italic_js_1.sansSerifBoldItalic,
    'monospace': monospace_js_1.monospace,
    '-smallop': smallop_js_1.smallop,
    '-largeop': largeop_js_1.largeop,
    '-size3': tex_size3_js_1.texSize3,
    '-size4': tex_size4_js_1.texSize4,
    '-tex-calligraphic': tex_calligraphic_js_1.texCalligraphic,
    '-tex-bold-calligraphic': tex_calligraphic_bold_js_1.texCalligraphicBold,
    '-tex-mathit': tex_mathit_js_1.texMathit,
    '-tex-oldstyle': tex_oldstyle_js_1.texOldstyle,
    '-tex-bold-oldstyle': tex_oldstyle_bold_js_1.texOldstyleBold,
    '-tex-variant': tex_variant_js_1.texVariant
  };
  TeXFont.defaultStyles = __assign$9(__assign$9({}, FontData_js_1.CHTMLFontData.defaultStyles), {
    '.MJX-TEX': {
      'font-family': 'MJXZERO, MJXTEX'
    },
    '.TEX-B': {
      'font-family': 'MJXZERO, MJXTEX-B'
    },
    '.TEX-I': {
      'font-family': 'MJXZERO, MJXTEX-I'
    },
    '.TEX-MI': {
      'font-family': 'MJXZERO, MJXTEX-MI'
    },
    '.TEX-BI': {
      'font-family': 'MJXZERO, MJXTEX-BI'
    },
    '.TEX-S1': {
      'font-family': 'MJXZERO, MJXTEX-S1'
    },
    '.TEX-S2': {
      'font-family': 'MJXZERO, MJXTEX-S2'
    },
    '.TEX-S3': {
      'font-family': 'MJXZERO, MJXTEX-S3'
    },
    '.TEX-S4': {
      'font-family': 'MJXZERO, MJXTEX-S4'
    },
    '.TEX-A': {
      'font-family': 'MJXZERO, MJXTEX-A'
    },
    '.TEX-C': {
      'font-family': 'MJXZERO, MJXTEX-C'
    },
    '.TEX-CB': {
      'font-family': 'MJXZERO, MJXTEX-CB'
    },
    '.TEX-FR': {
      'font-family': 'MJXZERO, MJXTEX-FR'
    },
    '.TEX-FRB': {
      'font-family': 'MJXZERO, MJXTEX-FRB'
    },
    '.TEX-SS': {
      'font-family': 'MJXZERO, MJXTEX-SS'
    },
    '.TEX-SSB': {
      'font-family': 'MJXZERO, MJXTEX-SSB'
    },
    '.TEX-SSI': {
      'font-family': 'MJXZERO, MJXTEX-SSI'
    },
    '.TEX-SC': {
      'font-family': 'MJXZERO, MJXTEX-SC'
    },
    '.TEX-T': {
      'font-family': 'MJXZERO, MJXTEX-T'
    },
    '.TEX-V': {
      'font-family': 'MJXZERO, MJXTEX-V'
    },
    '.TEX-VB': {
      'font-family': 'MJXZERO, MJXTEX-VB'
    },
    'mjx-stretchy-v mjx-c, mjx-stretchy-h mjx-c': {
      'font-family': 'MJXZERO, MJXTEX-S1, MJXTEX-S4, MJXTEX, MJXTEX-A ! important'
    }
  });
  TeXFont.defaultFonts = __assign$9(__assign$9({}, FontData_js_1.CHTMLFontData.defaultFonts), {
    '@font-face /* 1 */': {
      'font-family': 'MJXTEX',
      src: 'url("%%URL%%/MathJax_Main-Regular.woff") format("woff")'
    },
    '@font-face /* 2 */': {
      'font-family': 'MJXTEX-B',
      src: 'url("%%URL%%/MathJax_Main-Bold.woff") format("woff")'
    },
    '@font-face /* 3 */': {
      'font-family': 'MJXTEX-I',
      src: 'url("%%URL%%/MathJax_Math-Italic.woff") format("woff")'
    },
    '@font-face /* 4 */': {
      'font-family': 'MJXTEX-MI',
      src: 'url("%%URL%%/MathJax_Main-Italic.woff") format("woff")'
    },
    '@font-face /* 5 */': {
      'font-family': 'MJXTEX-BI',
      src: 'url("%%URL%%/MathJax_Math-BoldItalic.woff") format("woff")'
    },
    '@font-face /* 6 */': {
      'font-family': 'MJXTEX-S1',
      src: 'url("%%URL%%/MathJax_Size1-Regular.woff") format("woff")'
    },
    '@font-face /* 7 */': {
      'font-family': 'MJXTEX-S2',
      src: 'url("%%URL%%/MathJax_Size2-Regular.woff") format("woff")'
    },
    '@font-face /* 8 */': {
      'font-family': 'MJXTEX-S3',
      src: 'url("%%URL%%/MathJax_Size3-Regular.woff") format("woff")'
    },
    '@font-face /* 9 */': {
      'font-family': 'MJXTEX-S4',
      src: 'url("%%URL%%/MathJax_Size4-Regular.woff") format("woff")'
    },
    '@font-face /* 10 */': {
      'font-family': 'MJXTEX-A',
      src: 'url("%%URL%%/MathJax_AMS-Regular.woff") format("woff")'
    },
    '@font-face /* 11 */': {
      'font-family': 'MJXTEX-C',
      src: 'url("%%URL%%/MathJax_Calligraphic-Regular.woff") format("woff")'
    },
    '@font-face /* 12 */': {
      'font-family': 'MJXTEX-CB',
      src: 'url("%%URL%%/MathJax_Calligraphic-Bold.woff") format("woff")'
    },
    '@font-face /* 13 */': {
      'font-family': 'MJXTEX-FR',
      src: 'url("%%URL%%/MathJax_Fraktur-Regular.woff") format("woff")'
    },
    '@font-face /* 14 */': {
      'font-family': 'MJXTEX-FRB',
      src: 'url("%%URL%%/MathJax_Fraktur-Bold.woff") format("woff")'
    },
    '@font-face /* 15 */': {
      'font-family': 'MJXTEX-SS',
      src: 'url("%%URL%%/MathJax_SansSerif-Regular.woff") format("woff")'
    },
    '@font-face /* 16 */': {
      'font-family': 'MJXTEX-SSB',
      src: 'url("%%URL%%/MathJax_SansSerif-Bold.woff") format("woff")'
    },
    '@font-face /* 17 */': {
      'font-family': 'MJXTEX-SSI',
      src: 'url("%%URL%%/MathJax_SansSerif-Italic.woff") format("woff")'
    },
    '@font-face /* 18 */': {
      'font-family': 'MJXTEX-SC',
      src: 'url("%%URL%%/MathJax_Script-Regular.woff") format("woff")'
    },
    '@font-face /* 19 */': {
      'font-family': 'MJXTEX-T',
      src: 'url("%%URL%%/MathJax_Typewriter-Regular.woff") format("woff")'
    },
    '@font-face /* 20 */': {
      'font-family': 'MJXTEX-V',
      src: 'url("%%URL%%/MathJax_Vector-Regular.woff") format("woff")'
    },
    '@font-face /* 21 */': {
      'font-family': 'MJXTEX-VB',
      src: 'url("%%URL%%/MathJax_Vector-Bold.woff") format("woff")'
    }
  });
  return TeXFont;
})((0, tex_js_1$1.CommonTeXFontMixin)(FontData_js_1.CHTMLFontData));
tex$1.TeXFont = TeXFont;

var __extends$t = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$8 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$8 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$8.apply(this, arguments);
});
var __createBinding$7 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$7 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$7 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$7(result, mod, k);
  __setModuleDefault$7(result, mod);
  return result;
});
var __values$b = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(chtml, "__esModule", {
  value: true
});
var CHTML_1 = chtml.CHTML = void 0;
var OutputJax_js_1 = OutputJax$1;
var StyleList_js_1 = StyleList;
var WrapperFactory_js_1 = WrapperFactory$2;
var Usage_js_1 = Usage$1;
var tex_js_1 = tex$1;
var LENGTHS = __importStar$7(lengths);
var string_js_1 = string;
var CHTML = (function (_super) {
  __extends$t(CHTML, _super);
  function CHTML(options) {
    if (options === void 0) {
      options = null;
    }
    var _this = _super.call(this, options, WrapperFactory_js_1.CHTMLWrapperFactory, tex_js_1.TeXFont) || this;
    _this.chtmlStyles = null;
    _this.font.adaptiveCSS(_this.options.adaptiveCSS);
    _this.wrapperUsage = new Usage_js_1.Usage();
    return _this;
  }
  CHTML.prototype.escaped = function (math, html) {
    this.setDocument(html);
    return this.html('span', {}, [this.text(math.math)]);
  };
  CHTML.prototype.styleSheet = function (html) {
    if (this.chtmlStyles) {
      if (this.options.adaptiveCSS) {
        var styles = new StyleList_js_1.CssStyles();
        this.addWrapperStyles(styles);
        this.updateFontStyles(styles);
        this.adaptor.insertRules(this.chtmlStyles, styles.getStyleRules());
      }
      return this.chtmlStyles;
    }
    var sheet = this.chtmlStyles = _super.prototype.styleSheet.call(this, html);
    this.adaptor.setAttribute(sheet, 'id', CHTML.STYLESHEETID);
    this.wrapperUsage.update();
    return sheet;
  };
  CHTML.prototype.updateFontStyles = function (styles) {
    styles.addStyles(this.font.updateStyles({}));
  };
  CHTML.prototype.addWrapperStyles = function (styles) {
    var e_1, _a;
    if (!this.options.adaptiveCSS) {
      _super.prototype.addWrapperStyles.call(this, styles);
      return;
    }
    try {
      for (var _b = __values$b(this.wrapperUsage.update()), _c = _b.next(); !_c.done; _c = _b.next()) {
        var kind = _c.value;
        var wrapper = this.factory.getNodeClass(kind);
        wrapper && this.addClassStyles(wrapper, styles);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  CHTML.prototype.addClassStyles = function (wrapper, styles) {
    var _a;
    var CLASS = wrapper;
    if (CLASS.autoStyle && CLASS.kind !== 'unknown') {
      styles.addStyles((_a = {}, _a['mjx-' + CLASS.kind] = {
        display: 'inline-block',
        'text-align': 'left'
      }, _a));
    }
    this.wrapperUsage.add(CLASS.kind);
    _super.prototype.addClassStyles.call(this, wrapper, styles);
  };
  CHTML.prototype.processMath = function (math, parent) {
    this.factory.wrap(math).toCHTML(parent);
  };
  CHTML.prototype.clearCache = function () {
    this.cssStyles.clear();
    this.font.clearCache();
    this.wrapperUsage.clear();
    this.chtmlStyles = null;
  };
  CHTML.prototype.reset = function () {
    this.clearCache();
  };
  CHTML.prototype.unknownText = function (text, variant, width) {
    if (width === void 0) {
      width = null;
    }
    var styles = {};
    var scale = 100 / this.math.metrics.scale;
    if (scale !== 100) {
      styles['font-size'] = this.fixed(scale, 1) + '%';
      styles.padding = LENGTHS.em(75 / scale) + ' 0 ' + LENGTHS.em(20 / scale) + ' 0';
    }
    if (variant !== '-explicitFont') {
      var c = (0, string_js_1.unicodeChars)(text);
      if (c.length !== 1 || c[0] < 0x1D400 || c[0] > 0x1D7FF) {
        this.cssFontStyles(this.font.getCssFont(variant), styles);
      }
    }
    if (width !== null) {
      var metrics = this.math.metrics;
      styles.width = Math.round(width * metrics.em * metrics.scale) + 'px';
    }
    return this.html('mjx-utext', {
      variant: variant,
      style: styles
    }, [this.text(text)]);
  };
  CHTML.prototype.measureTextNode = function (textNode) {
    var adaptor = this.adaptor;
    var text = adaptor.clone(textNode);
    adaptor.setStyle(text, 'font-family', adaptor.getStyle(text, 'font-family').replace(/MJXZERO, /g, ''));
    var style = {
      position: 'absolute',
      'white-space': 'nowrap'
    };
    var node = this.html('mjx-measure-text', {
      style: style
    }, [text]);
    adaptor.append(adaptor.parent(this.math.start.node), this.container);
    adaptor.append(this.container, node);
    var w = adaptor.nodeSize(text, this.math.metrics.em)[0] / this.math.metrics.scale;
    adaptor.remove(this.container);
    adaptor.remove(node);
    return {
      w: w,
      h: .75,
      d: .2
    };
  };
  CHTML.NAME = 'CHTML';
  CHTML.OPTIONS = __assign$8(__assign$8({}, OutputJax_js_1.CommonOutputJax.OPTIONS), {
    adaptiveCSS: true,
    matchFontHeight: true
  });
  CHTML.commonStyles = {
    'mjx-container[jax="CHTML"]': {
      'line-height': 0
    },
    'mjx-container [space="1"]': {
      'margin-left': '.111em'
    },
    'mjx-container [space="2"]': {
      'margin-left': '.167em'
    },
    'mjx-container [space="3"]': {
      'margin-left': '.222em'
    },
    'mjx-container [space="4"]': {
      'margin-left': '.278em'
    },
    'mjx-container [space="5"]': {
      'margin-left': '.333em'
    },
    'mjx-container [rspace="1"]': {
      'margin-right': '.111em'
    },
    'mjx-container [rspace="2"]': {
      'margin-right': '.167em'
    },
    'mjx-container [rspace="3"]': {
      'margin-right': '.222em'
    },
    'mjx-container [rspace="4"]': {
      'margin-right': '.278em'
    },
    'mjx-container [rspace="5"]': {
      'margin-right': '.333em'
    },
    'mjx-container [size="s"]': {
      'font-size': '70.7%'
    },
    'mjx-container [size="ss"]': {
      'font-size': '50%'
    },
    'mjx-container [size="Tn"]': {
      'font-size': '60%'
    },
    'mjx-container [size="sm"]': {
      'font-size': '85%'
    },
    'mjx-container [size="lg"]': {
      'font-size': '120%'
    },
    'mjx-container [size="Lg"]': {
      'font-size': '144%'
    },
    'mjx-container [size="LG"]': {
      'font-size': '173%'
    },
    'mjx-container [size="hg"]': {
      'font-size': '207%'
    },
    'mjx-container [size="HG"]': {
      'font-size': '249%'
    },
    'mjx-container [width="full"]': {
      width: '100%'
    },
    'mjx-box': {
      display: 'inline-block'
    },
    'mjx-block': {
      display: 'block'
    },
    'mjx-itable': {
      display: 'inline-table'
    },
    'mjx-row': {
      display: 'table-row'
    },
    'mjx-row > *': {
      display: 'table-cell'
    },
    'mjx-mtext': {
      display: 'inline-block'
    },
    'mjx-mstyle': {
      display: 'inline-block'
    },
    'mjx-merror': {
      display: 'inline-block',
      color: 'red',
      'background-color': 'yellow'
    },
    'mjx-mphantom': {
      visibility: 'hidden'
    },
    '_::-webkit-full-page-media, _:future, :root mjx-container': {
      'will-change': 'opacity'
    }
  };
  CHTML.STYLESHEETID = 'MJX-CHTML-styles';
  return CHTML;
})(OutputJax_js_1.CommonOutputJax);
CHTML_1 = chtml.CHTML = CHTML;

var html = {};

var HTMLHandler$1 = {};

var Handler = {};

var MathDocument = {};

var MathList = {};

var LinkedList = {};

(function (exports) {
  var __generator = commonjsGlobal && commonjsGlobal.__generator || (function (thisArg, body) {
    var _ = {
      label: 0,
      sent: function () {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    }, f, y, t, g;
    return (g = {
      next: verb(0),
      "throw": verb(1),
      "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
      return this;
    }), g);
    function verb(n) {
      return function (v) {
        return step([n, v]);
      };
    }
    function step(op) {
      if (f) throw new TypeError("Generator is already executing.");
      while (_) try {
        if ((f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)) return t;
        if ((y = 0, t)) op = [op[0] & 2, t.value];
        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;
          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };
          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;
          case 7:
            op = _.ops.pop();
            _.trys.pop();
            continue;
          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }
            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }
            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }
            if (t && _.label < t[2]) {
              _.label = t[2];
              _.ops.push(op);
              break;
            }
            if (t[2]) _.ops.pop();
            _.trys.pop();
            continue;
        }
        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
      if (op[0] & 5) throw op[1];
      return {
        value: op[0] ? op[1] : void 0,
        done: true
      };
    }
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.LinkedList = exports.ListItem = exports.END = void 0;
  exports.END = Symbol();
  var ListItem = (function () {
    function ListItem(data) {
      if (data === void 0) {
        data = null;
      }
      this.next = null;
      this.prev = null;
      this.data = data;
    }
    return ListItem;
  })();
  exports.ListItem = ListItem;
  var LinkedList = (function () {
    function LinkedList() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      this.list = new ListItem(exports.END);
      this.list.next = this.list.prev = this.list;
      this.push.apply(this, __spreadArray([], __read(args), false));
    }
    LinkedList.prototype.isBefore = function (a, b) {
      return a < b;
    };
    LinkedList.prototype.push = function () {
      var e_1, _a;
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      try {
        for (var args_1 = __values(args), args_1_1 = args_1.next(); !args_1_1.done; args_1_1 = args_1.next()) {
          var data = args_1_1.value;
          var item = new ListItem(data);
          item.next = this.list;
          item.prev = this.list.prev;
          this.list.prev = item;
          item.prev.next = item;
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (args_1_1 && !args_1_1.done && (_a = args_1.return)) _a.call(args_1);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return this;
    };
    LinkedList.prototype.pop = function () {
      var item = this.list.prev;
      if (item.data === exports.END) {
        return null;
      }
      this.list.prev = item.prev;
      item.prev.next = this.list;
      item.next = item.prev = null;
      return item.data;
    };
    LinkedList.prototype.unshift = function () {
      var e_2, _a;
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      try {
        for (var _b = __values(args.slice(0).reverse()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var data = _c.value;
          var item = new ListItem(data);
          item.next = this.list.next;
          item.prev = this.list;
          this.list.next = item;
          item.next.prev = item;
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      return this;
    };
    LinkedList.prototype.shift = function () {
      var item = this.list.next;
      if (item.data === exports.END) {
        return null;
      }
      this.list.next = item.next;
      item.next.prev = this.list;
      item.next = item.prev = null;
      return item.data;
    };
    LinkedList.prototype.remove = function () {
      var e_3, _a;
      var items = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        items[_i] = arguments[_i];
      }
      var map = new Map();
      try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
          var item_1 = items_1_1.value;
          map.set(item_1, true);
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      var item = this.list.next;
      while (item.data !== exports.END) {
        var next = item.next;
        if (map.has(item.data)) {
          item.prev.next = item.next;
          item.next.prev = item.prev;
          item.next = item.prev = null;
        }
        item = next;
      }
    };
    LinkedList.prototype.clear = function () {
      this.list.next.prev = this.list.prev.next = null;
      this.list.next = this.list.prev = this.list;
      return this;
    };
    LinkedList.prototype[Symbol.iterator] = function () {
      var current;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            current = this.list.next;
            _a.label = 1;
          case 1:
            if (!(current.data !== exports.END)) return [3, 3];
            return [4, current.data];
          case 2:
            _a.sent();
            current = current.next;
            return [3, 1];
          case 3:
            return [2];
        }
      });
    };
    LinkedList.prototype.reversed = function () {
      var current;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            current = this.list.prev;
            _a.label = 1;
          case 1:
            if (!(current.data !== exports.END)) return [3, 3];
            return [4, current.data];
          case 2:
            _a.sent();
            current = current.prev;
            return [3, 1];
          case 3:
            return [2];
        }
      });
    };
    LinkedList.prototype.insert = function (data, isBefore) {
      if (isBefore === void 0) {
        isBefore = null;
      }
      if (isBefore === null) {
        isBefore = this.isBefore.bind(this);
      }
      var item = new ListItem(data);
      var cur = this.list.next;
      while (cur.data !== exports.END && isBefore(cur.data, item.data)) {
        cur = cur.next;
      }
      item.prev = cur.prev;
      item.next = cur;
      cur.prev.next = cur.prev = item;
      return this;
    };
    LinkedList.prototype.sort = function (isBefore) {
      var e_4, _a;
      if (isBefore === void 0) {
        isBefore = null;
      }
      if (isBefore === null) {
        isBefore = this.isBefore.bind(this);
      }
      var lists = [];
      try {
        for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
          var item = _c.value;
          lists.push(new LinkedList(item));
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
      this.list.next = this.list.prev = this.list;
      while (lists.length > 1) {
        var l1 = lists.shift();
        var l2 = lists.shift();
        l1.merge(l2, isBefore);
        lists.push(l1);
      }
      if (lists.length) {
        this.list = lists[0].list;
      }
      return this;
    };
    LinkedList.prototype.merge = function (list, isBefore) {
      var _a, _b, _c, _d, _e;
      if (isBefore === void 0) {
        isBefore = null;
      }
      if (isBefore === null) {
        isBefore = this.isBefore.bind(this);
      }
      var lcur = this.list.next;
      var mcur = list.list.next;
      while (lcur.data !== exports.END && mcur.data !== exports.END) {
        if (isBefore(mcur.data, lcur.data)) {
          (_a = __read([lcur, mcur], 2), mcur.prev.next = _a[0], lcur.prev.next = _a[1]);
          (_b = __read([lcur.prev, mcur.prev], 2), mcur.prev = _b[0], lcur.prev = _b[1]);
          (_c = __read([list.list, this.list], 2), this.list.prev.next = _c[0], list.list.prev.next = _c[1]);
          (_d = __read([list.list.prev, this.list.prev], 2), this.list.prev = _d[0], list.list.prev = _d[1]);
          (_e = __read([mcur.next, lcur], 2), lcur = _e[0], mcur = _e[1]);
        } else {
          lcur = lcur.next;
        }
      }
      if (mcur.data !== exports.END) {
        this.list.prev.next = list.list.next;
        list.list.next.prev = this.list.prev;
        list.list.prev.next = this.list;
        this.list.prev = list.list.prev;
        list.list.next = list.list.prev = list.list;
      }
      return this;
    };
    return LinkedList;
  })();
  exports.LinkedList = LinkedList;
})(LinkedList);
getDefaultExportFromCjs(LinkedList);

var __extends$s = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(MathList, "__esModule", {
  value: true
});
MathList.AbstractMathList = void 0;
var LinkedList_js_1 = LinkedList;
var AbstractMathList = (function (_super) {
  __extends$s(AbstractMathList, _super);
  function AbstractMathList() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  AbstractMathList.prototype.isBefore = function (a, b) {
    return a.start.i < b.start.i || a.start.i === b.start.i && a.start.n < b.start.n;
  };
  return AbstractMathList;
})(LinkedList_js_1.LinkedList);
MathList.AbstractMathList = AbstractMathList;

var MmlFactory$1 = {};

var NodeFactory = {};

var __extends$r = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(NodeFactory, "__esModule", {
  value: true
});
NodeFactory.AbstractNodeFactory = void 0;
var Factory_js_1 = Factory;
var AbstractNodeFactory = (function (_super) {
  __extends$r(AbstractNodeFactory, _super);
  function AbstractNodeFactory() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  AbstractNodeFactory.prototype.create = function (kind, properties, children) {
    if (properties === void 0) {
      properties = {};
    }
    if (children === void 0) {
      children = [];
    }
    return this.node[kind](properties, children);
  };
  return AbstractNodeFactory;
})(Factory_js_1.AbstractFactory);
NodeFactory.AbstractNodeFactory = AbstractNodeFactory;

var MML = {};

var mstyle = {};

var __extends$q = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$7 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$7 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$7.apply(this, arguments);
});
Object.defineProperty(mstyle, "__esModule", {
  value: true
});
mstyle.MmlMstyle = void 0;
var MmlNode_js_1$d = MmlNode;
var Attributes_js_1$1 = Attributes;
var MmlMstyle = (function (_super) {
  __extends$q(MmlMstyle, _super);
  function MmlMstyle() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMstyle.prototype, "kind", {
    get: function () {
      return 'mstyle';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMstyle.prototype, "notParent", {
    get: function () {
      return this.childNodes[0] && this.childNodes[0].childNodes.length === 1;
    },
    enumerable: false,
    configurable: true
  });
  MmlMstyle.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    var scriptlevel = this.attributes.getExplicit('scriptlevel');
    if (scriptlevel != null) {
      scriptlevel = scriptlevel.toString();
      if (scriptlevel.match(/^\s*[-+]/)) {
        level += parseInt(scriptlevel);
      } else {
        level = parseInt(scriptlevel);
      }
      prime = false;
    }
    var displaystyle = this.attributes.getExplicit('displaystyle');
    if (displaystyle != null) {
      display = displaystyle === true;
      prime = false;
    }
    var cramped = this.attributes.getExplicit('data-cramped');
    if (cramped != null) {
      prime = cramped;
    }
    attributes = this.addInheritedAttributes(attributes, this.attributes.getAllAttributes());
    this.childNodes[0].setInheritedAttributes(attributes, display, level, prime);
  };
  MmlMstyle.defaults = __assign$7(__assign$7({}, MmlNode_js_1$d.AbstractMmlLayoutNode.defaults), {
    scriptlevel: Attributes_js_1$1.INHERIT,
    displaystyle: Attributes_js_1$1.INHERIT,
    scriptsizemultiplier: 1 / Math.sqrt(2),
    scriptminsize: '8px',
    mathbackground: Attributes_js_1$1.INHERIT,
    mathcolor: Attributes_js_1$1.INHERIT,
    dir: Attributes_js_1$1.INHERIT,
    infixlinebreakstyle: 'before'
  });
  return MmlMstyle;
})(MmlNode_js_1$d.AbstractMmlLayoutNode);
mstyle.MmlMstyle = MmlMstyle;

var merror$1 = {};

var __extends$p = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$6 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$6 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$6.apply(this, arguments);
});
Object.defineProperty(merror$1, "__esModule", {
  value: true
});
merror$1.MmlMerror = void 0;
var MmlNode_js_1$c = MmlNode;
var MmlMerror = (function (_super) {
  __extends$p(MmlMerror, _super);
  function MmlMerror() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$c.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMerror.prototype, "kind", {
    get: function () {
      return 'merror';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMerror.prototype, "arity", {
    get: function () {
      return -1;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMerror.prototype, "linebreakContainer", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMerror.defaults = __assign$6({}, MmlNode_js_1$c.AbstractMmlNode.defaults);
  return MmlMerror;
})(MmlNode_js_1$c.AbstractMmlNode);
merror$1.MmlMerror = MmlMerror;

var mphantom$1 = {};

var __extends$o = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$5 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$5 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$5.apply(this, arguments);
});
Object.defineProperty(mphantom$1, "__esModule", {
  value: true
});
mphantom$1.MmlMphantom = void 0;
var MmlNode_js_1$b = MmlNode;
var MmlMphantom = (function (_super) {
  __extends$o(MmlMphantom, _super);
  function MmlMphantom() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.texclass = MmlNode_js_1$b.TEXCLASS.ORD;
    return _this;
  }
  Object.defineProperty(MmlMphantom.prototype, "kind", {
    get: function () {
      return 'mphantom';
    },
    enumerable: false,
    configurable: true
  });
  MmlMphantom.defaults = __assign$5({}, MmlNode_js_1$b.AbstractMmlLayoutNode.defaults);
  return MmlMphantom;
})(MmlNode_js_1$b.AbstractMmlLayoutNode);
mphantom$1.MmlMphantom = MmlMphantom;

var maligngroup = {};

var __extends$n = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$4 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$4 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$4.apply(this, arguments);
});
Object.defineProperty(maligngroup, "__esModule", {
  value: true
});
maligngroup.MmlMaligngroup = void 0;
var MmlNode_js_1$a = MmlNode;
var Attributes_js_1 = Attributes;
var MmlMaligngroup = (function (_super) {
  __extends$n(MmlMaligngroup, _super);
  function MmlMaligngroup() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMaligngroup.prototype, "kind", {
    get: function () {
      return 'maligngroup';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMaligngroup.prototype, "isSpacelike", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMaligngroup.prototype.setChildInheritedAttributes = function (attributes, display, level, prime) {
    attributes = this.addInheritedAttributes(attributes, this.attributes.getAllAttributes());
    _super.prototype.setChildInheritedAttributes.call(this, attributes, display, level, prime);
  };
  MmlMaligngroup.defaults = __assign$4(__assign$4({}, MmlNode_js_1$a.AbstractMmlLayoutNode.defaults), {
    groupalign: Attributes_js_1.INHERIT
  });
  return MmlMaligngroup;
})(MmlNode_js_1$a.AbstractMmlLayoutNode);
maligngroup.MmlMaligngroup = MmlMaligngroup;

var malignmark = {};

var __extends$m = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$3 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$3 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$3.apply(this, arguments);
});
Object.defineProperty(malignmark, "__esModule", {
  value: true
});
malignmark.MmlMalignmark = void 0;
var MmlNode_js_1$9 = MmlNode;
var MmlMalignmark = (function (_super) {
  __extends$m(MmlMalignmark, _super);
  function MmlMalignmark() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlMalignmark.prototype, "kind", {
    get: function () {
      return 'malignmark';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMalignmark.prototype, "arity", {
    get: function () {
      return 0;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MmlMalignmark.prototype, "isSpacelike", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MmlMalignmark.defaults = __assign$3(__assign$3({}, MmlNode_js_1$9.AbstractMmlNode.defaults), {
    edge: 'left'
  });
  return MmlMalignmark;
})(MmlNode_js_1$9.AbstractMmlNode);
malignmark.MmlMalignmark = MmlMalignmark;

var mathchoice = {};

var __extends$l = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$2 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$2 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$2.apply(this, arguments);
});
Object.defineProperty(mathchoice, "__esModule", {
  value: true
});
mathchoice.MathChoice = void 0;
var MmlNode_js_1$8 = MmlNode;
var MathChoice = (function (_super) {
  __extends$l(MathChoice, _super);
  function MathChoice() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MathChoice.prototype, "kind", {
    get: function () {
      return 'MathChoice';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MathChoice.prototype, "arity", {
    get: function () {
      return 4;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(MathChoice.prototype, "notParent", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  MathChoice.prototype.setInheritedAttributes = function (attributes, display, level, prime) {
    var selection = display ? 0 : Math.max(0, Math.min(level, 2)) + 1;
    var child = this.childNodes[selection] || this.factory.create('mrow');
    this.parent.replaceChild(child, this);
    child.setInheritedAttributes(attributes, display, level, prime);
  };
  MathChoice.defaults = __assign$2({}, MmlNode_js_1$8.AbstractMmlBaseNode.defaults);
  return MathChoice;
})(MmlNode_js_1$8.AbstractMmlBaseNode);
mathchoice.MathChoice = MathChoice;

var _a$7;
Object.defineProperty(MML, "__esModule", {
  value: true
});
MML.MML = void 0;
var MmlNode_js_1$7 = MmlNode;
var math_js_1 = math$1;
var mi_js_1 = mi$1;
var mn_js_1 = mn$1;
var mo_js_1 = mo$3;
var mtext_js_1 = mtext$1;
var mspace_js_1 = mspace;
var ms_js_1 = ms$1;
var mrow_js_1 = mrow;
var mfrac_js_1 = mfrac$1;
var msqrt_js_1 = msqrt$1;
var mroot_js_1 = mroot$1;
var mstyle_js_1 = mstyle;
var merror_js_1 = merror$1;
var mpadded_js_1 = mpadded;
var mphantom_js_1 = mphantom$1;
var mfenced_js_1 = mfenced$1;
var menclose_js_1 = menclose$1;
var maction_js_1 = maction$1;
var msubsup_js_1 = msubsup$1;
var munderover_js_1 = munderover$1;
var mmultiscripts_js_1 = mmultiscripts$1;
var mtable_js_1 = mtable$1;
var mtr_js_1 = mtr$1;
var mtd_js_1 = mtd;
var maligngroup_js_1 = maligngroup;
var malignmark_js_1 = malignmark;
var mglyph_js_1 = mglyph;
var semantics_js_1 = semantics;
var TeXAtom_js_1 = TeXAtom$1;
var mathchoice_js_1 = mathchoice;
MML.MML = (_a$7 = {}, _a$7[math_js_1.MmlMath.prototype.kind] = math_js_1.MmlMath, _a$7[mi_js_1.MmlMi.prototype.kind] = mi_js_1.MmlMi, _a$7[mn_js_1.MmlMn.prototype.kind] = mn_js_1.MmlMn, _a$7[mo_js_1.MmlMo.prototype.kind] = mo_js_1.MmlMo, _a$7[mtext_js_1.MmlMtext.prototype.kind] = mtext_js_1.MmlMtext, _a$7[mspace_js_1.MmlMspace.prototype.kind] = mspace_js_1.MmlMspace, _a$7[ms_js_1.MmlMs.prototype.kind] = ms_js_1.MmlMs, _a$7[mrow_js_1.MmlMrow.prototype.kind] = mrow_js_1.MmlMrow, _a$7[mrow_js_1.MmlInferredMrow.prototype.kind] = mrow_js_1.MmlInferredMrow, _a$7[mfrac_js_1.MmlMfrac.prototype.kind] = mfrac_js_1.MmlMfrac, _a$7[msqrt_js_1.MmlMsqrt.prototype.kind] = msqrt_js_1.MmlMsqrt, _a$7[mroot_js_1.MmlMroot.prototype.kind] = mroot_js_1.MmlMroot, _a$7[mstyle_js_1.MmlMstyle.prototype.kind] = mstyle_js_1.MmlMstyle, _a$7[merror_js_1.MmlMerror.prototype.kind] = merror_js_1.MmlMerror, _a$7[mpadded_js_1.MmlMpadded.prototype.kind] = mpadded_js_1.MmlMpadded, _a$7[mphantom_js_1.MmlMphantom.prototype.kind] = mphantom_js_1.MmlMphantom, _a$7[mfenced_js_1.MmlMfenced.prototype.kind] = mfenced_js_1.MmlMfenced, _a$7[menclose_js_1.MmlMenclose.prototype.kind] = menclose_js_1.MmlMenclose, _a$7[maction_js_1.MmlMaction.prototype.kind] = maction_js_1.MmlMaction, _a$7[msubsup_js_1.MmlMsub.prototype.kind] = msubsup_js_1.MmlMsub, _a$7[msubsup_js_1.MmlMsup.prototype.kind] = msubsup_js_1.MmlMsup, _a$7[msubsup_js_1.MmlMsubsup.prototype.kind] = msubsup_js_1.MmlMsubsup, _a$7[munderover_js_1.MmlMunder.prototype.kind] = munderover_js_1.MmlMunder, _a$7[munderover_js_1.MmlMover.prototype.kind] = munderover_js_1.MmlMover, _a$7[munderover_js_1.MmlMunderover.prototype.kind] = munderover_js_1.MmlMunderover, _a$7[mmultiscripts_js_1.MmlMmultiscripts.prototype.kind] = mmultiscripts_js_1.MmlMmultiscripts, _a$7[mmultiscripts_js_1.MmlMprescripts.prototype.kind] = mmultiscripts_js_1.MmlMprescripts, _a$7[mmultiscripts_js_1.MmlNone.prototype.kind] = mmultiscripts_js_1.MmlNone, _a$7[mtable_js_1.MmlMtable.prototype.kind] = mtable_js_1.MmlMtable, _a$7[mtr_js_1.MmlMlabeledtr.prototype.kind] = mtr_js_1.MmlMlabeledtr, _a$7[mtr_js_1.MmlMtr.prototype.kind] = mtr_js_1.MmlMtr, _a$7[mtd_js_1.MmlMtd.prototype.kind] = mtd_js_1.MmlMtd, _a$7[maligngroup_js_1.MmlMaligngroup.prototype.kind] = maligngroup_js_1.MmlMaligngroup, _a$7[malignmark_js_1.MmlMalignmark.prototype.kind] = malignmark_js_1.MmlMalignmark, _a$7[mglyph_js_1.MmlMglyph.prototype.kind] = mglyph_js_1.MmlMglyph, _a$7[semantics_js_1.MmlSemantics.prototype.kind] = semantics_js_1.MmlSemantics, _a$7[semantics_js_1.MmlAnnotation.prototype.kind] = semantics_js_1.MmlAnnotation, _a$7[semantics_js_1.MmlAnnotationXML.prototype.kind] = semantics_js_1.MmlAnnotationXML, _a$7[TeXAtom_js_1.TeXAtom.prototype.kind] = TeXAtom_js_1.TeXAtom, _a$7[mathchoice_js_1.MathChoice.prototype.kind] = mathchoice_js_1.MathChoice, _a$7[MmlNode_js_1$7.TextNode.prototype.kind] = MmlNode_js_1$7.TextNode, _a$7[MmlNode_js_1$7.XMLNode.prototype.kind] = MmlNode_js_1$7.XMLNode, _a$7);

var __extends$k = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(MmlFactory$1, "__esModule", {
  value: true
});
var MmlFactory_2 = MmlFactory$1.MmlFactory = void 0;
var NodeFactory_js_1$1 = NodeFactory;
var MML_js_1 = MML;
var MmlFactory = (function (_super) {
  __extends$k(MmlFactory, _super);
  function MmlFactory() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MmlFactory.prototype, "MML", {
    get: function () {
      return this.node;
    },
    enumerable: false,
    configurable: true
  });
  MmlFactory.defaultNodes = MML_js_1.MML;
  return MmlFactory;
})(NodeFactory_js_1$1.AbstractNodeFactory);
MmlFactory_2 = MmlFactory$1.MmlFactory = MmlFactory;

var BitField$1 = {};

var __extends$j = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$a = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$8 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$3 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(BitField$1, "__esModule", {
  value: true
});
BitField$1.BitFieldClass = BitField$1.BitField = void 0;
var BitField = (function () {
  function BitField() {
    this.bits = 0;
  }
  BitField.allocate = function () {
    var e_1, _a;
    var names = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      names[_i] = arguments[_i];
    }
    try {
      for (var names_1 = __values$a(names), names_1_1 = names_1.next(); !names_1_1.done; names_1_1 = names_1.next()) {
        var name_1 = names_1_1.value;
        if (this.has(name_1)) {
          throw new Error('Bit already allocated for ' + name_1);
        }
        if (this.next === BitField.MAXBIT) {
          throw new Error('Maximum number of bits already allocated');
        }
        this.names.set(name_1, this.next);
        this.next <<= 1;
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (names_1_1 && !names_1_1.done && (_a = names_1.return)) _a.call(names_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  BitField.has = function (name) {
    return this.names.has(name);
  };
  BitField.prototype.set = function (name) {
    this.bits |= this.getBit(name);
  };
  BitField.prototype.clear = function (name) {
    this.bits &= ~this.getBit(name);
  };
  BitField.prototype.isSet = function (name) {
    return !!(this.bits & this.getBit(name));
  };
  BitField.prototype.reset = function () {
    this.bits = 0;
  };
  BitField.prototype.getBit = function (name) {
    var bit = this.constructor.names.get(name);
    if (!bit) {
      throw new Error('Unknown bit-field name: ' + name);
    }
    return bit;
  };
  BitField.MAXBIT = 1 << 31;
  BitField.next = 1;
  BitField.names = new Map();
  return BitField;
})();
BitField$1.BitField = BitField;
function BitFieldClass() {
  var names = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    names[_i] = arguments[_i];
  }
  var Bits = (function (_super) {
    __extends$j(Bits, _super);
    function Bits() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    return Bits;
  })(BitField);
  Bits.allocate.apply(Bits, __spreadArray$3([], __read$8(names), false));
  return Bits;
}
BitField$1.BitFieldClass = BitFieldClass;

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.AbstractMathDocument = exports.resetAllOptions = exports.resetOptions = exports.RenderList = void 0;
  var Options_js_1 = Options;
  var InputJax_js_1 = InputJax;
  var OutputJax_js_1 = OutputJax;
  var MathList_js_1 = MathList;
  var MathItem_js_1 = MathItem;
  var MmlFactory_js_1 = MmlFactory$1;
  var BitField_js_1 = BitField$1;
  var PrioritizedList_js_1 = PrioritizedList$1;
  var RenderList = (function (_super) {
    __extends(RenderList, _super);
    function RenderList() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    RenderList.create = function (actions) {
      var e_1, _a;
      var list = new this();
      try {
        for (var _b = __values(Object.keys(actions)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var id = _c.value;
          var _d = __read(this.action(id, actions[id]), 2), action = _d[0], priority = _d[1];
          if (priority) {
            list.add(action, priority);
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return list;
    };
    RenderList.action = function (id, action) {
      var _a, _b, _c, _d;
      var renderDoc, renderMath;
      var convert = true;
      var priority = action[0];
      if (action.length === 1 || typeof action[1] === 'boolean') {
        action.length === 2 && (convert = action[1]);
        (_a = __read(this.methodActions(id), 2), renderDoc = _a[0], renderMath = _a[1]);
      } else if (typeof action[1] === 'string') {
        if (typeof action[2] === 'string') {
          action.length === 4 && (convert = action[3]);
          var _e = __read(action.slice(1), 2), method1 = _e[0], method2 = _e[1];
          (_b = __read(this.methodActions(method1, method2), 2), renderDoc = _b[0], renderMath = _b[1]);
        } else {
          action.length === 3 && (convert = action[2]);
          (_c = __read(this.methodActions(action[1]), 2), renderDoc = _c[0], renderMath = _c[1]);
        }
      } else {
        action.length === 4 && (convert = action[3]);
        (_d = __read(action.slice(1), 2), renderDoc = _d[0], renderMath = _d[1]);
      }
      return [{
        id: id,
        renderDoc: renderDoc,
        renderMath: renderMath,
        convert: convert
      }, priority];
    };
    RenderList.methodActions = function (method1, method2) {
      if (method2 === void 0) {
        method2 = method1;
      }
      return [function (document) {
        method1 && document[method1]();
        return false;
      }, function (math, document) {
        method2 && math[method2](document);
        return false;
      }];
    };
    RenderList.prototype.renderDoc = function (document, start) {
      var e_2, _a;
      if (start === void 0) {
        start = MathItem_js_1.STATE.UNPROCESSED;
      }
      try {
        for (var _b = __values(this.items), _c = _b.next(); !_c.done; _c = _b.next()) {
          var item = _c.value;
          if (item.priority >= start) {
            if (item.item.renderDoc(document)) return;
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    };
    RenderList.prototype.renderMath = function (math, document, start) {
      var e_3, _a;
      if (start === void 0) {
        start = MathItem_js_1.STATE.UNPROCESSED;
      }
      try {
        for (var _b = __values(this.items), _c = _b.next(); !_c.done; _c = _b.next()) {
          var item = _c.value;
          if (item.priority >= start) {
            if (item.item.renderMath(math, document)) return;
          }
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
    };
    RenderList.prototype.renderConvert = function (math, document, end) {
      var e_4, _a;
      if (end === void 0) {
        end = MathItem_js_1.STATE.LAST;
      }
      try {
        for (var _b = __values(this.items), _c = _b.next(); !_c.done; _c = _b.next()) {
          var item = _c.value;
          if (item.priority > end) return;
          if (item.item.convert) {
            if (item.item.renderMath(math, document)) return;
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_4) throw e_4.error;
        }
      }
    };
    RenderList.prototype.findID = function (id) {
      var e_5, _a;
      try {
        for (var _b = __values(this.items), _c = _b.next(); !_c.done; _c = _b.next()) {
          var item = _c.value;
          if (item.item.id === id) {
            return item.item;
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_5) throw e_5.error;
        }
      }
      return null;
    };
    return RenderList;
  })(PrioritizedList_js_1.PrioritizedList);
  exports.RenderList = RenderList;
  exports.resetOptions = {
    all: false,
    processed: false,
    inputJax: null,
    outputJax: null
  };
  exports.resetAllOptions = {
    all: true,
    processed: true,
    inputJax: [],
    outputJax: []
  };
  var DefaultInputJax = (function (_super) {
    __extends(DefaultInputJax, _super);
    function DefaultInputJax() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultInputJax.prototype.compile = function (_math) {
      return null;
    };
    return DefaultInputJax;
  })(InputJax_js_1.AbstractInputJax);
  var DefaultOutputJax = (function (_super) {
    __extends(DefaultOutputJax, _super);
    function DefaultOutputJax() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultOutputJax.prototype.typeset = function (_math, _document) {
      return null;
    };
    DefaultOutputJax.prototype.escaped = function (_math, _document) {
      return null;
    };
    return DefaultOutputJax;
  })(OutputJax_js_1.AbstractOutputJax);
  var DefaultMathList = (function (_super) {
    __extends(DefaultMathList, _super);
    function DefaultMathList() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    return DefaultMathList;
  })(MathList_js_1.AbstractMathList);
  var DefaultMathItem = (function (_super) {
    __extends(DefaultMathItem, _super);
    function DefaultMathItem() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    return DefaultMathItem;
  })(MathItem_js_1.AbstractMathItem);
  var AbstractMathDocument = (function () {
    function AbstractMathDocument(document, adaptor, options) {
      var _this = this;
      var CLASS = this.constructor;
      this.document = document;
      this.options = (0, Options_js_1.userOptions)((0, Options_js_1.defaultOptions)({}, CLASS.OPTIONS), options);
      this.math = new (this.options['MathList'] || DefaultMathList)();
      this.renderActions = RenderList.create(this.options['renderActions']);
      this.processed = new AbstractMathDocument.ProcessBits();
      this.outputJax = this.options['OutputJax'] || new DefaultOutputJax();
      var inputJax = this.options['InputJax'] || [new DefaultInputJax()];
      if (!Array.isArray(inputJax)) {
        inputJax = [inputJax];
      }
      this.inputJax = inputJax;
      this.adaptor = adaptor;
      this.outputJax.setAdaptor(adaptor);
      this.inputJax.map(function (jax) {
        return jax.setAdaptor(adaptor);
      });
      this.mmlFactory = this.options['MmlFactory'] || new MmlFactory_js_1.MmlFactory();
      this.inputJax.map(function (jax) {
        return jax.setMmlFactory(_this.mmlFactory);
      });
      this.outputJax.initialize();
      this.inputJax.map(function (jax) {
        return jax.initialize();
      });
    }
    Object.defineProperty(AbstractMathDocument.prototype, "kind", {
      get: function () {
        return this.constructor.KIND;
      },
      enumerable: false,
      configurable: true
    });
    AbstractMathDocument.prototype.addRenderAction = function (id) {
      var action = [];
      for (var _i = 1; _i < arguments.length; _i++) {
        action[_i - 1] = arguments[_i];
      }
      var _a = __read(RenderList.action(id, action), 2), fn = _a[0], p = _a[1];
      this.renderActions.add(fn, p);
    };
    AbstractMathDocument.prototype.removeRenderAction = function (id) {
      var action = this.renderActions.findID(id);
      if (action) {
        this.renderActions.remove(action);
      }
    };
    AbstractMathDocument.prototype.render = function () {
      this.renderActions.renderDoc(this);
      return this;
    };
    AbstractMathDocument.prototype.rerender = function (start) {
      if (start === void 0) {
        start = MathItem_js_1.STATE.RERENDER;
      }
      this.state(start - 1);
      this.render();
      return this;
    };
    AbstractMathDocument.prototype.convert = function (math, options) {
      if (options === void 0) {
        options = {};
      }
      var _a = (0, Options_js_1.userOptions)({
        format: this.inputJax[0].name,
        display: true,
        end: MathItem_js_1.STATE.LAST,
        em: 16,
        ex: 8,
        containerWidth: null,
        lineWidth: 1000000,
        scale: 1,
        family: ''
      }, options), format = _a.format, display = _a.display, end = _a.end, ex = _a.ex, em = _a.em, containerWidth = _a.containerWidth, lineWidth = _a.lineWidth, scale = _a.scale, family = _a.family;
      if (containerWidth === null) {
        containerWidth = 80 * ex;
      }
      var jax = this.inputJax.reduce(function (jax, ijax) {
        return ijax.name === format ? ijax : jax;
      }, null);
      var mitem = new this.options.MathItem(math, jax, display);
      mitem.start.node = this.adaptor.body(this.document);
      mitem.setMetrics(em, ex, containerWidth, lineWidth, scale);
      if (this.outputJax.options.mtextInheritFont) {
        mitem.outputData.mtextFamily = family;
      }
      if (this.outputJax.options.merrorInheritFont) {
        mitem.outputData.merrorFamily = family;
      }
      mitem.convert(this, end);
      return mitem.typesetRoot || mitem.root;
    };
    AbstractMathDocument.prototype.findMath = function (_options) {
      this.processed.set('findMath');
      return this;
    };
    AbstractMathDocument.prototype.compile = function () {
      var e_6, _a, e_7, _b;
      if (!this.processed.isSet('compile')) {
        var recompile = [];
        try {
          for (var _c = __values(this.math), _d = _c.next(); !_d.done; _d = _c.next()) {
            var math = _d.value;
            this.compileMath(math);
            if (math.inputData.recompile !== undefined) {
              recompile.push(math);
            }
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
          } finally {
            if (e_6) throw e_6.error;
          }
        }
        try {
          for (var recompile_1 = __values(recompile), recompile_1_1 = recompile_1.next(); !recompile_1_1.done; recompile_1_1 = recompile_1.next()) {
            var math = recompile_1_1.value;
            var data = math.inputData.recompile;
            math.state(data.state);
            math.inputData.recompile = data;
            this.compileMath(math);
          }
        } catch (e_7_1) {
          e_7 = {
            error: e_7_1
          };
        } finally {
          try {
            if (recompile_1_1 && !recompile_1_1.done && (_b = recompile_1.return)) _b.call(recompile_1);
          } finally {
            if (e_7) throw e_7.error;
          }
        }
        this.processed.set('compile');
      }
      return this;
    };
    AbstractMathDocument.prototype.compileMath = function (math) {
      try {
        math.compile(this);
      } catch (err) {
        if (err.retry || err.restart) {
          throw err;
        }
        this.options['compileError'](this, math, err);
        math.inputData['error'] = err;
      }
    };
    AbstractMathDocument.prototype.compileError = function (math, err) {
      math.root = this.mmlFactory.create('math', null, [this.mmlFactory.create('merror', {
        'data-mjx-error': err.message,
        title: err.message
      }, [this.mmlFactory.create('mtext', null, [this.mmlFactory.create('text').setText('Math input error')])])]);
      if (math.display) {
        math.root.attributes.set('display', 'block');
      }
      math.inputData.error = err.message;
    };
    AbstractMathDocument.prototype.typeset = function () {
      var e_8, _a;
      if (!this.processed.isSet('typeset')) {
        try {
          for (var _b = __values(this.math), _c = _b.next(); !_c.done; _c = _b.next()) {
            var math = _c.value;
            try {
              math.typeset(this);
            } catch (err) {
              if (err.retry || err.restart) {
                throw err;
              }
              this.options['typesetError'](this, math, err);
              math.outputData['error'] = err;
            }
          }
        } catch (e_8_1) {
          e_8 = {
            error: e_8_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_8) throw e_8.error;
          }
        }
        this.processed.set('typeset');
      }
      return this;
    };
    AbstractMathDocument.prototype.typesetError = function (math, err) {
      math.typesetRoot = this.adaptor.node('mjx-container', {
        class: 'MathJax mjx-output-error',
        jax: this.outputJax.name
      }, [this.adaptor.node('span', {
        'data-mjx-error': err.message,
        title: err.message,
        style: {
          color: 'red',
          'background-color': 'yellow',
          'line-height': 'normal'
        }
      }, [this.adaptor.text('Math output error')])]);
      if (math.display) {
        this.adaptor.setAttributes(math.typesetRoot, {
          style: {
            display: 'block',
            margin: '1em 0',
            'text-align': 'center'
          }
        });
      }
      math.outputData.error = err.message;
    };
    AbstractMathDocument.prototype.getMetrics = function () {
      if (!this.processed.isSet('getMetrics')) {
        this.outputJax.getMetrics(this);
        this.processed.set('getMetrics');
      }
      return this;
    };
    AbstractMathDocument.prototype.updateDocument = function () {
      var e_9, _a;
      if (!this.processed.isSet('updateDocument')) {
        try {
          for (var _b = __values(this.math.reversed()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var math = _c.value;
            math.updateDocument(this);
          }
        } catch (e_9_1) {
          e_9 = {
            error: e_9_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
          } finally {
            if (e_9) throw e_9.error;
          }
        }
        this.processed.set('updateDocument');
      }
      return this;
    };
    AbstractMathDocument.prototype.removeFromDocument = function (_restore) {
      return this;
    };
    AbstractMathDocument.prototype.state = function (state, restore) {
      var e_10, _a;
      if (restore === void 0) {
        restore = false;
      }
      try {
        for (var _b = __values(this.math), _c = _b.next(); !_c.done; _c = _b.next()) {
          var math = _c.value;
          math.state(state, restore);
        }
      } catch (e_10_1) {
        e_10 = {
          error: e_10_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_10) throw e_10.error;
        }
      }
      if (state < MathItem_js_1.STATE.INSERTED) {
        this.processed.clear('updateDocument');
      }
      if (state < MathItem_js_1.STATE.TYPESET) {
        this.processed.clear('typeset');
        this.processed.clear('getMetrics');
      }
      if (state < MathItem_js_1.STATE.COMPILED) {
        this.processed.clear('compile');
      }
      return this;
    };
    AbstractMathDocument.prototype.reset = function (options) {
      var _a;
      if (options === void 0) {
        options = {
          processed: true
        };
      }
      options = (0, Options_js_1.userOptions)(Object.assign({}, exports.resetOptions), options);
      options.all && Object.assign(options, exports.resetAllOptions);
      options.processed && this.processed.reset();
      options.inputJax && this.inputJax.forEach(function (jax) {
        return jax.reset.apply(jax, __spreadArray([], __read(options.inputJax), false));
      });
      options.outputJax && (_a = this.outputJax).reset.apply(_a, __spreadArray([], __read(options.outputJax), false));
      return this;
    };
    AbstractMathDocument.prototype.clear = function () {
      this.reset();
      this.math.clear();
      return this;
    };
    AbstractMathDocument.prototype.concat = function (list) {
      this.math.merge(list);
      return this;
    };
    AbstractMathDocument.prototype.clearMathItemsWithin = function (containers) {
      var _a;
      var items = this.getMathItemsWithin(containers);
      (_a = this.math).remove.apply(_a, __spreadArray([], __read(items), false));
      return items;
    };
    AbstractMathDocument.prototype.getMathItemsWithin = function (elements) {
      var e_11, _a, e_12, _b;
      if (!Array.isArray(elements)) {
        elements = [elements];
      }
      var adaptor = this.adaptor;
      var items = [];
      var containers = adaptor.getElements(elements, this.document);
      try {
        ITEMS: for (var _c = __values(this.math), _d = _c.next(); !_d.done; _d = _c.next()) {
          var item = _d.value;
          try {
            for (var containers_1 = (e_12 = void 0, __values(containers)), containers_1_1 = containers_1.next(); !containers_1_1.done; containers_1_1 = containers_1.next()) {
              var container = containers_1_1.value;
              if (item.start.node && adaptor.contains(container, item.start.node)) {
                items.push(item);
                continue ITEMS;
              }
            }
          } catch (e_12_1) {
            e_12 = {
              error: e_12_1
            };
          } finally {
            try {
              if (containers_1_1 && !containers_1_1.done && (_b = containers_1.return)) _b.call(containers_1);
            } finally {
              if (e_12) throw e_12.error;
            }
          }
        }
      } catch (e_11_1) {
        e_11 = {
          error: e_11_1
        };
      } finally {
        try {
          if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        } finally {
          if (e_11) throw e_11.error;
        }
      }
      return items;
    };
    AbstractMathDocument.KIND = 'MathDocument';
    AbstractMathDocument.OPTIONS = {
      OutputJax: null,
      InputJax: null,
      MmlFactory: null,
      MathList: DefaultMathList,
      MathItem: DefaultMathItem,
      compileError: function (doc, math, err) {
        doc.compileError(math, err);
      },
      typesetError: function (doc, math, err) {
        doc.typesetError(math, err);
      },
      renderActions: (0, Options_js_1.expandable)({
        find: [MathItem_js_1.STATE.FINDMATH, 'findMath', '', false],
        compile: [MathItem_js_1.STATE.COMPILED],
        metrics: [MathItem_js_1.STATE.METRICS, 'getMetrics', '', false],
        typeset: [MathItem_js_1.STATE.TYPESET],
        update: [MathItem_js_1.STATE.INSERTED, 'updateDocument', false]
      })
    };
    AbstractMathDocument.ProcessBits = (0, BitField_js_1.BitFieldClass)('findMath', 'compile', 'getMetrics', 'typeset', 'updateDocument');
    return AbstractMathDocument;
  })();
  exports.AbstractMathDocument = AbstractMathDocument;
})(MathDocument);
getDefaultExportFromCjs(MathDocument);

var __extends$i = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(Handler, "__esModule", {
  value: true
});
Handler.AbstractHandler = void 0;
var MathDocument_js_1$1 = MathDocument;
var DefaultMathDocument = (function (_super) {
  __extends$i(DefaultMathDocument, _super);
  function DefaultMathDocument() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return DefaultMathDocument;
})(MathDocument_js_1$1.AbstractMathDocument);
var AbstractHandler = (function () {
  function AbstractHandler(adaptor, priority) {
    if (priority === void 0) {
      priority = 5;
    }
    this.documentClass = DefaultMathDocument;
    this.adaptor = adaptor;
    this.priority = priority;
  }
  Object.defineProperty(AbstractHandler.prototype, "name", {
    get: function () {
      return this.constructor.NAME;
    },
    enumerable: false,
    configurable: true
  });
  AbstractHandler.prototype.handlesDocument = function (_document) {
    return false;
  };
  AbstractHandler.prototype.create = function (document, options) {
    return new this.documentClass(document, this.adaptor, options);
  };
  AbstractHandler.NAME = 'generic';
  return AbstractHandler;
})();
Handler.AbstractHandler = AbstractHandler;

var HTMLDocument$1 = {};

var HTMLMathItem$1 = {};

var __extends$h = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(HTMLMathItem$1, "__esModule", {
  value: true
});
HTMLMathItem$1.HTMLMathItem = void 0;
var MathItem_js_1$1 = MathItem;
var HTMLMathItem = (function (_super) {
  __extends$h(HTMLMathItem, _super);
  function HTMLMathItem(math, jax, display, start, end) {
    if (display === void 0) {
      display = true;
    }
    if (start === void 0) {
      start = {
        node: null,
        n: 0,
        delim: ''
      };
    }
    if (end === void 0) {
      end = {
        node: null,
        n: 0,
        delim: ''
      };
    }
    return _super.call(this, math, jax, display, start, end) || this;
  }
  Object.defineProperty(HTMLMathItem.prototype, "adaptor", {
    get: function () {
      return this.inputJax.adaptor;
    },
    enumerable: false,
    configurable: true
  });
  HTMLMathItem.prototype.updateDocument = function (_html) {
    if (this.state() < MathItem_js_1$1.STATE.INSERTED) {
      if (this.inputJax.processStrings) {
        var node = this.start.node;
        if (node === this.end.node) {
          if (this.end.n && this.end.n < this.adaptor.value(this.end.node).length) {
            this.adaptor.split(this.end.node, this.end.n);
          }
          if (this.start.n) {
            node = this.adaptor.split(this.start.node, this.start.n);
          }
          this.adaptor.replace(this.typesetRoot, node);
        } else {
          if (this.start.n) {
            node = this.adaptor.split(node, this.start.n);
          }
          while (node !== this.end.node) {
            var next = this.adaptor.next(node);
            this.adaptor.remove(node);
            node = next;
          }
          this.adaptor.insert(this.typesetRoot, node);
          if (this.end.n < this.adaptor.value(node).length) {
            this.adaptor.split(node, this.end.n);
          }
          this.adaptor.remove(node);
        }
      } else {
        this.adaptor.replace(this.typesetRoot, this.start.node);
      }
      this.start.node = this.end.node = this.typesetRoot;
      this.start.n = this.end.n = 0;
      this.state(MathItem_js_1$1.STATE.INSERTED);
    }
  };
  HTMLMathItem.prototype.updateStyleSheet = function (document) {
    document.addStyleSheet();
  };
  HTMLMathItem.prototype.removeFromDocument = function (restore) {
    if (restore === void 0) {
      restore = false;
    }
    if (this.state() >= MathItem_js_1$1.STATE.TYPESET) {
      var adaptor = this.adaptor;
      var node = this.start.node;
      var math = adaptor.text('');
      if (restore) {
        var text = this.start.delim + this.math + this.end.delim;
        if (this.inputJax.processStrings) {
          math = adaptor.text(text);
        } else {
          var doc = adaptor.parse(text, 'text/html');
          math = adaptor.firstChild(adaptor.body(doc));
        }
      }
      if (adaptor.parent(node)) {
        adaptor.replace(math, node);
      }
      this.start.node = this.end.node = math;
      this.start.n = this.end.n = 0;
    }
  };
  return HTMLMathItem;
})(MathItem_js_1$1.AbstractMathItem);
HTMLMathItem$1.HTMLMathItem = HTMLMathItem;

var HTMLMathList$1 = {};

var __extends$g = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(HTMLMathList$1, "__esModule", {
  value: true
});
HTMLMathList$1.HTMLMathList = void 0;
var MathList_js_1 = MathList;
var HTMLMathList = (function (_super) {
  __extends$g(HTMLMathList, _super);
  function HTMLMathList() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return HTMLMathList;
})(MathList_js_1.AbstractMathList);
HTMLMathList$1.HTMLMathList = HTMLMathList;

var HTMLDomStrings$1 = {};

var __read$7 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
Object.defineProperty(HTMLDomStrings$1, "__esModule", {
  value: true
});
HTMLDomStrings$1.HTMLDomStrings = void 0;
var Options_js_1$3 = Options;
var HTMLDomStrings = (function () {
  function HTMLDomStrings(options) {
    if (options === void 0) {
      options = null;
    }
    var CLASS = this.constructor;
    this.options = (0, Options_js_1$3.userOptions)((0, Options_js_1$3.defaultOptions)({}, CLASS.OPTIONS), options);
    this.init();
    this.getPatterns();
  }
  HTMLDomStrings.prototype.init = function () {
    this.strings = [];
    this.string = '';
    this.snodes = [];
    this.nodes = [];
    this.stack = [];
  };
  HTMLDomStrings.prototype.getPatterns = function () {
    var skip = (0, Options_js_1$3.makeArray)(this.options['skipHtmlTags']);
    var ignore = (0, Options_js_1$3.makeArray)(this.options['ignoreHtmlClass']);
    var process = (0, Options_js_1$3.makeArray)(this.options['processHtmlClass']);
    this.skipHtmlTags = new RegExp('^(?:' + skip.join('|') + ')$', 'i');
    this.ignoreHtmlClass = new RegExp('(?:^| )(?:' + ignore.join('|') + ')(?: |$)');
    this.processHtmlClass = new RegExp('(?:^| )(?:' + process + ')(?: |$)');
  };
  HTMLDomStrings.prototype.pushString = function () {
    if (this.string.match(/\S/)) {
      this.strings.push(this.string);
      this.nodes.push(this.snodes);
    }
    this.string = '';
    this.snodes = [];
  };
  HTMLDomStrings.prototype.extendString = function (node, text) {
    this.snodes.push([node, text.length]);
    this.string += text;
  };
  HTMLDomStrings.prototype.handleText = function (node, ignore) {
    if (!ignore) {
      this.extendString(node, this.adaptor.value(node));
    }
    return this.adaptor.next(node);
  };
  HTMLDomStrings.prototype.handleTag = function (node, ignore) {
    if (!ignore) {
      var text = this.options['includeHtmlTags'][this.adaptor.kind(node)];
      this.extendString(node, text);
    }
    return this.adaptor.next(node);
  };
  HTMLDomStrings.prototype.handleContainer = function (node, ignore) {
    this.pushString();
    var cname = this.adaptor.getAttribute(node, 'class') || '';
    var tname = this.adaptor.kind(node) || '';
    var process = this.processHtmlClass.exec(cname);
    var next = node;
    if (this.adaptor.firstChild(node) && !this.adaptor.getAttribute(node, 'data-MJX') && (process || !this.skipHtmlTags.exec(tname))) {
      if (this.adaptor.next(node)) {
        this.stack.push([this.adaptor.next(node), ignore]);
      }
      next = this.adaptor.firstChild(node);
      ignore = (ignore || this.ignoreHtmlClass.exec(cname)) && !process;
    } else {
      next = this.adaptor.next(node);
    }
    return [next, ignore];
  };
  HTMLDomStrings.prototype.handleOther = function (node, _ignore) {
    this.pushString();
    return this.adaptor.next(node);
  };
  HTMLDomStrings.prototype.find = function (node) {
    var _a, _b;
    this.init();
    var stop = this.adaptor.next(node);
    var ignore = false;
    var include = this.options['includeHtmlTags'];
    while (node && node !== stop) {
      var kind = this.adaptor.kind(node);
      if (kind === '#text') {
        node = this.handleText(node, ignore);
      } else if (include.hasOwnProperty(kind)) {
        node = this.handleTag(node, ignore);
      } else if (kind) {
        (_a = __read$7(this.handleContainer(node, ignore), 2), node = _a[0], ignore = _a[1]);
      } else {
        node = this.handleOther(node, ignore);
      }
      if (!node && this.stack.length) {
        this.pushString();
        (_b = __read$7(this.stack.pop(), 2), node = _b[0], ignore = _b[1]);
      }
    }
    this.pushString();
    var result = [this.strings, this.nodes];
    this.init();
    return result;
  };
  HTMLDomStrings.OPTIONS = {
    skipHtmlTags: ['script', 'noscript', 'style', 'textarea', 'pre', 'code', 'annotation', 'annotation-xml'],
    includeHtmlTags: {
      br: '\n',
      wbr: '',
      '#comment': ''
    },
    ignoreHtmlClass: 'mathjax_ignore',
    processHtmlClass: 'mathjax_process'
  };
  return HTMLDomStrings;
})();
HTMLDomStrings$1.HTMLDomStrings = HTMLDomStrings;

var __extends$f = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign$1 = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign$1 = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign$1.apply(this, arguments);
});
var __read$6 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __values$9 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(HTMLDocument$1, "__esModule", {
  value: true
});
HTMLDocument$1.HTMLDocument = void 0;
var MathDocument_js_1 = MathDocument;
var Options_js_1$2 = Options;
var HTMLMathItem_js_1 = HTMLMathItem$1;
var HTMLMathList_js_1 = HTMLMathList$1;
var HTMLDomStrings_js_1 = HTMLDomStrings$1;
var MathItem_js_1 = MathItem;
var HTMLDocument = (function (_super) {
  __extends$f(HTMLDocument, _super);
  function HTMLDocument(document, adaptor, options) {
    var _this = this;
    var _a = __read$6((0, Options_js_1$2.separateOptions)(options, HTMLDomStrings_js_1.HTMLDomStrings.OPTIONS), 2), html = _a[0], dom = _a[1];
    _this = _super.call(this, document, adaptor, html) || this;
    _this.domStrings = _this.options['DomStrings'] || new HTMLDomStrings_js_1.HTMLDomStrings(dom);
    _this.domStrings.adaptor = adaptor;
    _this.styles = [];
    return _this;
  }
  HTMLDocument.prototype.findPosition = function (N, index, delim, nodes) {
    var e_1, _a;
    var adaptor = this.adaptor;
    try {
      for (var _b = __values$9(nodes[N]), _c = _b.next(); !_c.done; _c = _b.next()) {
        var list = _c.value;
        var _d = __read$6(list, 2), node = _d[0], n = _d[1];
        if (index <= n && adaptor.kind(node) === '#text') {
          return {
            node: node,
            n: Math.max(index, 0),
            delim: delim
          };
        }
        index -= n;
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return {
      node: null,
      n: 0,
      delim: delim
    };
  };
  HTMLDocument.prototype.mathItem = function (item, jax, nodes) {
    var math = item.math;
    var start = this.findPosition(item.n, item.start.n, item.open, nodes);
    var end = this.findPosition(item.n, item.end.n, item.close, nodes);
    return new this.options.MathItem(math, jax, item.display, start, end);
  };
  HTMLDocument.prototype.findMath = function (options) {
    var e_2, _a, e_3, _b, _c, e_4, _d, e_5, _e;
    if (!this.processed.isSet('findMath')) {
      this.adaptor.document = this.document;
      options = (0, Options_js_1$2.userOptions)({
        elements: this.options.elements || [this.adaptor.body(this.document)]
      }, options);
      try {
        for (var _f = __values$9(this.adaptor.getElements(options['elements'], this.document)), _g = _f.next(); !_g.done; _g = _f.next()) {
          var container = _g.value;
          var _h = __read$6([null, null], 2), strings = _h[0], nodes = _h[1];
          try {
            for (var _j = (e_3 = void 0, __values$9(this.inputJax)), _k = _j.next(); !_k.done; _k = _j.next()) {
              var jax = _k.value;
              var list = new this.options['MathList']();
              if (jax.processStrings) {
                if (strings === null) {
                  (_c = __read$6(this.domStrings.find(container), 2), strings = _c[0], nodes = _c[1]);
                }
                try {
                  for (var _l = (e_4 = void 0, __values$9(jax.findMath(strings))), _m = _l.next(); !_m.done; _m = _l.next()) {
                    var math = _m.value;
                    list.push(this.mathItem(math, jax, nodes));
                  }
                } catch (e_4_1) {
                  e_4 = {
                    error: e_4_1
                  };
                } finally {
                  try {
                    if (_m && !_m.done && (_d = _l.return)) _d.call(_l);
                  } finally {
                    if (e_4) throw e_4.error;
                  }
                }
              } else {
                try {
                  for (var _o = (e_5 = void 0, __values$9(jax.findMath(container))), _p = _o.next(); !_p.done; _p = _o.next()) {
                    var math = _p.value;
                    var item = new this.options.MathItem(math.math, jax, math.display, math.start, math.end);
                    list.push(item);
                  }
                } catch (e_5_1) {
                  e_5 = {
                    error: e_5_1
                  };
                } finally {
                  try {
                    if (_p && !_p.done && (_e = _o.return)) _e.call(_o);
                  } finally {
                    if (e_5) throw e_5.error;
                  }
                }
              }
              this.math.merge(list);
            }
          } catch (e_3_1) {
            e_3 = {
              error: e_3_1
            };
          } finally {
            try {
              if (_k && !_k.done && (_b = _j.return)) _b.call(_j);
            } finally {
              if (e_3) throw e_3.error;
            }
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_g && !_g.done && (_a = _f.return)) _a.call(_f);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      this.processed.set('findMath');
    }
    return this;
  };
  HTMLDocument.prototype.updateDocument = function () {
    if (!this.processed.isSet('updateDocument')) {
      this.addPageElements();
      this.addStyleSheet();
      _super.prototype.updateDocument.call(this);
      this.processed.set('updateDocument');
    }
    return this;
  };
  HTMLDocument.prototype.addPageElements = function () {
    var body = this.adaptor.body(this.document);
    var node = this.documentPageElements();
    if (node) {
      this.adaptor.append(body, node);
    }
  };
  HTMLDocument.prototype.addStyleSheet = function () {
    var sheet = this.documentStyleSheet();
    var adaptor = this.adaptor;
    if (sheet && !adaptor.parent(sheet)) {
      var head = adaptor.head(this.document);
      var styles = this.findSheet(head, adaptor.getAttribute(sheet, 'id'));
      if (styles) {
        adaptor.replace(sheet, styles);
      } else {
        adaptor.append(head, sheet);
      }
    }
  };
  HTMLDocument.prototype.findSheet = function (head, id) {
    var e_6, _a;
    if (id) {
      try {
        for (var _b = __values$9(this.adaptor.tags(head, 'style')), _c = _b.next(); !_c.done; _c = _b.next()) {
          var sheet = _c.value;
          if (this.adaptor.getAttribute(sheet, 'id') === id) {
            return sheet;
          }
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_6) throw e_6.error;
        }
      }
    }
    return null;
  };
  HTMLDocument.prototype.removeFromDocument = function (restore) {
    var e_7, _a;
    if (restore === void 0) {
      restore = false;
    }
    if (this.processed.isSet('updateDocument')) {
      try {
        for (var _b = __values$9(this.math), _c = _b.next(); !_c.done; _c = _b.next()) {
          var math = _c.value;
          if (math.state() >= MathItem_js_1.STATE.INSERTED) {
            math.state(MathItem_js_1.STATE.TYPESET, restore);
          }
        }
      } catch (e_7_1) {
        e_7 = {
          error: e_7_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_7) throw e_7.error;
        }
      }
    }
    this.processed.clear('updateDocument');
    return this;
  };
  HTMLDocument.prototype.documentStyleSheet = function () {
    return this.outputJax.styleSheet(this);
  };
  HTMLDocument.prototype.documentPageElements = function () {
    return this.outputJax.pageElements(this);
  };
  HTMLDocument.prototype.addStyles = function (styles) {
    this.styles.push(styles);
  };
  HTMLDocument.prototype.getStyles = function () {
    return this.styles;
  };
  HTMLDocument.KIND = 'HTML';
  HTMLDocument.OPTIONS = __assign$1(__assign$1({}, MathDocument_js_1.AbstractMathDocument.OPTIONS), {
    renderActions: (0, Options_js_1$2.expandable)(__assign$1(__assign$1({}, MathDocument_js_1.AbstractMathDocument.OPTIONS.renderActions), {
      styles: [MathItem_js_1.STATE.INSERTED + 1, '', 'updateStyleSheet', false]
    })),
    MathList: HTMLMathList_js_1.HTMLMathList,
    MathItem: HTMLMathItem_js_1.HTMLMathItem,
    DomStrings: null
  });
  return HTMLDocument;
})(MathDocument_js_1.AbstractMathDocument);
HTMLDocument$1.HTMLDocument = HTMLDocument;

var __extends$e = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(HTMLHandler$1, "__esModule", {
  value: true
});
HTMLHandler$1.HTMLHandler = void 0;
var Handler_js_1 = Handler;
var HTMLDocument_js_1 = HTMLDocument$1;
var HTMLHandler = (function (_super) {
  __extends$e(HTMLHandler, _super);
  function HTMLHandler() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.documentClass = HTMLDocument_js_1.HTMLDocument;
    return _this;
  }
  HTMLHandler.prototype.handlesDocument = function (document) {
    var adaptor = this.adaptor;
    if (typeof document === 'string') {
      try {
        document = adaptor.parse(document, 'text/html');
      } catch (err) {}
    }
    if (document instanceof adaptor.window.Document || document instanceof adaptor.window.HTMLElement || document instanceof adaptor.window.DocumentFragment) {
      return true;
    }
    return false;
  };
  HTMLHandler.prototype.create = function (document, options) {
    var adaptor = this.adaptor;
    if (typeof document === 'string') {
      document = adaptor.parse(document, 'text/html');
    } else if (document instanceof adaptor.window.HTMLElement || document instanceof adaptor.window.DocumentFragment) {
      var child = document;
      document = adaptor.parse('', 'text/html');
      adaptor.append(adaptor.body(document), child);
    }
    return _super.prototype.create.call(this, document, options);
  };
  return HTMLHandler;
})(Handler_js_1.AbstractHandler);
HTMLHandler$1.HTMLHandler = HTMLHandler;

Object.defineProperty(html, "__esModule", {
  value: true
});
var RegisterHTMLHandler_1 = html.RegisterHTMLHandler = void 0;
var mathjax_js_1 = mathjax;
var HTMLHandler_js_1 = HTMLHandler$1;
function RegisterHTMLHandler(adaptor) {
  var handler = new HTMLHandler_js_1.HTMLHandler(adaptor);
  mathjax_js_1.mathjax.handlers.register(handler);
  return handler;
}
RegisterHTMLHandler_1 = html.RegisterHTMLHandler = RegisterHTMLHandler;

var browserAdaptor$1 = {};

var HTMLAdaptor$1 = {};

var DOMAdaptor = {};

var __values$8 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(DOMAdaptor, "__esModule", {
  value: true
});
DOMAdaptor.AbstractDOMAdaptor = void 0;
var AbstractDOMAdaptor = (function () {
  function AbstractDOMAdaptor(document) {
    if (document === void 0) {
      document = null;
    }
    this.document = document;
  }
  AbstractDOMAdaptor.prototype.node = function (kind, def, children, ns) {
    var e_1, _a;
    if (def === void 0) {
      def = {};
    }
    if (children === void 0) {
      children = [];
    }
    var node = this.create(kind, ns);
    this.setAttributes(node, def);
    try {
      for (var children_1 = __values$8(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
        var child = children_1_1.value;
        this.append(node, child);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return node;
  };
  AbstractDOMAdaptor.prototype.setAttributes = function (node, def) {
    var e_2, _a, e_3, _b, e_4, _c;
    if (def.style && typeof def.style !== 'string') {
      try {
        for (var _d = __values$8(Object.keys(def.style)), _e = _d.next(); !_e.done; _e = _d.next()) {
          var key = _e.value;
          this.setStyle(node, key.replace(/-([a-z])/g, function (_m, c) {
            return c.toUpperCase();
          }), def.style[key]);
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }
    if (def.properties) {
      try {
        for (var _f = __values$8(Object.keys(def.properties)), _g = _f.next(); !_g.done; _g = _f.next()) {
          var key = _g.value;
          node[key] = def.properties[key];
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
    }
    try {
      for (var _h = __values$8(Object.keys(def)), _j = _h.next(); !_j.done; _j = _h.next()) {
        var key = _j.value;
        if ((key !== 'style' || typeof def.style === 'string') && key !== 'properties') {
          this.setAttribute(node, key, def[key]);
        }
      }
    } catch (e_4_1) {
      e_4 = {
        error: e_4_1
      };
    } finally {
      try {
        if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
      } finally {
        if (e_4) throw e_4.error;
      }
    }
  };
  AbstractDOMAdaptor.prototype.replace = function (nnode, onode) {
    this.insert(nnode, onode);
    this.remove(onode);
    return onode;
  };
  AbstractDOMAdaptor.prototype.childNode = function (node, i) {
    return this.childNodes(node)[i];
  };
  AbstractDOMAdaptor.prototype.allClasses = function (node) {
    var classes = this.getAttribute(node, 'class');
    return !classes ? [] : classes.replace(/  +/g, ' ').replace(/^ /, '').replace(/ $/, '').split(/ /);
  };
  return AbstractDOMAdaptor;
})();
DOMAdaptor.AbstractDOMAdaptor = AbstractDOMAdaptor;

var __extends$d = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$7 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(HTMLAdaptor$1, "__esModule", {
  value: true
});
HTMLAdaptor$1.HTMLAdaptor = void 0;
var DOMAdaptor_js_1 = DOMAdaptor;
var HTMLAdaptor = (function (_super) {
  __extends$d(HTMLAdaptor, _super);
  function HTMLAdaptor(window) {
    var _this = _super.call(this, window.document) || this;
    _this.window = window;
    _this.parser = new window.DOMParser();
    return _this;
  }
  HTMLAdaptor.prototype.parse = function (text, format) {
    if (format === void 0) {
      format = 'text/html';
    }
    return this.parser.parseFromString(text, format);
  };
  HTMLAdaptor.prototype.create = function (kind, ns) {
    return ns ? this.document.createElementNS(ns, kind) : this.document.createElement(kind);
  };
  HTMLAdaptor.prototype.text = function (text) {
    return this.document.createTextNode(text);
  };
  HTMLAdaptor.prototype.head = function (doc) {
    return doc.head || doc;
  };
  HTMLAdaptor.prototype.body = function (doc) {
    return doc.body || doc;
  };
  HTMLAdaptor.prototype.root = function (doc) {
    return doc.documentElement || doc;
  };
  HTMLAdaptor.prototype.doctype = function (doc) {
    return doc.doctype ? ("<!DOCTYPE ").concat(doc.doctype.name, ">") : '';
  };
  HTMLAdaptor.prototype.tags = function (node, name, ns) {
    if (ns === void 0) {
      ns = null;
    }
    var nodes = ns ? node.getElementsByTagNameNS(ns, name) : node.getElementsByTagName(name);
    return Array.from(nodes);
  };
  HTMLAdaptor.prototype.getElements = function (nodes, _document) {
    var e_1, _a;
    var containers = [];
    try {
      for (var nodes_1 = __values$7(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
        var node = nodes_1_1.value;
        if (typeof node === 'string') {
          containers = containers.concat(Array.from(this.document.querySelectorAll(node)));
        } else if (Array.isArray(node)) {
          containers = containers.concat(Array.from(node));
        } else if (node instanceof this.window.NodeList || node instanceof this.window.HTMLCollection) {
          containers = containers.concat(Array.from(node));
        } else {
          containers.push(node);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    return containers;
  };
  HTMLAdaptor.prototype.contains = function (container, node) {
    return container.contains(node);
  };
  HTMLAdaptor.prototype.parent = function (node) {
    return node.parentNode;
  };
  HTMLAdaptor.prototype.append = function (node, child) {
    return node.appendChild(child);
  };
  HTMLAdaptor.prototype.insert = function (nchild, ochild) {
    return this.parent(ochild).insertBefore(nchild, ochild);
  };
  HTMLAdaptor.prototype.remove = function (child) {
    return this.parent(child).removeChild(child);
  };
  HTMLAdaptor.prototype.replace = function (nnode, onode) {
    return this.parent(onode).replaceChild(nnode, onode);
  };
  HTMLAdaptor.prototype.clone = function (node) {
    return node.cloneNode(true);
  };
  HTMLAdaptor.prototype.split = function (node, n) {
    return node.splitText(n);
  };
  HTMLAdaptor.prototype.next = function (node) {
    return node.nextSibling;
  };
  HTMLAdaptor.prototype.previous = function (node) {
    return node.previousSibling;
  };
  HTMLAdaptor.prototype.firstChild = function (node) {
    return node.firstChild;
  };
  HTMLAdaptor.prototype.lastChild = function (node) {
    return node.lastChild;
  };
  HTMLAdaptor.prototype.childNodes = function (node) {
    return Array.from(node.childNodes);
  };
  HTMLAdaptor.prototype.childNode = function (node, i) {
    return node.childNodes[i];
  };
  HTMLAdaptor.prototype.kind = function (node) {
    var n = node.nodeType;
    return n === 1 || n === 3 || n === 8 ? node.nodeName.toLowerCase() : '';
  };
  HTMLAdaptor.prototype.value = function (node) {
    return node.nodeValue || '';
  };
  HTMLAdaptor.prototype.textContent = function (node) {
    return node.textContent;
  };
  HTMLAdaptor.prototype.innerHTML = function (node) {
    return node.innerHTML;
  };
  HTMLAdaptor.prototype.outerHTML = function (node) {
    return node.outerHTML;
  };
  HTMLAdaptor.prototype.serializeXML = function (node) {
    var serializer = new this.window.XMLSerializer();
    return serializer.serializeToString(node);
  };
  HTMLAdaptor.prototype.setAttribute = function (node, name, value, ns) {
    if (ns === void 0) {
      ns = null;
    }
    if (!ns) {
      return node.setAttribute(name, value);
    }
    name = ns.replace(/.*\//, '') + ':' + name.replace(/^.*:/, '');
    return node.setAttributeNS(ns, name, value);
  };
  HTMLAdaptor.prototype.getAttribute = function (node, name) {
    return node.getAttribute(name);
  };
  HTMLAdaptor.prototype.removeAttribute = function (node, name) {
    return node.removeAttribute(name);
  };
  HTMLAdaptor.prototype.hasAttribute = function (node, name) {
    return node.hasAttribute(name);
  };
  HTMLAdaptor.prototype.allAttributes = function (node) {
    return Array.from(node.attributes).map(function (x) {
      return {
        name: x.name,
        value: x.value
      };
    });
  };
  HTMLAdaptor.prototype.addClass = function (node, name) {
    if (node.classList) {
      node.classList.add(name);
    } else {
      node.className = (node.className + ' ' + name).trim();
    }
  };
  HTMLAdaptor.prototype.removeClass = function (node, name) {
    if (node.classList) {
      node.classList.remove(name);
    } else {
      node.className = node.className.split(/ /).filter(function (c) {
        return c !== name;
      }).join(' ');
    }
  };
  HTMLAdaptor.prototype.hasClass = function (node, name) {
    if (node.classList) {
      return node.classList.contains(name);
    }
    return node.className.split(/ /).indexOf(name) >= 0;
  };
  HTMLAdaptor.prototype.setStyle = function (node, name, value) {
    node.style[name] = value;
  };
  HTMLAdaptor.prototype.getStyle = function (node, name) {
    return node.style[name];
  };
  HTMLAdaptor.prototype.allStyles = function (node) {
    return node.style.cssText;
  };
  HTMLAdaptor.prototype.insertRules = function (node, rules) {
    var e_2, _a;
    try {
      for (var _b = __values$7(rules.reverse()), _c = _b.next(); !_c.done; _c = _b.next()) {
        var rule = _c.value;
        try {
          node.sheet.insertRule(rule, 0);
        } catch (e) {
          console.warn(("MathJax: can't insert css rule '").concat(rule, "': ").concat(e.message));
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  HTMLAdaptor.prototype.fontSize = function (node) {
    var style = this.window.getComputedStyle(node);
    return parseFloat(style.fontSize);
  };
  HTMLAdaptor.prototype.fontFamily = function (node) {
    var style = this.window.getComputedStyle(node);
    return style.fontFamily || '';
  };
  HTMLAdaptor.prototype.nodeSize = function (node, em, local) {
    if (em === void 0) {
      em = 1;
    }
    if (local === void 0) {
      local = false;
    }
    if (local && node.getBBox) {
      var _a = node.getBBox(), width = _a.width, height = _a.height;
      return [width / em, height / em];
    }
    return [node.offsetWidth / em, node.offsetHeight / em];
  };
  HTMLAdaptor.prototype.nodeBBox = function (node) {
    var _a = node.getBoundingClientRect(), left = _a.left, right = _a.right, top = _a.top, bottom = _a.bottom;
    return {
      left: left,
      right: right,
      top: top,
      bottom: bottom
    };
  };
  return HTMLAdaptor;
})(DOMAdaptor_js_1.AbstractDOMAdaptor);
HTMLAdaptor$1.HTMLAdaptor = HTMLAdaptor;

Object.defineProperty(browserAdaptor$1, "__esModule", {
  value: true
});
var browserAdaptor_2 = browserAdaptor$1.browserAdaptor = void 0;
var HTMLAdaptor_js_1 = HTMLAdaptor$1;
function browserAdaptor() {
  return new HTMLAdaptor_js_1.HTMLAdaptor(window);
}
browserAdaptor_2 = browserAdaptor$1.browserAdaptor = browserAdaptor;

var AllPackages = {};

var ActionConfiguration = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ActionConfiguration = exports.ActionMethods = void 0;
  var Configuration_js_1 = Configuration;
  var TexParser_js_1 = __importDefault(TexParser$1);
  var SymbolMap_js_1 = SymbolMap;
  var BaseMethods_js_1 = __importDefault(BaseMethods$1);
  exports.ActionMethods = {};
  exports.ActionMethods.Macro = BaseMethods_js_1.default.Macro;
  exports.ActionMethods.Toggle = function (parser, name) {
    var children = [];
    var arg;
    while ((arg = parser.GetArgument(name)) !== '\\endtoggle') {
      children.push(new TexParser_js_1.default(arg, parser.stack.env, parser.configuration).mml());
    }
    parser.Push(parser.create('node', 'maction', children, {
      actiontype: 'toggle'
    }));
  };
  exports.ActionMethods.Mathtip = function (parser, name) {
    var arg = parser.ParseArg(name);
    var tip = parser.ParseArg(name);
    parser.Push(parser.create('node', 'maction', [arg, tip], {
      actiontype: 'tooltip'
    }));
  };
  new SymbolMap_js_1.CommandMap('action-macros', {
    toggle: 'Toggle',
    mathtip: 'Mathtip',
    texttip: ['Macro', '\\mathtip{#1}{\\text{#2}}', 2]
  }, exports.ActionMethods);
  exports.ActionConfiguration = Configuration_js_1.Configuration.create('action', {
    handler: {
      macro: ['action-macros']
    }
  });
})(ActionConfiguration);
getDefaultExportFromCjs(ActionConfiguration);

var AmsConfiguration = {};

var AmsItems = {};

var __extends$c = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __assign = commonjsGlobal && commonjsGlobal.__assign || (function () {
  __assign = Object.assign || (function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  });
  return __assign.apply(this, arguments);
});
var __importDefault$x = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(AmsItems, "__esModule", {
  value: true
});
AmsItems.FlalignItem = AmsItems.MultlineItem = void 0;
var BaseItems_js_1$4 = BaseItems;
var ParseUtil_js_1$a = __importDefault$x(ParseUtil$1);
var NodeUtil_js_1$7 = __importDefault$x(NodeUtil$1);
var TexError_js_1$d = __importDefault$x(TexError$1);
var TexConstants_js_1$8 = TexConstants;
var MultlineItem = (function (_super) {
  __extends$c(MultlineItem, _super);
  function MultlineItem(factory) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    var _this = _super.call(this, factory) || this;
    _this.factory.configuration.tags.start('multline', true, args[0]);
    return _this;
  }
  Object.defineProperty(MultlineItem.prototype, "kind", {
    get: function () {
      return 'multline';
    },
    enumerable: false,
    configurable: true
  });
  MultlineItem.prototype.EndEntry = function () {
    if (this.table.length) {
      ParseUtil_js_1$a.default.fixInitialMO(this.factory.configuration, this.nodes);
    }
    var shove = this.getProperty('shove');
    var mtd = this.create('node', 'mtd', this.nodes, shove ? {
      columnalign: shove
    } : {});
    this.setProperty('shove', null);
    this.row.push(mtd);
    this.Clear();
  };
  MultlineItem.prototype.EndRow = function () {
    if (this.row.length !== 1) {
      throw new TexError_js_1$d.default('MultlineRowsOneCol', 'The rows within the %1 environment must have exactly one column', 'multline');
    }
    var row = this.create('node', 'mtr', this.row);
    this.table.push(row);
    this.row = [];
  };
  MultlineItem.prototype.EndTable = function () {
    _super.prototype.EndTable.call(this);
    if (this.table.length) {
      var m = this.table.length - 1, label = -1;
      if (!NodeUtil_js_1$7.default.getAttribute(NodeUtil_js_1$7.default.getChildren(this.table[0])[0], 'columnalign')) {
        NodeUtil_js_1$7.default.setAttribute(NodeUtil_js_1$7.default.getChildren(this.table[0])[0], 'columnalign', TexConstants_js_1$8.TexConstant.Align.LEFT);
      }
      if (!NodeUtil_js_1$7.default.getAttribute(NodeUtil_js_1$7.default.getChildren(this.table[m])[0], 'columnalign')) {
        NodeUtil_js_1$7.default.setAttribute(NodeUtil_js_1$7.default.getChildren(this.table[m])[0], 'columnalign', TexConstants_js_1$8.TexConstant.Align.RIGHT);
      }
      var tag = this.factory.configuration.tags.getTag();
      if (tag) {
        label = this.arraydef.side === TexConstants_js_1$8.TexConstant.Align.LEFT ? 0 : this.table.length - 1;
        var mtr = this.table[label];
        var mlabel = this.create('node', 'mlabeledtr', [tag].concat(NodeUtil_js_1$7.default.getChildren(mtr)));
        NodeUtil_js_1$7.default.copyAttributes(mtr, mlabel);
        this.table[label] = mlabel;
      }
    }
    this.factory.configuration.tags.end();
  };
  return MultlineItem;
})(BaseItems_js_1$4.ArrayItem);
AmsItems.MultlineItem = MultlineItem;
var FlalignItem = (function (_super) {
  __extends$c(FlalignItem, _super);
  function FlalignItem(factory, name, numbered, padded, center) {
    var _this = _super.call(this, factory) || this;
    _this.name = name;
    _this.numbered = numbered;
    _this.padded = padded;
    _this.center = center;
    _this.factory.configuration.tags.start(name, numbered, numbered);
    return _this;
  }
  Object.defineProperty(FlalignItem.prototype, "kind", {
    get: function () {
      return 'flalign';
    },
    enumerable: false,
    configurable: true
  });
  FlalignItem.prototype.EndEntry = function () {
    _super.prototype.EndEntry.call(this);
    var n = this.getProperty('xalignat');
    if (!n) return;
    if (this.row.length > n) {
      throw new TexError_js_1$d.default('XalignOverflow', 'Extra %1 in row of %2', '&', this.name);
    }
  };
  FlalignItem.prototype.EndRow = function () {
    var cell;
    var row = this.row;
    var n = this.getProperty('xalignat');
    while (row.length < n) {
      row.push(this.create('node', 'mtd'));
    }
    this.row = [];
    if (this.padded) {
      this.row.push(this.create('node', 'mtd'));
    }
    while (cell = row.shift()) {
      this.row.push(cell);
      cell = row.shift();
      if (cell) this.row.push(cell);
      if (row.length || this.padded) {
        this.row.push(this.create('node', 'mtd'));
      }
    }
    if (this.row.length > this.maxrow) {
      this.maxrow = this.row.length;
    }
    _super.prototype.EndRow.call(this);
    var mtr = this.table[this.table.length - 1];
    if (this.getProperty('zeroWidthLabel') && mtr.isKind('mlabeledtr')) {
      var mtd = NodeUtil_js_1$7.default.getChildren(mtr)[0];
      var side = this.factory.configuration.options['tagSide'];
      var def = __assign({
        width: 0
      }, side === 'right' ? {
        lspace: '-1width'
      } : {});
      var mpadded = this.create('node', 'mpadded', NodeUtil_js_1$7.default.getChildren(mtd), def);
      mtd.setChildren([mpadded]);
    }
  };
  FlalignItem.prototype.EndTable = function () {
    _super.prototype.EndTable.call(this);
    if (this.center) {
      if (this.maxrow <= 2) {
        var def = this.arraydef;
        delete def.width;
        delete this.global.indentalign;
      }
    }
  };
  return FlalignItem;
})(BaseItems_js_1$4.EqnArrayItem);
AmsItems.FlalignItem = FlalignItem;

var AmsMethods = {};

(function (exports) {
  var __assign = commonjsGlobal && commonjsGlobal.__assign || (function () {
    __assign = Object.assign || (function (t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    });
    return __assign.apply(this, arguments);
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.NEW_OPS = exports.AmsMethods = void 0;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var ParseMethods_js_1 = __importDefault(ParseMethods$1);
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var TexConstants_js_1 = TexConstants;
  var TexParser_js_1 = __importDefault(TexParser$1);
  var TexError_js_1 = __importDefault(TexError$1);
  var Symbol_js_1 = _Symbol;
  var BaseMethods_js_1 = __importDefault(BaseMethods$1);
  var MmlNode_js_1 = MmlNode;
  exports.AmsMethods = {};
  exports.AmsMethods.AmsEqnArray = function (parser, begin, numbered, taggable, align, spacing, style) {
    var args = parser.GetBrackets('\\begin{' + begin.getName() + '}');
    var array = BaseMethods_js_1.default.EqnArray(parser, begin, numbered, taggable, align, spacing, style);
    return ParseUtil_js_1.default.setArrayAlign(array, args);
  };
  exports.AmsMethods.AlignAt = function (parser, begin, numbered, taggable) {
    var name = begin.getName();
    var n, valign, align = '', spacing = [];
    if (!taggable) {
      valign = parser.GetBrackets('\\begin{' + name + '}');
    }
    n = parser.GetArgument('\\begin{' + name + '}');
    if (n.match(/[^0-9]/)) {
      throw new TexError_js_1.default('PositiveIntegerArg', 'Argument to %1 must me a positive integer', '\\begin{' + name + '}');
    }
    var count = parseInt(n, 10);
    while (count > 0) {
      align += 'rl';
      spacing.push('0em 0em');
      count--;
    }
    var spaceStr = spacing.join(' ');
    if (taggable) {
      return exports.AmsMethods.EqnArray(parser, begin, numbered, taggable, align, spaceStr);
    }
    var array = exports.AmsMethods.EqnArray(parser, begin, numbered, taggable, align, spaceStr);
    return ParseUtil_js_1.default.setArrayAlign(array, valign);
  };
  exports.AmsMethods.Multline = function (parser, begin, numbered) {
    parser.Push(begin);
    ParseUtil_js_1.default.checkEqnEnv(parser);
    var item = parser.itemFactory.create('multline', numbered, parser.stack);
    item.arraydef = {
      displaystyle: true,
      rowspacing: '.5em',
      columnspacing: '100%',
      width: parser.options.ams['multlineWidth'],
      side: parser.options['tagSide'],
      minlabelspacing: parser.options['tagIndent'],
      framespacing: parser.options.ams['multlineIndent'] + ' 0',
      frame: '',
      'data-width-includes-label': true
    };
    return item;
  };
  exports.AmsMethods.XalignAt = function (parser, begin, numbered, padded) {
    var n = parser.GetArgument('\\begin{' + begin.getName() + '}');
    if (n.match(/[^0-9]/)) {
      throw new TexError_js_1.default('PositiveIntegerArg', 'Argument to %1 must me a positive integer', '\\begin{' + begin.getName() + '}');
    }
    var align = padded ? 'crl' : 'rlc';
    var width = padded ? 'fit auto auto' : 'auto auto fit';
    var item = exports.AmsMethods.FlalignArray(parser, begin, numbered, padded, false, align, width, true);
    item.setProperty('xalignat', 2 * parseInt(n));
    return item;
  };
  exports.AmsMethods.FlalignArray = function (parser, begin, numbered, padded, center, align, width, zeroWidthLabel) {
    if (zeroWidthLabel === void 0) {
      zeroWidthLabel = false;
    }
    parser.Push(begin);
    ParseUtil_js_1.default.checkEqnEnv(parser);
    align = align.split('').join(' ').replace(/r/g, 'right').replace(/l/g, 'left').replace(/c/g, 'center');
    var item = parser.itemFactory.create('flalign', begin.getName(), numbered, padded, center, parser.stack);
    item.arraydef = {
      width: '100%',
      displaystyle: true,
      columnalign: align,
      columnspacing: '0em',
      columnwidth: width,
      rowspacing: '3pt',
      side: parser.options['tagSide'],
      minlabelspacing: zeroWidthLabel ? '0' : parser.options['tagIndent'],
      'data-width-includes-label': true
    };
    item.setProperty('zeroWidthLabel', zeroWidthLabel);
    return item;
  };
  exports.NEW_OPS = 'ams-declare-ops';
  exports.AmsMethods.HandleDeclareOp = function (parser, name) {
    var star = parser.GetStar() ? '*' : '';
    var cs = ParseUtil_js_1.default.trimSpaces(parser.GetArgument(name));
    if (cs.charAt(0) === '\\') {
      cs = cs.substr(1);
    }
    var op = parser.GetArgument(name);
    parser.configuration.handlers.retrieve(exports.NEW_OPS).add(cs, new Symbol_js_1.Macro(cs, exports.AmsMethods.Macro, [("\\operatorname").concat(star, "{").concat(op, "}")]));
  };
  exports.AmsMethods.HandleOperatorName = function (parser, name) {
    var star = parser.GetStar();
    var op = ParseUtil_js_1.default.trimSpaces(parser.GetArgument(name));
    var mml = new TexParser_js_1.default(op, __assign(__assign({}, parser.stack.env), {
      font: TexConstants_js_1.TexConstant.Variant.NORMAL,
      multiLetterIdentifiers: /^[-*a-z]+/i,
      operatorLetters: true
    }), parser.configuration).mml();
    if (!mml.isKind('mi')) {
      mml = parser.create('node', 'TeXAtom', [mml]);
    }
    NodeUtil_js_1.default.setProperties(mml, {
      movesupsub: star,
      movablelimits: true,
      texClass: MmlNode_js_1.TEXCLASS.OP
    });
    if (!star) {
      var c = parser.GetNext(), i = parser.i;
      if (c === '\\' && ++parser.i && parser.GetCS() !== 'limits') {
        parser.i = i;
      }
    }
    parser.Push(mml);
  };
  exports.AmsMethods.SideSet = function (parser, name) {
    var _a = __read(splitSideSet(parser.ParseArg(name)), 2), preScripts = _a[0], preRest = _a[1];
    var _b = __read(splitSideSet(parser.ParseArg(name)), 2), postScripts = _b[0], postRest = _b[1];
    var base = parser.ParseArg(name);
    var mml = base;
    if (preScripts) {
      if (preRest) {
        preScripts.replaceChild(parser.create('node', 'mphantom', [parser.create('node', 'mpadded', [ParseUtil_js_1.default.copyNode(base, parser)], {
          width: 0
        })]), NodeUtil_js_1.default.getChildAt(preScripts, 0));
      } else {
        mml = parser.create('node', 'mmultiscripts', [base]);
        if (postScripts) {
          NodeUtil_js_1.default.appendChildren(mml, [NodeUtil_js_1.default.getChildAt(postScripts, 1) || parser.create('node', 'none'), NodeUtil_js_1.default.getChildAt(postScripts, 2) || parser.create('node', 'none')]);
        }
        NodeUtil_js_1.default.setProperty(mml, 'scriptalign', 'left');
        NodeUtil_js_1.default.appendChildren(mml, [parser.create('node', 'mprescripts'), NodeUtil_js_1.default.getChildAt(preScripts, 1) || parser.create('node', 'none'), NodeUtil_js_1.default.getChildAt(preScripts, 2) || parser.create('node', 'none')]);
      }
    }
    if (postScripts && mml === base) {
      postScripts.replaceChild(base, NodeUtil_js_1.default.getChildAt(postScripts, 0));
      mml = postScripts;
    }
    var mrow = parser.create('node', 'TeXAtom', [], {
      texClass: MmlNode_js_1.TEXCLASS.OP,
      movesupsub: true,
      movablelimits: true
    });
    if (preRest) {
      preScripts && mrow.appendChild(preScripts);
      mrow.appendChild(preRest);
    }
    mrow.appendChild(mml);
    postRest && mrow.appendChild(postRest);
    parser.Push(mrow);
  };
  function splitSideSet(mml) {
    if (!mml || mml.isInferred && mml.childNodes.length === 0) return [null, null];
    if (mml.isKind('msubsup') && checkSideSetBase(mml)) return [mml, null];
    var child = NodeUtil_js_1.default.getChildAt(mml, 0);
    if (!(mml.isInferred && child && checkSideSetBase(child))) return [null, mml];
    mml.childNodes.splice(0, 1);
    return [child, mml];
  }
  function checkSideSetBase(mml) {
    var base = mml.childNodes[0];
    return base && base.isKind('mi') && base.getText() === '';
  }
  exports.AmsMethods.operatorLetter = function (parser, c) {
    return parser.stack.env.operatorLetters ? ParseMethods_js_1.default.variable(parser, c) : false;
  };
  exports.AmsMethods.MultiIntegral = function (parser, name, integral) {
    var next = parser.GetNext();
    if (next === '\\') {
      var i = parser.i;
      next = parser.GetArgument(name);
      parser.i = i;
      if (next === '\\limits') {
        if (name === '\\idotsint') {
          integral = '\\!\\!\\mathop{\\,\\,' + integral + '}';
        } else {
          integral = '\\!\\!\\!\\mathop{\\,\\,\\,' + integral + '}';
        }
      }
    }
    parser.string = integral + ' ' + parser.string.slice(parser.i);
    parser.i = 0;
  };
  exports.AmsMethods.xArrow = function (parser, name, chr, l, r) {
    var def = {
      width: '+' + ParseUtil_js_1.default.Em((l + r) / 18),
      lspace: ParseUtil_js_1.default.Em(l / 18)
    };
    var bot = parser.GetBrackets(name);
    var first = parser.ParseArg(name);
    var dstrut = parser.create('node', 'mspace', [], {
      depth: '.25em'
    });
    var arrow = parser.create('token', 'mo', {
      stretchy: true,
      texClass: MmlNode_js_1.TEXCLASS.REL
    }, String.fromCodePoint(chr));
    arrow = parser.create('node', 'mstyle', [arrow], {
      scriptlevel: 0
    });
    var mml = parser.create('node', 'munderover', [arrow]);
    var mpadded = parser.create('node', 'mpadded', [first, dstrut], def);
    NodeUtil_js_1.default.setAttribute(mpadded, 'voffset', '-.2em');
    NodeUtil_js_1.default.setAttribute(mpadded, 'height', '-.2em');
    NodeUtil_js_1.default.setChild(mml, mml.over, mpadded);
    if (bot) {
      var bottom = new TexParser_js_1.default(bot, parser.stack.env, parser.configuration).mml();
      var bstrut = parser.create('node', 'mspace', [], {
        height: '.75em'
      });
      mpadded = parser.create('node', 'mpadded', [bottom, bstrut], def);
      NodeUtil_js_1.default.setAttribute(mpadded, 'voffset', '.15em');
      NodeUtil_js_1.default.setAttribute(mpadded, 'depth', '-.15em');
      NodeUtil_js_1.default.setChild(mml, mml.under, mpadded);
    }
    NodeUtil_js_1.default.setProperty(mml, 'subsupOK', true);
    parser.Push(mml);
  };
  exports.AmsMethods.HandleShove = function (parser, _name, shove) {
    var top = parser.stack.Top();
    if (top.kind !== 'multline') {
      throw new TexError_js_1.default('CommandOnlyAllowedInEnv', '%1 only allowed in %2 environment', parser.currentCS, 'multline');
    }
    if (top.Size()) {
      throw new TexError_js_1.default('CommandAtTheBeginingOfLine', '%1 must come at the beginning of the line', parser.currentCS);
    }
    top.setProperty('shove', shove);
  };
  exports.AmsMethods.CFrac = function (parser, name) {
    var lr = ParseUtil_js_1.default.trimSpaces(parser.GetBrackets(name, ''));
    var num = parser.GetArgument(name);
    var den = parser.GetArgument(name);
    var lrMap = {
      l: TexConstants_js_1.TexConstant.Align.LEFT,
      r: TexConstants_js_1.TexConstant.Align.RIGHT,
      '': ''
    };
    var numNode = new TexParser_js_1.default('\\strut\\textstyle{' + num + '}', parser.stack.env, parser.configuration).mml();
    var denNode = new TexParser_js_1.default('\\strut\\textstyle{' + den + '}', parser.stack.env, parser.configuration).mml();
    var frac = parser.create('node', 'mfrac', [numNode, denNode]);
    lr = lrMap[lr];
    if (lr == null) {
      throw new TexError_js_1.default('IllegalAlign', 'Illegal alignment specified in %1', parser.currentCS);
    }
    if (lr) {
      NodeUtil_js_1.default.setProperties(frac, {
        numalign: lr,
        denomalign: lr
      });
    }
    parser.Push(frac);
  };
  exports.AmsMethods.Genfrac = function (parser, name, left, right, thick, style) {
    if (left == null) {
      left = parser.GetDelimiterArg(name);
    }
    if (right == null) {
      right = parser.GetDelimiterArg(name);
    }
    if (thick == null) {
      thick = parser.GetArgument(name);
    }
    if (style == null) {
      style = ParseUtil_js_1.default.trimSpaces(parser.GetArgument(name));
    }
    var num = parser.ParseArg(name);
    var den = parser.ParseArg(name);
    var frac = parser.create('node', 'mfrac', [num, den]);
    if (thick !== '') {
      NodeUtil_js_1.default.setAttribute(frac, 'linethickness', thick);
    }
    if (left || right) {
      NodeUtil_js_1.default.setProperty(frac, 'withDelims', true);
      frac = ParseUtil_js_1.default.fixedFence(parser.configuration, left, frac, right);
    }
    if (style !== '') {
      var styleDigit = parseInt(style, 10);
      var styleAlpha = ['D', 'T', 'S', 'SS'][styleDigit];
      if (styleAlpha == null) {
        throw new TexError_js_1.default('BadMathStyleFor', 'Bad math style for %1', parser.currentCS);
      }
      frac = parser.create('node', 'mstyle', [frac]);
      if (styleAlpha === 'D') {
        NodeUtil_js_1.default.setProperties(frac, {
          displaystyle: true,
          scriptlevel: 0
        });
      } else {
        NodeUtil_js_1.default.setProperties(frac, {
          displaystyle: false,
          scriptlevel: styleDigit - 1
        });
      }
    }
    parser.Push(frac);
  };
  exports.AmsMethods.HandleTag = function (parser, name) {
    if (!parser.tags.currentTag.taggable && parser.tags.env) {
      throw new TexError_js_1.default('CommandNotAllowedInEnv', '%1 not allowed in %2 environment', parser.currentCS, parser.tags.env);
    }
    if (parser.tags.currentTag.tag) {
      throw new TexError_js_1.default('MultipleCommand', 'Multiple %1', parser.currentCS);
    }
    var star = parser.GetStar();
    var tagId = ParseUtil_js_1.default.trimSpaces(parser.GetArgument(name));
    parser.tags.tag(tagId, star);
  };
  exports.AmsMethods.HandleNoTag = BaseMethods_js_1.default.HandleNoTag;
  exports.AmsMethods.HandleRef = BaseMethods_js_1.default.HandleRef;
  exports.AmsMethods.Macro = BaseMethods_js_1.default.Macro;
  exports.AmsMethods.Accent = BaseMethods_js_1.default.Accent;
  exports.AmsMethods.Tilde = BaseMethods_js_1.default.Tilde;
  exports.AmsMethods.Array = BaseMethods_js_1.default.Array;
  exports.AmsMethods.Spacer = BaseMethods_js_1.default.Spacer;
  exports.AmsMethods.NamedOp = BaseMethods_js_1.default.NamedOp;
  exports.AmsMethods.EqnArray = BaseMethods_js_1.default.EqnArray;
  exports.AmsMethods.Equation = BaseMethods_js_1.default.Equation;
})(AmsMethods);
getDefaultExportFromCjs(AmsMethods);

var AmsMappings = {};

var __createBinding$6 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$6 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$6 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$6(result, mod, k);
  __setModuleDefault$6(result, mod);
  return result;
});
var __importDefault$w = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(AmsMappings, "__esModule", {
  value: true
});
var AmsMethods_js_1$2 = AmsMethods;
var sm$3 = __importStar$6(SymbolMap);
var TexConstants_js_1$7 = TexConstants;
var ParseMethods_js_1$6 = __importDefault$w(ParseMethods$1);
var ParseUtil_js_1$9 = __importDefault$w(ParseUtil$1);
var MmlNode_js_1$6 = MmlNode;
var lengths_js_1$1 = lengths;
new sm$3.CharacterMap('AMSmath-mathchar0mo', ParseMethods_js_1$6.default.mathchar0mo, {
  iiiint: ['\u2A0C', {
    texClass: MmlNode_js_1$6.TEXCLASS.OP
  }]
});
new sm$3.RegExpMap('AMSmath-operatorLetter', AmsMethods_js_1$2.AmsMethods.operatorLetter, /[-*]/i);
new sm$3.CommandMap('AMSmath-macros', {
  mathring: ['Accent', '02DA'],
  nobreakspace: 'Tilde',
  negmedspace: ['Spacer', lengths_js_1$1.MATHSPACE.negativemediummathspace],
  negthickspace: ['Spacer', lengths_js_1$1.MATHSPACE.negativethickmathspace],
  idotsint: ['MultiIntegral', '\\int\\cdots\\int'],
  dddot: ['Accent', '20DB'],
  ddddot: ['Accent', '20DC'],
  sideset: 'SideSet',
  boxed: ['Macro', '\\fbox{$\\displaystyle{#1}$}', 1],
  tag: 'HandleTag',
  notag: 'HandleNoTag',
  eqref: ['HandleRef', true],
  substack: ['Macro', '\\begin{subarray}{c}#1\\end{subarray}', 1],
  injlim: ['NamedOp', 'inj&thinsp;lim'],
  projlim: ['NamedOp', 'proj&thinsp;lim'],
  varliminf: ['Macro', '\\mathop{\\underline{\\mmlToken{mi}{lim}}}'],
  varlimsup: ['Macro', '\\mathop{\\overline{\\mmlToken{mi}{lim}}}'],
  varinjlim: ['Macro', '\\mathop{\\underrightarrow{\\mmlToken{mi}{lim}}}'],
  varprojlim: ['Macro', '\\mathop{\\underleftarrow{\\mmlToken{mi}{lim}}}'],
  DeclareMathOperator: 'HandleDeclareOp',
  operatorname: 'HandleOperatorName',
  genfrac: 'Genfrac',
  frac: ['Genfrac', '', '', '', ''],
  tfrac: ['Genfrac', '', '', '', '1'],
  dfrac: ['Genfrac', '', '', '', '0'],
  binom: ['Genfrac', '(', ')', '0', ''],
  tbinom: ['Genfrac', '(', ')', '0', '1'],
  dbinom: ['Genfrac', '(', ')', '0', '0'],
  cfrac: 'CFrac',
  shoveleft: ['HandleShove', TexConstants_js_1$7.TexConstant.Align.LEFT],
  shoveright: ['HandleShove', TexConstants_js_1$7.TexConstant.Align.RIGHT],
  xrightarrow: ['xArrow', 0x2192, 5, 10],
  xleftarrow: ['xArrow', 0x2190, 10, 5]
}, AmsMethods_js_1$2.AmsMethods);
new sm$3.EnvironmentMap('AMSmath-environment', ParseMethods_js_1$6.default.environment, {
  'equation*': ['Equation', null, false],
  'eqnarray*': ['EqnArray', null, false, true, 'rcl', ParseUtil_js_1$9.default.cols(0, lengths_js_1$1.MATHSPACE.thickmathspace), '.5em'],
  align: ['EqnArray', null, true, true, 'rl', ParseUtil_js_1$9.default.cols(0, 2)],
  'align*': ['EqnArray', null, false, true, 'rl', ParseUtil_js_1$9.default.cols(0, 2)],
  multline: ['Multline', null, true],
  'multline*': ['Multline', null, false],
  split: ['EqnArray', null, false, false, 'rl', ParseUtil_js_1$9.default.cols(0)],
  gather: ['EqnArray', null, true, true, 'c'],
  'gather*': ['EqnArray', null, false, true, 'c'],
  alignat: ['AlignAt', null, true, true],
  'alignat*': ['AlignAt', null, false, true],
  alignedat: ['AlignAt', null, false, false],
  aligned: ['AmsEqnArray', null, null, null, 'rl', ParseUtil_js_1$9.default.cols(0, 2), '.5em', 'D'],
  gathered: ['AmsEqnArray', null, null, null, 'c', null, '.5em', 'D'],
  xalignat: ['XalignAt', null, true, true],
  'xalignat*': ['XalignAt', null, false, true],
  xxalignat: ['XalignAt', null, false, false],
  flalign: ['FlalignArray', null, true, false, true, 'rlc', 'auto auto fit'],
  'flalign*': ['FlalignArray', null, false, false, true, 'rlc', 'auto auto fit'],
  subarray: ['Array', null, null, null, null, ParseUtil_js_1$9.default.cols(0), '0.1em', 'S', 1],
  smallmatrix: ['Array', null, null, null, 'c', ParseUtil_js_1$9.default.cols(1 / 3), '.2em', 'S', 1],
  matrix: ['Array', null, null, null, 'c'],
  pmatrix: ['Array', null, '(', ')', 'c'],
  bmatrix: ['Array', null, '[', ']', 'c'],
  Bmatrix: ['Array', null, '\\{', '\\}', 'c'],
  vmatrix: ['Array', null, '\\vert', '\\vert', 'c'],
  Vmatrix: ['Array', null, '\\Vert', '\\Vert', 'c'],
  cases: ['Array', null, '\\{', '.', 'll', null, '.2em', 'T']
}, AmsMethods_js_1$2.AmsMethods);
new sm$3.DelimiterMap('AMSmath-delimiter', ParseMethods_js_1$6.default.delimiter, {
  '\\lvert': ['\u007C', {
    texClass: MmlNode_js_1$6.TEXCLASS.OPEN
  }],
  '\\rvert': ['\u007C', {
    texClass: MmlNode_js_1$6.TEXCLASS.CLOSE
  }],
  '\\lVert': ['\u2016', {
    texClass: MmlNode_js_1$6.TEXCLASS.OPEN
  }],
  '\\rVert': ['\u2016', {
    texClass: MmlNode_js_1$6.TEXCLASS.CLOSE
  }]
});
new sm$3.CharacterMap('AMSsymbols-mathchar0mi', ParseMethods_js_1$6.default.mathchar0mi, {
  digamma: '\u03DD',
  varkappa: '\u03F0',
  varGamma: ['\u0393', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varDelta: ['\u0394', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varTheta: ['\u0398', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varLambda: ['\u039B', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varXi: ['\u039E', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varPi: ['\u03A0', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varSigma: ['\u03A3', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varUpsilon: ['\u03A5', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varPhi: ['\u03A6', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varPsi: ['\u03A8', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  varOmega: ['\u03A9', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.ITALIC
  }],
  beth: '\u2136',
  gimel: '\u2137',
  daleth: '\u2138',
  backprime: ['\u2035', {
    variantForm: true
  }],
  hslash: '\u210F',
  varnothing: ['\u2205', {
    variantForm: true
  }],
  blacktriangle: '\u25B4',
  triangledown: ['\u25BD', {
    variantForm: true
  }],
  blacktriangledown: '\u25BE',
  square: '\u25FB',
  Box: '\u25FB',
  blacksquare: '\u25FC',
  lozenge: '\u25CA',
  Diamond: '\u25CA',
  blacklozenge: '\u29EB',
  circledS: ['\u24C8', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.NORMAL
  }],
  bigstar: '\u2605',
  sphericalangle: '\u2222',
  measuredangle: '\u2221',
  nexists: '\u2204',
  complement: '\u2201',
  mho: '\u2127',
  eth: ['\u00F0', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.NORMAL
  }],
  Finv: '\u2132',
  diagup: '\u2571',
  Game: '\u2141',
  diagdown: '\u2572',
  Bbbk: ['\u006B', {
    mathvariant: TexConstants_js_1$7.TexConstant.Variant.DOUBLESTRUCK
  }],
  yen: '\u00A5',
  circledR: '\u00AE',
  checkmark: '\u2713',
  maltese: '\u2720'
});
new sm$3.CharacterMap('AMSsymbols-mathchar0mo', ParseMethods_js_1$6.default.mathchar0mo, {
  dotplus: '\u2214',
  ltimes: '\u22C9',
  smallsetminus: ['\u2216', {
    variantForm: true
  }],
  rtimes: '\u22CA',
  Cap: '\u22D2',
  doublecap: '\u22D2',
  leftthreetimes: '\u22CB',
  Cup: '\u22D3',
  doublecup: '\u22D3',
  rightthreetimes: '\u22CC',
  barwedge: '\u22BC',
  curlywedge: '\u22CF',
  veebar: '\u22BB',
  curlyvee: '\u22CE',
  doublebarwedge: '\u2A5E',
  boxminus: '\u229F',
  circleddash: '\u229D',
  boxtimes: '\u22A0',
  circledast: '\u229B',
  boxdot: '\u22A1',
  circledcirc: '\u229A',
  boxplus: '\u229E',
  centerdot: ['\u22C5', {
    variantForm: true
  }],
  divideontimes: '\u22C7',
  intercal: '\u22BA',
  leqq: '\u2266',
  geqq: '\u2267',
  leqslant: '\u2A7D',
  geqslant: '\u2A7E',
  eqslantless: '\u2A95',
  eqslantgtr: '\u2A96',
  lesssim: '\u2272',
  gtrsim: '\u2273',
  lessapprox: '\u2A85',
  gtrapprox: '\u2A86',
  approxeq: '\u224A',
  lessdot: '\u22D6',
  gtrdot: '\u22D7',
  lll: '\u22D8',
  llless: '\u22D8',
  ggg: '\u22D9',
  gggtr: '\u22D9',
  lessgtr: '\u2276',
  gtrless: '\u2277',
  lesseqgtr: '\u22DA',
  gtreqless: '\u22DB',
  lesseqqgtr: '\u2A8B',
  gtreqqless: '\u2A8C',
  doteqdot: '\u2251',
  Doteq: '\u2251',
  eqcirc: '\u2256',
  risingdotseq: '\u2253',
  circeq: '\u2257',
  fallingdotseq: '\u2252',
  triangleq: '\u225C',
  backsim: '\u223D',
  thicksim: ['\u223C', {
    variantForm: true
  }],
  backsimeq: '\u22CD',
  thickapprox: ['\u2248', {
    variantForm: true
  }],
  subseteqq: '\u2AC5',
  supseteqq: '\u2AC6',
  Subset: '\u22D0',
  Supset: '\u22D1',
  sqsubset: '\u228F',
  sqsupset: '\u2290',
  preccurlyeq: '\u227C',
  succcurlyeq: '\u227D',
  curlyeqprec: '\u22DE',
  curlyeqsucc: '\u22DF',
  precsim: '\u227E',
  succsim: '\u227F',
  precapprox: '\u2AB7',
  succapprox: '\u2AB8',
  vartriangleleft: '\u22B2',
  lhd: '\u22B2',
  vartriangleright: '\u22B3',
  rhd: '\u22B3',
  trianglelefteq: '\u22B4',
  unlhd: '\u22B4',
  trianglerighteq: '\u22B5',
  unrhd: '\u22B5',
  vDash: ['\u22A8', {
    variantForm: true
  }],
  Vdash: '\u22A9',
  Vvdash: '\u22AA',
  smallsmile: ['\u2323', {
    variantForm: true
  }],
  shortmid: ['\u2223', {
    variantForm: true
  }],
  smallfrown: ['\u2322', {
    variantForm: true
  }],
  shortparallel: ['\u2225', {
    variantForm: true
  }],
  bumpeq: '\u224F',
  between: '\u226C',
  Bumpeq: '\u224E',
  pitchfork: '\u22D4',
  varpropto: ['\u221D', {
    variantForm: true
  }],
  backepsilon: '\u220D',
  blacktriangleleft: '\u25C2',
  blacktriangleright: '\u25B8',
  therefore: '\u2234',
  because: '\u2235',
  eqsim: '\u2242',
  vartriangle: ['\u25B3', {
    variantForm: true
  }],
  Join: '\u22C8',
  nless: '\u226E',
  ngtr: '\u226F',
  nleq: '\u2270',
  ngeq: '\u2271',
  nleqslant: ['\u2A87', {
    variantForm: true
  }],
  ngeqslant: ['\u2A88', {
    variantForm: true
  }],
  nleqq: ['\u2270', {
    variantForm: true
  }],
  ngeqq: ['\u2271', {
    variantForm: true
  }],
  lneq: '\u2A87',
  gneq: '\u2A88',
  lneqq: '\u2268',
  gneqq: '\u2269',
  lvertneqq: ['\u2268', {
    variantForm: true
  }],
  gvertneqq: ['\u2269', {
    variantForm: true
  }],
  lnsim: '\u22E6',
  gnsim: '\u22E7',
  lnapprox: '\u2A89',
  gnapprox: '\u2A8A',
  nprec: '\u2280',
  nsucc: '\u2281',
  npreceq: ['\u22E0', {
    variantForm: true
  }],
  nsucceq: ['\u22E1', {
    variantForm: true
  }],
  precneqq: '\u2AB5',
  succneqq: '\u2AB6',
  precnsim: '\u22E8',
  succnsim: '\u22E9',
  precnapprox: '\u2AB9',
  succnapprox: '\u2ABA',
  nsim: '\u2241',
  ncong: '\u2247',
  nshortmid: ['\u2224', {
    variantForm: true
  }],
  nshortparallel: ['\u2226', {
    variantForm: true
  }],
  nmid: '\u2224',
  nparallel: '\u2226',
  nvdash: '\u22AC',
  nvDash: '\u22AD',
  nVdash: '\u22AE',
  nVDash: '\u22AF',
  ntriangleleft: '\u22EA',
  ntriangleright: '\u22EB',
  ntrianglelefteq: '\u22EC',
  ntrianglerighteq: '\u22ED',
  nsubseteq: '\u2288',
  nsupseteq: '\u2289',
  nsubseteqq: ['\u2288', {
    variantForm: true
  }],
  nsupseteqq: ['\u2289', {
    variantForm: true
  }],
  subsetneq: '\u228A',
  supsetneq: '\u228B',
  varsubsetneq: ['\u228A', {
    variantForm: true
  }],
  varsupsetneq: ['\u228B', {
    variantForm: true
  }],
  subsetneqq: '\u2ACB',
  supsetneqq: '\u2ACC',
  varsubsetneqq: ['\u2ACB', {
    variantForm: true
  }],
  varsupsetneqq: ['\u2ACC', {
    variantForm: true
  }],
  leftleftarrows: '\u21C7',
  rightrightarrows: '\u21C9',
  leftrightarrows: '\u21C6',
  rightleftarrows: '\u21C4',
  Lleftarrow: '\u21DA',
  Rrightarrow: '\u21DB',
  twoheadleftarrow: '\u219E',
  twoheadrightarrow: '\u21A0',
  leftarrowtail: '\u21A2',
  rightarrowtail: '\u21A3',
  looparrowleft: '\u21AB',
  looparrowright: '\u21AC',
  leftrightharpoons: '\u21CB',
  rightleftharpoons: ['\u21CC', {
    variantForm: true
  }],
  curvearrowleft: '\u21B6',
  curvearrowright: '\u21B7',
  circlearrowleft: '\u21BA',
  circlearrowright: '\u21BB',
  Lsh: '\u21B0',
  Rsh: '\u21B1',
  upuparrows: '\u21C8',
  downdownarrows: '\u21CA',
  upharpoonleft: '\u21BF',
  upharpoonright: '\u21BE',
  downharpoonleft: '\u21C3',
  restriction: '\u21BE',
  multimap: '\u22B8',
  downharpoonright: '\u21C2',
  leftrightsquigarrow: '\u21AD',
  rightsquigarrow: '\u21DD',
  leadsto: '\u21DD',
  dashrightarrow: '\u21E2',
  dashleftarrow: '\u21E0',
  nleftarrow: '\u219A',
  nrightarrow: '\u219B',
  nLeftarrow: '\u21CD',
  nRightarrow: '\u21CF',
  nleftrightarrow: '\u21AE',
  nLeftrightarrow: '\u21CE'
});
new sm$3.DelimiterMap('AMSsymbols-delimiter', ParseMethods_js_1$6.default.delimiter, {
  '\\ulcorner': '\u231C',
  '\\urcorner': '\u231D',
  '\\llcorner': '\u231E',
  '\\lrcorner': '\u231F'
});
new sm$3.CommandMap('AMSsymbols-macros', {
  implies: ['Macro', '\\;\\Longrightarrow\\;'],
  impliedby: ['Macro', '\\;\\Longleftarrow\\;']
}, AmsMethods_js_1$2.AmsMethods);

var __extends$b = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var _a$6;
Object.defineProperty(AmsConfiguration, "__esModule", {
  value: true
});
AmsConfiguration.AmsConfiguration = AmsConfiguration.AmsTags = void 0;
var Configuration_js_1$i = Configuration;
var AmsItems_js_1$1 = AmsItems;
var Tags_js_1$3 = Tags;
var AmsMethods_js_1$1 = AmsMethods;
var SymbolMap_js_1$f = SymbolMap;
var AmsTags = (function (_super) {
  __extends$b(AmsTags, _super);
  function AmsTags() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return AmsTags;
})(Tags_js_1$3.AbstractTags);
AmsConfiguration.AmsTags = AmsTags;
var init$1 = function (config) {
  new SymbolMap_js_1$f.CommandMap(AmsMethods_js_1$1.NEW_OPS, {}, {});
  config.append(Configuration_js_1$i.Configuration.local({
    handler: {
      macro: [AmsMethods_js_1$1.NEW_OPS]
    },
    priority: -1
  }));
};
AmsConfiguration.AmsConfiguration = Configuration_js_1$i.Configuration.create('ams', {
  handler: {
    character: ['AMSmath-operatorLetter'],
    delimiter: ['AMSsymbols-delimiter', 'AMSmath-delimiter'],
    macro: ['AMSsymbols-mathchar0mi', 'AMSsymbols-mathchar0mo', 'AMSsymbols-delimiter', 'AMSsymbols-macros', 'AMSmath-mathchar0mo', 'AMSmath-macros', 'AMSmath-delimiter'],
    environment: ['AMSmath-environment']
  },
  items: (_a$6 = {}, _a$6[AmsItems_js_1$1.MultlineItem.prototype.kind] = AmsItems_js_1$1.MultlineItem, _a$6[AmsItems_js_1$1.FlalignItem.prototype.kind] = AmsItems_js_1$1.FlalignItem, _a$6),
  tags: {
    'ams': AmsTags
  },
  init: init$1,
  config: function (_config, jax) {
    if (jax.parseOptions.options.multlineWidth) {
      jax.parseOptions.options.ams.multlineWidth = jax.parseOptions.options.multlineWidth;
    }
    delete jax.parseOptions.options.multlineWidth;
  },
  options: {
    multlineWidth: '',
    ams: {
      multlineWidth: '100%',
      multlineIndent: '1em'
    }
  }
});

var AmsCdConfiguration = {};

var AmsCdMappings = {};

var AmsCdMethods$1 = {};

var __importDefault$v = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(AmsCdMethods$1, "__esModule", {
  value: true
});
var TexParser_js_1$7 = __importDefault$v(TexParser$1);
var BaseConfiguration_js_1 = BaseConfiguration;
var MmlNode_js_1$5 = MmlNode;
var NodeUtil_js_1$6 = __importDefault$v(NodeUtil$1);
var AmsCdMethods = {};
AmsCdMethods.CD = function (parser, begin) {
  parser.Push(begin);
  var item = parser.itemFactory.create('array');
  var options = parser.configuration.options.amscd;
  item.setProperties({
    minw: parser.stack.env.CD_minw || options.harrowsize,
    minh: parser.stack.env.CD_minh || options.varrowsize
  });
  item.arraydef = {
    columnalign: 'center',
    columnspacing: options.colspace,
    rowspacing: options.rowspace,
    displaystyle: true
  };
  return item;
};
AmsCdMethods.arrow = function (parser, name) {
  var c = parser.string.charAt(parser.i);
  if (!c.match(/[><VA.|=]/)) {
    return (0, BaseConfiguration_js_1.Other)(parser, name);
  } else {
    parser.i++;
  }
  var first = parser.stack.Top();
  if (!first.isKind('array') || first.Size()) {
    AmsCdMethods.cell(parser, name);
    first = parser.stack.Top();
  }
  var top = first;
  var arrowRow = top.table.length % 2 === 1;
  var n = (top.row.length + (arrowRow ? 0 : 1)) % 2;
  while (n) {
    AmsCdMethods.cell(parser, name);
    n--;
  }
  var mml;
  var hdef = {
    minsize: top.getProperty('minw'),
    stretchy: true
  }, vdef = {
    minsize: top.getProperty('minh'),
    stretchy: true,
    symmetric: true,
    lspace: 0,
    rspace: 0
  };
  if (c === '.') ; else if (c === '|') {
    mml = parser.create('token', 'mo', vdef, '\u2225');
  } else if (c === '=') {
    mml = parser.create('token', 'mo', hdef, '=');
  } else {
    var arrow = ({
      '>': '\u2192',
      '<': '\u2190',
      'V': '\u2193',
      'A': '\u2191'
    })[c];
    var a = parser.GetUpTo(name + c, c);
    var b = parser.GetUpTo(name + c, c);
    if (c === '>' || c === '<') {
      mml = parser.create('token', 'mo', hdef, arrow);
      if (!a) {
        a = '\\kern ' + top.getProperty('minw');
      }
      if (a || b) {
        var pad = {
          width: '+.67em',
          lspace: '.33em'
        };
        mml = parser.create('node', 'munderover', [mml]);
        if (a) {
          var nodeA = new TexParser_js_1$7.default(a, parser.stack.env, parser.configuration).mml();
          var mpadded = parser.create('node', 'mpadded', [nodeA], pad);
          NodeUtil_js_1$6.default.setAttribute(mpadded, 'voffset', '.1em');
          NodeUtil_js_1$6.default.setChild(mml, mml.over, mpadded);
        }
        if (b) {
          var nodeB = new TexParser_js_1$7.default(b, parser.stack.env, parser.configuration).mml();
          NodeUtil_js_1$6.default.setChild(mml, mml.under, parser.create('node', 'mpadded', [nodeB], pad));
        }
        if (parser.configuration.options.amscd.hideHorizontalLabels) {
          mml = parser.create('node', 'mpadded', mml, {
            depth: 0,
            height: '.67em'
          });
        }
      }
    } else {
      var arrowNode = parser.create('token', 'mo', vdef, arrow);
      mml = arrowNode;
      if (a || b) {
        mml = parser.create('node', 'mrow');
        if (a) {
          NodeUtil_js_1$6.default.appendChildren(mml, [new TexParser_js_1$7.default('\\scriptstyle\\llap{' + a + '}', parser.stack.env, parser.configuration).mml()]);
        }
        arrowNode.texClass = MmlNode_js_1$5.TEXCLASS.ORD;
        NodeUtil_js_1$6.default.appendChildren(mml, [arrowNode]);
        if (b) {
          NodeUtil_js_1$6.default.appendChildren(mml, [new TexParser_js_1$7.default('\\scriptstyle\\rlap{' + b + '}', parser.stack.env, parser.configuration).mml()]);
        }
      }
    }
  }
  if (mml) {
    parser.Push(mml);
  }
  AmsCdMethods.cell(parser, name);
};
AmsCdMethods.cell = function (parser, name) {
  var top = parser.stack.Top();
  if ((top.table || []).length % 2 === 0 && (top.row || []).length === 0) {
    parser.Push(parser.create('node', 'mpadded', [], {
      height: '8.5pt',
      depth: '2pt'
    }));
  }
  parser.Push(parser.itemFactory.create('cell').setProperties({
    isEntry: true,
    name: name
  }));
};
AmsCdMethods.minCDarrowwidth = function (parser, name) {
  parser.stack.env.CD_minw = parser.GetDimen(name);
};
AmsCdMethods.minCDarrowheight = function (parser, name) {
  parser.stack.env.CD_minh = parser.GetDimen(name);
};
AmsCdMethods$1.default = AmsCdMethods;

var __createBinding$5 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$5 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$5 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$5(result, mod, k);
  __setModuleDefault$5(result, mod);
  return result;
});
var __importDefault$u = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(AmsCdMappings, "__esModule", {
  value: true
});
var sm$2 = __importStar$5(SymbolMap);
var ParseMethods_js_1$5 = __importDefault$u(ParseMethods$1);
var AmsCdMethods_js_1 = __importDefault$u(AmsCdMethods$1);
new sm$2.EnvironmentMap('amscd_environment', ParseMethods_js_1$5.default.environment, {
  CD: 'CD'
}, AmsCdMethods_js_1.default);
new sm$2.CommandMap('amscd_macros', {
  minCDarrowwidth: 'minCDarrowwidth',
  minCDarrowheight: 'minCDarrowheight'
}, AmsCdMethods_js_1.default);
new sm$2.MacroMap('amscd_special', {
  '@': 'arrow'
}, AmsCdMethods_js_1.default);

Object.defineProperty(AmsCdConfiguration, "__esModule", {
  value: true
});
AmsCdConfiguration.AmsCdConfiguration = void 0;
var Configuration_js_1$h = Configuration;
AmsCdConfiguration.AmsCdConfiguration = Configuration_js_1$h.Configuration.create('amscd', {
  handler: {
    character: ['amscd_special'],
    macro: ['amscd_macros'],
    environment: ['amscd_environment']
  },
  options: {
    amscd: {
      colspace: '5pt',
      rowspace: '5pt',
      harrowsize: '2.75em',
      varrowsize: '1.75em',
      hideHorizontalLabels: false
    }
  }
});

var BboxConfiguration = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.BboxConfiguration = exports.BboxMethods = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var TexError_js_1 = __importDefault(TexError$1);
  exports.BboxMethods = {};
  exports.BboxMethods.BBox = function (parser, name) {
    var bbox = parser.GetBrackets(name, '');
    var math = parser.ParseArg(name);
    var parts = bbox.split(/,/);
    var def, background, style;
    for (var i = 0, m = parts.length; i < m; i++) {
      var part = parts[i].trim();
      var match = part.match(/^(\.\d+|\d+(\.\d*)?)(pt|em|ex|mu|px|in|cm|mm)$/);
      if (match) {
        if (def) {
          throw new TexError_js_1.default('MultipleBBoxProperty', '%1 specified twice in %2', 'Padding', name);
        }
        var pad = BBoxPadding(match[1] + match[3]);
        if (pad) {
          def = {
            height: '+' + pad,
            depth: '+' + pad,
            lspace: pad,
            width: '+' + 2 * parseInt(match[1], 10) + match[3]
          };
        }
      } else if (part.match(/^([a-z0-9]+|\#[0-9a-f]{6}|\#[0-9a-f]{3})$/i)) {
        if (background) {
          throw new TexError_js_1.default('MultipleBBoxProperty', '%1 specified twice in %2', 'Background', name);
        }
        background = part;
      } else if (part.match(/^[-a-z]+:/i)) {
        if (style) {
          throw new TexError_js_1.default('MultipleBBoxProperty', '%1 specified twice in %2', 'Style', name);
        }
        style = BBoxStyle(part);
      } else if (part !== '') {
        throw new TexError_js_1.default('InvalidBBoxProperty', '"%1" doesn\'t look like a color, a padding dimension, or a style', part);
      }
    }
    if (def) {
      math = parser.create('node', 'mpadded', [math], def);
    }
    if (background || style) {
      def = {};
      if (background) {
        Object.assign(def, {
          mathbackground: background
        });
      }
      if (style) {
        Object.assign(def, {
          style: style
        });
      }
      math = parser.create('node', 'mstyle', [math], def);
    }
    parser.Push(math);
  };
  var BBoxStyle = function (styles) {
    return styles;
  };
  var BBoxPadding = function (pad) {
    return pad;
  };
  new SymbolMap_js_1.CommandMap('bbox', {
    bbox: 'BBox'
  }, exports.BboxMethods);
  exports.BboxConfiguration = Configuration_js_1.Configuration.create('bbox', {
    handler: {
      macro: ['bbox']
    }
  });
})(BboxConfiguration);
getDefaultExportFromCjs(BboxConfiguration);

var BoldsymbolConfiguration = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.BoldsymbolConfiguration = exports.rewriteBoldTokens = exports.createBoldToken = exports.BoldsymbolMethods = void 0;
  var Configuration_js_1 = Configuration;
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var TexConstants_js_1 = TexConstants;
  var SymbolMap_js_1 = SymbolMap;
  var NodeFactory_js_1 = NodeFactory$2;
  var BOLDVARIANT = {};
  BOLDVARIANT[TexConstants_js_1.TexConstant.Variant.NORMAL] = TexConstants_js_1.TexConstant.Variant.BOLD;
  BOLDVARIANT[TexConstants_js_1.TexConstant.Variant.ITALIC] = TexConstants_js_1.TexConstant.Variant.BOLDITALIC;
  BOLDVARIANT[TexConstants_js_1.TexConstant.Variant.FRAKTUR] = TexConstants_js_1.TexConstant.Variant.BOLDFRAKTUR;
  BOLDVARIANT[TexConstants_js_1.TexConstant.Variant.SCRIPT] = TexConstants_js_1.TexConstant.Variant.BOLDSCRIPT;
  BOLDVARIANT[TexConstants_js_1.TexConstant.Variant.SANSSERIF] = TexConstants_js_1.TexConstant.Variant.BOLDSANSSERIF;
  BOLDVARIANT['-tex-calligraphic'] = '-tex-bold-calligraphic';
  BOLDVARIANT['-tex-oldstyle'] = '-tex-bold-oldstyle';
  BOLDVARIANT['-tex-mathit'] = TexConstants_js_1.TexConstant.Variant.BOLDITALIC;
  exports.BoldsymbolMethods = {};
  exports.BoldsymbolMethods.Boldsymbol = function (parser, name) {
    var boldsymbol = parser.stack.env['boldsymbol'];
    parser.stack.env['boldsymbol'] = true;
    var mml = parser.ParseArg(name);
    parser.stack.env['boldsymbol'] = boldsymbol;
    parser.Push(mml);
  };
  new SymbolMap_js_1.CommandMap('boldsymbol', {
    boldsymbol: 'Boldsymbol'
  }, exports.BoldsymbolMethods);
  function createBoldToken(factory, kind, def, text) {
    var token = NodeFactory_js_1.NodeFactory.createToken(factory, kind, def, text);
    if (kind !== 'mtext' && factory.configuration.parser.stack.env['boldsymbol']) {
      NodeUtil_js_1.default.setProperty(token, 'fixBold', true);
      factory.configuration.addNode('fixBold', token);
    }
    return token;
  }
  exports.createBoldToken = createBoldToken;
  function rewriteBoldTokens(arg) {
    var e_1, _a;
    try {
      for (var _b = __values(arg.data.getList('fixBold')), _c = _b.next(); !_c.done; _c = _b.next()) {
        var node = _c.value;
        if (NodeUtil_js_1.default.getProperty(node, 'fixBold')) {
          var variant = NodeUtil_js_1.default.getAttribute(node, 'mathvariant');
          if (variant == null) {
            NodeUtil_js_1.default.setAttribute(node, 'mathvariant', TexConstants_js_1.TexConstant.Variant.BOLD);
          } else {
            NodeUtil_js_1.default.setAttribute(node, 'mathvariant', BOLDVARIANT[variant] || variant);
          }
          NodeUtil_js_1.default.removeProperties(node, 'fixBold');
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  }
  exports.rewriteBoldTokens = rewriteBoldTokens;
  exports.BoldsymbolConfiguration = Configuration_js_1.Configuration.create('boldsymbol', {
    handler: {
      macro: ['boldsymbol']
    },
    nodes: {
      'token': createBoldToken
    },
    postprocessors: [rewriteBoldTokens]
  });
})(BoldsymbolConfiguration);
getDefaultExportFromCjs(BoldsymbolConfiguration);

var BraketConfiguration = {};

var BraketItems = {};

var __extends$a = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __importDefault$t = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BraketItems, "__esModule", {
  value: true
});
BraketItems.BraketItem = void 0;
var StackItem_js_1$3 = StackItem;
var MmlNode_js_1$4 = MmlNode;
var ParseUtil_js_1$8 = __importDefault$t(ParseUtil$1);
var BraketItem = (function (_super) {
  __extends$a(BraketItem, _super);
  function BraketItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(BraketItem.prototype, "kind", {
    get: function () {
      return 'braket';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BraketItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  BraketItem.prototype.checkItem = function (item) {
    if (item.isKind('close')) {
      return [[this.factory.create('mml', this.toMml())], true];
    }
    if (item.isKind('mml')) {
      this.Push(item.toMml());
      if (this.getProperty('single')) {
        return [[this.toMml()], true];
      }
      return StackItem_js_1$3.BaseItem.fail;
    }
    return _super.prototype.checkItem.call(this, item);
  };
  BraketItem.prototype.toMml = function () {
    var inner = _super.prototype.toMml.call(this);
    var open = this.getProperty('open');
    var close = this.getProperty('close');
    if (this.getProperty('stretchy')) {
      return ParseUtil_js_1$8.default.fenced(this.factory.configuration, open, inner, close);
    }
    var attrs = {
      fence: true,
      stretchy: false,
      symmetric: true,
      texClass: MmlNode_js_1$4.TEXCLASS.OPEN
    };
    var openNode = this.create('token', 'mo', attrs, open);
    attrs.texClass = MmlNode_js_1$4.TEXCLASS.CLOSE;
    var closeNode = this.create('token', 'mo', attrs, close);
    var mrow = this.create('node', 'mrow', [openNode, inner, closeNode], {
      open: open,
      close: close,
      texClass: MmlNode_js_1$4.TEXCLASS.INNER
    });
    return mrow;
  };
  return BraketItem;
})(StackItem_js_1$3.BaseItem);
BraketItems.BraketItem = BraketItem;

var BraketMappings = {};

var BraketMethods$1 = {};

var __importDefault$s = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BraketMethods$1, "__esModule", {
  value: true
});
var BaseMethods_js_1$5 = __importDefault$s(BaseMethods$1);
var MmlNode_js_1$3 = MmlNode;
var TexError_js_1$c = __importDefault$s(TexError$1);
var BraketMethods = {};
BraketMethods.Macro = BaseMethods_js_1$5.default.Macro;
BraketMethods.Braket = function (parser, _name, open, close, stretchy, barmax) {
  var next = parser.GetNext();
  if (next === '') {
    throw new TexError_js_1$c.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
  }
  var single = true;
  if (next === '{') {
    parser.i++;
    single = false;
  }
  parser.Push(parser.itemFactory.create('braket').setProperties({
    barmax: barmax,
    barcount: 0,
    open: open,
    close: close,
    stretchy: stretchy,
    single: single
  }));
};
BraketMethods.Bar = function (parser, name) {
  var c = name === '|' ? '|' : '\u2225';
  var top = parser.stack.Top();
  if (top.kind !== 'braket' || top.getProperty('barcount') >= top.getProperty('barmax')) {
    var mml = parser.create('token', 'mo', {
      texClass: MmlNode_js_1$3.TEXCLASS.ORD,
      stretchy: false
    }, c);
    parser.Push(mml);
    return;
  }
  if (c === '|' && parser.GetNext() === '|') {
    parser.i++;
    c = '\u2225';
  }
  var stretchy = top.getProperty('stretchy');
  if (!stretchy) {
    var node_1 = parser.create('token', 'mo', {
      stretchy: false,
      braketbar: true
    }, c);
    parser.Push(node_1);
    return;
  }
  var node = parser.create('node', 'TeXAtom', [], {
    texClass: MmlNode_js_1$3.TEXCLASS.CLOSE
  });
  parser.Push(node);
  top.setProperty('barcount', top.getProperty('barcount') + 1);
  node = parser.create('token', 'mo', {
    stretchy: true,
    braketbar: true
  }, c);
  parser.Push(node);
  node = parser.create('node', 'TeXAtom', [], {
    texClass: MmlNode_js_1$3.TEXCLASS.OPEN
  });
  parser.Push(node);
};
BraketMethods$1.default = BraketMethods;

var __importDefault$r = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BraketMappings, "__esModule", {
  value: true
});
var SymbolMap_js_1$e = SymbolMap;
var BraketMethods_js_1 = __importDefault$r(BraketMethods$1);
new SymbolMap_js_1$e.CommandMap('Braket-macros', {
  bra: ['Macro', '{\\langle {#1} \\vert}', 1],
  ket: ['Macro', '{\\vert {#1} \\rangle}', 1],
  braket: ['Braket', '\u27E8', '\u27E9', false, Infinity],
  'set': ['Braket', '{', '}', false, 1],
  Bra: ['Macro', '{\\left\\langle {#1} \\right\\vert}', 1],
  Ket: ['Macro', '{\\left\\vert {#1} \\right\\rangle}', 1],
  Braket: ['Braket', '\u27E8', '\u27E9', true, Infinity],
  Set: ['Braket', '{', '}', true, 1],
  ketbra: ['Macro', '{\\vert {#1} \\rangle\\langle {#2} \\vert}', 2],
  Ketbra: ['Macro', '{\\left\\vert {#1} \\right\\rangle\\left\\langle {#2} \\right\\vert}', 2],
  '|': 'Bar'
}, BraketMethods_js_1.default);
new SymbolMap_js_1$e.MacroMap('Braket-characters', {
  '|': 'Bar'
}, BraketMethods_js_1.default);

var _a$5;
Object.defineProperty(BraketConfiguration, "__esModule", {
  value: true
});
BraketConfiguration.BraketConfiguration = void 0;
var Configuration_js_1$g = Configuration;
var BraketItems_js_1 = BraketItems;
BraketConfiguration.BraketConfiguration = Configuration_js_1$g.Configuration.create('braket', {
  handler: {
    character: ['Braket-characters'],
    macro: ['Braket-macros']
  },
  items: (_a$5 = {}, _a$5[BraketItems_js_1.BraketItem.prototype.kind] = BraketItems_js_1.BraketItem, _a$5)
});

var BussproofsConfiguration = {};

var BussproofsItems = {};

var BussproofsUtil$2 = {};

(function (exports) {
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  var _a;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.clearDocument = exports.saveDocument = exports.makeBsprAttributes = exports.removeProperty = exports.getProperty = exports.setProperty = exports.balanceRules = void 0;
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var doc = null;
  var item = null;
  var getBBox = function (node) {
    item.root = node;
    var width = doc.outputJax.getBBox(item, doc).w;
    return width;
  };
  var getRule = function (node) {
    var i = 0;
    while (node && !NodeUtil_js_1.default.isType(node, 'mtable')) {
      if (NodeUtil_js_1.default.isType(node, 'text')) {
        return null;
      }
      if (NodeUtil_js_1.default.isType(node, 'mrow')) {
        node = node.childNodes[0];
        i = 0;
        continue;
      }
      node = node.parent.childNodes[i];
      i++;
    }
    return node;
  };
  var getPremises = function (rule, direction) {
    return rule.childNodes[direction === 'up' ? 1 : 0].childNodes[0].childNodes[0].childNodes[0].childNodes[0];
  };
  var getPremise = function (premises, n) {
    return premises.childNodes[n].childNodes[0].childNodes[0];
  };
  var firstPremise = function (premises) {
    return getPremise(premises, 0);
  };
  var lastPremise = function (premises) {
    return getPremise(premises, premises.childNodes.length - 1);
  };
  var getConclusion = function (rule, direction) {
    return rule.childNodes[direction === 'up' ? 0 : 1].childNodes[0].childNodes[0].childNodes[0];
  };
  var getColumn = function (inf) {
    while (inf && !NodeUtil_js_1.default.isType(inf, 'mtd')) {
      inf = inf.parent;
    }
    return inf;
  };
  var nextSibling = function (inf) {
    return inf.parent.childNodes[inf.parent.childNodes.indexOf(inf) + 1];
  };
  var getParentInf = function (inf) {
    while (inf && (0, exports.getProperty)(inf, 'inference') == null) {
      inf = inf.parent;
    }
    return inf;
  };
  var getSpaces = function (inf, rule, right) {
    if (right === void 0) {
      right = false;
    }
    var result = 0;
    if (inf === rule) {
      return result;
    }
    if (inf !== rule.parent) {
      var children_1 = inf.childNodes;
      var index_1 = right ? children_1.length - 1 : 0;
      if (NodeUtil_js_1.default.isType(children_1[index_1], 'mspace')) {
        result += getBBox(children_1[index_1]);
      }
      inf = rule.parent;
    }
    if (inf === rule) {
      return result;
    }
    var children = inf.childNodes;
    var index = right ? children.length - 1 : 0;
    if (children[index] !== rule) {
      result += getBBox(children[index]);
    }
    return result;
  };
  var adjustValue = function (inf, right) {
    if (right === void 0) {
      right = false;
    }
    var rule = getRule(inf);
    var conc = getConclusion(rule, (0, exports.getProperty)(rule, 'inferenceRule'));
    var w = getSpaces(inf, rule, right);
    var x = getBBox(rule);
    var y = getBBox(conc);
    return w + (x - y) / 2;
  };
  var addSpace = function (config, inf, space, right) {
    if (right === void 0) {
      right = false;
    }
    if ((0, exports.getProperty)(inf, 'inferenceRule') || (0, exports.getProperty)(inf, 'labelledRule')) {
      var mrow = config.nodeFactory.create('node', 'mrow');
      inf.parent.replaceChild(mrow, inf);
      mrow.setChildren([inf]);
      moveProperties(inf, mrow);
      inf = mrow;
    }
    var index = right ? inf.childNodes.length - 1 : 0;
    var mspace = inf.childNodes[index];
    if (NodeUtil_js_1.default.isType(mspace, 'mspace')) {
      NodeUtil_js_1.default.setAttribute(mspace, 'width', ParseUtil_js_1.default.Em(ParseUtil_js_1.default.dimen2em(NodeUtil_js_1.default.getAttribute(mspace, 'width')) + space));
      return;
    }
    mspace = config.nodeFactory.create('node', 'mspace', [], {
      width: ParseUtil_js_1.default.Em(space)
    });
    if (right) {
      inf.appendChild(mspace);
      return;
    }
    mspace.parent = inf;
    inf.childNodes.unshift(mspace);
  };
  var moveProperties = function (src, dest) {
    var props = ['inference', 'proof', 'maxAdjust', 'labelledRule'];
    props.forEach(function (x) {
      var value = (0, exports.getProperty)(src, x);
      if (value != null) {
        (0, exports.setProperty)(dest, x, value);
        (0, exports.removeProperty)(src, x);
      }
    });
  };
  var adjustSequents = function (config) {
    var sequents = config.nodeLists['sequent'];
    if (!sequents) {
      return;
    }
    for (var i = sequents.length - 1, seq = void 0; seq = sequents[i]; i--) {
      if ((0, exports.getProperty)(seq, 'sequentProcessed')) {
        (0, exports.removeProperty)(seq, 'sequentProcessed');
        continue;
      }
      var collect = [];
      var inf = getParentInf(seq);
      if ((0, exports.getProperty)(inf, 'inference') !== 1) {
        continue;
      }
      collect.push(seq);
      while ((0, exports.getProperty)(inf, 'inference') === 1) {
        inf = getRule(inf);
        var premise = firstPremise(getPremises(inf, (0, exports.getProperty)(inf, 'inferenceRule')));
        var sequent = (0, exports.getProperty)(premise, 'inferenceRule') ? getConclusion(premise, (0, exports.getProperty)(premise, 'inferenceRule')) : premise;
        if ((0, exports.getProperty)(sequent, 'sequent')) {
          seq = sequent.childNodes[0];
          collect.push(seq);
          (0, exports.setProperty)(seq, 'sequentProcessed', true);
        }
        inf = premise;
      }
      adjustSequentPairwise(config, collect);
    }
  };
  var addSequentSpace = function (config, sequent, position, direction, width) {
    var mspace = config.nodeFactory.create('node', 'mspace', [], {
      width: ParseUtil_js_1.default.Em(width)
    });
    if (direction === 'left') {
      var row = sequent.childNodes[position].childNodes[0];
      mspace.parent = row;
      row.childNodes.unshift(mspace);
    } else {
      sequent.childNodes[position].appendChild(mspace);
    }
    (0, exports.setProperty)(sequent.parent, 'sequentAdjust_' + direction, width);
  };
  var adjustSequentPairwise = function (config, sequents) {
    var top = sequents.pop();
    while (sequents.length) {
      var bottom = sequents.pop();
      var _a = __read(compareSequents(top, bottom), 2), left = _a[0], right = _a[1];
      if ((0, exports.getProperty)(top.parent, 'axiom')) {
        addSequentSpace(config, left < 0 ? top : bottom, 0, 'left', Math.abs(left));
        addSequentSpace(config, right < 0 ? top : bottom, 2, 'right', Math.abs(right));
      }
      top = bottom;
    }
  };
  var compareSequents = function (top, bottom) {
    var tr = getBBox(top.childNodes[2]);
    var br = getBBox(bottom.childNodes[2]);
    var tl = getBBox(top.childNodes[0]);
    var bl = getBBox(bottom.childNodes[0]);
    var dl = tl - bl;
    var dr = tr - br;
    return [dl, dr];
  };
  var balanceRules = function (arg) {
    var e_1, _a;
    item = new arg.document.options.MathItem('', null, arg.math.display);
    var config = arg.data;
    adjustSequents(config);
    var inferences = config.nodeLists['inference'] || [];
    try {
      for (var inferences_1 = __values(inferences), inferences_1_1 = inferences_1.next(); !inferences_1_1.done; inferences_1_1 = inferences_1.next()) {
        var inf = inferences_1_1.value;
        var isProof = (0, exports.getProperty)(inf, 'proof');
        var rule = getRule(inf);
        var premises = getPremises(rule, (0, exports.getProperty)(rule, 'inferenceRule'));
        var premiseF = firstPremise(premises);
        if ((0, exports.getProperty)(premiseF, 'inference')) {
          var adjust_1 = adjustValue(premiseF);
          if (adjust_1) {
            addSpace(config, premiseF, -adjust_1);
            var w_1 = getSpaces(inf, rule, false);
            addSpace(config, inf, adjust_1 - w_1);
          }
        }
        var premiseL = lastPremise(premises);
        if ((0, exports.getProperty)(premiseL, 'inference') == null) {
          continue;
        }
        var adjust = adjustValue(premiseL, true);
        addSpace(config, premiseL, -adjust, true);
        var w = getSpaces(inf, rule, true);
        var maxAdjust = (0, exports.getProperty)(inf, 'maxAdjust');
        if (maxAdjust != null) {
          adjust = Math.max(adjust, maxAdjust);
        }
        var column = void 0;
        if (isProof || !(column = getColumn(inf))) {
          addSpace(config, (0, exports.getProperty)(inf, 'proof') ? inf : inf.parent, adjust - w, true);
          continue;
        }
        var sibling = nextSibling(column);
        if (sibling) {
          var pos = config.nodeFactory.create('node', 'mspace', [], {
            width: adjust - w + 'em'
          });
          sibling.appendChild(pos);
          inf.removeProperty('maxAdjust');
          continue;
        }
        var parentRule = getParentInf(column);
        if (!parentRule) {
          continue;
        }
        adjust = (0, exports.getProperty)(parentRule, 'maxAdjust') ? Math.max((0, exports.getProperty)(parentRule, 'maxAdjust'), adjust) : adjust;
        (0, exports.setProperty)(parentRule, 'maxAdjust', adjust);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (inferences_1_1 && !inferences_1_1.done && (_a = inferences_1.return)) _a.call(inferences_1);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  };
  exports.balanceRules = balanceRules;
  var property_prefix = 'bspr_';
  var blacklistedProperties = (_a = {}, _a[property_prefix + 'maxAdjust'] = true, _a);
  var setProperty = function (node, property, value) {
    NodeUtil_js_1.default.setProperty(node, property_prefix + property, value);
  };
  exports.setProperty = setProperty;
  var getProperty = function (node, property) {
    return NodeUtil_js_1.default.getProperty(node, property_prefix + property);
  };
  exports.getProperty = getProperty;
  var removeProperty = function (node, property) {
    node.removeProperty(property_prefix + property);
  };
  exports.removeProperty = removeProperty;
  var makeBsprAttributes = function (arg) {
    arg.data.root.walkTree(function (mml, _data) {
      var attr = [];
      mml.getPropertyNames().forEach(function (x) {
        if (!blacklistedProperties[x] && x.match(RegExp('^' + property_prefix))) {
          attr.push(x + ':' + mml.getProperty(x));
        }
      });
      if (attr.length) {
        NodeUtil_js_1.default.setAttribute(mml, 'semantics', attr.join(';'));
      }
    });
  };
  exports.makeBsprAttributes = makeBsprAttributes;
  var saveDocument = function (arg) {
    doc = arg.document;
    if (!(('getBBox' in doc.outputJax))) {
      throw Error('The bussproofs extension requires an output jax with a getBBox() method');
    }
  };
  exports.saveDocument = saveDocument;
  var clearDocument = function (_arg) {
    doc = null;
  };
  exports.clearDocument = clearDocument;
})(BussproofsUtil$2);
getDefaultExportFromCjs(BussproofsUtil$2);

var __extends$9 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __createBinding$4 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$4 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$4 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$4(result, mod, k);
  __setModuleDefault$4(result, mod);
  return result;
});
var __importDefault$q = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BussproofsItems, "__esModule", {
  value: true
});
BussproofsItems.ProofTreeItem = void 0;
var TexError_js_1$b = __importDefault$q(TexError$1);
var StackItem_js_1$2 = StackItem;
var Stack_js_1 = __importDefault$q(Stack$1);
var BussproofsUtil$1 = __importStar$4(BussproofsUtil$2);
var ProofTreeItem = (function (_super) {
  __extends$9(ProofTreeItem, _super);
  function ProofTreeItem() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.leftLabel = null;
    _this.rigthLabel = null;
    _this.innerStack = new Stack_js_1.default(_this.factory, {}, true);
    return _this;
  }
  Object.defineProperty(ProofTreeItem.prototype, "kind", {
    get: function () {
      return 'proofTree';
    },
    enumerable: false,
    configurable: true
  });
  ProofTreeItem.prototype.checkItem = function (item) {
    if (item.isKind('end') && item.getName() === 'prooftree') {
      var node = this.toMml();
      BussproofsUtil$1.setProperty(node, 'proof', true);
      return [[this.factory.create('mml', node), item], true];
    }
    if (item.isKind('stop')) {
      throw new TexError_js_1$b.default('EnvMissingEnd', 'Missing \\end{%1}', this.getName());
    }
    this.innerStack.Push(item);
    return StackItem_js_1$2.BaseItem.fail;
  };
  ProofTreeItem.prototype.toMml = function () {
    var tree = _super.prototype.toMml.call(this);
    var start = this.innerStack.Top();
    if (start.isKind('start') && !start.Size()) {
      return tree;
    }
    this.innerStack.Push(this.factory.create('stop'));
    var prefix = this.innerStack.Top().toMml();
    return this.create('node', 'mrow', [prefix, tree], {});
  };
  return ProofTreeItem;
})(StackItem_js_1$2.BaseItem);
BussproofsItems.ProofTreeItem = ProofTreeItem;

var BussproofsMappings = {};

var BussproofsMethods$1 = {};

var __createBinding$3 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$3 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$3 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$3(result, mod, k);
  __setModuleDefault$3(result, mod);
  return result;
});
var __read$5 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$2 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$p = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BussproofsMethods$1, "__esModule", {
  value: true
});
var TexError_js_1$a = __importDefault$p(TexError$1);
var TexParser_js_1$6 = __importDefault$p(TexParser$1);
var ParseUtil_js_1$7 = __importDefault$p(ParseUtil$1);
var BussproofsUtil = __importStar$3(BussproofsUtil$2);
var BussproofsMethods = {};
BussproofsMethods.Prooftree = function (parser, begin) {
  parser.Push(begin);
  var newItem = parser.itemFactory.create('proofTree').setProperties({
    name: begin.getName(),
    line: 'solid',
    currentLine: 'solid',
    rootAtTop: false
  });
  return newItem;
};
BussproofsMethods.Axiom = function (parser, name) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  var content = paddedContent(parser, parser.GetArgument(name));
  BussproofsUtil.setProperty(content, 'axiom', true);
  top.Push(content);
};
var paddedContent = function (parser, content) {
  var nodes = ParseUtil_js_1$7.default.internalMath(parser, ParseUtil_js_1$7.default.trimSpaces(content), 0);
  if (!nodes[0].childNodes[0].childNodes.length) {
    return parser.create('node', 'mrow', []);
  }
  var lpad = parser.create('node', 'mspace', [], {
    width: '.5ex'
  });
  var rpad = parser.create('node', 'mspace', [], {
    width: '.5ex'
  });
  return parser.create('node', 'mrow', __spreadArray$2(__spreadArray$2([lpad], __read$5(nodes), false), [rpad], false));
};
BussproofsMethods.Inference = function (parser, name, n) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  if (top.Size() < n) {
    throw new TexError_js_1$a.default('BadProofTree', 'Proof tree badly specified.');
  }
  var rootAtTop = top.getProperty('rootAtTop');
  var childCount = n === 1 && !top.Peek()[0].childNodes.length ? 0 : n;
  var children = [];
  do {
    if (children.length) {
      children.unshift(parser.create('node', 'mtd', [], {}));
    }
    children.unshift(parser.create('node', 'mtd', [top.Pop()], {
      'rowalign': rootAtTop ? 'top' : 'bottom'
    }));
    n--;
  } while (n > 0);
  var row = parser.create('node', 'mtr', children, {});
  var table = parser.create('node', 'mtable', [row], {
    framespacing: '0 0'
  });
  var conclusion = paddedContent(parser, parser.GetArgument(name));
  var style = top.getProperty('currentLine');
  if (style !== top.getProperty('line')) {
    top.setProperty('currentLine', top.getProperty('line'));
  }
  var rule = createRule(parser, table, [conclusion], top.getProperty('left'), top.getProperty('right'), style, rootAtTop);
  top.setProperty('left', null);
  top.setProperty('right', null);
  BussproofsUtil.setProperty(rule, 'inference', childCount);
  parser.configuration.addNode('inference', rule);
  top.Push(rule);
};
function createRule(parser, premise, conclusions, left, right, style, rootAtTop) {
  var upper = parser.create('node', 'mtr', [parser.create('node', 'mtd', [premise], {})], {});
  var lower = parser.create('node', 'mtr', [parser.create('node', 'mtd', conclusions, {})], {});
  var rule = parser.create('node', 'mtable', rootAtTop ? [lower, upper] : [upper, lower], {
    align: 'top 2',
    rowlines: style,
    framespacing: '0 0'
  });
  BussproofsUtil.setProperty(rule, 'inferenceRule', rootAtTop ? 'up' : 'down');
  var leftLabel, rightLabel;
  if (left) {
    leftLabel = parser.create('node', 'mpadded', [left], {
      height: '+.5em',
      width: '+.5em',
      voffset: '-.15em'
    });
    BussproofsUtil.setProperty(leftLabel, 'prooflabel', 'left');
  }
  if (right) {
    rightLabel = parser.create('node', 'mpadded', [right], {
      height: '+.5em',
      width: '+.5em',
      voffset: '-.15em'
    });
    BussproofsUtil.setProperty(rightLabel, 'prooflabel', 'right');
  }
  var children, label;
  if (left && right) {
    children = [leftLabel, rule, rightLabel];
    label = 'both';
  } else if (left) {
    children = [leftLabel, rule];
    label = 'left';
  } else if (right) {
    children = [rule, rightLabel];
    label = 'right';
  } else {
    return rule;
  }
  rule = parser.create('node', 'mrow', children);
  BussproofsUtil.setProperty(rule, 'labelledRule', label);
  return rule;
}
BussproofsMethods.Label = function (parser, name, side) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  var content = ParseUtil_js_1$7.default.internalMath(parser, parser.GetArgument(name), 0);
  var label = content.length > 1 ? parser.create('node', 'mrow', content, {}) : content[0];
  top.setProperty(side, label);
};
BussproofsMethods.SetLine = function (parser, _name, style, always) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  top.setProperty('currentLine', style);
  if (always) {
    top.setProperty('line', style);
  }
};
BussproofsMethods.RootAtTop = function (parser, _name, where) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  top.setProperty('rootAtTop', where);
};
BussproofsMethods.AxiomF = function (parser, name) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  var line = parseFCenterLine(parser, name);
  BussproofsUtil.setProperty(line, 'axiom', true);
  top.Push(line);
};
function parseFCenterLine(parser, name) {
  var dollar = parser.GetNext();
  if (dollar !== '$') {
    throw new TexError_js_1$a.default('IllegalUseOfCommand', 'Use of %1 does not match it\'s definition.', name);
  }
  parser.i++;
  var axiom = parser.GetUpTo(name, '$');
  if (axiom.indexOf('\\fCenter') === -1) {
    throw new TexError_js_1$a.default('IllegalUseOfCommand', 'Missing \\fCenter in %1.', name);
  }
  var _a = __read$5(axiom.split('\\fCenter'), 2), prem = _a[0], conc = _a[1];
  var premise = new TexParser_js_1$6.default(prem, parser.stack.env, parser.configuration).mml();
  var conclusion = new TexParser_js_1$6.default(conc, parser.stack.env, parser.configuration).mml();
  var fcenter = new TexParser_js_1$6.default('\\fCenter', parser.stack.env, parser.configuration).mml();
  var left = parser.create('node', 'mtd', [premise], {});
  var middle = parser.create('node', 'mtd', [fcenter], {});
  var right = parser.create('node', 'mtd', [conclusion], {});
  var row = parser.create('node', 'mtr', [left, middle, right], {});
  var table = parser.create('node', 'mtable', [row], {
    columnspacing: '.5ex',
    columnalign: 'center 2'
  });
  BussproofsUtil.setProperty(table, 'sequent', true);
  parser.configuration.addNode('sequent', row);
  return table;
}
BussproofsMethods.FCenter = function (_parser, _name) {};
BussproofsMethods.InferenceF = function (parser, name, n) {
  var top = parser.stack.Top();
  if (top.kind !== 'proofTree') {
    throw new TexError_js_1$a.default('IllegalProofCommand', 'Proof commands only allowed in prooftree environment.');
  }
  if (top.Size() < n) {
    throw new TexError_js_1$a.default('BadProofTree', 'Proof tree badly specified.');
  }
  var rootAtTop = top.getProperty('rootAtTop');
  var childCount = n === 1 && !top.Peek()[0].childNodes.length ? 0 : n;
  var children = [];
  do {
    if (children.length) {
      children.unshift(parser.create('node', 'mtd', [], {}));
    }
    children.unshift(parser.create('node', 'mtd', [top.Pop()], {
      'rowalign': rootAtTop ? 'top' : 'bottom'
    }));
    n--;
  } while (n > 0);
  var row = parser.create('node', 'mtr', children, {});
  var table = parser.create('node', 'mtable', [row], {
    framespacing: '0 0'
  });
  var conclusion = parseFCenterLine(parser, name);
  var style = top.getProperty('currentLine');
  if (style !== top.getProperty('line')) {
    top.setProperty('currentLine', top.getProperty('line'));
  }
  var rule = createRule(parser, table, [conclusion], top.getProperty('left'), top.getProperty('right'), style, rootAtTop);
  top.setProperty('left', null);
  top.setProperty('right', null);
  BussproofsUtil.setProperty(rule, 'inference', childCount);
  parser.configuration.addNode('inference', rule);
  top.Push(rule);
};
BussproofsMethods$1.default = BussproofsMethods;

var __importDefault$o = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(BussproofsMappings, "__esModule", {
  value: true
});
var BussproofsMethods_js_1 = __importDefault$o(BussproofsMethods$1);
var ParseMethods_js_1$4 = __importDefault$o(ParseMethods$1);
var SymbolMap_js_1$d = SymbolMap;
new SymbolMap_js_1$d.CommandMap('Bussproofs-macros', {
  AxiomC: 'Axiom',
  UnaryInfC: ['Inference', 1],
  BinaryInfC: ['Inference', 2],
  TrinaryInfC: ['Inference', 3],
  QuaternaryInfC: ['Inference', 4],
  QuinaryInfC: ['Inference', 5],
  RightLabel: ['Label', 'right'],
  LeftLabel: ['Label', 'left'],
  AXC: 'Axiom',
  UIC: ['Inference', 1],
  BIC: ['Inference', 2],
  TIC: ['Inference', 3],
  RL: ['Label', 'right'],
  LL: ['Label', 'left'],
  noLine: ['SetLine', 'none', false],
  singleLine: ['SetLine', 'solid', false],
  solidLine: ['SetLine', 'solid', false],
  dashedLine: ['SetLine', 'dashed', false],
  alwaysNoLine: ['SetLine', 'none', true],
  alwaysSingleLine: ['SetLine', 'solid', true],
  alwaysSolidLine: ['SetLine', 'solid', true],
  alwaysDashedLine: ['SetLine', 'dashed', true],
  rootAtTop: ['RootAtTop', true],
  alwaysRootAtTop: ['RootAtTop', true],
  rootAtBottom: ['RootAtTop', false],
  alwaysRootAtBottom: ['RootAtTop', false],
  fCenter: 'FCenter',
  Axiom: 'AxiomF',
  UnaryInf: ['InferenceF', 1],
  BinaryInf: ['InferenceF', 2],
  TrinaryInf: ['InferenceF', 3],
  QuaternaryInf: ['InferenceF', 4],
  QuinaryInf: ['InferenceF', 5]
}, BussproofsMethods_js_1.default);
new SymbolMap_js_1$d.EnvironmentMap('Bussproofs-environments', ParseMethods_js_1$4.default.environment, {
  prooftree: ['Prooftree', null, false]
}, BussproofsMethods_js_1.default);

var _a$4;
Object.defineProperty(BussproofsConfiguration, "__esModule", {
  value: true
});
BussproofsConfiguration.BussproofsConfiguration = void 0;
var Configuration_js_1$f = Configuration;
var BussproofsItems_js_1 = BussproofsItems;
var BussproofsUtil_js_1 = BussproofsUtil$2;
BussproofsConfiguration.BussproofsConfiguration = Configuration_js_1$f.Configuration.create('bussproofs', {
  handler: {
    macro: ['Bussproofs-macros'],
    environment: ['Bussproofs-environments']
  },
  items: (_a$4 = {}, _a$4[BussproofsItems_js_1.ProofTreeItem.prototype.kind] = BussproofsItems_js_1.ProofTreeItem, _a$4),
  preprocessors: [[BussproofsUtil_js_1.saveDocument, 1]],
  postprocessors: [[BussproofsUtil_js_1.clearDocument, 3], [BussproofsUtil_js_1.makeBsprAttributes, 2], [BussproofsUtil_js_1.balanceRules, 1]]
});

var CancelConfiguration = {};

var EncloseConfiguration = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.EncloseConfiguration = exports.EncloseMethods = exports.ENCLOSE_OPTIONS = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  exports.ENCLOSE_OPTIONS = {
    'data-arrowhead': 1,
    color: 1,
    mathcolor: 1,
    background: 1,
    mathbackground: 1,
    'data-padding': 1,
    'data-thickness': 1
  };
  exports.EncloseMethods = {};
  exports.EncloseMethods.Enclose = function (parser, name) {
    var notation = parser.GetArgument(name).replace(/,/g, ' ');
    var attr = parser.GetBrackets(name, '');
    var math = parser.ParseArg(name);
    var def = ParseUtil_js_1.default.keyvalOptions(attr, exports.ENCLOSE_OPTIONS);
    def.notation = notation;
    parser.Push(parser.create('node', 'menclose', [math], def));
  };
  new SymbolMap_js_1.CommandMap('enclose', {
    enclose: 'Enclose'
  }, exports.EncloseMethods);
  exports.EncloseConfiguration = Configuration_js_1.Configuration.create('enclose', {
    handler: {
      macro: ['enclose']
    }
  });
})(EncloseConfiguration);
getDefaultExportFromCjs(EncloseConfiguration);

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CancelConfiguration = exports.CancelMethods = void 0;
  var Configuration_js_1 = Configuration;
  var TexConstants_js_1 = TexConstants;
  var SymbolMap_js_1 = SymbolMap;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var EncloseConfiguration_js_1 = EncloseConfiguration;
  exports.CancelMethods = {};
  exports.CancelMethods.Cancel = function (parser, name, notation) {
    var attr = parser.GetBrackets(name, '');
    var math = parser.ParseArg(name);
    var def = ParseUtil_js_1.default.keyvalOptions(attr, EncloseConfiguration_js_1.ENCLOSE_OPTIONS);
    def['notation'] = notation;
    parser.Push(parser.create('node', 'menclose', [math], def));
  };
  exports.CancelMethods.CancelTo = function (parser, name) {
    var attr = parser.GetBrackets(name, '');
    var value = parser.ParseArg(name);
    var math = parser.ParseArg(name);
    var def = ParseUtil_js_1.default.keyvalOptions(attr, EncloseConfiguration_js_1.ENCLOSE_OPTIONS);
    def['notation'] = [TexConstants_js_1.TexConstant.Notation.UPDIAGONALSTRIKE, TexConstants_js_1.TexConstant.Notation.UPDIAGONALARROW, TexConstants_js_1.TexConstant.Notation.NORTHEASTARROW].join(' ');
    value = parser.create('node', 'mpadded', [value], {
      depth: '-.1em',
      height: '+.1em',
      voffset: '.1em'
    });
    parser.Push(parser.create('node', 'msup', [parser.create('node', 'menclose', [math], def), value]));
  };
  new SymbolMap_js_1.CommandMap('cancel', {
    cancel: ['Cancel', TexConstants_js_1.TexConstant.Notation.UPDIAGONALSTRIKE],
    bcancel: ['Cancel', TexConstants_js_1.TexConstant.Notation.DOWNDIAGONALSTRIKE],
    xcancel: ['Cancel', TexConstants_js_1.TexConstant.Notation.UPDIAGONALSTRIKE + ' ' + TexConstants_js_1.TexConstant.Notation.DOWNDIAGONALSTRIKE],
    cancelto: 'CancelTo'
  }, exports.CancelMethods);
  exports.CancelConfiguration = Configuration_js_1.Configuration.create('cancel', {
    handler: {
      macro: ['cancel']
    }
  });
})(CancelConfiguration);
getDefaultExportFromCjs(CancelConfiguration);

var CasesConfiguration = {};

var EmpheqUtil = {};

(function (exports) {
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
      if (ar || !((i in from))) {
        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
        ar[i] = from[i];
      }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.EmpheqUtil = void 0;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var TexParser_js_1 = __importDefault(TexParser$1);
  exports.EmpheqUtil = {
    environment: function (parser, env, func, args) {
      var name = args[0];
      var item = parser.itemFactory.create(name + '-begin').setProperties({
        name: env,
        end: name
      });
      parser.Push(func.apply(void 0, __spreadArray([parser, item], __read(args.slice(1)), false)));
    },
    splitOptions: function (text, allowed) {
      if (allowed === void 0) {
        allowed = null;
      }
      return ParseUtil_js_1.default.keyvalOptions(text, allowed, true);
    },
    columnCount: function (table) {
      var e_1, _a;
      var m = 0;
      try {
        for (var _b = __values(table.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var row = _c.value;
          var n = row.childNodes.length - (row.isKind('mlabeledtr') ? 1 : 0);
          if (n > m) m = n;
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return m;
    },
    cellBlock: function (tex, table, parser, env) {
      var e_2, _a;
      var mpadded = parser.create('node', 'mpadded', [], {
        height: 0,
        depth: 0,
        voffset: '-1height'
      });
      var result = new TexParser_js_1.default(tex, parser.stack.env, parser.configuration);
      var mml = result.mml();
      if (env && result.configuration.tags.label) {
        result.configuration.tags.currentTag.env = env;
        result.configuration.tags.getTag(true);
      }
      try {
        for (var _b = __values(mml.isInferred ? mml.childNodes : [mml]), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          mpadded.appendChild(child);
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      mpadded.appendChild(parser.create('node', 'mphantom', [parser.create('node', 'mpadded', [table], {
        width: 0
      })]));
      return mpadded;
    },
    topRowTable: function (original, parser) {
      var table = ParseUtil_js_1.default.copyNode(original, parser);
      table.setChildren(table.childNodes.slice(0, 1));
      table.attributes.set('align', 'baseline 1');
      return original.factory.create('mphantom', {}, [parser.create('node', 'mpadded', [table], {
        width: 0
      })]);
    },
    rowspanCell: function (mtd, tex, table, parser, env) {
      mtd.appendChild(parser.create('node', 'mpadded', [this.cellBlock(tex, ParseUtil_js_1.default.copyNode(table, parser), parser, env), this.topRowTable(table, parser)], {
        height: 0,
        depth: 0,
        voffset: 'height'
      }));
    },
    left: function (table, original, left, parser, env) {
      var e_3, _a;
      if (env === void 0) {
        env = '';
      }
      table.attributes.set('columnalign', 'right ' + (table.attributes.get('columnalign') || ''));
      table.attributes.set('columnspacing', '0em ' + (table.attributes.get('columnspacing') || ''));
      var mtd;
      try {
        for (var _b = __values(table.childNodes.slice(0).reverse()), _c = _b.next(); !_c.done; _c = _b.next()) {
          var row = _c.value;
          mtd = parser.create('node', 'mtd');
          row.childNodes.unshift(mtd);
          mtd.parent = row;
          if (row.isKind('mlabeledtr')) {
            row.childNodes[0] = row.childNodes[1];
            row.childNodes[1] = mtd;
          }
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      this.rowspanCell(mtd, left, original, parser, env);
    },
    right: function (table, original, right, parser, env) {
      if (env === void 0) {
        env = '';
      }
      if (table.childNodes.length === 0) {
        table.appendChild(parser.create('node', 'mtr'));
      }
      var m = exports.EmpheqUtil.columnCount(table);
      var row = table.childNodes[0];
      while (row.childNodes.length < m) row.appendChild(parser.create('node', 'mtd'));
      var mtd = row.appendChild(parser.create('node', 'mtd'));
      exports.EmpheqUtil.rowspanCell(mtd, right, original, parser, env);
      table.attributes.set('columnalign', (table.attributes.get('columnalign') || '').split(/ /).slice(0, m).join(' ') + ' left');
      table.attributes.set('columnspacing', (table.attributes.get('columnspacing') || '').split(/ /).slice(0, m - 1).join(' ') + ' 0em');
    },
    adjustTable: function (empheq, parser) {
      var left = empheq.getProperty('left');
      var right = empheq.getProperty('right');
      if (left || right) {
        var table = empheq.Last;
        var original = ParseUtil_js_1.default.copyNode(table, parser);
        if (left) this.left(table, original, left, parser);
        if (right) this.right(table, original, right, parser);
      }
    },
    allowEnv: {
      equation: true,
      align: true,
      gather: true,
      flalign: true,
      alignat: true,
      multline: true
    },
    checkEnv: function (env) {
      return this.allowEnv.hasOwnProperty(env.replace(/\*$/, '')) || false;
    }
  };
})(EmpheqUtil);
getDefaultExportFromCjs(EmpheqUtil);

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  var _a;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.CasesConfiguration = exports.CasesMethods = exports.CasesTags = exports.CasesBeginItem = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var BaseMethods_js_1 = __importDefault(BaseMethods$1);
  var TexError_js_1 = __importDefault(TexError$1);
  var BaseItems_js_1 = BaseItems;
  var AmsConfiguration_js_1 = AmsConfiguration;
  var EmpheqUtil_js_1 = EmpheqUtil;
  var CasesBeginItem = (function (_super) {
    __extends(CasesBeginItem, _super);
    function CasesBeginItem() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(CasesBeginItem.prototype, "kind", {
      get: function () {
        return 'cases-begin';
      },
      enumerable: false,
      configurable: true
    });
    CasesBeginItem.prototype.checkItem = function (item) {
      if (item.isKind('end') && item.getName() === this.getName()) {
        if (this.getProperty('end')) {
          this.setProperty('end', false);
          return [[], true];
        }
      }
      return _super.prototype.checkItem.call(this, item);
    };
    return CasesBeginItem;
  })(BaseItems_js_1.BeginItem);
  exports.CasesBeginItem = CasesBeginItem;
  var CasesTags = (function (_super) {
    __extends(CasesTags, _super);
    function CasesTags() {
      var _this = _super !== null && _super.apply(this, arguments) || this;
      _this.subcounter = 0;
      return _this;
    }
    CasesTags.prototype.start = function (env, taggable, defaultTags) {
      this.subcounter = 0;
      _super.prototype.start.call(this, env, taggable, defaultTags);
    };
    CasesTags.prototype.autoTag = function () {
      if (this.currentTag.tag != null) return;
      if (this.currentTag.env === 'subnumcases') {
        if (this.subcounter === 0) this.counter++;
        this.subcounter++;
        this.tag(this.formatNumber(this.counter, this.subcounter), false);
      } else {
        if (this.subcounter === 0 || this.currentTag.env !== 'numcases-left') this.counter++;
        this.tag(this.formatNumber(this.counter), false);
      }
    };
    CasesTags.prototype.formatNumber = function (n, m) {
      if (m === void 0) {
        m = null;
      }
      return n.toString() + (m === null ? '' : String.fromCharCode(0x60 + m));
    };
    return CasesTags;
  })(AmsConfiguration_js_1.AmsTags);
  exports.CasesTags = CasesTags;
  exports.CasesMethods = {
    NumCases: function (parser, begin) {
      if (parser.stack.env.closing === begin.getName()) {
        delete parser.stack.env.closing;
        parser.Push(parser.itemFactory.create('end').setProperty('name', begin.getName()));
        var cases = parser.stack.Top();
        var table = cases.Last;
        var original = ParseUtil_js_1.default.copyNode(table, parser);
        var left = cases.getProperty('left');
        EmpheqUtil_js_1.EmpheqUtil.left(table, original, left + '\\empheqlbrace\\,', parser, 'numcases-left');
        parser.Push(parser.itemFactory.create('end').setProperty('name', begin.getName()));
        return null;
      } else {
        var left = parser.GetArgument('\\begin{' + begin.getName() + '}');
        begin.setProperty('left', left);
        var array = BaseMethods_js_1.default.EqnArray(parser, begin, true, true, 'll');
        array.arraydef.displaystyle = false;
        array.arraydef.rowspacing = '.2em';
        array.setProperty('numCases', true);
        parser.Push(begin);
        return array;
      }
    },
    Entry: function (parser, name) {
      if (!parser.stack.Top().getProperty('numCases')) {
        return BaseMethods_js_1.default.Entry(parser, name);
      }
      parser.Push(parser.itemFactory.create('cell').setProperties({
        isEntry: true,
        name: name
      }));
      var tex = parser.string;
      var braces = 0, i = parser.i, m = tex.length;
      while (i < m) {
        var c = tex.charAt(i);
        if (c === '{') {
          braces++;
          i++;
        } else if (c === '}') {
          if (braces === 0) {
            break;
          } else {
            braces--;
            i++;
          }
        } else if (c === '&' && braces === 0) {
          throw new TexError_js_1.default('ExtraCasesAlignTab', 'Extra alignment tab in text for numcase environment');
        } else if (c === '\\' && braces === 0) {
          var cs = (tex.slice(i + 1).match(/^[a-z]+|./i) || [])[0];
          if (cs === '\\' || cs === 'cr' || cs === 'end' || cs === 'label') {
            break;
          } else {
            i += cs.length;
          }
        } else {
          i++;
        }
      }
      var text = tex.substr(parser.i, i - parser.i).replace(/^\s*/, '');
      parser.PushAll(ParseUtil_js_1.default.internalMath(parser, text, 0));
      parser.i = i;
    }
  };
  new SymbolMap_js_1.EnvironmentMap('cases-env', EmpheqUtil_js_1.EmpheqUtil.environment, {
    numcases: ['NumCases', 'cases'],
    subnumcases: ['NumCases', 'cases']
  }, exports.CasesMethods);
  new SymbolMap_js_1.MacroMap('cases-macros', {
    '&': 'Entry'
  }, exports.CasesMethods);
  exports.CasesConfiguration = Configuration_js_1.Configuration.create('cases', {
    handler: {
      environment: ['cases-env'],
      character: ['cases-macros']
    },
    items: (_a = {}, _a[CasesBeginItem.prototype.kind] = CasesBeginItem, _a),
    tags: {
      'cases': CasesTags
    }
  });
})(CasesConfiguration);
getDefaultExportFromCjs(CasesConfiguration);

var CenternotConfiguration = {};

var __values$6 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$n = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(CenternotConfiguration, "__esModule", {
  value: true
});
CenternotConfiguration.CenternotConfiguration = CenternotConfiguration.filterCenterOver = void 0;
var Configuration_js_1$e = Configuration;
var TexParser_js_1$5 = __importDefault$n(TexParser$1);
var NodeUtil_js_1$5 = __importDefault$n(NodeUtil$1);
var SymbolMap_js_1$c = SymbolMap;
var BaseMethods_js_1$4 = __importDefault$n(BaseMethods$1);
new SymbolMap_js_1$c.CommandMap('centernot', {
  centerOver: 'CenterOver',
  centernot: ['Macro', '\\centerOver{#1}{{\u29F8}}', 1]
}, {
  CenterOver: function (parser, name) {
    var arg = '{' + parser.GetArgument(name) + '}';
    var over = parser.ParseArg(name);
    var base = new TexParser_js_1$5.default(arg, parser.stack.env, parser.configuration).mml();
    var mml = parser.create('node', 'TeXAtom', [new TexParser_js_1$5.default(arg, parser.stack.env, parser.configuration).mml(), parser.create('node', 'mpadded', [parser.create('node', 'mpadded', [over], {
      width: 0,
      lspace: '-.5width'
    }), parser.create('node', 'mphantom', [base])], {
      width: 0,
      lspace: '-.5width'
    })]);
    parser.configuration.addNode('centerOver', base);
    parser.Push(mml);
  },
  Macro: BaseMethods_js_1$4.default.Macro
});
function filterCenterOver(_a) {
  var e_1, _b;
  var data = _a.data;
  try {
    for (var _c = __values$6(data.getList('centerOver')), _d = _c.next(); !_d.done; _d = _c.next()) {
      var base = _d.value;
      var texClass = NodeUtil_js_1$5.default.getTexClass(base.childNodes[0].childNodes[0]);
      if (texClass !== null) {
        NodeUtil_js_1$5.default.setProperties(base.parent.parent.parent.parent.parent.parent, {
          texClass: texClass
        });
      }
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
}
CenternotConfiguration.filterCenterOver = filterCenterOver;
CenternotConfiguration.CenternotConfiguration = Configuration_js_1$e.Configuration.create('centernot', {
  handler: {
    macro: ['centernot']
  },
  postprocessors: [filterCenterOver]
});

var ColorConfiguration = {};

var ColorMethods = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ColorMethods = void 0;
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  function padding(colorPadding) {
    var pad = ("+").concat(colorPadding);
    var unit = colorPadding.replace(/^.*?([a-z]*)$/, '$1');
    var pad2 = 2 * parseFloat(pad);
    return {
      width: ("+").concat(pad2).concat(unit),
      height: pad,
      depth: pad,
      lspace: colorPadding
    };
  }
  exports.ColorMethods = {};
  exports.ColorMethods.Color = function (parser, name) {
    var model = parser.GetBrackets(name, '');
    var colorDef = parser.GetArgument(name);
    var colorModel = parser.configuration.packageData.get('color').model;
    var color = colorModel.getColor(model, colorDef);
    var style = parser.itemFactory.create('style').setProperties({
      styles: {
        mathcolor: color
      }
    });
    parser.stack.env['color'] = color;
    parser.Push(style);
  };
  exports.ColorMethods.TextColor = function (parser, name) {
    var model = parser.GetBrackets(name, '');
    var colorDef = parser.GetArgument(name);
    var colorModel = parser.configuration.packageData.get('color').model;
    var color = colorModel.getColor(model, colorDef);
    var old = parser.stack.env['color'];
    parser.stack.env['color'] = color;
    var math = parser.ParseArg(name);
    if (old) {
      parser.stack.env['color'] = old;
    } else {
      delete parser.stack.env['color'];
    }
    var node = parser.create('node', 'mstyle', [math], {
      mathcolor: color
    });
    parser.Push(node);
  };
  exports.ColorMethods.DefineColor = function (parser, name) {
    var cname = parser.GetArgument(name);
    var model = parser.GetArgument(name);
    var def = parser.GetArgument(name);
    var colorModel = parser.configuration.packageData.get('color').model;
    colorModel.defineColor(model, cname, def);
  };
  exports.ColorMethods.ColorBox = function (parser, name) {
    var cname = parser.GetArgument(name);
    var math = ParseUtil_js_1.default.internalMath(parser, parser.GetArgument(name));
    var colorModel = parser.configuration.packageData.get('color').model;
    var node = parser.create('node', 'mpadded', math, {
      mathbackground: colorModel.getColor('named', cname)
    });
    NodeUtil_js_1.default.setProperties(node, padding(parser.options.color.padding));
    parser.Push(node);
  };
  exports.ColorMethods.FColorBox = function (parser, name) {
    var fname = parser.GetArgument(name);
    var cname = parser.GetArgument(name);
    var math = ParseUtil_js_1.default.internalMath(parser, parser.GetArgument(name));
    var options = parser.options.color;
    var colorModel = parser.configuration.packageData.get('color').model;
    var node = parser.create('node', 'mpadded', math, {
      mathbackground: colorModel.getColor('named', cname),
      style: ("border: ").concat(options.borderWidth, " solid ").concat(colorModel.getColor('named', fname))
    });
    NodeUtil_js_1.default.setProperties(node, padding(options.padding));
    parser.Push(node);
  };
})(ColorMethods);
getDefaultExportFromCjs(ColorMethods);

var ColorUtil = {};

var ColorConstants = {};

Object.defineProperty(ColorConstants, "__esModule", {
  value: true
});
ColorConstants.COLORS = void 0;
ColorConstants.COLORS = new Map([['Apricot', '#FBB982'], ['Aquamarine', '#00B5BE'], ['Bittersweet', '#C04F17'], ['Black', '#221E1F'], ['Blue', '#2D2F92'], ['BlueGreen', '#00B3B8'], ['BlueViolet', '#473992'], ['BrickRed', '#B6321C'], ['Brown', '#792500'], ['BurntOrange', '#F7921D'], ['CadetBlue', '#74729A'], ['CarnationPink', '#F282B4'], ['Cerulean', '#00A2E3'], ['CornflowerBlue', '#41B0E4'], ['Cyan', '#00AEEF'], ['Dandelion', '#FDBC42'], ['DarkOrchid', '#A4538A'], ['Emerald', '#00A99D'], ['ForestGreen', '#009B55'], ['Fuchsia', '#8C368C'], ['Goldenrod', '#FFDF42'], ['Gray', '#949698'], ['Green', '#00A64F'], ['GreenYellow', '#DFE674'], ['JungleGreen', '#00A99A'], ['Lavender', '#F49EC4'], ['LimeGreen', '#8DC73E'], ['Magenta', '#EC008C'], ['Mahogany', '#A9341F'], ['Maroon', '#AF3235'], ['Melon', '#F89E7B'], ['MidnightBlue', '#006795'], ['Mulberry', '#A93C93'], ['NavyBlue', '#006EB8'], ['OliveGreen', '#3C8031'], ['Orange', '#F58137'], ['OrangeRed', '#ED135A'], ['Orchid', '#AF72B0'], ['Peach', '#F7965A'], ['Periwinkle', '#7977B8'], ['PineGreen', '#008B72'], ['Plum', '#92268F'], ['ProcessBlue', '#00B0F0'], ['Purple', '#99479B'], ['RawSienna', '#974006'], ['Red', '#ED1B23'], ['RedOrange', '#F26035'], ['RedViolet', '#A1246B'], ['Rhodamine', '#EF559F'], ['RoyalBlue', '#0071BC'], ['RoyalPurple', '#613F99'], ['RubineRed', '#ED017D'], ['Salmon', '#F69289'], ['SeaGreen', '#3FBC9D'], ['Sepia', '#671800'], ['SkyBlue', '#46C5DD'], ['SpringGreen', '#C6DC67'], ['Tan', '#DA9D76'], ['TealBlue', '#00AEB3'], ['Thistle', '#D883B7'], ['Turquoise', '#00B4CE'], ['Violet', '#58429B'], ['VioletRed', '#EF58A0'], ['White', '#FFFFFF'], ['WildStrawberry', '#EE2967'], ['Yellow', '#FFF200'], ['YellowGreen', '#98CC70'], ['YellowOrange', '#FAA21A']]);

var __values$5 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$m = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(ColorUtil, "__esModule", {
  value: true
});
ColorUtil.ColorModel = void 0;
var TexError_js_1$9 = __importDefault$m(TexError$1);
var ColorConstants_js_1 = ColorConstants;
var ColorModelProcessors = new Map();
var ColorModel = (function () {
  function ColorModel() {
    this.userColors = new Map();
  }
  ColorModel.prototype.normalizeColor = function (model, def) {
    if (!model || model === 'named') {
      return def;
    }
    if (ColorModelProcessors.has(model)) {
      var modelProcessor = ColorModelProcessors.get(model);
      return modelProcessor(def);
    }
    throw new TexError_js_1$9.default('UndefinedColorModel', 'Color model \'%1\' not defined', model);
  };
  ColorModel.prototype.getColor = function (model, def) {
    if (!model || model === 'named') {
      return this.getColorByName(def);
    }
    return this.normalizeColor(model, def);
  };
  ColorModel.prototype.getColorByName = function (name) {
    if (this.userColors.has(name)) {
      return this.userColors.get(name);
    }
    if (ColorConstants_js_1.COLORS.has(name)) {
      return ColorConstants_js_1.COLORS.get(name);
    }
    return name;
  };
  ColorModel.prototype.defineColor = function (model, name, def) {
    var normalized = this.normalizeColor(model, def);
    this.userColors.set(name, normalized);
  };
  return ColorModel;
})();
ColorUtil.ColorModel = ColorModel;
ColorModelProcessors.set('rgb', function (rgb) {
  var e_1, _a;
  var rgbParts = rgb.trim().split(/\s*,\s*/);
  var RGB = '#';
  if (rgbParts.length !== 3) {
    throw new TexError_js_1$9.default('ModelArg1', 'Color values for the %1 model require 3 numbers', 'rgb');
  }
  try {
    for (var rgbParts_1 = __values$5(rgbParts), rgbParts_1_1 = rgbParts_1.next(); !rgbParts_1_1.done; rgbParts_1_1 = rgbParts_1.next()) {
      var rgbPart = rgbParts_1_1.value;
      if (!rgbPart.match(/^(\d+(\.\d*)?|\.\d+)$/)) {
        throw new TexError_js_1$9.default('InvalidDecimalNumber', 'Invalid decimal number');
      }
      var n = parseFloat(rgbPart);
      if (n < 0 || n > 1) {
        throw new TexError_js_1$9.default('ModelArg2', 'Color values for the %1 model must be between %2 and %3', 'rgb', '0', '1');
      }
      var pn = Math.floor(n * 255).toString(16);
      if (pn.length < 2) {
        pn = '0' + pn;
      }
      RGB += pn;
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (rgbParts_1_1 && !rgbParts_1_1.done && (_a = rgbParts_1.return)) _a.call(rgbParts_1);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
  return RGB;
});
ColorModelProcessors.set('RGB', function (rgb) {
  var e_2, _a;
  var rgbParts = rgb.trim().split(/\s*,\s*/);
  var RGB = '#';
  if (rgbParts.length !== 3) {
    throw new TexError_js_1$9.default('ModelArg1', 'Color values for the %1 model require 3 numbers', 'RGB');
  }
  try {
    for (var rgbParts_2 = __values$5(rgbParts), rgbParts_2_1 = rgbParts_2.next(); !rgbParts_2_1.done; rgbParts_2_1 = rgbParts_2.next()) {
      var rgbPart = rgbParts_2_1.value;
      if (!rgbPart.match(/^\d+$/)) {
        throw new TexError_js_1$9.default('InvalidNumber', 'Invalid number');
      }
      var n = parseInt(rgbPart);
      if (n > 255) {
        throw new TexError_js_1$9.default('ModelArg2', 'Color values for the %1 model must be between %2 and %3', 'RGB', '0', '255');
      }
      var pn = n.toString(16);
      if (pn.length < 2) {
        pn = '0' + pn;
      }
      RGB += pn;
    }
  } catch (e_2_1) {
    e_2 = {
      error: e_2_1
    };
  } finally {
    try {
      if (rgbParts_2_1 && !rgbParts_2_1.done && (_a = rgbParts_2.return)) _a.call(rgbParts_2);
    } finally {
      if (e_2) throw e_2.error;
    }
  }
  return RGB;
});
ColorModelProcessors.set('gray', function (gray) {
  if (!gray.match(/^\s*(\d+(\.\d*)?|\.\d+)\s*$/)) {
    throw new TexError_js_1$9.default('InvalidDecimalNumber', 'Invalid decimal number');
  }
  var n = parseFloat(gray);
  if (n < 0 || n > 1) {
    throw new TexError_js_1$9.default('ModelArg2', 'Color values for the %1 model must be between %2 and %3', 'gray', '0', '1');
  }
  var pn = Math.floor(n * 255).toString(16);
  if (pn.length < 2) {
    pn = '0' + pn;
  }
  return ("#").concat(pn).concat(pn).concat(pn);
});

Object.defineProperty(ColorConfiguration, "__esModule", {
  value: true
});
ColorConfiguration.ColorConfiguration = void 0;
var SymbolMap_js_1$b = SymbolMap;
var Configuration_js_1$d = Configuration;
var ColorMethods_js_1 = ColorMethods;
var ColorUtil_js_1 = ColorUtil;
new SymbolMap_js_1$b.CommandMap('color', {
  color: 'Color',
  textcolor: 'TextColor',
  definecolor: 'DefineColor',
  colorbox: 'ColorBox',
  fcolorbox: 'FColorBox'
}, ColorMethods_js_1.ColorMethods);
var config$1 = function (_config, jax) {
  jax.parseOptions.packageData.set('color', {
    model: new ColorUtil_js_1.ColorModel()
  });
};
ColorConfiguration.ColorConfiguration = Configuration_js_1$d.Configuration.create('color', {
  handler: {
    macro: ['color']
  },
  options: {
    color: {
      padding: '5px',
      borderWidth: '2px'
    }
  },
  config: config$1
});

var ColorV2Configuration = {};

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ColorConfiguration = exports.ColorV2Methods = void 0;
  var SymbolMap_js_1 = SymbolMap;
  var Configuration_js_1 = Configuration;
  exports.ColorV2Methods = {
    Color: function (parser, name) {
      var color = parser.GetArgument(name);
      var old = parser.stack.env['color'];
      parser.stack.env['color'] = color;
      var math = parser.ParseArg(name);
      if (old) {
        parser.stack.env['color'] = old;
      } else {
        delete parser.stack.env['color'];
      }
      var node = parser.create('node', 'mstyle', [math], {
        mathcolor: color
      });
      parser.Push(node);
    }
  };
  new SymbolMap_js_1.CommandMap('colorv2', {
    color: 'Color'
  }, exports.ColorV2Methods);
  exports.ColorConfiguration = Configuration_js_1.Configuration.create('colorv2', {
    handler: {
      macro: ['colorv2']
    }
  });
})(ColorV2Configuration);
getDefaultExportFromCjs(ColorV2Configuration);

var ColortblConfiguration = {};

var __extends$8 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __importDefault$l = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(ColortblConfiguration, "__esModule", {
  value: true
});
ColortblConfiguration.ColortblConfiguration = ColortblConfiguration.ColorArrayItem = void 0;
var BaseItems_js_1$3 = BaseItems;
var Configuration_js_1$c = Configuration;
var SymbolMap_js_1$a = SymbolMap;
var TexError_js_1$8 = __importDefault$l(TexError$1);
var ColorArrayItem = (function (_super) {
  __extends$8(ColorArrayItem, _super);
  function ColorArrayItem() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.color = {
      cell: '',
      row: '',
      col: []
    };
    _this.hasColor = false;
    return _this;
  }
  ColorArrayItem.prototype.EndEntry = function () {
    _super.prototype.EndEntry.call(this);
    var cell = this.row[this.row.length - 1];
    var color = this.color.cell || this.color.row || this.color.col[this.row.length - 1];
    if (color) {
      cell.attributes.set('mathbackground', color);
      this.color.cell = '';
      this.hasColor = true;
    }
  };
  ColorArrayItem.prototype.EndRow = function () {
    _super.prototype.EndRow.call(this);
    this.color.row = '';
  };
  ColorArrayItem.prototype.createMml = function () {
    var mml = _super.prototype.createMml.call(this);
    var table = mml.isKind('mrow') ? mml.childNodes[1] : mml;
    if (table.isKind('menclose')) {
      table = table.childNodes[0].childNodes[0];
    }
    if (this.hasColor && table.attributes.get('frame') === 'none') {
      table.attributes.set('frame', '');
    }
    return mml;
  };
  return ColorArrayItem;
})(BaseItems_js_1$3.ArrayItem);
ColortblConfiguration.ColorArrayItem = ColorArrayItem;
new SymbolMap_js_1$a.CommandMap('colortbl', {
  cellcolor: ['TableColor', 'cell'],
  rowcolor: ['TableColor', 'row'],
  columncolor: ['TableColor', 'col']
}, {
  TableColor: function (parser, name, type) {
    var lookup = parser.configuration.packageData.get('color').model;
    var model = parser.GetBrackets(name, '');
    var color = lookup.getColor(model, parser.GetArgument(name));
    var top = parser.stack.Top();
    if (!(top instanceof ColorArrayItem)) {
      throw new TexError_js_1$8.default('UnsupportedTableColor', 'Unsupported use of %1', parser.currentCS);
    }
    if (type === 'col') {
      if (top.table.length) {
        throw new TexError_js_1$8.default('ColumnColorNotTop', '%1 must be in the top row', name);
      }
      top.color.col[top.row.length] = color;
      if (parser.GetBrackets(name, '')) {
        parser.GetBrackets(name, '');
      }
    } else {
      top.color[type] = color;
      if (type === 'row' && (top.Size() || top.row.length)) {
        throw new TexError_js_1$8.default('RowColorNotFirst', '%1 must be at the beginning of a row', name);
      }
    }
  }
});
var config = function (config, jax) {
  if (!jax.parseOptions.packageData.has('color')) {
    Configuration_js_1$c.ConfigurationHandler.get('color').config(config, jax);
  }
};
ColortblConfiguration.ColortblConfiguration = Configuration_js_1$c.Configuration.create('colortbl', {
  handler: {
    macro: ['colortbl']
  },
  items: {
    'array': ColorArrayItem
  },
  priority: 10,
  config: [config, 10]
});

var ConfigMacrosConfiguration = {};

var NewcommandMethods$1 = {};

var NewcommandUtil$1 = {};

var __importDefault$k = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(NewcommandUtil$1, "__esModule", {
  value: true
});
var ParseUtil_js_1$6 = __importDefault$k(ParseUtil$1);
var TexError_js_1$7 = __importDefault$k(TexError$1);
var Symbol_js_1$2 = _Symbol;
var NewcommandUtil;
(function (NewcommandUtil) {
  function disassembleSymbol(name, symbol) {
    var newArgs = [name, symbol.char];
    if (symbol.attributes) {
      for (var key in symbol.attributes) {
        newArgs.push(key);
        newArgs.push(symbol.attributes[key]);
      }
    }
    return newArgs;
  }
  NewcommandUtil.disassembleSymbol = disassembleSymbol;
  function assembleSymbol(args) {
    var name = args[0];
    var char = args[1];
    var attrs = {};
    for (var i = 2; i < args.length; i = i + 2) {
      attrs[args[i]] = args[i + 1];
    }
    return new Symbol_js_1$2.Symbol(name, char, attrs);
  }
  NewcommandUtil.assembleSymbol = assembleSymbol;
  function GetCSname(parser, cmd) {
    var c = parser.GetNext();
    if (c !== '\\') {
      throw new TexError_js_1$7.default('MissingCS', '%1 must be followed by a control sequence', cmd);
    }
    var cs = ParseUtil_js_1$6.default.trimSpaces(parser.GetArgument(cmd));
    return cs.substr(1);
  }
  NewcommandUtil.GetCSname = GetCSname;
  function GetCsNameArgument(parser, name) {
    var cs = ParseUtil_js_1$6.default.trimSpaces(parser.GetArgument(name));
    if (cs.charAt(0) === '\\') {
      cs = cs.substr(1);
    }
    if (!cs.match(/^(.|[a-z]+)$/i)) {
      throw new TexError_js_1$7.default('IllegalControlSequenceName', 'Illegal control sequence name for %1', name);
    }
    return cs;
  }
  NewcommandUtil.GetCsNameArgument = GetCsNameArgument;
  function GetArgCount(parser, name) {
    var n = parser.GetBrackets(name);
    if (n) {
      n = ParseUtil_js_1$6.default.trimSpaces(n);
      if (!n.match(/^[0-9]+$/)) {
        throw new TexError_js_1$7.default('IllegalParamNumber', 'Illegal number of parameters specified in %1', name);
      }
    }
    return n;
  }
  NewcommandUtil.GetArgCount = GetArgCount;
  function GetTemplate(parser, cmd, cs) {
    var c = parser.GetNext();
    var params = [];
    var n = 0;
    var i = parser.i;
    while (parser.i < parser.string.length) {
      c = parser.GetNext();
      if (c === '#') {
        if (i !== parser.i) {
          params[n] = parser.string.substr(i, parser.i - i);
        }
        c = parser.string.charAt(++parser.i);
        if (!c.match(/^[1-9]$/)) {
          throw new TexError_js_1$7.default('CantUseHash2', 'Illegal use of # in template for %1', cs);
        }
        if (parseInt(c) !== ++n) {
          throw new TexError_js_1$7.default('SequentialParam', 'Parameters for %1 must be numbered sequentially', cs);
        }
        i = parser.i + 1;
      } else if (c === '{') {
        if (i !== parser.i) {
          params[n] = parser.string.substr(i, parser.i - i);
        }
        if (params.length > 0) {
          return [n.toString()].concat(params);
        } else {
          return n;
        }
      }
      parser.i++;
    }
    throw new TexError_js_1$7.default('MissingReplacementString', 'Missing replacement string for definition of %1', cmd);
  }
  NewcommandUtil.GetTemplate = GetTemplate;
  function GetParameter(parser, name, param) {
    if (param == null) {
      return parser.GetArgument(name);
    }
    var i = parser.i;
    var j = 0;
    var hasBraces = 0;
    while (parser.i < parser.string.length) {
      var c = parser.string.charAt(parser.i);
      if (c === '{') {
        if (parser.i === i) {
          hasBraces = 1;
        }
        parser.GetArgument(name);
        j = parser.i - i;
      } else if (MatchParam(parser, param)) {
        if (hasBraces) {
          i++;
          j -= 2;
        }
        return parser.string.substr(i, j);
      } else if (c === '\\') {
        parser.i++;
        j++;
        hasBraces = 0;
        var match = parser.string.substr(parser.i).match(/[a-z]+|./i);
        if (match) {
          parser.i += match[0].length;
          j = parser.i - i;
        }
      } else {
        parser.i++;
        j++;
        hasBraces = 0;
      }
    }
    throw new TexError_js_1$7.default('RunawayArgument', 'Runaway argument for %1?', name);
  }
  NewcommandUtil.GetParameter = GetParameter;
  function MatchParam(parser, param) {
    if (parser.string.substr(parser.i, param.length) !== param) {
      return 0;
    }
    if (param.match(/\\[a-z]+$/i) && parser.string.charAt(parser.i + param.length).match(/[a-z]/i)) {
      return 0;
    }
    parser.i += param.length;
    return 1;
  }
  NewcommandUtil.MatchParam = MatchParam;
  function addDelimiter(parser, cs, char, attr) {
    var handlers = parser.configuration.handlers;
    var handler = handlers.retrieve(NewcommandUtil.NEW_DELIMITER);
    handler.add(cs, new Symbol_js_1$2.Symbol(cs, char, attr));
  }
  NewcommandUtil.addDelimiter = addDelimiter;
  function addMacro(parser, cs, func, attr, symbol) {
    if (symbol === void 0) {
      symbol = '';
    }
    var handlers = parser.configuration.handlers;
    var handler = handlers.retrieve(NewcommandUtil.NEW_COMMAND);
    handler.add(cs, new Symbol_js_1$2.Macro(symbol ? symbol : cs, func, attr));
  }
  NewcommandUtil.addMacro = addMacro;
  function addEnvironment(parser, env, func, attr) {
    var handlers = parser.configuration.handlers;
    var handler = handlers.retrieve(NewcommandUtil.NEW_ENVIRONMENT);
    handler.add(env, new Symbol_js_1$2.Macro(env, func, attr));
  }
  NewcommandUtil.addEnvironment = addEnvironment;
  NewcommandUtil.NEW_DELIMITER = 'new-Delimiter';
  NewcommandUtil.NEW_COMMAND = 'new-Command';
  NewcommandUtil.NEW_ENVIRONMENT = 'new-Environment';
})(NewcommandUtil || (NewcommandUtil = {}));
NewcommandUtil$1.default = NewcommandUtil;

var __createBinding$2 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$2 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$2 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$2(result, mod, k);
  __setModuleDefault$2(result, mod);
  return result;
});
var __importDefault$j = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(NewcommandMethods$1, "__esModule", {
  value: true
});
var TexError_js_1$6 = __importDefault$j(TexError$1);
var sm$1 = __importStar$2(SymbolMap);
var BaseMethods_js_1$3 = __importDefault$j(BaseMethods$1);
var ParseUtil_js_1$5 = __importDefault$j(ParseUtil$1);
var NewcommandUtil_js_1$1 = __importDefault$j(NewcommandUtil$1);
var NewcommandMethods = {};
NewcommandMethods.NewCommand = function (parser, name) {
  var cs = NewcommandUtil_js_1$1.default.GetCsNameArgument(parser, name);
  var n = NewcommandUtil_js_1$1.default.GetArgCount(parser, name);
  var opt = parser.GetBrackets(name);
  var def = parser.GetArgument(name);
  NewcommandUtil_js_1$1.default.addMacro(parser, cs, NewcommandMethods.Macro, [def, n, opt]);
};
NewcommandMethods.NewEnvironment = function (parser, name) {
  var env = ParseUtil_js_1$5.default.trimSpaces(parser.GetArgument(name));
  var n = NewcommandUtil_js_1$1.default.GetArgCount(parser, name);
  var opt = parser.GetBrackets(name);
  var bdef = parser.GetArgument(name);
  var edef = parser.GetArgument(name);
  NewcommandUtil_js_1$1.default.addEnvironment(parser, env, NewcommandMethods.BeginEnv, [true, bdef, edef, n, opt]);
};
NewcommandMethods.MacroDef = function (parser, name) {
  var cs = NewcommandUtil_js_1$1.default.GetCSname(parser, name);
  var params = NewcommandUtil_js_1$1.default.GetTemplate(parser, name, '\\' + cs);
  var def = parser.GetArgument(name);
  !(params instanceof Array) ? NewcommandUtil_js_1$1.default.addMacro(parser, cs, NewcommandMethods.Macro, [def, params]) : NewcommandUtil_js_1$1.default.addMacro(parser, cs, NewcommandMethods.MacroWithTemplate, [def].concat(params));
};
NewcommandMethods.Let = function (parser, name) {
  var cs = NewcommandUtil_js_1$1.default.GetCSname(parser, name);
  var c = parser.GetNext();
  if (c === '=') {
    parser.i++;
    c = parser.GetNext();
  }
  var handlers = parser.configuration.handlers;
  if (c === '\\') {
    name = NewcommandUtil_js_1$1.default.GetCSname(parser, name);
    var macro_1 = handlers.get('delimiter').lookup('\\' + name);
    if (macro_1) {
      NewcommandUtil_js_1$1.default.addDelimiter(parser, '\\' + cs, macro_1.char, macro_1.attributes);
      return;
    }
    var map_1 = handlers.get('macro').applicable(name);
    if (!map_1) {
      return;
    }
    if (map_1 instanceof sm$1.MacroMap) {
      var macro_2 = map_1.lookup(name);
      NewcommandUtil_js_1$1.default.addMacro(parser, cs, macro_2.func, macro_2.args, macro_2.symbol);
      return;
    }
    macro_1 = map_1.lookup(name);
    var newArgs = NewcommandUtil_js_1$1.default.disassembleSymbol(cs, macro_1);
    var method = function (p, _cs) {
      var rest = [];
      for (var _i = 2; _i < arguments.length; _i++) {
        rest[_i - 2] = arguments[_i];
      }
      var symb = NewcommandUtil_js_1$1.default.assembleSymbol(rest);
      return map_1.parser(p, symb);
    };
    NewcommandUtil_js_1$1.default.addMacro(parser, cs, method, newArgs);
    return;
  }
  parser.i++;
  var macro = handlers.get('delimiter').lookup(c);
  if (macro) {
    NewcommandUtil_js_1$1.default.addDelimiter(parser, '\\' + cs, macro.char, macro.attributes);
    return;
  }
  NewcommandUtil_js_1$1.default.addMacro(parser, cs, NewcommandMethods.Macro, [c]);
};
NewcommandMethods.MacroWithTemplate = function (parser, name, text, n) {
  var params = [];
  for (var _i = 4; _i < arguments.length; _i++) {
    params[_i - 4] = arguments[_i];
  }
  var argCount = parseInt(n, 10);
  if (argCount) {
    var args = [];
    parser.GetNext();
    if (params[0] && !NewcommandUtil_js_1$1.default.MatchParam(parser, params[0])) {
      throw new TexError_js_1$6.default('MismatchUseDef', 'Use of %1 doesn\'t match its definition', name);
    }
    for (var i = 0; i < argCount; i++) {
      args.push(NewcommandUtil_js_1$1.default.GetParameter(parser, name, params[i + 1]));
    }
    text = ParseUtil_js_1$5.default.substituteArgs(parser, args, text);
  }
  parser.string = ParseUtil_js_1$5.default.addArgs(parser, text, parser.string.slice(parser.i));
  parser.i = 0;
  ParseUtil_js_1$5.default.checkMaxMacros(parser);
};
NewcommandMethods.BeginEnv = function (parser, begin, bdef, edef, n, def) {
  if (begin.getProperty('end') && parser.stack.env['closing'] === begin.getName()) {
    delete parser.stack.env['closing'];
    var rest = parser.string.slice(parser.i);
    parser.string = edef;
    parser.i = 0;
    parser.Parse();
    parser.string = rest;
    parser.i = 0;
    return parser.itemFactory.create('end').setProperty('name', begin.getName());
  }
  if (n) {
    var args = [];
    if (def != null) {
      var optional = parser.GetBrackets('\\begin{' + begin.getName() + '}');
      args.push(optional == null ? def : optional);
    }
    for (var i = args.length; i < n; i++) {
      args.push(parser.GetArgument('\\begin{' + begin.getName() + '}'));
    }
    bdef = ParseUtil_js_1$5.default.substituteArgs(parser, args, bdef);
    edef = ParseUtil_js_1$5.default.substituteArgs(parser, [], edef);
  }
  parser.string = ParseUtil_js_1$5.default.addArgs(parser, bdef, parser.string.slice(parser.i));
  parser.i = 0;
  return parser.itemFactory.create('beginEnv').setProperty('name', begin.getName());
};
NewcommandMethods.Macro = BaseMethods_js_1$3.default.Macro;
NewcommandMethods$1.default = NewcommandMethods;

var NewcommandItems = {};

var __extends$7 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __importDefault$i = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(NewcommandItems, "__esModule", {
  value: true
});
NewcommandItems.BeginEnvItem = void 0;
var TexError_js_1$5 = __importDefault$i(TexError$1);
var StackItem_js_1$1 = StackItem;
var BeginEnvItem = (function (_super) {
  __extends$7(BeginEnvItem, _super);
  function BeginEnvItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(BeginEnvItem.prototype, "kind", {
    get: function () {
      return 'beginEnv';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(BeginEnvItem.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  BeginEnvItem.prototype.checkItem = function (item) {
    if (item.isKind('end')) {
      if (item.getName() !== this.getName()) {
        throw new TexError_js_1$5.default('EnvBadEnd', '\\begin{%1} ended with \\end{%2}', this.getName(), item.getName());
      }
      return [[this.factory.create('mml', this.toMml())], true];
    }
    if (item.isKind('stop')) {
      throw new TexError_js_1$5.default('EnvMissingEnd', 'Missing \\end{%1}', this.getName());
    }
    return _super.prototype.checkItem.call(this, item);
  };
  return BeginEnvItem;
})(StackItem_js_1$1.BaseItem);
NewcommandItems.BeginEnvItem = BeginEnvItem;

var __values$4 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __importDefault$h = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
var _a$3;
Object.defineProperty(ConfigMacrosConfiguration, "__esModule", {
  value: true
});
ConfigMacrosConfiguration.ConfigMacrosConfiguration = void 0;
var Configuration_js_1$b = Configuration;
var Options_js_1$1 = Options;
var SymbolMap_js_1$9 = SymbolMap;
var ParseMethods_js_1$3 = __importDefault$h(ParseMethods$1);
var Symbol_js_1$1 = _Symbol;
var NewcommandMethods_js_1$1 = __importDefault$h(NewcommandMethods$1);
var NewcommandItems_js_1$1 = NewcommandItems;
var MACROSMAP = 'configmacros-map';
var ENVIRONMENTMAP = 'configmacros-env-map';
function configmacrosInit(config) {
  new SymbolMap_js_1$9.CommandMap(MACROSMAP, {}, {});
  new SymbolMap_js_1$9.EnvironmentMap(ENVIRONMENTMAP, ParseMethods_js_1$3.default.environment, {}, {});
  config.append(Configuration_js_1$b.Configuration.local({
    handler: {
      macro: [MACROSMAP],
      environment: [ENVIRONMENTMAP]
    },
    priority: 3
  }));
}
function configmacrosConfig(_config, jax) {
  configMacros(jax);
  configEnvironments(jax);
}
function configMacros(jax) {
  var e_1, _a;
  var handler = jax.parseOptions.handlers.retrieve(MACROSMAP);
  var macros = jax.parseOptions.options.macros;
  try {
    for (var _b = __values$4(Object.keys(macros)), _c = _b.next(); !_c.done; _c = _b.next()) {
      var cs = _c.value;
      var def = typeof macros[cs] === 'string' ? [macros[cs]] : macros[cs];
      var macro = Array.isArray(def[2]) ? new Symbol_js_1$1.Macro(cs, NewcommandMethods_js_1$1.default.MacroWithTemplate, def.slice(0, 2).concat(def[2])) : new Symbol_js_1$1.Macro(cs, NewcommandMethods_js_1$1.default.Macro, def);
      handler.add(cs, macro);
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
}
function configEnvironments(jax) {
  var e_2, _a;
  var handler = jax.parseOptions.handlers.retrieve(ENVIRONMENTMAP);
  var environments = jax.parseOptions.options.environments;
  try {
    for (var _b = __values$4(Object.keys(environments)), _c = _b.next(); !_c.done; _c = _b.next()) {
      var env = _c.value;
      handler.add(env, new Symbol_js_1$1.Macro(env, NewcommandMethods_js_1$1.default.BeginEnv, [true].concat(environments[env])));
    }
  } catch (e_2_1) {
    e_2 = {
      error: e_2_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_2) throw e_2.error;
    }
  }
}
ConfigMacrosConfiguration.ConfigMacrosConfiguration = Configuration_js_1$b.Configuration.create('configmacros', {
  init: configmacrosInit,
  config: configmacrosConfig,
  items: (_a$3 = {}, _a$3[NewcommandItems_js_1$1.BeginEnvItem.prototype.kind] = NewcommandItems_js_1$1.BeginEnvItem, _a$3),
  options: {
    macros: (0, Options_js_1$1.expandable)({}),
    environments: (0, Options_js_1$1.expandable)({})
  }
});

var EmpheqConfiguration = {};

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  var _a;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.EmpheqConfiguration = exports.EmpheqMethods = exports.EmpheqBeginItem = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var TexError_js_1 = __importDefault(TexError$1);
  var BaseItems_js_1 = BaseItems;
  var EmpheqUtil_js_1 = EmpheqUtil;
  var EmpheqBeginItem = (function (_super) {
    __extends(EmpheqBeginItem, _super);
    function EmpheqBeginItem() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(EmpheqBeginItem.prototype, "kind", {
      get: function () {
        return 'empheq-begin';
      },
      enumerable: false,
      configurable: true
    });
    EmpheqBeginItem.prototype.checkItem = function (item) {
      if (item.isKind('end') && item.getName() === this.getName()) {
        this.setProperty('end', false);
      }
      return _super.prototype.checkItem.call(this, item);
    };
    return EmpheqBeginItem;
  })(BaseItems_js_1.BeginItem);
  exports.EmpheqBeginItem = EmpheqBeginItem;
  exports.EmpheqMethods = {
    Empheq: function (parser, begin) {
      if (parser.stack.env.closing === begin.getName()) {
        delete parser.stack.env.closing;
        parser.Push(parser.itemFactory.create('end').setProperty('name', parser.stack.global.empheq));
        parser.stack.global.empheq = '';
        var empheq = parser.stack.Top();
        EmpheqUtil_js_1.EmpheqUtil.adjustTable(empheq, parser);
        parser.Push(parser.itemFactory.create('end').setProperty('name', 'empheq'));
      } else {
        ParseUtil_js_1.default.checkEqnEnv(parser);
        delete parser.stack.global.eqnenv;
        var opts = parser.GetBrackets('\\begin{' + begin.getName() + '}') || '';
        var _a = __read((parser.GetArgument('\\begin{' + begin.getName() + '}') || '').split(/=/), 2), env = _a[0], n = _a[1];
        if (!EmpheqUtil_js_1.EmpheqUtil.checkEnv(env)) {
          throw new TexError_js_1.default('UnknownEnv', 'Unknown environment "%1"', env);
        }
        if (opts) {
          begin.setProperties(EmpheqUtil_js_1.EmpheqUtil.splitOptions(opts, {
            left: 1,
            right: 1
          }));
        }
        parser.stack.global.empheq = env;
        parser.string = '\\begin{' + env + '}' + (n ? '{' + n + '}' : '') + parser.string.slice(parser.i);
        parser.i = 0;
        parser.Push(begin);
      }
    },
    EmpheqMO: function (parser, _name, c) {
      parser.Push(parser.create('token', 'mo', {}, c));
    },
    EmpheqDelim: function (parser, name) {
      var c = parser.GetDelimiter(name);
      parser.Push(parser.create('token', 'mo', {
        stretchy: true,
        symmetric: true
      }, c));
    }
  };
  new SymbolMap_js_1.EnvironmentMap('empheq-env', EmpheqUtil_js_1.EmpheqUtil.environment, {
    empheq: ['Empheq', 'empheq']
  }, exports.EmpheqMethods);
  new SymbolMap_js_1.CommandMap('empheq-macros', {
    empheqlbrace: ['EmpheqMO', '{'],
    empheqrbrace: ['EmpheqMO', '}'],
    empheqlbrack: ['EmpheqMO', '['],
    empheqrbrack: ['EmpheqMO', ']'],
    empheqlangle: ['EmpheqMO', '\u27E8'],
    empheqrangle: ['EmpheqMO', '\u27E9'],
    empheqlparen: ['EmpheqMO', '('],
    empheqrparen: ['EmpheqMO', ')'],
    empheqlvert: ['EmpheqMO', '|'],
    empheqrvert: ['EmpheqMO', '|'],
    empheqlVert: ['EmpheqMO', '\u2016'],
    empheqrVert: ['EmpheqMO', '\u2016'],
    empheqlfloor: ['EmpheqMO', '\u230A'],
    empheqrfloor: ['EmpheqMO', '\u230B'],
    empheqlceil: ['EmpheqMO', '\u2308'],
    empheqrceil: ['EmpheqMO', '\u2309'],
    empheqbiglbrace: ['EmpheqMO', '{'],
    empheqbigrbrace: ['EmpheqMO', '}'],
    empheqbiglbrack: ['EmpheqMO', '['],
    empheqbigrbrack: ['EmpheqMO', ']'],
    empheqbiglangle: ['EmpheqMO', '\u27E8'],
    empheqbigrangle: ['EmpheqMO', '\u27E9'],
    empheqbiglparen: ['EmpheqMO', '('],
    empheqbigrparen: ['EmpheqMO', ')'],
    empheqbiglvert: ['EmpheqMO', '|'],
    empheqbigrvert: ['EmpheqMO', '|'],
    empheqbiglVert: ['EmpheqMO', '\u2016'],
    empheqbigrVert: ['EmpheqMO', '\u2016'],
    empheqbiglfloor: ['EmpheqMO', '\u230A'],
    empheqbigrfloor: ['EmpheqMO', '\u230B'],
    empheqbiglceil: ['EmpheqMO', '\u2308'],
    empheqbigrceil: ['EmpheqMO', '\u2309'],
    empheql: 'EmpheqDelim',
    empheqr: 'EmpheqDelim',
    empheqbigl: 'EmpheqDelim',
    empheqbigr: 'EmpheqDelim'
  }, exports.EmpheqMethods);
  exports.EmpheqConfiguration = Configuration_js_1.Configuration.create('empheq', {
    handler: {
      macro: ['empheq-macros'],
      environment: ['empheq-env']
    },
    items: (_a = {}, _a[EmpheqBeginItem.prototype.kind] = EmpheqBeginItem, _a)
  });
})(EmpheqConfiguration);
getDefaultExportFromCjs(EmpheqConfiguration);

var ExtpfeilConfiguration = {};

var NewcommandConfiguration = {};

var NewcommandMappings = {};

var __importDefault$g = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(NewcommandMappings, "__esModule", {
  value: true
});
var NewcommandMethods_js_1 = __importDefault$g(NewcommandMethods$1);
var SymbolMap_js_1$8 = SymbolMap;
new SymbolMap_js_1$8.CommandMap('Newcommand-macros', {
  newcommand: 'NewCommand',
  renewcommand: 'NewCommand',
  newenvironment: 'NewEnvironment',
  renewenvironment: 'NewEnvironment',
  def: 'MacroDef',
  'let': 'Let'
}, NewcommandMethods_js_1.default);

var __createBinding$1 = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  var desc = Object.getOwnPropertyDescriptor(m, k);
  if (!desc || (("get" in desc) ? !m.__esModule : desc.writable || desc.configurable)) {
    desc = {
      enumerable: true,
      get: function () {
        return m[k];
      }
    };
  }
  Object.defineProperty(o, k2, desc);
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault$1 = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar$1 = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$1(result, mod, k);
  __setModuleDefault$1(result, mod);
  return result;
});
var __importDefault$f = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
var _a$2;
Object.defineProperty(NewcommandConfiguration, "__esModule", {
  value: true
});
NewcommandConfiguration.NewcommandConfiguration = void 0;
var Configuration_js_1$a = Configuration;
var NewcommandItems_js_1 = NewcommandItems;
var NewcommandUtil_js_1 = __importDefault$f(NewcommandUtil$1);
var ParseMethods_js_1$2 = __importDefault$f(ParseMethods$1);
var sm = __importStar$1(SymbolMap);
var init = function (config) {
  new sm.DelimiterMap(NewcommandUtil_js_1.default.NEW_DELIMITER, ParseMethods_js_1$2.default.delimiter, {});
  new sm.CommandMap(NewcommandUtil_js_1.default.NEW_COMMAND, {}, {});
  new sm.EnvironmentMap(NewcommandUtil_js_1.default.NEW_ENVIRONMENT, ParseMethods_js_1$2.default.environment, {}, {});
  config.append(Configuration_js_1$a.Configuration.local({
    handler: {
      character: [],
      delimiter: [NewcommandUtil_js_1.default.NEW_DELIMITER],
      macro: [NewcommandUtil_js_1.default.NEW_DELIMITER, NewcommandUtil_js_1.default.NEW_COMMAND],
      environment: [NewcommandUtil_js_1.default.NEW_ENVIRONMENT]
    },
    priority: -1
  }));
};
NewcommandConfiguration.NewcommandConfiguration = Configuration_js_1$a.Configuration.create('newcommand', {
  handler: {
    macro: ['Newcommand-macros']
  },
  items: (_a$2 = {}, _a$2[NewcommandItems_js_1.BeginEnvItem.prototype.kind] = NewcommandItems_js_1.BeginEnvItem, _a$2),
  options: {
    maxMacros: 1000
  },
  init: init
});

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ExtpfeilConfiguration = exports.ExtpfeilMethods = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var AmsMethods_js_1 = AmsMethods;
  var NewcommandUtil_js_1 = __importDefault(NewcommandUtil$1);
  var NewcommandConfiguration_js_1 = NewcommandConfiguration;
  var TexError_js_1 = __importDefault(TexError$1);
  exports.ExtpfeilMethods = {};
  exports.ExtpfeilMethods.xArrow = AmsMethods_js_1.AmsMethods.xArrow;
  exports.ExtpfeilMethods.NewExtArrow = function (parser, name) {
    var cs = parser.GetArgument(name);
    var space = parser.GetArgument(name);
    var chr = parser.GetArgument(name);
    if (!cs.match(/^\\([a-z]+|.)$/i)) {
      throw new TexError_js_1.default('NewextarrowArg1', 'First argument to %1 must be a control sequence name', name);
    }
    if (!space.match(/^(\d+),(\d+)$/)) {
      throw new TexError_js_1.default('NewextarrowArg2', 'Second argument to %1 must be two integers separated by a comma', name);
    }
    if (!chr.match(/^(\d+|0x[0-9A-F]+)$/i)) {
      throw new TexError_js_1.default('NewextarrowArg3', 'Third argument to %1 must be a unicode character number', name);
    }
    cs = cs.substr(1);
    var spaces = space.split(',');
    NewcommandUtil_js_1.default.addMacro(parser, cs, exports.ExtpfeilMethods.xArrow, [parseInt(chr), parseInt(spaces[0]), parseInt(spaces[1])]);
  };
  new SymbolMap_js_1.CommandMap('extpfeil', {
    xtwoheadrightarrow: ['xArrow', 0x21A0, 12, 16],
    xtwoheadleftarrow: ['xArrow', 0x219E, 17, 13],
    xmapsto: ['xArrow', 0x21A6, 6, 7],
    xlongequal: ['xArrow', 0x003D, 7, 7],
    xtofrom: ['xArrow', 0x21C4, 12, 12],
    Newextarrow: 'NewExtArrow'
  }, exports.ExtpfeilMethods);
  var init = function (config) {
    NewcommandConfiguration_js_1.NewcommandConfiguration.init(config);
  };
  exports.ExtpfeilConfiguration = Configuration_js_1.Configuration.create('extpfeil', {
    handler: {
      macro: ['extpfeil']
    },
    init: init
  });
})(ExtpfeilConfiguration);
getDefaultExportFromCjs(ExtpfeilConfiguration);

var GensymbConfiguration = {};

Object.defineProperty(GensymbConfiguration, "__esModule", {
  value: true
});
GensymbConfiguration.GensymbConfiguration = void 0;
var Configuration_js_1$9 = Configuration;
var TexConstants_js_1$6 = TexConstants;
var SymbolMap_js_1$7 = SymbolMap;
function mathcharUnit(parser, mchar) {
  var def = mchar.attributes || ({});
  def.mathvariant = TexConstants_js_1$6.TexConstant.Variant.NORMAL;
  def.class = 'MathML-Unit';
  var node = parser.create('token', 'mi', def, mchar.char);
  parser.Push(node);
}
new SymbolMap_js_1$7.CharacterMap('gensymb-symbols', mathcharUnit, {
  ohm: '\u2126',
  degree: '\u00B0',
  celsius: '\u2103',
  perthousand: '\u2030',
  micro: '\u00B5'
});
GensymbConfiguration.GensymbConfiguration = Configuration_js_1$9.Configuration.create('gensymb', {
  handler: {
    macro: ['gensymb-symbols']
  }
});

var HtmlConfiguration = {};

var HtmlMethods$1 = {};

var __importDefault$e = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(HtmlMethods$1, "__esModule", {
  value: true
});
var NodeUtil_js_1$4 = __importDefault$e(NodeUtil$1);
var HtmlMethods = {};
HtmlMethods.Href = function (parser, name) {
  var url = parser.GetArgument(name);
  var arg = GetArgumentMML(parser, name);
  NodeUtil_js_1$4.default.setAttribute(arg, 'href', url);
  parser.Push(arg);
};
HtmlMethods.Class = function (parser, name) {
  var CLASS = parser.GetArgument(name);
  var arg = GetArgumentMML(parser, name);
  var oldClass = NodeUtil_js_1$4.default.getAttribute(arg, 'class');
  if (oldClass) {
    CLASS = oldClass + ' ' + CLASS;
  }
  NodeUtil_js_1$4.default.setAttribute(arg, 'class', CLASS);
  parser.Push(arg);
};
HtmlMethods.Style = function (parser, name) {
  var style = parser.GetArgument(name);
  var arg = GetArgumentMML(parser, name);
  var oldStyle = NodeUtil_js_1$4.default.getAttribute(arg, 'style');
  if (oldStyle) {
    if (style.charAt(style.length - 1) !== ';') {
      style += ';';
    }
    style = oldStyle + ' ' + style;
  }
  NodeUtil_js_1$4.default.setAttribute(arg, 'style', style);
  parser.Push(arg);
};
HtmlMethods.Id = function (parser, name) {
  var ID = parser.GetArgument(name);
  var arg = GetArgumentMML(parser, name);
  NodeUtil_js_1$4.default.setAttribute(arg, 'id', ID);
  parser.Push(arg);
};
var GetArgumentMML = function (parser, name) {
  var arg = parser.ParseArg(name);
  if (!NodeUtil_js_1$4.default.isInferred(arg)) {
    return arg;
  }
  var children = NodeUtil_js_1$4.default.getChildren(arg);
  if (children.length === 1) {
    return children[0];
  }
  var mrow = parser.create('node', 'mrow');
  NodeUtil_js_1$4.default.copyChildren(arg, mrow);
  NodeUtil_js_1$4.default.copyAttributes(arg, mrow);
  return mrow;
};
HtmlMethods$1.default = HtmlMethods;

var __importDefault$d = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(HtmlConfiguration, "__esModule", {
  value: true
});
HtmlConfiguration.HtmlConfiguration = void 0;
var Configuration_js_1$8 = Configuration;
var SymbolMap_js_1$6 = SymbolMap;
var HtmlMethods_js_1 = __importDefault$d(HtmlMethods$1);
new SymbolMap_js_1$6.CommandMap('html_macros', {
  href: 'Href',
  'class': 'Class',
  style: 'Style',
  cssId: 'Id'
}, HtmlMethods_js_1.default);
HtmlConfiguration.HtmlConfiguration = Configuration_js_1$8.Configuration.create('html', {
  handler: {
    macro: ['html_macros']
  }
});

var MathtoolsConfiguration = {};

var MathtoolsMappings = {};

var MathtoolsMethods = {};

var MathtoolsUtil = {};

var __read$4 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __importDefault$c = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(MathtoolsUtil, "__esModule", {
  value: true
});
MathtoolsUtil.MathtoolsUtil = void 0;
var BaseItems_js_1$2 = BaseItems;
var ParseUtil_js_1$4 = __importDefault$c(ParseUtil$1);
var TexParser_js_1$4 = __importDefault$c(TexParser$1);
var TexError_js_1$4 = __importDefault$c(TexError$1);
var Symbol_js_1 = _Symbol;
var Options_js_1 = Options;
var MathtoolsMethods_js_1$1 = MathtoolsMethods;
var MathtoolsConfiguration_js_1 = MathtoolsConfiguration;
MathtoolsUtil.MathtoolsUtil = {
  setDisplayLevel: function (mml, style) {
    if (!style) return;
    var _a = __read$4((0, Options_js_1.lookup)(style, {
      '\\displaystyle': [true, 0],
      '\\textstyle': [false, 0],
      '\\scriptstyle': [false, 1],
      '\\scriptscriptstyle': [false, 2]
    }, [null, null]), 2), display = _a[0], script = _a[1];
    if (display !== null) {
      mml.attributes.set('displaystyle', display);
      mml.attributes.set('scriptlevel', script);
    }
  },
  checkAlignment: function (parser, name) {
    var top = parser.stack.Top();
    if (top.kind !== BaseItems_js_1$2.EqnArrayItem.prototype.kind) {
      throw new TexError_js_1$4.default('NotInAlignment', '%1 can only be used in aligment environments', name);
    }
    return top;
  },
  addPairedDelims: function (config, cs, args) {
    var delims = config.handlers.retrieve(MathtoolsConfiguration_js_1.PAIREDDELIMS);
    delims.add(cs, new Symbol_js_1.Macro(cs, MathtoolsMethods_js_1$1.MathtoolsMethods.PairedDelimiters, args));
  },
  spreadLines: function (mtable, spread) {
    if (!mtable.isKind('mtable')) return;
    var rowspacing = mtable.attributes.get('rowspacing');
    if (rowspacing) {
      var add_1 = ParseUtil_js_1$4.default.dimen2em(spread);
      rowspacing = rowspacing.split(/ /).map(function (s) {
        return ParseUtil_js_1$4.default.Em(Math.max(0, ParseUtil_js_1$4.default.dimen2em(s) + add_1));
      }).join(' ');
    } else {
      rowspacing = spread;
    }
    mtable.attributes.set('rowspacing', rowspacing);
  },
  plusOrMinus: function (name, n) {
    n = n.trim();
    if (!n.match(/^[-+]?(?:\d+(?:\.\d*)?|\.\d+)$/)) {
      throw new TexError_js_1$4.default('NotANumber', 'Argument to %1 is not a number', name);
    }
    return n.match(/^[-+]/) ? n : '+' + n;
  },
  getScript: function (parser, name, pos) {
    var arg = ParseUtil_js_1$4.default.trimSpaces(parser.GetArgument(name));
    if (arg === '') {
      return parser.create('node', 'none');
    }
    var format = parser.options.mathtools[("prescript-").concat(pos, "-format")];
    format && (arg = ("").concat(format, "{").concat(arg, "}"));
    return new TexParser_js_1$4.default(arg, parser.stack.env, parser.configuration).mml();
  }
};

(function (exports) {
  var __assign = commonjsGlobal && commonjsGlobal.__assign || (function () {
    __assign = Object.assign || (function (t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    });
    return __assign.apply(this, arguments);
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.MathtoolsMethods = void 0;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var AmsMethods_js_1 = AmsMethods;
  var BaseMethods_js_1 = __importDefault(BaseMethods$1);
  var TexParser_js_1 = __importDefault(TexParser$1);
  var TexError_js_1 = __importDefault(TexError$1);
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var MmlNode_js_1 = MmlNode;
  var lengths_js_1 = lengths;
  var Options_js_1 = Options;
  var NewcommandUtil_js_1 = __importDefault(NewcommandUtil$1);
  var NewcommandMethods_js_1 = __importDefault(NewcommandMethods$1);
  var MathtoolsUtil_js_1 = MathtoolsUtil;
  exports.MathtoolsMethods = {
    MtMatrix: function (parser, begin, open, close) {
      var align = parser.GetBrackets(("\\begin{").concat(begin.getName(), "}"), 'c');
      return exports.MathtoolsMethods.Array(parser, begin, open, close, align);
    },
    MtSmallMatrix: function (parser, begin, open, close, align) {
      if (!align) {
        align = parser.GetBrackets(("\\begin{").concat(begin.getName(), "}"), parser.options.mathtools['smallmatrix-align']);
      }
      return exports.MathtoolsMethods.Array(parser, begin, open, close, align, ParseUtil_js_1.default.Em(1 / 3), '.2em', 'S', 1);
    },
    MtMultlined: function (parser, begin) {
      var _a;
      var name = ("\\begin{").concat(begin.getName(), "}");
      var pos = parser.GetBrackets(name, parser.options.mathtools['multlined-pos'] || 'c');
      var width = pos ? parser.GetBrackets(name, '') : '';
      if (pos && !pos.match(/^[cbt]$/)) {
        (_a = __read([pos, width], 2), width = _a[0], pos = _a[1]);
      }
      parser.Push(begin);
      var item = parser.itemFactory.create('multlined', parser, begin);
      item.arraydef = {
        displaystyle: true,
        rowspacing: '.5em',
        width: width || 'auto',
        columnwidth: '100%'
      };
      return ParseUtil_js_1.default.setArrayAlign(item, pos || 'c');
    },
    HandleShove: function (parser, name, shove) {
      var top = parser.stack.Top();
      if (top.kind !== 'multline' && top.kind !== 'multlined') {
        throw new TexError_js_1.default('CommandInMultlined', '%1 can only appear within the multline or multlined environments', name);
      }
      if (top.Size()) {
        throw new TexError_js_1.default('CommandAtTheBeginingOfLine', '%1 must come at the beginning of the line', name);
      }
      top.setProperty('shove', shove);
      var shift = parser.GetBrackets(name);
      var mml = parser.ParseArg(name);
      if (shift) {
        var mrow = parser.create('node', 'mrow', []);
        var mspace = parser.create('node', 'mspace', [], {
          width: shift
        });
        if (shove === 'left') {
          mrow.appendChild(mspace);
          mrow.appendChild(mml);
        } else {
          mrow.appendChild(mml);
          mrow.appendChild(mspace);
        }
        mml = mrow;
      }
      parser.Push(mml);
    },
    SpreadLines: function (parser, begin) {
      var e_1, _a;
      if (parser.stack.env.closing === begin.getName()) {
        delete parser.stack.env.closing;
        var top_1 = parser.stack.Pop();
        var mml = top_1.toMml();
        var spread = top_1.getProperty('spread');
        if (mml.isInferred) {
          try {
            for (var _b = __values(NodeUtil_js_1.default.getChildren(mml)), _c = _b.next(); !_c.done; _c = _b.next()) {
              var child = _c.value;
              MathtoolsUtil_js_1.MathtoolsUtil.spreadLines(child, spread);
            }
          } catch (e_1_1) {
            e_1 = {
              error: e_1_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            } finally {
              if (e_1) throw e_1.error;
            }
          }
        } else {
          MathtoolsUtil_js_1.MathtoolsUtil.spreadLines(mml, spread);
        }
        parser.Push(mml);
      } else {
        var spread = parser.GetDimen(("\\begin{").concat(begin.getName(), "}"));
        begin.setProperty('spread', spread);
        parser.Push(begin);
      }
    },
    Cases: function (parser, begin, open, close, style) {
      var array = parser.itemFactory.create('array').setProperty('casesEnv', begin.getName());
      array.arraydef = {
        rowspacing: '.2em',
        columnspacing: '1em',
        columnalign: 'left'
      };
      if (style === 'D') {
        array.arraydef.displaystyle = true;
      }
      array.setProperties({
        open: open,
        close: close
      });
      parser.Push(begin);
      return array;
    },
    MathLap: function (parser, name, pos, cramped) {
      var style = parser.GetBrackets(name, '').trim();
      var mml = parser.create('node', 'mstyle', [parser.create('node', 'mpadded', [parser.ParseArg(name)], __assign({
        width: 0
      }, pos === 'r' ? {} : {
        lspace: pos === 'l' ? '-1width' : '-.5width'
      }))], {
        'data-cramped': cramped
      });
      MathtoolsUtil_js_1.MathtoolsUtil.setDisplayLevel(mml, style);
      parser.Push(parser.create('node', 'TeXAtom', [mml]));
    },
    Cramped: function (parser, name) {
      var style = parser.GetBrackets(name, '').trim();
      var arg = parser.ParseArg(name);
      var mml = parser.create('node', 'mstyle', [arg], {
        'data-cramped': true
      });
      MathtoolsUtil_js_1.MathtoolsUtil.setDisplayLevel(mml, style);
      parser.Push(mml);
    },
    MtLap: function (parser, name, pos) {
      var content = ParseUtil_js_1.default.internalMath(parser, parser.GetArgument(name), 0);
      var mml = parser.create('node', 'mpadded', content, {
        width: 0
      });
      if (pos !== 'r') {
        NodeUtil_js_1.default.setAttribute(mml, 'lspace', pos === 'l' ? '-1width' : '-.5width');
      }
      parser.Push(mml);
    },
    MathMakeBox: function (parser, name) {
      var width = parser.GetBrackets(name);
      var pos = parser.GetBrackets(name, 'c');
      var mml = parser.create('node', 'mpadded', [parser.ParseArg(name)]);
      if (width) {
        NodeUtil_js_1.default.setAttribute(mml, 'width', width);
      }
      var align = (0, Options_js_1.lookup)(pos, {
        c: 'center',
        r: 'right'
      }, '');
      if (align) {
        NodeUtil_js_1.default.setAttribute(mml, 'data-align', align);
      }
      parser.Push(mml);
    },
    MathMBox: function (parser, name) {
      parser.Push(parser.create('node', 'mrow', [parser.ParseArg(name)]));
    },
    UnderOverBracket: function (parser, name) {
      var thickness = (0, lengths_js_1.length2em)(parser.GetBrackets(name, '.1em'), .1);
      var height = parser.GetBrackets(name, '.2em');
      var arg = parser.GetArgument(name);
      var _a = __read(name.charAt(1) === 'o' ? ['over', 'accent', 'bottom'] : ['under', 'accentunder', 'top'], 3), pos = _a[0], accent = _a[1], border = _a[2];
      var t = (0, lengths_js_1.em)(thickness);
      var base = new TexParser_js_1.default(arg, parser.stack.env, parser.configuration).mml();
      var copy = new TexParser_js_1.default(arg, parser.stack.env, parser.configuration).mml();
      var script = parser.create('node', 'mpadded', [parser.create('node', 'mphantom', [copy])], {
        style: ("border: ").concat(t, " solid; border-").concat(border, ": none"),
        height: height,
        depth: 0
      });
      var node = ParseUtil_js_1.default.underOver(parser, base, script, pos, true);
      var munderover = NodeUtil_js_1.default.getChildAt(NodeUtil_js_1.default.getChildAt(node, 0), 0);
      NodeUtil_js_1.default.setAttribute(munderover, accent, true);
      parser.Push(node);
    },
    Aboxed: function (parser, name) {
      var top = MathtoolsUtil_js_1.MathtoolsUtil.checkAlignment(parser, name);
      if (top.row.length % 2 === 1) {
        top.row.push(parser.create('node', 'mtd', []));
      }
      var arg = parser.GetArgument(name);
      var rest = parser.string.substr(parser.i);
      parser.string = arg + '&&\\endAboxed';
      parser.i = 0;
      var left = parser.GetUpTo(name, '&');
      var right = parser.GetUpTo(name, '&');
      parser.GetUpTo(name, '\\endAboxed');
      var tex = ParseUtil_js_1.default.substituteArgs(parser, [left, right], '\\rlap{\\boxed{#1{}#2}}\\kern.267em\\phantom{#1}&\\phantom{{}#2}\\kern.267em');
      parser.string = tex + rest;
      parser.i = 0;
    },
    ArrowBetweenLines: function (parser, name) {
      var top = MathtoolsUtil_js_1.MathtoolsUtil.checkAlignment(parser, name);
      if (top.Size() || top.row.length) {
        throw new TexError_js_1.default('BetweenLines', '%1 must be on a row by itself', name);
      }
      var star = parser.GetStar();
      var symbol = parser.GetBrackets(name, '\\Updownarrow');
      if (star) {
        top.EndEntry();
        top.EndEntry();
      }
      var tex = star ? '\\quad' + symbol : symbol + '\\quad';
      var mml = new TexParser_js_1.default(tex, parser.stack.env, parser.configuration).mml();
      parser.Push(mml);
      top.EndEntry();
      top.EndRow();
    },
    VDotsWithin: function (parser, name) {
      var top = parser.stack.Top();
      var isFlush = top.getProperty('flushspaceabove') === top.table.length;
      var arg = '\\mmlToken{mi}{}' + parser.GetArgument(name) + '\\mmlToken{mi}{}';
      var base = new TexParser_js_1.default(arg, parser.stack.env, parser.configuration).mml();
      var mml = parser.create('node', 'mpadded', [parser.create('node', 'mpadded', [parser.create('node', 'mo', [parser.create('text', '\u22EE')])], __assign({
        width: 0,
        lspace: '-.5width'
      }, isFlush ? {
        height: '-.6em',
        voffset: '-.18em'
      } : {})), parser.create('node', 'mphantom', [base])], {
        lspace: '.5width'
      });
      parser.Push(mml);
    },
    ShortVDotsWithin: function (parser, _name) {
      var top = parser.stack.Top();
      var star = parser.GetStar();
      exports.MathtoolsMethods.FlushSpaceAbove(parser, '\\MTFlushSpaceAbove');
      !star && top.EndEntry();
      exports.MathtoolsMethods.VDotsWithin(parser, '\\vdotswithin');
      star && top.EndEntry();
      exports.MathtoolsMethods.FlushSpaceBelow(parser, '\\MTFlushSpaceBelow');
    },
    FlushSpaceAbove: function (parser, name) {
      var top = MathtoolsUtil_js_1.MathtoolsUtil.checkAlignment(parser, name);
      top.setProperty('flushspaceabove', top.table.length);
      top.addRowSpacing('-' + parser.options.mathtools['shortvdotsadjustabove']);
    },
    FlushSpaceBelow: function (parser, name) {
      var top = MathtoolsUtil_js_1.MathtoolsUtil.checkAlignment(parser, name);
      top.Size() && top.EndEntry();
      top.EndRow();
      top.addRowSpacing('-' + parser.options.mathtools['shortvdotsadjustbelow']);
    },
    PairedDelimiters: function (parser, name, open, close, body, n, pre, post) {
      if (body === void 0) {
        body = '#1';
      }
      if (n === void 0) {
        n = 1;
      }
      if (pre === void 0) {
        pre = '';
      }
      if (post === void 0) {
        post = '';
      }
      var star = parser.GetStar();
      var size = star ? '' : parser.GetBrackets(name);
      var _a = __read(star ? ['\\left', '\\right'] : size ? [size + 'l', size + 'r'] : ['', ''], 2), left = _a[0], right = _a[1];
      var delim = star ? '\\middle' : size || '';
      if (n) {
        var args = [];
        for (var i = args.length; i < n; i++) {
          args.push(parser.GetArgument(name));
        }
        pre = ParseUtil_js_1.default.substituteArgs(parser, args, pre);
        body = ParseUtil_js_1.default.substituteArgs(parser, args, body);
        post = ParseUtil_js_1.default.substituteArgs(parser, args, post);
      }
      body = body.replace(/\\delimsize/g, delim);
      parser.string = [pre, left, open, body, right, close, post, parser.string.substr(parser.i)].reduce(function (s, part) {
        return ParseUtil_js_1.default.addArgs(parser, s, part);
      }, '');
      parser.i = 0;
      ParseUtil_js_1.default.checkMaxMacros(parser);
    },
    DeclarePairedDelimiter: function (parser, name) {
      var cs = NewcommandUtil_js_1.default.GetCsNameArgument(parser, name);
      var open = parser.GetArgument(name);
      var close = parser.GetArgument(name);
      MathtoolsUtil_js_1.MathtoolsUtil.addPairedDelims(parser.configuration, cs, [open, close]);
    },
    DeclarePairedDelimiterX: function (parser, name) {
      var cs = NewcommandUtil_js_1.default.GetCsNameArgument(parser, name);
      var n = NewcommandUtil_js_1.default.GetArgCount(parser, name);
      var open = parser.GetArgument(name);
      var close = parser.GetArgument(name);
      var body = parser.GetArgument(name);
      MathtoolsUtil_js_1.MathtoolsUtil.addPairedDelims(parser.configuration, cs, [open, close, body, n]);
    },
    DeclarePairedDelimiterXPP: function (parser, name) {
      var cs = NewcommandUtil_js_1.default.GetCsNameArgument(parser, name);
      var n = NewcommandUtil_js_1.default.GetArgCount(parser, name);
      var pre = parser.GetArgument(name);
      var open = parser.GetArgument(name);
      var close = parser.GetArgument(name);
      var post = parser.GetArgument(name);
      var body = parser.GetArgument(name);
      MathtoolsUtil_js_1.MathtoolsUtil.addPairedDelims(parser.configuration, cs, [open, close, body, n, pre, post]);
    },
    CenterColon: function (parser, _name, center, force, thin) {
      if (force === void 0) {
        force = false;
      }
      if (thin === void 0) {
        thin = false;
      }
      var options = parser.options.mathtools;
      var mml = parser.create('token', 'mo', {}, ':');
      if (center && (options['centercolon'] || force)) {
        var dy = options['centercolon-offset'];
        mml = parser.create('node', 'mpadded', [mml], __assign({
          voffset: dy,
          height: ("+").concat(dy),
          depth: ("-").concat(dy)
        }, thin ? {
          width: options['thincolon-dw'],
          lspace: options['thincolon-dx']
        } : {}));
      }
      parser.Push(mml);
    },
    Relation: function (parser, _name, tex, unicode) {
      var options = parser.options.mathtools;
      if (options['use-unicode'] && unicode) {
        parser.Push(parser.create('token', 'mo', {
          texClass: MmlNode_js_1.TEXCLASS.REL
        }, unicode));
      } else {
        tex = '\\mathrel{' + tex.replace(/:/g, '\\MTThinColon').replace(/-/g, '\\mathrel{-}') + '}';
        parser.string = ParseUtil_js_1.default.addArgs(parser, tex, parser.string.substr(parser.i));
        parser.i = 0;
      }
    },
    NArrow: function (parser, _name, c, dy) {
      parser.Push(parser.create('node', 'TeXAtom', [parser.create('token', 'mtext', {}, c), parser.create('node', 'mpadded', [parser.create('node', 'mpadded', [parser.create('node', 'menclose', [parser.create('node', 'mspace', [], {
        height: '.2em',
        depth: 0,
        width: '.4em'
      })], {
        notation: 'updiagonalstrike',
        'data-thickness': '.05em',
        'data-padding': 0
      })], {
        width: 0,
        lspace: '-.5width',
        voffset: dy
      }), parser.create('node', 'mphantom', [parser.create('token', 'mtext', {}, c)])], {
        width: 0,
        lspace: '-.5width'
      })], {
        texClass: MmlNode_js_1.TEXCLASS.REL
      }));
    },
    SplitFrac: function (parser, name, display) {
      var num = parser.ParseArg(name);
      var den = parser.ParseArg(name);
      parser.Push(parser.create('node', 'mstyle', [parser.create('node', 'mfrac', [parser.create('node', 'mstyle', [num, parser.create('token', 'mi'), parser.create('token', 'mspace', {
        width: '1em'
      })], {
        scriptlevel: 0
      }), parser.create('node', 'mstyle', [parser.create('token', 'mspace', {
        width: '1em'
      }), parser.create('token', 'mi'), den], {
        scriptlevel: 0
      })], {
        linethickness: 0,
        numalign: 'left',
        denomalign: 'right'
      })], {
        displaystyle: display,
        scriptlevel: 0
      }));
    },
    XMathStrut: function (parser, name) {
      var dd = parser.GetBrackets(name);
      var dh = parser.GetArgument(name);
      dh = MathtoolsUtil_js_1.MathtoolsUtil.plusOrMinus(name, dh);
      dd = MathtoolsUtil_js_1.MathtoolsUtil.plusOrMinus(name, dd || dh);
      parser.Push(parser.create('node', 'TeXAtom', [parser.create('node', 'mpadded', [parser.create('node', 'mphantom', [parser.create('token', 'mo', {
        stretchy: false
      }, '(')])], {
        width: 0,
        height: dh + 'height',
        depth: dd + 'depth'
      })], {
        texClass: MmlNode_js_1.TEXCLASS.ORD
      }));
    },
    Prescript: function (parser, name) {
      var sup = MathtoolsUtil_js_1.MathtoolsUtil.getScript(parser, name, 'sup');
      var sub = MathtoolsUtil_js_1.MathtoolsUtil.getScript(parser, name, 'sub');
      var base = MathtoolsUtil_js_1.MathtoolsUtil.getScript(parser, name, 'arg');
      if (NodeUtil_js_1.default.isType(sup, 'none') && NodeUtil_js_1.default.isType(sub, 'none')) {
        parser.Push(base);
        return;
      }
      var mml = parser.create('node', 'mmultiscripts', [base]);
      NodeUtil_js_1.default.getChildren(mml).push(null, null);
      NodeUtil_js_1.default.appendChildren(mml, [parser.create('node', 'mprescripts'), sub, sup]);
      mml.setProperty('fixPrescript', true);
      parser.Push(mml);
    },
    NewTagForm: function (parser, name, renew) {
      if (renew === void 0) {
        renew = false;
      }
      var tags = parser.tags;
      if (!(('mtFormats' in tags))) {
        throw new TexError_js_1.default('TagsNotMT', '%1 can only be used with ams or mathtools tags', name);
      }
      var id = parser.GetArgument(name).trim();
      if (!id) {
        throw new TexError_js_1.default('InvalidTagFormID', 'Tag form name can\'t be empty');
      }
      var format = parser.GetBrackets(name, '');
      var left = parser.GetArgument(name);
      var right = parser.GetArgument(name);
      if (!renew && tags.mtFormats.has(id)) {
        throw new TexError_js_1.default('DuplicateTagForm', 'Duplicate tag form: %1', id);
      }
      tags.mtFormats.set(id, [left, right, format]);
    },
    UseTagForm: function (parser, name) {
      var tags = parser.tags;
      if (!(('mtFormats' in tags))) {
        throw new TexError_js_1.default('TagsNotMT', '%1 can only be used with ams or mathtools tags', name);
      }
      var id = parser.GetArgument(name).trim();
      if (!id) {
        tags.mtCurrent = null;
        return;
      }
      if (!tags.mtFormats.has(id)) {
        throw new TexError_js_1.default('UndefinedTagForm', 'Undefined tag form: %1', id);
      }
      tags.mtCurrent = tags.mtFormats.get(id);
    },
    SetOptions: function (parser, name) {
      var e_2, _a;
      var options = parser.options.mathtools;
      if (!options['allow-mathtoolsset']) {
        throw new TexError_js_1.default('ForbiddenMathtoolsSet', '%1 is disabled', name);
      }
      var allowed = {};
      Object.keys(options).forEach(function (id) {
        if (id !== 'pariedDelimiters' && id !== 'tagforms' && id !== 'allow-mathtoolsset') {
          allowed[id] = 1;
        }
      });
      var args = parser.GetArgument(name);
      var keys = ParseUtil_js_1.default.keyvalOptions(args, allowed, true);
      try {
        for (var _b = __values(Object.keys(keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var id = _c.value;
          options[id] = keys[id];
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    },
    Array: BaseMethods_js_1.default.Array,
    Macro: BaseMethods_js_1.default.Macro,
    xArrow: AmsMethods_js_1.AmsMethods.xArrow,
    HandleRef: AmsMethods_js_1.AmsMethods.HandleRef,
    AmsEqnArray: AmsMethods_js_1.AmsMethods.AmsEqnArray,
    MacroWithTemplate: NewcommandMethods_js_1.default.MacroWithTemplate
  };
})(MathtoolsMethods);
getDefaultExportFromCjs(MathtoolsMethods);

var __importDefault$b = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(MathtoolsMappings, "__esModule", {
  value: true
});
var ParseMethods_js_1$1 = __importDefault$b(ParseMethods$1);
var SymbolMap_js_1$5 = SymbolMap;
var TexConstants_js_1$5 = TexConstants;
var MathtoolsMethods_js_1 = MathtoolsMethods;
new SymbolMap_js_1$5.CommandMap('mathtools-macros', {
  shoveleft: ['HandleShove', TexConstants_js_1$5.TexConstant.Align.LEFT],
  shoveright: ['HandleShove', TexConstants_js_1$5.TexConstant.Align.RIGHT],
  xleftrightarrow: ['xArrow', 0x2194, 10, 10],
  xLeftarrow: ['xArrow', 0x21D0, 12, 7],
  xRightarrow: ['xArrow', 0x21D2, 7, 12],
  xLeftrightarrow: ['xArrow', 0x21D4, 12, 12],
  xhookleftarrow: ['xArrow', 0x21A9, 10, 5],
  xhookrightarrow: ['xArrow', 0x21AA, 5, 10],
  xmapsto: ['xArrow', 0x21A6, 10, 10],
  xrightharpoondown: ['xArrow', 0x21C1, 5, 10],
  xleftharpoondown: ['xArrow', 0x21BD, 10, 5],
  xrightleftharpoons: ['xArrow', 0x21CC, 10, 10],
  xrightharpoonup: ['xArrow', 0x21C0, 5, 10],
  xleftharpoonup: ['xArrow', 0x21BC, 10, 5],
  xleftrightharpoons: ['xArrow', 0x21CB, 10, 10],
  mathllap: ['MathLap', 'l', false],
  mathrlap: ['MathLap', 'r', false],
  mathclap: ['MathLap', 'c', false],
  clap: ['MtLap', 'c'],
  textllap: ['MtLap', 'l'],
  textrlap: ['MtLap', 'r'],
  textclap: ['MtLap', 'c'],
  cramped: 'Cramped',
  crampedllap: ['MathLap', 'l', true],
  crampedrlap: ['MathLap', 'r', true],
  crampedclap: ['MathLap', 'c', true],
  crampedsubstack: ['Macro', '\\begin{crampedsubarray}{c}#1\\end{crampedsubarray}', 1],
  mathmbox: 'MathMBox',
  mathmakebox: 'MathMakeBox',
  overbracket: 'UnderOverBracket',
  underbracket: 'UnderOverBracket',
  refeq: 'HandleRef',
  MoveEqLeft: ['Macro', '\\hspace{#1em}&\\hspace{-#1em}', 1, '2'],
  Aboxed: 'Aboxed',
  ArrowBetweenLines: 'ArrowBetweenLines',
  vdotswithin: 'VDotsWithin',
  shortvdotswithin: 'ShortVDotsWithin',
  MTFlushSpaceAbove: 'FlushSpaceAbove',
  MTFlushSpaceBelow: 'FlushSpaceBelow',
  DeclarePairedDelimiter: 'DeclarePairedDelimiter',
  DeclarePairedDelimiterX: 'DeclarePairedDelimiterX',
  DeclarePairedDelimiterXPP: 'DeclarePairedDelimiterXPP',
  DeclarePairedDelimiters: 'DeclarePairedDelimiter',
  DeclarePairedDelimitersX: 'DeclarePairedDelimiterX',
  DeclarePairedDelimitersXPP: 'DeclarePairedDelimiterXPP',
  centercolon: ['CenterColon', true, true],
  ordinarycolon: ['CenterColon', false],
  MTThinColon: ['CenterColon', true, true, true],
  coloneqq: ['Relation', ':=', '\u2254'],
  Coloneqq: ['Relation', '::=', '\u2A74'],
  coloneq: ['Relation', ':-'],
  Coloneq: ['Relation', '::-'],
  eqqcolon: ['Relation', '=:', '\u2255'],
  Eqqcolon: ['Relation', '=::'],
  eqcolon: ['Relation', '-:', '\u2239'],
  Eqcolon: ['Relation', '-::'],
  colonapprox: ['Relation', ':\\approx'],
  Colonapprox: ['Relation', '::\\approx'],
  colonsim: ['Relation', ':\\sim'],
  Colonsim: ['Relation', '::\\sim'],
  dblcolon: ['Relation', '::', '\u2237'],
  nuparrow: ['NArrow', '\u2191', '.06em'],
  ndownarrow: ['NArrow', '\u2193', '.25em'],
  bigtimes: ['Macro', '\\mathop{\\Large\\kern-.1em\\boldsymbol{\\times}\\kern-.1em}'],
  splitfrac: ['SplitFrac', false],
  splitdfrac: ['SplitFrac', true],
  xmathstrut: 'XMathStrut',
  prescript: 'Prescript',
  newtagform: ['NewTagForm', false],
  renewtagform: ['NewTagForm', true],
  usetagform: 'UseTagForm',
  adjustlimits: ['MacroWithTemplate', '\\mathop{{#1}\\vphantom{{#3}}}_{{#2}\\vphantom{{#4}}}\\mathop{{#3}\\vphantom{{#1}}}_{{#4}\\vphantom{{#2}}}', 4, , '_', , '_'],
  mathtoolsset: 'SetOptions'
}, MathtoolsMethods_js_1.MathtoolsMethods);
new SymbolMap_js_1$5.EnvironmentMap('mathtools-environments', ParseMethods_js_1$1.default.environment, {
  dcases: ['Array', null, '\\{', '', 'll', null, '.2em', 'D'],
  rcases: ['Array', null, '', '\\}', 'll', null, '.2em'],
  drcases: ['Array', null, '', '\\}', 'll', null, '.2em', 'D'],
  'dcases*': ['Cases', null, '{', '', 'D'],
  'rcases*': ['Cases', null, '', '}'],
  'drcases*': ['Cases', null, '', '}', 'D'],
  'cases*': ['Cases', null, '{', ''],
  'matrix*': ['MtMatrix', null, null, null],
  'pmatrix*': ['MtMatrix', null, '(', ')'],
  'bmatrix*': ['MtMatrix', null, '[', ']'],
  'Bmatrix*': ['MtMatrix', null, '\\{', '\\}'],
  'vmatrix*': ['MtMatrix', null, '\\vert', '\\vert'],
  'Vmatrix*': ['MtMatrix', null, '\\Vert', '\\Vert'],
  'smallmatrix*': ['MtSmallMatrix', null, null, null],
  psmallmatrix: ['MtSmallMatrix', null, '(', ')', 'c'],
  'psmallmatrix*': ['MtSmallMatrix', null, '(', ')'],
  bsmallmatrix: ['MtSmallMatrix', null, '[', ']', 'c'],
  'bsmallmatrix*': ['MtSmallMatrix', null, '[', ']'],
  Bsmallmatrix: ['MtSmallMatrix', null, '\\{', '\\}', 'c'],
  'Bsmallmatrix*': ['MtSmallMatrix', null, '\\{', '\\}'],
  vsmallmatrix: ['MtSmallMatrix', null, '\\vert', '\\vert', 'c'],
  'vsmallmatrix*': ['MtSmallMatrix', null, '\\vert', '\\vert'],
  Vsmallmatrix: ['MtSmallMatrix', null, '\\Vert', '\\Vert', 'c'],
  'Vsmallmatrix*': ['MtSmallMatrix', null, '\\Vert', '\\Vert'],
  crampedsubarray: ['Array', null, null, null, null, '0em', '0.1em', 'S\'', 1],
  multlined: 'MtMultlined',
  spreadlines: ['SpreadLines', true],
  lgathered: ['AmsEqnArray', null, null, null, 'l', null, '.5em', 'D'],
  rgathered: ['AmsEqnArray', null, null, null, 'r', null, '.5em', 'D']
}, MathtoolsMethods_js_1.MathtoolsMethods);
new SymbolMap_js_1$5.DelimiterMap('mathtools-delimiters', ParseMethods_js_1$1.default.delimiter, {
  '\\lparen': '(',
  '\\rparen': ')'
});
new SymbolMap_js_1$5.CommandMap('mathtools-characters', {
  ':': ['CenterColon', true]
}, MathtoolsMethods_js_1.MathtoolsMethods);

var MathtoolsTags = {};

var __extends$6 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$3 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$3 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __importDefault$a = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(MathtoolsTags, "__esModule", {
  value: true
});
MathtoolsTags.MathtoolsTagFormat = void 0;
var TexError_js_1$3 = __importDefault$a(TexError$1);
var Tags_js_1$2 = Tags;
var tagID$1 = 0;
function MathtoolsTagFormat(config, jax) {
  var tags = jax.parseOptions.options.tags;
  if (tags !== 'base' && config.tags.hasOwnProperty(tags)) {
    Tags_js_1$2.TagsFactory.add(tags, config.tags[tags]);
  }
  var TagClass = Tags_js_1$2.TagsFactory.create(jax.parseOptions.options.tags).constructor;
  var TagFormat = (function (_super) {
    __extends$6(TagFormat, _super);
    function TagFormat() {
      var e_1, _a;
      var _this = _super.call(this) || this;
      _this.mtFormats = new Map();
      _this.mtCurrent = null;
      var forms = jax.parseOptions.options.mathtools.tagforms;
      try {
        for (var _b = __values$3(Object.keys(forms)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var form = _c.value;
          if (!Array.isArray(forms[form]) || forms[form].length !== 3) {
            throw new TexError_js_1$3.default('InvalidTagFormDef', 'The tag form definition for "%1" should be an array fo three strings', form);
          }
          _this.mtFormats.set(form, forms[form]);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return _this;
    }
    TagFormat.prototype.formatTag = function (tag) {
      if (this.mtCurrent) {
        var _a = __read$3(this.mtCurrent, 3), left = _a[0], right = _a[1], format = _a[2];
        return format ? ("").concat(left).concat(format, "{").concat(tag, "}").concat(right) : ("").concat(left).concat(tag).concat(right);
      }
      return _super.prototype.formatTag.call(this, tag);
    };
    return TagFormat;
  })(TagClass);
  tagID$1++;
  var tagName = 'MathtoolsTags-' + tagID$1;
  Tags_js_1$2.TagsFactory.add(tagName, TagFormat);
  jax.parseOptions.options.tags = tagName;
}
MathtoolsTags.MathtoolsTagFormat = MathtoolsTagFormat;

var MathtoolsItems = {};

var __extends$5 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __importDefault$9 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(MathtoolsItems, "__esModule", {
  value: true
});
MathtoolsItems.MultlinedItem = void 0;
var AmsItems_js_1 = AmsItems;
var NodeUtil_js_1$3 = __importDefault$9(NodeUtil$1);
var TexConstants_js_1$4 = TexConstants;
var MultlinedItem = (function (_super) {
  __extends$5(MultlinedItem, _super);
  function MultlinedItem() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  Object.defineProperty(MultlinedItem.prototype, "kind", {
    get: function () {
      return 'multlined';
    },
    enumerable: false,
    configurable: true
  });
  MultlinedItem.prototype.EndTable = function () {
    if (this.Size() || this.row.length) {
      this.EndEntry();
      this.EndRow();
    }
    if (this.table.length > 1) {
      var options = this.factory.configuration.options.mathtools;
      var gap = options.multlinegap;
      var firstskip = options['firstline-afterskip'] || gap;
      var lastskip = options['lastline-preskip'] || gap;
      var first = NodeUtil_js_1$3.default.getChildren(this.table[0])[0];
      if (NodeUtil_js_1$3.default.getAttribute(first, 'columnalign') !== TexConstants_js_1$4.TexConstant.Align.RIGHT) {
        first.appendChild(this.create('node', 'mspace', [], {
          width: firstskip
        }));
      }
      var last = NodeUtil_js_1$3.default.getChildren(this.table[this.table.length - 1])[0];
      if (NodeUtil_js_1$3.default.getAttribute(last, 'columnalign') !== TexConstants_js_1$4.TexConstant.Align.LEFT) {
        var top_1 = NodeUtil_js_1$3.default.getChildren(last)[0];
        top_1.childNodes.unshift(null);
        var space = this.create('node', 'mspace', [], {
          width: lastskip
        });
        NodeUtil_js_1$3.default.setChild(top_1, 0, space);
      }
    }
    _super.prototype.EndTable.call(this);
  };
  return MultlinedItem;
})(AmsItems_js_1.MultlineItem);
MathtoolsItems.MultlinedItem = MultlinedItem;

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  var _a;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.MathtoolsConfiguration = exports.fixPrescripts = exports.PAIREDDELIMS = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var Options_js_1 = Options;
  var MathtoolsUtil_js_1 = MathtoolsUtil;
  var MathtoolsTags_js_1 = MathtoolsTags;
  var MathtoolsItems_js_1 = MathtoolsItems;
  exports.PAIREDDELIMS = 'mathtools-paired-delims';
  function initMathtools(config) {
    new SymbolMap_js_1.CommandMap(exports.PAIREDDELIMS, {}, {});
    config.append(Configuration_js_1.Configuration.local({
      handler: {
        macro: [exports.PAIREDDELIMS]
      },
      priority: -5
    }));
  }
  function configMathtools(config, jax) {
    var e_1, _a;
    var parser = jax.parseOptions;
    var pairedDelims = parser.options.mathtools.pairedDelimiters;
    try {
      for (var _b = __values(Object.keys(pairedDelims)), _c = _b.next(); !_c.done; _c = _b.next()) {
        var cs = _c.value;
        MathtoolsUtil_js_1.MathtoolsUtil.addPairedDelims(parser, cs, pairedDelims[cs]);
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    (0, MathtoolsTags_js_1.MathtoolsTagFormat)(config, jax);
  }
  function fixPrescripts(_a) {
    var e_2, _b, e_3, _c, e_4, _d;
    var data = _a.data;
    try {
      for (var _e = __values(data.getList('mmultiscripts')), _f = _e.next(); !_f.done; _f = _e.next()) {
        var node = _f.value;
        if (!node.getProperty('fixPrescript')) continue;
        var childNodes = NodeUtil_js_1.default.getChildren(node);
        var n = 0;
        try {
          for (var _g = (e_3 = void 0, __values([1, 2])), _h = _g.next(); !_h.done; _h = _g.next()) {
            var i = _h.value;
            if (!childNodes[i]) {
              NodeUtil_js_1.default.setChild(node, i, data.nodeFactory.create('node', 'none'));
              n++;
            }
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_h && !_h.done && (_c = _g.return)) _c.call(_g);
          } finally {
            if (e_3) throw e_3.error;
          }
        }
        try {
          for (var _j = (e_4 = void 0, __values([4, 5])), _k = _j.next(); !_k.done; _k = _j.next()) {
            var i = _k.value;
            if (NodeUtil_js_1.default.isType(childNodes[i], 'mrow') && NodeUtil_js_1.default.getChildren(childNodes[i]).length === 0) {
              NodeUtil_js_1.default.setChild(node, i, data.nodeFactory.create('node', 'none'));
            }
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_k && !_k.done && (_d = _j.return)) _d.call(_j);
          } finally {
            if (e_4) throw e_4.error;
          }
        }
        if (n === 2) {
          childNodes.splice(1, 2);
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  }
  exports.fixPrescripts = fixPrescripts;
  exports.MathtoolsConfiguration = Configuration_js_1.Configuration.create('mathtools', {
    handler: {
      macro: ['mathtools-macros', 'mathtools-delimiters'],
      environment: ['mathtools-environments'],
      delimiter: ['mathtools-delimiters'],
      character: ['mathtools-characters']
    },
    items: (_a = {}, _a[MathtoolsItems_js_1.MultlinedItem.prototype.kind] = MathtoolsItems_js_1.MultlinedItem, _a),
    init: initMathtools,
    config: configMathtools,
    postprocessors: [[fixPrescripts, -6]],
    options: {
      mathtools: {
        'multlinegap': '1em',
        'multlined-pos': 'c',
        'firstline-afterskip': '',
        'lastline-preskip': '',
        'smallmatrix-align': 'c',
        'shortvdotsadjustabove': '.2em',
        'shortvdotsadjustbelow': '.2em',
        'centercolon': false,
        'centercolon-offset': '.04em',
        'thincolon-dx': '-.04em',
        'thincolon-dw': '-.08em',
        'use-unicode': false,
        'prescript-sub-format': '',
        'prescript-sup-format': '',
        'prescript-arg-format': '',
        'allow-mathtoolsset': true,
        pairedDelimiters: (0, Options_js_1.expandable)({}),
        tagforms: (0, Options_js_1.expandable)({})
      }
    }
  });
})(MathtoolsConfiguration);
getDefaultExportFromCjs(MathtoolsConfiguration);

var MhchemConfiguration = {};

var mhchemParser$1 = {};

Object.defineProperty(mhchemParser$1, "__esModule", {
  value: true
});
mhchemParser$1.mhchemParser = void 0;
var mhchemParser = (function () {
  function mhchemParser() {}
  mhchemParser.toTex = function (input, type) {
    return _mhchemTexify.go(_mhchemParser.go(input, type), type !== "tex");
  };
  return mhchemParser;
})();
mhchemParser$1.mhchemParser = mhchemParser;
function _mhchemCreateTransitions(o) {
  var pattern, state;
  var transitions = {};
  for (pattern in o) {
    for (state in o[pattern]) {
      var stateArray = state.split("|");
      o[pattern][state].stateArray = stateArray;
      for (var i = 0; i < stateArray.length; i++) {
        transitions[stateArray[i]] = [];
      }
    }
  }
  for (pattern in o) {
    for (state in o[pattern]) {
      var stateArray = o[pattern][state].stateArray || [];
      for (var i = 0; i < stateArray.length; i++) {
        var p = o[pattern][state];
        p.action_ = [].concat(p.action_);
        for (var k = 0; k < p.action_.length; k++) {
          if (typeof p.action_[k] === "string") {
            p.action_[k] = {
              type_: p.action_[k]
            };
          }
        }
        var patternArray = pattern.split("|");
        for (var j = 0; j < patternArray.length; j++) {
          if (stateArray[i] === '*') {
            var t = void 0;
            for (t in transitions) {
              transitions[t].push({
                pattern: patternArray[j],
                task: p
              });
            }
          } else {
            transitions[stateArray[i]].push({
              pattern: patternArray[j],
              task: p
            });
          }
        }
      }
    }
  }
  return transitions;
}
var _mhchemParser = {
  go: function (input, stateMachine) {
    if (!input) {
      return [];
    }
    if (stateMachine === undefined) {
      stateMachine = 'ce';
    }
    var state = '0';
    var buffer = {};
    buffer['parenthesisLevel'] = 0;
    input = input.replace(/\n/g, " ");
    input = input.replace(/[\u2212\u2013\u2014\u2010]/g, "-");
    input = input.replace(/[\u2026]/g, "...");
    var lastInput;
    var watchdog = 10;
    var output = [];
    while (true) {
      if (lastInput !== input) {
        watchdog = 10;
        lastInput = input;
      } else {
        watchdog--;
      }
      var machine = _mhchemParser.stateMachines[stateMachine];
      var t = machine.transitions[state] || machine.transitions['*'];
      iterateTransitions: for (var i = 0; i < t.length; i++) {
        var matches = _mhchemParser.patterns.match_(t[i].pattern, input);
        if (matches) {
          var task = t[i].task;
          for (var iA = 0; iA < task.action_.length; iA++) {
            var o = void 0;
            if (machine.actions[task.action_[iA].type_]) {
              o = machine.actions[task.action_[iA].type_](buffer, matches.match_, task.action_[iA].option);
            } else if (_mhchemParser.actions[task.action_[iA].type_]) {
              o = _mhchemParser.actions[task.action_[iA].type_](buffer, matches.match_, task.action_[iA].option);
            } else {
              throw ["MhchemBugA", "mhchem bug A. Please report. (" + task.action_[iA].type_ + ")"];
            }
            _mhchemParser.concatArray(output, o);
          }
          state = task.nextState || state;
          if (input.length > 0) {
            if (!task.revisit) {
              input = matches.remainder;
            }
            if (!task.toContinue) {
              break iterateTransitions;
            }
          } else {
            return output;
          }
        }
      }
      if (watchdog <= 0) {
        throw ["MhchemBugU", "mhchem bug U. Please report."];
      }
    }
  },
  concatArray: function (a, b) {
    if (b) {
      if (Array.isArray(b)) {
        for (var iB = 0; iB < b.length; iB++) {
          a.push(b[iB]);
        }
      } else {
        a.push(b);
      }
    }
  },
  patterns: {
    patterns: {
      'empty': /^$/,
      'else': /^./,
      'else2': /^./,
      'space': /^\s/,
      'space A': /^\s(?=[A-Z\\$])/,
      'space$': /^\s$/,
      'a-z': /^[a-z]/,
      'x': /^x/,
      'x$': /^x$/,
      'i$': /^i$/,
      'letters': /^(?:[a-zA-Z\u03B1-\u03C9\u0391-\u03A9?@]|(?:\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega|Gamma|Delta|Theta|Lambda|Xi|Pi|Sigma|Upsilon|Phi|Psi|Omega)(?:\s+|\{\}|(?![a-zA-Z]))))+/,
      '\\greek': /^\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega|Gamma|Delta|Theta|Lambda|Xi|Pi|Sigma|Upsilon|Phi|Psi|Omega)(?:\s+|\{\}|(?![a-zA-Z]))/,
      'one lowercase latin letter $': /^(?:([a-z])(?:$|[^a-zA-Z]))$/,
      '$one lowercase latin letter$ $': /^\$(?:([a-z])(?:$|[^a-zA-Z]))\$$/,
      'one lowercase greek letter $': /^(?:\$?[\u03B1-\u03C9]\$?|\$?\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega)\s*\$?)(?:\s+|\{\}|(?![a-zA-Z]))$/,
      'digits': /^[0-9]+/,
      '-9.,9': /^[+\-]?(?:[0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+))/,
      '-9.,9 no missing 0': /^[+\-]?[0-9]+(?:[.,][0-9]+)?/,
      '(-)(9.,9)(e)(99)': function (input) {
        var match = input.match(/^(\+\-|\+\/\-|\+|\-|\\pm\s?)?([0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+))?(\((?:[0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+))\))?(?:(?:([eE])|\s*(\*|x|\\times|\u00D7)\s*10\^)([+\-]?[0-9]+|\{[+\-]?[0-9]+\}))?/);
        if (match && match[0]) {
          return {
            match_: match.slice(1),
            remainder: input.substr(match[0].length)
          };
        }
        return null;
      },
      '(-)(9)^(-9)': /^(\+\-|\+\/\-|\+|\-|\\pm\s?)?([0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+)?)\^([+\-]?[0-9]+|\{[+\-]?[0-9]+\})/,
      'state of aggregation $': function (input) {
        var a = _mhchemParser.patterns.findObserveGroups(input, "", /^\([a-z]{1,3}(?=[\),])/, ")", "");
        if (a && a.remainder.match(/^($|[\s,;\)\]\}])/)) {
          return a;
        }
        var match = input.match(/^(?:\((?:\\ca\s?)?\$[amothc]\$\))/);
        if (match) {
          return {
            match_: match[0],
            remainder: input.substr(match[0].length)
          };
        }
        return null;
      },
      '_{(state of aggregation)}$': /^_\{(\([a-z]{1,3}\))\}/,
      '{[(': /^(?:\\\{|\[|\()/,
      ')]}': /^(?:\)|\]|\\\})/,
      ', ': /^[,;]\s*/,
      ',': /^[,;]/,
      '.': /^[.]/,
      '. __* ': /^([.\u22C5\u00B7\u2022]|[*])\s*/,
      '...': /^\.\.\.(?=$|[^.])/,
      '^{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "^{", "", "", "}");
      },
      '^($...$)': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "^", "$", "$", "");
      },
      '^a': /^\^([0-9]+|[^\\_])/,
      '^\\x{}{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "^", /^\\[a-zA-Z]+\{/, "}", "", "", "{", "}", "", true);
      },
      '^\\x{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "^", /^\\[a-zA-Z]+\{/, "}", "");
      },
      '^\\x': /^\^(\\[a-zA-Z]+)\s*/,
      '^(-1)': /^\^(-?\d+)/,
      '\'': /^'/,
      '_{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "_{", "", "", "}");
      },
      '_($...$)': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "_", "$", "$", "");
      },
      '_9': /^_([+\-]?[0-9]+|[^\\])/,
      '_\\x{}{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "_", /^\\[a-zA-Z]+\{/, "}", "", "", "{", "}", "", true);
      },
      '_\\x{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "_", /^\\[a-zA-Z]+\{/, "}", "");
      },
      '_\\x': /^_(\\[a-zA-Z]+)\s*/,
      '^_': /^(?:\^(?=_)|\_(?=\^)|[\^_]$)/,
      '{}^': /^\{\}(?=\^)/,
      '{}': /^\{\}/,
      '{...}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "", "{", "}", "");
      },
      '{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "{", "", "", "}");
      },
      '$...$': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "", "$", "$", "");
      },
      '${(...)}$__$(...)$': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "${", "", "", "}$") || _mhchemParser.patterns.findObserveGroups(input, "$", "", "", "$");
      },
      '=<>': /^[=<>]/,
      '#': /^[#\u2261]/,
      '+': /^\+/,
      '-$': /^-(?=[\s_},;\]/]|$|\([a-z]+\))/,
      '-9': /^-(?=[0-9])/,
      '- orbital overlap': /^-(?=(?:[spd]|sp)(?:$|[\s,;\)\]\}]))/,
      '-': /^-/,
      'pm-operator': /^(?:\\pm|\$\\pm\$|\+-|\+\/-)/,
      'operator': /^(?:\+|(?:[\-=<>]|<<|>>|\\approx|\$\\approx\$)(?=\s|$|-?[0-9]))/,
      'arrowUpDown': /^(?:v|\(v\)|\^|\(\^\))(?=$|[\s,;\)\]\}])/,
      '\\bond{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\bond{", "", "", "}");
      },
      '->': /^(?:<->|<-->|->|<-|<=>>|<<=>|<=>|[\u2192\u27F6\u21CC])/,
      'CMT': /^[CMT](?=\[)/,
      '[(...)]': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "[", "", "", "]");
      },
      '1st-level escape': /^(&|\\\\|\\hline)\s*/,
      '\\,': /^(?:\\[,\ ;:])/,
      '\\x{}{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "", /^\\[a-zA-Z]+\{/, "}", "", "", "{", "}", "", true);
      },
      '\\x{}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "", /^\\[a-zA-Z]+\{/, "}", "");
      },
      '\\ca': /^\\ca(?:\s+|(?![a-zA-Z]))/,
      '\\x': /^(?:\\[a-zA-Z]+\s*|\\[_&{}%])/,
      'orbital': /^(?:[0-9]{1,2}[spdfgh]|[0-9]{0,2}sp)(?=$|[^a-zA-Z])/,
      'others': /^[\/~|]/,
      '\\frac{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\frac{", "", "", "}", "{", "", "", "}");
      },
      '\\overset{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\overset{", "", "", "}", "{", "", "", "}");
      },
      '\\underset{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\underset{", "", "", "}", "{", "", "", "}");
      },
      '\\underbrace{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\underbrace{", "", "", "}_", "{", "", "", "}");
      },
      '\\color{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\color{", "", "", "}");
      },
      '\\color{(...)}{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\color{", "", "", "}", "{", "", "", "}") || _mhchemParser.patterns.findObserveGroups(input, "\\color", "\\", "", /^(?=\{)/, "{", "", "", "}");
      },
      '\\ce{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\ce{", "", "", "}");
      },
      '\\pu{(...)}': function (input) {
        return _mhchemParser.patterns.findObserveGroups(input, "\\pu{", "", "", "}");
      },
      'oxidation$': /^(?:[+-][IVX]+|\\pm\s*0|\$\\pm\$\s*0)$/,
      'd-oxidation$': /^(?:[+-]?\s?[IVX]+|\\pm\s*0|\$\\pm\$\s*0)$/,
      'roman numeral': /^[IVX]+/,
      '1/2$': /^[+\-]?(?:[0-9]+|\$[a-z]\$|[a-z])\/[0-9]+(?:\$[a-z]\$|[a-z])?$/,
      'amount': function (input) {
        var match;
        match = input.match(/^(?:(?:(?:\([+\-]?[0-9]+\/[0-9]+\)|[+\-]?(?:[0-9]+|\$[a-z]\$|[a-z])\/[0-9]+|[+\-]?[0-9]+[.,][0-9]+|[+\-]?\.[0-9]+|[+\-]?[0-9]+)(?:[a-z](?=\s*[A-Z]))?)|[+\-]?[a-z](?=\s*[A-Z])|\+(?!\s))/);
        if (match) {
          return {
            match_: match[0],
            remainder: input.substr(match[0].length)
          };
        }
        var a = _mhchemParser.patterns.findObserveGroups(input, "", "$", "$", "");
        if (a) {
          match = a.match_.match(/^\$(?:\(?[+\-]?(?:[0-9]*[a-z]?[+\-])?[0-9]*[a-z](?:[+\-][0-9]*[a-z]?)?\)?|\+|-)\$$/);
          if (match) {
            return {
              match_: match[0],
              remainder: input.substr(match[0].length)
            };
          }
        }
        return null;
      },
      'amount2': function (input) {
        return this['amount'](input);
      },
      '(KV letters),': /^(?:[A-Z][a-z]{0,2}|i)(?=,)/,
      'formula$': function (input) {
        if (input.match(/^\([a-z]+\)$/)) {
          return null;
        }
        var match = input.match(/^(?:[a-z]|(?:[0-9\ \+\-\,\.\(\)]+[a-z])+[0-9\ \+\-\,\.\(\)]*|(?:[a-z][0-9\ \+\-\,\.\(\)]+)+[a-z]?)$/);
        if (match) {
          return {
            match_: match[0],
            remainder: input.substr(match[0].length)
          };
        }
        return null;
      },
      'uprightEntities': /^(?:pH|pOH|pC|pK|iPr|iBu)(?=$|[^a-zA-Z])/,
      '/': /^\s*(\/)\s*/,
      '//': /^\s*(\/\/)\s*/,
      '*': /^\s*[*.]\s*/
    },
    findObserveGroups: function (input, begExcl, begIncl, endIncl, endExcl, beg2Excl, beg2Incl, end2Incl, end2Excl, combine) {
      var _match = function (input, pattern) {
        if (typeof pattern === "string") {
          if (input.indexOf(pattern) !== 0) {
            return null;
          }
          return pattern;
        } else {
          var match_1 = input.match(pattern);
          if (!match_1) {
            return null;
          }
          return match_1[0];
        }
      };
      var _findObserveGroups = function (input, i, endChars) {
        var braces = 0;
        while (i < input.length) {
          var a = input.charAt(i);
          var match_2 = _match(input.substr(i), endChars);
          if (match_2 !== null && braces === 0) {
            return {
              endMatchBegin: i,
              endMatchEnd: i + match_2.length
            };
          } else if (a === "{") {
            braces++;
          } else if (a === "}") {
            if (braces === 0) {
              throw ["ExtraCloseMissingOpen", "Extra close brace or missing open brace"];
            } else {
              braces--;
            }
          }
          i++;
        }
        if (braces > 0) {
          return null;
        }
        return null;
      };
      var match = _match(input, begExcl);
      if (match === null) {
        return null;
      }
      input = input.substr(match.length);
      match = _match(input, begIncl);
      if (match === null) {
        return null;
      }
      var e = _findObserveGroups(input, match.length, endIncl || endExcl);
      if (e === null) {
        return null;
      }
      var match1 = input.substring(0, endIncl ? e.endMatchEnd : e.endMatchBegin);
      if (!(beg2Excl || beg2Incl)) {
        return {
          match_: match1,
          remainder: input.substr(e.endMatchEnd)
        };
      } else {
        var group2 = this.findObserveGroups(input.substr(e.endMatchEnd), beg2Excl, beg2Incl, end2Incl, end2Excl);
        if (group2 === null) {
          return null;
        }
        var matchRet = [match1, group2.match_];
        return {
          match_: combine ? matchRet.join("") : matchRet,
          remainder: group2.remainder
        };
      }
    },
    match_: function (m, input) {
      var pattern = _mhchemParser.patterns.patterns[m];
      if (pattern === undefined) {
        throw ["MhchemBugP", "mhchem bug P. Please report. (" + m + ")"];
      } else if (typeof pattern === "function") {
        return _mhchemParser.patterns.patterns[m](input);
      } else {
        var match = input.match(pattern);
        if (match) {
          if (match.length > 2) {
            return {
              match_: match.slice(1),
              remainder: input.substr(match[0].length)
            };
          } else {
            return {
              match_: match[1] || match[0],
              remainder: input.substr(match[0].length)
            };
          }
        }
        return null;
      }
    }
  },
  actions: {
    'a=': function (buffer, m) {
      buffer.a = (buffer.a || "") + m;
      return undefined;
    },
    'b=': function (buffer, m) {
      buffer.b = (buffer.b || "") + m;
      return undefined;
    },
    'p=': function (buffer, m) {
      buffer.p = (buffer.p || "") + m;
      return undefined;
    },
    'o=': function (buffer, m) {
      buffer.o = (buffer.o || "") + m;
      return undefined;
    },
    'q=': function (buffer, m) {
      buffer.q = (buffer.q || "") + m;
      return undefined;
    },
    'd=': function (buffer, m) {
      buffer.d = (buffer.d || "") + m;
      return undefined;
    },
    'rm=': function (buffer, m) {
      buffer.rm = (buffer.rm || "") + m;
      return undefined;
    },
    'text=': function (buffer, m) {
      buffer.text_ = (buffer.text_ || "") + m;
      return undefined;
    },
    'insert': function (_buffer, _m, a) {
      return {
        type_: a
      };
    },
    'insert+p1': function (_buffer, m, a) {
      return {
        type_: a,
        p1: m
      };
    },
    'insert+p1+p2': function (_buffer, m, a) {
      return {
        type_: a,
        p1: m[0],
        p2: m[1]
      };
    },
    'copy': function (_buffer, m) {
      return m;
    },
    'write': function (_buffer, _m, a) {
      return a;
    },
    'rm': function (_buffer, m) {
      return {
        type_: 'rm',
        p1: m
      };
    },
    'text': function (_buffer, m) {
      return _mhchemParser.go(m, 'text');
    },
    'tex-math': function (_buffer, m) {
      return _mhchemParser.go(m, 'tex-math');
    },
    'tex-math tight': function (_buffer, m) {
      return _mhchemParser.go(m, 'tex-math tight');
    },
    'bond': function (_buffer, m, k) {
      return {
        type_: 'bond',
        kind_: k || m
      };
    },
    'color0-output': function (_buffer, m) {
      return {
        type_: 'color0',
        color: m
      };
    },
    'ce': function (_buffer, m) {
      return _mhchemParser.go(m, 'ce');
    },
    'pu': function (_buffer, m) {
      return _mhchemParser.go(m, 'pu');
    },
    '1/2': function (_buffer, m) {
      var ret = [];
      if (m.match(/^[+\-]/)) {
        ret.push(m.substr(0, 1));
        m = m.substr(1);
      }
      var n = m.match(/^([0-9]+|\$[a-z]\$|[a-z])\/([0-9]+)(\$[a-z]\$|[a-z])?$/);
      n[1] = n[1].replace(/\$/g, "");
      ret.push({
        type_: 'frac',
        p1: n[1],
        p2: n[2]
      });
      if (n[3]) {
        n[3] = n[3].replace(/\$/g, "");
        ret.push({
          type_: 'tex-math',
          p1: n[3]
        });
      }
      return ret;
    },
    '9,9': function (_buffer, m) {
      return _mhchemParser.go(m, '9,9');
    }
  },
  stateMachines: {
    'tex': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '0': {
            action_: 'copy'
          }
        },
        '\\ce{(...)}': {
          '0': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'ce', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '\\pu{(...)}': {
          '0': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        'else': {
          '0': {
            action_: 'copy'
          }
        }
      }),
      actions: {}
    },
    'ce': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        'else': {
          '0|1|2': {
            action_: 'beginsWithBond=false',
            revisit: true,
            toContinue: true
          }
        },
        'oxidation$': {
          '0': {
            action_: 'oxidation-output'
          }
        },
        'CMT': {
          'r': {
            action_: 'rdt=',
            nextState: 'rt'
          },
          'rd': {
            action_: 'rqt=',
            nextState: 'rdt'
          }
        },
        'arrowUpDown': {
          '0|1|2|as': {
            action_: ['sb=false', 'output', 'operator'],
            nextState: '1'
          }
        },
        'uprightEntities': {
          '0|1|2': {
            action_: ['o=', 'output'],
            nextState: '1'
          }
        },
        'orbital': {
          '0|1|2|3': {
            action_: 'o=',
            nextState: 'o'
          }
        },
        '->': {
          '0|1|2|3': {
            action_: 'r=',
            nextState: 'r'
          },
          'a|as': {
            action_: ['output', 'r='],
            nextState: 'r'
          },
          '*': {
            action_: ['output', 'r='],
            nextState: 'r'
          }
        },
        '+': {
          'o': {
            action_: 'd= kv',
            nextState: 'd'
          },
          'd|D': {
            action_: 'd=',
            nextState: 'd'
          },
          'q': {
            action_: 'd=',
            nextState: 'qd'
          },
          'qd|qD': {
            action_: 'd=',
            nextState: 'qd'
          },
          'dq': {
            action_: ['output', 'd='],
            nextState: 'd'
          },
          '3': {
            action_: ['sb=false', 'output', 'operator'],
            nextState: '0'
          }
        },
        'amount': {
          '0|2': {
            action_: 'a=',
            nextState: 'a'
          }
        },
        'pm-operator': {
          '0|1|2|a|as': {
            action_: ['sb=false', 'output', {
              type_: 'operator',
              option: '\\pm'
            }],
            nextState: '0'
          }
        },
        'operator': {
          '0|1|2|a|as': {
            action_: ['sb=false', 'output', 'operator'],
            nextState: '0'
          }
        },
        '-$': {
          'o|q': {
            action_: ['charge or bond', 'output'],
            nextState: 'qd'
          },
          'd': {
            action_: 'd=',
            nextState: 'd'
          },
          'D': {
            action_: ['output', {
              type_: 'bond',
              option: "-"
            }],
            nextState: '3'
          },
          'q': {
            action_: 'd=',
            nextState: 'qd'
          },
          'qd': {
            action_: 'd=',
            nextState: 'qd'
          },
          'qD|dq': {
            action_: ['output', {
              type_: 'bond',
              option: "-"
            }],
            nextState: '3'
          }
        },
        '-9': {
          '3|o': {
            action_: ['output', {
              type_: 'insert',
              option: 'hyphen'
            }],
            nextState: '3'
          }
        },
        '- orbital overlap': {
          'o': {
            action_: ['output', {
              type_: 'insert',
              option: 'hyphen'
            }],
            nextState: '2'
          },
          'd': {
            action_: ['output', {
              type_: 'insert',
              option: 'hyphen'
            }],
            nextState: '2'
          }
        },
        '-': {
          '0|1|2': {
            action_: [{
              type_: 'output',
              option: 1
            }, 'beginsWithBond=true', {
              type_: 'bond',
              option: "-"
            }],
            nextState: '3'
          },
          '3': {
            action_: {
              type_: 'bond',
              option: "-"
            }
          },
          'a': {
            action_: ['output', {
              type_: 'insert',
              option: 'hyphen'
            }],
            nextState: '2'
          },
          'as': {
            action_: [{
              type_: 'output',
              option: 2
            }, {
              type_: 'bond',
              option: "-"
            }],
            nextState: '3'
          },
          'b': {
            action_: 'b='
          },
          'o': {
            action_: {
              type_: '- after o/d',
              option: false
            },
            nextState: '2'
          },
          'q': {
            action_: {
              type_: '- after o/d',
              option: false
            },
            nextState: '2'
          },
          'd|qd|dq': {
            action_: {
              type_: '- after o/d',
              option: true
            },
            nextState: '2'
          },
          'D|qD|p': {
            action_: ['output', {
              type_: 'bond',
              option: "-"
            }],
            nextState: '3'
          }
        },
        'amount2': {
          '1|3': {
            action_: 'a=',
            nextState: 'a'
          }
        },
        'letters': {
          '0|1|2|3|a|as|b|p|bp|o': {
            action_: 'o=',
            nextState: 'o'
          },
          'q|dq': {
            action_: ['output', 'o='],
            nextState: 'o'
          },
          'd|D|qd|qD': {
            action_: 'o after d',
            nextState: 'o'
          }
        },
        'digits': {
          'o': {
            action_: 'q=',
            nextState: 'q'
          },
          'd|D': {
            action_: 'q=',
            nextState: 'dq'
          },
          'q': {
            action_: ['output', 'o='],
            nextState: 'o'
          },
          'a': {
            action_: 'o=',
            nextState: 'o'
          }
        },
        'space A': {
          'b|p|bp': {
            action_: []
          }
        },
        'space': {
          'a': {
            action_: [],
            nextState: 'as'
          },
          '0': {
            action_: 'sb=false'
          },
          '1|2': {
            action_: 'sb=true'
          },
          'r|rt|rd|rdt|rdq': {
            action_: 'output',
            nextState: '0'
          },
          '*': {
            action_: ['output', 'sb=true'],
            nextState: '1'
          }
        },
        '1st-level escape': {
          '1|2': {
            action_: ['output', {
              type_: 'insert+p1',
              option: '1st-level escape'
            }]
          },
          '*': {
            action_: ['output', {
              type_: 'insert+p1',
              option: '1st-level escape'
            }],
            nextState: '0'
          }
        },
        '[(...)]': {
          'r|rt': {
            action_: 'rd=',
            nextState: 'rd'
          },
          'rd|rdt': {
            action_: 'rq=',
            nextState: 'rdq'
          }
        },
        '...': {
          'o|d|D|dq|qd|qD': {
            action_: ['output', {
              type_: 'bond',
              option: "..."
            }],
            nextState: '3'
          },
          '*': {
            action_: [{
              type_: 'output',
              option: 1
            }, {
              type_: 'insert',
              option: 'ellipsis'
            }],
            nextState: '1'
          }
        },
        '. __* ': {
          '*': {
            action_: ['output', {
              type_: 'insert',
              option: 'addition compound'
            }],
            nextState: '1'
          }
        },
        'state of aggregation $': {
          '*': {
            action_: ['output', 'state of aggregation'],
            nextState: '1'
          }
        },
        '{[(': {
          'a|as|o': {
            action_: ['o=', 'output', 'parenthesisLevel++'],
            nextState: '2'
          },
          '0|1|2|3': {
            action_: ['o=', 'output', 'parenthesisLevel++'],
            nextState: '2'
          },
          '*': {
            action_: ['output', 'o=', 'output', 'parenthesisLevel++'],
            nextState: '2'
          }
        },
        ')]}': {
          '0|1|2|3|b|p|bp|o': {
            action_: ['o=', 'parenthesisLevel--'],
            nextState: 'o'
          },
          'a|as|d|D|q|qd|qD|dq': {
            action_: ['output', 'o=', 'parenthesisLevel--'],
            nextState: 'o'
          }
        },
        ', ': {
          '*': {
            action_: ['output', 'comma'],
            nextState: '0'
          }
        },
        '^_': {
          '*': {
            action_: []
          }
        },
        '^{(...)}|^($...$)': {
          '0|1|2|as': {
            action_: 'b=',
            nextState: 'b'
          },
          'p': {
            action_: 'b=',
            nextState: 'bp'
          },
          '3|o': {
            action_: 'd= kv',
            nextState: 'D'
          },
          'q': {
            action_: 'd=',
            nextState: 'qD'
          },
          'd|D|qd|qD|dq': {
            action_: ['output', 'd='],
            nextState: 'D'
          }
        },
        '^a|^\\x{}{}|^\\x{}|^\\x|\'': {
          '0|1|2|as': {
            action_: 'b=',
            nextState: 'b'
          },
          'p': {
            action_: 'b=',
            nextState: 'bp'
          },
          '3|o': {
            action_: 'd= kv',
            nextState: 'd'
          },
          'q': {
            action_: 'd=',
            nextState: 'qd'
          },
          'd|qd|D|qD': {
            action_: 'd='
          },
          'dq': {
            action_: ['output', 'd='],
            nextState: 'd'
          }
        },
        '_{(state of aggregation)}$': {
          'd|D|q|qd|qD|dq': {
            action_: ['output', 'q='],
            nextState: 'q'
          }
        },
        '_{(...)}|_($...$)|_9|_\\x{}{}|_\\x{}|_\\x': {
          '0|1|2|as': {
            action_: 'p=',
            nextState: 'p'
          },
          'b': {
            action_: 'p=',
            nextState: 'bp'
          },
          '3|o': {
            action_: 'q=',
            nextState: 'q'
          },
          'd|D': {
            action_: 'q=',
            nextState: 'dq'
          },
          'q|qd|qD|dq': {
            action_: ['output', 'q='],
            nextState: 'q'
          }
        },
        '=<>': {
          '0|1|2|3|a|as|o|q|d|D|qd|qD|dq': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'bond'],
            nextState: '3'
          }
        },
        '#': {
          '0|1|2|3|a|as|o': {
            action_: [{
              type_: 'output',
              option: 2
            }, {
              type_: 'bond',
              option: "#"
            }],
            nextState: '3'
          }
        },
        '{}^': {
          '*': {
            action_: [{
              type_: 'output',
              option: 1
            }, {
              type_: 'insert',
              option: 'tinySkip'
            }],
            nextState: '1'
          }
        },
        '{}': {
          '*': {
            action_: {
              type_: 'output',
              option: 1
            },
            nextState: '1'
          }
        },
        '{...}': {
          '0|1|2|3|a|as|b|p|bp': {
            action_: 'o=',
            nextState: 'o'
          },
          'o|d|D|q|qd|qD|dq': {
            action_: ['output', 'o='],
            nextState: 'o'
          }
        },
        '$...$': {
          'a': {
            action_: 'a='
          },
          '0|1|2|3|as|b|p|bp|o': {
            action_: 'o=',
            nextState: 'o'
          },
          'as|o': {
            action_: 'o='
          },
          'q|d|D|qd|qD|dq': {
            action_: ['output', 'o='],
            nextState: 'o'
          }
        },
        '\\bond{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'bond'],
            nextState: "3"
          }
        },
        '\\frac{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 1
            }, 'frac-output'],
            nextState: '3'
          }
        },
        '\\overset{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'overset-output'],
            nextState: '3'
          }
        },
        '\\underset{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'underset-output'],
            nextState: '3'
          }
        },
        '\\underbrace{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'underbrace-output'],
            nextState: '3'
          }
        },
        '\\color{(...)}{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'color-output'],
            nextState: '3'
          }
        },
        '\\color{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'color0-output']
          }
        },
        '\\ce{(...)}': {
          '*': {
            action_: [{
              type_: 'output',
              option: 2
            }, 'ce'],
            nextState: '3'
          }
        },
        '\\,': {
          '*': {
            action_: [{
              type_: 'output',
              option: 1
            }, 'copy'],
            nextState: '1'
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: ['output', {
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }],
            nextState: '3'
          }
        },
        '\\x{}{}|\\x{}|\\x': {
          '0|1|2|3|a|as|b|p|bp|o|c0': {
            action_: ['o=', 'output'],
            nextState: '3'
          },
          '*': {
            action_: ['output', 'o=', 'output'],
            nextState: '3'
          }
        },
        'others': {
          '*': {
            action_: [{
              type_: 'output',
              option: 1
            }, 'copy'],
            nextState: '3'
          }
        },
        'else2': {
          'a': {
            action_: 'a to o',
            nextState: 'o',
            revisit: true
          },
          'as': {
            action_: ['output', 'sb=true'],
            nextState: '1',
            revisit: true
          },
          'r|rt|rd|rdt|rdq': {
            action_: ['output'],
            nextState: '0',
            revisit: true
          },
          '*': {
            action_: ['output', 'copy'],
            nextState: '3'
          }
        }
      }),
      actions: {
        'o after d': function (buffer, m) {
          var ret;
          if ((buffer.d || "").match(/^[1-9][0-9]*$/)) {
            var tmp = buffer.d;
            buffer.d = undefined;
            ret = this['output'](buffer);
            ret.push({
              type_: 'tinySkip'
            });
            buffer.b = tmp;
          } else {
            ret = this['output'](buffer);
          }
          _mhchemParser.actions['o='](buffer, m);
          return ret;
        },
        'd= kv': function (buffer, m) {
          buffer.d = m;
          buffer.dType = 'kv';
          return undefined;
        },
        'charge or bond': function (buffer, m) {
          if (buffer['beginsWithBond']) {
            var ret = [];
            _mhchemParser.concatArray(ret, this['output'](buffer));
            _mhchemParser.concatArray(ret, _mhchemParser.actions['bond'](buffer, m, "-"));
            return ret;
          } else {
            buffer.d = m;
            return undefined;
          }
        },
        '- after o/d': function (buffer, m, isAfterD) {
          var c1 = _mhchemParser.patterns.match_('orbital', buffer.o || "");
          var c2 = _mhchemParser.patterns.match_('one lowercase greek letter $', buffer.o || "");
          var c3 = _mhchemParser.patterns.match_('one lowercase latin letter $', buffer.o || "");
          var c4 = _mhchemParser.patterns.match_('$one lowercase latin letter$ $', buffer.o || "");
          var hyphenFollows = m === "-" && (c1 && c1.remainder === "" || c2 || c3 || c4);
          if (hyphenFollows && !buffer.a && !buffer.b && !buffer.p && !buffer.d && !buffer.q && !c1 && c3) {
            buffer.o = '$' + buffer.o + '$';
          }
          var ret = [];
          if (hyphenFollows) {
            _mhchemParser.concatArray(ret, this['output'](buffer));
            ret.push({
              type_: 'hyphen'
            });
          } else {
            c1 = _mhchemParser.patterns.match_('digits', buffer.d || "");
            if (isAfterD && c1 && c1.remainder === '') {
              _mhchemParser.concatArray(ret, _mhchemParser.actions['d='](buffer, m));
              _mhchemParser.concatArray(ret, this['output'](buffer));
            } else {
              _mhchemParser.concatArray(ret, this['output'](buffer));
              _mhchemParser.concatArray(ret, _mhchemParser.actions['bond'](buffer, m, "-"));
            }
          }
          return ret;
        },
        'a to o': function (buffer) {
          buffer.o = buffer.a;
          buffer.a = undefined;
          return undefined;
        },
        'sb=true': function (buffer) {
          buffer.sb = true;
          return undefined;
        },
        'sb=false': function (buffer) {
          buffer.sb = false;
          return undefined;
        },
        'beginsWithBond=true': function (buffer) {
          buffer['beginsWithBond'] = true;
          return undefined;
        },
        'beginsWithBond=false': function (buffer) {
          buffer['beginsWithBond'] = false;
          return undefined;
        },
        'parenthesisLevel++': function (buffer) {
          buffer['parenthesisLevel']++;
          return undefined;
        },
        'parenthesisLevel--': function (buffer) {
          buffer['parenthesisLevel']--;
          return undefined;
        },
        'state of aggregation': function (_buffer, m) {
          return {
            type_: 'state of aggregation',
            p1: _mhchemParser.go(m, 'o')
          };
        },
        'comma': function (buffer, m) {
          var a = m.replace(/\s*$/, '');
          var withSpace = a !== m;
          if (withSpace && buffer['parenthesisLevel'] === 0) {
            return {
              type_: 'comma enumeration L',
              p1: a
            };
          } else {
            return {
              type_: 'comma enumeration M',
              p1: a
            };
          }
        },
        'output': function (buffer, _m, entityFollows) {
          var ret;
          if (!buffer.r) {
            ret = [];
            if (!buffer.a && !buffer.b && !buffer.p && !buffer.o && !buffer.q && !buffer.d && !entityFollows) ; else {
              if (buffer.sb) {
                ret.push({
                  type_: 'entitySkip'
                });
              }
              if (!buffer.o && !buffer.q && !buffer.d && !buffer.b && !buffer.p && entityFollows !== 2) {
                buffer.o = buffer.a;
                buffer.a = undefined;
              } else if (!buffer.o && !buffer.q && !buffer.d && (buffer.b || buffer.p)) {
                buffer.o = buffer.a;
                buffer.d = buffer.b;
                buffer.q = buffer.p;
                buffer.a = buffer.b = buffer.p = undefined;
              } else {
                if (buffer.o && buffer.dType === 'kv' && _mhchemParser.patterns.match_('d-oxidation$', buffer.d || "")) {
                  buffer.dType = 'oxidation';
                } else if (buffer.o && buffer.dType === 'kv' && !buffer.q) {
                  buffer.dType = undefined;
                }
              }
              ret.push({
                type_: 'chemfive',
                a: _mhchemParser.go(buffer.a, 'a'),
                b: _mhchemParser.go(buffer.b, 'bd'),
                p: _mhchemParser.go(buffer.p, 'pq'),
                o: _mhchemParser.go(buffer.o, 'o'),
                q: _mhchemParser.go(buffer.q, 'pq'),
                d: _mhchemParser.go(buffer.d, buffer.dType === 'oxidation' ? 'oxidation' : 'bd'),
                dType: buffer.dType
              });
            }
          } else {
            var rd = void 0;
            if (buffer.rdt === 'M') {
              rd = _mhchemParser.go(buffer.rd, 'tex-math');
            } else if (buffer.rdt === 'T') {
              rd = [{
                type_: 'text',
                p1: buffer.rd || ""
              }];
            } else {
              rd = _mhchemParser.go(buffer.rd, 'ce');
            }
            var rq = void 0;
            if (buffer.rqt === 'M') {
              rq = _mhchemParser.go(buffer.rq, 'tex-math');
            } else if (buffer.rqt === 'T') {
              rq = [{
                type_: 'text',
                p1: buffer.rq || ""
              }];
            } else {
              rq = _mhchemParser.go(buffer.rq, 'ce');
            }
            ret = {
              type_: 'arrow',
              r: buffer.r,
              rd: rd,
              rq: rq
            };
          }
          for (var p in buffer) {
            if (p !== 'parenthesisLevel' && p !== 'beginsWithBond') {
              delete buffer[p];
            }
          }
          return ret;
        },
        'oxidation-output': function (_buffer, m) {
          var ret = ["{"];
          _mhchemParser.concatArray(ret, _mhchemParser.go(m, 'oxidation'));
          ret.push("}");
          return ret;
        },
        'frac-output': function (_buffer, m) {
          return {
            type_: 'frac-ce',
            p1: _mhchemParser.go(m[0], 'ce'),
            p2: _mhchemParser.go(m[1], 'ce')
          };
        },
        'overset-output': function (_buffer, m) {
          return {
            type_: 'overset',
            p1: _mhchemParser.go(m[0], 'ce'),
            p2: _mhchemParser.go(m[1], 'ce')
          };
        },
        'underset-output': function (_buffer, m) {
          return {
            type_: 'underset',
            p1: _mhchemParser.go(m[0], 'ce'),
            p2: _mhchemParser.go(m[1], 'ce')
          };
        },
        'underbrace-output': function (_buffer, m) {
          return {
            type_: 'underbrace',
            p1: _mhchemParser.go(m[0], 'ce'),
            p2: _mhchemParser.go(m[1], 'ce')
          };
        },
        'color-output': function (_buffer, m) {
          return {
            type_: 'color',
            color1: m[0],
            color2: _mhchemParser.go(m[1], 'ce')
          };
        },
        'r=': function (buffer, m) {
          buffer.r = m;
          return undefined;
        },
        'rdt=': function (buffer, m) {
          buffer.rdt = m;
          return undefined;
        },
        'rd=': function (buffer, m) {
          buffer.rd = m;
          return undefined;
        },
        'rqt=': function (buffer, m) {
          buffer.rqt = m;
          return undefined;
        },
        'rq=': function (buffer, m) {
          buffer.rq = m;
          return undefined;
        },
        'operator': function (_buffer, m, p1) {
          return {
            type_: 'operator',
            kind_: p1 || m
          };
        }
      }
    },
    'a': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        '1/2$': {
          '0': {
            action_: '1/2'
          }
        },
        'else': {
          '0': {
            action_: [],
            nextState: '1',
            revisit: true
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math tight',
            nextState: '1'
          }
        },
        ',': {
          '*': {
            action_: {
              type_: 'insert',
              option: 'commaDecimal'
            }
          }
        },
        'else2': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {}
    },
    'o': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        '1/2$': {
          '0': {
            action_: '1/2'
          }
        },
        'else': {
          '0': {
            action_: [],
            nextState: '1',
            revisit: true
          }
        },
        'letters': {
          '*': {
            action_: 'rm'
          }
        },
        '\\ca': {
          '*': {
            action_: {
              type_: 'insert',
              option: 'circa'
            }
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: 'copy'
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math'
          }
        },
        '{(...)}': {
          '*': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'text', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        'else2': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {}
    },
    'text': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        '{...}': {
          '*': {
            action_: 'text='
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math'
          }
        },
        '\\greek': {
          '*': {
            action_: ['output', 'rm']
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: ['output', {
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '\\,|\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: ['output', 'copy']
          }
        },
        'else': {
          '*': {
            action_: 'text='
          }
        }
      }),
      actions: {
        'output': function (buffer) {
          if (buffer.text_) {
            var ret = {
              type_: 'text',
              p1: buffer.text_
            };
            for (var p in buffer) {
              delete buffer[p];
            }
            return ret;
          }
          return undefined;
        }
      }
    },
    'pq': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        'state of aggregation $': {
          '*': {
            action_: 'state of aggregation'
          }
        },
        'i$': {
          '0': {
            action_: [],
            nextState: '!f',
            revisit: true
          }
        },
        '(KV letters),': {
          '0': {
            action_: 'rm',
            nextState: '0'
          }
        },
        'formula$': {
          '0': {
            action_: [],
            nextState: 'f',
            revisit: true
          }
        },
        '1/2$': {
          '0': {
            action_: '1/2'
          }
        },
        'else': {
          '0': {
            action_: [],
            nextState: '!f',
            revisit: true
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math'
          }
        },
        '{(...)}': {
          '*': {
            action_: 'text'
          }
        },
        'a-z': {
          'f': {
            action_: 'tex-math'
          }
        },
        'letters': {
          '*': {
            action_: 'rm'
          }
        },
        '-9.,9': {
          '*': {
            action_: '9,9'
          }
        },
        ',': {
          '*': {
            action_: {
              type_: 'insert+p1',
              option: 'comma enumeration S'
            }
          }
        },
        '\\color{(...)}{(...)}': {
          '*': {
            action_: 'color-output'
          }
        },
        '\\color{(...)}': {
          '*': {
            action_: 'color0-output'
          }
        },
        '\\ce{(...)}': {
          '*': {
            action_: 'ce'
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '\\,|\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: 'copy'
          }
        },
        'else2': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {
        'state of aggregation': function (_buffer, m) {
          return {
            type_: 'state of aggregation subscript',
            p1: _mhchemParser.go(m, 'o')
          };
        },
        'color-output': function (_buffer, m) {
          return {
            type_: 'color',
            color1: m[0],
            color2: _mhchemParser.go(m[1], 'pq')
          };
        }
      }
    },
    'bd': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        'x$': {
          '0': {
            action_: [],
            nextState: '!f',
            revisit: true
          }
        },
        'formula$': {
          '0': {
            action_: [],
            nextState: 'f',
            revisit: true
          }
        },
        'else': {
          '0': {
            action_: [],
            nextState: '!f',
            revisit: true
          }
        },
        '-9.,9 no missing 0': {
          '*': {
            action_: '9,9'
          }
        },
        '.': {
          '*': {
            action_: {
              type_: 'insert',
              option: 'electron dot'
            }
          }
        },
        'a-z': {
          'f': {
            action_: 'tex-math'
          }
        },
        'x': {
          '*': {
            action_: {
              type_: 'insert',
              option: 'KV x'
            }
          }
        },
        'letters': {
          '*': {
            action_: 'rm'
          }
        },
        '\'': {
          '*': {
            action_: {
              type_: 'insert',
              option: 'prime'
            }
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math'
          }
        },
        '{(...)}': {
          '*': {
            action_: 'text'
          }
        },
        '\\color{(...)}{(...)}': {
          '*': {
            action_: 'color-output'
          }
        },
        '\\color{(...)}': {
          '*': {
            action_: 'color0-output'
          }
        },
        '\\ce{(...)}': {
          '*': {
            action_: 'ce'
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: [{
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '\\,|\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: 'copy'
          }
        },
        'else2': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {
        'color-output': function (_buffer, m) {
          return {
            type_: 'color',
            color1: m[0],
            color2: _mhchemParser.go(m[1], 'bd')
          };
        }
      }
    },
    'oxidation': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        'roman numeral': {
          '*': {
            action_: 'roman-numeral'
          }
        },
        '${(...)}$__$(...)$': {
          '*': {
            action_: 'tex-math'
          }
        },
        'else': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {
        'roman-numeral': function (_buffer, m) {
          return {
            type_: 'roman numeral',
            p1: m
          };
        }
      }
    },
    'tex-math': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        '\\ce{(...)}': {
          '*': {
            action_: ['output', 'ce']
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: ['output', {
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '{...}|\\,|\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: 'o='
          }
        },
        'else': {
          '*': {
            action_: 'o='
          }
        }
      }),
      actions: {
        'output': function (buffer) {
          if (buffer.o) {
            var ret = {
              type_: 'tex-math',
              p1: buffer.o
            };
            for (var p in buffer) {
              delete buffer[p];
            }
            return ret;
          }
          return undefined;
        }
      }
    },
    'tex-math tight': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        '\\ce{(...)}': {
          '*': {
            action_: ['output', 'ce']
          }
        },
        '\\pu{(...)}': {
          '*': {
            action_: ['output', {
              type_: 'write',
              option: "{"
            }, 'pu', {
              type_: 'write',
              option: "}"
            }]
          }
        },
        '{...}|\\,|\\x{}{}|\\x{}|\\x': {
          '*': {
            action_: 'o='
          }
        },
        '-|+': {
          '*': {
            action_: 'tight operator'
          }
        },
        'else': {
          '*': {
            action_: 'o='
          }
        }
      }),
      actions: {
        'tight operator': function (buffer, m) {
          buffer.o = (buffer.o || "") + "{" + m + "}";
          return undefined;
        },
        'output': function (buffer) {
          if (buffer.o) {
            var ret = {
              type_: 'tex-math',
              p1: buffer.o
            };
            for (var p in buffer) {
              delete buffer[p];
            }
            return ret;
          }
          return undefined;
        }
      }
    },
    '9,9': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: []
          }
        },
        ',': {
          '*': {
            action_: 'comma'
          }
        },
        'else': {
          '*': {
            action_: 'copy'
          }
        }
      }),
      actions: {
        'comma': function () {
          return {
            type_: 'commaDecimal'
          };
        }
      }
    },
    'pu': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        'space$': {
          '*': {
            action_: ['output', 'space']
          }
        },
        '{[(|)]}': {
          '0|a': {
            action_: 'copy'
          }
        },
        '(-)(9)^(-9)': {
          '0': {
            action_: 'number^',
            nextState: 'a'
          }
        },
        '(-)(9.,9)(e)(99)': {
          '0': {
            action_: 'enumber',
            nextState: 'a'
          }
        },
        'space': {
          '0|a': {
            action_: []
          }
        },
        'pm-operator': {
          '0|a': {
            action_: {
              type_: 'operator',
              option: '\\pm'
            },
            nextState: '0'
          }
        },
        'operator': {
          '0|a': {
            action_: 'copy',
            nextState: '0'
          }
        },
        '//': {
          'd': {
            action_: 'o=',
            nextState: '/'
          }
        },
        '/': {
          'd': {
            action_: 'o=',
            nextState: '/'
          }
        },
        '{...}|else': {
          '0|d': {
            action_: 'd=',
            nextState: 'd'
          },
          'a': {
            action_: ['space', 'd='],
            nextState: 'd'
          },
          '/|q': {
            action_: 'q=',
            nextState: 'q'
          }
        }
      }),
      actions: {
        'enumber': function (_buffer, m) {
          var ret = [];
          if (m[0] === "+-" || m[0] === "+/-") {
            ret.push("\\pm ");
          } else if (m[0]) {
            ret.push(m[0]);
          }
          if (m[1]) {
            _mhchemParser.concatArray(ret, _mhchemParser.go(m[1], 'pu-9,9'));
            if (m[2]) {
              if (m[2].match(/[,.]/)) {
                _mhchemParser.concatArray(ret, _mhchemParser.go(m[2], 'pu-9,9'));
              } else {
                ret.push(m[2]);
              }
            }
            if (m[3] || m[4]) {
              if (m[3] === "e" || m[4] === "*") {
                ret.push({
                  type_: 'cdot'
                });
              } else {
                ret.push({
                  type_: 'times'
                });
              }
            }
          }
          if (m[5]) {
            ret.push("10^{" + m[5] + "}");
          }
          return ret;
        },
        'number^': function (_buffer, m) {
          var ret = [];
          if (m[0] === "+-" || m[0] === "+/-") {
            ret.push("\\pm ");
          } else if (m[0]) {
            ret.push(m[0]);
          }
          _mhchemParser.concatArray(ret, _mhchemParser.go(m[1], 'pu-9,9'));
          ret.push("^{" + m[2] + "}");
          return ret;
        },
        'operator': function (_buffer, m, p1) {
          return {
            type_: 'operator',
            kind_: p1 || m
          };
        },
        'space': function () {
          return {
            type_: 'pu-space-1'
          };
        },
        'output': function (buffer) {
          var ret;
          var md = _mhchemParser.patterns.match_('{(...)}', buffer.d || "");
          if (md && md.remainder === '') {
            buffer.d = md.match_;
          }
          var mq = _mhchemParser.patterns.match_('{(...)}', buffer.q || "");
          if (mq && mq.remainder === '') {
            buffer.q = mq.match_;
          }
          if (buffer.d) {
            buffer.d = buffer.d.replace(/\u00B0C|\^oC|\^{o}C/g, "{}^{\\circ}C");
            buffer.d = buffer.d.replace(/\u00B0F|\^oF|\^{o}F/g, "{}^{\\circ}F");
          }
          if (buffer.q) {
            buffer.q = buffer.q.replace(/\u00B0C|\^oC|\^{o}C/g, "{}^{\\circ}C");
            buffer.q = buffer.q.replace(/\u00B0F|\^oF|\^{o}F/g, "{}^{\\circ}F");
            var b5 = {
              d: _mhchemParser.go(buffer.d, 'pu'),
              q: _mhchemParser.go(buffer.q, 'pu')
            };
            if (buffer.o === '//') {
              ret = {
                type_: 'pu-frac',
                p1: b5.d,
                p2: b5.q
              };
            } else {
              ret = b5.d;
              if (b5.d.length > 1 || b5.q.length > 1) {
                ret.push({
                  type_: ' / '
                });
              } else {
                ret.push({
                  type_: '/'
                });
              }
              _mhchemParser.concatArray(ret, b5.q);
            }
          } else {
            ret = _mhchemParser.go(buffer.d, 'pu-2');
          }
          for (var p in buffer) {
            delete buffer[p];
          }
          return ret;
        }
      }
    },
    'pu-2': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '*': {
            action_: 'output'
          }
        },
        '*': {
          '*': {
            action_: ['output', 'cdot'],
            nextState: '0'
          }
        },
        '\\x': {
          '*': {
            action_: 'rm='
          }
        },
        'space': {
          '*': {
            action_: ['output', 'space'],
            nextState: '0'
          }
        },
        '^{(...)}|^(-1)': {
          '1': {
            action_: '^(-1)'
          }
        },
        '-9.,9': {
          '0': {
            action_: 'rm=',
            nextState: '0'
          },
          '1': {
            action_: '^(-1)',
            nextState: '0'
          }
        },
        '{...}|else': {
          '*': {
            action_: 'rm=',
            nextState: '1'
          }
        }
      }),
      actions: {
        'cdot': function () {
          return {
            type_: 'tight cdot'
          };
        },
        '^(-1)': function (buffer, m) {
          buffer.rm += "^{" + m + "}";
          return undefined;
        },
        'space': function () {
          return {
            type_: 'pu-space-2'
          };
        },
        'output': function (buffer) {
          var ret = [];
          if (buffer.rm) {
            var mrm = _mhchemParser.patterns.match_('{(...)}', buffer.rm || "");
            if (mrm && mrm.remainder === '') {
              ret = _mhchemParser.go(mrm.match_, 'pu');
            } else {
              ret = {
                type_: 'rm',
                p1: buffer.rm
              };
            }
          }
          for (var p in buffer) {
            delete buffer[p];
          }
          return ret;
        }
      }
    },
    'pu-9,9': {
      transitions: _mhchemCreateTransitions({
        'empty': {
          '0': {
            action_: 'output-0'
          },
          'o': {
            action_: 'output-o'
          }
        },
        ',': {
          '0': {
            action_: ['output-0', 'comma'],
            nextState: 'o'
          }
        },
        '.': {
          '0': {
            action_: ['output-0', 'copy'],
            nextState: 'o'
          }
        },
        'else': {
          '*': {
            action_: 'text='
          }
        }
      }),
      actions: {
        'comma': function () {
          return {
            type_: 'commaDecimal'
          };
        },
        'output-0': function (buffer) {
          var ret = [];
          buffer.text_ = buffer.text_ || "";
          if (buffer.text_.length > 4) {
            var a = buffer.text_.length % 3;
            if (a === 0) {
              a = 3;
            }
            for (var i = buffer.text_.length - 3; i > 0; i -= 3) {
              ret.push(buffer.text_.substr(i, 3));
              ret.push({
                type_: '1000 separator'
              });
            }
            ret.push(buffer.text_.substr(0, a));
            ret.reverse();
          } else {
            ret.push(buffer.text_);
          }
          for (var p in buffer) {
            delete buffer[p];
          }
          return ret;
        },
        'output-o': function (buffer) {
          var ret = [];
          buffer.text_ = buffer.text_ || "";
          if (buffer.text_.length > 4) {
            var a = buffer.text_.length - 3;
            var i = void 0;
            for (i = 0; i < a; i += 3) {
              ret.push(buffer.text_.substr(i, 3));
              ret.push({
                type_: '1000 separator'
              });
            }
            ret.push(buffer.text_.substr(i));
          } else {
            ret.push(buffer.text_);
          }
          for (var p in buffer) {
            delete buffer[p];
          }
          return ret;
        }
      }
    }
  }
};
var _mhchemTexify = {
  go: function (input, addOuterBraces) {
    if (!input) {
      return "";
    }
    var res = "";
    var cee = false;
    for (var i = 0; i < input.length; i++) {
      var inputi = input[i];
      if (typeof inputi === "string") {
        res += inputi;
      } else {
        res += _mhchemTexify._go2(inputi);
        if (inputi.type_ === '1st-level escape') {
          cee = true;
        }
      }
    }
    if (addOuterBraces && !cee && res) {
      res = "{" + res + "}";
    }
    return res;
  },
  _goInner: function (input) {
    return _mhchemTexify.go(input, false);
  },
  _go2: function (buf) {
    var res;
    switch (buf.type_) {
      case 'chemfive':
        res = "";
        var b5 = {
          a: _mhchemTexify._goInner(buf.a),
          b: _mhchemTexify._goInner(buf.b),
          p: _mhchemTexify._goInner(buf.p),
          o: _mhchemTexify._goInner(buf.o),
          q: _mhchemTexify._goInner(buf.q),
          d: _mhchemTexify._goInner(buf.d)
        };
        if (b5.a) {
          if (b5.a.match(/^[+\-]/)) {
            b5.a = "{" + b5.a + "}";
          }
          res += b5.a + "\\,";
        }
        if (b5.b || b5.p) {
          res += "{\\vphantom{A}}";
          res += "^{\\hphantom{" + (b5.b || "") + "}}_{\\hphantom{" + (b5.p || "") + "}}";
          res += "\\mkern-1.5mu";
          res += "{\\vphantom{A}}";
          res += "^{\\smash[t]{\\vphantom{2}}\\llap{" + (b5.b || "") + "}}";
          res += "_{\\vphantom{2}\\llap{\\smash[t]{" + (b5.p || "") + "}}}";
        }
        if (b5.o) {
          if (b5.o.match(/^[+\-]/)) {
            b5.o = "{" + b5.o + "}";
          }
          res += b5.o;
        }
        if (buf.dType === 'kv') {
          if (b5.d || b5.q) {
            res += "{\\vphantom{A}}";
          }
          if (b5.d) {
            res += "^{" + b5.d + "}";
          }
          if (b5.q) {
            res += "_{\\smash[t]{" + b5.q + "}}";
          }
        } else if (buf.dType === 'oxidation') {
          if (b5.d) {
            res += "{\\vphantom{A}}";
            res += "^{" + b5.d + "}";
          }
          if (b5.q) {
            res += "{\\vphantom{A}}";
            res += "_{\\smash[t]{" + b5.q + "}}";
          }
        } else {
          if (b5.q) {
            res += "{\\vphantom{A}}";
            res += "_{\\smash[t]{" + b5.q + "}}";
          }
          if (b5.d) {
            res += "{\\vphantom{A}}";
            res += "^{" + b5.d + "}";
          }
        }
        break;
      case 'rm':
        res = "\\mathrm{" + buf.p1 + "}";
        break;
      case 'text':
        if (buf.p1.match(/[\^_]/)) {
          buf.p1 = buf.p1.replace(" ", "~").replace("-", "\\text{-}");
          res = "\\mathrm{" + buf.p1 + "}";
        } else {
          res = "\\text{" + buf.p1 + "}";
        }
        break;
      case 'roman numeral':
        res = "\\mathrm{" + buf.p1 + "}";
        break;
      case 'state of aggregation':
        res = "\\mskip2mu " + _mhchemTexify._goInner(buf.p1);
        break;
      case 'state of aggregation subscript':
        res = "\\mskip1mu " + _mhchemTexify._goInner(buf.p1);
        break;
      case 'bond':
        res = _mhchemTexify._getBond(buf.kind_);
        if (!res) {
          throw ["MhchemErrorBond", "mhchem Error. Unknown bond type (" + buf.kind_ + ")"];
        }
        break;
      case 'frac':
        var c = "\\frac{" + buf.p1 + "}{" + buf.p2 + "}";
        res = "\\mathchoice{\\textstyle" + c + "}{" + c + "}{" + c + "}{" + c + "}";
        break;
      case 'pu-frac':
        var d = "\\frac{" + _mhchemTexify._goInner(buf.p1) + "}{" + _mhchemTexify._goInner(buf.p2) + "}";
        res = "\\mathchoice{\\textstyle" + d + "}{" + d + "}{" + d + "}{" + d + "}";
        break;
      case 'tex-math':
        res = buf.p1 + " ";
        break;
      case 'frac-ce':
        res = "\\frac{" + _mhchemTexify._goInner(buf.p1) + "}{" + _mhchemTexify._goInner(buf.p2) + "}";
        break;
      case 'overset':
        res = "\\overset{" + _mhchemTexify._goInner(buf.p1) + "}{" + _mhchemTexify._goInner(buf.p2) + "}";
        break;
      case 'underset':
        res = "\\underset{" + _mhchemTexify._goInner(buf.p1) + "}{" + _mhchemTexify._goInner(buf.p2) + "}";
        break;
      case 'underbrace':
        res = "\\underbrace{" + _mhchemTexify._goInner(buf.p1) + "}_{" + _mhchemTexify._goInner(buf.p2) + "}";
        break;
      case 'color':
        res = "{\\color{" + buf.color1 + "}{" + _mhchemTexify._goInner(buf.color2) + "}}";
        break;
      case 'color0':
        res = "\\color{" + buf.color + "}";
        break;
      case 'arrow':
        var b6 = {
          rd: _mhchemTexify._goInner(buf.rd),
          rq: _mhchemTexify._goInner(buf.rq)
        };
        var arrow = _mhchemTexify._getArrow(buf.r);
        if (b6.rd || b6.rq) {
          if (buf.r === "<=>" || buf.r === "<=>>" || buf.r === "<<=>" || buf.r === "<-->") {
            arrow = "\\long" + arrow;
            if (b6.rd) {
              arrow = "\\overset{" + b6.rd + "}{" + arrow + "}";
            }
            if (b6.rq) {
              if (buf.r === "<-->") {
                arrow = "\\underset{\\lower2mu{" + b6.rq + "}}{" + arrow + "}";
              } else {
                arrow = "\\underset{\\lower6mu{" + b6.rq + "}}{" + arrow + "}";
              }
            }
            arrow = " {}\\mathrel{" + arrow + "}{} ";
          } else {
            if (b6.rq) {
              arrow += "[{" + b6.rq + "}]";
            }
            arrow += "{" + b6.rd + "}";
            arrow = " {}\\mathrel{\\x" + arrow + "}{} ";
          }
        } else {
          arrow = " {}\\mathrel{\\long" + arrow + "}{} ";
        }
        res = arrow;
        break;
      case 'operator':
        res = _mhchemTexify._getOperator(buf.kind_);
        break;
      case '1st-level escape':
        res = buf.p1 + " ";
        break;
      case 'space':
        res = " ";
        break;
      case 'tinySkip':
        res = '\\mkern2mu';
        break;
      case 'entitySkip':
        res = "~";
        break;
      case 'pu-space-1':
        res = "~";
        break;
      case 'pu-space-2':
        res = "\\mkern3mu ";
        break;
      case '1000 separator':
        res = "\\mkern2mu ";
        break;
      case 'commaDecimal':
        res = "{,}";
        break;
      case 'comma enumeration L':
        res = "{" + buf.p1 + "}\\mkern6mu ";
        break;
      case 'comma enumeration M':
        res = "{" + buf.p1 + "}\\mkern3mu ";
        break;
      case 'comma enumeration S':
        res = "{" + buf.p1 + "}\\mkern1mu ";
        break;
      case 'hyphen':
        res = "\\text{-}";
        break;
      case 'addition compound':
        res = "\\,{\\cdot}\\,";
        break;
      case 'electron dot':
        res = "\\mkern1mu \\bullet\\mkern1mu ";
        break;
      case 'KV x':
        res = "{\\times}";
        break;
      case 'prime':
        res = "\\prime ";
        break;
      case 'cdot':
        res = "\\cdot ";
        break;
      case 'tight cdot':
        res = "\\mkern1mu{\\cdot}\\mkern1mu ";
        break;
      case 'times':
        res = "\\times ";
        break;
      case 'circa':
        res = "{\\sim}";
        break;
      case '^':
        res = "uparrow";
        break;
      case 'v':
        res = "downarrow";
        break;
      case 'ellipsis':
        res = "\\ldots ";
        break;
      case '/':
        res = "/";
        break;
      case ' / ':
        res = "\\,/\\,";
        break;
      default:
        throw ["MhchemBugT", "mhchem bug T. Please report."];
    }
    return res;
  },
  _getArrow: function (a) {
    switch (a) {
      case "->":
        return "rightarrow";
      case "\u2192":
        return "rightarrow";
      case "\u27F6":
        return "rightarrow";
      case "<-":
        return "leftarrow";
      case "<->":
        return "leftrightarrow";
      case "<-->":
        return "leftrightarrows";
      case "<=>":
        return "rightleftharpoons";
      case "\u21CC":
        return "rightleftharpoons";
      case "<=>>":
        return "Rightleftharpoons";
      case "<<=>":
        return "Leftrightharpoons";
      default:
        throw ["MhchemBugT", "mhchem bug T. Please report."];
    }
  },
  _getBond: function (a) {
    switch (a) {
      case "-":
        return "{-}";
      case "1":
        return "{-}";
      case "=":
        return "{=}";
      case "2":
        return "{=}";
      case "#":
        return "{\\equiv}";
      case "3":
        return "{\\equiv}";
      case "~":
        return "{\\tripledash}";
      case "~-":
        return "{\\rlap{\\lower.1em{-}}\\raise.1em{\\tripledash}}";
      case "~=":
        return "{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{\\tripledash}}-}";
      case "~--":
        return "{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{\\tripledash}}-}";
      case "-~-":
        return "{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{-}}\\tripledash}";
      case "...":
        return "{{\\cdot}{\\cdot}{\\cdot}}";
      case "....":
        return "{{\\cdot}{\\cdot}{\\cdot}{\\cdot}}";
      case "->":
        return "{\\rightarrow}";
      case "<-":
        return "{\\leftarrow}";
      case "<":
        return "{<}";
      case ">":
        return "{>}";
      default:
        throw ["MhchemBugT", "mhchem bug T. Please report."];
    }
  },
  _getOperator: function (a) {
    switch (a) {
      case "+":
        return " {}+{} ";
      case "-":
        return " {}-{} ";
      case "=":
        return " {}={} ";
      case "<":
        return " {}<{} ";
      case ">":
        return " {}>{} ";
      case "<<":
        return " {}\\ll{} ";
      case ">>":
        return " {}\\gg{} ";
      case "\\pm":
        return " {}\\pm{} ";
      case "\\approx":
        return " {}\\approx{} ";
      case "$\\approx$":
        return " {}\\approx{} ";
      case "v":
        return " \\downarrow{} ";
      case "(v)":
        return " \\downarrow{} ";
      case "^":
        return " \\uparrow{} ";
      case "(^)":
        return " \\uparrow{} ";
      default:
        throw ["MhchemBugT", "mhchem bug T. Please report."];
    }
  }
};

var __importDefault$8 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(MhchemConfiguration, "__esModule", {
  value: true
});
MhchemConfiguration.MhchemConfiguration = void 0;
var Configuration_js_1$7 = Configuration;
var SymbolMap_js_1$4 = SymbolMap;
var TexError_js_1$2 = __importDefault$8(TexError$1);
var BaseMethods_js_1$2 = __importDefault$8(BaseMethods$1);
var AmsMethods_js_1 = AmsMethods;
var mhchemParser_js_1 = mhchemParser$1;
var MhchemMethods = {};
MhchemMethods.Macro = BaseMethods_js_1$2.default.Macro;
MhchemMethods.xArrow = AmsMethods_js_1.AmsMethods.xArrow;
MhchemMethods.Machine = function (parser, name, machine) {
  var arg = parser.GetArgument(name);
  var tex;
  try {
    tex = mhchemParser_js_1.mhchemParser.toTex(arg, machine);
  } catch (err) {
    throw new TexError_js_1$2.default(err[0], err[1]);
  }
  parser.string = tex + parser.string.substr(parser.i);
  parser.i = 0;
};
new SymbolMap_js_1$4.CommandMap('mhchem', {
  ce: ['Machine', 'ce'],
  pu: ['Machine', 'pu'],
  longrightleftharpoons: ['Macro', '\\stackrel{\\textstyle{-}\\!\\!{\\rightharpoonup}}{\\smash{{\\leftharpoondown}\\!\\!{-}}}'],
  longRightleftharpoons: ['Macro', '\\stackrel{\\textstyle{-}\\!\\!{\\rightharpoonup}}{\\smash{\\leftharpoondown}}'],
  longLeftrightharpoons: ['Macro', '\\stackrel{\\textstyle\\vphantom{{-}}{\\rightharpoonup}}{\\smash{{\\leftharpoondown}\\!\\!{-}}}'],
  longleftrightarrows: ['Macro', '\\stackrel{\\longrightarrow}{\\smash{\\longleftarrow}\\Rule{0px}{.25em}{0px}}'],
  tripledash: ['Macro', '\\vphantom{-}\\raise2mu{\\kern2mu\\tiny\\text{-}\\kern1mu\\text{-}\\kern1mu\\text{-}\\kern2mu}'],
  xleftrightarrow: ['xArrow', 0x2194, 6, 6],
  xrightleftharpoons: ['xArrow', 0x21CC, 5, 7],
  xRightleftharpoons: ['xArrow', 0x21CC, 5, 7],
  xLeftrightharpoons: ['xArrow', 0x21CC, 5, 7]
}, MhchemMethods);
MhchemConfiguration.MhchemConfiguration = Configuration_js_1$7.Configuration.create('mhchem', {
  handler: {
    macro: ['mhchem']
  }
});

var NoErrorsConfiguration = {};

Object.defineProperty(NoErrorsConfiguration, "__esModule", {
  value: true
});
NoErrorsConfiguration.NoErrorsConfiguration = void 0;
var Configuration_js_1$6 = Configuration;
function noErrors(factory, message, _id, expr) {
  var mtext = factory.create('token', 'mtext', {}, expr.replace(/\n/g, ' '));
  var error = factory.create('node', 'merror', [mtext], {
    'data-mjx-error': message,
    title: message
  });
  return error;
}
NoErrorsConfiguration.NoErrorsConfiguration = Configuration_js_1$6.Configuration.create('noerrors', {
  nodes: {
    'error': noErrors
  }
});

var NoUndefinedConfiguration = {};

var __values$2 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
Object.defineProperty(NoUndefinedConfiguration, "__esModule", {
  value: true
});
NoUndefinedConfiguration.NoUndefinedConfiguration = void 0;
var Configuration_js_1$5 = Configuration;
function noUndefined(parser, name) {
  var e_1, _a;
  var textNode = parser.create('text', '\\' + name);
  var options = parser.options.noundefined || ({});
  var def = {};
  try {
    for (var _b = __values$2(['color', 'background', 'size']), _c = _b.next(); !_c.done; _c = _b.next()) {
      var id = _c.value;
      if (options[id]) {
        def['math' + id] = options[id];
      }
    }
  } catch (e_1_1) {
    e_1 = {
      error: e_1_1
    };
  } finally {
    try {
      if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
    } finally {
      if (e_1) throw e_1.error;
    }
  }
  parser.Push(parser.create('node', 'mtext', [], def, textNode));
}
NoUndefinedConfiguration.NoUndefinedConfiguration = Configuration_js_1$5.Configuration.create('noundefined', {
  fallback: {
    macro: noUndefined
  },
  options: {
    noundefined: {
      color: 'red',
      background: '',
      size: ''
    }
  },
  priority: 3
});

var PhysicsConfiguration = {};

var PhysicsItems = {};

var __extends$4 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __importDefault$7 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(PhysicsItems, "__esModule", {
  value: true
});
PhysicsItems.AutoOpen = void 0;
var StackItem_js_1 = StackItem;
var ParseUtil_js_1$3 = __importDefault$7(ParseUtil$1);
var NodeUtil_js_1$2 = __importDefault$7(NodeUtil$1);
var TexParser_js_1$3 = __importDefault$7(TexParser$1);
var AutoOpen = (function (_super) {
  __extends$4(AutoOpen, _super);
  function AutoOpen() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.openCount = 0;
    return _this;
  }
  Object.defineProperty(AutoOpen.prototype, "kind", {
    get: function () {
      return 'auto open';
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(AutoOpen.prototype, "isOpen", {
    get: function () {
      return true;
    },
    enumerable: false,
    configurable: true
  });
  AutoOpen.prototype.toMml = function () {
    var parser = this.factory.configuration.parser;
    var right = this.getProperty('right');
    if (this.getProperty('smash')) {
      var mml_1 = _super.prototype.toMml.call(this);
      var smash = parser.create('node', 'mpadded', [mml_1], {
        height: 0,
        depth: 0
      });
      this.Clear();
      this.Push(parser.create('node', 'TeXAtom', [smash]));
    }
    if (right) {
      this.Push(new TexParser_js_1$3.default(right, parser.stack.env, parser.configuration).mml());
    }
    var mml = ParseUtil_js_1$3.default.fenced(this.factory.configuration, this.getProperty('open'), _super.prototype.toMml.call(this), this.getProperty('close'), this.getProperty('big'));
    NodeUtil_js_1$2.default.removeProperties(mml, 'open', 'close', 'texClass');
    return mml;
  };
  AutoOpen.prototype.checkItem = function (item) {
    if (item.isKind('mml') && item.Size() === 1) {
      var mml = item.toMml();
      if (mml.isKind('mo') && mml.getText() === this.getProperty('open')) {
        this.openCount++;
      }
    }
    var close = item.getProperty('autoclose');
    if (close && close === this.getProperty('close') && !this.openCount--) {
      if (this.getProperty('ignore')) {
        this.Clear();
        return [[], true];
      }
      return [[this.toMml()], true];
    }
    return _super.prototype.checkItem.call(this, item);
  };
  AutoOpen.errors = Object.assign(Object.create(StackItem_js_1.BaseItem.errors), {
    'stop': ['ExtraOrMissingDelims', 'Extra open or missing close delimiter']
  });
  return AutoOpen;
})(StackItem_js_1.BaseItem);
PhysicsItems.AutoOpen = AutoOpen;

var PhysicsMappings = {};

var PhysicsMethods$1 = {};

var __read$2 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __importDefault$6 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(PhysicsMethods$1, "__esModule", {
  value: true
});
var BaseMethods_js_1$1 = __importDefault$6(BaseMethods$1);
var TexParser_js_1$2 = __importDefault$6(TexParser$1);
var TexError_js_1$1 = __importDefault$6(TexError$1);
var MmlNode_js_1$2 = MmlNode;
var ParseUtil_js_1$2 = __importDefault$6(ParseUtil$1);
var NodeUtil_js_1$1 = __importDefault$6(NodeUtil$1);
var NodeFactory_js_1 = NodeFactory$2;
var PhysicsMethods = {};
var pairs = {
  '(': ')',
  '[': ']',
  '{': '}',
  '|': '|'
};
var biggs = /^(b|B)i(g{1,2})$/;
PhysicsMethods.Quantity = function (parser, name, open, close, arg, named, variant) {
  if (open === void 0) {
    open = '(';
  }
  if (close === void 0) {
    close = ')';
  }
  if (arg === void 0) {
    arg = false;
  }
  if (named === void 0) {
    named = '';
  }
  if (variant === void 0) {
    variant = '';
  }
  var star = arg ? parser.GetStar() : false;
  var next = parser.GetNext();
  var position = parser.i;
  var big = null;
  if (next === '\\') {
    parser.i++;
    big = parser.GetCS();
    if (!big.match(biggs)) {
      var empty = parser.create('node', 'mrow');
      parser.Push(ParseUtil_js_1$2.default.fenced(parser.configuration, open, empty, close));
      parser.i = position;
      return;
    }
    next = parser.GetNext();
  }
  var right = pairs[next];
  if (arg && next !== '{') {
    throw new TexError_js_1$1.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
  }
  if (!right) {
    var empty = parser.create('node', 'mrow');
    parser.Push(ParseUtil_js_1$2.default.fenced(parser.configuration, open, empty, close));
    parser.i = position;
    return;
  }
  if (named) {
    var mml = parser.create('token', 'mi', {
      texClass: MmlNode_js_1$2.TEXCLASS.OP
    }, named);
    if (variant) {
      NodeUtil_js_1$1.default.setAttribute(mml, 'mathvariant', variant);
    }
    parser.Push(parser.itemFactory.create('fn', mml));
  }
  if (next === '{') {
    var argument = parser.GetArgument(name);
    next = arg ? open : '\\{';
    right = arg ? close : '\\}';
    argument = star ? next + ' ' + argument + ' ' + right : big ? '\\' + big + 'l' + next + ' ' + argument + ' ' + '\\' + big + 'r' + right : '\\left' + next + ' ' + argument + ' ' + '\\right' + right;
    parser.Push(new TexParser_js_1$2.default(argument, parser.stack.env, parser.configuration).mml());
    return;
  }
  if (arg) {
    next = open;
    right = close;
  }
  parser.i++;
  parser.Push(parser.itemFactory.create('auto open').setProperties({
    open: next,
    close: right,
    big: big
  }));
};
PhysicsMethods.Eval = function (parser, name) {
  var star = parser.GetStar();
  var next = parser.GetNext();
  if (next === '{') {
    var arg = parser.GetArgument(name);
    var replace = '\\left. ' + (star ? '\\smash{' + arg + '}' : arg) + ' ' + '\\vphantom{\\int}\\right|';
    parser.string = parser.string.slice(0, parser.i) + replace + parser.string.slice(parser.i);
    return;
  }
  if (next === '(' || next === '[') {
    parser.i++;
    parser.Push(parser.itemFactory.create('auto open').setProperties({
      open: next,
      close: '|',
      smash: star,
      right: '\\vphantom{\\int}'
    }));
    return;
  }
  throw new TexError_js_1$1.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
};
PhysicsMethods.Commutator = function (parser, name, open, close) {
  if (open === void 0) {
    open = '[';
  }
  if (close === void 0) {
    close = ']';
  }
  var star = parser.GetStar();
  var next = parser.GetNext();
  var big = null;
  if (next === '\\') {
    parser.i++;
    big = parser.GetCS();
    if (!big.match(biggs)) {
      throw new TexError_js_1$1.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
    }
    next = parser.GetNext();
  }
  if (next !== '{') {
    throw new TexError_js_1$1.default('MissingArgFor', 'Missing argument for %1', parser.currentCS);
  }
  var arg1 = parser.GetArgument(name);
  var arg2 = parser.GetArgument(name);
  var argument = arg1 + ',' + arg2;
  argument = star ? open + ' ' + argument + ' ' + close : big ? '\\' + big + 'l' + open + ' ' + argument + ' ' + '\\' + big + 'r' + close : '\\left' + open + ' ' + argument + ' ' + '\\right' + close;
  parser.Push(new TexParser_js_1$2.default(argument, parser.stack.env, parser.configuration).mml());
};
var latinCap = [0x41, 0x5A];
var latinSmall = [0x61, 0x7A];
var greekCap = [0x391, 0x3A9];
var greekSmall = [0x3B1, 0x3C9];
var digits = [0x30, 0x39];
function inRange(value, range) {
  return value >= range[0] && value <= range[1];
}
function createVectorToken(factory, kind, def, text) {
  var parser = factory.configuration.parser;
  var token = NodeFactory_js_1.NodeFactory.createToken(factory, kind, def, text);
  var code = text.codePointAt(0);
  if (text.length === 1 && !parser.stack.env.font && parser.stack.env.vectorFont && (inRange(code, latinCap) || inRange(code, latinSmall) || inRange(code, greekCap) || inRange(code, digits) || inRange(code, greekSmall) && parser.stack.env.vectorStar || NodeUtil_js_1$1.default.getAttribute(token, 'accent'))) {
    NodeUtil_js_1$1.default.setAttribute(token, 'mathvariant', parser.stack.env.vectorFont);
  }
  return token;
}
PhysicsMethods.VectorBold = function (parser, name) {
  var star = parser.GetStar();
  var arg = parser.GetArgument(name);
  var oldToken = parser.configuration.nodeFactory.get('token');
  var oldFont = parser.stack.env.font;
  delete parser.stack.env.font;
  parser.configuration.nodeFactory.set('token', createVectorToken);
  parser.stack.env.vectorFont = star ? 'bold-italic' : 'bold';
  parser.stack.env.vectorStar = star;
  var node = new TexParser_js_1$2.default(arg, parser.stack.env, parser.configuration).mml();
  if (oldFont) {
    parser.stack.env.font = oldFont;
  }
  delete parser.stack.env.vectorFont;
  delete parser.stack.env.vectorStar;
  parser.configuration.nodeFactory.set('token', oldToken);
  parser.Push(node);
};
PhysicsMethods.StarMacro = function (parser, name, argcount) {
  var parts = [];
  for (var _i = 3; _i < arguments.length; _i++) {
    parts[_i - 3] = arguments[_i];
  }
  var star = parser.GetStar();
  var args = [];
  if (argcount) {
    for (var i = args.length; i < argcount; i++) {
      args.push(parser.GetArgument(name));
    }
  }
  var macro = parts.join(star ? '*' : '');
  macro = ParseUtil_js_1$2.default.substituteArgs(parser, args, macro);
  parser.string = ParseUtil_js_1$2.default.addArgs(parser, macro, parser.string.slice(parser.i));
  parser.i = 0;
  ParseUtil_js_1$2.default.checkMaxMacros(parser);
};
var vectorApplication = function (parser, kind, name, operator, fences) {
  var op = new TexParser_js_1$2.default(operator, parser.stack.env, parser.configuration).mml();
  parser.Push(parser.itemFactory.create(kind, op));
  var left = parser.GetNext();
  var right = pairs[left];
  if (!right) {
    return;
  }
  var lfence = '', rfence = '', arg = '';
  var enlarge = fences.indexOf(left) !== -1;
  if (left === '{') {
    arg = parser.GetArgument(name);
    lfence = enlarge ? '\\left\\{' : '';
    rfence = enlarge ? '\\right\\}' : '';
    var macro = lfence + ' ' + arg + ' ' + rfence;
    parser.string = macro + parser.string.slice(parser.i);
    parser.i = 0;
    return;
  }
  if (!enlarge) {
    return;
  }
  parser.i++;
  parser.Push(parser.itemFactory.create('auto open').setProperties({
    open: left,
    close: right
  }));
};
PhysicsMethods.OperatorApplication = function (parser, name, operator) {
  var fences = [];
  for (var _i = 3; _i < arguments.length; _i++) {
    fences[_i - 3] = arguments[_i];
  }
  vectorApplication(parser, 'fn', name, operator, fences);
};
PhysicsMethods.VectorOperator = function (parser, name, operator) {
  var fences = [];
  for (var _i = 3; _i < arguments.length; _i++) {
    fences[_i - 3] = arguments[_i];
  }
  vectorApplication(parser, 'mml', name, operator, fences);
};
PhysicsMethods.Expression = function (parser, name, opt, id) {
  if (opt === void 0) {
    opt = true;
  }
  if (id === void 0) {
    id = '';
  }
  id = id || name.slice(1);
  var exp = opt ? parser.GetBrackets(name) : null;
  var mml = parser.create('token', 'mi', {
    texClass: MmlNode_js_1$2.TEXCLASS.OP
  }, id);
  if (exp) {
    var sup = new TexParser_js_1$2.default(exp, parser.stack.env, parser.configuration).mml();
    mml = parser.create('node', 'msup', [mml, sup]);
  }
  parser.Push(parser.itemFactory.create('fn', mml));
  if (parser.GetNext() !== '(') {
    return;
  }
  parser.i++;
  parser.Push(parser.itemFactory.create('auto open').setProperties({
    open: '(',
    close: ')'
  }));
};
PhysicsMethods.Qqtext = function (parser, name, text) {
  var star = parser.GetStar();
  var arg = text ? text : parser.GetArgument(name);
  var replace = (star ? '' : '\\quad') + '\\text{' + arg + '}\\quad ';
  parser.string = parser.string.slice(0, parser.i) + replace + parser.string.slice(parser.i);
};
PhysicsMethods.Differential = function (parser, name, op) {
  var optArg = parser.GetBrackets(name);
  var power = optArg != null ? '^{' + optArg + '}' : ' ';
  var parens = parser.GetNext() === '(';
  var braces = parser.GetNext() === '{';
  var macro = op + power;
  if (!(parens || braces)) {
    macro += parser.GetArgument(name, true) || '';
    var mml = new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml();
    parser.Push(mml);
    return;
  }
  if (braces) {
    macro += parser.GetArgument(name);
    var mml = new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml();
    parser.Push(parser.create('node', 'TeXAtom', [mml], {
      texClass: MmlNode_js_1$2.TEXCLASS.OP
    }));
    return;
  }
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
  parser.i++;
  parser.Push(parser.itemFactory.create('auto open').setProperties({
    open: '(',
    close: ')'
  }));
};
PhysicsMethods.Derivative = function (parser, name, argMax, op) {
  var star = parser.GetStar();
  var optArg = parser.GetBrackets(name);
  var argCounter = 1;
  var args = [];
  args.push(parser.GetArgument(name));
  while (parser.GetNext() === '{' && argCounter < argMax) {
    args.push(parser.GetArgument(name));
    argCounter++;
  }
  var ignore = false;
  var power1 = ' ';
  var power2 = ' ';
  if (argMax > 2 && args.length > 2) {
    power1 = '^{' + (args.length - 1) + '}';
    ignore = true;
  } else if (optArg != null) {
    if (argMax > 2 && args.length > 1) {
      ignore = true;
    }
    power1 = '^{' + optArg + '}';
    power2 = power1;
  }
  var frac = star ? '\\flatfrac' : '\\frac';
  var first = args.length > 1 ? args[0] : '';
  var second = args.length > 1 ? args[1] : args[0];
  var rest = '';
  for (var i = 2, arg = void 0; arg = args[i]; i++) {
    rest += op + ' ' + arg;
  }
  var macro = frac + '{' + op + power1 + first + '}' + '{' + op + ' ' + second + power2 + ' ' + rest + '}';
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
  if (parser.GetNext() === '(') {
    parser.i++;
    parser.Push(parser.itemFactory.create('auto open').setProperties({
      open: '(',
      close: ')',
      ignore: ignore
    }));
  }
};
PhysicsMethods.Bra = function (parser, name) {
  var starBra = parser.GetStar();
  var bra = parser.GetArgument(name);
  var ket = '';
  var hasKet = false;
  var starKet = false;
  if (parser.GetNext() === '\\') {
    var saveI = parser.i;
    parser.i++;
    var cs = parser.GetCS();
    var symbol = parser.lookup('macro', cs);
    if (symbol && symbol.symbol === 'ket') {
      hasKet = true;
      saveI = parser.i;
      starKet = parser.GetStar();
      if (parser.GetNext() === '{') {
        ket = parser.GetArgument(cs, true);
      } else {
        parser.i = saveI;
        starKet = false;
      }
    } else {
      parser.i = saveI;
    }
  }
  var macro = '';
  if (hasKet) {
    macro = starBra || starKet ? ("\\langle{").concat(bra, "}\\vert{").concat(ket, "}\\rangle") : ("\\left\\langle{").concat(bra, "}\\middle\\vert{").concat(ket, "}\\right\\rangle");
  } else {
    macro = starBra || starKet ? ("\\langle{").concat(bra, "}\\vert") : ("\\left\\langle{").concat(bra, "}\\right\\vert{").concat(ket, "}");
  }
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.Ket = function (parser, name) {
  var star = parser.GetStar();
  var ket = parser.GetArgument(name);
  var macro = star ? ("\\vert{").concat(ket, "}\\rangle") : ("\\left\\vert{").concat(ket, "}\\right\\rangle");
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.BraKet = function (parser, name) {
  var star = parser.GetStar();
  var bra = parser.GetArgument(name);
  var ket = null;
  if (parser.GetNext() === '{') {
    ket = parser.GetArgument(name, true);
  }
  var macro = '';
  if (ket == null) {
    macro = star ? ("\\langle{").concat(bra, "}\\vert{").concat(bra, "}\\rangle") : ("\\left\\langle{").concat(bra, "}\\middle\\vert{").concat(bra, "}\\right\\rangle");
  } else {
    macro = star ? ("\\langle{").concat(bra, "}\\vert{").concat(ket, "}\\rangle") : ("\\left\\langle{").concat(bra, "}\\middle\\vert{").concat(ket, "}\\right\\rangle");
  }
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.KetBra = function (parser, name) {
  var star = parser.GetStar();
  var ket = parser.GetArgument(name);
  var bra = null;
  if (parser.GetNext() === '{') {
    bra = parser.GetArgument(name, true);
  }
  var macro = '';
  if (bra == null) {
    macro = star ? ("\\vert{").concat(ket, "}\\rangle\\!\\langle{").concat(ket, "}\\vert") : ("\\left\\vert{").concat(ket, "}\\middle\\rangle\\!\\middle\\langle{").concat(ket, "}\\right\\vert");
  } else {
    macro = star ? ("\\vert{").concat(ket, "}\\rangle\\!\\langle{").concat(bra, "}\\vert") : ("\\left\\vert{").concat(ket, "}\\middle\\rangle\\!\\middle\\langle{").concat(bra, "}\\right\\vert");
  }
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
function outputBraket(_a, star1, star2) {
  var _b = __read$2(_a, 3), arg1 = _b[0], arg2 = _b[1], arg3 = _b[2];
  return star1 && star2 ? ("\\left\\langle{").concat(arg1, "}\\middle\\vert{").concat(arg2, "}\\middle\\vert{").concat(arg3, "}\\right\\rangle") : star1 ? ("\\langle{").concat(arg1, "}\\vert{").concat(arg2, "}\\vert{").concat(arg3, "}\\rangle") : ("\\left\\langle{").concat(arg1, "}\\right\\vert{").concat(arg2, "}\\left\\vert{").concat(arg3, "}\\right\\rangle");
}
PhysicsMethods.Expectation = function (parser, name) {
  var star1 = parser.GetStar();
  var star2 = star1 && parser.GetStar();
  var arg1 = parser.GetArgument(name);
  var arg2 = null;
  if (parser.GetNext() === '{') {
    arg2 = parser.GetArgument(name, true);
  }
  var macro = arg1 && arg2 ? outputBraket([arg2, arg1, arg2], star1, star2) : star1 ? ("\\langle {").concat(arg1, "} \\rangle") : ("\\left\\langle {").concat(arg1, "} \\right\\rangle");
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.MatrixElement = function (parser, name) {
  var star1 = parser.GetStar();
  var star2 = star1 && parser.GetStar();
  var arg1 = parser.GetArgument(name);
  var arg2 = parser.GetArgument(name);
  var arg3 = parser.GetArgument(name);
  var macro = outputBraket([arg1, arg2, arg3], star1, star2);
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.MatrixQuantity = function (parser, name, small) {
  var star = parser.GetStar();
  var next = parser.GetNext();
  var array = small ? 'smallmatrix' : 'array';
  var arg = '';
  var open = '';
  var close = '';
  switch (next) {
    case '{':
      arg = parser.GetArgument(name);
      break;
    case '(':
      parser.i++;
      open = star ? '\\lgroup' : '(';
      close = star ? '\\rgroup' : ')';
      arg = parser.GetUpTo(name, ')');
      break;
    case '[':
      parser.i++;
      open = '[';
      close = ']';
      arg = parser.GetUpTo(name, ']');
      break;
    case '|':
      parser.i++;
      open = '|';
      close = '|';
      arg = parser.GetUpTo(name, '|');
      break;
    default:
      open = '(';
      close = ')';
      break;
  }
  var macro = (open ? '\\left' : '') + open + '\\begin{' + array + '}{} ' + arg + '\\end{' + array + '}' + (open ? '\\right' : '') + close;
  parser.Push(new TexParser_js_1$2.default(macro, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.IdentityMatrix = function (parser, name) {
  var arg = parser.GetArgument(name);
  var size = parseInt(arg, 10);
  if (isNaN(size)) {
    throw new TexError_js_1$1.default('InvalidNumber', 'Invalid number');
  }
  if (size <= 1) {
    parser.string = '1' + parser.string.slice(parser.i);
    parser.i = 0;
    return;
  }
  var zeros = Array(size).fill('0');
  var columns = [];
  for (var i = 0; i < size; i++) {
    var row = zeros.slice();
    row[i] = '1';
    columns.push(row.join(' & '));
  }
  parser.string = columns.join('\\\\ ') + parser.string.slice(parser.i);
  parser.i = 0;
};
PhysicsMethods.XMatrix = function (parser, name) {
  var star = parser.GetStar();
  var arg1 = parser.GetArgument(name);
  var arg2 = parser.GetArgument(name);
  var arg3 = parser.GetArgument(name);
  var n = parseInt(arg2, 10);
  var m = parseInt(arg3, 10);
  if (isNaN(n) || isNaN(m) || m.toString() !== arg3 || n.toString() !== arg2) {
    throw new TexError_js_1$1.default('InvalidNumber', 'Invalid number');
  }
  n = n < 1 ? 1 : n;
  m = m < 1 ? 1 : m;
  if (!star) {
    var row = Array(m).fill(arg1).join(' & ');
    var matrix_1 = Array(n).fill(row).join('\\\\ ');
    parser.string = matrix_1 + parser.string.slice(parser.i);
    parser.i = 0;
    return;
  }
  var matrix = '';
  if (n === 1 && m === 1) {
    matrix = arg1;
  } else if (n === 1) {
    var row = [];
    for (var i = 1; i <= m; i++) {
      row.push(("").concat(arg1, "_{").concat(i, "}"));
    }
    matrix = row.join(' & ');
  } else if (m === 1) {
    var row = [];
    for (var i = 1; i <= n; i++) {
      row.push(("").concat(arg1, "_{").concat(i, "}"));
    }
    matrix = row.join('\\\\ ');
  } else {
    var rows = [];
    for (var i = 1; i <= n; i++) {
      var row = [];
      for (var j = 1; j <= m; j++) {
        row.push(("").concat(arg1, "_{{").concat(i, "}{").concat(j, "}}"));
      }
      rows.push(row.join(' & '));
    }
    matrix = rows.join('\\\\ ');
  }
  parser.string = matrix + parser.string.slice(parser.i);
  parser.i = 0;
  return;
};
PhysicsMethods.PauliMatrix = function (parser, name) {
  var arg = parser.GetArgument(name);
  var matrix = arg.slice(1);
  switch (arg[0]) {
    case '0':
      matrix += ' 1 & 0\\\\ 0 & 1';
      break;
    case '1':
    case 'x':
      matrix += ' 0 & 1\\\\ 1 & 0';
      break;
    case '2':
    case 'y':
      matrix += ' 0 & -i\\\\ i & 0';
      break;
    case '3':
    case 'z':
      matrix += ' 1 & 0\\\\ 0 & -1';
      break;
  }
  parser.string = matrix + parser.string.slice(parser.i);
  parser.i = 0;
};
PhysicsMethods.DiagonalMatrix = function (parser, name, anti) {
  if (parser.GetNext() !== '{') {
    return;
  }
  var startI = parser.i;
  parser.GetArgument(name);
  var endI = parser.i;
  parser.i = startI + 1;
  var elements = [];
  var element = '';
  var currentI = parser.i;
  while (currentI < endI) {
    try {
      element = parser.GetUpTo(name, ',');
    } catch (e) {
      parser.i = endI;
      elements.push(parser.string.slice(currentI, endI - 1));
      break;
    }
    if (parser.i >= endI) {
      elements.push(parser.string.slice(currentI, endI));
      break;
    }
    currentI = parser.i;
    elements.push(element);
  }
  parser.string = makeDiagMatrix(elements, anti) + parser.string.slice(endI);
  parser.i = 0;
};
function makeDiagMatrix(elements, anti) {
  var length = elements.length;
  var matrix = [];
  for (var i = 0; i < length; i++) {
    matrix.push(Array(anti ? length - i : i + 1).join('&') + '\\mqty{' + elements[i] + '}');
  }
  return matrix.join('\\\\ ');
}
PhysicsMethods.AutoClose = function (parser, fence, _texclass) {
  var mo = parser.create('token', 'mo', {
    stretchy: false
  }, fence);
  var item = parser.itemFactory.create('mml', mo).setProperties({
    autoclose: fence
  });
  parser.Push(item);
};
PhysicsMethods.Vnabla = function (parser, _name) {
  var argument = parser.options.physics.arrowdel ? '\\vec{\\gradientnabla}' : '{\\gradientnabla}';
  return parser.Push(new TexParser_js_1$2.default(argument, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.DiffD = function (parser, _name) {
  var argument = parser.options.physics.italicdiff ? 'd' : '{\\rm d}';
  return parser.Push(new TexParser_js_1$2.default(argument, parser.stack.env, parser.configuration).mml());
};
PhysicsMethods.Macro = BaseMethods_js_1$1.default.Macro;
PhysicsMethods.NamedFn = BaseMethods_js_1$1.default.NamedFn;
PhysicsMethods.Array = BaseMethods_js_1$1.default.Array;
PhysicsMethods$1.default = PhysicsMethods;

var __importDefault$5 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(PhysicsMappings, "__esModule", {
  value: true
});
var SymbolMap_js_1$3 = SymbolMap;
var PhysicsMethods_js_1 = __importDefault$5(PhysicsMethods$1);
var TexConstants_js_1$3 = TexConstants;
var ParseMethods_js_1 = __importDefault$5(ParseMethods$1);
var MmlNode_js_1$1 = MmlNode;
new SymbolMap_js_1$3.CommandMap('Physics-automatic-bracing-macros', {
  'quantity': 'Quantity',
  'qty': 'Quantity',
  'pqty': ['Quantity', '(', ')', true],
  'bqty': ['Quantity', '[', ']', true],
  'vqty': ['Quantity', '|', '|', true],
  'Bqty': ['Quantity', '\\{', '\\}', true],
  'absolutevalue': ['Quantity', '|', '|', true],
  'abs': ['Quantity', '|', '|', true],
  'norm': ['Quantity', '\\|', '\\|', true],
  'evaluated': 'Eval',
  'eval': 'Eval',
  'order': ['Quantity', '(', ')', true, 'O', TexConstants_js_1$3.TexConstant.Variant.CALLIGRAPHIC],
  'commutator': 'Commutator',
  'comm': 'Commutator',
  'anticommutator': ['Commutator', '\\{', '\\}'],
  'acomm': ['Commutator', '\\{', '\\}'],
  'poissonbracket': ['Commutator', '\\{', '\\}'],
  'pb': ['Commutator', '\\{', '\\}']
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CharacterMap('Physics-vector-mo', ParseMethods_js_1.default.mathchar0mo, {
  dotproduct: ['\u22C5', {
    mathvariant: TexConstants_js_1$3.TexConstant.Variant.BOLD
  }],
  vdot: ['\u22C5', {
    mathvariant: TexConstants_js_1$3.TexConstant.Variant.BOLD
  }],
  crossproduct: '\u00D7',
  cross: '\u00D7',
  cp: '\u00D7',
  gradientnabla: ['\u2207', {
    mathvariant: TexConstants_js_1$3.TexConstant.Variant.BOLD
  }]
});
new SymbolMap_js_1$3.CharacterMap('Physics-vector-mi', ParseMethods_js_1.default.mathchar0mi, {
  real: ['\u211C', {
    mathvariant: TexConstants_js_1$3.TexConstant.Variant.NORMAL
  }],
  imaginary: ['\u2111', {
    mathvariant: TexConstants_js_1$3.TexConstant.Variant.NORMAL
  }]
});
new SymbolMap_js_1$3.CommandMap('Physics-vector-macros', {
  'vnabla': 'Vnabla',
  'vectorbold': 'VectorBold',
  'vb': 'VectorBold',
  'vectorarrow': ['StarMacro', 1, '\\vec{\\vb', '{#1}}'],
  'va': ['StarMacro', 1, '\\vec{\\vb', '{#1}}'],
  'vectorunit': ['StarMacro', 1, '\\hat{\\vb', '{#1}}'],
  'vu': ['StarMacro', 1, '\\hat{\\vb', '{#1}}'],
  'gradient': ['OperatorApplication', '\\vnabla', '(', '['],
  'grad': ['OperatorApplication', '\\vnabla', '(', '['],
  'divergence': ['VectorOperator', '\\vnabla\\vdot', '(', '['],
  'div': ['VectorOperator', '\\vnabla\\vdot', '(', '['],
  'curl': ['VectorOperator', '\\vnabla\\crossproduct', '(', '['],
  'laplacian': ['OperatorApplication', '\\nabla^2', '(', '[']
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CommandMap('Physics-expressions-macros', {
  'sin': 'Expression',
  'sinh': 'Expression',
  'arcsin': 'Expression',
  'asin': 'Expression',
  'cos': 'Expression',
  'cosh': 'Expression',
  'arccos': 'Expression',
  'acos': 'Expression',
  'tan': 'Expression',
  'tanh': 'Expression',
  'arctan': 'Expression',
  'atan': 'Expression',
  'csc': 'Expression',
  'csch': 'Expression',
  'arccsc': 'Expression',
  'acsc': 'Expression',
  'sec': 'Expression',
  'sech': 'Expression',
  'arcsec': 'Expression',
  'asec': 'Expression',
  'cot': 'Expression',
  'coth': 'Expression',
  'arccot': 'Expression',
  'acot': 'Expression',
  'exp': ['Expression', false],
  'log': 'Expression',
  'ln': 'Expression',
  'det': ['Expression', false],
  'Pr': ['Expression', false],
  'tr': ['Expression', false],
  'trace': ['Expression', false, 'tr'],
  'Tr': ['Expression', false],
  'Trace': ['Expression', false, 'Tr'],
  'rank': 'NamedFn',
  'erf': ['Expression', false],
  'Residue': ['Macro', '\\mathrm{Res}'],
  'Res': ['OperatorApplication', '\\Residue', '(', '[', '{'],
  'principalvalue': ['OperatorApplication', '{\\cal P}'],
  'pv': ['OperatorApplication', '{\\cal P}'],
  'PV': ['OperatorApplication', '{\\rm P.V.}'],
  'Re': ['OperatorApplication', '\\mathrm{Re}', '{'],
  'Im': ['OperatorApplication', '\\mathrm{Im}', '{'],
  'sine': ['NamedFn', 'sin'],
  'hypsine': ['NamedFn', 'sinh'],
  'arcsine': ['NamedFn', 'arcsin'],
  'asine': ['NamedFn', 'asin'],
  'cosine': ['NamedFn', 'cos'],
  'hypcosine': ['NamedFn', 'cosh'],
  'arccosine': ['NamedFn', 'arccos'],
  'acosine': ['NamedFn', 'acos'],
  'tangent': ['NamedFn', 'tan'],
  'hyptangent': ['NamedFn', 'tanh'],
  'arctangent': ['NamedFn', 'arctan'],
  'atangent': ['NamedFn', 'atan'],
  'cosecant': ['NamedFn', 'csc'],
  'hypcosecant': ['NamedFn', 'csch'],
  'arccosecant': ['NamedFn', 'arccsc'],
  'acosecant': ['NamedFn', 'acsc'],
  'secant': ['NamedFn', 'sec'],
  'hypsecant': ['NamedFn', 'sech'],
  'arcsecant': ['NamedFn', 'arcsec'],
  'asecant': ['NamedFn', 'asec'],
  'cotangent': ['NamedFn', 'cot'],
  'hypcotangent': ['NamedFn', 'coth'],
  'arccotangent': ['NamedFn', 'arccot'],
  'acotangent': ['NamedFn', 'acot'],
  'exponential': ['NamedFn', 'exp'],
  'logarithm': ['NamedFn', 'log'],
  'naturallogarithm': ['NamedFn', 'ln'],
  'determinant': ['NamedFn', 'det'],
  'Probability': ['NamedFn', 'Pr']
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CommandMap('Physics-quick-quad-macros', {
  'qqtext': 'Qqtext',
  'qq': 'Qqtext',
  'qcomma': ['Macro', '\\qqtext*{,}'],
  'qc': ['Macro', '\\qqtext*{,}'],
  'qcc': ['Qqtext', 'c.c.'],
  'qif': ['Qqtext', 'if'],
  'qthen': ['Qqtext', 'then'],
  'qelse': ['Qqtext', 'else'],
  'qotherwise': ['Qqtext', 'otherwise'],
  'qunless': ['Qqtext', 'unless'],
  'qgiven': ['Qqtext', 'given'],
  'qusing': ['Qqtext', 'using'],
  'qassume': ['Qqtext', 'assume'],
  'qsince': ['Qqtext', 'since'],
  'qlet': ['Qqtext', 'let'],
  'qfor': ['Qqtext', 'for'],
  'qall': ['Qqtext', 'all'],
  'qeven': ['Qqtext', 'even'],
  'qodd': ['Qqtext', 'odd'],
  'qinteger': ['Qqtext', 'integer'],
  'qand': ['Qqtext', 'and'],
  'qor': ['Qqtext', 'or'],
  'qas': ['Qqtext', 'as'],
  'qin': ['Qqtext', 'in']
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CommandMap('Physics-derivative-macros', {
  'diffd': 'DiffD',
  'flatfrac': ['Macro', '\\left.#1\\middle/#2\\right.', 2],
  'differential': ['Differential', '\\diffd'],
  'dd': ['Differential', '\\diffd'],
  'variation': ['Differential', '\\delta'],
  'var': ['Differential', '\\delta'],
  'derivative': ['Derivative', 2, '\\diffd'],
  'dv': ['Derivative', 2, '\\diffd'],
  'partialderivative': ['Derivative', 3, '\\partial'],
  'pderivative': ['Derivative', 3, '\\partial'],
  'pdv': ['Derivative', 3, '\\partial'],
  'functionalderivative': ['Derivative', 2, '\\delta'],
  'fderivative': ['Derivative', 2, '\\delta'],
  'fdv': ['Derivative', 2, '\\delta']
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CommandMap('Physics-bra-ket-macros', {
  'bra': 'Bra',
  'ket': 'Ket',
  'innerproduct': 'BraKet',
  'ip': 'BraKet',
  'braket': 'BraKet',
  'outerproduct': 'KetBra',
  'dyad': 'KetBra',
  'ketbra': 'KetBra',
  'op': 'KetBra',
  'expectationvalue': 'Expectation',
  'expval': 'Expectation',
  'ev': 'Expectation',
  'matrixelement': 'MatrixElement',
  'matrixel': 'MatrixElement',
  'mel': 'MatrixElement'
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.CommandMap('Physics-matrix-macros', {
  'matrixquantity': 'MatrixQuantity',
  'mqty': 'MatrixQuantity',
  'pmqty': ['Macro', '\\mqty(#1)', 1],
  'Pmqty': ['Macro', '\\mqty*(#1)', 1],
  'bmqty': ['Macro', '\\mqty[#1]', 1],
  'vmqty': ['Macro', '\\mqty|#1|', 1],
  'smallmatrixquantity': ['MatrixQuantity', true],
  'smqty': ['MatrixQuantity', true],
  'spmqty': ['Macro', '\\smqty(#1)', 1],
  'sPmqty': ['Macro', '\\smqty*(#1)', 1],
  'sbmqty': ['Macro', '\\smqty[#1]', 1],
  'svmqty': ['Macro', '\\smqty|#1|', 1],
  'matrixdeterminant': ['Macro', '\\vmqty{#1}', 1],
  'mdet': ['Macro', '\\vmqty{#1}', 1],
  'smdet': ['Macro', '\\svmqty{#1}', 1],
  'identitymatrix': 'IdentityMatrix',
  'imat': 'IdentityMatrix',
  'xmatrix': 'XMatrix',
  'xmat': 'XMatrix',
  'zeromatrix': ['Macro', '\\xmat{0}{#1}{#2}', 2],
  'zmat': ['Macro', '\\xmat{0}{#1}{#2}', 2],
  'paulimatrix': 'PauliMatrix',
  'pmat': 'PauliMatrix',
  'diagonalmatrix': 'DiagonalMatrix',
  'dmat': 'DiagonalMatrix',
  'antidiagonalmatrix': ['DiagonalMatrix', true],
  'admat': ['DiagonalMatrix', true]
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.EnvironmentMap('Physics-aux-envs', ParseMethods_js_1.default.environment, {
  smallmatrix: ['Array', null, null, null, 'c', '0.333em', '.2em', 'S', 1]
}, PhysicsMethods_js_1.default);
new SymbolMap_js_1$3.MacroMap('Physics-characters', {
  '|': ['AutoClose', MmlNode_js_1$1.TEXCLASS.ORD],
  ')': 'AutoClose',
  ']': 'AutoClose'
}, PhysicsMethods_js_1.default);

var _a$1;
Object.defineProperty(PhysicsConfiguration, "__esModule", {
  value: true
});
PhysicsConfiguration.PhysicsConfiguration = void 0;
var Configuration_js_1$4 = Configuration;
var PhysicsItems_js_1 = PhysicsItems;
PhysicsConfiguration.PhysicsConfiguration = Configuration_js_1$4.Configuration.create('physics', {
  handler: {
    macro: ['Physics-automatic-bracing-macros', 'Physics-vector-macros', 'Physics-vector-mo', 'Physics-vector-mi', 'Physics-derivative-macros', 'Physics-expressions-macros', 'Physics-quick-quad-macros', 'Physics-bra-ket-macros', 'Physics-matrix-macros'],
    character: ['Physics-characters'],
    environment: ['Physics-aux-envs']
  },
  items: (_a$1 = {}, _a$1[PhysicsItems_js_1.AutoOpen.prototype.kind] = PhysicsItems_js_1.AutoOpen, _a$1),
  options: {
    physics: {
      italicdiff: false,
      arrowdel: false
    }
  }
});

var SetOptionsConfiguration = {};

(function (exports) {
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SetOptionsConfiguration = exports.SetOptionsUtil = void 0;
  var Configuration_js_1 = Configuration;
  var SymbolMap_js_1 = SymbolMap;
  var TexError_js_1 = __importDefault(TexError$1);
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var Symbol_js_1 = _Symbol;
  var BaseMethods_js_1 = __importDefault(BaseMethods$1);
  var Options_js_1 = Options;
  exports.SetOptionsUtil = {
    filterPackage: function (parser, extension) {
      if (extension !== 'tex' && !Configuration_js_1.ConfigurationHandler.get(extension)) {
        throw new TexError_js_1.default('NotAPackage', 'Not a defined package: %1', extension);
      }
      var config = parser.options.setoptions;
      var options = config.allowOptions[extension];
      if (options === undefined && !config.allowPackageDefault || options === false) {
        throw new TexError_js_1.default('PackageNotSettable', 'Options can\'t be set for package "%1"', extension);
      }
      return true;
    },
    filterOption: function (parser, extension, option) {
      var _a;
      var config = parser.options.setoptions;
      var options = config.allowOptions[extension] || ({});
      var allow = options.hasOwnProperty(option) && !(0, Options_js_1.isObject)(options[option]) ? options[option] : null;
      if (allow === false || allow === null && !config.allowOptionsDefault) {
        throw new TexError_js_1.default('OptionNotSettable', 'Option "%1" is not allowed to be set', option);
      }
      if (!((_a = extension === 'tex' ? parser.options : parser.options[extension]) === null || _a === void 0 ? void 0 : _a.hasOwnProperty(option))) {
        if (extension === 'tex') {
          throw new TexError_js_1.default('InvalidTexOption', 'Invalid TeX option "%1"', option);
        } else {
          throw new TexError_js_1.default('InvalidOptionKey', 'Invalid option "%1" for package "%2"', option, extension);
        }
      }
      return true;
    },
    filterValue: function (_parser, _extension, _option, value) {
      return value;
    }
  };
  var setOptionsMap = new SymbolMap_js_1.CommandMap('setoptions', {
    setOptions: 'SetOptions'
  }, {
    SetOptions: function (parser, name) {
      var e_1, _a;
      var extension = parser.GetBrackets(name) || 'tex';
      var options = ParseUtil_js_1.default.keyvalOptions(parser.GetArgument(name));
      var config = parser.options.setoptions;
      if (!config.filterPackage(parser, extension)) return;
      try {
        for (var _b = __values(Object.keys(options)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key = _c.value;
          if (config.filterOption(parser, extension, key)) {
            (extension === 'tex' ? parser.options : parser.options[extension])[key] = config.filterValue(parser, extension, key, options[key]);
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
    }
  });
  function setoptionsConfig(_config, jax) {
    var require = jax.parseOptions.handlers.get('macro').lookup('require');
    if (require) {
      setOptionsMap.add('Require', new Symbol_js_1.Macro('Require', require._func));
      setOptionsMap.add('require', new Symbol_js_1.Macro('require', BaseMethods_js_1.default.Macro, ['\\Require{#2}\\setOptions[#2]{#1}', 2, '']));
    }
  }
  exports.SetOptionsConfiguration = Configuration_js_1.Configuration.create('setoptions', {
    handler: {
      macro: ['setoptions']
    },
    config: setoptionsConfig,
    priority: 3,
    options: {
      setoptions: {
        filterPackage: exports.SetOptionsUtil.filterPackage,
        filterOption: exports.SetOptionsUtil.filterOption,
        filterValue: exports.SetOptionsUtil.filterValue,
        allowPackageDefault: true,
        allowOptionsDefault: true,
        allowOptions: (0, Options_js_1.expandable)({
          tex: {
            FindTeX: false,
            formatError: false,
            package: false,
            baseURL: false,
            tags: false,
            maxBuffer: false,
            maxMaxros: false,
            macros: false,
            environments: false
          },
          setoptions: false,
          autoload: false,
          require: false,
          configmacros: false,
          tagformat: false
        })
      }
    }
  });
})(SetOptionsConfiguration);
getDefaultExportFromCjs(SetOptionsConfiguration);

var TagFormatConfiguration = {};

var __extends$3 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(TagFormatConfiguration, "__esModule", {
  value: true
});
TagFormatConfiguration.TagFormatConfiguration = TagFormatConfiguration.tagformatConfig = void 0;
var Configuration_js_1$3 = Configuration;
var Tags_js_1$1 = Tags;
var tagID = 0;
function tagformatConfig(config, jax) {
  var tags = jax.parseOptions.options.tags;
  if (tags !== 'base' && config.tags.hasOwnProperty(tags)) {
    Tags_js_1$1.TagsFactory.add(tags, config.tags[tags]);
  }
  var TagClass = Tags_js_1$1.TagsFactory.create(jax.parseOptions.options.tags).constructor;
  var TagFormat = (function (_super) {
    __extends$3(TagFormat, _super);
    function TagFormat() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    TagFormat.prototype.formatNumber = function (n) {
      return jax.parseOptions.options.tagformat.number(n);
    };
    TagFormat.prototype.formatTag = function (tag) {
      return jax.parseOptions.options.tagformat.tag(tag);
    };
    TagFormat.prototype.formatId = function (id) {
      return jax.parseOptions.options.tagformat.id(id);
    };
    TagFormat.prototype.formatUrl = function (id, base) {
      return jax.parseOptions.options.tagformat.url(id, base);
    };
    return TagFormat;
  })(TagClass);
  tagID++;
  var tagName = 'configTags-' + tagID;
  Tags_js_1$1.TagsFactory.add(tagName, TagFormat);
  jax.parseOptions.options.tags = tagName;
}
TagFormatConfiguration.tagformatConfig = tagformatConfig;
TagFormatConfiguration.TagFormatConfiguration = Configuration_js_1$3.Configuration.create('tagformat', {
  config: [tagformatConfig, 10],
  options: {
    tagformat: {
      number: function (n) {
        return n.toString();
      },
      tag: function (tag) {
        return '(' + tag + ')';
      },
      id: function (id) {
        return 'mjx-eqn:' + id.replace(/\s/g, '_');
      },
      url: function (id, base) {
        return base + '#' + encodeURIComponent(id);
      }
    }
  }
});

var TextcompConfiguration = {};

var TextcompMappings = {};

var TextMacrosMethods = {};

var __importDefault$4 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(TextMacrosMethods, "__esModule", {
  value: true
});
TextMacrosMethods.TextMacrosMethods = void 0;
var TexParser_js_1$1 = __importDefault$4(TexParser$1);
var Retries_js_1 = Retries;
var BaseMethods_js_1 = __importDefault$4(BaseMethods$1);
TextMacrosMethods.TextMacrosMethods = {
  Comment: function (parser, _c) {
    while (parser.i < parser.string.length && parser.string.charAt(parser.i) !== '\n') {
      parser.i++;
    }
    parser.i++;
  },
  Math: function (parser, open) {
    parser.saveText();
    var i = parser.i;
    var j, c;
    var braces = 0;
    while (c = parser.GetNext()) {
      j = parser.i++;
      switch (c) {
        case '\\':
          var cs = parser.GetCS();
          if (cs === ')') c = '\\(';
        case '$':
          if (braces === 0 && open === c) {
            var config = parser.texParser.configuration;
            var mml = new TexParser_js_1$1.default(parser.string.substr(i, j - i), parser.stack.env, config).mml();
            parser.PushMath(mml);
            return;
          }
          break;
        case '{':
          braces++;
          break;
        case '}':
          if (braces === 0) {
            parser.Error('ExtraCloseMissingOpen', 'Extra close brace or missing open brace');
          }
          braces--;
          break;
      }
    }
    parser.Error('MathNotTerminated', 'Math-mode is not properly terminated');
  },
  MathModeOnly: function (parser, c) {
    parser.Error('MathModeOnly', '\'%1\' allowed only in math mode', c);
  },
  Misplaced: function (parser, c) {
    parser.Error('Misplaced', '\'%1\' can not be used here', c);
  },
  OpenBrace: function (parser, _c) {
    var env = parser.stack.env;
    parser.envStack.push(env);
    parser.stack.env = Object.assign({}, env);
  },
  CloseBrace: function (parser, _c) {
    if (parser.envStack.length) {
      parser.saveText();
      parser.stack.env = parser.envStack.pop();
    } else {
      parser.Error('ExtraCloseMissingOpen', 'Extra close brace or missing open brace');
    }
  },
  OpenQuote: function (parser, c) {
    if (parser.string.charAt(parser.i) === c) {
      parser.text += '\u201C';
      parser.i++;
    } else {
      parser.text += '\u2018';
    }
  },
  CloseQuote: function (parser, c) {
    if (parser.string.charAt(parser.i) === c) {
      parser.text += '\u201D';
      parser.i++;
    } else {
      parser.text += '\u2019';
    }
  },
  Tilde: function (parser, _c) {
    parser.text += '\u00A0';
  },
  Space: function (parser, _c) {
    parser.text += ' ';
    while (parser.GetNext().match(/\s/)) parser.i++;
  },
  SelfQuote: function (parser, name) {
    parser.text += name.substr(1);
  },
  Insert: function (parser, _name, c) {
    parser.text += c;
  },
  Accent: function (parser, name, c) {
    var base = parser.ParseArg(name);
    var accent = parser.create('token', 'mo', {}, c);
    parser.addAttributes(accent);
    parser.Push(parser.create('node', 'mover', [base, accent]));
  },
  Emph: function (parser, name) {
    var variant = parser.stack.env.mathvariant === '-tex-mathit' ? 'normal' : '-tex-mathit';
    parser.Push(parser.ParseTextArg(name, {
      mathvariant: variant
    }));
  },
  SetFont: function (parser, _name, variant) {
    parser.saveText();
    parser.stack.env.mathvariant = variant;
  },
  SetSize: function (parser, _name, size) {
    parser.saveText();
    parser.stack.env.mathsize = size;
  },
  CheckAutoload: function (parser, name) {
    var autoload = parser.configuration.packageData.get('autoload');
    var texParser = parser.texParser;
    name = name.slice(1);
    var macro = texParser.lookup('macro', name);
    if (!macro || autoload && macro._func === autoload.Autoload) {
      texParser.parse('macro', [texParser, name]);
      if (!macro) return;
      (0, Retries_js_1.retryAfter)(Promise.resolve());
    }
    texParser.parse('macro', [parser, name]);
  },
  Macro: BaseMethods_js_1.default.Macro,
  Spacer: BaseMethods_js_1.default.Spacer,
  Hskip: BaseMethods_js_1.default.Hskip,
  rule: BaseMethods_js_1.default.rule,
  Rule: BaseMethods_js_1.default.Rule,
  HandleRef: BaseMethods_js_1.default.HandleRef
};

var TextParser$1 = {};

var __extends$2 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
var __values$1 = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read$1 = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray$1 = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
var __importDefault$3 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(TextParser$1, "__esModule", {
  value: true
});
TextParser$1.TextParser = void 0;
var TexParser_js_1 = __importDefault$3(TexParser$1);
var TexError_js_1 = __importDefault$3(TexError$1);
var ParseUtil_js_1$1 = __importDefault$3(ParseUtil$1);
var MmlNode_js_1 = MmlNode;
var NodeUtil_js_1 = __importDefault$3(NodeUtil$1);
var BaseItems_js_1$1 = BaseItems;
var TextParser = (function (_super) {
  __extends$2(TextParser, _super);
  function TextParser(text, env, configuration, level) {
    var _this = _super.call(this, text, env, configuration) || this;
    _this.level = level;
    return _this;
  }
  Object.defineProperty(TextParser.prototype, "texParser", {
    get: function () {
      return this.configuration.packageData.get('textmacros').texParser;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(TextParser.prototype, "tags", {
    get: function () {
      return this.texParser.tags;
    },
    enumerable: false,
    configurable: true
  });
  TextParser.prototype.mml = function () {
    return this.level != null ? this.create('node', 'mstyle', this.nodes, {
      displaystyle: false,
      scriptlevel: this.level
    }) : this.nodes.length === 1 ? this.nodes[0] : this.create('node', 'mrow', this.nodes);
  };
  TextParser.prototype.Parse = function () {
    this.text = '';
    this.nodes = [];
    this.envStack = [];
    _super.prototype.Parse.call(this);
  };
  TextParser.prototype.saveText = function () {
    if (this.text) {
      var mathvariant = this.stack.env.mathvariant;
      var text = ParseUtil_js_1$1.default.internalText(this, this.text, mathvariant ? {
        mathvariant: mathvariant
      } : {});
      this.text = '';
      this.Push(text);
    }
  };
  TextParser.prototype.Push = function (mml) {
    if (this.text) {
      this.saveText();
    }
    if (mml instanceof BaseItems_js_1$1.StopItem) {
      return _super.prototype.Push.call(this, mml);
    }
    if (mml instanceof BaseItems_js_1$1.StyleItem) {
      this.stack.env.mathcolor = this.stack.env.color;
      return;
    }
    if (mml instanceof MmlNode_js_1.AbstractMmlNode) {
      this.addAttributes(mml);
      this.nodes.push(mml);
    }
  };
  TextParser.prototype.PushMath = function (mml) {
    var e_1, _a;
    var env = this.stack.env;
    if (!mml.isKind('TeXAtom')) {
      mml = this.create('node', 'TeXAtom', [mml]);
    }
    try {
      for (var _b = __values$1(['mathsize', 'mathcolor']), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_1 = _c.value;
        if (env[name_1] && !mml.attributes.getExplicit(name_1)) {
          if (!mml.isToken && !mml.isKind('mstyle')) {
            mml = this.create('node', 'mstyle', [mml]);
          }
          NodeUtil_js_1.default.setAttribute(mml, name_1, env[name_1]);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
    if (mml.isInferred) {
      mml = this.create('node', 'mrow', mml.childNodes);
    }
    this.nodes.push(mml);
  };
  TextParser.prototype.addAttributes = function (mml) {
    var e_2, _a;
    var env = this.stack.env;
    if (!mml.isToken) return;
    try {
      for (var _b = __values$1(['mathsize', 'mathcolor', 'mathvariant']), _c = _b.next(); !_c.done; _c = _b.next()) {
        var name_2 = _c.value;
        if (env[name_2] && !mml.attributes.getExplicit(name_2)) {
          NodeUtil_js_1.default.setAttribute(mml, name_2, env[name_2]);
        }
      }
    } catch (e_2_1) {
      e_2 = {
        error: e_2_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_2) throw e_2.error;
      }
    }
  };
  TextParser.prototype.ParseTextArg = function (name, env) {
    var text = this.GetArgument(name);
    env = Object.assign(Object.assign({}, this.stack.env), env);
    return new TextParser(text, env, this.configuration).mml();
  };
  TextParser.prototype.ParseArg = function (name) {
    return new TextParser(this.GetArgument(name), this.stack.env, this.configuration).mml();
  };
  TextParser.prototype.Error = function (id, message) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
      args[_i - 2] = arguments[_i];
    }
    throw new (TexError_js_1.default.bind.apply(TexError_js_1.default, __spreadArray$1([void 0, id, message], __read$1(args), false)))();
  };
  return TextParser;
})(TexParser_js_1.default);
TextParser$1.TextParser = TextParser;

var __importDefault$2 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(TextcompMappings, "__esModule", {
  value: true
});
var SymbolMap_js_1$2 = SymbolMap;
var TexConstants_js_1$2 = TexConstants;
var TextMacrosMethods_js_1$2 = TextMacrosMethods;
var ParseUtil_js_1 = __importDefault$2(ParseUtil$1);
var TextParser_js_1$1 = TextParser$1;
new SymbolMap_js_1$2.CommandMap('textcomp-macros', {
  'textasciicircum': ['Insert', '\u005E'],
  'textasciitilde': ['Insert', '\u007E'],
  'textasteriskcentered': ['Insert', '\u002A'],
  'textbackslash': ['Insert', '\u005C'],
  'textbar': ['Insert', '\u007C'],
  'textbraceleft': ['Insert', '\u007B'],
  'textbraceright': ['Insert', '\u007D'],
  'textbullet': ['Insert', '\u2022'],
  'textdagger': ['Insert', '\u2020'],
  'textdaggerdbl': ['Insert', '\u2021'],
  'textellipsis': ['Insert', '\u2026'],
  'textemdash': ['Insert', '\u2014'],
  'textendash': ['Insert', '\u2013'],
  'textexclamdown': ['Insert', '\u00A1'],
  'textgreater': ['Insert', '\u003E'],
  'textless': ['Insert', '\u003C'],
  'textordfeminine': ['Insert', '\u00AA'],
  'textordmasculine': ['Insert', '\u00BA'],
  'textparagraph': ['Insert', '\u00B6'],
  'textperiodcentered': ['Insert', '\u00B7'],
  'textquestiondown': ['Insert', '\u00BF'],
  'textquotedblleft': ['Insert', '\u201C'],
  'textquotedblright': ['Insert', '\u201D'],
  'textquoteleft': ['Insert', '\u2018'],
  'textquoteright': ['Insert', '\u2019'],
  'textsection': ['Insert', '\u00A7'],
  'textunderscore': ['Insert', '\u005F'],
  'textvisiblespace': ['Insert', '\u2423'],
  'textacutedbl': ['Insert', '\u02DD'],
  'textasciiacute': ['Insert', '\u00B4'],
  'textasciibreve': ['Insert', '\u02D8'],
  'textasciicaron': ['Insert', '\u02C7'],
  'textasciidieresis': ['Insert', '\u00A8'],
  'textasciimacron': ['Insert', '\u00AF'],
  'textgravedbl': ['Insert', '\u02F5'],
  'texttildelow': ['Insert', '\u02F7'],
  'textbaht': ['Insert', '\u0E3F'],
  'textcent': ['Insert', '\u00A2'],
  'textcolonmonetary': ['Insert', '\u20A1'],
  'textcurrency': ['Insert', '\u00A4'],
  'textdollar': ['Insert', '\u0024'],
  'textdong': ['Insert', '\u20AB'],
  'texteuro': ['Insert', '\u20AC'],
  'textflorin': ['Insert', '\u0192'],
  'textguarani': ['Insert', '\u20B2'],
  'textlira': ['Insert', '\u20A4'],
  'textnaira': ['Insert', '\u20A6'],
  'textpeso': ['Insert', '\u20B1'],
  'textsterling': ['Insert', '\u00A3'],
  'textwon': ['Insert', '\u20A9'],
  'textyen': ['Insert', '\u00A5'],
  'textcircledP': ['Insert', '\u2117'],
  'textcompwordmark': ['Insert', '\u200C'],
  'textcopyleft': ['Insert', "\uD83C\uDD2F"],
  'textcopyright': ['Insert', '\u00A9'],
  'textregistered': ['Insert', '\u00AE'],
  'textservicemark': ['Insert', '\u2120'],
  'texttrademark': ['Insert', '\u2122'],
  'textbardbl': ['Insert', '\u2016'],
  'textbigcircle': ['Insert', '\u25EF'],
  'textblank': ['Insert', '\u2422'],
  'textbrokenbar': ['Insert', '\u00A6'],
  'textdiscount': ['Insert', '\u2052'],
  'textestimated': ['Insert', '\u212E'],
  'textinterrobang': ['Insert', '\u203D'],
  'textinterrobangdown': ['Insert', '\u2E18'],
  'textmusicalnote': ['Insert', '\u266A'],
  'textnumero': ['Insert', '\u2116'],
  'textopenbullet': ['Insert', '\u25E6'],
  'textpertenthousand': ['Insert', '\u2031'],
  'textperthousand': ['Insert', '\u2030'],
  'textrecipe': ['Insert', '\u211E'],
  'textreferencemark': ['Insert', '\u203B'],
  'textlangle': ['Insert', '\u2329'],
  'textrangle': ['Insert', '\u232A'],
  'textlbrackdbl': ['Insert', '\u27E6'],
  'textrbrackdbl': ['Insert', '\u27E7'],
  'textlquill': ['Insert', '\u2045'],
  'textrquill': ['Insert', '\u2046'],
  'textcelsius': ['Insert', '\u2103'],
  'textdegree': ['Insert', '\u00B0'],
  'textdiv': ['Insert', '\u00F7'],
  'textdownarrow': ['Insert', '\u2193'],
  'textfractionsolidus': ['Insert', '\u2044'],
  'textleftarrow': ['Insert', '\u2190'],
  'textlnot': ['Insert', '\u00AC'],
  'textmho': ['Insert', '\u2127'],
  'textminus': ['Insert', '\u2212'],
  'textmu': ['Insert', '\u00B5'],
  'textohm': ['Insert', '\u2126'],
  'textonehalf': ['Insert', '\u00BD'],
  'textonequarter': ['Insert', '\u00BC'],
  'textonesuperior': ['Insert', '\u00B9'],
  'textpm': ['Insert', '\u00B1'],
  'textrightarrow': ['Insert', '\u2192'],
  'textsurd': ['Insert', '\u221A'],
  'textthreequarters': ['Insert', '\u00BE'],
  'textthreesuperior': ['Insert', '\u00B3'],
  'texttimes': ['Insert', '\u00D7'],
  'texttwosuperior': ['Insert', '\u00B2'],
  'textuparrow': ['Insert', '\u2191'],
  'textborn': ['Insert', '\u002A'],
  'textdied': ['Insert', '\u2020'],
  'textdivorced': ['Insert', '\u26AE'],
  'textmarried': ['Insert', '\u26AD'],
  'textcentoldstyle': ['Insert', '\u00A2', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textdollaroldstyle': ['Insert', '\u0024', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textzerooldstyle': ['Insert', '0', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textoneoldstyle': ['Insert', '1', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'texttwooldstyle': ['Insert', '2', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textthreeoldstyle': ['Insert', '3', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textfouroldstyle': ['Insert', '4', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textfiveoldstyle': ['Insert', '5', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textsixoldstyle': ['Insert', '6', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textsevenoldstyle': ['Insert', '7', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'texteightoldstyle': ['Insert', '8', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE],
  'textnineoldstyle': ['Insert', '9', TexConstants_js_1$2.TexConstant.Variant.OLDSTYLE]
}, {
  Insert: function (parser, name, c, font) {
    if (parser instanceof TextParser_js_1$1.TextParser) {
      if (!font) {
        TextMacrosMethods_js_1$2.TextMacrosMethods.Insert(parser, name, c);
        return;
      }
      parser.saveText();
    }
    parser.Push(ParseUtil_js_1.default.internalText(parser, c, font ? {
      mathvariant: font
    } : {}));
  }
});

Object.defineProperty(TextcompConfiguration, "__esModule", {
  value: true
});
TextcompConfiguration.TextcompConfiguration = void 0;
var Configuration_js_1$2 = Configuration;
TextcompConfiguration.TextcompConfiguration = Configuration_js_1$2.Configuration.create('textcomp', {
  handler: {
    macro: ['textcomp-macros']
  }
});

var TextMacrosConfiguration = {};

var TextMacrosMappings = {};

Object.defineProperty(TextMacrosMappings, "__esModule", {
  value: true
});
var SymbolMap_js_1$1 = SymbolMap;
var TexConstants_js_1$1 = TexConstants;
var TextMacrosMethods_js_1$1 = TextMacrosMethods;
var lengths_js_1 = lengths;
new SymbolMap_js_1$1.MacroMap('text-special', {
  '$': 'Math',
  '%': 'Comment',
  '^': 'MathModeOnly',
  '_': 'MathModeOnly',
  '&': 'Misplaced',
  '#': 'Misplaced',
  '~': 'Tilde',
  ' ': 'Space',
  '\t': 'Space',
  '\r': 'Space',
  '\n': 'Space',
  '\u00A0': 'Tilde',
  '{': 'OpenBrace',
  '}': 'CloseBrace',
  '`': 'OpenQuote',
  '\'': 'CloseQuote'
}, TextMacrosMethods_js_1$1.TextMacrosMethods);
new SymbolMap_js_1$1.CommandMap('text-macros', {
  '(': 'Math',
  '$': 'SelfQuote',
  '_': 'SelfQuote',
  '%': 'SelfQuote',
  '{': 'SelfQuote',
  '}': 'SelfQuote',
  ' ': 'SelfQuote',
  '&': 'SelfQuote',
  '#': 'SelfQuote',
  '\\': 'SelfQuote',
  '\'': ['Accent', '\u00B4'],
  '\u2019': ['Accent', '\u00B4'],
  '`': ['Accent', '\u0060'],
  '\u2018': ['Accent', '\u0060'],
  '^': ['Accent', '^'],
  '\"': ['Accent', '\u00A8'],
  '~': ['Accent', '~'],
  '=': ['Accent', '\u00AF'],
  '.': ['Accent', '\u02D9'],
  'u': ['Accent', '\u02D8'],
  'v': ['Accent', '\u02C7'],
  emph: 'Emph',
  rm: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.NORMAL],
  mit: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.ITALIC],
  oldstyle: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.OLDSTYLE],
  cal: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.CALLIGRAPHIC],
  it: ['SetFont', '-tex-mathit'],
  bf: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.BOLD],
  bbFont: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.DOUBLESTRUCK],
  scr: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.SCRIPT],
  frak: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.FRAKTUR],
  sf: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.SANSSERIF],
  tt: ['SetFont', TexConstants_js_1$1.TexConstant.Variant.MONOSPACE],
  tiny: ['SetSize', 0.5],
  Tiny: ['SetSize', 0.6],
  scriptsize: ['SetSize', 0.7],
  small: ['SetSize', 0.85],
  normalsize: ['SetSize', 1.0],
  large: ['SetSize', 1.2],
  Large: ['SetSize', 1.44],
  LARGE: ['SetSize', 1.73],
  huge: ['SetSize', 2.07],
  Huge: ['SetSize', 2.49],
  Bbb: ['Macro', '{\\bbFont #1}', 1],
  textnormal: ['Macro', '{\\rm #1}', 1],
  textup: ['Macro', '{\\rm #1}', 1],
  textrm: ['Macro', '{\\rm #1}', 1],
  textit: ['Macro', '{\\it #1}', 1],
  textbf: ['Macro', '{\\bf #1}', 1],
  textsf: ['Macro', '{\\sf #1}', 1],
  texttt: ['Macro', '{\\tt #1}', 1],
  dagger: ['Insert', '\u2020'],
  ddagger: ['Insert', '\u2021'],
  S: ['Insert', '\u00A7'],
  ',': ['Spacer', lengths_js_1.MATHSPACE.thinmathspace],
  ':': ['Spacer', lengths_js_1.MATHSPACE.mediummathspace],
  '>': ['Spacer', lengths_js_1.MATHSPACE.mediummathspace],
  ';': ['Spacer', lengths_js_1.MATHSPACE.thickmathspace],
  '!': ['Spacer', lengths_js_1.MATHSPACE.negativethinmathspace],
  enspace: ['Spacer', .5],
  quad: ['Spacer', 1],
  qquad: ['Spacer', 2],
  thinspace: ['Spacer', lengths_js_1.MATHSPACE.thinmathspace],
  negthinspace: ['Spacer', lengths_js_1.MATHSPACE.negativethinmathspace],
  hskip: 'Hskip',
  hspace: 'Hskip',
  kern: 'Hskip',
  mskip: 'Hskip',
  mspace: 'Hskip',
  mkern: 'Hskip',
  rule: 'rule',
  Rule: ['Rule'],
  Space: ['Rule', 'blank'],
  color: 'CheckAutoload',
  textcolor: 'CheckAutoload',
  colorbox: 'CheckAutoload',
  fcolorbox: 'CheckAutoload',
  href: 'CheckAutoload',
  style: 'CheckAutoload',
  class: 'CheckAutoload',
  cssId: 'CheckAutoload',
  unicode: 'CheckAutoload',
  ref: ['HandleRef', false],
  eqref: ['HandleRef', true]
}, TextMacrosMethods_js_1$1.TextMacrosMethods);

var __importDefault$1 = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
var _a;
Object.defineProperty(TextMacrosConfiguration, "__esModule", {
  value: true
});
TextMacrosConfiguration.TextMacrosConfiguration = TextMacrosConfiguration.TextBaseConfiguration = void 0;
var Configuration_js_1$1 = Configuration;
var ParseOptions_js_1 = __importDefault$1(ParseOptions$1);
var Tags_js_1 = Tags;
var BaseItems_js_1 = BaseItems;
var TextParser_js_1 = TextParser$1;
var TextMacrosMethods_js_1 = TextMacrosMethods;
TextMacrosConfiguration.TextBaseConfiguration = Configuration_js_1$1.Configuration.create('text-base', {
  parser: 'text',
  handler: {
    character: ['command', 'text-special'],
    macro: ['text-macros']
  },
  fallback: {
    character: function (parser, c) {
      parser.text += c;
    },
    macro: function (parser, name) {
      var texParser = parser.texParser;
      var macro = texParser.lookup('macro', name);
      if (macro && macro._func !== TextMacrosMethods_js_1.TextMacrosMethods.Macro) {
        parser.Error('MathMacro', '%1 is only supported in math mode', '\\' + name);
      }
      texParser.parse('macro', [parser, name]);
    }
  },
  items: (_a = {}, _a[BaseItems_js_1.StartItem.prototype.kind] = BaseItems_js_1.StartItem, _a[BaseItems_js_1.StopItem.prototype.kind] = BaseItems_js_1.StopItem, _a[BaseItems_js_1.MmlItem.prototype.kind] = BaseItems_js_1.MmlItem, _a[BaseItems_js_1.StyleItem.prototype.kind] = BaseItems_js_1.StyleItem, _a)
});
function internalMath(parser, text, level, mathvariant) {
  var config = parser.configuration.packageData.get('textmacros');
  if (!(parser instanceof TextParser_js_1.TextParser)) {
    config.texParser = parser;
  }
  return [new TextParser_js_1.TextParser(text, mathvariant ? {
    mathvariant: mathvariant
  } : {}, config.parseOptions, level).mml()];
}
TextMacrosConfiguration.TextMacrosConfiguration = Configuration_js_1$1.Configuration.create('textmacros', {
  config: function (_config, jax) {
    var textConf = new Configuration_js_1$1.ParserConfiguration(jax.parseOptions.options.textmacros.packages, ['tex', 'text']);
    textConf.init();
    var parseOptions = new ParseOptions_js_1.default(textConf, []);
    parseOptions.options = jax.parseOptions.options;
    textConf.config(jax);
    Tags_js_1.TagsFactory.addTags(textConf.tags);
    parseOptions.tags = Tags_js_1.TagsFactory.getDefault();
    parseOptions.tags.configuration = parseOptions;
    parseOptions.packageData = jax.parseOptions.packageData;
    parseOptions.packageData.set('textmacros', {
      parseOptions: parseOptions,
      jax: jax,
      texParser: null
    });
    parseOptions.options.internalMath = internalMath;
  },
  preprocessors: [function (data) {
    var config = data.data.packageData.get('textmacros');
    config.parseOptions.nodeFactory.setMmlFactory(config.jax.mmlFactory);
  }],
  options: {
    textmacros: {
      packages: ['text-base']
    }
  }
});

var UpgreekConfiguration = {};

Object.defineProperty(UpgreekConfiguration, "__esModule", {
  value: true
});
UpgreekConfiguration.UpgreekConfiguration = void 0;
var Configuration_js_1 = Configuration;
var SymbolMap_js_1 = SymbolMap;
var TexConstants_js_1 = TexConstants;
function mathchar0miNormal(parser, mchar) {
  var def = mchar.attributes || ({});
  def.mathvariant = TexConstants_js_1.TexConstant.Variant.NORMAL;
  var node = parser.create('token', 'mi', def, mchar.char);
  parser.Push(node);
}
new SymbolMap_js_1.CharacterMap('upgreek', mathchar0miNormal, {
  upalpha: '\u03B1',
  upbeta: '\u03B2',
  upgamma: '\u03B3',
  updelta: '\u03B4',
  upepsilon: '\u03F5',
  upzeta: '\u03B6',
  upeta: '\u03B7',
  uptheta: '\u03B8',
  upiota: '\u03B9',
  upkappa: '\u03BA',
  uplambda: '\u03BB',
  upmu: '\u03BC',
  upnu: '\u03BD',
  upxi: '\u03BE',
  upomicron: '\u03BF',
  uppi: '\u03C0',
  uprho: '\u03C1',
  upsigma: '\u03C3',
  uptau: '\u03C4',
  upupsilon: '\u03C5',
  upphi: '\u03D5',
  upchi: '\u03C7',
  uppsi: '\u03C8',
  upomega: '\u03C9',
  upvarepsilon: '\u03B5',
  upvartheta: '\u03D1',
  upvarpi: '\u03D6',
  upvarrho: '\u03F1',
  upvarsigma: '\u03C2',
  upvarphi: '\u03C6',
  Upgamma: '\u0393',
  Updelta: '\u0394',
  Uptheta: '\u0398',
  Uplambda: '\u039B',
  Upxi: '\u039E',
  Uppi: '\u03A0',
  Upsigma: '\u03A3',
  Upupsilon: '\u03A5',
  Upphi: '\u03A6',
  Uppsi: '\u03A8',
  Upomega: '\u03A9'
});
UpgreekConfiguration.UpgreekConfiguration = Configuration_js_1.Configuration.create('upgreek', {
  handler: {
    macro: ['upgreek']
  }
});

var UnicodeConfiguration = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.UnicodeConfiguration = exports.UnicodeMethods = void 0;
  var Configuration_js_1 = Configuration;
  var TexError_js_1 = __importDefault(TexError$1);
  var SymbolMap_js_1 = SymbolMap;
  var ParseUtil_js_1 = __importDefault(ParseUtil$1);
  var NodeUtil_js_1 = __importDefault(NodeUtil$1);
  var Entities_js_1 = Entities$1;
  exports.UnicodeMethods = {};
  var UnicodeCache = {};
  exports.UnicodeMethods.Unicode = function (parser, name) {
    var HD = parser.GetBrackets(name);
    var HDsplit = null;
    var font = null;
    if (HD) {
      if (HD.replace(/ /g, '').match(/^(\d+(\.\d*)?|\.\d+),(\d+(\.\d*)?|\.\d+)$/)) {
        HDsplit = HD.replace(/ /g, '').split(/,/);
        font = parser.GetBrackets(name);
      } else {
        font = HD;
      }
    }
    var n = ParseUtil_js_1.default.trimSpaces(parser.GetArgument(name)).replace(/^0x/, 'x');
    if (!n.match(/^(x[0-9A-Fa-f]+|[0-9]+)$/)) {
      throw new TexError_js_1.default('BadUnicode', 'Argument to \\unicode must be a number');
    }
    var N = parseInt(n.match(/^x/) ? '0' + n : n);
    if (!UnicodeCache[N]) {
      UnicodeCache[N] = [800, 200, font, N];
    } else if (!font) {
      font = UnicodeCache[N][2];
    }
    if (HDsplit) {
      UnicodeCache[N][0] = Math.floor(parseFloat(HDsplit[0]) * 1000);
      UnicodeCache[N][1] = Math.floor(parseFloat(HDsplit[1]) * 1000);
    }
    var variant = parser.stack.env.font;
    var def = {};
    if (font) {
      UnicodeCache[N][2] = def.fontfamily = font.replace(/'/g, '\'');
      if (variant) {
        if (variant.match(/bold/)) {
          def.fontweight = 'bold';
        }
        if (variant.match(/italic|-mathit/)) {
          def.fontstyle = 'italic';
        }
      }
    } else if (variant) {
      def.mathvariant = variant;
    }
    var node = parser.create('token', 'mtext', def, (0, Entities_js_1.numeric)(n));
    NodeUtil_js_1.default.setProperty(node, 'unicode', true);
    parser.Push(node);
  };
  new SymbolMap_js_1.CommandMap('unicode', {
    unicode: 'Unicode'
  }, exports.UnicodeMethods);
  exports.UnicodeConfiguration = Configuration_js_1.Configuration.create('unicode', {
    handler: {
      macro: ['unicode']
    }
  });
})(UnicodeConfiguration);
getDefaultExportFromCjs(UnicodeConfiguration);

var VerbConfiguration = {};

(function (exports) {
  var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
    return mod && mod.__esModule ? mod : {
      "default": mod
    };
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.VerbConfiguration = exports.VerbMethods = void 0;
  var Configuration_js_1 = Configuration;
  var TexConstants_js_1 = TexConstants;
  var SymbolMap_js_1 = SymbolMap;
  var TexError_js_1 = __importDefault(TexError$1);
  exports.VerbMethods = {};
  exports.VerbMethods.Verb = function (parser, name) {
    var c = parser.GetNext();
    var start = ++parser.i;
    if (c === '') {
      throw new TexError_js_1.default('MissingArgFor', 'Missing argument for %1', name);
    }
    while (parser.i < parser.string.length && parser.string.charAt(parser.i) !== c) {
      parser.i++;
    }
    if (parser.i === parser.string.length) {
      throw new TexError_js_1.default('NoClosingDelim', 'Can\'t find closing delimiter for %1', parser.currentCS);
    }
    var text = parser.string.slice(start, parser.i).replace(/ /g, '\u00A0');
    parser.i++;
    parser.Push(parser.create('token', 'mtext', {
      mathvariant: TexConstants_js_1.TexConstant.Variant.MONOSPACE
    }, text));
  };
  new SymbolMap_js_1.CommandMap('verb', {
    verb: 'Verb'
  }, exports.VerbMethods);
  exports.VerbConfiguration = Configuration_js_1.Configuration.create('verb', {
    handler: {
      macro: ['verb']
    }
  });
})(VerbConfiguration);
getDefaultExportFromCjs(VerbConfiguration);

Object.defineProperty(AllPackages, "__esModule", {
  value: true
});
var AllPackages_1 = AllPackages.AllPackages = void 0;
if (typeof MathJax !== 'undefined' && MathJax.loader) {
  MathJax.loader.preLoad('[tex]/action', '[tex]/ams', '[tex]/amscd', '[tex]/bbox', '[tex]/boldsymbol', '[tex]/braket', '[tex]/bussproofs', '[tex]/cancel', '[tex]/cases', '[tex]/centernot', '[tex]/color', '[tex]/colorv2', '[tex]/colortbl', '[tex]/empheq', '[tex]/enclose', '[tex]/extpfeil', '[tex]/gensymb', '[tex]/html', '[tex]/mathtools', '[tex]/mhchem', '[tex]/newcommand', '[tex]/noerrors', '[tex]/noundefined', '[tex]/physics', '[tex]/upgreek', '[tex]/unicode', '[tex]/verb', '[tex]/configmacros', '[tex]/tagformat', '[tex]/textcomp', '[tex]/textmacros', '[tex]/setoptions');
}
AllPackages_1 = AllPackages.AllPackages = ['base', 'action', 'ams', 'amscd', 'bbox', 'boldsymbol', 'braket', 'bussproofs', 'cancel', 'cases', 'centernot', 'color', 'colortbl', 'empheq', 'enclose', 'extpfeil', 'gensymb', 'html', 'mathtools', 'mhchem', 'newcommand', 'noerrors', 'noundefined', 'upgreek', 'unicode', 'verb', 'configmacros', 'tagformat', 'textcomp', 'textmacros'];

var name = "@pie-lib/math-rendering";
var version = "3.2.1";
var description = "math rendering utilities";
var publishConfig = {
	access: "public"
};
var main$1 = "lib/index.js";
var module = "src/index.js";
var author = "pie-framework developers";
var license = "ISC";
var dependencies = {
	debug: "^4.1.1",
	lodash: "^4.17.11",
	"mathjax-full": "3.2.2",
	"mathml-to-latex": "1.2.0"
};
var gitHead = "f3345ae70660f4ae88450512261c7ea1601003c8";
var scripts = {
};
var pkg = {
	name: name,
	version: version,
	description: description,
	publishConfig: publishConfig,
	main: main$1,
	module: module,
	author: author,
	license: license,
	dependencies: dependencies,
	gitHead: gitHead,
	scripts: scripts
};

var lodash = {
  exports: {}
};

(function (module, exports) {
  (function () {
    var undefined$1;
    var VERSION = '4.17.21';
    var LARGE_ARRAY_SIZE = 200;
    var CORE_ERROR_TEXT = 'Unsupported core-js use. Try https://npms.io/search?q=ponyfill.', FUNC_ERROR_TEXT = 'Expected a function', INVALID_TEMPL_VAR_ERROR_TEXT = 'Invalid `variable` option passed into `_.template`';
    var HASH_UNDEFINED = '__lodash_hash_undefined__';
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = '__lodash_placeholder__';
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = '...';
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, MAX_INTEGER = 1.7976931348623157e+308, NAN = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [['ary', WRAP_ARY_FLAG], ['bind', WRAP_BIND_FLAG], ['bindKey', WRAP_BIND_KEY_FLAG], ['curry', WRAP_CURRY_FLAG], ['curryRight', WRAP_CURRY_RIGHT_FLAG], ['flip', WRAP_FLIP_FLAG], ['partial', WRAP_PARTIAL_FLAG], ['partialRight', WRAP_PARTIAL_RIGHT_FLAG], ['rearg', WRAP_REARG_FLAG]];
    var argsTag = '[object Arguments]', arrayTag = '[object Array]', asyncTag = '[object AsyncFunction]', boolTag = '[object Boolean]', dateTag = '[object Date]', domExcTag = '[object DOMException]', errorTag = '[object Error]', funcTag = '[object Function]', genTag = '[object GeneratorFunction]', mapTag = '[object Map]', numberTag = '[object Number]', nullTag = '[object Null]', objectTag = '[object Object]', promiseTag = '[object Promise]', proxyTag = '[object Proxy]', regexpTag = '[object RegExp]', setTag = '[object Set]', stringTag = '[object String]', symbolTag = '[object Symbol]', undefinedTag = '[object Undefined]', weakMapTag = '[object WeakMap]', weakSetTag = '[object WeakSet]';
    var arrayBufferTag = '[object ArrayBuffer]', dataViewTag = '[object DataView]', float32Tag = '[object Float32Array]', float64Tag = '[object Float64Array]', int8Tag = '[object Int8Array]', int16Tag = '[object Int16Array]', int32Tag = '[object Int32Array]', uint8Tag = '[object Uint8Array]', uint8ClampedTag = '[object Uint8ClampedArray]', uint16Tag = '[object Uint16Array]', uint32Tag = '[object Uint32Array]';
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
    var reTrimStart = /^\s+/;
    var reWhitespace = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary = /^0b[01]+$/i;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var reIsOctal = /^0o[0-7]+$/i;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = '\\ud800-\\udfff', rsComboMarksRange = '\\u0300-\\u036f', reComboHalfMarksRange = '\\ufe20-\\ufe2f', rsComboSymbolsRange = '\\u20d0-\\u20ff', rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = '\\u2700-\\u27bf', rsLowerRange = 'a-z\\xdf-\\xf6\\xf8-\\xff', rsMathOpRange = '\\xac\\xb1\\xd7\\xf7', rsNonCharRange = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf', rsPunctuationRange = '\\u2000-\\u206f', rsSpaceRange = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000', rsUpperRange = 'A-Z\\xc0-\\xd6\\xd8-\\xde', rsVarRange = '\\ufe0e\\ufe0f', rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = '[' + rsAstralRange + ']', rsBreak = '[' + rsBreakRange + ']', rsCombo = '[' + rsComboRange + ']', rsDigits = '\\d+', rsDingbat = '[' + rsDingbatRange + ']', rsLower = '[' + rsLowerRange + ']', rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']', rsFitz = '\\ud83c[\\udffb-\\udfff]', rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')', rsNonAstral = '[^' + rsAstralRange + ']', rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}', rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]', rsUpper = '[' + rsUpperRange + ']', rsZWJ = '\\u200d';
    var rsMiscLower = '(?:' + rsLower + '|' + rsMisc + ')', rsMiscUpper = '(?:' + rsUpper + '|' + rsMisc + ')', rsOptContrLower = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?', rsOptContrUpper = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?', reOptMod = rsModifier + '?', rsOptVar = '[' + rsVarRange + ']?', rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*', rsOrdLower = '\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])', rsOrdUpper = '\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])', rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq, rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';
    var reApos = RegExp(rsApos, 'g');
    var reComboMark = RegExp(rsCombo, 'g');
    var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');
    var reUnicodeWord = RegExp([rsUpper + '?' + rsLower + '+' + rsOptContrLower + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')', rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak, rsUpper + rsMiscLower, '$'].join('|') + ')', rsUpper + '?' + rsMiscLower + '+' + rsOptContrLower, rsUpper + '+' + rsOptContrUpper, rsOrdUpper, rsOrdLower, rsDigits, rsEmoji].join('|'), 'g');
    var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + ']');
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = ['Array', 'Buffer', 'DataView', 'Date', 'Error', 'Float32Array', 'Float64Array', 'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Map', 'Math', 'Object', 'Promise', 'RegExp', 'Set', 'String', 'Symbol', 'TypeError', 'Uint8Array', 'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap', '_', 'clearTimeout', 'isFinite', 'parseInt', 'setTimeout'];
    var templateCounter = -1;
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    var deburredLetters = {
      '\xc0': 'A',
      '\xc1': 'A',
      '\xc2': 'A',
      '\xc3': 'A',
      '\xc4': 'A',
      '\xc5': 'A',
      '\xe0': 'a',
      '\xe1': 'a',
      '\xe2': 'a',
      '\xe3': 'a',
      '\xe4': 'a',
      '\xe5': 'a',
      '\xc7': 'C',
      '\xe7': 'c',
      '\xd0': 'D',
      '\xf0': 'd',
      '\xc8': 'E',
      '\xc9': 'E',
      '\xca': 'E',
      '\xcb': 'E',
      '\xe8': 'e',
      '\xe9': 'e',
      '\xea': 'e',
      '\xeb': 'e',
      '\xcc': 'I',
      '\xcd': 'I',
      '\xce': 'I',
      '\xcf': 'I',
      '\xec': 'i',
      '\xed': 'i',
      '\xee': 'i',
      '\xef': 'i',
      '\xd1': 'N',
      '\xf1': 'n',
      '\xd2': 'O',
      '\xd3': 'O',
      '\xd4': 'O',
      '\xd5': 'O',
      '\xd6': 'O',
      '\xd8': 'O',
      '\xf2': 'o',
      '\xf3': 'o',
      '\xf4': 'o',
      '\xf5': 'o',
      '\xf6': 'o',
      '\xf8': 'o',
      '\xd9': 'U',
      '\xda': 'U',
      '\xdb': 'U',
      '\xdc': 'U',
      '\xf9': 'u',
      '\xfa': 'u',
      '\xfb': 'u',
      '\xfc': 'u',
      '\xdd': 'Y',
      '\xfd': 'y',
      '\xff': 'y',
      '\xc6': 'Ae',
      '\xe6': 'ae',
      '\xde': 'Th',
      '\xfe': 'th',
      '\xdf': 'ss',
      '\u0100': 'A',
      '\u0102': 'A',
      '\u0104': 'A',
      '\u0101': 'a',
      '\u0103': 'a',
      '\u0105': 'a',
      '\u0106': 'C',
      '\u0108': 'C',
      '\u010a': 'C',
      '\u010c': 'C',
      '\u0107': 'c',
      '\u0109': 'c',
      '\u010b': 'c',
      '\u010d': 'c',
      '\u010e': 'D',
      '\u0110': 'D',
      '\u010f': 'd',
      '\u0111': 'd',
      '\u0112': 'E',
      '\u0114': 'E',
      '\u0116': 'E',
      '\u0118': 'E',
      '\u011a': 'E',
      '\u0113': 'e',
      '\u0115': 'e',
      '\u0117': 'e',
      '\u0119': 'e',
      '\u011b': 'e',
      '\u011c': 'G',
      '\u011e': 'G',
      '\u0120': 'G',
      '\u0122': 'G',
      '\u011d': 'g',
      '\u011f': 'g',
      '\u0121': 'g',
      '\u0123': 'g',
      '\u0124': 'H',
      '\u0126': 'H',
      '\u0125': 'h',
      '\u0127': 'h',
      '\u0128': 'I',
      '\u012a': 'I',
      '\u012c': 'I',
      '\u012e': 'I',
      '\u0130': 'I',
      '\u0129': 'i',
      '\u012b': 'i',
      '\u012d': 'i',
      '\u012f': 'i',
      '\u0131': 'i',
      '\u0134': 'J',
      '\u0135': 'j',
      '\u0136': 'K',
      '\u0137': 'k',
      '\u0138': 'k',
      '\u0139': 'L',
      '\u013b': 'L',
      '\u013d': 'L',
      '\u013f': 'L',
      '\u0141': 'L',
      '\u013a': 'l',
      '\u013c': 'l',
      '\u013e': 'l',
      '\u0140': 'l',
      '\u0142': 'l',
      '\u0143': 'N',
      '\u0145': 'N',
      '\u0147': 'N',
      '\u014a': 'N',
      '\u0144': 'n',
      '\u0146': 'n',
      '\u0148': 'n',
      '\u014b': 'n',
      '\u014c': 'O',
      '\u014e': 'O',
      '\u0150': 'O',
      '\u014d': 'o',
      '\u014f': 'o',
      '\u0151': 'o',
      '\u0154': 'R',
      '\u0156': 'R',
      '\u0158': 'R',
      '\u0155': 'r',
      '\u0157': 'r',
      '\u0159': 'r',
      '\u015a': 'S',
      '\u015c': 'S',
      '\u015e': 'S',
      '\u0160': 'S',
      '\u015b': 's',
      '\u015d': 's',
      '\u015f': 's',
      '\u0161': 's',
      '\u0162': 'T',
      '\u0164': 'T',
      '\u0166': 'T',
      '\u0163': 't',
      '\u0165': 't',
      '\u0167': 't',
      '\u0168': 'U',
      '\u016a': 'U',
      '\u016c': 'U',
      '\u016e': 'U',
      '\u0170': 'U',
      '\u0172': 'U',
      '\u0169': 'u',
      '\u016b': 'u',
      '\u016d': 'u',
      '\u016f': 'u',
      '\u0171': 'u',
      '\u0173': 'u',
      '\u0174': 'W',
      '\u0175': 'w',
      '\u0176': 'Y',
      '\u0177': 'y',
      '\u0178': 'Y',
      '\u0179': 'Z',
      '\u017b': 'Z',
      '\u017d': 'Z',
      '\u017a': 'z',
      '\u017c': 'z',
      '\u017e': 'z',
      '\u0132': 'IJ',
      '\u0133': 'ij',
      '\u0152': 'Oe',
      '\u0153': 'oe',
      '\u0149': "'n",
      '\u017f': 's'
    };
    var htmlEscapes = {
      '&': '&amp;',
      '<': '&lt;',
      '>': '&gt;',
      '"': '&quot;',
      "'": '&#39;'
    };
    var htmlUnescapes = {
      '&amp;': '&',
      '&lt;': '<',
      '&gt;': '>',
      '&quot;': '"',
      '&#39;': "'"
    };
    var stringEscapes = {
      '\\': '\\',
      "'": "'",
      '\n': 'n',
      '\r': 'r',
      '\u2028': 'u2028',
      '\u2029': 'u2029'
    };
    var freeParseFloat = parseFloat, freeParseInt = parseInt;
    var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf = typeof self == 'object' && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function('return this')();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = (function () {
      try {
        var types = freeModule && freeModule.require && freeModule.require('util').types;
        if (types) {
          return types;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding('util');
      } catch (e) {}
    })();
    var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array, setter, iteratee, accumulator) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        var value = array[index];
        setter(accumulator, value, iteratee(value), array);
      }
      return accumulator;
    }
    function arrayEach(array, iteratee) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (iteratee(array[index], index, array) === false) {
          break;
        }
      }
      return array;
    }
    function arrayEachRight(array, iteratee) {
      var length = array == null ? 0 : array.length;
      while (length--) {
        if (iteratee(array[length], length, array) === false) {
          break;
        }
      }
      return array;
    }
    function arrayEvery(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (!predicate(array[index], index, array)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array, value) {
      var length = array == null ? 0 : array.length;
      return !!length && baseIndexOf(array, value, 0) > -1;
    }
    function arrayIncludesWith(array, value, comparator) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (comparator(value, array[index])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array, iteratee) {
      var index = -1, length = array == null ? 0 : array.length, result = Array(length);
      while (++index < length) {
        result[index] = iteratee(array[index], index, array);
      }
      return result;
    }
    function arrayPush(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    function arrayReduce(array, iteratee, accumulator, initAccum) {
      var index = -1, length = array == null ? 0 : array.length;
      if (initAccum && length) {
        accumulator = array[++index];
      }
      while (++index < length) {
        accumulator = iteratee(accumulator, array[index], index, array);
      }
      return accumulator;
    }
    function arrayReduceRight(array, iteratee, accumulator, initAccum) {
      var length = array == null ? 0 : array.length;
      if (initAccum && length) {
        accumulator = array[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array[length], length, array);
      }
      return accumulator;
    }
    function arraySome(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty('length');
    function asciiToArray(string) {
      return string.split('');
    }
    function asciiWords(string) {
      return string.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function (value, key, collection) {
        if (predicate(value, key, collection)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array, predicate, fromIndex, fromRight) {
      var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index-- : ++index < length) {
        if (predicate(array[index], index, array)) {
          return index;
        }
      }
      return -1;
    }
    function baseIndexOf(array, value, fromIndex) {
      return value === value ? strictIndexOf(array, value, fromIndex) : baseFindIndex(array, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array, value, fromIndex, comparator) {
      var index = fromIndex - 1, length = array.length;
      while (++index < length) {
        if (comparator(array[index], value)) {
          return index;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array, iteratee) {
      var length = array == null ? 0 : array.length;
      return length ? baseSum(array, iteratee) / length : NAN;
    }
    function baseProperty(key) {
      return function (object) {
        return object == null ? undefined$1 : object[key];
      };
    }
    function basePropertyOf(object) {
      return function (key) {
        return object == null ? undefined$1 : object[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function (value, index, collection) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index, collection);
      });
      return accumulator;
    }
    function baseSortBy(array, comparer) {
      var length = array.length;
      array.sort(comparer);
      while (length--) {
        array[length] = array[length].value;
      }
      return array;
    }
    function baseSum(array, iteratee) {
      var result, index = -1, length = array.length;
      while (++index < length) {
        var current = iteratee(array[index]);
        if (current !== undefined$1) {
          result = result === undefined$1 ? current : result + current;
        }
      }
      return result;
    }
    function baseTimes(n, iteratee) {
      var index = -1, result = Array(n);
      while (++index < n) {
        result[index] = iteratee(index);
      }
      return result;
    }
    function baseToPairs(object, props) {
      return arrayMap(props, function (key) {
        return [key, object[key]];
      });
    }
    function baseTrim(string) {
      return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '') : string;
    }
    function baseUnary(func) {
      return function (value) {
        return func(value);
      };
    }
    function baseValues(object, props) {
      return arrayMap(props, function (key) {
        return object[key];
      });
    }
    function cacheHas(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index = -1, length = strSymbols.length;
      while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
      return index;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index = strSymbols.length;
      while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
      return index;
    }
    function countHolders(array, placeholder) {
      var length = array.length, result = 0;
      while (length--) {
        if (array[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return '\\' + stringEscapes[chr];
    }
    function getValue(object, key) {
      return object == null ? undefined$1 : object[key];
    }
    function hasUnicode(string) {
      return reHasUnicode.test(string);
    }
    function hasUnicodeWord(string) {
      return reHasUnicodeWord.test(string);
    }
    function iteratorToArray(iterator) {
      var data, result = [];
      while (!(data = iterator.next()).done) {
        result.push(data.value);
      }
      return result;
    }
    function mapToArray(map) {
      var index = -1, result = Array(map.size);
      map.forEach(function (value, key) {
        result[++index] = [key, value];
      });
      return result;
    }
    function overArg(func, transform) {
      return function (arg) {
        return func(transform(arg));
      };
    }
    function replaceHolders(array, placeholder) {
      var index = -1, length = array.length, resIndex = 0, result = [];
      while (++index < length) {
        var value = array[index];
        if (value === placeholder || value === PLACEHOLDER) {
          array[index] = PLACEHOLDER;
          result[resIndex++] = index;
        }
      }
      return result;
    }
    function setToArray(set) {
      var index = -1, result = Array(set.size);
      set.forEach(function (value) {
        result[++index] = value;
      });
      return result;
    }
    function setToPairs(set) {
      var index = -1, result = Array(set.size);
      set.forEach(function (value) {
        result[++index] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array, value, fromIndex) {
      var index = fromIndex - 1, length = array.length;
      while (++index < length) {
        if (array[index] === value) {
          return index;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array, value, fromIndex) {
      var index = fromIndex + 1;
      while (index--) {
        if (array[index] === value) {
          return index;
        }
      }
      return index;
    }
    function stringSize(string) {
      return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
    }
    function stringToArray(string) {
      return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
    }
    function trimmedEndIndex(string) {
      var index = string.length;
      while (index-- && reWhitespace.test(string.charAt(index))) {}
      return index;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string) {
      return string.match(reUnicode) || [];
    }
    function unicodeWords(string) {
      return string.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext(context) {
      context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));
      var Array = context.Array, Date = context.Date, Error = context.Error, Function = context.Function, Math = context.Math, Object = context.Object, RegExp = context.RegExp, String = context.String, TypeError = context.TypeError;
      var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype;
      var coreJsData = context['__core-js_shared__'];
      var funcToString = funcProto.toString;
      var hasOwnProperty = objectProto.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey = (function () {
        var uid = (/[^.]+$/).exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
        return uid ? 'Symbol(src)_1.' + uid : '';
      })();
      var nativeObjectToString = objectProto.toString;
      var objectCtorString = funcToString.call(Object);
      var oldDash = root._;
      var reIsNative = RegExp('^' + funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
      var Buffer = moduleExports ? context.Buffer : undefined$1, Symbol = context.Symbol, Uint8Array = context.Uint8Array, allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined$1, getPrototype = overArg(Object.getPrototypeOf, Object), objectCreate = Object.create, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined$1, symIterator = Symbol ? Symbol.iterator : undefined$1, symToStringTag = Symbol ? Symbol.toStringTag : undefined$1;
      var defineProperty = (function () {
        try {
          var func = getNative(Object, 'defineProperty');
          func({}, '', {});
          return func;
        } catch (e) {}
      })();
      var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout, ctxNow = Date && Date.now !== root.Date.now && Date.now, ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;
      var nativeCeil = Math.ceil, nativeFloor = Math.floor, nativeGetSymbols = Object.getOwnPropertySymbols, nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto.join, nativeKeys = overArg(Object.keys, Object), nativeMax = Math.max, nativeMin = Math.min, nativeNow = Date.now, nativeParseInt = context.parseInt, nativeRandom = Math.random, nativeReverse = arrayProto.reverse;
      var DataView = getNative(context, 'DataView'), Map = getNative(context, 'Map'), Promise = getNative(context, 'Promise'), Set = getNative(context, 'Set'), WeakMap = getNative(context, 'WeakMap'), nativeCreate = getNative(Object, 'create');
      var metaMap = WeakMap && new WeakMap();
      var realNames = {};
      var dataViewCtorString = toSource(DataView), mapCtorString = toSource(Map), promiseCtorString = toSource(Promise), setCtorString = toSource(Set), weakMapCtorString = toSource(WeakMap);
      var symbolProto = Symbol ? Symbol.prototype : undefined$1, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined$1, symbolToString = symbolProto ? symbolProto.toString : undefined$1;
      function lodash(value) {
        if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty.call(value, '__wrapped__')) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = (function () {
        function object() {}
        return function (proto) {
          if (!isObject(proto)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto);
          }
          object.prototype = proto;
          var result = new object();
          object.prototype = undefined$1;
          return result;
        };
      })();
      function baseLodash() {}
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash.templateSettings = {
        'escape': reEscape,
        'evaluate': reEvaluate,
        'interpolate': reInterpolate,
        'variable': '',
        'imports': {
          '_': lodash
        }
      };
      lodash.prototype = baseLodash.prototype;
      lodash.prototype.constructor = lodash;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result = new LazyWrapper(this.__wrapped__);
        result.__actions__ = copyArray(this.__actions__);
        result.__dir__ = this.__dir__;
        result.__filtered__ = this.__filtered__;
        result.__iteratees__ = copyArray(this.__iteratees__);
        result.__takeCount__ = this.__takeCount__;
        result.__views__ = copyArray(this.__views__);
        return result;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result = new LazyWrapper(this);
          result.__dir__ = -1;
          result.__filtered__ = true;
        } else {
          result = this.clone();
          result.__dir__ *= -1;
        }
        return result;
      }
      function lazyValue() {
        var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = getView(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : start - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array, this.__actions__);
        }
        var result = [];
        outer: while (length-- && resIndex < takeCount) {
          index += dir;
          var iterIndex = -1, value = array[index];
          while (++iterIndex < iterLength) {
            var data = iteratees[iterIndex], iteratee = data.iteratee, type = data.type, computed = iteratee(value);
            if (type == LAZY_MAP_FLAG) {
              value = computed;
            } else if (!computed) {
              if (type == LAZY_FILTER_FLAG) {
                continue outer;
              } else {
                break outer;
              }
            }
          }
          result[resIndex++] = value;
        }
        return result;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash(entries) {
        var index = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index < length) {
          var entry = entries[index];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear() {
        this.__data__ = nativeCreate ? nativeCreate(null) : {};
        this.size = 0;
      }
      function hashDelete(key) {
        var result = this.has(key) && delete this.__data__[key];
        this.size -= result ? 1 : 0;
        return result;
      }
      function hashGet(key) {
        var data = this.__data__;
        if (nativeCreate) {
          var result = data[key];
          return result === HASH_UNDEFINED ? undefined$1 : result;
        }
        return hasOwnProperty.call(data, key) ? data[key] : undefined$1;
      }
      function hashHas(key) {
        var data = this.__data__;
        return nativeCreate ? data[key] !== undefined$1 : hasOwnProperty.call(data, key);
      }
      function hashSet(key, value) {
        var data = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data[key] = nativeCreate && value === undefined$1 ? HASH_UNDEFINED : value;
        return this;
      }
      Hash.prototype.clear = hashClear;
      Hash.prototype['delete'] = hashDelete;
      Hash.prototype.get = hashGet;
      Hash.prototype.has = hashHas;
      Hash.prototype.set = hashSet;
      function ListCache(entries) {
        var index = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index < length) {
          var entry = entries[index];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete(key) {
        var data = this.__data__, index = assocIndexOf(data, key);
        if (index < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index == lastIndex) {
          data.pop();
        } else {
          splice.call(data, index, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet(key) {
        var data = this.__data__, index = assocIndexOf(data, key);
        return index < 0 ? undefined$1 : data[index][1];
      }
      function listCacheHas(key) {
        return assocIndexOf(this.__data__, key) > -1;
      }
      function listCacheSet(key, value) {
        var data = this.__data__, index = assocIndexOf(data, key);
        if (index < 0) {
          ++this.size;
          data.push([key, value]);
        } else {
          data[index][1] = value;
        }
        return this;
      }
      ListCache.prototype.clear = listCacheClear;
      ListCache.prototype['delete'] = listCacheDelete;
      ListCache.prototype.get = listCacheGet;
      ListCache.prototype.has = listCacheHas;
      ListCache.prototype.set = listCacheSet;
      function MapCache(entries) {
        var index = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index < length) {
          var entry = entries[index];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear() {
        this.size = 0;
        this.__data__ = {
          'hash': new Hash(),
          'map': new (Map || ListCache)(),
          'string': new Hash()
        };
      }
      function mapCacheDelete(key) {
        var result = getMapData(this, key)['delete'](key);
        this.size -= result ? 1 : 0;
        return result;
      }
      function mapCacheGet(key) {
        return getMapData(this, key).get(key);
      }
      function mapCacheHas(key) {
        return getMapData(this, key).has(key);
      }
      function mapCacheSet(key, value) {
        var data = getMapData(this, key), size = data.size;
        data.set(key, value);
        this.size += data.size == size ? 0 : 1;
        return this;
      }
      MapCache.prototype.clear = mapCacheClear;
      MapCache.prototype['delete'] = mapCacheDelete;
      MapCache.prototype.get = mapCacheGet;
      MapCache.prototype.has = mapCacheHas;
      MapCache.prototype.set = mapCacheSet;
      function SetCache(values) {
        var index = -1, length = values == null ? 0 : values.length;
        this.__data__ = new MapCache();
        while (++index < length) {
          this.add(values[index]);
        }
      }
      function setCacheAdd(value) {
        this.__data__.set(value, HASH_UNDEFINED);
        return this;
      }
      function setCacheHas(value) {
        return this.__data__.has(value);
      }
      SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
      SetCache.prototype.has = setCacheHas;
      function Stack(entries) {
        var data = this.__data__ = new ListCache(entries);
        this.size = data.size;
      }
      function stackClear() {
        this.__data__ = new ListCache();
        this.size = 0;
      }
      function stackDelete(key) {
        var data = this.__data__, result = data['delete'](key);
        this.size = data.size;
        return result;
      }
      function stackGet(key) {
        return this.__data__.get(key);
      }
      function stackHas(key) {
        return this.__data__.has(key);
      }
      function stackSet(key, value) {
        var data = this.__data__;
        if (data instanceof ListCache) {
          var pairs = data.__data__;
          if (!Map || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
          }
          data = this.__data__ = new MapCache(pairs);
        }
        data.set(key, value);
        this.size = data.size;
        return this;
      }
      Stack.prototype.clear = stackClear;
      Stack.prototype['delete'] = stackDelete;
      Stack.prototype.get = stackGet;
      Stack.prototype.has = stackHas;
      Stack.prototype.set = stackSet;
      function arrayLikeKeys(value, inherited) {
        var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == 'length' || isBuff && (key == 'offset' || key == 'parent') || isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset') || isIndex(key, length)))) {
            result.push(key);
          }
        }
        return result;
      }
      function arraySample(array) {
        var length = array.length;
        return length ? array[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array, n) {
        return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
      }
      function arrayShuffle(array) {
        return shuffleSelf(copyArray(array));
      }
      function assignMergeValue(object, key, value) {
        if (value !== undefined$1 && !eq(object[key], value) || value === undefined$1 && !((key in object))) {
          baseAssignValue(object, key, value);
        }
      }
      function assignValue(object, key, value) {
        var objValue = object[key];
        if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === undefined$1 && !((key in object))) {
          baseAssignValue(object, key, value);
        }
      }
      function assocIndexOf(array, key) {
        var length = array.length;
        while (length--) {
          if (eq(array[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee, accumulator) {
        baseEach(collection, function (value, key, collection) {
          setter(accumulator, value, iteratee(value), collection);
        });
        return accumulator;
      }
      function baseAssign(object, source) {
        return object && copyObject(source, keys(source), object);
      }
      function baseAssignIn(object, source) {
        return object && copyObject(source, keysIn(source), object);
      }
      function baseAssignValue(object, key, value) {
        if (key == '__proto__' && defineProperty) {
          defineProperty(object, key, {
            'configurable': true,
            'enumerable': true,
            'value': value,
            'writable': true
          });
        } else {
          object[key] = value;
        }
      }
      function baseAt(object, paths) {
        var index = -1, length = paths.length, result = Array(length), skip = object == null;
        while (++index < length) {
          result[index] = skip ? undefined$1 : get(object, paths[index]);
        }
        return result;
      }
      function baseClamp(number, lower, upper) {
        if (number === number) {
          if (upper !== undefined$1) {
            number = number <= upper ? number : upper;
          }
          if (lower !== undefined$1) {
            number = number >= lower ? number : lower;
          }
        }
        return number;
      }
      function baseClone(value, bitmask, customizer, key, object, stack) {
        var result, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result = object ? customizer(value, key, object, stack) : customizer(value);
        }
        if (result !== undefined$1) {
          return result;
        }
        if (!isObject(value)) {
          return value;
        }
        var isArr = isArray(value);
        if (isArr) {
          result = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result);
          }
        } else {
          var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
          if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag || tag == argsTag || isFunc && !object) {
            result = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result, value)) : copySymbols(value, baseAssign(result, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object ? value : {};
            }
            result = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result);
        if (isSet(value)) {
          value.forEach(function (subValue) {
            result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function (subValue, key) {
            result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function (subValue, key) {
          if (props) {
            key = subValue;
            subValue = value[key];
          }
          assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
        });
        return result;
      }
      function baseConforms(source) {
        var props = keys(source);
        return function (object) {
          return baseConformsTo(object, source, props);
        };
      }
      function baseConformsTo(object, source, props) {
        var length = props.length;
        if (object == null) {
          return !length;
        }
        object = Object(object);
        while (length--) {
          var key = props[length], predicate = source[key], value = object[key];
          if (value === undefined$1 && !((key in object)) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        return setTimeout(function () {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array, values, iteratee, comparator) {
        var index = -1, includes = arrayIncludes, isCommon = true, length = array.length, result = [], valuesLength = values.length;
        if (!length) {
          return result;
        }
        if (iteratee) {
          values = arrayMap(values, baseUnary(iteratee));
        }
        if (comparator) {
          includes = arrayIncludesWith;
          isCommon = false;
        } else if (values.length >= LARGE_ARRAY_SIZE) {
          includes = cacheHas;
          isCommon = false;
          values = new SetCache(values);
        }
        outer: while (++index < length) {
          var value = array[index], computed = iteratee == null ? value : iteratee(value);
          value = comparator || value !== 0 ? value : 0;
          if (isCommon && computed === computed) {
            var valuesIndex = valuesLength;
            while (valuesIndex--) {
              if (values[valuesIndex] === computed) {
                continue outer;
              }
            }
            result.push(value);
          } else if (!includes(values, computed, comparator)) {
            result.push(value);
          }
        }
        return result;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result = true;
        baseEach(collection, function (value, index, collection) {
          result = !!predicate(value, index, collection);
          return result;
        });
        return result;
      }
      function baseExtremum(array, iteratee, comparator) {
        var index = -1, length = array.length;
        while (++index < length) {
          var value = array[index], current = iteratee(value);
          if (current != null && (computed === undefined$1 ? current === current && !isSymbol(current) : comparator(current, computed))) {
            var computed = current, result = value;
          }
        }
        return result;
      }
      function baseFill(array, value, start, end) {
        var length = array.length;
        start = toInteger(start);
        if (start < 0) {
          start = -start > length ? 0 : length + start;
        }
        end = end === undefined$1 || end > length ? length : toInteger(end);
        if (end < 0) {
          end += length;
        }
        end = start > end ? 0 : toLength(end);
        while (start < end) {
          array[start++] = value;
        }
        return array;
      }
      function baseFilter(collection, predicate) {
        var result = [];
        baseEach(collection, function (value, index, collection) {
          if (predicate(value, index, collection)) {
            result.push(value);
          }
        });
        return result;
      }
      function baseFlatten(array, depth, predicate, isStrict, result) {
        var index = -1, length = array.length;
        predicate || (predicate = isFlattenable);
        result || (result = []);
        while (++index < length) {
          var value = array[index];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result);
            } else {
              arrayPush(result, value);
            }
          } else if (!isStrict) {
            result[result.length] = value;
          }
        }
        return result;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object, iteratee) {
        return object && baseFor(object, iteratee, keys);
      }
      function baseForOwnRight(object, iteratee) {
        return object && baseForRight(object, iteratee, keys);
      }
      function baseFunctions(object, props) {
        return arrayFilter(props, function (key) {
          return isFunction(object[key]);
        });
      }
      function baseGet(object, path) {
        path = castPath(path, object);
        var index = 0, length = path.length;
        while (object != null && index < length) {
          object = object[toKey(path[index++])];
        }
        return index && index == length ? object : undefined$1;
      }
      function baseGetAllKeys(object, keysFunc, symbolsFunc) {
        var result = keysFunc(object);
        return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
      }
      function baseGetTag(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag : nullTag;
        }
        return symToStringTag && (symToStringTag in Object(value)) ? getRawTag(value) : objectToString(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object, key) {
        return object != null && hasOwnProperty.call(object, key);
      }
      function baseHasIn(object, key) {
        return object != null && (key in Object(object));
      }
      function baseInRange(number, start, end) {
        return number >= nativeMin(start, end) && number < nativeMax(start, end);
      }
      function baseIntersection(arrays, iteratee, comparator) {
        var includes = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array(othLength), maxLength = Infinity, result = [];
        while (othIndex--) {
          var array = arrays[othIndex];
          if (othIndex && iteratee) {
            array = arrayMap(array, baseUnary(iteratee));
          }
          maxLength = nativeMin(array.length, maxLength);
          caches[othIndex] = !comparator && (iteratee || length >= 120 && array.length >= 120) ? new SetCache(othIndex && array) : undefined$1;
        }
        array = arrays[0];
        var index = -1, seen = caches[0];
        outer: while (++index < length && result.length < maxLength) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          value = comparator || value !== 0 ? value : 0;
          if (!(seen ? cacheHas(seen, computed) : includes(result, computed, comparator))) {
            othIndex = othLength;
            while (--othIndex) {
              var cache = caches[othIndex];
              if (!(cache ? cacheHas(cache, computed) : includes(arrays[othIndex], computed, comparator))) {
                continue outer;
              }
            }
            if (seen) {
              seen.push(computed);
            }
            result.push(value);
          }
        }
        return result;
      }
      function baseInverter(object, setter, iteratee, accumulator) {
        baseForOwn(object, function (value, key, object) {
          setter(accumulator, iteratee(value), key, object);
        });
        return accumulator;
      }
      function baseInvoke(object, path, args) {
        path = castPath(path, object);
        object = parent(object, path);
        var func = object == null ? object : object[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object, args);
      }
      function baseIsArguments(value) {
        return isObjectLike(value) && baseGetTag(value) == argsTag;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
      }
      function baseIsDate(value) {
        return isObjectLike(value) && baseGetTag(value) == dateTag;
      }
      function baseIsEqual(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
      }
      function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray(object), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
        objTag = objTag == argsTag ? objectTag : objTag;
        othTag = othTag == argsTag ? objectTag : othTag;
        var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer(object)) {
          if (!isBuffer(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack());
          return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
          var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'), othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack());
        return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike(value) && getTag(value) == mapTag;
      }
      function baseIsMatch(object, source, matchData, customizer) {
        var index = matchData.length, length = index, noCustomizer = !customizer;
        if (object == null) {
          return !length;
        }
        object = Object(object);
        while (index--) {
          var data = matchData[index];
          if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !((data[0] in object))) {
            return false;
          }
        }
        while (++index < length) {
          data = matchData[index];
          var key = data[0], objValue = object[key], srcValue = data[1];
          if (noCustomizer && data[2]) {
            if (objValue === undefined$1 && !((key in object))) {
              return false;
            }
          } else {
            var stack = new Stack();
            if (customizer) {
              var result = customizer(objValue, srcValue, key, object, source, stack);
            }
            if (!(result === undefined$1 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative(value) {
        if (!isObject(value) || isMasked(value)) {
          return false;
        }
        var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
        return pattern.test(toSource(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike(value) && baseGetTag(value) == regexpTag;
      }
      function baseIsSet(value) {
        return isObjectLike(value) && getTag(value) == setTag;
      }
      function baseIsTypedArray(value) {
        return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
      }
      function baseIteratee(value) {
        if (typeof value == 'function') {
          return value;
        }
        if (value == null) {
          return identity;
        }
        if (typeof value == 'object') {
          return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys(object) {
        if (!isPrototype(object)) {
          return nativeKeys(object);
        }
        var result = [];
        for (var key in Object(object)) {
          if (hasOwnProperty.call(object, key) && key != 'constructor') {
            result.push(key);
          }
        }
        return result;
      }
      function baseKeysIn(object) {
        if (!isObject(object)) {
          return nativeKeysIn(object);
        }
        var isProto = isPrototype(object), result = [];
        for (var key in object) {
          if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
            result.push(key);
          }
        }
        return result;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee) {
        var index = -1, result = isArrayLike(collection) ? Array(collection.length) : [];
        baseEach(collection, function (value, key, collection) {
          result[++index] = iteratee(value, key, collection);
        });
        return result;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function (object) {
          return object === source || baseIsMatch(object, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function (object) {
          var objValue = get(object, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
        };
      }
      function baseMerge(object, source, srcIndex, customizer, stack) {
        if (object === source) {
          return;
        }
        baseFor(source, function (srcValue, key) {
          stack || (stack = new Stack());
          if (isObject(srcValue)) {
            baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + '', object, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + '', object, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
            newValue = objValue;
            if (isArguments(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject(objValue) || isFunction(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack['delete'](srcValue);
        }
        assignMergeValue(object, key, newValue);
      }
      function baseNth(array, n) {
        var length = array.length;
        if (!length) {
          return;
        }
        n += n < 0 ? length : 0;
        return isIndex(n, length) ? array[n] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function (iteratee) {
            if (isArray(iteratee)) {
              return function (value) {
                return baseGet(value, iteratee.length === 1 ? iteratee[0] : iteratee);
              };
            }
            return iteratee;
          });
        } else {
          iteratees = [identity];
        }
        var index = -1;
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        var result = baseMap(collection, function (value, key, collection) {
          var criteria = arrayMap(iteratees, function (iteratee) {
            return iteratee(value);
          });
          return {
            'criteria': criteria,
            'index': ++index,
            'value': value
          };
        });
        return baseSortBy(result, function (object, other) {
          return compareMultiple(object, other, orders);
        });
      }
      function basePick(object, paths) {
        return basePickBy(object, paths, function (value, path) {
          return hasIn(object, path);
        });
      }
      function basePickBy(object, paths, predicate) {
        var index = -1, length = paths.length, result = {};
        while (++index < length) {
          var path = paths[index], value = baseGet(object, path);
          if (predicate(value, path)) {
            baseSet(result, castPath(path, object), value);
          }
        }
        return result;
      }
      function basePropertyDeep(path) {
        return function (object) {
          return baseGet(object, path);
        };
      }
      function basePullAll(array, values, iteratee, comparator) {
        var indexOf = comparator ? baseIndexOfWith : baseIndexOf, index = -1, length = values.length, seen = array;
        if (array === values) {
          values = copyArray(values);
        }
        if (iteratee) {
          seen = arrayMap(array, baseUnary(iteratee));
        }
        while (++index < length) {
          var fromIndex = 0, value = values[index], computed = iteratee ? iteratee(value) : value;
          while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array) {
              splice.call(seen, fromIndex, 1);
            }
            splice.call(array, fromIndex, 1);
          }
        }
        return array;
      }
      function basePullAt(array, indexes) {
        var length = array ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index = indexes[length];
          if (length == lastIndex || index !== previous) {
            var previous = index;
            if (isIndex(index)) {
              splice.call(array, index, 1);
            } else {
              baseUnset(array, index);
            }
          }
        }
        return array;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start, end, step, fromRight) {
        var index = -1, length = nativeMax(nativeCeil((end - start) / (step || 1)), 0), result = Array(length);
        while (length--) {
          result[fromRight ? length : ++index] = start;
          start += step;
        }
        return result;
      }
      function baseRepeat(string, n) {
        var result = '';
        if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
          return result;
        }
        do {
          if (n % 2) {
            result += string;
          }
          n = nativeFloor(n / 2);
          if (n) {
            string += string;
          }
        } while (n);
        return result;
      }
      function baseRest(func, start) {
        return setToString(overRest(func, start, identity), func + '');
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n) {
        var array = values(collection);
        return shuffleSelf(array, baseClamp(n, 0, array.length));
      }
      function baseSet(object, path, value, customizer) {
        if (!isObject(object)) {
          return object;
        }
        path = castPath(path, object);
        var index = -1, length = path.length, lastIndex = length - 1, nested = object;
        while (nested != null && ++index < length) {
          var key = toKey(path[index]), newValue = value;
          if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
            return object;
          }
          if (index != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject(objValue) ? objValue : isIndex(path[index + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object;
      }
      var baseSetData = !metaMap ? identity : function (func, data) {
        metaMap.set(func, data);
        return func;
      };
      var baseSetToString = !defineProperty ? identity : function (func, string) {
        return defineProperty(func, 'toString', {
          'configurable': true,
          'enumerable': false,
          'value': constant(string),
          'writable': true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array, start, end) {
        var index = -1, length = array.length;
        if (start < 0) {
          start = -start > length ? 0 : length + start;
        }
        end = end > length ? length : end;
        if (end < 0) {
          end += length;
        }
        length = start > end ? 0 : end - start >>> 0;
        start >>>= 0;
        var result = Array(length);
        while (++index < length) {
          result[index] = array[index + start];
        }
        return result;
      }
      function baseSome(collection, predicate) {
        var result;
        baseEach(collection, function (value, index, collection) {
          result = predicate(value, index, collection);
          return !result;
        });
        return !!result;
      }
      function baseSortedIndex(array, value, retHighest) {
        var low = 0, high = array == null ? low : array.length;
        if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array[mid];
            if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array, value, identity, retHighest);
      }
      function baseSortedIndexBy(array, value, iteratee, retHighest) {
        var low = 0, high = array == null ? 0 : array.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee(array[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array, iteratee) {
        var index = -1, length = array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          if (!index || !eq(computed, seen)) {
            var seen = computed;
            result[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result;
      }
      function baseToNumber(value) {
        if (typeof value == 'number') {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == 'string') {
          return value;
        }
        if (isArray(value)) {
          return arrayMap(value, baseToString) + '';
        }
        if (isSymbol(value)) {
          return symbolToString ? symbolToString.call(value) : '';
        }
        var result = value + '';
        return result == '0' && 1 / value == -INFINITY ? '-0' : result;
      }
      function baseUniq(array, iteratee, comparator) {
        var index = -1, includes = arrayIncludes, length = array.length, isCommon = true, result = [], seen = result;
        if (comparator) {
          isCommon = false;
          includes = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE) {
          var set = iteratee ? null : createSet(array);
          if (set) {
            return setToArray(set);
          }
          isCommon = false;
          includes = cacheHas;
          seen = new SetCache();
        } else {
          seen = iteratee ? [] : result;
        }
        outer: while (++index < length) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          value = comparator || value !== 0 ? value : 0;
          if (isCommon && computed === computed) {
            var seenIndex = seen.length;
            while (seenIndex--) {
              if (seen[seenIndex] === computed) {
                continue outer;
              }
            }
            if (iteratee) {
              seen.push(computed);
            }
            result.push(value);
          } else if (!includes(seen, computed, comparator)) {
            if (seen !== result) {
              seen.push(computed);
            }
            result.push(value);
          }
        }
        return result;
      }
      function baseUnset(object, path) {
        path = castPath(path, object);
        object = parent(object, path);
        return object == null || delete object[toKey(last(path))];
      }
      function baseUpdate(object, path, updater, customizer) {
        return baseSet(object, path, updater(baseGet(object, path)), customizer);
      }
      function baseWhile(array, predicate, isDrop, fromRight) {
        var length = array.length, index = fromRight ? length : -1;
        while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {}
        return isDrop ? baseSlice(array, fromRight ? 0 : index, fromRight ? index + 1 : length) : baseSlice(array, fromRight ? index + 1 : 0, fromRight ? length : index);
      }
      function baseWrapperValue(value, actions) {
        var result = value;
        if (result instanceof LazyWrapper) {
          result = result.value();
        }
        return arrayReduce(actions, function (result, action) {
          return action.func.apply(action.thisArg, arrayPush([result], action.args));
        }, result);
      }
      function baseXor(arrays, iteratee, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index = -1, result = Array(length);
        while (++index < length) {
          var array = arrays[index], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index) {
              result[index] = baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result, 1), iteratee, comparator);
      }
      function baseZipObject(props, values, assignFunc) {
        var index = -1, length = props.length, valsLength = values.length, result = {};
        while (++index < length) {
          var value = index < valsLength ? values[index] : undefined$1;
          assignFunc(result, props[index], value);
        }
        return result;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == 'function' ? value : identity;
      }
      function castPath(value, object) {
        if (isArray(value)) {
          return value;
        }
        return isKey(value, object) ? [value] : stringToPath(toString(value));
      }
      var castRest = baseRest;
      function castSlice(array, start, end) {
        var length = array.length;
        end = end === undefined$1 ? length : end;
        return !start && end >= length ? array : baseSlice(array, start, end);
      }
      var clearTimeout = ctxClearTimeout || (function (id) {
        return root.clearTimeout(id);
      });
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result);
        return result;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array(result).set(new Uint8Array(arrayBuffer));
        return result;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp) {
        var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
        result.lastIndex = regexp.lastIndex;
        return result;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object, other, orders) {
        var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index < length) {
          var result = compareAscending(objCriteria[index], othCriteria[index]);
          if (result) {
            if (index >= ordersLength) {
              return result;
            }
            var order = orders[index];
            return result * (order == 'desc' ? -1 : 1);
          }
        }
        return object.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result = Array(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result[leftIndex++] = args[argsIndex++];
        }
        return result;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result = Array(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result[argsIndex] = args[argsIndex];
        }
        var offset = argsIndex;
        while (++rightIndex < rightLength) {
          result[offset + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result[offset + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result;
      }
      function copyArray(source, array) {
        var index = -1, length = source.length;
        array || (array = Array(length));
        while (++index < length) {
          array[index] = source[index];
        }
        return array;
      }
      function copyObject(source, props, object, customizer) {
        var isNew = !object;
        object || (object = {});
        var index = -1, length = props.length;
        while (++index < length) {
          var key = props[index];
          var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object, key, newValue);
          } else {
            assignValue(object, key, newValue);
          }
        }
        return object;
      }
      function copySymbols(source, object) {
        return copyObject(source, getSymbols(source), object);
      }
      function copySymbolsIn(source, object) {
        return copyObject(source, getSymbolsIn(source), object);
      }
      function createAggregator(setter, initializer) {
        return function (collection, iteratee) {
          var func = isArray(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function (object, sources) {
          var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == 'function' ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object = Object(object);
          while (++index < length) {
            var source = sources[index];
            if (source) {
              assigner(object, source, index, customizer);
            }
          }
          return object;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function (collection, iteratee) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike(collection)) {
            return eachFunc(collection, iteratee);
          }
          var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection);
          while (fromRight ? index-- : ++index < length) {
            if (iteratee(iterable[index], index, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function (object, iteratee, keysFunc) {
          var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index];
            if (iteratee(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function (string) {
          string = toString(string);
          var strSymbols = hasUnicode(string) ? stringToArray(string) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join('') : string.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function (string) {
          return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');
        };
      }
      function createCtor(Ctor) {
        return function () {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result = Ctor.apply(thisBinding, args);
          return isObject(result) ? result : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array(length), index = length, placeholder = getHolder(wrapper);
          while (index--) {
            args[index] = arguments[index];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function (collection, predicate, fromIndex) {
          var iterable = Object(collection);
          if (!isArrayLike(collection)) {
            var iteratee = getIteratee(predicate, 3);
            collection = keys(collection);
            predicate = function (key) {
              return iteratee(iterable[key], key, iterable);
            };
          }
          var index = findIndexFunc(collection, predicate, fromIndex);
          return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function (funcs) {
          var length = funcs.length, index = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index--) {
            var func = funcs[index];
            if (typeof func != 'function') {
              throw new TypeError(FUNC_ERROR_TEXT);
            }
            if (prereq && !wrapper && getFuncName(func) == 'wrapper') {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index = wrapper ? index : length;
          while (++index < length) {
            func = funcs[index];
            var funcName = getFuncName(func), data = funcName == 'wrapper' ? getData(func) : undefined$1;
            if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
              wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function () {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray(value)) {
              return wrapper.plant(value).value();
            }
            var index = 0, result = length ? funcs[index].apply(this, args) : value;
            while (++index < length) {
              result = funcs[index].call(this, result);
            }
            return result;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array(length), index = length;
          while (index--) {
            args[index] = arguments[index];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary < length) {
            args.length = ary;
          }
          if (this && this !== root && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function (object, iteratee) {
          return baseInverter(object, setter, toIteratee(iteratee), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function (value, other) {
          var result;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result = value;
          }
          if (other !== undefined$1) {
            if (result === undefined$1) {
              return other;
            }
            if (typeof value == 'string' || typeof other == 'string') {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result = operator(value, other);
          }
          return result;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function (iteratees) {
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          return baseRest(function (args) {
            var thisArg = this;
            return arrayFunc(iteratees, function (iteratee) {
              return apply(iteratee, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? ' ' : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result), 0, length).join('') : result.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array(leftLength + argsLength), fn = this && this !== root && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function (start, end, step) {
          if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
            end = step = undefined$1;
          }
          start = toFinite(start);
          if (end === undefined$1) {
            end = start;
            start = 0;
          } else {
            end = toFinite(end);
          }
          step = step === undefined$1 ? start < end ? 1 : -1 : toFinite(step);
          return baseRange(start, end, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function (value, other) {
          if (!(typeof value == 'string' && typeof other == 'string')) {
            value = toNumber(value);
            other = toNumber(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [func, bitmask, thisArg, newPartials, newHolders, newPartialsRight, newHoldersRight, argPos, ary, arity];
        var result = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result, newData);
        }
        result.placeholder = placeholder;
        return setWrapToString(result, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math[methodName];
        return function (number, precision) {
          number = toNumber(number);
          precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
          if (precision && nativeIsFinite(number)) {
            var pair = (toString(number) + 'e').split('e'), value = func(pair[0] + 'e' + (+pair[1] + precision));
            pair = (toString(value) + 'e').split('e');
            return +(pair[0] + 'e' + (+pair[1] - precision));
          }
          return func(number);
        };
      }
      var createSet = !(Set && 1 / setToArray(new Set([, -0]))[1] == INFINITY) ? noop : function (values) {
        return new Set(values);
      };
      function createToPairs(keysFunc) {
        return function (object) {
          var tag = getTag(object);
          if (tag == mapTag) {
            return mapToArray(object);
          }
          if (tag == setTag) {
            return setToPairs(object);
          }
          return baseToPairs(object, keysFunc(object));
        };
      }
      function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary = ary === undefined$1 ? ary : nativeMax(toInteger(ary), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data = isBindKey ? undefined$1 : getData(func);
        var newData = [func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity];
        if (data) {
          mergeData(newData, data);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result = createPartial(func, bitmask, thisArg, partials);
        } else {
          result = createHybrid.apply(undefined$1, newData);
        }
        var setter = data ? baseSetData : setData;
        return setWrapToString(setter(result, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object) {
        if (objValue === undefined$1 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
        if (isObject(objValue) && isObject(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack['delete'](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array;
        }
        var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined$1;
        stack.set(array, other);
        stack.set(other, array);
        while (++index < arrLength) {
          var arrValue = array[index], othValue = other[index];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result = false;
            break;
          }
          if (seen) {
            if (!arraySome(other, function (othValue, othIndex) {
              if (!cacheHas(seen, othIndex) && (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result = false;
            break;
          }
        }
        stack['delete'](array);
        stack['delete'](other);
        return result;
      }
      function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag:
            if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
              return false;
            }
            object = object.buffer;
            other = other.buffer;
          case arrayBufferTag:
            if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
              return false;
            }
            return true;
          case boolTag:
          case dateTag:
          case numberTag:
            return eq(+object, +other);
          case errorTag:
            return object.name == other.name && object.message == other.message;
          case regexpTag:
          case stringTag:
            return object == other + '';
          case mapTag:
            var convert = mapToArray;
          case setTag:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
            convert || (convert = setToArray);
            if (object.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG;
            stack.set(object, other);
            var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
            stack['delete'](object);
            return result;
          case symbolTag:
            if (symbolValueOf) {
              return symbolValueOf.call(object) == symbolValueOf.call(other);
            }
        }
        return false;
      }
      function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index = objLength;
        while (index--) {
          var key = objProps[index];
          if (!(isPartial ? (key in other) : hasOwnProperty.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object;
        }
        var result = true;
        stack.set(object, other);
        stack.set(other, object);
        var skipCtor = isPartial;
        while (++index < objLength) {
          key = objProps[index];
          var objValue = object[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result = false;
            break;
          }
          skipCtor || (skipCtor = key == 'constructor');
        }
        if (result && !skipCtor) {
          var objCtor = object.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && (('constructor' in object) && ('constructor' in other)) && !(typeof objCtor == 'function' && objCtor instanceof objCtor && typeof othCtor == 'function' && othCtor instanceof othCtor)) {
            result = false;
          }
        }
        stack['delete'](object);
        stack['delete'](other);
        return result;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + '');
      }
      function getAllKeys(object) {
        return baseGetAllKeys(object, keys, getSymbols);
      }
      function getAllKeysIn(object) {
        return baseGetAllKeys(object, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop : function (func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result = func.name + '', array = realNames[result], length = hasOwnProperty.call(realNames, result) ? array.length : 0;
        while (length--) {
          var data = array[length], otherFunc = data.func;
          if (otherFunc == null || otherFunc == func) {
            return data.name;
          }
        }
        return result;
      }
      function getHolder(func) {
        var object = hasOwnProperty.call(lodash, 'placeholder') ? lodash : func;
        return object.placeholder;
      }
      function getIteratee() {
        var result = lodash.iteratee || iteratee;
        result = result === iteratee ? baseIteratee : result;
        return arguments.length ? result(arguments[0], arguments[1]) : result;
      }
      function getMapData(map, key) {
        var data = map.__data__;
        return isKeyable(key) ? data[typeof key == 'string' ? 'string' : 'hash'] : data.map;
      }
      function getMatchData(object) {
        var result = keys(object), length = result.length;
        while (length--) {
          var key = result[length], value = object[key];
          result[length] = [key, value, isStrictComparable(value)];
        }
        return result;
      }
      function getNative(object, key) {
        var value = getValue(object, key);
        return baseIsNative(value) ? value : undefined$1;
      }
      function getRawTag(value) {
        var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
        try {
          value[symToStringTag] = undefined$1;
          var unmasked = true;
        } catch (e) {}
        var result = nativeObjectToString.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag] = tag;
          } else {
            delete value[symToStringTag];
          }
        }
        return result;
      }
      var getSymbols = !nativeGetSymbols ? stubArray : function (object) {
        if (object == null) {
          return [];
        }
        object = Object(object);
        return arrayFilter(nativeGetSymbols(object), function (symbol) {
          return propertyIsEnumerable.call(object, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols ? stubArray : function (object) {
        var result = [];
        while (object) {
          arrayPush(result, getSymbols(object));
          object = getPrototype(object);
        }
        return result;
      };
      var getTag = baseGetTag;
      if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map && getTag(new Map()) != mapTag || Promise && getTag(Promise.resolve()) != promiseTag || Set && getTag(new Set()) != setTag || WeakMap && getTag(new WeakMap()) != weakMapTag) {
        getTag = function (value) {
          var result = baseGetTag(value), Ctor = result == objectTag ? value.constructor : undefined$1, ctorString = Ctor ? toSource(Ctor) : '';
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString:
                return dataViewTag;
              case mapCtorString:
                return mapTag;
              case promiseCtorString:
                return promiseTag;
              case setCtorString:
                return setTag;
              case weakMapCtorString:
                return weakMapTag;
            }
          }
          return result;
        };
      }
      function getView(start, end, transforms) {
        var index = -1, length = transforms.length;
        while (++index < length) {
          var data = transforms[index], size = data.size;
          switch (data.type) {
            case 'drop':
              start += size;
              break;
            case 'dropRight':
              end -= size;
              break;
            case 'take':
              end = nativeMin(end, start + size);
              break;
            case 'takeRight':
              start = nativeMax(start, end - size);
              break;
          }
        }
        return {
          'start': start,
          'end': end
        };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object, path, hasFunc) {
        path = castPath(path, object);
        var index = -1, length = path.length, result = false;
        while (++index < length) {
          var key = toKey(path[index]);
          if (!(result = object != null && hasFunc(object, key))) {
            break;
          }
          object = object[key];
        }
        if (result || ++index != length) {
          return result;
        }
        length = object == null ? 0 : object.length;
        return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
      }
      function initCloneArray(array) {
        var length = array.length, result = new array.constructor(length);
        if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
          result.index = array.index;
          result.input = array.input;
        }
        return result;
      }
      function initCloneObject(object) {
        return typeof object.constructor == 'function' && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
      }
      function initCloneByTag(object, tag, isDeep) {
        var Ctor = object.constructor;
        switch (tag) {
          case arrayBufferTag:
            return cloneArrayBuffer(object);
          case boolTag:
          case dateTag:
            return new Ctor(+object);
          case dataViewTag:
            return cloneDataView(object, isDeep);
          case float32Tag:
          case float64Tag:
          case int8Tag:
          case int16Tag:
          case int32Tag:
          case uint8Tag:
          case uint8ClampedTag:
          case uint16Tag:
          case uint32Tag:
            return cloneTypedArray(object, isDeep);
          case mapTag:
            return new Ctor();
          case numberTag:
          case stringTag:
            return new Ctor(object);
          case regexpTag:
            return cloneRegExp(object);
          case setTag:
            return new Ctor();
          case symbolTag:
            return cloneSymbol(object);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? '& ' : '') + details[lastIndex];
        details = details.join(length > 2 ? ', ' : ' ');
        return source.replace(reWrapComment, '{\n/* [wrapped with ' + details + '] */\n');
      }
      function isFlattenable(value) {
        return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex(value, length) {
        var type = typeof value;
        length = length == null ? MAX_SAFE_INTEGER : length;
        return !!length && (type == 'number' || type != 'symbol' && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index, object) {
        if (!isObject(object)) {
          return false;
        }
        var type = typeof index;
        if (type == 'number' ? isArrayLike(object) && isIndex(index, object.length) : type == 'string' && (index in object)) {
          return eq(object[index], value);
        }
        return false;
      }
      function isKey(value, object) {
        if (isArray(value)) {
          return false;
        }
        var type = typeof value;
        if (type == 'number' || type == 'symbol' || type == 'boolean' || value == null || isSymbol(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && (value in Object(object));
      }
      function isKeyable(value) {
        var type = typeof value;
        return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash[funcName];
        if (typeof other != 'function' || !((funcName in LazyWrapper.prototype))) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data = getData(other);
        return !!data && func === data[0];
      }
      function isMasked(func) {
        return !!maskSrcKey && (maskSrcKey in func);
      }
      var isMaskable = coreJsData ? isFunction : stubFalse;
      function isPrototype(value) {
        var Ctor = value && value.constructor, proto = typeof Ctor == 'function' && Ctor.prototype || objectProto;
        return value === proto;
      }
      function isStrictComparable(value) {
        return value === value && !isObject(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function (object) {
          if (object == null) {
            return false;
          }
          return object[key] === srcValue && (srcValue !== undefined$1 || (key in Object(object)));
        };
      }
      function memoizeCapped(func) {
        var result = memoize(func, function (key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result.cache;
        return result;
      }
      function mergeData(data, source) {
        var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data[3];
          data[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data[5];
          data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
        }
        if (data[9] == null) {
          data[9] = source[9];
        }
        data[0] = source[0];
        data[1] = newBitmask;
        return data;
      }
      function nativeKeysIn(object) {
        var result = [];
        if (object != null) {
          for (var key in Object(object)) {
            result.push(key);
          }
        }
        return result;
      }
      function objectToString(value) {
        return nativeObjectToString.call(value);
      }
      function overRest(func, start, transform) {
        start = nativeMax(start === undefined$1 ? func.length - 1 : start, 0);
        return function () {
          var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
          while (++index < length) {
            array[index] = args[start + index];
          }
          index = -1;
          var otherArgs = Array(start + 1);
          while (++index < start) {
            otherArgs[index] = args[index];
          }
          otherArgs[start] = transform(array);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object, path) {
        return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
      }
      function reorder(array, indexes) {
        var arrLength = array.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array);
        while (length--) {
          var index = indexes[length];
          array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined$1;
        }
        return array;
      }
      function safeGet(object, key) {
        if (key === 'constructor' && typeof object[key] === 'function') {
          return;
        }
        if (key == '__proto__') {
          return;
        }
        return object[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout = ctxSetTimeout || (function (func, wait) {
        return root.setTimeout(func, wait);
      });
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + '';
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count = 0, lastCalled = 0;
        return function () {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array, size) {
        var index = -1, length = array.length, lastIndex = length - 1;
        size = size === undefined$1 ? length : size;
        while (++index < size) {
          var rand = baseRandom(index, lastIndex), value = array[rand];
          array[rand] = array[index];
          array[index] = value;
        }
        array.length = size;
        return array;
      }
      var stringToPath = memoizeCapped(function (string) {
        var result = [];
        if (string.charCodeAt(0) === 46) {
          result.push('');
        }
        string.replace(rePropName, function (match, number, quote, subString) {
          result.push(quote ? subString.replace(reEscapeChar, '$1') : number || match);
        });
        return result;
      });
      function toKey(value) {
        if (typeof value == 'string' || isSymbol(value)) {
          return value;
        }
        var result = value + '';
        return result == '0' && 1 / value == -INFINITY ? '-0' : result;
      }
      function toSource(func) {
        if (func != null) {
          try {
            return funcToString.call(func);
          } catch (e) {}
          try {
            return func + '';
          } catch (e) {}
        }
        return '';
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function (pair) {
          var value = '_.' + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result.__actions__ = copyArray(wrapper.__actions__);
        result.__index__ = wrapper.__index__;
        result.__values__ = wrapper.__values__;
        return result;
      }
      function chunk(array, size, guard) {
        if (guard ? isIterateeCall(array, size, guard) : size === undefined$1) {
          size = 1;
        } else {
          size = nativeMax(toInteger(size), 0);
        }
        var length = array == null ? 0 : array.length;
        if (!length || size < 1) {
          return [];
        }
        var index = 0, resIndex = 0, result = Array(nativeCeil(length / size));
        while (index < length) {
          result[resIndex++] = baseSlice(array, index, index += size);
        }
        return result;
      }
      function compact(array) {
        var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index];
          if (value) {
            result[resIndex++] = value;
          }
        }
        return result;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array(length - 1), array = arguments[0], index = length;
        while (index--) {
          args[index - 1] = arguments[index];
        }
        return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
      }
      var difference = baseRest(function (array, values) {
        return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function (array, values) {
        var iteratee = last(values);
        if (isArrayLikeObject(iteratee)) {
          iteratee = undefined$1;
        }
        return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), getIteratee(iteratee, 2)) : [];
      });
      var differenceWith = baseRest(function (array, values) {
        var comparator = last(values);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array, n, guard) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        n = guard || n === undefined$1 ? 1 : toInteger(n);
        return baseSlice(array, n < 0 ? 0 : n, length);
      }
      function dropRight(array, n, guard) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        n = guard || n === undefined$1 ? 1 : toInteger(n);
        n = length - n;
        return baseSlice(array, 0, n < 0 ? 0 : n);
      }
      function dropRightWhile(array, predicate) {
        return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array, predicate) {
        return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true) : [];
      }
      function fill(array, value, start, end) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {
          start = 0;
          end = length;
        }
        return baseFill(array, value, start, end);
      }
      function findIndex(array, predicate, fromIndex) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return -1;
        }
        var index = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index < 0) {
          index = nativeMax(length + index, 0);
        }
        return baseFindIndex(array, getIteratee(predicate, 3), index);
      }
      function findLastIndex(array, predicate, fromIndex) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return -1;
        }
        var index = length - 1;
        if (fromIndex !== undefined$1) {
          index = toInteger(fromIndex);
          index = fromIndex < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
        }
        return baseFindIndex(array, getIteratee(predicate, 3), index, true);
      }
      function flatten(array) {
        var length = array == null ? 0 : array.length;
        return length ? baseFlatten(array, 1) : [];
      }
      function flattenDeep(array) {
        var length = array == null ? 0 : array.length;
        return length ? baseFlatten(array, INFINITY) : [];
      }
      function flattenDepth(array, depth) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array, depth);
      }
      function fromPairs(pairs) {
        var index = -1, length = pairs == null ? 0 : pairs.length, result = {};
        while (++index < length) {
          var pair = pairs[index];
          result[pair[0]] = pair[1];
        }
        return result;
      }
      function head(array) {
        return array && array.length ? array[0] : undefined$1;
      }
      function indexOf(array, value, fromIndex) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return -1;
        }
        var index = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index < 0) {
          index = nativeMax(length + index, 0);
        }
        return baseIndexOf(array, value, index);
      }
      function initial(array) {
        var length = array == null ? 0 : array.length;
        return length ? baseSlice(array, 0, -1) : [];
      }
      var intersection = baseRest(function (arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function (arrays) {
        var iteratee = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee === last(mapped)) {
          iteratee = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee, 2)) : [];
      });
      var intersectionWith = baseRest(function (arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == 'function' ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array, separator) {
        return array == null ? '' : nativeJoin.call(array, separator);
      }
      function last(array) {
        var length = array == null ? 0 : array.length;
        return length ? array[length - 1] : undefined$1;
      }
      function lastIndexOf(array, value, fromIndex) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return -1;
        }
        var index = length;
        if (fromIndex !== undefined$1) {
          index = toInteger(fromIndex);
          index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
        }
        return value === value ? strictLastIndexOf(array, value, index) : baseFindIndex(array, baseIsNaN, index, true);
      }
      function nth(array, n) {
        return array && array.length ? baseNth(array, toInteger(n)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array, values) {
        return array && array.length && values && values.length ? basePullAll(array, values) : array;
      }
      function pullAllBy(array, values, iteratee) {
        return array && array.length && values && values.length ? basePullAll(array, values, getIteratee(iteratee, 2)) : array;
      }
      function pullAllWith(array, values, comparator) {
        return array && array.length && values && values.length ? basePullAll(array, values, undefined$1, comparator) : array;
      }
      var pullAt = flatRest(function (array, indexes) {
        var length = array == null ? 0 : array.length, result = baseAt(array, indexes);
        basePullAt(array, arrayMap(indexes, function (index) {
          return isIndex(index, length) ? +index : index;
        }).sort(compareAscending));
        return result;
      });
      function remove(array, predicate) {
        var result = [];
        if (!(array && array.length)) {
          return result;
        }
        var index = -1, indexes = [], length = array.length;
        predicate = getIteratee(predicate, 3);
        while (++index < length) {
          var value = array[index];
          if (predicate(value, index, array)) {
            result.push(value);
            indexes.push(index);
          }
        }
        basePullAt(array, indexes);
        return result;
      }
      function reverse(array) {
        return array == null ? array : nativeReverse.call(array);
      }
      function slice(array, start, end) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {
          start = 0;
          end = length;
        } else {
          start = start == null ? 0 : toInteger(start);
          end = end === undefined$1 ? length : toInteger(end);
        }
        return baseSlice(array, start, end);
      }
      function sortedIndex(array, value) {
        return baseSortedIndex(array, value);
      }
      function sortedIndexBy(array, value, iteratee) {
        return baseSortedIndexBy(array, value, getIteratee(iteratee, 2));
      }
      function sortedIndexOf(array, value) {
        var length = array == null ? 0 : array.length;
        if (length) {
          var index = baseSortedIndex(array, value);
          if (index < length && eq(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function sortedLastIndex(array, value) {
        return baseSortedIndex(array, value, true);
      }
      function sortedLastIndexBy(array, value, iteratee) {
        return baseSortedIndexBy(array, value, getIteratee(iteratee, 2), true);
      }
      function sortedLastIndexOf(array, value) {
        var length = array == null ? 0 : array.length;
        if (length) {
          var index = baseSortedIndex(array, value, true) - 1;
          if (eq(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function sortedUniq(array) {
        return array && array.length ? baseSortedUniq(array) : [];
      }
      function sortedUniqBy(array, iteratee) {
        return array && array.length ? baseSortedUniq(array, getIteratee(iteratee, 2)) : [];
      }
      function tail(array) {
        var length = array == null ? 0 : array.length;
        return length ? baseSlice(array, 1, length) : [];
      }
      function take(array, n, guard) {
        if (!(array && array.length)) {
          return [];
        }
        n = guard || n === undefined$1 ? 1 : toInteger(n);
        return baseSlice(array, 0, n < 0 ? 0 : n);
      }
      function takeRight(array, n, guard) {
        var length = array == null ? 0 : array.length;
        if (!length) {
          return [];
        }
        n = guard || n === undefined$1 ? 1 : toInteger(n);
        n = length - n;
        return baseSlice(array, n < 0 ? 0 : n, length);
      }
      function takeRightWhile(array, predicate) {
        return array && array.length ? baseWhile(array, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array, predicate) {
        return array && array.length ? baseWhile(array, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function (arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function (arrays) {
        var iteratee = last(arrays);
        if (isArrayLikeObject(iteratee)) {
          iteratee = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee, 2));
      });
      var unionWith = baseRest(function (arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == 'function' ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array) {
        return array && array.length ? baseUniq(array) : [];
      }
      function uniqBy(array, iteratee) {
        return array && array.length ? baseUniq(array, getIteratee(iteratee, 2)) : [];
      }
      function uniqWith(array, comparator) {
        comparator = typeof comparator == 'function' ? comparator : undefined$1;
        return array && array.length ? baseUniq(array, undefined$1, comparator) : [];
      }
      function unzip(array) {
        if (!(array && array.length)) {
          return [];
        }
        var length = 0;
        array = arrayFilter(array, function (group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax(group.length, length);
            return true;
          }
        });
        return baseTimes(length, function (index) {
          return arrayMap(array, baseProperty(index));
        });
      }
      function unzipWith(array, iteratee) {
        if (!(array && array.length)) {
          return [];
        }
        var result = unzip(array);
        if (iteratee == null) {
          return result;
        }
        return arrayMap(result, function (group) {
          return apply(iteratee, undefined$1, group);
        });
      }
      var without = baseRest(function (array, values) {
        return isArrayLikeObject(array) ? baseDifference(array, values) : [];
      });
      var xor = baseRest(function (arrays) {
        return baseXor(arrayFilter(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function (arrays) {
        var iteratee = last(arrays);
        if (isArrayLikeObject(iteratee)) {
          iteratee = undefined$1;
        }
        return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee, 2));
      });
      var xorWith = baseRest(function (arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == 'function' ? comparator : undefined$1;
        return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values) {
        return baseZipObject(props || [], values || [], assignValue);
      }
      function zipObjectDeep(props, values) {
        return baseZipObject(props || [], values || [], baseSet);
      }
      var zipWith = baseRest(function (arrays) {
        var length = arrays.length, iteratee = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee = typeof iteratee == 'function' ? (arrays.pop(), iteratee) : undefined$1;
        return unzipWith(arrays, iteratee);
      });
      function chain(value) {
        var result = lodash(value);
        result.__chain__ = true;
        return result;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function (paths) {
        var length = paths.length, start = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function (object) {
          return baseAt(object, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start)) {
          return this.thru(interceptor);
        }
        value = value.slice(start, +start + (length ? 1 : 0));
        value.__actions__.push({
          'func': thru,
          'args': [interceptor],
          'thisArg': undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function (array) {
          if (length && !array.length) {
            array.push(undefined$1);
          }
          return array;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return {
          'done': done,
          'value': value
        };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result, parent = this;
        while (parent instanceof baseLodash) {
          var clone = wrapperClone(parent);
          clone.__index__ = 0;
          clone.__values__ = undefined$1;
          if (result) {
            previous.__wrapped__ = clone;
          } else {
            result = clone;
          }
          var previous = clone;
          parent = parent.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            'func': thru,
            'args': [reverse],
            'thisArg': undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function (result, value, key) {
        if (hasOwnProperty.call(result, key)) {
          ++result[key];
        } else {
          baseAssignValue(result, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter(collection, predicate) {
        var func = isArray(collection) ? arrayFilter : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee) {
        return baseFlatten(map(collection, iteratee), 1);
      }
      function flatMapDeep(collection, iteratee) {
        return baseFlatten(map(collection, iteratee), INFINITY);
      }
      function flatMapDepth(collection, iteratee, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map(collection, iteratee), depth);
      }
      function forEach(collection, iteratee) {
        var func = isArray(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee, 3));
      }
      function forEachRight(collection, iteratee) {
        var func = isArray(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee, 3));
      }
      var groupBy = createAggregator(function (result, value, key) {
        if (hasOwnProperty.call(result, key)) {
          result[key].push(value);
        } else {
          baseAssignValue(result, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax(length + fromIndex, 0);
        }
        return isString(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function (collection, path, args) {
        var index = -1, isFunc = typeof path == 'function', result = isArrayLike(collection) ? Array(collection.length) : [];
        baseEach(collection, function (value) {
          result[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result;
      });
      var keyBy = createAggregator(function (result, value, key) {
        baseAssignValue(result, key, value);
      });
      function map(collection, iteratee) {
        var func = isArray(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function (result, value, key) {
        result[key ? 0 : 1].push(value);
      }, function () {
        return [[], []];
      });
      function reduce(collection, iteratee, accumulator) {
        var func = isArray(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee, accumulator) {
        var func = isArray(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray(collection) ? arrayFilter : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n, guard) {
        if (guard ? isIterateeCall(collection, n, guard) : n === undefined$1) {
          n = 1;
        } else {
          n = toInteger(n);
        }
        var func = isArray(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n);
      }
      function shuffle(collection) {
        var func = isArray(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike(collection)) {
          return isString(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag(collection);
        if (tag == mapTag || tag == setTag) {
          return collection.size;
        }
        return baseKeys(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray(collection) ? arraySome : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function (collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now = ctxNow || (function () {
        return root.Date.now();
      });
      function after(n, func) {
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        n = toInteger(n);
        return function () {
          if (--n < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n, guard) {
        n = guard ? undefined$1 : n;
        n = func && n == null ? func.length : n;
        return createWrap(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n);
      }
      function before(n, func) {
        var result;
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        n = toInteger(n);
        return function () {
          if (--n > 0) {
            result = func.apply(this, arguments);
          }
          if (n <= 1) {
            func = undefined$1;
          }
          return result;
        };
      }
      var bind = baseRest(function (func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function (object, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap(key, bitmask, object, partials, holders);
      });
      function curry(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result = createWrap(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result.placeholder = curry.placeholder;
        return result;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result.placeholder = curryRight.placeholder;
        return result;
      }
      function debounce(func, wait, options) {
        var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        wait = toNumber(wait) || 0;
        if (isObject(options)) {
          leading = !!options.leading;
          maxing = ('maxWait' in options);
          maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
          trailing = ('trailing' in options) ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result = func.apply(thisArg, args);
          return result;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout(timerExpired, wait);
          return leading ? invokeFunc(time) : result;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result;
        }
        function cancel() {
          if (timerId !== undefined$1) {
            clearTimeout(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result : trailingEdge(now());
        }
        function debounced() {
          var time = now(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout(timerId);
              timerId = setTimeout(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout(timerExpired, wait);
          }
          return result;
        }
        debounced.cancel = cancel;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function (func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function (func, wait, args) {
        return baseDelay(func, toNumber(wait) || 0, args);
      });
      function flip(func) {
        return createWrap(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != 'function' || resolver != null && typeof resolver != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        var memoized = function () {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result = func.apply(this, args);
          memoized.cache = cache.set(key, result) || cache;
          return result;
        };
        memoized.cache = new (memoize.Cache || MapCache)();
        return memoized;
      }
      memoize.Cache = MapCache;
      function negate(predicate) {
        if (typeof predicate != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        return function () {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function (func, transforms) {
        transforms = transforms.length == 1 && isArray(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function (args) {
          var index = -1, length = nativeMin(args.length, funcsLength);
          while (++index < length) {
            args[index] = transforms[index].call(this, args[index]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function (func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function (func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function (func, indexes) {
        return createWrap(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start) {
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        start = start === undefined$1 ? start : toInteger(start);
        return baseRest(func, start);
      }
      function spread(func, start) {
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        start = start == null ? 0 : nativeMax(toInteger(start), 0);
        return baseRest(function (args) {
          var array = args[start], otherArgs = castSlice(args, 0, start);
          if (array) {
            arrayPush(otherArgs, array);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        if (isObject(options)) {
          leading = ('leading' in options) ? !!options.leading : leading;
          trailing = ('trailing' in options) ? !!options.trailing : trailing;
        }
        return debounce(func, wait, {
          'leading': leading,
          'maxWait': wait,
          'trailing': trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray(value) ? value : [value];
      }
      function clone(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object, source) {
        return source == null || baseConformsTo(object, source, keys(source));
      }
      function eq(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function (value, other) {
        return value >= other;
      });
      var isArguments = baseIsArguments((function () {
        return arguments;
      })()) ? baseIsArguments : function (value) {
        return isObjectLike(value) && hasOwnProperty.call(value, 'callee') && !propertyIsEnumerable.call(value, 'callee');
      };
      var isArray = Array.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike(value) {
        return value != null && isLength(value.length) && !isFunction(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike(value) && isArrayLike(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike(value) && baseGetTag(value) == boolTag;
      }
      var isBuffer = nativeIsBuffer || stubFalse;
      var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike(value) && (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' || isBuffer(value) || isTypedArray(value) || isArguments(value))) {
          return !value.length;
        }
        var tag = getTag(value);
        if (tag == mapTag || tag == setTag) {
          return !value.size;
        }
        if (isPrototype(value)) {
          return !baseKeys(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual(value, other) {
        return baseIsEqual(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        var result = customizer ? customizer(value, other) : undefined$1;
        return result === undefined$1 ? baseIsEqual(value, other, undefined$1, customizer) : !!result;
      }
      function isError(value) {
        if (!isObjectLike(value)) {
          return false;
        }
        var tag = baseGetTag(value);
        return tag == errorTag || tag == domExcTag || typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject(value);
      }
      function isFinite(value) {
        return typeof value == 'number' && nativeIsFinite(value);
      }
      function isFunction(value) {
        if (!isObject(value)) {
          return false;
        }
        var tag = baseGetTag(value);
        return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
      }
      function isInteger(value) {
        return typeof value == 'number' && value == toInteger(value);
      }
      function isLength(value) {
        return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
      }
      function isObject(value) {
        var type = typeof value;
        return value != null && (type == 'object' || type == 'function');
      }
      function isObjectLike(value) {
        return value != null && typeof value == 'object';
      }
      var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
      function isMatch(object, source) {
        return object === source || baseIsMatch(object, source, getMatchData(source));
      }
      function isMatchWith(object, source, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        return baseIsMatch(object, source, getMatchData(source), customizer);
      }
      function isNaN(value) {
        return isNumber(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error(CORE_ERROR_TEXT);
        }
        return baseIsNative(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber(value) {
        return typeof value == 'number' || isObjectLike(value) && baseGetTag(value) == numberTag;
      }
      function isPlainObject(value) {
        if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
          return false;
        }
        var proto = getPrototype(value);
        if (proto === null) {
          return true;
        }
        var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
        return typeof Ctor == 'function' && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
      }
      var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
      }
      var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
      function isString(value) {
        return typeof value == 'string' || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
      }
      function isSymbol(value) {
        return typeof value == 'symbol' || isObjectLike(value) && baseGetTag(value) == symbolTag;
      }
      var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike(value) && getTag(value) == weakMapTag;
      }
      function isWeakSet(value) {
        return isObjectLike(value) && baseGetTag(value) == weakSetTag;
      }
      var lt = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function (value, other) {
        return value <= other;
      });
      function toArray(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike(value)) {
          return isString(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result = toFinite(value), remainder = result % 1;
        return result === result ? remainder ? result - remainder : result : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber(value) {
        if (typeof value == 'number') {
          return value;
        }
        if (isSymbol(value)) {
          return NAN;
        }
        if (isObject(value)) {
          var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
          value = isObject(other) ? other + '' : other;
        }
        if (typeof value != 'string') {
          return value === 0 ? value : +value;
        }
        value = baseTrim(value);
        var isBinary = reIsBinary.test(value);
        return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER) : value === 0 ? value : 0;
      }
      function toString(value) {
        return value == null ? '' : baseToString(value);
      }
      var assign = createAssigner(function (object, source) {
        if (isPrototype(source) || isArrayLike(source)) {
          copyObject(source, keys(source), object);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty.call(source, key)) {
            assignValue(object, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function (object, source) {
        copyObject(source, keysIn(source), object);
      });
      var assignInWith = createAssigner(function (object, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object, customizer);
      });
      var assignWith = createAssigner(function (object, source, srcIndex, customizer) {
        copyObject(source, keys(source), object, customizer);
      });
      var at = flatRest(baseAt);
      function create(prototype, properties) {
        var result = baseCreate(prototype);
        return properties == null ? result : baseAssign(result, properties);
      }
      var defaults = baseRest(function (object, sources) {
        object = Object(object);
        var index = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index < length) {
          var source = sources[index];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object[key];
            if (value === undefined$1 || eq(value, objectProto[key]) && !hasOwnProperty.call(object, key)) {
              object[key] = source[key];
            }
          }
        }
        return object;
      });
      var defaultsDeep = baseRest(function (args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object, predicate) {
        return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object, predicate) {
        return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object, iteratee) {
        return object == null ? object : baseFor(object, getIteratee(iteratee, 3), keysIn);
      }
      function forInRight(object, iteratee) {
        return object == null ? object : baseForRight(object, getIteratee(iteratee, 3), keysIn);
      }
      function forOwn(object, iteratee) {
        return object && baseForOwn(object, getIteratee(iteratee, 3));
      }
      function forOwnRight(object, iteratee) {
        return object && baseForOwnRight(object, getIteratee(iteratee, 3));
      }
      function functions(object) {
        return object == null ? [] : baseFunctions(object, keys(object));
      }
      function functionsIn(object) {
        return object == null ? [] : baseFunctions(object, keysIn(object));
      }
      function get(object, path, defaultValue) {
        var result = object == null ? undefined$1 : baseGet(object, path);
        return result === undefined$1 ? defaultValue : result;
      }
      function has(object, path) {
        return object != null && hasPath(object, path, baseHas);
      }
      function hasIn(object, path) {
        return object != null && hasPath(object, path, baseHasIn);
      }
      var invert = createInverter(function (result, value, key) {
        if (value != null && typeof value.toString != 'function') {
          value = nativeObjectToString.call(value);
        }
        result[value] = key;
      }, constant(identity));
      var invertBy = createInverter(function (result, value, key) {
        if (value != null && typeof value.toString != 'function') {
          value = nativeObjectToString.call(value);
        }
        if (hasOwnProperty.call(result, value)) {
          result[value].push(key);
        } else {
          result[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys(object) {
        return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
      }
      function keysIn(object) {
        return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
      }
      function mapKeys(object, iteratee) {
        var result = {};
        iteratee = getIteratee(iteratee, 3);
        baseForOwn(object, function (value, key, object) {
          baseAssignValue(result, iteratee(value, key, object), value);
        });
        return result;
      }
      function mapValues(object, iteratee) {
        var result = {};
        iteratee = getIteratee(iteratee, 3);
        baseForOwn(object, function (value, key, object) {
          baseAssignValue(result, key, iteratee(value, key, object));
        });
        return result;
      }
      var merge = createAssigner(function (object, source, srcIndex) {
        baseMerge(object, source, srcIndex);
      });
      var mergeWith = createAssigner(function (object, source, srcIndex, customizer) {
        baseMerge(object, source, srcIndex, customizer);
      });
      var omit = flatRest(function (object, paths) {
        var result = {};
        if (object == null) {
          return result;
        }
        var isDeep = false;
        paths = arrayMap(paths, function (path) {
          path = castPath(path, object);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object, getAllKeysIn(object), result);
        if (isDeep) {
          result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result, paths[length]);
        }
        return result;
      });
      function omitBy(object, predicate) {
        return pickBy(object, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function (object, paths) {
        return object == null ? {} : basePick(object, paths);
      });
      function pickBy(object, predicate) {
        if (object == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object), function (prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object, props, function (value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object, path, defaultValue) {
        path = castPath(path, object);
        var index = -1, length = path.length;
        if (!length) {
          length = 1;
          object = undefined$1;
        }
        while (++index < length) {
          var value = object == null ? undefined$1 : object[toKey(path[index])];
          if (value === undefined$1) {
            index = length;
            value = defaultValue;
          }
          object = isFunction(value) ? value.call(object) : value;
        }
        return object;
      }
      function set(object, path, value) {
        return object == null ? object : baseSet(object, path, value);
      }
      function setWith(object, path, value, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        return object == null ? object : baseSet(object, path, value, customizer);
      }
      var toPairs = createToPairs(keys);
      var toPairsIn = createToPairs(keysIn);
      function transform(object, iteratee, accumulator) {
        var isArr = isArray(object), isArrLike = isArr || isBuffer(object) || isTypedArray(object);
        iteratee = getIteratee(iteratee, 4);
        if (accumulator == null) {
          var Ctor = object && object.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject(object)) {
            accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object, function (value, index, object) {
          return iteratee(accumulator, value, index, object);
        });
        return accumulator;
      }
      function unset(object, path) {
        return object == null ? true : baseUnset(object, path);
      }
      function update(object, path, updater) {
        return object == null ? object : baseUpdate(object, path, castFunction(updater));
      }
      function updateWith(object, path, updater, customizer) {
        customizer = typeof customizer == 'function' ? customizer : undefined$1;
        return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);
      }
      function values(object) {
        return object == null ? [] : baseValues(object, keys(object));
      }
      function valuesIn(object) {
        return object == null ? [] : baseValues(object, keysIn(object));
      }
      function clamp(number, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber(number), lower, upper);
      }
      function inRange(number, start, end) {
        start = toFinite(start);
        if (end === undefined$1) {
          end = start;
          start = 0;
        } else {
          end = toFinite(end);
        }
        number = toNumber(number);
        return baseInRange(number, start, end);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != 'boolean' && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == 'boolean') {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == 'boolean') {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin(lower + rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function (result, word, index) {
        word = word.toLowerCase();
        return result + (index ? capitalize(word) : word);
      });
      function capitalize(string) {
        return upperFirst(toString(string).toLowerCase());
      }
      function deburr(string) {
        string = toString(string);
        return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');
      }
      function endsWith(string, target, position) {
        string = toString(string);
        target = baseToString(target);
        var length = string.length;
        position = position === undefined$1 ? length : baseClamp(toInteger(position), 0, length);
        var end = position;
        position -= target.length;
        return position >= 0 && string.slice(position, end) == target;
      }
      function escape(string) {
        string = toString(string);
        return string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
      }
      function escapeRegExp(string) {
        string = toString(string);
        return string && reHasRegExpChar.test(string) ? string.replace(reRegExpChar, '\\$&') : string;
      }
      var kebabCase = createCompounder(function (result, word, index) {
        return result + (index ? '-' : '') + word.toLowerCase();
      });
      var lowerCase = createCompounder(function (result, word, index) {
        return result + (index ? ' ' : '') + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst('toLowerCase');
      function pad(string, length, chars) {
        string = toString(string);
        length = toInteger(length);
        var strLength = length ? stringSize(string) : 0;
        if (!length || strLength >= length) {
          return string;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string, length, chars) {
        string = toString(string);
        length = toInteger(length);
        var strLength = length ? stringSize(string) : 0;
        return length && strLength < length ? string + createPadding(length - strLength, chars) : string;
      }
      function padStart(string, length, chars) {
        string = toString(string);
        length = toInteger(length);
        var strLength = length ? stringSize(string) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string : string;
      }
      function parseInt(string, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);
      }
      function repeat(string, n, guard) {
        if (guard ? isIterateeCall(string, n, guard) : n === undefined$1) {
          n = 1;
        } else {
          n = toInteger(n);
        }
        return baseRepeat(toString(string), n);
      }
      function replace() {
        var args = arguments, string = toString(args[0]);
        return args.length < 3 ? string : string.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function (result, word, index) {
        return result + (index ? '_' : '') + word.toLowerCase();
      });
      function split(string, separator, limit) {
        if (limit && typeof limit != 'number' && isIterateeCall(string, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string = toString(string);
        if (string && (typeof separator == 'string' || separator != null && !isRegExp(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string)) {
            return castSlice(stringToArray(string), 0, limit);
          }
        }
        return string.split(separator, limit);
      }
      var startCase = createCompounder(function (result, word, index) {
        return result + (index ? ' ' : '') + upperFirst(word);
      });
      function startsWith(string, target, position) {
        string = toString(string);
        position = position == null ? 0 : baseClamp(toInteger(position), 0, string.length);
        target = baseToString(target);
        return string.slice(position, position + target.length) == target;
      }
      function template(string, options, guard) {
        var settings = lodash.templateSettings;
        if (guard && isIterateeCall(string, options, guard)) {
          options = undefined$1;
        }
        string = toString(string);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp((options.escape || reNoMatch).source + '|' + interpolate.source + '|' + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' + (options.evaluate || reNoMatch).source + '|$', 'g');
        var sourceURL = '//# sourceURL=' + (hasOwnProperty.call(options, 'sourceURL') ? (options.sourceURL + '').replace(/\s/g, ' ') : 'lodash.templateSources[' + ++templateCounter + ']') + '\n';
        string.replace(reDelimiters, function (match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index = offset + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty.call(options, 'variable') && options.variable;
        if (!variable) {
          source = 'with (obj) {\n' + source + '\n}\n';
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source).replace(reEmptyStringMiddle, '$1').replace(reEmptyStringTrailing, '$1;');
        source = 'function(' + (variable || 'obj') + ') {\n' + (variable ? '' : 'obj || (obj = {});\n') + "var __t, __p = ''" + (isEscaping ? ', __e = _.escape' : '') + (isEvaluating ? ', __j = Array.prototype.join;\n' + "function print() { __p += __j.call(arguments, '') }\n" : ';\n') + source + 'return __p\n}';
        var result = attempt(function () {
          return Function(importsKeys, sourceURL + 'return ' + source).apply(undefined$1, importsValues);
        });
        result.source = source;
        if (isError(result)) {
          throw result;
        }
        return result;
      }
      function toLower(value) {
        return toString(value).toLowerCase();
      }
      function toUpper(value) {
        return toString(value).toUpperCase();
      }
      function trim(string, chars, guard) {
        string = toString(string);
        if (string && (guard || chars === undefined$1)) {
          return baseTrim(string);
        }
        if (!string || !(chars = baseToString(chars))) {
          return string;
        }
        var strSymbols = stringToArray(string), chrSymbols = stringToArray(chars), start = charsStartIndex(strSymbols, chrSymbols), end = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start, end).join('');
      }
      function trimEnd(string, chars, guard) {
        string = toString(string);
        if (string && (guard || chars === undefined$1)) {
          return string.slice(0, trimmedEndIndex(string) + 1);
        }
        if (!string || !(chars = baseToString(chars))) {
          return string;
        }
        var strSymbols = stringToArray(string), end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end).join('');
      }
      function trimStart(string, chars, guard) {
        string = toString(string);
        if (string && (guard || chars === undefined$1)) {
          return string.replace(reTrimStart, '');
        }
        if (!string || !(chars = baseToString(chars))) {
          return string;
        }
        var strSymbols = stringToArray(string), start = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start).join('');
      }
      function truncate(string, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject(options)) {
          var separator = ('separator' in options) ? options.separator : separator;
          length = ('length' in options) ? toInteger(options.length) : length;
          omission = ('omission' in options) ? baseToString(options.omission) : omission;
        }
        string = toString(string);
        var strLength = string.length;
        if (hasUnicode(string)) {
          var strSymbols = stringToArray(string);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string;
        }
        var end = length - stringSize(omission);
        if (end < 1) {
          return omission;
        }
        var result = strSymbols ? castSlice(strSymbols, 0, end).join('') : string.slice(0, end);
        if (separator === undefined$1) {
          return result + omission;
        }
        if (strSymbols) {
          end += result.length - end;
        }
        if (isRegExp(separator)) {
          if (string.slice(end).search(separator)) {
            var match, substring = result;
            if (!separator.global) {
              separator = RegExp(separator.source, toString(reFlags.exec(separator)) + 'g');
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result = result.slice(0, newEnd === undefined$1 ? end : newEnd);
          }
        } else if (string.indexOf(baseToString(separator), end) != end) {
          var index = result.lastIndexOf(separator);
          if (index > -1) {
            result = result.slice(0, index);
          }
        }
        return result + omission;
      }
      function unescape(string) {
        string = toString(string);
        return string && reHasEscapedHtml.test(string) ? string.replace(reEscapedHtml, unescapeHtmlChar) : string;
      }
      var upperCase = createCompounder(function (result, word, index) {
        return result + (index ? ' ' : '') + word.toUpperCase();
      });
      var upperFirst = createCaseFirst('toUpperCase');
      function words(string, pattern, guard) {
        string = toString(string);
        pattern = guard ? undefined$1 : pattern;
        if (pattern === undefined$1) {
          return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
        }
        return string.match(pattern) || [];
      }
      var attempt = baseRest(function (func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e) {
          return isError(e) ? e : new Error(e);
        }
      });
      var bindAll = flatRest(function (object, methodNames) {
        arrayEach(methodNames, function (key) {
          key = toKey(key);
          baseAssignValue(object, key, bind(object[key], object));
        });
        return object;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function (pair) {
          if (typeof pair[1] != 'function') {
            throw new TypeError(FUNC_ERROR_TEXT);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function (args) {
          var index = -1;
          while (++index < length) {
            var pair = pairs[index];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function () {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == 'function' ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method = baseRest(function (path, args) {
        return function (object) {
          return baseInvoke(object, path, args);
        };
      });
      var methodOf = baseRest(function (object, args) {
        return function (path) {
          return baseInvoke(object, path, args);
        };
      });
      function mixin(object, source, options) {
        var props = keys(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object;
          object = this;
          methodNames = baseFunctions(source, keys(source));
        }
        var chain = !(isObject(options) && ('chain' in options)) || !!options.chain, isFunc = isFunction(object);
        arrayEach(methodNames, function (methodName) {
          var func = source[methodName];
          object[methodName] = func;
          if (isFunc) {
            object.prototype[methodName] = function () {
              var chainAll = this.__chain__;
              if (chain || chainAll) {
                var result = object(this.__wrapped__), actions = result.__actions__ = copyArray(this.__actions__);
                actions.push({
                  'func': func,
                  'args': arguments,
                  'thisArg': object
                });
                result.__chain__ = chainAll;
                return result;
              }
              return func.apply(object, arrayPush([this.value()], arguments));
            };
          }
        });
        return object;
      }
      function noConflict() {
        if (root._ === this) {
          root._ = oldDash;
        }
        return this;
      }
      function noop() {}
      function nthArg(n) {
        n = toInteger(n);
        return baseRest(function (args) {
          return baseNth(args, n);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object) {
        return function (path) {
          return object == null ? undefined$1 : baseGet(object, path);
        };
      }
      var range = createRange();
      var rangeRight = createRange(true);
      function stubArray() {
        return [];
      }
      function stubFalse() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return '';
      }
      function stubTrue() {
        return true;
      }
      function times(n, iteratee) {
        n = toInteger(n);
        if (n < 1 || n > MAX_SAFE_INTEGER) {
          return [];
        }
        var index = MAX_ARRAY_LENGTH, length = nativeMin(n, MAX_ARRAY_LENGTH);
        iteratee = getIteratee(iteratee);
        n -= MAX_ARRAY_LENGTH;
        var result = baseTimes(length, iteratee);
        while (++index < n) {
          iteratee(index);
        }
        return result;
      }
      function toPath(value) {
        if (isArray(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
      }
      function uniqueId(prefix) {
        var id = ++idCounter;
        return toString(prefix) + id;
      }
      var add = createMathOperation(function (augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound('ceil');
      var divide = createMathOperation(function (dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound('floor');
      function max(array) {
        return array && array.length ? baseExtremum(array, identity, baseGt) : undefined$1;
      }
      function maxBy(array, iteratee) {
        return array && array.length ? baseExtremum(array, getIteratee(iteratee, 2), baseGt) : undefined$1;
      }
      function mean(array) {
        return baseMean(array, identity);
      }
      function meanBy(array, iteratee) {
        return baseMean(array, getIteratee(iteratee, 2));
      }
      function min(array) {
        return array && array.length ? baseExtremum(array, identity, baseLt) : undefined$1;
      }
      function minBy(array, iteratee) {
        return array && array.length ? baseExtremum(array, getIteratee(iteratee, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function (multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round = createRound('round');
      var subtract = createMathOperation(function (minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum(array) {
        return array && array.length ? baseSum(array, identity) : 0;
      }
      function sumBy(array, iteratee) {
        return array && array.length ? baseSum(array, getIteratee(iteratee, 2)) : 0;
      }
      lodash.after = after;
      lodash.ary = ary;
      lodash.assign = assign;
      lodash.assignIn = assignIn;
      lodash.assignInWith = assignInWith;
      lodash.assignWith = assignWith;
      lodash.at = at;
      lodash.before = before;
      lodash.bind = bind;
      lodash.bindAll = bindAll;
      lodash.bindKey = bindKey;
      lodash.castArray = castArray;
      lodash.chain = chain;
      lodash.chunk = chunk;
      lodash.compact = compact;
      lodash.concat = concat;
      lodash.cond = cond;
      lodash.conforms = conforms;
      lodash.constant = constant;
      lodash.countBy = countBy;
      lodash.create = create;
      lodash.curry = curry;
      lodash.curryRight = curryRight;
      lodash.debounce = debounce;
      lodash.defaults = defaults;
      lodash.defaultsDeep = defaultsDeep;
      lodash.defer = defer;
      lodash.delay = delay;
      lodash.difference = difference;
      lodash.differenceBy = differenceBy;
      lodash.differenceWith = differenceWith;
      lodash.drop = drop;
      lodash.dropRight = dropRight;
      lodash.dropRightWhile = dropRightWhile;
      lodash.dropWhile = dropWhile;
      lodash.fill = fill;
      lodash.filter = filter;
      lodash.flatMap = flatMap;
      lodash.flatMapDeep = flatMapDeep;
      lodash.flatMapDepth = flatMapDepth;
      lodash.flatten = flatten;
      lodash.flattenDeep = flattenDeep;
      lodash.flattenDepth = flattenDepth;
      lodash.flip = flip;
      lodash.flow = flow;
      lodash.flowRight = flowRight;
      lodash.fromPairs = fromPairs;
      lodash.functions = functions;
      lodash.functionsIn = functionsIn;
      lodash.groupBy = groupBy;
      lodash.initial = initial;
      lodash.intersection = intersection;
      lodash.intersectionBy = intersectionBy;
      lodash.intersectionWith = intersectionWith;
      lodash.invert = invert;
      lodash.invertBy = invertBy;
      lodash.invokeMap = invokeMap;
      lodash.iteratee = iteratee;
      lodash.keyBy = keyBy;
      lodash.keys = keys;
      lodash.keysIn = keysIn;
      lodash.map = map;
      lodash.mapKeys = mapKeys;
      lodash.mapValues = mapValues;
      lodash.matches = matches;
      lodash.matchesProperty = matchesProperty;
      lodash.memoize = memoize;
      lodash.merge = merge;
      lodash.mergeWith = mergeWith;
      lodash.method = method;
      lodash.methodOf = methodOf;
      lodash.mixin = mixin;
      lodash.negate = negate;
      lodash.nthArg = nthArg;
      lodash.omit = omit;
      lodash.omitBy = omitBy;
      lodash.once = once;
      lodash.orderBy = orderBy;
      lodash.over = over;
      lodash.overArgs = overArgs;
      lodash.overEvery = overEvery;
      lodash.overSome = overSome;
      lodash.partial = partial;
      lodash.partialRight = partialRight;
      lodash.partition = partition;
      lodash.pick = pick;
      lodash.pickBy = pickBy;
      lodash.property = property;
      lodash.propertyOf = propertyOf;
      lodash.pull = pull;
      lodash.pullAll = pullAll;
      lodash.pullAllBy = pullAllBy;
      lodash.pullAllWith = pullAllWith;
      lodash.pullAt = pullAt;
      lodash.range = range;
      lodash.rangeRight = rangeRight;
      lodash.rearg = rearg;
      lodash.reject = reject;
      lodash.remove = remove;
      lodash.rest = rest;
      lodash.reverse = reverse;
      lodash.sampleSize = sampleSize;
      lodash.set = set;
      lodash.setWith = setWith;
      lodash.shuffle = shuffle;
      lodash.slice = slice;
      lodash.sortBy = sortBy;
      lodash.sortedUniq = sortedUniq;
      lodash.sortedUniqBy = sortedUniqBy;
      lodash.split = split;
      lodash.spread = spread;
      lodash.tail = tail;
      lodash.take = take;
      lodash.takeRight = takeRight;
      lodash.takeRightWhile = takeRightWhile;
      lodash.takeWhile = takeWhile;
      lodash.tap = tap;
      lodash.throttle = throttle;
      lodash.thru = thru;
      lodash.toArray = toArray;
      lodash.toPairs = toPairs;
      lodash.toPairsIn = toPairsIn;
      lodash.toPath = toPath;
      lodash.toPlainObject = toPlainObject;
      lodash.transform = transform;
      lodash.unary = unary;
      lodash.union = union;
      lodash.unionBy = unionBy;
      lodash.unionWith = unionWith;
      lodash.uniq = uniq;
      lodash.uniqBy = uniqBy;
      lodash.uniqWith = uniqWith;
      lodash.unset = unset;
      lodash.unzip = unzip;
      lodash.unzipWith = unzipWith;
      lodash.update = update;
      lodash.updateWith = updateWith;
      lodash.values = values;
      lodash.valuesIn = valuesIn;
      lodash.without = without;
      lodash.words = words;
      lodash.wrap = wrap;
      lodash.xor = xor;
      lodash.xorBy = xorBy;
      lodash.xorWith = xorWith;
      lodash.zip = zip;
      lodash.zipObject = zipObject;
      lodash.zipObjectDeep = zipObjectDeep;
      lodash.zipWith = zipWith;
      lodash.entries = toPairs;
      lodash.entriesIn = toPairsIn;
      lodash.extend = assignIn;
      lodash.extendWith = assignInWith;
      mixin(lodash, lodash);
      lodash.add = add;
      lodash.attempt = attempt;
      lodash.camelCase = camelCase;
      lodash.capitalize = capitalize;
      lodash.ceil = ceil;
      lodash.clamp = clamp;
      lodash.clone = clone;
      lodash.cloneDeep = cloneDeep;
      lodash.cloneDeepWith = cloneDeepWith;
      lodash.cloneWith = cloneWith;
      lodash.conformsTo = conformsTo;
      lodash.deburr = deburr;
      lodash.defaultTo = defaultTo;
      lodash.divide = divide;
      lodash.endsWith = endsWith;
      lodash.eq = eq;
      lodash.escape = escape;
      lodash.escapeRegExp = escapeRegExp;
      lodash.every = every;
      lodash.find = find;
      lodash.findIndex = findIndex;
      lodash.findKey = findKey;
      lodash.findLast = findLast;
      lodash.findLastIndex = findLastIndex;
      lodash.findLastKey = findLastKey;
      lodash.floor = floor;
      lodash.forEach = forEach;
      lodash.forEachRight = forEachRight;
      lodash.forIn = forIn;
      lodash.forInRight = forInRight;
      lodash.forOwn = forOwn;
      lodash.forOwnRight = forOwnRight;
      lodash.get = get;
      lodash.gt = gt;
      lodash.gte = gte;
      lodash.has = has;
      lodash.hasIn = hasIn;
      lodash.head = head;
      lodash.identity = identity;
      lodash.includes = includes;
      lodash.indexOf = indexOf;
      lodash.inRange = inRange;
      lodash.invoke = invoke;
      lodash.isArguments = isArguments;
      lodash.isArray = isArray;
      lodash.isArrayBuffer = isArrayBuffer;
      lodash.isArrayLike = isArrayLike;
      lodash.isArrayLikeObject = isArrayLikeObject;
      lodash.isBoolean = isBoolean;
      lodash.isBuffer = isBuffer;
      lodash.isDate = isDate;
      lodash.isElement = isElement;
      lodash.isEmpty = isEmpty;
      lodash.isEqual = isEqual;
      lodash.isEqualWith = isEqualWith;
      lodash.isError = isError;
      lodash.isFinite = isFinite;
      lodash.isFunction = isFunction;
      lodash.isInteger = isInteger;
      lodash.isLength = isLength;
      lodash.isMap = isMap;
      lodash.isMatch = isMatch;
      lodash.isMatchWith = isMatchWith;
      lodash.isNaN = isNaN;
      lodash.isNative = isNative;
      lodash.isNil = isNil;
      lodash.isNull = isNull;
      lodash.isNumber = isNumber;
      lodash.isObject = isObject;
      lodash.isObjectLike = isObjectLike;
      lodash.isPlainObject = isPlainObject;
      lodash.isRegExp = isRegExp;
      lodash.isSafeInteger = isSafeInteger;
      lodash.isSet = isSet;
      lodash.isString = isString;
      lodash.isSymbol = isSymbol;
      lodash.isTypedArray = isTypedArray;
      lodash.isUndefined = isUndefined;
      lodash.isWeakMap = isWeakMap;
      lodash.isWeakSet = isWeakSet;
      lodash.join = join;
      lodash.kebabCase = kebabCase;
      lodash.last = last;
      lodash.lastIndexOf = lastIndexOf;
      lodash.lowerCase = lowerCase;
      lodash.lowerFirst = lowerFirst;
      lodash.lt = lt;
      lodash.lte = lte;
      lodash.max = max;
      lodash.maxBy = maxBy;
      lodash.mean = mean;
      lodash.meanBy = meanBy;
      lodash.min = min;
      lodash.minBy = minBy;
      lodash.stubArray = stubArray;
      lodash.stubFalse = stubFalse;
      lodash.stubObject = stubObject;
      lodash.stubString = stubString;
      lodash.stubTrue = stubTrue;
      lodash.multiply = multiply;
      lodash.nth = nth;
      lodash.noConflict = noConflict;
      lodash.noop = noop;
      lodash.now = now;
      lodash.pad = pad;
      lodash.padEnd = padEnd;
      lodash.padStart = padStart;
      lodash.parseInt = parseInt;
      lodash.random = random;
      lodash.reduce = reduce;
      lodash.reduceRight = reduceRight;
      lodash.repeat = repeat;
      lodash.replace = replace;
      lodash.result = result;
      lodash.round = round;
      lodash.runInContext = runInContext;
      lodash.sample = sample;
      lodash.size = size;
      lodash.snakeCase = snakeCase;
      lodash.some = some;
      lodash.sortedIndex = sortedIndex;
      lodash.sortedIndexBy = sortedIndexBy;
      lodash.sortedIndexOf = sortedIndexOf;
      lodash.sortedLastIndex = sortedLastIndex;
      lodash.sortedLastIndexBy = sortedLastIndexBy;
      lodash.sortedLastIndexOf = sortedLastIndexOf;
      lodash.startCase = startCase;
      lodash.startsWith = startsWith;
      lodash.subtract = subtract;
      lodash.sum = sum;
      lodash.sumBy = sumBy;
      lodash.template = template;
      lodash.times = times;
      lodash.toFinite = toFinite;
      lodash.toInteger = toInteger;
      lodash.toLength = toLength;
      lodash.toLower = toLower;
      lodash.toNumber = toNumber;
      lodash.toSafeInteger = toSafeInteger;
      lodash.toString = toString;
      lodash.toUpper = toUpper;
      lodash.trim = trim;
      lodash.trimEnd = trimEnd;
      lodash.trimStart = trimStart;
      lodash.truncate = truncate;
      lodash.unescape = unescape;
      lodash.uniqueId = uniqueId;
      lodash.upperCase = upperCase;
      lodash.upperFirst = upperFirst;
      lodash.each = forEach;
      lodash.eachRight = forEachRight;
      lodash.first = head;
      mixin(lodash, (function () {
        var source = {};
        baseForOwn(lodash, function (func, methodName) {
          if (!hasOwnProperty.call(lodash.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      })(), {
        'chain': false
      });
      lodash.VERSION = VERSION;
      arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function (methodName) {
        lodash[methodName].placeholder = lodash;
      });
      arrayEach(['drop', 'take'], function (methodName, index) {
        LazyWrapper.prototype[methodName] = function (n) {
          n = n === undefined$1 ? 1 : nativeMax(toInteger(n), 0);
          var result = this.__filtered__ && !index ? new LazyWrapper(this) : this.clone();
          if (result.__filtered__) {
            result.__takeCount__ = nativeMin(n, result.__takeCount__);
          } else {
            result.__views__.push({
              'size': nativeMin(n, MAX_ARRAY_LENGTH),
              'type': methodName + (result.__dir__ < 0 ? 'Right' : '')
            });
          }
          return result;
        };
        LazyWrapper.prototype[methodName + 'Right'] = function (n) {
          return this.reverse()[methodName](n).reverse();
        };
      });
      arrayEach(['filter', 'map', 'takeWhile'], function (methodName, index) {
        var type = index + 1, isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function (iteratee) {
          var result = this.clone();
          result.__iteratees__.push({
            'iteratee': getIteratee(iteratee, 3),
            'type': type
          });
          result.__filtered__ = result.__filtered__ || isFilter;
          return result;
        };
      });
      arrayEach(['head', 'last'], function (methodName, index) {
        var takeName = 'take' + (index ? 'Right' : '');
        LazyWrapper.prototype[methodName] = function () {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(['initial', 'tail'], function (methodName, index) {
        var dropName = 'drop' + (index ? '' : 'Right');
        LazyWrapper.prototype[methodName] = function () {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function () {
        return this.filter(identity);
      };
      LazyWrapper.prototype.find = function (predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function (predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function (path, args) {
        if (typeof path == 'function') {
          return new LazyWrapper(this);
        }
        return this.map(function (value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function (predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function (start, end) {
        start = toInteger(start);
        var result = this;
        if (result.__filtered__ && (start > 0 || end < 0)) {
          return new LazyWrapper(result);
        }
        if (start < 0) {
          result = result.takeRight(-start);
        } else if (start) {
          result = result.drop(start);
        }
        if (end !== undefined$1) {
          end = toInteger(end);
          result = end < 0 ? result.dropRight(-end) : result.take(end - start);
        }
        return result;
      };
      LazyWrapper.prototype.takeRightWhile = function (predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function () {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function (func, methodName) {
        var checkIteratee = (/^(?:filter|find|map|reject)|While$/).test(methodName), isTaker = (/^(?:head|last)$/).test(methodName), lodashFunc = lodash[isTaker ? 'take' + (methodName == 'last' ? 'Right' : '') : methodName], retUnwrapped = isTaker || (/^find/).test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash.prototype[methodName] = function () {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee = args[0], useLazy = isLazy || isArray(value);
          var interceptor = function (value) {
            var result = lodashFunc.apply(lodash, arrayPush([value], args));
            return isTaker && chainAll ? result[0] : result;
          };
          if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result = func.apply(value, args);
            result.__actions__.push({
              'func': thru,
              'args': [interceptor],
              'thisArg': undefined$1
            });
            return new LodashWrapper(result, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result.value()[0] : result.value() : result;
        };
      });
      arrayEach(['pop', 'push', 'shift', 'sort', 'splice', 'unshift'], function (methodName) {
        var func = arrayProto[methodName], chainName = (/^(?:push|sort|unshift)$/).test(methodName) ? 'tap' : 'thru', retUnwrapped = (/^(?:pop|shift)$/).test(methodName);
        lodash.prototype[methodName] = function () {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray(value) ? value : [], args);
          }
          return this[chainName](function (value) {
            return func.apply(isArray(value) ? value : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function (func, methodName) {
        var lodashFunc = lodash[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + '';
          if (!hasOwnProperty.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({
            'name': methodName,
            'func': lodashFunc
          });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        'name': 'wrapper',
        'func': undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash.prototype.at = wrapperAt;
      lodash.prototype.chain = wrapperChain;
      lodash.prototype.commit = wrapperCommit;
      lodash.prototype.next = wrapperNext;
      lodash.prototype.plant = wrapperPlant;
      lodash.prototype.reverse = wrapperReverse;
      lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;
      lodash.prototype.first = lodash.prototype.head;
      if (symIterator) {
        lodash.prototype[symIterator] = wrapperToIterator;
      }
      return lodash;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
var _ = lodash.exports;

const reduceText = (acc, n) => {
  if (n.node && n.node.kind === 'text') {
    acc += n.node.text;
  }
  return acc;
};
class Line {
  constructor() {
    this.kind = 'line';
  }
  get columns() {
    return [];
  }
}
class Row {
  constructor(columns, operator) {
    this.kind = 'row';
    this.operator = operator;
    this.columns = columns;
  }
  pad(count, direction = 'right') {
    if (count < this.columns.length) {
      throw new Error('no');
    }
    const diff = count - this.columns.length;
    const padding = _.times(diff).map(() => '__pad__');
    return direction === 'right' ? [...padding, ...this.columns] : [...this.columns, ...padding];
  }
}
const mathNodeToCharArray = mn => {
  const text = mn.childNodes.reduce(reduceText, '');
  return text.split('');
};
const toColumnArray = child => {
  if (!child || !child.kind) {
    return [];
  }
  if (child.kind === 'msrow') {
    throw new Error('msrow in msrow?');
  }
  if (child.kind === 'mo') {
    console.warn('mo that is not 1st node in msrow?');
    return mathNodeToCharArray(child);
  }
  if (child.kind === 'mn') {
    return mathNodeToCharArray(child);
  }
  if (child.toCHTML) {
    return child;
  }
};
const rowStack = child => {
  if (!child || !child.kind) {
    return;
  }
  if (child.kind === 'msrow') {
    if (!child.childNodes || child.childNodes.length === 0) {
      return new Row([]);
    }
    const f = _.first(child.childNodes);
    const nodes = f && f.kind === 'mo' ? _.tail(child.childNodes) : child.childNodes;
    const columns = _.flatten(nodes.map(toColumnArray));
    return new Row(columns, f.kind === 'mo' ? f : undefined);
  }
  if (child.kind === 'mn') {
    const columns = mathNodeToCharArray(child);
    return new Row(columns, undefined);
  }
  if (child.kind === 'mo') {
    console.warn('mo on its own row?');
    return new Row([], child);
  }
  if (child.kind === 'msline') {
    return new Line();
  }
  if (child.toCHTML) {
    return new Row([child]);
  }
};
const getStackData = mstack => {
  if (!mstack || !mstack.childNodes) {
    return [];
  }
  return _.compact(mstack.childNodes.map(rowStack));
};
class CHTMLmstack extends Wrapper$3.CHTMLWrapper {
  constructor(factory, node, parent = null) {
    super(factory, node, parent);
    this.ce = this.adaptor.document.createElement.bind(this.adaptor.document);
  }
  toCHTML(parent) {
    const chtml = this.standardCHTMLnode(parent);
    const stackData = getStackData(this);
    const maxCols = stackData.reduce((acc, r) => {
      if (r && r.columns.length > acc) {
        acc = r.columns.length;
      }
      return acc;
    }, 0);
    const table = this.ce('table');
    chtml.appendChild(table);
    stackData.forEach(row => {
      const tr = this.ce('tr');
      table.appendChild(tr);
      if (row.kind === 'row') {
        const td = this.ce('td');
        tr.appendChild(td);
        if (row.operator && row.operator.toCHTML) {
          td.setAttribute('class', 'inner');
          row.operator.toCHTML(td);
        } else {
          td.textContent = '';
        }
        const cols = row.pad(maxCols, 'right');
        cols.forEach(c => {
          const t = this.ce('td');
          tr.appendChild(t);
          if (c === '__pad__') {
            t.textContent = '';
          } else if (typeof c === 'string') {
            t.textContent = c;
          } else if (c.kind === 'none') {
            t.textContent = '';
          } else if (c.toCHTML) {
            t.setAttribute('class', 'inner');
            c.toCHTML(t);
          }
        });
      } else if (row.kind === 'line') {
        const td = this.ce('td');
        tr.appendChild(td);
        td.setAttribute('colspan', maxCols + 1);
        td.setAttribute('class', 'mjx-line');
        td.textContent = '';
      }
    });
  }
}
CHTMLmstack.styles = {
  'mjx-mstack > table': {
    'line-height': 'initial',
    border: 'solid 0px red',
    'border-spacing': '0em',
    'border-collapse': 'separate'
  },
  'mjx-mstack > table > tr': {
    'line-height': 'initial'
  },
  'mjx-mstack > table > tr > td': {
    border: 'solid 0px blue',
    'font-family': 'sans-serif',
    'line-height': 'initial'
  },
  'mjx-mstack > table > tr > td.inner': {
    'font-family': 'inherit'
  },
  'mjx-mstack > table > tr > .mjx-line': {
    padding: 0,
    'border-top': 'solid 1px black'
  },
  '.TEX-A': {
    'font-family': 'MJXZERO, MJXTEX !important'
  }
};

class MmlNone extends MmlNode.AbstractMmlNode {
  get kind() {
    return 'none';
  }
}
class MmlMstack extends MmlNode.AbstractMmlNode {
  get kind() {
    return 'mstack';
  }
}
class MmlMsrow extends MmlNode.AbstractMmlNode {
  get kind() {
    return 'msrow';
  }
}
class MmlMsline extends MmlNode.AbstractMmlNode {
  get kind() {
    return 'msline';
  }
}

const chtmlNodes = {
  mstack: CHTMLmstack
};
const mmlNodes = {
  mstack: MmlMstack,
  msline: MmlMsline,
  msrow: MmlMsrow,
  none: MmlNone
};

var browser = {
  exports: {}
};

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var w = d * 7;
var y = d * 365.25;
var ms = function (val, options) {
  options = options || ({});
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse$1(val);
  } else if (type === 'number' && isFinite(val)) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error('val is not a non-empty string or a valid number. val=' + JSON.stringify(val));
};
function parse$1(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = (/^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i).exec(str);
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'weeks':
    case 'week':
    case 'w':
      return n * w;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}
function fmtShort(ms) {
  var msAbs = Math.abs(ms);
  if (msAbs >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (msAbs >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (msAbs >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (msAbs >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}
function fmtLong(ms) {
  var msAbs = Math.abs(ms);
  if (msAbs >= d) {
    return plural(ms, msAbs, d, 'day');
  }
  if (msAbs >= h) {
    return plural(ms, msAbs, h, 'hour');
  }
  if (msAbs >= m) {
    return plural(ms, msAbs, m, 'minute');
  }
  if (msAbs >= s) {
    return plural(ms, msAbs, s, 'second');
  }
  return ms + ' ms';
}
function plural(ms, msAbs, n, name) {
  var isPlural = msAbs >= n * 1.5;
  return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
}

function setup(env) {
  createDebug.debug = createDebug;
  createDebug.default = createDebug;
  createDebug.coerce = coerce;
  createDebug.disable = disable;
  createDebug.enable = enable;
  createDebug.enabled = enabled;
  createDebug.humanize = ms;
  createDebug.destroy = destroy;
  Object.keys(env).forEach(key => {
    createDebug[key] = env[key];
  });
  createDebug.names = [];
  createDebug.skips = [];
  createDebug.formatters = {};
  function selectColor(namespace) {
    let hash = 0;
    for (let i = 0; i < namespace.length; i++) {
      hash = (hash << 5) - hash + namespace.charCodeAt(i);
      hash |= 0;
    }
    return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
  }
  createDebug.selectColor = selectColor;
  function createDebug(namespace) {
    let prevTime;
    let enableOverride = null;
    let namespacesCache;
    let enabledCache;
    function debug(...args) {
      if (!debug.enabled) {
        return;
      }
      const self = debug;
      const curr = Number(new Date());
      const ms = curr - (prevTime || curr);
      self.diff = ms;
      self.prev = prevTime;
      self.curr = curr;
      prevTime = curr;
      args[0] = createDebug.coerce(args[0]);
      if (typeof args[0] !== 'string') {
        args.unshift('%O');
      }
      let index = 0;
      args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
        if (match === '%%') {
          return '%';
        }
        index++;
        const formatter = createDebug.formatters[format];
        if (typeof formatter === 'function') {
          const val = args[index];
          match = formatter.call(self, val);
          args.splice(index, 1);
          index--;
        }
        return match;
      });
      createDebug.formatArgs.call(self, args);
      const logFn = self.log || createDebug.log;
      logFn.apply(self, args);
    }
    debug.namespace = namespace;
    debug.useColors = createDebug.useColors();
    debug.color = createDebug.selectColor(namespace);
    debug.extend = extend;
    debug.destroy = createDebug.destroy;
    Object.defineProperty(debug, 'enabled', {
      enumerable: true,
      configurable: false,
      get: () => {
        if (enableOverride !== null) {
          return enableOverride;
        }
        if (namespacesCache !== createDebug.namespaces) {
          namespacesCache = createDebug.namespaces;
          enabledCache = createDebug.enabled(namespace);
        }
        return enabledCache;
      },
      set: v => {
        enableOverride = v;
      }
    });
    if (typeof createDebug.init === 'function') {
      createDebug.init(debug);
    }
    return debug;
  }
  function extend(namespace, delimiter) {
    const newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
    newDebug.log = this.log;
    return newDebug;
  }
  function enable(namespaces) {
    createDebug.save(namespaces);
    createDebug.namespaces = namespaces;
    createDebug.names = [];
    createDebug.skips = [];
    let i;
    const split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
    const len = split.length;
    for (i = 0; i < len; i++) {
      if (!split[i]) {
        continue;
      }
      namespaces = split[i].replace(/\*/g, '.*?');
      if (namespaces[0] === '-') {
        createDebug.skips.push(new RegExp('^' + namespaces.slice(1) + '$'));
      } else {
        createDebug.names.push(new RegExp('^' + namespaces + '$'));
      }
    }
  }
  function disable() {
    const namespaces = [...createDebug.names.map(toNamespace), ...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace)].join(',');
    createDebug.enable('');
    return namespaces;
  }
  function enabled(name) {
    if (name[name.length - 1] === '*') {
      return true;
    }
    let i;
    let len;
    for ((i = 0, len = createDebug.skips.length); i < len; i++) {
      if (createDebug.skips[i].test(name)) {
        return false;
      }
    }
    for ((i = 0, len = createDebug.names.length); i < len; i++) {
      if (createDebug.names[i].test(name)) {
        return true;
      }
    }
    return false;
  }
  function toNamespace(regexp) {
    return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, '*');
  }
  function coerce(val) {
    if (val instanceof Error) {
      return val.stack || val.message;
    }
    return val;
  }
  function destroy() {
    console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
  }
  createDebug.enable(createDebug.load());
  return createDebug;
}
var common = setup;

(function (module, exports) {
  exports.formatArgs = formatArgs;
  exports.save = save;
  exports.load = load;
  exports.useColors = useColors;
  exports.storage = localstorage();
  exports.destroy = (() => {
    let warned = false;
    return () => {
      if (!warned) {
        warned = true;
        console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
      }
    };
  })();
  exports.colors = ['#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC', '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF', '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC', '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF', '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC', '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033', '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366', '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933', '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC', '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF', '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'];
  function useColors() {
    if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
      return true;
    }
    if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
      return false;
    }
    return typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== 'undefined' && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
  }
  function formatArgs(args) {
    args[0] = (this.useColors ? '%c' : '') + this.namespace + (this.useColors ? ' %c' : ' ') + args[0] + (this.useColors ? '%c ' : ' ') + '+' + module.exports.humanize(this.diff);
    if (!this.useColors) {
      return;
    }
    const c = 'color: ' + this.color;
    args.splice(1, 0, c, 'color: inherit');
    let index = 0;
    let lastC = 0;
    args[0].replace(/%[a-zA-Z%]/g, match => {
      if (match === '%%') {
        return;
      }
      index++;
      if (match === '%c') {
        lastC = index;
      }
    });
    args.splice(lastC, 0, c);
  }
  exports.log = console.debug || console.log || (() => {});
  function save(namespaces) {
    try {
      if (namespaces) {
        exports.storage.setItem('debug', namespaces);
      } else {
        exports.storage.removeItem('debug');
      }
    } catch (error) {}
  }
  function load() {
    let r;
    try {
      r = exports.storage.getItem('debug');
    } catch (error) {}
    if (!r && typeof process !== 'undefined' && ('env' in process)) {
      r = process.env.DEBUG;
    }
    return r;
  }
  function localstorage() {
    try {
      return localStorage;
    } catch (error) {}
  }
  module.exports = common(exports);
  const {formatters} = module.exports;
  formatters.j = function (v) {
    try {
      return JSON.stringify(v);
    } catch (error) {
      return '[UnexpectedJSONParseError]: ' + error.message;
    }
  };
})(browser, browser.exports);
var debug = browser.exports;

const BracketTypes = {};
BracketTypes.ROUND_BRACKETS = 'round_brackets';
BracketTypes.SQUARE_BRACKETS = 'square_brackets';
BracketTypes.DOLLAR = 'dollar';
BracketTypes.DOUBLE_DOLLAR = 'double_dollar';
const PAIRS = {
  [BracketTypes.ROUND_BRACKETS]: ['\\(', '\\)'],
  [BracketTypes.SQUARE_BRACKETS]: ['\\[', '\\]'],
  [BracketTypes.DOLLAR]: ['$', '$'],
  [BracketTypes.DOUBLE_DOLLAR]: ['$$', '$$']
};
const wrapMath = (content, wrapType) => {
  if (wrapType === BracketTypes.SQUARE_BRACKETS) {
    console.warn('\\[...\\] is not supported yet');
    wrapType = BracketTypes.ROUND_BRACKETS;
  }
  if (wrapType === BracketTypes.DOUBLE_DOLLAR) {
    console.warn('$$...$$ is not supported yet');
    wrapType = BracketTypes.DOLLAR;
  }
  const [start, end] = PAIRS[wrapType] || PAIRS[BracketTypes.ROUND_BRACKETS];
  return `${start}${content}${end}`;
};
const unWrapMath = content => {
  const displayStyleIndex = content.indexOf('\\displaystyle');
  if (displayStyleIndex !== -1) {
    console.warn('\\displaystyle is not supported - removing');
    content = content.replace('\\displaystyle', '').trim();
  }
  if (content.startsWith('$$') && content.endsWith('$$')) {
    console.warn('$$ syntax is not yet supported');
    return {
      unwrapped: content.substring(2, content.length - 2),
      wrapType: BracketTypes.DOLLAR
    };
  }
  if (content.startsWith('$') && content.endsWith('$')) {
    return {
      unwrapped: content.substring(1, content.length - 1),
      wrapType: BracketTypes.DOLLAR
    };
  }
  if (content.startsWith('\\[') && content.endsWith('\\]')) {
    console.warn('\\[..\\] syntax is not yet supported');
    return {
      unwrapped: content.substring(2, content.length - 2),
      wrapType: BracketTypes.ROUND_BRACKETS
    };
  }
  if (content.startsWith('\\(') && content.endsWith('\\)')) {
    return {
      unwrapped: content.substring(2, content.length - 2),
      wrapType: BracketTypes.ROUND_BRACKETS
    };
  }
  return {
    unwrapped: content,
    wrapType: BracketTypes.ROUND_BRACKETS
  };
};

var SerializedMmlVisitor = {};

var MmlVisitor$1 = {};

var Visitor = {};

var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
  var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
  if (m) return m.call(o);
  if (o && typeof o.length === "number") return {
    next: function () {
      if (o && i >= o.length) o = void 0;
      return {
        value: o && o[i++],
        done: !o
      };
    }
  };
  throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
});
var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
  var m = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m) return o;
  var i = m.call(o), r, ar = [], e;
  try {
    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
  } catch (error) {
    e = {
      error: error
    };
  } finally {
    try {
      if (r && !r.done && (m = i["return"])) m.call(i);
    } finally {
      if (e) throw e.error;
    }
  }
  return ar;
});
var __spreadArray = commonjsGlobal && commonjsGlobal.__spreadArray || (function (to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !((i in from))) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
});
Object.defineProperty(Visitor, "__esModule", {
  value: true
});
Visitor.AbstractVisitor = void 0;
var Node_js_1 = Node$1;
var AbstractVisitor = (function () {
  function AbstractVisitor(factory) {
    var e_1, _a;
    this.nodeHandlers = new Map();
    try {
      for (var _b = __values(factory.getKinds()), _c = _b.next(); !_c.done; _c = _b.next()) {
        var kind = _c.value;
        var method = this[AbstractVisitor.methodName(kind)];
        if (method) {
          this.nodeHandlers.set(kind, method);
        }
      }
    } catch (e_1_1) {
      e_1 = {
        error: e_1_1
      };
    } finally {
      try {
        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
      } finally {
        if (e_1) throw e_1.error;
      }
    }
  }
  AbstractVisitor.methodName = function (kind) {
    return 'visit' + (kind.charAt(0).toUpperCase() + kind.substr(1)).replace(/[^a-z0-9_]/ig, '_') + 'Node';
  };
  AbstractVisitor.prototype.visitTree = function (tree) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    return this.visitNode.apply(this, __spreadArray([tree], __read(args), false));
  };
  AbstractVisitor.prototype.visitNode = function (node) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    var handler = this.nodeHandlers.get(node.kind) || this.visitDefault;
    return handler.call.apply(handler, __spreadArray([this, node], __read(args), false));
  };
  AbstractVisitor.prototype.visitDefault = function (node) {
    var e_2, _a;
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (node instanceof Node_js_1.AbstractNode) {
      try {
        for (var _b = __values(node.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          this.visitNode.apply(this, __spreadArray([child], __read(args), false));
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
    }
  };
  AbstractVisitor.prototype.setNodeHandler = function (kind, handler) {
    this.nodeHandlers.set(kind, handler);
  };
  AbstractVisitor.prototype.removeNodeHandler = function (kind) {
    this.nodeHandlers.delete(kind);
  };
  return AbstractVisitor;
})();
Visitor.AbstractVisitor = AbstractVisitor;

var __extends$1 = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(MmlVisitor$1, "__esModule", {
  value: true
});
MmlVisitor$1.MmlVisitor = void 0;
var MmlFactory_js_1 = MmlFactory$1;
var Visitor_js_1 = Visitor;
var MmlVisitor = (function (_super) {
  __extends$1(MmlVisitor, _super);
  function MmlVisitor(factory) {
    if (factory === void 0) {
      factory = null;
    }
    if (!factory) {
      factory = new MmlFactory_js_1.MmlFactory();
    }
    return _super.call(this, factory) || this;
  }
  MmlVisitor.prototype.visitTextNode = function (_node) {
    var _args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      _args[_i - 1] = arguments[_i];
    }
  };
  MmlVisitor.prototype.visitXMLNode = function (_node) {
    var _args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      _args[_i - 1] = arguments[_i];
    }
  };
  return MmlVisitor;
})(Visitor_js_1.AbstractVisitor);
MmlVisitor$1.MmlVisitor = MmlVisitor;

(function (exports) {
  var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || ({
        __proto__: []
      }) instanceof Array && (function (d, b) {
        d.__proto__ = b;
      }) || (function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      });
      return extendStatics(d, b);
    };
    return function (d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  })();
  var __values = commonjsGlobal && commonjsGlobal.__values || (function (o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
      next: function () {
        if (o && i >= o.length) o = void 0;
        return {
          value: o && o[i++],
          done: !o
        };
      }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  });
  var __read = commonjsGlobal && commonjsGlobal.__read || (function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
      while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    } catch (error) {
      e = {
        error: error
      };
    } finally {
      try {
        if (r && !r.done && (m = i["return"])) m.call(i);
      } finally {
        if (e) throw e.error;
      }
    }
    return ar;
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.SerializedMmlVisitor = exports.toEntity = exports.DATAMJX = void 0;
  var MmlVisitor_js_1 = MmlVisitor$1;
  var MmlNode_js_1 = MmlNode;
  var mi_js_1 = mi$1;
  exports.DATAMJX = 'data-mjx-';
  var toEntity = function (c) {
    return '&#x' + c.codePointAt(0).toString(16).toUpperCase() + ';';
  };
  exports.toEntity = toEntity;
  var SerializedMmlVisitor = (function (_super) {
    __extends(SerializedMmlVisitor, _super);
    function SerializedMmlVisitor() {
      return _super !== null && _super.apply(this, arguments) || this;
    }
    SerializedMmlVisitor.prototype.visitTree = function (node) {
      return this.visitNode(node, '');
    };
    SerializedMmlVisitor.prototype.visitTextNode = function (node, _space) {
      return this.quoteHTML(node.getText());
    };
    SerializedMmlVisitor.prototype.visitXMLNode = function (node, space) {
      return space + node.getSerializedXML();
    };
    SerializedMmlVisitor.prototype.visitInferredMrowNode = function (node, space) {
      var e_1, _a;
      var mml = [];
      try {
        for (var _b = __values(node.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          mml.push(this.visitNode(child, space));
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_1) throw e_1.error;
        }
      }
      return mml.join('\n');
    };
    SerializedMmlVisitor.prototype.visitTeXAtomNode = function (node, space) {
      var children = this.childNodeMml(node, space + '  ', '\n');
      var mml = space + '<mrow' + this.getAttributes(node) + '>' + (children.match(/\S/) ? '\n' + children + space : '') + '</mrow>';
      return mml;
    };
    SerializedMmlVisitor.prototype.visitAnnotationNode = function (node, space) {
      return space + '<annotation' + this.getAttributes(node) + '>' + this.childNodeMml(node, '', '') + '</annotation>';
    };
    SerializedMmlVisitor.prototype.visitDefault = function (node, space) {
      var kind = node.kind;
      var _a = __read(node.isToken || node.childNodes.length === 0 ? ['', ''] : ['\n', space], 2), nl = _a[0], endspace = _a[1];
      var children = this.childNodeMml(node, space + '  ', nl);
      return space + '<' + kind + this.getAttributes(node) + '>' + (children.match(/\S/) ? nl + children + endspace : '') + '</' + kind + '>';
    };
    SerializedMmlVisitor.prototype.childNodeMml = function (node, space, nl) {
      var e_2, _a;
      var mml = '';
      try {
        for (var _b = __values(node.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
          var child = _c.value;
          mml += this.visitNode(child, space) + nl;
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_2) throw e_2.error;
        }
      }
      return mml;
    };
    SerializedMmlVisitor.prototype.getAttributes = function (node) {
      var e_3, _a;
      var attr = [];
      var defaults = this.constructor.defaultAttributes[node.kind] || ({});
      var attributes = Object.assign({}, defaults, this.getDataAttributes(node), node.attributes.getAllAttributes());
      var variants = this.constructor.variants;
      if (attributes.hasOwnProperty('mathvariant') && variants.hasOwnProperty(attributes.mathvariant)) {
        attributes.mathvariant = variants[attributes.mathvariant];
      }
      try {
        for (var _b = __values(Object.keys(attributes)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var name_1 = _c.value;
          var value = String(attributes[name_1]);
          if (value === undefined) continue;
          attr.push(name_1 + '="' + this.quoteHTML(value) + '"');
        }
      } catch (e_3_1) {
        e_3 = {
          error: e_3_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        } finally {
          if (e_3) throw e_3.error;
        }
      }
      return attr.length ? ' ' + attr.join(' ') : '';
    };
    SerializedMmlVisitor.prototype.getDataAttributes = function (node) {
      var data = {};
      var variant = node.attributes.getExplicit('mathvariant');
      var variants = this.constructor.variants;
      variant && variants.hasOwnProperty(variant) && this.setDataAttribute(data, 'variant', variant);
      node.getProperty('variantForm') && this.setDataAttribute(data, 'alternate', '1');
      node.getProperty('pseudoscript') && this.setDataAttribute(data, 'pseudoscript', 'true');
      node.getProperty('autoOP') === false && this.setDataAttribute(data, 'auto-op', 'false');
      var scriptalign = node.getProperty('scriptalign');
      scriptalign && this.setDataAttribute(data, 'script-align', scriptalign);
      var texclass = node.getProperty('texClass');
      if (texclass !== undefined) {
        var setclass = true;
        if (texclass === MmlNode_js_1.TEXCLASS.OP && node.isKind('mi')) {
          var name_2 = node.getText();
          setclass = !(name_2.length > 1 && name_2.match(mi_js_1.MmlMi.operatorName));
        }
        setclass && this.setDataAttribute(data, 'texclass', texclass < 0 ? 'NONE' : MmlNode_js_1.TEXCLASSNAMES[texclass]);
      }
      node.getProperty('scriptlevel') && node.getProperty('useHeight') === false && this.setDataAttribute(data, 'smallmatrix', 'true');
      return data;
    };
    SerializedMmlVisitor.prototype.setDataAttribute = function (data, name, value) {
      data[exports.DATAMJX + name] = value;
    };
    SerializedMmlVisitor.prototype.quoteHTML = function (value) {
      return value.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/\"/g, '&quot;').replace(/[\uD800-\uDBFF]./g, exports.toEntity).replace(/[\u0080-\uD7FF\uE000-\uFFFF]/g, exports.toEntity);
    };
    SerializedMmlVisitor.variants = {
      '-tex-calligraphic': 'script',
      '-tex-bold-calligraphic': 'bold-script',
      '-tex-oldstyle': 'normal',
      '-tex-bold-oldstyle': 'bold',
      '-tex-mathit': 'italic'
    };
    SerializedMmlVisitor.defaultAttributes = {
      math: {
        xmlns: 'http://www.w3.org/1998/Math/MathML'
      }
    };
    return SerializedMmlVisitor;
  })(MmlVisitor_js_1.MmlVisitor);
  exports.SerializedMmlVisitor = SerializedMmlVisitor;
})(SerializedMmlVisitor);
getDefaultExportFromCjs(SerializedMmlVisitor);

if (typeof window !== 'undefined') {
  RegisterHTMLHandler_1(browserAdaptor_2());
}
const visitor = new SerializedMmlVisitor.SerializedMmlVisitor();
const toMMl = node => visitor.visitTree(node);
const log = debug('pie-lib:math-rendering');
const NEWLINE_BLOCK_REGEX = /\\embed\{newLine\}\[\]/g;
const NEWLINE_LATEX = '\\newline ';
const getGlobal = () => {
  const key = `${pkg.name}@${pkg.version.split('.')[0]}`;
  if (typeof window !== 'undefined') {
    if (!window[key]) {
      window[key] = {};
    }
    return window[key];
  } else {
    return {};
  }
};
const defaultOpts = () => getGlobal().opts || ({});
const fixMathElement = element => {
  if (element.dataset.mathHandled) {
    return;
  }
  let property = 'innerText';
  if (element.textContent) {
    property = 'textContent';
  }
  if (element[property]) {
    element[property] = wrapMath(unWrapMath(element[property]).unwrapped);
    element[property] = element[property].replace(NEWLINE_BLOCK_REGEX, NEWLINE_LATEX);
    element.dataset.mathHandled = true;
  }
};
const fixMathElements = (el = document) => {
  const mathElements = el.querySelectorAll('[data-latex]');
  mathElements.forEach(item => fixMathElement(item));
};
const adjustMathMLStyle = (el = document) => {
  const nodes = el.querySelectorAll('math');
  nodes.forEach(node => node.setAttribute('displaystyle', 'true'));
};
const createMathMLInstance = (opts, docProvided = document) => {
  opts = opts || defaultOpts();
  if (opts.useSingleDollar) {
    console.warn('[math-rendering] using $ is not advisable, please use $$..$$ or \\(...\\)');
  }
  const packages = AllPackages_1.filter(name => name !== 'bussproofs');
  packages.push('autoload');
  const macros = {
    parallelogram: '\\lower.2em{\\Huge\\unicode{x25B1}}',
    overarc: '\\overparen',
    napprox: '\\not\\approx',
    longdiv: '\\enclose{longdiv}'
  };
  const texConfig = opts.useSingleDollar ? {
    packages,
    macros,
    inlineMath: [['$', '$'], ['\\(', '\\)']],
    processEscapes: true,
    options: {
      enableExplorer: true,
      enableAssistiveMml: true,
      a11y: {
        speech: true,
        braille: true,
        subtitles: true
      },
      sre: {
        domain: 'default',
        style: 'default',
        locale: 'en'
      }
    }
  } : {
    packages,
    macros,
    options: {
      enableExplorer: true,
      enableAssistiveMml: true,
      a11y: {
        speech: true,
        braille: true,
        subtitles: true
      },
      sre: {
        domain: 'default',
        style: 'default',
        locale: 'en'
      }
    }
  };
  const mmlConfig = {
    options: {
      a11y: {
        speech: true,
        braille: true,
        subtitles: true
      }
    },
    parseError: function (node) {
      console.log('error:', node);
      this.error(this.adaptor.textContent(node).replace(/\n.*/g, ''));
    }
  };
  const fontURL = `https://unpkg.com/mathjax-full@${mathjax.mathjax.version}/ts/output/chtml/fonts/tex-woff-v2`;
  const htmlConfig = {
    fontURL,
    wrapperFactory: new CHTMLWrapperFactory_1({
      ...CHTMLWrapperFactory_1.defaultNodes,
      ...chtmlNodes
    }),
    options: {
      renderActions: {
        assistiveMml: [['AssistiveMmlHandler']]
      }
    }
  };
  const mml = new MathML_1(mmlConfig);
  const customMmlFactory = new MmlFactory_2({
    ...MmlFactory_2.defaultNodes,
    ...mmlNodes
  });
  const html = mathjax.mathjax.document(docProvided, {
    compileError: (mj, math, err) => {
      console.log('bad math?:', math);
      console.error(err);
    },
    typesetError: function (doc, math, err) {
      console.log('typeset error');
      console.error(err);
      doc.typesetError(math, err);
    },
    options: {
      enableAssistiveMml: true,
      menuOptions: {
        settings: {
          assistiveMml: true,
          collapsible: true,
          explorer: true
        }
      }
    },
    InputJax: [new TeX_1(texConfig), mml],
    OutputJax: new CHTML_1(htmlConfig)
  });
  mml.setMmlFactory(customMmlFactory);
  return html;
};
const bootstrap = opts => {
  if (typeof window === 'undefined') {
    return {
      Typeset: () => ({})
    };
  }
  const html = createMathMLInstance(opts);
  return {
    version: mathjax.mathjax.version,
    html: html,
    Typeset: function (...elements) {
      const updatedDocument = this.html.findMath(elements.length ? {
        elements
      } : {}).compile().getMetrics().typeset().updateDocument();
      try {
        const list = updatedDocument.math.list;
        for (let item = list.next; typeof item.data !== 'symbol'; item = item.next) {
          const mathMl = toMMl(item.data.root);
          const parsedMathMl = mathMl.replaceAll('\n', '');
          item.data.typesetRoot.setAttribute('data-mathml', parsedMathMl);
        }
      } catch (e) {
        console.error(e.toString());
      }
      updatedDocument.clear();
    }
  };
};
const renderMath = (el, renderOpts) => {
  const isString = typeof el === 'string';
  let executeOn = document.body;
  if (isString) {
    const div = document.createElement('div');
    div.innerHTML = el;
    executeOn = div;
  }
  fixMathElements(executeOn);
  adjustMathMLStyle(executeOn);
  if (isString) {
    const html = createMathMLInstance(undefined, executeOn);
    const updatedDocument = html.findMath().compile().getMetrics().typeset().updateDocument();
    const list = updatedDocument.math.list;
    const item = list.next;
    if (!item) {
      return '';
    }
    const mathMl = toMMl(item.data.root);
    const parsedMathMl = mathMl.replaceAll('\n', '');
    return parsedMathMl;
  }
  if (!getGlobal().instance) {
    getGlobal().instance = bootstrap(renderOpts);
  }
  if (!el) {
    log('el is undefined');
    return;
  }
  if (el instanceof Element) {
    getGlobal().instance.Typeset(el);
  } else if (el.length) {
    const arr = Array.from(el);
    getGlobal().instance.Typeset(...arr);
  }
};
CHTMLmspace_1.styles = {
  'mjx-mspace': {
    display: 'block',
    'text-align': 'center',
    height: '5px'
  }
};

var dist = {
  exports: {}
};

var main = {};

var mathmlToLatex = {};

var mathmlElementToLatexConverterAdapter = {};

var converters = {};

var math = {};

var mathmlElementToLatexConverter = {};

Object.defineProperty(mathmlElementToLatexConverter, "__esModule", {
  value: true
});
mathmlElementToLatexConverter.mathMLElementToLaTeXConverter = void 0;
var mathml_element_to_latex_converter_adapter_1$1 = mathmlElementToLatexConverterAdapter;
var mathMLElementToLaTeXConverter = function (mathMLElement) {
  return new mathml_element_to_latex_converter_adapter_1$1.MathMLElementToLatexConverterAdapter(mathMLElement).toLatexConverter();
};
mathmlElementToLatexConverter.mathMLElementToLaTeXConverter = mathMLElementToLaTeXConverter;

var normalizeWhitespace = {};

Object.defineProperty(normalizeWhitespace, "__esModule", {
  value: true
});
normalizeWhitespace.normalizeWhiteSpaces = void 0;
var normalizeWhiteSpaces = function (str) {
  return str.replace(/\s+/g, ' ');
};
normalizeWhitespace.normalizeWhiteSpaces = normalizeWhiteSpaces;

Object.defineProperty(math, "__esModule", {
  value: true
});
math.Math = void 0;
var mathml_element_to_latex_converter_1$5 = mathmlElementToLatexConverter;
var normalize_whitespace_1 = normalizeWhitespace;
var Math$1 = (function () {
  function Math(mathElement) {
    this._mathmlElement = mathElement;
  }
  Math.prototype.convert = function () {
    var unnormalizedLatex = this._mathmlElement.children.map(function (child) {
      return mathml_element_to_latex_converter_1$5.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join('');
    return normalize_whitespace_1.normalizeWhiteSpaces(unnormalizedLatex);
  };
  return Math;
})();
math.Math = Math$1;

var mi = {};

var helpers = {};

var wrappers = {};

var bracket = {};

var wrapper = {};

Object.defineProperty(wrapper, "__esModule", {
  value: true
});
wrapper.Wrapper = void 0;
var Wrapper = (function () {
  function Wrapper(open, close) {
    this._open = open;
    this._close = close;
  }
  Wrapper.prototype.wrap = function (str) {
    return this._open + str + this._close;
  };
  return Wrapper;
})();
wrapper.Wrapper = Wrapper;

Object.defineProperty(bracket, "__esModule", {
  value: true
});
bracket.BracketWrapper = void 0;
var wrapper_1$2 = wrapper;
var BracketWrapper = (function () {
  function BracketWrapper() {
    this._open = '{';
    this._close = '}';
  }
  BracketWrapper.prototype.wrap = function (str) {
    return new wrapper_1$2.Wrapper(this._open, this._close).wrap(str);
  };
  return BracketWrapper;
})();
bracket.BracketWrapper = BracketWrapper;

var parenthesis = {};

Object.defineProperty(parenthesis, "__esModule", {
  value: true
});
parenthesis.ParenthesisWrapper = void 0;
var wrapper_1$1 = wrapper;
var ParenthesisWrapper = (function () {
  function ParenthesisWrapper() {
    this._open = '\\left(';
    this._close = '\\right)';
  }
  ParenthesisWrapper.prototype.wrap = function (str) {
    return new wrapper_1$1.Wrapper(this._open, this._close).wrap(str);
  };
  ParenthesisWrapper.prototype.wrapIfMoreThanOneChar = function (str) {
    if (str.length <= 1) return str;
    return this.wrap(str);
  };
  return ParenthesisWrapper;
})();
parenthesis.ParenthesisWrapper = ParenthesisWrapper;

var generic = {};

Object.defineProperty(generic, "__esModule", {
  value: true
});
generic.GenericWrapper = void 0;
var wrapper_1 = wrapper;
var GenericWrapper = (function () {
  function GenericWrapper(open, close) {
    this._open = '\\left' + open;
    this._close = '\\right' + close;
  }
  GenericWrapper.prototype.wrap = function (str) {
    return new wrapper_1.Wrapper(this._open, this._close).wrap(str);
  };
  return GenericWrapper;
})();
generic.GenericWrapper = GenericWrapper;

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.GenericWrapper = exports.ParenthesisWrapper = exports.BracketWrapper = void 0;
  var bracket_1 = bracket;
  Object.defineProperty(exports, "BracketWrapper", {
    enumerable: true,
    get: function () {
      return bracket_1.BracketWrapper;
    }
  });
  var parenthesis_1 = parenthesis;
  Object.defineProperty(exports, "ParenthesisWrapper", {
    enumerable: true,
    get: function () {
      return parenthesis_1.ParenthesisWrapper;
    }
  });
  var generic_1 = generic;
  Object.defineProperty(exports, "GenericWrapper", {
    enumerable: true,
    get: function () {
      return generic_1.GenericWrapper;
    }
  });
})(wrappers);
getDefaultExportFromCjs(wrappers);

var joinWithManySeparators = {};

Object.defineProperty(joinWithManySeparators, "__esModule", {
  value: true
});
joinWithManySeparators.JoinWithManySeparators = void 0;
var JoinWithManySeparators = (function () {
  function JoinWithManySeparators(separators) {
    this._separators = separators;
  }
  JoinWithManySeparators.join = function (arr, separators) {
    return new JoinWithManySeparators(separators)._join(arr);
  };
  JoinWithManySeparators.prototype._join = function (arr) {
    var _this = this;
    return arr.reduce(function (joinedStr, currentStr, currentIndex, strArr) {
      var separator = currentIndex === strArr.length - 1 ? '' : _this._get(currentIndex);
      return joinedStr + currentStr + separator;
    }, '');
  };
  JoinWithManySeparators.prototype._get = function (index) {
    if (this._separators[index]) return this._separators[index];
    return this._separators.length > 0 ? this._separators[this._separators.length - 1] : ',';
  };
  return JoinWithManySeparators;
})();
joinWithManySeparators.JoinWithManySeparators = JoinWithManySeparators;

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, {
      enumerable: true,
      get: function () {
        return m[k];
      }
    });
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  __exportStar(wrappers, exports);
  __exportStar(joinWithManySeparators, exports);
  __exportStar(mathmlElementToLatexConverter, exports);
  __exportStar(normalizeWhitespace, exports);
})(helpers);
getDefaultExportFromCjs(helpers);

var syntax = {};

var allMathOperatorsByChar = {};

Object.defineProperty(allMathOperatorsByChar, "__esModule", {
  value: true
});
allMathOperatorsByChar.allMathOperatorsByChar = void 0;
allMathOperatorsByChar.allMathOperatorsByChar = {
  _: '\\underline',
  '&#x23E1;': '\\underbrace',
  '&#x23E0;': '\\overbrace',
  '&#x23DF;': '\\underbrace',
  '&#x23DE;': '\\overbrace',
  '&#x23DD;': '\\underbrace',
  '&#x23DC;': '\\overbrace',
  '&#x23B5;': '\\underbrace',
  '&#x23B4;': '\\overbrace',
  '&#x20DC;': '\\square',
  '&#x20DB;': '\\square',
  '&#x2064;': '',
  '&#x2057;': "''''",
  '&#x203E;': '\\bar',
  '&#x2037;': '```',
  '&#x2036;': '``',
  '&#x2035;': '`',
  '&#x2034;': "'''",
  '&#x2033;': "''",
  '&#x201F;': '``',
  '&#x201E;': ',,',
  '&#x201B;': '`',
  '&#x201A;': ',',
  '&#x302;': '\\hat',
  '&#x2F7;': '\\sim',
  '&#x2DD;': '\\sim',
  '&#x2DC;': '\\sim',
  '&#x2DA;': '\\circ',
  '&#x2D9;': '\\cdot',
  '&#x2D8;': '',
  '&#x2CD;': '\\_',
  '&#x2CB;': 'ˋ',
  '&#x2CA;': 'ˊ',
  '&#x2C9;': 'ˉ',
  '&#x2C7;': '',
  '&#x2C6;': '\\hat',
  '&#xBA;': 'o',
  '&#xB9;': '1',
  '&#xB8;': '¸',
  '&#xB4;': '´',
  '&#xB3;': '3',
  '&#xB2;': '2',
  '&#xB0;': '\\circ',
  '&#xAF;': '\\bar',
  '&#xAA;': 'a',
  '&#xA8;': '\\cdot\\cdot',
  '~': '\\sim',
  '`': '`',
  '^': '\\hat',
  '--': '--',
  '++': '++',
  '&amp;': '\\&',
  '&#x2061;': '',
  '&#x221C;': '\\sqrt[4]{}',
  '&#x221B;': '\\sqrt[3]{}',
  '&#x221A;': '\\sqrt{}',
  '&#x2146;': 'd',
  '&#x2145;': '\\mathbb{D}',
  '?': '?',
  '@': '@',
  '//': '//',
  '!!': '!!',
  '!': '!',
  '&#x266F;': '\\#',
  '&#x266E;': '',
  '&#x266D;': '',
  '&#x2032;': "'",
  '&lt;>': '<>',
  '**': '\\star\\star',
  '&#x2207;': '\\nabla',
  '&#x2202;': '\\partial',
  '&#x2299;': '\\bigodot',
  '&#xAC;': '\\neg',
  '&#x2222;': '\\measuredangle',
  '&#x2221;': '\\measuredangle',
  '&#x2220;': '\\angle',
  '&#xF7;': '\\div',
  '/': '/',
  '&#x2216;': '\\backslash',
  '\\': '\\backslash',
  '%': '\\%',
  '&#x2297;': '\\bigotimes',
  '&#xB7;': '\\cdot',
  '&#x2A3F;': '\\coprod',
  '&#x2A2F;': '\\times',
  '&#x22C5;': '\\cdot',
  '&#x22A1;': '\\boxdot',
  '&#x22A0;': '\\boxtimes',
  '&#x2062;': '',
  '&#x2043;': '-',
  '&#x2022;': '\\cdot',
  '&#xD7;': '\\times',
  '.': '.',
  '*': '\\star',
  '&#x222A;': '\\cup',
  '&#x2229;': '\\cap',
  '&#x2210;': '\\coprod',
  '&#x220F;': '\\prod',
  '&#x2240;': '',
  '&#x2AFF;': '',
  '&#x2AFC;': '\\mid\\mid\\mid',
  '&#x2A09;': '\\times',
  '&#x2A08;': '',
  '&#x2A07;': '',
  '&#x2A06;': '\\sqcup',
  '&#x2A05;': '\\sqcap',
  '&#x2A02;': '\\otimes',
  '&#x2A00;': '\\odot',
  '&#x22C2;': '\\cap',
  '&#x22C1;': '\\vee',
  '&#x22C0;': '\\wedge',
  '&#x2A04;': '\\uplus',
  '&#x2A03;': '\\cup',
  '&#x22C3;': '\\cup',
  '&#x2A1C;': '\\underline{\\int}',
  '&#x2A1B;': '\\overline{\\int}',
  '&#x2A1A;': '\\int',
  '&#x2A19;': '\\int',
  '&#x2A18;': '\\int',
  '&#x2A17;': '\\int',
  '&#x2A16;': '\\oint',
  '&#x2A15;': '\\oint',
  '&#x2A14;': '\\int',
  '&#x2A13;': '\\int',
  '&#x2A12;': '\\int',
  '&#x2A11;': '\\int',
  '&#x2A10;': '\\int',
  '&#x2A0F;': '\\bcancel{\\int}',
  '&#x2A0E;': '',
  '&#x2A0D;': '\\hcancel{\\int}',
  '&#x2A0C;': '\\iiiint',
  '&#x2233;': '\\oint',
  '&#x2232;': '\\oint',
  '&#x2231;': '\\int',
  '&#x2230;': '\\oiint',
  '&#x222F;': '\\oiint',
  '&#x222E;': '\\oint',
  '&#x222B;': '\\int',
  '&#x2A01;': '\\oplus',
  '&#x2298;': '\\oslash',
  '&#x2296;': '\\ominus',
  '&#x2295;': '\\oplus',
  '&#x222D;': '\\iiint',
  '&#x222C;': '\\iint',
  '&#x2A0B;': '',
  '&#x2A0A;': '',
  '&#x2211;': '\\sum',
  '&#x229F;': '\\boxminus',
  '&#x229E;': '\\boxplus',
  '&#x2214;': '\\dot{+}',
  '&#x2213;': '+-',
  '&#x2212;': '-',
  '&#xB1;': '\\pm',
  '-': '-',
  '+': '+',
  '&#x2B46;': '\\Rrightarrow',
  '&#x2B45;': '\\Lleftarrow',
  '&#x29F4;': ':\\rightarrow',
  '&#x29EF;': '',
  '&#x29DF;': '\\bullet-\\bullet',
  '&#x299F;': '\\angle',
  '&#x299E;': '\\measuredangle',
  '&#x299D;': '\\measuredangle',
  '&#x299C;': '\\perp',
  '&#x299B;': '\\measuredangle',
  '&#x299A;': '',
  '&#x2999;': '\\vdots',
  '&#x297F;': '',
  '&#x297E;': '',
  '&#x297D;': '\\prec',
  '&#x297C;': '\\succ',
  '&#x297B;': '\\underset{\\rightarrow}{\\supset}',
  '&#x297A;': '',
  '&#x2979;': '\\underset{\\rightarrow}{\\subset}',
  '&#x2978;': '\\underset{\\rightarrow}{>}',
  '&#x2977;': '',
  '&#x2976;': '\\underset{\\leftarrow}{<}',
  '&#x2975;': '\\underset{\\approx}{\\rightarrow}',
  '&#x2974;': '\\underset{\\sim}{\\rightarrow}',
  '&#x2973;': '\\underset{\\sim}{\\leftarrow}',
  '&#x2972;': '\\overset{\\sim}{\\rightarrow}',
  '&#x2971;': '\\overset{=}{\\rightarrow}',
  '&#x2970;': '',
  '&#x296F;': '',
  '&#x296E;': '',
  '&#x296D;': '\\overline{\\rightharpoondown}',
  '&#x296C;': '\\underline{\\rightharpoonup}',
  '&#x296B;': '\\overline{\\leftharpoondown}',
  '&#x296A;': '\\underline{\\leftharpoonup}',
  '&#x2969;': '\\rightleftharpoons',
  '&#x2968;': '\\rightleftharpoons',
  '&#x2967;': '\\rightleftharpoons',
  '&#x2966;': '\\rightleftharpoons',
  '&#x2965;': '\\Downarrow',
  '&#x2964;': '\\Rightarrow',
  '&#x2963;': '\\Uparrow',
  '&#x2962;': '\\Leftarrow',
  '&#x2961;': '\\downarrow',
  '&#x2960;': '\\uparrow',
  '&#x295F;': '\\rightarrow',
  '&#x295E;': '\\leftarrow',
  '&#x295D;': '\\downarrow',
  '&#x295C;': '\\uparrow',
  '&#x295B;': '\\rightarrow',
  '&#x295A;': '\\leftarrow',
  '&#x2959;': '\\downarrow',
  '&#x2958;': '\\uparrow',
  '&#x2957;': '\\rightarrow',
  '&#x2956;': '\\leftarrow',
  '&#x2955;': '\\downarrow',
  '&#x2954;': '\\uparrow',
  '&#x2953;': '\\rightarrow',
  '&#x2952;': '\\leftarrow',
  '&#x2951;': '\\updownarrow',
  '&#x2950;': '\\leftrightarrow',
  '&#x294F;': '\\updownarrow',
  '&#x294E;': '\\leftrightarrow',
  '&#x294D;': '\\updownarrow',
  '&#x294C;': '\\updownarrow',
  '&#x294B;': '\\leftrightarrow',
  '&#x294A;': '\\leftrightarrow',
  '&#x2949;': '',
  '&#x2948;': '\\leftrightarrow',
  '&#x2947;': '\\nrightarrow',
  '&#x2946;': '',
  '&#x2945;': '',
  '&#x2944;': '\\rightleftarrows',
  '&#x2943;': '\\leftrightarrows',
  '&#x2942;': '\\rightleftarrows',
  '&#x2941;': '\\circlearrowright',
  '&#x2940;': '\\circlearrowleft',
  '&#x293F;': '\\rightarrow',
  '&#x293E;': '\\leftarrow',
  '&#x293D;': '',
  '&#x293C;': '',
  '&#x293B;': '',
  '&#x293A;': '',
  '&#x2939;': '',
  '&#x2938;': '',
  '&#x2937;': '\\Rsh',
  '&#x2936;': '\\Lsh',
  '&#x2935;': '\\downarrow',
  '&#x2934;': '\\uparrow',
  '&#x2933;': '\\leadsto',
  '&#x2932;': '',
  '&#x2931;': '',
  '&#x2930;': '',
  '&#x292F;': '',
  '&#x292E;': '',
  '&#x292D;': '',
  '&#x292C;': '\\times',
  '&#x292B;': '\\times',
  '&#x292A;': '',
  '&#x2929;': '',
  '&#x2928;': '',
  '&#x2927;': '',
  '&#x2926;': '',
  '&#x2925;': '',
  '&#x2924;': '',
  '&#x2923;': '',
  '&#x2922;': '',
  '&#x2921;': '',
  '&#x2920;': '\\mapsto\\cdot',
  '&#x291F;': '\\cdot\\leftarrow',
  '&#x291E;': '\\rightarrow\\cdot',
  '&#x291D;': '\\leftarrow',
  '&#x291C;': '\\rightarrow',
  '&#x291B;': '\\leftarrow',
  '&#x291A;': '\\rightarrow',
  '&#x2919;': '\\leftarrow',
  '&#x2918;': '\\rightarrow',
  '&#x2917;': '\\rightarrow',
  '&#x2916;': '\\rightarrow',
  '&#x2915;': '\\rightarrow',
  '&#x2914;': '\\rightarrow',
  '&#x2913;': '\\downarrow',
  '&#x2912;': '\\uparrow',
  '&#x2911;': '\\rightarrow',
  '&#x2910;': '\\rightarrow',
  '&#x290F;': '\\rightarrow',
  '&#x290E;': '\\leftarrow',
  '&#x290D;': '\\rightarrow',
  '&#x290C;': '\\leftarrow',
  '&#x290B;': '\\Downarrow',
  '&#x290A;': '\\Uparrow',
  '&#x2909;': '\\uparrow',
  '&#x2908;': '\\downarrow',
  '&#x2907;': '\\Rightarrow',
  '&#x2906;': '\\Leftarrow',
  '&#x2905;': '\\mapsto',
  '&#x2904;': '\\nLeftrightarrow',
  '&#x2903;': '\\nRightarrow',
  '&#x2902;': '\\nLeftarrow',
  '&#x2901;': '\\rightsquigarrow',
  '&#x2900;': '\\rightsquigarrow',
  '&#x27FF;': '\\rightsquigarrow',
  '&#x27FE;': '\\Rightarrow',
  '&#x27FD;': '\\Leftarrow',
  '&#x27FC;': '\\mapsto',
  '&#x27FB;': '\\leftarrow',
  '&#x27FA;': '\\Longleftrightarrow',
  '&#x27F9;': '\\Longrightarrow',
  '&#x27F8;': '\\Longleftarrow',
  '&#x27F7;': '\\leftrightarrow',
  '&#x27F6;': '\\rightarrow',
  '&#x27F5;': '\\leftarrow',
  '&#x27F1;': '\\Downarrow',
  '&#x27F0;': '\\Uparrow',
  '&#x22B8;': '\\rightarrow',
  '&#x21FF;': '\\leftrightarrow',
  '&#x21FE;': '\\rightarrow',
  '&#x21FD;': '\\leftarrow',
  '&#x21FC;': '\\nleftrightarrow',
  '&#x21FB;': '\\nrightarrow',
  '&#x21FA;': '\\nleftarrow',
  '&#x21F9;': '\\nleftrightarrow',
  '&#x21F8;': '\\nrightarrow',
  '&#x21F7;': '\\nleftarrow',
  '&#x21F6;': '\\Rrightarrow',
  '&#x21F5;': '',
  '&#x21F4;': '\\rightarrow',
  '&#x21F3;': '\\Updownarrow',
  '&#x21F2;': '\\searrow',
  '&#x21F1;': '\\nwarrow',
  '&#x21F0;': '\\Leftarrow',
  '&#x21EF;': '\\Uparrow',
  '&#x21EE;': '\\Uparrow',
  '&#x21ED;': '\\Uparrow',
  '&#x21EC;': '\\Uparrow',
  '&#x21EB;': '\\Uparrow',
  '&#x21EA;': '\\Uparrow',
  '&#x21E9;': '\\Downarrow',
  '&#x21E8;': '\\Rightarrow',
  '&#x21E7;': '\\Uparrow',
  '&#x21E6;': '\\Leftarrow',
  '&#x21E5;': '\\rightarrow',
  '&#x21E4;': '\\leftarrow',
  '&#x21E3;': '\\downarrow',
  '&#x21E2;': '\\rightarrow',
  '&#x21E1;': '\\uparrow',
  '&#x21E0;': '\\leftarrow',
  '&#x21DF;': '\\downarrow',
  '&#x21DE;': '\\uparrow',
  '&#x21DD;': '\\rightsquigarrow',
  '&#x21DC;': '\\leftarrow',
  '&#x21DB;': '\\Rrightarrow',
  '&#x21DA;': '\\Lleftarrow',
  '&#x21D9;': '\\swarrow',
  '&#x21D8;': '\\searrow',
  '&#x21D7;': '\\nearrow',
  '&#x21D6;': '\\nwarrow',
  '&#x21D5;': '\\Updownarrow',
  '&#x21D4;': '\\Leftrightarrow',
  '&#x21D3;': '\\Downarrow',
  '&#x21D2;': '\\Rightarrow',
  '&#x21D1;': '\\Uparrow',
  '&#x21D0;': '\\Leftarrow',
  '&#x21CF;': '\\nRightarrow',
  '&#x21CE;': '\\nLeftrightarrow',
  '&#x21CD;': '\\nLeftarrow',
  '&#x21CC;': '\\rightleftharpoons',
  '&#x21CB;': '\\leftrightharpoons',
  '&#x21CA;': '\\downdownarrows',
  '&#x21C9;': '\\rightrightarrows',
  '&#x21C8;': '\\upuparrows',
  '&#x21C7;': '\\leftleftarrows',
  '&#x21C6;': '\\leftrightarrows',
  '&#x21C5;': '',
  '&#x21C4;': '\\rightleftarrows',
  '&#x21C3;': '\\downharpoonleft',
  '&#x21C2;': '\\downharpoonright',
  '&#x21C1;': '\\rightharpoondown',
  '&#x21C0;': '\\rightharpoonup',
  '&#x21BF;': '\\upharpoonleft',
  '&#x21BE;': '\\upharpoonright',
  '&#x21BD;': '\\leftharpoondown',
  '&#x21BC;': '\\leftharpoonup',
  '&#x21BB;': '\\circlearrowright',
  '&#x21BA;': '\\circlearrowleft',
  '&#x21B9;': '\\leftrightarrows',
  '&#x21B8;': '\\overline{\\nwarrow}',
  '&#x21B7;': '\\curvearrowright',
  '&#x21B6;': '\\curvearrowleft',
  '&#x21B5;': '\\swarrow',
  '&#x21B4;': '\\searrow',
  '&#x21B3;': '\\Rsh',
  '&#x21B2;': '\\Lsh',
  '&#x21B1;': '\\Rsh',
  '&#x21B0;': '\\Lsh',
  '&#x21AF;': '\\swarrow',
  '&#x21AE;': '',
  '&#x21AD;': '\\leftrightsquigarrow',
  '&#x21AC;': '\\looparrowright',
  '&#x21AB;': '\\looparrowleft',
  '&#x21AA;': '\\hookrightarrow',
  '&#x21A9;': '\\hookleftarrow',
  '&#x21A8;': '\\underline{\\updownarrow}',
  '&#x21A7;': '\\downarrow',
  '&#x21A6;': '\\rightarrowtail',
  '&#x21A5;': '\\uparrow',
  '&#x21A4;': '\\leftarrowtail',
  '&#x21A3;': '\\rightarrowtail',
  '&#x21A2;': '\\leftarrowtail',
  '&#x21A1;': '\\downarrow',
  '&#x21A0;': '\\twoheadrightarrow',
  '&#x219F;': '\\uparrow',
  '&#x219E;': '\\twoheadleftarrow',
  '&#x219D;': '\\nearrow',
  '&#x219C;': '\\nwarrow',
  '&#x219B;': '',
  '&#x219A;': '',
  '&#x2199;': '\\swarrow',
  '&#x2198;': '\\searrow',
  '&#x2197;': '\\nearrow',
  '&#x2196;': '\\nwarrow',
  '&#x2195;': '\\updownarrow',
  '&#x2194;': '\\leftrightarrow',
  '&#x2193;': '\\downarrow',
  '&#x2192;': '\\rightarrow',
  '&#x2191;': '\\uparrow',
  '&#x2190;': '\\leftarrow',
  '|||': '\\left|||\\right.',
  '||': '\\left||\\right.',
  '|': '\\left|\\right.',
  '&#x2AFE;': '',
  '&#x2AFD;': '//',
  '&#x2AFB;': '///',
  '&#x2AFA;': '',
  '&#x2AF9;': '',
  '&#x2AF8;': '',
  '&#x2AF7;': '',
  '&#x2AF6;': '\\vdots',
  '&#x2AF5;': '',
  '&#x2AF4;': '',
  '&#x2AF3;': '',
  '&#x2AF2;': '\\nparallel',
  '&#x2AF1;': '',
  '&#x2AF0;': '',
  '&#x2AEF;': '',
  '&#x2AEE;': '\\bcancel{\\mid}',
  '&#x2AED;': '',
  '&#x2AEC;': '',
  '&#x2AEB;': '',
  '&#x2AEA;': '',
  '&#x2AE9;': '',
  '&#x2AE8;': '\\underline{\\perp}',
  '&#x2AE7;': '\\overline{\\top}',
  '&#x2AE6;': '',
  '&#x2AE5;': '',
  '&#x2AE4;': '',
  '&#x2AE3;': '',
  '&#x2AE2;': '',
  '&#x2AE1;': '',
  '&#x2AE0;': '\\perp',
  '&#x2ADF;': '\\top',
  '&#x2ADE;': '\\dashv',
  '&#x2ADD;&#x338;': '',
  '&#x2ADD;': '',
  '&#x2ADB;': '\\pitchfork',
  '&#x2ADA;': '',
  '&#x2AD9;': '',
  '&#x2AD8;': '',
  '&#x2AD7;': '',
  '&#x2AD6;': '',
  '&#x2AD5;': '',
  '&#x2AD4;': '',
  '&#x2AD3;': '',
  '&#x2AD2;': '',
  '&#x2AD1;': '',
  '&#x2AD0;': '',
  '&#x2ACF;': '',
  '&#x2ACE;': '',
  '&#x2ACD;': '',
  '&#x2ACC;': '\\underset{\\neq}{\\supset}',
  '&#x2ACB;': '\\underset{\\neq}{\\subset}',
  '&#x2ACA;': '\\underset{\\approx}{\\supset}',
  '&#x2AC9;': '\\underset{\\approx}{\\subset}',
  '&#x2AC8;': '\\underset{\\sim}{\\supset}',
  '&#x2AC7;': '\\underset{\\sim}{\\subset}',
  '&#x2AC6;': '\\supseteqq',
  '&#x2AC5;': '\\subseteqq',
  '&#x2AC4;': '\\dot{\\supseteq}',
  '&#x2AC3;': '\\dot{\\subseteq}',
  '&#x2AC2;': '\\underset{\\times}{\\supset}',
  '&#x2AC1;': '\\underset{\\times}{\\subset}',
  '&#x2AC0;': '\\underset{+}{\\supset}',
  '&#x2ABF;': '\\underset{+}{\\subset}',
  '&#x2ABE;': '',
  '&#x2ABD;': '',
  '&#x2ABC;': '\\gg ',
  '&#x2ABB;': '\\ll',
  '&#x2ABA;': '\\underset{\\cancel{\\approx}}{\\succ}',
  '&#x2AB9;': '\\underset{\\cancel{\\approx}}{\\prec}',
  '&#x2AB8;': '\\underset{\\approx}{\\succ}',
  '&#x2AB7;': '\\underset{\\approx}{\\prec}',
  '&#x2AB6;': '\\underset{\\cancel{=}}{\\succ}',
  '&#x2AB5;': '\\underset{\\cancel{=}}{\\prec}',
  '&#x2AB4;': '\\underset{=}{\\succ}',
  '&#x2AB3;': '\\underset{=}{\\prec}',
  '&#x2AB2;': '',
  '&#x2AB1;': '',
  '&#x2AAE;': '',
  '&#x2AAD;': '\\underline{\\hcancel{>}}',
  '&#x2AAC;': '\\underline{\\hcancel{>}}',
  '&#x2AAB;': '\\hcancel{>}',
  '&#x2AAA;': '\\hcancel{<}',
  '&#x2AA9;': '',
  '&#x2AA8;': '',
  '&#x2AA7;': '\\vartriangleright',
  '&#x2AA6;': '\\vartriangleleft',
  '&#x2AA5;': '><',
  '&#x2AA4;': '><',
  '&#x2AA3;': '\\underline{\\ll}',
  '&#x2AA2;&#x338;': '\\cancel{\\gg}',
  '&#x2AA2;': '\\gg',
  '&#x2AA1;&#x338;': '\\cancel{\\ll}',
  '&#x2AA1;': '\\ll',
  '&#x2AA0;': '\\overset{\\sim}{\\geqq}',
  '&#x2A9F;': '\\overset{\\sim}{\\leqq}',
  '&#x2A9E;': '\\overset{\\sim}{>}',
  '&#x2A9D;': '\\overset{\\sim}{<}',
  '&#x2A9C;': '',
  '&#x2A9B;': '',
  '&#x2A9A;': '\\overset{=}{>}',
  '&#x2A99;': '\\overset{=}{<}',
  '&#x2A98;': '',
  '&#x2A97;': '',
  '&#x2A96;': '',
  '&#x2A95;': '',
  '&#x2A94;': '',
  '&#x2A93;': '',
  '&#x2A92;': '\\underset{=}{\\gtrless}',
  '&#x2A91;': '\\underset{=}{\\lessgtr}',
  '&#x2A90;': '\\underset{<}{\\gtrsim}',
  '&#x2A8F;': '\\underset{>}{\\lesssim}',
  '&#x2A8E;': '\\underset{\\simeq}{>}',
  '&#x2A8D;': '\\underset{\\simeq}{<}',
  '&#x2A8C;': '\\gtreqqless',
  '&#x2A8B;': '\\lesseqqgtr',
  '&#x2A8A;': '\\underset{\\cancel{\\approx}}{>}',
  '&#x2A89;': '\\underset{\\approx}{<}',
  '&#x2A86;': '\\underset{\\approx}{>}',
  '&#x2A85;': '\\underset{\\approx}{<}',
  '&#x2A84;': '',
  '&#x2A83;': '',
  '&#x2A82;': '',
  '&#x2A81;': '',
  '&#x2A80;': '',
  '&#x2A7F;': '',
  '&#x2A7E;&#x338;': '\\bcancel{\\geq}',
  '&#x2A7E;': '\\geq',
  '&#x2A7D;&#x338;': '\\bcancel{\\leq}',
  '&#x2A7D;': '\\leq',
  '&#x2A7C;': '',
  '&#x2A7B;': '',
  '&#x2A7A;': '',
  '&#x2A79;': '',
  '&#x2A78;': '\\overset{\\dots}{\\equiv}',
  '&#x2A77;': '',
  '&#x2A76;': '===',
  '&#x2A75;': '==',
  '&#x2A74;': '::=',
  '&#x2A73;': '',
  '&#x2A72;': '\\underset{=}{+}',
  '&#x2A71;': '\\overset{=}{+}',
  '&#x2A70;': '\\overset{\\approx}{=}',
  '&#x2A6F;': '\\overset{\\wedge}{=}',
  '&#x2A6E;': '\\overset{*}{=}',
  '&#x2A6D;': '\\dot{\\approx}',
  '&#x2A6C;': '',
  '&#x2A6B;': '',
  '&#x2A6A;': '\\dot{\\sim}',
  '&#x2A69;': '',
  '&#x2A68;': '',
  '&#x2A67;': '\\dot{\\equiv}',
  '&#x2A66;': '\\underset{\\cdot}{=}',
  '&#x2A65;': '',
  '&#x2A64;': '',
  '&#x2A63;': '\\underset{=}{\\vee}',
  '&#x2A62;': '\\overset{=}{\\vee}',
  '&#x2A61;': 'ul(vv)',
  '&#x2A60;': '\\underset{=}{\\wedge}',
  '&#x2A5F;': '\\underline{\\wedge}',
  '&#x2A5E;': '\\overset{=}{\\wedge}',
  '&#x2A5D;': '\\hcancel{\\vee}',
  '&#x2A5C;': '\\hcancel{\\wedge}',
  '&#x2A5B;': '',
  '&#x2A5A;': '',
  '&#x2A59;': '',
  '&#x2A58;': '\\vee',
  '&#x2A57;': '\\wedge',
  '&#x2A56;': '',
  '&#x2A55;': '',
  '&#x2A54;': '',
  '&#x2A53;': '',
  '&#x2A52;': '\\dot{\\vee}',
  '&#x2A51;': '\\dot{\\wedge}',
  '&#x2A50;': '',
  '&#x2A4F;': '',
  '&#x2A4E;': '',
  '&#x2A4D;': '\\overline{\\cap}',
  '&#x2A4C;': '\\overline{\\cup}',
  '&#x2A4B;': '',
  '&#x2A4A;': '',
  '&#x2A49;': '',
  '&#x2A48;': '',
  '&#x2A47;': '',
  '&#x2A46;': '',
  '&#x2A45;': '',
  '&#x2A44;': '',
  '&#x2A43;': '\\overline{\\cap}',
  '&#x2A42;': '\\overline{\\cup}',
  '&#x2A41;': '',
  '&#x2A40;': '',
  '&#x2A3E;': '',
  '&#x2A3D;': '\\llcorner',
  '&#x2A3C;': '\\lrcorner',
  '&#x2A3B;': '',
  '&#x2A3A;': '',
  '&#x2A39;': '',
  '&#x2A38;': '',
  '&#x2A37;': '',
  '&#x2A36;': '\\hat{\\otimes}',
  '&#x2A35;': '',
  '&#x2A34;': '',
  '&#x2A33;': '',
  '&#x2A32;': '\\underline{\\times}',
  '&#x2A31;': '\\underline{\\times}',
  '&#x2A30;': '\\dot{\\times}',
  '&#x2A2E;': '',
  '&#x2A2D;': '',
  '&#x2A2C;': '',
  '&#x2A2B;': '',
  '&#x2A2A;': '',
  '&#x2A29;': '',
  '&#x2A28;': '',
  '&#x2A27;': '',
  '&#x2A26;': '\\underset{\\sim}{+}',
  '&#x2A25;': '\\underset{\\circ}{+}',
  '&#x2A24;': '\\overset{\\sim}{+}',
  '&#x2A23;': '\\hat{+}',
  '&#x2A22;': '\\dot{+}',
  '&#x2A21;': '\\upharpoonright',
  '&#x2A20;': '>>',
  '&#x2A1F;': '',
  '&#x2A1E;': '\\triangleleft',
  '&#x2A1D;': '\\bowtie',
  '&#x29FF;': '',
  '&#x29FE;': '+',
  '&#x29FB;': '\\hcancel{|||}',
  '&#x29FA;': '\\hcancel{||}',
  '&#x29F9;': '\\backslash',
  '&#x29F8;': '/',
  '&#x29F7;': 'hcancel{\backslash}',
  '&#x29F6;': '',
  '&#x29F5;': '\\backslash',
  '&#x29F2;': '\\Phi',
  '&#x29F1;': '',
  '&#x29F0;': '',
  '&#x29EE;': '',
  '&#x29ED;': '',
  '&#x29EC;': '',
  '&#x29EB;': '\\lozenge',
  '&#x29EA;': '',
  '&#x29E9;': '',
  '&#x29E8;': '',
  '&#x29E7;': '\\ddagger',
  '&#x29E2;': '\\sqcup\\sqcup',
  '&#x29E1;': '',
  '&#x29E0;': '\\square',
  '&#x29DE;': '',
  '&#x29DD;': '',
  '&#x29DC;': '',
  '&#x29DB;': '\\{\\{',
  '&#x29D9;': '\\{',
  '&#x29D8;': '\\}',
  '&#x29D7;': '',
  '&#x29D6;': '',
  '&#x29D5;': '\\bowtie',
  '&#x29D4;': '\\bowtie',
  '&#x29D3;': '\\bowtie',
  '&#x29D2;': '\\bowtie',
  '&#x29D1;': '\\bowtie',
  '&#x29D0;&#x338;': '| \\not\\triangleright',
  '&#x29D0;': '| \\triangleright',
  '&#x29CF;&#x338;': '\\not\\triangleleft |',
  '&#x29CF;': '\\triangleleft |',
  '&#x29CE;': '',
  '&#x29CD;': '\\triangle',
  '&#x29CC;': '',
  '&#x29CB;': '\\underline{\\triangle}',
  '&#x29CA;': '\\dot{\\triangle}',
  '&#x29C9;': '',
  '&#x29C8;': '\\boxed{\\circ}',
  '&#x29C7;': '\\boxed{\\circ}',
  '&#x29C6;': '\\boxed{\\rightarrow}',
  '&#x29C5;': '\\bcancel{\\square}',
  '&#x29C4;': '\\cancel{\\square}',
  '&#x29C3;': '\\odot',
  '&#x29C2;': '\\odot',
  '&#x29BF;': '\\odot',
  '&#x29BE;': '\\odot',
  '&#x29BD;': '\\varnothing',
  '&#x29BC;': '\\oplus',
  '&#x29BB;': '\\otimes',
  '&#x29BA;': '',
  '&#x29B9;': '\\varnothing',
  '&#x29B8;': '\\varnothing',
  '&#x29B7;': '\\ominus',
  '&#x29B6;': '\\ominus',
  '&#x29B5;': '\\ominus',
  '&#x29B4;': '\\vec{\\varnothing}',
  '&#x29B3;': '\\vec{\\varnothing}',
  '&#x29B2;': '\\dot{\\varnothing}',
  '&#x29B1;': '\\overline{\\varnothing}',
  '&#x29B0;': '\\varnothing',
  '&#x29AF;': '',
  '&#x29AE;': '',
  '&#x29AD;': '',
  '&#x29AC;': '',
  '&#x29AB;': '',
  '&#x29AA;': '',
  '&#x29A9;': '',
  '&#x29A8;': '',
  '&#x29A7;': '',
  '&#x29A6;': '',
  '&#x29A5;': '',
  '&#x29A4;': '',
  '&#x29A3;': '',
  '&#x29A2;': '',
  '&#x29A1;': '\\not\\lor',
  '&#x29A0;': '\\bcancel{>}',
  '&#x2982;': ':',
  '&#x2981;': '\\circ',
  '&#x2758;': '|',
  '&#x25B2;': '\\bigtriangleup',
  '&#x22FF;': '\\Epsilon',
  '&#x22FE;': '\\overline{\\ni}',
  '&#x22FD;': '\\overline{\\ni}',
  '&#x22FC;': '\\in',
  '&#x22FB;': '\\in',
  '&#x22FA;': '\\in',
  '&#x22F9;': '\\underline{\\in}',
  '&#x22F8;': '\\underline{\\in}',
  '&#x22F7;': '\\overline{\\in}',
  '&#x22F6;': '\\overline{\\in}',
  '&#x22F5;': '\\dot{\\in}',
  '&#x22F4;': '\\in',
  '&#x22F3;': '\\in',
  '&#x22F2;': '\\in',
  '&#x22F0;': '\\ddots',
  '&#x22E9;': '\\underset{\\sim}{\\succ}',
  '&#x22E8;': '\\underset{\\sim}{\\prec}',
  '&#x22E7;': '\\underset{\\not\\sim}{>}',
  '&#x22E6;': '\\underset{\\not\\sim}{<}',
  '&#x22E5;': '\\not\\sqsupseteq',
  '&#x22E4;': '\\not\\sqsubseteq',
  '&#x22E3;': '\\not\\sqsupseteq',
  '&#x22E2;': '\\not\\sqsubseteq',
  '&#x22E1;': '\\nsucc',
  '&#x22E0;': '\\nprec',
  '&#x22DF;': '\\succ',
  '&#x22DE;': '\\prec',
  '&#x22DD;': '\\overline{>}',
  '&#x22DC;': '\\overline{<}',
  '&#x22DB;': '\\underset{>}{\\leq}',
  '&#x22DA;': '\\underset{<}{\\geq}',
  '&#x22D5;': '\\#',
  '&#x22D3;': '\\cup',
  '&#x22D2;': '\\cap',
  '&#x22D1;': '\\supset',
  '&#x22D0;': '\\subset',
  '&#x22CF;': '\\wedge',
  '&#x22CE;': '\\vee',
  '&#x22CD;': '\\simeq',
  '&#x22C8;': '\\bowtie',
  '&#x22C7;': '\\ast',
  '&#x22C6;': '\\star',
  '&#x22C4;': '\\diamond',
  '&#x22BF;': '\\triangle',
  '&#x22BE;': '\\measuredangle',
  '&#x22BD;': '\\overline{\\lor}',
  '&#x22BC;': '\\overline{\\land}',
  '&#x22BB;': '\\underline{\\lor}',
  '&#x22BA;': '\\top',
  '&#x22B9;': '',
  '&#x22B7;': '\\circ\\multimap',
  '&#x22B6;': '\\circ\\multimap',
  '&#x22B3;': '\\triangleright',
  '&#x22B2;': '\\triangleleft',
  '&#x22B1;': '\\succ',
  '&#x22B0;': '\\prec',
  '&#x22AB;': '|\\models',
  '&#x22AA;': '|\\models',
  '&#x22A7;': '\\models',
  '&#x22A6;': '\\vdash',
  '&#x229D;': '\\ominus',
  '&#x229C;': '\\ominus',
  '&#x229B;': '\\odot',
  '&#x229A;': '\\odot',
  '&#x2294;': '\\sqcup',
  '&#x2293;': '\\sqcap',
  '&#x2292;': '\\sqsupseteq',
  '&#x2291;': '\\sqsubseteq',
  '&#x2290;&#x338;': '\\not\\sqsupset',
  '&#x2290;': '\\sqsupset',
  '&#x228F;&#x338;': '\\not\\sqsubset',
  '&#x228F;': '\\sqsubset',
  '&#x228E;': '\\cup',
  '&#x228D;': '\\cup',
  '&#x228C;': '\\cup',
  '&#x227F;&#x338;': '\\not\\succsim',
  '&#x227F;': '\\succsim',
  '&#x227E;': '\\precsim',
  '&#x2279;': '\\not\\overset{>}{<}',
  '&#x2278;': '\\not\\overset{>}{<}',
  '&#x2277;': '\\overset{>}{<}',
  '&#x2276;': '\\overset{<}{>}',
  '&#x2275;': '\\not\\geg',
  '&#x2274;': '\\not\\leq',
  '&#x2273;': '\\geg',
  '&#x2272;': '\\leq',
  '&#x226C;': '',
  '&#x2267;': '\\geg',
  '&#x2266;&#x338;': '\\not\\leq',
  '&#x2266;': '\\leq',
  '&#x2263;': '\\overset{=}{=} ',
  '&#x225E;': '\\overset{m}{=} ',
  '&#x225D;': '\\overset{def}{=}',
  '&#x2258;': '=',
  '&#x2256;': '=',
  '&#x2255;': '=:',
  '&#x2253;': '\\doteq',
  '&#x2252;': '\\doteq',
  '&#x2251;': '\\doteq',
  '&#x2250;': '\\doteq',
  '&#x224F;&#x338;': '',
  '&#x224F;': '',
  '&#x224E;&#x338;': '',
  '&#x224E;': '',
  '&#x224C;': '\\approx',
  '&#x224B;': '\\approx',
  '&#x224A;': '\\approx',
  '&#x2242;&#x338;': '\\neq',
  '&#x2242;': '=',
  '&#x223F;': '\\sim',
  '&#x223E;': '\\infty',
  '&#x223D;&#x331;': '\\sim',
  '&#x223D;': '\\sim',
  '&#x223B;': '\\sim',
  '&#x223A;': ':-:',
  '&#x2239;': '-:',
  '&#x2238;': '\\bot',
  '&#x2237;': '::',
  '&#x2236;': ':',
  '&#x2223;': '|',
  '&#x221F;': '\\llcorner',
  '&#x2219;': '\\cdot',
  '&#x2218;': '\\circ',
  '&#x2217;': '*',
  '&#x2215;': '/',
  '&#x220E;': '\\square',
  '&#x220D;': '\\ni',
  '&#x220A;': '\\in',
  '&#x2206;': '\\Delta',
  '&#x2044;': '/',
  '&#x2AB0;&#x338;': '\\nsucceq',
  '&#x2AB0;': '\\succeq',
  '&#x2AAF;&#x338;': '\\npreceq',
  '&#x2AAF;': '\\preceq',
  '&#x2A88;': '\\ngeqslant',
  '&#x2A87;': '\\nleqslant',
  '&#x29F3;': '\\Phi',
  '&#x29E6;': '\\models',
  '&#x29E5;': '\\not\\equiv',
  '&#x29E4;': '\\approx\\neq',
  '&#x29E3;': '\\neq',
  '&#x29C1;': '\\circle',
  '&#x29C0;': '\\circle',
  '&#x25E6;': '\\circle',
  '&#x25D7;': '\\circle',
  '&#x25D6;': '\\circle',
  '&#x25CF;': '\\circle',
  '&#x25CE;': '\\circledcirc',
  '&#x25CD;': '\\circledcirc',
  '&#x25CC;': '\\circledcirc',
  '&#x25C9;': '\\circledcirc',
  '&#x25C8;': '\\diamond',
  '&#x25C7;': '\\diamond',
  '&#x25C6;': '\\diamond',
  '&#x25C5;': '\\triangleleft',
  '&#x25C4;': '\\triangleleft',
  '&#x25C3;': '\\triangleleft',
  '&#x25C2;': '\\triangleleft',
  '&#x25C1;': '\\triangleleft',
  '&#x25C0;': '\\triangleleft',
  '&#x25BF;': '\\triangledown',
  '&#x25BE;': '\\triangledown',
  '&#x25BD;': '\\triangledown',
  '&#x25BC;': '\\triangledown',
  '&#x25B9;': '\\triangleright',
  '&#x25B8;': '\\triangleright',
  '&#x25B7;': '\\triangleright',
  '&#x25B6;': '\\triangleright',
  '&#x25B5;': '\\triangle',
  '&#x25B4;': '\\triangle',
  '&#x25B3;': '\\triangle',
  '&#x25B1;': '\\square',
  '&#x25B0;': '\\square',
  '&#x25AF;': '\\square',
  '&#x25AE;': '\\square',
  '&#x25AD;': '\\square',
  '&#x25AB;': '\\square',
  '&#x25AA;': '\\square',
  '&#x25A1;': '\\square',
  '&#x25A0;': '\\square',
  '&#x22ED;': '\\not\\triangleright',
  '&#x22EC;': '\\not\\triangleleft',
  '&#x22EB;': '\\not\\triangleright',
  '&#x22EA;': '\\not\\triangleleft',
  '&#x22D9;': '\\ggg',
  '&#x22D8;': '\\lll',
  '&#x22D7;': '*>',
  '&#x22D6;': '<*',
  '&#x22D4;': '\\pitchfork',
  '&#x22CC;': '',
  '&#x22CB;': '',
  '&#x22CA;': '\\rtimes',
  '&#x22C9;': '\\ltimes',
  '&#x22B5;': '\\triangleright',
  '&#x22B4;': '',
  '&#x22A5;': '\\bot',
  '&#x2281;': '\\nsucc',
  '&#x2280;': '\\preceq',
  '&#x227D;': '\\succeq',
  '&#x227C;': '\\preceq',
  '&#x227B;': '\\succ',
  '&#x227A;': '\\prec',
  '&#x2271;': '\\geq/',
  '&#x2270;': '\\leq/',
  '&#x226D;': '\\neq',
  '&#x226B;&#x338;': '\\not\\gg',
  '&#x226B;': '\\gg',
  '&#x226A;&#x338;': '\\not\\ll',
  '&#x226A;': '\\ll',
  '&#x2269;': '\\ngeqslant',
  '&#x2268;': '\\nleqslant',
  '&#x2261;': '\\equiv',
  '&#x225F;': '\\doteq',
  '&#x225C;': '\\triangleq',
  '&#x225B;': '\\doteq',
  '&#x225A;': '\\triangleq',
  '&#x2259;': '\\triangleq',
  '&#x2257;': '\\doteq',
  '&#x2254;': ':=',
  '&#x224D;': '\\asymp',
  '&#x2247;': '\\ncong',
  '&#x2246;': '\\ncong',
  '&#x2245;': '\\cong',
  '&#x2244;': '\\not\\simeq',
  '&#x2243;': '\\simeq',
  '&#x2241;': '\\not\\sim',
  '&#x2226;': '\\not\\parallel',
  '&#x2225;': '\\parallel',
  '&#x2224;': '\\not|',
  '&#x221D;': '\\propto',
  '==': '==',
  '=': '=',
  ':=': ':=',
  '/=': '=',
  '-=': '-=',
  '+=': '+=',
  '*=': '*=',
  '!=': '!=',
  '&#x2260;': '\\neq',
  '&#x2262;': '\\equiv /',
  '&#x2249;': '\\approx /',
  '&#x223C;': 'sim',
  '&#x2248;': '\\approx',
  '&#x226E;': '</',
  '&lt;': '<',
  '&#x226F;': '>/',
  '>=': '>=',
  '>': '>',
  '&#x2265;': '\\geq',
  '&#x2264;': '\\leq',
  '&lt;=': '<=',
  '&#x228B;': '\\supsetneq',
  '&#x228A;': '\\subsetneq',
  '&#x2289;': '\\nsupseteq',
  '&#x2288;': '\\nsubseteq',
  '&#x2287;': '\\supseteq',
  '&#x2286;': '\\subseteq',
  '&#x2285;': '\\not\\supset',
  '&#x2284;': '\\not\\subset',
  '&#x2283;&#x20D2;': '\\supset |',
  '&#x2283;': '\\supset',
  '&#x2282;&#x20D2;': '\\subset |',
  '&#x2282;': '\\subset',
  '&#x220C;': '\\not\\in',
  '&#x2209;': '\\notin',
  '&#x2208;': '\\in',
  '&#x2201;': 'C',
  '&#x2204;': '\\nexists',
  '&#x2203;': '\\exists',
  '&#x2200;': '\\forall',
  '&#x2227;': '\\land',
  '&amp;&amp;': '\\&\\&',
  '&#x2228;': '\\lor',
  '&#x22AF;': '\\cancel{\\vDash}',
  '&#x22AE;': '\\cancel{\\Vdash}',
  '&#x22AD;': '\\nvDash',
  '&#x22AC;': '\\nvDash',
  '&#x22A9;': '\\Vdash',
  '&#x22A8;': '\\vDash',
  '&#x22A4;': '\\top',
  '&#x22A3;': '\\dashv',
  '&#x22A2;': '\\vdash',
  '&#x220B;': '\\ni',
  '&#x22F1;': '\\ddots',
  '&#x22EF;': '\\hdots',
  '&#x22EE;': '\\vdots',
  '&#x2026;': '\\hdots',
  '&#x3F6;': '\\ni',
  ':': ':',
  '...': '\\cdots',
  '..': '..',
  '->': '->',
  '&#x2235;': '\\because',
  '&#x2234;': '\\therefore ',
  '&#x2063;': '',
  ',': ',',
  ';': ';',
  '&#x29FD;': '\\}',
  '&#x29FC;': '\\{',
  '&#x2998;': '\\]',
  '&#x2997;': '\\[',
  '&#x2996;': '\\ll',
  '&#x2995;': '\\gg',
  '&#x2994;': '\\gg',
  '&#x2993;': '\\ll',
  '&#x2992;': '\\gg',
  '&#x2991;': '\\ll',
  '&#x2990;': '\\]',
  '&#x298F;': '\\]',
  '&#x298E;': '\\]',
  '&#x298D;': '\\[',
  '&#x298C;': '\\[',
  '&#x298B;': '\\]',
  '&#x298A;': '\\triangleright',
  '&#x2989;': '\\triangleleft',
  '&#x2988;': '|\\)',
  '&#x2987;': '\\(|',
  '&#x2986;': '|\\)',
  '&#x2985;': '\\(\\(',
  '&#x2984;': '|\\}',
  '&#x2983;': '\\{|',
  '&#x2980;': '\\||',
  '&#x27EF;': '\\left. \\right]',
  '&#x27EE;': '\\left[ \\right.',
  '&#x27ED;': '\\left. \\right]]',
  '&#x27EC;': '\\left[[ \\right.',
  '&#x27EB;': '\\gg',
  '&#x27EA;': '\\ll',
  '&#x27E9;': '\\rangle',
  '&#x27E8;': '\\langle',
  '&#x27E7;': '\\left. \\right]]',
  '&#x27E6;': '\\left[[ \\right.',
  '&#x2773;': '\\left.\\right)',
  '&#x2772;': '\\left(\\right.',
  '&#x232A;': '\\rangle',
  '&#x2329;': '\\langle',
  '&#x230B;': '\\rfloor',
  '&#x230A;': '\\lfloor',
  '&#x2309;': '\\rceil',
  '&#x2308;': '\\lceil',
  '&#x2016;': '\\parallel',
  '}': '\\left.\\right}',
  '{': '\\left{\\right.',
  ']': '\\left]\\right.',
  '[': '\\left[\\right.',
  ')': '\\left.\\right)',
  '(': '\\left(\\right.',
  '&#x201D;': '"',
  '&#x201C;': '``',
  '&#x2019;': "'",
  '&#x2018;': '`',
  '%CE%B1': '\\alpha',
  '%CE%B2': '\\beta',
  '%CE%B3': '\\gamma',
  '%CE%93': '\\Gamma',
  '%CE%B4': '\\delta',
  '%CE%94': '\\Delta',
  '%CF%B5': '\\epsilon',
  '%CE%B6': '\\zeta',
  '%CE%B7': '\\eta',
  '%CE%B8': '\\theta',
  '%CE%98': '\\Theta',
  '%CE%B9': '\\iota',
  '%CE%BA': '\\kappa',
  '%CE%BB': '\\lambda',
  '%CE%BC': '\\mu',
  '%CE%BD': '\\nu',
  '%CE%BF': '\\omicron',
  '%CF%80': '\\pi',
  '%CE%A0': '\\Pi',
  '%CF%81': '\\pho',
  '%CF%83': '\\sigma',
  '%CE%A3': '\\Sigma',
  '%CF%84': '\\tau',
  '%CF%85': '\\upsilon',
  '%CE%A5': '\\Upsilon',
  '%CF%95': '\\phi',
  '%CE%A6': '\\Phi',
  '%CF%87': '\\chi',
  '%CF%88': '\\psi',
  '%CE%A8': '\\Psi',
  '%CF%89': '\\omega',
  '%CE%A9': '\\Omega'
};

var allMathOperatorsByGlyph = {};

Object.defineProperty(allMathOperatorsByGlyph, "__esModule", {
  value: true
});
allMathOperatorsByGlyph.allMathOperatorsByGlyph = void 0;
allMathOperatorsByGlyph.allMathOperatorsByGlyph = {
  _: '\\underline',
  '⏡': '\\underbrace',
  '⏠': '\\overbrace',
  '⏟': '\\underbrace',
  '⏞': '\\overbrace',
  '⏝': '\\underbrace',
  '⏜': '\\overbrace',
  '⎵': '\\underbrace',
  '⎴': '\\overbrace',
  '⃜': '\\square',
  '⃛': '\\square',
  '⁤': '',
  '⁗': "''''",
  '‾': '\\bar',
  '‷': '```',
  '‶': '``',
  '‵': '`',
  '‴': "'''",
  '″': "''",
  '‟': '``',
  '„': ',,',
  '‛': '`',
  '‚': ',',
  '^': '\\hat',
  '˷': '\\sim',
  '˝': '\\sim',
  '˜': '\\sim',
  '˚': '\\circ',
  '˙': '\\cdot',
  '˘': '',
  ˍ: '\\_',
  ˋ: 'ˋ',
  ˊ: 'ˊ',
  ˉ: 'ˉ',
  ˇ: '',
  ˆ: '\\hat',
  º: 'o',
  '¹': '1',
  '¸': '¸',
  '´': '´',
  '³': '3',
  '²': '2',
  '°': '\\circ',
  '¯': '\\bar',
  ª: 'a',
  '¨': '\\cdot\\cdot',
  '~': '\\sim',
  '`': '`',
  '--': '--',
  '++': '++',
  '&': '\\&',
  '∜': '\\sqrt[4]{}',
  '∛': '\\sqrt[3]{}',
  '√': '\\sqrt{}',
  ⅆ: 'd',
  ⅅ: '\\mathbb{D}',
  '?': '?',
  '@': '@',
  '//': '//',
  '!!': '!!',
  '!': '!',
  '♯': '\\#',
  '♮': '',
  '♭': '',
  '′': "'",
  '<>': '<>',
  '**': '\\star\\star',
  '∇': '\\nabla',
  '∂': '\\partial',
  '⊙': '\\bigodot',
  '¬': '\\neg',
  '∢': '\\measuredangle',
  '∡': '\\measuredangle',
  '∠': '\\angle',
  '÷': '\\div',
  '/': '/',
  '∖': '\\backslash',
  '\\': '\\backslash',
  '%': '\\%',
  '⊗': '\\bigotimes',
  '·': '\\cdot',
  '⨿': '\\coprod',
  '⨯': '\\times',
  '⋅': '\\cdot',
  '⊡': '\\boxdot',
  '⊠': '\\boxtimes',
  '⁢': '',
  '⁃': '-',
  '•': '\\cdot',
  '×': '\\times',
  '.': '.',
  '*': '\\star',
  '∪': '\\cup',
  '∩': '\\cap',
  '∐': '\\coprod',
  '∏': '\\prod',
  '≀': '',
  '⫿': '',
  '⫼': '\\mid\\mid\\mid',
  '⨉': '\\times',
  '⨈': '',
  '⨇': '',
  '⨆': '\\sqcup',
  '⨅': '\\sqcap',
  '⨂': '\\otimes',
  '⨀': '\\odot',
  '⋂': '\\cap',
  '⋁': '\\vee',
  '⋀': '\\wedge',
  '⨄': '\\uplus',
  '⨃': '\\cup',
  '⋃': '\\cup',
  '⨜': '\\underline{\\int}',
  '⨛': '\\overline{\\int}',
  '⨚': '\\int',
  '⨙': '\\int',
  '⨘': '\\int',
  '⨗': '\\int',
  '⨖': '\\oint',
  '⨕': '\\oint',
  '⨔': '\\int',
  '⨓': '\\int',
  '⨒': '\\int',
  '⨑': '\\int',
  '⨐': '\\int',
  '⨏': '\\bcancel{\\int}',
  '⨎': '',
  '⨍': '\\hcancel{\\int}',
  '⨌': '\\iiiint',
  '∳': '\\oint',
  '∲': '\\oint',
  '∱': '\\int',
  '∰': '\\oiint',
  '∯': '\\oiint',
  '∮': '\\oint',
  '∫': '\\int',
  '⨁': '\\oplus',
  '⊘': '\\oslash',
  '⊖': '\\ominus',
  '⊕': '\\oplus',
  '∭': '\\iiint',
  '∬': '\\iint',
  '⨋': '',
  '⨊': '',
  '∑': '\\sum',
  '⊟': '\\boxminus',
  '⊞': '\\boxplus',
  '∔': '\\dot{+}',
  '∓': '+-',
  '−': '-',
  '±': '\\pm',
  '-': '-',
  '+': '+',
  '⭆': '\\Rrightarrow',
  '⭅': '\\Lleftarrow',
  '⧴': ':\\rightarrow',
  '⧯': '',
  '⧟': '\\bullet-\\bullet',
  '⦟': '\\angle',
  '⦞': '\\measuredangle',
  '⦝': '\\measuredangle',
  '⦜': '\\perp',
  '⦛': '\\measuredangle',
  '⦚': '',
  '⦙': '\\vdots',
  '⥿': '',
  '⥾': '',
  '⥽': '\\prec',
  '⥼': '\\succ',
  '⥻': '\\underset{\\rightarrow}{\\supset}',
  '⥺': '',
  '⥹': '\\underset{\\rightarrow}{\\subset}',
  '⥸': '\\underset{\\rightarrow}{>}',
  '⥷': '',
  '⥶': '\\underset{\\leftarrow}{<}',
  '⥵': '\\underset{\\approx}{\\rightarrow}',
  '⥴': '\\underset{\\sim}{\\rightarrow}',
  '⥳': '\\underset{\\sim}{\\leftarrow}',
  '⥲': '\\overset{\\sim}{\\rightarrow}',
  '⥱': '\\overset{=}{\\rightarrow}',
  '⥰': '',
  '⥯': '',
  '⥮': '',
  '⥭': '\\overline{\\rightharpoondown}',
  '⥬': '\\underline{\\rightharpoonup}',
  '⥫': '\\overline{\\leftharpoondown}',
  '⥪': '\\underline{\\leftharpoonup}',
  '⥩': '\\rightleftharpoons',
  '⥨': '\\rightleftharpoons',
  '⥧': '\\rightleftharpoons',
  '⥦': '\\rightleftharpoons',
  '⥥': '\\Downarrow',
  '⥤': '\\Rightarrow',
  '⥣': '\\Uparrow',
  '⥢': '\\Leftarrow',
  '⥡': '\\downarrow',
  '⥠': '\\uparrow',
  '⥟': '\\rightarrow',
  '⥞': '\\leftarrow',
  '⥝': '\\downarrow',
  '⥜': '\\uparrow',
  '⥛': '\\rightarrow',
  '⥚': '\\leftarrow',
  '⥙': '\\downarrow',
  '⥘': '\\uparrow',
  '⥗': '\\rightarrow',
  '⥖': '\\leftarrow',
  '⥕': '\\downarrow',
  '⥔': '\\uparrow',
  '⥓': '\\rightarrow',
  '⥒': '\\leftarrow',
  '⥑': '\\updownarrow',
  '⥐': '\\leftrightarrow',
  '⥏': '\\updownarrow',
  '⥎': '\\leftrightarrow',
  '⥍': '\\updownarrow',
  '⥌': '\\updownarrow',
  '⥋': '\\leftrightarrow',
  '⥊': '\\leftrightarrow',
  '⥉': '',
  '⥈': '\\leftrightarrow',
  '⥇': '\\nrightarrow',
  '⥆': '',
  '⥅': '',
  '⥄': '\\rightleftarrows',
  '⥃': '\\leftrightarrows',
  '⥂': '\\rightleftarrows',
  '⥁': '\\circlearrowright',
  '⥀': '\\circlearrowleft',
  '⤿': '\\rightarrow',
  '⤾': '\\leftarrow',
  '⤽': '',
  '⤼': '',
  '⤻': '',
  '⤺': '',
  '⤹': '',
  '⤸': '',
  '⤷': '\\Rsh',
  '⤶': '\\Lsh',
  '⤵': '\\downarrow',
  '⤴': '\\uparrow',
  '⤳': '\\leadsto',
  '⤲': '',
  '⤱': '',
  '⤰': '',
  '⤯': '',
  '⤮': '',
  '⤭': '',
  '⤬': '\\times',
  '⤫': '\\times',
  '⤪': '',
  '⤩': '',
  '⤨': '',
  '⤧': '',
  '⤦': '',
  '⤥': '',
  '⤤': '',
  '⤣': '',
  '⤢': '',
  '⤡': '',
  '⤠': '\\mapsto\\cdot',
  '⤟': '\\cdot\\leftarrow',
  '⤞': '\\rightarrow\\cdot',
  '⤝': '\\leftarrow',
  '⤜': '\\rightarrow',
  '⤛': '\\leftarrow',
  '⤚': '\\rightarrow',
  '⤙': '\\leftarrow',
  '⤘': '\\rightarrow',
  '⤗': '\\rightarrow',
  '⤖': '\\rightarrow',
  '⤕': '\\rightarrow',
  '⤔': '\\rightarrow',
  '⤓': '\\downarrow',
  '⤒': '\\uparrow',
  '⤑': '\\rightarrow',
  '⤐': '\\rightarrow',
  '⤏': '\\rightarrow',
  '⤎': '\\leftarrow',
  '⤍': '\\rightarrow',
  '⤌': '\\leftarrow',
  '⤋': '\\Downarrow',
  '⤊': '\\Uparrow',
  '⤉': '\\uparrow',
  '⤈': '\\downarrow',
  '⤇': '\\Rightarrow',
  '⤆': '\\Leftarrow',
  '⤅': '\\mapsto',
  '⤄': '\\nLeftrightarrow',
  '⤃': '\\nRightarrow',
  '⤂': '\\nLeftarrow',
  '⤁': '\\rightsquigarrow',
  '⤀': '\\rightsquigarrow',
  '⟿': '\\rightsquigarrow',
  '⟾': '\\Rightarrow',
  '⟽': '\\Leftarrow',
  '⟼': '\\mapsto',
  '⟻': '\\leftarrow',
  '⟺': '\\Longleftrightarrow',
  '⟹': '\\Longrightarrow',
  '⟸': '\\Longleftarrow',
  '⟷': '\\leftrightarrow',
  '⟶': '\\rightarrow',
  '⟵': '\\leftarrow',
  '⟱': '\\Downarrow',
  '⟰': '\\Uparrow',
  '⊸': '\\rightarrow',
  '⇿': '\\leftrightarrow',
  '⇾': '\\rightarrow',
  '⇽': '\\leftarrow',
  '⇼': '\\nleftrightarrow',
  '⇻': '\\nrightarrow',
  '⇺': '\\nleftarrow',
  '⇹': '\\nleftrightarrow',
  '⇸': '\\nrightarrow',
  '⇷': '\\nleftarrow',
  '⇶': '\\Rrightarrow',
  '⇵': '',
  '⇴': '\\rightarrow',
  '⇳': '\\Updownarrow',
  '⇲': '\\searrow',
  '⇱': '\\nwarrow',
  '⇰': '\\Leftarrow',
  '⇯': '\\Uparrow',
  '⇮': '\\Uparrow',
  '⇭': '\\Uparrow',
  '⇬': '\\Uparrow',
  '⇫': '\\Uparrow',
  '⇪': '\\Uparrow',
  '⇩': '\\Downarrow',
  '⇨': '\\Rightarrow',
  '⇧': '\\Uparrow',
  '⇦': '\\Leftarrow',
  '⇥': '\\rightarrow',
  '⇤': '\\leftarrow',
  '⇣': '\\downarrow',
  '⇢': '\\rightarrow',
  '⇡': '\\uparrow',
  '⇠': '\\leftarrow',
  '⇟': '\\downarrow',
  '⇞': '\\uparrow',
  '⇝': '\\rightsquigarrow',
  '⇜': '\\leftarrow',
  '⇛': '\\Rrightarrow',
  '⇚': '\\Lleftarrow',
  '⇙': '\\swarrow',
  '⇘': '\\searrow',
  '⇗': '\\nearrow',
  '⇖': '\\nwarrow',
  '⇕': '\\Updownarrow',
  '⇔': '\\Leftrightarrow',
  '⇓': '\\Downarrow',
  '⇒': '\\Rightarrow',
  '⇑': '\\Uparrow',
  '⇐': '\\Leftarrow',
  '⇏': '\\nRightarrow',
  '⇎': '\\nLeftrightarrow',
  '⇍': '\\nLeftarrow',
  '⇌': '\\rightleftharpoons',
  '⇋': '\\leftrightharpoons',
  '⇊': '\\downdownarrows',
  '⇉': '\\rightrightarrows',
  '⇈': '\\upuparrows',
  '⇇': '\\leftleftarrows',
  '⇆': '\\leftrightarrows',
  '⇅': '',
  '⇄': '\\rightleftarrows',
  '⇃': '\\downharpoonleft',
  '⇂': '\\downharpoonright',
  '⇁': '\\rightharpoondown',
  '⇀': '\\rightharpoonup',
  '↿': '\\upharpoonleft',
  '↾': '\\upharpoonright',
  '↽': '\\leftharpoondown',
  '↼': '\\leftharpoonup',
  '↻': '\\circlearrowright',
  '↺': '\\circlearrowleft',
  '↹': '\\leftrightarrows',
  '↸': '\\overline{\\nwarrow}',
  '↷': '\\curvearrowright',
  '↶': '\\curvearrowleft',
  '↵': '\\swarrow',
  '↴': '\\searrow',
  '↳': '\\Rsh',
  '↲': '\\Lsh',
  '↱': '\\Rsh',
  '↰': '\\Lsh',
  '↯': '\\swarrow',
  '↮': '',
  '↭': '\\leftrightsquigarrow',
  '↬': '\\looparrowright',
  '↫': '\\looparrowleft',
  '↪': '\\hookrightarrow',
  '↩': '\\hookleftarrow',
  '↨': '\\underline{\\updownarrow}',
  '↧': '\\downarrow',
  '↦': '\\rightarrowtail',
  '↥': '\\uparrow',
  '↤': '\\leftarrowtail',
  '↣': '\\rightarrowtail',
  '↢': '\\leftarrowtail',
  '↡': '\\downarrow',
  '↠': '\\twoheadrightarrow',
  '↟': '\\uparrow',
  '↞': '\\twoheadleftarrow',
  '↝': '\\nearrow',
  '↜': '\\nwarrow',
  '↛': '',
  '↚': '',
  '↙': '\\swarrow',
  '↘': '\\searrow',
  '↗': '\\nearrow',
  '↖': '\\nwarrow',
  '↕': '\\updownarrow',
  '↔': '\\leftrightarrow',
  '↓': '\\downarrow',
  '→': '\\rightarrow',
  '↑': '\\uparrow',
  '←': '\\leftarrow',
  '|||': '\\left|||\\right.',
  '||': '\\left||\\right.',
  '|': '\\left|\\right.',
  '⫾': '',
  '⫽': '//',
  '⫻': '///',
  '⫺': '',
  '⫹': '',
  '⫸': '',
  '⫷': '',
  '⫶': '\\vdots',
  '⫵': '',
  '⫴': '',
  '⫳': '',
  '⫲': '\\nparallel',
  '⫱': '',
  '⫰': '',
  '⫯': '',
  '⫮': '\\bcancel{\\mid}',
  '⫭': '',
  '⫬': '',
  '⫫': '',
  '⫪': '',
  '⫩': '',
  '⫨': '\\underline{\\perp}',
  '⫧': '\\overline{\\top}',
  '⫦': '',
  '⫥': '',
  '⫤': '',
  '⫣': '',
  '⫢': '',
  '⫡': '',
  '⫠': '\\perp',
  '⫟': '\\top',
  '⫞': '\\dashv',
  '⫝̸': '',
  '⫝': '',
  '⫛': '\\pitchfork',
  '⫚': '',
  '⫙': '',
  '⫘': '',
  '⫗': '',
  '⫖': '',
  '⫕': '',
  '⫔': '',
  '⫓': '',
  '⫒': '',
  '⫑': '',
  '⫐': '',
  '⫏': '',
  '⫎': '',
  '⫍': '',
  '⫌': '\\underset{\\neq}{\\supset}',
  '⫋': '\\underset{\\neq}{\\subset}',
  '⫊': '\\underset{\\approx}{\\supset}',
  '⫉': '\\underset{\\approx}{\\subset}',
  '⫈': '\\underset{\\sim}{\\supset}',
  '⫇': '\\underset{\\sim}{\\subset}',
  '⫆': '\\supseteqq',
  '⫅': '\\subseteqq',
  '⫄': '\\dot{\\supseteq}',
  '⫃': '\\dot{\\subseteq}',
  '⫂': '\\underset{\\times}{\\supset}',
  '⫁': '\\underset{\\times}{\\subset}',
  '⫀': '\\underset{+}{\\supset}',
  '⪿': '\\underset{+}{\\subset}',
  '⪾': '',
  '⪽': '',
  '⪼': '\\gg ',
  '⪻': '\\ll',
  '⪺': '\\underset{\\cancel{\\approx}}{\\succ}',
  '⪹': '\\underset{\\cancel{\\approx}}{\\prec}',
  '⪸': '\\underset{\\approx}{\\succ}',
  '⪷': '\\underset{\\approx}{\\prec}',
  '⪶': '\\underset{\\cancel{=}}{\\succ}',
  '⪵': '\\underset{\\cancel{=}}{\\prec}',
  '⪴': '\\underset{=}{\\succ}',
  '⪳': '\\underset{=}{\\prec}',
  '⪲': '',
  '⪱': '',
  '⪮': '',
  '⪭': '\\underline{\\hcancel{>}}',
  '⪬': '\\underline{\\hcancel{>}}',
  '⪫': '\\hcancel{>}',
  '⪪': '\\hcancel{<}',
  '⪩': '',
  '⪨': '',
  '⪧': '\\vartriangleright',
  '⪦': '\\vartriangleleft',
  '⪥': '><',
  '⪤': '><',
  '⪣': '\\underline{\\ll}',
  '⪢̸': '\\cancel{\\gg}',
  '⪢': '\\gg',
  '⪡̸': '\\cancel{\\ll}',
  '⪡': '\\ll',
  '⪠': '\\overset{\\sim}{\\geqq}',
  '⪟': '\\overset{\\sim}{\\leqq}',
  '⪞': '\\overset{\\sim}{>}',
  '⪝': '\\overset{\\sim}{<}',
  '⪜': '',
  '⪛': '',
  '⪚': '\\overset{=}{>}',
  '⪙': '\\overset{=}{<}',
  '⪘': '',
  '⪗': '',
  '⪖': '',
  '⪕': '',
  '⪔': '',
  '⪓': '',
  '⪒': '\\underset{=}{\\gtrless}',
  '⪑': '\\underset{=}{\\lessgtr}',
  '⪐': '\\underset{<}{\\gtrsim}',
  '⪏': '\\underset{>}{\\lesssim}',
  '⪎': '\\underset{\\simeq}{>}',
  '⪍': '\\underset{\\simeq}{<}',
  '⪌': '\\gtreqqless',
  '⪋': '\\lesseqqgtr',
  '⪊': '\\underset{\\cancel{\\approx}}{>}',
  '⪉': '\\underset{\\approx}{<}',
  '⪆': '\\underset{\\approx}{>}',
  '⪅': '\\underset{\\approx}{<}',
  '⪄': '',
  '⪃': '',
  '⪂': '',
  '⪁': '',
  '⪀': '',
  '⩿': '',
  '⩾̸': '\\bcancel{\\geq}',
  '⩾': '\\geq',
  '⩽̸': '\\bcancel{\\leq}',
  '⩽': '\\leq',
  '⩼': '',
  '⩻': '',
  '⩺': '',
  '⩹': '',
  '⩸': '\\overset{\\dots}{\\equiv}',
  '⩷': '',
  '⩶': '===',
  '⩵': '==',
  '⩴': '::=',
  '⩳': '',
  '⩲': '\\underset{=}{+}',
  '⩱': '\\overset{=}{+}',
  '⩰': '\\overset{\\approx}{=}',
  '⩯': '\\overset{\\wedge}{=}',
  '⩮': '\\overset{*}{=}',
  '⩭': '\\dot{\\approx}',
  '⩬': '',
  '⩫': '',
  '⩪': '\\dot{\\sim}',
  '⩩': '',
  '⩨': '',
  '⩧': '\\dot{\\equiv}',
  '⩦': '\\underset{\\cdot}{=}',
  '⩥': '',
  '⩤': '',
  '⩣': '\\underset{=}{\\vee}',
  '⩢': '\\overset{=}{\\vee}',
  '⩡': 'ul(vv)',
  '⩠': '\\underset{=}{\\wedge}',
  '⩟': '\\underline{\\wedge}',
  '⩞': '\\overset{=}{\\wedge}',
  '⩝': '\\hcancel{\\vee}',
  '⩜': '\\hcancel{\\wedge}',
  '⩛': '',
  '⩚': '',
  '⩙': '',
  '⩘': '\\vee',
  '⩗': '\\wedge',
  '⩖': '',
  '⩕': '',
  '⩔': '',
  '⩓': '',
  '⩒': '\\dot{\\vee}',
  '⩑': '\\dot{\\wedge}',
  '⩐': '',
  '⩏': '',
  '⩎': '',
  '⩍': '\\overline{\\cap}',
  '⩌': '\\overline{\\cup}',
  '⩋': '',
  '⩊': '',
  '⩉': '',
  '⩈': '',
  '⩇': '',
  '⩆': '',
  '⩅': '',
  '⩄': '',
  '⩃': '\\overline{\\cap}',
  '⩂': '\\overline{\\cup}',
  '⩁': '',
  '⩀': '',
  '⨾': '',
  '⨽': '\\llcorner',
  '⨼': '\\lrcorner',
  '⨻': '',
  '⨺': '',
  '⨹': '',
  '⨸': '',
  '⨷': '',
  '⨶': '\\hat{\\otimes}',
  '⨵': '',
  '⨴': '',
  '⨳': '',
  '⨲': '\\underline{\\times}',
  '⨱': '\\underline{\\times}',
  '⨰': '\\dot{\\times}',
  '⨮': '',
  '⨭': '',
  '⨬': '',
  '⨫': '',
  '⨪': '',
  '⨩': '',
  '⨨': '',
  '⨧': '',
  '⨦': '\\underset{\\sim}{+}',
  '⨥': '\\underset{\\circ}{+}',
  '⨤': '\\overset{\\sim}{+}',
  '⨣': '\\hat{+}',
  '⨢': '\\dot{+}',
  '⨡': '\\upharpoonright',
  '⨠': '>>',
  '⨟': '',
  '⨞': '\\triangleleft',
  '⨝': '\\bowtie',
  '⧿': '',
  '⧾': '+',
  '⧻': '\\hcancel{|||}',
  '⧺': '\\hcancel{||}',
  '⧹': '\\backslash',
  '⧸': '/',
  '⧷': 'hcancel{\backslash}',
  '⧶': '',
  '⧵': '\\backslash',
  '⧲': '\\Phi',
  '⧱': '',
  '⧰': '',
  '⧮': '',
  '⧭': '',
  '⧬': '',
  '⧫': '\\lozenge',
  '⧪': '',
  '⧩': '',
  '⧨': '',
  '⧧': '\\ddagger',
  '⧢': '\\sqcup\\sqcup',
  '⧡': '',
  '⧠': '\\square',
  '⧞': '',
  '⧝': '',
  '⧜': '',
  '⧛': '\\{\\{',
  '⧙': '\\{',
  '⧘': '\\}',
  '⧗': '',
  '⧖': '',
  '⧕': '\\bowtie',
  '⧔': '\\bowtie',
  '⧓': '\\bowtie',
  '⧒': '\\bowtie',
  '⧑': '\\bowtie',
  '⧐̸': '| \\not\\triangleright',
  '⧐': '| \\triangleright',
  '⧏̸': '\\not\\triangleleft |',
  '⧏': '\\triangleleft |',
  '⧎': '',
  '⧍': '\\triangle',
  '⧌': '',
  '⧋': '\\underline{\\triangle}',
  '⧊': '\\dot{\\triangle}',
  '⧉': '',
  '⧈': '\\boxed{\\circ}',
  '⧇': '\\boxed{\\circ}',
  '⧆': '\\boxed{\\rightarrow}',
  '⧅': '\\bcancel{\\square}',
  '⧄': '\\cancel{\\square}',
  '⧃': '\\odot',
  '⧂': '\\odot',
  '⦿': '\\odot',
  '⦾': '\\odot',
  '⦽': '\\varnothing',
  '⦼': '\\oplus',
  '⦻': '\\otimes',
  '⦺': '',
  '⦹': '\\varnothing',
  '⦸': '\\varnothing',
  '⦷': '\\ominus',
  '⦶': '\\ominus',
  '⦵': '\\ominus',
  '⦴': '\\vec{\\varnothing}',
  '⦳': '\\vec{\\varnothing}',
  '⦲': '\\dot{\\varnothing}',
  '⦱': '\\overline{\\varnothing}',
  '⦰': '\\varnothing',
  '⦯': '',
  '⦮': '',
  '⦭': '',
  '⦬': '',
  '⦫': '',
  '⦪': '',
  '⦩': '',
  '⦨': '',
  '⦧': '',
  '⦦': '',
  '⦥': '',
  '⦤': '',
  '⦣': '',
  '⦢': '',
  '⦡': '\\not\\lor',
  '⦠': '\\bcancel{>}',
  '⦂': ':',
  '⦁': '\\circ',
  '❘': '|',
  '▲': '\\bigtriangleup',
  '⋿': '\\Epsilon',
  '⋾': '\\overline{\\ni}',
  '⋽': '\\overline{\\ni}',
  '⋼': '\\in',
  '⋻': '\\in',
  '⋺': '\\in',
  '⋹': '\\underline{\\in}',
  '⋸': '\\underline{\\in}',
  '⋷': '\\overline{\\in}',
  '⋶': '\\overline{\\in}',
  '⋵': '\\dot{\\in}',
  '⋴': '\\in',
  '⋳': '\\in',
  '⋲': '\\in',
  '⋰': '\\ddots',
  '⋩': '\\underset{\\sim}{\\succ}',
  '⋨': '\\underset{\\sim}{\\prec}',
  '⋧': '\\underset{\\not\\sim}{>}',
  '⋦': '\\underset{\\not\\sim}{<}',
  '⋥': '\\not\\sqsupseteq',
  '⋤': '\\not\\sqsubseteq',
  '⋣': '\\not\\sqsupseteq',
  '⋢': '\\not\\sqsubseteq',
  '⋡': '\\nsucc',
  '⋠': '\\nprec',
  '⋟': '\\succ',
  '⋞': '\\prec',
  '⋝': '\\overline{>}',
  '⋜': '\\overline{<}',
  '⋛': '\\underset{>}{\\leq}',
  '⋚': '\\underset{<}{\\geq}',
  '⋕': '\\#',
  '⋓': '\\cup',
  '⋒': '\\cap',
  '⋑': '\\supset',
  '⋐': '\\subset',
  '⋏': '\\wedge',
  '⋎': '\\vee',
  '⋍': '\\simeq',
  '⋈': '\\bowtie',
  '⋇': '\\ast',
  '⋆': '\\star',
  '⋄': '\\diamond',
  '⊿': '\\triangle',
  '⊾': '\\measuredangle',
  '⊽': '\\overline{\\lor}',
  '⊼': '\\overline{\\land}',
  '⊻': '\\underline{\\lor}',
  '⊺': '\\top',
  '⊹': '',
  '⊷': '\\circ\\multimap',
  '⊶': '\\circ\\multimap',
  '⊳': '\\triangleright',
  '⊲': '\\triangleleft',
  '⊱': '\\succ',
  '⊰': '\\prec',
  '⊫': '|\\models',
  '⊪': '|\\models',
  '⊧': '\\models',
  '⊦': '\\vdash',
  '⊝': '\\ominus',
  '⊜': '\\ominus',
  '⊛': '\\odot',
  '⊚': '\\odot',
  '⊔': '\\sqcup',
  '⊓': '\\sqcap',
  '⊒': '\\sqsupseteq',
  '⊑': '\\sqsubseteq',
  '⊐̸': '\\not\\sqsupset',
  '⊐': '\\sqsupset',
  '⊏̸': '\\not\\sqsubset',
  '⊏': '\\sqsubset',
  '⊎': '\\cup',
  '⊍': '\\cup',
  '⊌': '\\cup',
  '≿̸': '\\not\\succsim',
  '≿': '\\succsim',
  '≾': '\\precsim',
  '≹': '\\not\\overset{>}{<}',
  '≸': '\\not\\overset{>}{<}',
  '≷': '\\overset{>}{<}',
  '≶': '\\overset{<}{>}',
  '≵': '\\not\\geg',
  '≴': '\\not\\leq',
  '≳': '\\geg',
  '≲': '\\leq',
  '≬': '',
  '≧': '\\geg',
  '≦̸': '\\not\\leq',
  '≦': '\\leq',
  '≣': '\\overset{=}{=} ',
  '≞': '\\overset{m}{=} ',
  '≝': '\\overset{def}{=}',
  '≘': '=',
  '≖': '=',
  '≕': '=:',
  '≓': '\\doteq',
  '≒': '\\doteq',
  '≑': '\\doteq',
  '≐': '\\doteq',
  '≏̸': '',
  '≏': '',
  '≎̸': '',
  '≎': '',
  '≌': '\\approx',
  '≋': '\\approx',
  '≊': '\\approx',
  '≂̸': '\\neq',
  '≂': '=',
  '∿': '\\sim',
  '∾': '\\infty',
  '∽̱': '\\sim',
  '∽': '\\sim',
  '∻': '\\sim',
  '∺': ':-:',
  '∹': '-:',
  '∸': '\\bot',
  '∷': '::',
  '∶': ':',
  '∣': '|',
  '∟': '\\llcorner',
  '∙': '\\cdot',
  '∘': '\\circ',
  '∗': '*',
  '∕': '/',
  '∎': '\\square',
  '∍': '\\ni',
  '∊': '\\in',
  '∆': '\\Delta',
  '⁄': '/',
  '⪰̸': '\\nsucceq',
  '⪰': '\\succeq',
  '⪯̸': '\\npreceq',
  '⪯': '\\preceq',
  '⪈': '\\ngeqslant',
  '⪇': '\\nleqslant',
  '⧳': '\\Phi',
  '⧦': '\\models',
  '⧥': '\\not\\equiv',
  '⧤': '\\approx\\neq',
  '⧣': '\\neq',
  '⧁': '\\circle',
  '⧀': '\\circle',
  '◦': '\\circle',
  '◗': '\\circle',
  '◖': '\\circle',
  '●': '\\circle',
  '◎': '\\circledcirc',
  '◍': '\\circledcirc',
  '◌': '\\circledcirc',
  '◉': '\\circledcirc',
  '◈': '\\diamond',
  '◇': '\\diamond',
  '◆': '\\diamond',
  '◅': '\\triangleleft',
  '◄': '\\triangleleft',
  '◃': '\\triangleleft',
  '◂': '\\triangleleft',
  '◁': '\\triangleleft',
  '◀': '\\triangleleft',
  '▿': '\\triangledown',
  '▾': '\\triangledown',
  '▽': '\\triangledown',
  '▼': '\\triangledown',
  '▹': '\\triangleright',
  '▸': '\\triangleright',
  '▷': '\\triangleright',
  '▶': '\\triangleright',
  '▵': '\\triangle',
  '▴': '\\triangle',
  '△': '\\triangle',
  '▱': '\\square',
  '▰': '\\square',
  '▯': '\\square',
  '▮': '\\square',
  '▭': '\\square',
  '▫': '\\square',
  '▪': '\\square',
  '□': '\\square',
  '■': '\\square',
  '⋭': '\\not\\triangleright',
  '⋬': '\\not\\triangleleft',
  '⋫': '\\not\\triangleright',
  '⋪': '\\not\\triangleleft',
  '⋙': '\\ggg',
  '⋘': '\\lll',
  '⋗': '*>',
  '⋖': '<*',
  '⋔': '\\pitchfork',
  '⋌': '',
  '⋋': '',
  '⋊': '\\rtimes',
  '⋉': '\\ltimes',
  '⊵': '\\triangleright',
  '\\triangleleft': '',
  '⊥': '\\bot',
  '⊁': '\\nsucc',
  '⊀': '\\preceq',
  '≽': '\\succeq',
  '≼': '\\preceq',
  '≻': '\\succ',
  '≺': '\\prec',
  '≱': '\\geq/',
  '≰': '\\leq/',
  '≭': '\\neq',
  '≫̸': '\\not\\gg',
  '≫': '\\gg',
  '≪̸': '\\not\\ll',
  '≪': '\\ll',
  '≩': '\\ngeqslant',
  '≨': '\\nleqslant',
  '≡': '\\equiv',
  '≟': '\\doteq',
  '≜': '\\triangleq',
  '≛': '\\doteq',
  '≚': '\\triangleq',
  '≙': '\\triangleq',
  '≗': '\\doteq',
  '≔': ':=',
  '≍': '\\asymp',
  '≇': '\\ncong',
  '≆': '\\ncong',
  '≅': '\\cong',
  '≄': '\\not\\simeq',
  '≃': '\\simeq',
  '≁': '\\not\\sim',
  '∦': '\\not\\parallel',
  '∥': '\\parallel',
  '∤': '\\not|',
  '∝': '\\propto',
  '==': '==',
  '=': '=',
  ':=': ':=',
  '/=': '=',
  '-=': '-=',
  '+=': '+=',
  '*=': '*=',
  '!=': '!=',
  '≠': '\\neq',
  '≢': '\\equiv /',
  '≉': '\\approx /',
  '∼': 'sim',
  '≈': '\\approx',
  '≮': '</',
  '<': '<',
  '≯': '>/',
  '>=': '>=',
  '>': '>',
  '≥': '\\geq',
  '≤': '\\leq',
  '<=': '<=',
  '⊋': '\\supsetneq',
  '⊊': '\\subsetneq',
  '⊉': '\\nsupseteq',
  '⊈': '\\nsubseteq',
  '⊇': '\\supseteq',
  '⊆': '\\subseteq',
  '⊅': '\\not\\supset',
  '⊄': '\\not\\subset',
  '⊃⃒': '\\supset |',
  '⊃': '\\supset',
  '⊂⃒': '\\subset |',
  '⊂': '\\subset',
  '∌': '\\not\\in',
  '∉': '\\notin',
  '∈': '\\in',
  '∁': 'C',
  '∄': '\\nexists',
  '∃': '\\exists',
  '∀': '\\forall',
  '∧': '\\land',
  '&&': '\\&\\&',
  '∨': '\\lor',
  '⊯': '\\cancel{\\vDash}',
  '⊮': '\\cancel{\\Vdash}',
  '⊭': '\\nvDash',
  '⊬': '\\nvDash',
  '⊩': '\\Vdash',
  '⊨': '\\vDash',
  '⊤': '\\top',
  '⊣': '\\dashv',
  '⊢': '\\vdash',
  '∋': '\\ni',
  '⋱': '\\ddots',
  '⋯': '\\hdots',
  '⋮': '\\vdots',
  '…': '\\hdots',
  '϶': '\\ni',
  ':': ':',
  '...': '\\cdots',
  '..': '..',
  '->': '->',
  '∵': '\\because',
  '∴': '\\therefore ',
  '⁣': '',
  ',': ',',
  ';': ';',
  '⧽': '\\}',
  '⧼': '\\{',
  '⦘': '\\]',
  '⦗': '\\[',
  '⦖': '\\ll',
  '⦕': '\\gg',
  '⦔': '\\gg',
  '⦓': '\\ll',
  '⦒': '\\gg',
  '⦑': '\\ll',
  '⦐': '\\]',
  '⦏': '\\]',
  '⦎': '\\]',
  '⦍': '\\[',
  '⦌': '\\[',
  '⦋': '\\]',
  '⦊': '\\triangleright',
  '⦉': '\\triangleleft',
  '⦈': '|\\)',
  '⦇': '\\(|',
  '⦆': '|\\)',
  '⦅': '\\(\\(',
  '⦄': '|\\}',
  '⦃': '\\{|',
  '⦀': '\\||',
  '⟯': '\\left. \\right]',
  '⟮': '\\left[ \\right.',
  '⟭': '\\left. \\right]]',
  '⟬': '\\left[[ \\right.',
  '⟫': '\\gg',
  '⟪': '\\ll',
  '⟩': '\\rangle',
  '⟨': '\\langle',
  '⟧': '\\left. \\right]]',
  '⟦': '\\left[[ \\right.',
  '❳': '\\left.\\right)',
  '❲': '\\left(\\right.',
  '〉': '\\rangle',
  '〈': '\\langle',
  '⌋': '\\rfloor',
  '⌊': '\\lfloor',
  '⌉': '\\rceil',
  '⌈': '\\lceil',
  '‖': '\\parallel',
  '}': '\\left.\\right}',
  '{': '\\left{\\right.',
  ']': '\\left]\\right.',
  '[': '\\left[\\right.',
  ')': '\\left.\\right)',
  '(': '\\left(\\right.',
  '”': '"',
  '“': '``',
  '’': "'",
  '‘': '`',
  α: '\\alpha',
  β: '\\beta',
  γ: '\\gamma',
  Γ: '\\Gamma',
  δ: '\\delta',
  Δ: '\\Delta',
  ϵ: '\\epsilon',
  ζ: '\\zeta',
  η: '\\eta',
  θ: '\\theta',
  Θ: '\\Theta',
  ι: '\\iota',
  κ: '\\kappa',
  λ: '\\lambda',
  μ: '\\mu',
  ν: '\\nu',
  ο: '\\omicron',
  π: '\\pi',
  Π: '\\Pi',
  ρ: '\\pho',
  σ: '\\sigma',
  Σ: '\\Sigma',
  τ: '\\tau',
  υ: '\\upsilon',
  Υ: '\\Upsilon',
  ϕ: '\\phi',
  Φ: '\\Phi',
  χ: '\\chi',
  ψ: '\\psi',
  Ψ: '\\Psi',
  ω: '\\omega',
  Ω: '\\Omega'
};

var allMathSymbolsByChar = {};

Object.defineProperty(allMathSymbolsByChar, "__esModule", {
  value: true
});
allMathSymbolsByChar.allMathSymbolsByChar = void 0;
allMathSymbolsByChar.allMathSymbolsByChar = {
  '&#xA0;': '\\textrm{ }',
  '&#x2203;': '\\exists',
  '&#x2200;': '\\forall',
  '&#x21D4;': '\\iff',
  '&#x21D2;': '=>',
  '&#xAC;': '\\neg',
  '&#x2124;': '\\mathbb{Z}',
  '&#x211D;': '\\mathbb{R}',
  '&#x211A;': '\\mathbb{Q}',
  '&#x2115;': '\\mathbb{N}',
  '&#x2102;': 'CC',
  '&#x25A1;': '\\square',
  '&#x22C4;': '\\diamond',
  '&#x25B3;': '\\triangle',
  '&#x2322;': '\\frown',
  '&#x2220;': '\\angle',
  '&#x22F1;': '\\ddots',
  '&#x22EE;': '\\vdots',
  '&#x2235;': '\\because',
  '&#x2234;': '\\therefore',
  '&#x2135;': '\\aleph',
  '&#x2205;': '\\oslash',
  '&#xB1;': '\\pm',
  '&#x2207;': '\\nabla',
  '&#x2202;': '\\partial',
  '&#x222E;': '\\oint',
  '&#x222B;': '\\int',
  '&#x22C3;': '\\cup',
  '&#x222A;': '\\cup',
  '&#x22C2;': '\\cap',
  '&#x2229;': '\\cap',
  '&#x22C1;': '\\vee',
  '&#x2228;': '\\vee',
  '&#x22C0;': '\\wedge',
  '&#x2227;': '\\wedge',
  '&#x220F;': '\\prod',
  '&#x2211;': '\\sum',
  '&#x2299;': '\\bigodot',
  '&#x2297;': '\\bigoplus',
  '&#x2295;': 'o+',
  '&#x2218;': '@',
  '&#x22C8;': '\\bowtie',
  '&#x22CA;': '\\rtimes',
  '&#x22C9;': '\\ltimes',
  '&#xF7;': '\\div',
  '&#xD7;': '\\times',
  '\\': '\\backslash',
  '&#x22C6;': '\\star',
  '&#x2217;': '\\star',
  '&#x22C5;': '\\cdot',
  '&#x3A9;': '\\Omega',
  '&#x3C9;': '\\omega',
  '&#x3A8;': '\\Psi',
  '&#x3C8;': '\\psi',
  '&#x3C7;': '\\chi',
  '&#x3C6;': '\\varphi',
  '&#x3A6;': '\\Phi',
  '&#x3D5;': '\\phi',
  '&#x3C5;': '\\upsilon',
  '&#x3C4;': '\\tau',
  '&#x3A3;': '\\Sigma',
  '&#x3C3;': '\\sigma',
  '&#x3C1;': '\\rho',
  '&#x3A0;': '\\Pi',
  '&#x3C0;': '\\pi',
  '&#x39E;': '\\Xi',
  '&#x3BE;': '\\xi',
  '&#x3BD;': '\\nu',
  '&#x3BC;': '\\mu',
  '&#x39B;': '\\Lambda',
  '&#x3BB;': '\\lambda',
  '&#x3BA;': '\\kappa',
  '&#x3B9;': '\\iota',
  '&#x3D1;': '\\vartheta',
  '&#x398;': '\\Theta',
  '&#x3B8;': '\\theta',
  '&#x3B7;': '\\eta',
  '&#x3B6;': '\\zeta',
  '&#x25B;': '\\varepsilon',
  '&#x3B5;': '\\epsilon',
  '&#x394;': '\\Delta',
  '&#x3B4;': '\\delta',
  '&#x393;': '\\Gamma',
  '&#x3B3;': '\\gamma',
  '&#x3B2;': '\\beta',
  '&#x3B1;': '\\alpha',
  '&#x221E;': '\\infty'
};

var allMathSymbolsByGlyph = {};

Object.defineProperty(allMathSymbolsByGlyph, "__esModule", {
  value: true
});
allMathSymbolsByGlyph.allMathSymbolsByGlyph = void 0;
allMathSymbolsByGlyph.allMathSymbolsByGlyph = {
  ' ': '\\textrm{ }',
  '∃': '\\exists',
  '∀': '\\forall',
  '⇔': '\\iff',
  '⇒': '=>',
  '¬': '\\neg',
  '□': '\\square',
  '⋄': '\\diamond',
  '△': '\\triangle',
  '⌢': '\\frown',
  '∠': '\\angle',
  '⋱': '\\ddots',
  '⋮': '\\vdots',
  '∵': '\\because',
  '∴': '\\therefore',
  ℵ: '\\aleph',
  '∅': '\\oslash',
  '±': '\\pm',
  '∇': '\\nabla',
  '∂': '\\partial',
  '∮': '\\oint',
  '∫': '\\int',
  '⋃': '\\cup',
  '∪': '\\cup',
  '⋂': '\\cap',
  '∩': '\\cap',
  '⋁': '\\vee',
  '∨': '\\vee',
  '⋀': '\\wedge',
  '∧': '\\wedge',
  '∏': '\\prod',
  '∑': '\\sum',
  '⊙': '\\bigodot',
  '⊗': '\\bigoplus',
  '⊕': 'o+',
  '∘': '@',
  '⋈': '\\bowtie',
  '⋊': '\\rtimes',
  '⋉': '\\ltimes',
  '÷': '\\div',
  '×': '\\times',
  '\\': '\\backslash',
  '⋆': '\\star',
  '∗': '\\star',
  '⋅': '\\cdot',
  Ω: '\\Omega',
  ω: '\\omega',
  Ψ: '\\Psi',
  ψ: '\\psi',
  χ: '\\chi',
  φ: '\\varphi',
  Φ: '\\Phi',
  ϕ: '\\phi',
  υ: '\\upsilon',
  τ: '\\tau',
  Σ: '\\Sigma',
  σ: '\\sigma',
  ρ: '\\rho',
  Π: '\\Pi',
  π: '\\pi',
  Ξ: '\\Xi',
  ξ: '\\xi',
  ν: '\\nu',
  μ: '\\mu',
  Λ: '\\Lambda',
  λ: '\\lambda',
  κ: '\\kappa',
  ι: '\\iota',
  ϑ: '\\vartheta',
  Θ: '\\Theta',
  θ: '\\theta',
  η: '\\eta',
  ζ: '\\zeta',
  ɛ: '\\varepsilon',
  ε: '\\epsilon',
  Δ: '\\Delta',
  δ: '\\delta',
  Γ: '\\Gamma',
  γ: '\\gamma',
  β: '\\beta',
  α: '\\alpha',
  '∞': '\\infty'
};

var latexAccents = {};

Object.defineProperty(latexAccents, "__esModule", {
  value: true
});
latexAccents.latexAccents = void 0;
latexAccents.latexAccents = ['\\hat', '\\bar', '\\underbrace', '\\overbrace'];

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, {
      enumerable: true,
      get: function () {
        return m[k];
      }
    });
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  __exportStar(allMathOperatorsByChar, exports);
  __exportStar(allMathOperatorsByGlyph, exports);
  __exportStar(allMathSymbolsByChar, exports);
  __exportStar(allMathSymbolsByGlyph, exports);
  __exportStar(latexAccents, exports);
})(syntax);
getDefaultExportFromCjs(syntax);

Object.defineProperty(mi, "__esModule", {
  value: true
});
mi.MI = void 0;
var helpers_1$e = helpers;
var syntax_1$1 = syntax;
var MI = (function () {
  function MI(mathElement) {
    this._mathmlElement = mathElement;
  }
  MI.prototype.convert = function () {
    var normalizedValue = helpers_1$e.normalizeWhiteSpaces(this._mathmlElement.value);
    if (normalizedValue === ' ') return Character.apply(normalizedValue);
    var trimmedValue = normalizedValue.trim();
    return Character.apply(trimmedValue);
  };
  return MI;
})();
mi.MI = MI;
var Character = (function () {
  function Character(value) {
    this._value = value;
  }
  Character.apply = function (value) {
    return new Character(value)._apply();
  };
  Character.prototype._apply = function () {
    return this._findByCharacter() || this._findByGlyph() || this._value;
  };
  Character.prototype._findByCharacter = function () {
    return syntax_1$1.allMathSymbolsByChar[this._value];
  };
  Character.prototype._findByGlyph = function () {
    return syntax_1$1.allMathSymbolsByGlyph[this._value];
  };
  return Character;
})();

var mo = {};

Object.defineProperty(mo, "__esModule", {
  value: true
});
mo.MO = void 0;
var helpers_1$d = helpers;
var syntax_1 = syntax;
var MO = (function () {
  function MO(mathElement) {
    this._mathmlElement = mathElement;
  }
  MO.prototype.convert = function () {
    var normalizedValue = helpers_1$d.normalizeWhiteSpaces(this._mathmlElement.value);
    var trimmedValue = normalizedValue.trim();
    return Operator.operate(trimmedValue);
  };
  return MO;
})();
mo.MO = MO;
var Operator = (function () {
  function Operator(value) {
    this._value = value;
  }
  Operator.operate = function (value) {
    return new Operator(value)._operate();
  };
  Operator.prototype._operate = function () {
    return this._findByCharacter() || this._findByGlyph() || this._value;
  };
  Operator.prototype._findByCharacter = function () {
    return syntax_1.allMathOperatorsByChar[this._value];
  };
  Operator.prototype._findByGlyph = function () {
    return syntax_1.allMathOperatorsByGlyph[this._value];
  };
  return Operator;
})();

var mn = {};

Object.defineProperty(mn, "__esModule", {
  value: true
});
mn.MN = void 0;
var helpers_1$c = helpers;
var MN = (function () {
  function MN(mathElement) {
    this._mathmlElement = mathElement;
  }
  MN.prototype.convert = function () {
    var normalizedValue = helpers_1$c.normalizeWhiteSpaces(this._mathmlElement.value);
    return normalizedValue.trim();
  };
  return MN;
})();
mn.MN = MN;

var msqrt = {};

Object.defineProperty(msqrt, "__esModule", {
  value: true
});
msqrt.MSqrt = void 0;
var helpers_1$b = helpers;
var MSqrt = (function () {
  function MSqrt(mathElement) {
    this._mathmlElement = mathElement;
  }
  MSqrt.prototype.convert = function () {
    var latexJoinedChildren = this._mathmlElement.children.map(function (child) {
      return helpers_1$b.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' ');
    return "\\sqrt{" + latexJoinedChildren + "}";
  };
  return MSqrt;
})();
msqrt.MSqrt = MSqrt;

var mfenced = {};

Object.defineProperty(mfenced, "__esModule", {
  value: true
});
mfenced.MFenced = void 0;
var mathml_element_to_latex_converter_1$4 = mathmlElementToLatexConverter;
var helpers_1$a = helpers;
var MFenced = (function () {
  function MFenced(mathmlElement) {
    this._mathmlElement = mathmlElement;
    this._open = this._mathmlElement.attributes.open || '';
    this._close = this._mathmlElement.attributes.close || '';
    this._separators = Array.from(this._mathmlElement.attributes.separators || '');
  }
  MFenced.prototype.convert = function () {
    var latexChildren = this._mathmlElement.children.map(function (child) {
      return mathml_element_to_latex_converter_1$4.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    });
    if (this._isThereRelativeOfName(this._mathmlElement.children, 'mtable')) return new Matrix(this._open, this._close).apply(latexChildren);
    return new Vector(this._open, this._close, this._separators).apply(latexChildren);
  };
  MFenced.prototype._isThereRelativeOfName = function (mathmlElements, elementName) {
    var _this = this;
    return mathmlElements.some(function (child) {
      return child.name === elementName || _this._isThereRelativeOfName(child.children, elementName);
    });
  };
  return MFenced;
})();
mfenced.MFenced = MFenced;
var Vector = (function () {
  function Vector(open, close, separators) {
    this._open = open || '(';
    this._close = close || ')';
    this._separators = separators;
  }
  Vector.prototype.apply = function (latexContents) {
    var contentWithoutWrapper = helpers_1$a.JoinWithManySeparators.join(latexContents, this._separators);
    return new helpers_1$a.GenericWrapper(this._open, this._close).wrap(contentWithoutWrapper);
  };
  return Vector;
})();
var Matrix = (function () {
  function Matrix(open, close) {
    this._genericCommand = 'matrix';
    this._separators = new Separators(open, close);
  }
  Matrix.prototype.apply = function (latexContents) {
    var command = this._command;
    var matrix = "\\begin{" + command + "}\n" + latexContents.join('') + "\n\\end{" + command + "}";
    return command === this._genericCommand ? this._separators.wrap(matrix) : matrix;
  };
  Object.defineProperty(Matrix.prototype, "_command", {
    get: function () {
      if (this._separators.areParentheses()) return 'pmatrix';
      if (this._separators.areSquareBrackets()) return 'bmatrix';
      if (this._separators.areBrackets()) return 'Bmatrix';
      if (this._separators.areDivides()) return 'vmatrix';
      if (this._separators.areParallels()) return 'Vmatrix';
      if (this._separators.areNotEqual()) return this._genericCommand;
      return 'bmatrix';
    },
    enumerable: false,
    configurable: true
  });
  return Matrix;
})();
var Separators = (function () {
  function Separators(open, close) {
    this._open = open;
    this._close = close;
  }
  Separators.prototype.wrap = function (str) {
    return new helpers_1$a.GenericWrapper(this._open, this._close).wrap(str);
  };
  Separators.prototype.areParentheses = function () {
    return this._compare('(', ')');
  };
  Separators.prototype.areSquareBrackets = function () {
    return this._compare('[', ']');
  };
  Separators.prototype.areBrackets = function () {
    return this._compare('{', '}');
  };
  Separators.prototype.areDivides = function () {
    return this._compare('|', '|');
  };
  Separators.prototype.areParallels = function () {
    return this._compare('||', '||');
  };
  Separators.prototype.areNotEqual = function () {
    return this._open !== this._close;
  };
  Separators.prototype._compare = function (openToCompare, closeToCompare) {
    return this._open === openToCompare && this._close === closeToCompare;
  };
  return Separators;
})();

var mfrac = {};

var errors = {};

var invalidNumberOfChildren = {};

var __extends = commonjsGlobal && commonjsGlobal.__extends || (function () {
  var extendStatics = function (d, b) {
    extendStatics = Object.setPrototypeOf || ({
      __proto__: []
    }) instanceof Array && (function (d, b) {
      d.__proto__ = b;
    }) || (function (d, b) {
      for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
    });
    return extendStatics(d, b);
  };
  return function (d, b) {
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
})();
Object.defineProperty(invalidNumberOfChildren, "__esModule", {
  value: true
});
invalidNumberOfChildren.InvalidNumberOfChildrenError = void 0;
var InvalidNumberOfChildrenError = (function (_super) {
  __extends(InvalidNumberOfChildrenError, _super);
  function InvalidNumberOfChildrenError(tagName, expectedNumberOfChild, currentNumberOfChild, comparison) {
    if (comparison === void 0) {
      comparison = 'exactly';
    }
    var _this = _super.call(this, tagName + " tag must have " + comparison + " " + expectedNumberOfChild + " children. It's actually " + currentNumberOfChild) || this;
    _this.name = 'InvalidNumberOfChildrenError';
    return _this;
  }
  return InvalidNumberOfChildrenError;
})(Error);
invalidNumberOfChildren.InvalidNumberOfChildrenError = InvalidNumberOfChildrenError;

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.InvalidNumberOfChildrenError = void 0;
  var invalid_number_of_children_1 = invalidNumberOfChildren;
  Object.defineProperty(exports, "InvalidNumberOfChildrenError", {
    enumerable: true,
    get: function () {
      return invalid_number_of_children_1.InvalidNumberOfChildrenError;
    }
  });
})(errors);
getDefaultExportFromCjs(errors);

Object.defineProperty(mfrac, "__esModule", {
  value: true
});
mfrac.MFrac = void 0;
var errors_1$7 = errors;
var helpers_1$9 = helpers;
var MFrac = (function () {
  function MFrac(mathElement) {
    this._mathmlElement = mathElement;
  }
  MFrac.prototype.convert = function () {
    var _a = this._mathmlElement, children = _a.children, name = _a.name;
    var childrenLength = children.length;
    if (childrenLength !== 2) throw new errors_1$7.InvalidNumberOfChildrenError(name, 2, childrenLength);
    var num = helpers_1$9.mathMLElementToLaTeXConverter(children[0]).convert();
    var den = helpers_1$9.mathMLElementToLaTeXConverter(children[1]).convert();
    if (this._isBevelled()) return this._wrapIfMoreThanOneChar(num) + "/" + this._wrapIfMoreThanOneChar(den);
    return "\\frac{" + num + "}{" + den + "}";
  };
  MFrac.prototype._wrapIfMoreThanOneChar = function (str) {
    return new helpers_1$9.ParenthesisWrapper().wrapIfMoreThanOneChar(str);
  };
  MFrac.prototype._isBevelled = function () {
    return !!this._mathmlElement.attributes.bevelled;
  };
  return MFrac;
})();
mfrac.MFrac = MFrac;

var mroot = {};

Object.defineProperty(mroot, "__esModule", {
  value: true
});
mroot.MRoot = void 0;
var helpers_1$8 = helpers;
var errors_1$6 = errors;
var MRoot = (function () {
  function MRoot(mathElement) {
    this._mathmlElement = mathElement;
  }
  MRoot.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 2) throw new errors_1$6.InvalidNumberOfChildrenError(name, 2, childrenLength);
    var content = helpers_1$8.mathMLElementToLaTeXConverter(children[0]).convert();
    var rootIndex = helpers_1$8.mathMLElementToLaTeXConverter(children[1]).convert();
    return "\\sqrt[" + rootIndex + "]{" + content + "}";
  };
  return MRoot;
})();
mroot.MRoot = MRoot;

var maction = {};

Object.defineProperty(maction, "__esModule", {
  value: true
});
maction.MAction = void 0;
var mathml_element_to_latex_converter_1$3 = mathmlElementToLatexConverter;
var MAction = (function () {
  function MAction(mathElement) {
    this._mathmlElement = mathElement;
  }
  MAction.prototype.convert = function () {
    var children = this._mathmlElement.children;
    if (this._isToggle()) return children.map(function (child) {
      return mathml_element_to_latex_converter_1$3.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' \\Longrightarrow ');
    return mathml_element_to_latex_converter_1$3.mathMLElementToLaTeXConverter(children[0]).convert();
  };
  MAction.prototype._isToggle = function () {
    var actiontype = this._mathmlElement.attributes.actiontype;
    return actiontype === 'toggle' || !actiontype;
  };
  return MAction;
})();
maction.MAction = MAction;

var menclose = {};

Object.defineProperty(menclose, "__esModule", {
  value: true
});
menclose.MEnclose = void 0;
var mathml_element_to_latex_converter_1$2 = mathmlElementToLatexConverter;
var MEnclose = (function () {
  function MEnclose(mathElement) {
    this._mathmlElement = mathElement;
  }
  MEnclose.prototype.convert = function () {
    var latexJoinedChildren = this._mathmlElement.children.map(function (child) {
      return mathml_element_to_latex_converter_1$2.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' ');
    if (this._notation === 'actuarial') return "\\overline{\\left." + latexJoinedChildren + "\\right|}";
    if (this._notation === 'radical') return "\\sqrt{" + latexJoinedChildren + "}";
    if (['box', 'roundedbox', 'circle'].includes(this._notation)) return "\\boxed{" + latexJoinedChildren + "}";
    if (this._notation === 'left') return "\\left|" + latexJoinedChildren;
    if (this._notation === 'right') return latexJoinedChildren + "\\right|";
    if (this._notation === 'top') return "\\overline{" + latexJoinedChildren + "}";
    if (this._notation === 'bottom') return "\\underline{" + latexJoinedChildren + "}";
    if (this._notation === 'updiagonalstrike') return "\\cancel{" + latexJoinedChildren + "}";
    if (this._notation === 'downdiagonalstrike') return "\\bcancel{" + latexJoinedChildren + "}";
    if (this._notation === 'updiagonalarrow') return "\\cancelto{}{" + latexJoinedChildren + "}";
    if (['verticalstrike', 'horizontalstrike'].includes(this._notation)) return "\\hcancel{" + latexJoinedChildren + "}";
    if (this._notation === 'madruwb') return "\\underline{" + latexJoinedChildren + "\\right|}";
    if (this._notation === 'phasorangle') return "{\\angle \\underline{" + latexJoinedChildren + "}}";
    return "\\overline{\\left.\\right)" + latexJoinedChildren + "}";
  };
  Object.defineProperty(MEnclose.prototype, "_notation", {
    get: function () {
      return this._mathmlElement.attributes.notation || 'longdiv';
    },
    enumerable: false,
    configurable: true
  });
  return MEnclose;
})();
menclose.MEnclose = MEnclose;

var merror = {};

Object.defineProperty(merror, "__esModule", {
  value: true
});
merror.MError = void 0;
var mathml_element_to_latex_converter_1$1 = mathmlElementToLatexConverter;
var MError = (function () {
  function MError(mathElement) {
    this._mathmlElement = mathElement;
  }
  MError.prototype.convert = function () {
    var latexJoinedChildren = this._mathmlElement.children.map(function (child) {
      return mathml_element_to_latex_converter_1$1.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' ');
    return "\\color{red}{" + latexJoinedChildren + "}";
  };
  return MError;
})();
merror.MError = MError;

var mphantom = {};

Object.defineProperty(mphantom, "__esModule", {
  value: true
});
mphantom.MPhantom = void 0;
var MPhantom = (function () {
  function MPhantom(mathElement) {
    this._mathmlElement = mathElement;
  }
  MPhantom.prototype.convert = function () {
    return '';
  };
  return MPhantom;
})();
mphantom.MPhantom = MPhantom;

var msup = {};

Object.defineProperty(msup, "__esModule", {
  value: true
});
msup.MSup = void 0;
var helpers_1$7 = helpers;
var errors_1$5 = errors;
var MSup = (function () {
  function MSup(mathElement) {
    this._mathmlElement = mathElement;
  }
  MSup.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 2) throw new errors_1$5.InvalidNumberOfChildrenError(name, 2, childrenLength);
    var base = helpers_1$7.mathMLElementToLaTeXConverter(children[0]).convert();
    var exponent = helpers_1$7.mathMLElementToLaTeXConverter(children[1]).convert();
    return new helpers_1$7.ParenthesisWrapper().wrapIfMoreThanOneChar(base) + "^" + new helpers_1$7.BracketWrapper().wrap(exponent);
  };
  return MSup;
})();
msup.MSup = MSup;

var msub = {};

Object.defineProperty(msub, "__esModule", {
  value: true
});
msub.MSub = void 0;
var helpers_1$6 = helpers;
var errors_1$4 = errors;
var MSub = (function () {
  function MSub(mathElement) {
    this._mathmlElement = mathElement;
  }
  MSub.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 2) throw new errors_1$4.InvalidNumberOfChildrenError(name, 2, childrenLength);
    var base = helpers_1$6.mathMLElementToLaTeXConverter(children[0]).convert();
    var subscript = helpers_1$6.mathMLElementToLaTeXConverter(children[1]).convert();
    return new helpers_1$6.ParenthesisWrapper().wrapIfMoreThanOneChar(base) + "_" + new helpers_1$6.BracketWrapper().wrap(subscript);
  };
  return MSub;
})();
msub.MSub = MSub;

var msubsup = {};

Object.defineProperty(msubsup, "__esModule", {
  value: true
});
msubsup.MSubsup = void 0;
var helpers_1$5 = helpers;
var errors_1$3 = errors;
var MSubsup = (function () {
  function MSubsup(mathElement) {
    this._mathmlElement = mathElement;
  }
  MSubsup.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 3) throw new errors_1$3.InvalidNumberOfChildrenError(name, 3, childrenLength);
    var base = helpers_1$5.mathMLElementToLaTeXConverter(children[0]).convert();
    var sub = helpers_1$5.mathMLElementToLaTeXConverter(children[1]).convert();
    var sup = helpers_1$5.mathMLElementToLaTeXConverter(children[2]).convert();
    var wrappedSub = new helpers_1$5.BracketWrapper().wrap(sub);
    var wrappedSup = new helpers_1$5.BracketWrapper().wrap(sup);
    return this._wrapInParenthesisIfThereIsSpace(base) + "_" + wrappedSub + "^" + wrappedSup;
  };
  MSubsup.prototype._wrapInParenthesisIfThereIsSpace = function (str) {
    if (!str.match(/\s+/g)) return str;
    return new helpers_1$5.ParenthesisWrapper().wrap(str);
  };
  return MSubsup;
})();
msubsup.MSubsup = MSubsup;

var mmultiscripts = {};

Object.defineProperty(mmultiscripts, "__esModule", {
  value: true
});
mmultiscripts.MMultiscripts = void 0;
var helpers_1$4 = helpers;
var errors_1$2 = errors;
var MMultiscripts = (function () {
  function MMultiscripts(mathElement) {
    this._mathmlElement = mathElement;
  }
  MMultiscripts.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength < 3) throw new errors_1$2.InvalidNumberOfChildrenError(name, 3, childrenLength, 'at least');
    var baseContent = helpers_1$4.mathMLElementToLaTeXConverter(children[0]).convert();
    return this._prescriptLatex() + this._wrapInParenthesisIfThereIsSpace(baseContent) + this._postscriptLatex();
  };
  MMultiscripts.prototype._prescriptLatex = function () {
    var children = this._mathmlElement.children;
    var sub;
    var sup;
    if (this._isPrescripts(children[1])) {
      sub = children[2];
      sup = children[3];
    } else if (this._isPrescripts(children[3])) {
      sub = children[4];
      sup = children[5];
    } else return '';
    var subLatex = helpers_1$4.mathMLElementToLaTeXConverter(sub).convert();
    var supLatex = helpers_1$4.mathMLElementToLaTeXConverter(sup).convert();
    return "\\_{" + subLatex + "}^{" + supLatex + "}";
  };
  MMultiscripts.prototype._postscriptLatex = function () {
    var children = this._mathmlElement.children;
    if (this._isPrescripts(children[1])) return '';
    var sub = children[1];
    var sup = children[2];
    var subLatex = helpers_1$4.mathMLElementToLaTeXConverter(sub).convert();
    var supLatex = helpers_1$4.mathMLElementToLaTeXConverter(sup).convert();
    return "_{" + subLatex + "}^{" + supLatex + "}";
  };
  MMultiscripts.prototype._wrapInParenthesisIfThereIsSpace = function (str) {
    if (!str.match(/\s+/g)) return str;
    return new helpers_1$4.ParenthesisWrapper().wrap(str);
  };
  MMultiscripts.prototype._isPrescripts = function (child) {
    return (child === null || child === void 0 ? void 0 : child.name) === 'mprescripts';
  };
  return MMultiscripts;
})();
mmultiscripts.MMultiscripts = MMultiscripts;

var mtext = {};

Object.defineProperty(mtext, "__esModule", {
  value: true
});
mtext.MText = void 0;
var MText = (function () {
  function MText(mathElement) {
    this._mathmlElement = mathElement;
  }
  MText.prototype.convert = function () {
    var _a = this._mathmlElement, attributes = _a.attributes, value = _a.value;
    return new TextCommand(attributes.mathvariant).apply(value);
  };
  return MText;
})();
mtext.MText = MText;
var TextCommand = (function () {
  function TextCommand(mathvariant) {
    this._mathvariant = mathvariant || 'normal';
  }
  TextCommand.prototype.apply = function (value) {
    return this._commands.reduce(function (acc, command, index) {
      if (index === 0) return command + "{" + value + "}";
      return command + "{" + acc + "}";
    }, '');
  };
  Object.defineProperty(TextCommand.prototype, "_commands", {
    get: function () {
      switch (this._mathvariant) {
        case 'bold':
          return ['\\textbf'];
        case 'italic':
          return ['\\textit'];
        case 'bold-italic':
          return ['\\textit', '\\textbf'];
        case 'double-struck':
          return ['\\mathbb'];
        case 'monospace':
          return ['\\mathtt'];
        case 'bold-fraktur':
        case 'fraktur':
          return ['\\mathfrak'];
        default:
          return ['\\text'];
      }
    },
    enumerable: false,
    configurable: true
  });
  return TextCommand;
})();

var munderover = {};

Object.defineProperty(munderover, "__esModule", {
  value: true
});
munderover.MUnderover = void 0;
var helpers_1$3 = helpers;
var errors_1$1 = errors;
var MUnderover = (function () {
  function MUnderover(mathElement) {
    this._mathmlElement = mathElement;
  }
  MUnderover.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 3) throw new errors_1$1.InvalidNumberOfChildrenError(name, 3, childrenLength);
    var base = helpers_1$3.mathMLElementToLaTeXConverter(children[0]).convert();
    var underContent = helpers_1$3.mathMLElementToLaTeXConverter(children[1]).convert();
    var overContent = helpers_1$3.mathMLElementToLaTeXConverter(children[2]).convert();
    return base + "_{" + underContent + "}^{" + overContent + "}";
  };
  return MUnderover;
})();
munderover.MUnderover = MUnderover;

var mtable = {};

Object.defineProperty(mtable, "__esModule", {
  value: true
});
mtable.MTable = void 0;
var helpers_1$2 = helpers;
var MTable = (function () {
  function MTable(mathElement) {
    this._mathmlElement = mathElement;
    this._addFlagRecursiveIfName(this._mathmlElement.children, 'mtable', 'innerTable');
  }
  MTable.prototype.convert = function () {
    var tableContent = this._mathmlElement.children.map(function (child) {
      return helpers_1$2.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' \\\\\n');
    return this._hasFlag('innerTable') ? this._wrap(tableContent) : tableContent;
  };
  MTable.prototype._wrap = function (latex) {
    return "\\begin{matrix}" + latex + "\\end{matrix}";
  };
  MTable.prototype._addFlagRecursiveIfName = function (mathmlElements, name, flag) {
    var _this = this;
    mathmlElements.forEach(function (mathmlElement) {
      if (mathmlElement.name === name) mathmlElement.attributes[flag] = flag;
      _this._addFlagRecursiveIfName(mathmlElement.children, name, flag);
    });
  };
  MTable.prototype._hasFlag = function (flag) {
    return !!this._mathmlElement.attributes[flag];
  };
  return MTable;
})();
mtable.MTable = MTable;

var mtr = {};

Object.defineProperty(mtr, "__esModule", {
  value: true
});
mtr.MTr = void 0;
var helpers_1$1 = helpers;
var MTr = (function () {
  function MTr(mathElement) {
    this._mathmlElement = mathElement;
  }
  MTr.prototype.convert = function () {
    return this._mathmlElement.children.map(function (child) {
      return helpers_1$1.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' & ');
  };
  return MTr;
})();
mtr.MTr = MTr;

var genericSpacingWrapper = {};

Object.defineProperty(genericSpacingWrapper, "__esModule", {
  value: true
});
genericSpacingWrapper.GenericSpacingWrapper = void 0;
var helpers_1 = helpers;
var GenericSpacingWrapper = (function () {
  function GenericSpacingWrapper(mathElement) {
    this._mathmlElement = mathElement;
  }
  GenericSpacingWrapper.prototype.convert = function () {
    return this._mathmlElement.children.map(function (child) {
      return helpers_1.mathMLElementToLaTeXConverter(child);
    }).map(function (converter) {
      return converter.convert();
    }).join(' ');
  };
  return GenericSpacingWrapper;
})();
genericSpacingWrapper.GenericSpacingWrapper = GenericSpacingWrapper;

var genericUnderOver = {};

Object.defineProperty(genericUnderOver, "__esModule", {
  value: true
});
genericUnderOver.GenericUnderOver = void 0;
var mathml_element_to_latex_converter_1 = mathmlElementToLatexConverter;
var errors_1 = errors;
var latex_accents_1 = latexAccents;
var GenericUnderOver = (function () {
  function GenericUnderOver(mathElement) {
    this._mathmlElement = mathElement;
  }
  GenericUnderOver.prototype.convert = function () {
    var _a = this._mathmlElement, name = _a.name, children = _a.children;
    var childrenLength = children.length;
    if (childrenLength !== 2) throw new errors_1.InvalidNumberOfChildrenError(name, 2, childrenLength);
    var content = mathml_element_to_latex_converter_1.mathMLElementToLaTeXConverter(children[0]).convert();
    var accent = mathml_element_to_latex_converter_1.mathMLElementToLaTeXConverter(children[1]).convert();
    return this._applyCommand(content, accent);
  };
  GenericUnderOver.prototype._applyCommand = function (content, accent) {
    var type = this._mathmlElement.name.match(/under/) ? TagTypes.Under : TagTypes.Over;
    return new UnderOverSetter(type).apply(content, accent);
  };
  return GenericUnderOver;
})();
genericUnderOver.GenericUnderOver = GenericUnderOver;
var UnderOverSetter = (function () {
  function UnderOverSetter(type) {
    this._type = type;
  }
  UnderOverSetter.prototype.apply = function (content, accent) {
    return latex_accents_1.latexAccents.includes(accent) ? accent + "{" + content + "}" : this._defaultCommand + "{" + accent + "}{" + content + "}";
  };
  Object.defineProperty(UnderOverSetter.prototype, "_defaultCommand", {
    get: function () {
      if (this._type === TagTypes.Under) return '\\underset';
      return '\\overset';
    },
    enumerable: false,
    configurable: true
  });
  return UnderOverSetter;
})();
var TagTypes;
(function (TagTypes) {
  TagTypes[TagTypes["Under"] = 0] = "Under";
  TagTypes[TagTypes["Over"] = 1] = "Over";
})(TagTypes || (TagTypes = {}));

(function (exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.GenericUnderOver = exports.GenericSpacingWrapper = exports.MTr = exports.MTable = exports.MUnderover = exports.MText = exports.MMultiscripts = exports.MSubsup = exports.MSub = exports.MSup = exports.MPhantom = exports.MError = exports.MEnclose = exports.MAction = exports.MRoot = exports.MFrac = exports.MFenced = exports.MSqrt = exports.MN = exports.MO = exports.MI = exports.Math = void 0;
  var math_1 = math;
  Object.defineProperty(exports, "Math", {
    enumerable: true,
    get: function () {
      return math_1.Math;
    }
  });
  var mi_1 = mi;
  Object.defineProperty(exports, "MI", {
    enumerable: true,
    get: function () {
      return mi_1.MI;
    }
  });
  var mo_1 = mo;
  Object.defineProperty(exports, "MO", {
    enumerable: true,
    get: function () {
      return mo_1.MO;
    }
  });
  var mn_1 = mn;
  Object.defineProperty(exports, "MN", {
    enumerable: true,
    get: function () {
      return mn_1.MN;
    }
  });
  var msqrt_1 = msqrt;
  Object.defineProperty(exports, "MSqrt", {
    enumerable: true,
    get: function () {
      return msqrt_1.MSqrt;
    }
  });
  var mfenced_1 = mfenced;
  Object.defineProperty(exports, "MFenced", {
    enumerable: true,
    get: function () {
      return mfenced_1.MFenced;
    }
  });
  var mfrac_1 = mfrac;
  Object.defineProperty(exports, "MFrac", {
    enumerable: true,
    get: function () {
      return mfrac_1.MFrac;
    }
  });
  var mroot_1 = mroot;
  Object.defineProperty(exports, "MRoot", {
    enumerable: true,
    get: function () {
      return mroot_1.MRoot;
    }
  });
  var maction_1 = maction;
  Object.defineProperty(exports, "MAction", {
    enumerable: true,
    get: function () {
      return maction_1.MAction;
    }
  });
  var menclose_1 = menclose;
  Object.defineProperty(exports, "MEnclose", {
    enumerable: true,
    get: function () {
      return menclose_1.MEnclose;
    }
  });
  var merror_1 = merror;
  Object.defineProperty(exports, "MError", {
    enumerable: true,
    get: function () {
      return merror_1.MError;
    }
  });
  var mphantom_1 = mphantom;
  Object.defineProperty(exports, "MPhantom", {
    enumerable: true,
    get: function () {
      return mphantom_1.MPhantom;
    }
  });
  var msup_1 = msup;
  Object.defineProperty(exports, "MSup", {
    enumerable: true,
    get: function () {
      return msup_1.MSup;
    }
  });
  var msub_1 = msub;
  Object.defineProperty(exports, "MSub", {
    enumerable: true,
    get: function () {
      return msub_1.MSub;
    }
  });
  var msubsup_1 = msubsup;
  Object.defineProperty(exports, "MSubsup", {
    enumerable: true,
    get: function () {
      return msubsup_1.MSubsup;
    }
  });
  var mmultiscripts_1 = mmultiscripts;
  Object.defineProperty(exports, "MMultiscripts", {
    enumerable: true,
    get: function () {
      return mmultiscripts_1.MMultiscripts;
    }
  });
  var mtext_1 = mtext;
  Object.defineProperty(exports, "MText", {
    enumerable: true,
    get: function () {
      return mtext_1.MText;
    }
  });
  var munderover_1 = munderover;
  Object.defineProperty(exports, "MUnderover", {
    enumerable: true,
    get: function () {
      return munderover_1.MUnderover;
    }
  });
  var mtable_1 = mtable;
  Object.defineProperty(exports, "MTable", {
    enumerable: true,
    get: function () {
      return mtable_1.MTable;
    }
  });
  var mtr_1 = mtr;
  Object.defineProperty(exports, "MTr", {
    enumerable: true,
    get: function () {
      return mtr_1.MTr;
    }
  });
  var generic_spacing_wrapper_1 = genericSpacingWrapper;
  Object.defineProperty(exports, "GenericSpacingWrapper", {
    enumerable: true,
    get: function () {
      return generic_spacing_wrapper_1.GenericSpacingWrapper;
    }
  });
  var generic_under_over_1 = genericUnderOver;
  Object.defineProperty(exports, "GenericUnderOver", {
    enumerable: true,
    get: function () {
      return generic_under_over_1.GenericUnderOver;
    }
  });
})(converters);
getDefaultExportFromCjs(converters);

var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function () {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});
var __setModuleDefault = commonjsGlobal && commonjsGlobal.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});
var __importStar = commonjsGlobal && commonjsGlobal.__importStar || (function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  __setModuleDefault(result, mod);
  return result;
});
Object.defineProperty(mathmlElementToLatexConverterAdapter, "__esModule", {
  value: true
});
mathmlElementToLatexConverterAdapter.MathMLElementToLatexConverterAdapter = void 0;
var ToLatexConverters = __importStar(converters);
var MathMLElementToLatexConverterAdapter = (function () {
  function MathMLElementToLatexConverterAdapter(mathMLElement) {
    this._mathMLElement = mathMLElement;
  }
  MathMLElementToLatexConverterAdapter.prototype.toLatexConverter = function () {
    var name = this._mathMLElement.name;
    var Converter = fromMathMLElementToLatexConverter[name] || ToLatexConverters.GenericSpacingWrapper;
    return new Converter(this._mathMLElement);
  };
  return MathMLElementToLatexConverterAdapter;
})();
mathmlElementToLatexConverterAdapter.MathMLElementToLatexConverterAdapter = MathMLElementToLatexConverterAdapter;
var fromMathMLElementToLatexConverter = {
  math: ToLatexConverters.Math,
  mi: ToLatexConverters.MI,
  mo: ToLatexConverters.MO,
  mn: ToLatexConverters.MN,
  msqrt: ToLatexConverters.MSqrt,
  mfenced: ToLatexConverters.MFenced,
  mfrac: ToLatexConverters.MFrac,
  mroot: ToLatexConverters.MRoot,
  maction: ToLatexConverters.MAction,
  menclose: ToLatexConverters.MEnclose,
  merror: ToLatexConverters.MError,
  mphantom: ToLatexConverters.MPhantom,
  msup: ToLatexConverters.MSup,
  msub: ToLatexConverters.MSub,
  msubsup: ToLatexConverters.MSubsup,
  mmultiscripts: ToLatexConverters.MMultiscripts,
  mtext: ToLatexConverters.MText,
  munderover: ToLatexConverters.MUnderover,
  mtable: ToLatexConverters.MTable,
  mtr: ToLatexConverters.MTr,
  mover: ToLatexConverters.GenericUnderOver,
  munder: ToLatexConverters.GenericUnderOver,
  mrow: ToLatexConverters.GenericSpacingWrapper,
  mpadded: ToLatexConverters.GenericSpacingWrapper
};

var factories = {};

var makeToMathElementsConverter$1 = {};

var xmldomToMathmlElements = {};

var xmldomToMathmlElementAdapter = {};

var domParser = {};

var entities = {};

entities.entityMap = {
  lt: '<',
  gt: '>',
  amp: '&',
  quot: '"',
  apos: "'",
  Agrave: "À",
  Aacute: "Á",
  Acirc: "Â",
  Atilde: "Ã",
  Auml: "Ä",
  Aring: "Å",
  AElig: "Æ",
  Ccedil: "Ç",
  Egrave: "È",
  Eacute: "É",
  Ecirc: "Ê",
  Euml: "Ë",
  Igrave: "Ì",
  Iacute: "Í",
  Icirc: "Î",
  Iuml: "Ï",
  ETH: "Ð",
  Ntilde: "Ñ",
  Ograve: "Ò",
  Oacute: "Ó",
  Ocirc: "Ô",
  Otilde: "Õ",
  Ouml: "Ö",
  Oslash: "Ø",
  Ugrave: "Ù",
  Uacute: "Ú",
  Ucirc: "Û",
  Uuml: "Ü",
  Yacute: "Ý",
  THORN: "Þ",
  szlig: "ß",
  agrave: "à",
  aacute: "á",
  acirc: "â",
  atilde: "ã",
  auml: "ä",
  aring: "å",
  aelig: "æ",
  ccedil: "ç",
  egrave: "è",
  eacute: "é",
  ecirc: "ê",
  euml: "ë",
  igrave: "ì",
  iacute: "í",
  icirc: "î",
  iuml: "ï",
  eth: "ð",
  ntilde: "ñ",
  ograve: "ò",
  oacute: "ó",
  ocirc: "ô",
  otilde: "õ",
  ouml: "ö",
  oslash: "ø",
  ugrave: "ù",
  uacute: "ú",
  ucirc: "û",
  uuml: "ü",
  yacute: "ý",
  thorn: "þ",
  yuml: "ÿ",
  nbsp: "\u00a0",
  iexcl: "¡",
  cent: "¢",
  pound: "£",
  curren: "¤",
  yen: "¥",
  brvbar: "¦",
  sect: "§",
  uml: "¨",
  copy: "©",
  ordf: "ª",
  laquo: "«",
  not: "¬",
  shy: "­­",
  reg: "®",
  macr: "¯",
  deg: "°",
  plusmn: "±",
  sup2: "²",
  sup3: "³",
  acute: "´",
  micro: "µ",
  para: "¶",
  middot: "·",
  cedil: "¸",
  sup1: "¹",
  ordm: "º",
  raquo: "»",
  frac14: "¼",
  frac12: "½",
  frac34: "¾",
  iquest: "¿",
  times: "×",
  divide: "÷",
  forall: "∀",
  part: "∂",
  exist: "∃",
  empty: "∅",
  nabla: "∇",
  isin: "∈",
  notin: "∉",
  ni: "∋",
  prod: "∏",
  sum: "∑",
  minus: "−",
  lowast: "∗",
  radic: "√",
  prop: "∝",
  infin: "∞",
  ang: "∠",
  and: "∧",
  or: "∨",
  cap: "∩",
  cup: "∪",
  'int': "∫",
  there4: "∴",
  sim: "∼",
  cong: "≅",
  asymp: "≈",
  ne: "≠",
  equiv: "≡",
  le: "≤",
  ge: "≥",
  sub: "⊂",
  sup: "⊃",
  nsub: "⊄",
  sube: "⊆",
  supe: "⊇",
  oplus: "⊕",
  otimes: "⊗",
  perp: "⊥",
  sdot: "⋅",
  Alpha: "Α",
  Beta: "Β",
  Gamma: "Γ",
  Delta: "Δ",
  Epsilon: "Ε",
  Zeta: "Ζ",
  Eta: "Η",
  Theta: "Θ",
  Iota: "Ι",
  Kappa: "Κ",
  Lambda: "Λ",
  Mu: "Μ",
  Nu: "Ν",
  Xi: "Ξ",
  Omicron: "Ο",
  Pi: "Π",
  Rho: "Ρ",
  Sigma: "Σ",
  Tau: "Τ",
  Upsilon: "Υ",
  Phi: "Φ",
  Chi: "Χ",
  Psi: "Ψ",
  Omega: "Ω",
  alpha: "α",
  beta: "β",
  gamma: "γ",
  delta: "δ",
  epsilon: "ε",
  zeta: "ζ",
  eta: "η",
  theta: "θ",
  iota: "ι",
  kappa: "κ",
  lambda: "λ",
  mu: "μ",
  nu: "ν",
  xi: "ξ",
  omicron: "ο",
  pi: "π",
  rho: "ρ",
  sigmaf: "ς",
  sigma: "σ",
  tau: "τ",
  upsilon: "υ",
  phi: "φ",
  chi: "χ",
  psi: "ψ",
  omega: "ω",
  thetasym: "ϑ",
  upsih: "ϒ",
  piv: "ϖ",
  OElig: "Œ",
  oelig: "œ",
  Scaron: "Š",
  scaron: "š",
  Yuml: "Ÿ",
  fnof: "ƒ",
  circ: "ˆ",
  tilde: "˜",
  ensp: " ",
  emsp: " ",
  thinsp: " ",
  zwnj: "‌",
  zwj: "‍",
  lrm: "‎",
  rlm: "‏",
  ndash: "–",
  mdash: "—",
  lsquo: "‘",
  rsquo: "’",
  sbquo: "‚",
  ldquo: "“",
  rdquo: "”",
  bdquo: "„",
  dagger: "†",
  Dagger: "‡",
  bull: "•",
  hellip: "…",
  permil: "‰",
  prime: "′",
  Prime: "″",
  lsaquo: "‹",
  rsaquo: "›",
  oline: "‾",
  euro: "€",
  trade: "™",
  larr: "←",
  uarr: "↑",
  rarr: "→",
  darr: "↓",
  harr: "↔",
  crarr: "↵",
  lceil: "⌈",
  rceil: "⌉",
  lfloor: "⌊",
  rfloor: "⌋",
  loz: "◊",
  spades: "♠",
  clubs: "♣",
  hearts: "♥",
  diams: "♦"
};

var sax = {};

var nameStartChar = /[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
var nameChar = new RegExp("[\\-\\.0-9" + nameStartChar.source.slice(1, -1) + "\\u00B7\\u0300-\\u036F\\u203F-\\u2040]");
var tagNamePattern = new RegExp('^' + nameStartChar.source + nameChar.source + '*(?:\:' + nameStartChar.source + nameChar.source + '*)?$');
var S_TAG = 0;
var S_ATTR = 1;
var S_ATTR_SPACE = 2;
var S_EQ = 3;
var S_ATTR_NOQUOT_VALUE = 4;
var S_ATTR_END = 5;
var S_TAG_SPACE = 6;
var S_TAG_CLOSE = 7;
function XMLReader$1() {}
XMLReader$1.prototype = {
  parse: function (source, defaultNSMap, entityMap) {
    var domBuilder = this.domBuilder;
    domBuilder.startDocument();
    _copy(defaultNSMap, defaultNSMap = {});
    parse(source, defaultNSMap, entityMap, domBuilder, this.errorHandler);
    domBuilder.endDocument();
  }
};
function parse(source, defaultNSMapCopy, entityMap, domBuilder, errorHandler) {
  function fixedFromCharCode(code) {
    if (code > 0xffff) {
      code -= 0x10000;
      var surrogate1 = 0xd800 + (code >> 10), surrogate2 = 0xdc00 + (code & 0x3ff);
      return String.fromCharCode(surrogate1, surrogate2);
    } else {
      return String.fromCharCode(code);
    }
  }
  function entityReplacer(a) {
    var k = a.slice(1, -1);
    if ((k in entityMap)) {
      return entityMap[k];
    } else if (k.charAt(0) === '#') {
      return fixedFromCharCode(parseInt(k.substr(1).replace('x', '0x')));
    } else {
      errorHandler.error('entity not found:' + a);
      return a;
    }
  }
  function appendText(end) {
    if (end > start) {
      var xt = source.substring(start, end).replace(/&#?\w+;/g, entityReplacer);
      locator && position(start);
      domBuilder.characters(xt, 0, end - start);
      start = end;
    }
  }
  function position(p, m) {
    while (p >= lineEnd && (m = linePattern.exec(source))) {
      lineStart = m.index;
      lineEnd = lineStart + m[0].length;
      locator.lineNumber++;
    }
    locator.columnNumber = p - lineStart + 1;
  }
  var lineStart = 0;
  var lineEnd = 0;
  var linePattern = /.*(?:\r\n?|\n)|.*$/g;
  var locator = domBuilder.locator;
  var parseStack = [{
    currentNSMap: defaultNSMapCopy
  }];
  var closeMap = {};
  var start = 0;
  while (true) {
    try {
      var tagStart = source.indexOf('<', start);
      if (tagStart < 0) {
        if (!source.substr(start).match(/^\s*$/)) {
          var doc = domBuilder.doc;
          var text = doc.createTextNode(source.substr(start));
          doc.appendChild(text);
          domBuilder.currentElement = text;
        }
        return;
      }
      if (tagStart > start) {
        appendText(tagStart);
      }
      switch (source.charAt(tagStart + 1)) {
        case '/':
          var end = source.indexOf('>', tagStart + 3);
          var tagName = source.substring(tagStart + 2, end);
          var config = parseStack.pop();
          if (end < 0) {
            tagName = source.substring(tagStart + 2).replace(/[\s<].*/, '');
            errorHandler.error("end tag name: " + tagName + ' is not complete:' + config.tagName);
            end = tagStart + 1 + tagName.length;
          } else if (tagName.match(/\s</)) {
            tagName = tagName.replace(/[\s<].*/, '');
            errorHandler.error("end tag name: " + tagName + ' maybe not complete');
            end = tagStart + 1 + tagName.length;
          }
          var localNSMap = config.localNSMap;
          var endMatch = config.tagName == tagName;
          var endIgnoreCaseMach = endMatch || config.tagName && config.tagName.toLowerCase() == tagName.toLowerCase();
          if (endIgnoreCaseMach) {
            domBuilder.endElement(config.uri, config.localName, tagName);
            if (localNSMap) {
              for (var prefix in localNSMap) {
                domBuilder.endPrefixMapping(prefix);
              }
            }
            if (!endMatch) {
              errorHandler.fatalError("end tag name: " + tagName + ' is not match the current start tagName:' + config.tagName);
            }
          } else {
            parseStack.push(config);
          }
          end++;
          break;
        case '?':
          locator && position(tagStart);
          end = parseInstruction(source, tagStart, domBuilder);
          break;
        case '!':
          locator && position(tagStart);
          end = parseDCC(source, tagStart, domBuilder, errorHandler);
          break;
        default:
          locator && position(tagStart);
          var el = new ElementAttributes();
          var currentNSMap = parseStack[parseStack.length - 1].currentNSMap;
          var end = parseElementStartPart(source, tagStart, el, currentNSMap, entityReplacer, errorHandler);
          var len = el.length;
          if (!el.closed && fixSelfClosed(source, end, el.tagName, closeMap)) {
            el.closed = true;
            if (!entityMap.nbsp) {
              errorHandler.warning('unclosed xml attribute');
            }
          }
          if (locator && len) {
            var locator2 = copyLocator(locator, {});
            for (var i = 0; i < len; i++) {
              var a = el[i];
              position(a.offset);
              a.locator = copyLocator(locator, {});
            }
            domBuilder.locator = locator2;
            if (appendElement$1(el, domBuilder, currentNSMap)) {
              parseStack.push(el);
            }
            domBuilder.locator = locator;
          } else {
            if (appendElement$1(el, domBuilder, currentNSMap)) {
              parseStack.push(el);
            }
          }
          if (el.uri === 'http://www.w3.org/1999/xhtml' && !el.closed) {
            end = parseHtmlSpecialContent(source, end, el.tagName, entityReplacer, domBuilder);
          } else {
            end++;
          }
      }
    } catch (e) {
      errorHandler.error('element parse error: ' + e);
      end = -1;
    }
    if (end > start) {
      start = end;
    } else {
      appendText(Math.max(tagStart, start) + 1);
    }
  }
}
function copyLocator(f, t) {
  t.lineNumber = f.lineNumber;
  t.columnNumber = f.columnNumber;
  return t;
}
function parseElementStartPart(source, start, el, currentNSMap, entityReplacer, errorHandler) {
  var attrName;
  var value;
  var p = ++start;
  var s = S_TAG;
  while (true) {
    var c = source.charAt(p);
    switch (c) {
      case '=':
        if (s === S_ATTR) {
          attrName = source.slice(start, p);
          s = S_EQ;
        } else if (s === S_ATTR_SPACE) {
          s = S_EQ;
        } else {
          throw new Error('attribute equal must after attrName');
        }
        break;
      case '\'':
      case '"':
        if (s === S_EQ || s === S_ATTR) {
          if (s === S_ATTR) {
            errorHandler.warning('attribute value must after "="');
            attrName = source.slice(start, p);
          }
          start = p + 1;
          p = source.indexOf(c, start);
          if (p > 0) {
            value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
            el.add(attrName, value, start - 1);
            s = S_ATTR_END;
          } else {
            throw new Error('attribute value no end \'' + c + '\' match');
          }
        } else if (s == S_ATTR_NOQUOT_VALUE) {
          value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
          el.add(attrName, value, start);
          errorHandler.warning('attribute "' + attrName + '" missed start quot(' + c + ')!!');
          start = p + 1;
          s = S_ATTR_END;
        } else {
          throw new Error('attribute value must after "="');
        }
        break;
      case '/':
        switch (s) {
          case S_TAG:
            el.setTagName(source.slice(start, p));
          case S_ATTR_END:
          case S_TAG_SPACE:
          case S_TAG_CLOSE:
            s = S_TAG_CLOSE;
            el.closed = true;
          case S_ATTR_NOQUOT_VALUE:
          case S_ATTR:
          case S_ATTR_SPACE:
            break;
          default:
            throw new Error("attribute invalid close char('/')");
        }
        break;
      case '':
        errorHandler.error('unexpected end of input');
        if (s == S_TAG) {
          el.setTagName(source.slice(start, p));
        }
        return p;
      case '>':
        switch (s) {
          case S_TAG:
            el.setTagName(source.slice(start, p));
          case S_ATTR_END:
          case S_TAG_SPACE:
          case S_TAG_CLOSE:
            break;
          case S_ATTR_NOQUOT_VALUE:
          case S_ATTR:
            value = source.slice(start, p);
            if (value.slice(-1) === '/') {
              el.closed = true;
              value = value.slice(0, -1);
            }
          case S_ATTR_SPACE:
            if (s === S_ATTR_SPACE) {
              value = attrName;
            }
            if (s == S_ATTR_NOQUOT_VALUE) {
              errorHandler.warning('attribute "' + value + '" missed quot(")!!');
              el.add(attrName, value.replace(/&#?\w+;/g, entityReplacer), start);
            } else {
              if (currentNSMap[''] !== 'http://www.w3.org/1999/xhtml' || !value.match(/^(?:disabled|checked|selected)$/i)) {
                errorHandler.warning('attribute "' + value + '" missed value!! "' + value + '" instead!!');
              }
              el.add(value, value, start);
            }
            break;
          case S_EQ:
            throw new Error('attribute value missed!!');
        }
        return p;
      case '\u0080':
        c = ' ';
      default:
        if (c <= ' ') {
          switch (s) {
            case S_TAG:
              el.setTagName(source.slice(start, p));
              s = S_TAG_SPACE;
              break;
            case S_ATTR:
              attrName = source.slice(start, p);
              s = S_ATTR_SPACE;
              break;
            case S_ATTR_NOQUOT_VALUE:
              var value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
              errorHandler.warning('attribute "' + value + '" missed quot(")!!');
              el.add(attrName, value, start);
            case S_ATTR_END:
              s = S_TAG_SPACE;
              break;
          }
        } else {
          switch (s) {
            case S_ATTR_SPACE:
              el.tagName;
              if (currentNSMap[''] !== 'http://www.w3.org/1999/xhtml' || !attrName.match(/^(?:disabled|checked|selected)$/i)) {
                errorHandler.warning('attribute "' + attrName + '" missed value!! "' + attrName + '" instead2!!');
              }
              el.add(attrName, attrName, start);
              start = p;
              s = S_ATTR;
              break;
            case S_ATTR_END:
              errorHandler.warning('attribute space is required"' + attrName + '"!!');
            case S_TAG_SPACE:
              s = S_ATTR;
              start = p;
              break;
            case S_EQ:
              s = S_ATTR_NOQUOT_VALUE;
              start = p;
              break;
            case S_TAG_CLOSE:
              throw new Error("elements closed character '/' and '>' must be connected to");
          }
        }
    }
    p++;
  }
}
function appendElement$1(el, domBuilder, currentNSMap) {
  var tagName = el.tagName;
  var localNSMap = null;
  var i = el.length;
  while (i--) {
    var a = el[i];
    var qName = a.qName;
    var value = a.value;
    var nsp = qName.indexOf(':');
    if (nsp > 0) {
      var prefix = a.prefix = qName.slice(0, nsp);
      var localName = qName.slice(nsp + 1);
      var nsPrefix = prefix === 'xmlns' && localName;
    } else {
      localName = qName;
      prefix = null;
      nsPrefix = qName === 'xmlns' && '';
    }
    a.localName = localName;
    if (nsPrefix !== false) {
      if (localNSMap == null) {
        localNSMap = {};
        _copy(currentNSMap, currentNSMap = {});
      }
      currentNSMap[nsPrefix] = localNSMap[nsPrefix] = value;
      a.uri = 'http://www.w3.org/2000/xmlns/';
      domBuilder.startPrefixMapping(nsPrefix, value);
    }
  }
  var i = el.length;
  while (i--) {
    a = el[i];
    var prefix = a.prefix;
    if (prefix) {
      if (prefix === 'xml') {
        a.uri = 'http://www.w3.org/XML/1998/namespace';
      }
      if (prefix !== 'xmlns') {
        a.uri = currentNSMap[prefix || ''];
      }
    }
  }
  var nsp = tagName.indexOf(':');
  if (nsp > 0) {
    prefix = el.prefix = tagName.slice(0, nsp);
    localName = el.localName = tagName.slice(nsp + 1);
  } else {
    prefix = null;
    localName = el.localName = tagName;
  }
  var ns = el.uri = currentNSMap[prefix || ''];
  domBuilder.startElement(ns, localName, tagName, el);
  if (el.closed) {
    domBuilder.endElement(ns, localName, tagName);
    if (localNSMap) {
      for (prefix in localNSMap) {
        domBuilder.endPrefixMapping(prefix);
      }
    }
  } else {
    el.currentNSMap = currentNSMap;
    el.localNSMap = localNSMap;
    return true;
  }
}
function parseHtmlSpecialContent(source, elStartEnd, tagName, entityReplacer, domBuilder) {
  if ((/^(?:script|textarea)$/i).test(tagName)) {
    var elEndStart = source.indexOf('</' + tagName + '>', elStartEnd);
    var text = source.substring(elStartEnd + 1, elEndStart);
    if ((/[&<]/).test(text)) {
      if ((/^script$/i).test(tagName)) {
        domBuilder.characters(text, 0, text.length);
        return elEndStart;
      }
      text = text.replace(/&#?\w+;/g, entityReplacer);
      domBuilder.characters(text, 0, text.length);
      return elEndStart;
    }
  }
  return elStartEnd + 1;
}
function fixSelfClosed(source, elStartEnd, tagName, closeMap) {
  var pos = closeMap[tagName];
  if (pos == null) {
    pos = source.lastIndexOf('</' + tagName + '>');
    if (pos < elStartEnd) {
      pos = source.lastIndexOf('</' + tagName);
    }
    closeMap[tagName] = pos;
  }
  return pos < elStartEnd;
}
function _copy(source, target) {
  for (var n in source) {
    target[n] = source[n];
  }
}
function parseDCC(source, start, domBuilder, errorHandler) {
  var next = source.charAt(start + 2);
  switch (next) {
    case '-':
      if (source.charAt(start + 3) === '-') {
        var end = source.indexOf('-->', start + 4);
        if (end > start) {
          domBuilder.comment(source, start + 4, end - start - 4);
          return end + 3;
        } else {
          errorHandler.error("Unclosed comment");
          return -1;
        }
      } else {
        return -1;
      }
    default:
      if (source.substr(start + 3, 6) == 'CDATA[') {
        var end = source.indexOf(']]>', start + 9);
        domBuilder.startCDATA();
        domBuilder.characters(source, start + 9, end - start - 9);
        domBuilder.endCDATA();
        return end + 3;
      }
      var matchs = split(source, start);
      var len = matchs.length;
      if (len > 1 && (/!doctype/i).test(matchs[0][0])) {
        var name = matchs[1][0];
        var pubid = false;
        var sysid = false;
        if (len > 3) {
          if ((/^public$/i).test(matchs[2][0])) {
            pubid = matchs[3][0];
            sysid = len > 4 && matchs[4][0];
          } else if ((/^system$/i).test(matchs[2][0])) {
            sysid = matchs[3][0];
          }
        }
        var lastMatch = matchs[len - 1];
        domBuilder.startDTD(name, pubid && pubid.replace(/^(['"])(.*?)\1$/, '$2'), sysid && sysid.replace(/^(['"])(.*?)\1$/, '$2'));
        domBuilder.endDTD();
        return lastMatch.index + lastMatch[0].length;
      }
  }
  return -1;
}
function parseInstruction(source, start, domBuilder) {
  var end = source.indexOf('?>', start);
  if (end) {
    var match = source.substring(start, end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);
    if (match) {
      match[0].length;
      domBuilder.processingInstruction(match[1], match[2]);
      return end + 2;
    } else {
      return -1;
    }
  }
  return -1;
}
function ElementAttributes(source) {}
ElementAttributes.prototype = {
  setTagName: function (tagName) {
    if (!tagNamePattern.test(tagName)) {
      throw new Error('invalid tagName:' + tagName);
    }
    this.tagName = tagName;
  },
  add: function (qName, value, offset) {
    if (!tagNamePattern.test(qName)) {
      throw new Error('invalid attribute:' + qName);
    }
    this[this.length++] = {
      qName: qName,
      value: value,
      offset: offset
    };
  },
  length: 0,
  getLocalName: function (i) {
    return this[i].localName;
  },
  getLocator: function (i) {
    return this[i].locator;
  },
  getQName: function (i) {
    return this[i].qName;
  },
  getURI: function (i) {
    return this[i].uri;
  },
  getValue: function (i) {
    return this[i].value;
  }
};
function split(source, start) {
  var match;
  var buf = [];
  var reg = /'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;
  reg.lastIndex = start;
  reg.exec(source);
  while (match = reg.exec(source)) {
    buf.push(match);
    if (match[1]) return buf;
  }
}
sax.XMLReader = XMLReader$1;

var dom = {};

function copy(src, dest) {
  for (var p in src) {
    dest[p] = src[p];
  }
}
function _extends(Class, Super) {
  var pt = Class.prototype;
  if (!(pt instanceof Super)) {
    function t() {}
    t.prototype = Super.prototype;
    t = new t();
    copy(pt, t);
    Class.prototype = pt = t;
  }
  if (pt.constructor != Class) {
    if (typeof Class != 'function') {
      console.error("unknow Class:" + Class);
    }
    pt.constructor = Class;
  }
}
var htmlns = 'http://www.w3.org/1999/xhtml';
var NodeType = {};
var ELEMENT_NODE = NodeType.ELEMENT_NODE = 1;
var ATTRIBUTE_NODE = NodeType.ATTRIBUTE_NODE = 2;
var TEXT_NODE = NodeType.TEXT_NODE = 3;
var CDATA_SECTION_NODE = NodeType.CDATA_SECTION_NODE = 4;
var ENTITY_REFERENCE_NODE = NodeType.ENTITY_REFERENCE_NODE = 5;
var ENTITY_NODE = NodeType.ENTITY_NODE = 6;
var PROCESSING_INSTRUCTION_NODE = NodeType.PROCESSING_INSTRUCTION_NODE = 7;
var COMMENT_NODE = NodeType.COMMENT_NODE = 8;
var DOCUMENT_NODE = NodeType.DOCUMENT_NODE = 9;
var DOCUMENT_TYPE_NODE = NodeType.DOCUMENT_TYPE_NODE = 10;
var DOCUMENT_FRAGMENT_NODE = NodeType.DOCUMENT_FRAGMENT_NODE = 11;
var NOTATION_NODE = NodeType.NOTATION_NODE = 12;
var ExceptionCode = {};
var ExceptionMessage = {};
ExceptionCode.INDEX_SIZE_ERR = (ExceptionMessage[1] = "Index size error", 1);
ExceptionCode.DOMSTRING_SIZE_ERR = (ExceptionMessage[2] = "DOMString size error", 2);
var HIERARCHY_REQUEST_ERR = ExceptionCode.HIERARCHY_REQUEST_ERR = (ExceptionMessage[3] = "Hierarchy request error", 3);
ExceptionCode.WRONG_DOCUMENT_ERR = (ExceptionMessage[4] = "Wrong document", 4);
ExceptionCode.INVALID_CHARACTER_ERR = (ExceptionMessage[5] = "Invalid character", 5);
ExceptionCode.NO_DATA_ALLOWED_ERR = (ExceptionMessage[6] = "No data allowed", 6);
ExceptionCode.NO_MODIFICATION_ALLOWED_ERR = (ExceptionMessage[7] = "No modification allowed", 7);
var NOT_FOUND_ERR = ExceptionCode.NOT_FOUND_ERR = (ExceptionMessage[8] = "Not found", 8);
ExceptionCode.NOT_SUPPORTED_ERR = (ExceptionMessage[9] = "Not supported", 9);
var INUSE_ATTRIBUTE_ERR = ExceptionCode.INUSE_ATTRIBUTE_ERR = (ExceptionMessage[10] = "Attribute in use", 10);
ExceptionCode.INVALID_STATE_ERR = (ExceptionMessage[11] = "Invalid state", 11);
ExceptionCode.SYNTAX_ERR = (ExceptionMessage[12] = "Syntax error", 12);
ExceptionCode.INVALID_MODIFICATION_ERR = (ExceptionMessage[13] = "Invalid modification", 13);
ExceptionCode.NAMESPACE_ERR = (ExceptionMessage[14] = "Invalid namespace", 14);
ExceptionCode.INVALID_ACCESS_ERR = (ExceptionMessage[15] = "Invalid access", 15);
function DOMException(code, message) {
  if (message instanceof Error) {
    var error = message;
  } else {
    error = this;
    Error.call(this, ExceptionMessage[code]);
    this.message = ExceptionMessage[code];
    if (Error.captureStackTrace) Error.captureStackTrace(this, DOMException);
  }
  error.code = code;
  if (message) this.message = this.message + ": " + message;
  return error;
}
DOMException.prototype = Error.prototype;
copy(ExceptionCode, DOMException);
function NodeList() {}
NodeList.prototype = {
  length: 0,
  item: function (index) {
    return this[index] || null;
  },
  toString: function (isHTML, nodeFilter) {
    for (var buf = [], i = 0; i < this.length; i++) {
      serializeToString(this[i], buf, isHTML, nodeFilter);
    }
    return buf.join('');
  }
};
function LiveNodeList(node, refresh) {
  this._node = node;
  this._refresh = refresh;
  _updateLiveList(this);
}
function _updateLiveList(list) {
  var inc = list._node._inc || list._node.ownerDocument._inc;
  if (list._inc != inc) {
    var ls = list._refresh(list._node);
    __set__(list, 'length', ls.length);
    copy(ls, list);
    list._inc = inc;
  }
}
LiveNodeList.prototype.item = function (i) {
  _updateLiveList(this);
  return this[i];
};
_extends(LiveNodeList, NodeList);
function NamedNodeMap() {}
function _findNodeIndex(list, node) {
  var i = list.length;
  while (i--) {
    if (list[i] === node) {
      return i;
    }
  }
}
function _addNamedNode(el, list, newAttr, oldAttr) {
  if (oldAttr) {
    list[_findNodeIndex(list, oldAttr)] = newAttr;
  } else {
    list[list.length++] = newAttr;
  }
  if (el) {
    newAttr.ownerElement = el;
    var doc = el.ownerDocument;
    if (doc) {
      oldAttr && _onRemoveAttribute(doc, el, oldAttr);
      _onAddAttribute(doc, el, newAttr);
    }
  }
}
function _removeNamedNode(el, list, attr) {
  var i = _findNodeIndex(list, attr);
  if (i >= 0) {
    var lastIndex = list.length - 1;
    while (i < lastIndex) {
      list[i] = list[++i];
    }
    list.length = lastIndex;
    if (el) {
      var doc = el.ownerDocument;
      if (doc) {
        _onRemoveAttribute(doc, el, attr);
        attr.ownerElement = null;
      }
    }
  } else {
    throw DOMException(NOT_FOUND_ERR, new Error(el.tagName + '@' + attr));
  }
}
NamedNodeMap.prototype = {
  length: 0,
  item: NodeList.prototype.item,
  getNamedItem: function (key) {
    var i = this.length;
    while (i--) {
      var attr = this[i];
      if (attr.nodeName == key) {
        return attr;
      }
    }
  },
  setNamedItem: function (attr) {
    var el = attr.ownerElement;
    if (el && el != this._ownerElement) {
      throw new DOMException(INUSE_ATTRIBUTE_ERR);
    }
    var oldAttr = this.getNamedItem(attr.nodeName);
    _addNamedNode(this._ownerElement, this, attr, oldAttr);
    return oldAttr;
  },
  setNamedItemNS: function (attr) {
    var el = attr.ownerElement, oldAttr;
    if (el && el != this._ownerElement) {
      throw new DOMException(INUSE_ATTRIBUTE_ERR);
    }
    oldAttr = this.getNamedItemNS(attr.namespaceURI, attr.localName);
    _addNamedNode(this._ownerElement, this, attr, oldAttr);
    return oldAttr;
  },
  removeNamedItem: function (key) {
    var attr = this.getNamedItem(key);
    _removeNamedNode(this._ownerElement, this, attr);
    return attr;
  },
  removeNamedItemNS: function (namespaceURI, localName) {
    var attr = this.getNamedItemNS(namespaceURI, localName);
    _removeNamedNode(this._ownerElement, this, attr);
    return attr;
  },
  getNamedItemNS: function (namespaceURI, localName) {
    var i = this.length;
    while (i--) {
      var node = this[i];
      if (node.localName == localName && node.namespaceURI == namespaceURI) {
        return node;
      }
    }
    return null;
  }
};
function DOMImplementation$1(features) {
  this._features = {};
  if (features) {
    for (var feature in features) {
      this._features = features[feature];
    }
  }
}
DOMImplementation$1.prototype = {
  hasFeature: function (feature, version) {
    var versions = this._features[feature.toLowerCase()];
    if (versions && (!version || (version in versions))) {
      return true;
    } else {
      return false;
    }
  },
  createDocument: function (namespaceURI, qualifiedName, doctype) {
    var doc = new Document();
    doc.implementation = this;
    doc.childNodes = new NodeList();
    doc.doctype = doctype;
    if (doctype) {
      doc.appendChild(doctype);
    }
    if (qualifiedName) {
      var root = doc.createElementNS(namespaceURI, qualifiedName);
      doc.appendChild(root);
    }
    return doc;
  },
  createDocumentType: function (qualifiedName, publicId, systemId) {
    var node = new DocumentType();
    node.name = qualifiedName;
    node.nodeName = qualifiedName;
    node.publicId = publicId;
    node.systemId = systemId;
    return node;
  }
};
function Node() {}
Node.prototype = {
  firstChild: null,
  lastChild: null,
  previousSibling: null,
  nextSibling: null,
  attributes: null,
  parentNode: null,
  childNodes: null,
  ownerDocument: null,
  nodeValue: null,
  namespaceURI: null,
  prefix: null,
  localName: null,
  insertBefore: function (newChild, refChild) {
    return _insertBefore(this, newChild, refChild);
  },
  replaceChild: function (newChild, oldChild) {
    this.insertBefore(newChild, oldChild);
    if (oldChild) {
      this.removeChild(oldChild);
    }
  },
  removeChild: function (oldChild) {
    return _removeChild(this, oldChild);
  },
  appendChild: function (newChild) {
    return this.insertBefore(newChild, null);
  },
  hasChildNodes: function () {
    return this.firstChild != null;
  },
  cloneNode: function (deep) {
    return cloneNode(this.ownerDocument || this, this, deep);
  },
  normalize: function () {
    var child = this.firstChild;
    while (child) {
      var next = child.nextSibling;
      if (next && next.nodeType == TEXT_NODE && child.nodeType == TEXT_NODE) {
        this.removeChild(next);
        child.appendData(next.data);
      } else {
        child.normalize();
        child = next;
      }
    }
  },
  isSupported: function (feature, version) {
    return this.ownerDocument.implementation.hasFeature(feature, version);
  },
  hasAttributes: function () {
    return this.attributes.length > 0;
  },
  lookupPrefix: function (namespaceURI) {
    var el = this;
    while (el) {
      var map = el._nsMap;
      if (map) {
        for (var n in map) {
          if (map[n] == namespaceURI) {
            return n;
          }
        }
      }
      el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
    }
    return null;
  },
  lookupNamespaceURI: function (prefix) {
    var el = this;
    while (el) {
      var map = el._nsMap;
      if (map) {
        if ((prefix in map)) {
          return map[prefix];
        }
      }
      el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
    }
    return null;
  },
  isDefaultNamespace: function (namespaceURI) {
    var prefix = this.lookupPrefix(namespaceURI);
    return prefix == null;
  }
};
function _xmlEncoder(c) {
  return c == '<' && '&lt;' || c == '>' && '&gt;' || c == '&' && '&amp;' || c == '"' && '&quot;' || '&#' + c.charCodeAt() + ';';
}
copy(NodeType, Node);
copy(NodeType, Node.prototype);
function _visitNode(node, callback) {
  if (callback(node)) {
    return true;
  }
  if (node = node.firstChild) {
    do {
      if (_visitNode(node, callback)) {
        return true;
      }
    } while (node = node.nextSibling);
  }
}
function Document() {}
function _onAddAttribute(doc, el, newAttr) {
  doc && doc._inc++;
  var ns = newAttr.namespaceURI;
  if (ns == 'http://www.w3.org/2000/xmlns/') {
    el._nsMap[newAttr.prefix ? newAttr.localName : ''] = newAttr.value;
  }
}
function _onRemoveAttribute(doc, el, newAttr, remove) {
  doc && doc._inc++;
  var ns = newAttr.namespaceURI;
  if (ns == 'http://www.w3.org/2000/xmlns/') {
    delete el._nsMap[newAttr.prefix ? newAttr.localName : ''];
  }
}
function _onUpdateChild(doc, el, newChild) {
  if (doc && doc._inc) {
    doc._inc++;
    var cs = el.childNodes;
    if (newChild) {
      cs[cs.length++] = newChild;
    } else {
      var child = el.firstChild;
      var i = 0;
      while (child) {
        cs[i++] = child;
        child = child.nextSibling;
      }
      cs.length = i;
    }
  }
}
function _removeChild(parentNode, child) {
  var previous = child.previousSibling;
  var next = child.nextSibling;
  if (previous) {
    previous.nextSibling = next;
  } else {
    parentNode.firstChild = next;
  }
  if (next) {
    next.previousSibling = previous;
  } else {
    parentNode.lastChild = previous;
  }
  _onUpdateChild(parentNode.ownerDocument, parentNode);
  return child;
}
function _insertBefore(parentNode, newChild, nextChild) {
  var cp = newChild.parentNode;
  if (cp) {
    cp.removeChild(newChild);
  }
  if (newChild.nodeType === DOCUMENT_FRAGMENT_NODE) {
    var newFirst = newChild.firstChild;
    if (newFirst == null) {
      return newChild;
    }
    var newLast = newChild.lastChild;
  } else {
    newFirst = newLast = newChild;
  }
  var pre = nextChild ? nextChild.previousSibling : parentNode.lastChild;
  newFirst.previousSibling = pre;
  newLast.nextSibling = nextChild;
  if (pre) {
    pre.nextSibling = newFirst;
  } else {
    parentNode.firstChild = newFirst;
  }
  if (nextChild == null) {
    parentNode.lastChild = newLast;
  } else {
    nextChild.previousSibling = newLast;
  }
  do {
    newFirst.parentNode = parentNode;
  } while (newFirst !== newLast && (newFirst = newFirst.nextSibling));
  _onUpdateChild(parentNode.ownerDocument || parentNode, parentNode);
  if (newChild.nodeType == DOCUMENT_FRAGMENT_NODE) {
    newChild.firstChild = newChild.lastChild = null;
  }
  return newChild;
}
function _appendSingleChild(parentNode, newChild) {
  var cp = newChild.parentNode;
  if (cp) {
    var pre = parentNode.lastChild;
    cp.removeChild(newChild);
    var pre = parentNode.lastChild;
  }
  var pre = parentNode.lastChild;
  newChild.parentNode = parentNode;
  newChild.previousSibling = pre;
  newChild.nextSibling = null;
  if (pre) {
    pre.nextSibling = newChild;
  } else {
    parentNode.firstChild = newChild;
  }
  parentNode.lastChild = newChild;
  _onUpdateChild(parentNode.ownerDocument, parentNode, newChild);
  return newChild;
}
Document.prototype = {
  nodeName: '#document',
  nodeType: DOCUMENT_NODE,
  doctype: null,
  documentElement: null,
  _inc: 1,
  insertBefore: function (newChild, refChild) {
    if (newChild.nodeType == DOCUMENT_FRAGMENT_NODE) {
      var child = newChild.firstChild;
      while (child) {
        var next = child.nextSibling;
        this.insertBefore(child, refChild);
        child = next;
      }
      return newChild;
    }
    if (this.documentElement == null && newChild.nodeType == ELEMENT_NODE) {
      this.documentElement = newChild;
    }
    return (_insertBefore(this, newChild, refChild), newChild.ownerDocument = this, newChild);
  },
  removeChild: function (oldChild) {
    if (this.documentElement == oldChild) {
      this.documentElement = null;
    }
    return _removeChild(this, oldChild);
  },
  importNode: function (importedNode, deep) {
    return importNode(this, importedNode, deep);
  },
  getElementById: function (id) {
    var rtv = null;
    _visitNode(this.documentElement, function (node) {
      if (node.nodeType == ELEMENT_NODE) {
        if (node.getAttribute('id') == id) {
          rtv = node;
          return true;
        }
      }
    });
    return rtv;
  },
  getElementsByClassName: function (className) {
    var pattern = new RegExp("(^|\\s)" + className + "(\\s|$)");
    return new LiveNodeList(this, function (base) {
      var ls = [];
      _visitNode(base.documentElement, function (node) {
        if (node !== base && node.nodeType == ELEMENT_NODE) {
          if (pattern.test(node.getAttribute('class'))) {
            ls.push(node);
          }
        }
      });
      return ls;
    });
  },
  createElement: function (tagName) {
    var node = new Element$1();
    node.ownerDocument = this;
    node.nodeName = tagName;
    node.tagName = tagName;
    node.childNodes = new NodeList();
    var attrs = node.attributes = new NamedNodeMap();
    attrs._ownerElement = node;
    return node;
  },
  createDocumentFragment: function () {
    var node = new DocumentFragment();
    node.ownerDocument = this;
    node.childNodes = new NodeList();
    return node;
  },
  createTextNode: function (data) {
    var node = new Text();
    node.ownerDocument = this;
    node.appendData(data);
    return node;
  },
  createComment: function (data) {
    var node = new Comment();
    node.ownerDocument = this;
    node.appendData(data);
    return node;
  },
  createCDATASection: function (data) {
    var node = new CDATASection();
    node.ownerDocument = this;
    node.appendData(data);
    return node;
  },
  createProcessingInstruction: function (target, data) {
    var node = new ProcessingInstruction();
    node.ownerDocument = this;
    node.tagName = node.target = target;
    node.nodeValue = node.data = data;
    return node;
  },
  createAttribute: function (name) {
    var node = new Attr();
    node.ownerDocument = this;
    node.name = name;
    node.nodeName = name;
    node.localName = name;
    node.specified = true;
    return node;
  },
  createEntityReference: function (name) {
    var node = new EntityReference();
    node.ownerDocument = this;
    node.nodeName = name;
    return node;
  },
  createElementNS: function (namespaceURI, qualifiedName) {
    var node = new Element$1();
    var pl = qualifiedName.split(':');
    var attrs = node.attributes = new NamedNodeMap();
    node.childNodes = new NodeList();
    node.ownerDocument = this;
    node.nodeName = qualifiedName;
    node.tagName = qualifiedName;
    node.namespaceURI = namespaceURI;
    if (pl.length == 2) {
      node.prefix = pl[0];
      node.localName = pl[1];
    } else {
      node.localName = qualifiedName;
    }
    attrs._ownerElement = node;
    return node;
  },
  createAttributeNS: function (namespaceURI, qualifiedName) {
    var node = new Attr();
    var pl = qualifiedName.split(':');
    node.ownerDocument = this;
    node.nodeName = qualifiedName;
    node.name = qualifiedName;
    node.namespaceURI = namespaceURI;
    node.specified = true;
    if (pl.length == 2) {
      node.prefix = pl[0];
      node.localName = pl[1];
    } else {
      node.localName = qualifiedName;
    }
    return node;
  }
};
_extends(Document, Node);
function Element$1() {
  this._nsMap = {};
}
Element$1.prototype = {
  nodeType: ELEMENT_NODE,
  hasAttribute: function (name) {
    return this.getAttributeNode(name) != null;
  },
  getAttribute: function (name) {
    var attr = this.getAttributeNode(name);
    return attr && attr.value || '';
  },
  getAttributeNode: function (name) {
    return this.attributes.getNamedItem(name);
  },
  setAttribute: function (name, value) {
    var attr = this.ownerDocument.createAttribute(name);
    attr.value = attr.nodeValue = "" + value;
    this.setAttributeNode(attr);
  },
  removeAttribute: function (name) {
    var attr = this.getAttributeNode(name);
    attr && this.removeAttributeNode(attr);
  },
  appendChild: function (newChild) {
    if (newChild.nodeType === DOCUMENT_FRAGMENT_NODE) {
      return this.insertBefore(newChild, null);
    } else {
      return _appendSingleChild(this, newChild);
    }
  },
  setAttributeNode: function (newAttr) {
    return this.attributes.setNamedItem(newAttr);
  },
  setAttributeNodeNS: function (newAttr) {
    return this.attributes.setNamedItemNS(newAttr);
  },
  removeAttributeNode: function (oldAttr) {
    return this.attributes.removeNamedItem(oldAttr.nodeName);
  },
  removeAttributeNS: function (namespaceURI, localName) {
    var old = this.getAttributeNodeNS(namespaceURI, localName);
    old && this.removeAttributeNode(old);
  },
  hasAttributeNS: function (namespaceURI, localName) {
    return this.getAttributeNodeNS(namespaceURI, localName) != null;
  },
  getAttributeNS: function (namespaceURI, localName) {
    var attr = this.getAttributeNodeNS(namespaceURI, localName);
    return attr && attr.value || '';
  },
  setAttributeNS: function (namespaceURI, qualifiedName, value) {
    var attr = this.ownerDocument.createAttributeNS(namespaceURI, qualifiedName);
    attr.value = attr.nodeValue = "" + value;
    this.setAttributeNode(attr);
  },
  getAttributeNodeNS: function (namespaceURI, localName) {
    return this.attributes.getNamedItemNS(namespaceURI, localName);
  },
  getElementsByTagName: function (tagName) {
    return new LiveNodeList(this, function (base) {
      var ls = [];
      _visitNode(base, function (node) {
        if (node !== base && node.nodeType == ELEMENT_NODE && (tagName === '*' || node.tagName == tagName)) {
          ls.push(node);
        }
      });
      return ls;
    });
  },
  getElementsByTagNameNS: function (namespaceURI, localName) {
    return new LiveNodeList(this, function (base) {
      var ls = [];
      _visitNode(base, function (node) {
        if (node !== base && node.nodeType === ELEMENT_NODE && (namespaceURI === '*' || node.namespaceURI === namespaceURI) && (localName === '*' || node.localName == localName)) {
          ls.push(node);
        }
      });
      return ls;
    });
  }
};
Document.prototype.getElementsByTagName = Element$1.prototype.getElementsByTagName;
Document.prototype.getElementsByTagNameNS = Element$1.prototype.getElementsByTagNameNS;
_extends(Element$1, Node);
function Attr() {}
Attr.prototype.nodeType = ATTRIBUTE_NODE;
_extends(Attr, Node);
function CharacterData() {}
CharacterData.prototype = {
  data: '',
  substringData: function (offset, count) {
    return this.data.substring(offset, offset + count);
  },
  appendData: function (text) {
    text = this.data + text;
    this.nodeValue = this.data = text;
    this.length = text.length;
  },
  insertData: function (offset, text) {
    this.replaceData(offset, 0, text);
  },
  appendChild: function (newChild) {
    throw new Error(ExceptionMessage[HIERARCHY_REQUEST_ERR]);
  },
  deleteData: function (offset, count) {
    this.replaceData(offset, count, "");
  },
  replaceData: function (offset, count, text) {
    var start = this.data.substring(0, offset);
    var end = this.data.substring(offset + count);
    text = start + text + end;
    this.nodeValue = this.data = text;
    this.length = text.length;
  }
};
_extends(CharacterData, Node);
function Text() {}
Text.prototype = {
  nodeName: "#text",
  nodeType: TEXT_NODE,
  splitText: function (offset) {
    var text = this.data;
    var newText = text.substring(offset);
    text = text.substring(0, offset);
    this.data = this.nodeValue = text;
    this.length = text.length;
    var newNode = this.ownerDocument.createTextNode(newText);
    if (this.parentNode) {
      this.parentNode.insertBefore(newNode, this.nextSibling);
    }
    return newNode;
  }
};
_extends(Text, CharacterData);
function Comment() {}
Comment.prototype = {
  nodeName: "#comment",
  nodeType: COMMENT_NODE
};
_extends(Comment, CharacterData);
function CDATASection() {}
CDATASection.prototype = {
  nodeName: "#cdata-section",
  nodeType: CDATA_SECTION_NODE
};
_extends(CDATASection, CharacterData);
function DocumentType() {}
DocumentType.prototype.nodeType = DOCUMENT_TYPE_NODE;
_extends(DocumentType, Node);
function Notation() {}
Notation.prototype.nodeType = NOTATION_NODE;
_extends(Notation, Node);
function Entity() {}
Entity.prototype.nodeType = ENTITY_NODE;
_extends(Entity, Node);
function EntityReference() {}
EntityReference.prototype.nodeType = ENTITY_REFERENCE_NODE;
_extends(EntityReference, Node);
function DocumentFragment() {}
DocumentFragment.prototype.nodeName = "#document-fragment";
DocumentFragment.prototype.nodeType = DOCUMENT_FRAGMENT_NODE;
_extends(DocumentFragment, Node);
function ProcessingInstruction() {}
ProcessingInstruction.prototype.nodeType = PROCESSING_INSTRUCTION_NODE;
_extends(ProcessingInstruction, Node);
function XMLSerializer() {}
XMLSerializer.prototype.serializeToString = function (node, isHtml, nodeFilter) {
  return nodeSerializeToString.call(node, isHtml, nodeFilter);
};
Node.prototype.toString = nodeSerializeToString;
function nodeSerializeToString(isHtml, nodeFilter) {
  var buf = [];
  var refNode = this.nodeType == 9 && this.documentElement || this;
  var prefix = refNode.prefix;
  var uri = refNode.namespaceURI;
  if (uri && prefix == null) {
    var prefix = refNode.lookupPrefix(uri);
    if (prefix == null) {
      var visibleNamespaces = [{
        namespace: uri,
        prefix: null
      }];
    }
  }
  serializeToString(this, buf, isHtml, nodeFilter, visibleNamespaces);
  return buf.join('');
}
function needNamespaceDefine(node, isHTML, visibleNamespaces) {
  var prefix = node.prefix || '';
  var uri = node.namespaceURI;
  if (!prefix && !uri) {
    return false;
  }
  if (prefix === "xml" && uri === "http://www.w3.org/XML/1998/namespace" || uri == 'http://www.w3.org/2000/xmlns/') {
    return false;
  }
  var i = visibleNamespaces.length;
  while (i--) {
    var ns = visibleNamespaces[i];
    if (ns.prefix == prefix) {
      return ns.namespace != uri;
    }
  }
  return true;
}
function serializeToString(node, buf, isHTML, nodeFilter, visibleNamespaces) {
  if (nodeFilter) {
    node = nodeFilter(node);
    if (node) {
      if (typeof node == 'string') {
        buf.push(node);
        return;
      }
    } else {
      return;
    }
  }
  switch (node.nodeType) {
    case ELEMENT_NODE:
      if (!visibleNamespaces) visibleNamespaces = [];
      visibleNamespaces.length;
      var attrs = node.attributes;
      var len = attrs.length;
      var child = node.firstChild;
      var nodeName = node.tagName;
      isHTML = htmlns === node.namespaceURI || isHTML;
      buf.push('<', nodeName);
      for (var i = 0; i < len; i++) {
        var attr = attrs.item(i);
        if (attr.prefix == 'xmlns') {
          visibleNamespaces.push({
            prefix: attr.localName,
            namespace: attr.value
          });
        } else if (attr.nodeName == 'xmlns') {
          visibleNamespaces.push({
            prefix: '',
            namespace: attr.value
          });
        }
      }
      for (var i = 0; i < len; i++) {
        var attr = attrs.item(i);
        if (needNamespaceDefine(attr, isHTML, visibleNamespaces)) {
          var prefix = attr.prefix || '';
          var uri = attr.namespaceURI;
          var ns = prefix ? ' xmlns:' + prefix : " xmlns";
          buf.push(ns, '="', uri, '"');
          visibleNamespaces.push({
            prefix: prefix,
            namespace: uri
          });
        }
        serializeToString(attr, buf, isHTML, nodeFilter, visibleNamespaces);
      }
      if (needNamespaceDefine(node, isHTML, visibleNamespaces)) {
        var prefix = node.prefix || '';
        var uri = node.namespaceURI;
        var ns = prefix ? ' xmlns:' + prefix : " xmlns";
        buf.push(ns, '="', uri, '"');
        visibleNamespaces.push({
          prefix: prefix,
          namespace: uri
        });
      }
      if (child || isHTML && !(/^(?:meta|link|img|br|hr|input)$/i).test(nodeName)) {
        buf.push('>');
        if (isHTML && (/^script$/i).test(nodeName)) {
          while (child) {
            if (child.data) {
              buf.push(child.data);
            } else {
              serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces);
            }
            child = child.nextSibling;
          }
        } else {
          while (child) {
            serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces);
            child = child.nextSibling;
          }
        }
        buf.push('</', nodeName, '>');
      } else {
        buf.push('/>');
      }
      return;
    case DOCUMENT_NODE:
    case DOCUMENT_FRAGMENT_NODE:
      var child = node.firstChild;
      while (child) {
        serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces);
        child = child.nextSibling;
      }
      return;
    case ATTRIBUTE_NODE:
      return buf.push(' ', node.name, '="', node.value.replace(/[<&"]/g, _xmlEncoder), '"');
    case TEXT_NODE:
      return buf.push(node.data.replace(/[<&]/g, _xmlEncoder));
    case CDATA_SECTION_NODE:
      return buf.push('<![CDATA[', node.data, ']]>');
    case COMMENT_NODE:
      return buf.push("<!--", node.data, "-->");
    case DOCUMENT_TYPE_NODE:
      var pubid = node.publicId;
      var sysid = node.systemId;
      buf.push('<!DOCTYPE ', node.name);
      if (pubid) {
        buf.push(' PUBLIC "', pubid);
        if (sysid && sysid != '.') {
          buf.push('" "', sysid);
        }
        buf.push('">');
      } else if (sysid && sysid != '.') {
        buf.push(' SYSTEM "', sysid, '">');
      } else {
        var sub = node.internalSubset;
        if (sub) {
          buf.push(" [", sub, "]");
        }
        buf.push(">");
      }
      return;
    case PROCESSING_INSTRUCTION_NODE:
      return buf.push("<?", node.target, " ", node.data, "?>");
    case ENTITY_REFERENCE_NODE:
      return buf.push('&', node.nodeName, ';');
    default:
      buf.push('??', node.nodeName);
  }
}
function importNode(doc, node, deep) {
  var node2;
  switch (node.nodeType) {
    case ELEMENT_NODE:
      node2 = node.cloneNode(false);
      node2.ownerDocument = doc;
    case DOCUMENT_FRAGMENT_NODE:
      break;
    case ATTRIBUTE_NODE:
      deep = true;
      break;
  }
  if (!node2) {
    node2 = node.cloneNode(false);
  }
  node2.ownerDocument = doc;
  node2.parentNode = null;
  if (deep) {
    var child = node.firstChild;
    while (child) {
      node2.appendChild(importNode(doc, child, deep));
      child = child.nextSibling;
    }
  }
  return node2;
}
function cloneNode(doc, node, deep) {
  var node2 = new node.constructor();
  for (var n in node) {
    var v = node[n];
    if (typeof v != 'object') {
      if (v != node2[n]) {
        node2[n] = v;
      }
    }
  }
  if (node.childNodes) {
    node2.childNodes = new NodeList();
  }
  node2.ownerDocument = doc;
  switch (node2.nodeType) {
    case ELEMENT_NODE:
      var attrs = node.attributes;
      var attrs2 = node2.attributes = new NamedNodeMap();
      var len = attrs.length;
      attrs2._ownerElement = node2;
      for (var i = 0; i < len; i++) {
        node2.setAttributeNode(cloneNode(doc, attrs.item(i), true));
      }
      break;
    case ATTRIBUTE_NODE:
      deep = true;
  }
  if (deep) {
    var child = node.firstChild;
    while (child) {
      node2.appendChild(cloneNode(doc, child, deep));
      child = child.nextSibling;
    }
  }
  return node2;
}
function __set__(object, key, value) {
  object[key] = value;
}
try {
  if (Object.defineProperty) {
    Object.defineProperty(LiveNodeList.prototype, 'length', {
      get: function () {
        _updateLiveList(this);
        return this.$$length;
      }
    });
    Object.defineProperty(Node.prototype, 'textContent', {
      get: function () {
        return getTextContent(this);
      },
      set: function (data) {
        switch (this.nodeType) {
          case ELEMENT_NODE:
          case DOCUMENT_FRAGMENT_NODE:
            while (this.firstChild) {
              this.removeChild(this.firstChild);
            }
            if (data || String(data)) {
              this.appendChild(this.ownerDocument.createTextNode(data));
            }
            break;
          default:
            this.data = data;
            this.value = data;
            this.nodeValue = data;
        }
      }
    });
    function getTextContent(node) {
      switch (node.nodeType) {
        case ELEMENT_NODE:
        case DOCUMENT_FRAGMENT_NODE:
          var buf = [];
          node = node.firstChild;
          while (node) {
            if (node.nodeType !== 7 && node.nodeType !== 8) {
              buf.push(getTextContent(node));
            }
            node = node.nextSibling;
          }
          return buf.join('');
        default:
          return node.nodeValue;
      }
    }
    __set__ = function (object, key, value) {
      object['$$' + key] = value;
    };
  }
} catch (e) {}
dom.Node = Node;
dom.DOMImplementation = DOMImplementation$1;
dom.XMLSerializer = XMLSerializer;

function DOMParser(options) {
  this.options = options || ({
    locator: {}
  });
}
DOMParser.prototype.parseFromString = function (source, mimeType) {
  var options = this.options;
  var sax = new XMLReader();
  var domBuilder = options.domBuilder || new DOMHandler();
  var errorHandler = options.errorHandler;
  var locator = options.locator;
  var defaultNSMap = options.xmlns || ({});
  var isHTML = (/\/x?html?$/).test(mimeType);
  var entityMap = isHTML ? htmlEntity.entityMap : {
    'lt': '<',
    'gt': '>',
    'amp': '&',
    'quot': '"',
    'apos': "'"
  };
  if (locator) {
    domBuilder.setDocumentLocator(locator);
  }
  sax.errorHandler = buildErrorHandler(errorHandler, domBuilder, locator);
  sax.domBuilder = options.domBuilder || domBuilder;
  if (isHTML) {
    defaultNSMap[''] = 'http://www.w3.org/1999/xhtml';
  }
  defaultNSMap.xml = defaultNSMap.xml || 'http://www.w3.org/XML/1998/namespace';
  if (source && typeof source === 'string') {
    sax.parse(source, defaultNSMap, entityMap);
  } else {
    sax.errorHandler.error("invalid doc source");
  }
  return domBuilder.doc;
};
function buildErrorHandler(errorImpl, domBuilder, locator) {
  if (!errorImpl) {
    if (domBuilder instanceof DOMHandler) {
      return domBuilder;
    }
    errorImpl = domBuilder;
  }
  var errorHandler = {};
  var isCallback = errorImpl instanceof Function;
  locator = locator || ({});
  function build(key) {
    var fn = errorImpl[key];
    if (!fn && isCallback) {
      fn = errorImpl.length == 2 ? function (msg) {
        errorImpl(key, msg);
      } : errorImpl;
    }
    errorHandler[key] = fn && (function (msg) {
      fn('[xmldom ' + key + ']\t' + msg + _locator(locator));
    }) || (function () {});
  }
  build('warning');
  build('error');
  build('fatalError');
  return errorHandler;
}
function DOMHandler() {
  this.cdata = false;
}
function position(locator, node) {
  node.lineNumber = locator.lineNumber;
  node.columnNumber = locator.columnNumber;
}
DOMHandler.prototype = {
  startDocument: function () {
    this.doc = new DOMImplementation().createDocument(null, null, null);
    if (this.locator) {
      this.doc.documentURI = this.locator.systemId;
    }
  },
  startElement: function (namespaceURI, localName, qName, attrs) {
    var doc = this.doc;
    var el = doc.createElementNS(namespaceURI, qName || localName);
    var len = attrs.length;
    appendElement(this, el);
    this.currentElement = el;
    this.locator && position(this.locator, el);
    for (var i = 0; i < len; i++) {
      var namespaceURI = attrs.getURI(i);
      var value = attrs.getValue(i);
      var qName = attrs.getQName(i);
      var attr = doc.createAttributeNS(namespaceURI, qName);
      this.locator && position(attrs.getLocator(i), attr);
      attr.value = attr.nodeValue = value;
      el.setAttributeNode(attr);
    }
  },
  endElement: function (namespaceURI, localName, qName) {
    var current = this.currentElement;
    current.tagName;
    this.currentElement = current.parentNode;
  },
  startPrefixMapping: function (prefix, uri) {},
  endPrefixMapping: function (prefix) {},
  processingInstruction: function (target, data) {
    var ins = this.doc.createProcessingInstruction(target, data);
    this.locator && position(this.locator, ins);
    appendElement(this, ins);
  },
  ignorableWhitespace: function (ch, start, length) {},
  characters: function (chars, start, length) {
    chars = _toString.apply(this, arguments);
    if (chars) {
      if (this.cdata) {
        var charNode = this.doc.createCDATASection(chars);
      } else {
        var charNode = this.doc.createTextNode(chars);
      }
      if (this.currentElement) {
        this.currentElement.appendChild(charNode);
      } else if ((/^\s*$/).test(chars)) {
        this.doc.appendChild(charNode);
      }
      this.locator && position(this.locator, charNode);
    }
  },
  skippedEntity: function (name) {},
  endDocument: function () {
    this.doc.normalize();
  },
  setDocumentLocator: function (locator) {
    if (this.locator = locator) {
      locator.lineNumber = 0;
    }
  },
  comment: function (chars, start, length) {
    chars = _toString.apply(this, arguments);
    var comm = this.doc.createComment(chars);
    this.locator && position(this.locator, comm);
    appendElement(this, comm);
  },
  startCDATA: function () {
    this.cdata = true;
  },
  endCDATA: function () {
    this.cdata = false;
  },
  startDTD: function (name, publicId, systemId) {
    var impl = this.doc.implementation;
    if (impl && impl.createDocumentType) {
      var dt = impl.createDocumentType(name, publicId, systemId);
      this.locator && position(this.locator, dt);
      appendElement(this, dt);
    }
  },
  warning: function (error) {
    console.warn('[xmldom warning]\t' + error, _locator(this.locator));
  },
  error: function (error) {
    console.error('[xmldom error]\t' + error, _locator(this.locator));
  },
  fatalError: function (error) {
    console.error('[xmldom fatalError]\t' + error, _locator(this.locator));
    throw error;
  }
};
function _locator(l) {
  if (l) {
    return '\n@' + (l.systemId || '') + '#[line:' + l.lineNumber + ',col:' + l.columnNumber + ']';
  }
}
function _toString(chars, start, length) {
  if (typeof chars == 'string') {
    return chars.substr(start, length);
  } else {
    if (chars.length >= start + length || start) {
      return new java.lang.String(chars, start, length) + '';
    }
    return chars;
  }
}
("endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl").replace(/\w+/g, function (key) {
  DOMHandler.prototype[key] = function () {
    return null;
  };
});
function appendElement(hander, node) {
  if (!hander.currentElement) {
    hander.doc.appendChild(node);
  } else {
    hander.currentElement.appendChild(node);
  }
}
var htmlEntity = entities;
var XMLReader = sax.XMLReader;
var DOMImplementation = domParser.DOMImplementation = dom.DOMImplementation;
domParser.XMLSerializer = dom.XMLSerializer;
domParser.DOMParser = DOMParser;

var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || (function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
});
Object.defineProperty(xmldomToMathmlElementAdapter, "__esModule", {
  value: true
});
xmldomToMathmlElementAdapter.XmlToMathMLAdapter = void 0;
var xmldom_1 = __importDefault(domParser);
var XmlToMathMLAdapter = (function () {
  function XmlToMathMLAdapter(elementsConvertor, errorHandler) {
    this._xml = '';
    this._elementsConvertor = elementsConvertor;
    this._errorHandler = errorHandler;
    this._xmlDOM = new xmldom_1.default.DOMParser({
      locator: this._errorHandler.errorLocator,
      errorHandler: this._fixError.bind(this)
    });
  }
  XmlToMathMLAdapter.prototype.convert = function (xml) {
    this._xml = this._removeLineBreaks(xml);
    return this._elementsConvertor.convert(this._mathMLElements);
  };
  XmlToMathMLAdapter.prototype._fixError = function (errorMessage) {
    this._xml = this._errorHandler.fixError(this._xml, errorMessage);
  };
  XmlToMathMLAdapter.prototype._removeLineBreaks = function (xml) {
    var LINE_BREAK = /\n|\r\n|\r/g;
    return xml.replace(LINE_BREAK, '');
  };
  Object.defineProperty(XmlToMathMLAdapter.prototype, "_mathMLElements", {
    get: function () {
      var elements = this._xmlDOM.parseFromString(this._xml).getElementsByTagName('math');
      if (this._errorHandler.isThereAnyErrors()) {
        this._errorHandler.cleanErrors();
        elements = this._xmlDOM.parseFromString(this._xml).getElementsByTagName('math');
      }
      return Array.from(elements);
    },
    enumerable: false,
    configurable: true
  });
  return XmlToMathMLAdapter;
})();
xmldomToMathmlElementAdapter.XmlToMathMLAdapter = XmlToMathMLAdapter;

var errorHandler = {};

Object.defineProperty(errorHandler, "__esModule", {
  value: true
});
errorHandler.ErrorHandler = void 0;
var ErrorHandler = (function () {
  function ErrorHandler() {
    this._errors = [];
    this.errorLocator = {};
  }
  ErrorHandler.prototype.fixError = function (xml, errorMessage) {
    if (!this._isMissingAttributeValueError(errorMessage)) return xml;
    this._errors.push(errorMessage);
    return this._fixMissingAttribute(errorMessage, xml);
  };
  ErrorHandler.prototype.isThereAnyErrors = function () {
    return this._errors.length > 0;
  };
  ErrorHandler.prototype.cleanErrors = function () {
    this._errors = [];
  };
  ErrorHandler.prototype._fixMissingAttribute = function (errorMessage, xml) {
    var missingAttribute = errorMessage.split('"')[1];
    if (missingAttribute) return xml.replace(this._matchMissingValueForAttribute(missingAttribute), '');
    while (this._mathGenericMissingValue().exec(xml)) {
      xml = xml.replace(this._mathGenericMissingValue(), '$1$3');
    }
    return xml;
  };
  ErrorHandler.prototype._matchMissingValueForAttribute = function (attribute) {
    return new RegExp("(" + attribute + "=(?!(\"|')))|(" + attribute + "(?!(\"|')))", 'gm');
  };
  ErrorHandler.prototype._mathGenericMissingValue = function () {
    return /(\<.* )(\w+=(?!\"|\'))(.*\>)/gm;
  };
  ErrorHandler.prototype._isMissingAttributeValueError = function (errorMessage) {
    return !!errorMessage.includes('attribute') && !!errorMessage.includes('missed') || errorMessage.includes('attribute value missed');
  };
  return ErrorHandler;
})();
errorHandler.ErrorHandler = ErrorHandler;

var xmldomElementsToMathmlElementsAdapter = {};

Object.defineProperty(xmldomElementsToMathmlElementsAdapter, "__esModule", {
  value: true
});
xmldomElementsToMathmlElementsAdapter.ElementsToMathMLAdapter = void 0;
var ElementsToMathMLAdapter = (function () {
  function ElementsToMathMLAdapter() {}
  ElementsToMathMLAdapter.prototype.convert = function (els) {
    var _this = this;
    return els.filter(function (el) {
      return el.tagName !== undefined;
    }).map(function (el) {
      return _this._convertElement(el);
    });
  };
  ElementsToMathMLAdapter.prototype._convertElement = function (el) {
    return {
      name: el.tagName,
      attributes: this._convertElementAttributes(el.attributes),
      value: this._hasElementChild(el) ? '' : el.textContent || '',
      children: this._hasElementChild(el) ? this.convert(Array.from(el.childNodes)) : []
    };
  };
  ElementsToMathMLAdapter.prototype._convertElementAttributes = function (attributes) {
    return Array.from(attributes).reduce(function (acc, attr) {
      var _a;
      return Object.assign((_a = {}, _a[attr.nodeName] = attr.nodeValue === attr.nodeName ? '' : attr.nodeValue, _a), acc);
    }, {});
  };
  ElementsToMathMLAdapter.prototype._hasElementChild = function (el) {
    var childNodes = el.childNodes;
    return !!childNodes && childNodes.length !== 0 && this._isThereAnyNoTextNode(childNodes);
  };
  ElementsToMathMLAdapter.prototype._isThereAnyNoTextNode = function (children) {
    return Array.from(children).some(function (child) {
      return child.nodeName !== '#text';
    });
  };
  return ElementsToMathMLAdapter;
})();
xmldomElementsToMathmlElementsAdapter.ElementsToMathMLAdapter = ElementsToMathMLAdapter;

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, {
      enumerable: true,
      get: function () {
        return m[k];
      }
    });
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  __exportStar(xmldomToMathmlElementAdapter, exports);
  __exportStar(errorHandler, exports);
  __exportStar(xmldomElementsToMathmlElementsAdapter, exports);
})(xmldomToMathmlElements);
getDefaultExportFromCjs(xmldomToMathmlElements);

Object.defineProperty(makeToMathElementsConverter$1, "__esModule", {
  value: true
});
makeToMathElementsConverter$1.makeToMathElementsConverter = void 0;
var xmldom_to_mathml_elements_1 = xmldomToMathmlElements;
var makeToMathElementsConverter = function () {
  var elementsToMathMLAdapter = new xmldom_to_mathml_elements_1.ElementsToMathMLAdapter();
  var errorHandler = new xmldom_to_mathml_elements_1.ErrorHandler();
  return new xmldom_to_mathml_elements_1.XmlToMathMLAdapter(elementsToMathMLAdapter, errorHandler);
};
makeToMathElementsConverter$1.makeToMathElementsConverter = makeToMathElementsConverter;

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, {
      enumerable: true,
      get: function () {
        return m[k];
      }
    });
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  __exportStar(makeToMathElementsConverter$1, exports);
})(factories);
getDefaultExportFromCjs(factories);

Object.defineProperty(mathmlToLatex, "__esModule", {
  value: true
});
mathmlToLatex.MathMLToLaTeX = void 0;
var mathml_element_to_latex_converter_adapter_1 = mathmlElementToLatexConverterAdapter;
var factories_1 = factories;
var MathMLToLaTeX = (function () {
  function MathMLToLaTeX() {}
  MathMLToLaTeX.convert = function (mathml) {
    var mathmlElements = factories_1.makeToMathElementsConverter().convert(mathml);
    var mathmlElementsToLaTeXConverters = mathmlElements.map(function (mathMLElement) {
      return new mathml_element_to_latex_converter_adapter_1.MathMLElementToLatexConverterAdapter(mathMLElement).toLatexConverter();
    });
    return mathmlElementsToLaTeXConverters.map(function (toLatexConverters) {
      return toLatexConverters.convert();
    }).join('');
  };
  return MathMLToLaTeX;
})();
mathmlToLatex.MathMLToLaTeX = MathMLToLaTeX;

(function (exports) {
  var __createBinding = commonjsGlobal && commonjsGlobal.__createBinding || (Object.create ? function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, {
      enumerable: true,
      get: function () {
        return m[k];
      }
    });
  } : function (o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
  });
  var __exportStar = commonjsGlobal && commonjsGlobal.__exportStar || (function (m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
  });
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  __exportStar(mathmlToLatex, exports);
})(main);
getDefaultExportFromCjs(main);

(function (module, exports) {
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  var main_1 = main;
  exports.default = main_1.MathMLToLaTeX;
  module.exports = main_1.MathMLToLaTeX;
})(dist, dist.exports);
var Mathml2latex = getDefaultExportFromCjs(dist.exports);

var mmlToLatex = mathml => Mathml2latex.convert(mathml);

var index = /*#__PURE__*/Object.freeze({
	__proto__: null,
	renderMath: renderMath,
	wrapMath: wrapMath,
	unWrapMath: unWrapMath,
	mmlToLatex: mmlToLatex
});

export { index as _dll_pie_lib__math_rendering };
